/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ne=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/base/common/async","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/path","vs/nls","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/platform/environment/common/environment","vs/platform/files/common/files","vs/base/common/types","vs/base/common/arrays","vs/base/common/buffer","vs/base/common/network","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/base/node/pfs","vs/base/common/cancellation","vs/platform/storage/common/storage","vs/platform/userDataSync/common/userDataSync","vs/platform/product/common/productService","vs/base/common/strings","vs/base/common/objects","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/process","os","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/json","vs/base/parts/ipc/common/ipc","vs/base/common/errorMessage","vs/platform/registry/common/platform","vs/base/common/map","vs/base/common/stream","vs/base/common/extpath","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","child_process","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/codicons","vs/base/common/jsonFormatter","fs","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/userDataSync/common/content","vs/base/common/decorators","vs/base/common/iterator","net","vs/base/common/date","vs/base/parts/ipc/node/ipc.cp","vs/platform/localizations/common/localizations","vs/platform/native/electron-sandbox/native","vs/base/common/semver/semver","vs/platform/remote/common/tunnel","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/collections","vs/base/common/functional","vs/base/common/jsonEdit","vs/base/common/hash","vs/base/common/normalization","vs/base/node/powershell","vs/base/parts/ipc/common/ipc.net","electron","vs/base/parts/storage/common/storage","vs/base/node/processes","vs/platform/environment/common/environmentService","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/extensions","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","crypto","vs/platform/files/common/io","vs/platform/instantiation/common/serviceCollection","vs/platform/log/common/logIpc","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/sharedProcess/common/sharedProcessWorkerService","vs/platform/sign/common/sign","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/userDataSync/common/ignoredExtensions","vs/base/common/assert","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/mime","vs/base/common/processes","vs/base/common/skipList","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/uriIpc","vs/base/node/decoder","vs/base/node/macAddress","vs/base/node/id","vs/base/node/extpath","vs/base/node/ports","vs/base/node/ps","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/environment/node/shellEnv","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/platform/assignment/common/assignment","vs/platform/environment/node/argv","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/platform/checksum/node/checksumService","vs/platform/environment/node/argvHelper","vs/platform/environment/node/shellEnv","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/platform/ipc/electron-sandbox/services","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/code/electron-browser/sharedProcess/contrib/codeCacheCleaner","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/localizations/node/localizations","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/remote/node/sharedProcessTunnelService","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/sharedProcess/electron-browser/sharedProcessWorker","vs/platform/sharedProcess/electron-browser/sharedProcessWorkerService","vs/platform/sharedProcess/node/sharedProcessEnvironmentService","vs/platform/sign/node/signService","vs/platform/extensionManagement/common/extensionEnablementService","vs/code/electron-browser/sharedProcess/contrib/extensionsCleaner","vs/platform/storage/common/storageIpc","vs/platform/storage/electron-sandbox/storageService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/assignment/common/assignmentService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/common/requestStore","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/windows/node/windowTracker","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","vs/base/parts/ipc/node/ipc.net","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/tunnelService","string_decoder","util","minimist","assert","graceful-fs","yauzl","yazl","zlib","vs/code/electron-browser/sharedProcess/sharedProcessMain"],ie=function(J){for(var e=[],D=0,n=J.length;D<n;D++)e[D]=ne[J[D]];return e};define(ne[99],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function D(n,L){if(!n)throw new Error(L?`Assertion failed (${L})`:"Assertion Failed")}e.ok=D}),define(ne[48],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function D(A){return A?A.replace(/\$\((.*?)\)/g,(R,b)=>` ${b} `).trim():""}e.getCodiconAriaLabel=D;class n{constructor(R,b,E){this.id=R,this.definition=b,this.description=E,n._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return n._allCodicons}}e.Codicon=n,n._allCodicons=[],n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",n.add.definition),n.gistNew=new n("gist-new",n.add.definition),n.repoCreate=new n("repo-create",n.add.definition),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eba4"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolCustomColor=new n("symbol-customcolor",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.inspect=new n("inspect",{fontCharacter:"\\ebd1"}),n.layers=new n("layers",{fontCharacter:"\\ebd2"}),n.layersDot=new n("layers-dot",{fontCharacter:"\\ebd3"}),n.layersActive=new n("layers-active",{fontCharacter:"\\ebd4"}),n.compass=new n("compass",{fontCharacter:"\\ebd5"}),n.compassDot=new n("compass-dot",{fontCharacter:"\\ebd6"}),n.compassActive=new n("compass-active",{fontCharacter:"\\ebd7"}),n.azure=new n("azure",{fontCharacter:"\\ebd8"}),n.issueDraft=new n("issue-draft",{fontCharacter:"\\ebd9"}),n.gitPullRequestClosed=new n("git-pull-request-closed",{fontCharacter:"\\ebda"}),n.gitPullRequestDraft=new n("git-pull-request-draft",{fontCharacter:"\\ebdb"}),n.debugAll=new n("debug-all",{fontCharacter:"\\ebdc"}),n.debugCoverage=new n("debug-coverage",{fontCharacter:"\\ebdd"}),n.runErrors=new n("run-errors",{fontCharacter:"\\ebde"}),n.folderLibrary=new n("folder-library",{fontCharacter:"\\ebdf"}),n.debugContinueSmall=new n("debug-continue-small",{fontCharacter:"\\ebe0"}),n.beakerStop=new n("beaker-stop",{fontCharacter:"\\ebe1"}),n.graphLine=new n("graph-line",{fontCharacter:"\\ebe2"}),n.graphScatter=new n("graph-scatter",{fontCharacter:"\\ebe3"}),n.pieChart=new n("pie-chart",{fontCharacter:"\\ebe4"}),n.bracket=new n("bracket",n.json.definition),n.bracketDot=new n("bracket-dot",{fontCharacter:"\\ebe5"}),n.bracketError=new n("bracket-error",{fontCharacter:"\\ebe6"}),n.lockSmall=new n("lock-small",{fontCharacter:"\\ebe7"}),n.azureDevops=new n("azure-devops",{fontCharacter:"\\ebe8"}),n.verifiedFilled=new n("verified-filled",{fontCharacter:"\\ebe9"}),n.newLine=new n("newline",{fontCharacter:"\\ebea"}),n.layout=new n("layout",{fontCharacter:"\\ebeb"}),n.dialogError=new n("dialog-error",n.error.definition),n.dialogWarning=new n("dialog-warning",n.warning.definition),n.dialogInfo=new n("dialog-info",n.info.definition),n.dialogClose=new n("dialog-close",n.close.definition),n.treeItemExpanded=new n("tree-item-expanded",n.chevronDown.definition),n.treeFilterOnTypeOn=new n("tree-filter-on-type-on",n.listFilter.definition),n.treeFilterOnTypeOff=new n("tree-filter-on-type-off",n.listSelection.definition),n.treeFilterClear=new n("tree-filter-clear",n.close.definition),n.treeItemLoading=new n("tree-item-loading",n.loading.definition),n.menuSelection=new n("menu-selection",n.check.definition),n.menuSubmenu=new n("menu-submenu",n.chevronRight.definition),n.menuBarMore=new n("menubar-more",n.more.definition),n.scrollbarButtonLeft=new n("scrollbar-button-left",n.triangleLeft.definition),n.scrollbarButtonRight=new n("scrollbar-button-right",n.triangleRight.definition),n.scrollbarButtonUp=new n("scrollbar-button-up",n.triangleUp.definition),n.scrollbarButtonDown=new n("scrollbar-button-down",n.triangleDown.definition),n.toolBarMore=new n("toolbar-more",n.more.definition),n.quickInputBack=new n("quick-input-back",n.arrowLeft.definition);function L(A,R){const b=["codicon","codicon-"+A];return R&&b.push("codicon-modifier-"+R),b}e.getClassNamesArray=L;var T;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const R=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function b(C){if(C instanceof n)return["codicon","codicon-"+C.id];const f=R.exec(C.id);if(!f)return b(n.error);let[,S,u]=f;const v=["codicon","codicon-"+S];return u&&v.push("codicon-modifier-"+u.substr(1)),v}A.asClassNameArray=b;function E(C){return b(C).join(" ")}A.asClassName=E;function I(C){return"."+b(C).join(".")}A.asCSSSelector=I})(T=e.CSSIcon||(e.CSSIcon={}))}),define(ne[67],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const D=Object.prototype.hasOwnProperty;function n(I){const C=[];for(let f in I)D.call(I,f)&&C.push(I[f]);return C}e.values=n;function L(I,C){for(let f in I)if(D.call(I,f)&&C({key:f,value:I[f]},function(){delete I[f]})===!1)return}e.forEach=L;function T(I,C){const f=Object.create(null);for(const S of I){const u=C(S);let v=f[u];v||(v=f[u]=[]),v.push(S)}return f}e.groupBy=T;function A(I){const C=Object.create(null);return I&&I.forEach((f,S)=>{C[S]=f}),C}e.fromMap=A;function R(I,C){const f=[],S=[];for(let u of I)C.has(u)||f.push(u);for(let u of C)I.has(u)||S.push(u);return{removed:f,added:S}}e.diffSets=R;function b(I,C){const f=[],S=[];for(let[u,v]of I)C.has(u)||f.push(v);for(let[u,v]of C)I.has(u)||S.push(v);return{removed:f,added:S}}e.diffMaps=b;class E{constructor(){this.map=new Map}add(C,f){let S=this.map.get(C);S||(S=new Set,this.map.set(C,S)),S.add(f)}delete(C,f){const S=this.map.get(C);!S||(S.delete(f),S.size===0&&this.map.delete(C))}forEach(C,f){const S=this.map.get(C);!S||S.forEach(f)}}e.SetMap=E}),define(ne[54],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function D(A){return(R,b,E)=>{let I=null,C=null;if(typeof E.value=="function"?(I="value",C=E.value):typeof E.get=="function"&&(I="get",C=E.get),!C)throw new Error("not supported");E[I]=A(C,b)}}e.createDecorator=D;function n(A,R,b){let E=null,I=null;if(typeof b.value=="function"?(E="value",I=b.value,I.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof b.get=="function"&&(E="get",I=b.get),!I)throw new Error("not supported");const C=`$memoize$${R}`;b[E]=function(...f){return this.hasOwnProperty(C)||Object.defineProperty(this,C,{configurable:!1,enumerable:!1,writable:!1,value:I.apply(this,f)}),this[C]}}e.memoize=n;function L(A,R,b){return D((E,I)=>{const C=`$debounce$${I}`,f=`$debounce$result$${I}`;return function(...S){this[f]||(this[f]=b?b():void 0),clearTimeout(this[C]),R&&(this[f]=R(this[f],...S),S=[this[f]]),this[C]=setTimeout(()=>{E.apply(this,S),this[f]=b?b():void 0},A)}})}e.debounce=L;function T(A,R,b){return D((E,I)=>{const C=`$throttle$timer$${I}`,f=`$throttle$result$${I}`,S=`$throttle$lastRun$${I}`,u=`$throttle$pending$${I}`;return function(...v){if(this[f]||(this[f]=b?b():void 0),(this[S]===null||this[S]===void 0)&&(this[S]=-Number.MAX_VALUE),R&&(this[f]=R(this[f],...v)),this[u])return;const d=this[S]+A;d<=Date.now()?(this[S]=Date.now(),E.apply(this,[this[f]]),this[f]=b?b():void 0):(this[u]=!0,this[C]=setTimeout(()=>{this[u]=!1,this[S]=Date.now(),E.apply(this,[this[f]]),this[f]=b?b():void 0},d-Date.now()))}})}e.throttle=T}),define(ne[9],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class D{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(r){setTimeout(()=>{throw r.stack?new Error(r.message+`

`+r.stack):r},0)}}addListener(r){return this.listeners.push(r),()=>{this._removeListener(r)}}emit(r){this.listeners.forEach(a=>{a(r)})}_removeListener(r){this.listeners.splice(this.listeners.indexOf(r),1)}setUnexpectedErrorHandler(r){this.unexpectedErrorHandler=r}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(r){this.unexpectedErrorHandler(r),this.emit(r)}onUnexpectedExternalError(r){this.unexpectedErrorHandler(r)}}e.ErrorHandler=D,e.errorHandler=new D;function n(l){e.errorHandler.setUnexpectedErrorHandler(l)}e.setUnexpectedErrorHandler=n;function L(l){b(l)||e.errorHandler.onUnexpectedError(l)}e.onUnexpectedError=L;function T(l){b(l)||e.errorHandler.onUnexpectedExternalError(l)}e.onUnexpectedExternalError=T;function A(l){if(l instanceof Error){let{name:r,message:a}=l;const i=l.stacktrace||l.stack;return{$isError:!0,name:r,message:a,stack:i}}return l}e.transformErrorForSerialization=A;const R="Canceled";function b(l){return l instanceof E?!0:l instanceof Error&&l.name===R&&l.message===R}e.isCancellationError=b;class E extends Error{constructor(){super(R);this.name=this.message}}e.CancellationError=E;function I(){const l=new Error(R);return l.name=l.message,l}e.canceled=I;function C(l){return l?new Error(`Illegal argument: ${l}`):new Error("Illegal argument")}e.illegalArgument=C;function f(l){return l?new Error(`Illegal state: ${l}`):new Error("Illegal state")}e.illegalState=f;function S(l){return l?new Error(`readonly property '${l} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=S;function u(l){const r=new Error(`${l} has been disposed`);return r.name="DISPOSED",r}e.disposed=u;function v(l){return l?l.message?l.message:l.stack?l.stack.split(`
`)[0]:String(l):"Error"}e.getErrorMessage=v;class d extends Error{constructor(r){super("NotImplemented");r&&(this.message=r)}}e.NotImplementedError=d;class g extends Error{constructor(r){super("NotSupported");r&&(this.message=r)}}e.NotSupportedError=g;class w extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=w;function y(l){const r=l;return r instanceof Error&&Array.isArray(r.actions)}e.isErrorWithActions=y;function p(l,r=Object.create(null)){const a=new Error(l);return r.actions&&(a.actions=r.actions),a}e.createErrorWithActions=p}),define(ne[16],ie([0,1,9]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.compareBy=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function n(B,F=0){return B[B.length-(1+F)]}e.tail=n;function L(B){if(B.length===0)throw new Error("Invalid tail call");return[B.slice(0,B.length-1),B[B.length-1]]}e.tail2=L;function T(B,F,x=(z,q)=>z===q){if(B===F)return!0;if(!B||!F||B.length!==F.length)return!1;for(let z=0,q=B.length;z<q;z++)if(!x(B[z],F[z]))return!1;return!0}e.equals=T;function A(B,F,x){let z=0,q=B.length-1;for(;z<=q;){const ee=(z+q)/2|0,se=x(B[ee],F);if(se<0)z=ee+1;else if(se>0)q=ee-1;else return ee}return-(z+1)}e.binarySearch=A;function R(B,F){let x=0,z=B.length;if(z===0)return 0;for(;x<z;){const q=Math.floor((x+z)/2);F(B[q])?z=q:x=q+1}return x}e.findFirstInSorted=R;function b(B,F,x){if(B=B|0,B>=F.length)throw new TypeError("invalid index");let z=F[Math.floor(F.length*Math.random())],q=[],ee=[],se=[];for(let ce of F){const ue=x(ce,z);ue<0?q.push(ce):ue>0?ee.push(ce):se.push(ce)}return B<q.length?b(B,q,x):B<q.length+se.length?se[0]:b(B-(q.length+se.length),ee,x)}e.quickSelect=b;function E(B,F){const x=[];let z;for(const q of B.slice(0).sort(F))!z||F(z[0],q)!==0?(z=[q],x.push(z)):z.push(q);return x}e.groupBy=E;function I(B,F,x){const z=[];function q(ce,ue,ve){if(ue===0&&ve.length===0)return;const pe=z[z.length-1];pe&&pe.start+pe.deleteCount===ce?(pe.deleteCount+=ue,pe.toInsert.push(...ve)):z.push({start:ce,deleteCount:ue,toInsert:ve})}let ee=0,se=0;for(;;){if(ee===B.length){q(ee,0,F.slice(se));break}if(se===F.length){q(ee,B.length-ee,[]);break}const ce=B[ee],ue=F[se],ve=x(ce,ue);ve===0?(ee+=1,se+=1):ve<0?(q(ee,1,[]),ee+=1):ve>0&&(q(ee,0,[ue]),se+=1)}return z}e.sortedDiff=I;function C(B,F,x){const z=I(B,F,x),q=[],ee=[];for(const se of z)q.push(...B.slice(se.start,se.start+se.deleteCount)),ee.push(...se.toInsert);return{removed:q,added:ee}}e.delta=C;function f(B,F,x){if(x===0)return[];const z=B.slice(0,x).sort(F);return u(B,F,z,x,B.length),z}e.top=f;function S(B,F,x,z,q){return x===0?Promise.resolve([]):new Promise((ee,se)=>{(async()=>{const ce=B.length,ue=B.slice(0,x).sort(F);for(let ve=x,pe=Math.min(x+z,ce);ve<ce;ve=pe,pe=Math.min(pe+z,ce)){if(ve>x&&await new Promise(Ie=>setTimeout(Ie)),q&&q.isCancellationRequested)throw(0,D.canceled)();u(B,F,ue,ve,pe)}return ue})().then(ee,se)})}e.topAsync=S;function u(B,F,x,z,q){for(const ee=x.length;z<q;z++){const se=B[z];if(F(se,x[ee-1])<0){x.pop();const ce=R(x,ue=>F(se,ue)<0);x.splice(ce,0,se)}}}function v(B){return B.filter(F=>!!F)}e.coalesce=v;function d(B){let F=0;for(let x=0;x<B.length;x++)B[x]&&(B[F]=B[x],F+=1);B.length=F}e.coalesceInPlace=d;function g(B,F,x){B.splice(x,0,B.splice(F,1)[0])}e.move=g;function w(B){return!Array.isArray(B)||B.length===0}e.isFalsyOrEmpty=w;function y(B){return Array.isArray(B)&&B.length>0}e.isNonEmptyArray=y;function p(B,F=x=>x){const x=new Set;return B.filter(z=>{const q=F(z);return x.has(q)?!1:(x.add(q),!0)})}e.distinct=p;function l(B){const F=new Set;return x=>{const z=B(x);return F.has(z)?!1:(F.add(z),!0)}}e.uniqueFilter=l;function r(B,F){const x=a(B,F);if(x!==-1)return B[x]}e.findLast=r;function a(B,F){for(let x=B.length-1;x>=0;x--){const z=B[x];if(F(z))return x}return-1}e.lastIndex=a;function i(B,F){return B.length>0?B[0]:F}e.firstOrDefault=i;function t(B,F,x=(z,q)=>z===q){let z=0;for(let q=0,ee=Math.min(B.length,F.length);q<ee&&x(B[q],F[q]);q++)z++;return z}e.commonPrefixLength=t;function o(B){return[].concat(...B)}e.flatten=o;function s(B,F){let x=typeof F=="number"?B:0;typeof F=="number"?x=B:(x=0,F=B);const z=[];if(x<=F)for(let q=x;q<F;q++)z.push(q);else for(let q=x;q>F;q--)z.push(q);return z}e.range=s;function c(B,F,x){return B.reduce((z,q)=>(z[F(q)]=x?x(q):q,z),Object.create(null))}e.index=c;function h(B,F){return B.push(F),()=>m(B,F)}e.insert=h;function m(B,F){const x=B.indexOf(F);if(x>-1)return B.splice(x,1),F}e.remove=m;function P(B,F,x){const z=B.slice(0,F),q=B.slice(F);return z.concat(x,q)}e.arrayInsert=P;function _(B,F){let x;if(typeof F=="number"){let z=F;x=()=>{const q=Math.sin(z++)*179426549;return q-Math.floor(q)}}else x=Math.random;for(let z=B.length-1;z>0;z-=1){const q=Math.floor(x()*(z+1)),ee=B[z];B[z]=B[q],B[q]=ee}}e.shuffle=_;function O(B,F){const x=B.indexOf(F);x>-1&&(B.splice(x,1),B.unshift(F))}e.pushToStart=O;function M(B,F){const x=B.indexOf(F);x>-1&&(B.splice(x,1),B.push(F))}e.pushToEnd=M;function k(B,F){return Array.isArray(B)?B.map(F):F(B)}e.mapArrayOrNot=k;function U(B){return Array.isArray(B)?B:[B]}e.asArray=U;function N(B){return B[Math.floor(Math.random()*B.length)]}e.getRandomElement=N;function V(B,F){for(const x of B){const z=F(x);if(z!==void 0)return z}}e.mapFind=V;function $(B,F,x){const z=te(B,F),q=B.length,ee=x.length;B.length=q+ee;for(let se=q-1;se>=z;se--)B[se+ee]=B[se];for(let se=0;se<ee;se++)B[se+z]=x[se]}e.insertInto=$;function G(B,F,x,z){const q=te(B,F),ee=B.splice(q,x);return $(B,q,z),ee}e.splice=G;function te(B,F){return F<0?Math.max(F+B.length,0):Math.min(F,B.length)}function W(B,F){return(x,z)=>F(B(x),B(z))}e.compareBy=W;const j=(B,F)=>B-F;e.numberComparator=j;function K(B,F){if(B.length===0)return;let x=B[0];for(let z=1;z<B.length;z++){const q=B[z];F(q,x)>0&&(x=q)}return x}e.findMaxBy=K;function H(B,F){if(B.length===0)return;let x=B[0];for(let z=1;z<B.length;z++){const q=B[z];F(q,x)>=0&&(x=q)}return x}e.findLastMaxBy=H;function Q(B,F){return K(B,(x,z)=>-F(x,z))}e.findMinBy=Q;class Z{constructor(F){this.items=F,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(F){let x=this.firstIdx;for(;x<this.items.length&&F(this.items[x]);)x++;const z=x===this.firstIdx?null:this.items.slice(this.firstIdx,x);return this.firstIdx=x,z}takeFromEndWhile(F){let x=this.lastIdx;for(;x>=0&&F(this.items[x]);)x--;const z=x===this.lastIdx?null:this.items.slice(x+1,this.lastIdx+1);return this.lastIdx=x,z}peek(){return this.items[this.firstIdx]}dequeue(){const F=this.items[this.firstIdx];return this.firstIdx++,F}takeCount(F){const x=this.items.slice(this.firstIdx,this.firstIdx+F);return this.firstIdx+=F,x}}e.ArrayQueue=Z}),define(ne[68],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function D(n){const L=this;let T=!1,A;return function(){return T||(T=!0,A=n.apply(L,arguments)),A}}e.once=D}),define(ne[55],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var D;(function(n){function L(l){return l&&typeof l=="object"&&typeof l[Symbol.iterator]=="function"}n.is=L;const T=Object.freeze([]);function A(){return T}n.empty=A;function*R(l){yield l}n.single=R;function b(l){return l||T}n.from=b;function E(l){return!l||l[Symbol.iterator]().next().done===!0}n.isEmpty=E;function I(l){return l[Symbol.iterator]().next().value}n.first=I;function C(l,r){for(const a of l)if(r(a))return!0;return!1}n.some=C;function f(l,r){for(const a of l)if(r(a))return a}n.find=f;function*S(l,r){for(const a of l)r(a)&&(yield a)}n.filter=S;function*u(l,r){let a=0;for(const i of l)yield r(i,a++)}n.map=u;function*v(...l){for(const r of l)for(const a of r)yield a}n.concat=v;function*d(l){for(const r of l)for(const a of r)yield a}n.concatNested=d;function g(l,r,a){let i=a;for(const t of l)i=r(i,t);return i}n.reduce=g;function*w(l,r,a=l.length){for(r<0&&(r+=l.length),a<0?a+=l.length:a>l.length&&(a=l.length);r<a;r++)yield l[r]}n.slice=w;function y(l,r=Number.POSITIVE_INFINITY){const a=[];if(r===0)return[a,l];const i=l[Symbol.iterator]();for(let t=0;t<r;t++){const o=i.next();if(o.done)return[a,n.empty()];a.push(o.value)}return[a,{[Symbol.iterator](){return i}}]}n.consume=y;function p(l,r,a=(i,t)=>i===t){const i=l[Symbol.iterator](),t=r[Symbol.iterator]();for(;;){const o=i.next(),s=t.next();if(o.done!==s.done)return!1;if(o.done)return!0;if(!a(o.value,s.value))return!1}}n.equals=p})(D=e.Iterable||(e.Iterable={}))}),define(ne[35],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var D;(function(r){r[r.None=0]="None",r[r.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=2]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",r[r.InvalidUnicode=4]="InvalidUnicode",r[r.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",r[r.InvalidCharacter=6]="InvalidCharacter"})(D=e.ScanError||(e.ScanError={}));var n;(function(r){r[r.OpenBraceToken=1]="OpenBraceToken",r[r.CloseBraceToken=2]="CloseBraceToken",r[r.OpenBracketToken=3]="OpenBracketToken",r[r.CloseBracketToken=4]="CloseBracketToken",r[r.CommaToken=5]="CommaToken",r[r.ColonToken=6]="ColonToken",r[r.NullKeyword=7]="NullKeyword",r[r.TrueKeyword=8]="TrueKeyword",r[r.FalseKeyword=9]="FalseKeyword",r[r.StringLiteral=10]="StringLiteral",r[r.NumericLiteral=11]="NumericLiteral",r[r.LineCommentTrivia=12]="LineCommentTrivia",r[r.BlockCommentTrivia=13]="BlockCommentTrivia",r[r.LineBreakTrivia=14]="LineBreakTrivia",r[r.Trivia=15]="Trivia",r[r.Unknown=16]="Unknown",r[r.EOF=17]="EOF"})(n=e.SyntaxKind||(e.SyntaxKind={}));var L;(function(r){r[r.InvalidSymbol=1]="InvalidSymbol",r[r.InvalidNumberFormat=2]="InvalidNumberFormat",r[r.PropertyNameExpected=3]="PropertyNameExpected",r[r.ValueExpected=4]="ValueExpected",r[r.ColonExpected=5]="ColonExpected",r[r.CommaExpected=6]="CommaExpected",r[r.CloseBraceExpected=7]="CloseBraceExpected",r[r.CloseBracketExpected=8]="CloseBracketExpected",r[r.EndOfFileExpected=9]="EndOfFileExpected",r[r.InvalidCommentToken=10]="InvalidCommentToken",r[r.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=12]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",r[r.InvalidUnicode=14]="InvalidUnicode",r[r.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",r[r.InvalidCharacter=16]="InvalidCharacter"})(L=e.ParseErrorCode||(e.ParseErrorCode={}));var T;(function(r){r.DEFAULT={allowTrailingComma:!0}})(T=e.ParseOptions||(e.ParseOptions={}));function A(r,a=!1){let i=0,t=r.length,o="",s=0,c=16,h=0;function m(N){let V=0,$=0;for(;V<N;){const G=r.charCodeAt(i);if(G>=48&&G<=57)$=$*16+G-48;else if(G>=65&&G<=70)$=$*16+G-65+10;else if(G>=97&&G<=102)$=$*16+G-97+10;else break;i++,V++}return V<N&&($=-1),$}function P(N){i=N,o="",s=0,c=16,h=0}function _(){const N=i;if(r.charCodeAt(i)===48)i++;else for(i++;i<r.length&&E(r.charCodeAt(i));)i++;if(i<r.length&&r.charCodeAt(i)===46)if(i++,i<r.length&&E(r.charCodeAt(i)))for(i++;i<r.length&&E(r.charCodeAt(i));)i++;else return h=3,r.substring(N,i);let V=i;if(i<r.length&&(r.charCodeAt(i)===69||r.charCodeAt(i)===101))if(i++,(i<r.length&&r.charCodeAt(i)===43||r.charCodeAt(i)===45)&&i++,i<r.length&&E(r.charCodeAt(i))){for(i++;i<r.length&&E(r.charCodeAt(i));)i++;V=i}else h=3;return r.substring(N,V)}function O(){let N="",V=i;for(;;){if(i>=t){N+=r.substring(V,i),h=2;break}const $=r.charCodeAt(i);if($===34){N+=r.substring(V,i),i++;break}if($===92){if(N+=r.substring(V,i),i++,i>=t){h=2;break}switch(r.charCodeAt(i++)){case 34:N+='"';break;case 92:N+="\\";break;case 47:N+="/";break;case 98:N+="\b";break;case 102:N+="\f";break;case 110:N+=`
`;break;case 114:N+="\r";break;case 116:N+="	";break;case 117:{const te=m(4);te>=0?N+=String.fromCharCode(te):h=4;break}default:h=5}V=i;continue}if($>=0&&$<=31)if(b($)){N+=r.substring(V,i),h=2;break}else h=6;i++}return N}function M(){if(o="",h=0,s=i,i>=t)return s=t,c=17;let N=r.charCodeAt(i);if(R(N)){do i++,o+=String.fromCharCode(N),N=r.charCodeAt(i);while(R(N));return c=15}if(b(N))return i++,o+=String.fromCharCode(N),N===13&&r.charCodeAt(i)===10&&(i++,o+=`
`),c=14;switch(N){case 123:return i++,c=1;case 125:return i++,c=2;case 91:return i++,c=3;case 93:return i++,c=4;case 58:return i++,c=6;case 44:return i++,c=5;case 34:return i++,o=O(),c=10;case 47:{const V=i-1;if(r.charCodeAt(i+1)===47){for(i+=2;i<t&&!b(r.charCodeAt(i));)i++;return o=r.substring(V,i),c=12}if(r.charCodeAt(i+1)===42){i+=2;const $=t-1;let G=!1;for(;i<$;){if(r.charCodeAt(i)===42&&r.charCodeAt(i+1)===47){i+=2,G=!0;break}i++}return G||(i++,h=1),o=r.substring(V,i),c=13}return o+=String.fromCharCode(N),i++,c=16}case 45:if(o+=String.fromCharCode(N),i++,i===t||!E(r.charCodeAt(i)))return c=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=_(),c=11;default:for(;i<t&&k(N);)i++,N=r.charCodeAt(i);if(s!==i){switch(o=r.substring(s,i),o){case"true":return c=8;case"false":return c=9;case"null":return c=7}return c=16}return o+=String.fromCharCode(N),i++,c=16}}function k(N){if(R(N)||b(N))return!1;switch(N){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function U(){let N;do N=M();while(N>=12&&N<=15);return N}return{setPosition:P,getPosition:()=>i,scan:a?U:M,getToken:()=>c,getTokenValue:()=>o,getTokenOffset:()=>s,getTokenLength:()=>i-s,getTokenError:()=>h}}e.createScanner=A;function R(r){return r===32||r===9||r===11||r===12||r===160||r===5760||r>=8192&&r<=8203||r===8239||r===8287||r===12288||r===65279}function b(r){return r===10||r===13||r===8232||r===8233}function E(r){return r>=48&&r<=57}var I;(function(r){r[r.nullCharacter=0]="nullCharacter",r[r.maxAsciiCharacter=127]="maxAsciiCharacter",r[r.lineFeed=10]="lineFeed",r[r.carriageReturn=13]="carriageReturn",r[r.lineSeparator=8232]="lineSeparator",r[r.paragraphSeparator=8233]="paragraphSeparator",r[r.nextLine=133]="nextLine",r[r.space=32]="space",r[r.nonBreakingSpace=160]="nonBreakingSpace",r[r.enQuad=8192]="enQuad",r[r.emQuad=8193]="emQuad",r[r.enSpace=8194]="enSpace",r[r.emSpace=8195]="emSpace",r[r.threePerEmSpace=8196]="threePerEmSpace",r[r.fourPerEmSpace=8197]="fourPerEmSpace",r[r.sixPerEmSpace=8198]="sixPerEmSpace",r[r.figureSpace=8199]="figureSpace",r[r.punctuationSpace=8200]="punctuationSpace",r[r.thinSpace=8201]="thinSpace",r[r.hairSpace=8202]="hairSpace",r[r.zeroWidthSpace=8203]="zeroWidthSpace",r[r.narrowNoBreakSpace=8239]="narrowNoBreakSpace",r[r.ideographicSpace=12288]="ideographicSpace",r[r.mathematicalSpace=8287]="mathematicalSpace",r[r.ogham=5760]="ogham",r[r._=95]="_",r[r.$=36]="$",r[r._0=48]="_0",r[r._1=49]="_1",r[r._2=50]="_2",r[r._3=51]="_3",r[r._4=52]="_4",r[r._5=53]="_5",r[r._6=54]="_6",r[r._7=55]="_7",r[r._8=56]="_8",r[r._9=57]="_9",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.ampersand=38]="ampersand",r[r.asterisk=42]="asterisk",r[r.at=64]="at",r[r.backslash=92]="backslash",r[r.bar=124]="bar",r[r.caret=94]="caret",r[r.closeBrace=125]="closeBrace",r[r.closeBracket=93]="closeBracket",r[r.closeParen=41]="closeParen",r[r.colon=58]="colon",r[r.comma=44]="comma",r[r.dot=46]="dot",r[r.doubleQuote=34]="doubleQuote",r[r.equals=61]="equals",r[r.exclamation=33]="exclamation",r[r.greaterThan=62]="greaterThan",r[r.lessThan=60]="lessThan",r[r.minus=45]="minus",r[r.openBrace=123]="openBrace",r[r.openBracket=91]="openBracket",r[r.openParen=40]="openParen",r[r.percent=37]="percent",r[r.plus=43]="plus",r[r.question=63]="question",r[r.semicolon=59]="semicolon",r[r.singleQuote=39]="singleQuote",r[r.slash=47]="slash",r[r.tilde=126]="tilde",r[r.backspace=8]="backspace",r[r.formFeed=12]="formFeed",r[r.byteOrderMark=65279]="byteOrderMark",r[r.tab=9]="tab",r[r.verticalTab=11]="verticalTab"})(I||(I={}));function C(r,a){const i=[],t=new Object;let o;const s={value:{},offset:0,length:0,type:"object",parent:void 0};let c=!1;function h(m,P,_,O){s.value=m,s.offset=P,s.length=_,s.type=O,s.colonOffset=void 0,o=s}try{y(r,{onObjectBegin:(m,P)=>{if(a<=m)throw t;o=void 0,c=a>m,i.push("")},onObjectProperty:(m,P,_)=>{if(a<P||(h(m,P,_,"property"),i[i.length-1]=m,a<=P+_))throw t},onObjectEnd:(m,P)=>{if(a<=m)throw t;o=void 0,i.pop()},onArrayBegin:(m,P)=>{if(a<=m)throw t;o=void 0,i.push(0)},onArrayEnd:(m,P)=>{if(a<=m)throw t;o=void 0,i.pop()},onLiteralValue:(m,P,_)=>{if(a<P||(h(m,P,_,l(m)),a<=P+_))throw t},onSeparator:(m,P,_)=>{if(a<=P)throw t;if(m===":"&&o&&o.type==="property")o.colonOffset=P,c=!1,o=void 0;else if(m===","){const O=i[i.length-1];typeof O=="number"?i[i.length-1]=O+1:(c=!0,i[i.length-1]=""),o=void 0}}})}catch(m){if(m!==t)throw m}return{path:i,previousNode:o,isAtPropertyKey:c,matches:m=>{let P=0;for(let _=0;P<m.length&&_<i.length;_++)if(m[P]===i[_]||m[P]==="*")P++;else if(m[P]!=="**")return!1;return P===m.length}}}e.getLocation=C;function f(r,a=[],i=T.DEFAULT){let t=null,o=[];const s=[];function c(m){Array.isArray(o)?o.push(m):t!==null&&(o[t]=m)}return y(r,{onObjectBegin:()=>{const m={};c(m),s.push(o),o=m,t=null},onObjectProperty:m=>{t=m},onObjectEnd:()=>{o=s.pop()},onArrayBegin:()=>{const m=[];c(m),s.push(o),o=m,t=null},onArrayEnd:()=>{o=s.pop()},onLiteralValue:c,onError:(m,P,_)=>{a.push({error:m,offset:P,length:_})}},i),o[0]}e.parse=f;function S(r,a=[],i=T.DEFAULT){let t={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(m){t.type==="property"&&(t.length=m-t.offset,t=t.parent)}function s(m){return t.children.push(m),m}y(r,{onObjectBegin:m=>{t=s({type:"object",offset:m,length:-1,parent:t,children:[]})},onObjectProperty:(m,P,_)=>{t=s({type:"property",offset:P,length:-1,parent:t,children:[]}),t.children.push({type:"string",value:m,offset:P,length:_,parent:t})},onObjectEnd:(m,P)=>{t.length=m+P-t.offset,t=t.parent,o(m+P)},onArrayBegin:(m,P)=>{t=s({type:"array",offset:m,length:-1,parent:t,children:[]})},onArrayEnd:(m,P)=>{t.length=m+P-t.offset,t=t.parent,o(m+P)},onLiteralValue:(m,P,_)=>{s({type:l(m),offset:P,length:_,parent:t,value:m}),o(P+_)},onSeparator:(m,P,_)=>{t.type==="property"&&(m===":"?t.colonOffset=P:m===","&&o(P))},onError:(m,P,_)=>{a.push({error:m,offset:P,length:_})}},i);const h=t.children[0];return h&&delete h.parent,h}e.parseTree=S;function u(r,a){if(!r)return;let i=r;for(let t of a)if(typeof t=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let o=!1;for(const s of i.children)if(Array.isArray(s.children)&&s.children[0].value===t){i=s.children[1],o=!0;break}if(!o)return}else{const o=t;if(i.type!=="array"||o<0||!Array.isArray(i.children)||o>=i.children.length)return;i=i.children[o]}return i}e.findNodeAtLocation=u;function v(r){if(!r.parent||!r.parent.children)return[];const a=v(r.parent);if(r.parent.type==="property"){const i=r.parent.children[0].value;a.push(i)}else if(r.parent.type==="array"){const i=r.parent.children.indexOf(r);i!==-1&&a.push(i)}return a}e.getNodePath=v;function d(r){switch(r.type){case"array":return r.children.map(d);case"object":{const a=Object.create(null);for(let i of r.children){const t=i.children[1];t&&(a[i.children[0].value]=d(t))}return a}case"null":case"string":case"number":case"boolean":return r.value;default:return}}e.getNodeValue=d;function g(r,a,i=!1){return a>=r.offset&&a<r.offset+r.length||i&&a===r.offset+r.length}e.contains=g;function w(r,a,i=!1){if(g(r,a,i)){const t=r.children;if(Array.isArray(t))for(let o=0;o<t.length&&t[o].offset<=a;o++){const s=w(t[o],a,i);if(s)return s}return r}}e.findNodeAtOffset=w;function y(r,a,i=T.DEFAULT){const t=A(r,!1);function o(Z){return Z?()=>Z(t.getTokenOffset(),t.getTokenLength()):()=>!0}function s(Z){return Z?B=>Z(B,t.getTokenOffset(),t.getTokenLength()):()=>!0}const c=o(a.onObjectBegin),h=s(a.onObjectProperty),m=o(a.onObjectEnd),P=o(a.onArrayBegin),_=o(a.onArrayEnd),O=s(a.onLiteralValue),M=s(a.onSeparator),k=o(a.onComment),U=s(a.onError),N=i&&i.disallowComments,V=i&&i.allowTrailingComma;function $(){for(;;){const Z=t.scan();switch(t.getTokenError()){case 4:G(14);break;case 5:G(15);break;case 3:G(13);break;case 1:N||G(11);break;case 2:G(12);break;case 6:G(16);break}switch(Z){case 12:case 13:N?G(10):k();break;case 16:G(1);break;case 15:case 14:break;default:return Z}}}function G(Z,B=[],F=[]){if(U(Z),B.length+F.length>0){let x=t.getToken();for(;x!==17;){if(B.indexOf(x)!==-1){$();break}else if(F.indexOf(x)!==-1)break;x=$()}}}function te(Z){const B=t.getTokenValue();return Z?O(B):h(B),$(),!0}function W(){switch(t.getToken()){case 11:{let Z=0;try{Z=JSON.parse(t.getTokenValue()),typeof Z!="number"&&(G(2),Z=0)}catch{G(2)}O(Z);break}case 7:O(null);break;case 8:O(!0);break;case 9:O(!1);break;default:return!1}return $(),!0}function j(){return t.getToken()!==10?(G(3,[],[2,5]),!1):(te(!1),t.getToken()===6?(M(":"),$(),Q()||G(4,[],[2,5])):G(5,[],[2,5]),!0)}function K(){c(),$();let Z=!1;for(;t.getToken()!==2&&t.getToken()!==17;){if(t.getToken()===5){if(Z||G(4,[],[]),M(","),$(),t.getToken()===2&&V)break}else Z&&G(6,[],[]);j()||G(4,[],[2,5]),Z=!0}return m(),t.getToken()!==2?G(7,[2],[]):$(),!0}function H(){P(),$();let Z=!1;for(;t.getToken()!==4&&t.getToken()!==17;){if(t.getToken()===5){if(Z||G(4,[],[]),M(","),$(),t.getToken()===4&&V)break}else Z&&G(6,[],[]);Q()||G(4,[],[4,5]),Z=!0}return _(),t.getToken()!==4?G(8,[4],[]):$(),!0}function Q(){switch(t.getToken()){case 3:return H();case 1:return K();case 10:return te(!0);default:return W()}}return $(),t.getToken()===17?i.allowEmptyContent?!0:(G(4,[],[]),!1):Q()?(t.getToken()!==17&&G(9,[],[]),!0):(G(4,[],[]),!1)}e.visit=y;function p(r,a){let i=A(r),t=[],o,s=0,c;do switch(c=i.getPosition(),o=i.scan(),o){case 12:case 13:case 17:s!==c&&t.push(r.substring(s,c)),a!==void 0&&t.push(i.getTokenValue().replace(/[^\r\n]/g,a)),s=i.getPosition();break}while(o!==17);return t.join("")}e.stripComments=p;function l(r){switch(typeof r){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(r){if(Array.isArray(r))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=l}),define(ne[49],ie([0,1,35]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function n(E,I,C){let f,S,u,v,d;if(I){for(v=I.offset,d=v+I.length,u=v;u>0&&!b(E,u-1);)u--;let c=d;for(;c<E.length&&!b(E,c);)c++;S=E.substring(u,c),f=A(S,C)}else S=E,f=0,u=0,v=0,d=E.length;const g=R(C,E);let w=!1,y=0,p;C.insertSpaces?p=T(" ",C.tabSize||4):p="	";const l=(0,D.createScanner)(S,!1);let r=!1;function a(){return g+T(p,f+y)}function i(){let c=l.scan();for(w=!1;c===15||c===14;)w=w||c===14,c=l.scan();return r=c===16||l.getTokenError()!==0,c}const t=[];function o(c,h,m){!r&&h<d&&m>v&&E.substring(h,m)!==c&&t.push({offset:h,length:m-h,content:c})}let s=i();if(s!==17){const c=l.getTokenOffset()+u,h=T(p,f);o(h,u,c)}for(;s!==17;){let c=l.getTokenOffset()+l.getTokenLength()+u,h=i(),m="";for(;!w&&(h===12||h===13);){const _=l.getTokenOffset()+u;o(" ",c,_),c=l.getTokenOffset()+l.getTokenLength()+u,m=h===12?a():"",h=i()}if(h===2)s!==1&&(y--,m=a());else if(h===4)s!==3&&(y--,m=a());else{switch(s){case 3:case 1:y++,m=a();break;case 5:case 12:m=a();break;case 13:w?m=a():m=" ";break;case 6:m=" ";break;case 10:if(h===6){m="";break}case 7:case 8:case 9:case 11:case 2:case 4:h===12||h===13?m=" ":h!==5&&h!==17&&(r=!0);break;case 16:r=!0;break}w&&(h===12||h===13)&&(m=a())}const P=l.getTokenOffset()+u;o(m,c,P),s=h}return t}e.format=n;function L(E,I){const C=JSON.stringify(E,void 0,I.insertSpaces?I.tabSize||4:"	");return I.eol!==void 0?C.replace(/\r\n|\r|\n/g,I.eol):C}e.toFormattedString=L;function T(E,I){let C="";for(let f=0;f<I;f++)C+=E;return C}function A(E,I){let C=0,f=0;const S=I.tabSize||4;for(;C<E.length;){const u=E.charAt(C);if(u===" ")f++;else if(u==="	")f+=S;else break;C++}return Math.floor(f/S)}function R(E,I){for(let C=0;C<I.length;C++){const f=I.charAt(C);if(f==="\r")return C+1<I.length&&I.charAt(C+1)===`
`?`\r
`:"\r";if(f===`
`)return`
`}return E&&E.eol||`
`}e.getEOL=R;function b(E,I){return`\r
`.indexOf(E.charAt(I))!==-1}e.isEOL=b}),define(ne[69],ie([0,1,35,49]),function(J,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function L(E,I,C){return T(E,I,void 0,C)}e.removeProperty=L;function T(E,I,C,f,S){const u=I.slice(),v=[],d=(0,D.parseTree)(E,v);let g,w;for(;u.length>0&&(w=u.pop(),g=(0,D.findNodeAtLocation)(d,u),g===void 0&&C!==void 0);)typeof w=="string"?C={[w]:C}:C=[C];if(g)if(g.type==="object"&&typeof w=="string"&&Array.isArray(g.children)){const y=(0,D.findNodeAtLocation)(g,[w]);if(y!==void 0)if(C===void 0){if(!y.parent)throw new Error("Malformed AST");const p=g.children.indexOf(y.parent);let l,r=y.parent.offset+y.parent.length;if(p>0){const a=g.children[p-1];l=a.offset+a.length}else l=g.offset+1,g.children.length>1&&(r=g.children[1].offset);return A(E,{offset:l,length:r-l,content:""},f)}else return A(E,{offset:y.offset,length:y.length,content:JSON.stringify(C)},f);else{if(C===void 0)return[];const p=`${JSON.stringify(w)}: ${JSON.stringify(C)}`,l=S?S(g.children.map(a=>a.children[0].value)):g.children.length;let r;if(l>0){const a=g.children[l-1];r={offset:a.offset+a.length,length:0,content:","+p}}else g.children.length===0?r={offset:g.offset+1,length:0,content:p}:r={offset:g.offset+1,length:0,content:p+","};return A(E,r,f)}}else if(g.type==="array"&&typeof w=="number"&&Array.isArray(g.children))if(C!==void 0){const y=`${JSON.stringify(C)}`;let p;if(g.children.length===0||w===0)p={offset:g.offset+1,length:0,content:g.children.length===0?y:y+","};else{const l=w===-1||w>g.children.length?g.children.length:w,r=g.children[l-1];p={offset:r.offset+r.length,length:0,content:","+y}}return A(E,p,f)}else{const y=w,p=g.children[y];let l;if(g.children.length===1)l={offset:g.offset+1,length:g.length-2,content:""};else if(g.children.length-1===y){const r=g.children[y-1],a=r.offset+r.length,i=g.offset+g.length;l={offset:a,length:i-2-a,content:""}}else l={offset:p.offset,length:g.children[y+1].offset-p.offset,content:""};return A(E,l,f)}else throw new Error(`Can not add ${typeof w!="number"?"index":"property"} to parent of type ${g.type}`);else{if(C===void 0)throw new Error("Can not delete in empty document");return A(E,{offset:d?d.offset:0,length:d?d.length:0,content:JSON.stringify(C)},f)}}e.setProperty=T;function A(E,I,C){let f=R(E,I),S=I.offset,u=I.offset+I.content.length;if(I.length===0||I.content.length===0){for(;S>0&&!(0,n.isEOL)(f,S-1);)S--;for(;u<f.length&&!(0,n.isEOL)(f,u);)u++}const v=(0,n.format)(f,{offset:S,length:u-S},C);for(let g=v.length-1;g>=0;g--){const w=v[g];f=R(f,w),S=Math.min(S,w.offset),u=Math.max(u,w.offset+w.length),u+=w.content.length-w.length}const d=E.length-(f.length-u)-S;return[{offset:S,length:d,content:f.substring(S,u)}]}e.withFormatting=A;function R(E,I){return E.substring(0,I.offset)+I.content+E.substring(I.offset+I.length)}e.applyEdit=R;function b(E,I){let C=I.slice(0).sort((S,u)=>{const v=S.offset-u.offset;return v===0?S.length-u.length:v}),f=E.length;for(let S=C.length-1;S>=0;S--){let u=C[S];if(u.offset+u.length<=f)E=R(E,u);else throw new Error("Overlapping edit");f=u.offset}return E}e.applyEdits=b}),define(ne[100],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class D{constructor(L){this.executor=L,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(L){this._error=L}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(L){return new D(()=>L(this.getValue()))}}e.Lazy=D}),define(ne[2],ie([0,1,68,55]),function(J,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const L=!1;let T=null;function A(t){T=t}if(e.setDisposableTracker=A,L){const t="__is_disposable_tracked__";A(new class{trackDisposable(o){const s=new Error("Potentially leaked disposable").stack;setTimeout(()=>{o[t]||console.log(s)},3e3)}setParent(o,s){if(o&&o!==w.None)try{o[t]=!0}catch{}}markAsDisposed(o){if(o&&o!==w.None)try{o[t]=!0}catch{}}markAsSingleton(o){}})}function R(t){return T?.trackDisposable(t),t}function b(t){T?.markAsDisposed(t)}function E(t,o){T?.setParent(t,o)}function I(t,o){if(!!T)for(const s of t)T.setParent(s,o)}function C(t){return T?.markAsSingleton(t),t}e.markAsSingleton=C;class f extends Error{constructor(o){super(`Encountered errors while disposing of store. Errors: [${o.join(", ")}]`);this.errors=o}}e.MultiDisposeError=f;function S(t){return typeof t.dispose=="function"&&t.dispose.length===0}e.isDisposable=S;function u(t){if(n.Iterable.is(t)){let o=[];for(const s of t)if(s)try{s.dispose()}catch(c){o.push(c)}if(o.length===1)throw o[0];if(o.length>1)throw new f(o);return Array.isArray(t)?[]:t}else if(t)return t.dispose(),t}e.dispose=u;function v(...t){const o=d(()=>u(t));return I(t,o),o}e.combinedDisposable=v;function d(t){const o=R({dispose:(0,D.once)(()=>{b(o),t()})});return o}e.toDisposable=d;class g{constructor(){this._toDispose=new Set,this._isDisposed=!1,R(this)}dispose(){this._isDisposed||(b(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{u(this._toDispose.values())}finally{this._toDispose.clear()}}add(o){if(!o)return o;if(o===this)throw new Error("Cannot register a disposable on itself!");return E(o,this),this._isDisposed?g.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(o),o}}e.DisposableStore=g,g.DISABLE_DISPOSED_WARNING=!1;class w{constructor(){this._store=new g,R(this),E(this._store,this)}dispose(){b(this),this._store.dispose()}_register(o){if(o===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(o)}}e.Disposable=w,w.None=Object.freeze({dispose(){}});class y{constructor(){this._isDisposed=!1,R(this)}get value(){return this._isDisposed?void 0:this._value}set value(o){this._isDisposed||o===this._value||(this._value?.dispose(),o&&E(o,this),this._value=o)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,b(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const o=this._value;return this._value=void 0,o&&E(o,null),o}}e.MutableDisposable=y;class p{constructor(o){this._disposable=o,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=p;class l{constructor(){this.references=new Map}acquire(o,...s){let c=this.references.get(o);c||(c={counter:0,object:this.createReferencedObject(o,...s)},this.references.set(o,c));const{object:h}=c,m=(0,D.once)(()=>{--c.counter==0&&(this.destroyReferencedObject(o,c.object),this.references.delete(o))});return c.counter++,{object:h,dispose:m}}}e.ReferenceCollection=l;class r{constructor(o){this.referenceCollection=o}async acquire(o,...s){const c=this.referenceCollection.acquire(o,...s);try{return{object:await c.object,dispose:()=>c.dispose()}}catch(h){throw c.dispose(),h}}}e.AsyncReferenceCollection=r;class a{constructor(o){this.object=o}dispose(){}}e.ImmortalReference=a;function i(t){const o=new g;try{t(o)}finally{o.dispose()}}e.disposeOnReturn=i}),define(ne[101],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class D{constructor(T){this.element=T,this.next=D.Undefined,this.prev=D.Undefined}}D.Undefined=new D(void 0);class n{constructor(){this._first=D.Undefined,this._last=D.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===D.Undefined}clear(){let T=this._first;for(;T!==D.Undefined;){const A=T.next;T.prev=D.Undefined,T.next=D.Undefined,T=A}this._first=D.Undefined,this._last=D.Undefined,this._size=0}unshift(T){return this._insert(T,!1)}push(T){return this._insert(T,!0)}_insert(T,A){const R=new D(T);if(this._first===D.Undefined)this._first=R,this._last=R;else if(A){const E=this._last;this._last=R,R.prev=E,E.next=R}else{const E=this._first;this._first=R,R.next=E,E.prev=R}this._size+=1;let b=!1;return()=>{b||(b=!0,this._remove(R))}}shift(){if(this._first!==D.Undefined){const T=this._first.element;return this._remove(this._first),T}}pop(){if(this._last!==D.Undefined){const T=this._last.element;return this._remove(this._last),T}}_remove(T){if(T.prev!==D.Undefined&&T.next!==D.Undefined){const A=T.prev;A.next=T.next,T.next.prev=A}else T.prev===D.Undefined&&T.next===D.Undefined?(this._first=D.Undefined,this._last=D.Undefined):T.next===D.Undefined?(this._last=this._last.prev,this._last.next=D.Undefined):T.prev===D.Undefined&&(this._first=this._first.next,this._first.prev=D.Undefined);this._size-=1}*[Symbol.iterator](){let T=this._first;for(;T!==D.Undefined;)yield T.element,T=T.next}}e.LinkedList=n}),function(){function J(L){const T=[];typeof L=="number"&&T.push("code/timeOrigin",L);function A(b){T.push(b,Date.now())}function R(){const b=[];for(let E=0;E<T.length;E+=2)b.push({name:T[E],startTime:T[E+1]});return b}return{mark:A,getMarks:R}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?J():{mark(L){performance.mark(L)},getMarks(){let L=performance.timeOrigin;typeof L!="number"&&(L=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const T=[{name:"code/timeOrigin",startTime:Math.round(L)}];for(const A of performance.getEntriesByType("mark"))T.push({name:A.name,startTime:Math.round(L+A.startTime)});return T}};if(typeof process=="object"){const L=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return J(L)}else return console.trace("perf-util loaded in UNKNOWN environment"),J()}function D(L){return L.MonacoPerformanceMarks||(L.MonacoPerformanceMarks=e()),L.MonacoPerformanceMarks}var n;typeof global=="object"?n=global:typeof self=="object"?n=self:n={},typeof define=="function"?define("vs/base/common/performance",[],function(){return D(n)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=D(n):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),n.perf=D(n))}(),define(ne[4],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const D="en";let n=!1,L=!1,T=!1,A=!1,R=!1,b=!1,E=!1,I=!1,C,f=D,S,u;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let v;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?v=e.globals.vscode.process:typeof process!="undefined"&&(v=process);const d=typeof v?.versions?.electron=="string",g=d&&v?.type==="renderer";if(e.isElectronSandboxed=g&&v?.sandboxed,typeof navigator=="object"&&!g)u=navigator.userAgent,n=u.indexOf("Windows")>=0,L=u.indexOf("Macintosh")>=0,I=(u.indexOf("Macintosh")>=0||u.indexOf("iPad")>=0||u.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,T=u.indexOf("Linux")>=0,b=!0,C=navigator.language,f=C;else if(typeof v=="object"){n=v.platform==="win32",L=v.platform==="darwin",T=v.platform==="linux",A=T&&!!v.env.SNAP&&!!v.env.SNAP_REVISION,E=d,C=D,f=D;const o=v.env.VSCODE_NLS_CONFIG;if(o)try{const s=JSON.parse(o),c=s.availableLanguages["*"];C=s.locale,f=c||D,S=s._translationsConfigFile}catch{}R=!0}else console.error("Unable to resolve platform.");var w;(function(o){o[o.Web=0]="Web",o[o.Mac=1]="Mac",o[o.Linux=2]="Linux",o[o.Windows=3]="Windows"})(w=e.Platform||(e.Platform={}));function y(o){switch(o){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=y;let p=0;L?p=1:n?p=3:T&&(p=2),e.isWindows=n,e.isMacintosh=L,e.isLinux=T,e.isLinuxSnap=A,e.isNative=R,e.isElectron=E,e.isWeb=b,e.isIOS=I,e.platform=p,e.userAgent=u,e.language=f;var l;(function(o){function s(){return e.language}o.value=s;function c(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}o.isDefaultVariant=c;function h(){return e.language==="en"}o.isDefault=h})(l=e.Language||(e.Language={})),e.locale=C,e.translationsConfigFile=S,e.setTimeout0=(()=>{if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let o=[];e.globals.addEventListener("message",c=>{if(c.data&&c.data.vscodeScheduleAsyncWork)for(let h=0,m=o.length;h<m;h++){const P=o[h];if(P.id===c.data.vscodeScheduleAsyncWork){o.splice(h,1),P.callback();return}}});let s=0;return c=>{const h=++s;o.push({id:h,callback:c}),e.globals.postMessage({vscodeScheduleAsyncWork:h},"*")}}return o=>setTimeout(o)})();var r;(function(o){o[o.Windows=1]="Windows",o[o.Macintosh=2]="Macintosh",o[o.Linux=3]="Linux"})(r=e.OperatingSystem||(e.OperatingSystem={})),e.OS=L||I?2:n?1:3;let a=!0,i=!1;function t(){if(!i){i=!0;const o=new Uint8Array(2);o[0]=1,o[1]=2,a=new Uint16Array(o.buffer)[0]===(2<<8)+1}return a}e.isLittleEndian=t,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(ne[32],ie([0,1,4]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let n;if(typeof D.globals.vscode!="undefined"&&typeof D.globals.vscode.process!="undefined"){const L=D.globals.vscode.process;n={get platform(){return L.platform},get arch(){return L.arch},get env(){return L.env},cwd(){return L.cwd()}}}else typeof process!="undefined"?n={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:n={get platform(){return D.isWindows?"win32":D.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=n.cwd,e.env=n.env,e.platform=n.platform,e.arch=n.arch}),define(ne[10],ie([0,1,32]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const n=65,L=97,T=90,A=122,R=46,b=47,E=92,I=58,C=63;class f extends Error{constructor(p,l,r){let a;typeof l=="string"&&l.indexOf("not ")===0?(a="must not be",l=l.replace(/^not /,"")):a="must be";const i=p.indexOf(".")!==-1?"property":"argument";let t=`The "${p}" ${i} ${a} of type ${l}`;t+=`. Received type ${typeof r}`;super(t);this.code="ERR_INVALID_ARG_TYPE"}}function S(y,p){if(typeof y!="string")throw new f(p,"string",y)}function u(y){return y===b||y===E}function v(y){return y===b}function d(y){return y>=n&&y<=T||y>=L&&y<=A}function g(y,p,l,r){let a="",i=0,t=-1,o=0,s=0;for(let c=0;c<=y.length;++c){if(c<y.length)s=y.charCodeAt(c);else{if(r(s))break;s=b}if(r(s)){if(!(t===c-1||o===1))if(o===2){if(a.length<2||i!==2||a.charCodeAt(a.length-1)!==R||a.charCodeAt(a.length-2)!==R){if(a.length>2){const h=a.lastIndexOf(l);h===-1?(a="",i=0):(a=a.slice(0,h),i=a.length-1-a.lastIndexOf(l)),t=c,o=0;continue}else if(a.length!==0){a="",i=0,t=c,o=0;continue}}p&&(a+=a.length>0?`${l}..`:"..",i=2)}else a.length>0?a+=`${l}${y.slice(t+1,c)}`:a=y.slice(t+1,c),i=c-t-1;t=c,o=0}else s===R&&o!==-1?++o:o=-1}return a}function w(y,p){if(p===null||typeof p!="object")throw new f("pathObject","Object",p);const l=p.dir||p.root,r=p.base||`${p.name||""}${p.ext||""}`;return l?l===p.root?`${l}${r}`:`${l}${y}${r}`:r}e.win32={resolve(...y){let p="",l="",r=!1;for(let a=y.length-1;a>=-1;a--){let i;if(a>=0){if(i=y[a],S(i,"path"),i.length===0)continue}else p.length===0?i=D.cwd():(i=D.env[`=${p}`]||D.cwd(),(i===void 0||i.slice(0,2).toLowerCase()!==p.toLowerCase()&&i.charCodeAt(2)===E)&&(i=`${p}\\`));const t=i.length;let o=0,s="",c=!1;const h=i.charCodeAt(0);if(t===1)u(h)&&(o=1,c=!0);else if(u(h))if(c=!0,u(i.charCodeAt(1))){let m=2,P=m;for(;m<t&&!u(i.charCodeAt(m));)m++;if(m<t&&m!==P){const _=i.slice(P,m);for(P=m;m<t&&u(i.charCodeAt(m));)m++;if(m<t&&m!==P){for(P=m;m<t&&!u(i.charCodeAt(m));)m++;(m===t||m!==P)&&(s=`\\\\${_}\\${i.slice(P,m)}`,o=m)}}}else o=1;else d(h)&&i.charCodeAt(1)===I&&(s=i.slice(0,2),o=2,t>2&&u(i.charCodeAt(2))&&(c=!0,o=3));if(s.length>0)if(p.length>0){if(s.toLowerCase()!==p.toLowerCase())continue}else p=s;if(r){if(p.length>0)break}else if(l=`${i.slice(o)}\\${l}`,r=c,c&&p.length>0)break}return l=g(l,!r,"\\",u),r?`${p}\\${l}`:`${p}${l}`||"."},normalize(y){S(y,"path");const p=y.length;if(p===0)return".";let l=0,r,a=!1;const i=y.charCodeAt(0);if(p===1)return v(i)?"\\":y;if(u(i))if(a=!0,u(y.charCodeAt(1))){let o=2,s=o;for(;o<p&&!u(y.charCodeAt(o));)o++;if(o<p&&o!==s){const c=y.slice(s,o);for(s=o;o<p&&u(y.charCodeAt(o));)o++;if(o<p&&o!==s){for(s=o;o<p&&!u(y.charCodeAt(o));)o++;if(o===p)return`\\\\${c}\\${y.slice(s)}\\`;o!==s&&(r=`\\\\${c}\\${y.slice(s,o)}`,l=o)}}}else l=1;else d(i)&&y.charCodeAt(1)===I&&(r=y.slice(0,2),l=2,p>2&&u(y.charCodeAt(2))&&(a=!0,l=3));let t=l<p?g(y.slice(l),!a,"\\",u):"";return t.length===0&&!a&&(t="."),t.length>0&&u(y.charCodeAt(p-1))&&(t+="\\"),r===void 0?a?`\\${t}`:t:a?`${r}\\${t}`:`${r}${t}`},isAbsolute(y){S(y,"path");const p=y.length;if(p===0)return!1;const l=y.charCodeAt(0);return u(l)||p>2&&d(l)&&y.charCodeAt(1)===I&&u(y.charCodeAt(2))},join(...y){if(y.length===0)return".";let p,l;for(let i=0;i<y.length;++i){const t=y[i];S(t,"path"),t.length>0&&(p===void 0?p=l=t:p+=`\\${t}`)}if(p===void 0)return".";let r=!0,a=0;if(typeof l=="string"&&u(l.charCodeAt(0))){++a;const i=l.length;i>1&&u(l.charCodeAt(1))&&(++a,i>2&&(u(l.charCodeAt(2))?++a:r=!1))}if(r){for(;a<p.length&&u(p.charCodeAt(a));)a++;a>=2&&(p=`\\${p.slice(a)}`)}return e.win32.normalize(p)},relative(y,p){if(S(y,"from"),S(p,"to"),y===p)return"";const l=e.win32.resolve(y),r=e.win32.resolve(p);if(l===r||(y=l.toLowerCase(),p=r.toLowerCase(),y===p))return"";let a=0;for(;a<y.length&&y.charCodeAt(a)===E;)a++;let i=y.length;for(;i-1>a&&y.charCodeAt(i-1)===E;)i--;const t=i-a;let o=0;for(;o<p.length&&p.charCodeAt(o)===E;)o++;let s=p.length;for(;s-1>o&&p.charCodeAt(s-1)===E;)s--;const c=s-o,h=t<c?t:c;let m=-1,P=0;for(;P<h;P++){const O=y.charCodeAt(a+P);if(O!==p.charCodeAt(o+P))break;O===E&&(m=P)}if(P!==h){if(m===-1)return r}else{if(c>h){if(p.charCodeAt(o+P)===E)return r.slice(o+P+1);if(P===2)return r.slice(o+P)}t>h&&(y.charCodeAt(a+P)===E?m=P:P===2&&(m=3)),m===-1&&(m=0)}let _="";for(P=a+m+1;P<=i;++P)(P===i||y.charCodeAt(P)===E)&&(_+=_.length===0?"..":"\\..");return o+=m,_.length>0?`${_}${r.slice(o,s)}`:(r.charCodeAt(o)===E&&++o,r.slice(o,s))},toNamespacedPath(y){if(typeof y!="string")return y;if(y.length===0)return"";const p=e.win32.resolve(y);if(p.length<=2)return y;if(p.charCodeAt(0)===E){if(p.charCodeAt(1)===E){const l=p.charCodeAt(2);if(l!==C&&l!==R)return`\\\\?\\UNC\\${p.slice(2)}`}}else if(d(p.charCodeAt(0))&&p.charCodeAt(1)===I&&p.charCodeAt(2)===E)return`\\\\?\\${p}`;return y},dirname(y){S(y,"path");const p=y.length;if(p===0)return".";let l=-1,r=0;const a=y.charCodeAt(0);if(p===1)return u(a)?y:".";if(u(a)){if(l=r=1,u(y.charCodeAt(1))){let o=2,s=o;for(;o<p&&!u(y.charCodeAt(o));)o++;if(o<p&&o!==s){for(s=o;o<p&&u(y.charCodeAt(o));)o++;if(o<p&&o!==s){for(s=o;o<p&&!u(y.charCodeAt(o));)o++;if(o===p)return y;o!==s&&(l=r=o+1)}}}}else d(a)&&y.charCodeAt(1)===I&&(l=p>2&&u(y.charCodeAt(2))?3:2,r=l);let i=-1,t=!0;for(let o=p-1;o>=r;--o)if(u(y.charCodeAt(o))){if(!t){i=o;break}}else t=!1;if(i===-1){if(l===-1)return".";i=l}return y.slice(0,i)},basename(y,p){p!==void 0&&S(p,"ext"),S(y,"path");let l=0,r=-1,a=!0,i;if(y.length>=2&&d(y.charCodeAt(0))&&y.charCodeAt(1)===I&&(l=2),p!==void 0&&p.length>0&&p.length<=y.length){if(p===y)return"";let t=p.length-1,o=-1;for(i=y.length-1;i>=l;--i){const s=y.charCodeAt(i);if(u(s)){if(!a){l=i+1;break}}else o===-1&&(a=!1,o=i+1),t>=0&&(s===p.charCodeAt(t)?--t==-1&&(r=i):(t=-1,r=o))}return l===r?r=o:r===-1&&(r=y.length),y.slice(l,r)}for(i=y.length-1;i>=l;--i)if(u(y.charCodeAt(i))){if(!a){l=i+1;break}}else r===-1&&(a=!1,r=i+1);return r===-1?"":y.slice(l,r)},extname(y){S(y,"path");let p=0,l=-1,r=0,a=-1,i=!0,t=0;y.length>=2&&y.charCodeAt(1)===I&&d(y.charCodeAt(0))&&(p=r=2);for(let o=y.length-1;o>=p;--o){const s=y.charCodeAt(o);if(u(s)){if(!i){r=o+1;break}continue}a===-1&&(i=!1,a=o+1),s===R?l===-1?l=o:t!==1&&(t=1):l!==-1&&(t=-1)}return l===-1||a===-1||t===0||t===1&&l===a-1&&l===r+1?"":y.slice(l,a)},format:w.bind(null,"\\"),parse(y){S(y,"path");const p={root:"",dir:"",base:"",ext:"",name:""};if(y.length===0)return p;const l=y.length;let r=0,a=y.charCodeAt(0);if(l===1)return u(a)?(p.root=p.dir=y,p):(p.base=p.name=y,p);if(u(a)){if(r=1,u(y.charCodeAt(1))){let m=2,P=m;for(;m<l&&!u(y.charCodeAt(m));)m++;if(m<l&&m!==P){for(P=m;m<l&&u(y.charCodeAt(m));)m++;if(m<l&&m!==P){for(P=m;m<l&&!u(y.charCodeAt(m));)m++;m===l?r=m:m!==P&&(r=m+1)}}}}else if(d(a)&&y.charCodeAt(1)===I){if(l<=2)return p.root=p.dir=y,p;if(r=2,u(y.charCodeAt(2))){if(l===3)return p.root=p.dir=y,p;r=3}}r>0&&(p.root=y.slice(0,r));let i=-1,t=r,o=-1,s=!0,c=y.length-1,h=0;for(;c>=r;--c){if(a=y.charCodeAt(c),u(a)){if(!s){t=c+1;break}continue}o===-1&&(s=!1,o=c+1),a===R?i===-1?i=c:h!==1&&(h=1):i!==-1&&(h=-1)}return o!==-1&&(i===-1||h===0||h===1&&i===o-1&&i===t+1?p.base=p.name=y.slice(t,o):(p.name=y.slice(t,i),p.base=y.slice(t,o),p.ext=y.slice(i,o))),t>0&&t!==r?p.dir=y.slice(0,t-1):p.dir=p.root,p},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...y){let p="",l=!1;for(let r=y.length-1;r>=-1&&!l;r--){const a=r>=0?y[r]:D.cwd();S(a,"path"),a.length!==0&&(p=`${a}/${p}`,l=a.charCodeAt(0)===b)}return p=g(p,!l,"/",v),l?`/${p}`:p.length>0?p:"."},normalize(y){if(S(y,"path"),y.length===0)return".";const p=y.charCodeAt(0)===b,l=y.charCodeAt(y.length-1)===b;return y=g(y,!p,"/",v),y.length===0?p?"/":l?"./":".":(l&&(y+="/"),p?`/${y}`:y)},isAbsolute(y){return S(y,"path"),y.length>0&&y.charCodeAt(0)===b},join(...y){if(y.length===0)return".";let p;for(let l=0;l<y.length;++l){const r=y[l];S(r,"path"),r.length>0&&(p===void 0?p=r:p+=`/${r}`)}return p===void 0?".":e.posix.normalize(p)},relative(y,p){if(S(y,"from"),S(p,"to"),y===p||(y=e.posix.resolve(y),p=e.posix.resolve(p),y===p))return"";const l=1,r=y.length,a=r-l,i=1,t=p.length-i,o=a<t?a:t;let s=-1,c=0;for(;c<o;c++){const m=y.charCodeAt(l+c);if(m!==p.charCodeAt(i+c))break;m===b&&(s=c)}if(c===o)if(t>o){if(p.charCodeAt(i+c)===b)return p.slice(i+c+1);if(c===0)return p.slice(i+c)}else a>o&&(y.charCodeAt(l+c)===b?s=c:c===0&&(s=0));let h="";for(c=l+s+1;c<=r;++c)(c===r||y.charCodeAt(c)===b)&&(h+=h.length===0?"..":"/..");return`${h}${p.slice(i+s)}`},toNamespacedPath(y){return y},dirname(y){if(S(y,"path"),y.length===0)return".";const p=y.charCodeAt(0)===b;let l=-1,r=!0;for(let a=y.length-1;a>=1;--a)if(y.charCodeAt(a)===b){if(!r){l=a;break}}else r=!1;return l===-1?p?"/":".":p&&l===1?"//":y.slice(0,l)},basename(y,p){p!==void 0&&S(p,"ext"),S(y,"path");let l=0,r=-1,a=!0,i;if(p!==void 0&&p.length>0&&p.length<=y.length){if(p===y)return"";let t=p.length-1,o=-1;for(i=y.length-1;i>=0;--i){const s=y.charCodeAt(i);if(s===b){if(!a){l=i+1;break}}else o===-1&&(a=!1,o=i+1),t>=0&&(s===p.charCodeAt(t)?--t==-1&&(r=i):(t=-1,r=o))}return l===r?r=o:r===-1&&(r=y.length),y.slice(l,r)}for(i=y.length-1;i>=0;--i)if(y.charCodeAt(i)===b){if(!a){l=i+1;break}}else r===-1&&(a=!1,r=i+1);return r===-1?"":y.slice(l,r)},extname(y){S(y,"path");let p=-1,l=0,r=-1,a=!0,i=0;for(let t=y.length-1;t>=0;--t){const o=y.charCodeAt(t);if(o===b){if(!a){l=t+1;break}continue}r===-1&&(a=!1,r=t+1),o===R?p===-1?p=t:i!==1&&(i=1):p!==-1&&(i=-1)}return p===-1||r===-1||i===0||i===1&&p===r-1&&p===l+1?"":y.slice(p,r)},format:w.bind(null,"/"),parse(y){S(y,"path");const p={root:"",dir:"",base:"",ext:"",name:""};if(y.length===0)return p;const l=y.charCodeAt(0)===b;let r;l?(p.root="/",r=1):r=0;let a=-1,i=0,t=-1,o=!0,s=y.length-1,c=0;for(;s>=r;--s){const h=y.charCodeAt(s);if(h===b){if(!o){i=s+1;break}continue}t===-1&&(o=!1,t=s+1),h===R?a===-1?a=s:c!==1&&(c=1):a!==-1&&(c=-1)}if(t!==-1){const h=i===0&&l?1:i;a===-1||c===0||c===1&&a===t-1&&a===i+1?p.base=p.name=y.slice(h,t):(p.name=y.slice(h,a),p.base=y.slice(h,t),p.ext=y.slice(a,t))}return i>0?p.dir=y.slice(0,i-1):l&&(p.dir="/"),p},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=D.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=D.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=D.platform==="win32"?e.win32.join:e.posix.join,e.resolve=D.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=D.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=D.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=D.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=D.platform==="win32"?e.win32.extname:e.posix.extname,e.format=D.platform==="win32"?e.win32.format:e.posix.format,e.parse=D.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=D.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=D.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=D.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(ne[102],ie([0,1,10]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0;var n;(function(C){C.text="text/plain",C.binary="application/octet-stream",C.unknown="application/unknown",C.markdown="text/markdown",C.latex="text/latex"})(n=e.Mimes||(e.Mimes={}));const L={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},T={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function A(C){const f=(0,D.extname)(C),S=L[f.toLowerCase()];return S!==void 0?S:R(C)}e.getMediaOrTextMime=A;function R(C){const f=(0,D.extname)(C);return T[f.toLowerCase()]}e.getMediaMime=R;function b(C){for(const f in T)if(T[f]===C)return f}e.getExtensionForMimeType=b;const E=/^(.+)\/(.+?)(;.+)?$/;function I(C,f){const S=E.exec(C);return S?`${S[1].toLowerCase()}/${S[2].toLowerCase()}${S[3]??""}`:f?void 0:C}e.normalizeMimeType=I}),define(ne[103],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var D;(function(T){T[T.stdout=0]="stdout",T[T.stderr=1]="stderr"})(D=e.Source||(e.Source={}));var n;(function(T){T[T.Success=0]="Success",T[T.Unknown=1]="Unknown",T[T.AccessDenied=2]="AccessDenied",T[T.ProcessNotFound=3]="ProcessNotFound"})(n=e.TerminateResponseCode||(e.TerminateResponseCode={}));function L(T,...A){const R=A.reduce((I,C)=>(I[C]=!0,I),{}),b=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(T).filter(I=>!R[I]).forEach(I=>{for(let C=0;C<b.length;C++)if(I.search(b[C])!==-1){delete T[I];break}})}e.sanitizeProcessEnvironment=L}),function(J,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var D=e();for(var n in D)(typeof exports=="object"?exports:J)[n]=D[n]}}(typeof self!="undefined"?self:this,function(){return function(J){var e={};function D(n){if(e[n])return e[n].exports;var L=e[n]={i:n,l:!1,exports:{}};return J[n].call(L.exports,L,L.exports,D),L.l=!0,L.exports}return D.m=J,D.c=e,D.d=function(n,L,T){D.o(n,L)||Object.defineProperty(n,L,{enumerable:!0,get:T})},D.r=function(n){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(n,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(n,"__esModule",{value:!0})},D.t=function(n,L){if(1&L&&(n=D(n)),8&L||4&L&&typeof n=="object"&&n&&n.__esModule)return n;var T=Object.create(null);if(D.r(T),Object.defineProperty(T,"default",{enumerable:!0,value:n}),2&L&&typeof n!="string")for(var A in n)D.d(T,A,function(R){return n[R]}.bind(null,A));return T},D.n=function(n){var L=n&&n.__esModule?function(){return n.default}:function(){return n};return D.d(L,"a",L),L},D.o=function(n,L){return Object.prototype.hasOwnProperty.call(n,L)},D.p="",D(D.s=0)}([function(J,e,D){(function(n){var L;e=J.exports=F,L=typeof n=="object"&&n.env&&n.env.NODE_DEBUG&&/\bsemver\b/i.test(n.env.NODE_DEBUG)?function(){var re=Array.prototype.slice.call(arguments,0);re.unshift("SEMVER"),console.log.apply(console,re)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var T=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,R=e.re=[],b=e.src=[],E=0,I=E++;b[I]="0|[1-9]\\d*";var C=E++;b[C]="[0-9]+";var f=E++;b[f]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var S=E++;b[S]="("+b[I]+")\\.("+b[I]+")\\.("+b[I]+")";var u=E++;b[u]="("+b[C]+")\\.("+b[C]+")\\.("+b[C]+")";var v=E++;b[v]="(?:"+b[I]+"|"+b[f]+")";var d=E++;b[d]="(?:"+b[C]+"|"+b[f]+")";var g=E++;b[g]="(?:-("+b[v]+"(?:\\."+b[v]+")*))";var w=E++;b[w]="(?:-?("+b[d]+"(?:\\."+b[d]+")*))";var y=E++;b[y]="[0-9A-Za-z-]+";var p=E++;b[p]="(?:\\+("+b[y]+"(?:\\."+b[y]+")*))";var l=E++,r="v?"+b[S]+b[g]+"?"+b[p]+"?";b[l]="^"+r+"$";var a="[v=\\s]*"+b[u]+b[w]+"?"+b[p]+"?",i=E++;b[i]="^"+a+"$";var t=E++;b[t]="((?:<|>)?=?)";var o=E++;b[o]=b[C]+"|x|X|\\*";var s=E++;b[s]=b[I]+"|x|X|\\*";var c=E++;b[c]="[v=\\s]*("+b[s]+")(?:\\.("+b[s]+")(?:\\.("+b[s]+")(?:"+b[g]+")?"+b[p]+"?)?)?";var h=E++;b[h]="[v=\\s]*("+b[o]+")(?:\\.("+b[o]+")(?:\\.("+b[o]+")(?:"+b[w]+")?"+b[p]+"?)?)?";var m=E++;b[m]="^"+b[t]+"\\s*"+b[c]+"$";var P=E++;b[P]="^"+b[t]+"\\s*"+b[h]+"$";var _=E++;b[_]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var O=E++;b[O]="(?:~>?)";var M=E++;b[M]="(\\s*)"+b[O]+"\\s+",R[M]=new RegExp(b[M],"g");var k=E++;b[k]="^"+b[O]+b[c]+"$";var U=E++;b[U]="^"+b[O]+b[h]+"$";var N=E++;b[N]="(?:\\^)";var V=E++;b[V]="(\\s*)"+b[N]+"\\s+",R[V]=new RegExp(b[V],"g");var $=E++;b[$]="^"+b[N]+b[c]+"$";var G=E++;b[G]="^"+b[N]+b[h]+"$";var te=E++;b[te]="^"+b[t]+"\\s*("+a+")$|^$";var W=E++;b[W]="^"+b[t]+"\\s*("+r+")$|^$";var j=E++;b[j]="(\\s*)"+b[t]+"\\s*("+a+"|"+b[c]+")",R[j]=new RegExp(b[j],"g");var K=E++;b[K]="^\\s*("+b[c]+")\\s+-\\s+("+b[c]+")\\s*$";var H=E++;b[H]="^\\s*("+b[h]+")\\s+-\\s+("+b[h]+")\\s*$";var Q=E++;b[Q]="(<|>)?=?\\s*\\*";for(var Z=0;Z<35;Z++)L(Z,b[Z]),R[Z]||(R[Z]=new RegExp(b[Z]));function B(re,ae){if(re instanceof F)return re;if(typeof re!="string"||re.length>T||!(ae?R[i]:R[l]).test(re))return null;try{return new F(re,ae)}catch{return null}}function F(re,ae){if(re instanceof F){if(re.loose===ae)return re;re=re.version}else if(typeof re!="string")throw new TypeError("Invalid Version: "+re);if(re.length>T)throw new TypeError("version is longer than "+T+" characters");if(!(this instanceof F))return new F(re,ae);L("SemVer",re,ae),this.loose=ae;var he=re.trim().match(ae?R[i]:R[l]);if(!he)throw new TypeError("Invalid Version: "+re);if(this.raw=re,this.major=+he[1],this.minor=+he[2],this.patch=+he[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");he[4]?this.prerelease=he[4].split(".").map(function(we){if(/^[0-9]+$/.test(we)){var Ce=+we;if(Ce>=0&&Ce<A)return Ce}return we}):this.prerelease=[],this.build=he[5]?he[5].split("."):[],this.format()}e.parse=B,e.valid=function(re,ae){var he=B(re,ae);return he?he.version:null},e.clean=function(re,ae){var he=B(re.trim().replace(/^[=v]+/,""),ae);return he?he.version:null},e.SemVer=F,F.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},F.prototype.toString=function(){return this.version},F.prototype.compare=function(re){return L("SemVer.compare",this.version,this.loose,re),re instanceof F||(re=new F(re,this.loose)),this.compareMain(re)||this.comparePre(re)},F.prototype.compareMain=function(re){return re instanceof F||(re=new F(re,this.loose)),z(this.major,re.major)||z(this.minor,re.minor)||z(this.patch,re.patch)},F.prototype.comparePre=function(re){if(re instanceof F||(re=new F(re,this.loose)),this.prerelease.length&&!re.prerelease.length)return-1;if(!this.prerelease.length&&re.prerelease.length)return 1;if(!this.prerelease.length&&!re.prerelease.length)return 0;var ae=0;do{var he=this.prerelease[ae],we=re.prerelease[ae];if(L("prerelease compare",ae,he,we),he===void 0&&we===void 0)return 0;if(we===void 0)return 1;if(he===void 0)return-1;if(he!==we)return z(he,we)}while(++ae)},F.prototype.inc=function(re,ae){switch(re){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ae);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ae);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ae),this.inc("pre",ae);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ae),this.inc("pre",ae);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var he=this.prerelease.length;--he>=0;)typeof this.prerelease[he]=="number"&&(this.prerelease[he]++,he=-2);he===-1&&this.prerelease.push(0)}ae&&(this.prerelease[0]===ae?isNaN(this.prerelease[1])&&(this.prerelease=[ae,0]):this.prerelease=[ae,0]);break;default:throw new Error("invalid increment argument: "+re)}return this.format(),this.raw=this.version,this},e.inc=function(re,ae,he,we){typeof he=="string"&&(we=he,he=void 0);try{return new F(re,he).inc(ae,we).version}catch{return null}},e.diff=function(re,ae){if(ce(re,ae))return null;var he=B(re),we=B(ae);if(he.prerelease.length||we.prerelease.length){for(var Ce in he)if((Ce==="major"||Ce==="minor"||Ce==="patch")&&he[Ce]!==we[Ce])return"pre"+Ce;return"prerelease"}for(var Ce in he)if((Ce==="major"||Ce==="minor"||Ce==="patch")&&he[Ce]!==we[Ce])return Ce},e.compareIdentifiers=z;var x=/^[0-9]+$/;function z(re,ae){var he=x.test(re),we=x.test(ae);return he&&we&&(re=+re,ae=+ae),he&&!we?-1:we&&!he?1:re<ae?-1:re>ae?1:0}function q(re,ae,he){return new F(re,he).compare(new F(ae,he))}function ee(re,ae,he){return q(re,ae,he)>0}function se(re,ae,he){return q(re,ae,he)<0}function ce(re,ae,he){return q(re,ae,he)===0}function ue(re,ae,he){return q(re,ae,he)!==0}function ve(re,ae,he){return q(re,ae,he)>=0}function pe(re,ae,he){return q(re,ae,he)<=0}function Ie(re,ae,he,we){var Ce;switch(ae){case"===":typeof re=="object"&&(re=re.version),typeof he=="object"&&(he=he.version),Ce=re===he;break;case"!==":typeof re=="object"&&(re=re.version),typeof he=="object"&&(he=he.version),Ce=re!==he;break;case"":case"=":case"==":Ce=ce(re,he,we);break;case"!=":Ce=ue(re,he,we);break;case">":Ce=ee(re,he,we);break;case">=":Ce=ve(re,he,we);break;case"<":Ce=se(re,he,we);break;case"<=":Ce=pe(re,he,we);break;default:throw new TypeError("Invalid operator: "+ae)}return Ce}function Ee(re,ae){if(re instanceof Ee){if(re.loose===ae)return re;re=re.value}if(!(this instanceof Ee))return new Ee(re,ae);L("comparator",re,ae),this.loose=ae,this.parse(re),this.semver===ye?this.value="":this.value=this.operator+this.semver.version,L("comp",this)}e.rcompareIdentifiers=function(re,ae){return z(ae,re)},e.major=function(re,ae){return new F(re,ae).major},e.minor=function(re,ae){return new F(re,ae).minor},e.patch=function(re,ae){return new F(re,ae).patch},e.compare=q,e.compareLoose=function(re,ae){return q(re,ae,!0)},e.rcompare=function(re,ae,he){return q(ae,re,he)},e.sort=function(re,ae){return re.sort(function(he,we){return e.compare(he,we,ae)})},e.rsort=function(re,ae){return re.sort(function(he,we){return e.rcompare(he,we,ae)})},e.gt=ee,e.lt=se,e.eq=ce,e.neq=ue,e.gte=ve,e.lte=pe,e.cmp=Ie,e.Comparator=Ee;var ye={};function be(re,ae){if(re instanceof be)return re.loose===ae?re:new be(re.raw,ae);if(re instanceof Ee)return new be(re.value,ae);if(!(this instanceof be))return new be(re,ae);if(this.loose=ae,this.raw=re,this.set=re.split(/\s*\|\|\s*/).map(function(he){return this.parseRange(he.trim())},this).filter(function(he){return he.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+re);this.format()}function Re(re){return!re||re.toLowerCase()==="x"||re==="*"}function Fe(re,ae,he,we,Ce,Ne,Te,Oe,_e,X,oe,le,fe){return((ae=Re(he)?"":Re(we)?">="+he+".0.0":Re(Ce)?">="+he+"."+we+".0":">="+ae)+" "+(Oe=Re(_e)?"":Re(X)?"<"+(+_e+1)+".0.0":Re(oe)?"<"+_e+"."+(+X+1)+".0":le?"<="+_e+"."+X+"."+oe+"-"+le:"<="+Oe)).trim()}function Me(re,ae){for(var he=0;he<re.length;he++)if(!re[he].test(ae))return!1;if(ae.prerelease.length){for(he=0;he<re.length;he++)if(L(re[he].semver),re[he].semver!==ye&&re[he].semver.prerelease.length>0){var we=re[he].semver;if(we.major===ae.major&&we.minor===ae.minor&&we.patch===ae.patch)return!0}return!1}return!0}function qe(re,ae,he){try{ae=new be(ae,he)}catch{return!1}return ae.test(re)}function xe(re,ae,he,we){var Ce,Ne,Te,Oe,_e;switch(re=new F(re,we),ae=new be(ae,we),he){case">":Ce=ee,Ne=pe,Te=se,Oe=">",_e=">=";break;case"<":Ce=se,Ne=ve,Te=ee,Oe="<",_e="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(qe(re,ae,we))return!1;for(var X=0;X<ae.set.length;++X){var oe=ae.set[X],le=null,fe=null;if(oe.forEach(function(ge){ge.semver===ye&&(ge=new Ee(">=0.0.0")),le=le||ge,fe=fe||ge,Ce(ge.semver,le.semver,we)?le=ge:Te(ge.semver,fe.semver,we)&&(fe=ge)}),le.operator===Oe||le.operator===_e||(!fe.operator||fe.operator===Oe)&&Ne(re,fe.semver)||fe.operator===_e&&Te(re,fe.semver))return!1}return!0}Ee.prototype.parse=function(re){var ae=this.loose?R[te]:R[W],he=re.match(ae);if(!he)throw new TypeError("Invalid comparator: "+re);this.operator=he[1],this.operator==="="&&(this.operator=""),he[2]?this.semver=new F(he[2],this.loose):this.semver=ye},Ee.prototype.toString=function(){return this.value},Ee.prototype.test=function(re){return L("Comparator.test",re,this.loose),this.semver===ye||(typeof re=="string"&&(re=new F(re,this.loose)),Ie(re,this.operator,this.semver,this.loose))},Ee.prototype.intersects=function(re,ae){if(!(re instanceof Ee))throw new TypeError("a Comparator is required");var he;if(this.operator==="")return he=new be(re.value,ae),qe(this.value,he,ae);if(re.operator==="")return he=new be(this.value,ae),qe(re.semver,he,ae);var we=!(this.operator!==">="&&this.operator!==">"||re.operator!==">="&&re.operator!==">"),Ce=!(this.operator!=="<="&&this.operator!=="<"||re.operator!=="<="&&re.operator!=="<"),Ne=this.semver.version===re.semver.version,Te=!(this.operator!==">="&&this.operator!=="<="||re.operator!==">="&&re.operator!=="<="),Oe=Ie(this.semver,"<",re.semver,ae)&&(this.operator===">="||this.operator===">")&&(re.operator==="<="||re.operator==="<"),_e=Ie(this.semver,">",re.semver,ae)&&(this.operator==="<="||this.operator==="<")&&(re.operator===">="||re.operator===">");return we||Ce||Ne&&Te||Oe||_e},e.Range=be,be.prototype.format=function(){return this.range=this.set.map(function(re){return re.join(" ").trim()}).join("||").trim(),this.range},be.prototype.toString=function(){return this.range},be.prototype.parseRange=function(re){var ae=this.loose;re=re.trim(),L("range",re,ae);var he=ae?R[H]:R[K];re=re.replace(he,Fe),L("hyphen replace",re),re=re.replace(R[j],"$1$2$3"),L("comparator trim",re,R[j]),re=(re=(re=re.replace(R[M],"$1~")).replace(R[V],"$1^")).split(/\s+/).join(" ");var we=ae?R[te]:R[W],Ce=re.split(" ").map(function(Ne){return function(Te,Oe){return L("comp",Te),Te=function(_e,X){return _e.trim().split(/\s+/).map(function(oe){return function(le,fe){L("caret",le,fe);var ge=fe?R[G]:R[$];return le.replace(ge,function(Le,Se,De,ke,Pe){var Ae;return L("caret",le,Le,Se,De,ke,Pe),Re(Se)?Ae="":Re(De)?Ae=">="+Se+".0.0 <"+(+Se+1)+".0.0":Re(ke)?Ae=Se==="0"?">="+Se+"."+De+".0 <"+Se+"."+(+De+1)+".0":">="+Se+"."+De+".0 <"+(+Se+1)+".0.0":Pe?(L("replaceCaret pr",Pe),Pe.charAt(0)!=="-"&&(Pe="-"+Pe),Ae=Se==="0"?De==="0"?">="+Se+"."+De+"."+ke+Pe+" <"+Se+"."+De+"."+(+ke+1):">="+Se+"."+De+"."+ke+Pe+" <"+Se+"."+(+De+1)+".0":">="+Se+"."+De+"."+ke+Pe+" <"+(+Se+1)+".0.0"):(L("no pr"),Ae=Se==="0"?De==="0"?">="+Se+"."+De+"."+ke+" <"+Se+"."+De+"."+(+ke+1):">="+Se+"."+De+"."+ke+" <"+Se+"."+(+De+1)+".0":">="+Se+"."+De+"."+ke+" <"+(+Se+1)+".0.0"),L("caret return",Ae),Ae})}(oe,X)}).join(" ")}(Te,Oe),L("caret",Te),Te=function(_e,X){return _e.trim().split(/\s+/).map(function(oe){return function(le,fe){var ge=fe?R[U]:R[k];return le.replace(ge,function(Le,Se,De,ke,Pe){var Ae;return L("tilde",le,Le,Se,De,ke,Pe),Re(Se)?Ae="":Re(De)?Ae=">="+Se+".0.0 <"+(+Se+1)+".0.0":Re(ke)?Ae=">="+Se+"."+De+".0 <"+Se+"."+(+De+1)+".0":Pe?(L("replaceTilde pr",Pe),Pe.charAt(0)!=="-"&&(Pe="-"+Pe),Ae=">="+Se+"."+De+"."+ke+Pe+" <"+Se+"."+(+De+1)+".0"):Ae=">="+Se+"."+De+"."+ke+" <"+Se+"."+(+De+1)+".0",L("tilde return",Ae),Ae})}(oe,X)}).join(" ")}(Te,Oe),L("tildes",Te),Te=function(_e,X){return L("replaceXRanges",_e,X),_e.split(/\s+/).map(function(oe){return function(le,fe){le=le.trim();var ge=fe?R[P]:R[m];return le.replace(ge,function(Le,Se,De,ke,Pe,Ae){L("xRange",le,Le,Se,De,ke,Pe,Ae);var $e=Re(De),je=$e||Re(ke),Be=je||Re(Pe);return Se==="="&&Be&&(Se=""),$e?Le=Se===">"||Se==="<"?"<0.0.0":"*":Se&&Be?(je&&(ke=0),Be&&(Pe=0),Se===">"?(Se=">=",je?(De=+De+1,ke=0,Pe=0):Be&&(ke=+ke+1,Pe=0)):Se==="<="&&(Se="<",je?De=+De+1:ke=+ke+1),Le=Se+De+"."+ke+"."+Pe):je?Le=">="+De+".0.0 <"+(+De+1)+".0.0":Be&&(Le=">="+De+"."+ke+".0 <"+De+"."+(+ke+1)+".0"),L("xRange return",Le),Le})}(oe,X)}).join(" ")}(Te,Oe),L("xrange",Te),Te=function(_e,X){return L("replaceStars",_e,X),_e.trim().replace(R[Q],"")}(Te,Oe),L("stars",Te),Te}(Ne,ae)}).join(" ").split(/\s+/);return this.loose&&(Ce=Ce.filter(function(Ne){return!!Ne.match(we)})),Ce=Ce.map(function(Ne){return new Ee(Ne,ae)})},be.prototype.intersects=function(re,ae){if(!(re instanceof be))throw new TypeError("a Range is required");return this.set.some(function(he){return he.every(function(we){return re.set.some(function(Ce){return Ce.every(function(Ne){return we.intersects(Ne,ae)})})})})},e.toComparators=function(re,ae){return new be(re,ae).set.map(function(he){return he.map(function(we){return we.value}).join(" ").trim().split(" ")})},be.prototype.test=function(re){if(!re)return!1;typeof re=="string"&&(re=new F(re,this.loose));for(var ae=0;ae<this.set.length;ae++)if(Me(this.set[ae],re))return!0;return!1},e.satisfies=qe,e.maxSatisfying=function(re,ae,he){var we=null,Ce=null;try{var Ne=new be(ae,he)}catch{return null}return re.forEach(function(Te){Ne.test(Te)&&(we&&Ce.compare(Te)!==-1||(Ce=new F(we=Te,he)))}),we},e.minSatisfying=function(re,ae,he){var we=null,Ce=null;try{var Ne=new be(ae,he)}catch{return null}return re.forEach(function(Te){Ne.test(Te)&&(we&&Ce.compare(Te)!==1||(Ce=new F(we=Te,he)))}),we},e.validRange=function(re,ae){try{return new be(re,ae).range||"*"}catch{return null}},e.ltr=function(re,ae,he){return xe(re,ae,"<",he)},e.gtr=function(re,ae,he){return xe(re,ae,">",he)},e.outside=xe,e.prerelease=function(re,ae){var he=B(re,ae);return he&&he.prerelease.length?he.prerelease:null},e.intersects=function(re,ae,he){return re=new be(re,he),ae=new be(ae,he),re.intersects(ae)},e.coerce=function(re){if(re instanceof F)return re;if(typeof re!="string")return null;var ae=re.match(R[_]);return ae==null?null:B((ae[1]||"0")+"."+(ae[2]||"0")+"."+(ae[3]||"0"))}}).call(this,D(1))},function(J,e){var D,n,L=J.exports={};function T(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function R(d){if(D===setTimeout)return setTimeout(d,0);if((D===T||!D)&&setTimeout)return D=setTimeout,setTimeout(d,0);try{return D(d,0)}catch{try{return D.call(null,d,0)}catch{return D.call(this,d,0)}}}(function(){try{D=typeof setTimeout=="function"?setTimeout:T}catch{D=T}try{n=typeof clearTimeout=="function"?clearTimeout:A}catch{n=A}})();var b,E=[],I=!1,C=-1;function f(){I&&b&&(I=!1,b.length?E=b.concat(E):C=-1,E.length&&S())}function S(){if(!I){var d=R(f);I=!0;for(var g=E.length;g;){for(b=E,E=[];++C<g;)b&&b[C].run();C=-1,g=E.length}b=null,I=!1,function(w){if(n===clearTimeout)return clearTimeout(w);if((n===A||!n)&&clearTimeout)return n=clearTimeout,clearTimeout(w);try{n(w)}catch{try{return n.call(null,w)}catch{return n.call(this,w)}}}(d)}}function u(d,g){this.fun=d,this.array=g}function v(){}L.nextTick=function(d){var g=new Array(arguments.length-1);if(arguments.length>1)for(var w=1;w<arguments.length;w++)g[w-1]=arguments[w];E.push(new u(d,g)),E.length!==1||I||R(S)},u.prototype.run=function(){this.fun.apply(null,this.array)},L.title="browser",L.browser=!0,L.env={},L.argv=[],L.version="",L.versions={},L.on=v,L.addListener=v,L.once=v,L.off=v,L.removeListener=v,L.removeAllListeners=v,L.emit=v,L.prependListener=v,L.prependOnceListener=v,L.listeners=function(d){return[]},L.binding=function(d){throw new Error("process.binding is not supported")},L.cwd=function(){return"/"},L.chdir=function(d){throw new Error("process.chdir is not supported")},L.umask=function(){return 0}}])}),define(ne[104],ie([0,1]),function(J,e){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class n{constructor(R,b,E){this.level=R,this.key=b,this.value=E,this.forward=[]}}const L=void 0;class T{constructor(R,b=2**16){this.comparator=R,this[D]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(b)|0),this._header=new n(this._maxLevel,L,L)}get size(){return this._size}clear(){this._header=new n(this._maxLevel,L,L)}has(R){return Boolean(T._search(this,R,this.comparator))}get(R){return T._search(this,R,this.comparator)?.value}set(R,b){return T._insert(this,R,b,this.comparator)&&(this._size+=1),this}delete(R){const b=T._delete(this,R,this.comparator);return b&&(this._size-=1),b}forEach(R,b){let E=this._header.forward[0];for(;E;)R.call(b,E.value,E.key,this),E=E.forward[0]}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let R=this._header.forward[0];for(;R;)yield[R.key,R.value],R=R.forward[0]}*keys(){let R=this._header.forward[0];for(;R;)yield R.key,R=R.forward[0]}*values(){let R=this._header.forward[0];for(;R;)yield R.value,R=R.forward[0]}toString(){let R="[SkipList]:",b=this._header.forward[0];for(;b;)R+=`node(${b.key}, ${b.value}, lvl:${b.level})`,b=b.forward[0];return R}static _search(R,b,E){let I=R._header;for(let C=R._level-1;C>=0;C--)for(;I.forward[C]&&E(I.forward[C].key,b)<0;)I=I.forward[C];if(I=I.forward[0],I&&E(I.key,b)===0)return I}static _insert(R,b,E,I){let C=[],f=R._header;for(let S=R._level-1;S>=0;S--){for(;f.forward[S]&&I(f.forward[S].key,b)<0;)f=f.forward[S];C[S]=f}if(f=f.forward[0],f&&I(f.key,b)===0)return f.value=E,!1;{let S=T._randomLevel(R);if(S>R._level){for(let u=R._level;u<S;u++)C[u]=R._header;R._level=S}f=new n(S,b,E);for(let u=0;u<S;u++)f.forward[u]=C[u].forward[u],C[u].forward[u]=f;return!0}}static _randomLevel(R,b=.5){let E=1;for(;Math.random()<b&&E<R._maxLevel;)E+=1;return E}static _delete(R,b,E){let I=[],C=R._header;for(let f=R._level-1;f>=0;f--){for(;C.forward[f]&&E(C.forward[f].key,b)<0;)C=C.forward[f];I[f]=C}if(C=C.forward[0],!C||E(C.key,b)!==0)return!1;for(let f=0;f<R._level&&I[f].forward[f]===C;f++)I[f].forward[f]=C.forward[f];for(;R._level>0&&R._header.forward[R._level-1]===L;)R._level-=1;return!0}}e.SkipList=T}),define(ne[105],ie([0,1,4]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const n=D.globals.performance&&typeof D.globals.performance.now=="function";class L{constructor(A){this._highResolution=n&&A,this._startTime=this._now(),this._stopTime=-1}static create(A=!0){return new L(A)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?D.globals.performance.now():Date.now()}}e.StopWatch=L}),define(ne[3],ie([0,1,9,68,2,101,105]),function(J,e,D,n,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var R;(function(p){p.None=()=>L.Disposable.None;function l(te){return(W,j=null,K)=>{let H=!1,Q;return Q=te(Z=>{if(!H)return Q?Q.dispose():H=!0,W.call(j,Z)},null,K),H&&Q.dispose(),Q}}p.once=l;function r(te,W){return c((j,K=null,H)=>te(Q=>j.call(K,W(Q)),null,H))}p.map=r;function a(te,W){return c((j,K=null,H)=>te(Q=>{W(Q),j.call(K,Q)},null,H))}p.forEach=a;function i(te,W){return c((j,K=null,H)=>te(Q=>W(Q)&&j.call(K,Q),null,H))}p.filter=i;function t(te){return te}p.signal=t;function o(...te){return(W,j=null,K)=>(0,L.combinedDisposable)(...te.map(H=>H(Q=>W.call(j,Q),null,K)))}p.any=o;function s(te,W,j){let K=j;return r(te,H=>(K=W(K,H),K))}p.reduce=s;function c(te){let W;const j=new f({onFirstListenerAdd(){W=te(j.fire,j)},onLastListenerRemove(){W.dispose()}});return j.event}function h(te,W,j,K=100,H=!1){let Q,Z,B=0;return te(F=>{B++,Q=j(Q,F),H&&!Z&&(W(Q),Q=void 0),clearTimeout(Z),Z=setTimeout(()=>{const x=Q;Q=void 0,Z=void 0,(!H||B>1)&&W(x),B=0},K)})}p.debouncedListener=h;function m(te,W,j=100,K=!1,H){let Q,Z,B,F=0;const x=new f({leakWarningThreshold:H,onFirstListenerAdd(){Q=te(z=>{F++,Z=W(Z,z),K&&!B&&(x.fire(Z),Z=void 0),clearTimeout(B),B=setTimeout(()=>{const q=Z;Z=void 0,B=void 0,(!K||F>1)&&x.fire(q),F=0},j)})},onLastListenerRemove(){Q.dispose()}});return x.event}p.debounce=m;function P(te,W=(j,K)=>j===K){let j=!0,K;return i(te,H=>{const Q=j||!W(H,K);return j=!1,K=H,Q})}p.latch=P;function _(te,W){return[p.filter(te,W),p.filter(te,j=>!W(j))]}p.split=_;function O(te,W=!1,j=[]){let K=j.slice(),H=te(B=>{K?K.push(B):Z.fire(B)});const Q=()=>{K&&K.forEach(B=>Z.fire(B)),K=null},Z=new f({onFirstListenerAdd(){H||(H=te(B=>Z.fire(B)))},onFirstListenerDidAdd(){K&&(W?setTimeout(Q):Q())},onLastListenerRemove(){H&&H.dispose(),H=null}});return Z.event}p.buffer=O;class M{constructor(W){this.event=W}map(W){return new M(r(this.event,W))}forEach(W){return new M(a(this.event,W))}filter(W){return new M(i(this.event,W))}reduce(W,j){return new M(s(this.event,W,j))}latch(){return new M(P(this.event))}debounce(W,j=100,K=!1,H){return new M(m(this.event,W,j,K,H))}on(W,j,K){return this.event(W,j,K)}once(W,j,K){return l(this.event)(W,j,K)}}function k(te){return new M(te)}p.chain=k;function U(te,W,j=K=>K){const K=(...B)=>Z.fire(j(...B)),H=()=>te.on(W,K),Q=()=>te.removeListener(W,K),Z=new f({onFirstListenerAdd:H,onLastListenerRemove:Q});return Z.event}p.fromNodeEventEmitter=U;function N(te,W,j=K=>K){const K=(...B)=>Z.fire(j(...B)),H=()=>te.addEventListener(W,K),Q=()=>te.removeEventListener(W,K),Z=new f({onFirstListenerAdd:H,onLastListenerRemove:Q});return Z.event}p.fromDOMEventEmitter=N;function V(te){return new Promise(W=>l(te)(W))}p.toPromise=V;function $(te,W){return W(void 0),te(j=>W(j))}p.runAndSubscribe=$;function G(te,W){let j=null;function K(Q){j?.dispose(),j=new L.DisposableStore,W(Q,j)}K(void 0);const H=te(Q=>K(Q));return(0,L.toDisposable)(()=>{H.dispose(),j?.dispose()})}p.runAndSubscribeWithStore=G})(R=e.Event||(e.Event={}));class b{constructor(l){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${l}_${b._idPool++}`}start(l){this._stopWatch=new A.StopWatch(!0),this._listenerCount=l}stop(){if(this._stopWatch){const l=this._stopWatch.elapsed();this._elapsedOverall+=l,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${l.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}b._idPool=0;let E=-1;function I(p){const l=E;return E=p,{dispose(){E=l}}}e.setGlobalLeakWarningThreshold=I;class C{constructor(l,r=Math.random().toString(18).slice(2,5)){this.customThreshold=l,this.name=r,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(l){let r=E;if(typeof this.customThreshold=="number"&&(r=this.customThreshold),r<=0||l<r)return;this._stacks||(this._stacks=new Map);const a=new Error().stack.split(`
`).slice(3).join(`
`),i=this._stacks.get(a)||0;if(this._stacks.set(a,i+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=r*.5;let t,o=0;for(const[s,c]of this._stacks)(!t||o<c)&&(t=s,o=c);console.warn(`[${this.name}] potential listener LEAK detected, having ${l} listeners already. MOST frequent listener (${o}):`),console.warn(t)}return()=>{const t=this._stacks.get(a)||0;this._stacks.set(a,t-1)}}}class f{constructor(l){this._disposed=!1,this._options=l,this._leakageMon=E>0?new C(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new b(this._options._profName):void 0}get event(){return this._event||(this._event=(l,r,a)=>{this._listeners||(this._listeners=new T.LinkedList);const i=this._listeners.isEmpty();i&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const t=this._listeners.push(r?[l,r]:l);i&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,l,r);const o=this._leakageMon?.check(this._listeners.size),s=(0,L.toDisposable)(()=>{o&&o(),this._disposed||(t(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return a instanceof L.DisposableStore?a.add(s):Array.isArray(a)&&a.push(s),s}),this._event}fire(l){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new T.LinkedList);for(let r of this._listeners)this._deliveryQueue.push([r,l]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[r,a]=this._deliveryQueue.shift();try{typeof r=="function"?r.call(void 0,a):r[0].call(r[1],a)}catch(i){(0,D.onUnexpectedError)(i)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=f;class S extends f{async fireAsync(l,r,a){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new T.LinkedList);for(const i of this._listeners)this._asyncDeliveryQueue.push([i,l]);for(;this._asyncDeliveryQueue.size>0&&!r.isCancellationRequested;){const[i,t]=this._asyncDeliveryQueue.shift(),o=[],s={...t,token:r,waitUntil:c=>{if(Object.isFrozen(o))throw new Error("waitUntil can NOT be called asynchronous");a&&(c=a(c,typeof i=="function"?i:i[0])),o.push(c)}};try{typeof i=="function"?i.call(void 0,s):i[0].call(i[1],s)}catch(c){(0,D.onUnexpectedError)(c);continue}Object.freeze(o),await Promise.allSettled(o).then(c=>{for(const h of c)h.status==="rejected"&&(0,D.onUnexpectedError)(h.reason)})}}}}e.AsyncEmitter=S;class u extends f{constructor(l){super(l);this._isPaused=0,this._eventQueue=new T.LinkedList,this._mergeFn=l?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const l=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(l))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(l){this._listeners&&(this._isPaused!==0?this._eventQueue.push(l):super.fire(l))}}e.PauseableEmitter=u;class v extends u{constructor(l){super(l);this._delay=l.delay??100}fire(l){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(l)}}e.DebounceEmitter=v;class d extends f{constructor(l){super(l);this._queuedEvents=[],this._mergeFn=l?.merge}fire(l){this._queuedEvents.push(l),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(r=>super.fire(r)),this._queuedEvents=[]})}}e.MicrotaskEmitter=d;class g{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new f({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(l){const r={event:l,listener:null};this.events.push(r),this.hasListeners&&this.hook(r);const a=()=>{this.hasListeners&&this.unhook(r);const i=this.events.indexOf(r);this.events.splice(i,1)};return(0,L.toDisposable)((0,n.once)(a))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(l=>this.hook(l))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(l=>this.unhook(l))}hook(l){l.listener=l.event(r=>this.emitter.fire(r))}unhook(l){l.listener&&l.listener.dispose(),l.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=g;class w{constructor(){this.buffers=[]}wrapEvent(l){return(r,a,i)=>l(t=>{const o=this.buffers[this.buffers.length-1];o?o.push(()=>r.call(a,t)):r.call(a,t)},void 0,i)}bufferEvents(l){const r=[];this.buffers.push(r);const a=l();return this.buffers.pop(),r.forEach(i=>i()),a}}e.EventBufferer=w;class y{constructor(){this.listening=!1,this.inputEvent=R.None,this.inputEventListener=L.Disposable.None,this.emitter=new f({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(l){this.inputEvent=l,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=l(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=y}),define(ne[23],ie([0,1,3]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const n=Object.freeze(function(R,b){const E=setTimeout(R.bind(b),0);return{dispose(){clearTimeout(E)}}});var L;(function(R){function b(E){return E===R.None||E===R.Cancelled||E instanceof T?!0:!E||typeof E!="object"?!1:typeof E.isCancellationRequested=="boolean"&&typeof E.onCancellationRequested=="function"}R.isCancellationToken=b,R.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:D.Event.None}),R.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:n})})(L=e.CancellationToken||(e.CancellationToken={}));class T{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?n:(this._emitter||(this._emitter=new D.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class A{constructor(b){this._token=void 0,this._parentListener=void 0,this._parentListener=b&&b.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new T),this._token}cancel(){this._token?this._token instanceof T&&this._token.cancel():this._token=L.Cancelled}dispose(b=!1){b&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof T&&this._token.dispose():this._token=L.None}}e.CancellationTokenSource=A}),define(ne[106],ie([0,1,23]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCachedComputed=e.Cache=void 0;class n{constructor(A){this.task=A,this.result=null}get(){if(this.result)return this.result;const A=new D.CancellationTokenSource,R=this.task(A.token);return this.result={promise:R,dispose:()=>{this.result=null,A.cancel(),A.dispose()}},this.result}}e.Cache=n;class L{constructor(A){this.computeFn=A,this.lastCache=void 0,this.lastArgKey=void 0}get(A){const R=JSON.stringify(A);return this.lastArgKey!==R&&(this.lastArgKey=R,this.lastCache=this.computeFn(A)),this.lastCache}}e.LRUCachedComputed=L}),define(ne[40],ie([0,1,9,2]),function(J,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function L(y){const p=y;return p?[p.on,p.pause,p.resume,p.destroy].every(l=>typeof l=="function"):!1}e.isReadableStream=L;function T(y){const p=y;return p?L(p.stream)&&Array.isArray(p.buffer)&&typeof p.ended=="boolean":!1}e.isReadableBufferedStream=T;function A(y,p){return new R(y,p)}e.newWriteableStream=A;class R{constructor(p,l){this.reducer=p,this.options=l,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(p){if(!this.state.destroyed){if(this.state.flowing)this.emitData(p);else if(this.buffer.data.push(p),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(l=>this.pendingWritePromises.push(l))}}error(p){this.state.destroyed||(this.state.flowing?this.emitError(p):this.buffer.error.push(p))}end(p){this.state.destroyed||(typeof p!="undefined"&&this.write(p),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(p){this.listeners.data.slice(0).forEach(l=>l(p))}emitError(p){this.listeners.error.length===0?(0,D.onUnexpectedError)(p):this.listeners.error.slice(0).forEach(l=>l(p))}emitEnd(){this.listeners.end.slice(0).forEach(p=>p())}on(p,l){if(!this.state.destroyed)switch(p){case"data":this.listeners.data.push(l),this.resume();break;case"end":this.listeners.end.push(l),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(l),this.state.flowing&&this.flowErrors();break}}removeListener(p,l){if(this.state.destroyed)return;let r;switch(p){case"data":r=this.listeners.data;break;case"end":r=this.listeners.end;break;case"error":r=this.listeners.error;break}if(r){const a=r.indexOf(l);a>=0&&r.splice(a,1)}}flowData(){if(this.buffer.data.length>0){const p=this.reducer(this.buffer.data);this.emitData(p),this.buffer.data.length=0;const l=[...this.pendingWritePromises];this.pendingWritePromises.length=0,l.forEach(r=>r())}}flowErrors(){if(this.listeners.error.length>0){for(const p of this.buffer.error)this.emitError(p);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function b(y,p){const l=[];let r;for(;(r=y.read())!==null;)l.push(r);return p(l)}e.consumeReadable=b;function E(y,p,l){const r=[];let a;for(;(a=y.read())!==null&&r.length<l;)r.push(a);return a===null&&r.length>0?p(r):{read:()=>{if(r.length>0)return r.shift();if(typeof a!="undefined"){const i=a;return a=void 0,i}return y.read()}}}e.peekReadable=E;function I(y,p){return new Promise((l,r)=>{const a=[];C(y,{onData:i=>{p&&a.push(i)},onError:i=>{p?r(i):l(void 0)},onEnd:()=>{l(p?p(a):void 0)}})})}e.consumeStream=I;function C(y,p){let l=!1;return y.on("error",r=>{l||p.onError(r)}),y.on("end",()=>{l||p.onEnd()}),y.on("data",r=>{l||p.onData(r)}),(0,n.toDisposable)(()=>l=!0)}e.listenStream=C;function f(y,p){return new Promise((l,r)=>{const a=new n.DisposableStore,i=[],t=c=>{if(i.push(c),i.length>p)return a.dispose(),y.pause(),l({stream:y,buffer:i,ended:!1})},o=c=>r(c),s=()=>l({stream:y,buffer:i,ended:!0});a.add((0,n.toDisposable)(()=>y.removeListener("error",o))),y.on("error",o),a.add((0,n.toDisposable)(()=>y.removeListener("end",s))),y.on("end",s),a.add((0,n.toDisposable)(()=>y.removeListener("data",t))),y.on("data",t)})}e.peekStream=f;function S(y,p){const l=A(p);return l.end(y),l}e.toStream=S;function u(){const y=A(()=>{throw new Error("not supported")});return y.end(),y}e.emptyStream=u;function v(y){let p=!1;return{read:()=>p?null:(p=!0,y)}}e.toReadable=v;function d(y,p,l){const r=A(l);return C(y,{onData:a=>r.write(p.data(a)),onError:a=>r.error(p.error?p.error(a):a),onEnd:()=>r.end()}),r}e.transform=d;function g(y,p,l){let r=!1;return{read:()=>{const a=p.read();return r?a:(r=!0,a!==null?l([y,a]):y)}}}e.prefixedReadable=g;function w(y,p,l){let r=!1;const a=A(l);return C(p,{onData:i=>r?a.write(i):(r=!0,a.write(l([y,i]))),onError:i=>a.error(i),onEnd:()=>{r||(r=!0,a.write(y)),a.end()}}),a}e.prefixedStream=w}),define(ne[17],ie([0,1,40]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const n=typeof Buffer!="undefined";let L,T;class A{constructor(h){this.buffer=h,this.byteLength=this.buffer.byteLength}static alloc(h){return n?new A(Buffer.allocUnsafe(h)):new A(new Uint8Array(h))}static wrap(h){return n&&!Buffer.isBuffer(h)&&(h=Buffer.from(h.buffer,h.byteOffset,h.byteLength)),new A(h)}static fromString(h,m){return!(m?.dontUseNodeBuffer||!1)&&n?new A(Buffer.from(h)):(L||(L=new TextEncoder),new A(L.encode(h)))}static fromByteArray(h){const m=A.alloc(h.length);for(let P=0,_=h.length;P<_;P++)m.buffer[P]=h[P];return m}static concat(h,m){if(typeof m=="undefined"){m=0;for(let O=0,M=h.length;O<M;O++)m+=h[O].byteLength}const P=A.alloc(m);let _=0;for(let O=0,M=h.length;O<M;O++){const k=h[O];P.set(k,_),_+=k.byteLength}return P}clone(){const h=A.alloc(this.byteLength);return h.set(this),h}toString(){return n?this.buffer.toString():(T||(T=new TextDecoder),T.decode(this.buffer))}slice(h,m){return new A(this.buffer.subarray(h,m))}set(h,m){if(h instanceof A)this.buffer.set(h.buffer,m);else if(h instanceof Uint8Array)this.buffer.set(h,m);else if(h instanceof ArrayBuffer)this.buffer.set(new Uint8Array(h),m);else if(ArrayBuffer.isView(h))this.buffer.set(new Uint8Array(h.buffer,h.byteOffset,h.byteLength),m);else throw new Error("Unkown argument 'array'")}readUInt32BE(h){return E(this.buffer,h)}writeUInt32BE(h,m){I(this.buffer,h,m)}readUInt32LE(h){return C(this.buffer,h)}writeUInt32LE(h,m){f(this.buffer,h,m)}readUInt8(h){return S(this.buffer,h)}writeUInt8(h,m){u(this.buffer,h,m)}}e.VSBuffer=A;function R(c,h){return c[h+0]<<0>>>0|c[h+1]<<8>>>0}e.readUInt16LE=R;function b(c,h,m){c[m+0]=h&255,h=h>>>8,c[m+1]=h&255}e.writeUInt16LE=b;function E(c,h){return c[h]*2**24+c[h+1]*2**16+c[h+2]*2**8+c[h+3]}e.readUInt32BE=E;function I(c,h,m){c[m+3]=h,h=h>>>8,c[m+2]=h,h=h>>>8,c[m+1]=h,h=h>>>8,c[m]=h}e.writeUInt32BE=I;function C(c,h){return c[h+0]<<0>>>0|c[h+1]<<8>>>0|c[h+2]<<16>>>0|c[h+3]<<24>>>0}e.readUInt32LE=C;function f(c,h,m){c[m+0]=h&255,h=h>>>8,c[m+1]=h&255,h=h>>>8,c[m+2]=h&255,h=h>>>8,c[m+3]=h&255}e.writeUInt32LE=f;function S(c,h){return c[h]}e.readUInt8=S;function u(c,h,m){c[m]=h}e.writeUInt8=u;function v(c){return D.consumeReadable(c,h=>A.concat(h))}e.readableToBuffer=v;function d(c){return D.toReadable(c)}e.bufferToReadable=d;function g(c){return D.consumeStream(c,h=>A.concat(h))}e.streamToBuffer=g;async function w(c){return c.ended?A.concat(c.buffer):A.concat([...c.buffer,await g(c.stream)])}e.bufferedStreamToBuffer=w;function y(c){return D.toStream(c,h=>A.concat(h))}e.bufferToStream=y;function p(c){return D.transform(c,{data:h=>typeof h=="string"?A.fromString(h):A.wrap(h)},h=>A.concat(h))}e.streamToBufferReadableStream=p;function l(c){return D.newWriteableStream(h=>A.concat(h),c)}e.newWriteableBufferStream=l;function r(c,h){return D.prefixedReadable(c,h,m=>A.concat(m))}e.prefixedBufferReadable=r;function a(c,h){return D.prefixedStream(c,h,m=>A.concat(m))}e.prefixedBufferStream=a;function i(c){let h=0,m=0,P=0;const _=new Uint8Array(Math.floor(c.length/4*3)),O=k=>{switch(m){case 3:_[P++]=h|k,m=0;break;case 2:_[P++]=h|k>>>2,h=k<<6,m=3;break;case 1:_[P++]=h|k>>>4,h=k<<4,m=2;break;default:h=k<<2,m=1}};for(let k=0;k<c.length;k++){const U=c.charCodeAt(k);if(U>=65&&U<=90)O(U-65);else if(U>=97&&U<=122)O(U-97+26);else if(U>=48&&U<=57)O(U-48+52);else if(U===43||U===45)O(62);else if(U===47||U===95)O(63);else{if(U===61)break;throw new SyntaxError(`Unexpected base64 character ${c[k]}`)}}const M=P;for(;m>0;)O(0);return A.wrap(_).slice(0,M)}e.decodeBase64=i;const t="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function s({buffer:c},h=!0,m=!1){const P=m?o:t;let _="";const O=c.byteLength%3;let M=0;for(;M<c.byteLength-O;M+=3){const k=c[M+0],U=c[M+1],N=c[M+2];_+=P[k>>>2],_+=P[(k<<4|U>>>4)&63],_+=P[(U<<2|N>>>6)&63],_+=P[N&63]}if(O===1){const k=c[M+0];_+=P[k>>>2],_+=P[k<<4&63],h&&(_+="==")}else if(O===2){const k=c[M+0],U=c[M+1];_+=P[k>>>2],_+=P[(k<<4|U>>>4)&63],_+=P[U<<2&63],h&&(_+="=")}return _}e.encodeBase64=s}),define(ne[27],ie([0,1,106,100]),function(J,e,D,n){"use strict";var L;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function T(X){return!X||typeof X!="string"?!0:X.trim().length===0}e.isFalsyOrWhitespace=T;const A=/{(\d+)}/g;function R(X,...oe){return oe.length===0?X:X.replace(A,function(le,fe){const ge=parseInt(fe,10);return isNaN(ge)||ge<0||ge>=oe.length?le:oe[ge]})}e.format=R;const b=/{([^}]+)}/g;function E(X,oe){return X.replace(b,(le,fe)=>oe[fe]??le)}e.format2=E;function I(X){return X.replace(/[<>&]/g,function(oe){switch(oe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return oe}})}e.escape=I;function C(X){return X.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=C;function f(X,oe){let le=0;const fe=oe.charCodeAt(0);for(let ge=X.length-1;ge>=0;ge--)X.charCodeAt(ge)===fe&&le++;return le}e.count=f;function S(X,oe,le="\u2026"){return X.length<=oe?X:`${X.substr(0,oe)}${le}`}e.truncate=S;function u(X,oe=" "){const le=v(X,oe);return d(le,oe)}e.trim=u;function v(X,oe){if(!X||!oe)return X;const le=oe.length;if(le===0||X.length===0)return X;let fe=0;for(;X.indexOf(oe,fe)===fe;)fe=fe+le;return X.substring(fe)}e.ltrim=v;function d(X,oe){if(!X||!oe)return X;const le=oe.length,fe=X.length;if(le===0||fe===0)return X;let ge=fe,Le=-1;for(;Le=X.lastIndexOf(oe,ge-1),!(Le===-1||Le+le!==ge);){if(Le===0)return"";ge=Le}return X.substring(0,ge)}e.rtrim=d;function g(X){return X.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=g;function w(X){return X.replace(/\*/g,"")}e.stripWildcards=w;function y(X,oe,le={}){if(!X)throw new Error("Cannot create regex from empty string");oe||(X=C(X)),le.wholeWord&&(/\B/.test(X.charAt(0))||(X="\\b"+X),/\B/.test(X.charAt(X.length-1))||(X=X+"\\b"));let fe="";return le.global&&(fe+="g"),le.matchCase||(fe+="i"),le.multiline&&(fe+="m"),le.unicode&&(fe+="u"),new RegExp(X,fe)}e.createRegExp=y;function p(X){return X.source==="^"||X.source==="^$"||X.source==="$"||X.source==="^\\s*$"?!1:!!(X.exec("")&&X.lastIndex===0)}e.regExpLeadsToEndlessLoop=p;function l(X){return!!X.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=l;function r(X){return(X.global?"g":"")+(X.ignoreCase?"i":"")+(X.multiline?"m":"")+(X.unicode?"u":"")}e.regExpFlags=r;function a(X){return X.split(/\r\n|\r|\n/)}e.splitLines=a;function i(X){for(let oe=0,le=X.length;oe<le;oe++){const fe=X.charCodeAt(oe);if(fe!==32&&fe!==9)return oe}return-1}e.firstNonWhitespaceIndex=i;function t(X,oe=0,le=X.length){for(let fe=oe;fe<le;fe++){const ge=X.charCodeAt(fe);if(ge!==32&&ge!==9)return X.substring(oe,fe)}return X.substring(oe,le)}e.getLeadingWhitespace=t;function o(X,oe=X.length-1){for(let le=oe;le>=0;le--){const fe=X.charCodeAt(le);if(fe!==32&&fe!==9)return le}return-1}e.lastNonWhitespaceIndex=o;function s(X,oe){return X<oe?-1:X>oe?1:0}e.compare=s;function c(X,oe,le=0,fe=X.length,ge=0,Le=oe.length){for(;le<fe&&ge<Le;le++,ge++){let ke=X.charCodeAt(le),Pe=oe.charCodeAt(ge);if(ke<Pe)return-1;if(ke>Pe)return 1}const Se=fe-le,De=Le-ge;return Se<De?-1:Se>De?1:0}e.compareSubstring=c;function h(X,oe){return m(X,oe,0,X.length,0,oe.length)}e.compareIgnoreCase=h;function m(X,oe,le=0,fe=X.length,ge=0,Le=oe.length){for(;le<fe&&ge<Le;le++,ge++){let ke=X.charCodeAt(le),Pe=oe.charCodeAt(ge);if(ke===Pe)continue;if(ke>=128||Pe>=128)return c(X.toLowerCase(),oe.toLowerCase(),le,fe,ge,Le);P(ke)&&(ke-=32),P(Pe)&&(Pe-=32);const Ae=ke-Pe;if(Ae!==0)return Ae}const Se=fe-le,De=Le-ge;return Se<De?-1:Se>De?1:0}e.compareSubstringIgnoreCase=m;function P(X){return X>=97&&X<=122}e.isLowerAsciiLetter=P;function _(X){return X>=65&&X<=90}e.isUpperAsciiLetter=_;function O(X,oe){return X.length===oe.length&&m(X,oe)===0}e.equalsIgnoreCase=O;function M(X,oe){const le=oe.length;return oe.length>X.length?!1:m(X,oe,0,le)===0}e.startsWithIgnoreCase=M;function k(X,oe){let le,fe=Math.min(X.length,oe.length);for(le=0;le<fe;le++)if(X.charCodeAt(le)!==oe.charCodeAt(le))return le;return fe}e.commonPrefixLength=k;function U(X,oe){let le,fe=Math.min(X.length,oe.length);const ge=X.length-1,Le=oe.length-1;for(le=0;le<fe;le++)if(X.charCodeAt(ge-le)!==oe.charCodeAt(Le-le))return le;return fe}e.commonSuffixLength=U;function N(X){return 55296<=X&&X<=56319}e.isHighSurrogate=N;function V(X){return 56320<=X&&X<=57343}e.isLowSurrogate=V;function $(X,oe){return(X-55296<<10)+(oe-56320)+65536}e.computeCodePoint=$;function G(X,oe,le){const fe=X.charCodeAt(le);if(N(fe)&&le+1<oe){const ge=X.charCodeAt(le+1);if(V(ge))return $(fe,ge)}return fe}e.getNextCodePoint=G;function te(X,oe){const le=X.charCodeAt(oe-1);if(V(le)&&oe>1){const fe=X.charCodeAt(oe-2);if(N(fe))return $(fe,le)}return le}class W{constructor(oe,le=0){this._str=oe,this._len=oe.length,this._offset=le}get offset(){return this._offset}setOffset(oe){this._offset=oe}prevCodePoint(){const oe=te(this._str,this._offset);return this._offset-=oe>=65536?2:1,oe}nextCodePoint(){const oe=G(this._str,this._len,this._offset);return this._offset+=oe>=65536?2:1,oe}eol(){return this._offset>=this._len}}e.CodePointIterator=W;class j{constructor(oe,le=0){this._iterator=new W(oe,le)}get offset(){return this._iterator.offset}nextGraphemeLength(){const oe=ae.getInstance(),le=this._iterator,fe=le.offset;let ge=oe.getGraphemeBreakType(le.nextCodePoint());for(;!le.eol();){const Le=le.offset,Se=oe.getGraphemeBreakType(le.nextCodePoint());if(xe(ge,Se)){le.setOffset(Le);break}ge=Se}return le.offset-fe}prevGraphemeLength(){const oe=ae.getInstance(),le=this._iterator,fe=le.offset;let ge=oe.getGraphemeBreakType(le.prevCodePoint());for(;le.offset>0;){const Le=le.offset,Se=oe.getGraphemeBreakType(le.prevCodePoint());if(xe(Se,ge)){le.setOffset(Le);break}ge=Se}return fe-le.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=j;function K(X,oe){return new j(X,oe).nextGraphemeLength()}e.nextCharLength=K;function H(X,oe){return new j(X,oe).prevGraphemeLength()}e.prevCharLength=H;function Q(X,oe){oe>0&&V(X.charCodeAt(oe))&&oe--;const le=oe+K(X,oe);return[le-H(X,le),le]}e.getCharContainingOffset=Q;const Z=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function B(X){return Z.test(X)}e.containsRTL=B;const F=/^[\t\n\r\x20-\x7E]*$/;function x(X){return F.test(X)}e.isBasicASCII=x,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function z(X){return e.UNUSUAL_LINE_TERMINATORS.test(X)}e.containsUnusualLineTerminators=z;function q(X){return X>=11904&&X<=55215||X>=63744&&X<=64255||X>=65281&&X<=65374}e.isFullWidthCharacter=q;function ee(X){return X>=127462&&X<=127487||X===8986||X===8987||X===9200||X===9203||X>=9728&&X<=10175||X===11088||X===11093||X>=127744&&X<=128591||X>=128640&&X<=128764||X>=128992&&X<=129008||X>=129280&&X<=129535||X>=129648&&X<=129782}e.isEmojiImprecise=ee;function se(X,oe){if(X.length<oe)return X;const le=/\b/g;let fe=0;for(;le.test(X)&&!(X.length-le.lastIndex<oe);)fe=le.lastIndex,le.lastIndex+=1;return X.substring(fe).replace(/^\s/,"")}e.lcut=se;const ce=/\x1B\x5B[12]?K/g,ue=/\x1b\[\d+m/g,ve=/\x1b\[0?m/g;function pe(X){return X&&(X=X.replace(ce,""),X=X.replace(ue,""),X=X.replace(ve,"")),X}e.removeAnsiEscapeCodes=pe,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Ie(X){return!!(X&&X.length>0&&X.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Ie;function Ee(X){return Ie(X)?X.substr(1):X}e.stripUTF8BOM=Ee;function ye(X,oe){if(!X||!oe||X.length<oe.length)return!1;const le=oe.length,fe=X.toLowerCase();let ge=0,Le=-1;for(;ge<le;){const Se=fe.indexOf(oe[ge],Le+1);if(Se<0)return!1;Le=Se,ge++}return!0}e.fuzzyContains=ye;function be(X,oe=!1){return X?(oe&&(X=X.replace(/\\./g,"")),X.toLowerCase()!==X):!1}e.containsUppercaseCharacter=be;function Re(X){return X.charAt(0).toUpperCase()+X.slice(1)}e.uppercaseFirstLetter=Re;function Fe(X,oe=1){if(oe===0)return"";let le=-1;do le=X.indexOf(`
`,le+1),oe--;while(oe>0&&le>=0);return le===-1?X:(X[le-1]==="\r"&&le--,X.substr(0,le))}e.getNLines=Fe;function Me(X){const oe=90-65+1;return X=X%(2*oe),X<oe?String.fromCharCode(97+X):String.fromCharCode(65+X-oe)}e.singleLetterHash=Me;function qe(X){return ae.getInstance().getGraphemeBreakType(X)}e.getGraphemeBreakType=qe;function xe(X,oe){return X===0?oe!==5&&oe!==7:X===2&&oe===3?!1:X===4||X===2||X===3||oe===4||oe===2||oe===3?!0:!(X===8&&(oe===8||oe===9||oe===11||oe===12)||(X===11||X===9)&&(oe===9||oe===10)||(X===12||X===10)&&oe===10||oe===5||oe===13||oe===7||X===1||X===13&&oe===14||X===6&&oe===6)}var re;(function(X){X[X.Other=0]="Other",X[X.Prepend=1]="Prepend",X[X.CR=2]="CR",X[X.LF=3]="LF",X[X.Control=4]="Control",X[X.Extend=5]="Extend",X[X.Regional_Indicator=6]="Regional_Indicator",X[X.SpacingMark=7]="SpacingMark",X[X.L=8]="L",X[X.V=9]="V",X[X.T=10]="T",X[X.LV=11]="LV",X[X.LVT=12]="LVT",X[X.ZWJ=13]="ZWJ",X[X.Extended_Pictographic=14]="Extended_Pictographic"})(re=e.GraphemeBreakType||(e.GraphemeBreakType={}));class ae{constructor(){this._data=he()}static getInstance(){return ae._INSTANCE||(ae._INSTANCE=new ae),ae._INSTANCE}getGraphemeBreakType(oe){if(oe<32)return oe===10?3:oe===13?2:4;if(oe<127)return 0;const le=this._data,fe=le.length/3;let ge=1;for(;ge<=fe;)if(oe<le[3*ge])ge=2*ge;else if(oe>le[3*ge+1])ge=2*ge+1;else return le[3*ge+2];return 0}}ae._INSTANCE=null;function he(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function we(X,oe){if(X===0)return 0;const le=Ce(X,oe);if(le!==void 0)return le;const fe=new W(oe,X);return fe.prevCodePoint(),fe.offset}e.getLeftDeleteOffset=we;function Ce(X,oe){const le=new W(oe,X);let fe=le.prevCodePoint();for(;Ne(fe)||fe===65039||fe===8419;){if(le.offset===0)return;fe=le.prevCodePoint()}if(!ee(fe))return;let ge=le.offset;return ge>0&&le.prevCodePoint()===8205&&(ge=le.offset),ge}function Ne(X){return 127995<=X&&X<=127999}var Te;(function(X){X[X.zwj=8205]="zwj",X[X.emojiVariantSelector=65039]="emojiVariantSelector",X[X.enclosingKeyCap=8419]="enclosingKeyCap"})(Te||(Te={})),e.noBreakWhitespace="\xA0";class Oe{constructor(oe){this.confusableDictionary=oe}static getInstance(oe){return Oe.cache.get(Array.from(oe))}static getLocales(){return Oe._locales.getValue()}isAmbiguous(oe){return this.confusableDictionary.has(oe)}getPrimaryConfusable(oe){return this.confusableDictionary.get(oe)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=Oe,L=Oe,Oe.ambiguousCharacterData=new n.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Oe.cache=new D.LRUCachedComputed(X=>{function oe(Pe){const Ae=new Map;for(let $e=0;$e<Pe.length;$e+=2)Ae.set(Pe[$e],Pe[$e+1]);return Ae}function le(Pe,Ae){const $e=new Map(Pe);for(const[je,Be]of Ae)$e.set(je,Be);return $e}function fe(Pe,Ae){if(!Pe)return Ae;const $e=new Map;for(const[je,Be]of Pe)Ae.has(je)&&$e.set(je,Be);return $e}const ge=L.ambiguousCharacterData.getValue();let Le=X.filter(Pe=>!Pe.startsWith("_")&&Pe in ge);Le.length===0&&(Le=["_default"]);let Se;for(const Pe of Le){const Ae=oe(ge[Pe]);Se=fe(Se,Ae)}const De=oe(ge._common),ke=le(De,Se);return new Oe(ke)}),Oe._locales=new n.Lazy(()=>Object.keys(Oe.ambiguousCharacterData.getValue()).filter(X=>!X.startsWith("_")));class _e{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(_e.getRawData())),this._data}static isInvisibleCharacter(oe){return _e.getData().has(oe)}static get codePoints(){return _e.getData()}}e.InvisibleCharacters=_e,_e._data=void 0}),define(ne[70],ie([0,1,27]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function n(g){return L(g,0)}e.hash=n;function L(g,w){switch(typeof g){case"object":return g===null?T(349,w):Array.isArray(g)?b(g,w):E(g,w);case"string":return R(g,w);case"boolean":return A(g,w);case"number":return T(g,w);case"undefined":return T(937,w);default:return T(617,w)}}e.doHash=L;function T(g,w){return(w<<5)-w+g|0}e.numberHash=T;function A(g,w){return T(g?433:863,w)}function R(g,w){w=T(149417,w);for(let y=0,p=g.length;y<p;y++)w=T(g.charCodeAt(y),w);return w}e.stringHash=R;function b(g,w){return w=T(104579,w),g.reduce((y,p)=>L(p,y),w)}function E(g,w){return w=T(181387,w),Object.keys(g).sort().reduce((y,p)=>(y=R(p,y),L(g[p],y)),w)}class I{constructor(){this._value=0}get value(){return this._value}hash(w){return this._value=L(w,this._value),this._value}}e.Hasher=I;var C;(function(g){g[g.BLOCK_SIZE=64]="BLOCK_SIZE",g[g.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(C||(C={}));function f(g,w,y=32){const p=y-w,l=~((1<<p)-1);return(g<<w|(l&g)>>>p)>>>0}function S(g,w=0,y=g.byteLength,p=0){for(let l=0;l<y;l++)g[w+l]=p}function u(g,w,y="0"){for(;g.length<w;)g=y+g;return g}function v(g,w=32){return g instanceof ArrayBuffer?Array.from(new Uint8Array(g)).map(y=>y.toString(16).padStart(2,"0")).join(""):u((g>>>0).toString(16),w/4)}e.toHexString=v;class d{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(w){const y=w.length;if(y===0)return;const p=this._buff;let l=this._buffLen,r=this._leftoverHighSurrogate,a,i;for(r!==0?(a=r,i=-1,r=0):(a=w.charCodeAt(0),i=0);;){let t=a;if(D.isHighSurrogate(a))if(i+1<y){const o=w.charCodeAt(i+1);D.isLowSurrogate(o)?(i++,t=D.computeCodePoint(a,o)):t=65533}else{r=a;break}else D.isLowSurrogate(a)&&(t=65533);if(l=this._push(p,l,t),i++,i<y)a=w.charCodeAt(i);else break}this._buffLen=l,this._leftoverHighSurrogate=r}_push(w,y,p){return p<128?w[y++]=p:p<2048?(w[y++]=192|(p&1984)>>>6,w[y++]=128|(p&63)>>>0):p<65536?(w[y++]=224|(p&61440)>>>12,w[y++]=128|(p&4032)>>>6,w[y++]=128|(p&63)>>>0):(w[y++]=240|(p&1835008)>>>18,w[y++]=128|(p&258048)>>>12,w[y++]=128|(p&4032)>>>6,w[y++]=128|(p&63)>>>0),y>=64&&(this._step(),y-=64,this._totalLen+=64,w[0]=w[64+0],w[1]=w[64+1],w[2]=w[64+2]),y}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),v(this._h0)+v(this._h1)+v(this._h2)+v(this._h3)+v(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,S(this._buff,this._buffLen),this._buffLen>56&&(this._step(),S(this._buff));const w=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(w/4294967296),!1),this._buffDV.setUint32(60,w%4294967296,!1),this._step()}_step(){const w=d._bigBlock32,y=this._buffDV;for(let c=0;c<64;c+=4)w.setUint32(c,y.getUint32(c,!1),!1);for(let c=64;c<320;c+=4)w.setUint32(c,f(w.getUint32(c-12,!1)^w.getUint32(c-32,!1)^w.getUint32(c-56,!1)^w.getUint32(c-64,!1),1),!1);let p=this._h0,l=this._h1,r=this._h2,a=this._h3,i=this._h4,t,o,s;for(let c=0;c<80;c++)c<20?(t=l&r|~l&a,o=1518500249):c<40?(t=l^r^a,o=1859775393):c<60?(t=l&r|l&a|r&a,o=2400959708):(t=l^r^a,o=3395469782),s=f(p,5)+t+i+o+w.getUint32(c*4,!1)&4294967295,i=a,a=r,r=f(l,30),l=p,p=s;this._h0=this._h0+p&4294967295,this._h1=this._h1+l&4294967295,this._h2=this._h2+r&4294967295,this._h3=this._h3+a&4294967295,this._h4=this._h4+i&4294967295}}e.StringSHA1=d,d._bigBlock32=new DataView(new ArrayBuffer(320))});var It=this&&this.__classPrivateFieldSet||function(J,e,D,n,L){if(n==="m")throw new TypeError("Private method is not writable");if(n==="a"&&!L)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return n==="a"?L.call(J,D):L?L.value=D:e.set(J,D),D},Ke=this&&this.__classPrivateFieldGet||function(J,e,D,n){if(D==="a"&&!n)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!n:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return D==="m"?n:D==="a"?n.call(J):n?n.value:e.get(J)};define(ne[39],ie([0,1,16,27]),function(J,e,D,n){"use strict";var L,T,A;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function R(i,t,o){let s=i.get(t);return s===void 0&&(s=o,i.set(t,s)),s}e.getOrSet=R;function b(i){const t=[];return i.forEach((o,s)=>{t.push(`${s} => ${o}`)}),`Map(${i.size}) {${t.join(", ")}}`}e.mapToString=b;function E(i){const t=[];return i.forEach(o=>{t.push(o)}),`Set(${i.size}) {${t.join(", ")}}`}e.setToString=E;class I{constructor(){this._value="",this._pos=0}reset(t){return this._value=t,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(t){const o=t.charCodeAt(0),s=this._value.charCodeAt(this._pos);return o-s}value(){return this._value[this._pos]}}e.StringIterator=I;class C{constructor(t=!0){this._caseSensitive=t}reset(t){return this._value=t,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let t=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(t)this._from++;else break;else t=!1;return this}cmp(t){return this._caseSensitive?(0,n.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,n.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=C;class f{constructor(t=!0,o=!0){this._splitOnBackslash=t,this._caseSensitive=o}reset(t){this._from=0,this._to=0,this._value=t,this._valueLen=t.length;for(let o=t.length-1;o>=0;o--,this._valueLen--){const s=this._value.charCodeAt(o);if(!(s===47||this._splitOnBackslash&&s===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let t=!0;for(;this._to<this._valueLen;this._to++){const o=this._value.charCodeAt(this._to);if(o===47||this._splitOnBackslash&&o===92)if(t)this._from++;else break;else t=!1}return this}cmp(t){return this._caseSensitive?(0,n.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,n.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=f;var S;(function(i){i[i.Scheme=1]="Scheme",i[i.Authority=2]="Authority",i[i.Path=3]="Path",i[i.Query=4]="Query",i[i.Fragment=5]="Fragment"})(S||(S={}));class u{constructor(t){this._ignorePathCasing=t,this._states=[],this._stateIdx=0}reset(t){return this._value=t,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new f(!1,!this._ignorePathCasing(t)),this._pathIterator.reset(t.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(t){if(this._states[this._stateIdx]===1)return(0,n.compareIgnoreCase)(t,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,n.compareIgnoreCase)(t,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(t);if(this._states[this._stateIdx]===4)return(0,n.compare)(t,this._value.query);if(this._states[this._stateIdx]===5)return(0,n.compare)(t,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=u;class v{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const t=this.right;return this.right=t.left,t.left=this,this.updateHeight(),t.updateHeight(),t}rotateRight(){const t=this.left;return this.left=t.right,t.right=this,this.updateHeight(),t.updateHeight(),t}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var d;(function(i){i[i.Left=-1]="Left",i[i.Mid=0]="Mid",i[i.Right=1]="Right"})(d||(d={}));class g{constructor(t){this._iter=t}static forUris(t=()=>!1){return new g(new u(t))}static forPaths(t=!1){return new g(new f(void 0,!t))}static forStrings(){return new g(new I)}static forConfigKeys(){return new g(new C)}clear(){this._root=void 0}fill(t,o){if(o){const s=o.slice(0);(0,D.shuffle)(s);for(let c of s)this.set(c,t)}else{const s=t.slice(0);(0,D.shuffle)(s);for(let c of s)this.set(c[0],c[1])}}set(t,o){const s=this._iter.reset(t);let c;this._root||(this._root=new v,this._root.segment=s.value());const h=[];for(c=this._root;;){const P=s.cmp(c.segment);if(P>0)c.left||(c.left=new v,c.left.segment=s.value()),h.push([-1,c]),c=c.left;else if(P<0)c.right||(c.right=new v,c.right.segment=s.value()),h.push([1,c]),c=c.right;else if(s.hasNext())s.next(),c.mid||(c.mid=new v,c.mid.segment=s.value()),h.push([0,c]),c=c.mid;else break}const m=c.value;c.value=o,c.key=t;for(let P=h.length-1;P>=0;P--){const _=h[P][1];_.updateHeight();const O=_.balanceFactor();if(O<-1||O>1){const M=h[P][0],k=h[P+1][0];if(M===1&&k===1)h[P][1]=_.rotateLeft();else if(M===-1&&k===-1)h[P][1]=_.rotateRight();else if(M===1&&k===-1)_.right=h[P+1][1]=h[P+1][1].rotateRight(),h[P][1]=_.rotateLeft();else if(M===-1&&k===1)_.left=h[P+1][1]=h[P+1][1].rotateLeft(),h[P][1]=_.rotateRight();else throw new Error;if(P>0)switch(h[P-1][0]){case-1:h[P-1][1].left=h[P][1];break;case 1:h[P-1][1].right=h[P][1];break;case 0:h[P-1][1].mid=h[P][1];break}else this._root=h[0][1]}}return m}get(t){return this._getNode(t)?.value}_getNode(t){const o=this._iter.reset(t);let s=this._root;for(;s;){const c=o.cmp(s.segment);if(c>0)s=s.left;else if(c<0)s=s.right;else if(o.hasNext())o.next(),s=s.mid;else break}return s}has(t){const o=this._getNode(t);return!(o?.value===void 0&&o?.mid===void 0)}delete(t){return this._delete(t,!1)}deleteSuperstr(t){return this._delete(t,!0)}_delete(t,o){const s=this._iter.reset(t),c=[];let h=this._root;for(;h;){const m=s.cmp(h.segment);if(m>0)c.push([-1,h]),h=h.left;else if(m<0)c.push([1,h]),h=h.right;else if(s.hasNext())s.next(),c.push([0,h]),h=h.mid;else break}if(!!h){if(o?(h.left=void 0,h.mid=void 0,h.right=void 0,h.height=1):(h.key=void 0,h.value=void 0),!h.mid&&!h.value)if(h.left&&h.right){const m=this._min(h.right),{key:P,value:_,segment:O}=m;this._delete(m.key,!1),h.key=P,h.value=_,h.segment=O}else{const m=h.left??h.right;if(c.length>0){const[P,_]=c[c.length-1];switch(P){case-1:_.left=m;break;case 0:_.mid=m;break;case 1:_.right=m;break}}else this._root=m}for(let m=c.length-1;m>=0;m--){const P=c[m][1];P.updateHeight();const _=P.balanceFactor();if(_>1?(P.right.balanceFactor()>=0||(P.right=P.right.rotateRight()),c[m][1]=P.rotateLeft()):_<-1&&(P.left.balanceFactor()<=0||(P.left=P.left.rotateLeft()),c[m][1]=P.rotateRight()),m>0)switch(c[m-1][0]){case-1:c[m-1][1].left=c[m][1];break;case 1:c[m-1][1].right=c[m][1];break;case 0:c[m-1][1].mid=c[m][1];break}else this._root=c[0][1]}}}_min(t){for(;t.left;)t=t.left;return t}findSubstr(t){const o=this._iter.reset(t);let s=this._root,c;for(;s;){const h=o.cmp(s.segment);if(h>0)s=s.left;else if(h<0)s=s.right;else if(o.hasNext())o.next(),c=s.value||c,s=s.mid;else break}return s&&s.value||c}findSuperstr(t){const o=this._iter.reset(t);let s=this._root;for(;s;){const c=o.cmp(s.segment);if(c>0)s=s.left;else if(c<0)s=s.right;else if(o.hasNext())o.next(),s=s.mid;else return s.mid?this._entries(s.mid):void 0}}forEach(t){for(const[o,s]of this)t(s,o)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(t){!t||(t.left&&(yield*this._entries(t.left)),t.value&&(yield[t.key,t.value]),t.mid&&(yield*this._entries(t.mid)),t.right&&(yield*this._entries(t.right)))}_isBalanced(){const t=o=>{if(!o)return!0;const s=o.balanceFactor();return s<-1||s>1?!1:t(o.left)&&t(o.right)};return t(this._root)}}e.TernarySearchTree=g;class w{constructor(t,o){this.uri=t,this.value=o}}class y{constructor(t,o){this[L]="ResourceMap",t instanceof y?(this.map=new Map(t.map),this.toKey=o??y.defaultToKey):(this.map=new Map,this.toKey=t??y.defaultToKey)}set(t,o){return this.map.set(this.toKey(t),new w(t,o)),this}get(t){return this.map.get(this.toKey(t))?.value}has(t){return this.map.has(this.toKey(t))}get size(){return this.map.size}clear(){this.map.clear()}delete(t){return this.map.delete(this.toKey(t))}forEach(t,o){typeof o!="undefined"&&(t=t.bind(o));for(let[s,c]of this.map)t(c.value,c.uri,this)}*values(){for(let t of this.map.values())yield t.value}*keys(){for(let t of this.map.values())yield t.uri}*entries(){for(let t of this.map.values())yield[t.uri,t.value]}*[(L=Symbol.toStringTag,Symbol.iterator)](){for(let[,t]of this.map)yield[t.uri,t.value]}}e.ResourceMap=y,y.defaultToKey=i=>i.toString();var p;(function(i){i[i.None=0]="None",i[i.AsOld=1]="AsOld",i[i.AsNew=2]="AsNew"})(p=e.Touch||(e.Touch={}));class l{constructor(){this[T]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(t){return this._map.has(t)}get(t,o=0){const s=this._map.get(t);if(!!s)return o!==0&&this.touch(s,o),s.value}set(t,o,s=0){let c=this._map.get(t);if(c)c.value=o,s!==0&&this.touch(c,s);else{switch(c={key:t,value:o,next:void 0,previous:void 0},s){case 0:this.addItemLast(c);break;case 1:this.addItemFirst(c);break;case 2:this.addItemLast(c);break;default:this.addItemLast(c);break}this._map.set(t,c),this._size++}return this}delete(t){return!!this.remove(t)}remove(t){const o=this._map.get(t);if(!!o)return this._map.delete(t),this.removeItem(o),this._size--,o.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const t=this._head;return this._map.delete(t.key),this.removeItem(t),this._size--,t.value}forEach(t,o){const s=this._state;let c=this._head;for(;c;){if(o?t.bind(o)(c.value,c.key,this):t(c.value,c.key,this),this._state!==s)throw new Error("LinkedMap got modified during iteration.");c=c.next}}keys(){const t=this,o=this._state;let s=this._head;const c={[Symbol.iterator](){return c},next(){if(t._state!==o)throw new Error("LinkedMap got modified during iteration.");if(s){const h={value:s.key,done:!1};return s=s.next,h}else return{value:void 0,done:!0}}};return c}values(){const t=this,o=this._state;let s=this._head;const c={[Symbol.iterator](){return c},next(){if(t._state!==o)throw new Error("LinkedMap got modified during iteration.");if(s){const h={value:s.value,done:!1};return s=s.next,h}else return{value:void 0,done:!0}}};return c}entries(){const t=this,o=this._state;let s=this._head;const c={[Symbol.iterator](){return c},next(){if(t._state!==o)throw new Error("LinkedMap got modified during iteration.");if(s){const h={value:[s.key,s.value],done:!1};return s=s.next,h}else return{value:void 0,done:!0}}};return c}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(t){if(t>=this.size)return;if(t===0){this.clear();return}let o=this._head,s=this.size;for(;o&&s>t;)this._map.delete(o.key),o=o.next,s--;this._head=o,this._size=s,o&&(o.previous=void 0),this._state++}addItemFirst(t){if(!this._head&&!this._tail)this._tail=t;else if(this._head)t.next=this._head,this._head.previous=t;else throw new Error("Invalid list");this._head=t,this._state++}addItemLast(t){if(!this._head&&!this._tail)this._head=t;else if(this._tail)t.previous=this._tail,this._tail.next=t;else throw new Error("Invalid list");this._tail=t,this._state++}removeItem(t){if(t===this._head&&t===this._tail)this._head=void 0,this._tail=void 0;else if(t===this._head){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this._head=t.next}else if(t===this._tail){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this._tail=t.previous}else{const o=t.next,s=t.previous;if(!o||!s)throw new Error("Invalid list");o.previous=s,s.next=o}t.next=void 0,t.previous=void 0,this._state++}touch(t,o){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(t===this._head)return;const s=t.next,c=t.previous;t===this._tail?(c.next=void 0,this._tail=c):(s.previous=c,c.next=s),t.previous=void 0,t.next=this._head,this._head.previous=t,this._head=t,this._state++}else if(o===2){if(t===this._tail)return;const s=t.next,c=t.previous;t===this._head?(s.previous=void 0,this._head=s):(s.previous=c,c.next=s),t.next=void 0,t.previous=this._tail,this._tail.next=t,this._tail=t,this._state++}}}toJSON(){const t=[];return this.forEach((o,s)=>{t.push([s,o])}),t}fromJSON(t){this.clear();for(const[o,s]of t)this.set(o,s)}}e.LinkedMap=l;class r extends l{constructor(t,o=1){super();this._limit=t,this._ratio=Math.min(Math.max(0,o),1)}get limit(){return this._limit}set limit(t){this._limit=t,this.checkTrim()}get ratio(){return this._ratio}set ratio(t){this._ratio=Math.min(Math.max(0,t),1),this.checkTrim()}get(t,o=2){return super.get(t,o)}peek(t){return super.get(t,0)}set(t,o){return super.set(t,o,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=r;class a{constructor(t){A.set(this,void 0),It(this,A,t,"f")}get size(){return Ke(this,A,"f").size}forEach(t,o){Ke(this,A,"f").forEach(t,o)}get(t){return Ke(this,A,"f").get(t)}has(t){return Ke(this,A,"f").has(t)}entries(){return Ke(this,A,"f").entries()}keys(){return Ke(this,A,"f").keys()}values(){return Ke(this,A,"f").values()}[(A=new WeakMap,Symbol.iterator)](){return Ke(this,A,"f").entries()}}e.ReadonlyMapView=a}),define(ne[71],ie([0,1,39]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const n=new D.LRUCache(1e4);function L(E){return b(E,"NFC",n)}e.normalizeNFC=L;const T=new D.LRUCache(1e4);function A(E){return b(E,"NFD",T)}e.normalizeNFD=A;const R=/[^\u0000-\u0080]/;function b(E,I,C){if(!E)return E;const f=C.get(E);if(f)return f;let S;return R.test(E)?S=E.normalize(I):S=E,C.set(E,S),S}e.removeAccents=function(){const E=/[\u0300-\u036f]/g;return function(I){return A(I).replace(E,"")}}()}),define(ne[15],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function D(s){return Array.isArray(s)}e.isArray=D;function n(s){return typeof s=="string"}e.isString=n;function L(s){return Array.isArray(s)&&s.every(c=>n(c))}e.isStringArray=L;function T(s){return typeof s=="object"&&s!==null&&!Array.isArray(s)&&!(s instanceof RegExp)&&!(s instanceof Date)}e.isObject=T;function A(s){return typeof s=="number"&&!isNaN(s)}e.isNumber=A;function R(s){return!!s&&typeof s[Symbol.iterator]=="function"}e.isIterable=R;function b(s){return s===!0||s===!1}e.isBoolean=b;function E(s){return typeof s=="undefined"}e.isUndefined=E;function I(s){return!C(s)}e.isDefined=I;function C(s){return E(s)||s===null}e.isUndefinedOrNull=C;function f(s,c){if(!s)throw new Error(c?`Unexpected type, expected '${c}'`:"Unexpected type")}e.assertType=f;function S(s){if(C(s))throw new Error("Assertion Failed: argument is undefined or null");return s}e.assertIsDefined=S;function u(...s){const c=[];for(let h=0;h<s.length;h++){const m=s[h];if(C(m))throw new Error(`Assertion Failed: argument at index ${h} is undefined or null`);c.push(m)}return c}e.assertAllDefined=u;const v=Object.prototype.hasOwnProperty;function d(s){if(!T(s))return!1;for(let c in s)if(v.call(s,c))return!1;return!0}e.isEmptyObject=d;function g(s){return typeof s=="function"}e.isFunction=g;function w(...s){return s.length>0&&s.every(g)}e.areFunctions=w;function y(s,c){const h=Math.min(s.length,c.length);for(let m=0;m<h;m++)p(s[m],c[m])}e.validateConstraints=y;function p(s,c){if(n(c)){if(typeof s!==c)throw new Error(`argument does not match constraint: typeof ${c}`)}else if(g(c)){try{if(s instanceof c)return}catch{}if(!C(s)&&s.constructor===c||c.length===1&&c.call(void 0,s)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=p;function l(s){let c=[],h=Object.getPrototypeOf(s);for(;Object.prototype!==h;)c=c.concat(Object.getOwnPropertyNames(h)),h=Object.getPrototypeOf(h);return c}e.getAllPropertyNames=l;function r(s){const c=[];for(const h of l(s))typeof s[h]=="function"&&c.push(h);return c}e.getAllMethodNames=r;function a(s,c){const h=P=>function(){const _=Array.prototype.slice.call(arguments,0);return c(P,_)};let m={};for(const P of s)m[P]=h(P);return m}e.createProxyObject=a;function i(s){return s===null?void 0:s}e.withNullAsUndefined=i;function t(s){return typeof s=="undefined"?null:s}e.withUndefinedAsNull=t;function o(s,c="Unreachable"){throw new Error(c)}e.assertNever=o}),define(ne[41],ie([0,1,10,4,27,15]),function(J,e,D,n,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function A(o){return o===47||o===92}e.isPathSeparator=A;function R(o){return o.replace(/[\\/]/g,D.posix.sep)}e.toSlashes=R;function b(o){return o.indexOf("/")===-1&&(o=R(o)),/^[a-zA-Z]:(\/|$)/.test(o)&&(o="/"+o),o}e.toPosixPath=b;function E(o,s=D.posix.sep){if(!o)return"";const c=o.length,h=o.charCodeAt(0);if(A(h)){if(A(o.charCodeAt(1))&&!A(o.charCodeAt(2))){let P=3;const _=P;for(;P<c&&!A(o.charCodeAt(P));P++);if(_!==P&&!A(o.charCodeAt(P+1))){for(P+=1;P<c;P++)if(A(o.charCodeAt(P)))return o.slice(0,P+1).replace(/[\\/]/g,s)}}return s}else if(g(h)&&o.charCodeAt(1)===58)return A(o.charCodeAt(2))?o.slice(0,2)+s:o.slice(0,2);let m=o.indexOf("://");if(m!==-1){for(m+=3;m<c;m++)if(A(o.charCodeAt(m)))return o.slice(0,m+1)}return""}e.getRoot=E;function I(o){if(!n.isWindows||!o||o.length<5)return!1;let s=o.charCodeAt(0);if(s!==92||(s=o.charCodeAt(1),s!==92))return!1;let c=2;const h=c;for(;c<o.length&&(s=o.charCodeAt(c),s!==92);c++);return!(h===c||(s=o.charCodeAt(c+1),isNaN(s)||s===92))}e.isUNC=I;const C=/[\\/:\*\?"<>\|]/g,f=/[\\/]/g,S=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function u(o,s=n.isWindows){const c=s?C:f;return!(!o||o.length===0||/^\s+$/.test(o)||(c.lastIndex=0,c.test(o))||s&&S.test(o)||o==="."||o===".."||s&&o[o.length-1]==="."||s&&o.length!==o.trim().length||o.length>255)}e.isValidBasename=u;function v(o,s,c){const h=o===s;return!c||h?h:!o||!s?!1:(0,L.equalsIgnoreCase)(o,s)}e.isEqual=v;function d(o,s,c,h=D.sep){if(o===s)return!0;if(!o||!s||s.length>o.length)return!1;if(c){if(!(0,L.startsWithIgnoreCase)(o,s))return!1;if(s.length===o.length)return!0;let P=s.length;return s.charAt(s.length-1)===h&&P--,o.charAt(P)===h}return s.charAt(s.length-1)!==h&&(s+=h),o.indexOf(s)===0}e.isEqualOrParent=d;function g(o){return o>=65&&o<=90||o>=97&&o<=122}e.isWindowsDriveLetter=g;function w(o,s){return n.isWindows&&o.endsWith(":")&&(o+=D.sep),(0,D.isAbsolute)(o)||(o=(0,D.join)(s,o)),o=(0,D.normalize)(o),n.isWindows?(o=(0,L.rtrim)(o,D.sep),o.endsWith(":")&&(o+=D.sep)):(o=(0,L.rtrim)(o,D.sep),o||(o=D.sep)),o}e.sanitizeFilePath=w;function y(o){const s=(0,D.normalize)(o);return n.isWindows?o.length>3?!1:p(s)&&(o.length===2||s.charCodeAt(2)===92):s===D.posix.sep}e.isRootOrDriveLetter=y;function p(o,s){return(s!==void 0?s:n.isWindows)?g(o.charCodeAt(0))&&o.charCodeAt(1)===58:!1}e.hasDriveLetter=p;function l(o){return p(o)?o[0]:void 0}e.getDriveLetter=l;function r(o,s,c){return s.length>o.length?-1:o===s?0:(c&&(o=o.toLowerCase(),s=s.toLowerCase()),o.indexOf(s))}e.indexOfPath=r;function a(o){const s=o.split(":");let c,h,m;for(const P of s){const _=Number(P);(0,T.isNumber)(_)?h===void 0?h=_:m===void 0&&(m=_):c=c?[c,P].join(":"):P}if(!c)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:c,line:h!==void 0?h:void 0,column:m!==void 0?m:h!==void 0?1:void 0}}e.parseLineAndColumnAware=a;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function t(o,s,c=8){let h="";for(let P=0;P<c;P++)h+=i.charAt(Math.floor(Math.random()*i.length));let m;return s?m=`${s}-${h}`:m=h,o?(0,D.join)(o,m):m}e.randomPath=t}),define(ne[28],ie([0,1,15]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function n(v){if(!v||typeof v!="object"||v instanceof RegExp)return v;const d=Array.isArray(v)?[]:{};return Object.keys(v).forEach(g=>{v[g]&&typeof v[g]=="object"?d[g]=n(v[g]):d[g]=v[g]}),d}e.deepClone=n;function L(v){if(!v||typeof v!="object")return v;const d=[v];for(;d.length>0;){const g=d.shift();Object.freeze(g);for(const w in g)if(T.call(g,w)){const y=g[w];typeof y=="object"&&!Object.isFrozen(y)&&d.push(y)}}return v}e.deepFreeze=L;const T=Object.prototype.hasOwnProperty;function A(v,d){return R(v,d,new Set)}e.cloneAndChange=A;function R(v,d,g){if((0,D.isUndefinedOrNull)(v))return v;const w=d(v);if(typeof w!="undefined")return w;if((0,D.isArray)(v)){const y=[];for(const p of v)y.push(R(p,d,g));return y}if((0,D.isObject)(v)){if(g.has(v))throw new Error("Cannot clone recursive data-structure");g.add(v);const y={};for(let p in v)T.call(v,p)&&(y[p]=R(v[p],d,g));return g.delete(v),y}return v}function b(v,d,g=!0){return(0,D.isObject)(v)?((0,D.isObject)(d)&&Object.keys(d).forEach(w=>{w in v?g&&((0,D.isObject)(v[w])&&(0,D.isObject)(d[w])?b(v[w],d[w],g):v[w]=d[w]):v[w]=d[w]}),v):d}e.mixin=b;function E(v,d){if(v===d)return!0;if(v==null||d===null||d===void 0||typeof v!=typeof d||typeof v!="object"||Array.isArray(v)!==Array.isArray(d))return!1;let g,w;if(Array.isArray(v)){if(v.length!==d.length)return!1;for(g=0;g<v.length;g++)if(!E(v[g],d[g]))return!1}else{const y=[];for(w in v)y.push(w);y.sort();const p=[];for(w in d)p.push(w);if(p.sort(),!E(y,p))return!1;for(g=0;g<y.length;g++)if(!E(v[y[g]],d[y[g]]))return!1}return!0}e.equals=E;function I(v){const d=new Set;return JSON.stringify(v,(g,w)=>{if((0,D.isObject)(w)||Array.isArray(w)){if(d.has(w))return"[Circular]";d.add(w)}return w})}e.safeStringify=I;function C(v,d,g){const w=d(v);return typeof w=="undefined"?g:w}e.getOrDefault=C;function f(v,d){const g=Object.create(null);return!v||!d||Object.keys(d).forEach(y=>{const p=v[y],l=d[y];E(p,l)||(g[y]=l)}),g}e.distinct=f;function S(v,d){const g=d.toLowerCase(),w=Object.keys(v).find(y=>y.toLowerCase()===g);return w?v[w]:v[d]}e.getCaseInsensitive=S;function u(v,d){const g=Object.create(null);for(const[w,y]of Object.entries(v))d(w,y)&&(g[w]=y);return g}e.filter=u}),define(ne[7],ie([0,1,10,4]),function(J,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const L=/^\w[\w\d+.-]*$/,T=/^\//,A=/^\/\//;function R(i,t){if(!i.scheme&&t)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!L.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!T.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function b(i,t){return!i&&!t?"file":i}function E(i,t){switch(i){case"https":case"http":case"file":t?t[0]!==C&&(t=C+t):t=C;break}return t}const I="",C="/",f=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class S{constructor(t,o,s,c,h,m=!1){typeof t=="object"?(this.scheme=t.scheme||I,this.authority=t.authority||I,this.path=t.path||I,this.query=t.query||I,this.fragment=t.fragment||I):(this.scheme=b(t,m),this.authority=o||I,this.path=E(this.scheme,s||I),this.query=c||I,this.fragment=h||I,R(this,m))}static isUri(t){return t instanceof S?!0:t?typeof t.authority=="string"&&typeof t.fragment=="string"&&typeof t.path=="string"&&typeof t.query=="string"&&typeof t.scheme=="string"&&typeof t.fsPath=="string"&&typeof t.with=="function"&&typeof t.toString=="function":!1}get fsPath(){return y(this,!1)}with(t){if(!t)return this;let{scheme:o,authority:s,path:c,query:h,fragment:m}=t;return o===void 0?o=this.scheme:o===null&&(o=I),s===void 0?s=this.authority:s===null&&(s=I),c===void 0?c=this.path:c===null&&(c=I),h===void 0?h=this.query:h===null&&(h=I),m===void 0?m=this.fragment:m===null&&(m=I),o===this.scheme&&s===this.authority&&c===this.path&&h===this.query&&m===this.fragment?this:new v(o,s,c,h,m)}static parse(t,o=!1){const s=f.exec(t);return s?new v(s[2]||I,a(s[4]||I),a(s[5]||I),a(s[7]||I),a(s[9]||I),o):new v(I,I,I,I,I)}static file(t){let o=I;if(n.isWindows&&(t=t.replace(/\\/g,C)),t[0]===C&&t[1]===C){const s=t.indexOf(C,2);s===-1?(o=t.substring(2),t=C):(o=t.substring(2,s),t=t.substring(s)||C)}return new v("file",o,t,I,I)}static from(t){const o=new v(t.scheme,t.authority,t.path,t.query,t.fragment);return R(o,!0),o}static joinPath(t,...o){if(!t.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let s;return n.isWindows&&t.scheme==="file"?s=S.file(D.win32.join(y(t,!0),...o)).path:s=D.posix.join(t.path,...o),t.with({path:s})}toString(t=!1){return p(this,t)}toJSON(){return this}static revive(t){if(t){if(t instanceof S)return t;{const o=new v(t);return o._formatted=t.external,o._fsPath=t._sep===u?t.fsPath:null,o}}else return t}}e.URI=S;const u=n.isWindows?1:void 0;class v extends S{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=y(this,!1)),this._fsPath}toString(t=!1){return t?p(this,!0):(this._formatted||(this._formatted=p(this,!1)),this._formatted)}toJSON(){const t={$mid:1};return this._fsPath&&(t.fsPath=this._fsPath,t._sep=u),this._formatted&&(t.external=this._formatted),this.path&&(t.path=this.path),this.scheme&&(t.scheme=this.scheme),this.authority&&(t.authority=this.authority),this.query&&(t.query=this.query),this.fragment&&(t.fragment=this.fragment),t}}const d={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function g(i,t){let o,s=-1;for(let c=0;c<i.length;c++){const h=i.charCodeAt(c);if(h>=97&&h<=122||h>=65&&h<=90||h>=48&&h<=57||h===45||h===46||h===95||h===126||t&&h===47)s!==-1&&(o+=encodeURIComponent(i.substring(s,c)),s=-1),o!==void 0&&(o+=i.charAt(c));else{o===void 0&&(o=i.substr(0,c));const m=d[h];m!==void 0?(s!==-1&&(o+=encodeURIComponent(i.substring(s,c)),s=-1),o+=m):s===-1&&(s=c)}}return s!==-1&&(o+=encodeURIComponent(i.substring(s))),o!==void 0?o:i}function w(i){let t;for(let o=0;o<i.length;o++){const s=i.charCodeAt(o);s===35||s===63?(t===void 0&&(t=i.substr(0,o)),t+=d[s]):t!==void 0&&(t+=i[o])}return t!==void 0?t:i}function y(i,t){let o;return i.authority&&i.path.length>1&&i.scheme==="file"?o=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?t?o=i.path.substr(1):o=i.path[1].toLowerCase()+i.path.substr(2):o=i.path,n.isWindows&&(o=o.replace(/\//g,"\\")),o}e.uriToFsPath=y;function p(i,t){const o=t?w:g;let s="",{scheme:c,authority:h,path:m,query:P,fragment:_}=i;if(c&&(s+=c,s+=":"),(h||c==="file")&&(s+=C,s+=C),h){let O=h.indexOf("@");if(O!==-1){const M=h.substr(0,O);h=h.substr(O+1),O=M.indexOf(":"),O===-1?s+=o(M,!1):(s+=o(M.substr(0,O),!1),s+=":",s+=o(M.substr(O+1),!1)),s+="@"}h=h.toLowerCase(),O=h.indexOf(":"),O===-1?s+=o(h,!1):(s+=o(h.substr(0,O),!1),s+=h.substr(O))}if(m){if(m.length>=3&&m.charCodeAt(0)===47&&m.charCodeAt(2)===58){const O=m.charCodeAt(1);O>=65&&O<=90&&(m=`/${String.fromCharCode(O+32)}:${m.substr(3)}`)}else if(m.length>=2&&m.charCodeAt(1)===58){const O=m.charCodeAt(0);O>=65&&O<=90&&(m=`${String.fromCharCode(O+32)}:${m.substr(2)}`)}s+=o(m,!0)}return P&&(s+="?",s+=o(P,!1)),_&&(s+="#",s+=t?_:g(_,!1)),s}function l(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+l(i.substr(3)):i}}const r=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function a(i){return i.match(r)?i.replace(r,t=>l(t)):i}}),define(ne[107],ie([0,1,7]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function n(E){const I=E;return I&&typeof I.type=="string"&&typeof I.severity=="string"}e.isRemoteConsoleLog=n;function L(E){const I=[];let C;try{const f=JSON.parse(E.arguments),S=f[f.length-1];S&&S.__$stack&&(f.pop(),C=S.__$stack),I.push(...f)}catch{I.push("Unable to log remote console arguments",E.arguments)}return{args:I,stack:C}}e.parse=L;function T(E){if(typeof E!="string")return T(L(E).stack);const I=E;if(I){const C=A(I),f=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(C||"");if(f&&f.length===4)return{uri:D.URI.file(f[1]),line:Number(f[2]),column:Number(f[3])}}}e.getFirstFrame=T;function A(E){if(!E)return E;const I=E.indexOf(`
`);return I===-1?E:E.substring(0,I)}function R(E,I){const{args:C,stack:f}=L(E),S=typeof C[0]=="string"&&C.length===1;let u=A(f);u&&(u=`(${u.trim()})`);let v=[];if(typeof C[0]=="string"?u&&S?v=[`%c[${I}] %c${C[0]} %c${u}`,b("blue"),b(""),b("grey")]:v=[`%c[${I}] %c${C[0]}`,b("blue"),b(""),...C.slice(1)]:v=[`%c[${I}]%`,b("blue"),...C],u&&!S&&v.push(u),typeof console[E.severity]!="function")throw new Error("Unknown console method");console[E.severity].apply(console,v)}e.log=R;function b(E){return`color: ${E}`}}),define(ne[108],ie([0,1,17,27,7]),function(J,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function T(I){return JSON.stringify(I,b)}e.stringify=T;function A(I){let C=JSON.parse(I);return C=E(C),C}e.parse=A;var R;(function(I){I[I.Uri=1]="Uri",I[I.Regexp=2]="Regexp",I[I.ScmResource=3]="ScmResource",I[I.ScmResourceGroup=4]="ScmResourceGroup",I[I.ScmProvider=5]="ScmProvider",I[I.CommentController=6]="CommentController",I[I.CommentThread=7]="CommentThread",I[I.CommentThreadReply=8]="CommentThreadReply",I[I.CommentNode=9]="CommentNode",I[I.CommentThreadNode=10]="CommentThreadNode",I[I.TimelineActionContext=11]="TimelineActionContext",I[I.NotebookCellActionContext=12]="NotebookCellActionContext",I[I.TestItemContext=13]="TestItemContext",I[I.Date=14]="Date"})(R=e.MarshalledId||(e.MarshalledId={}));function b(I,C){return C instanceof RegExp?{$mid:2,source:C.source,flags:(0,n.regExpFlags)(C)}:C}function E(I,C=0){if(!I||C>200)return I;if(typeof I=="object"){switch(I.$mid){case 1:return L.URI.revive(I);case 2:return new RegExp(I.source,I.flags);case 14:return new Date(I.source)}if(I instanceof D.VSBuffer||I instanceof Uint8Array)return I;if(Array.isArray(I))for(let f=0;f<I.length;++f)I[f]=E(I[f],C+1);else for(const f in I)Object.hasOwnProperty.call(I,f)&&(I[f]=E(I[f],C+1))}return I}e.revive=E}),define(ne[18],ie([0,1,4,7]),function(J,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var L;(function(R){R.inMemory="inmemory",R.vscode="vscode",R.internal="private",R.walkThrough="walkThrough",R.walkThroughSnippet="walkThroughSnippet",R.http="http",R.https="https",R.file="file",R.mailto="mailto",R.untitled="untitled",R.data="data",R.command="command",R.vscodeRemote="vscode-remote",R.vscodeRemoteResource="vscode-remote-resource",R.userData="vscode-userdata",R.vscodeCustomEditor="vscode-custom-editor",R.vscodeNotebook="vscode-notebook",R.vscodeNotebookCell="vscode-notebook-cell",R.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",R.vscodeNotebookCellOutput="vscode-notebook-cell-output",R.vscodeInteractive="vscode-interactive",R.vscodeInteractiveInput="vscode-interactive-input",R.vscodeSettings="vscode-settings",R.vscodeWorkspaceTrust="vscode-workspace-trust",R.vscodeTerminal="vscode-terminal",R.webviewPanel="webview-panel",R.vscodeWebview="vscode-webview",R.extension="extension",R.vscodeFileResource="vscode-file",R.tmp="tmp",R.vsls="vsls"})(L=e.Schemas||(e.Schemas={}));class T{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(b){this._preferredWebSchema=b}setDelegate(b){this._delegate=b}set(b,E,I){this._hosts[b]=E,this._ports[b]=I}setConnectionToken(b,E){this._connectionTokens[b]=E}rewrite(b){if(this._delegate)return this._delegate(b);const E=b.authority;let I=this._hosts[E];I&&I.indexOf(":")!==-1&&(I=`[${I}]`);const C=this._ports[E],f=this._connectionTokens[E];let S=`path=${encodeURIComponent(b.path)}`;return typeof f=="string"&&(S+=`&tkn=${encodeURIComponent(f)}`),n.URI.from({scheme:D.isWeb?this._preferredWebSchema:L.vscodeRemoteResource,authority:`${I}:${C}`,path:"/vscode-remote-resource",query:S})}}e.RemoteAuthorities=new T;class A{asBrowserUri(b,E){const I=this.toUri(b,E);return I.scheme===L.vscodeRemote?e.RemoteAuthorities.rewrite(I):I.scheme===L.file&&(D.isNative||typeof D.globals.importScripts=="function"&&D.globals.origin===`${L.vscodeFileResource}://${A.FALLBACK_AUTHORITY}`)?I.with({scheme:L.vscodeFileResource,authority:I.authority||A.FALLBACK_AUTHORITY,query:null,fragment:null}):I}asFileUri(b,E){const I=this.toUri(b,E);return I.scheme===L.vscodeFileResource?I.with({scheme:L.file,authority:I.authority!==A.FALLBACK_AUTHORITY?I.authority:null,query:null,fragment:null}):I}toUri(b,E){return n.URI.isUri(b)?b:n.URI.parse(E.toUrl(b))}}A.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new A}),define(ne[19],ie([0,1,41,18,10,4,27,7]),function(J,e,D,n,L,T,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function b(S){return(0,R.uriToFsPath)(S,!0)}e.originalFSPath=b;class E{constructor(u){this._ignorePathCasing=u}compare(u,v,d=!1){return u===v?0:(0,A.compare)(this.getComparisonKey(u,d),this.getComparisonKey(v,d))}isEqual(u,v,d=!1){return u===v?!0:!u||!v?!1:this.getComparisonKey(u,d)===this.getComparisonKey(v,d)}getComparisonKey(u,v=!1){return u.with({path:this._ignorePathCasing(u)?u.path.toLowerCase():void 0,fragment:v?null:void 0}).toString()}ignorePathCasing(u){return this._ignorePathCasing(u)}isEqualOrParent(u,v,d=!1){if(u.scheme===v.scheme){if(u.scheme===n.Schemas.file)return D.isEqualOrParent(b(u),b(v),this._ignorePathCasing(u))&&u.query===v.query&&(d||u.fragment===v.fragment);if((0,e.isEqualAuthority)(u.authority,v.authority))return D.isEqualOrParent(u.path,v.path,this._ignorePathCasing(u),"/")&&u.query===v.query&&(d||u.fragment===v.fragment)}return!1}joinPath(u,...v){return R.URI.joinPath(u,...v)}basenameOrAuthority(u){return(0,e.basename)(u)||u.authority}basename(u){return L.posix.basename(u.path)}extname(u){return L.posix.extname(u.path)}dirname(u){if(u.path.length===0)return u;let v;return u.scheme===n.Schemas.file?v=R.URI.file(L.dirname(b(u))).path:(v=L.posix.dirname(u.path),u.authority&&v.length&&v.charCodeAt(0)!==47&&(console.error(`dirname("${u.toString})) resulted in a relative path`),v="/")),u.with({path:v})}normalizePath(u){if(!u.path.length)return u;let v;return u.scheme===n.Schemas.file?v=R.URI.file(L.normalize(b(u))).path:v=L.posix.normalize(u.path),u.with({path:v})}relativePath(u,v){if(u.scheme!==v.scheme||!(0,e.isEqualAuthority)(u.authority,v.authority))return;if(u.scheme===n.Schemas.file){const w=L.relative(b(u),b(v));return T.isWindows?D.toSlashes(w):w}let d=u.path||"/",g=v.path||"/";if(this._ignorePathCasing(u)){let w=0;for(const y=Math.min(d.length,g.length);w<y&&!(d.charCodeAt(w)!==g.charCodeAt(w)&&d.charAt(w).toLowerCase()!==g.charAt(w).toLowerCase());w++);d=g.substr(0,w)+d.substr(w)}return L.posix.relative(d,g)}resolvePath(u,v){if(u.scheme===n.Schemas.file){const d=R.URI.file(L.resolve(b(u),v));return u.with({authority:d.authority,path:d.path})}return v=D.toPosixPath(v),u.with({path:L.posix.resolve(u.path,v)})}isAbsolutePath(u){return!!u.path&&u.path[0]==="/"}isEqualAuthority(u,v){return u===v||u!==void 0&&v!==void 0&&(0,A.equalsIgnoreCase)(u,v)}hasTrailingPathSeparator(u,v=L.sep){if(u.scheme===n.Schemas.file){const d=b(u);return d.length>D.getRoot(d).length&&d[d.length-1]===v}else{const d=u.path;return d.length>1&&d.charCodeAt(d.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(u.fsPath)}}removeTrailingPathSeparator(u,v=L.sep){return(0,e.hasTrailingPathSeparator)(u,v)?u.with({path:u.path.substr(0,u.path.length-1)}):u}addTrailingPathSeparator(u,v=L.sep){let d=!1;if(u.scheme===n.Schemas.file){const g=b(u);d=g!==void 0&&g.length===D.getRoot(g).length&&g[g.length-1]===v}else{v="/";const g=u.path;d=g.length===1&&g.charCodeAt(g.length-1)===47}return!d&&!(0,e.hasTrailingPathSeparator)(u,v)?u.with({path:u.path+"/"}):u}}e.ExtUri=E,e.extUri=new E(()=>!1),e.extUriBiasedIgnorePathCase=new E(S=>S.scheme===n.Schemas.file?!T.isLinux:!0),e.extUriIgnorePathCase=new E(S=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function I(S,u){const v=[];for(let d=0;d<S.length;d++){const g=u(S[d]);S.some((w,y)=>y===d?!1:(0,e.isEqualOrParent)(g,u(w)))||v.push(S[d])}return v}e.distinctParents=I;var C;(function(S){S.META_DATA_LABEL="label",S.META_DATA_DESCRIPTION="description",S.META_DATA_SIZE="size",S.META_DATA_MIME="mime";function u(v){const d=new Map;v.path.substring(v.path.indexOf(";")+1,v.path.lastIndexOf(";")).split(";").forEach(y=>{const[p,l]=y.split(":");p&&l&&d.set(p,l)});const w=v.path.substring(0,v.path.indexOf(";"));return w&&d.set(S.META_DATA_MIME,w),d}S.parseMetaData=u})(C=e.DataUri||(e.DataUri={}));function f(S,u,v){if(u){let d=S.path;return d&&d[0]!==L.posix.sep&&(d=L.posix.sep+d),S.with({scheme:v,authority:u,path:d})}return S.with({scheme:v})}e.toLocalResource=f}),define(ne[5],ie([0,1,23,9,3,2,19,4]),function(J,e,D,n,L,T,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function b(B){return!!B&&typeof B.then=="function"}e.isThenable=b;function E(B){const F=new D.CancellationTokenSource,x=B(F.token),z=new Promise((q,ee)=>{const se=F.token.onCancellationRequested(()=>{se.dispose(),F.dispose(),ee(new n.CancellationError)});Promise.resolve(x).then(ce=>{se.dispose(),F.dispose(),q(ce)},ce=>{se.dispose(),F.dispose(),ee(ce)})});return new class{cancel(){F.cancel()}then(q,ee){return z.then(q,ee)}catch(q){return this.then(void 0,q)}finally(q){return z.finally(q)}}}e.createCancelablePromise=E;function I(B,F,x){return new Promise((z,q)=>{const ee=F.onCancellationRequested(()=>{ee.dispose(),z(x)});B.then(z,q).finally(()=>ee.dispose())})}e.raceCancellation=I;function C(B,F){return new Promise((x,z)=>{const q=F.onCancellationRequested(()=>{q.dispose(),z(new n.CancellationError)});B.then(x,z).finally(()=>q.dispose())})}e.raceCancellationError=C;async function f(B){let F=-1;const x=B.map((q,ee)=>q.then(se=>(F=ee,se))),z=await Promise.race(x);return B.forEach((q,ee)=>{ee!==F&&q.cancel()}),z}e.raceCancellablePromises=f;function S(B,F,x){let z;const q=setTimeout(()=>{z?.(void 0),x?.()},F);return Promise.race([B.finally(()=>clearTimeout(q)),new Promise(ee=>z=ee)])}e.raceTimeout=S;function u(B){return new Promise((F,x)=>{const z=B();b(z)?z.then(F,x):F(z)})}e.asPromise=u;class v{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(F){if(this.activePromise){if(this.queuedPromiseFactory=F,!this.queuedPromise){const x=()=>{this.queuedPromise=null;const z=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,z};this.queuedPromise=new Promise(z=>{this.activePromise.then(x,x).then(z)})}return new Promise((x,z)=>{this.queuedPromise.then(x,z)})}return this.activePromise=F(),new Promise((x,z)=>{this.activePromise.then(q=>{this.activePromise=null,x(q)},q=>{this.activePromise=null,z(q)})})}}e.Throttler=v;class d{constructor(){this.current=Promise.resolve(null)}queue(F){return this.current=this.current.then(()=>F(),()=>F())}}e.Sequencer=d;class g{constructor(){this.promiseMap=new Map}queue(F,x){const q=(this.promiseMap.get(F)??Promise.resolve()).catch(()=>{}).then(x).finally(()=>{this.promiseMap.get(F)===q&&this.promiseMap.delete(F)});return this.promiseMap.set(F,q),q}}e.SequencerByKey=g;const w=(B,F)=>{let x=!0;const z=setTimeout(()=>{x=!1,F()},B);return{isTriggered:()=>x,dispose:()=>{clearTimeout(z),x=!1}}},y=B=>{let F=!0;return queueMicrotask(()=>{F&&(F=!1,B())}),{isTriggered:()=>F,dispose:()=>{F=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class p{constructor(F){this.defaultDelay=F,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(F,x=this.defaultDelay){this.task=F,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((q,ee)=>{this.doResolve=q,this.doReject=ee}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const q=this.task;return this.task=null,q()}}));const z=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=x===e.MicrotaskDelay?y(z):w(x,z),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(new n.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=p;class l{constructor(F){this.delayer=new p(F),this.throttler=new v}trigger(F,x){return this.delayer.trigger(()=>this.throttler.queue(F),x)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=l;class r{constructor(){this._isOpen=!1,this._promise=new Promise((F,x)=>{this._completePromise=F})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=r;class a extends r{constructor(F){super();this._timeout=setTimeout(()=>this.open(),F)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=a;function i(B,F){return F?new Promise((x,z)=>{const q=setTimeout(()=>{ee.dispose(),x()},B),ee=F.onCancellationRequested(()=>{clearTimeout(q),ee.dispose(),z(new n.CancellationError)})}):E(x=>i(B,x))}e.timeout=i;function t(B,F=0){const x=setTimeout(B,F);return(0,T.toDisposable)(()=>clearTimeout(x))}e.disposableTimeout=t;function o(B){const F=[];let x=0;const z=B.length;function q(){return x<z?B[x++]():null}function ee(se){se!=null&&F.push(se);const ce=q();return ce?ce.then(ee):Promise.resolve(F)}return Promise.resolve(null).then(ee)}e.sequence=o;function s(B,F=z=>!!z,x=null){let z=0;const q=B.length,ee=()=>{if(z>=q)return Promise.resolve(x);const se=B[z++];return Promise.resolve(se()).then(ue=>F(ue)?Promise.resolve(ue):ee())};return ee()}e.first=s;function c(B,F=z=>!!z,x=null){if(B.length===0)return Promise.resolve(x);let z=B.length;const q=()=>{z=-1;for(const ee of B)ee.cancel?.()};return new Promise((ee,se)=>{for(const ce of B)ce.then(ue=>{--z>=0&&F(ue)?(q(),ee(ue)):z===0&&ee(x)}).catch(ue=>{--z>=0&&(q(),se(ue))})})}e.firstParallel=c;class h{constructor(F){this._size=0,this.maxDegreeOfParalellism=F,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new L.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(F){return this._size++,new Promise((x,z)=>{this.outstandingPromises.push({factory:F,c:x,e:z}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const F=this.outstandingPromises.shift();this.runningPromises++;const x=F.factory();x.then(F.c,F.e),x.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=h;class m extends h{constructor(){super(1)}}e.Queue=m;class P{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const F=new W;return this.drainers.add(F),F.p}isDrained(){for(const[,F]of this.queues)if(F.size>0)return!1;return!0}queueFor(F,x=A.extUri){const z=x.getComparisonKey(F);let q=this.queues.get(z);return q||(q=new m,L.Event.once(q.onFinished)(()=>{q?.dispose(),this.queues.delete(z),this.onDidQueueFinish()}),this.queues.set(z,q)),q}onDidQueueFinish(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const F of this.drainers)F.complete();this.drainers.clear()}dispose(){for(const[,F]of this.queues)F.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=P;class _{constructor(F,x){this._token=-1,typeof F=="function"&&typeof x=="number"&&this.setIfNotSet(F,x)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(F,x){this.cancel(),this._token=setTimeout(()=>{this._token=-1,F()},x)}setIfNotSet(F,x){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,F()},x))}}e.TimeoutTimer=_;class O{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(F,x){this.cancel(),this._token=setInterval(()=>{F()},x)}}e.IntervalTimer=O;class M{constructor(F,x){this.timeoutToken=-1,this.runner=F,this.timeout=x,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(F=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,F)}get delay(){return this.timeout}set delay(F){this.timeout=F}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=M;class k{constructor(F,x){x%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${x}ms is not a multiple of 1000ms.`),this.runner=F,this.timeout=x,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(F=this.timeout){F%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${F}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(F/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=k;class U extends M{constructor(F,x){super(F,x);this.units=[]}work(F){this.units.push(F),this.isScheduled()||this.schedule()}doRun(){const F=this.units;this.units=[],this.runner&&this.runner(F)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=U;class N extends T.Disposable{constructor(F,x){super();this.options=F,this.handler=x,this.pendingWork=[],this.throttler=this._register(new T.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(F){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+F.length>this.options.maxBufferedWork)return!1}else if(this.pending+F.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...F),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new M(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=N,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=B=>{(0,R.setTimeout0)(()=>{if(F)return;const x=Date.now()+15;B(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,x-Date.now())}}))});let F=!1;return{dispose(){F||(F=!0)}}}:e.runWhenIdle=(B,F)=>{const x=requestIdleCallback(B,typeof F=="number"?{timeout:F}:void 0);let z=!1;return{dispose(){z||(z=!0,cancelIdleCallback(x))}}}}();class V{constructor(F){this._didRun=!1,this._executor=()=>{try{this._value=F()}catch(x){this._error=x}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=V;async function $(B,F,x){let z;for(let q=0;q<x;q++)try{return await B()}catch(ee){z=ee,await i(F)}throw z}e.retry=$;class G{hasPending(F){return this._pending?typeof F=="number"?this._pending.taskId===F:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(F,x,z){return this._pending={taskId:F,cancel:()=>z?.(),promise:x},x.then(()=>this.donePending(F),()=>this.donePending(F)),x}donePending(F){this._pending&&F===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const F=this._next;this._next=void 0,F.run().then(F.promiseResolve,F.promiseReject)}}setNext(F){if(this._next)this._next.run=F;else{let x,z;const q=new Promise((ee,se)=>{x=ee,z=se});this._next={run:F,promise:q,promiseResolve:x,promiseReject:z}}return this._next.promise}}e.TaskSequentializer=G;class te{constructor(F,x=()=>Date.now()){this.interval=F,this.nowFn=x,this.lastIncrementTime=0,this.value=0}increment(){const F=this.nowFn();return F-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=F,this.value=0),this.value++,this.value}}e.IntervalCounter=te;class W{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((F,x)=>{this.completeCallback=F,this.errorCallback=x})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(F){return new Promise(x=>{this.completeCallback(F),this.resolved=!0,x()})}error(F){return new Promise(x=>{this.errorCallback(F),this.rejected=!0,x()})}cancel(){new Promise(F=>{this.errorCallback(new n.CancellationError),this.rejected=!0,F()})}}e.DeferredPromise=W;var j;(function(B){async function F(z){let q;const ee=await Promise.all(z.map(se=>se.then(ce=>ce,ce=>{q||(q=ce)})));if(typeof q!="undefined")throw q;return ee}B.settled=F;function x(z){return new Promise(async(q,ee)=>{try{await z(q,ee)}catch(se){ee(se)}})}B.withAsyncBody=x})(j=e.Promises||(e.Promises={}));var K;(function(B){B[B.Initial=0]="Initial",B[B.DoneOK=1]="DoneOK",B[B.DoneError=2]="DoneError"})(K||(K={}));class H{constructor(F){this._state=0,this._results=[],this._error=null,this._onStateChanged=new L.Emitter,queueMicrotask(async()=>{const x={emitOne:z=>this.emitOne(z),emitMany:z=>this.emitMany(z),reject:z=>this.reject(z)};try{await Promise.resolve(F(x)),this.resolve()}catch(z){this.reject(z)}finally{x.emitOne=void 0,x.emitMany=void 0,x.reject=void 0}})}static fromArray(F){return new H(x=>{x.emitMany(F)})}static fromPromise(F){return new H(async x=>{x.emitMany(await F)})}static fromPromises(F){return new H(async x=>{await Promise.all(F.map(async z=>x.emitOne(await z)))})}static merge(F){return new H(async x=>{await Promise.all(F.map(async z=>{for await(const q of z)x.emitOne(q)}))})}[Symbol.asyncIterator](){let F=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(F<this._results.length)return{done:!1,value:this._results[F++]};if(this._state===1)return{done:!0,value:void 0};await L.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(F,x){return new H(async z=>{for await(const q of F)z.emitOne(x(q))})}map(F){return H.map(this,F)}static filter(F,x){return new H(async z=>{for await(const q of F)x(q)&&z.emitOne(q)})}filter(F){return H.filter(this,F)}static coalesce(F){return H.filter(F,x=>!!x)}coalesce(){return H.coalesce(this)}static async toPromise(F){const x=[];for await(const z of F)x.push(z);return x}toPromise(){return H.toPromise(this)}emitOne(F){this._state===0&&(this._results.push(F),this._onStateChanged.fire())}emitMany(F){this._state===0&&(this._results=this._results.concat(F),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(F){this._state===0&&(this._state=2,this._error=F,this._onStateChanged.fire())}}e.AsyncIterableObject=H,H.EMPTY=H.fromArray([]);class Q extends H{constructor(F,x){super(x);this._source=F}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=Q;function Z(B){const F=new D.CancellationTokenSource,x=B(F.token);return new Q(F,async z=>{const q=F.token.onCancellationRequested(()=>{q.dispose(),F.dispose(),z.reject(new n.CancellationError)});try{for await(const ee of x){if(F.token.isCancellationRequested)return;z.emitOne(ee)}q.dispose(),F.dispose()}catch(ee){q.dispose(),F.dispose(),z.reject(ee)}})}e.createCancelableAsyncIterable=Z}),define(ne[109],ie([0,1,5,41,39,10,4,27]),function(J,e,D,n,L,T,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function b(){return Object.create(null)}e.getEmptyExpression=b,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const E="[/\\\\]",I="[^/\\\\]",C=/\//g;function f(W){switch(W){case 0:return"";case 1:return`${I}*?`;default:return`(?:${E}|${I}+${E}|${E}${I}+)*?`}}function S(W,j){if(!W)return[];const K=[];let H=!1,Q=!1,Z="";for(const B of W){switch(B){case j:if(!H&&!Q){K.push(Z),Z="";continue}break;case"{":H=!0;break;case"}":H=!1;break;case"[":Q=!0;break;case"]":Q=!1;break}Z+=B}return Z&&K.push(Z),K}e.splitGlobAware=S;function u(W){if(!W)return"";let j="";const K=S(W,e.GLOB_SPLIT);if(K.every(H=>H===e.GLOBSTAR))j=".*";else{let H=!1;K.forEach((Q,Z)=>{if(Q===e.GLOBSTAR){H||(j+=f(2),H=!0);return}let B=!1,F="",x=!1,z="";for(const q of Q){if(q!=="}"&&B){F+=q;continue}if(x&&(q!=="]"||!z)){let ee;q==="-"?ee=q:(q==="^"||q==="!")&&!z?ee="^":q===e.GLOB_SPLIT?ee="":ee=(0,R.escapeRegExpCharacters)(q),z+=ee;continue}switch(q){case"{":B=!0;continue;case"[":x=!0;continue;case"}":{j+=`(?:${S(F,",").map(ce=>u(ce)).join("|")})`,B=!1,F="";break}case"]":j+="["+z+"]",x=!1,z="";break;case"?":j+=I;continue;case"*":j+=f(1);continue;default:j+=(0,R.escapeRegExpCharacters)(q)}}Z<K.length-1&&(K[Z+1]!==e.GLOBSTAR||Z+2<K.length)&&(j+=E),H=!1})}return j}const v=/^\*\*\/\*\.[\w\.-]+$/,d=/^\*\*\/([\w\.-]+)\/?$/,g=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,w=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,y=/^\*\*((\/[\w\.-]+)+)\/?$/,p=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,l=new L.LRUCache(1e4),r=function(){return!1},a=function(){return null};function i(W,j){if(!W)return a;let K;typeof W!="string"?K=W.pattern:K=W,K=K.trim();const H=`${K}_${!!j.trimForExclusions}`;let Q=l.get(H);if(Q)return t(Q,W);let Z;if(v.test(K)){const B=K.substr(4);Q=function(F,x){return typeof F=="string"&&F.endsWith(B)?K:null}}else(Z=d.exec(o(K,j)))?Q=s(Z[1],K):(j.trimForExclusions?w:g).test(K)?Q=c(K,j):(Z=y.exec(o(K,j)))?Q=h(Z[1].substr(1),K,!0):(Z=p.exec(o(K,j)))?Q=h(Z[1],K,!1):Q=m(K);return l.set(H,Q),t(Q,W)}function t(W,j){return typeof j=="string"?W:function(K,H){return(0,n.isEqualOrParent)(K,j.base,!A.isLinux)?W(K.substr(j.base.length+1),H):null}}function o(W,j){return j.trimForExclusions&&W.endsWith("/**")?W.substr(0,W.length-2):W}function s(W,j){const K=`/${W}`,H=`\\${W}`,Q=function(B,F){return typeof B!="string"?null:F?F===W?j:null:B===W||B.endsWith(K)||B.endsWith(H)?j:null},Z=[W];return Q.basenames=Z,Q.patterns=[j],Q.allBasenames=Z,Q}function c(W,j){const K=te(W.slice(1,-1).split(",").map(F=>i(F,j)).filter(F=>F!==a),W),H=K.length;if(!H)return a;if(H===1)return K[0];const Q=function(F,x){for(let z=0,q=K.length;z<q;z++)if(K[z](F,x))return W;return null},Z=K.find(F=>!!F.allBasenames);Z&&(Q.allBasenames=Z.allBasenames);const B=K.reduce((F,x)=>x.allPaths?F.concat(x.allPaths):F,[]);return B.length&&(Q.allPaths=B),Q}function h(W,j,K){const H=T.sep===T.posix.sep,Q=H?W:W.replace(C,T.sep),Z=T.sep+Q,B=T.posix.sep+W,F=K?function(x,z){return typeof x=="string"&&(x===Q||x.endsWith(Z)||!H&&(x===W||x.endsWith(B)))?j:null}:function(x,z){return typeof x=="string"&&(x===Q||!H&&x===W)?j:null};return F.allPaths=[(K?"*/":"./")+W],F}function m(W){try{const j=new RegExp(`^${u(W)}$`);return function(K){return j.lastIndex=0,typeof K=="string"&&j.test(K)?W:null}}catch{return a}}function P(W,j,K){return!W||typeof j!="string"?!1:_(W)(j,void 0,K)}e.match=P;function _(W,j={}){if(!W)return r;if(typeof W=="string"||U(W)){const K=i(W,j);if(K===a)return r;const H=function(Q,Z){return!!K(Q,Z)};return K.allBasenames&&(H.allBasenames=K.allBasenames),K.allPaths&&(H.allPaths=K.allPaths),H}return $(W,j)}e.parse=_;function O(W){if(!W)return;let j;return K=>(j||(j=(W()||Promise.resolve([])).then(H=>H?k(H):{})),j.then(H=>!!H[K]))}e.hasSiblingPromiseFn=O;function M(W){if(!W)return;let j;return K=>{if(!j){const H=W();j=H?k(H):{}}return!!j[K]}}e.hasSiblingFn=M;function k(W){const j={};for(const K of W)j[K]=!0;return j}function U(W){const j=W;return j?typeof j.base=="string"&&typeof j.pattern=="string":!1}e.isRelativePattern=U;function N(W){return W.allBasenames||[]}e.getBasenameTerms=N;function V(W){return W.allPaths||[]}e.getPathTerms=V;function $(W,j){const K=te(Object.getOwnPropertyNames(W).map(F=>G(F,W[F],j)).filter(F=>F!==a)),H=K.length;if(!H)return a;if(!K.some(F=>!!F.requiresSiblings)){if(H===1)return K[0];const F=function(q,ee){for(let se=0,ce=K.length;se<ce;se++){const ue=K[se](q,ee);if(ue)return ue}return null},x=K.find(q=>!!q.allBasenames);x&&(F.allBasenames=x.allBasenames);const z=K.reduce((q,ee)=>ee.allPaths?q.concat(ee.allPaths):q,[]);return z.length&&(F.allPaths=z),F}const Q=function(F,x,z){let q;for(let ee=0,se=K.length;ee<se;ee++){const ce=K[ee];ce.requiresSiblings&&z&&(x||(x=(0,T.basename)(F)),q||(q=x.substr(0,x.length-(0,T.extname)(F).length)));const ue=ce(F,x,q,z);if(ue)return ue}return null},Z=K.find(F=>!!F.allBasenames);Z&&(Q.allBasenames=Z.allBasenames);const B=K.reduce((F,x)=>x.allPaths?F.concat(x.allPaths):F,[]);return B.length&&(Q.allPaths=B),Q}function G(W,j,K){if(j===!1)return a;const H=i(W,K);if(H===a)return a;if(typeof j=="boolean")return H;if(j){const Q=j.when;if(typeof Q=="string"){const Z=(B,F,x,z)=>{if(!z||!H(B,F))return null;const q=Q.replace("$(basename)",x),ee=z(q);return(0,D.isThenable)(ee)?ee.then(se=>se?W:null):ee?W:null};return Z.requiresSiblings=!0,Z}}return H}function te(W,j){const K=W.filter(F=>!!F.basenames);if(K.length<2)return W;const H=K.reduce((F,x)=>{const z=x.basenames;return z?F.concat(z):F},[]);let Q;if(j){Q=[];for(let F=0,x=H.length;F<x;F++)Q.push(j)}else Q=K.reduce((F,x)=>{const z=x.patterns;return z?F.concat(z):F},[]);const Z=function(F,x){if(typeof F!="string")return null;if(!x){let q;for(q=F.length;q>0;q--){const ee=F.charCodeAt(q-1);if(ee===47||ee===92)break}x=F.substr(q)}const z=H.indexOf(x);return z!==-1?Q[z]:null};Z.basenames=H,Z.patterns=Q,Z.allBasenames=H;const B=W.filter(F=>!F.basenames);return B.push(Z),B}}),define(ne[110],ie([0,1,7]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function n(I){return I.toJSON()}class L{constructor(C){this._uriTransformer=C}transformIncoming(C){const f=this._uriTransformer.transformIncoming(C);return f===C?C:n(D.URI.from(f))}transformOutgoing(C){const f=this._uriTransformer.transformOutgoing(C);return f===C?C:n(D.URI.from(f))}transformOutgoingURI(C){const f=this._uriTransformer.transformOutgoing(C);return f===C?C:D.URI.from(f)}transformOutgoingScheme(C){return this._uriTransformer.transformOutgoingScheme(C)}}e.URITransformer=L,e.DefaultURITransformer=new class{transformIncoming(I){return I}transformOutgoing(I){return I}transformOutgoingURI(I){return I}transformOutgoingScheme(I){return I}};function T(I,C,f){if(!I||f>200)return null;if(typeof I=="object"){if(I instanceof D.URI)return C.transformOutgoing(I);for(let S in I)if(Object.hasOwnProperty.call(I,S)){const u=T(I[S],C,f+1);u!==null&&(I[S]=u)}}return null}function A(I,C){const f=T(I,C,0);return f===null?I:f}e.transformOutgoingURIs=A;function R(I,C,f,S){if(!I||S>200)return null;if(typeof I=="object"){if(I.$mid===1)return f?D.URI.revive(C.transformIncoming(I)):C.transformIncoming(I);for(let u in I)if(Object.hasOwnProperty.call(I,u)){const v=R(I[u],C,f,S+1);v!==null&&(I[u]=v)}}return null}function b(I,C){const f=R(I,C,!1,0);return f===null?I:f}e.transformIncomingURIs=b;function E(I,C){const f=R(I,C,!0,0);return f===null?I:f}e.transformAndReviveIncomingURIs=E}),define(ne[29],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const D=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function n(b){return D.test(b)}e.isUUID=n;const L=new Uint8Array(16),T=[];for(let b=0;b<256;b++)T.push(b.toString(16).padStart(2,"0"));let A;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?A=crypto.getRandomValues.bind(crypto):A=function(b){for(let E=0;E<b.length;E++)b[E]=Math.floor(Math.random()*256);return b};function R(){A(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let b=0,E="";return E+=T[L[b++]],E+=T[L[b++]],E+=T[L[b++]],E+=T[L[b++]],E+="-",E+=T[L[b++]],E+=T[L[b++]],E+="-",E+=T[L[b++]],E+=T[L[b++]],E+="-",E+=T[L[b++]],E+=T[L[b++]],E+="-",E+=T[L[b++]],E+=T[L[b++]],E+=T[L[b++]],E+=T[L[b++]],E+=T[L[b++]],E+=T[L[b++]],E}e.generateUuid=R}),define(ne[111],ie([0,1,250]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class n{constructor(T="utf8"){this.stringDecoder=new D.StringDecoder(T),this.remaining=null}write(T){const A=[],R=this.remaining?this.remaining+this.stringDecoder.write(T):this.stringDecoder.write(T);if(R.length<1)return A;let b=0,E,I=b;for(;I<R.length;)if(E=R.charCodeAt(I),E===13||E===10){if(A.push(R.substring(b,I)),I++,I<R.length){const C=E;E=R.charCodeAt(I),(C===13&&E===10||C===10&&E===13)&&I++}b=I}else I++;return this.remaining=b<R.length?R.substr(b):null,A}end(){return this.remaining}}e.LineDecoder=n}),define(ne[112],ie([0,1,33]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const n=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function L(A){const R=A.replace(/\-/g,":").toLowerCase();return!n.has(R)}function T(){const A=(0,D.networkInterfaces)();for(let R in A){const b=A[R];if(b){for(const{mac:E}of b)if(L(E))return E}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=T}),define(ne[113],ie([0,1,33,9,39,29,112]),function(J,e,D,n,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(I){return this._virtualMachineOUIs||(this._virtualMachineOUIs=L.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(I)}value(){if(this._value===void 0){let I=0,C=0;const f=(0,D.networkInterfaces)();for(let S in f){const u=f[S];if(u)for(const{mac:v,internal:d}of u)d||(C+=1,this._isVirtualMachineMacAddress(v.toUpperCase())&&(I+=1))}this._value=C>0?I/C:0}return this._value}};let R;async function b(){return R||(R=(async()=>await E()||T.generateUuid())()),R}e.getMachineId=b;async function E(){try{const I=await new Promise((f,S)=>{J(["crypto"],f,S)}),C=(0,A.getMac)();return I.createHash("sha256").update(C,"utf8").digest("hex")}catch(I){n.onUnexpectedError(I);return}}}),define(ne[22],ie([0,1,50,33,251,5,41,71,10,4,19,7]),function(J,e,D,n,L,T,A,R,b,E,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var f;(function(N){N[N.UNLINK=0]="UNLINK",N[N.MOVE=1]="MOVE"})(f=e.RimRafMode||(e.RimRafMode={}));async function S(N,V=f.UNLINK){if((0,A.isRootOrDriveLetter)(N))throw new Error("rimraf - will refuse to recursively delete root");return V===f.UNLINK?v(N):u(N)}async function u(N){try{const V=(0,A.randomPath)((0,n.tmpdir)());try{await D.promises.rename(N,V)}catch{return v(N)}v(V).catch($=>{})}catch(V){if(V.code!=="ENOENT")throw V}}async function v(N){return e.Promises.rmdir(N,{recursive:!0,maxRetries:3})}function d(N){if((0,A.isRootOrDriveLetter)(N))throw new Error("rimraf - will refuse to recursively delete root");D.rmdirSync(N,{recursive:!0})}e.rimrafSync=d;async function g(N,V){return p(await(V?w(N):(0,L.promisify)(D.readdir)(N)))}async function w(N){try{return await(0,L.promisify)(D.readdir)(N,{withFileTypes:!0})}catch(G){console.warn("[node.js fs] readdir with filetypes failed with error: ",G)}const V=[],$=await g(N);for(const G of $){let te=!1,W=!1,j=!1;try{const K=await e.Promises.lstat((0,b.join)(N,G));te=K.isFile(),W=K.isDirectory(),j=K.isSymbolicLink()}catch(K){console.warn("[node.js fs] unexpected error from lstat after readdir: ",K)}V.push({name:G,isFile:()=>te,isDirectory:()=>W,isSymbolicLink:()=>j})}return V}function y(N){return p(D.readdirSync(N))}e.readdirSync=y;function p(N){return N.map(V=>typeof V=="string"?E.isMacintosh?(0,R.normalizeNFC)(V):V:(V.name=E.isMacintosh?(0,R.normalizeNFC)(V.name):V.name,V))}async function l(N){const V=await g(N),$=[];for(const G of V)await a.existsDirectory((0,b.join)(N,G))&&$.push(G);return $}function r(N,V=1e3){return new Promise($=>{let G=!1;const te=setInterval(()=>{G||(G=!0,D.access(N,W=>{G=!1,W&&(clearInterval(te),$(void 0))}))},V)})}e.whenDeleted=r;var a;(function(N){async function V(te){let W;try{if(W=await e.Promises.lstat(te),!W.isSymbolicLink())return{stat:W}}catch{}try{return{stat:await e.Promises.stat(te),symbolicLink:W?.isSymbolicLink()?{dangling:!1}:void 0}}catch(j){if(j.code==="ENOENT"&&W)return{stat:W,symbolicLink:{dangling:!0}};if(E.isWindows&&j.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(te)),symbolicLink:{dangling:!1}}}catch(K){if(K.code==="ENOENT"&&W)return{stat:W,symbolicLink:{dangling:!0}};throw K}throw j}}N.stat=V;async function $(te){try{const{stat:W,symbolicLink:j}=await N.stat(te);return W.isFile()&&j?.dangling!==!0}catch{}return!1}N.existsFile=$;async function G(te){try{const{stat:W,symbolicLink:j}=await N.stat(te);return W.isDirectory()&&j?.dangling!==!0}catch{}return!1}N.existsDirectory=G})(a=e.SymlinkSupport||(e.SymlinkSupport={}));const i=new T.ResourceQueue;function t(N,V,$){return i.queueFor(C.URI.file(N),I.extUriBiasedIgnorePathCase).queue(()=>{const G=h($);return new Promise((te,W)=>s(N,V,G,j=>j?W(j):te()))})}let o=!0;function s(N,V,$,G){if(!o)return D.writeFile(N,V,{mode:$.mode,flag:$.flag},G);D.open(N,$.flag,$.mode,(te,W)=>{if(te)return G(te);D.writeFile(W,V,j=>{if(j)return D.close(W,()=>G(j));D.fdatasync(W,K=>(K&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",K),o=!1),D.close(W,H=>G(H))))})})}function c(N,V,$){const G=h($);if(!o)return D.writeFileSync(N,V,{mode:G.mode,flag:G.flag});const te=D.openSync(N,G.flag,G.mode);try{D.writeFileSync(te,V);try{D.fdatasyncSync(te)}catch(W){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",W),o=!1}}finally{D.closeSync(te)}}e.writeFileSync=c;function h(N){return N?{mode:typeof N.mode=="number"?N.mode:438,flag:typeof N.flag=="string"?N.flag:"w"}:{mode:438,flag:"w"}}async function m(N,V){if(N===V)return;async function $(G){try{const te=await e.Promises.lstat(G);if(te.isDirectory()||te.isSymbolicLink())return;await e.Promises.utimes(G,te.atime,new Date)}catch{}}try{await e.Promises.rename(N,V),await $(V)}catch(G){if(N.toLowerCase()!==V.toLowerCase()&&G.code==="EXDEV"||N.endsWith("."))await P(N,V,{preserveSymlinks:!1}),await S(N,f.MOVE),await $(V);else throw G}}async function P(N,V,$){return O(N,V,{root:{source:N,target:V},options:$,handledSourcePaths:new Set})}const _=511;async function O(N,V,$){if($.handledSourcePaths.has(N))return;$.handledSourcePaths.add(N);const{stat:G,symbolicLink:te}=await a.stat(N);if(te){if($.options.preserveSymlinks)try{return await U(N,V,$)}catch(W){console.warn("[node.js fs] copy of symlink failed: ",W)}if(te.dangling)return}return G.isDirectory()?M(N,V,G.mode&_,$):k(N,V,G.mode&_)}async function M(N,V,$,G){await e.Promises.mkdir(V,{recursive:!0,mode:$});const te=await g(N);for(const W of te)await O((0,b.join)(N,W),(0,b.join)(V,W),G)}async function k(N,V,$){await e.Promises.copyFile(N,V),await e.Promises.chmod(V,$)}async function U(N,V,$){let G=await e.Promises.readlink(N);(0,A.isEqualOrParent)(G,$.root.source,!E.isLinux)&&(G=(0,b.join)($.root.target,G.substr($.root.source.length+1))),await e.Promises.symlink(G,V)}e.Promises=new class{get access(){return(0,L.promisify)(D.access)}get stat(){return(0,L.promisify)(D.stat)}get lstat(){return(0,L.promisify)(D.lstat)}get utimes(){return(0,L.promisify)(D.utimes)}get read(){return(N,V,$,G,te)=>new Promise((W,j)=>{D.read(N,V,$,G,te,(K,H,Q)=>K?j(K):W({bytesRead:H,buffer:Q}))})}get readFile(){return(0,L.promisify)(D.readFile)}get write(){return(N,V,$,G,te)=>new Promise((W,j)=>{D.write(N,V,$,G,te,(K,H,Q)=>K?j(K):W({bytesWritten:H,buffer:Q}))})}get appendFile(){return(0,L.promisify)(D.appendFile)}get fdatasync(){return(0,L.promisify)(D.fdatasync)}get truncate(){return(0,L.promisify)(D.truncate)}get rename(){return(0,L.promisify)(D.rename)}get copyFile(){return(0,L.promisify)(D.copyFile)}get open(){return(0,L.promisify)(D.open)}get close(){return(0,L.promisify)(D.close)}get symlink(){return(0,L.promisify)(D.symlink)}get readlink(){return(0,L.promisify)(D.readlink)}get chmod(){return(0,L.promisify)(D.chmod)}get mkdir(){return(0,L.promisify)(D.mkdir)}get unlink(){return(0,L.promisify)(D.unlink)}get rmdir(){return(0,L.promisify)(D.rmdir)}get realpath(){return(0,L.promisify)(D.realpath)}async exists(N){try{return await e.Promises.access(N),!0}catch{return!1}}get readdir(){return g}get readDirsInDir(){return l}get writeFile(){return t}get rm(){return S}get move(){return m}get copy(){return P}}}),define(ne[114],ie([0,1,50,10,4,27,22]),function(J,e,D,n,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function R(f){if(L.isLinux)return f;const S=(0,n.dirname)(f);if(f===S)return f;const u=((0,n.basename)(f)||f).toLowerCase();try{const d=(0,A.readdirSync)(S).filter(g=>g.toLowerCase()===u);if(d.length===1){const g=R(S);if(g)return(0,n.join)(g,d[0])}else if(d.length>1){const g=d.indexOf(u);if(g>=0){const w=R(S);if(w)return(0,n.join)(w,d[g])}}}catch{}return null}e.realcaseSync=R;async function b(f){if(L.isLinux)return f;const S=(0,n.dirname)(f);if(f===S)return f;const u=((0,n.basename)(f)||f).toLowerCase();try{const d=(await A.Promises.readdir(S)).filter(g=>g.toLowerCase()===u);if(d.length===1){const g=await b(S);if(g)return(0,n.join)(g,d[0])}else if(d.length>1){const g=d.indexOf(u);if(g>=0){const w=await b(S);if(w)return(0,n.join)(w,d[g])}}}catch{}return null}e.realcase=b;async function E(f){try{return await A.Promises.realpath(f)}catch{const u=C(f);return await A.Promises.access(u,D.constants.R_OK),u}}e.realpath=E;function I(f){try{return D.realpathSync(f)}catch{const u=C(f);return D.accessSync(u,D.constants.R_OK),u}}e.realpathSync=I;function C(f){return(0,T.rtrim)((0,n.normalize)(f),n.sep)}}),define(ne[115],ie([0,1,56]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function n(R,b,E,I=1){let C=!1;return new Promise(f=>{const S=setTimeout(()=>{if(!C)return C=!0,f(0)},E);L(R,b,I,u=>{if(!C)return C=!0,clearTimeout(S),f(u)})})}e.findFreePort=n;function L(R,b,E,I){if(b===0)return I(0);const C=new D.Socket;C.once("connect",()=>(A(C),L(R+E,b-1,E,I))),C.once("data",()=>{}),C.once("error",f=>(A(C),f.code!=="ECONNREFUSED"?L(R+E,b-1,E,I):I(R))),C.connect(R,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function T(R,b,E){let I=!1,C,f=1;const S=D.createServer({pauseOnConnect:!0});function u(v,d){I||(I=!0,S.removeAllListeners(),S.close(),C&&clearTimeout(C),d(v))}return new Promise(v=>{C=setTimeout(()=>{u(0,v)},E),S.on("listening",()=>{u(R,v)}),S.on("error",d=>{d&&(d.code==="EADDRINUSE"||d.code==="EACCES")&&f<b?(R++,f++,S.listen(R,"127.0.0.1")):u(0,v)}),S.on("close",()=>{u(0,v)}),S.listen(R,"127.0.0.1")})}e.findFreePortFaster=T;function A(R){try{R.removeAllListeners("connect"),R.removeAllListeners("error"),R.end(),R.destroy(),R.unref()}catch(b){console.error(b)}}}),define(ne[72],ie([0,1,33,10,22]),function(J,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const T=/^\d+$/,A=/^Microsoft.PowerShell_.*/,R=/^Microsoft.PowerShellPreview_.*/;var b;(function(p){p[p.x64=0]="x64",p[p.x86=1]="x86",p[p.ARM=2]="ARM"})(b||(b={}));let E;switch(process.arch){case"ia32":case"x32":E=1;break;case"arm":case"arm64":E=2;break;default:E=0;break}let I;process.env.PROCESSOR_ARCHITEW6432?I=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?I=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?I=1:I=0;class C{constructor(l,r,a){this.exePath=l,this.displayName=r,this.knownToExist=a}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await L.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function f({useAlternateBitness:p=!1}={}){return p?E===0?process.env["ProgramFiles(x86)"]||null:I===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function S({useAlternateBitness:p=!1,findPreview:l=!1}={}){const r=f({useAlternateBitness:p});if(!r)return null;const a=n.join(r,"PowerShell");if(!await L.SymlinkSupport.existsDirectory(a))return null;let i=-1,t=null;for(const c of await L.Promises.readdir(a)){let h=-1;if(l){const P=c.indexOf("-");if(P<0)continue;const _=c.substring(0,P);if(!T.test(_)||c.substring(P+1)!=="preview")continue;h=parseInt(_,10)}else{if(!T.test(c))continue;h=parseInt(c,10)}if(h<=i)continue;const m=n.join(a,c,"pwsh.exe");!await L.SymlinkSupport.existsFile(m)||(t=m,i=h)}if(!t)return null;const o=r.includes("x86")?" (x86)":"",s=l?" Preview":"";return new C(t,`PowerShell${s}${o}`,!0)}async function u({findPreview:p}={}){if(!process.env.LOCALAPPDATA)return null;const l=n.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await L.SymlinkSupport.existsDirectory(l))return null;const{pwshMsixDirRegex:r,pwshMsixName:a}=p?{pwshMsixDirRegex:R,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:A,pwshMsixName:"PowerShell (Store)"};for(const i of await L.Promises.readdir(l))if(r.test(i)){const t=n.join(l,i,"pwsh.exe");return new C(t,a)}return null}function v(){const p=n.join(D.homedir(),".dotnet","tools","pwsh.exe");return new C(p,".NET Core PowerShell Global Tool")}function d(){const p=n.join(process.env.windir,E===1&&I!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new C(p,"Windows PowerShell",!0)}async function*g(){let p=await S();p&&(yield p),p=await S({useAlternateBitness:!0}),p&&(yield p),p=await u(),p&&(yield p),p=v(),p&&(yield p),p=await S({findPreview:!0}),p&&(yield p),p=await u({findPreview:!0}),p&&(yield p),p=await S({useAlternateBitness:!0,findPreview:!0}),p&&(yield p),p=d(),p&&(yield p)}async function*w(){for await(const p of g())await p.exists()&&(yield p)}e.enumeratePowerShellInstallations=w;async function y(){for await(const p of w())return p;return null}e.getFirstAvailablePowerShellInstallation=y}),define(ne[116],ie([0,1,45,18]),function(J,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function L(A){return new Promise((R,b)=>{let E;const I=new Map;function C(S,u,v,d,g){const w=I.get(u);if(S===A||w){const y={name:f(v),cmd:v,pid:S,ppid:u,load:d,mem:g};I.set(S,y),S===A&&(E=y),w&&(w.children||(w.children=[]),w.children.push(y),w.children.length>1&&(w.children=w.children.sort((p,l)=>p.pid-l.pid)))}}function f(S){const u=/--vscode-window-kind=shared-process/,v=/--vscode-window-kind=issue-reporter/,d=/--vscode-window-kind=process-explorer/,g=/--utility-sub-type=network/,w=/--crashes-directory/,y=/\\pipe\\winpty-control/,p=/conhost\.exe/,l=/--type=([a-zA-Z-]+)/;if(w.exec(S))return"electron-crash-reporter";if(y.exec(S))return"winpty-process";if(p.exec(S))return"console-window-host (Windows internal process)";let r=l.exec(S);if(r&&r.length===2)return r[1]==="renderer"?u.exec(S)?"shared-process":v.exec(S)?"issue-reporter":d.exec(S)?"process-explorer":"window":r[1]==="utility"&&g.exec(S)?"utility-network-service":r[1];const a=/[a-zA-Z-]+\.js/g;let i="";do r=a.exec(S),r&&(i+=r+" ");while(r);return i&&S.indexOf("node ")<0&&S.indexOf("node.exe")<0?`electron_node ${i}`:S}if(process.platform==="win32"){const S=u=>u.indexOf("\\\\?\\")===0||u.indexOf("\\??\\")===0?u.substr(4):u.indexOf('"\\\\?\\')===0||u.indexOf('"\\??\\')===0?'"'+u.substr(5):u;new Promise((u,v)=>{J(["windows-process-tree"],u,v)}).then(u=>{u.getProcessList(A,v=>{u.getProcessCpuUsage(v,d=>{const g=new Map;d.forEach(w=>{const y=S(w.commandLine||"");g.set(w.pid,{name:f(y),cmd:y,pid:w.pid,ppid:w.ppid,load:w.cpu||0,mem:w.memory||0})}),E=g.get(A),E?(g.forEach(w=>{const y=g.get(w.ppid);y&&(y.children||(y.children=[]),y.children.push(w))}),g.forEach(w=>{w.children&&(w.children=w.children.sort((y,p)=>y.pid-p.pid))}),R(E)):b(new Error(`Root process ${A} not found`))})},u.ProcessDataFlag.CommandLine|u.ProcessDataFlag.Memory)})}else{let S=function(){let u=[E];const v=[];for(;u.length;){const g=u.shift();g&&(v.push(g.pid),g.children&&(u=u.concat(g.children)))}let d=JSON.stringify(n.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",J).fsPath);d+=" "+v.join(" "),(0,D.exec)(d,{},(g,w,y)=>{if(g||y)b(g||new Error(y.toString()));else{const p=w.toString().split(`
`);for(let l=0;l<v.length;l++){const r=I.get(v[l]);r.load=parseFloat(p[l])}if(!E){b(new Error(`Root process ${A} not found`));return}R(E)}})};(0,D.exec)("which ps",{},(u,v,d)=>{if(u||d)if(process.platform!=="linux")b(u||new Error(d.toString()));else{const g=JSON.stringify(n.FileAccess.asFileUri("vs/base/node/ps.sh",J).fsPath);(0,D.exec)(g,{},(w,y,p)=>{w||p?b(w||new Error(p.toString())):(T(y,C),S())})}else{const g=v.toString().trim(),w="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,D.exec)(`${g} ${w}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(y,p,l)=>{y||l&&!l.includes("screen size is bogus")?b(y||new Error(l.toString())):(T(p,C),process.platform==="linux"?S():E?R(E):b(new Error(`Root process ${A} not found`)))})}})}})}e.listProcesses=L;function T(A,R){const b=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,E=A.toString().split(`
`);for(const I of E){const C=b.exec(I.trim());C&&C.length===6&&R(parseInt(C[1]),parseInt(C[2]),C[5],parseFloat(C[3]),parseFloat(C[4]))}}});var de=this&&this.__decorate||function(J,e,D,n){var L=arguments.length,T=L<3?e:n===null?n=Object.getOwnPropertyDescriptor(e,D):n,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")T=Reflect.decorate(J,e,D,n);else for(var R=J.length-1;R>=0;R--)(A=J[R])&&(T=(L<3?A(T):L>3?A(e,D,T):A(e,D))||T);return L>3&&T&&Object.defineProperty(e,D,T),T};define(ne[36],ie([0,1,16,5,17,23,54,9,3,2,108,27,15]),function(J,e,D,n,L,T,A,R,b,E,I,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var S;(function(W){W[W.Promise=100]="Promise",W[W.PromiseCancel=101]="PromiseCancel",W[W.EventListen=102]="EventListen",W[W.EventDispose=103]="EventDispose"})(S=e.RequestType||(e.RequestType={}));function u(W){switch(W){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var v;(function(W){W[W.Initialize=200]="Initialize",W[W.PromiseSuccess=201]="PromiseSuccess",W[W.PromiseError=202]="PromiseError",W[W.PromiseErrorObj=203]="PromiseErrorObj",W[W.EventFire=204]="EventFire"})(v=e.ResponseType||(e.ResponseType={}));function d(W){switch(W){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var g;(function(W){W[W.Uninitialized=0]="Uninitialized",W[W.Idle=1]="Idle"})(g||(g={}));class w{constructor(j){this.buffer=j,this.pos=0}read(j){const K=this.buffer.slice(this.pos,this.pos+j);return this.pos+=K.byteLength,K}}class y{constructor(){this.buffers=[]}get buffer(){return L.VSBuffer.concat(this.buffers)}write(j){this.buffers.push(j)}}var p;(function(W){W[W.Undefined=0]="Undefined",W[W.String=1]="String",W[W.Buffer=2]="Buffer",W[W.VSBuffer=3]="VSBuffer",W[W.Array=4]="Array",W[W.Object=5]="Object"})(p||(p={}));function l(W){const j=L.VSBuffer.alloc(4);return j.writeUInt32BE(W,0),j}function r(W){return W.read(4).readUInt32BE(0)}function a(W){const j=L.VSBuffer.alloc(1);return j.writeUInt8(W,0),j}const i={Undefined:a(p.Undefined),String:a(p.String),Buffer:a(p.Buffer),VSBuffer:a(p.VSBuffer),Array:a(p.Array),Object:a(p.Object)},t=typeof Buffer!="undefined";function o(W,j){if(typeof j=="undefined")W.write(i.Undefined);else if(typeof j=="string"){const K=L.VSBuffer.fromString(j);W.write(i.String),W.write(l(K.byteLength)),W.write(K)}else if(t&&Buffer.isBuffer(j)){const K=L.VSBuffer.wrap(j);W.write(i.Buffer),W.write(l(K.byteLength)),W.write(K)}else if(j instanceof L.VSBuffer)W.write(i.VSBuffer),W.write(l(j.byteLength)),W.write(j);else if(Array.isArray(j)){W.write(i.Array),W.write(l(j.length));for(const K of j)o(W,K)}else{const K=L.VSBuffer.fromString(JSON.stringify(j));W.write(i.Object),W.write(l(K.byteLength)),W.write(K)}}function s(W){switch(W.read(1).readUInt8(0)){case p.Undefined:return;case p.String:return W.read(r(W)).toString();case p.Buffer:return W.read(r(W)).buffer;case p.VSBuffer:return W.read(r(W));case p.Array:{const K=r(W),H=[];for(let Q=0;Q<K;Q++)H.push(s(W));return H}case p.Object:return JSON.parse(W.read(r(W)).toString())}}class c{constructor(j,K,H=null,Q=1e3){this.protocol=j,this.ctx=K,this.logger=H,this.timeoutDelay=Q,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(Z=>this.onRawMessage(Z)),this.sendResponse({type:200})}registerChannel(j,K){this.channels.set(j,K),setTimeout(()=>this.flushPendingRequests(j),0)}sendResponse(j){switch(j.type){case 200:{const K=this.send([j.type]);this.logger&&this.logger.logOutgoing(K,0,1,d(j.type));return}case 201:case 202:case 204:case 203:{const K=this.send([j.type,j.id],j.data);this.logger&&this.logger.logOutgoing(K,j.id,1,d(j.type),j.data);return}}}send(j,K=void 0){const H=new y;return o(H,j),o(H,K),this.sendBuffer(H.buffer)}sendBuffer(j){try{return this.protocol.send(j),j.byteLength}catch{return 0}}onRawMessage(j){const K=new w(j),H=s(K),Q=s(K),Z=H[0];switch(Z){case 100:return this.logger&&this.logger.logIncoming(j.byteLength,H[1],1,`${u(Z)}: ${H[2]}.${H[3]}`,Q),this.onPromise({type:Z,id:H[1],channelName:H[2],name:H[3],arg:Q});case 102:return this.logger&&this.logger.logIncoming(j.byteLength,H[1],1,`${u(Z)}: ${H[2]}.${H[3]}`,Q),this.onEventListen({type:Z,id:H[1],channelName:H[2],name:H[3],arg:Q});case 101:return this.logger&&this.logger.logIncoming(j.byteLength,H[1],1,`${u(Z)}`),this.disposeActiveRequest({type:Z,id:H[1]});case 103:return this.logger&&this.logger.logIncoming(j.byteLength,H[1],1,`${u(Z)}`),this.disposeActiveRequest({type:Z,id:H[1]})}}onPromise(j){const K=this.channels.get(j.channelName);if(!K){this.collectPendingRequest(j);return}const H=new T.CancellationTokenSource;let Q;try{Q=K.call(this.ctx,j.name,j.arg,H.token)}catch(F){Q=Promise.reject(F)}const Z=j.id;Q.then(F=>{this.sendResponse({id:Z,data:F,type:201}),this.activeRequests.delete(j.id)},F=>{F instanceof Error?this.sendResponse({id:Z,data:{message:F.message,name:F.name,stack:F.stack?F.stack.split?F.stack.split(`
`):F.stack:void 0},type:202}):this.sendResponse({id:Z,data:F,type:203}),this.activeRequests.delete(j.id)});const B=(0,E.toDisposable)(()=>H.cancel());this.activeRequests.set(j.id,B)}onEventListen(j){const K=this.channels.get(j.channelName);if(!K){this.collectPendingRequest(j);return}const H=j.id,Z=K.listen(this.ctx,j.name,j.arg)(B=>this.sendResponse({id:H,data:B,type:204}));this.activeRequests.set(j.id,Z)}disposeActiveRequest(j){const K=this.activeRequests.get(j.id);K&&(K.dispose(),this.activeRequests.delete(j.id))}collectPendingRequest(j){let K=this.pendingRequests.get(j.channelName);K||(K=[],this.pendingRequests.set(j.channelName,K));const H=setTimeout(()=>{console.error(`Unknown channel: ${j.channelName}`),j.type===100&&this.sendResponse({id:j.id,data:{name:"Unknown channel",message:`Channel name '${j.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);K.push({request:j,timeoutTimer:H})}flushPendingRequests(j){const K=this.pendingRequests.get(j);if(K){for(const H of K)switch(clearTimeout(H.timeoutTimer),H.request.type){case 100:this.onPromise(H.request);break;case 102:this.onEventListen(H.request);break}this.pendingRequests.delete(j)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(j=>j.dispose()),this.activeRequests.clear()}}e.ChannelServer=c;var h;(function(W){W[W.LocalSide=0]="LocalSide",W[W.OtherSide=1]="OtherSide"})(h=e.RequestInitiator||(e.RequestInitiator={}));class m{constructor(j,K=null){this.protocol=j,this.isDisposed=!1,this.state=g.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new b.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(H=>this.onBuffer(H)),this.logger=K}getChannel(j){const K=this;return{call(H,Q,Z){return K.isDisposed?Promise.reject(R.canceled()):K.requestPromise(j,H,Q,Z)},listen(H,Q){return K.isDisposed?Promise.reject(R.canceled()):K.requestEvent(j,H,Q)}}}requestPromise(j,K,H,Q=T.CancellationToken.None){const Z=this.lastRequestId++,F={id:Z,type:100,channelName:j,name:K,arg:H};if(Q.isCancellationRequested)return Promise.reject(R.canceled());let x;return new Promise((q,ee)=>{if(Q.isCancellationRequested)return ee(R.canceled());const se=()=>{const pe=Ie=>{switch(Ie.type){case 201:this.handlers.delete(Z),q(Ie.data);break;case 202:{this.handlers.delete(Z);const Ee=new Error(Ie.data.message);Ee.stack=Ie.data.stack,Ee.name=Ie.data.name,ee(Ee);break}case 203:this.handlers.delete(Z),ee(Ie.data);break}};this.handlers.set(Z,pe),this.sendRequest(F)};let ce=null;this.state===g.Idle?se():(ce=(0,n.createCancelablePromise)(pe=>this.whenInitialized()),ce.then(()=>{ce=null,se()}));const ue=()=>{ce?(ce.cancel(),ce=null):this.sendRequest({id:Z,type:101}),ee(R.canceled())},ve=Q.onCancellationRequested(ue);x=(0,E.combinedDisposable)((0,E.toDisposable)(ue),ve),this.activeRequests.add(x)}).finally(()=>{this.activeRequests.delete(x)})}requestEvent(j,K,H){const Q=this.lastRequestId++,B={id:Q,type:102,channelName:j,name:K,arg:H};let F=null;const x=new b.Emitter({onFirstListenerAdd:()=>{F=(0,n.createCancelablePromise)(q=>this.whenInitialized()),F.then(()=>{F=null,this.activeRequests.add(x),this.sendRequest(B)})},onLastListenerRemove:()=>{F?(F.cancel(),F=null):(this.activeRequests.delete(x),this.sendRequest({id:Q,type:103}))}}),z=q=>x.fire(q.data);return this.handlers.set(Q,z),x.event}sendRequest(j){switch(j.type){case 100:case 102:{const K=this.send([j.type,j.id,j.channelName,j.name],j.arg);this.logger&&this.logger.logOutgoing(K,j.id,0,`${u(j.type)}: ${j.channelName}.${j.name}`,j.arg);return}case 101:case 103:{const K=this.send([j.type,j.id]);this.logger&&this.logger.logOutgoing(K,j.id,0,u(j.type));return}}}send(j,K=void 0){const H=new y;return o(H,j),o(H,K),this.sendBuffer(H.buffer)}sendBuffer(j){try{return this.protocol.send(j),j.byteLength}catch{return 0}}onBuffer(j){const K=new w(j),H=s(K),Q=s(K),Z=H[0];switch(Z){case 200:return this.logger&&this.logger.logIncoming(j.byteLength,0,0,d(Z)),this.onResponse({type:H[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(j.byteLength,H[1],0,d(Z),Q),this.onResponse({type:H[0],id:H[1],data:Q})}}onResponse(j){if(j.type===200){this.state=g.Idle,this._onDidInitialize.fire();return}const K=this.handlers.get(j.id);K&&K(j)}get onDidInitializePromise(){return b.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===g.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(j=>j.dispose()),this.activeRequests.clear()}}de([A.memoize],m.prototype,"onDidInitializePromise",null),e.ChannelClient=m;class P{constructor(j){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new b.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new b.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,j(({protocol:K,onDidClientDisconnect:H})=>{b.Event.once(K.onMessage)(Z=>{const B=new w(Z),F=s(B),x=new c(K,F),z=new m(K);this.channels.forEach((ee,se)=>x.registerChannel(se,ee));const q={channelServer:x,channelClient:z,ctx:F};this._connections.add(q),this._onDidAddConnection.fire(q),H(()=>{x.dispose(),z.dispose(),this._connections.delete(q),this._onDidRemoveConnection.fire(q)})})})}get connections(){const j=[];return this._connections.forEach(K=>j.push(K)),j}getChannel(j,K){const H=this;return{call(Q,Z,B){let F;if((0,f.isFunction)(K)){let z=(0,D.getRandomElement)(H.connections.filter(K));F=z?Promise.resolve(z):b.Event.toPromise(b.Event.filter(H.onDidAddConnection,K))}else F=K.routeCall(H,Q,Z);const x=F.then(z=>z.channelClient.getChannel(j));return O(x).call(Q,Z,B)},listen(Q,Z){if((0,f.isFunction)(K))return H.getMulticastEvent(j,K,Q,Z);const B=K.routeEvent(H,Q,Z).then(F=>F.channelClient.getChannel(j));return O(B).listen(Q,Z)}}}getMulticastEvent(j,K,H,Q){const Z=this;let B=new E.DisposableStore;const F=new b.Emitter({onFirstListenerAdd:()=>{B=new E.DisposableStore;const x=new b.EventMultiplexer,z=new Map,q=se=>{const ue=se.channelClient.getChannel(j).listen(H,Q),ve=x.add(ue);z.set(se,ve)},ee=se=>{const ce=z.get(se);!ce||(ce.dispose(),z.delete(se))};Z.connections.filter(K).forEach(q),b.Event.filter(Z.onDidAddConnection,K)(q,void 0,B),Z.onDidRemoveConnection(ee,void 0,B),x.event(F.fire,F,B),B.add(x)},onLastListenerRemove:()=>{B.dispose()}});return F.event}registerChannel(j,K){this.channels.set(j,K),this._connections.forEach(H=>{H.channelServer.registerChannel(j,K)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=P;class _{constructor(j,K,H=null){const Q=new y;o(Q,K),j.send(Q.buffer),this.channelClient=new m(j,H),this.channelServer=new c(j,K,H)}getChannel(j){return this.channelClient.getChannel(j)}registerChannel(j,K){this.channelServer.registerChannel(j,K)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=_;function O(W){return{call(j,K,H){return W.then(Q=>Q.call(j,K,H))},listen(j,K){const H=new b.Relay;return W.then(Q=>H.input=Q.listen(j,K)),H.event}}}e.getDelayedChannel=O;function M(W){let j=!1;return{call(K,H,Q){return j?W.call(K,H,Q):(0,n.timeout)(0).then(()=>j=!0).then(()=>W.call(K,H,Q))},listen(K,H){if(j)return W.listen(K,H);const Q=new b.Relay;return(0,n.timeout)(0).then(()=>j=!0).then(()=>Q.input=W.listen(K,H)),Q.event}}}e.getNextTickChannel=M;class k{constructor(j){this.fn=j}routeCall(j){return this.route(j)}routeEvent(j){return this.route(j)}async route(j){for(const K of j.connections)if(await Promise.resolve(this.fn(K.ctx)))return Promise.resolve(K);return await b.Event.toPromise(j.onDidAddConnection),await this.route(j)}}e.StaticRouter=k;var U;(function(W){function j(Z,B){const F=Z,x=B&&B.disableMarshalling,z=new Map;for(const q in F)H(q)&&z.set(q,b.Event.buffer(F[q],!0));return new class{listen(q,ee,se){const ce=z.get(ee);if(ce)return ce;if(Q(ee)){const ue=F[ee];if(typeof ue=="function")return ue.call(F,se)}throw new Error(`Event not found: ${ee}`)}call(q,ee,se){const ce=F[ee];if(typeof ce=="function"){if(!x&&Array.isArray(se))for(let ue=0;ue<se.length;ue++)se[ue]=(0,I.revive)(se[ue]);return ce.apply(F,se)}throw new Error(`Method not found: ${ee}`)}}}W.fromService=j;function K(Z,B){const F=B&&B.disableMarshalling;return new Proxy({},{get(x,z){if(typeof z=="string")return B?.properties?.has(z)?B.properties.get(z):Q(z)?function(q){return Z.listen(z,q)}:H(z)?Z.listen(z):async function(...q){let ee;B&&!(0,f.isUndefinedOrNull)(B.context)?ee=[B.context,...q]:ee=q;const se=await Z.call(z,ee);return F?se:(0,I.revive)(se)};throw new Error(`Property not found: ${String(z)}`)}})}W.toService=K;function H(Z){return Z[0]==="o"&&Z[1]==="n"&&C.isUpperAsciiLetter(Z.charCodeAt(2))}function Q(Z){return/^onDynamic/.test(Z)&&C.isUpperAsciiLetter(Z.charCodeAt(9))}})(U=e.ProxyChannel||(e.ProxyChannel={}));const N=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function V(W){if(Array.isArray(W))return W;if(W&&typeof W=="object"&&typeof W.toString=="function"){let j=W.toString();if(j!=="[object Object]")return j}return W}function $(W){return Array.isArray(W)?W.map(V):V(W)}function G(W,j,K,H,Q,Z,B){B=$(B);const F=N[Q],x=F[H%F.length];let z=[`%c[${W}]%c[${String(j).padStart(7," ")}]%c[len: ${String(K).padStart(5," ")}]%c${String(H).padStart(5," ")} - ${Z}`,"color: darkgreen","color: grey","color: grey",`color: ${x}`];/\($/.test(Z)?(z=z.concat(B),z.push(")")):z.push(B),console.log.apply(console,z)}e.logWithColors=G;class te{constructor(j,K){this._outgoingPrefix=j,this._incomingPrefix=K,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(j,K,H,Q,Z){this._totalOutgoing+=j,G(this._outgoingPrefix,this._totalOutgoing,j,K,H,Q,Z)}logIncoming(j,K,H,Q,Z){this._totalIncoming+=j,G(this._incomingPrefix,this._totalIncoming,j,K,H,Q,Z)}}e.IPCLogger=te}),define(ne[117],ie([0,1,17,3,36]),function(J,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class T{constructor(b){this.port=b,this.onMessage=n.Event.fromDOMEventEmitter(this.port,"message",E=>D.VSBuffer.wrap(E.data)),b.start()}send(b){this.port.postMessage(b.buffer)}disconnect(){this.port.close()}}e.Protocol=T;class A extends L.IPCClient{constructor(b,E){const I=new T(b);super(I,E);this.protocol=I}dispose(){this.protocol.disconnect()}}e.Client=A}),define(ne[73],ie([0,1,17,3,2,36]),function(J,e,D,n,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var A;(function(t){t.Created="created",t.Read="read",t.Write="write",t.Open="open",t.Error="error",t.Close="close",t.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",t.NodeEndReceived="nodeEndReceived",t.NodeEndSent="nodeEndSent",t.NodeDrainBegin="nodeDrainBegin",t.NodeDrainEnd="nodeDrainEnd",t.zlibInflateError="zlibInflateError",t.zlibInflateData="zlibInflateData",t.zlibInflateInitialWrite="zlibInflateInitialWrite",t.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",t.zlibInflateWrite="zlibInflateWrite",t.zlibInflateFlushFired="zlibInflateFlushFired",t.zlibDeflateError="zlibDeflateError",t.zlibDeflateData="zlibDeflateData",t.zlibDeflateWrite="zlibDeflateWrite",t.zlibDeflateFlushFired="zlibDeflateFlushFired",t.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",t.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",t.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",t.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",t.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",t.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",t.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",t.ProtocolHeaderRead="protocolHeaderRead",t.ProtocolMessageRead="protocolMessageRead",t.ProtocolHeaderWrite="protocolHeaderWrite",t.ProtocolMessageWrite="protocolMessageWrite",t.ProtocolWrite="protocolWrite"})(A=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var R;(function(t){t.enableDiagnostics=!1,t.records=[];const o=new WeakMap;let s=0;function c(m,P){if(!o.has(m)){const _=String(++s);o.set(m,_)}return o.get(m)}function h(m,P,_,O){if(!t.enableDiagnostics)return;const M=c(m,P);if(O instanceof D.VSBuffer||O instanceof Uint8Array||O instanceof ArrayBuffer||ArrayBuffer.isView(O)){const k=D.VSBuffer.alloc(O.byteLength);k.set(O),t.records.push({timestamp:Date.now(),id:M,label:P,type:_,buff:k})}else t.records.push({timestamp:Date.now(),id:M,label:P,type:_,data:O})}t.traceSocketEvent=h})(R=e.SocketDiagnostics||(e.SocketDiagnostics={}));var b;(function(t){t[t.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",t[t.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(b=e.SocketCloseEventType||(e.SocketCloseEventType={}));let E=null;function I(){return E||(E=D.VSBuffer.alloc(0)),E}class C{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(o){this._chunks.push(o),this._totalLength+=o.byteLength}read(o){return this._read(o,!0)}peek(o){return this._read(o,!1)}_read(o,s){if(o===0)return I();if(o>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===o){const P=this._chunks[0];return s&&(this._chunks.shift(),this._totalLength-=o),P}if(this._chunks[0].byteLength>o){const P=this._chunks[0].slice(0,o);return s&&(this._chunks[0]=this._chunks[0].slice(o),this._totalLength-=o),P}let c=D.VSBuffer.alloc(o),h=0,m=0;for(;o>0;){const P=this._chunks[m];if(P.byteLength>o){const _=P.slice(0,o);c.set(_,h),h+=o,s&&(this._chunks[m]=P.slice(o),this._totalLength-=o),o-=o}else c.set(P,h),h+=P.byteLength,s?(this._chunks.shift(),this._totalLength-=P.byteLength):m++,o-=P.byteLength}return c}}e.ChunkStream=C;var f;(function(t){t[t.None=0]="None",t[t.Regular=1]="Regular",t[t.Control=2]="Control",t[t.Ack=3]="Ack",t[t.Disconnect=5]="Disconnect",t[t.ReplayRequest=6]="ReplayRequest",t[t.Pause=7]="Pause",t[t.Resume=8]="Resume"})(f||(f={}));function S(t){switch(t){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting"}}var u;(function(t){t[t.HeaderLength=13]="HeaderLength",t[t.AcknowledgeTime=2e3]="AcknowledgeTime",t[t.TimeoutTime=2e4]="TimeoutTime",t[t.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",t[t.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(u=e.ProtocolConstants||(e.ProtocolConstants={}));class v{constructor(o,s,c,h){this.type=o,this.id=s,this.ack=c,this.data=h,this.writtenTime=0}get size(){return this.data.byteLength}}class d extends L.Disposable{constructor(o){super();this._onMessage=this._register(new n.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=o,this._isDisposed=!1,this._incomingData=new C,this._register(this._socket.onData(s=>this.acceptChunk(s))),this.lastReadTime=Date.now()}acceptChunk(o){if(!(!o||o.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(o);this._incomingData.byteLength>=this._state.readLen;){const s=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=s.readUInt32BE(9),this._state.messageType=s.readUInt8(0),this._state.id=s.readUInt32BE(1),this._state.ack=s.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:S(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const c=this._state.messageType,h=this._state.id,m=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",s),this._onMessage.fire(new v(c,h,m,s)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class g{constructor(o){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=o,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(o){if(this._isDisposed)return;o.writtenTime=Date.now(),this.lastWriteTime=Date.now();const s=D.VSBuffer.alloc(13);s.writeUInt8(o.type,0),s.writeUInt32BE(o.id,1),s.writeUInt32BE(o.ack,5),s.writeUInt32BE(o.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:S(o.type),id:o.id,ack:o.ack,messageSize:o.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",o.data),this._writeSoon(s,o.data)}_bufferAdd(o,s){const c=this._totalLength===0;return this._data.push(o,s),this._totalLength+=o.byteLength+s.byteLength,c}_bufferTake(){const o=D.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,o}_writeSoon(o,s){this._bufferAdd(o,s)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const o=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:o.byteLength}),this._socket.write(o)}}class w extends L.Disposable{constructor(o){super();this._onMessage=new n.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new n.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=o,this._socketWriter=this._register(new g(this._socket)),this._socketReader=this._register(new d(this._socket)),this._register(this._socketReader.onMessage(s=>{s.type===1&&this._onMessage.fire(s.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(o){this._socketWriter.write(new v(1,0,0,o))}}e.Protocol=w;class y extends T.IPCClient{constructor(o,s,c=null){super(o,s,c);this.protocol=o}static fromSocket(o,s){return new y(new w(o),s)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const o=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),o.end()}}e.Client=y;class p{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new n.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(o){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(o):this._emitter.fire(o):this._bufferedMessages.push(o)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=p;class l{constructor(o){this.data=o,this.next=null}}class r{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let o=[],s=0,c=this._first;for(;c;)o[s++]=c.data,c=c.next;return o}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(o){const s=new l(o);if(!this._first){this._first=s,this._last=s;return}this._last.next=s,this._last=s}}class a{constructor(){this.lastRuns=[];const o=Date.now();for(let s=0;s<a._HISTORY_LENGTH;s++)this.lastRuns[s]=o-1e3*s;setInterval(()=>{for(let s=a._HISTORY_LENGTH;s>=1;s--)this.lastRuns[s]=this.lastRuns[s-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return a._INSTANCE||(a._INSTANCE=new a),a._INSTANCE}load(){const o=Date.now(),s=(1+a._HISTORY_LENGTH)*1e3;let c=0;for(let h=0;h<a._HISTORY_LENGTH;h++)o-this.lastRuns[h]<=s&&c++;return 1-c/a._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}a._HISTORY_LENGTH=10,a._INSTANCE=null;class i{constructor(o,s=null,c=a.getInstance()){this._onControlMessage=new p,this.onControlMessage=this._onControlMessage.event,this._onMessage=new p,this.onMessage=this._onMessage.event,this._onDidDispose=new p,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new p,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new p,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=c,this._isReconnecting=!1,this._outgoingUnackMsg=new r,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=o,this._socketWriter=new g(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new d(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(h=>this._receiveMessage(h))),this._socketDisposables.push(this._socket.onClose(h=>this._onSocketClose.fire(h))),s&&this._socketReader.acceptChunk(s)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._socketDisposables=(0,L.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const o=new v(5,0,0,I());this._socketWriter.write(o),this._socketWriter.flush()}sendPause(){const o=new v(7,0,0,I());this._socketWriter.write(o)}sendResume(){const o=new v(8,0,0,I());this._socketWriter.write(o)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(o,s){this._isReconnecting=!0,this._socketDisposables=(0,L.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=o,this._socketWriter=new g(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new d(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(c=>this._receiveMessage(c))),this._socketDisposables.push(this._socket.onClose(c=>this._onSocketClose.fire(c))),this._socketReader.acceptChunk(s)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const o=new v(3,0,this._incomingAckId,I());this._socketWriter.write(o);const s=this._outgoingUnackMsg.toArray();for(let c=0,h=s.length;c<h;c++)this._socketWriter.write(s[c]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(o){if(o.ack>this._outgoingAckId){this._outgoingAckId=o.ack;do{const s=this._outgoingUnackMsg.peek();if(s&&s.id<=o.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(o.type){case 0:break;case 1:{if(o.id>this._incomingMsgId)if(o.id!==this._incomingMsgId+1){const s=Date.now();s-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=s,this._socketWriter.write(new v(6,0,0,I())))}else this._incomingMsgId=o.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(o.data);break}case 2:{this._onControlMessage.fire(o.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const s=this._outgoingUnackMsg.toArray();for(let c=0,h=s.length;c<h;c++)this._socketWriter.write(s[c]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(o){const s=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const c=new v(1,s,this._incomingAckId,o);this._outgoingUnackMsg.push(c),this._isReconnecting||(this._socketWriter.write(c),this._recvAckCheck())}sendControl(o){const s=new v(2,0,0,o);this._socketWriter.write(s)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const o=Date.now()-this._incomingMsgLastTime;if(o>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-o+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const o=this._outgoingUnackMsg.peek(),s=Date.now()-o.writtenTime,c=Date.now()-this._socketReader.lastReadTime,h=Date.now()-this._lastSocketTimeoutTime;if(s>=2e4&&c>=2e4&&h>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire(void 0);return}const m=Math.max(2e4-s,2e4-c,2e4-h,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},m)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const o=new v(3,0,this._incomingAckId,I());this._socketWriter.write(o)}}e.PersistentProtocol=i}),define(ne[118],ie([0,1,74,3,36,117]),function(J,e,D,n,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class A extends L.IPCServer{static getOnDidClientConnect(){const b=n.Event.fromNodeEventEmitter(D.ipcRenderer,"vscode:createMessageChannel",(E,I)=>I);return n.Event.map(b,E=>{const{port1:I,port2:C}=new MessageChannel,S={protocol:new T.Protocol(I),onDidClientDisconnect:n.Event.fromDOMEventEmitter(I,"close")};return D.ipcRenderer.postMessage("vscode:createMessageChannelResult",E,[C]),S})}constructor(){super(A.getOnDidClientConnect())}}e.Server=A}),define(ne[119],ie([0,1,17,9]),function(J,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function L(R,b){R.proxyAuthorization&&(R.headers={...R.headers||{},"Proxy-Authorization":R.proxyAuthorization});const E=new XMLHttpRequest;return new Promise((I,C)=>{E.open(R.type||"GET",R.url||"",!0,R.user,R.password),T(E,R),E.responseType="arraybuffer",E.onerror=f=>C(new Error(E.statusText&&"XHR failed: "+E.statusText||"XHR failed")),E.onload=f=>{I({res:{statusCode:E.status,headers:A(E)},stream:(0,D.bufferToStream)(D.VSBuffer.wrap(new Uint8Array(E.response)))})},E.ontimeout=f=>C(new Error(`XHR timeout: ${R.timeout}ms`)),R.timeout&&(E.timeout=R.timeout),E.send(R.data),b.onCancellationRequested(()=>{E.abort(),C((0,n.canceled)())})})}e.request=L;function T(R,b){if(b.headers){e:for(let E in b.headers){switch(E){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}R.setRequestHeader(E,b.headers[E])}}}function A(R){const b=Object.create(null);for(const E of R.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(E){const I=E.indexOf(":");b[E.substr(0,I).trim().toLowerCase()]=E.substr(I+1).trim()}return b}}),define(ne[75],ie([0,1,5,3,2,15]),function(J,e,D,n,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var A;(function(C){C[C.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(A=e.StorageHint||(e.StorageHint={}));function R(C){const f=C;return f?.changed instanceof Map||f?.deleted instanceof Set}e.isStorageItemsChangeEvent=R;var b;(function(C){C[C.None=0]="None",C[C.Initialized=1]="Initialized",C[C.Closed=2]="Closed"})(b||(b={}));class E extends L.Disposable{constructor(f,S=Object.create(null)){super();this.database=f,this.options=S,this._onDidChangeStorage=this._register(new n.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=b.None,this.cache=new Map,this.flushDelayer=new D.ThrottledDelayer(E.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(f=>this.onDidChangeItemsExternal(f)))}onDidChangeItemsExternal(f){f.changed?.forEach((S,u)=>this.accept(u,S)),f.deleted?.forEach(S=>this.accept(S,void 0))}accept(f,S){if(this.state===b.Closed)return;let u=!1;(0,T.isUndefinedOrNull)(S)?u=this.cache.delete(f):this.cache.get(f)!==S&&(this.cache.set(f,S),u=!0),u&&this._onDidChangeStorage.fire(f)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===b.None&&(this.state=b.Initialized,this.options.hint!==A.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(f,S){const u=this.cache.get(f);return(0,T.isUndefinedOrNull)(u)?S:u}getBoolean(f,S){const u=this.get(f);return(0,T.isUndefinedOrNull)(u)?S:u==="true"}getNumber(f,S){const u=this.get(f);return(0,T.isUndefinedOrNull)(u)?S:parseInt(u,10)}async set(f,S){if(this.state===b.Closed)return;if((0,T.isUndefinedOrNull)(S))return this.delete(f);const u=String(S);if(this.cache.get(f)!==u)return this.cache.set(f,u),this.pendingInserts.set(f,u),this.pendingDeletes.delete(f),this._onDidChangeStorage.fire(f),this.doFlush()}async delete(f){if(!(this.state===b.Closed||!this.cache.delete(f)))return this.pendingDeletes.has(f)||this.pendingDeletes.add(f),this.pendingInserts.delete(f),this._onDidChangeStorage.fire(f),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=b.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const f={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(f).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(f){if(!!this.hasPending)return this.doFlush(f)}async doFlush(f){return this.flushDelayer.trigger(()=>this.flushPending(),f)}async whenFlushed(){if(!!this.hasPending)return new Promise(f=>this.whenFlushedCallbacks.push(f))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=E,E.DEFAULT_FLUSH_DELAY=100;class I{constructor(){this.onDidChangeItemsExternal=n.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(f){f.insert&&f.insert.forEach((S,u)=>this.items.set(u,S)),f.delete&&f.delete.forEach(S=>this.items.delete(S))}async close(){}}e.InMemoryStorageDatabase=I}),define(ne[120],ie([11,12]),function(J,e){return J.create("vs/base/common/date",e)}),define(ne[57],ie([0,1,120]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const n=60,L=n*60,T=L*24,A=T*7,R=T*30,b=T*365;function E(C,f,S){typeof C!="number"&&(C=C.getTime());const u=Math.round((new Date().getTime()-C)/1e3);if(u<-30)return(0,D.localize)(0,null,E(new Date().getTime()+u*1e3,!1));if(u<30)return(0,D.localize)(1,null);let v;return u<n?(v=u,f?v===1?S?(0,D.localize)(2,null,v):(0,D.localize)(3,null,v):S?(0,D.localize)(4,null,v):(0,D.localize)(5,null,v):v===1?S?(0,D.localize)(6,null,v):(0,D.localize)(7,null,v):S?(0,D.localize)(8,null,v):(0,D.localize)(9,null,v)):u<L?(v=Math.floor(u/n),f?v===1?S?(0,D.localize)(10,null,v):(0,D.localize)(11,null,v):S?(0,D.localize)(12,null,v):(0,D.localize)(13,null,v):v===1?S?(0,D.localize)(14,null,v):(0,D.localize)(15,null,v):S?(0,D.localize)(16,null,v):(0,D.localize)(17,null,v)):u<T?(v=Math.floor(u/L),f?v===1?S?(0,D.localize)(18,null,v):(0,D.localize)(19,null,v):S?(0,D.localize)(20,null,v):(0,D.localize)(21,null,v):v===1?S?(0,D.localize)(22,null,v):(0,D.localize)(23,null,v):S?(0,D.localize)(24,null,v):(0,D.localize)(25,null,v)):u<A?(v=Math.floor(u/T),f?v===1?(0,D.localize)(26,null,v):(0,D.localize)(27,null,v):v===1?(0,D.localize)(28,null,v):(0,D.localize)(29,null,v)):u<R?(v=Math.floor(u/A),f?v===1?S?(0,D.localize)(30,null,v):(0,D.localize)(31,null,v):S?(0,D.localize)(32,null,v):(0,D.localize)(33,null,v):v===1?S?(0,D.localize)(34,null,v):(0,D.localize)(35,null,v):S?(0,D.localize)(36,null,v):(0,D.localize)(37,null,v)):u<b?(v=Math.floor(u/R),f?v===1?S?(0,D.localize)(38,null,v):(0,D.localize)(39,null,v):S?(0,D.localize)(40,null,v):(0,D.localize)(41,null,v):v===1?S?(0,D.localize)(42,null,v):(0,D.localize)(43,null,v):S?(0,D.localize)(44,null,v):(0,D.localize)(45,null,v)):(v=Math.floor(u/b),f?v===1?S?(0,D.localize)(46,null,v):(0,D.localize)(47,null,v):S?(0,D.localize)(48,null,v):(0,D.localize)(49,null,v):v===1?S?(0,D.localize)(50,null,v):(0,D.localize)(51,null,v):S?(0,D.localize)(52,null,v):(0,D.localize)(53,null,v))}e.fromNow=E;function I(C){return C.getFullYear()+"-"+String(C.getMonth()+1).padStart(2,"0")+"-"+String(C.getDate()).padStart(2,"0")+"T"+String(C.getHours()).padStart(2,"0")+":"+String(C.getMinutes()).padStart(2,"0")+":"+String(C.getSeconds()).padStart(2,"0")+"."+(C.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=I}),define(ne[121],ie([11,12]),function(J,e){return J.create("vs/base/common/errorMessage",e)}),define(ne[37],ie([0,1,16,15,121]),function(J,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function T(E,I){return I&&(E.stack||E.stacktrace)?L.localize(0,null,R(E),A(E.stack)||A(E.stacktrace)):R(E)}function A(E){return Array.isArray(E)?E.join(`
`):E}function R(E){return typeof E.code=="string"&&typeof E.errno=="number"&&typeof E.syscall=="string"?L.localize(1,null,E.message):E.message||L.localize(2,null)}function b(E=null,I=!1){if(!E)return L.localize(3,null);if(Array.isArray(E)){const C=D.coalesce(E),f=b(C[0],I);return C.length>1?L.localize(4,null,f,C.length):f}if(n.isString(E))return E;if(E.detail){const C=E.detail;if(C.error)return T(C.error,I);if(C.exception)return T(C.exception,I)}return E.stack?T(E,I):E.message?E.message:L.localize(5,null)}e.toErrorMessage=b}),define(ne[122],ie([11,12]),function(J,e){return J.create("vs/base/node/processes",e)}),define(ne[76],ie([0,1,45,41,18,28,10,4,32,103,15,111,22,122]),function(J,e,D,n,L,T,A,R,b,E,I,C,f,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.removeDangerousEnvVariables=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return E.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return E.TerminateResponseCode}});function u(r){switch(r){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function v(r,a){if(R.isWindows)try{const i={stdio:["pipe","pipe","ignore"]};a&&(i.cwd=a);const t=D.execFile("taskkill",["/T","/F","/PID",r.pid.toString()],i);return new Promise(o=>{t.once("error",s=>{o({success:!1,error:s})}),t.once("exit",(s,c)=>{o(s===0?{success:!0}:{success:!1,code:s!==null?s:1})})})}catch(i){return Promise.resolve({success:!1,error:i,code:i.status?u(i.status):1})}else if(R.isLinux||R.isMacintosh)try{const i=L.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",J).fsPath;return new Promise(t=>{D.execFile(i,[r.pid.toString()],{encoding:"utf8",shell:!0},(o,s,c)=>{t(o?{success:!1,error:o}:{success:!0})})})}catch(i){return Promise.resolve({success:!1,error:i})}else r.kill("SIGKILL");return Promise.resolve({success:!0})}function d(r){!r||(delete r.DEBUG,R.isMacintosh&&delete r.DYLD_LIBRARY_PATH,R.isLinux&&delete r.LD_PRELOAD)}e.removeDangerousEnvVariables=d;function g(r=b.env){return r.comspec||"cmd.exe"}e.getWindowsShell=g;class w{constructor(a,i,t,o){if(i!==void 0&&t!==void 0&&o!==void 0)this.cmd=a,this.args=i,this.shell=t,this.options=o;else{const s=a;this.cmd=s.command,this.shell=s.isShellCommand,this.args=s.args.slice(0),this.options=s.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const s=Object.create(null);Object.keys(b.env).forEach(c=>{s[c]=b.env[c]}),Object.keys(this.options.env).forEach(c=>{s[c]=this.options.env[c]}),this.options.env=s}}getSanitizedCommand(){let a=this.cmd.toLowerCase();const i=a.lastIndexOf(A.sep);return i!==-1&&(a=a.substring(i+1)),w.WellKnowCommands[a]?a:"other"}start(a){return R.isWindows&&(this.options&&this.options.cwd&&n.isUNC(this.options.cwd)||!this.options&&n.isUNC(b.cwd()))?Promise.reject(new Error(S.localize(0,null))):this.useExec().then(i=>{let t,o;const s=new Promise((c,h)=>{t=c,o=h});if(i){let c=this.cmd;this.args&&(c=c+" "+this.args.join(" ")),this.childProcess=D.exec(c,this.options,(h,m,P)=>{this.childProcess=null;const _=h;_&&_.killed?o({killed:this.terminateRequested,stdout:m.toString(),stderr:P.toString()}):this.handleExec(t,a,h,m,P)})}else{let c=null;const h=m=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(m,t,a,o);const P={terminated:this.terminateRequested};I.isNumber(m)&&(P.cmdCode=m),t(P)};if(this.shell&&R.isWindows){const m=T.deepClone(this.options);m.windowsVerbatimArguments=!0,m.detached=!1;let P=!1,_=!1;const O=[];let M=this.ensureQuotes(this.cmd);O.push(M.value),P=M.quoted,this.args&&this.args.forEach(U=>{M=this.ensureQuotes(U),O.push(M.value),_=_&&M.quoted});const k=["/s","/c"];P?_?k.push('"'+O.join(" ")+'"'):O.length>1?k.push('"'+O[0]+'" '+O.slice(1).join(" ")):k.push('"'+O[0]+'"'):k.push(O.join(" ")),c=D.spawn(g(),k,m)}else this.cmd&&(c=D.spawn(this.cmd,this.args,this.options));c&&(this.childProcess=c,this.childProcessPromise=Promise.resolve(c),this.pidResolve&&(this.pidResolve(I.isNumber(c.pid)?c.pid:-1),this.pidResolve=void 0),c.on("error",m=>{this.childProcess=null,o({terminated:this.terminateRequested,error:m})}),c.pid&&(this.childProcess.on("close",h),this.handleSpawn(c,t,a,o,!0)))}return s})}handleClose(a,i,t,o){}ensureQuotes(a){return w.regexp.test(a)?{value:'"'+a+'"',quoted:!0}:{value:a,quoted:a.length>0&&a[0]==='"'&&a[a.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(a=>a.pid,a=>-1):new Promise(a=>{this.pidResolve=a})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(a=>(this.terminateRequested=!0,v(a,this.options.cwd).then(i=>(i.success&&(this.childProcess=null),i))),a=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(a=>{if(!this.shell||!R.isWindows)return a(!1);const i=D.spawn(g(),["/s","/c"]);i.on("error",t=>a(!0)),i.on("exit",t=>a(!1))})}}e.AbstractProcess=w,w.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},w.regexp=/^[^"].* .*[^"]/;class y extends w{constructor(a,i,t,o){super(a,i,t,o);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(a,i,t,o,s){[o,s].forEach((c,h)=>{const m=new C.LineDecoder;m.write(c).forEach(O=>{i({line:O,source:h===0?0:1})});const _=m.end();_&&i({line:_,source:h===0?0:1})}),a({terminated:this.terminateRequested,error:t})}handleSpawn(a,i,t,o,s){const c=new C.LineDecoder,h=new C.LineDecoder;a.stdout.on("data",m=>{c.write(m).forEach(_=>t({line:_,source:0}))}),a.stderr.on("data",m=>{h.write(m).forEach(_=>t({line:_,source:1}))}),this.stdoutLineDecoder=c,this.stderrLineDecoder=h}handleClose(a,i,t,o){const s=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;s&&t({line:s,source:0});const c=this.stderrLineDecoder?this.stderrLineDecoder.end():null;c&&t({line:c,source:1})}}e.LineProcess=y;function p(r){let a=[],i=!1;const t=function(o){if(i){a.push(o);return}(!r.send(o,c=>{if(c&&console.error(c),i=!1,a.length>0){const h=a.slice(0);a=[],h.forEach(m=>t(m))}})||R.isWindows)&&(i=!0)};return{send:t}}e.createQueuedSender=p;var l;(function(r){async function a(i,t,o){if(A.isAbsolute(i))return i;if(t===void 0&&(t=b.cwd()),A.dirname(i)!=="."||(o===void 0&&I.isString(b.env.PATH)&&(o=b.env.PATH.split(A.delimiter)),o===void 0||o.length===0))return A.join(t,i);async function c(h){if(await f.Promises.exists(h)){let m;try{m=await f.Promises.stat(h)}catch(P){P.message.startsWith("EACCES")&&(m=await f.Promises.lstat(h))}return m?!m.isDirectory():!1}return!1}for(let h of o){let m;if(A.isAbsolute(h)?m=A.join(h,i):m=A.join(t,h,i),await c(m))return m;let P=m+".com";if(await c(P)||(P=m+".exe",await c(P)))return P}return A.join(t,i)}r.findExecutable=a})(l=e.win32||(e.win32={}))}),define(ne[123],ie([0,1,33,4,72,76]),function(J,e,D,n,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function A(S,u){return S===1?n.isWindows?C():T.getWindowsShell(u):E(S,u)}e.getSystemShell=A;function R(S,u){return S===1?n.isWindows?f(u):T.getWindowsShell(u):E(S,u)}e.getSystemShellSync=R;let b=null;function E(S,u){if(n.isLinux&&S===2||n.isMacintosh&&S===3)return"/bin/bash";if(!b){let v;if(n.isWindows)v="/bin/bash";else{if(v=u.SHELL,!v)try{v=(0,D.userInfo)().shell}catch{}v||(v="sh"),v==="/bin/false"&&(v="/bin/bash")}b=v}return b}let I=null;async function C(){return I||(I=(await(0,L.getFirstAvailablePowerShellInstallation)()).exePath),I}function f(S){if(I)return I;const u=n.isWindows&&parseFloat((0,D.release)())>=10,v=S.hasOwnProperty("PROCESSOR_ARCHITEW6432"),d=`${S.windir}\\${v?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return u?d:T.getWindowsShell(S)}}),define(ne[58],ie([0,1,45,5,17,23,107,9,3,2,28,76,36]),function(J,e,D,n,L,T,A,R,b,E,I,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class S extends f.ChannelServer{constructor(d){super({send:g=>{try{process.send&&process.send(g.buffer.toString("base64"))}catch{}},onMessage:b.Event.fromNodeEventEmitter(process,"message",g=>L.VSBuffer.wrap(Buffer.from(g,"base64")))},d);process.once("disconnect",()=>this.dispose())}}e.Server=S;class u{constructor(d,g){this.modulePath=d,this.options=g,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new b.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const w=g&&g.timeout?g.timeout:6e4;this.disposeDelayer=new n.Delayer(w),this.child=null,this._client=null}getChannel(d){const g=this;return{call(w,y,p){return g.requestPromise(d,w,y,p)},listen(w,y){return g.requestEvent(d,w,y)}}}requestPromise(d,g,w,y=T.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(y.isCancellationRequested)return Promise.reject(R.canceled());this.disposeDelayer.cancel();const p=this.getCachedChannel(d),l=(0,n.createCancelablePromise)(i=>p.call(g,w,i)),r=y.onCancellationRequested(()=>l.cancel()),a=(0,E.toDisposable)(()=>l.cancel());return this.activeRequests.add(a),l.finally(()=>{r.dispose(),this.activeRequests.delete(a),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),l}requestEvent(d,g,w){if(!this.disposeDelayer)return b.Event.None;this.disposeDelayer.cancel();let y;const p=new b.Emitter({onFirstListenerAdd:()=>{y=this.getCachedChannel(d).listen(g,w)(p.fire,p),this.activeRequests.add(y)},onLastListenerRemove:()=>{this.activeRequests.delete(y),y.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return p.event}get client(){if(!this._client){const d=this.options&&this.options.args?this.options.args:[],g=Object.create(null);g.env={...(0,I.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(g.env={...g.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(g.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(g.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(g.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),g.execArgv===void 0&&(g.execArgv=process.execArgv.filter(t=>!/^--inspect(-brk)?=/.test(t))),(0,C.removeDangerousEnvVariables)(g.env),this.child=(0,D.fork)(this.modulePath,d,g);const w=new b.Emitter;b.Event.fromNodeEventEmitter(this.child,"message",t=>t)(t=>{if((0,A.isRemoteConsoleLog)(t)){(0,A.log)(t,`IPC Library: ${this.options.serverName}`);return}w.fire(L.VSBuffer.wrap(Buffer.from(t,"base64")))});const p=this.options.useQueue?(0,C.createQueuedSender)(this.child):this.child,l=t=>this.child&&this.child.connected&&p.send(t.buffer.toString("base64")),r=w.event,a={send:l,onMessage:r};this._client=new f.ChannelClient(a);const i=()=>this.disposeClient();process.once("exit",i),this.child.on("error",t=>console.warn('IPC "'+this.options.serverName+'" errored with '+t)),this.child.on("exit",(t,o)=>{process.removeListener("exit",i),this.activeRequests.forEach(s=>(0,E.dispose)(s)),this.activeRequests.clear(),t!==0&&o!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+t+" and signal "+o),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:t,signal:o})})}return this._client}getCachedChannel(d){let g=this.channels.get(d);return g||(g=this.client.getChannel(d),this.channels.set(d,g)),g}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=u}),define(ne[124],ie([11,12]),function(J,e){return J.create("vs/base/node/zip",e)}),define(ne[125],ie([11,12]),function(J,e){return J.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ne[126],ie([11,12]),function(J,e){return J.create("vs/platform/environment/node/argv",e)}),define(ne[127],ie([11,12]),function(J,e){return J.create("vs/platform/environment/node/argvHelper",e)}),define(ne[128],ie([11,12]),function(J,e){return J.create("vs/platform/environment/node/shellEnv",e)}),define(ne[129],ie([11,12]),function(J,e){return J.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ne[130],ie([11,12]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ne[131],ie([11,12]),function(J,e){return J.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(ne[132],ie([11,12]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ne[133],ie([11,12]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ne[134],ie([11,12]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionsScanner",e)}),define(ne[135],ie([11,12]),function(J,e){return J.create("vs/platform/extensions/common/extensionValidator",e)}),define(ne[136],ie([11,12]),function(J,e){return J.create("vs/platform/files/common/fileService",e)}),define(ne[137],ie([11,12]),function(J,e){return J.create("vs/platform/files/common/files",e)}),define(ne[138],ie([11,12]),function(J,e){return J.create("vs/platform/files/common/io",e)}),define(ne[139],ie([11,12]),function(J,e){return J.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ne[140],ie([11,12]),function(J,e){return J.create("vs/platform/request/common/request",e)}),define(ne[141],ie([11,12]),function(J,e){return J.create("vs/platform/telemetry/common/telemetryService",e)}),define(ne[142],ie([11,12]),function(J,e){return J.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(ne[143],ie([11,12]),function(J,e){return J.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(ne[144],ie([11,12]),function(J,e){return J.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(ne[145],ie([11,12]),function(J,e){return J.create("vs/platform/userDataSync/common/settingsSync",e)}),define(ne[146],ie([11,12]),function(J,e){return J.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(ne[147],ie([11,12]),function(J,e){return J.create("vs/platform/userDataSync/common/userDataSync",e)}),define(ne[148],ie([11,12]),function(J,e){return J.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(ne[149],ie([0,1,4]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AssignmentFilterProvider=e.Filters=e.TargetPopulation=e.ASSIGNMENT_REFETCH_INTERVAL=e.ASSIGNMENT_STORAGE_KEY=void 0,e.ASSIGNMENT_STORAGE_KEY="VSCode.ABExp.FeatureData",e.ASSIGNMENT_REFETCH_INTERVAL=0;var n;(function(A){A.Team="team",A.Internal="internal",A.Insiders="insider",A.Public="public"})(n=e.TargetPopulation||(e.TargetPopulation={}));var L;(function(A){A.Market="X-MSEdge-Market",A.CorpNet="X-FD-Corpnet",A.ApplicationVersion="X-VSCode-AppVersion",A.Build="X-VSCode-Build",A.ClientId="X-MSEdge-ClientId",A.ExtensionName="X-VSCode-ExtensionName",A.Language="X-VSCode-Language",A.TargetPopulation="X-VSCode-TargetPopulation"})(L=e.Filters||(e.Filters={}));class T{constructor(R,b,E,I){this.version=R,this.appName=b,this.machineId=E,this.targetPopulation=I}getFilterValue(R){switch(R){case L.ApplicationVersion:return this.version;case L.Build:return this.appName;case L.ClientId:return this.machineId;case L.Language:return D.language;case L.ExtensionName:return"vscode-core";case L.TargetPopulation:return this.targetPopulation;default:return""}}getFilters(){let R=new Map,b=Object.values(L);for(let E of b)R.set(E,this.getFilterValue(E));return R}}e.AssignmentFilterProvider=T}),define(ne[77],ie([0,1,57,54,18,10,32,19,7]),function(J,e,D,n,L,T,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class E{constructor(v,d,g){this._args=v,this.paths=d,this.productService=g}get appRoot(){return(0,T.dirname)(L.FileAccess.asFileUri("",J).fsPath)}get userHome(){return b.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return b.URI.file((0,T.join)(this.userDataPath,"User"))}get tmpDir(){return b.URI.file(this.paths.tmpDir)}get cacheHome(){return b.URI.file(this.userDataPath)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,R.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,R.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const v=(0,D.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,T.join)(this.userDataPath,"logs",v)}return this.args.logsPath}get userDataSyncLogResource(){return b.URI.file((0,T.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,R.joinPath)(b.URI.file((0,T.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return b.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return b.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,R.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,R.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const v=A.env.VSCODE_PORTABLE;return v?b.URI.file((0,T.join)(v,"argv.json")):(0,R.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,R.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return b.URI.file((0,T.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,T.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const v=this.args["builtin-extensions-dir"];return v?(0,T.resolve)(v):(0,T.normalize)((0,T.join)(L.FileAccess.asFileUri("",J).fsPath,"..","extensions"))}get extensionsDownloadPath(){const v=this.args["extensions-download-dir"];return v?(0,T.resolve)(v):(0,T.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const v=this.args["extensions-dir"];if(v)return(0,T.resolve)(v);const d=A.env.VSCODE_EXTENSIONS;if(d)return d;const g=A.env.VSCODE_PORTABLE;return g?(0,T.join)(g,"extensions"):(0,R.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const v=this.args.extensionDevelopmentPath;if(Array.isArray(v))return v.map(d=>/^[^:/?#]+?:\/\//.test(d)?b.URI.parse(d):b.URI.file((0,T.normalize)(d)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(v=>v==="ui"||v==="workspace"||v==="web"?v:"workspace")}get extensionTestsLocationURI(){const v=this.args.extensionTestsPath;if(v)return/^[^:/?#]+?:\/\//.test(v)?b.URI.parse(v):b.URI.file((0,T.normalize)(v))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const v=this.args["disable-extension"];if(v){if(typeof v=="string")return[v];if(Array.isArray(v)&&v.length>0)return v}return!1}get debugExtensionHost(){return I(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!A.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,R.joinPath)(b.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return b.URI.file((0,T.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}de([n.memoize],E.prototype,"appRoot",null),de([n.memoize],E.prototype,"userHome",null),de([n.memoize],E.prototype,"userDataPath",null),de([n.memoize],E.prototype,"appSettingsHome",null),de([n.memoize],E.prototype,"tmpDir",null),de([n.memoize],E.prototype,"cacheHome",null),de([n.memoize],E.prototype,"userRoamingDataHome",null),de([n.memoize],E.prototype,"settingsResource",null),de([n.memoize],E.prototype,"userDataSyncHome",null),de([n.memoize],E.prototype,"userDataSyncLogResource",null),de([n.memoize],E.prototype,"sync",null),de([n.memoize],E.prototype,"machineSettingsResource",null),de([n.memoize],E.prototype,"globalStorageHome",null),de([n.memoize],E.prototype,"workspaceStorageHome",null),de([n.memoize],E.prototype,"keybindingsResource",null),de([n.memoize],E.prototype,"keyboardLayoutResource",null),de([n.memoize],E.prototype,"argvResource",null),de([n.memoize],E.prototype,"snippetsHome",null),de([n.memoize],E.prototype,"isExtensionDevelopment",null),de([n.memoize],E.prototype,"untitledWorkspacesHome",null),de([n.memoize],E.prototype,"installSourcePath",null),de([n.memoize],E.prototype,"builtinExtensionsPath",null),de([n.memoize],E.prototype,"extensionsPath",null),de([n.memoize],E.prototype,"extensionDevelopmentLocationURI",null),de([n.memoize],E.prototype,"extensionDevelopmentKind",null),de([n.memoize],E.prototype,"extensionTestsLocationURI",null),de([n.memoize],E.prototype,"debugExtensionHost",null),de([n.memoize],E.prototype,"serviceMachineIdResource",null),de([n.memoize],E.prototype,"telemetryLogResource",null),de([n.memoize],E.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=E;function I(u,v){return S(u["inspect-extensions"],u["inspect-brk-extensions"],5870,v,u.debugId,u.extensionEnvironment)}e.parseExtensionHostPort=I;function C(u,v){return S(u["inspect-search"],u["inspect-brk-search"],5876,v,u.extensionEnvironment)}e.parseSearchPort=C;function f(u,v){return S(u["inspect-ptyhost"],u["inspect-brk-ptyhost"],5877,v,u.extensionEnvironment)}e.parsePtyHostPort=f;function S(u,v,d,g,w,y){const l=Number(v||u)||(g?null:d),r=l?Boolean(!!v):!1;let a;if(y)try{a=JSON.parse(y)}catch{}return{port:l,break:r,debugId:w,env:a}}}),define(ne[150],ie([0,1,252,4,126]),function(J,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const T={o:(0,L.localize)(0,null),e:(0,L.localize)(1,null),t:(0,L.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,L.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,L.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,L.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,L.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,L.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,L.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,L.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,L.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,L.localize)(11,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,L.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,L.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,L.localize)(14,null)},category:{type:"string",cat:"e",description:(0,L.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:(0,L.localize)(16,null)},"pre-release":{type:"boolean",cat:"e",description:(0,L.localize)(17,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:(0,L.localize)(18,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:(0,L.localize)(19,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,L.localize)(20,null)},verbose:{type:"boolean",cat:"t",description:(0,L.localize)(21,null)},log:{type:"string",cat:"t",args:"level",description:(0,L.localize)(22,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,L.localize)(23,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,L.localize)(24,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,L.localize)(25,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:(0,L.localize)(26,null)},sync:{type:"string",cat:"t",description:(0,L.localize)(27,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,L.localize)(28,null)},"inspect-brk-extensions":{type:"string",deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,L.localize)(29,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,L.localize)(30,null)},"ms-enable-electron-run-as-node":{type:"boolean"},"max-memory":{type:"string",cat:"t",description:(0,L.localize)(31,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,L.localize)(32,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string"},"inspect-brk-ptyhost":{type:"string"},"inspect-search":{type:"string",deprecates:["debugSearch"]},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"]},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const A={onUnknownOption:()=>{},onMultipleValues:()=>{},onDeprecatedOption:()=>{}};function R(u,v,d=A){const g={},w=[],y=[];for(let a in v){const i=v[a];i.alias&&(g[a]=i.alias),i.type==="string"||i.type==="string[]"?(w.push(a),i.deprecates&&w.push(...i.deprecates)):i.type==="boolean"&&(y.push(a),i.deprecates&&y.push(...i.deprecates))}const p=D(u,{string:w,boolean:y,alias:g}),l={},r=p;l._=p._.map(a=>String(a)).filter(a=>a.length>0),delete r._;for(let a in v){const i=v[a];i.alias&&delete r[i.alias];let t=r[a];if(i.deprecates)for(const o of i.deprecates)r.hasOwnProperty(o)&&(t||(t=r[o],t&&d.onDeprecatedOption(o,i.deprecationMessage||(0,L.localize)(33,null))),delete r[o]);typeof t!="undefined"&&(i.type==="string[]"?t&&!Array.isArray(t)&&(t=[t]):i.type==="string"&&Array.isArray(t)&&(t=t.pop(),d.onMultipleValues(a,t)),l[a]=t,i.deprecationMessage&&d.onDeprecatedOption(a,i.deprecationMessage)),delete r[a]}for(let a in r)d.onUnknownOption(a);return l}e.parseArgs=R;function b(u,v){let d="";return v.args&&(Array.isArray(v.args)?d=` <${v.args.join("> <")}>`:d=` <${v.args}>`),v.alias?`-${v.alias} --${u}${d}`:`--${u}${d}`}function E(u,v){let d=0,g=[];for(const l in u){const r=u[l],a=b(l,r);d=Math.max(d,a.length),g.push([a,r.description])}let w=d+2+1;if(v-w<25)return g.reduce((l,r)=>l.concat([`  ${r[0]}`,`      ${r[1]}`]),[]);let y=v-w-1,p=[];for(const l of g){let r=l[0],a=C(l[1],y),i=I(w-r.length-2);p.push("  "+r+i+a[0]);for(let t=1;t<a.length;t++)p.push(I(w)+a[t])}return p}e.formatOptions=E;function I(u){return" ".repeat(u)}function C(u,v){let d=[];for(;u.length;){let g=u.length<v?u.length:u.lastIndexOf(" ",v),w=u.slice(0,g).trim();u=u.slice(g),d.push(w)}return d}function f(u,v,d,g,w){const y=process.stdout.isTTY&&process.stdout.columns||80,p=w?.noInputFiles!==!0?`[${(0,L.localize)(34,null)}...]`:"",l=[`${u} ${d}`];l.push(""),l.push(`${(0,L.localize)(35,null)}: ${v} [${(0,L.localize)(36,null)}]${p}`),l.push(""),w?.noPipe!==!0&&(n.isWindows?l.push((0,L.localize)(37,null,v)):l.push((0,L.localize)(38,null,v)),l.push(""));const r={};for(const a in g){const i=g[a];if(i.description&&i.cat){let t=r[i.cat];t||(r[i.cat]=t={}),t[a]=i}}for(let a in r){const i=a;let t=r[i];t&&(l.push(T[i]),l.push(...E(t,y)),l.push(""))}return l.join(`
`)}e.buildHelpMessage=f;function S(u,v){return`${u||(0,L.localize)(39,null)}
${v||(0,L.localize)(40,null)}
${process.arch}`}e.buildVersionMessage=S}),function(){"use strict";function J(e,D,n,L){function T(R){const b=A(R),E=[b];return e.isAbsolute(b)||E.unshift(L),e.resolve(...E)}function A(R){const b=process.env.VSCODE_PORTABLE;if(b)return e.join(b,"user-data");let E=process.env.VSCODE_APPDATA;if(E)return e.join(E,n);const I=R["user-data-dir"];if(I)return I;switch(process.platform){case"win32":if(E=process.env.APPDATA,!E){const C=process.env.USERPROFILE;if(typeof C!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");E=e.join(C,"AppData","Roaming")}break;case"darwin":E=e.join(D.homedir(),"Library","Application Support");break;case"linux":E=process.env.XDG_CONFIG_HOME||e.join(D.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(E,n)}return{getUserDataPath:T}}if(typeof define=="function")define(ne[151],ie([0,152,33,18,19,32]),function(e,D,n,L,T,A){const R=T.dirname(L.FileAccess.asFileUri("",e)),b=e.__$__nodeRequire(T.joinPath(R,"package.json").fsPath);return J(D,n,b.name,A.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),D=require("path"),n=require("os");module.exports=J(D,n,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ne[153],ie([0,1,33,77,151]),function(J,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class T extends n.AbstractNativeEnvironmentService{constructor(R,b){super(R,{homeDir:(0,D.homedir)(),tmpDir:(0,D.tmpdir)(),userDataDir:(0,L.getUserDataPath)(R)},b)}}e.NativeEnvironmentService=T}),define(ne[154],ie([0,1,7]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const n=/^([^@:]+@)?([^:]+):/,L=/^([^@:]+@)?([^:]+):(.+)$/,T=/^([^@]+@)?([^:]+)(:\d+)?$/,A=/([^@:.]+\.[^@:.]+)(:\d+)?$/,R=/^\s*url\s*=\s*(.+\S)\s*$/mg,b=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function E(d){const g=d.match(A);return g?g[1]:null}function I(d){if(d.indexOf("://")===-1){const g=d.match(n);return g?E(g[2]):null}try{const g=D.URI.parse(d);if(g.authority)return E(g.authority)}catch{}return null}function C(d,g){const w=new Set;let y;for(;y=R.exec(d);){const l=I(y[1]);l&&w.add(l)}const p=new Set(g);return Array.from(w).map(l=>p.has(l)?l:l.replace(b,"a"))}e.getDomainsOfRemotes=C;function f(d){const g=d.match(T);return g?g[2]:null}function S(d,g,w){return d&&g?(w&&g.endsWith(".git")&&(g=g.substr(0,g.length-4)),g.indexOf("/")===0?`${d}${g}`:`${d}/${g}`):null}function u(d,g){if(d.indexOf("://")===-1){const w=d.match(L);if(w)return S(w[2],w[3],g)}try{const w=D.URI.parse(d);if(w.authority)return S(f(w.authority),w.path,g)}catch{}return null}function v(d,g=!1){const w=[];let y;for(;y=R.exec(d);){const p=u(y[1],g);p&&w.push(p)}return w}e.getRemotes=v}),define(ne[155],ie([0,1,28]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;const n=/^%([\w\d.-]+)%$/i;function L(T,A){const R=b=>{if(typeof b!="string")return;const E=n.exec(b);if(!E)return;const I=A[E[1]]??b;return typeof I=="string"?I:typeof I.message=="string"?I.message:b};return(0,D.cloneAndChange)(T,R)}e.localizeManifest=L}),define(ne[156],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class D{constructor(T){this.channel=T}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(T,A,R,b){return this.channel.call("promptImportantExtensionsInstallNotification",[T,A,R,b])}promptWorkspaceRecommendations(T){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=D;class n{constructor(T){this.service=T}listen(T,A){throw new Error(`Event not found: ${A}`)}call(T,A,R){switch(A){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(R[0],R[1],R[2],R[3])}throw new Error(`Call not found: ${A}`)}}e.ExtensionRecommendationNotificationServiceChannel=n}),define(ne[78],ie([0,1,135]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const n=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,L=/^-(\d{4})(\d{2})(\d{2})$/;function T(f){return f=f.trim(),f==="*"||n.test(f)}e.isValidVersionStr=T;function A(f){if(!T(f))return null;if(f=f.trim(),f==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let S=f.match(n);return S?{hasCaret:S[1]==="^",hasGreaterEquals:S[1]===">=",majorBase:S[2]==="x"?0:parseInt(S[2],10),majorMustEqual:S[2]!=="x",minorBase:S[4]==="x"?0:parseInt(S[4],10),minorMustEqual:S[4]!=="x",patchBase:S[6]==="x"?0:parseInt(S[6],10),patchMustEqual:S[6]!=="x",preRelease:S[8]||null}:null}e.parseVersion=A;function R(f){if(!f)return null;let S=f.majorBase,u=f.majorMustEqual,v=f.minorBase,d=f.minorMustEqual,g=f.patchBase,w=f.patchMustEqual;f.hasCaret&&(S===0||(d=!1),w=!1);let y=0;if(f.preRelease){const p=L.exec(f.preRelease);if(p){const[,l,r,a]=p;y=Date.UTC(Number(l),Number(r)-1,Number(a))}}return{majorBase:S,majorMustEqual:u,minorBase:v,minorMustEqual:d,patchBase:g,patchMustEqual:w,isMinimum:f.hasGreaterEquals,notBefore:y}}e.normalizeVersion=R;function b(f,S,u){let v;typeof f=="string"?v=R(A(f)):v=f;let d;S instanceof Date?d=S.getTime():typeof S=="string"&&(d=new Date(S).getTime());let g;if(typeof u=="string"?g=R(A(u)):g=u,!v||!g)return!1;let w=v.majorBase,y=v.minorBase,p=v.patchBase,l=g.majorBase,r=g.minorBase,a=g.patchBase,i=g.notBefore,t=g.majorMustEqual,o=g.minorMustEqual,s=g.patchMustEqual;return g.isMinimum?w>l?!0:w<l?!1:y>r?!0:y<r||d&&d<i?!1:p>=a:(w===1&&l===0&&(!t||!o||!s)&&(l=1,r=0,a=0,t=!0,o=!1,s=!1),w<l?!1:w>l?!t:y<r?!1:y>r?!o:p<a?!1:p>a?!s:!(d&&d<i))}e.isValidVersion=b;function E(f,S,u,v){return u.isBuiltin||typeof u.main=="undefined"?!0:C(f,S,u.engines.vscode,v)}e.isValidExtensionVersion=E;function I(f,S,u){return f==="*"||C(S,u,f)}e.isEngineValid=I;function C(f,S,u,v=[]){let d=R(A(u));if(!d)return v.push(D.localize(0,null,u)),!1;if(d.majorBase===0){if(!d.majorMustEqual||!d.minorMustEqual)return v.push(D.localize(1,null,u)),!1}else if(!d.majorMustEqual)return v.push(D.localize(2,null,u)),!1;return b(f,S,d)?!0:(v.push(D.localize(3,null,f,u)),!1)}}),define(ne[51],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class D{constructor(L,T=[],A=!1){this.ctor=L,this.staticArguments=T,this.supportsDelayedInstantiation=A}}e.SyncDescriptor=D}),define(ne[79],ie([0,1,51]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const n=[];function L(A,R,b){R instanceof D.SyncDescriptor||(R=new D.SyncDescriptor(R,[],b)),n.push([A,R])}e.registerSingleton=L;function T(){return n}e.getSingletonServiceDescriptors=T}),define(ne[157],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class D{constructor(T){this.incoming=new Map,this.outgoing=new Map,this.data=T}}e.Node=D;class n{constructor(T){this._hashFn=T,this._nodes=new Map}roots(){const T=[];for(let A of this._nodes.values())A.outgoing.size===0&&T.push(A);return T}insertEdge(T,A){const R=this.lookupOrInsertNode(T),b=this.lookupOrInsertNode(A);R.outgoing.set(this._hashFn(A),b),b.incoming.set(this._hashFn(T),R)}removeNode(T){const A=this._hashFn(T);this._nodes.delete(A);for(let R of this._nodes.values())R.outgoing.delete(A),R.incoming.delete(A)}lookupOrInsertNode(T){const A=this._hashFn(T);let R=this._nodes.get(A);return R||(R=new D(T),this._nodes.set(A,R)),R}lookup(T){return this._nodes.get(this._hashFn(T))}isEmpty(){return this._nodes.size===0}toString(){let T=[];for(let[A,R]of this._nodes)T.push(`${A}, (incoming)[${[...R.incoming.keys()].join(", ")}], (outgoing)[${[...R.outgoing.keys()].join(",")}]`);return T.join(`
`)}findCycleSlow(){for(let[T,A]of this._nodes){const R=new Set([T]),b=this._findCycle(A,R);if(b)return b}}_findCycle(T,A){for(let[R,b]of T.outgoing){if(A.has(R))return[...A,R].join(" -> ");A.add(R);const E=this._findCycle(b,A);if(E)return E;A.delete(R)}}}e.Graph=n}),define(ne[6],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var D;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function R(b){return b[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=R})(D=e._util||(e._util={})),e.IInstantiationService=L("instantiationService");function n(A,R,b,E){R[D.DI_TARGET]===R?R[D.DI_DEPENDENCIES].push({id:A,index:b,optional:E}):(R[D.DI_DEPENDENCIES]=[{id:A,index:b,optional:E}],R[D.DI_TARGET]=R)}function L(A){if(D.serviceIds.has(A))return D.serviceIds.get(A);const R=function(b,E,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");n(R,b,I,!1)};return R.toString=()=>A,D.serviceIds.set(A,R),R}e.createDecorator=L;function T(A){return A}e.refineServiceDecorator=T}),define(ne[158],ie([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,D.createDecorator)("checksumService")}),define(ne[20],ie([0,1,15,7,6]),function(J,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,L.createDecorator)("configurationService");function T(d){return d&&typeof d=="object"&&(!d.overrideIdentifier||typeof d.overrideIdentifier=="string")&&(!d.resource||d.resource instanceof n.URI)}e.isConfigurationOverrides=T;function A(d){return d&&typeof d=="object"&&(!d.overrideIdentifiers||D.isArray(d.overrideIdentifiers))&&!d.overrideIdentifier&&(!d.resource||d.resource instanceof n.URI)}e.isConfigurationUpdateOverrides=A;var R;(function(d){d[d.USER=1]="USER",d[d.USER_LOCAL=2]="USER_LOCAL",d[d.USER_REMOTE=3]="USER_REMOTE",d[d.WORKSPACE=4]="WORKSPACE",d[d.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",d[d.DEFAULT=6]="DEFAULT",d[d.MEMORY=7]="MEMORY"})(R=e.ConfigurationTarget||(e.ConfigurationTarget={}));function b(d){switch(d){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=b;function E(d,g){const w=Object.create(null);for(let y in d)I(w,y,d[y],g);return w}e.toValuesTree=E;function I(d,g,w,y){const p=g.split("."),l=p.pop();let r=d;for(let a=0;a<p.length;a++){let i=p[a],t=r[i];switch(typeof t){case"undefined":t=r[i]=Object.create(null);break;case"object":break;default:y(`Ignoring ${g} as ${p.slice(0,a+1).join(".")} is ${JSON.stringify(t)}`);return}r=t}if(typeof r=="object"&&r!==null)try{r[l]=w}catch{y(`Ignoring ${g} as ${p.join(".")} is ${JSON.stringify(r)}`)}else y(`Ignoring ${g} as ${p.join(".")} is ${JSON.stringify(r)}`)}e.addToValueTree=I;function C(d,g){const w=g.split(".");f(d,w)}e.removeFromValueTree=C;function f(d,g){const w=g.shift();if(g.length===0){delete d[w];return}if(Object.keys(d).indexOf(w)!==-1){const y=d[w];typeof y=="object"&&!Array.isArray(y)&&(f(y,g),Object.keys(y).length===0&&delete d[w])}}function S(d,g,w){function y(r,a){let i=r;for(const t of a){if(typeof i!="object"||i===null)return;i=i[t]}return i}const p=g.split("."),l=y(d,p);return typeof l=="undefined"?w:l}e.getConfigurationValue=S;function u(d,g,w){Object.keys(g).forEach(y=>{y!=="__proto__"&&(y in d?D.isObject(d[y])&&D.isObject(g[y])?u(d[y],g[y],w):w&&(d[y]=g[y]):d[y]=g[y])})}e.merge=u;function v(d,g,w){const y=d.inspect(g),p=d.inspect(w);return typeof y.userValue!="undefined"||typeof y.workspaceValue!="undefined"||typeof y.workspaceFolderValue!="undefined"?y.value:typeof p.userValue!="undefined"||typeof p.workspaceValue!="undefined"||typeof p.workspaceFolderValue!="undefined"?p.value:y.defaultValue}e.getMigratedSettingValue=v}),define(ne[159],ie([0,1,4,27,6]),function(J,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const T=new Map;T.set("false",!1),T.set("true",!0),T.set("isMac",D.isMacintosh),T.set("isLinux",D.isLinux),T.set("isWindows",D.isWindows),T.set("isWeb",D.isWeb),T.set("isMacNative",D.isMacintosh&&!D.isWeb),T.set("isEdge",D.isEdge),T.set("isFirefox",D.isFirefox),T.set("isChrome",D.isChrome),T.set("isSafari",D.isSafari);const A=Object.prototype.hasOwnProperty;var R;(function(M){M[M.False=0]="False",M[M.True=1]="True",M[M.Defined=2]="Defined",M[M.Not=3]="Not",M[M.Equals=4]="Equals",M[M.NotEquals=5]="NotEquals",M[M.And=6]="And",M[M.Regex=7]="Regex",M[M.NotRegex=8]="NotRegex",M[M.Or=9]="Or",M[M.In=10]="In",M[M.NotIn=11]="NotIn",M[M.Greater=12]="Greater",M[M.GreaterEquals=13]="GreaterEquals",M[M.Smaller=14]="Smaller",M[M.SmallerEquals=15]="SmallerEquals"})(R=e.ContextKeyExprType||(e.ContextKeyExprType={}));class b{static false(){return C.INSTANCE}static true(){return f.INSTANCE}static has(k){return S.create(k)}static equals(k,U){return u.create(k,U)}static notEquals(k,U){return g.create(k,U)}static regex(k,U){return i.create(k,U)}static in(k,U){return v.create(k,U)}static not(k){return w.create(k)}static and(...k){return s.create(k,null)}static or(...k){return c.create(k,null,!0)}static greater(k,U){return p.create(k,U)}static greaterEquals(k,U){return l.create(k,U)}static smaller(k,U){return r.create(k,U)}static smallerEquals(k,U){return a.create(k,U)}static deserialize(k,U=!1){if(!!k)return this._deserializeOrExpression(k,U)}static _deserializeOrExpression(k,U){let N=k.split("||");return c.create(N.map(V=>this._deserializeAndExpression(V,U)),null,!0)}static _deserializeAndExpression(k,U){let N=k.split("&&");return s.create(N.map(V=>this._deserializeOne(V,U)),null)}static _deserializeOne(k,U){if(k=k.trim(),k.indexOf("!=")>=0){let N=k.split("!=");return g.create(N[0].trim(),this._deserializeValue(N[1],U))}if(k.indexOf("==")>=0){let N=k.split("==");return u.create(N[0].trim(),this._deserializeValue(N[1],U))}if(k.indexOf("=~")>=0){let N=k.split("=~");return i.create(N[0].trim(),this._deserializeRegexValue(N[1],U))}if(k.indexOf(" in ")>=0){let N=k.split(" in ");return v.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(k)){const N=k.split(">=");return l.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(k)){const N=k.split(">");return p.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(k)){const N=k.split("<=");return a.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(k)){const N=k.split("<");return r.create(N[0].trim(),N[1].trim())}return/^\!\s*/.test(k)?w.create(k.substr(1).trim()):S.create(k)}static _deserializeValue(k,U){if(k=k.trim(),k==="true")return!0;if(k==="false")return!1;let N=/^'([^']*)'$/.exec(k);return N?N[1].trim():k}static _deserializeRegexValue(k,U){if((0,n.isFalsyOrWhitespace)(k)){if(U)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let N=k.indexOf("/"),V=k.lastIndexOf("/");if(N===V||N<0){if(U)throw new Error(`bad regexp-value '${k}', missing /-enclosure`);return console.warn(`bad regexp-value '${k}', missing /-enclosure`),null}let $=k.slice(N+1,V),G=k[V+1]==="i"?"i":"";try{return new RegExp($,G)}catch(te){if(U)throw new Error(`bad regexp-value '${k}', parse error: ${te}`);return console.warn(`bad regexp-value '${k}', parse error: ${te}`),null}}}e.ContextKeyExpr=b;function E(M,k){const U=M?M.substituteConstants():void 0,N=k?k.substituteConstants():void 0;return!U&&!N?!0:!U||!N?!1:U.equals(N)}e.expressionsAreEqualWithConstantSubstitution=E;function I(M,k){return M.cmp(k)}class C{constructor(){this.type=0}cmp(k){return this.type-k.type}equals(k){return k.type===this.type}substituteConstants(){return this}evaluate(k){return!1}serialize(){return"false"}keys(){return[]}map(k){return this}negate(){return f.INSTANCE}}e.ContextKeyFalseExpr=C,C.INSTANCE=new C;class f{constructor(){this.type=1}cmp(k){return this.type-k.type}equals(k){return k.type===this.type}substituteConstants(){return this}evaluate(k){return!0}serialize(){return"true"}keys(){return[]}map(k){return this}negate(){return C.INSTANCE}}e.ContextKeyTrueExpr=f,f.INSTANCE=new f;class S{constructor(k,U){this.key=k,this.negated=U,this.type=2}static create(k,U=null){const N=T.get(k);return typeof N=="boolean"?N?f.INSTANCE:C.INSTANCE:new S(k,U)}cmp(k){return k.type!==this.type?this.type-k.type:m(this.key,k.key)}equals(k){return k.type===this.type?this.key===k.key:!1}substituteConstants(){const k=T.get(this.key);return typeof k=="boolean"?k?f.INSTANCE:C.INSTANCE:this}evaluate(k){return!!k.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(k){return k.mapDefined(this.key)}negate(){return this.negated||(this.negated=w.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=S;class u{constructor(k,U,N){this.key=k,this.value=U,this.negated=N,this.type=4}static create(k,U,N=null){if(typeof U=="boolean")return U?S.create(k,N):w.create(k,N);const V=T.get(k);return typeof V=="boolean"?U===(V?"true":"false")?f.INSTANCE:C.INSTANCE:new u(k,U,N)}cmp(k){return k.type!==this.type?this.type-k.type:P(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){const k=T.get(this.key);if(typeof k=="boolean"){const U=k?"true":"false";return this.value===U?f.INSTANCE:C.INSTANCE}return this}evaluate(k){return k.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(k){return k.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=g.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=u;class v{constructor(k,U){this.key=k,this.valueKey=U,this.type=10,this.negated=null}static create(k,U){return new v(k,U)}cmp(k){return k.type!==this.type?this.type-k.type:P(this.key,this.valueKey,k.key,k.valueKey)}equals(k){return k.type===this.type?this.key===k.key&&this.valueKey===k.valueKey:!1}substituteConstants(){return this}evaluate(k){const U=k.getValue(this.valueKey),N=k.getValue(this.key);return Array.isArray(U)?U.indexOf(N)>=0:typeof N=="string"&&typeof U=="object"&&U!==null?A.call(U,N):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(k){return k.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=d.create(this)),this.negated}}e.ContextKeyInExpr=v;class d{constructor(k){this._actual=k,this.type=11}static create(k){return new d(k)}cmp(k){return k.type!==this.type?this.type-k.type:this._actual.cmp(k._actual)}equals(k){return k.type===this.type?this._actual.equals(k._actual):!1}substituteConstants(){return this}evaluate(k){return!this._actual.evaluate(k)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(k){return new d(this._actual.map(k))}negate(){return this._actual}}e.ContextKeyNotInExpr=d;class g{constructor(k,U,N){this.key=k,this.value=U,this.negated=N,this.type=5}static create(k,U,N=null){if(typeof U=="boolean")return U?w.create(k,N):S.create(k,N);const V=T.get(k);return typeof V=="boolean"?U===(V?"true":"false")?C.INSTANCE:f.INSTANCE:new g(k,U,N)}cmp(k){return k.type!==this.type?this.type-k.type:P(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){const k=T.get(this.key);if(typeof k=="boolean"){const U=k?"true":"false";return this.value===U?C.INSTANCE:f.INSTANCE}return this}evaluate(k){return k.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(k){return k.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=u.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=g;class w{constructor(k,U){this.key=k,this.negated=U,this.type=3}static create(k,U=null){const N=T.get(k);return typeof N=="boolean"?N?C.INSTANCE:f.INSTANCE:new w(k,U)}cmp(k){return k.type!==this.type?this.type-k.type:m(this.key,k.key)}equals(k){return k.type===this.type?this.key===k.key:!1}substituteConstants(){const k=T.get(this.key);return typeof k=="boolean"?k?C.INSTANCE:f.INSTANCE:this}evaluate(k){return!k.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(k){return k.mapNot(this.key)}negate(){return this.negated||(this.negated=S.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=w;function y(M,k){if(typeof M=="string"){const U=parseFloat(M);isNaN(U)||(M=U)}return typeof M=="string"||typeof M=="number"?k(M):C.INSTANCE}class p{constructor(k,U,N){this.key=k,this.value=U,this.negated=N,this.type=12}static create(k,U,N=null){return y(U,V=>new p(k,V,N))}cmp(k){return k.type!==this.type?this.type-k.type:P(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(k){return k.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=a.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=p;class l{constructor(k,U,N){this.key=k,this.value=U,this.negated=N,this.type=13}static create(k,U,N=null){return y(U,V=>new l(k,V,N))}cmp(k){return k.type!==this.type?this.type-k.type:P(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(k){return k.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=r.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=l;class r{constructor(k,U,N){this.key=k,this.value=U,this.negated=N,this.type=14}static create(k,U,N=null){return y(U,V=>new r(k,V,N))}cmp(k){return k.type!==this.type?this.type-k.type:P(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(k){return k.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=l.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=r;class a{constructor(k,U,N){this.key=k,this.value=U,this.negated=N,this.type=15}static create(k,U,N=null){return y(U,V=>new a(k,V,N))}cmp(k){return k.type!==this.type?this.type-k.type:P(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(k){return k.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=p.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=a;class i{constructor(k,U){this.key=k,this.regexp=U,this.type=7,this.negated=null}static create(k,U){return new i(k,U)}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.key<k.key)return-1;if(this.key>k.key)return 1;const U=this.regexp?this.regexp.source:"",N=k.regexp?k.regexp.source:"";return U<N?-1:U>N?1:0}equals(k){if(k.type===this.type){const U=this.regexp?this.regexp.source:"",N=k.regexp?k.regexp.source:"";return this.key===k.key&&U===N}return!1}substituteConstants(){return this}evaluate(k){let U=k.getValue(this.key);return this.regexp?this.regexp.test(U):!1}serialize(){const k=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${k}`}keys(){return[this.key]}map(k){return k.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=t.create(this)),this.negated}}e.ContextKeyRegexExpr=i;class t{constructor(k){this._actual=k,this.type=8}static create(k){return new t(k)}cmp(k){return k.type!==this.type?this.type-k.type:this._actual.cmp(k._actual)}equals(k){return k.type===this.type?this._actual.equals(k._actual):!1}substituteConstants(){return this}evaluate(k){return!this._actual.evaluate(k)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(k){return new t(this._actual.map(k))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=t;function o(M){let k=null;for(let U=0,N=M.length;U<N;U++){const V=M[U].substituteConstants();if(M[U]!==V&&k===null){k=[];for(let $=0;$<U;$++)k[$]=M[$]}k!==null&&(k[U]=V)}return k===null?M:k}class s{constructor(k,U){this.expr=k,this.negated=U,this.type=6}static create(k,U){return s._normalizeArr(k,U)}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.expr.length<k.expr.length)return-1;if(this.expr.length>k.expr.length)return 1;for(let U=0,N=this.expr.length;U<N;U++){const V=I(this.expr[U],k.expr[U]);if(V!==0)return V}return 0}equals(k){if(k.type===this.type){if(this.expr.length!==k.expr.length)return!1;for(let U=0,N=this.expr.length;U<N;U++)if(!this.expr[U].equals(k.expr[U]))return!1;return!0}return!1}substituteConstants(){const k=o(this.expr);return k===this.expr?this:s.create(k,this.negated)}evaluate(k){for(let U=0,N=this.expr.length;U<N;U++)if(!this.expr[U].evaluate(k))return!1;return!0}static _normalizeArr(k,U){const N=[];let V=!1;for(const $ of k)if(!!$){if($.type===1){V=!0;continue}if($.type===0)return C.INSTANCE;if($.type===6){N.push(...$.expr);continue}N.push($)}if(N.length===0&&V)return f.INSTANCE;if(N.length!==0){if(N.length===1)return N[0];N.sort(I);for(let $=1;$<N.length;$++)N[$-1].equals(N[$])&&(N.splice($,1),$--);if(N.length===1)return N[0];for(;N.length>1;){const $=N[N.length-1];if($.type!==9)break;N.pop();const G=N.pop(),te=N.length===0,W=c.create($.expr.map(j=>s.create([j,G],null)),null,te);W&&(N.push(W),N.sort(I))}return N.length===1?N[0]:new s(N,U)}}serialize(){return this.expr.map(k=>k.serialize()).join(" && ")}keys(){const k=[];for(let U of this.expr)k.push(...U.keys());return k}map(k){return new s(this.expr.map(U=>U.map(k)),null)}negate(){if(!this.negated){const k=[];for(let U of this.expr)k.push(U.negate());this.negated=c.create(k,this,!0)}return this.negated}}class c{constructor(k,U){this.expr=k,this.negated=U,this.type=9}static create(k,U,N){return c._normalizeArr(k,U,N)}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.expr.length<k.expr.length)return-1;if(this.expr.length>k.expr.length)return 1;for(let U=0,N=this.expr.length;U<N;U++){const V=I(this.expr[U],k.expr[U]);if(V!==0)return V}return 0}equals(k){if(k.type===this.type){if(this.expr.length!==k.expr.length)return!1;for(let U=0,N=this.expr.length;U<N;U++)if(!this.expr[U].equals(k.expr[U]))return!1;return!0}return!1}substituteConstants(){const k=o(this.expr);return k===this.expr?this:c.create(k,this.negated,!1)}evaluate(k){for(let U=0,N=this.expr.length;U<N;U++)if(this.expr[U].evaluate(k))return!0;return!1}static _normalizeArr(k,U,N){let V=[],$=!1;if(k){for(let G=0,te=k.length;G<te;G++){const W=k[G];if(!!W){if(W.type===0){$=!0;continue}if(W.type===1)return f.INSTANCE;if(W.type===9){V=V.concat(W.expr);continue}V.push(W)}}if(V.length===0&&$)return C.INSTANCE;V.sort(I)}if(V.length!==0){if(V.length===1)return V[0];for(let G=1;G<V.length;G++)V[G-1].equals(V[G])&&(V.splice(G,1),G--);if(V.length===1)return V[0];if(N){for(let G=0;G<V.length;G++)for(let te=G+1;te<V.length;te++)_(V[G],V[te])&&(V.splice(te,1),te--);if(V.length===1)return V[0]}return new c(V,U)}}serialize(){return this.expr.map(k=>k.serialize()).join(" || ")}keys(){const k=[];for(let U of this.expr)k.push(...U.keys());return k}map(k){return new c(this.expr.map(U=>U.map(k)),null)}negate(){if(!this.negated){let k=[];for(let U of this.expr)k.push(U.negate());for(;k.length>1;){const U=k.shift(),N=k.shift(),V=[];for(const G of O(U))for(const te of O(N))V.push(s.create([G,te],null));const $=k.length===0;k.unshift(c.create(V,null,$))}this.negated=k[0]}return this.negated}}class h extends S{constructor(k,U,N){super(k,null);this._defaultValue=U,typeof N=="object"?h._info.push({...N,key:k}):N!==!0&&h._info.push({key:k,description:N,type:U!=null?typeof U:void 0})}static all(){return h._info.values()}bindTo(k){return k.createKey(this.key,this._defaultValue)}getValue(k){return k.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(k){return u.create(this.key,k)}notEqualsTo(k){return g.create(this.key,k)}}e.RawContextKey=h,h._info=[],e.IContextKeyService=(0,L.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function m(M,k){return M<k?-1:M>k?1:0}function P(M,k,U,N){return M<U?-1:M>U?1:k<N?-1:k>N?1:0}function _(M,k){if(k.type===6&&M.type!==9&&M.type!==6){for(const V of k.expr)if(M.equals(V))return!0}const U=M.negate(),N=O(U).concat(O(k));N.sort(I);for(let V=0;V<N.length;V++){const G=N[V].negate();for(let te=V+1;te<N.length;te++){const W=N[te];if(G.equals(W))return!0}}return!1}e.implies=_;function O(M){return M.type===9?M.expr:[M]}}),define(ne[80],ie([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,D.createDecorator)(e.ID);function n(L){return!!L.hostName&&!!L.errorMessage}e.isRemoteDiagnosticError=n}),define(ne[81],ie([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,D.createDecorator)("downloadService")}),define(ne[13],ie([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,D.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,D.refineServiceDecorator)(e.IEnvironmentService)}),define(ne[82],ie([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var n;(function(A){A[A.FILE=1]="FILE",A[A.WORKSPACE=2]="WORKSPACE",A[A.EXE=3]="EXE"})(n=e.RecommendationSource||(e.RecommendationSource={}));function L(A){switch(A){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=L;var T;(function(A){A.Ignored="ignored",A.Cancelled="cancelled",A.TooMany="toomany",A.IncompatibleWindow="incompatibleWindow",A.Accepted="reacted"})(T=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,D.createDecorator)("IExtensionRecommendationNotificationService")}),define(ne[14],ie([0,1,39,10,27,15,7,137,6]),function(J,e,D,n,L,T,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,b.createDecorator)("fileService");function E($){return $.create===!0}e.isFileOpenForWriteOptions=E;var I;(function($){$[$.Unknown=0]="Unknown",$[$.File=1]="File",$[$.Directory=2]="Directory",$[$.SymbolicLink=64]="SymbolicLink"})(I=e.FileType||(e.FileType={}));var C;(function($){$[$.Readonly=1]="Readonly"})(C=e.FilePermission||(e.FilePermission={}));var f;(function($){$[$.FileReadWrite=2]="FileReadWrite",$[$.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",$[$.FileReadStream=16]="FileReadStream",$[$.FileFolderCopy=8]="FileFolderCopy",$[$.PathCaseSensitive=1024]="PathCaseSensitive",$[$.Readonly=2048]="Readonly",$[$.Trash=4096]="Trash",$[$.FileWriteUnlock=8192]="FileWriteUnlock",$[$.FileAtomicRead=16384]="FileAtomicRead"})(f=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function S($){return!!($.capabilities&2)}e.hasReadWriteCapability=S;function u($){return!!($.capabilities&8)}e.hasFileFolderCopyCapability=u;function v($){return!!($.capabilities&4)}e.hasOpenReadWriteCloseCapability=v;function d($){return!!($.capabilities&16)}e.hasFileReadStreamCapability=d;function g($){return S($)?!!($.capabilities&16384):!1}e.hasFileAtomicReadCapability=g;var w;(function($){$.FileExists="EntryExists",$.FileNotFound="EntryNotFound",$.FileNotADirectory="EntryNotADirectory",$.FileIsADirectory="EntryIsADirectory",$.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",$.FileTooLarge="EntryTooLarge",$.FileWriteLocked="EntryWriteLocked",$.NoPermissions="NoPermissions",$.Unavailable="Unavailable",$.Unknown="Unknown"})(w=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class y extends Error{constructor(G,te){super(G);this.code=te}}e.FileSystemProviderError=y;function p($,G){const te=new y($.toString(),G);return r(te,G),te}e.createFileSystemProviderError=p;function l($){return $||p((0,R.localize)(0,null),w.Unknown)}e.ensureFileSystemProviderError=l;function r($,G){return $.name=G?`${G} (FileSystemError)`:"FileSystemError",$}e.markAsFileSystemProviderError=r;function a($){if(!$)return w.Unknown;if($ instanceof y)return $.code;const G=/^(.+) \(FileSystemError\)$/.exec($.name);if(!G)return w.Unknown;switch(G[1]){case w.FileExists:return w.FileExists;case w.FileIsADirectory:return w.FileIsADirectory;case w.FileNotADirectory:return w.FileNotADirectory;case w.FileNotFound:return w.FileNotFound;case w.FileExceedsMemoryLimit:return w.FileExceedsMemoryLimit;case w.FileTooLarge:return w.FileTooLarge;case w.FileWriteLocked:return w.FileWriteLocked;case w.NoPermissions:return w.NoPermissions;case w.Unavailable:return w.Unavailable}return w.Unknown}e.toFileSystemProviderErrorCode=a;function i($){if($ instanceof m)return $.fileOperationResult;switch(a($)){case w.FileNotFound:return 1;case w.FileIsADirectory:return 0;case w.FileNotADirectory:return 10;case w.FileWriteLocked:return 5;case w.NoPermissions:return 6;case w.FileExists:return 4;case w.FileExceedsMemoryLimit:return 9;case w.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=i;var t;(function($){$[$.CREATE=0]="CREATE",$[$.DELETE=1]="DELETE",$[$.MOVE=2]="MOVE",$[$.COPY=3]="COPY"})(t=e.FileOperation||(e.FileOperation={}));class o{constructor(G,te,W){this.resource=G,this.operation=te,this.target=W}isOperation(G){return this.operation===G}}e.FileOperationEvent=o;var s;(function($){$[$.UPDATED=0]="UPDATED",$[$.ADDED=1]="ADDED",$[$.DELETED=2]="DELETED"})(s=e.FileChangeType||(e.FileChangeType={}));class c{constructor(G,te){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=G;const W=new Map;for(const j of G){const K=W.get(j.type);switch(K?K.push([j.resource,j]):W.set(j.type,[[j.resource,j]]),j.type){case 1:this.rawAdded.push(j.resource);break;case 0:this.rawUpdated.push(j.resource);break;case 2:this.rawDeleted.push(j.resource);break}}for(const[j,K]of W)switch(j){case 1:this.added=D.TernarySearchTree.forUris(()=>te),this.added.fill(K);break;case 0:this.updated=D.TernarySearchTree.forUris(()=>te),this.updated.fill(K);break;case 2:this.deleted=D.TernarySearchTree.forUris(()=>te),this.deleted.fill(K);break}}contains(G,...te){return this.doContains(G,{includeChildren:!1},...te)}affects(G,...te){return this.doContains(G,{includeChildren:!0},...te)}doContains(G,te,...W){if(!G)return!1;const j=W.length>0;return!!((!j||W.includes(1))&&(this.added?.get(G)||te.includeChildren&&this.added?.findSuperstr(G))||(!j||W.includes(0))&&(this.updated?.get(G)||te.includeChildren&&this.updated?.findSuperstr(G))||(!j||W.includes(2))&&(this.deleted?.findSubstr(G)||te.includeChildren&&this.deleted?.findSuperstr(G)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=c;function h($,G,te){return!$||!G||$===G||G.length>$.length?!1:(G.charAt(G.length-1)!==n.sep&&(G+=n.sep),te?(0,L.startsWithIgnoreCase)($,G):$.indexOf(G)===0)}e.isParent=h;class m extends Error{constructor(G,te,W){super(G);this.fileOperationResult=te,this.options=W}}e.FileOperationError=m;class P extends m{constructor(G,te,W){super(G,2,W);this.stat=te}}e.NotModifiedSinceFileOperationError=P;var _;(function($){$[$.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",$[$.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",$[$.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",$[$.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",$[$.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",$[$.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",$[$.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",$[$.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",$[$.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",$[$.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",$[$.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",$[$.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(_=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var O;(function($){$[$.FILE=0]="FILE",$[$.FOLDER=1]="FOLDER",$[$.ROOT_FOLDER=2]="ROOT_FOLDER"})(O=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function M($){if(!(typeof $.size!="number"||typeof $.mtime!="number"))return $.mtime.toString(29)+$.size.toString(31)}e.etag=M;async function k($,G){if(!G.hasProvider(A.URI.from({scheme:$.scheme})))return new Promise(te=>{const W=G.onDidChangeFileSystemProviderRegistrations(j=>{j.scheme===$.scheme&&j.added&&(W.dispose(),te())})})}e.whenProviderRegistered=k,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class U{static formatSize(G){return(0,T.isNumber)(G)||(G=0),G<U.KB?(0,R.localize)(1,null,G.toFixed(0)):G<U.MB?(0,R.localize)(2,null,(G/U.KB).toFixed(2)):G<U.GB?(0,R.localize)(3,null,(G/U.MB).toFixed(2)):G<U.TB?(0,R.localize)(4,null,(G/U.GB).toFixed(2)):(0,R.localize)(5,null,(G/U.TB).toFixed(2))}}e.ByteSize=U,U.KB=1024,U.MB=U.KB*U.KB,U.GB=U.MB*U.KB,U.TB=U.GB*U.KB;var N;(function($){$[$.IA32=0]="IA32",$[$.OTHER=1]="OTHER"})(N=e.Arch||(e.Arch={}));function V($){return{maxFileSize:$===0?300*U.MB:16*U.GB,maxHeapSize:$===0?700*U.MB:2*700*U.MB}}e.getPlatformLimits=V});var Y=this&&this.__param||function(J,e){return function(D,n){e(D,n,J)}};define(ne[160],ie([0,1,83,40,14]),function(J,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let T=class{constructor(R){this.fileService=R}async checksum(R){const b=(await this.fileService.readFileStream(R)).value;return new Promise((E,I)=>{const C=(0,D.createHash)("md5");(0,n.listenStream)(b,{onData:f=>C.update(f.buffer),onError:f=>I(f),onEnd:()=>E(C.digest("base64").replace(/=+$/,""))})})}};T=de([Y(0,L.IFileService)],T),e.ChecksumService=T}),define(ne[161],ie([0,1,253,127,150,14]),function(J,e,D,n,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function A(f,S){const u={onUnknownOption:d=>{console.warn((0,n.localize)(0,null,d))},onMultipleValues:(d,g)=>{console.warn((0,n.localize)(1,null,d,g))},onDeprecatedOption:(d,g)=>{console.warn((0,n.localize)(2,null,d,g))}},v=(0,L.parseArgs)(f,L.OPTIONS,S?u:void 0);return v.goto&&v._.forEach(d=>D(/^(\w:)?[^:]+(:\d*){0,2}$/.test(d),(0,n.localize)(3,null))),v["max-memory"]&&D(parseInt(v["max-memory"])>=T.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${T.MIN_MAX_MEMORY_SIZE_MB} MB.`),v}function R(f){const S=f.findIndex(u=>!/^-/.test(u));if(S>-1)return[...f.slice(0,S),...f.slice(S+1)]}function b(f){let[,...S]=f;process.env.VSCODE_DEV&&(S=R(S)||[]);const u=!C(process.env);return A(S,u)}e.parseMainProcessArgv=b;function E(f){const[,,...S]=f;return A(S,!0)}e.parseCLIProcessArgv=E;function I(f,...S){const u=f.indexOf("--");return u===-1?f.push(...S):f.splice(u,0,...S),f}e.addArg=I;function C(f){return f.VSCODE_CLI==="1"}e.isLaunchedFromCli=C}),define(ne[162],ie([0,1,45,10,128,23,37,9,4,29,123,161,5]),function(J,e,D,n,L,T,A,R,b,E,I,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const S=1e4;let u;async function v(g,w,y){return w["force-disable-user-env"]?(g.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):b.isWindows?(g.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,C.isLaunchedFromCli)(y)&&!w["force-user-env"]?(g.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,C.isLaunchedFromCli)(y)?g.trace("resolveShellEnv(): running (--force-user-env)"):g.trace("resolveShellEnv(): running (macOS/Linux)"),u||(u=f.Promises.withAsyncBody(async(p,l)=>{const r=new T.CancellationTokenSource,a=setTimeout(()=>{r.dispose(!0),l(new Error((0,L.localize)(0,null)))},S);try{p(await d(g,r.token))}catch(i){!(0,R.isCancellationError)(i)&&!r.token.isCancellationRequested?l(new Error((0,L.localize)(1,null,(0,A.toErrorMessage)(i)))):p({})}finally{clearTimeout(a),r.dispose()}})),u)}e.getResolvedShellEnv=v;async function d(g,w){const y=process.env.ELECTRON_RUN_AS_NODE;g.trace("getUnixShellEnvironment#runAsNode",y);const p=process.env.ELECTRON_NO_ATTACH_CONSOLE;g.trace("getUnixShellEnvironment#noAttach",p);const l=(0,E.generateUuid)().replace(/-/g,"").substr(0,12),r=new RegExp(l+"(.*)"+l),a={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};g.trace("getUnixShellEnvironment#env",a);const i=await(0,I.getSystemShell)(b.OS,a);return g.trace("getUnixShellEnvironment#shell",i),new Promise((t,o)=>{if(w.isCancellationRequested)return o((0,R.canceled)());const s=(0,n.basename)(i);let c,h;const m=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(s)?(c=`& '${process.execPath}' ${m} -p '''${l}'' + JSON.stringify(process.env) + ''${l}'''`,h=["-Login","-Command"]):(c=`'${process.execPath}' ${m} -p '"${l}" + JSON.stringify(process.env) + "${l}"'`,s==="tcsh"?h=["-ic"]:h=["-ilc"]),g.trace("getUnixShellEnvironment#spawn",JSON.stringify(h),c);const P=(0,D.spawn)(i,[...h,c],{detached:!0,stdio:["ignore","pipe","pipe"],env:a});w.onCancellationRequested(()=>(P.kill(),o((0,R.canceled)()))),P.on("error",M=>{g.error("getUnixShellEnvironment#errorChildProcess",(0,A.toErrorMessage)(M)),o(M)});const _=[];P.stdout.on("data",M=>_.push(M));const O=[];P.stderr.on("data",M=>O.push(M)),P.on("close",(M,k)=>{const U=Buffer.concat(_).toString("utf8");g.trace("getUnixShellEnvironment#raw",U);const N=Buffer.concat(O).toString("utf8");if(N.trim()&&g.trace("getUnixShellEnvironment#stderr",N),M||k)return o(new Error((0,L.localize)(2,null,M,k)));const V=r.exec(U),$=V?V[1]:"{}";try{const G=JSON.parse($);y?G.ELECTRON_RUN_AS_NODE=y:delete G.ELECTRON_RUN_AS_NODE,p?G.ELECTRON_NO_ATTACH_CONSOLE=p:delete G.ELECTRON_NO_ATTACH_CONSOLE,delete G.XDG_RUNTIME_DIR,g.trace("getUnixShellEnvironment#result",G),t(G)}catch(G){g.error("getUnixShellEnvironment#errorCaught",(0,A.toErrorMessage)(G)),o(G)}})})}}),define(ne[163],ie([0,1,17,37,9,3,2,40,7,29,14]),function(J,e,D,n,L,T,A,R,b,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class C extends A.Disposable{constructor(S,u){super();this.channel=S,this.extraCapabilities=u,this.onDidChangeCapabilities=T.Event.None,this._onDidChange=this._register(new T.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new T.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,E.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(S){return this.channel.call("stat",[S])}readdir(S){return this.channel.call("readdir",[S])}async readFile(S,u){const{buffer:v}=await this.channel.call("readFile",[S,u]);return v}readFileStream(S,u,v){const d=(0,R.newWriteableStream)(w=>D.VSBuffer.concat(w.map(y=>D.VSBuffer.wrap(y))).buffer),g=this.channel.listen("readFileStream",[S,u])(w=>{if(w instanceof D.VSBuffer)d.write(w.buffer);else{if(w==="end")d.end();else{let y=w;y instanceof Error||(y=(0,I.createFileSystemProviderError)((0,n.toErrorMessage)(y),I.FileSystemProviderErrorCode.Unknown)),d.error(y),d.end()}g.dispose()}});return v.onCancellationRequested(()=>{d.error((0,L.canceled)()),d.end(),g.dispose()}),d}writeFile(S,u,v){return this.channel.call("writeFile",[S,D.VSBuffer.wrap(u),v])}open(S,u){return this.channel.call("open",[S,u])}close(S){return this.channel.call("close",[S])}async read(S,u,v,d,g){const[w,y]=await this.channel.call("read",[S,u,g]);return v.set(w.buffer.slice(0,y),d),y}write(S,u,v,d,g){return this.channel.call("write",[S,u,D.VSBuffer.wrap(v),d,g])}mkdir(S){return this.channel.call("mkdir",[S])}delete(S,u){return this.channel.call("delete",[S,u])}rename(S,u,v){return this.channel.call("rename",[S,u,v])}copy(S,u,v){return this.channel.call("copy",[S,u,v])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(S=>{if(Array.isArray(S)){const u=S;this._onDidChange.fire(u.map(v=>({resource:b.URI.revive(v.resource),type:v.type})))}else{const u=S;this._onDidWatchError.fire(u)}}))}watch(S,u){const v=(0,E.generateUuid)();return this.channel.call("watch",[this.sessionId,v,S,u]),(0,A.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,v]))}}e.DiskFileSystemProviderClient=C}),define(ne[84],ie([0,1,17,9,138,14]),function(J,e,D,n,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function A(I,C,f,S,u,v){let d;try{await R(I,C,f,S,u,v)}catch(g){d=g}finally{d&&u.errorTransformer&&(d=u.errorTransformer(d)),typeof d!="undefined"&&f.error(d),f.end()}}e.readFileIntoStream=A;async function R(I,C,f,S,u,v){b(v);const d=await I.open(C,{create:!1});try{b(v);let g=0,w=0,y=u&&typeof u.length=="number"?u.length:void 0,p=D.VSBuffer.alloc(Math.min(u.bufferSize,typeof y=="number"?y:u.bufferSize)),l=u&&typeof u.position=="number"?u.position:0,r=0;do w=await I.read(d,l,p.buffer,r,p.byteLength-r),l+=w,r+=w,g+=w,typeof y=="number"&&(y-=w),r===p.byteLength&&(await f.write(S(p)),p=D.VSBuffer.alloc(Math.min(u.bufferSize,typeof y=="number"?y:u.bufferSize)),r=0);while(w>0&&(typeof y!="number"||y>0)&&b(v)&&E(g,u));if(r>0){let a=r;typeof y=="number"&&(a=Math.min(r,y)),f.write(S(p.slice(0,a)))}}catch(g){throw(0,T.ensureFileSystemProviderError)(g)}finally{await I.close(d)}}function b(I){if(I.isCancellationRequested)throw(0,n.canceled)();return!0}function E(I,C){if(C?.limits){if(typeof C.limits.memory=="number"&&I>C.limits.memory)throw(0,T.createFileSystemProviderError)((0,L.localize)(0,null),T.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof C.limits.size=="number"&&I>C.limits.size)throw(0,T.createFileSystemProviderError)((0,L.localize)(1,null),T.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(ne[52],ie([0,1,2,4,7,14]),function(J,e,D,n,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function A(S){return S.recursive===!0}e.isRecursiveWatchRequest=A;class R extends D.Disposable{constructor(u,v,d,g){super();this.onFileChanges=u,this.onLogMessage=v,this.verboseLogging=d,this.options=g,this.watcherDisposables=this._register(new D.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const u=new D.DisposableStore;this.watcherDisposables.value=u,this.watcher=this.createWatcher(u),this.watcher.setVerboseLogging(this.verboseLogging),u.add(this.watcher.onDidChangeFile(v=>this.onFileChanges(v))),u.add(this.watcher.onDidLogMessage(v=>this.onLogMessage(v))),u.add(this.watcher.onDidError(v=>this.onError(v)))}onError(u){this.options.restartOnError?this.restartCounter<R.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${u}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${u}`):this.error(u)}restart(u){this.restartCounter++,this.init(),this.watch(u)}async watch(u){this.requests=u,await this.watcher?.watch(u)}async setVerboseLogging(u){this.verboseLogging=u,await this.watcher?.setVerboseLogging(u)}error(u){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${u}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=R,R.MAX_RESTARTS=5;class b extends R{constructor(u,v,d){super(u,v,d,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=b;class E extends R{constructor(u,v,d){super(u,v,d,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=E;function I(S){return S.map(u=>({type:u.type,resource:L.URI.file(u.path)}))}e.toFileChanges=I;function C(S){const u=new f;for(const v of S)u.processEvent(v);return u.coalesce()}e.coalesceEvents=C;class f{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(u){return n.isLinux?u.path:u.path.toLowerCase()}processEvent(u){const v=this.mapPathToChange.get(this.toKey(u));let d=!1;if(v){const g=v.type,w=u.type;v.path!==u.path&&(u.type===2||u.type===1)?d=!0:g===1&&w===2?(this.mapPathToChange.delete(this.toKey(u)),this.coalesced.delete(v)):g===2&&w===1?v.type=0:g===1&&w===0||(v.type=w)}else d=!0;d&&(this.coalesced.add(u),this.mapPathToChange.set(this.toKey(u),u))}coalesce(){const u=[],v=[];return Array.from(this.coalesced).filter(d=>d.type!==2?(u.push(d),!1):!0).sort((d,g)=>d.path.length-g.path.length).filter(d=>v.some(g=>(0,T.isParent)(d.path,g,!n.isLinux))?!1:(v.push(d.path),!0)).concat(u)}}}),define(ne[164],ie([0,1,50,5,23,41,109,2,71,10,4,114,22,52]),function(J,e,D,n,L,T,A,R,b,E,I,C,f,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class u extends R.Disposable{constructor(g,w,y,p){super();this.request=g,this.onDidFilesChange=w,this.onLogMessage=y,this.verboseLogging=p,this.throttledFileChangesWorker=new n.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},l=>this.onDidFilesChange(l)),this.fileChangesDelayer=this._register(new n.ThrottledDelayer(u.FILE_CHANGES_HANDLER_DELAY)),this.fileChangesBuffer=[],this.excludes=this.request.excludes.map(l=>(0,A.parse)(l)),this.cts=new L.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const g=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const w=await f.Promises.stat(g);this._register(await this.doWatch(g,w.isDirectory()))}catch(g){g.code!=="ENOENT"?this.error(g):this.trace(g)}}async normalizePath(g){let w=g.path;try{w=await f.Promises.realpath(g.path),g.path===w&&(w=await(0,C.realcase)(g.path)??g.path),g.path!==w&&this.warn(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${g.path}, real: ${w})`)}catch{}return w}async doWatch(g,w){if(I.isMacintosh&&(0,T.isEqualOrParent)(g,"/Volumes/",!0))return this.error(`Refusing to watch ${g} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),R.Disposable.None;const y=new L.CancellationTokenSource(this.cts.token);let p=new R.DisposableStore;try{const l=(0,E.basename)(g),r=(0,D.watch)(g);p.add((0,R.toDisposable)(()=>{r.removeAllListeners(),r.close()})),this.trace(`Started watching: '${g}'`);const a=new Set;if(w)try{for(const t of await f.Promises.readdir(g))a.add(t)}catch(t){this.error(t)}const i=new Map;p.add((0,R.toDisposable)(()=>{for(const[,t]of i)t.dispose();i.clear()})),r.on("error",(t,o)=>{this.error(`Failed to watch ${g} for changes using fs.watch() (${t}, ${o})`),this.dispose()}),r.on("change",(t,o)=>{if(y.token.isCancellationRequested)return;this.trace(`[raw] ["${t}"] ${o}`);let s="";if(o&&(s=o.toString(),I.isMacintosh&&(s=(0,b.normalizeNFC)(s))),!(!s||t!=="change"&&t!=="rename"))if(w)if(t==="rename"){i.get(s)?.dispose();const c=setTimeout(async()=>{if(i.delete(s),s===l&&!await f.Promises.exists(g)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const h=await this.existsChildStrictCase((0,E.join)(g,s));if(y.token.isCancellationRequested)return;let m;h?a.has(s)?m=0:(m=1,a.add(s)):(a.delete(s),m=2),this.onFileChange({path:(0,E.join)(this.request.path,s),type:m})},u.FILE_DELETE_HANDLER_DELAY);i.set(s,(0,R.toDisposable)(()=>clearTimeout(c)))}else{let c;a.has(s)?c=0:(c=1,a.add(s)),this.onFileChange({path:(0,E.join)(this.request.path,s),type:c})}else if(t==="rename"||s!==l){const c=setTimeout(async()=>{const h=await f.Promises.exists(g);y.token.isCancellationRequested||(h?(this.onFileChange({path:this.request.path,type:0},!0),p.add(await this.doWatch(g,!1))):(await this.onFileChange({path:this.request.path,type:2},!0),this.dispose()))},u.FILE_DELETE_HANDLER_DELAY);p.clear(),p.add((0,R.toDisposable)(()=>clearTimeout(c)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(l){await f.Promises.exists(g)&&!y.token.isCancellationRequested&&this.error(`Failed to watch ${g} for changes using fs.watch() (${l.toString()})`)}return(0,R.toDisposable)(()=>{y.dispose(!0),p.dispose()})}async onFileChange(g,w=!1){if(!this.cts.token.isCancellationRequested){this.verboseLogging&&this.trace(`${g.type===1?"[ADDED]":g.type===2?"[DELETED]":"[CHANGED]"} ${g.path}`),!w&&this.excludes.some(y=>y(g.path))?this.verboseLogging&&this.trace(` >> ignored ${g.path}`):this.fileChangesBuffer.push(g);try{await this.fileChangesDelayer.trigger(async()=>{const y=this.fileChangesBuffer;this.fileChangesBuffer=[];const p=(0,S.coalesceEvents)(y);if(p.length>0){if(this.verboseLogging)for(const r of p)this.trace(`>> normalized ${r.type===1?"[ADDED]":r.type===2?"[DELETED]":"[CHANGED]"} ${r.path}`);this.throttledFileChangesWorker.work(p)?this.throttledFileChangesWorker.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesWorker.pending}, most recent change: ${p[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${p.length}, most recent change: ${p[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}})}catch{}}}async existsChildStrictCase(g){if(I.isLinux)return f.Promises.exists(g);try{const w=(0,E.basename)(g);return(await f.Promises.readdir((0,E.dirname)(g))).some(p=>p===w)}catch(w){return this.trace(w),!1}}setVerboseLogging(g){this.verboseLogging=g}error(g){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${g}`})}warn(g){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${g}`})}trace(g){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${g}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=u,u.FILE_DELETE_HANDLER_DELAY=100,u.FILE_CHANGES_HANDLER_DELAY=50;async function v(d,g,w,y,p=512){const l=await f.Promises.open(d,"r"),r=Buffer.allocUnsafe(p),a=new L.CancellationTokenSource(y);let i,t=!1;const o={path:d,excludes:[],recursive:!1},s=new u(o,c=>{(async()=>{for(const{type:h}of c)if(h===0){if(t)return;t=!0;try{for(;!a.token.isCancellationRequested;){const{bytesRead:m}=await f.Promises.read(l,r,0,p,null);if(!m||a.token.isCancellationRequested)break;g(r.slice(0,m))}}catch(m){i=new Error(m),a.dispose(!0)}finally{t=!1}}})()});return await s.ready,w(),new Promise((c,h)=>{a.token.onCancellationRequested(async()=>{s.dispose();try{await f.Promises.close(l)}catch(m){i=new Error(m)}i?h(i):c()})})}e.watchFileContents=v}),define(ne[165],ie([0,1,16,3,2,4,164]),function(J,e,D,n,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class R extends L.Disposable{constructor(){super(...arguments);this._onDidChangeFile=this._register(new n.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new n.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=n.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(E){const I=this.normalizeRequests(E),C=I.filter(S=>{const u=this.watchers.get(S.path);return u?!(0,D.equals)(u.request.excludes,S.excludes):!0}),f=Array.from(this.watchers.values()).filter(({request:S})=>!I.find(u=>u.path===S.path&&(0,D.equals)(u.excludes,S.excludes))).map(({request:S})=>S.path);C.length&&this.trace(`Request to start watching: ${C.map(S=>`${S.path} (excludes: ${S.excludes.length>0?S.excludes:"<none>"})`).join(",")}`),f.length&&this.trace(`Request to stop watching: ${f.join(",")}`);for(const S of f)this.stopWatching(S);for(const S of C)this.startWatching(S)}startWatching(E){const I=new A.NodeJSFileWatcherLibrary(E,f=>this._onDidChangeFile.fire(f),f=>this._onDidLogMessage.fire(f),this.verboseLogging),C={request:E,instance:I};this.watchers.set(E.path,C)}async stop(){for(const[E]of this.watchers)this.stopWatching(E);this.watchers.clear()}stopWatching(E){const I=this.watchers.get(E);I&&(this.watchers.delete(E),I.instance.dispose())}normalizeRequests(E){const I=new Map;for(const C of E){const f=T.isLinux?C.path:C.path.toLowerCase();I.set(f,C)}return Array.from(I.values())}async setVerboseLogging(E){this.verboseLogging=E;for(const[,I]of this.watchers)I.instance.setVerboseLogging(E)}trace(E){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(E)})}toMessage(E,I){return I?`[File Watcher (node.js)] ${E} (path: ${I.request.path})`:`[File Watcher (node.js)] ${E}`}}e.NodeJSWatcher=R}),define(ne[166],ie([0,1,52,165]),function(J,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class L extends D.AbstractNonRecursiveWatcherClient{constructor(A,R,b){super(A,R,b);this.init()}createWatcher(){return new n.NodeJSWatcher}}e.NodeJSWatcherClient=L}),define(ne[167],ie([0,1,18,36,58,52]),function(J,e,D,n,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class A extends T.AbstractUniversalWatcherClient{constructor(b,E,I){super(b,E,I);this.init()}createWatcher(b){const E=b.add(new L.Client(D.FileAccess.asFileUri("bootstrap-fork",J).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return b.add(E.onDidProcessExit(({code:I,signal:C})=>this.onError(`terminated by itself with code ${I}, signal: ${C}`))),n.ProxyChannel.toService((0,n.getNextTickChannel)(E.getChannel("watcher")))}}e.UniversalWatcherClient=A}),define(ne[85],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class D{constructor(...L){this._entries=new Map;for(let[T,A]of L)this.set(T,A)}set(L,T){const A=this._entries.get(L);return this._entries.set(L,T),A}has(L){return this._entries.has(L)}get(L){return this._entries.get(L)}}e.ServiceCollection=D}),define(ne[168],ie([0,1,5,9,51,157,6,85]),function(J,e,D,n,L,T,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const b=!1;class E extends Error{constructor(u){super("cyclic dependency between services");this.message=u.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${u.toString()}`}}class I{constructor(u=new R.ServiceCollection,v=!1,d){this._activeInstantiations=new Set,this._services=u,this._strict=v,this._parent=d,this._services.set(A.IInstantiationService,this)}createChild(u){return new I(u,this._strict,this)}invokeFunction(u,...v){let d=f.traceInvocation(u),g=!1;try{return u({get:y=>{if(g)throw(0,n.illegalState)("service accessor is only valid during the invocation of its target method");const p=this._getOrCreateServiceInstance(y,d);if(!p)throw new Error(`[invokeFunction] unknown service '${y}'`);return p}},...v)}finally{g=!0,d.stop()}}createInstance(u,...v){let d,g;return u instanceof L.SyncDescriptor?(d=f.traceCreation(u.ctor),g=this._createInstance(u.ctor,u.staticArguments.concat(v),d)):(d=f.traceCreation(u),g=this._createInstance(u,v,d)),d.stop(),g}_createInstance(u,v=[],d){let g=A._util.getServiceDependencies(u).sort((p,l)=>p.index-l.index),w=[];for(const p of g){let l=this._getOrCreateServiceInstance(p.id,d);if(!l&&this._strict&&!p.optional)throw new Error(`[createInstance] ${u.name} depends on UNKNOWN service ${p.id}.`);w.push(l)}let y=g.length>0?g[0].index:v.length;if(v.length!==y){console.warn(`[createInstance] First service dependency of ${u.name} at position ${y+1} conflicts with ${v.length} static arguments`);let p=y-v.length;p>0?v=v.concat(new Array(p)):v=v.slice(0,y)}return new u(...[...v,...w])}_setServiceInstance(u,v){if(this._services.get(u)instanceof L.SyncDescriptor)this._services.set(u,v);else if(this._parent)this._parent._setServiceInstance(u,v);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(u){let v=this._services.get(u);return!v&&this._parent?this._parent._getServiceInstanceOrDescriptor(u):v}_getOrCreateServiceInstance(u,v){let d=this._getServiceInstanceOrDescriptor(u);return d instanceof L.SyncDescriptor?this._safeCreateAndCacheServiceInstance(u,d,v.branch(u,!0)):(v.branch(u,!1),d)}_safeCreateAndCacheServiceInstance(u,v,d){if(this._activeInstantiations.has(u))throw new Error(`illegal state - RECURSIVELY instantiating service '${u}'`);this._activeInstantiations.add(u);try{return this._createAndCacheServiceInstance(u,v,d)}finally{this._activeInstantiations.delete(u)}}_createAndCacheServiceInstance(u,v,d){const g=new T.Graph(p=>p.id.toString());let w=0;const y=[{id:u,desc:v,_trace:d}];for(;y.length;){const p=y.pop();if(g.lookupOrInsertNode(p),w++>1e3)throw new E(g);for(let l of A._util.getServiceDependencies(p.desc.ctor)){let r=this._getServiceInstanceOrDescriptor(l.id);if(!r&&!l.optional&&console.warn(`[createInstance] ${u} depends on ${l.id} which is NOT registered.`),r instanceof L.SyncDescriptor){const a={id:l.id,desc:r,_trace:p._trace.branch(l.id,!0)};g.insertEdge(p,a),y.push(a)}}}for(;;){const p=g.roots();if(p.length===0){if(!g.isEmpty())throw new E(g);break}for(const{data:l}of p){if(this._getServiceInstanceOrDescriptor(l.id)instanceof L.SyncDescriptor){const a=this._createServiceInstanceWithOwner(l.id,l.desc.ctor,l.desc.staticArguments,l.desc.supportsDelayedInstantiation,l._trace);this._setServiceInstance(l.id,a)}g.removeNode(l)}}return this._getServiceInstanceOrDescriptor(u)}_createServiceInstanceWithOwner(u,v,d=[],g,w){if(this._services.get(u)instanceof L.SyncDescriptor)return this._createServiceInstance(v,d,g,w);if(this._parent)return this._parent._createServiceInstanceWithOwner(u,v,d,g,w);throw new Error(`illegalState - creating UNKNOWN service instance ${v.name}`)}_createServiceInstance(u,v=[],d,g){if(d){const w=new D.IdleValue(()=>this._createInstance(u,v,g));return new Proxy(Object.create(null),{get(y,p){if(p in y)return y[p];let l=w.value,r=l[p];return typeof r!="function"||(r=r.bind(l),y[p]=r),r},set(y,p,l){return w.value[p]=l,!0}})}else return this._createInstance(u,v,g)}}e.InstantiationService=I;var C;(function(S){S[S.Creation=0]="Creation",S[S.Invocation=1]="Invocation",S[S.Branch=2]="Branch"})(C||(C={}));class f{constructor(u,v){this.type=u,this.name=v,this._start=Date.now(),this._dep=[]}static traceInvocation(u){return b?new f(1,u.name||u.toString().substring(0,42).replace(/\n/g,"")):f._None}static traceCreation(u){return b?new f(0,u.name):f._None}branch(u,v){let d=new f(2,u.toString());return this._dep.push([u,v,d]),d}stop(){let u=Date.now()-this._start;f._totals+=u;let v=!1;function d(w,y){let p=[],l=new Array(w+1).join("	");for(const[r,a,i]of y._dep)if(a&&i){v=!0,p.push(`${l}CREATES -> ${r}`);let t=d(w+1,i);t&&p.push(t)}else p.push(`${l}uses -> ${r}`);return p.join(`
`)}let g=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${d(1,this)}`,`DONE, took ${u.toFixed(2)}ms (grand total ${f._totals.toFixed(2)}ms)`];(u>2||v)&&console.log(g.join(`
`))}}e.Trace=f,f._None=new class extends f{constructor(){super(-1,null)}stop(){}branch(){return this}},f._totals=0}),define(ne[169],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class D{constructor(L,T){this.server=L,this.router=T}getChannel(L){return this.server.getChannel(L,this.router)}registerChannel(L,T){this.server.registerChannel(L,T)}}e.MessagePortMainProcessService=D}),define(ne[170],ie([0,1,36,51,79,6]),function(J,e,D,n,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class A{constructor(S,u,v){const d=v.getChannel(S);return R(u)?new u.channelClientCtor(d):D.ProxyChannel.toService(d,u?.proxyOptions)}}function R(f){return!!f?.channelClientCtor}e.IMainProcessService=(0,T.createDecorator)("mainProcessService");let b=class extends A{constructor(S,u,v){super(S,u,v)}};b=de([Y(2,e.IMainProcessService)],b);function E(f,S,u){(0,L.registerSingleton)(f,new n.SyncDescriptor(b,[S,u],u?.supportsDelayedInstantiation))}e.registerMainProcessRemoteService=E,e.ISharedProcessService=(0,T.createDecorator)("sharedProcessService");let I=class extends A{constructor(S,u,v){super(S,u,v)}};I=de([Y(2,e.ISharedProcessService)],I);function C(f,S,u){(0,L.registerSingleton)(f,new n.SyncDescriptor(I,[S,u],u?.supportsDelayedInstantiation))}e.registerSharedProcessRemoteService=C}),define(ne[59],ie([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidLocalization=e.ILocalizationsService=void 0,e.ILocalizationsService=(0,D.createDecorator)("localizationsService");function n(L){if(typeof L.languageId!="string"||!Array.isArray(L.translations)||L.translations.length===0)return!1;for(const T of L.translations)if(typeof T.id!="string"||typeof T.path!="string")return!1;return!(L.languageName&&typeof L.languageName!="string"||L.localizedLanguageName&&typeof L.localizedLanguageName!="string")}e.isValidLocalization=n}),define(ne[171],ie([0,1,2,59]),function(J,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let L=class extends D.Disposable{constructor(A){super();this.localizationsService=A,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};L=de([Y(0,n.ILocalizationsService)],L),e.LocalizationsUpdater=L}),define(ne[8],ie([0,1,37,3,2,4,6]),function(J,e,D,n,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,A.createDecorator)("logService"),e.ILoggerService=(0,A.createDecorator)("loggerService");function R(){return new Date().toISOString()}var b;(function(a){a[a.Trace=0]="Trace",a[a.Debug=1]="Debug",a[a.Info=2]="Info",a[a.Warning=3]="Warning",a[a.Error=4]="Error",a[a.Critical=5]="Critical",a[a.Off=6]="Off"})(b=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=b.Info;function E(a,i,t){switch(i){case b.Trace:a.trace(t);break;case b.Debug:a.debug(t);break;case b.Info:a.info(t);break;case b.Warning:a.warn(t);break;case b.Error:a.error(t);break;case b.Critical:a.critical(t);break;default:throw new Error("Invalid log level")}}e.log=E;function I(a){let i="";for(let t=0;t<a.length;t++){let o=a[t];if(typeof o=="object")try{o=JSON.stringify(o)}catch{}i+=(t>0?" ":"")+o}return i}e.format=I;class C extends L.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new n.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=C;class f extends C{constructor(i){super();this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...t){this.checkLogLevel(b.Trace)&&this.log(b.Trace,I([i,...t]))}debug(i,...t){this.checkLogLevel(b.Debug)&&this.log(b.Debug,I([i,...t]))}info(i,...t){this.checkLogLevel(b.Info)&&this.log(b.Info,I([i,...t]))}warn(i,...t){this.checkLogLevel(b.Warning)&&this.log(b.Warning,I([i,...t]))}error(i,...t){if(this.checkLogLevel(b.Error))if(i instanceof Error){const o=Array.prototype.slice.call(arguments);o[0]=i.stack,this.log(b.Error,I(o))}else this.log(b.Error,I([i,...t]))}critical(i,...t){this.checkLogLevel(b.Critical)&&this.log(b.Critical,I([i,...t]))}flush(){}}e.AbstractMessageLogger=f;class S extends C{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i),this.useColors=!T.isWindows}trace(i,...t){this.getLevel()<=b.Trace&&(this.useColors?console.log(`[90m[main ${R()}][0m`,i,...t):console.log(`[main ${R()}]`,i,...t))}debug(i,...t){this.getLevel()<=b.Debug&&(this.useColors?console.log(`[90m[main ${R()}][0m`,i,...t):console.log(`[main ${R()}]`,i,...t))}info(i,...t){this.getLevel()<=b.Info&&(this.useColors?console.log(`[90m[main ${R()}][0m`,i,...t):console.log(`[main ${R()}]`,i,...t))}warn(i,...t){this.getLevel()<=b.Warning&&(this.useColors?console.warn(`[93m[main ${R()}][0m`,i,...t):console.warn(`[main ${R()}]`,i,...t))}error(i,...t){this.getLevel()<=b.Error&&(this.useColors?console.error(`[91m[main ${R()}][0m`,i,...t):console.error(`[main ${R()}]`,i,...t))}critical(i,...t){this.getLevel()<=b.Critical&&(this.useColors?console.error(`[90m[main ${R()}][0m`,i,...t):console.error(`[main ${R()}]`,i,...t))}dispose(){}flush(){}}e.ConsoleMainLogger=S;class u extends C{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i)}trace(i,...t){this.getLevel()<=b.Trace&&console.log("%cTRACE","color: #888",i,...t)}debug(i,...t){this.getLevel()<=b.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...t)}info(i,...t){this.getLevel()<=b.Info&&console.log("%c INFO","color: #33f",i,...t)}warn(i,...t){this.getLevel()<=b.Warning&&console.log("%c WARN","color: #993",i,...t)}error(i,...t){this.getLevel()<=b.Error&&console.log("%c  ERR","color: #f33",i,...t)}critical(i,...t){this.getLevel()<=b.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...t)}dispose(){}flush(){}}e.ConsoleLogger=u;class v extends C{constructor(i,t=e.DEFAULT_LOG_LEVEL){super();this.adapter=i,this.setLevel(t)}trace(i,...t){this.getLevel()<=b.Trace&&this.adapter.log(b.Trace,[this.extractMessage(i),...t])}debug(i,...t){this.getLevel()<=b.Debug&&this.adapter.log(b.Debug,[this.extractMessage(i),...t])}info(i,...t){this.getLevel()<=b.Info&&this.adapter.log(b.Info,[this.extractMessage(i),...t])}warn(i,...t){this.getLevel()<=b.Warning&&this.adapter.log(b.Warning,[this.extractMessage(i),...t])}error(i,...t){this.getLevel()<=b.Error&&this.adapter.log(b.Error,[this.extractMessage(i),...t])}critical(i,...t){this.getLevel()<=b.Critical&&this.adapter.log(b.Critical,[this.extractMessage(i),...t])}extractMessage(i){return typeof i=="string"?i:(0,D.toErrorMessage)(i,this.getLevel()<=b.Trace)}dispose(){}flush(){}}e.AdapterLogger=v;class d extends C{constructor(i){super();this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const t of this.logServices)t.setLevel(i);super.setLevel(i)}trace(i,...t){for(const o of this.logServices)o.trace(i,...t)}debug(i,...t){for(const o of this.logServices)o.debug(i,...t)}info(i,...t){for(const o of this.logServices)o.info(i,...t)}warn(i,...t){for(const o of this.logServices)o.warn(i,...t)}error(i,...t){for(const o of this.logServices)o.error(i,...t)}critical(i,...t){for(const o of this.logServices)o.critical(i,...t)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}e.MultiplexLogService=d;class g extends L.Disposable{constructor(i){super();this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...t){this.logger.trace(i,...t)}debug(i,...t){this.logger.debug(i,...t)}info(i,...t){this.logger.info(i,...t)}warn(i,...t){this.logger.warn(i,...t)}error(i,...t){this.logger.error(i,...t)}critical(i,...t){this.logger.critical(i,...t)}flush(){this.logger.flush()}}e.LogService=g;class w extends L.Disposable{constructor(i,t){super();this.logLevel=i,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(t(o=>{this.logLevel=o,this.logLevelChangeableLoggers.forEach(s=>s.setLevel(o))}))}getLogger(i){return this.loggers.get(i.toString())}createLogger(i,t){let o=this.loggers.get(i.toString());return o||(o=this.doCreateLogger(i,t?.always?b.Trace:this.logLevel,t),this.loggers.set(i.toString(),o),t?.always||this.logLevelChangeableLoggers.push(o)),o}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(i=>i.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=w;class y{constructor(){this.onDidChangeLogLevel=new n.Emitter().event}setLevel(i){}getLevel(){return b.Info}trace(i,...t){}debug(i,...t){}info(i,...t){}warn(i,...t){}error(i,...t){}critical(i,...t){}dispose(){}flush(){}}e.NullLogService=y;function p(a){if(a.verbose)return b.Trace;if(typeof a.logLevel=="string"){const i=l(a.logLevel.toLowerCase());if(i!==void 0)return i}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=p;function l(a){switch(a){case"trace":return b.Trace;case"debug":return b.Debug;case"info":return b.Info;case"warn":return b.Warning;case"error":return b.Error;case"critical":return b.Critical;case"off":return b.Off}}e.parseLogLevel=l;function r(a){switch(a){case b.Trace:return"trace";case b.Debug:return"debug";case b.Info:return"info";case b.Warning:return"warn";case b.Error:return"error";case b.Critical:return"critical";case b.Off:return"off"}}e.LogLevelToString=r}),define(ne[172],ie([0,1,5,9,2,10,22,13,8]),function(J,e,D,n,L,T,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let E=class extends L.Disposable{constructor(C,f){super();this.environmentService=C,this.logService=f,this._register(new D.RunOnceScheduler(()=>{this.cleanUpOldLogs()},10*1e3)).schedule()}async cleanUpOldLogs(){this.logService.trace("[logs cleanup]: Starting to clean up old logs.");try{const C=(0,T.basename)(this.environmentService.logsPath),f=(0,T.dirname)(this.environmentService.logsPath),v=(await A.Promises.readdir(f)).filter(g=>/^\d{8}T\d{6}$/.test(g)).sort().filter(g=>g!==C),d=v.slice(0,Math.max(0,v.length-9));d.length>0&&(this.logService.trace(`[logs cleanup]: Removing log folders '${d.join(", ")}'`),await Promise.all(d.map(g=>A.Promises.rm((0,T.join)(f,g)))))}catch(C){(0,n.onUnexpectedError)(C)}}};E=de([Y(0,R.IEnvironmentService),Y(1,b.ILogService)],E),e.LogsDataCleaner=E}),define(ne[173],ie([0,1,5,9,2,10,22,13,8]),function(J,e,D,n,L,T,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDataCleaner=void 0;let E=class gt extends L.Disposable{constructor(C,f,S){super();this.backupWorkspacesPath=C,this.environmentService=f,this.logService=S,this._register(new D.RunOnceScheduler(()=>{this.cleanUpStorage()},30*1e3)).schedule()}async cleanUpStorage(){this.logService.trace("[storage cleanup]: Starting to clean up storage folders.");try{const C=await A.Promises.readFile(this.backupWorkspacesPath,"utf8"),S=JSON.parse(C).emptyWorkspaceInfos.map(v=>v.backupFolder),u=await A.Promises.readdir(this.environmentService.workspaceStorageHome.fsPath);await Promise.all(u.map(async v=>{v.length===gt.NON_EMPTY_WORKSPACE_ID_LENGTH||v===gt.EXTENSION_DEV_EMPTY_WINDOW_ID||S.indexOf(v)>=0||(this.logService.trace(`[storage cleanup]: Deleting workspace storage folder ${v}.`),await A.Promises.rm((0,T.join)(this.environmentService.workspaceStorageHome.fsPath,v)))}))}catch(C){(0,n.onUnexpectedError)(C)}}};E.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4,E.EXTENSION_DEV_EMPTY_WINDOW_ID="ext-dev",E=de([Y(1,R.INativeEnvironmentService),Y(2,b.ILogService)],E),e.StorageDataCleaner=E}),define(ne[174],ie([0,1,45,5,37,3,2,18,10,22,13,8]),function(J,e,D,n,L,T,A,R,b,E,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let f=class extends A.Disposable{constructor(u,v){super();this.environmentService=u,this.logService=v,this.processesLimiter=new n.Limiter(5)}async postUninstall(u){const v=this.parseScript(u,"uninstall");return v&&(this.logService.info(u.identifier.id,u.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(v.script,"uninstall",v.args,!0,u).then(()=>this.logService.info(u.identifier.id,u.manifest.version,"Finished running post uninstall script"),d=>this.logService.error(u.identifier.id,u.manifest.version,`Failed to run post uninstall script: ${d}`)))),E.Promises.rm(this.getExtensionStoragePath(u)).then(void 0,d=>this.logService.error("Error while removing extension storage path",d))}parseScript(u,v){const d=`vscode:${v}`;if(u.location.scheme===R.Schemas.file&&u.manifest&&u.manifest.scripts&&typeof u.manifest.scripts[d]=="string"){const g=u.manifest.scripts[d].split(" ");return g.length<2||g[0]!=="node"||!g[1]?(this.logService.warn(u.identifier.id,u.manifest.version,`${d} should be a node script`),null):{script:(0,b.join)(u.location.fsPath,g[1]),args:g.slice(2)||[]}}return null}runLifecycleHook(u,v,d,g,w){return new Promise((y,p)=>{const l=this.start(u,v,d,w);let r;const a=i=>{r&&(clearTimeout(r),r=null),i?p(i):y(void 0)};l.on("error",i=>{a((0,L.toErrorMessage)(i)||"Unknown")}),l.on("exit",(i,t)=>{a(i?`post-${v} process exited with code ${i}`:void 0)}),g&&(r=setTimeout(()=>{r=null,l.kill(),p("timed out")},5e3))})}start(u,v,d,g){const w={silent:!0,execArgv:void 0},y=(0,D.fork)(u,[`--type=extension-post-${v}`,...d],w);y.stdout.setEncoding("utf8"),y.stderr.setEncoding("utf8");const p=T.Event.fromNodeEventEmitter(y.stdout,"data"),l=T.Event.fromNodeEventEmitter(y.stderr,"data");p(i=>this.logService.info(g.identifier.id,g.manifest.version,`post-${v}`,i)),l(i=>this.logService.error(g.identifier.id,g.manifest.version,`post-${v}`,i));const r=T.Event.any(T.Event.map(p,i=>({data:`%c${i}`,format:[""]})),T.Event.map(l,i=>({data:`%c${i}`,format:["color: red"]})));return T.Event.debounce(r,(i,t)=>i?{data:i.data+t.data,format:[...i.format,...t.format]}:{data:t.data,format:t.format},100)(i=>{console.group(g.identifier.id),console.log(i.data,...i.format),console.groupEnd()}),y}getExtensionStoragePath(u){return(0,b.join)(this.environmentService.globalStorageHome.fsPath,u.identifier.id.toLowerCase())}};f=de([Y(0,I.IEnvironmentService),Y(1,C.ILogService)],f),e.ExtensionsLifecycle=f}),define(ne[175],ie([0,1,16,5,9,3,2,10,52,8]),function(J,e,D,n,L,T,A,R,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class I extends A.Disposable{constructor(f,S){super();this.logService=f,this.options=S,this._onDidChangeFile=this._register(new T.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new T.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new n.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new n.ThrottledDelayer(0))}watch(f,S){return S.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(f,S):this.watchNonRecursive(f,S)}watchUniversal(f,S){const u={path:this.toFilePath(f),excludes:S.excludes,recursive:S.recursive},v=(0,D.insert)(this.universalPathsToWatch,u);return this.refreshUniversalWatchers(),(0,A.toDisposable)(()=>{v(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(f=>(0,L.onUnexpectedError)(f))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(S=>this._onDidChangeFile.fire((0,b.toFileChanges)(S)),S=>this.onWatcherLogMessage(S),this.logService.getLevel()===E.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===E.LogLevel.Trace)})));const f=this.options?.watcher?.recursive?.usePolling;if(f===!0)for(const S of this.universalPathsToWatch)(0,b.isRecursiveWatchRequest)(S)&&(S.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(f))for(const S of this.universalPathsToWatch)(0,b.isRecursiveWatchRequest)(S)&&f.includes(S.path)&&(S.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(f,S){const u={path:this.toFilePath(f),excludes:S.excludes,recursive:!1},v=(0,D.insert)(this.nonRecursivePathsToWatch,u);return this.refreshNonRecursiveWatchers(),(0,A.toDisposable)(()=>{v(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(f=>(0,L.onUnexpectedError)(f))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(f=>this._onDidChangeFile.fire((0,b.toFileChanges)(f)),f=>this.onWatcherLogMessage(f),this.logService.getLevel()===E.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===E.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(f){f.type==="error"&&this._onDidWatchError.fire(f.message),this.logService[f.type](f.message)}toFilePath(f){return(0,R.normalize)(f.fsPath)}}e.AbstractDiskFileSystemProvider=I}),define(ne[176],ie([0,1,16,5,17,23,3,70,55,2,39,18,177,19,40,136,14,84,8]),function(J,e,D,n,L,T,A,R,b,E,I,C,f,S,u,v,d,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let y=class extends E.Disposable{constructor(l){super();this.logService=l,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new A.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new A.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new A.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new A.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new A.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new A.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new n.ResourceQueue)}registerProvider(l,r){if(this.provider.has(l))throw new Error(`A filesystem provider for the scheme '${l}' is already registered.`);(0,f.mark)(`code/registerFilesystem/${l}`);const a=new E.DisposableStore;return this.provider.set(l,r),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:l,provider:r}),a.add(r.onDidChangeFile(i=>this._onDidFilesChange.fire(new d.FileChangesEvent(i,!this.isPathCaseSensitive(r))))),typeof r.onDidWatchError=="function"&&a.add(r.onDidWatchError(i=>this._onDidWatchError.fire(new Error(i)))),a.add(r.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:r,scheme:l}))),(0,E.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:l,provider:r}),this.provider.delete(l),(0,E.dispose)(a)})}getProvider(l){return this.provider.get(l)}async activateProvider(l){const r=[];this._onWillActivateFileSystemProvider.fire({scheme:l,join(a){r.push(a)}}),!this.provider.has(l)&&await n.Promises.settled(r)}async canHandleResource(l){return await this.activateProvider(l.scheme),this.hasProvider(l)}hasProvider(l){return this.provider.has(l.scheme)}hasCapability(l,r){const a=this.provider.get(l.scheme);return!!(a&&a.capabilities&r)}listCapabilities(){return b.Iterable.map(this.provider,([l,r])=>({scheme:l,capabilities:r.capabilities}))}async withProvider(l){if(!(0,S.isAbsolutePath)(l))throw new d.FileOperationError((0,v.localize)(0,null,this.resourceForError(l)),8);await this.activateProvider(l.scheme);const r=this.provider.get(l.scheme);if(!r){const a=new Error;throw a.name="ENOPRO",a.message=(0,v.localize)(1,null,l.toString()),a}return r}async withReadProvider(l){const r=await this.withProvider(l);if((0,d.hasOpenReadWriteCloseCapability)(r)||(0,d.hasReadWriteCapability)(r)||(0,d.hasFileReadStreamCapability)(r))return r;throw new Error(`Filesystem provider for scheme '${l.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(l){const r=await this.withProvider(l);if((0,d.hasOpenReadWriteCloseCapability)(r)||(0,d.hasReadWriteCapability)(r))return r;throw new Error(`Filesystem provider for scheme '${l.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(l,r){try{return await this.doResolveFile(l,r)}catch(a){throw(0,d.toFileSystemProviderErrorCode)(a)===d.FileSystemProviderErrorCode.FileNotFound?new d.FileOperationError((0,v.localize)(2,null,this.resourceForError(l)),1):(0,d.ensureFileSystemProviderError)(a)}}async doResolveFile(l,r){const a=await this.withProvider(l),i=this.isPathCaseSensitive(a),t=r?.resolveTo,o=r?.resolveSingleChildDescendants,s=r?.resolveMetadata,c=await a.stat(l);let h;return this.toFileStat(a,l,c,void 0,!!s,(m,P)=>(h||(h=I.TernarySearchTree.forUris(()=>!i),h.set(l,!0),t&&h.fill(!0,t)),h.get(m.resource)||h.findSuperstr(m.resource.with({query:null,fragment:null}))?!0:m.isDirectory&&o?P===1:!1))}async toFileStat(l,r,a,i,t,o){const{providerExtUri:s}=this.getExtUri(l),c={resource:r,name:s.basename(r),isFile:(a.type&d.FileType.File)!=0,isDirectory:(a.type&d.FileType.Directory)!=0,isSymbolicLink:(a.type&d.FileType.SymbolicLink)!=0,mtime:a.mtime,ctime:a.ctime,size:a.size,readonly:Boolean((a.permissions??0)&d.FilePermission.Readonly)||Boolean(l.capabilities&2048),etag:(0,d.etag)({mtime:a.mtime,size:a.size})};if(c.isDirectory&&o(c,i)){try{const h=await l.readdir(r),m=await n.Promises.settled(h.map(async([P,_])=>{try{const O=s.joinPath(r,P),M=t?await l.stat(O):{type:_};return await this.toFileStat(l,O,M,h.length,t,o)}catch(O){return this.logService.trace(O),null}}));c.children=(0,D.coalesce)(m)}catch(h){this.logService.trace(h),c.children=[]}return c}return c}async resolveAll(l){return n.Promises.settled(l.map(async r=>{try{return{stat:await this.doResolveFile(r.resource,r.options),success:!0}}catch(a){return this.logService.trace(a),{stat:void 0,success:!1}}}))}async exists(l){const r=await this.withProvider(l);try{return!!await r.stat(l)}catch{return!1}}async canCreateFile(l,r){try{await this.doValidateCreateFile(l,r)}catch(a){return a}return!0}async doValidateCreateFile(l,r){if(!r?.overwrite&&await this.exists(l))throw new d.FileOperationError((0,v.localize)(3,null,this.resourceForError(l)),3,r)}async createFile(l,r=L.VSBuffer.fromString(""),a){await this.doValidateCreateFile(l,a);const i=await this.writeFile(l,r);return this._onDidRunOperation.fire(new d.FileOperationEvent(l,0,i)),i}async writeFile(l,r,a){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),{providerExtUri:t}=this.getExtUri(i);try{await this.validateWriteFile(i,l,a)||await this.mkdirp(i,t.dirname(l));let s;if((0,d.hasReadWriteCapability)(i)&&!(r instanceof L.VSBuffer))if((0,u.isReadableStream)(r)){const c=await(0,u.peekStream)(r,3);c.ended?s=L.VSBuffer.concat(c.buffer):s=c}else s=(0,u.peekReadable)(r,c=>L.VSBuffer.concat(c),3);else s=r;!(0,d.hasOpenReadWriteCloseCapability)(i)||(0,d.hasReadWriteCapability)(i)&&s instanceof L.VSBuffer?await this.doWriteUnbuffered(i,l,a,s):await this.doWriteBuffered(i,l,a,s instanceof L.VSBuffer?(0,L.bufferToReadable)(s):s)}catch(o){throw new d.FileOperationError((0,v.localize)(4,null,this.resourceForError(l),(0,d.ensureFileSystemProviderError)(o).toString()),(0,d.toFileOperationResult)(o),a)}return this.resolve(l,{resolveMetadata:!0})}async validateWriteFile(l,r,a){if(!!a?.unlock&&!(l.capabilities&8192))throw new Error((0,v.localize)(5,null,this.resourceForError(r)));let t;try{t=await l.stat(r)}catch{return}if((t.type&d.FileType.Directory)!=0)throw new d.FileOperationError((0,v.localize)(6,null,this.resourceForError(r)),0,a);if(this.throwIfFileIsReadonly(r,t),typeof a?.mtime=="number"&&typeof a.etag=="string"&&a.etag!==d.ETAG_DISABLED&&typeof t.mtime=="number"&&typeof t.size=="number"&&a.mtime<t.mtime&&a.etag!==(0,d.etag)({mtime:a.mtime,size:t.size}))throw new d.FileOperationError((0,v.localize)(7,null),3,a);return t}async readFile(l,r,a){const i=await this.withReadProvider(l);return r?.atomic?this.doReadFileAtomic(i,l,r,a):this.doReadFile(i,l,r,a)}async doReadFileAtomic(l,r,a,i){return new Promise((t,o)=>{this.writeQueue.queueFor(r,this.getExtUri(l).providerExtUri).queue(async()=>{try{const s=await this.doReadFile(l,r,a,i);t(s)}catch(s){o(s)}})})}async doReadFile(l,r,a,i){const t=await this.doReadFileStream(l,r,{...a,preferUnbuffered:!0},i);return{...t,value:await(0,L.streamToBuffer)(t.value)}}async readFileStream(l,r,a){const i=await this.withReadProvider(l);return this.doReadFileStream(i,l,r,a)}async doReadFileStream(l,r,a,i){const t=new T.CancellationTokenSource(i),o=this.validateReadFile(r,a).then(c=>c,c=>{throw t.cancel(),c});let s;try{return typeof a?.etag=="string"&&a.etag!==d.ETAG_DISABLED&&await o,a?.atomic&&(0,d.hasFileAtomicReadCapability)(l)||!((0,d.hasOpenReadWriteCloseCapability)(l)||(0,d.hasFileReadStreamCapability)(l))||(0,d.hasReadWriteCapability)(l)&&a?.preferUnbuffered?s=this.readFileUnbuffered(l,r,a):(0,d.hasFileReadStreamCapability)(l)?s=this.readFileStreamed(l,r,t.token,a):s=this.readFileBuffered(l,r,t.token,a),{...await o,value:s}}catch(c){s&&await(0,u.consumeStream)(s);const h=(0,v.localize)(8,null,this.resourceForError(r),(0,d.ensureFileSystemProviderError)(c).toString());throw c instanceof d.NotModifiedSinceFileOperationError?new d.NotModifiedSinceFileOperationError(h,c.stat,a):new d.FileOperationError(h,(0,d.toFileOperationResult)(c),a)}}readFileStreamed(l,r,a,i=Object.create(null)){const t=l.readFileStream(r,i,a);return(0,u.transform)(t,{data:o=>o instanceof L.VSBuffer?o:L.VSBuffer.wrap(o),error:o=>new d.FileOperationError((0,v.localize)(9,null,this.resourceForError(r),(0,d.ensureFileSystemProviderError)(o).toString()),(0,d.toFileOperationResult)(o),i)},o=>L.VSBuffer.concat(o))}readFileBuffered(l,r,a,i=Object.create(null)){const t=(0,L.newWriteableBufferStream)();return(0,g.readFileIntoStream)(l,r,t,o=>o,{...i,bufferSize:this.BUFFER_SIZE,errorTransformer:o=>new d.FileOperationError((0,v.localize)(10,null,this.resourceForError(r),(0,d.ensureFileSystemProviderError)(o).toString()),(0,d.toFileOperationResult)(o),i)},a),t}readFileUnbuffered(l,r,a){const i=(0,u.newWriteableStream)(t=>L.VSBuffer.concat(t));return(async()=>{try{let t;a?.atomic&&(0,d.hasFileAtomicReadCapability)(l)?t=await l.readFile(r,{atomic:!0}):t=await l.readFile(r),typeof a?.position=="number"&&(t=t.slice(a.position)),typeof a?.length=="number"&&(t=t.slice(0,a.length)),this.validateReadFileLimits(r,t.byteLength,a),i.end(L.VSBuffer.wrap(t))}catch(t){i.error(t),i.end()}})(),i}async validateReadFile(l,r){const a=await this.resolve(l,{resolveMetadata:!0});if(a.isDirectory)throw new d.FileOperationError((0,v.localize)(11,null,this.resourceForError(l)),0,r);if(typeof r?.etag=="string"&&r.etag!==d.ETAG_DISABLED&&r.etag===a.etag)throw new d.NotModifiedSinceFileOperationError((0,v.localize)(12,null),a,r);return this.validateReadFileLimits(l,a.size,r),a}validateReadFileLimits(l,r,a){if(a?.limits){let i;if(typeof a.limits.memory=="number"&&r>a.limits.memory&&(i=9),typeof a.limits.size=="number"&&r>a.limits.size&&(i=7),typeof i=="number")throw new d.FileOperationError((0,v.localize)(13,null,this.resourceForError(l)),i)}}async canMove(l,r,a){return this.doCanMoveCopy(l,r,"move",a)}async canCopy(l,r,a){return this.doCanMoveCopy(l,r,"copy",a)}async doCanMoveCopy(l,r,a,i){if(l.toString()!==r.toString())try{const t=a==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l):await this.withReadProvider(l),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r);await this.doValidateMoveCopy(t,l,o,r,a,i)}catch(t){return t}return!0}async move(l,r,a){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),o=await this.doMoveCopy(i,l,t,r,"move",!!a),s=await this.resolve(r,{resolveMetadata:!0});return this._onDidRunOperation.fire(new d.FileOperationEvent(l,o==="move"?2:3,s)),s}async copy(l,r,a){const i=await this.withReadProvider(l),t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),o=await this.doMoveCopy(i,l,t,r,"copy",!!a),s=await this.resolve(r,{resolveMetadata:!0});return this._onDidRunOperation.fire(new d.FileOperationEvent(l,o==="copy"?3:2,s)),s}async doMoveCopy(l,r,a,i,t,o){if(r.toString()===i.toString())return t;const{exists:s,isSameResourceWithDifferentPathCase:c}=await this.doValidateMoveCopy(l,r,a,i,t,o);if(s&&!c&&o&&await this.del(i,{recursive:!0}),await this.mkdirp(a,this.getExtUri(a).providerExtUri.dirname(i)),t==="copy"){if(l===a&&(0,d.hasFileFolderCopyCapability)(l))await l.copy(r,i,{overwrite:o});else{const h=await this.resolve(r);h.isDirectory?await this.doCopyFolder(l,h,a,i):await this.doCopyFile(l,r,a,i)}return t}else return l===a?(await l.rename(r,i,{overwrite:o}),t):(await this.doMoveCopy(l,r,a,i,"copy",o),await this.del(r,{recursive:!0}),"copy")}async doCopyFile(l,r,a,i){if((0,d.hasOpenReadWriteCloseCapability)(l)&&(0,d.hasOpenReadWriteCloseCapability)(a))return this.doPipeBuffered(l,r,a,i);if((0,d.hasOpenReadWriteCloseCapability)(l)&&(0,d.hasReadWriteCapability)(a))return this.doPipeBufferedToUnbuffered(l,r,a,i);if((0,d.hasReadWriteCapability)(l)&&(0,d.hasOpenReadWriteCloseCapability)(a))return this.doPipeUnbufferedToBuffered(l,r,a,i);if((0,d.hasReadWriteCapability)(l)&&(0,d.hasReadWriteCapability)(a))return this.doPipeUnbuffered(l,r,a,i)}async doCopyFolder(l,r,a,i){await a.mkdir(i),Array.isArray(r.children)&&await n.Promises.settled(r.children.map(async t=>{const o=this.getExtUri(a).providerExtUri.joinPath(i,t.name);return t.isDirectory?this.doCopyFolder(l,await this.resolve(t.resource),a,o):this.doCopyFile(l,t.resource,a,o)}))}async doValidateMoveCopy(l,r,a,i,t,o){let s=!1;if(l===a){const{providerExtUri:h,isPathCaseSensitive:m}=this.getExtUri(l);if(m||(s=h.isEqual(r,i)),s&&t==="copy")throw new Error((0,v.localize)(14,null,this.resourceForError(r),this.resourceForError(i)));if(!s&&h.isEqualOrParent(i,r))throw new Error((0,v.localize)(15,null,this.resourceForError(r),this.resourceForError(i)))}const c=await this.exists(i);if(c&&!s){if(!o)throw new d.FileOperationError((0,v.localize)(16,null,this.resourceForError(r),this.resourceForError(i)),4);if(l===a){const{providerExtUri:h}=this.getExtUri(l);if(h.isEqualOrParent(r,i))throw new Error((0,v.localize)(17,null,this.resourceForError(r),this.resourceForError(i)))}}return{exists:c,isSameResourceWithDifferentPathCase:s}}getExtUri(l){const r=this.isPathCaseSensitive(l);return{providerExtUri:r?S.extUri:S.extUriIgnorePathCase,isPathCaseSensitive:r}}isPathCaseSensitive(l){return!!(l.capabilities&1024)}async createFolder(l){const r=this.throwIfFileSystemIsReadonly(await this.withProvider(l),l);await this.mkdirp(r,l);const a=await this.resolve(l,{resolveMetadata:!0});return this._onDidRunOperation.fire(new d.FileOperationEvent(l,0,a)),a}async mkdirp(l,r){const a=[],{providerExtUri:i}=this.getExtUri(l);for(;!i.isEqual(r,i.dirname(r));)try{if(((await l.stat(r)).type&d.FileType.Directory)==0)throw new Error((0,v.localize)(18,null,this.resourceForError(r)));break}catch(t){if((0,d.toFileSystemProviderErrorCode)(t)!==d.FileSystemProviderErrorCode.FileNotFound)throw t;a.push(i.basename(r)),r=i.dirname(r)}for(let t=a.length-1;t>=0;t--){r=i.joinPath(r,a[t]);try{await l.mkdir(r)}catch(o){if((0,d.toFileSystemProviderErrorCode)(o)!==d.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(l,r){try{await this.doValidateDelete(l,r)}catch(a){return a}return!0}async doValidateDelete(l,r){const a=this.throwIfFileSystemIsReadonly(await this.withProvider(l),l);if(!!r?.useTrash&&!(a.capabilities&4096))throw new Error((0,v.localize)(19,null,this.resourceForError(l)));let t;try{t=await a.stat(l)}catch{}if(t)this.throwIfFileIsReadonly(l,t);else throw new d.FileOperationError((0,v.localize)(20,null,this.resourceForError(l)),1);if(!!!r?.recursive){const s=await this.resolve(l);if(s.isDirectory&&Array.isArray(s.children)&&s.children.length>0)throw new Error((0,v.localize)(21,null,this.resourceForError(l)))}return a}async del(l,r){const a=await this.doValidateDelete(l,r),i=!!r?.useTrash,t=!!r?.recursive;await a.delete(l,{recursive:t,useTrash:i}),this._onDidRunOperation.fire(new d.FileOperationEvent(l,1))}watch(l,r={recursive:!1,excludes:[]}){const a=new E.DisposableStore;let i=!1,t=()=>{i=!0};return a.add((0,E.toDisposable)(()=>t())),(async()=>{try{const o=await this.doWatch(l,r);i?(0,E.dispose)(o):t=()=>(0,E.dispose)(o)}catch(o){this.logService.error(o)}})(),a}async doWatch(l,r){const a=await this.withProvider(l),i=(0,R.hash)([this.getExtUri(a).providerExtUri.getComparisonKey(l),r]);let t=this.activeWatchers.get(i);return t||(t={count:0,disposable:a.watch(l,r)},this.activeWatchers.set(i,t)),t.count+=1,(0,E.toDisposable)(()=>{t&&(t.count--,t.count===0&&((0,E.dispose)(t.disposable),this.activeWatchers.delete(i)))})}dispose(){super.dispose();for(const[,l]of this.activeWatchers)(0,E.dispose)(l.disposable);this.activeWatchers.clear()}async doWriteBuffered(l,r,a,i){return this.writeQueue.queueFor(r,this.getExtUri(l).providerExtUri).queue(async()=>{const t=await l.open(r,{create:!0,unlock:a?.unlock??!1});try{(0,u.isReadableStream)(i)||(0,u.isReadableBufferedStream)(i)?await this.doWriteStreamBufferedQueued(l,t,i):await this.doWriteReadableBufferedQueued(l,t,i)}catch(o){throw(0,d.ensureFileSystemProviderError)(o)}finally{await l.close(t)}})}async doWriteStreamBufferedQueued(l,r,a){let i=0,t;if((0,u.isReadableBufferedStream)(a)){if(a.buffer.length>0){const o=L.VSBuffer.concat(a.buffer);await this.doWriteBuffer(l,r,o,o.byteLength,i,0),i+=o.byteLength}if(a.ended)return;t=a.stream}else t=a;return new Promise((o,s)=>{(0,u.listenStream)(t,{onData:async c=>{t.pause();try{await this.doWriteBuffer(l,r,c,c.byteLength,i,0)}catch(h){return s(h)}i+=c.byteLength,setTimeout(()=>t.resume())},onError:c=>s(c),onEnd:()=>o()})})}async doWriteReadableBufferedQueued(l,r,a){let i=0,t;for(;(t=a.read())!==null;)await this.doWriteBuffer(l,r,t,t.byteLength,i,0),i+=t.byteLength}async doWriteBuffer(l,r,a,i,t,o){let s=0;for(;s<i;)s+=await l.write(r,t+s,a.buffer,o+s,i-s)}async doWriteUnbuffered(l,r,a,i){return this.writeQueue.queueFor(r,this.getExtUri(l).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(l,r,a,i))}async doWriteUnbufferedQueued(l,r,a,i){let t;i instanceof L.VSBuffer?t=i:(0,u.isReadableStream)(i)?t=await(0,L.streamToBuffer)(i):(0,u.isReadableBufferedStream)(i)?t=await(0,L.bufferedStreamToBuffer)(i):t=(0,L.readableToBuffer)(i),await l.writeFile(r,t.buffer,{create:!0,overwrite:!0,unlock:a?.unlock??!1})}async doPipeBuffered(l,r,a,i){return this.writeQueue.queueFor(i,this.getExtUri(a).providerExtUri).queue(()=>this.doPipeBufferedQueued(l,r,a,i))}async doPipeBufferedQueued(l,r,a,i){let t,o;try{t=await l.open(r,{create:!1}),o=await a.open(i,{create:!0,unlock:!1});const s=L.VSBuffer.alloc(this.BUFFER_SIZE);let c=0,h=0,m=0;do m=await l.read(t,c,s.buffer,h,s.byteLength-h),await this.doWriteBuffer(a,o,s,m,c,h),c+=m,h+=m,h===s.byteLength&&(h=0);while(m>0)}catch(s){throw(0,d.ensureFileSystemProviderError)(s)}finally{await n.Promises.settled([typeof t=="number"?l.close(t):Promise.resolve(),typeof o=="number"?a.close(o):Promise.resolve()])}}async doPipeUnbuffered(l,r,a,i){return this.writeQueue.queueFor(i,this.getExtUri(a).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(l,r,a,i))}async doPipeUnbufferedQueued(l,r,a,i){return a.writeFile(i,await l.readFile(r),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(l,r,a,i){return this.writeQueue.queueFor(i,this.getExtUri(a).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(l,r,a,i))}async doPipeUnbufferedToBufferedQueued(l,r,a,i){const t=await a.open(i,{create:!0,unlock:!1});try{const o=await l.readFile(r);await this.doWriteBuffer(a,t,L.VSBuffer.wrap(o),o.byteLength,0,0)}catch(o){throw(0,d.ensureFileSystemProviderError)(o)}finally{await a.close(t)}}async doPipeBufferedToUnbuffered(l,r,a,i){const t=await(0,L.streamToBuffer)(this.readFileBuffered(l,r,T.CancellationToken.None));await this.doWriteUnbuffered(a,i,void 0,t)}throwIfFileSystemIsReadonly(l,r){if(l.capabilities&2048)throw new d.FileOperationError((0,v.localize)(22,null,this.resourceForError(r)),6);return l}throwIfFileIsReadonly(l,r){if((r.permissions??0)&d.FilePermission.Readonly)throw new d.FileOperationError((0,v.localize)(23,null,this.resourceForError(l)),6)}resourceForError(l){return l.scheme===C.Schemas.file?l.fsPath:l.toString(!0)}};y=de([Y(0,w.ILogService)],y),e.FileService=y}),define(ne[178],ie([0,1,50,254,5,39,17,3,41,2,10,4,19,40,22,139,14,84,175,37,167,166]),function(J,e,D,n,L,T,A,R,b,E,I,C,f,S,u,v,d,g,w,y,p,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,n.gracefulify)(D)}catch(a){console.error(`Error enabling graceful-fs: ${(0,y.toErrorMessage)(a)}`)}})();class r extends w.AbstractDiskFileSystemProvider{constructor(i,t){super(i,t);this.onDidChangeCapabilities=R.Event.None,this.resourceLocks=new T.ResourceMap(o=>f.extUriBiasedIgnorePathCase.getComparisonKey(o)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384,C.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(i){try{const{stat:t,symbolicLink:o}=await u.SymlinkSupport.stat(this.toFilePath(i));return{type:this.toType(t,o),ctime:t.birthtime.getTime(),mtime:t.mtime.getTime(),size:t.size}}catch(t){throw this.toFileSystemProviderError(t)}}async readdir(i){try{const t=await u.Promises.readdir(this.toFilePath(i),{withFileTypes:!0}),o=[];return await Promise.all(t.map(async s=>{try{let c;s.isSymbolicLink()?c=(await this.stat((0,f.joinPath)(i,s.name))).type:c=this.toType(s),o.push([s.name,c])}catch(c){this.logService.trace(c)}})),o}catch(t){throw this.toFileSystemProviderError(t)}}toType(i,t){let o;return t?.dangling?o=d.FileType.Unknown:i.isFile()?o=d.FileType.File:i.isDirectory()?o=d.FileType.Directory:o=d.FileType.Unknown,t&&(o|=d.FileType.SymbolicLink),o}async createResourceLock(i){this.logService.trace(`[Disk FileSystemProvider]: request to acquire resource lock (${this.toFilePath(i)})`);let t;for(;t=this.resourceLocks.get(i);)this.logService.trace(`[Disk FileSystemProvider]: waiting for resource lock to be released (${this.toFilePath(i)})`),await t.wait();const o=new L.Barrier;return this.resourceLocks.set(i,o),this.logService.trace(`[Disk FileSystemProvider]: new resource lock created (${this.toFilePath(i)})`),(0,E.toDisposable)(()=>{this.logService.trace(`[Disk FileSystemProvider]: resource lock disposed (${this.toFilePath(i)})`),this.resourceLocks.delete(i),o.open()})}async readFile(i,t){let o;try{t?.atomic&&(this.logService.trace(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(i)})`),o=await this.createResourceLock(i));const s=this.toFilePath(i);return await u.Promises.readFile(s)}catch(s){throw this.toFileSystemProviderError(s)}finally{o?.dispose()}}readFileStream(i,t,o){const s=(0,S.newWriteableStream)(c=>A.VSBuffer.concat(c.map(h=>A.VSBuffer.wrap(h))).buffer);return(0,g.readFileIntoStream)(this,i,s,c=>c.buffer,{...t,bufferSize:256*1024},o),s}async writeFile(i,t,o){let s;try{const c=this.toFilePath(i);if(!o.create||!o.overwrite){if(await u.Promises.exists(c)){if(!o.overwrite)throw(0,d.createFileSystemProviderError)((0,v.localize)(0,null),d.FileSystemProviderErrorCode.FileExists)}else if(!o.create)throw(0,d.createFileSystemProviderError)((0,v.localize)(1,null),d.FileSystemProviderErrorCode.FileNotFound)}s=await this.open(i,{create:!0,unlock:o.unlock}),await this.write(s,0,t,0,t.byteLength)}catch(c){throw await this.toFileSystemProviderWriteError(i,c)}finally{typeof s=="number"&&await this.close(s)}}async open(i,t){let o;(0,d.isFileOpenForWriteOptions)(t)&&(o=await this.createResourceLock(i));let s;try{const c=this.toFilePath(i);if((0,d.isFileOpenForWriteOptions)(t)&&t.unlock)try{const{stat:m}=await u.SymlinkSupport.stat(c);m.mode&128||await u.Promises.chmod(c,m.mode|128)}catch(m){this.logService.trace(m)}let h;if((0,d.isFileOpenForWriteOptions)(t)){if(C.isWindows)try{await u.Promises.truncate(c,0),h="r+"}catch(m){m.code!=="ENOENT"&&this.logService.trace(m)}h||(h="w")}else h="r";s=await u.Promises.open(c,h)}catch(c){throw o?.dispose(),(0,d.isFileOpenForWriteOptions)(t)?await this.toFileSystemProviderWriteError(i,c):this.toFileSystemProviderError(c)}return this.mapHandleToPos.set(s,0),(0,d.isFileOpenForWriteOptions)(t)&&this.writeHandles.set(s,i),o&&this.mapHandleToLock.set(s,o),s}async close(i){try{if(this.mapHandleToPos.delete(i),this.writeHandles.delete(i)&&this.canFlush)try{await u.Promises.fdatasync(i)}catch(t){this.canFlush=!1,this.logService.error(t)}return await u.Promises.close(i)}catch(t){throw this.toFileSystemProviderError(t)}finally{const t=this.mapHandleToLock.get(i);t&&(this.mapHandleToLock.delete(i),t.dispose())}}async read(i,t,o,s,c){const h=this.normalizePos(i,t);let m=null;try{const{bytesRead:P}=await u.Promises.read(i,o,s,c,h);return P}catch(P){throw this.toFileSystemProviderError(P)}finally{this.updatePos(i,h,m)}}normalizePos(i,t){return t===this.mapHandleToPos.get(i)?null:t}updatePos(i,t,o){const s=this.mapHandleToPos.get(i);typeof s=="number"&&(typeof t=="number"||(typeof o=="number"?this.mapHandleToPos.set(i,s+o):this.mapHandleToPos.delete(i)))}async write(i,t,o,s,c){return(0,L.retry)(()=>this.doWrite(i,t,o,s,c),100,3)}async doWrite(i,t,o,s,c){const h=this.normalizePos(i,t);let m=null;try{const{bytesWritten:P}=await u.Promises.write(i,o,s,c,h);return P}catch(P){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(i),P)}finally{this.updatePos(i,h,m)}}async mkdir(i){try{await u.Promises.mkdir(this.toFilePath(i))}catch(t){throw this.toFileSystemProviderError(t)}}async delete(i,t){try{const o=this.toFilePath(i);t.recursive?await u.Promises.rm(o,u.RimRafMode.MOVE):await u.Promises.unlink(o)}catch(o){throw this.toFileSystemProviderError(o)}}async rename(i,t,o){const s=this.toFilePath(i),c=this.toFilePath(t);if(s!==c)try{await this.validateTargetDeleted(i,t,"move",o.overwrite),await u.Promises.move(s,c)}catch(h){throw(h.code==="EINVAL"||h.code==="EBUSY"||h.code==="ENAMETOOLONG")&&(h=new Error((0,v.localize)(2,null,(0,I.basename)(s),(0,I.basename)((0,I.dirname)(c)),h.toString()))),this.toFileSystemProviderError(h)}}async copy(i,t,o){const s=this.toFilePath(i),c=this.toFilePath(t);if(s!==c)try{await this.validateTargetDeleted(i,t,"copy",o.overwrite),await u.Promises.copy(s,c,{preserveSymlinks:!0})}catch(h){throw(h.code==="EINVAL"||h.code==="EBUSY"||h.code==="ENAMETOOLONG")&&(h=new Error((0,v.localize)(3,null,(0,I.basename)(s),(0,I.basename)((0,I.dirname)(c)),h.toString()))),this.toFileSystemProviderError(h)}}async validateTargetDeleted(i,t,o,s){const c=this.toFilePath(i),h=this.toFilePath(t);let m=!1;if(!!(this.capabilities&1024)||(m=(0,b.isEqual)(c,h,!0)),m&&o==="copy")throw(0,d.createFileSystemProviderError)((0,v.localize)(4,null),d.FileSystemProviderErrorCode.FileExists);if(!m&&await u.Promises.exists(h)){if(!s)throw(0,d.createFileSystemProviderError)((0,v.localize)(5,null),d.FileSystemProviderErrorCode.FileExists);await this.delete(t,{recursive:!0,useTrash:!1})}}createUniversalWatcher(i,t,o){return new p.UniversalWatcherClient(s=>i(s),s=>t(s),o)}createNonRecursiveWatcher(i,t,o){return new l.NodeJSWatcherClient(s=>i(s),s=>t(s),o)}toFileSystemProviderError(i){if(i instanceof d.FileSystemProviderError)return i;let t;switch(i.code){case"ENOENT":t=d.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":t=d.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":t=d.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":t=d.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":t=d.FileSystemProviderErrorCode.NoPermissions;break;default:t=d.FileSystemProviderErrorCode.Unknown}return(0,d.createFileSystemProviderError)(i,t)}async toFileSystemProviderWriteError(i,t){let o=this.toFileSystemProviderError(t);if(i&&o.code===d.FileSystemProviderErrorCode.NoPermissions)try{const{stat:s}=await u.SymlinkSupport.stat(this.toFilePath(i));s.mode&128||(o=(0,d.createFileSystemProviderError)(t,d.FileSystemProviderErrorCode.FileWriteLocked))}catch(s){this.logService.trace(s)}return o}}e.DiskFileSystemProvider=r}),define(ne[86],ie([0,1,3,7,8]),function(J,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class T{constructor(f){this.service=f,this.onDidChangeLogLevel=D.Event.buffer(f.onDidChangeLogLevel,!0)}listen(f,S){switch(S){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${S}`)}async call(f,S,u){switch(S){case"setLevel":return this.service.setLevel(u)}throw new Error(`Call not found: ${S}`)}}e.LogLevelChannel=T;class A{constructor(f){this.channel=f}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(f){A.setLevel(this.channel,f)}static setLevel(f,S){return f.call("setLevel",S)}}e.LogLevelChannelClient=A;class R{constructor(f){this.loggerService=f,this.loggers=new Map}listen(f,S){throw new Error(`Event not found: ${S}`)}async call(f,S,u){switch(S){case"createLogger":this.createLogger(n.URI.revive(u[0]),u[1]);return;case"log":return this.log(n.URI.revive(u[0]),u[1]);case"consoleLog":return this.consoleLog(u[0],u[1])}throw new Error(`Call not found: ${S}`)}createLogger(f,S){this.loggers.set(f.toString(),this.loggerService.createLogger(f,S))}consoleLog(f,S){let u=console.log;switch(f){case L.LogLevel.Error:u=console.error;break;case L.LogLevel.Warning:u=console.warn;break;case L.LogLevel.Info:u=console.info;break}u.call(console,...S)}log(f,S){const u=this.loggers.get(f.toString());if(!u)throw new Error("Create the logger before logging");for(const[v,d]of S)(0,L.log)(u,v,d)}}e.LoggerChannel=R;class b extends L.AbstractLoggerService{constructor(f,S,u){super(f,S);this.channel=u}createConsoleMainLogger(){return new L.AdapterLogger({log:(f,S)=>{this.channel.call("consoleLog",[f,S])}})}doCreateLogger(f,S,u){return new E(this.channel,f,S,u)}}e.LoggerChannelClient=b;class E extends L.AbstractMessageLogger{constructor(f,S,u,v){super(v?.always);this.channel=f,this.file=S,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(u),this.channel.call("createLogger",[S,v]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(f,S){const u=[[f,S]];this.isLoggerCreated?this.doLog(u):this.buffer.push(...u)}doLog(f){this.channel.call("log",[this.file,f])}}class I extends L.LogService{constructor(f,S){super(S);this.parent=f,this._register(f.onDidChangeLogLevel(u=>S.setLevel(u)))}setLevel(f){super.setLevel(f),this.parent.setLevel(f)}}e.FollowerLogService=I}),define(ne[60],ie([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,D.createDecorator)("nativeHostService")}),define(ne[87],ie([0,1,18,4,32,19]),function(J,e,D,n,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let A;if(typeof n.globals.vscode!="undefined"&&typeof n.globals.vscode.context!="undefined"){const R=n.globals.vscode.context.configuration();if(R)A=R.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof J?.__$__nodeRequire=="function"){const R=(0,T.dirname)(D.FileAccess.asFileUri("",J));A=J.__$__nodeRequire((0,T.joinPath)(R,"product.json").fsPath);const b=J.__$__nodeRequire((0,T.joinPath)(R,"package.json").fsPath);L.env.VSCODE_DEV&&Object.assign(A,{nameShort:`${A.nameShort} Dev`,nameLong:`${A.nameLong} Dev`,dataFolderName:`${A.dataFolderName}-dev`}),Object.assign(A,{version:b.version})}else A={},Object.keys(A).length===0&&Object.assign(A,{version:"1.64.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=A}),define(ne[26],ie([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,D.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(ne[179],ie([0,1,5,9,2,10,22,8,26]),function(J,e,D,n,L,T,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let E=class extends L.Disposable{constructor(C,f,S){super();this.productService=f,this.logService=S,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,C&&this._register(new D.RunOnceScheduler(()=>{this.cleanUpCodeCaches(C)},30*1e3)).schedule()}async cleanUpCodeCaches(C){this.logService.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const f=Date.now(),S=(0,T.dirname)(C),u=(0,T.basename)(C),v=await A.Promises.readdir(S);await Promise.all(v.map(async d=>{if(d===u)return;const g=(0,T.join)(S,d),w=await A.Promises.stat(g);if(w.isDirectory()&&f-w.mtime.getTime()>this._DataMaxAge)return this.logService.trace(`[code cache cleanup]: Removing code cache folder ${d}.`),A.Promises.rm(g)}))}catch(f){(0,n.onUnexpectedError)(f)}}};E=de([Y(1,b.IProductService),Y(2,R.ILogService)],E),e.CodeCacheCleaner=E}),define(ne[180],ie([0,1,5,9,2,10,22,13,8,26]),function(J,e,D,n,L,T,A,R,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let I=class extends L.Disposable{constructor(f,S,u){super();this.environmentService=f,this.logService=S,this.productService=u,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.environmentService.isBuilt&&this._register(new D.RunOnceScheduler(()=>{this.cleanUpLanguagePackCache()},40*1e3)).schedule()}async cleanUpLanguagePackCache(){this.logService.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const f=Object.create(null),S=JSON.parse(await A.Promises.readFile((0,T.join)(this.environmentService.userDataPath,"languagepacks.json"),"utf8"));for(let w of Object.keys(S)){const y=S[w];f[`${y.hash}.${w}`]=!0}const u=(0,T.join)(this.environmentService.userDataPath,"clp");if(!await A.Promises.exists(u))return;const d=await A.Promises.readdir(u);for(const w of d){if(f[w]){this.logService.trace(`[language pack cache cleanup]: Skipping folder ${w}. Language pack still in use.`);continue}this.logService.trace(`[language pack cache cleanup]: Removing unused language pack: ${w}`),await A.Promises.rm((0,T.join)(u,w))}const g=Date.now();for(const w of Object.keys(f)){const y=(0,T.join)(u,w),p=await A.Promises.readdir(y);for(const l of p){if(l==="tcf.json")continue;const r=(0,T.join)(y,l),a=await A.Promises.stat(r);a.isDirectory()&&g-a.mtime.getTime()>this._DataMaxAge&&(this.logService.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,T.join)(w,l)}`),await A.Promises.rm(r))}}}catch(f){(0,n.onUnexpectedError)(f)}}};I=de([Y(0,R.INativeEnvironmentService),Y(1,b.ILogService),Y(2,E.IProductService)],I),e.LanguagePackCachedDataCleaner=I}),define(ne[181],ie([0,1,10,6]),function(J,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.IV8InspectProfilingService=void 0,e.IV8InspectProfilingService=(0,n.createDecorator)("IV8InspectProfilingService");var L;(function(T){function A(R,b="noAbsolutePaths"){for(const E of R.nodes)E.callFrame&&E.callFrame.url&&((0,D.isAbsolute)(E.callFrame.url)||/^\w[\w\d+.-]*:\/\/\//.test(E.callFrame.url))&&(E.callFrame.url=(0,D.join)(b,(0,D.basename)(E.callFrame.url)));return R}T.rewriteAbsolutePaths=A})(L=e.Utils||(e.Utils={}))}),define(ne[182],ie([0,1,29]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InspectProfilingService=void 0;class n{constructor(){this._sessions=new Map}async startProfiling(T){const R=await(await new Promise((E,I)=>{J(["v8-inspect-profiler"],E,I)})).startProfiling({port:T.port,checkForPaused:!0}),b=(0,D.generateUuid)();return this._sessions.set(b,R),b}async stopProfiling(T){const A=this._sessions.get(T);if(!A)throw new Error(`UNKNOWN session '${T}'`);const R=await A.stop();return this._sessions.delete(T),R.profile}}e.InspectProfilingService=n}),define(ne[38],ie([0,1,99,15]),function(J,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class L{constructor(){this.data=new Map}add(A,R){D.ok(n.isString(A)),D.ok(n.isObject(R)),D.ok(!this.data.has(A),"There is already an extension with this id"),this.data.set(A,R)}knows(A){return this.data.has(A)}as(A){return this.data.get(A)||null}}e.Registry=new L}),define(ne[88],ie([0,1,3,38]),function(J,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function L(R){return R.length>0&&R.charAt(R.length-1)==="#"?R.substring(0,R.length-1):R}class T{constructor(){this._onDidChangeSchema=new D.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(b,E){this.schemasById[L(b)]=E,this._onDidChangeSchema.fire(b)}notifySchemaChanged(b){this._onDidChangeSchema.fire(b)}getSchemaContributions(){return{schemas:this.schemasById}}}const A=new T;n.Registry.add(e.Extensions.JSONContribution,A)}),define(ne[42],ie([0,1,16,3,15,125,88,38]),function(J,e,D,n,L,T,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var b;(function(p){p.Multiline="multilineText",p.Singleline="singlelineText"})(b=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var E;(function(p){p[p.APPLICATION=1]="APPLICATION",p[p.MACHINE=2]="MACHINE",p[p.WINDOW=3]="WINDOW",p[p.RESOURCE=4]="RESOURCE",p[p.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",p[p.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(E=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const I=R.Registry.as(A.Extensions.JSONContribution);class C{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new n.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new n.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:T.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(l,r=!0){this.registerConfigurations([l],r)}registerConfigurations(l,r=!0){const a=this.doRegisterConfigurations(l,r);I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a})}deregisterConfigurations(l){const r=this.doDeregisterConfigurations(l);I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}updateConfigurations({add:l,remove:r}){const a=[];a.push(...this.doDeregisterConfigurations(r)),a.push(...this.doRegisterConfigurations(l,!1)),I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,D.distinct)(a)})}registerDefaultConfigurations(l){const r=[],a=[];for(const{overrides:i,source:t}of l)for(const o in i)if(r.push(o),e.OVERRIDE_PROPERTY_REGEX.test(o)){const s={...this.configurationDefaultsOverrides.get(o)?.value||{},...i[o]};this.configurationDefaultsOverrides.set(o,{source:t,value:s});const c={type:"object",default:s,description:T.localize(1,null,o),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:s,source:L.isString(t)?void 0:t};a.push(...u(o)),this.configurationProperties[o]=c,this.defaultLanguageConfigurationOverridesNode.properties[o]=c}else{this.configurationDefaultsOverrides.set(o,{value:i[o],source:t});const s=this.configurationProperties[o];s&&(this.updatePropertyDefaultValue(o,s),this.updateSchema(o,s))}this.registerOverrideIdentifiers(a),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}deregisterDefaultConfigurations(l){const r=[];for(const{overrides:a,source:i}of l)for(const t in a){const o=this.configurationDefaultsOverrides.get(t),s=L.isString(i)?i:i?.id,c=L.isString(o?.source)?o?.source:o?.source?.id;if(s===c)if(r.push(t),this.configurationDefaultsOverrides.delete(t),e.OVERRIDE_PROPERTY_REGEX.test(t))delete this.configurationProperties[t],delete this.defaultLanguageConfigurationOverridesNode.properties[t];else{const h=this.configurationProperties[t];h&&(this.updatePropertyDefaultValue(t,h),this.updateSchema(t,h))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...l){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(l){for(const r of l)this.overrideIdentifiers.add(r);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(l,r){const a=[];return l.forEach(i=>{a.push(...this.validateAndRegisterProperties(i,r,i.extensionInfo,i.restrictedProperties)),this.configurationContributors.push(i),this.registerJSONConfiguration(i)}),a}doDeregisterConfigurations(l){const r=[],a=i=>{if(i.properties)for(const t in i.properties)r.push(t),delete this.configurationProperties[t],this.removeFromSchema(t,i.properties[t]);i.allOf&&i.allOf.forEach(t=>a(t))};for(const i of l){a(i);const t=this.configurationContributors.indexOf(i);t!==-1&&this.configurationContributors.splice(t,1)}return r}validateAndRegisterProperties(l,r=!0,a,i,t=3){t=L.isUndefinedOrNull(l.scope)?t:l.scope;let o=[],s=l.properties;if(s)for(let h in s){if(r&&w(h)){delete s[h];continue}const m=s[h];if(m.source=a,m.defaultDefaultValue=s[h].default,this.updatePropertyDefaultValue(h,m),e.OVERRIDE_PROPERTY_REGEX.test(h)?m.scope=void 0:(m.scope=L.isUndefinedOrNull(m.scope)?t:m.scope,m.restricted=L.isUndefinedOrNull(m.restricted)?!!i?.includes(h):m.restricted),s[h].hasOwnProperty("included")&&!s[h].included){this.excludedConfigurationProperties[h]=s[h],delete s[h];continue}else this.configurationProperties[h]=s[h];!s[h].deprecationMessage&&s[h].markdownDeprecationMessage&&(s[h].deprecationMessage=s[h].markdownDeprecationMessage),o.push(h)}let c=l.allOf;if(c)for(let h of c)o.push(...this.validateAndRegisterProperties(h,r,a,i,t));return o}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(l){const r=a=>{let i=a.properties;if(i)for(const o in i)this.updateSchema(o,i[o]);let t=a.allOf;t&&t.forEach(r)};r(l)}updateSchema(l,r){switch(e.allSettings.properties[l]=r,r.scope){case 1:e.applicationSettings.properties[l]=r;break;case 2:e.machineSettings.properties[l]=r;break;case 6:e.machineOverridableSettings.properties[l]=r;break;case 3:e.windowSettings.properties[l]=r;break;case 4:e.resourceSettings.properties[l]=r;break;case 5:e.resourceSettings.properties[l]=r,this.resourceLanguageSettingsSchema.properties[l]=r;break}}removeFromSchema(l,r){switch(delete e.allSettings.properties[l],r.scope){case 1:delete e.applicationSettings.properties[l];break;case 2:delete e.machineSettings.properties[l];break;case 6:delete e.machineOverridableSettings.properties[l];break;case 3:delete e.windowSettings.properties[l];break;case 4:case 5:delete e.resourceSettings.properties[l],delete this.resourceLanguageSettingsSchema.properties[l];break}}updateOverridePropertyPatternKey(){for(const l of this.overrideIdentifiers.values()){const r=`[${l}]`,a={type:"object",description:T.localize(2,null),errorMessage:T.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(r,a),e.allSettings.properties[r]=a,e.applicationSettings.properties[r]=a,e.machineSettings.properties[r]=a,e.machineOverridableSettings.properties[r]=a,e.windowSettings.properties[r]=a,e.resourceSettings.properties[r]=a}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const l={type:"object",description:T.localize(4,null),errorMessage:T.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(l,r){const a=this.configurationDefaultsOverrides.get(l);let i=a?.value,t=a?.source;L.isUndefined(i)&&(i=r.defaultDefaultValue,t=void 0),L.isUndefined(i)&&(i=d(r.type)),r.default=i,r.defaultValueSource=t}}const f="\\[([^\\]]+)\\]",S=new RegExp(f,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${f})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function u(p){const l=[];if(e.OVERRIDE_PROPERTY_REGEX.test(p)){let r=S.exec(p);for(;r?.length;){const a=r[1].trim();a&&l.push(a),r=S.exec(p)}}return(0,D.distinct)(l)}e.overrideIdentifiersFromKey=u;function v(p){return p.reduce((l,r)=>`${l}[${r}]`,"")}e.keyFromOverrideIdentifiers=v;function d(p){switch(Array.isArray(p)?p[0]:p){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=d;const g=new C;R.Registry.add(e.Extensions.Configuration,g);function w(p){return p.trim()?e.OVERRIDE_PROPERTY_REGEX.test(p)?T.localize(7,null,p):g.getConfigurationProperties()[p]!==void 0?T.localize(8,null,p):null:T.localize(6,null)}e.validateProperty=w;function y(){const p=[],l=g.getConfigurationProperties();for(const r of Object.keys(l))p.push([r,l[r].scope]);return p.push(["launch",4]),p.push(["task",4]),p}e.getScopes=y}),define(ne[89],ie([0,1,16,3,35,2,39,28,15,7,20,42,38]),function(J,e,D,n,L,T,A,R,b,E,I,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class S{constructor(i={},t=[],o=[]){this._contents=i,this._keys=t,this._overrides=o,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(i){return i?(0,I.getConfigurationValue)(this.contents,i):this.contents}getOverrideValue(i,t){const o=this.getContentsForOverrideIdentifer(t);return o?i?(0,I.getConfigurationValue)(o,i):o:void 0}getKeysForOverrideIdentifier(i){const t=[];for(const o of this.overrides)o.identifiers.includes(i)&&t.push(...o.keys);return D.distinct(t)}getAllOverrideIdentifiers(){const i=[];for(const t of this.overrides)i.push(...t.identifiers);return D.distinct(i)}override(i){let t=this.overrideConfigurations.get(i);return t||(t=this.createOverrideConfigurationModel(i),this.overrideConfigurations.set(i,t)),t}merge(...i){const t=R.deepClone(this.contents),o=R.deepClone(this.overrides),s=[...this.keys];for(const c of i){this.mergeContents(t,c.contents);for(const h of c.overrides){const[m]=o.filter(P=>D.equals(P.identifiers,h.identifiers));m?(this.mergeContents(m.contents,h.contents),m.keys.push(...h.keys),m.keys=D.distinct(m.keys)):o.push(R.deepClone(h))}for(const h of c.keys)s.indexOf(h)===-1&&s.push(h)}return new S(t,s,o)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(i){const t=this.getContentsForOverrideIdentifer(i);if(!t||typeof t!="object"||!Object.keys(t).length)return this;let o={};for(const s of D.distinct([...Object.keys(this.contents),...Object.keys(t)])){let c=this.contents[s],h=t[s];h&&(typeof c=="object"&&typeof h=="object"?(c=R.deepClone(c),this.mergeContents(c,h)):c=h),o[s]=c}return new S(o,this.keys,this.overrides)}mergeContents(i,t){for(const o of Object.keys(t)){if(o in i&&b.isObject(i[o])&&b.isObject(t[o])){this.mergeContents(i[o],t[o]);continue}i[o]=R.deepClone(t[o])}}checkAndFreeze(i){return this.isFrozen&&!Object.isFrozen(i)?R.deepFreeze(i):i}getContentsForOverrideIdentifer(i){let t=null,o=null;const s=c=>{c&&(o?this.mergeContents(o,c):o=R.deepClone(c))};for(const c of this.overrides)D.equals(c.identifiers,[i])?t=c.contents:c.identifiers.includes(i)&&s(c.contents);return s(t),o}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(i,t){this.addKey(i),(0,I.addToValueTree)(this.contents,i,t,o=>{throw new Error(o)})}removeValue(i){this.removeKey(i)&&(0,I.removeFromValueTree)(this.contents,i)}addKey(i){let t=this.keys.length;for(let o=0;o<t;o++)i.indexOf(this.keys[o])===0&&(t=o);this.keys.splice(t,1,i)}removeKey(i){let t=this.keys.indexOf(i);return t!==-1?(this.keys.splice(t,1),!0):!1}}e.ConfigurationModel=S;class u extends S{constructor(i={}){const t=f.Registry.as(C.Extensions.Configuration).getConfigurationProperties(),o=Object.keys(t),s=Object.create(null),c=[];for(const h in t){const m=i[h],P=m!==void 0?m:t[h].default;(0,I.addToValueTree)(s,h,P,_=>console.error(`Conflict in default settings: ${_}`))}for(const h of Object.keys(s))C.OVERRIDE_PROPERTY_REGEX.test(h)&&c.push({identifiers:(0,C.overrideIdentifiersFromKey)(h),keys:Object.keys(s[h]),contents:(0,I.toValuesTree)(s[h],m=>console.error(`Conflict in default settings file: ${m}`))});super(s,o,c)}}e.DefaultConfigurationModel=u;class v{constructor(i){this._name=i,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new S}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(i,t){if(!b.isUndefinedOrNull(i)){const o=this.doParseContent(i);this.parseRaw(o,t)}}reparse(i){this._raw&&this.parseRaw(this._raw,i)}parseRaw(i,t){this._raw=i;const{contents:o,keys:s,overrides:c,restricted:h}=this.doParseRaw(i,t);this._configurationModel=new S(o,s,c),this._restrictedConfigurations=h||[]}doParseContent(i){let t={},o=null,s=[],c=[],h=[];function m(_){Array.isArray(s)?s.push(_):o!==null&&(s[o]=_)}let P={onObjectBegin:()=>{let _={};m(_),c.push(s),s=_,o=null},onObjectProperty:_=>{o=_},onObjectEnd:()=>{s=c.pop()},onArrayBegin:()=>{let _=[];m(_),c.push(s),s=_,o=null},onArrayEnd:()=>{s=c.pop()},onLiteralValue:m,onError:(_,O,M)=>{h.push({error:_,offset:O,length:M})}};if(i)try{L.visit(i,P),t=s[0]||{}}catch(_){console.error(`Error while parsing settings file ${this._name}: ${_}`),this._parseErrors=[_]}return t}doParseRaw(i,t){const o=f.Registry.as(C.Extensions.Configuration).getConfigurationProperties(),s=this.filter(i,o,!0,t);i=s.raw;const c=(0,I.toValuesTree)(i,P=>console.error(`Conflict in settings file ${this._name}: ${P}`)),h=Object.keys(i),m=this.toOverrides(i,P=>console.error(`Conflict in settings file ${this._name}: ${P}`));return{contents:c,keys:h,overrides:m,restricted:s.restricted}}filter(i,t,o,s){if(!s?.scopes&&!s?.skipRestricted)return{raw:i,restricted:[]};const c={},h=[];for(let m in i)if(C.OVERRIDE_PROPERTY_REGEX.test(m)&&o){const P=this.filter(i[m],t,!1,s);c[m]=P.raw,h.push(...P.restricted)}else{const P=t[m],_=P?typeof P.scope!="undefined"?P.scope:3:void 0;P?.restricted&&h.push(m),(_===void 0||s.scopes===void 0||s.scopes.includes(_))&&(s.skipRestricted&&P?.restricted||(c[m]=i[m]))}return{raw:c,restricted:h}}toOverrides(i,t){const o=[];for(const s of Object.keys(i))if(C.OVERRIDE_PROPERTY_REGEX.test(s)){const c={};for(const h in i[s])c[h]=i[s][h];o.push({identifiers:(0,C.overrideIdentifiersFromKey)(s),keys:Object.keys(c),contents:(0,I.toValuesTree)(c,t)})}return o}}e.ConfigurationModelParser=v;class d extends T.Disposable{constructor(i,t,o,s){super();this.userSettingsResource=i,this.scopes=t,this.fileService=s,this._onDidChange=this._register(new n.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new v(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(o.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(n.Event.filter(this.fileService.onDidFilesChange,c=>c.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const i=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(i.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new S}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=d;class g{constructor(i,t,o=new S,s=new S,c=new A.ResourceMap,h=new S,m=new A.ResourceMap,P=!0){this._defaultConfiguration=i,this._localUserConfiguration=t,this._remoteUserConfiguration=o,this._workspaceConfiguration=s,this._folderConfigurations=c,this._memoryConfiguration=h,this._memoryConfigurationByResource=m,this._freeze=P,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new A.ResourceMap,this._userConfiguration=null}getValue(i,t,o){return this.getConsolidateConfigurationModel(t,o).getValue(i)}updateValue(i,t,o={}){let s;o.resource?(s=this._memoryConfigurationByResource.get(o.resource),s||(s=new S,this._memoryConfigurationByResource.set(o.resource,s))):s=this._memoryConfiguration,t===void 0?s.removeValue(i):s.setValue(i,t),o.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(i,t,o){const s=this.getConsolidateConfigurationModel(t,o),c=this.getFolderConfigurationModelForResource(t.resource,o),h=t.resource?this._memoryConfigurationByResource.get(t.resource)||this._memoryConfiguration:this._memoryConfiguration,m=t.overrideIdentifier?this._defaultConfiguration.freeze().override(t.overrideIdentifier).getValue(i):this._defaultConfiguration.freeze().getValue(i),P=t.overrideIdentifier?this.userConfiguration.freeze().override(t.overrideIdentifier).getValue(i):this.userConfiguration.freeze().getValue(i),_=t.overrideIdentifier?this.localUserConfiguration.freeze().override(t.overrideIdentifier).getValue(i):this.localUserConfiguration.freeze().getValue(i),O=t.overrideIdentifier?this.remoteUserConfiguration.freeze().override(t.overrideIdentifier).getValue(i):this.remoteUserConfiguration.freeze().getValue(i),M=o?t.overrideIdentifier?this._workspaceConfiguration.freeze().override(t.overrideIdentifier).getValue(i):this._workspaceConfiguration.freeze().getValue(i):void 0,k=c?t.overrideIdentifier?c.freeze().override(t.overrideIdentifier).getValue(i):c.freeze().getValue(i):void 0,U=t.overrideIdentifier?h.override(t.overrideIdentifier).getValue(i):h.getValue(i),N=s.getValue(i),V=D.distinct(D.flatten(s.overrides.map($=>$.identifiers))).filter($=>s.getOverrideValue(i,$)!==void 0);return{defaultValue:m,userValue:P,userLocalValue:_,userRemoteValue:O,workspaceValue:M,workspaceFolderValue:k,memoryValue:U,value:N,default:m!==void 0?{value:this._defaultConfiguration.freeze().getValue(i),override:t.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(i,t.overrideIdentifier):void 0}:void 0,user:P!==void 0?{value:this.userConfiguration.freeze().getValue(i),override:t.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(i,t.overrideIdentifier):void 0}:void 0,userLocal:_!==void 0?{value:this.localUserConfiguration.freeze().getValue(i),override:t.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(i,t.overrideIdentifier):void 0}:void 0,userRemote:O!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(i),override:t.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(i,t.overrideIdentifier):void 0}:void 0,workspace:M!==void 0?{value:this._workspaceConfiguration.freeze().getValue(i),override:t.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(i,t.overrideIdentifier):void 0}:void 0,workspaceFolder:k!==void 0?{value:c?.freeze().getValue(i),override:t.overrideIdentifier?c?.freeze().getOverrideValue(i,t.overrideIdentifier):void 0}:void 0,memory:U!==void 0?{value:h.getValue(i),override:t.overrideIdentifier?h.getOverrideValue(i,t.overrideIdentifier):void 0}:void 0,overrideIdentifiers:V.length?V:void 0}}keys(i){const t=this.getFolderConfigurationModelForResource(void 0,i);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:t?t.freeze().keys:[]}}updateDefaultConfiguration(i){this._defaultConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(i){this._localUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(i){this._remoteUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(i){this._workspaceConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(i,t){this._folderConfigurations.set(i,t),this._foldersConsolidatedConfigurations.delete(i)}deleteFolderConfiguration(i){this.folderConfigurations.delete(i),this._foldersConsolidatedConfigurations.delete(i)}compareAndUpdateDefaultConfiguration(i,t){const o=[];if(!t){const{added:s,updated:c,removed:h}=l(this._defaultConfiguration,i);t=[...s,...c,...h]}for(const s of t)for(const c of(0,C.overrideIdentifiersFromKey)(s)){const h=this._defaultConfiguration.getKeysForOverrideIdentifier(c),m=i.getKeysForOverrideIdentifier(c),P=[...m.filter(_=>h.indexOf(_)===-1),...h.filter(_=>m.indexOf(_)===-1),...h.filter(_=>!R.equals(this._defaultConfiguration.override(c).getValue(_),i.override(c).getValue(_)))];o.push([c,P])}return this.updateDefaultConfiguration(i),{keys:t,overrides:o}}compareAndUpdateLocalUserConfiguration(i){const{added:t,updated:o,removed:s,overrides:c}=l(this.localUserConfiguration,i),h=[...t,...o,...s];return h.length&&this.updateLocalUserConfiguration(i),{keys:h,overrides:c}}compareAndUpdateRemoteUserConfiguration(i){const{added:t,updated:o,removed:s,overrides:c}=l(this.remoteUserConfiguration,i);let h=[...t,...o,...s];return h.length&&this.updateRemoteUserConfiguration(i),{keys:h,overrides:c}}compareAndUpdateWorkspaceConfiguration(i){const{added:t,updated:o,removed:s,overrides:c}=l(this.workspaceConfiguration,i);let h=[...t,...o,...s];return h.length&&this.updateWorkspaceConfiguration(i),{keys:h,overrides:c}}compareAndUpdateFolderConfiguration(i,t){const o=this.folderConfigurations.get(i),{added:s,updated:c,removed:h,overrides:m}=l(o,t);let P=[...s,...c,...h];return(P.length||!o)&&this.updateFolderConfiguration(i,t),{keys:P,overrides:m}}compareAndDeleteFolderConfiguration(i){const t=this.folderConfigurations.get(i);if(!t)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:o,updated:s,removed:c,overrides:h}=l(t,void 0);return{keys:[...o,...s,...c],overrides:h}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(i,t){let o=this.getConsolidatedConfigurationModelForResource(i,t);return i.overrideIdentifier?o.override(i.overrideIdentifier):o}getConsolidatedConfigurationModelForResource({resource:i},t){let o=this.getWorkspaceConsolidatedConfiguration();if(t&&i){const s=t.getFolder(i);s&&(o=this.getFolderConsolidatedConfiguration(s.uri)||o);const c=this._memoryConfigurationByResource.get(i);c&&(o=o.merge(c))}return o}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(i){let t=this._foldersConsolidatedConfigurations.get(i);if(!t){const o=this.getWorkspaceConsolidatedConfiguration(),s=this._folderConfigurations.get(i);s?(t=o.merge(s),this._freeze&&(t=t.freeze()),this._foldersConsolidatedConfigurations.set(i,t)):t=o}return t}getFolderConfigurationModelForResource(i,t){if(t&&i){const o=t.getFolder(i);if(o)return this._folderConfigurations.get(o.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((i,t)=>{const{contents:o,overrides:s,keys:c}=this._folderConfigurations.get(t);return i.push([t,{contents:o,overrides:s,keys:c}]),i},[])}}allKeys(){const i=new Set;return this._defaultConfiguration.freeze().keys.forEach(t=>i.add(t)),this.userConfiguration.freeze().keys.forEach(t=>i.add(t)),this._workspaceConfiguration.freeze().keys.forEach(t=>i.add(t)),this._folderConfigurations.forEach(t=>t.freeze().keys.forEach(o=>i.add(o))),[...i.values()]}allOverrideIdentifiers(){const i=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>i.add(t)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>i.add(t)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>i.add(t)),this._folderConfigurations.forEach(t=>t.freeze().getAllOverrideIdentifiers().forEach(o=>i.add(o))),[...i.values()]}getAllKeysForOverrideIdentifier(i){const t=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(i).forEach(o=>t.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(o=>t.add(o)),this._workspaceConfiguration.getKeysForOverrideIdentifier(i).forEach(o=>t.add(o)),this._folderConfigurations.forEach(o=>o.getKeysForOverrideIdentifier(i).forEach(s=>t.add(s))),[...t.values()]}static parse(i){const t=this.parseConfigurationModel(i.defaults),o=this.parseConfigurationModel(i.user),s=this.parseConfigurationModel(i.workspace),c=i.folders.reduce((h,m)=>(h.set(E.URI.revive(m[0]),this.parseConfigurationModel(m[1])),h),new A.ResourceMap);return new g(t,o,new S,s,c,new S,new A.ResourceMap,!1)}static parseConfigurationModel(i){return new S(i.contents,i.keys,i.overrides).freeze()}}e.Configuration=g;function w(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const i=new Set,t=new Map;for(const s of a)s.keys.forEach(c=>i.add(c)),s.overrides.forEach(([c,h])=>{const m=(0,A.getOrSet)(t,c,new Set);h.forEach(P=>m.add(P))});const o=[];return t.forEach((s,c)=>o.push([c,[...s.values()]])),{keys:[...i.values()],overrides:o}}e.mergeChanges=w;class y{constructor(i,t,o,s){this.change=i,this.previous=t,this.currentConfiguraiton=o,this.currentWorkspace=s,this._previousConfiguration=void 0;const c=new Set;i.keys.forEach(m=>c.add(m)),i.overrides.forEach(([,m])=>m.forEach(P=>c.add(P))),this.affectedKeys=[...c.values()];const h=new S;this.affectedKeys.forEach(m=>h.setValue(m,{})),this.affectedKeysTree=h.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=g.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(i,t){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,i)){if(t){const o=this.previousConfiguration?this.previousConfiguration.getValue(i,t,this.previous?.workspace):void 0,s=this.currentConfiguraiton.getValue(i,t,this.currentWorkspace);return!R.equals(o,s)}return!0}return!1}doesAffectedKeysTreeContains(i,t){let o=(0,I.toValuesTree)({[t]:!0},()=>{}),s;for(;typeof o=="object"&&(s=Object.keys(o)[0]);){if(i=i[s],!i)return!1;o=o[s]}return!0}}e.ConfigurationChangeEvent=y;class p extends y{constructor(i,t,o,s){super({keys:i.allKeys(),overrides:[]},void 0,i,t);this.source=o,this.sourceConfig=s}}e.AllKeysConfigurationChangeEvent=p;function l(a,i){const{added:t,removed:o,updated:s}=r(i,a),c=[],h=a?.getAllOverrideIdentifiers()||[],m=i?.getAllOverrideIdentifiers()||[];if(i){const P=m.filter(_=>!h.includes(_));for(const _ of P)c.push([_,i.getKeysForOverrideIdentifier(_)])}if(a){const P=h.filter(_=>!m.includes(_));for(const _ of P)c.push([_,a.getKeysForOverrideIdentifier(_)])}if(i&&a){for(const P of h)if(m.includes(P)){const _=r({contents:a.getOverrideValue(void 0,P)||{},keys:a.getKeysForOverrideIdentifier(P)},{contents:i.getOverrideValue(void 0,P)||{},keys:i.getKeysForOverrideIdentifier(P)});c.push([P,[..._.added,..._.removed,..._.updated]])}}return{added:t,removed:o,updated:s,overrides:c}}function r(a,i){const t=a?i?a.keys.filter(c=>i.keys.indexOf(c)===-1):[...a.keys]:[],o=i?a?i.keys.filter(c=>a.keys.indexOf(c)===-1):[...i.keys]:[],s=[];if(a&&i){for(const c of i.keys)if(a.keys.indexOf(c)!==-1){const h=(0,I.getConfigurationValue)(i.contents,c),m=(0,I.getConfigurationValue)(a.contents,c);R.equals(h,m)||s.push(c)}}return{added:t,removed:o,updated:s}}}),define(ne[183],ie([0,1,5,3,2,19,20,89,42,38]),function(J,e,D,n,L,T,A,R,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class I extends L.Disposable{constructor(f,S){super();this.settingsResource=f,this._onDidChangeConfiguration=this._register(new n.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new R.UserSettings(this.settingsResource,void 0,T.extUriBiasedIgnorePathCase,S)),this.configuration=new R.Configuration(new R.DefaultConfigurationModel,new R.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new D.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(E.Registry.as(b.Extensions.Configuration).onDidUpdateConfiguration(({properties:u})=>this.onDidDefaultConfigurationChange(u))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const f=await this.userConfiguration.loadConfiguration();this.configuration=new R.Configuration(new R.DefaultConfigurationModel,f)}getConfigurationData(){return this.configuration.toData()}getValue(f,S){const u=typeof f=="string"?f:void 0,v=(0,A.isConfigurationOverrides)(f)?f:(0,A.isConfigurationOverrides)(S)?S:{};return this.configuration.getValue(u,v,void 0)}updateValue(f,S,u,v){return Promise.reject(new Error("not supported"))}inspect(f){return this.configuration.inspect(f,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const f=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(f)}onDidChangeUserConfiguration(f){const S=this.configuration.toData(),u=this.configuration.compareAndUpdateLocalUserConfiguration(f);this.trigger(u,S,1)}onDidDefaultConfigurationChange(f){const S=this.configuration.toData(),u=this.configuration.compareAndUpdateDefaultConfiguration(new R.DefaultConfigurationModel,f);this.trigger(u,S,6)}trigger(f,S,u){const v=new R.ConfigurationChangeEvent(f,{data:S},this.configuration);v.source=u,v.sourceConfig=this.getTargetConfiguration(u),this._onDidChangeConfiguration.fire(v)}getTargetConfiguration(f){switch(f){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=I}),define(ne[184],ie([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,D.createDecorator)("remoteAuthorityResolverService");var n;(function(T){T.Unknown="Unknown",T.NotAvailable="NotAvailable",T.TemporarilyNotAvailable="TemporarilyNotAvailable",T.NoResolverFound="NoResolverFound"})(n=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class L extends Error{constructor(A,R=n.Unknown,b){super(A);this._message=A,this._code=R,this._detail=b,this.isHandled=R===n.NotAvailable&&b===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,L.prototype)}static isTemporarilyNotAvailable(A){return A instanceof L&&A._code===n.TemporarilyNotAvailable}static isNoResolverFound(A){return A instanceof L&&A._code===n.NoResolverFound}static isHandled(A){return A instanceof L&&A.isHandled}}e.RemoteAuthorityResolverError=L}),define(ne[185],ie([0,1,5,17,23,9,3,2,29,73,184]),function(J,e,D,n,L,T,A,R,b,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const C=30*1e3;var f;(function(H){H[H.Management=1]="Management",H[H.ExtensionHost=2]="ExtensionHost",H[H.Tunnel=3]="Tunnel"})(f=e.ConnectionType||(e.ConnectionType={}));function S(H){switch(H){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function u(H){const Q=new L.CancellationTokenSource;return setTimeout(()=>Q.cancel(),H),Q.token}function v(H,Q){if(H.isCancellationRequested||Q.isCancellationRequested)return L.CancellationToken.Cancelled;const Z=new L.CancellationTokenSource;return H.onCancellationRequested(()=>Z.cancel()),Q.onCancellationRequested(()=>Z.cancel()),Z.token}class d{constructor(Q){this._state="pending",this._disposables=new R.DisposableStore,this.promise=new Promise((Z,B)=>{this._resolvePromise=Z,this._rejectPromise=B}),Q.isCancellationRequested?this._timeout():this._disposables.add(Q.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(Q){this._state==="pending"?this._disposables.add(Q):Q.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const Q=new Error("Time limit reached");return Q.code="ETIMEDOUT",Q.syscall="connect",Q}resolve(Q){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(Q))}reject(Q){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(Q))}}function g(H,Q){const Z=new d(Q);return Z.registerDisposable(H.onControlMessage(B=>{const F=JSON.parse(B.toString()),x=G(F);x?Z.reject(x):Z.resolve(F)})),Z.promise}function w(H,Q,Z,B,F,x,z){const q=new d(z);return Q.connect(Z,B,F,x,(ee,se)=>{q.didTimeout?(ee&&H.error(ee),se?.dispose()):ee||!se?q.reject(ee):q.resolve(se)}),q.promise}function y(H,Q){const Z=new d(Q);return H.then(B=>{Z.didTimeout||Z.resolve(B)},B=>{Z.didTimeout||Z.reject(B)}),Z.promise}async function p(H,Q,Z,B){const F=j(H,Q);H.logService.trace(`${F} 1/6. invoking socketFactory.connect().`);let x;try{x=await w(H.logService,H.socketFactory,H.host,H.port,`reconnectionToken=${H.reconnectionToken}&reconnection=${H.reconnectionProtocol?"true":"false"}`,`renderer-${S(Q)}-${H.reconnectionToken}`,B)}catch(ce){throw H.logService.error(`${F} socketFactory.connect() failed or timed out. Error:`),H.logService.error(ce),ce}H.logService.trace(`${F} 2/6. socketFactory.connect() was successful.`);let z,q;H.reconnectionProtocol?(H.reconnectionProtocol.beginAcceptReconnection(x,null),z=H.reconnectionProtocol,q=!1):(z=new E.PersistentProtocol(x,null),q=!0),H.logService.trace(`${F} 3/6. sending AuthRequest control message.`);const ee=await y(H.signService.createNewMessage((0,b.generateUuid)()),B),se={type:"auth",auth:H.connectionToken||"00000000000000000000",data:ee.data};z.sendControl(n.VSBuffer.fromString(JSON.stringify(se)));try{const ce=await g(z,v(B,u(1e4)));if(ce.type!=="sign"||typeof ce.data!="string"){const Ie=new Error("Unexpected handshake message");throw Ie.code="VSCODE_CONNECTION_ERROR",Ie}if(H.logService.trace(`${F} 4/6. received SignRequest control message.`),!await y(H.signService.validate(ee,ce.signedData),B)){const Ie=new Error("Refused to connect to unsupported server");throw Ie.code="VSCODE_CONNECTION_ERROR",Ie}const ve=await y(H.signService.sign(ce.data),B),pe={type:"connectionType",commit:H.commit,signedData:ve,desiredConnectionType:Q};return Z&&(pe.args=Z),H.logService.trace(`${F} 5/6. sending ConnectionTypeRequest control message.`),z.sendControl(n.VSBuffer.fromString(JSON.stringify(pe))),{protocol:z,ownsProtocol:q}}catch(ce){throw ce&&ce.code==="ETIMEDOUT"&&(H.logService.error(`${F} the handshake timed out. Error:`),H.logService.error(ce)),ce&&ce.code==="VSCODE_CONNECTION_ERROR"&&(H.logService.error(`${F} received error control message when negotiating connection. Error:`),H.logService.error(ce)),q&&$(z),ce}}async function l(H,Q,Z,B){const F=Date.now(),x=j(H,Q),{protocol:z,ownsProtocol:q}=await p(H,Q,Z,B),ee=new d(B);return ee.registerDisposable(z.onControlMessage(se=>{const ce=JSON.parse(se.toString()),ue=G(ce);ue?(H.logService.error(`${x} received error control message when negotiating connection. Error:`),H.logService.error(ue),q&&$(z),ee.reject(ue)):(H.reconnectionProtocol&&H.reconnectionProtocol.endAcceptReconnection(),H.logService.trace(`${x} 6/6. handshake finished, connection is up and running after ${K(F)}!`),ee.resolve({protocol:z,firstMessage:ce}))})),ee.promise}async function r(H,Q){const{protocol:Z}=await l(H,1,void 0,Q);return{protocol:Z}}async function a(H,Q,Z){const{protocol:B,firstMessage:F}=await l(H,2,Q,Z),x=F&&F.debugPort;return{protocol:B,debugPort:x}}async function i(H,Q,Z){const B=Date.now(),F=j(H,3),{protocol:x}=await p(H,3,Q,Z);return H.logService.trace(`${F} 6/6. handshake finished, connection is up and running after ${K(B)}!`),x}async function t(H,Q,Z){const{host:B,port:F,connectionToken:x}=await H.addressProvider.getAddress();return{commit:H.commit,host:B,port:F,connectionToken:x,reconnectionToken:Q,reconnectionProtocol:Z,socketFactory:H.socketFactory,signService:H.signService,logService:H.logService}}async function o(H,Q,Z){try{const B=(0,b.generateUuid)(),F=await t(H,B,null),{protocol:x}=await r(F,L.CancellationToken.None);return new N(H,Q,Z,B,x)}catch(B){throw H.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),H.logService.error(B),U.triggerPermanentFailure(0,0,I.RemoteAuthorityResolverError.isHandled(B)),B}}e.connectRemoteAgentManagement=o;async function s(H,Q){try{const Z=(0,b.generateUuid)(),B=await t(H,Z,null),{protocol:F,debugPort:x}=await a(B,Q,L.CancellationToken.None);return new V(H,Q,Z,F,x)}catch(Z){throw H.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),H.logService.error(Z),U.triggerPermanentFailure(0,0,I.RemoteAuthorityResolverError.isHandled(Z)),Z}}e.connectRemoteAgentExtensionHost=s;async function c(H,Q,Z){const B=await t(H,(0,b.generateUuid)(),null);return await i(B,{host:Q,port:Z},L.CancellationToken.None)}e.connectRemoteAgentTunnel=c;function h(H){return(0,D.createCancelablePromise)(Q=>new Promise((Z,B)=>{const F=setTimeout(Z,H*1e3);Q.onCancellationRequested(()=>{clearTimeout(F),Z()})}))}var m;(function(H){H[H.ConnectionLost=0]="ConnectionLost",H[H.ReconnectionWait=1]="ReconnectionWait",H[H.ReconnectionRunning=2]="ReconnectionRunning",H[H.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",H[H.ConnectionGain=4]="ConnectionGain"})(m=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class P{constructor(Q,Z){this.reconnectionToken=Q,this.millisSinceLastIncomingData=Z,this.type=0}}e.ConnectionLostEvent=P;class _{constructor(Q,Z,B,F){this.reconnectionToken=Q,this.millisSinceLastIncomingData=Z,this.durationSeconds=B,this.cancellableTimer=F,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=_;class O{constructor(Q,Z,B){this.reconnectionToken=Q,this.millisSinceLastIncomingData=Z,this.attempt=B,this.type=2}}e.ReconnectionRunningEvent=O;class M{constructor(Q,Z,B){this.reconnectionToken=Q,this.millisSinceLastIncomingData=Z,this.attempt=B,this.type=4}}e.ConnectionGainEvent=M;class k{constructor(Q,Z,B,F){this.reconnectionToken=Q,this.millisSinceLastIncomingData=Z,this.attempt=B,this.handled=F,this.type=3}}e.ReconnectionPermanentFailureEvent=k;class U extends R.Disposable{constructor(Q,Z,B,F){super();this._connectionType=Q,this._onDidStateChange=this._register(new A.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._options=Z,this.reconnectionToken=B,this.protocol=F,this._isReconnecting=!1,this._onDidStateChange.fire(new M(this.reconnectionToken,0,0)),this._register(F.onSocketClose(x=>{const z=W(this._connectionType,this.reconnectionToken,!0);x?x.type===0?(this._options.logService.info(`${z} received socket close event (hadError: ${x.hadError}).`),x.error&&this._options.logService.error(x.error)):(this._options.logService.info(`${z} received socket close event (wasClean: ${x.wasClean}, code: ${x.code}, reason: ${x.reason}).`),x.event&&this._options.logService.error(x.event)):this._options.logService.info(`${z} received socket close event.`),this._beginReconnecting()})),this._register(F.onSocketTimeout(()=>{const x=W(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${x} received socket timeout event.`),this._beginReconnecting()})),U._instances.push(this),U._permanentFailure&&this._gotoPermanentFailure(U._permanentFailureMillisSinceLastIncomingData,U._permanentFailureAttempt,U._permanentFailureHandled)}static triggerPermanentFailure(Q,Z,B){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=Q,this._permanentFailureAttempt=Z,this._permanentFailureHandled=B,this._instances.forEach(F=>F._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(Q=>Q._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(Q=>Q._pauseSocketWriting())}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(U._permanentFailure)return;const Q=W(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${Q} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new P(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const Z=[0,5,5,10,10,10,10,10,30];let B=-1;do{B++;const F=B<Z.length?Z[B]:Z[Z.length-1];try{if(F>0){const z=h(F);this._onDidStateChange.fire(new _(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),F,z)),this._options.logService.info(`${Q} waiting for ${F} seconds before reconnecting...`);try{await z}catch{}}if(U._permanentFailure){this._options.logService.error(`${Q} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new O(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),B+1)),this._options.logService.info(`${Q} resolving connection...`);const x=await t(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${Q} connecting to ${x.host}:${x.port}...`),await this._reconnect(x,u(C)),this._options.logService.info(`${Q} reconnected!`),this._onDidStateChange.fire(new M(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),B+1));break}catch(x){if(x.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${Q} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(x),U.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),B+1,!1);break}if(B>360){this._options.logService.error(`${Q} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(x),U.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),B+1,!1);break}if(I.RemoteAuthorityResolverError.isTemporarilyNotAvailable(x)){this._options.logService.info(`${Q} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(x);continue}if((x.code==="ETIMEDOUT"||x.code==="ENETUNREACH"||x.code==="ECONNREFUSED"||x.code==="ECONNRESET")&&x.syscall==="connect"){this._options.logService.info(`${Q} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(x);continue}if((0,T.isCancellationError)(x)){this._options.logService.info(`${Q} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(x);continue}if(x instanceof I.RemoteAuthorityResolverError){this._options.logService.error(`${Q} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(x),U.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),B+1,I.RemoteAuthorityResolverError.isHandled(x));break}this._options.logService.error(`${Q} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(x),U.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),B+1,!1);break}}while(!U._permanentFailure)}_gotoPermanentFailure(Q,Z,B){this._onDidStateChange.fire(new k(this.reconnectionToken,Q,Z,B)),$(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=U,U._permanentFailure=!1,U._permanentFailureMillisSinceLastIncomingData=0,U._permanentFailureAttempt=0,U._permanentFailureHandled=!1,U._instances=[];class N extends U{constructor(Q,Z,B,F,x){super(1,Q,F,x);this.client=this._register(new E.Client(x,{remoteAuthority:Z,clientId:B},Q.ipcLogger))}async _reconnect(Q,Z){await r(Q,Z)}}e.ManagementPersistentConnection=N;class V extends U{constructor(Q,Z,B,F,x){super(2,Q,B,F);this._startArguments=Z,this.debugPort=x}async _reconnect(Q,Z){await a(Q,this._startArguments,Z)}}e.ExtensionHostPersistentConnection=V;function $(H){try{H.acceptDisconnect();const Q=H.getSocket();H.dispose(),Q.dispose()}catch(Q){(0,T.onUnexpectedError)(Q)}}function G(H){if(H&&H.type==="error"){const Q=new Error(`Connection error: ${H.reason}`);return Q.code="VSCODE_CONNECTION_ERROR",Q}return null}function te(H,Q){for(;H.length<Q;)H+=" ";return H}function W(H,Q,Z){return`[remote-connection][${te(S(H),13)}][${Q.substr(0,5)}\u2026][${Z?"reconnect":"initial"}]`}function j(H,Q){return`${W(Q,H.reconnectionToken,!!H.reconnectionProtocol)}[${H.host}:${H.port}]`}function K(H){return`${Date.now()-H} ms`}}),define(ne[186],ie([0,1,18]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function n(E){return E.scheme===D.Schemas.vscodeRemote?E.authority:void 0}e.getRemoteAuthority=n;function L(E){if(!E)return;const I=E.indexOf("+");return I<0?E:E.substr(0,I)}e.getRemoteName=L;function T(E){return E.scheme!==D.Schemas.file&&E.scheme!==D.Schemas.vscodeRemote}e.isVirtualResource=T;function A(E){if(E.folders.length)return E.folders.every(I=>T(I.uri))?E.folders[0].uri:void 0;if(E.configuration&&T(E.configuration))return E.configuration}e.getVirtualWorkspaceLocation=A;function R(E){return A(E)?.scheme}e.getVirtualWorkspaceScheme=R;function b(E){return A(E)!==void 0}e.isVirtualWorkspace=b}),define(ne[90],ie([0,1,27,6,186]),function(J,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function T(f){if(typeof f=="object"&&f!==null&&f.supported!==!0)return f.description}e.getWorkspaceSupportTypeMessage=T;function A(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.isIExtensionIdentifier=A,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(f){f[f.System=0]="System",f[f.User=1]="User"})(R=e.ExtensionType||(e.ExtensionType={}));class b{constructor(S){this.value=S,this._lower=S.toLowerCase()}static equals(S,u){if(typeof S=="undefined"||S===null)return typeof u=="undefined"||u===null;if(typeof u=="undefined"||u===null)return!1;if(typeof S=="string"||typeof u=="string"){let v=typeof S=="string"?S:S.value,d=typeof u=="string"?u:u.value;return D.equalsIgnoreCase(v,d)}return S._lower===u._lower}static toKey(S){return typeof S=="string"?S.toLowerCase():S._lower}}e.ExtensionIdentifier=b;function E(f){return f.contributes&&f.contributes.localizations?f.contributes.localizations.length>0:!1}e.isLanguagePackExtension=E;function I(f){return f.contributes&&f.contributes.authentication?f.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=I;function C(f,S){if(S){const u=`onResolveRemoteAuthority:${(0,L.getRemoteName)(S)}`;return f.activationEvents?.indexOf(u)!==-1}return!1}e.isResolverExtension=C,e.IBuiltinExtensionsScannerService=(0,n.createDecorator)("IBuiltinExtensionsScannerService")}),define(ne[31],ie([0,1,27,90]),function(J,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function L(u,v){return u.uuid&&v.uuid?u.uuid===v.uuid:u.id===v.id?!0:(0,D.compareIgnoreCase)(u.id,v.id)===0}e.areSameExtensions=L;class T{constructor(v,d){this.version=d,this.id=v.id,this.uuid=v.uuid}key(){return`${this.id}-${this.version}`}equals(v){return v instanceof T?L(this,v)&&this.version===v.version:!1}}e.ExtensionIdentifierWithVersion=T;function A(u,v){return`${u}.${v}`}e.getExtensionId=A;function R(u){return u.toLocaleLowerCase()}e.adoptToGalleryExtensionId=R;function b(u,v){return R(A(u,v))}e.getGalleryExtensionId=b;function E(u,v){const d=[],g=w=>{for(const y of d)if(y.some(p=>L(v(p),v(w))))return y;return null};for(const w of u){const y=g(w);y?y.push(w):d.push([w])}return d}e.groupByExtension=E;function I(u){return{id:u.identifier.id,name:u.manifest.name,galleryId:null,publisherId:u.publisherId,publisherName:u.manifest.publisher,publisherDisplayName:u.publisherDisplayName,dependencies:u.manifest.extensionDependencies&&u.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=I;function C(u){return{id:u.identifier.id,name:u.name,galleryId:u.identifier.uuid,publisherId:u.publisherId,publisherName:u.publisher,publisherDisplayName:u.publisherDisplayName,isPreReleaseVersion:u.properties.isPreReleaseVersion,dependencies:!!(u.properties.dependencies&&u.properties.dependencies.length>0),...u.telemetryData}}e.getGalleryExtensionTelemetryData=C,e.BetterMergeId=new n.ExtensionIdentifier("pprice.better-merge");function f(u){const v=new Set;if(u.malicious)for(const d of u.malicious)v.add(d.id);return v}e.getMaliciousExtensionsSet=f;function S(u,v){const d=[],g=v.manifest.extensionDependencies?.slice(0)??[];for(;g.length;){const w=g.shift();if(w&&d.every(y=>!L(y.identifier,{id:w}))){const y=u.filter(p=>L(p.identifier,{id:w}));y.length===1&&(d.push(y[0]),g.push(...y[0].manifest.extensionDependencies?.slice(0)??[]))}}return d}e.getExtensionDependencies=S}),define(ne[30],ie([0,1,18,130,31,6]),function(J,e,D,n,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.getIdAndVersion=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";const A=/^([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;function R(r){const a=A.exec(r);return a&&a[1]?[(0,L.adoptToGalleryExtensionId)(a[1]),a[2]]:[(0,L.adoptToGalleryExtensionId)(r),void 0]}e.getIdAndVersion=R;var b;(function(r){r.WIN32_X64="win32-x64",r.WIN32_IA32="win32-ia32",r.WIN32_ARM64="win32-arm64",r.LINUX_X64="linux-x64",r.LINUX_ARM64="linux-arm64",r.LINUX_ARMHF="linux-armhf",r.ALPINE_X64="alpine-x64",r.ALPINE_ARM64="alpine-arm64",r.DARWIN_X64="darwin-x64",r.DARWIN_ARM64="darwin-arm64",r.WEB="web",r.UNIVERSAL="universal",r.UNKNOWN="unknown",r.UNDEFINED="undefined"})(b=e.TargetPlatform||(e.TargetPlatform={}));function E(r){switch(r){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=E;function I(r){switch(r){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=I;function C(r,a){switch(r){case 3:return a==="x64"?"win32-x64":a==="ia32"?"win32-ia32":a==="arm64"?"win32-arm64":"unknown";case 2:return a==="x64"?"linux-x64":a==="arm64"?"linux-arm64":a==="arm"?"linux-armhf":"unknown";case"alpine":return a==="x64"?"alpine-x64":a==="arm64"?"alpine-arm64":"unknown";case 1:return a==="x64"?"darwin-x64":a==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=C;function f(r,a){return a==="web"&&!r.includes("web")}e.isNotWebExtensionInWebTargetPlatform=f;function S(r,a,i){return f(a,i)?!1:r==="undefined"||r==="universal"?!0:r==="unknown"?!1:r===i?!0:u(i).includes(r)}e.isTargetPlatformCompatible=S;function u(r){switch(r){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=u;function v(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(!r.uuid||typeof r.uuid=="string")}e.isIExtensionIdentifier=v;var d;(function(r){r[r.NoneOrRelevance=0]="NoneOrRelevance",r[r.LastUpdatedDate=1]="LastUpdatedDate",r[r.Title=2]="Title",r[r.PublisherName=3]="PublisherName",r[r.InstallCount=4]="InstallCount",r[r.PublishedDate=10]="PublishedDate",r[r.AverageRating=6]="AverageRating",r[r.WeightedRating=12]="WeightedRating"})(d=e.SortBy||(e.SortBy={}));var g;(function(r){r[r.Default=0]="Default",r[r.Ascending=1]="Ascending",r[r.Descending=2]="Descending"})(g=e.SortOrder||(e.SortOrder={}));var w;(function(r){r.Install="install",r.Uninstall="uninstall"})(w=e.StatisticType||(e.StatisticType={}));var y;(function(r){r[r.None=1]="None",r[r.Install=2]="Install",r[r.Update=3]="Update",r[r.Migrate=4]="Migrate"})(y=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,T.createDecorator)("extensionGalleryService");var p;(function(r){r.Unsupported="Unsupported",r.UnsupportedPreRelease="UnsupportedPreRelease",r.Malicious="Malicious",r.Incompatible="Incompatible",r.IncompatiblePreRelease="IncompatiblePreRelease",r.IncompatibleTargetPlatform="IncompatibleTargetPlatform",r.ReleaseVersionNotFound="ReleaseVersionNotFound",r.Invalid="Invalid",r.Download="Download",r.Extract="Extract",r.Delete="Delete",r.Rename="Rename",r.CorruptZip="CorruptZip",r.IncompleteZip="IncompleteZip",r.Internal="Internal"})(p=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class l extends Error{constructor(a,i){super(a);this.code=i,this.name=i}}e.ExtensionManagementError=l,e.IExtensionManagementService=(0,T.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,T.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,T.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=D.FileAccess.asBrowserUri("./media/defaultIcon.png",J).toString(!0),e.ExtensionsLabel=(0,n.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,n.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,T.createDecorator)("IExtensionManagementCLIService")}),define(ne[187],ie([0,1,3,2,28,7,110,30]),function(J,e,D,n,L,T,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function b(v,d){return T.URI.revive(d?d.transformIncoming(v):v)}function E(v,d){return d?d.transformOutgoingURI(v):v}function I(v,d){d=d||A.DefaultURITransformer;const g=v.manifest;return{...(0,A.transformAndReviveIncomingURIs)({...v,manifest:void 0},d),manifest:g}}function C(v,d){return d?(0,L.cloneAndChange)(v,g=>g instanceof T.URI?d.transformOutgoingURI(g):void 0):v}class f{constructor(d,g){this.service=d,this.getUriTransformer=g,this.onInstallExtension=D.Event.buffer(d.onInstallExtension,!0),this.onDidInstallExtensions=D.Event.buffer(d.onDidInstallExtensions,!0),this.onUninstallExtension=D.Event.buffer(d.onUninstallExtension,!0),this.onDidUninstallExtension=D.Event.buffer(d.onDidUninstallExtension,!0)}listen(d,g){const w=this.getUriTransformer(d);switch(g){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return D.Event.map(this.onDidInstallExtensions,y=>y.map(p=>({...p,local:p.local?C(p.local,w):p.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(d,g,w){const y=this.getUriTransformer(d);switch(g){case"zip":return this.service.zip(I(w[0],y)).then(p=>E(p,y));case"unzip":return this.service.unzip(b(w[0],y));case"install":return this.service.install(b(w[0],y),w[1]);case"getManifest":return this.service.getManifest(b(w[0],y));case"getTargetPlatform":return this.service.getTargetPlatform();case"canInstall":return this.service.canInstall(w[0]);case"installFromGallery":return this.service.installFromGallery(w[0],w[1]);case"uninstall":return this.service.uninstall(I(w[0],y),w[1]);case"reinstallFromGallery":return this.service.reinstallFromGallery(I(w[0],y));case"getInstalled":return this.service.getInstalled(w[0]).then(p=>p.map(l=>C(l,y)));case"updateMetadata":return this.service.updateMetadata(I(w[0],y),w[1]).then(p=>C(p,y));case"updateExtensionScope":return this.service.updateExtensionScope(I(w[0],y),w[1]).then(p=>C(p,y));case"getExtensionsControlManifest":return this.service.getExtensionsControlManifest()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=f;class S extends n.Disposable{constructor(d){super();this.channel=d,this._onInstallExtension=this._register(new D.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new D.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new D.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new D.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this._register(this.channel.listen("onInstallExtension")(g=>this._onInstallExtension.fire({identifier:g.identifier,source:this.isUriComponents(g.source)?T.URI.revive(g.source):g.source}))),this._register(this.channel.listen("onDidInstallExtensions")(g=>this._onDidInstallExtensions.fire(g.map(w=>({...w,local:w.local?I(w.local,null):w.local,source:this.isUriComponents(w.source)?T.URI.revive(w.source):w.source}))))),this._register(this.channel.listen("onUninstallExtension")(g=>this._onUninstallExtension.fire(g))),this._register(this.channel.listen("onDidUninstallExtension")(g=>this._onDidUninstallExtension.fire(g)))}isUriComponents(d){return d?typeof d.path=="string"&&typeof d.scheme=="string":!1}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=this.channel.call("getTargetPlatform")),this._targetPlatformPromise}async canInstall(d){const g=await this.getTargetPlatform();return d.allTargetPlatforms.some(w=>(0,R.isTargetPlatformCompatible)(w,d.allTargetPlatforms,g))}zip(d){return Promise.resolve(this.channel.call("zip",[d]).then(g=>T.URI.revive(g)))}unzip(d){return Promise.resolve(this.channel.call("unzip",[d]))}install(d,g){return Promise.resolve(this.channel.call("install",[d,g])).then(w=>I(w,null))}getManifest(d){return Promise.resolve(this.channel.call("getManifest",[d]))}installFromGallery(d,g){return Promise.resolve(this.channel.call("installFromGallery",[d,g])).then(w=>I(w,null))}uninstall(d,g){return Promise.resolve(this.channel.call("uninstall",[d,g]))}reinstallFromGallery(d){return Promise.resolve(this.channel.call("reinstallFromGallery",[d]))}getInstalled(d=null){return Promise.resolve(this.channel.call("getInstalled",[d])).then(g=>g.map(w=>I(w,null)))}updateMetadata(d,g){return Promise.resolve(this.channel.call("updateMetadata",[d,g])).then(w=>I(w,null))}updateExtensionScope(d,g){return Promise.resolve(this.channel.call("updateExtensionScope",[d,g])).then(w=>I(w,null))}getExtensionsControlManifest(){return Promise.resolve(this.channel.call("getExtensionsControlManifest"))}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=S;class u{constructor(d){this.service=d}listen(d,g){throw new Error("Invalid listen")}call(d,g,w){switch(g){case"getConfigBasedTips":return this.service.getConfigBasedTips(T.URI.revive(w[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=u}),define(ne[188],ie([0,1,23,31]),function(J,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.migrateUnsupportedExtensions=void 0;async function L(T,A,R,b,E){try{const I=await T.getExtensionsControlManifest();if(!I.unsupportedPreReleaseExtensions)return;const C=await T.getInstalled(1);for(const[f,{id:S,migrateStorage:u}]of Object.entries(I.unsupportedPreReleaseExtensions)){const v=C.find(g=>(0,n.areSameExtensions)(g.identifier,{id:f}));if(!v)continue;const d=(await A.getExtensions([{id:S,preRelease:!0}],{targetPlatform:await T.getTargetPlatform(),compatible:!0},D.CancellationToken.None))[0];if(!d){E.info(`Skipping migrating '${v.identifier.id}' extension because, the comaptible target '${S}' extension is not found`);continue}try{E.info(`Migrating '${v.identifier.id}' extension to '${S}' extension...`);const g=!b.getDisabledExtensions().some(y=>(0,n.areSameExtensions)(y,v.identifier));await T.uninstall(v),E.info(`Uninstalled the unsupported extension '${v.identifier.id}'`);let w=C.find(y=>(0,n.areSameExtensions)(y.identifier,{id:S}));(!w||!w.isPreReleaseVersion&&g)&&(w=await T.installFromGallery(d,{installPreReleaseVersion:!0,isMachineScoped:v.isMachineScoped,operation:4}),E.info(`Installed the pre-release extension '${w.identifier.id}'`),g||(await b.disableExtension(w.identifier),E.info(`Disabled the pre-release extension '${w.identifier.id}' because the unsupported extension '${v.identifier.id}' is disabled`)),u&&(R.addToMigrationList((0,n.getExtensionId)(v.manifest.publisher,v.manifest.name),(0,n.getExtensionId)(w.manifest.publisher,w.manifest.name)),E.info("Added pre-release extension to the storage migration list"))),E.info(`Migrated '${v.identifier.id}' extension to '${S}' extension.`)}catch(g){E.error(g)}}}catch(I){E.error(I)}}e.migrateUnsupportedExtensions=L}),define(ne[189],ie([0,1,5,9,2,4,19,61,7,29,22,13,30,31,14,8]),function(J,e,D,n,L,T,A,R,b,E,I,C,f,S,u,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;const d=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let g=class extends L.Disposable{constructor(y,p,l,r){super();this.fileService=p,this.extensionGalleryService=l,this.logService=r,this.extensionsDownloadDir=b.URI.file(y.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(y,p){await this.cleanUpPromise;const l=this.getName(y),r=(0,A.joinPath)(this.extensionsDownloadDir,l);if(!await this.fileService.exists(r)){const a=(0,A.joinPath)(this.extensionsDownloadDir,`.${(0,E.generateUuid)()}`);await this.fileService.exists(a)||await this.extensionGalleryService.download(y,a,p);try{await this.rename(a,r,Date.now()+2*60*1e3)}catch(i){try{await this.fileService.del(a)}catch{}if(i.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",y.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,n.getErrorMessage)(i)}. Deleted the vsix from downloaded location`,a.path),i}}return r}async delete(y){await this.cleanUpPromise,await this.fileService.del(y)}async rename(y,p,l){try{await I.Promises.rename(y.fsPath,p.fsPath)}catch(r){if(T.isWindows&&r&&r.code==="EPERM"&&Date.now()<l)return this.logService.info(`Failed renaming ${y} to ${p} with 'EPERM' error. Trying again...`),this.rename(y,p,l);throw r}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const y=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(y.children){const p=[],l=[];for(const i of y.children){const t=this.parse(i.name);t&&l.push([t,i])}const r=(0,S.groupByExtension)(l,([i])=>i),a=[];for(const i of r)i.sort((t,o)=>R.rcompare(t[0].version,o[0].version)),p.push(...i.slice(1).map(t=>t[1].resource)),a.push(i[0][1]);a.sort((i,t)=>i.mtime-t.mtime),p.push(...a.slice(0,Math.max(0,a.length-this.cache)).map(i=>i.resource)),await D.Promises.settled(p.map(i=>(this.logService.trace("Deleting vsix from cache",i.path),this.fileService.del(i))))}}catch(y){this.logService.error(y)}}getName(y){return this.cache?`${new S.ExtensionIdentifierWithVersion(y.identifier,y.version).key().toLowerCase()}${y.properties.targetPlatform!=="undefined"?`-${y.properties.targetPlatform}`:""}`:(0,E.generateUuid)()}parse(y){const p=d.exec(y);return p&&p[1]&&p[2]?new S.ExtensionIdentifierWithVersion({id:p[1]},p[2]):null}};g=de([Y(0,C.INativeEnvironmentService),Y(1,u.IFileService),Y(2,f.IExtensionGalleryService),Y(3,v.ILogService)],g),e.ExtensionsDownloader=g}),define(ne[190],ie([0,1,2,10,22,90]),function(J,e,D,n,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class A extends D.Disposable{constructor(b,E){super();this.environmentService=b,this.extensionsManifestCache=(0,n.join)(this.environmentService.userDataPath,T.MANIFEST_CACHE_FOLDER,T.USER_MANIFEST_CACHE_FILE),this._register(E.onDidInstallExtensions(I=>this.onDidInstallExtensions(I))),this._register(E.onDidUninstallExtension(I=>this.onDidUnInstallExtension(I)))}onDidInstallExtensions(b){b.some(E=>!!E.local)&&this.invalidate()}onDidUnInstallExtension(b){b.error||this.invalidate()}invalidate(){L.Promises.rm(this.extensionsManifestCache,L.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=A}),define(ne[191],ie([0,1,83,16,5,2,18,10,22,13,30,31,59,8]),function(J,e,D,n,L,T,A,R,b,E,I,C,f,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsService=void 0;let u=class extends T.Disposable{constructor(g,w,y){super();this.extensionManagementService=g,this.logService=y,this.cache=this._register(new v(w,y)),this.extensionManagementService.registerParticipant({postInstall:async p=>this.postInstallExtension(p),postUninstall:async p=>this.postUninstallExtension(p)})}async getLanguageIds(){const g=await this.cache.getLanguagePacks(),w=["en",...Object.keys(g)];return(0,n.distinct)(w)}async postInstallExtension(g){g&&g.manifest&&g.manifest.contributes&&g.manifest.contributes.localizations&&g.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",g.identifier.id),await this.update())}async postUninstallExtension(g){const w=await this.cache.getLanguagePacks();Object.keys(w).some(y=>w[y]&&w[y].extensions.some(p=>(0,C.areSameExtensions)(p.extensionIdentifier,g.identifier)))&&(this.logService.info("Removing language packs from the extension",g.identifier.id),await this.update())}async update(){const[g,w]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),y=await this.cache.update(w);return!(0,n.equals)(Object.keys(g),Object.keys(y))}};u=de([Y(0,I.IExtensionManagementService),Y(1,E.INativeEnvironmentService),Y(2,S.ILogService)],u),e.LocalizationsService=u;let v=class extends T.Disposable{constructor(g,w){super();this.logService=w,this.languagePacks={},this.languagePacksFilePath=(0,R.join)(g.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new L.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(g){return this.withLanguagePacks(w=>{Object.keys(w).forEach(y=>delete w[y]),this.createLanguagePacksFromExtensions(w,...g)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(g,...w){for(const y of w)y&&y.manifest&&y.manifest.contributes&&y.manifest.contributes.localizations&&y.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(g,y);Object.keys(g).forEach(y=>this.updateHash(g[y]))}createLanguagePacksFromExtension(g,w){const y=w.identifier,p=w.manifest.contributes&&w.manifest.contributes.localizations?w.manifest.contributes.localizations:[];for(const l of p)if(w.location.scheme===A.Schemas.file&&(0,f.isValidLocalization)(l)){let r=g[l.languageId];r||(r={hash:"",extensions:[],translations:{}},g[l.languageId]=r);let a=r.extensions.filter(i=>(0,C.areSameExtensions)(i.extensionIdentifier,y))[0];a?a.version=w.manifest.version:r.extensions.push({extensionIdentifier:y,version:w.manifest.version});for(const i of l.translations)r.translations[i.id]=(0,R.join)(w.location.fsPath,i.path)}}updateHash(g){if(g){const w=(0,D.createHash)("md5");for(const y of g.extensions)w.update(y.extensionIdentifier.uuid||y.extensionIdentifier.id).update(y.version);g.hash=w.digest("hex")}}withLanguagePacks(g=()=>null){return this.languagePacksFileLimiter.queue(()=>{let w=null;return b.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,y=>y.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(y)).then(y=>{try{return JSON.parse(y)}catch{return{}}}).then(y=>(w=g(y),y)).then(y=>{for(const l of Object.keys(y))y[l]||delete y[l];this.languagePacks=y,this.initializedCache=!0;const p=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",p),b.Promises.writeFile(this.languagePacksFilePath,p)}).then(()=>w,y=>this.logService.error(y))})}};v=de([Y(0,E.INativeEnvironmentService),Y(1,S.ILogService)],v)}),define(ne[192],ie([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessTunnelChannelName=e.ISharedProcessTunnelService=void 0,e.ISharedProcessTunnelService=(0,D.createDecorator)("sharedProcessTunnelService"),e.ipcSharedProcessTunnelChannelName="sharedProcessTunnel"}),define(ne[62],ie([0,1,3,4,6,8]),function(J,e,D,n,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,L.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,L.createDecorator)("sharedTunnelsService");var A;(function(u){u.Http="http",u.Https="https"})(A=e.TunnelProtocol||(e.TunnelProtocol={}));var R;(function(u){u.ConstantPrivate="constantPrivate",u.Private="private",u.Public="public"})(R=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var b;(function(u){u[u.Notify=1]="Notify",u[u.OpenBrowser=2]="OpenBrowser",u[u.OpenPreview=3]="OpenPreview",u[u.Silent=4]="Silent",u[u.Ignore=5]="Ignore",u[u.OpenBrowserOnce=6]="OpenBrowserOnce"})(b=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function E(u){if(u.scheme!=="http"&&u.scheme!=="https")return;const v=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(u.authority);if(!!v)return{address:v[1],port:+v[2]}}e.extractLocalHostUriMetaDataForPortMapping=E,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function I(u){return e.LOCALHOST_ADDRESSES.indexOf(u)>=0}e.isLocalhost=I,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function C(u){return e.ALL_INTERFACES_ADDRESSES.indexOf(u)>=0}e.isAllInterfaces=C;function f(u,v){return v?v!==1&&u<1024:!n.isWindows&&u<1024}e.isPortPrivileged=f;let S=class{constructor(v){this.logService=v,this._onTunnelOpened=new D.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new D.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new D.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(v){return this._tunnelProvider=v,v?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(v){this._canElevate=v.elevation,this._privacyOptions=v.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const v=[],d=Array.from(this._tunnels.values());for(let g of d){const w=Array.from(g.values());for(let y of w){const p=await y.value;p&&v.push(p)}}return v}async dispose(){for(const v of this._tunnels.values()){for(const{value:d}of v.values())await d.then(g=>g?.dispose());v.clear()}this._tunnels.clear()}openTunnel(v,d,g,w,y=!1,p=R.Private,l){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${d}:${g} on local port ${w}.`),!v)return;d||(d="localhost");const r=this.retainOrCreateTunnel(v,d,g,w,y,p,l);return r?r.then(a=>{if(!a){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(d,g);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const i=this.makeTunnel(a);return(a.tunnelRemoteHost!==d||a.tunnelRemotePort!==g)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(i),i}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),r)}makeTunnel(v){return{tunnelRemotePort:v.tunnelRemotePort,tunnelRemoteHost:v.tunnelRemoteHost,tunnelLocalPort:v.tunnelLocalPort,localAddress:v.localAddress,privacy:v.privacy,protocol:v.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${v.tunnelRemoteHost}:${v.tunnelRemotePort} `);const d=this._tunnels.get(v.tunnelRemoteHost);if(d){const g=d.get(v.tunnelRemotePort);g&&(g.refcount--,await this.tryDisposeTunnel(v.tunnelRemoteHost,v.tunnelRemotePort,g))}}}}async tryDisposeTunnel(v,d,g){if(g.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${v}:${d}.`);const w=g.value.then(async y=>{y&&(await y.dispose(!0),this._onTunnelClosed.fire({host:y.tunnelRemoteHost,port:y.tunnelRemotePort}))});return this._tunnels.has(v)&&this._tunnels.get(v).delete(d),w}}async closeTunnel(v,d){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${v}:${d} `);const g=this._tunnels.get(v);if(g&&g.has(d)){const w=g.get(d);w.refcount=0,await this.tryDisposeTunnel(v,d,w)}}addTunnelToMap(v,d,g){this._tunnels.has(v)||this._tunnels.set(v,new Map),this._tunnels.get(v).set(d,{refcount:1,value:g})}async removeEmptyTunnelFromMap(v,d){const g=this._tunnels.get(v);g&&(await g.get(d)||g.delete(d),g.size===0&&this._tunnels.delete(v))}getTunnelFromMap(v,d){let g=[v];I(v)?(g.push(...e.LOCALHOST_ADDRESSES),g.push(...e.ALL_INTERFACES_ADDRESSES)):C(v)&&g.push(...e.ALL_INTERFACES_ADDRESSES);const w=g.map(y=>this._tunnels.get(y));for(const y of w){const p=y?.get(d);if(p)return p}}canTunnel(v){return!!E(v)}createWithProvider(v,d,g,w,y,p,l){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${d}:${g} on local port ${w}.`);const a={elevationRequired:y?f(w===void 0?g:w):!1},i={remoteAddress:{host:d,port:g},localAddressPort:w,privacy:p,public:p!==R.Private,protocol:l},t=v.forwardPort(i,a);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),t&&this.addTunnelToMap(d,g,t),t}};S=de([Y(0,T.ILogService)],S),e.AbstractTunnelService=S}),define(ne[193],ie([0,1,8,62,2,9,5]),function(J,e,D,n,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessTunnelService=void 0;class R extends L.Disposable{constructor(){super();this._address=null,this._addressPromise=null}async getAddress(){return this._address?this._address:(this._addressPromise||(this._addressPromise=new A.DeferredPromise),this._addressPromise.p)}setAddress(I){this._address=I,this._addressPromise&&(this._addressPromise.complete(I),this._addressPromise=null)}setTunnel(I){this._register(I)}}let b=class Ct extends L.Disposable{constructor(I,C){super();this._tunnelService=I,this._logService=C,this._tunnels=new Map,this._disposedTunnels=new Set}dispose(){super.dispose(),this._tunnels.forEach(I=>I.dispose())}async createTunnel(){return{id:String(++Ct._lastId)}}async startTunnel(I,C,f,S,u,v){const d=new R,g=await Promise.resolve(this._tunnelService.openTunnel(I,d,f,S,u,v));if(!g)throw this._logService.info(`[SharedProcessTunnelService] Could not create a tunnel to ${f}:${S} (remote).`),d.dispose(),new Error("Could not create tunnel");if(this._disposedTunnels.has(C))throw this._disposedTunnels.delete(C),d.dispose(),await g.dispose(),(0,T.canceled)();return d.setTunnel(g),this._tunnels.set(C,d),this._logService.info(`[SharedProcessTunnelService] Created tunnel ${C}: ${g.localAddress} (local) to ${f}:${S} (remote).`),{tunnelLocalPort:g.tunnelLocalPort,localAddress:g.localAddress}}async setAddress(I,C){const f=this._tunnels.get(I);!f||f.setAddress(C)}async destroyTunnel(I){const C=this._tunnels.get(I);if(C){this._logService.info(`[SharedProcessTunnelService] Disposing tunnel ${I}.`),this._tunnels.delete(I),await C.dispose();return}this._disposedTunnels.add(I)}};b._lastId=0,b=de([Y(0,n.ISharedTunnelsService),Y(1,D.ILogService)],b),e.SharedProcessTunnelService=b}),define(ne[194],ie([0,1,119,20,8]),function(J,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let T=class{constructor(R,b){this.configurationService=R,this.logService=b}request(R,b){return this.logService.trace("RequestService#request",R.url),R.proxyAuthorization||(R.proxyAuthorization=this.configurationService.getValue("http.proxyAuthorization")),(0,D.request)(R,b)}async resolveProxy(R){}};T=de([Y(0,n.IConfigurationService),Y(1,L.ILogService)],T),e.RequestService=T}),define(ne[43],ie([0,1,17,140,42,6,38]),function(J,e,D,n,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,T.createDecorator)("requestService");function R(u){return u.res.statusCode&&u.res.statusCode>=200&&u.res.statusCode<300||u.res.statusCode===1223}e.isSuccess=R;function b(u){return u.res.statusCode===204}async function E(u){if(!R(u))throw new Error("Server returned "+u.res.statusCode);return b(u)?null:(await(0,D.streamToBuffer)(u.stream)).toString()}e.asText=E;async function I(u){if(!R(u))throw new Error("Server returned "+u.res.statusCode);if(b(u))return null;const d=(await(0,D.streamToBuffer)(u.stream)).toString();try{return JSON.parse(d)}catch(g){throw g.message+=`:
`+d,g}}e.asJson=I;function C(u){S(u)}e.updateProxyConfigurationsScope=C;let f;function S(u){const v=A.Registry.as(L.Extensions.Configuration),d=f;f={id:"http",order:15,title:(0,n.localize)(0,null),type:"object",scope:u,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,n.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,n.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,n.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,n.localize)(4,null),(0,n.localize)(5,null),(0,n.localize)(6,null),(0,n.localize)(7,null)],default:"override",description:(0,n.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,n.localize)(9,null),restricted:!0}}},v.updateConfigurations({add:[f],remove:d?[d]:[]})}S(2)}),define(ne[195],ie([0,1,23,18,14,43]),function(J,e,D,n,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let A=class{constructor(b,E){this.requestService=b,this.fileService=E}async download(b,E,I=D.CancellationToken.None){if(b.scheme===n.Schemas.file||b.scheme===n.Schemas.vscodeRemote){await this.fileService.copy(b,E);return}const C={type:"GET",url:b.toString()},f=await this.requestService.request(C,I);if(f.res.statusCode===200)await this.fileService.writeFile(E,f.stream);else{const S=await(0,T.asText)(f);throw new Error(`Expected 200, got back ${f.res.statusCode} instead.

${S}`)}}};A=de([Y(0,T.IRequestService),Y(1,L.IFileService)],A),e.DownloadService=A}),define(ne[196],ie([0,1,16,23,67,2,19,154,14,8,26,43]),function(J,e,D,n,L,T,A,R,b,E,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let f=class extends T.Disposable{constructor(u,v,d,g){super();this.fileService=u,this.productService=v,this.requestService=d,this.logService=g,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&(0,L.forEach)(this.productService.configBasedExtensionTips,({value:w})=>this.allConfigBasedTips.set(w.configPath,w))}getConfigBasedTips(u){return this.getValidConfigBasedTips(u)}getAllWorkspacesTips(){return this.fetchWorkspacesTips()}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(u){const v=[];for(const[d,g]of this.allConfigBasedTips)if(!(g.configScheme&&g.configScheme!==u.scheme))try{const w=await this.fileService.readFile((0,A.joinPath)(u,d)),y=new Map;(0,L.forEach)(g.recommendations,({key:l,value:r})=>{if((0,D.isNonEmptyArray)(r.remotes))for(const a of r.remotes)y.set(a,{extensionId:l,extensionName:r.name,configName:g.configName,important:!!r.important,isExtensionPack:!!r.isExtensionPack});else v.push({extensionId:l,extensionName:r.name,configName:g.configName,important:!!r.important,isExtensionPack:!!r.isExtensionPack})});const p=(0,R.getDomainsOfRemotes)(w.value.toString(),[...y.keys()]);for(const l of p){const r=y.get(l);r&&v.push(r)}}catch{}return v}async fetchWorkspacesTips(){if(!this.productService.extensionsGallery?.recommendationsUrl)return[];try{const u=await this.requestService.request({type:"GET",url:this.productService.extensionsGallery?.recommendationsUrl},n.CancellationToken.None);if(u.res.statusCode!==200)return[];const v=await(0,C.asJson)(u);return v?v.workspaceRecommendations||[]:[]}catch(u){return this.logService.error(u),[]}}};f=de([Y(0,b.IFileService),Y(1,I.IProductService),Y(2,C.IRequestService),Y(3,E.ILogService)],f),e.ExtensionTipsService=f}),define(ne[46],ie([0,1,17,29]),function(J,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function L(T,A,R){let b=R&&R.get("storage.serviceMachineId",0)||null;if(b)return b;try{const I=(await A.readFile(T.serviceMachineIdResource)).value.toString();b=(0,n.isUUID)(I)?I:null}catch{b=null}if(!b){b=(0,n.generateUuid)();try{await A.writeFile(T.serviceMachineIdResource,D.VSBuffer.fromString(b))}catch{}}return R&&R.store("storage.serviceMachineId",b,0,1),b}e.getServiceMachineId=L}),define(ne[91],ie([0,1,70,6]),function(J,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessWorkerChannelName=e.ISharedProcessWorkerService=e.hash=void 0;function L(T){return(0,D.hash)({moduleId:T.process.moduleId,windowId:T.reply.windowId})}e.hash=L,e.ISharedProcessWorkerService=(0,n.createDecorator)("sharedProcessWorkerService"),e.ipcSharedProcessWorkerChannelName="sharedProcessWorker"}),define(ne[197],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerMessages=void 0;var D;(function(n){n.Spawn="vscode:shared-process->shared-process-worker=spawn",n.Terminate="vscode:shared-process->shared-process-worker=terminate",n.SelfTerminated="vscode:shared-process-worker->shared-process=selfTerminated",n.Ready="vscode:shared-process-worker->shared-process=ready",n.Ack="vscode:shared-process-worker->shared-process=ack",n.Trace="vscode:shared-process-worker->shared-process=trace",n.Info="vscode:shared-process-worker->shared-process=info",n.Warn="vscode:shared-process-worker->shared-process=warn",n.Error="vscode:shared-process-worker->shared-process=error"})(D=e.SharedProcessWorkerMessages||(e.SharedProcessWorkerMessages={}))}),define(ne[198],ie([0,1,74,152,5,23,3,2,18,4,29,13,8,26,91,197]),function(J,e,D,n,L,T,A,R,b,E,I,C,f,S,u,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerService=void 0;let d=class{constructor(y,p,l){this.logService=y,this.productService=p,this.environmentService=l,this.workers=new Map,this.processeDisposables=new Map,this.processResolvers=new Map}async createWorker(y){const p=`window: ${y.reply.windowId}, moduleId: ${y.process.moduleId}`;this.logService.trace(`SharedProcess: createWorker (${p})`);const l=(0,u.hash)(y);this.processeDisposables.has(l)&&(this.logService.warn(`SharedProcess: createWorker found an existing worker that will be terminated (${p})`),this.doDisposeWorker(y));const r=new T.CancellationTokenSource;let a,i,t;this.processeDisposables.set(l,h=>{r.dispose(!0),a?.terminate(y,T.CancellationToken.None),i?.close(),t?.close(),this.processeDisposables.delete(l);const m=this.processResolvers.get(l);m&&(this.processResolvers.delete(l),m({reason:h}))}),a=await this.getOrCreateWebWorker(y);const o=new Promise(h=>{this.processResolvers.set(l,h)});if(r.token.isCancellationRequested)return o;const{port1:s,port2:c}=new MessageChannel;return i=s,t=c,await a.spawn(y,t,r.token),r.token.isCancellationRequested||(this.logService.trace(`SharedProcess: createWorker sending message port back to window (${p})`),D.ipcRenderer.postMessage("vscode:relaySharedProcessWorkerMessageChannel",y,[i])),o}getOrCreateWebWorker(y){let p=this.workers.get(y.process.moduleId);if(!p){this.logService.trace(`SharedProcess: creating new web worker (${y.process.moduleId})`);const l=new g(y.process.type,this.logService,this.productService,this.environmentService);p=l.init(),l.onDidProcessSelfTerminate(({configuration:r,reason:a})=>{this.doDisposeWorker(r,a)}),this.workers.set(y.process.moduleId,p)}return p}async disposeWorker(y){return this.doDisposeWorker(y)}doDisposeWorker(y,p){const l=this.processeDisposables.get((0,u.hash)(y));l&&(this.logService.trace(`SharedProcess: disposeWorker (window: ${y.reply.windowId}, moduleId: ${y.process.moduleId})`),l(p))}};d=de([Y(0,f.ILogService),Y(1,S.IProductService),Y(2,C.INativeEnvironmentService)],d),e.SharedProcessWorkerService=d;class g extends R.Disposable{constructor(y,p,l,r){super();this.type=y,this.logService=p,this.productService=l,this.environmentService=r,this._onDidProcessSelfTerminate=this._register(new A.Emitter),this.onDidProcessSelfTerminate=this._onDidProcessSelfTerminate.event,this.workerReady=this.doInit(),this.mapMessageNonceToPendingMessageResolve=new Map}async init(){return await this.workerReady,this}doInit(){const y=new L.DeferredPromise,p=new Worker("../../../base/worker/workerMain.js",{name:`Shared Process Worker (${this.type})`});return p.onerror=l=>{this.logService.error(`SharedProcess: worker error (${this.type})`,l.message)},p.onmessageerror=l=>{this.logService.error(`SharedProcess: worker message error (${this.type})`,l)},p.onmessage=l=>{const{id:r,message:a,configuration:i,nonce:t}=l.data;switch(r){case v.SharedProcessWorkerMessages.Ready:y.complete(p);break;case v.SharedProcessWorkerMessages.Ack:if(t){const o=this.mapMessageNonceToPendingMessageResolve.get(t);o&&(this.mapMessageNonceToPendingMessageResolve.delete(t),o())}break;case v.SharedProcessWorkerMessages.SelfTerminated:i&&a&&this._onDidProcessSelfTerminate.fire({configuration:i,reason:JSON.parse(a)});break;case v.SharedProcessWorkerMessages.Trace:this.logService.trace(`SharedProcess (worker, ${this.type}):`,a);break;case v.SharedProcessWorkerMessages.Info:a&&this.logService.info(a);break;case v.SharedProcessWorkerMessages.Warn:this.logService.warn(`SharedProcess (worker, ${this.type}):`,a);break;case v.SharedProcessWorkerMessages.Error:this.logService.error(`SharedProcess (worker, ${this.type}):`,a);break;default:this.logService.warn(`SharedProcess: unexpected worker message (${this.type})`,l)}},p.postMessage("vs/platform/sharedProcess/electron-browser/sharedProcessWorkerMain"),y.p}async send(y,p,l){const r=await this.workerReady;if(!p.isCancellationRequested)return new Promise(a=>{const i=(0,I.generateUuid)();this.mapMessageNonceToPendingMessageResolve.set(i,a);const t={...y,nonce:i};l?r.postMessage(t,[l]):r.postMessage(t),p.onCancellationRequested(()=>{this.mapMessageNonceToPendingMessageResolve.delete(i)&&a()})})}spawn(y,p,l){const r={id:v.SharedProcessWorkerMessages.Spawn,configuration:y,environment:this.getSharedProcessWorkerEnvironment()};return this.send(r,l,p)}getSharedProcessWorkerEnvironment(){const y={bootstrapPath:b.FileAccess.asFileUri("bootstrap-fork",J).fsPath,env:Object.create(null)};if(E.isLinux){const p={companyName:this.productService.crashReporter?.companyName||"Microsoft",productName:this.productService.crashReporter?.productName||this.productService.nameShort,submitURL:"",uploadToServer:!1},l=this.environmentService.args["crash-reporter-id"],r=this.productService.appCenter;if(!this.environmentService.args["crash-reporter-directory"]&&r&&l&&(0,I.isUUID)(l)){const t=r["linux-x64"];p.submitURL=t.concat("&uid=",l,"&iid=",l,"&sid=",l),p.uploadToServer=!0}const i=this.environmentService.args["crash-reporter-directory"]||this.environmentService.userDataPath;y.env.BREAKPAD_DUMP_LOCATION=(0,n.join)(i,this.type),y.env.VSCODE_CRASH_REPORTER_START_OPTIONS=JSON.stringify(p)}return y}terminate(y,p){const l={id:v.SharedProcessWorkerMessages.Terminate,configuration:y};return this.send(l,p)}}}),define(ne[199],ie([0,1,54,18,153]),function(J,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessEnvironmentService=void 0;class T extends L.NativeEnvironmentService{get userRoamingDataHome(){return this.appSettingsHome.with({scheme:n.Schemas.userData})}}de([D.memoize],T.prototype,"userRoamingDataHome",null),e.SharedProcessEnvironmentService=T}),define(ne[92],ie([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,D.createDecorator)(e.SIGN_SERVICE_ID)}),define(ne[200],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class D{constructor(){this.validators=new Map}vsda(){return new Promise((L,T)=>J(["vsda"],L,T))}async createNewMessage(L){try{const T=await this.vsda(),A=new T.validator;if(A){const R=String(D._nextId++);return this.validators.set(R,A),{id:R,data:A.createNewMessage(L)}}}catch{}return{id:"",data:L}}async validate(L,T){if(!L.id)return!0;const A=this.validators.get(L.id);if(!A)return!1;this.validators.delete(L.id);try{return A.validate(T)==="ok"}catch{return!1}}async sign(L){try{const T=await this.vsda(),A=new T.signer;if(A)return A.sign(L)}catch{}return L}}e.SignService=D,D._nextId=1}),define(ne[24],ie([0,1,5,3,2,177,15,75,6]),function(J,e,D,n,L,T,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const E="__$__targetStorageMarker";e.IStorageService=(0,b.createDecorator)("storageService");var I;(function(d){d[d.NONE=0]="NONE",d[d.SHUTDOWN=1]="SHUTDOWN"})(I=e.WillSaveStateReason||(e.WillSaveStateReason={}));var C;(function(d){d[d.GLOBAL=0]="GLOBAL",d[d.WORKSPACE=1]="WORKSPACE"})(C=e.StorageScope||(e.StorageScope={}));var f;(function(d){d[d.USER=0]="USER",d[d.MACHINE=1]="MACHINE"})(f=e.StorageTarget||(e.StorageTarget={}));class S extends L.Disposable{constructor(g={flushInterval:S.DEFAULT_FLUSH_INTERVAL}){super();this.options=g,this._onDidChangeValue=this._register(new n.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new n.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new n.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new D.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new L.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,D.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,L.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,T.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,T.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(g,w){w===E?(g===0?this._globalKeyTargets=void 0:g===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:g})):this._onDidChangeValue.fire({scope:g,key:w,target:this.getKeyTargets(g)[w]})}emitWillSaveState(g){this._onWillSaveState.fire({reason:g})}get(g,w,y){return this.getStorage(w)?.get(g,y)}getBoolean(g,w,y){return this.getStorage(w)?.getBoolean(g,y)}getNumber(g,w,y){return this.getStorage(w)?.getNumber(g,y)}store(g,w,y,p){if((0,A.isUndefinedOrNull)(w)){this.remove(g,y);return}this.withPausedEmitters(()=>{this.updateKeyTarget(g,y,p),this.getStorage(y)?.set(g,w)})}remove(g,w){this.withPausedEmitters(()=>{this.updateKeyTarget(g,w,void 0),this.getStorage(w)?.delete(g)})}withPausedEmitters(g){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{g()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(g,w){const y=[],p=this.getKeyTargets(g);for(const l of Object.keys(p))p[l]===w&&y.push(l);return y}updateKeyTarget(g,w,y){const p=this.getKeyTargets(w);typeof y=="number"?p[g]!==y&&(p[g]=y,this.getStorage(w)?.set(E,JSON.stringify(p))):typeof p[g]=="number"&&(delete p[g],this.getStorage(w)?.set(E,JSON.stringify(p)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(g){return g===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(g){const w=this.get(E,g);if(w)try{return JSON.parse(w)}catch{}return Object.create(null)}isNew(g){return this.getBoolean(e.IS_NEW_KEY,g)===!0}async flush(g=I.NONE){this._onWillSaveState.fire({reason:g});const w=this.getStorage(0),y=this.getStorage(1);switch(g){case I.NONE:await D.Promises.settled([w?.whenFlushed()??Promise.resolve(),y?.whenFlushed()??Promise.resolve()]);break;case I.SHUTDOWN:await D.Promises.settled([w?.flush(0)??Promise.resolve(),y?.flush(0)??Promise.resolve()]);break}}async logStorage(){const g=this.getStorage(0)?.items??new Map,w=this.getStorage(1)?.items??new Map;return v(g,w,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=S,S.DEFAULT_FLUSH_INTERVAL=60*1e3;class u extends S{constructor(){super();this.globalStorage=this._register(new R.Storage(new R.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new R.Storage(new R.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(g=>this.emitDidChangeValue(1,g))),this._register(this.globalStorage.onDidChangeStorage(g=>this.emitDidChangeValue(0,g)))}getStorage(g){return g===0?this.globalStorage:this.workspaceStorage}getLogDetails(g){return g===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(g){}}e.InMemoryStorageService=u;async function v(d,g,w,y){const p=s=>{try{return JSON.parse(s)}catch{return s}},l=new Map,r=new Map;d.forEach((s,c)=>{l.set(c,s),r.set(c,p(s))});const a=new Map,i=new Map;g.forEach((s,c)=>{a.set(c,s),i.set(c,p(s))}),console.group(`Storage: Global (path: ${w})`);let t=[];l.forEach((s,c)=>{t.push({key:c,value:s})}),console.table(t),console.groupEnd(),console.log(r),console.group(`Storage: Workspace (path: ${y})`);let o=[];a.forEach((s,c)=>{o.push({key:c,value:s})}),console.table(o),console.groupEnd(),console.log(i)}e.logStorage=v}),define(ne[201],ie([0,1,3,2,15,30,31,24]),function(J,e,D,n,L,T,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let b=class extends n.Disposable{constructor(C,f){super();this._onDidChangeEnablement=new D.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new E(C)),this._register(this.storageManger.onDidChange(S=>this._onDidChangeEnablement.fire({extensions:S,source:"storage"}))),this._register(f.onDidInstallExtensions(S=>S.forEach(({local:u,operation:v})=>{u&&v===4&&this._removeFromDisabledExtensions(u.identifier)})))}async enableExtension(C,f){return this._removeFromDisabledExtensions(C)?(this._onDidChangeEnablement.fire({extensions:[C],source:f}),!0):!1}async disableExtension(C,f){return this._addToDisabledExtensions(C)?(this._onDidChangeEnablement.fire({extensions:[C],source:f}),!0):!1}getDisabledExtensions(){return this._getExtensions(T.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(C){let f=this.getDisabledExtensions();return f.every(S=>!(0,A.areSameExtensions)(S,C))?(f.push(C),this._setDisabledExtensions(f),!0):!1}_removeFromDisabledExtensions(C){let f=this.getDisabledExtensions();for(let S=0;S<f.length;S++){const u=f[S];if((0,A.areSameExtensions)(u,C))return f.splice(S,1),this._setDisabledExtensions(f),!0}return!1}_setDisabledExtensions(C){this._setExtensions(T.DISABLED_EXTENSIONS_STORAGE_PATH,C)}_getExtensions(C){return this.storageManger.get(C,0)}_setExtensions(C,f){this.storageManger.set(C,f,0)}};b=de([Y(0,R.IStorageService),Y(1,T.IExtensionManagementService)],b),e.GlobalExtensionEnablementService=b;class E extends n.Disposable{constructor(C){super();this.storageService=C,this.storage=Object.create(null),this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event,this._register(C.onDidChangeValue(f=>this.onDidStorageChange(f)))}get(C,f){let S;return f===0?((0,L.isUndefinedOrNull)(this.storage[C])&&(this.storage[C]=this._get(C,f)),S=this.storage[C]):S=this._get(C,f),JSON.parse(S)}set(C,f,S){let u=JSON.stringify(f.map(({id:d,uuid:g})=>({id:d,uuid:g})));this._get(C,S)!==u&&(S===0&&(f.length?this.storage[C]=u:delete this.storage[C]),this._set(C,f.length?u:void 0,S))}onDidStorageChange(C){if(C.scope===0&&!(0,L.isUndefinedOrNull)(this.storage[C.key])&&this._get(C.key,C.scope)!==this.storage[C.key]){const S=this.get(C.key,C.scope);delete this.storage[C.key];const u=this.get(C.key,C.scope),v=S.filter(g=>!u.some(w=>(0,A.areSameExtensions)(g,w))),d=u.filter(g=>!S.some(w=>(0,A.areSameExtensions)(w,g)));(v.length||d.length)&&this._onDidChange.fire([...v,...d])}}_get(C,f){return this.storageService.get(C,f,"[]")}_set(C,f,S){f?this.storageService.store(C,f,S,1):this.storageService.remove(C,S)}}e.StorageManager=E}),define(ne[63],ie([0,1,6,3,2,24,31,26,16,8,15]),function(J,e,D,n,L,T,A,R,b,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStorageService=e.IExtensionStorageService=void 0,e.IExtensionStorageService=(0,D.createDecorator)("IExtensionStorageService");const C=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let f=class nt extends L.Disposable{constructor(u,v,d){super();this.storageService=u,this.productService=v,this.logService=d,this._onDidChangeExtensionStorageToSync=this._register(new n.Emitter),this.onDidChangeExtensionStorageToSync=this._onDidChangeExtensionStorageToSync.event,this.extensionsWithKeysForSync=new Set,this.initialize(),this._register(this.storageService.onDidChangeValue(g=>this.onDidChangeStorageValue(g)))}static toKey(u){return`extensionKeys/${(0,A.adoptToGalleryExtensionId)(u.id)}@${u.version}`}static fromKey(u){const v=C.exec(u);if(v&&v[1])return{id:v[1],version:v[2]}}initialize(){const u=this.storageService.keys(0,1);for(const v of u){const d=nt.fromKey(v);d&&this.extensionsWithKeysForSync.add(d.id.toLowerCase())}}onDidChangeStorageValue(u){if(u.scope!==0)return;if(this.extensionsWithKeysForSync.has(u.key.toLowerCase())){this._onDidChangeExtensionStorageToSync.fire();return}const v=nt.fromKey(u.key);if(v){this.extensionsWithKeysForSync.add(v.id.toLowerCase()),this._onDidChangeExtensionStorageToSync.fire();return}}getExtensionId(u){if((0,I.isString)(u))return u;const v=u.manifest?u.manifest.publisher:u.publisher,d=u.manifest?u.manifest.name:u.name;return(0,A.getExtensionId)(v,d)}getExtensionState(u,v){const d=this.getExtensionId(u),g=this.storageService.get(d,v?0:1);if(g)try{return JSON.parse(g)}catch(w){this.logService.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${d}, global: ${v}): ${w}`)}}setExtensionState(u,v,d){const g=this.getExtensionId(u);v===void 0?this.storageService.remove(g,d?0:1):this.storageService.store(g,JSON.stringify(v),d?0:1,1)}setKeysForSync(u,v){this.storageService.store(nt.toKey(u),JSON.stringify(v),0,1)}getKeysForSync(u){const v=this.productService.extensionSyncedKeys?.[u.id.toLowerCase()],d=this.storageService.get(nt.toKey(u),0),g=d?JSON.parse(d):void 0;return g&&v?(0,b.distinct)([...g,...v]):g||v}addToMigrationList(u,v){if(u!==v){const d=this.migrationList.filter(g=>!g.includes(u)&&!g.includes(v));d.push([u,v]),this.migrationList=d}}getSourceExtensionToMigrate(u){const v=this.migrationList.find(([,d])=>u===d);return v?v[0]:void 0}get migrationList(){const u=this.storageService.get("extensionStorage.migrationList",0,"[]");try{const v=JSON.parse(u);if((0,I.isArray)(v))return v}catch{}return[]}set migrationList(u){u.length?this.storageService.store("extensionStorage.migrationList",JSON.stringify(u),0,1):this.storageService.remove("extensionStorage.migrationList",0)}};f=de([Y(0,T.IStorageService),Y(1,R.IProductService),Y(2,E.ILogService)],f),e.ExtensionStorageService=f}),define(ne[202],ie([0,1,2,30,63,188,8]),function(J,e,D,n,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsCleaner=void 0;let R=class extends D.Disposable{constructor(E,I,C,f,S){super();E.removeDeprecatedExtensions(),(0,T.migrateUnsupportedExtensions)(E,I,C,f,S)}};R=de([Y(0,n.IExtensionManagementService),Y(1,n.IExtensionGalleryService),Y(2,L.IExtensionStorageService),Y(3,n.IGlobalExtensionEnablementService),Y(4,A.ILogService)],R),e.ExtensionsCleaner=R}),define(ne[203],ie([0,1,3,2]),function(J,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannelClient=void 0;class L extends n.Disposable{constructor(E,I){super();this.channel=E,this.workspace=I}async getItems(){const E={workspace:this.workspace},I=await this.channel.call("getItems",E);return new Map(I)}updateItems(E){const I={workspace:this.workspace};return E.insert&&(I.insert=Array.from(E.insert.entries())),E.delete&&(I.delete=Array.from(E.delete.values())),this.channel.call("updateItems",I)}}class T extends L{constructor(E){super(E,void 0);this._onDidChangeItemsExternal=this._register(new D.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeGlobalStorage")(E=>this.onDidChangeGlobalStorage(E)))}onDidChangeGlobalStorage(E){(Array.isArray(E.changed)||Array.isArray(E.deleted))&&this._onDidChangeItemsExternal.fire({changed:E.changed?new Map(E.changed):void 0,deleted:E.deleted?new Set(E.deleted):void 0})}async close(){this.dispose()}}class A extends L{constructor(E,I){super(E,I);this.onDidChangeItemsExternal=D.Event.None}async close(){const E={workspace:this.workspace};return this.channel.call("close",E)}}class R extends n.Disposable{constructor(E,I){super();this.channel=E,this.workspace=I,this._globalStorage=void 0,this._workspaceStorage=void 0}get globalStorage(){return this._globalStorage||(this._globalStorage=new T(this.channel)),this._globalStorage}get workspaceStorage(){return!this._workspaceStorage&&this.workspace&&(this._workspaceStorage=new A(this.channel,this.workspace)),this._workspaceStorage}}e.StorageDatabaseChannelClient=R}),define(ne[204],ie([0,1,5,2,19,75,24,203]),function(J,e,D,n,L,T,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class b extends A.AbstractStorageService{constructor(I,C,f){super();this.mainProcessService=C,this.environmentService=f,this.workspaceStorage=void 0,this.workspaceStorageId=void 0,this.workspaceStorageDisposable=this._register(new n.MutableDisposable),this.globalStorage=this.createGlobalStorage(),this.workspaceStorage=this.createWorkspaceStorage(I)}createGlobalStorage(){const I=new R.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),void 0),C=new T.Storage(I.globalStorage);return this._register(C.onDidChangeStorage(f=>this.emitDidChangeValue(0,f))),C}createWorkspaceStorage(I){const C=new R.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),I);if(C.workspaceStorage){const f=new T.Storage(C.workspaceStorage);return this.workspaceStorageDisposable.value=f.onDidChangeStorage(S=>this.emitDidChangeValue(1,S)),this.workspaceStorageId=I?.id,f}else{this.workspaceStorageDisposable.clear(),this.workspaceStorageId=void 0;return}}async doInitialize(){await D.Promises.settled([this.globalStorage.init(),this.workspaceStorage?.init()??Promise.resolve()])}getStorage(I){return I===0?this.globalStorage:this.workspaceStorage}getLogDetails(I){return I===0?this.environmentService.globalStorageHome.fsPath:this.workspaceStorageId?`${(0,L.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").fsPath}`:void 0}async close(){this.stopFlushWhenIdle(),this.emitWillSaveState(A.WillSaveStateReason.SHUTDOWN),await D.Promises.settled([this.globalStorage.close(),this.workspaceStorage?.close()??Promise.resolve()])}async migrate(I){const C=this.workspaceStorage,f=C?.items??new Map;C&&(await C.close(),C.dispose()),this.workspaceStorage=this.createWorkspaceStorage(I),await this.workspaceStorage.init();for(const[S,u]of f)this.workspaceStorage.set(S,u)}}e.NativeStorageService=b}),define(ne[205],ie([0,1,4,32,7,29]),function(J,e,D,n,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function A(E){if(D.platform===2&&/^penguin(\.|$)/i.test(E))return"chromebook"}async function R(E,I,C,f,S,u,v,d,g,w){const y=Object.create(null);y["common.machineId"]=v,y.sessionID=(0,T.generateUuid)()+Date.now(),y.commitHash=S,y.version=u,y["common.platformVersion"]=(I||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),y["common.platform"]=(0,D.PlatformToString)(D.platform),y["common.nodePlatform"]=n.platform,y["common.nodeArch"]=f,y["common.product"]=w||"desktop";const p=b(d||[]);p&&(y["common.msftInternal"]=p);let l=0;const r=Date.now();Object.defineProperties(y,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-r,enumerable:!0},"common.sequence":{get:()=>l++,enumerable:!0}}),D.isLinuxSnap&&(y["common.snap"]="true");const a=A(C);a&&(y["common.platformDetail"]=a);try{const i=await E.readFile(L.URI.file(g));y["common.source"]=i.value.toString().slice(0,30)}catch{}return y}e.resolveCommonProperties=R;function b(E){const I=n.env.USERDNSDOMAIN;if(!I)return!1;const C=I.toLowerCase();return E.some(f=>C===f)}e.verifyMicrosoftInternalDomain=b}),define(ne[21],ie([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,D.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,D.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var n;(function(T){T[T.NONE=0]="NONE",T[T.CRASH=1]="CRASH",T[T.ERROR=2]="ERROR",T[T.USAGE=3]="USAGE"})(n=e.TelemetryLevel||(e.TelemetryLevel={}));var L;(function(T){T.OFF="off",T.CRASH="crash",T.ERROR="error",T.ON="all"})(L=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(ne[206],ie([0,1,33,55,5,35,18,10,4,7,113,22,116,80,14,26,21]),function(J,e,D,n,L,T,A,R,b,E,I,C,f,S,u,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function g(r,a){const i=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],t=new Map,o=new Map,s=2e4;function c(P,_,O,M){const k=_.substring(P.length+1);return L.Promises.withAsyncBody(async U=>{let N;try{N=await C.Promises.readdir(_,{withFileTypes:!0})}catch{U();return}if(M.count>=s){M.count+=N.length,M.maxReached=!0,U();return}let V=N.length;if(V===0){U();return}let $=N;M.count+N.length>s&&(M.maxReached=!0,V=s-M.count,$=N.slice(0,V)),M.count+=N.length;for(const G of $)if(G.isDirectory()){if(O.includes(G.name)||await c(P,(0,R.join)(_,G.name),O,M),--V==0){U();return}}else{const te=G.name.lastIndexOf(".");if(te>=0){const W=G.name.substring(te+1);W&&t.set(W,(t.get(W)??0)+1)}for(const W of i)W.relativePathPattern?.test(k)!==!1&&W.filePattern.test(G.name)&&o.set(W.tag,(o.get(W.tag)??0)+1);if(--V==0){U();return}}})}const h={count:0,maxReached:!1};await c(r,r,a,h);const m=await p(r);return{configFiles:w(o),fileTypes:w(t),fileCount:h.count,maxFilesReached:h.maxReached,launchConfigFiles:m}}e.collectWorkspaceStats=g;function w(r){return[...n.Iterable.map(r.entries(),([a,i])=>({name:a,count:i}))].sort((a,i)=>i.count-a.count)}function y(){const r={os:`${D.type()} ${D.arch()} ${D.release()}`,memory:`${(D.totalmem()/u.ByteSize.GB).toFixed(2)}GB (${(D.freemem()/u.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(I.virtualMachineHint.value()*100)}%`},a=D.cpus();return a&&a.length>0&&(r.cpus=`${a[0].model} (${a.length} x ${a[0].speed})`),r}e.getMachineInfo=y;async function p(r){try{const a=new Map,i=(0,R.join)(r,".vscode","launch.json"),t=await C.Promises.readFile(i),o=[],s=(0,T.parse)(t.toString(),o);if(o.length)return console.log(`Unable to parse ${i}`),[];if((0,T.getNodeType)(s)==="object"&&s.configurations)for(const c of s.configurations){const h=c.type;h&&(a.has(h)?a.set(h,a.get(h)+1):a.set(h,1))}return w(a)}catch{return[]}}e.collectLaunchConfigs=p;let l=class{constructor(a,i){this.telemetryService=a,this.productService=i}formatMachineInfo(a){const i=[];return i.push(`OS Version:       ${a.os}`),i.push(`CPUs:             ${a.cpus}`),i.push(`Memory (System):  ${a.memory}`),i.push(`VM:               ${a.vmHint}`),i.join(`
`)}formatEnvironment(a){const i=[];i.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),i.push(`OS Version:       ${D.type()} ${D.arch()} ${D.release()}`);const t=D.cpus();return t&&t.length>0&&i.push(`CPUs:             ${t[0].model} (${t.length} x ${t[0].speed})`),i.push(`Memory (System):  ${(D.totalmem()/u.ByteSize.GB).toFixed(2)}GB (${(D.freemem()/u.ByteSize.GB).toFixed(2)}GB free)`),b.isWindows||i.push(`Load (avg):       ${D.loadavg().map(o=>Math.round(o)).join(", ")}`),i.push(`VM:               ${Math.round(I.virtualMachineHint.value()*100)}%`),i.push(`Screen Reader:    ${a.screenReader?"yes":"no"}`),i.push(`Process Argv:     ${a.mainArguments.join(" ")}`),i.push(`GPU Status:       ${this.expandGPUFeatures(a.gpuFeatureStatus)}`),i.join(`
`)}async getPerformanceInfo(a,i){return Promise.all([(0,f.listProcesses)(a.mainPID),this.formatWorkspaceMetadata(a)]).then(async t=>{let[o,s]=t,c=this.formatProcessList(a,o);return i.forEach(h=>{if((0,S.isRemoteDiagnosticError)(h))c+=`
${h.errorMessage}`,s+=`
${h.errorMessage}`;else if(c+=`

Remote: ${h.hostName}`,h.processes&&(c+=`
${this.formatProcessList(a,h.processes)}`),h.workspaceMetadata){s+=`
|  Remote: ${h.hostName}`;for(const m of Object.keys(h.workspaceMetadata)){const P=h.workspaceMetadata[m];let _=`${P.fileCount} files`;P.maxFilesReached&&(_=`more than ${_}`),s+=`|    Folder (${m}): ${_}`,s+=this.formatWorkspaceStats(P)}}}),{processInfo:c,workspaceInfo:s}})}async getSystemInfo(a,i){const{memory:t,vmHint:o,os:s,cpus:c}=y(),h={os:s,memory:t,cpus:c,vmHint:o,processArgs:`${a.mainArguments.join(" ")}`,gpuStatus:a.gpuFeatureStatus,screenReader:`${a.screenReader?"yes":"no"}`,remoteData:i};return b.isWindows||(h.load=`${D.loadavg().map(m=>Math.round(m)).join(", ")}`),b.isLinux&&(h.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(h)}async getDiagnostics(a,i){const t=[];return(0,f.listProcesses)(a.mainPID).then(async o=>(t.push(""),t.push(this.formatEnvironment(a)),t.push(""),t.push(this.formatProcessList(a,o)),a.windows.some(s=>s.folderURIs&&s.folderURIs.length>0&&!s.remoteAuthority)&&(t.push(""),t.push("Workspace Stats: "),t.push(await this.formatWorkspaceMetadata(a))),i.forEach(s=>{if((0,S.isRemoteDiagnosticError)(s))t.push(`
${s.errorMessage}`);else if(t.push(`

`),t.push(`Remote:           ${s.hostName}`),t.push(this.formatMachineInfo(s.machineInfo)),s.processes&&t.push(this.formatProcessList(a,s.processes)),s.workspaceMetadata)for(const c of Object.keys(s.workspaceMetadata)){const h=s.workspaceMetadata[c];let m=`${h.fileCount} files`;h.maxFilesReached&&(m=`more than ${m}`),t.push(`Folder (${c}): ${m}`),t.push(this.formatWorkspaceStats(h))}}),t.push(""),t.push(""),t.join(`
`)))}formatWorkspaceStats(a){const i=[],t=60;let o=0;const s=(P,_)=>{const O=` ${P}(${_})`;o+O.length>t?(i.push(c),c="|                 ",o=c.length):o+=O.length,c+=O};let c="|      File types:";const h=10;let m=a.fileTypes.length>h?h:a.fileTypes.length;for(let P=0;P<m;P++){const _=a.fileTypes[P];s(_.name,_.count)}if(i.push(c),a.configFiles.length>=0&&(c="|      Conf files:",o=0,a.configFiles.forEach(P=>{s(P.name,P.count)}),i.push(c)),a.launchConfigFiles.length>0){let P="|      Launch Configs:";a.launchConfigFiles.forEach(_=>{P+=_.count>1?` ${_.name}(${_.count})`:` ${_.name}`}),i.push(P)}return i.join(`
`)}expandGPUFeatures(a){const i=Math.max(...Object.keys(a).map(t=>t.length));return Object.keys(a).map(t=>`${t}:  ${" ".repeat(i-t.length)}  ${a[t]}`).join(`
                  `)}formatWorkspaceMetadata(a){const i=[],t=[];return a.windows.forEach(o=>{o.folderURIs.length===0||!!o.remoteAuthority||(i.push(`|  Window (${o.title})`),o.folderURIs.forEach(s=>{const c=E.URI.revive(s);if(c.scheme===A.Schemas.file){const h=c.fsPath;t.push(g(h,["node_modules",".git"]).then(m=>{let P=`${m.fileCount} files`;m.maxFilesReached&&(P=`more than ${P}`),i.push(`|    Folder (${(0,R.basename)(h)}): ${P}`),i.push(this.formatWorkspaceStats(m))}).catch(m=>{i.push(`|      Error: Unable to collect workspace stats for folder ${h} (${m.toString()})`)}))}else i.push(`|    Folder (${c.toString()}): Workspace stats not available.`)}))}),Promise.all(t).then(o=>i.join(`
`)).catch(o=>`Unable to collect workspace stats: ${o}`)}formatProcessList(a,i){const t=new Map;a.windows.forEach(s=>t.set(s.pid,s.title));const o=[];return o.push("CPU %	Mem MB	   PID	Process"),i&&this.formatProcessItem(a.mainPID,t,o,i,0),o.join(`
`)}formatProcessItem(a,i,t,o,s){const c=s===0;let h;c?h=o.pid===a?`${this.productService.applicationName} main`:"remote agent":(h=`${"  ".repeat(s)} ${o.name}`,o.name==="window"&&(h=`${h} (${i.get(o.pid)})`));const m=process.platform==="win32"?o.mem:D.totalmem()*(o.mem/100);t.push(`${o.load.toFixed(0).padStart(5," ")}	${(m/u.ByteSize.MB).toFixed(0).padStart(6," ")}	${o.pid.toFixed(0).padStart(6," ")}	${h}`),Array.isArray(o.children)&&o.children.forEach(P=>this.formatProcessItem(a,i,t,P,s+1))}async reportWorkspaceStats(a){for(const{uri:i}of a.folders){const t=E.URI.revive(i);if(t.scheme!==A.Schemas.file)continue;const o=t.fsPath;try{const s=await g(o,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":a.telemetryId,rendererSessionId:a.rendererSessionId}),s.fileTypes.forEach(c=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:a.rendererSessionId,type:c.name,count:c.count})}),s.launchConfigFiles.forEach(c=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:a.rendererSessionId,type:c.name,count:c.count})}),s.configFiles.forEach(c=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:a.rendererSessionId,type:c.name,count:c.count})})}catch{}}}};l=de([Y(0,d.ITelemetryService),Y(1,v.IProductService)],l),e.DiagnosticsService=l}),define(ne[207],ie([0,1,16,5,23,9,3,2,4,15,7,129,30,31,8,26,21]),function(J,e,D,n,L,T,A,R,b,E,I,C,f,S,u,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=void 0;let g=class extends R.Disposable{constructor(a,i,t,o){super();this.galleryService=a,this.telemetryService=i,this.logService=t,this.productService=o,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new A.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new A.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new A.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new A.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,R.toDisposable)(()=>{this.installingExtensions.forEach(s=>s.cancel()),this.uninstallingExtensions.forEach(s=>s.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(a){const i=await this.getTargetPlatform();return a.allTargetPlatforms.some(t=>(0,f.isTargetPlatformCompatible)(t,a.allTargetPlatforms,i))}async installFromGallery(a,i={}){try{if(!this.galleryService.isEnabled())throw new f.ExtensionManagementError(C.localize(0,null),f.ExtensionManagementErrorCode.Internal);const t=await this.checkAndGetCompatibleVersion(a,!i.installGivenVersion,!!i.installPreReleaseVersion);return await this.installExtension(t.manifest,t.extension,i)}catch(t){throw p(this.telemetryService,"extensionGallery:install",(0,S.getGalleryExtensionTelemetryData)(a),void 0,t),this.logService.error("Failed to install extension.",a.identifier.id),this.logService.error(t),y(t)}}async uninstall(a,i={}){return this.logService.trace("ExtensionManagementService#uninstall",a.identifier.id),this.unininstallExtension(a,i)}async reinstallFromGallery(a){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",a.identifier.id),!this.galleryService.isEnabled())throw new Error(C.localize(1,null));const i=await this.findGalleryExtension(a);if(!i)throw new Error(C.localize(2,null));await this.createUninstallExtensionTask(a,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(i)}getExtensionsControlManifest(){const a=new Date().getTime();return(!this.extensionsControlManifest||a-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=a),this.extensionsControlManifest}registerParticipant(a){this.participants.push(a)}async installExtension(a,i,t){if(!I.URI.isUri(i)){let m=this.installingExtensions.get(new S.ExtensionIdentifierWithVersion(i.identifier,i.version).key());if(m)return this.logService.info("Extensions is already requested to install",i.identifier.id),m.waitUntilTaskIsFinished();t={...t,installOnlyNewlyAddedFromExtensionPack:!0}}const o=[],s=[],c=this.createInstallExtensionTask(a,i,t);I.URI.isUri(i)||this.installingExtensions.set(new S.ExtensionIdentifierWithVersion(c.identifier,a.version).key(),c),this._onInstallExtension.fire({identifier:c.identifier,source:i}),this.logService.info("Installing extension:",c.identifier.id),o.push({task:c,manifest:a});let h=!1;try{if(t.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",c.identifier.id);else try{const P=await this.getAllDepsAndPackExtensionsToInstall(c.identifier,a,!!t.installOnlyNewlyAddedFromExtensionPack,!!t.installPreReleaseVersion);for(const{gallery:_,manifest:O}of P)if(h=h||!!O.extensionDependencies?.some(M=>(0,S.areSameExtensions)({id:M},c.identifier)),this.installingExtensions.has(new S.ExtensionIdentifierWithVersion(_.identifier,_.version).key()))this.logService.info("Extension is already requested to install",_.identifier.id);else{const M=this.createInstallExtensionTask(O,_,{...t,donotIncludePackAndDependencies:!0});this.installingExtensions.set(new S.ExtensionIdentifierWithVersion(M.identifier,O.version).key(),M),this._onInstallExtension.fire({identifier:M.identifier,source:_}),this.logService.info("Installing extension:",M.identifier.id),o.push({task:M,manifest:O})}}catch(P){if(I.URI.isUri(c.source))(0,D.isNonEmptyArray)(a.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",c.identifier.id,P.message),(0,D.isNonEmptyArray)(a.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",c.identifier.id,P.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",c.identifier.id),P}const m=o.reduce((P,{task:_,manifest:O})=>(P.set(_.identifier.id.toLowerCase(),{task:_,manifest:O}),P),new Map);for(;m.size;){let P;const _=[...m.values()].filter(({manifest:O})=>!O.extensionDependencies?.some(M=>m.has(M.toLowerCase())));_.length?P=m.size===1?_:_.filter(({task:O})=>!(O===c&&!h)):(this.logService.info("Found extensions with circular dependencies",_.map(({task:O})=>O.identifier.id)),P=[...m.values()]),await this.joinAllSettled(P.map(async({task:O})=>{const M=new Date().getTime(),k=(0,E.isUndefined)(t.operation)?O.operation:t.operation;try{const U=await O.run();if(await this.joinAllSettled(this.participants.map(N=>N.postInstall(U,O.source,t,L.CancellationToken.None))),!I.URI.isUri(O.source)&&(p(this.telemetryService,k===3?"extensionGallery:update":"extensionGallery:install",(0,S.getGalleryExtensionTelemetryData)(O.source),new Date().getTime()-M,void 0),b.isWeb&&k!==3))try{await this.galleryService.reportStatistic(U.manifest.publisher,U.manifest.name,U.manifest.version,"install")}catch{}s.push({local:U,identifier:O.identifier,operation:k,source:O.source})}catch(U){throw I.URI.isUri(O.source)||p(this.telemetryService,k===3?"extensionGallery:update":"extensionGallery:install",(0,S.getGalleryExtensionTelemetryData)(O.source),new Date().getTime()-M,U),this.logService.error("Error while installing the extension:",O.identifier.id),U}finally{m.delete(O.identifier.id.toLowerCase())}}))}return s.forEach(({identifier:P})=>this.logService.info("Extension installed successfully:",P.id)),this._onDidInstallExtensions.fire(s),s.filter(({identifier:P})=>(0,S.areSameExtensions)(P,c.identifier))[0].local}catch(m){if(o.forEach(({task:P})=>P.cancel()),s.length)try{const P=await Promise.allSettled(s.map(({local:_})=>this.createUninstallExtensionTask(_,{versionOnly:!0}).run()));for(let _=0;_<P.length;_++){const O=P[_],{identifier:M}=s[_];O.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",M.id):this.logService.warn("Rollback: Error while uninstalling extension",M.id,(0,T.getErrorMessage)(O.reason))}}catch(P){this.logService.warn("Error while rolling back extensions",(0,T.getErrorMessage)(P),s.map(({identifier:_})=>_.id))}throw this._onDidInstallExtensions.fire(o.map(({task:P})=>({identifier:P.identifier,operation:2,source:P.source}))),m}finally{for(const{task:m,manifest:P}of o)if(!I.URI.isUri(m.source)){const _=new S.ExtensionIdentifierWithVersion(m.identifier,P.version).key();this.installingExtensions.delete(_)||this.logService.warn("Installation task is not found in the cache",_)}}}async joinAllSettled(a){const i=[],t=[],o=await Promise.allSettled(a);for(const s of o)s.status==="fulfilled"?i.push(s.value):t.push(s.reason);if(t.length)throw w(t);return i}async getAllDepsAndPackExtensionsToInstall(a,i,t,o){if(!this.galleryService.isEnabled())return[];let s=await this.getInstalled();const c=[a,...s.map(P=>P.identifier)],h=[],m=async(P,_)=>{const O=_.extensionDependencies||[],M=[...O];if(_.extensionPack){const k=t?s.find(U=>(0,S.areSameExtensions)(U.identifier,P)):void 0;for(const U of _.extensionPack)k&&k.manifest.extensionPack&&k.manifest.extensionPack.some(N=>(0,S.areSameExtensions)({id:N},{id:U}))||M.every(N=>!(0,S.areSameExtensions)({id:N},{id:U}))&&M.push(U)}if(M.length){const k=[...c,...h.map(N=>N.gallery.identifier)],U=M.filter(N=>k.every(V=>!(0,S.areSameExtensions)(V,{id:N})));if(U.length){const N=await this.galleryService.query({names:U,pageSize:M.length},L.CancellationToken.None);for(const V of N.firstPage){if(k.find(te=>(0,S.areSameExtensions)(te,V.identifier)))continue;const $=O.some(te=>(0,S.areSameExtensions)({id:te},V.identifier));let G;try{G=await this.checkAndGetCompatibleVersion(V,!0,o)}catch(te){if(te instanceof f.ExtensionManagementError&&te.code===f.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!$){this.logService.info("Skipping the packed extension as it cannot be installed",V.identifier.id);continue}else throw te}h.push({gallery:G.extension,manifest:G.manifest}),await m(G.extension.identifier,_)}}}};return await m(a,i),s=await this.getInstalled(),h.filter(P=>!s.some(_=>(0,S.areSameExtensions)(_.identifier,P.gallery.identifier)))}async checkAndGetCompatibleVersion(a,i,t){const o=await this.getExtensionsControlManifest();if((0,S.getMaliciousExtensionsSet)(o).has(a.identifier.id))throw new f.ExtensionManagementError(C.localize(3,null,a.identifier.id),f.ExtensionManagementErrorCode.Malicious);if(!!o.unsupportedPreReleaseExtensions&&!!o.unsupportedPreReleaseExtensions[a.identifier.id])throw new f.ExtensionManagementError(C.localize(4,null,a.identifier.id,o.unsupportedPreReleaseExtensions[a.identifier.id].displayName),f.ExtensionManagementErrorCode.UnsupportedPreRelease);if(!await this.canInstall(a)){const h=await this.getTargetPlatform();throw new f.ExtensionManagementError(C.localize(5,null,a.identifier.id,this.productService.nameLong,(0,f.TargetPlatformToString)(h)),f.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const s=await this.getCompatibleVersion(a,i,t);if(s){if(t&&i&&a.hasPreReleaseVersion&&!s.properties.isPreReleaseVersion)throw new f.ExtensionManagementError(C.localize(6,null,a.identifier.id,this.productService.nameLong,this.productService.version),f.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!t&&a.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([a.identifier],L.CancellationToken.None))[0]?new f.ExtensionManagementError(C.localize(7,null,a.identifier.id),f.ExtensionManagementErrorCode.ReleaseVersionNotFound):new f.ExtensionManagementError(C.localize(8,null,a.identifier.id,this.productService.nameLong,this.productService.version),f.ExtensionManagementErrorCode.Incompatible);this.logService.info("Getting Manifest...",s.identifier.id);const c=await this.galleryService.getManifest(s,L.CancellationToken.None);if(c===null)throw new f.ExtensionManagementError(`Missing manifest for extension ${a.identifier.id}`,f.ExtensionManagementErrorCode.Invalid);if(c.version!==s.version)throw new f.ExtensionManagementError(`Cannot install '${a.identifier.id}' extension because of version mismatch in Marketplace`,f.ExtensionManagementErrorCode.Invalid);return{extension:s,manifest:c}}async getCompatibleVersion(a,i,t){const o=await this.getTargetPlatform();let s=null;return i&&a.hasPreReleaseVersion&&a.properties.isPreReleaseVersion!==t&&(s=(await this.galleryService.getExtensions([{...a.identifier,preRelease:t}],{targetPlatform:o,compatible:!0},L.CancellationToken.None))[0]||null),!s&&await this.galleryService.isExtensionCompatible(a,t,o)&&(s=a),!s&&i&&(s=await this.galleryService.getCompatibleExtension(a,t,o)),s}async unininstallExtension(a,i){const t=this.uninstallingExtensions.get(a.identifier.id.toLowerCase());if(t)return this.logService.info("Extensions is already requested to uninstall",a.identifier.id),t.waitUntilTaskIsFinished();const o=(m,P)=>{const _=this.createUninstallExtensionTask(m,P);return this.uninstallingExtensions.set(_.extension.identifier.id.toLowerCase(),_),this.logService.info("Uninstalling extension:",m.identifier.id),this._onUninstallExtension.fire(m.identifier),_},s=(m,P)=>{P?this.logService.error("Failed to uninstall extension:",m.identifier.id,P.message):this.logService.info("Successfully uninstalled extension:",m.identifier.id),p(this.telemetryService,"extensionGallery:uninstall",(0,S.getLocalExtensionTelemetryData)(m),void 0,P),this._onDidUninstallExtension.fire({identifier:m.identifier,error:P?.code})},c=[],h=[];try{c.push(o(a,{}));const m=await this.getInstalled(1);if(i.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",a.identifier.id);else{const P=this.getAllPackExtensionsToUninstall(a,m);for(const _ of P)this.uninstallingExtensions.has(_.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",_.identifier.id):c.push(o(_,{}))}i.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",a.identifier.id):this.checkForDependents(c.map(P=>P.extension),m,a),await this.joinAllSettled(c.map(async P=>{try{if(await P.run(),await this.joinAllSettled(this.participants.map(_=>_.postUninstall(P.extension,i,L.CancellationToken.None))),P.extension.identifier.uuid)try{await this.galleryService.reportStatistic(P.extension.manifest.publisher,P.extension.manifest.name,P.extension.manifest.version,"uninstall")}catch{}s(P.extension)}catch(_){const O=_ instanceof f.ExtensionManagementError?_:new f.ExtensionManagementError((0,T.getErrorMessage)(_),f.ExtensionManagementErrorCode.Internal);throw s(P.extension,O),O}finally{h.push(P)}}))}catch(m){const P=m instanceof f.ExtensionManagementError?m:new f.ExtensionManagementError((0,T.getErrorMessage)(m),f.ExtensionManagementErrorCode.Internal);for(const _ of c){try{_.cancel()}catch{}h.includes(_)||s(_.extension,P)}throw P}finally{for(const m of c)this.uninstallingExtensions.delete(m.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",m.extension.identifier.id)}}checkForDependents(a,i,t){for(const o of a){const s=this.getDependents(o,i);if(s.length){const c=s.filter(h=>!a.some(m=>(0,S.areSameExtensions)(m.identifier,h.identifier)));if(c.length)throw new Error(this.getDependentsErrorMessage(o,c,t))}}}getDependentsErrorMessage(a,i,t){return t===a?i.length===1?C.localize(9,null,t.manifest.displayName||t.manifest.name,i[0].manifest.displayName||i[0].manifest.name):i.length===2?C.localize(10,null,t.manifest.displayName||t.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name):C.localize(11,null,t.manifest.displayName||t.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name):i.length===1?C.localize(12,null,t.manifest.displayName||t.manifest.name,a.manifest.displayName||a.manifest.name,i[0].manifest.displayName||i[0].manifest.name):i.length===2?C.localize(13,null,t.manifest.displayName||t.manifest.name,a.manifest.displayName||a.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name):C.localize(14,null,t.manifest.displayName||t.manifest.name,a.manifest.displayName||a.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name)}getAllPackExtensionsToUninstall(a,i,t=[]){if(t.indexOf(a)!==-1)return[];t.push(a);const o=a.manifest.extensionPack?a.manifest.extensionPack:[];if(o.length){const s=i.filter(h=>!h.isBuiltin&&o.some(m=>(0,S.areSameExtensions)({id:m},h.identifier))),c=[];for(const h of s)c.push(...this.getAllPackExtensionsToUninstall(h,i,t));return[...s,...c]}return[]}getDependents(a,i){return i.filter(t=>t.manifest.extensionDependencies&&t.manifest.extensionDependencies.some(o=>(0,S.areSameExtensions)({id:o},a.identifier)))}async findGalleryExtension(a){if(a.identifier.uuid){const i=await this.findGalleryExtensionById(a.identifier.uuid);return i||this.findGalleryExtensionByName(a.identifier.id)}return this.findGalleryExtensionByName(a.identifier.id)}async findGalleryExtensionById(a){return(await this.galleryService.query({ids:[a],pageSize:1},L.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(a){return(await this.galleryService.query({names:[a],pageSize:1},L.CancellationToken.None)).firstPage[0]}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const a=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",a),a}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[]}}}};g=de([Y(0,f.IExtensionGalleryService),Y(1,d.ITelemetryService),Y(2,u.ILogService),Y(3,v.IProductService)],g),e.AbstractExtensionManagementService=g;function w(r){const a=Array.isArray(r)?r:[r];return a.length===1?a[0]instanceof Error?a[0]:new Error(a[0]):a.reduce((i,t)=>new Error(`${i.message}${i.message?",":""}${t instanceof Error?t.message:t}`),new Error(""))}e.joinErrors=w;function y(r){if(r instanceof f.ExtensionManagementError)return r;const a=new f.ExtensionManagementError(r.message,f.ExtensionManagementErrorCode.Internal);return a.stack=r.stack,a}function p(r,a,i,t,o){const s=o?o instanceof f.ExtensionManagementError?o.code:f.ExtensionManagementErrorCode.Internal:void 0;r.publicLogError(a,{...i,success:!o,duration:t,errorcode:s})}e.reportTelemetry=p;class l{constructor(){this.barrier=new n.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,n.createCancelablePromise)(a=>this.doRun(a))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,n.createCancelablePromise)(a=>new Promise((i,t)=>{const o=a.onCancellationRequested(()=>{o.dispose(),t((0,T.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=l}),define(ne[208],ie([0,1,16,5,67,3,10,4,32,7,131,13,30,196,82,14,8,60,26,43,24,21]),function(J,e,D,n,L,T,A,R,b,E,I,C,f,S,u,v,d,g,w,y,p,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const r="extensionTips/promptedExecutableTips",a="extensionTips/lastPromptedMediumImpExeTime";let i=class extends S.ExtensionTipsService{constructor(o,s,c,h,m,P,_,O,M,k){super(_,O,M,k);this.environmentService=o,this.telemetryService=s,this.extensionManagementService=c,this.storageService=h,this.nativeHostService=m,this.extensionRecommendationNotificationService=P,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,O.exeBasedExtensionTips&&(0,L.forEach)(O.exeBasedExtensionTips,({key:U,value:N})=>{const V=[],$=[],G=[];(0,L.forEach)(N.recommendations,({key:te,value:W})=>{W.important?N.important?V.push({extensionId:te,extensionName:W.name,isExtensionPack:!!W.isExtensionPack}):$.push({extensionId:te,extensionName:W.name,isExtensionPack:!!W.isExtensionPack}):G.push({extensionId:te,extensionName:W.name,isExtensionPack:!!W.isExtensionPack})}),V.length&&this.highImportanceExecutableTips.set(U,{exeFriendlyName:N.friendlyName,windowsPath:N.windowsPath,recommendations:V}),$.length&&this.mediumImportanceExecutableTips.set(U,{exeFriendlyName:N.friendlyName,windowsPath:N.windowsPath,recommendations:$}),G.length&&this.allOtherExecutableTips.set(U,{exeFriendlyName:N.friendlyName,windowsPath:N.windowsPath,recommendations:G})}),(0,n.timeout)(3e3).then(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()})}async getImportantExecutableBasedTips(){const o=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),s=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...o,...s]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const o=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),s=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),c=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(o,c),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(s,c)}groupImportantTipsByExe(o,s){const c=new Map;o.forEach(O=>c.set(O.extensionId.toLowerCase(),O));const{installed:h,uninstalled:m}=this.groupByInstalled([...c.keys()],s);for(const O of h){const M=c.get(O);M&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:O,exeName:M.exeName})}for(const O of m){const M=c.get(O);M&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:O,exeName:M.exeName})}const P=this.getPromptedExecutableTips(),_=new Map;for(const O of m){const M=c.get(O);if(M&&(!P[M.exeName]||!P[M.exeName].includes(M.extensionId))){let k=_.get(M.exeName);k||(k=[],_.set(M.exeName,k)),k.push(M)}}return _}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size===0)return;const[o,s]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(s).then(c=>{switch(c){case"reacted":this.addToRecommendedExecutables(s[0].exeName,s);break;case"ignored":this.highImportanceTipsByExe.delete(o);break;case"incompatibleWindow":{const h=T.Event.once(T.Event.latch(T.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(h(()=>this.promptHighImportanceExeBasedTip()));break}case"toomany":{const h=this._register((0,n.disposableTimeout)(()=>{h.dispose(),this.promptHighImportanceExeBasedTip()},60*60*1e3));break}}})}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size===0)return;const o=this.getLastPromptedMediumExeTime(),s=Date.now()-o,c=7*24*60*60*1e3;if(s<c){const P=this._register((0,n.disposableTimeout)(()=>{P.dispose(),this.promptMediumImportanceExeBasedTip()},c-s));return}const[h,m]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(m).then(P=>{switch(P){case"reacted":{this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(h),this.addToRecommendedExecutables(m[0].exeName,m);const _=this._register((0,n.disposableTimeout)(()=>{_.dispose(),this.promptMediumImportanceExeBasedTip()},c));break}case"ignored":this.mediumImportanceTipsByExe.delete(h),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":{const _=T.Event.once(T.Event.latch(T.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(_(()=>this.promptMediumImportanceExeBasedTip()));break}case"toomany":{const _=this._register((0,n.disposableTimeout)(()=>{_.dispose(),this.promptMediumImportanceExeBasedTip()},60*60*1e3));break}}})}promptExeRecommendations(o){const s=o.map(({extensionId:h})=>h.toLowerCase()),c=(0,I.localize)(0,null,o[0].exeFriendlyName);return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification(s,c,`@exe:"${o[0].exeName}"`,3)}getLastPromptedMediumExeTime(){let o=this.storageService.getNumber(a,0);return o||(o=Date.now(),this.updateLastPromptedMediumExeTime(o)),o}updateLastPromptedMediumExeTime(o){this.storageService.store(a,o,0,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(r,0,"{}"))}addToRecommendedExecutables(o,s){const c=this.getPromptedExecutableTips();c[o]=s.map(({extensionId:h})=>h.toLowerCase()),this.storageService.store(r,JSON.stringify(c),0,0)}groupByInstalled(o,s){const c=[],h=[],m=s.reduce((P,_)=>(P.add(_.identifier.id.toLowerCase()),P),new Set);return o.forEach(P=>{m.has(P.toLowerCase())?c.push(P):h.push(P)}),{installed:c,uninstalled:h}}async getValidExecutableBasedExtensionTips(o){const s=[],c=new Map;for(const h of o.keys()){const m=o.get(h);if(!m||!(0,D.isNonEmptyArray)(m.recommendations))continue;const P=[];R.isWindows?m.windowsPath&&P.push(m.windowsPath.replace("%USERPROFILE%",b.env.USERPROFILE).replace("%ProgramFiles(x86)%",b.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",b.env.ProgramFiles).replace("%APPDATA%",b.env.APPDATA).replace("%WINDIR%",b.env.WINDIR)):(P.push((0,A.join)("/usr/local/bin",h)),P.push((0,A.join)("/usr/bin",h)),P.push((0,A.join)(this.environmentService.userHome.fsPath,h)));for(const _ of P){let O=c.get(_);if(O===void 0&&(O=await this.fileService.exists(E.URI.file(_)),c.set(_,O)),O)for(const{extensionId:M,extensionName:k,isExtensionPack:U}of m.recommendations)s.push({extensionId:M,extensionName:k,isExtensionPack:U,exeName:h,exeFriendlyName:m.exeFriendlyName,windowsPath:m.windowsPath})}}return s}};i=de([Y(0,C.INativeEnvironmentService),Y(1,l.ITelemetryService),Y(2,f.IExtensionManagementService),Y(3,p.IStorageService),Y(4,g.INativeHostService),Y(5,u.IExtensionRecommendationNotificationService),Y(6,v.IFileService),Y(7,w.IProductService),Y(8,y.IRequestService),Y(9,d.ILogService)],i),e.ExtensionTipsService=i}),define(ne[93],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class D{constructor(T){this.appenders=T}listen(T,A){throw new Error(`Event not found: ${A}`)}call(T,A,{eventName:R,data:b}){return this.appenders.forEach(E=>E.log(R,b)),Promise.resolve(null)}}e.TelemetryAppenderChannel=D;class n{constructor(T){this.channel=T}log(T,A){return this.channel.call("log",{eventName:T,data:A}).then(void 0,R=>`Failed to log telemetry: ${console.warn(R)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=n}),define(ne[44],ie([0,1,28,15,20,21]),function(J,e,D,n,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class A{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(g,w){return Promise.resolve(void 0)}publicLog2(g,w){return this.publicLog(g,w)}publicLogError(g,w){return Promise.resolve(void 0)}publicLogError2(g,w){return this.publicLogError(g,w)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=A,e.NullTelemetryService=new A;class R{async publicLog(g,w,y){}async publicLogError(g,w,y){}}e.NullEndpointTelemetryService=R,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function b(d,g){return g.onDidChangeConfiguration(w=>{w.source!==6&&d.publicLog2("updateConfiguration",{configurationSource:(0,L.ConfigurationTargetToString)(w.source),configurationKeys:u(w.sourceConfig)})})}e.configurationTelemetry=b;function E(d,g){return!(g.disableTelemetry||!d.enableTelemetry||g.extensionTestsLocationURI)}e.supportsTelemetry=E;function I(d){const g=d.getValue(T.TELEMETRY_SETTING_ID),w=d.getValue("telemetry.enableCrashReporter");if(d.getValue(T.TELEMETRY_OLD_SETTING_ID)===!1||w===!1)return 0;switch(g??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=I;function C(d){const g=Object.create(null),w=Object.create(null),y=Object.create(null);S(d,y);for(let p in y){p=p.length>150?p.substr(p.length-149):p;const l=y[p];typeof l=="number"?w[p]=l:typeof l=="boolean"?w[p]=l?1:0:typeof l=="string"?(l.length>8192&&console.warn(`Telemetry property: ${p} has been trimmed to 8192, the original length is ${l.length}`),g[p]=l.substring(0,8191)):typeof l!="undefined"&&l!==null&&(g[p]=l)}return{properties:g,measurements:w}}e.validateTelemetryData=C;function f(d){if(!d)return"none";let g="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(y=>{d.indexOf(`${y}+`)===0&&(g=y)}),g}e.cleanRemoteAuthority=f;function S(d,g,w=0,y){if(!!d)for(let p of Object.getOwnPropertyNames(d)){const l=d[p],r=y?y+p:p;Array.isArray(l)?g[r]=(0,D.safeStringify)(l):l instanceof Date?g[r]=l.toISOString():(0,n.isObject)(l)?w<2?S(l,g,w+1,r+"."):g[r]=(0,D.safeStringify)(l):g[r]=l}}function u(d){if(!d)return[];const g=[];return v(g,"",d),g}function v(d,g,w){w&&typeof w=="object"&&!Array.isArray(w)?Object.keys(w).forEach(y=>v(d,g?`${g}.${y}`:y,w[y])):d.push(g)}}),define(ne[209],ie([0,1,44,149]),function(J,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AssignmentService=e.BaseAssignmentService=void 0;class L{constructor(){}setSharedProperty(b,E){}postEvent(b,E){}}class T{constructor(b,E,I,C,f){this.getMachineId=b,this.configurationService=E,this.productService=I,this.telemetry=C,this.keyValueStorage=f,this.networkInitialized=!1,I.tasConfig&&this.experimentsEnabled&&(0,D.getTelemetryLevel)(this.configurationService)===3&&(this.tasClient=this.setupTASClient());const S=this.configurationService.getValue("experiments.overrideDelay"),u=typeof S=="number"?S:0;this.overrideInitDelay=new Promise(v=>setTimeout(v,u))}get experimentsEnabled(){return!0}async getTreatment(b){await this.overrideInitDelay;const E=this.configurationService.getValue("experiments.override."+b);if(E!==void 0)return E;if(!this.tasClient||!this.experimentsEnabled)return;let I;const C=await this.tasClient;return this.networkInitialized?I=C.getTreatmentVariable("vscode",b):I=await C.getTreatmentVariableAsync("vscode",b,!0),I=C.getTreatmentVariable("vscode",b),I}async setupTASClient(){const b=this.productService.quality==="stable"?n.TargetPopulation.Public:n.TargetPopulation.Insiders,E=await this.getMachineId(),I=new n.AssignmentFilterProvider(this.productService.version,this.productService.nameLong,E,b),C=this.productService.tasConfig,f=new(await new Promise((S,u)=>{J(["tas-client-umd"],S,u)})).ExperimentationService({filterProviders:[I],telemetry:this.telemetry,storageKey:n.ASSIGNMENT_STORAGE_KEY,keyValueStorage:this.keyValueStorage,featuresTelemetryPropertyName:C.featuresTelemetryPropertyName,assignmentContextTelemetryPropertyName:C.assignmentContextTelemetryPropertyName,telemetryEventName:C.telemetryEventName,endpoint:C.endpoint,refetchInterval:n.ASSIGNMENT_REFETCH_INTERVAL});return await f.initializePromise,f.initialFetch.then(()=>this.networkInitialized=!0),f}}e.BaseAssignmentService=T;class A extends T{constructor(b,E,I){super(()=>Promise.resolve(b),E,I,new L)}}e.AssignmentService=A}),define(ne[210],ie([0,1,16,23,9,28,4,32,15,7,20,13,30,31,78,14,8,26,43,46,24,21,44]),function(J,e,D,n,L,T,A,R,b,E,I,C,f,S,u,v,d,g,w,y,p,l,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const a=A.isWeb?"web":(0,f.getTargetPlatform)(A.platform,R.arch);var i;(function(z){z[z.None=0]="None",z[z.IncludeVersions=1]="IncludeVersions",z[z.IncludeFiles=2]="IncludeFiles",z[z.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",z[z.IncludeSharedAccounts=8]="IncludeSharedAccounts",z[z.IncludeVersionProperties=16]="IncludeVersionProperties",z[z.ExcludeNonValidated=32]="ExcludeNonValidated",z[z.IncludeInstallationTargets=64]="IncludeInstallationTargets",z[z.IncludeAssetUri=128]="IncludeAssetUri",z[z.IncludeStatistics=256]="IncludeStatistics",z[z.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",z[z.Unpublished=4096]="Unpublished",z[z.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(i||(i={}));function t(...z){return String(z.reduce((q,ee)=>q|ee,0))}var o;(function(z){z[z.Tag=1]="Tag",z[z.ExtensionId=4]="ExtensionId",z[z.Category=5]="Category",z[z.ExtensionName=7]="ExtensionName",z[z.Target=8]="Target",z[z.Featured=9]="Featured",z[z.SearchText=10]="SearchText",z[z.ExcludeWithFlags=12]="ExcludeWithFlags"})(o||(o={}));const s={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},c={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},m={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:i.None,criteria:[],assetTypes:[]};class P{constructor(q=m){this.state=q}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(q,ee=this.state.pageSize){return new P({...this.state,pageNumber:q,pageSize:ee})}withFilter(q,...ee){const se=[...this.state.criteria,...ee.length?ee.map(ce=>({filterType:q,value:ce})):[{filterType:q}]];return new P({...this.state,criteria:se})}withSortBy(q){return new P({...this.state,sortBy:q})}withSortOrder(q){return new P({...this.state,sortOrder:q})}withFlags(...q){return new P({...this.state,flags:q.reduce((ee,se)=>ee|se,0)})}withAssetTypes(...q){return new P({...this.state,assetTypes:q})}get raw(){const{criteria:q,pageNumber:ee,pageSize:se,sortBy:ce,sortOrder:ue,flags:ve,assetTypes:pe}=this.state;return{filters:[{criteria:q,pageNumber:ee,pageSize:se,sortBy:ce,sortOrder:ue}],assetTypes:pe,flags:ve}}get searchText(){const q=this.state.criteria.filter(ee=>ee.filterType===o.SearchText)[0];return q&&q.value?q.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(q=>String(q.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function _(z,q){const ee=(z||[]).filter(se=>se.statisticName===q)[0];return ee?ee.value:0}function O(z){const q="Microsoft.VisualStudio.Code.Translation.";return z.files.filter(se=>se.assetType.indexOf(q)===0).reduce((se,ce)=>{const ue=N(z,ce.assetType);return ue&&se.push([ce.assetType.substring(q.length),ue]),se},[])}function M(z){if(z.properties){const q=z.properties.filter(ce=>ce.key===s.Repository),ee=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),se=q.filter(ce=>ee.test(ce.value))[0];return se?{uri:se.value,fallbackUri:se.value}:null}return N(z,s.Repository)}function k(z){return{uri:`${z.fallbackAssetUri}/${s.VSIX}?redirect=true${z.targetPlatform?`&targetPlatform=${z.targetPlatform}`:""}`,fallbackUri:`${z.fallbackAssetUri}/${s.VSIX}${z.targetPlatform?`?targetPlatform=${z.targetPlatform}`:""}`}}function U(z){const q=N(z,s.Icon);if(q)return q;const ee=f.DefaultIconPath;return{uri:ee,fallbackUri:ee}}function N(z,q){return z.files.filter(se=>se.assetType===q)[0]?{uri:`${z.assetUri}/${q}${z.targetPlatform?`?targetPlatform=${z.targetPlatform}`:""}`,fallbackUri:`${z.fallbackAssetUri}/${q}${z.targetPlatform?`?targetPlatform=${z.targetPlatform}`:""}`}:null}function V(z,q){const ee=z.properties?z.properties.filter(ce=>ce.key===q):[],se=ee.length>0&&ee[0].value;return se?se.split(",").map(ce=>(0,S.adoptToGalleryExtensionId)(ce)):[]}function $(z){const q=z.properties?z.properties.filter(ee=>ee.key===c.Engine):[];return q.length>0&&q[0].value||""}function G(z){const q=z.properties?z.properties.filter(ee=>ee.key===c.PreRelease):[];return q.length>0&&q[0].value==="true"}function te(z){const q=z.properties?z.properties.filter(se=>se.key===c.LocalizedLanguages):[],ee=q.length>0&&q[0].value||"";return ee?ee.split(","):[]}function W(z){return z.indexOf("preview")!==-1}function j(z){return z.targetPlatform?(0,f.toTargetPlatform)(z.targetPlatform):"undefined"}function K(z){const q=(0,D.distinct)(z.versions.map(j)),ee=!!z.tags?.includes(f.WEB_EXTENSION_TAG),se=q.indexOf("web");return ee?se===-1&&q.push("web"):se!==-1&&q.splice(se,1),q}function H(z,q){const ee=(0,f.getFallbackTargetPlarforms)(q);for(let se=0;se<z.length;se++){const ce=z[se];if(ce.version===z[se-1]?.version){let ue=se;const ve=j(ce);if(ve===q)for(;ue>0&&z[ue-1].version===ce.version;)ue--;else if(ee.includes(ve))for(;ue>0&&z[ue-1].version===ce.version&&j(z[ue-1])!==q;)ue--;ue!==se&&(z.splice(se,1),z.splice(ue,0,ce))}}return z}e.sortExtensionVersions=H;function Q(z,q,ee){const se=z.versions[0],ce={manifest:N(q,s.Manifest),readme:N(q,s.Details),changelog:N(q,s.Changelog),license:N(q,s.License),repository:M(q),download:k(q),icon:U(q),coreTranslations:O(q)};return{identifier:{id:(0,S.getGalleryExtensionId)(z.publisher.publisherName,z.extensionName),uuid:z.extensionId},name:z.extensionName,version:q.version,displayName:z.displayName,publisherId:z.publisher.publisherId,publisher:z.publisher.publisherName,publisherDisplayName:z.publisher.displayName,publisherDomain:z.publisher.domain?{link:z.publisher.domain,verified:!!z.publisher.isDomainVerified}:void 0,description:z.shortDescription||"",installCount:_(z.statistics,"install"),rating:_(z.statistics,"averagerating"),ratingCount:_(z.statistics,"ratingcount"),categories:z.categories||[],tags:z.tags||[],releaseDate:Date.parse(z.releaseDate),lastUpdated:Date.parse(z.lastUpdated),allTargetPlatforms:ee,assets:ce,properties:{dependencies:V(q,c.Dependency),extensionPack:V(q,c.ExtensionPack),engine:$(q),localizedLanguages:te(q),targetPlatform:j(q),isPreReleaseVersion:G(q)},hasPreReleaseVersion:G(se),hasReleaseVersion:!0,preview:W(z.flags)}}let Z=class{constructor(q,ee,se,ce,ue,ve,pe,Ie){this.requestService=ee,this.logService=se,this.environmentService=ce,this.telemetryService=ue,this.fileService=ve,this.productService=pe,this.configurationService=Ie;const Ee=pe.extensionsGallery;this.extensionsGalleryUrl=Ee&&Ee.serviceUrl,this.extensionsControlUrl=Ee&&Ee.controlUrl,this.commonHeadersPromise=x(pe.version,pe,this.environmentService,this.configurationService,this.fileService,q)}api(q=""){return`${this.extensionsGalleryUrl}${q}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(q,ee,se){const ce=n.CancellationToken.isCancellationToken(ee)?{targetPlatform:a}:ee,ue=n.CancellationToken.isCancellationToken(ee)?ee:se,ve=[],pe=[],Ie=[],Ee=[];for(const Re of q)Re.uuid?pe.push(Re.uuid):ve.push(Re.id),Ie.push({...Re,preRelease:!!Re.preRelease}),Re.version&&Ee.push({...Re,version:Re.version});if(!pe.length&&!ve.length)return[];let ye=new P().withPage(1,q.length);pe.length&&(ye=ye.withFilter(o.ExtensionId,...pe)),ve.length&&(ye=ye.withFilter(o.ExtensionName,...ve));const{extensions:be}=await this.queryGalleryExtensions(ye,{targetPlatform:ce.targetPlatform,preRelease:Ie,versions:Ee,compatible:!!ce.compatible},ue);return be}async getCompatibleExtension(q,ee,se){if((0,f.isNotWebExtensionInWebTargetPlatform)(q.allTargetPlatforms,se))return null;if(await this.isExtensionCompatible(q,ee,se))return q;const ce=new P().withFlags(i.IncludeVersions).withPage(1,1).withFilter(o.ExtensionId,q.identifier.uuid),{extensions:ue}=await this.queryGalleryExtensions(ce,{targetPlatform:se,compatible:!0,preRelease:ee},n.CancellationToken.None);return ue[0]||null}async isExtensionCompatible(q,ee,se){if(!(0,f.isTargetPlatformCompatible)(q.properties.targetPlatform,q.allTargetPlatforms,se)||!ee&&q.properties.isPreReleaseVersion)return!1;let ce=q.properties.engine;if(!ce){const ue=await this.getManifest(q,n.CancellationToken.None);if(!ue)throw new Error("Manifest was not found");ce=ue.engines.vscode}return(0,u.isEngineValid)(ce,this.productService.version,this.productService.date)}async isValidVersion(q,ee,se,ce,ue){if(!(0,f.isTargetPlatformCompatible)(j(q),ce,ue)||!ee&&G(q))return!1;if(se){const ve=await this.getEngine(q);if(!(0,u.isEngineValid)(ve,this.productService.version,this.productService.date))return!1}return!0}async query(q,ee){if(!this.isEnabled())throw new Error("No extension gallery service configured.");let se=q.text||"";const ce=(0,T.getOrDefault)(q,ye=>ye.pageSize,50);let ue=new P().withPage(1,ce);se?(se=se.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ye,be,Re)=>(ue=ue.withFilter(o.Category,Re||be),"")),se=se.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ye,be,Re)=>(ue=ue.withFilter(o.Tag,Re||be),"")),se=se.replace(/\bfeatured(\s+|\b|$)/g,()=>(ue=ue.withFilter(o.Featured),"")),se=se.trim(),se&&(se=se.length<200?se:se.substring(0,200),ue=ue.withFilter(o.SearchText,se)),ue=ue.withSortBy(0)):q.ids?ue=ue.withFilter(o.ExtensionId,...q.ids):q.names?ue=ue.withFilter(o.ExtensionName,...q.names):ue=ue.withSortBy(4),typeof q.sortBy=="number"&&(ue=ue.withSortBy(q.sortBy)),typeof q.sortOrder=="number"&&(ue=ue.withSortOrder(q.sortOrder));const ve=async(ye,be)=>{const{extensions:Re,total:Fe}=await this.queryGalleryExtensions(ye,{targetPlatform:a,compatible:!1,preRelease:!!q.includePreRelease},be);return Re.forEach((Me,qe)=>Me.telemetryData={index:(ye.pageNumber-1)*ye.pageSize+qe,querySource:q.source}),{extensions:Re,total:Fe}},{extensions:pe,total:Ie}=await ve(ue,ee),Ee=async(ye,be)=>{if(be.isCancellationRequested)throw new L.CancellationError;const{extensions:Re}=await ve(ue.withPage(ye+1),be);return Re};return{firstPage:pe,total:Ie,pageSize:ue.pageSize,getPage:Ee}}async queryGalleryExtensions(q,ee,se){const ce=q.flags;!!(q.flags&i.IncludeLatestVersionOnly)&&!!(q.flags&i.IncludeVersions)&&(q=q.withFlags(q.flags&~i.IncludeVersions,i.IncludeLatestVersionOnly)),!(q.flags&i.IncludeLatestVersionOnly)&&!(q.flags&i.IncludeVersions)&&(q=q.withFlags(q.flags,i.IncludeLatestVersionOnly)),ee.versions?.length&&(q=q.withFlags(q.flags&~i.IncludeLatestVersionOnly,i.IncludeVersions)),q=q.withFlags(q.flags,i.IncludeAssetUri,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeStatistics,i.IncludeVersionProperties);const{galleryExtensions:ue,total:ve}=await this.queryRawGalleryExtensions(q,se);if(!(q.flags&i.IncludeLatestVersionOnly)){const ye=[];for(const be of ue){const Re=await this.toGalleryExtensionWithCriteria(be,ee,!0);Re&&ye.push(Re)}return{extensions:ye,total:ve}}const Ie=[],Ee=new Map;for(let ye=0;ye<ue.length;ye++){const be=ue[ye],Re={id:(0,S.getGalleryExtensionId)(be.publisher.publisherName,be.extensionName),uuid:be.extensionId},Fe=(0,b.isBoolean)(ee.preRelease)?ee.preRelease:!!ee.preRelease.find(qe=>(0,S.areSameExtensions)(qe,Re))?.preRelease;let Me=await this.toGalleryExtensionWithCriteria(be,ee,!1);!Me||Me.properties.isPreReleaseVersion&&(!Fe||!Me.hasReleaseVersion)||!Me.properties.isPreReleaseVersion&&Me.properties.targetPlatform!==ee.targetPlatform&&Me.hasPreReleaseVersion?Ee.set(be.extensionId,ye):Ie.push([ye,Me])}if(Ee.size){const ye=new Date().getTime(),be=new P().withFlags(ce&~i.IncludeLatestVersionOnly,i.IncludeVersions).withPage(1,Ee.size).withFilter(o.ExtensionId,...Ee.keys()),{extensions:Re}=await this.queryGalleryExtensions(be,ee,se);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-ye,count:Ee.size});for(const Fe of Re){const Me=Ee.get(Fe.identifier.uuid);Ie.push([Me,Fe])}}return{extensions:Ie.sort((ye,be)=>ye[0]-be[0]).map(([,ye])=>ye),total:ve}}async toGalleryExtensionWithCriteria(q,ee,se){const ce={id:(0,S.getGalleryExtensionId)(q.publisher.publisherName,q.extensionName),uuid:q.extensionId},ue=ee.versions?.find(Ee=>(0,S.areSameExtensions)(Ee,ce))?.version,ve=(0,b.isBoolean)(ee.preRelease)?ee.preRelease:!!ee.preRelease.find(Ee=>(0,S.areSameExtensions)(Ee,ce))?.preRelease,pe=K(q),Ie=H(q.versions,ee.targetPlatform);if(ee.compatible&&se&&(0,f.isNotWebExtensionInWebTargetPlatform)(pe,ee.targetPlatform))return null;for(let Ee=0;Ee<Ie.length;Ee++){const ye=Ie[Ee];if(!(ue&&ye.version!==ue)){if(await this.isValidVersion(ye,ve,ee.compatible,pe,ee.targetPlatform))return Q(q,ye,pe);if(ue&&ye.version===ue)return null}}return ue||ee.compatible?null:Q(q,q.versions[0],pe)}async queryRawGalleryExtensions(q,ee){if(!this.isEnabled())throw new Error("No extension gallery service configured.");q=q.withFlags(q.flags,i.ExcludeNonValidated).withFilter(o.Target,"Microsoft.VisualStudio.Code").withFilter(o.ExcludeWithFlags,t(i.Unpublished));const se=await this.commonHeadersPromise,ce=JSON.stringify(q.raw),ue={...se,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(ce.length)},ve=new Date().getTime();let pe,Ie,Ee=0;try{if(pe=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:ce,headers:ue},ee),pe.res.statusCode&&pe.res.statusCode>=400&&pe.res.statusCode<500)return{galleryExtensions:[],total:Ee};const ye=await(0,w.asJson)(pe);if(ye){const be=ye.results[0],Re=be.extensions,Fe=be.resultMetadata&&be.resultMetadata.filter(Me=>Me.metadataType==="ResultCount")[0];return Ee=Fe&&Fe.metadataItems.filter(Me=>Me.name==="TotalCount")[0].count||0,{galleryExtensions:Re,total:Ee}}return{galleryExtensions:[],total:Ee}}catch(ye){throw Ie=ye,ye}finally{this.telemetryService.publicLog2("galleryService:query",{...q.telemetryData,requestBodySize:String(ce.length),duration:new Date().getTime()-ve,success:!!pe&&(0,w.isSuccess)(pe),responseBodySize:pe?.res.headers["Content-Length"],statusCode:pe?String(pe.res.statusCode):void 0,errorCode:Ie?(0,L.isCancellationError)(Ie)?"canceled":(0,L.getErrorMessage)(Ie).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(Ee)})}}async reportStatistic(q,ee,se,ce){if(!this.isEnabled())return;const ue=A.isWeb?this.api(`/itemName/${q}.${ee}/version/${se}/statType/${ce==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${q}/extensions/${ee}/${se}/stats?statType=${ce}`),ve=A.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",Ie={...await this.commonHeadersPromise,Accept:ve};try{await this.requestService.request({type:"POST",url:ue,headers:Ie},n.CancellationToken.None)}catch{}}async download(q,ee,se){this.logService.trace("ExtensionGalleryService#download",q.identifier.id);const ce=(0,S.getGalleryExtensionTelemetryData)(q),ue=new Date().getTime(),ve=ye=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...ce,duration:ye}),pe=se===2?"install":se===3?"update":"",Ie=pe?{uri:`${q.assets.download.uri}${E.URI.parse(q.assets.download.uri).query?"&":"?"}${pe}=true`,fallbackUri:`${q.assets.download.fallbackUri}${E.URI.parse(q.assets.download.fallbackUri).query?"&":"?"}${pe}=true`}:q.assets.download,Ee=await this.getAsset(Ie);await this.fileService.writeFile(ee,Ee.stream),ve(new Date().getTime()-ue)}async getReadme(q,ee){if(q.assets.readme){const se=await this.getAsset(q.assets.readme,{},ee);return await(0,w.asText)(se)||""}return""}async getManifest(q,ee){if(q.assets.manifest){const se=await this.getAsset(q.assets.manifest,{},ee),ce=await(0,w.asText)(se);return ce?JSON.parse(ce):null}return null}async getManifestFromRawExtensionVersion(q,ee){const se=N(q,s.Manifest);if(!se)throw new Error("Manifest was not found");const ce={"Accept-Encoding":"gzip"},ue=await this.getAsset(se,{headers:ce});return await(0,w.asJson)(ue)}async getCoreTranslation(q,ee){const se=q.assets.coreTranslations.filter(ce=>ce[0]===ee.toUpperCase())[0];if(se){const ce=await this.getAsset(se[1]),ue=await(0,w.asText)(ce);return ue?JSON.parse(ue):null}return null}async getChangelog(q,ee){if(q.assets.changelog){const se=await this.getAsset(q.assets.changelog,{},ee);return await(0,w.asText)(se)||""}return""}async getAllCompatibleVersions(q,ee,se){let ce=new P().withFlags(i.IncludeVersions,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,1);q.identifier.uuid?ce=ce.withFilter(o.ExtensionId,q.identifier.uuid):ce=ce.withFilter(o.ExtensionName,q.identifier.id);const{galleryExtensions:ue}=await this.queryRawGalleryExtensions(ce,n.CancellationToken.None);if(!ue.length)return[];const ve=K(ue[0]);if((0,f.isNotWebExtensionInWebTargetPlatform)(ve,se))return[];const pe=[],Ie=new Set;return await Promise.all(ue[0].versions.map(async Ee=>{try{if(Ie.has(Ee.version))return;Ie.add(Ee.version),await this.isValidVersion(Ee,ee,!0,ve,se)&&pe.push({version:Ee.version,date:Ee.lastUpdated,isPreReleaseVersion:G(Ee)})}catch{}})),pe}async getAsset(q,ee={},se=n.CancellationToken.None){const ce=await this.commonHeadersPromise,ue={type:"GET"},ve={...ce,...ee.headers||{}};ee={...ee,...ue,headers:ve};const pe=q.uri,Ie=q.fallbackUri,Ee={...ee,url:pe};try{const ye=await this.requestService.request(Ee,se);if(ye.res.statusCode===200)return ye;const be=await(0,w.asText)(ye);throw new Error(`Expected 200, got back ${ye.res.statusCode} instead.

${be}`)}catch(ye){if((0,L.isCancellationError)(ye))throw ye;const be=(0,L.getErrorMessage)(ye);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:pe,message:be});const Re={...ee,url:Ie};return this.requestService.request(Re,se)}}async getEngine(q){let ee=$(q);if(!ee){const se=await this.getManifestFromRawExtensionVersion(q,n.CancellationToken.None);if(!se)throw new Error("Manifest was not found");ee=se.engines.vscode}return ee}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[]};const q=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},n.CancellationToken.None);if(q.res.statusCode!==200)throw new Error("Could not get extensions report.");const ee=await(0,w.asJson)(q),se=[],ce={};if(ee){for(const ue of ee.malicious)se.push({id:ue});if(ee.unsupported)for(const ue of Object.keys(ee.unsupported)){const ve=ee.unsupported[ue];(0,b.isBoolean)(ve)||(ce[ue.toLowerCase()]=ve.preReleaseExtension)}if(ee.migrateToPreRelease)for(const[ue,ve]of Object.entries(ee.migrateToPreRelease))(!ve.engine||(0,u.isEngineValid)(ve.engine,this.productService.version,this.productService.date))&&(ce[ue.toLowerCase()]=ve)}return{malicious:se,unsupportedPreReleaseExtensions:ce}}};Z=de([Y(1,w.IRequestService),Y(2,d.ILogService),Y(3,C.IEnvironmentService),Y(4,l.ITelemetryService),Y(5,v.IFileService),Y(6,g.IProductService),Y(7,I.IConfigurationService)],Z);let B=class extends Z{constructor(q,ee,se,ce,ue,ve,pe,Ie){super(q,ee,se,ce,ue,ve,pe,Ie)}};B=de([Y(0,p.IStorageService),Y(1,w.IRequestService),Y(2,d.ILogService),Y(3,C.IEnvironmentService),Y(4,l.ITelemetryService),Y(5,v.IFileService),Y(6,g.IProductService),Y(7,I.IConfigurationService)],B),e.ExtensionGalleryService=B;let F=class extends Z{constructor(q,ee,se,ce,ue,ve,pe){super(void 0,q,ee,se,ce,ue,ve,pe)}};F=de([Y(0,w.IRequestService),Y(1,d.ILogService),Y(2,C.IEnvironmentService),Y(3,l.ITelemetryService),Y(4,v.IFileService),Y(5,g.IProductService),Y(6,I.IConfigurationService)],F),e.ExtensionGalleryServiceWithNoStorageService=F;async function x(z,q,ee,se,ce,ue){const ve={"X-Market-Client-Id":`VSCode ${z}`,"User-Agent":`VSCode ${z} (${q.nameShort})`},pe=await(0,y.getServiceMachineId)(ee,ce,ue);return(0,r.supportsTelemetry)(q,ee)&&(0,r.getTelemetryLevel)(se)===3&&(ve["X-Market-User-Id"]=pe),ve}e.resolveMarketplaceHeaders=x}),define(ne[94],ie([0,1,2,13,8,44]),function(J,e,D,n,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let A=class extends D.Disposable{constructor(b,E,I=""){super();this.prefix=I;const C=b.getLogger(E.telemetryLogResource);C?this.logger=this._register(C):(this.logger=this._register(b.createLogger(E.telemetryLogResource)),this.logger.info("The below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("==========================================================="))}flush(){return Promise.resolve(void 0)}log(b,E){this.logger.trace(`${this.prefix}telemetry/${b}`,(0,T.validateTelemetryData)(E))}};A=de([Y(0,L.ILoggerService),Y(1,n.IEnvironmentService)],A),e.TelemetryLogAppender=A}),define(ne[95],ie([0,1,2,28,4,27,141,20,42,87,38,21,44]),function(J,e,D,n,L,T,A,R,b,E,I,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let S=class{constructor(d,g){this._configurationService=g,this._experimentProperties={},this._disposables=new D.DisposableStore,this._cleanupPatterns=[],this._appenders=d.appenders,this._commonProperties=d.commonProperties||Promise.resolve({}),this._piiPaths=d.piiPaths||[],this._telemetryLevel=3,this.sendErrorTelemetry=!!d.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let w of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,T.escapeRegExpCharacters)(w),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._telemetryLevel===3}),this._commonProperties.then(w=>{const y=/^[a-f0-9]+$/i.test(w["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!y})})}setExperimentProperty(d,g){this._experimentProperties[d]=g}_updateTelemetryLevel(){this._telemetryLevel=(0,f.getTelemetryLevel)(this._configurationService)}get telemetryLevel(){return this._telemetryLevel}async getTelemetryInfo(){const d=await this._commonProperties;let g=d.sessionID,w=d["common.machineId"],y=d["common.firstSessionDate"],p=d["common.msftInternal"];return{sessionId:g,machineId:w,firstSessionDate:y,msftInternal:p}}dispose(){this._disposables.dispose()}_log(d,g,w,y){return this.telemetryLevel<g?Promise.resolve(void 0):this._commonProperties.then(p=>{w=(0,n.mixin)(w,p),w=(0,n.mixin)(w,this._experimentProperties),w=(0,n.cloneAndChange)(w,l=>{if(typeof l=="string")return this._cleanupInfo(l,y)}),this._appenders.forEach(l=>l.log(d,w))},p=>{console.error(p)})}publicLog(d,g,w){return this._log(d,3,g,w)}publicLog2(d,g,w){return this.publicLog(d,g,w)}publicLogError(d,g){return this.sendErrorTelemetry?this._log(d,2,g,!0):Promise.resolve(void 0)}publicLogError2(d,g){return this.publicLogError(d,g)}_anonymizeFilePaths(d){let g=d;const w=[];for(let r of this._cleanupPatterns)for(;;){const a=r.exec(d);if(!a)break;w.push([a.index,r.lastIndex])}const y=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,p=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let l=0;for(g="";;){const r=p.exec(d);if(!r)break;!y.test(r[0])&&w.every(([a,i])=>r.index<a||r.index>=i)&&(g+=d.substring(l,r.index)+"<REDACTED: user-file-path>",l=p.lastIndex)}return l<d.length&&(g+=d.substr(l)),g}_removePropertiesWithPossibleUserInfo(d){if(!d)return d;const g=d.toLowerCase(),w=/@[a-zA-Z0-9-.]+/,y=/(key|token|sig|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/,p=/xox[pbaors]\-[a-zA-Z0-9]+\-[a-zA-Z0-9\-]+?/;return y.test(g)?"<REDACTED: secret>":w.test(g)?"<REDACTED: email>":p.test(g)?"<REDACTED: token>":d}_cleanupInfo(d,g){let w=d;g&&(w=this._anonymizeFilePaths(w));for(let y of this._cleanupPatterns)w=w.replace(y,"");return w=this._removePropertiesWithPossibleUserInfo(w),w}};S.IDLE_START_EVENT_NAME="UserIdleStart",S.IDLE_STOP_EVENT_NAME="UserIdleStop",S=de([Y(1,R.IConfigurationService)],S),e.TelemetryService=S;function u(){const v=(0,A.localize)(0,null,E.default.nameLong),d=E.default.privacyStatementUrl?(0,A.localize)(2,null,"https://aka.ms/vscode-telemetry",E.default.privacyStatementUrl):(0,A.localize)(1,null,"https://aka.ms/vscode-telemetry"),g=L.isWeb?"":(0,A.localize)(3,null),w=(0,A.localize)(4,null),y=(0,A.localize)(5,null),p=(0,A.localize)(6,null),l=(0,A.localize)(7,null),r=`
|       | ${w} | ${y} | ${p} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,a=(0,A.localize)(8,null);return`
${v} ${d} ${g}

&nbsp;

${l}
${r}

&nbsp;

${a}
`}I.Registry.as(b.Extensions.Configuration).registerConfiguration({id:C.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,A.localize)(9,null),properties:{[C.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,A.localize)(10,null),(0,A.localize)(11,null),(0,A.localize)(12,null),(0,A.localize)(13,null)],markdownDescription:u(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),I.Registry.as(b.Extensions.Configuration).registerConfiguration({id:C.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,A.localize)(14,null),properties:{[C.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:E.default.privacyStatementUrl?(0,A.localize)(16,null,E.default.nameLong,E.default.privacyStatementUrl):(0,A.localize)(15,null,E.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,A.localize)(17,null,`\`#${C.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ne[211],ie([0,1,9,28,44]),function(J,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AppInsightsAppender=void 0;async function T(R,b){const E=await new Promise((C,f)=>{J(["applicationinsights"],C,f)});let I;return E.defaultClient?(I=new E.TelemetryClient(R),I.channel.setUseDiskRetryCaching(!0)):(E.setup(R).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),I=E.defaultClient),R.indexOf("AIF-")===0&&(I.config.endpointUrl=b?"https://mobile.events.data.microsoft.com/collect/v1":"https://vortex.data.microsoft.com/collect/v1"),I}class A{constructor(b,E,I,C,f){this._eventPrefix=b,this._defaultData=E,this.testCollector=C,this.mirrored=f,this._defaultData||(this._defaultData=Object.create(null)),typeof I=="function"?this._aiClient=I():this._aiClient=I,this._asyncAIClient=null}_withAIClient(b){if(!!this._aiClient){if(typeof this._aiClient!="string"){b(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=T(this._aiClient,this.testCollector??!1)),this._asyncAIClient.then(E=>{b(E)},E=>{(0,D.onUnexpectedError)(E),console.error(E)})}}log(b,E){if(!!this._aiClient){E=(0,n.mixin)(E,this._defaultData),E=(0,L.validateTelemetryData)(E),this.testCollector&&(E.properties["common.useragent"]=this.mirrored?"mirror-collector++":"collector++");try{this._withAIClient(I=>I.trackEvent({name:this._eventPrefix+"/"+b,properties:E.properties,measurements:E.measurements}))}catch{}}}flush(){return this._aiClient?new Promise(b=>{this._withAIClient(E=>{try{E.flush({callback:()=>{this._aiClient=void 0,b(void 0)}})}catch{}})}):Promise.resolve(void 0)}}e.AppInsightsAppender=A}),define(ne[212],ie([0,1,18,58,20,13,8,21,93,94,95]),function(J,e,D,n,L,T,A,R,b,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let C=class{constructor(S,u,v,d){this.configurationService=S,this.telemetryService=u,this.loggerService=v,this.environmentService=d,this.customTelemetryServices=new Map}async getCustomTelemetryService(S){if(!this.customTelemetryServices.has(S.id)){const{machineId:u,sessionId:v}=await this.telemetryService.getTelemetryInfo(),d=Object.create(null);d["common.vscodemachineid"]=u,d["common.vscodesessionid"]=v;const g=[S.id,JSON.stringify(d),S.aiKey],y=new n.Client(D.FileAccess.asFileUri("bootstrap-fork",J).fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:g,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),p=[new b.TelemetryAppenderClient(y),new E.TelemetryLogAppender(this.loggerService,this.environmentService,`[${S.id}] `)];this.customTelemetryServices.set(S.id,new I.TelemetryService({appenders:p,sendErrorTelemetry:S.sendErrorTelemetry},this.configurationService))}return this.customTelemetryServices.get(S.id)}async publicLog(S,u,v){await(await this.getCustomTelemetryService(S)).publicLog(u,v)}async publicLogError(S,u,v){await(await this.getCustomTelemetryService(S)).publicLogError(u,v)}};C=de([Y(0,L.IConfigurationService),Y(1,R.ITelemetryService),Y(2,A.ILoggerService),Y(3,T.IEnvironmentService)],C),e.CustomEndpointTelemetryService=C}),define(ne[213],ie([0,1,5,23,3,2,8]),function(J,e,D,n,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let R=class extends T.Disposable{constructor(E,I){super();this._logService=I,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new L.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=E===void 0?15e3:E}createRequest(E){return new Promise((I,C)=>{const f=++this._lastRequestId;this._pendingRequests.set(f,I),this._onCreateRequest.fire({requestId:f,...E});const S=new n.CancellationTokenSource;(0,D.timeout)(this._timeout,S.token).then(()=>C(`Request ${f} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(f,[(0,T.toDisposable)(()=>S.cancel())])})}acceptReply(E,I){const C=this._pendingRequests.get(E);C?(this._pendingRequests.delete(E),(0,T.dispose)(this._pendingRequestDisposables.get(E)||[]),this._pendingRequestDisposables.delete(E),C(I)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${E}`)}};R=de([Y(1,A.ILogService)],R),e.RequestStore=R}),define(ne[96],ie([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalCapability=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var n;(function(d){d.Shell="terminal.integrated.shell.",d.ShellArgs="terminal.integrated.shellArgs.",d.DefaultProfile="terminal.integrated.defaultProfile.",d.Profiles="terminal.integrated.profiles."})(n=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var L;(function(d){d.ShellLinux="terminal.integrated.shell.linux",d.ShellMacOs="terminal.integrated.shell.osx",d.ShellWindows="terminal.integrated.shell.windows",d.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",d.AutomationShellLinux="terminal.integrated.automationShell.linux",d.AutomationShellMacOs="terminal.integrated.automationShell.osx",d.AutomationShellWindows="terminal.integrated.automationShell.windows",d.AutomationProfileLinux="terminal.integrated.automationProfile.linux",d.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",d.AutomationProfileWindows="terminal.integrated.automationProfile.windows",d.ShellArgsLinux="terminal.integrated.shellArgs.linux",d.ShellArgsMacOs="terminal.integrated.shellArgs.osx",d.ShellArgsWindows="terminal.integrated.shellArgs.windows",d.ProfilesWindows="terminal.integrated.profiles.windows",d.ProfilesMacOs="terminal.integrated.profiles.osx",d.ProfilesLinux="terminal.integrated.profiles.linux",d.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",d.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",d.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",d.UseWslProfiles="terminal.integrated.useWslProfiles",d.TabsEnabled="terminal.integrated.tabs.enabled",d.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",d.TabsHideCondition="terminal.integrated.tabs.hideCondition",d.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",d.TabsShowActions="terminal.integrated.tabs.showActions",d.TabsLocation="terminal.integrated.tabs.location",d.TabsFocusMode="terminal.integrated.tabs.focusMode",d.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",d.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",d.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",d.CopyOnSelection="terminal.integrated.copyOnSelection",d.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",d.FontFamily="terminal.integrated.fontFamily",d.FontSize="terminal.integrated.fontSize",d.LetterSpacing="terminal.integrated.letterSpacing",d.LineHeight="terminal.integrated.lineHeight",d.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",d.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",d.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",d.BellDuration="terminal.integrated.bellDuration",d.FontWeight="terminal.integrated.fontWeight",d.FontWeightBold="terminal.integrated.fontWeightBold",d.CursorBlinking="terminal.integrated.cursorBlinking",d.CursorStyle="terminal.integrated.cursorStyle",d.CursorWidth="terminal.integrated.cursorWidth",d.Scrollback="terminal.integrated.scrollback",d.DetectLocale="terminal.integrated.detectLocale",d.DefaultLocation="terminal.integrated.defaultLocation",d.GpuAcceleration="terminal.integrated.gpuAcceleration",d.TerminalTitleSeparator="terminal.integrated.tabs.separator",d.TerminalTitle="terminal.integrated.tabs.title",d.TerminalDescription="terminal.integrated.tabs.description",d.RightClickBehavior="terminal.integrated.rightClickBehavior",d.Cwd="terminal.integrated.cwd",d.ConfirmOnExit="terminal.integrated.confirmOnExit",d.ConfirmOnKill="terminal.integrated.confirmOnKill",d.EnableBell="terminal.integrated.enableBell",d.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",d.AllowChords="terminal.integrated.allowChords",d.AllowMnemonics="terminal.integrated.allowMnemonics",d.EnvMacOs="terminal.integrated.env.osx",d.EnvLinux="terminal.integrated.env.linux",d.EnvWindows="terminal.integrated.env.windows",d.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",d.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",d.ShowExitAlert="terminal.integrated.showExitAlert",d.SplitCwd="terminal.integrated.splitCwd",d.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",d.WordSeparators="terminal.integrated.wordSeparators",d.EnableFileLinks="terminal.integrated.enableFileLinks",d.UnicodeVersion="terminal.integrated.unicodeVersion",d.ExperimentalLinkProvider="terminal.integrated.experimentalLinkProvider",d.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",d.LocalEchoEnabled="terminal.integrated.localEchoEnabled",d.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",d.LocalEchoStyle="terminal.integrated.localEchoStyle",d.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",d.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",d.CustomGlyphs="terminal.integrated.customGlyphs",d.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",d.InheritEnv="terminal.integrated.inheritEnv",d.ShowLinkHover="terminal.integrated.showLinkHover",d.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",d.AutoReplies="terminal.integrated.autoReplies",d.EnableShellIntegration="terminal.integrated.enableShellIntegration"})(L=e.TerminalSettingId||(e.TerminalSettingId={}));var T;(function(d){d.CommandPrompt="cmd",d.PowerShell="pwsh",d.Wsl="wsl",d.GitBash="gitbash"})(T=e.WindowsShellType||(e.WindowsShellType={}));var A;(function(d){d[d.Api=0]="Api",d[d.Process=1]="Process",d[d.Sequence=2]="Sequence",d[d.Config=3]="Config"})(A=e.TitleEventSource||(e.TitleEventSource={}));var R;(function(d){d.LocalPty="localPty",d.PtyHost="ptyHost",d.Log="log",d.Heartbeat="heartbeat"})(R=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,D.createDecorator)("ptyService");var b;(function(d){d.Cwd="cwd",d.InitialCwd="initialCwd",d.FixedDimensions="fixedDimensions",d.Title="title",d.ShellType="shellType",d.HasChildProcesses="hasChildProcesses",d.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",d.OverrideDimensions="overrideDimensions"})(b=e.ProcessPropertyType||(e.ProcessPropertyType={}));var E;(function(d){d[d.BeatInterval=5e3]="BeatInterval",d[d.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",d[d.SecondWaitMultiplier=1]="SecondWaitMultiplier",d[d.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(E=e.HeartbeatConstants||(e.HeartbeatConstants={}));var I;(function(d){d[d.Panel=1]="Panel",d[d.Editor=2]="Editor"})(I=e.TerminalLocation||(e.TerminalLocation={}));var C;(function(d){d.TerminalView="view",d.Editor="editor"})(C=e.TerminalLocationString||(e.TerminalLocationString={}));var f;(function(d){d[d.CwdDetection=0]="CwdDetection",d[d.NaiveCwdDetection=1]="NaiveCwdDetection",d[d.CommandDetection=2]="CommandDetection",d[d.PartialCommandDetection=3]="PartialCommandDetection"})(f=e.TerminalCapability||(e.TerminalCapability={}));var S;(function(d){d[d.GraceTime=6e4]="GraceTime",d[d.ShortGraceTime=6e3]="ShortGraceTime"})(S=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var u;(function(d){d[d.HighWatermarkChars=1e5]="HighWatermarkChars",d[d.LowWatermarkChars=5e3]="LowWatermarkChars",d[d.CharCountAckSize=5e3]="CharCountAckSize"})(u=e.FlowControlConstants||(e.FlowControlConstants={}));var v;(function(d){d.GitBash="Git Bash",d.Pwsh="PowerShell"})(v=e.ProfileSource||(e.ProfileSource={}))}),define(ne[214],ie([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,D.createDecorator)("localPtyService")}),define(ne[215],ie([0,1,33,28,10,4,32,15,22]),function(J,e,D,n,L,T,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findExecutable=e.getWindowsBuildNumber=void 0;function E(){const C=/(\d+)\.(\d+)\.(\d+)/g.exec(D.release());let f=0;return C&&C.length===4&&(f=parseInt(C[3])),f}e.getWindowsBuildNumber=E;async function I(C,f,S,u=A.env,v=b.Promises.exists){if(L.isAbsolute(C))return await v(C)?C:void 0;if(f===void 0&&(f=A.cwd()),L.dirname(C)!=="."){const y=L.join(f,C);return await v(y)?y:void 0}const g=(0,n.getCaseInsensitive)(u,"PATH");if(S===void 0&&(0,R.isString)(g)&&(S=g.split(L.delimiter)),S===void 0||S.length===0){const y=L.join(f,C);return await v(y)?y:void 0}for(let y of S){let p;if(L.isAbsolute(y)?p=L.join(y,C):p=L.join(f,y,C),await v(p))return p;if(T.isWindows){let l=p+".com";if(await v(l)||(l=p+".exe",await v(l)))return l}}const w=L.join(f,C);return await v(w)?w:void 0}e.findExecutable=I}),define(ne[216],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var D;(function(n){n.DARK="dark",n.LIGHT="light",n.HIGH_CONTRAST="hc"})(D=e.ColorScheme||(e.ColorScheme={}))}),define(ne[97],ie([0,1,48,3,2,6,38,216]),function(J,e,D,n,L,T,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,T.createDecorator)("themeService");var b;(function(d){function g(w){return w&&typeof w=="object"&&typeof w.id=="string"}d.isThemeColor=g})(b=e.ThemeColor||(e.ThemeColor={}));function E(d){return{id:d}}e.themeColorFromId=E;var I;(function(d){function g(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(typeof t.color=="undefined"||b.isThemeColor(t.color))}d.isThemeIcon=g;const w=new RegExp(`^\\$\\((${D.CSSIcon.iconNameExpression}(?:${D.CSSIcon.iconModifierExpression})?)\\)$`);function y(t){const o=w.exec(t);if(!o)return;let[,s]=o;return{id:s}}d.fromString=y;function p(t){return{id:t}}d.fromId=p;function l(t,o){let s=t.id;const c=s.lastIndexOf("~");return c!==-1&&(s=s.substring(0,c)),o&&(s=`${s}~${o}`),{id:s}}d.modify=l;function r(t){const o=t.id.lastIndexOf("~");if(o!==-1)return t.id.substring(o+1)}d.getModifier=r;function a(t,o){return t.id===o.id&&t.color?.id===o.color?.id}d.isEqual=a;function i(t,o){return{id:t.id,color:o?E(o):void 0}}d.asThemeIcon=i,d.asClassNameArray=D.CSSIcon.asClassNameArray,d.asClassName=D.CSSIcon.asClassName,d.asCSSSelector=D.CSSIcon.asCSSSelector})(I=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=D.Codicon.file,e.FolderThemeIcon=D.Codicon.folder;function C(d){switch(d){case R.ColorScheme.DARK:return"vs-dark";case R.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=C,e.Extensions={ThemingContribution:"base.contributions.theming"};class f{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new n.Emitter}onColorThemeChange(g){return this.themingParticipants.push(g),this.onThemingParticipantAddedEmitter.fire(g),(0,L.toDisposable)(()=>{const w=this.themingParticipants.indexOf(g);this.themingParticipants.splice(w,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let S=new f;A.Registry.add(e.Extensions.ThemingContribution,S);function u(d){return S.onColorThemeChange(d)}e.registerThemingParticipant=u;class v extends L.Disposable{constructor(g){super();this.themeService=g,this.theme=g.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(w=>this.onThemeChange(w)))}onThemeChange(g){this.theme=g,this.updateStyles()}updateStyles(){}getColor(g,w){let y=this.theme.getColor(g);return y&&w&&(y=w(y,this.theme)),y?y.toString():null}}e.Themable=v}),define(ne[217],ie([0,1,48,7,97]),function(J,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function T(C,f){const S=C.map(u=>({name:u.profileName,description:A(u)}));return f&&S.push(...f.map(u=>({name:u.title,description:R(u)}))),{values:S.map(u=>u.name),markdownDescriptions:S.map(u=>u.description)}}e.createProfileSchemaEnums=T;function A(C){let f=`$(${L.ThemeIcon.isThemeIcon(C.icon)?C.icon.id:C.icon?C.icon:D.Codicon.terminal.id}) ${C.profileName}
- path: ${C.path}`;return C.args&&(typeof C.args=="string"?f+=`
- args: "${C.args}"`:f+=`
- args: [${C.args.length===0?"":`'${C.args.join("','")}'`}]`),C.overrideName!==void 0&&(f+=`
- overrideName: ${C.overrideName}`),C.color&&(f+=`
- color: ${C.color}`),C.env&&(f+=`
- env: ${JSON.stringify(C.env)}`),f}function R(C){return`$(${L.ThemeIcon.isThemeIcon(C.icon)?C.icon.id:C.icon?C.icon:D.Codicon.terminal.id}) ${C.title}
- extensionIdenfifier: ${C.extensionIdentifier}`}function b(C,f){if(!C&&!f)return!0;if(typeof C=="string"&&typeof f=="string")return C===f;if(Array.isArray(C)&&Array.isArray(f)){if(C.length!==f.length)return!1;for(let S=0;S<C.length;S++)if(C[S]!==f[S])return!1;return!0}return!1}e.terminalProfileArgsMatch=b;function E(C,f){if(!C&&!f)return!0;if(!C||!f)return!1;if(L.ThemeIcon.isThemeIcon(C)&&L.ThemeIcon.isThemeIcon(f))return C.id===f.id&&C.color===f.color;if(typeof C=="object"&&C&&"light"in C&&"dark"in C&&typeof f=="object"&&f&&"light"in f&&"dark"in f){const S=C,u=f;if((n.URI.isUri(S.light)||I(S.light))&&(n.URI.isUri(S.dark)||I(S.dark))&&(n.URI.isUri(u.light)||I(u.light))&&(n.URI.isUri(u.dark)||I(u.dark)))return S.light.path===u.light.path&&S.dark.path===u.dark.path}if(n.URI.isUri(C)&&n.URI.isUri(f)||I(C)||I(f)){const S=C,u=f;return S.path===u.path&&S.scheme===u.scheme}return!1}e.terminalIconsEqual=E;function I(C){return C?typeof C.path=="string"&&typeof C.scheme=="string":!1}e.isUriComponents=I}),define(ne[218],ie([0,1,48,142,42,38,217]),function(J,e,D,n,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=void 0;const R={args:{description:(0,n.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,n.localize)(1,null),type:"boolean"},icon:{description:(0,n.localize)(2,null),type:"string",enum:Array.from(D.Codicon.getAll(),p=>p.id),markdownEnumDescriptions:Array.from(D.Codicon.getAll(),p=>`$(${p.id})`)},color:{description:(0,n.localize)(3,null),type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},env:{markdownDescription:(0,n.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},b={type:"object",required:["path"],properties:{path:{description:(0,n.localize)(5,null),type:["string","array"],items:{type:"string"}},...R}},E={type:"object",required:["path"],properties:{path:{description:(0,n.localize)(6,null),type:["string"],items:{type:"string"}},...R}},I=(0,n.localize)(7,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),C=(0,n.localize)(8,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),f=(0,n.localize)(9,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),S=(0,n.localize)(10,null,"`#terminal.integrated.automationProfile.linux#`"),u=(0,n.localize)(11,null,"`#terminal.integrated.automationProfile.osx#`"),v=(0,n.localize)(12,null,"`#terminal.integrated.automationProfile.windows#`"),d={id:"terminal",order:100,title:(0,n.localize)(13,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(14,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:S},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(15,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:u},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(16,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:v},["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(17,null,"#terminal.integrated.automationShell.linux#"),type:["object","null"],default:null,anyOf:[{type:"null"},E],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,description:(0,n.localize)(18,null,"#terminal.integrated.automationShell.osx#"),type:["object","null"],default:null,anyOf:[{type:"null"},E],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,description:(0,n.localize)(19,null,"#terminal.integrated.automationShell.windows#"),type:["object","null"],default:null,anyOf:[{type:"null"},E],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(20,null),type:["string","null"],default:null,markdownDeprecationMessage:I},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(21,null),type:["string","null"],default:null,markdownDeprecationMessage:C},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(22,null),type:["string","null"],default:null,markdownDeprecationMessage:f},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(23,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:I},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(24,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:C},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(25,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,n.localize)(26,null)}},{type:"string",markdownDescription:(0,n.localize)(27,null)}],default:[],markdownDeprecationMessage:f},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(28,null,"`source`","`path`","`args`","`null`",'`"Ubuntu-20.04 (WSL)": null`'),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,n.localize)(29,null),enum:["PowerShell","Git Bash"]},...R}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,n.localize)(30,null),type:"string"},id:{description:(0,n.localize)(31,null),type:"string"},title:{description:(0,n.localize)(32,null),type:"string"},...R}},{type:"null"},b]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(33,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,n.localize)(34,null),type:"string"},id:{description:(0,n.localize)(35,null),type:"string"},title:{description:(0,n.localize)(36,null),type:"string"},...R}},{type:"null"},b]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(37,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,n.localize)(38,null),type:"string"},id:{description:(0,n.localize)(39,null),type:"string"},title:{description:(0,n.localize)(40,null),type:"string"},...R}},{type:"null"},b]}},["terminal.integrated.useWslProfiles"]:{description:(0,n.localize)(41,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,n.localize)(42,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,n.localize)(43,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,n.localize)(44,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,n.localize)(45,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function g(){T.Registry.as(L.Extensions.Configuration).registerConfiguration(d),y()}e.registerTerminalPlatformConfiguration=g;let w;function y(p,l){const r=T.Registry.as(L.Extensions.Configuration);let a;p&&(a=(0,A.createProfileSchemaEnums)(p?.profiles,l));const i=w;w={id:"terminal",order:100,title:(0,n.localize)(46,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(47,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:p?.os===3?a?.values:void 0,markdownEnumDescriptions:p?.os===3?a?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(48,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:p?.os===2?a?.values:void 0,markdownEnumDescriptions:p?.os===2?a?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(49,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:p?.os===1?a?.values:void 0,markdownEnumDescriptions:p?.os===1?a?.markdownDescriptions:void 0}}},r.updateConfigurations({add:[w],remove:i?[i]:[]})}e.registerTerminalDefaultProfileConfiguration=y}),define(ne[219],ie([0,1,45,48,10,4,22,72,215,97]),function(J,e,D,n,L,T,A,R,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let I,C=!0;function f(a,i,t,o,s=process.env,c,h,m,P){return c=c||{existsFile:A.SymlinkSupport.existsFile,readFile:A.Promises.readFile},T.isWindows?S(t,c,s,h,o.getValue("terminal.integrated.useWslProfiles")!==!1,a&&typeof a=="object"?{...a}:o.getValue("terminal.integrated.profiles.windows"),typeof i=="string"?i:o.getValue("terminal.integrated.defaultProfile.windows"),P,m):p(c,h,t,a&&typeof a=="object"?{...a}:o.getValue(T.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof i=="string"?i:o.getValue(T.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),P,m,s)}e.detectAvailableProfiles=f;async function S(a,i,t,o,s,c,h,m,P){const _=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),O=`${process.env.windir}\\${_?"Sysnative":"System32"}`;let M=!1;(0,b.getWindowsBuildNumber)()>=16299&&(M=!0),await d(m);const k=new Map;a&&(k.set("PowerShell",{source:"PowerShell",icon:n.Codicon.terminalPowershell,isAutoDetected:!0}),k.set("Windows PowerShell",{path:`${O}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:n.Codicon.terminalPowershell,isAutoDetected:!0}),k.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),k.set("Cygwin",{path:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"],isAutoDetected:!0}),k.set("Command Prompt",{path:`${O}\\cmd.exe`,icon:n.Codicon.terminalCmd,isAutoDetected:!0})),l(c,k);const U=await u(k.entries(),h,i,t,o,P);if(a||!a&&s)try{const N=await w(`${O}\\${M?"wsl":"bash"}.exe`,h);for(const V of N)(!c||!(V.profileName in c))&&U.push(V)}catch{C&&(o?.info("WSL is not installed, so could not detect WSL profiles"),C=!1)}return U}async function u(a,i,t,o=process.env,s,c){const h=[];for(const[m,P]of a){if(P===null)continue;let _,O,M;if("source"in P){const N=I?.get(P.source);if(!N)continue;_=N.paths,O=P.args||N.args,P.icon?M=v(P.icon):N.icon&&(M=N.icon)}else _=Array.isArray(P.path)?P.path:[P.path],O=T.isWindows||Array.isArray(P.args)?P.args:void 0,M=v(P.icon);const k=await c?.(_)||_.slice(),U=await r(m,i,k,t,o,O,P.env,P.overrideName,P.isAutoDetected,s);U?(U.isAutoDetected=P.isAutoDetected,U.icon=M,U.color=P.color,h.push(U)):s?.trace("profile not validated",m,_)}return h}function v(a){return typeof a=="string"?{id:a}:a}async function d(a){I&&!a||(I=new Map,I.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`,`${process.env.AllUsersProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login"]}),I.set("PowerShell",{profileName:"PowerShell",paths:a||await g(),icon:E.ThemeIcon.asThemeIcon(n.Codicon.terminalPowershell)}))}async function g(){const a=[];for await(const i of(0,R.enumeratePowerShellInstallations)())a.push(i.exePath);return a}async function w(a,i){const t=[],o=await new Promise((h,m)=>{D.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(P,_)=>{if(P)return m("Problem occurred when getting wsl distros");h(_)})});if(!o)return[];const s=new RegExp(/[\r?\n]/),c=o.split(s).filter(h=>h.trim().length>0&&h!=="");for(const h of c){if(h===""||h.startsWith("docker-desktop"))continue;const m=`${h} (WSL)`,P={profileName:m,path:a,args:["-d",`${h}`],isDefault:m===i,icon:y(h),isAutoDetected:!1};t.push(P)}return t}function y(a){return a.includes("Ubuntu")?E.ThemeIcon.asThemeIcon(n.Codicon.terminalUbuntu):a.includes("Debian")?E.ThemeIcon.asThemeIcon(n.Codicon.terminalDebian):E.ThemeIcon.asThemeIcon(n.Codicon.terminalLinux)}async function p(a,i,t,o,s,c,h,m){const P=new Map;if(t){const _=(await a.readFile("/etc/shells")).toString(),O=c||_.split(`
`).filter(k=>k.trim().indexOf("#")!==0&&k.trim().length>0),M=new Map;for(const k of O){let U=(0,L.basename)(k),N=M.get(U)||0;N++,N>1&&(U=`${U} (${N})`),M.set(U,N),P.set(U,{path:k,isAutoDetected:!0})}}return l(o,P),await u(P.entries(),s,a,m,i,h)}function l(a,i){if(!!a)for(const[t,o]of Object.entries(a))o===null||!("path"in o)&&!("source"in o)?i.delete(t):(o.icon=o.icon||i.get(t)?.icon,i.set(t,o))}async function r(a,i,t,o,s,c,h,m,P,_){if(t.length===0)return Promise.resolve(void 0);const O=t.shift();if(O==="")return r(a,i,t,o,s,c,h,m,P);const M={profileName:a,path:O,args:c,env:h,overrideName:m,isAutoDetected:P,isDefault:a===i};if((0,L.basename)(O)===O){const U=s.PATH?s.PATH.split(L.delimiter):void 0,N=await(0,b.findExecutable)(O,void 0,U,void 0,o.existsFile);return N?(M.path=N,M.isFromPath=!0,M):r(a,i,t,o,s,c)}return await o.existsFile((0,L.normalize)(O))?M:r(a,i,t,o,s,c,h,m,P)}}),define(ne[220],ie([0,1,3,2,18,4,36,58,20,13,77,162,8,86,21,213,96,218,219]),function(J,e,D,n,L,T,A,R,b,E,I,C,f,S,u,v,d,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var y;(function(r){r[r.MaxRestarts=5]="MaxRestarts"})(y||(y={}));let p=0,l=class extends n.Disposable{constructor(a,i,t,o,s){super();this._reconnectConstants=a,this._configurationService=i,this._environmentService=t,this._logService=o,this._telemetryService=s,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new D.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new D.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new D.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new D.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new D.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new D.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessReady=this._register(new D.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new D.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessOrphanQuestion=this._register(new D.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new D.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onDidChangeProperty=this._register(new D.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=this._register(new D.Emitter),this.onProcessExit=this._onProcessExit.event,(0,g.registerTerminalPlatformConfiguration)(),this._shellEnv=this._resolveShellEnv(),this._register((0,n.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new v.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),[this._client,this._proxy]=this._startPtyHost(),this._register(this._configurationService.onDidChangeConfiguration(async c=>{c.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this._refreshIgnoreProcessNames()}))}async initialize(){await this._refreshIgnoreProcessNames()}get _ignoreProcessNames(){return this._configurationService.getValue("terminal.integrated.ignoreProcessNames")}async _refreshIgnoreProcessNames(){return this._proxy.refreshIgnoreProcessNames?.(this._ignoreProcessNames)}async _resolveShellEnv(){if(T.isWindows)return process.env;try{return await(0,C.getResolvedShellEnv)(this._logService,{_:[]},process.env)}catch(a){return this._logService.error("ptyHost was unable to resolve shell environment",a),{}}}_startPtyHost(){const a={serverName:"Pty Host",args:["--type=ptyHost"],env:{VSCODE_LAST_PTY_ID:p,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this._reconnectConstants.scrollback}},i=(0,I.parsePtyHostPort)(this._environmentService.args,this._environmentService.isBuilt);i&&(i.break&&i.port?a.debugBrk=i.port:!i.break&&i.port&&(a.debug=i.port));const t=new R.Client(L.FileAccess.asFileUri("bootstrap-fork",J).fsPath,a);this._onPtyHostStart.fire(),A.ProxyChannel.toService(t.getChannel(d.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(t.onDidProcessExit(h=>{this._telemetryService.publicLog("ptyHost/exit"),this._onPtyHostExit.fire(h.code),this._isDisposed||(this._restartCount<=y.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${h.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${h.code}, giving up`))}));const s=t.getChannel(d.TerminalIpcChannels.Log);S.LogLevelChannelClient.setLevel(s,this._logService.getLevel()),this._register(this._logService.onDidChangeLogLevel(()=>{S.LogLevelChannelClient.setLevel(s,this._logService.getLevel())}));const c=A.ProxyChannel.toService(t.getChannel(d.TerminalIpcChannels.PtyHost));return this._register(c.onProcessData(h=>this._onProcessData.fire(h))),this._register(c.onProcessReady(h=>this._onProcessReady.fire(h))),this._register(c.onProcessExit(h=>this._onProcessExit.fire(h))),this._register(c.onDidChangeProperty(h=>this._onDidChangeProperty.fire(h))),this._register(c.onProcessReplay(h=>this._onProcessReplay.fire(h))),this._register(c.onProcessOrphanQuestion(h=>this._onProcessOrphanQuestion.fire(h))),this._register(c.onDidRequestDetach(h=>this._onDidRequestDetach.fire(h))),[t,c]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(a,i,t,o,s,c,h,m,P,_,O){const M=setTimeout(()=>this._handleUnresponsiveCreateProcess(),d.HeartbeatConstants.CreateProcessTimeout),k=await this._proxy.createProcess(a,i,t,o,s,c,h,m,P,_,O);return clearTimeout(M),p=Math.max(p,k),k}updateTitle(a,i,t){return this._proxy.updateTitle(a,i,t)}updateIcon(a,i,t){return this._proxy.updateIcon(a,i,t)}attachToProcess(a){return this._proxy.attachToProcess(a)}detachFromProcess(a){return this._proxy.detachFromProcess(a)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(a){return this._proxy.start(a)}shutdown(a,i){return this._proxy.shutdown(a,i)}input(a,i){return this._proxy.input(a,i)}processBinary(a,i){return this._proxy.processBinary(a,i)}resize(a,i,t){return this._proxy.resize(a,i,t)}acknowledgeDataEvent(a,i){return this._proxy.acknowledgeDataEvent(a,i)}setUnicodeVersion(a,i){return this._proxy.setUnicodeVersion(a,i)}getInitialCwd(a){return this._proxy.getInitialCwd(a)}getCwd(a){return this._proxy.getCwd(a)}getLatency(a){return this._proxy.getLatency(a)}orphanQuestionReply(a){return this._proxy.orphanQuestionReply(a)}installAutoReply(a,i){return this._proxy.installAutoReply(a,i)}uninstallAllAutoReplies(){return this._proxy.uninstallAllAutoReplies()}uninstallAutoReply(a){return this._proxy.uninstallAutoReply(a)}getDefaultSystemShell(a){return this._proxy.getDefaultSystemShell(a)}async getProfiles(a,i,t,o=!1){const s=await this._shellEnv;return(0,w.detectAvailableProfiles)(i,t,o,this._configurationService,s,void 0,this._logService,this._resolveVariables.bind(this,a))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(a){return this._proxy.getWslPath(a)}setTerminalLayoutInfo(a){return this._proxy.setTerminalLayoutInfo(a)}async getTerminalLayoutInfo(a){return await this._proxy.getTerminalLayoutInfo(a)}async requestDetachInstance(a,i){return this._proxy.requestDetachInstance(a,i)}async acceptDetachInstanceReply(a,i){return this._proxy.acceptDetachInstanceReply(a,i)}async serializeTerminalState(a){return this._proxy.serializeTerminalState(a)}async reviveTerminalProcesses(a,i){return this._proxy.reviveTerminalProcesses(a,i)}async refreshProperty(a,i){return this._proxy.refreshProperty(a,i)}async updateProperty(a,i,t){return this._proxy.updateProperty(a,i,t)}async restartPtyHost(){this._telemetryService.publicLog("ptyHost/restart"),this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll?.(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),d.HeartbeatConstants.BeatInterval*d.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._telemetryService.publicLog("ptyHost/responsive"),this._isResponsive=!0),this._onPtyHostResponsive.fire()}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${d.HeartbeatConstants.BeatInterval*d.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),d.HeartbeatConstants.BeatInterval*d.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(d.HeartbeatConstants.BeatInterval*d.HeartbeatConstants.FirstWaitMultiplier+d.HeartbeatConstants.BeatInterval*d.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._telemetryService.publicLog("ptyHost/unresponsive"),this._isResponsive=!1),this._onPtyHostUnresponsive.fire()}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${d.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._telemetryService.publicLog("ptyHost/responsive"),this._onPtyHostUnresponsive.fire()}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(a,i){return this._resolveVariablesRequestStore.createRequest({workspaceId:a,originalText:i})}async acceptPtyHostResolvedVariables(a,i){this._resolveVariablesRequestStore.acceptReply(a,i)}};l=de([Y(1,b.IConfigurationService),Y(2,E.IEnvironmentService),Y(3,f.ILogService),Y(4,u.ITelemetryService)],l),e.PtyHostService=l}),define(ne[34],ie([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,D.createDecorator)("IUriIdentityService")}),define(ne[221],ie([0,1,3,2,7,13,31,14,8,34]),function(J,e,D,n,L,T,A,R,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let I=class extends n.Disposable{constructor(f,S,u,v,d){super();this.extensionsManagementService=f,this.logService=v,this.uriIdentityService=d,this._onDidChangeExtensionsByAnotherSource=this._register(new D.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(w=>{this.installedExtensions=w.map(y=>y.identifier),this.startTimestamp=Date.now()}),this._register(f.onInstallExtension(w=>this.onInstallExtension(w))),this._register(f.onDidInstallExtensions(w=>this.onDidInstallExtensions(w))),this._register(f.onDidUninstallExtension(w=>this.onDidUninstallExtension(w)));const g=L.URI.file(u.extensionsPath);this._register(S.watch(g)),this._register(D.Event.filter(S.onDidFilesChange,w=>w.rawChanges.some(y=>this.doesChangeAffects(y,g)))(()=>this.onDidChange()))}doesChangeAffects(f,S){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(f.resource),S)?this.uriIdentityService.extUri.isEqual(f.resource,this.uriIdentityService.extUri.joinPath(S,".obsolete"))?!0:!(f.type!==1&&f.type!==2||this.uriIdentityService.extUri.basename(f.resource).startsWith(".")):!1}onInstallExtension(f){this.addInstallingExtension(f.identifier)}onDidInstallExtensions(f){for(const S of f)this.removeInstallingExtension(S.identifier),S.local&&this.addInstalledExtension(S.identifier)}onDidUninstallExtension(f){f.error||this.removeInstalledExtension(f.identifier)}addInstallingExtension(f){this.removeInstallingExtension(f),this.installingExtensions.push(f)}removeInstallingExtension(f){this.installingExtensions=this.installingExtensions.filter(S=>!(0,A.areSameExtensions)(S,f))}addInstalledExtension(f){this.installedExtensions&&(this.removeInstalledExtension(f),this.installedExtensions.push(f))}removeInstalledExtension(f){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(S=>!(0,A.areSameExtensions)(S,f)))}async onDidChange(){if(this.installedExtensions){const f=await this.extensionsManagementService.getInstalled(1),S=f.filter(v=>[...this.installingExtensions,...this.installedExtensions].some(d=>(0,A.areSameExtensions)(d,v.identifier))?!1:v.installedTimestamp&&v.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",v.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",v.identifier.id),!1)),u=this.installedExtensions.filter(v=>this.installingExtensions.some(d=>(0,A.areSameExtensions)(d,v))?!1:f.every(d=>!(0,A.areSameExtensions)(d.identifier,v))?(this.logService.info("Detected extension removed from another source",v.id),!0):!1);this.installedExtensions=f.map(v=>v.identifier),(S.length||u.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:S,removed:u})}}};I=de([Y(1,R.IFileService),Y(2,T.INativeEnvironmentService),Y(3,b.ILogService),Y(4,E.IUriIdentityService)],I),e.ExtensionsWatcher=I}),define(ne[222],ie([0,1,34,79,14,19,104,3,2]),function(J,e,D,n,L,T,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class E{constructor(f){this.uri=f,this.time=E._clock++}touch(){return this.time=E._clock++,this}}E._clock=0;let I=class{constructor(f){this._fileService=f,this._dispooables=new b.DisposableStore,this._limit=2**16;const S=new Map,u=v=>{let d=S.get(v.scheme);return d===void 0&&(d=f.hasProvider(v)&&!this._fileService.hasCapability(v,1024),S.set(v.scheme,d)),d};this._dispooables.add(R.Event.any(f.onDidChangeFileSystemProviderRegistrations,f.onDidChangeFileSystemProviderCapabilities)(v=>{S.delete(v.scheme)})),this.extUri=new T.ExtUri(u),this._canonicalUris=new A.SkipList((v,d)=>this.extUri.compare(v,d,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(f){this._fileService.hasProvider(f)&&(f=(0,T.normalizePath)(f));let S=this._canonicalUris.get(f);return S?S.touch().uri.with({fragment:f.fragment}):(this._canonicalUris.set(f,new E(f)),this._checkTrim(),f)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const f=[...this._canonicalUris.entries()].sort((u,v)=>u[1].touch<v[1].touch?1:u[1].touch>v[1].touch?-1:0);E._clock=0,this._canonicalUris.clear();const S=this._limit*.5;for(let u=0;u<S;u++)this._canonicalUris.set(f[u][0],f[u][1].touch())}};I=de([Y(0,L.IFileService)],I),e.UriIdentityService=I,(0,n.registerSingleton)(D.IUriIdentityService,I,!0)}),define(ne[223],ie([0,1,3,2,40,39,17]),function(J,e,D,n,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class R extends n.Disposable{constructor(E,I,C,f,S){super();this.fileSystemScheme=E,this.fileSystemProvider=I,this.userDataScheme=C,this.logService=S,this.onDidChangeCapabilities=this.fileSystemProvider.onDidChangeCapabilities,this._onDidChangeFile=this._register(new D.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.watchResources=T.TernarySearchTree.forUris(()=>!(this.capabilities&1024)),this._register(f.onDidFilesChange(u=>this.handleFileChanges(u)))}get capabilities(){return this.fileSystemProvider.capabilities&~4}watch(E,I){this.watchResources.set(E,E);const C=this.fileSystemProvider.watch(this.toFileSystemResource(E),I);return(0,n.toDisposable)(()=>{this.watchResources.delete(E),C.dispose()})}stat(E){return this.fileSystemProvider.stat(this.toFileSystemResource(E))}mkdir(E){return this.fileSystemProvider.mkdir(this.toFileSystemResource(E))}rename(E,I,C){return this.fileSystemProvider.rename(this.toFileSystemResource(E),this.toFileSystemResource(I),C)}readFile(E){return this.fileSystemProvider.readFile(this.toFileSystemResource(E),{atomic:!0})}readFileStream(E,I,C){const f=(0,L.newWriteableStream)(S=>A.VSBuffer.concat(S.map(u=>A.VSBuffer.wrap(u))).buffer);return(async()=>{try{const S=await this.readFile(E);f.end(S)}catch(S){f.error(S),f.end()}})(),f}readdir(E){return this.fileSystemProvider.readdir(this.toFileSystemResource(E))}writeFile(E,I,C){return this.fileSystemProvider.writeFile(this.toFileSystemResource(E),I,C)}delete(E,I){return this.fileSystemProvider.delete(this.toFileSystemResource(E),I)}handleFileChanges(E){const I=[];for(const C of E.rawChanges){if(C.resource.scheme!==this.fileSystemScheme)continue;const f=this.toUserDataResource(C.resource);this.watchResources.findSubstr(f)&&I.push({resource:f,type:C.type})}I.length&&(this.logService.debug("User data changed"),this._onDidChangeFile.fire(I))}toFileSystemResource(E){return E.with({scheme:this.fileSystemScheme})}toUserDataResource(E){return E.with({scheme:this.userDataScheme})}}e.FileUserDataProvider=R}),define(ne[53],ie([0,1,69]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function n(A,R,b,E){const I=(0,D.setProperty)(A,R,b,E)[0];return I&&(A=A.substring(0,I.offset)+I.content+A.substring(I.offset+I.length)),A}e.edit=n;function L(A,R,b){let E=b;for(;E>=0;){if(A.charAt(E)===R.charAt(R.length-1)&&R.length===1)return E+1;if(E--,R.length===2&&E>=0&&A.charAt(E)===R.charAt(0))return E+2}return 0}e.getLineStartOffset=L;function T(A,R,b){let E=b;for(;E>=0;)if(A.charAt(E)===R.charAt(R.length-1)&&R.length===1||(E++,R.length===2&&E>=0&&A.charAt(E)===R.charAt(1)))return E;return A.length-1}e.getLineEndOffset=T}),define(ne[224],ie([0,1,28,61,15]),function(J,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function T(f,S,u,v,d){const g=[],w=[],y=[];if(!S){const O=f.filter(({identifier:M})=>d.every(k=>k.toLowerCase()!==M.id.toLowerCase()));return{local:{added:g,removed:w,updated:y},remote:O.length>0?{added:O,updated:[],removed:[],all:O}:null}}f=f.map(I),S=S.map(I),u=u?u.map(I):null;const p=new Map,l=O=>{O.uuid&&p.set(O.id.toLowerCase(),O.uuid)};f.forEach(({identifier:O})=>l(O)),S.forEach(({identifier:O})=>l(O)),u&&u.forEach(({identifier:O})=>l(O));const r=O=>{const M=O.identifier.uuid||p.get(O.identifier.id.toLowerCase());return M?`uuid:${M}`:`id:${O.identifier.id.toLowerCase()}`},a=(O,M)=>(O.set(r(M),M),O),i=f.reduce(a,new Map),t=S.reduce(a,new Map),o=S.reduce((O,M)=>{const k=r(M);M=(0,D.deepClone)(M);const U=i.get(k);return U&&(U.installed&&(M.installed=!0),M.version||(M.version=U.version)),a(O,M)},new Map),s=u?u.reduce(a,new Map):null,c=v.reduce(a,new Map),h=d.reduce((O,M)=>{const k=p.get(M.toLowerCase());return O.add(k?`uuid:${k}`:`id:${M.toLowerCase()}`)},new Set),m=A(i,t,h);if(m.added.size>0||m.removed.size>0||m.updated.size>0){const O=A(s,i,h),M=A(s,t,h),k=(U,N)=>{const V=i.get(U);if(V){const $=t.get(U),G=N?$:V;return{...G,version:($.version&&n.gt($.version,V.version),V.version),state:R(V,$,s?.get(U)),preRelease:(0,L.isUndefined)(G.preRelease)?V.preRelease:G.preRelease}}};for(const U of M.removed.values()){const N=i.get(U);N&&w.push(N.identifier)}for(const U of M.added.values())if(O.added.has(U)){if(m.updated.has(U)){const N=k(U,!0);N&&(y.push(C(N,U)),o.set(U,N))}}else{const N=t.get(U);N.installed&&g.push(C(N,U))}for(const U of M.updated.values()){const N=k(U,!0);N&&(y.push(C(N,U)),o.set(U,N))}for(const U of O.added.values())M.added.has(U)||o.set(U,i.get(U));for(const U of O.updated.values())if(!M.removed.has(U)&&!M.updated.has(U)){const N=k(U,!1);N&&(o.get(U)?.installed&&(N.installed=!0),o.set(U,N))}for(const U of O.removed.values())!c.has(U)&&!M.updated.has(U)&&s?.get(U)?.installed&&o.delete(U)}const P=[],_=A(t,o,new Set,{checkInstalledProperty:!0,checkVersionProperty:!0});return(_.added.size>0||_.updated.size>0||_.removed.size>0)&&o.forEach((O,M)=>P.push(C(O,M))),{local:{added:g,removed:w,updated:y},remote:P.length?{added:[..._.added].map(O=>o.get(O)),updated:[..._.updated].map(O=>o.get(O)),removed:[..._.removed].map(O=>t.get(O)),all:P}:null}}e.merge=T;function A(f,S,u,{checkInstalledProperty:v,checkVersionProperty:d}={checkInstalledProperty:!1,checkVersionProperty:!1}){const g=f?[...f.keys()].filter(r=>!u.has(r)):[],w=[...S.keys()].filter(r=>!u.has(r)),y=w.filter(r=>g.indexOf(r)===-1).reduce((r,a)=>(r.add(a),r),new Set),p=g.filter(r=>w.indexOf(r)===-1).reduce((r,a)=>(r.add(a),r),new Set),l=new Set;for(const r of g){if(p.has(r))continue;const a=f.get(r),i=S.get(r);(!i||a.disabled!==i.disabled||a.preRelease!==i.preRelease||!E(a.state,i.state)||d&&a.version!==i.version||v&&a.installed!==i.installed)&&l.add(r)}return{added:y,removed:p,updated:l}}function R(f,S,u){const v=f.state,d=S.state,g=u?.state;if(!S.version||v&&n.gt(f.version,S.version))return v;if(d&&n.gt(S.version,f.version)||!v)return d;if(!d)return v;const w=(0,D.deepClone)(v),y=g?b(g,d):{added:Object.keys(d).reduce((l,r)=>(l.add(r),l),new Set),removed:new Set,updated:new Set},p=g?b(g,v):{added:Object.keys(v).reduce((l,r)=>(l.add(r),l),new Set),removed:new Set,updated:new Set};for(const l of[...y.added.values(),...y.updated.values()])w[l]=d[l];for(const l of y.removed.values())p.updated.has(l)||delete w[l];return w}function b(f,S){const u=Object.keys(f),v=Object.keys(S),d=v.filter(y=>u.indexOf(y)===-1).reduce((y,p)=>(y.add(p),y),new Set),g=u.filter(y=>v.indexOf(y)===-1).reduce((y,p)=>(y.add(p),y),new Set),w=new Set;for(const y of u){if(g.has(y))continue;const p=f[y],l=S[y];(0,D.equals)(p,l)||w.add(y)}return{added:d,removed:g,updated:w}}function E(f={},S={}){const{added:u,removed:v,updated:d}=b(f,S);return u.size===0&&v.size===0&&d.size===0}function I(f){return{...f,disabled:!!f.disabled,installed:!!f.installed}}function C(f,S){const u={identifier:{id:f.identifier.id,uuid:S.startsWith("uuid:")?S.substring("uuid:".length):void 0},preRelease:!!f.preRelease};return f.version&&(u.version=f.version),f.disabled&&(u.disabled=!0),f.installed&&(u.installed=!0),f.state&&(u.state=f.state),u}}),define(ne[98],ie([0,1,16,20,6]),function(J,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,L.createDecorator)("IIgnoredExtensionsManagementService");let T=class{constructor(R){this.configurationService=R}hasToNeverSyncExtension(R){return this.getConfiguredIgnoredExtensions().includes(R.toLowerCase())}hasToAlwaysSyncExtension(R){return this.getConfiguredIgnoredExtensions().includes(`-${R.toLowerCase()}`)}updateIgnoredExtensions(R,b){let E=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(I=>I.toLowerCase());return E=E.filter(I=>I!==R&&I!==`-${R}`),b&&E.push(R.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",E.length?E:void 0,1)}updateSynchronizedExtensions(R,b){let E=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(I=>I.toLowerCase());return E=E.filter(I=>I!==R&&I!==`-${R}`),b&&E.push(`-${R.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",E.length?E:void 0,1)}getIgnoredExtensions(R){const b=R.filter(f=>f.isMachineScoped).map(f=>f.identifier.id.toLowerCase()),E=this.getConfiguredIgnoredExtensions().map(f=>f.toLowerCase()),I=[],C=[];if(Array.isArray(E))for(const f of E)f.startsWith("-")?C.push(f.substring(1)):I.push(f);return(0,D.distinct)([...b,...I].filter(f=>C.indexOf(f)===-1))}getConfiguredIgnoredExtensions(){let R=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return R!==void 0||(R=this.configurationService.inspect("sync.ignoredExtensions").userValue,R!==void 0)?R:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(b=>b.toLowerCase())}};T=de([Y(0,n.IConfigurationService)],T),e.IgnoredExtensionsManagementService=T}),define(ne[225],ie([0,1,16,35,28,159,53]),function(J,e,D,n,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function R(p){return(0,n.parse)(p)||[]}e.parseKeybindings=R;async function b(p,l,r,a,i){const t=R(p),o=R(l),s=r?R(r):null,c=[...t,...o,...s||[]].map($=>$.key),h=await i.resolveUserBindings(c);let m=I(t,o,s,h);if(!m.hasLocalForwarded&&!m.hasRemoteForwarded)return{mergeContent:p,hasChanges:!1,hasConflicts:!1};if(!m.hasLocalForwarded&&m.hasRemoteForwarded)return{mergeContent:l,hasChanges:!0,hasConflicts:!1};if(m.hasLocalForwarded&&!m.hasRemoteForwarded)return{mergeContent:p,hasChanges:!0,hasConflicts:!1};const P=f(t),_=f(o),O=s?f(s):null,M=u(P,_,h),k=O?u(O,P,h):{added:[...P.keys()].reduce(($,G)=>($.add(G),$),new Set),removed:new Set,updated:new Set},U=O?u(O,_,h):{added:[..._.keys()].reduce(($,G)=>($.add(G),$),new Set),removed:new Set,updated:new Set},N=E(M,k,U);let V=p;for(const $ of N.removed.values())N.conflicts.has($)||(V=w(V,$,a));for(const $ of N.added.values()){if(N.conflicts.has($))continue;const G=_.get($);if(G.some(te=>te.command!==`-${$}`&&m.conflicts.has(h[te.key]))){N.conflicts.add($);continue}V=g(V,G,a)}for(const $ of N.updated.values()){if(N.conflicts.has($))continue;const G=_.get($);if(G.some(te=>te.command!==`-${$}`&&m.conflicts.has(h[te.key]))){N.conflicts.add($);continue}V=y(V,$,G,a)}return{mergeContent:V,hasChanges:!0,hasConflicts:N.conflicts.size>0}}e.merge=b;function E(p,l,r){const a=new Set,i=new Set,t=new Set,o=new Set;for(const s of l.removed.values())r.updated.has(s)&&o.add(s);for(const s of r.removed.values())o.has(s)||(l.updated.has(s)?o.add(s):i.add(s));for(const s of l.added.values())o.has(s)||r.added.has(s)&&p.updated.has(s)&&o.add(s);for(const s of r.added.values())o.has(s)||(l.added.has(s)?p.updated.has(s)&&o.add(s):a.add(s));for(const s of l.updated.values())o.has(s)||r.updated.has(s)&&p.updated.has(s)&&o.add(s);for(const s of r.updated.values())o.has(s)||(l.updated.has(s)?p.updated.has(s)&&o.add(s):t.add(s));return{added:a,removed:i,updated:t,conflicts:o}}function I(p,l,r,a){const i=new Set,t=C(p,a),o=C(l,a),s=r?C(r,a):null,c=S(t,o);if(c.added.size===0&&c.removed.size===0&&c.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:i,removed:i,updated:i,conflicts:i};const h=s?S(s,t):{added:[...t.keys()].reduce((k,U)=>(k.add(U),k),new Set),removed:new Set,updated:new Set};if(h.added.size===0&&h.removed.size===0&&h.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:i,removed:i,updated:i,conflicts:i};const m=s?S(s,o):{added:[...o.keys()].reduce((k,U)=>(k.add(U),k),new Set),removed:new Set,updated:new Set};if(m.added.size===0&&m.removed.size===0&&m.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:i,removed:i,updated:i,conflicts:i};const{added:P,removed:_,updated:O,conflicts:M}=E(c,h,m);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:P,removed:_,updated:O,conflicts:M}}function C(p,l){const r=new Map;for(const a of p){const i=l[a.key];let t=r.get(i);t||(t=[],r.set(i,t)),t.push(a)}return r}function f(p){const l=new Map;for(const r of p){const a=r.command[0]==="-"?r.command.substring(1):r.command;let i=l.get(a);i||(i=[],l.set(a,i)),i.push(r)}return l}function S(p,l){const r=[...p.keys()],a=[...l.keys()],i=a.filter(s=>r.indexOf(s)===-1).reduce((s,c)=>(s.add(c),s),new Set),t=r.filter(s=>a.indexOf(s)===-1).reduce((s,c)=>(s.add(c),s),new Set),o=new Set;for(const s of r){if(t.has(s))continue;const c=p.get(s).map(m=>({...m,key:s})),h=l.get(s).map(m=>({...m,key:s}));(0,D.equals)(c,h,(m,P)=>d(m,P))||o.add(s)}return{added:i,removed:t,updated:o}}function u(p,l,r){const a=[...p.keys()],i=[...l.keys()],t=i.filter(c=>a.indexOf(c)===-1).reduce((c,h)=>(c.add(h),c),new Set),o=a.filter(c=>i.indexOf(c)===-1).reduce((c,h)=>(c.add(h),c),new Set),s=new Set;for(const c of a){if(o.has(c))continue;const h=p.get(c).map(P=>({...P,key:r[P.key]})),m=l.get(c).map(P=>({...P,key:r[P.key]}));v(h,m)||s.add(c)}return{added:t,removed:o,updated:s}}function v(p,l){return!(!(0,D.equals)(p.filter(({command:r})=>r[0]!=="-"),l.filter(({command:r})=>r[0]!=="-"),(r,a)=>d(r,a))||!(0,D.equals)(p.filter(({command:r})=>r[0]==="-"),l.filter(({command:r})=>r[0]==="-"),(r,a)=>d(r,a)))}function d(p,l){if(p.command!==l.command||p.key!==l.key)return!1;const r=T.ContextKeyExpr.deserialize(p.when),a=T.ContextKeyExpr.deserialize(l.when);return!(r&&!a||!r&&a||r&&a&&!r.equals(a)||!L.equals(p.args,l.args))}function g(p,l,r){for(const a of l)p=A.edit(p,[-1],a,r);return p}function w(p,l,r){const a=R(p);for(let i=a.length-1;i>=0;i--)(a[i].command===l||a[i].command===`-${l}`)&&(p=A.edit(p,[i],void 0,r));return p}function y(p,l,r,a){const i=R(p),t=i.findIndex(o=>o.command===l||o.command===`-${l}`);for(let o=i.length-1;o>=0;o--)(i[o].command===l||i[o].command===`-${l}`)&&(p=A.edit(p,[o],void 0,a));for(let o=r.length-1;o>=0;o--)p=A.edit(p,[t],r[o],a);return p}}),define(ne[226],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function D(T,A,R){const b={},E={},I=new Set;if(!A)return{local:{added:b,updated:E,removed:[...I.values()]},remote:{added:T,updated:{},removed:[]},conflicts:[]};const C=n(T,A);if(C.added.size===0&&C.removed.size===0&&C.updated.size===0)return{local:{added:b,updated:E,removed:[...I.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const f=n(R,T),S=n(R,A),u={},v={},d=new Set,g=new Set;for(const w of f.removed.values())S.updated.has(w)?b[w]=A[w]:d.add(w);for(const w of S.removed.values())g.has(w)||(f.updated.has(w)?g.add(w):I.add(w));for(const w of f.updated.values())g.has(w)||(S.updated.has(w)?C.updated.has(w)&&g.add(w):v[w]=T[w]);for(const w of S.updated.values())g.has(w)||(f.updated.has(w)?C.updated.has(w)&&g.add(w):T[w]!==void 0&&(E[w]=A[w]));for(const w of f.added.values())g.has(w)||(S.added.has(w)?C.updated.has(w)&&g.add(w):u[w]=T[w]);for(const w of S.added.values())g.has(w)||(f.added.has(w)?C.updated.has(w)&&g.add(w):b[w]=A[w]);return{local:{added:b,removed:[...I.values()],updated:E},remote:{added:u,removed:[...d.values()],updated:v},conflicts:[...g.values()]}}e.merge=D;function n(T,A){const R=T?Object.keys(T):[],b=A?Object.keys(A):[],E=b.filter(f=>R.indexOf(f)===-1).reduce((f,S)=>(f.add(S),f),new Set),I=R.filter(f=>b.indexOf(f)===-1).reduce((f,S)=>(f.add(S),f),new Set),C=new Set;for(const f of R){if(I.has(f))continue;const S=T[f],u=A[f];S!==u&&C.add(f)}return{added:E,removed:I,updated:C}}function L(T,A){const{added:R,removed:b,updated:E}=n(T,A);return R.size===0&&b.size===0&&E.size===0}e.areSame=L}),define(ne[25],ie([0,1,16,19,15,147,42,30,6,88,38]),function(J,e,D,n,L,T,A,R,b,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSyncResourceFromLocalPreview=e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataSyncService=e.IUserDataSyncEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.USER_DATA_SYNC_CONFIGURATION_SCOPE=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function C(){const s=I.Registry.as(A.Extensions.Configuration).getConfigurationProperties();return Object.keys(s).filter(c=>!!s[c].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=C;function f(){const s=I.Registry.as(A.Extensions.Configuration).getConfigurationProperties(),c=Object.keys(s).filter(P=>!!s[P].ignoreSync),h=Object.keys(s).filter(P=>s[P].scope===2||s[P].scope===6),m=C();return(0,D.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...c,...h,...m])}e.getDefaultIgnoredSettings=f,e.USER_DATA_SYNC_CONFIGURATION_SCOPE="settingsSync";function S(){const s="vscode://schemas/ignoredSettings",c=I.Registry.as(A.Extensions.Configuration);c.registerConfiguration({id:"settingsSync",order:30,title:(0,T.localize)(0,null),type:"object",properties:{"settingsSync.keybindingsPerPlatform":{type:"boolean",description:(0,T.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,T.localize)(2,null),items:[{type:"string",pattern:R.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,T.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,T.localize)(4,null),default:[],scope:1,$ref:s,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const h=I.Registry.as(E.Extensions.JSONContribution),m=()=>{const P=C(),_=f().filter(U=>U!==e.CONFIGURATION_SYNC_STORE_KEY),O=Object.keys(A.allSettings.properties).filter(U=>_.indexOf(U)===-1),M=_.filter(U=>P.indexOf(U)===-1),k={items:{type:"string",enum:[...O,...M.map(U=>`-${U}`)]}};h.registerSchema(s,k)};return c.onDidUpdateConfiguration(()=>m())}e.registerConfiguration=S;function u(s){return s&&(0,L.isObject)(s)&&(0,L.isString)(s.id)&&(0,L.isArray)(s.scopes)}e.isAuthenticationProvider=u;var v;(function(s){s.Settings="settings",s.Keybindings="keybindings",s.Snippets="snippets",s.Extensions="extensions",s.GlobalState="globalState"})(v=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","extensions","globalState"];function d(s,c,h){return h.joinPath(c.userDataSyncHome,s,`lastSync${s}.json`)}e.getLastSyncResourceUri=d,e.IUserDataSyncStoreManagementService=(0,b.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,b.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,b.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function g(s){const c={};return c[e.HEADER_EXECUTION_ID]=s,c}e.createSyncHeaders=g;var w;(function(s){s.Unauthorized="Unauthorized",s.Conflict="Conflict",s.Gone="Gone",s.PreconditionFailed="PreconditionFailed",s.TooLarge="TooLarge",s.UpgradeRequired="UpgradeRequired",s.PreconditionRequired="PreconditionRequired",s.TooManyRequests="RemoteTooManyRequests",s.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",s.RequestFailed="RequestFailed",s.RequestCanceled="RequestCanceled",s.RequestTimeout="RequestTimeout",s.RequestProtocolNotSupported="RequestProtocolNotSupported",s.RequestPathNotEscaped="RequestPathNotEscaped",s.RequestHeadersNotObject="RequestHeadersNotObject",s.NoRef="NoRef",s.EmptyResponse="EmptyResponse",s.TurnedOff="TurnedOff",s.SessionExpired="SessionExpired",s.ServiceChanged="ServiceChanged",s.DefaultServiceChanged="DefaultServiceChanged",s.LocalTooManyRequests="LocalTooManyRequests",s.LocalPreconditionFailed="LocalPreconditionFailed",s.LocalInvalidContent="LocalInvalidContent",s.LocalError="LocalError",s.IncompatibleLocalContent="IncompatibleLocalContent",s.IncompatibleRemoteContent="IncompatibleRemoteContent",s.UnresolvedConflicts="UnresolvedConflicts",s.Unknown="Unknown"})(w=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class y extends Error{constructor(c,h,m,P){super(c);this.code=h,this.resource=m,this.operationId=P,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=y;class p extends y{constructor(c,h,m,P,_){super(c,m,void 0,_);this.url=h,this.serverCode=P}}e.UserDataSyncStoreError=p;class l extends y{constructor(c,h){super(c,h)}}e.UserDataAutoSyncError=l,function(s){function c(h){if(h instanceof s)return h;const m=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(h.name);if(m&&m[1]){const P=m[2]==="unknown"?void 0:m[2],_=m[3]==="unknown"?void 0:m[3];return new s(h.message,m[1],P,_)}return new s(h.message,"Unknown")}s.toUserDataSyncError=c}(y=e.UserDataSyncError||(e.UserDataSyncError={}));var r;(function(s){s.Uninitialized="uninitialized",s.Idle="idle",s.Syncing="syncing",s.HasConflicts="hasConflicts"})(r=e.SyncStatus||(e.SyncStatus={}));var a;(function(s){s[s.None=0]="None",s[s.Added=1]="Added",s[s.Modified=2]="Modified",s[s.Deleted=3]="Deleted"})(a=e.Change||(e.Change={}));var i;(function(s){s.Preview="preview",s.Conflict="conflict",s.Accepted="accepted"})(i=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function t(s){return`sync.enable.${s}`}e.getEnablementKey=t,e.IUserDataSyncEnablementService=(0,b.createDecorator)("IUserDataSyncEnablementService"),e.IUserDataSyncService=(0,b.createDecorator)("IUserDataSyncService"),e.IUserDataAutoSyncService=(0,b.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,b.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,b.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview";function o(s,c){if(s.scheme!==e.USER_DATA_SYNC_SCHEME)return s=s.with({scheme:c.userDataSyncHome.scheme}),e.ALL_SYNC_RESOURCES.filter(h=>(0,n.isEqualOrParent)(s,(0,n.joinPath)(c.userDataSyncHome,h,e.PREVIEW_DIR_NAME)))[0]}e.getSyncResourceFromLocalPreview=o}),define(ne[47],ie([0,1,16,5,17,23,3,35,2,27,15,7,143,20,13,14,8,46,24,21,34,25]),function(J,e,D,n,L,T,A,R,b,E,I,C,f,S,u,v,d,g,w,y,p,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.isSyncData=void 0;function r(s){return!!(s&&s.version!==void 0&&typeof s.version=="number"&&s.content!==void 0&&typeof s.content=="string"&&(Object.keys(s).length===2||Object.keys(s).length===3&&s.machineId!==void 0&&typeof s.machineId=="string"))}e.isSyncData=r;let a=class extends b.Disposable{constructor(c,h,m,P,_,O,M,k,U,N,V){super();this.resource=c,this.fileService=h,this.environmentService=m,this.userDataSyncStoreService=_,this.userDataSyncBackupStoreService=O,this.userDataSyncEnablementService=M,this.telemetryService=k,this.logService=U,this.configurationService=N,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new A.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new A.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerThrottler=new n.ThrottledDelayer(50),this._onDidChangeLocal=this._register(new A.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.syncResourceLogLabel=(0,E.uppercaseFirstLetter)(this.resource),this.extUri=V.extUri,this.syncFolder=this.extUri.joinPath(m.userDataSyncHome,c),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,l.PREVIEW_DIR_NAME),this.lastSyncResource=(0,l.getLastSyncResourceUri)(c,m,this.extUri),this.currentMachineIdPromise=(0,g.getServiceMachineId)(m,h,P)}get status(){return this._status}get conflicts(){return this._conflicts}triggerLocalChange(){this.localChangeTriggerThrottler.trigger(()=>this.doTriggerLocalChange())}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const c=await this.syncPreviewPromise;this.syncPreviewPromise=null;const h=await this.performSync(c.remoteUserData,c.lastSyncUserData,!0,this.getUserDataSyncConfiguration());this.setStatus(h)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const c=await this.getLastSyncUserData();(c?await this.hasRemoteChanged(c):!0)&&this._onDidChangeLocal.fire()}}setStatus(c){if(this._status!==c){const h=this._status;c==="hasConflicts"&&this.telemetryService.publicLog2("sync/conflictsDetected",{source:this.resource}),h==="hasConflicts"&&c==="idle"&&this.telemetryService.publicLog2("sync/conflictsResolved",{source:this.resource}),this._status=c,this._onDidChangStatus.fire(c)}}async sync(c,h={}){await this._sync(c,!0,this.getUserDataSyncConfiguration(),h)}async preview(c,h,m={}){return this._sync(c,!1,h,m)}async apply(c,h={}){try{this.syncHeaders={...h};const m=await this.doApply(c);return this.setStatus(m),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(c,h,m,P){try{if(this.syncHeaders={...P},this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let _="idle";try{const O=await this.getLastSyncUserData(),M=await this.getLatestRemoteUserData(c,O);return _=await this.performSync(M,O,h,m),_==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):_==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(_)}}finally{this.syncHeaders={}}}async replace(c){const h=await this.resolveContent(c);if(!h)return!1;const m=this.parseSyncData(h);if(!m)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const P=await this.getLastSyncUserData(),_=await this.getLatestRemoteUserData(null,P),O=await this.isRemoteDataFromCurrentMachine(_),M=await this.generateSyncPreview({ref:_.ref,syncData:m},P,O,this.getUserDataSyncConfiguration(),T.CancellationToken.None),k=[];for(const U of M){const N=await this.getAcceptResult(U,U.remoteResource,void 0,T.CancellationToken.None),{remoteChange:V}=await this.getAcceptResult(U,U.previewResource,U.remoteContent,T.CancellationToken.None);k.push([U,{...N,remoteChange:V!==0?V:2}])}await this.applyResult(_,P,k,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async isRemoteDataFromCurrentMachine(c){const h=await this.currentMachineIdPromise;return!!c.syncData?.machineId&&c.syncData.machineId===h}async getLatestRemoteUserData(c,h){if(h){const m=c&&c.latest?c.latest[this.resource]:void 0;if(h.ref===m||m===void 0&&h.syncData===null)return h}return this.getRemoteUserData(h)}async performSync(c,h,m,P){if(c.syncData&&c.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new l.UserDataSyncError((0,f.localize)(0,null,this.resource,this.version,c.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.doSync(c,h,m,P)}catch(_){if(_ instanceof l.UserDataSyncError)switch(_.code){case"LocalPreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(c,h,m,P);case"Conflict":case"PreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),c=await this.getRemoteUserData(null),h=await this.getLastSyncUserData(),this.performSync(c,h,m,P)}throw _}}async doSync(c,h,m,P){try{this.syncPreviewPromise||(this.syncPreviewPromise=(0,n.createCancelablePromise)(O=>this.doGenerateSyncResourcePreview(c,h,m,P,O)));const _=await this.syncPreviewPromise;return this.updateConflicts(_.resourcePreviews),_.resourcePreviews.some(({mergeState:O})=>O==="conflict")?"hasConflicts":m?await this.doApply(!1):"syncing"}catch(_){throw this.syncPreviewPromise=null,_}}async merge(c){return await this.updateSyncResourcePreview(c,async h=>{const m=await this.getMergeResult(h,T.CancellationToken.None);await this.fileService.writeFile(h.previewResource,L.VSBuffer.fromString(m?.content||""));const P=m&&!m.hasConflicts?await this.getAcceptResult(h,h.previewResource,void 0,T.CancellationToken.None):void 0;return h.acceptResult=P,h.mergeState=m.hasConflicts?"conflict":P?"accepted":"preview",h.localChange=P?P.localChange:m.localChange,h.remoteChange=P?P.remoteChange:m.remoteChange,h}),this.syncPreviewPromise}async accept(c,h){return await this.updateSyncResourcePreview(c,async m=>{const P=await this.getAcceptResult(m,c,h,T.CancellationToken.None);return m.acceptResult=P,m.mergeState="accepted",m.localChange=P.localChange,m.remoteChange=P.remoteChange,m}),this.syncPreviewPromise}async discard(c){return await this.updateSyncResourcePreview(c,async h=>{const m=await this.getMergeResult(h,T.CancellationToken.None);return await this.fileService.writeFile(h.previewResource,L.VSBuffer.fromString(m.content||"")),h.acceptResult=void 0,h.mergeState="preview",h.localChange=m.localChange,h.remoteChange=m.remoteChange,h}),this.syncPreviewPromise}async updateSyncResourcePreview(c,h){if(!this.syncPreviewPromise)return;let m=await this.syncPreviewPromise;const P=m.resourcePreviews.findIndex(({localResource:_,remoteResource:O,previewResource:M})=>this.extUri.isEqual(_,c)||this.extUri.isEqual(O,c)||this.extUri.isEqual(M,c));P!==-1&&(this.syncPreviewPromise=(0,n.createCancelablePromise)(async _=>{const O=[...m.resourcePreviews];return O[P]=await h(O[P]),{...m,resourcePreviews:O}}),m=await this.syncPreviewPromise,this.updateConflicts(m.resourcePreviews),m.resourcePreviews.some(({mergeState:_})=>_==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}async doApply(c){if(!this.syncPreviewPromise)return"idle";const h=await this.syncPreviewPromise;return h.resourcePreviews.some(({mergeState:m})=>m==="conflict")?"hasConflicts":h.resourcePreviews.some(({mergeState:m})=>m!=="accepted")?"syncing":(await this.applyResult(h.remoteUserData,h.lastSyncUserData,h.resourcePreviews.map(m=>[m,m.acceptResult]),c),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch{}}updateConflicts(c){const h=c.filter(({mergeState:m})=>m==="conflict");(0,D.equals)(this._conflicts,h,(m,P)=>this.extUri.isEqual(m.previewResource,P.previewResource))||(this._conflicts=h,this._onDidChangeConflicts.fire(h))}async hasPreviouslySynced(){return!!await this.getLastSyncUserData()}async getRemoteSyncResourceHandles(){return(await this.userDataSyncStoreService.getAllRefs(this.resource)).map(({created:h,ref:m})=>({created:h,uri:this.toRemoteBackupResource(m)}))}async getLocalSyncResourceHandles(){return(await this.userDataSyncBackupStoreService.getAllRefs(this.resource)).map(({created:h,ref:m})=>({created:h,uri:this.toLocalBackupResource(m)}))}toRemoteBackupResource(c){return C.URI.from({scheme:l.USER_DATA_SYNC_SCHEME,authority:"remote-backup",path:`/${this.resource}/${c}`})}toLocalBackupResource(c){return C.URI.from({scheme:l.USER_DATA_SYNC_SCHEME,authority:"local-backup",path:`/${this.resource}/${c}`})}async getMachineId({uri:c}){const h=this.extUri.basename(c);if(this.extUri.isEqual(c,this.toRemoteBackupResource(h))){const{content:m}=await this.getUserData(h);if(m)return this.parseSyncData(m)?.machineId}}async resolveContent(c){const h=this.extUri.basename(c);if(this.extUri.isEqual(c,this.toRemoteBackupResource(h))){const{content:m}=await this.getUserData(h);return m}return this.extUri.isEqual(c,this.toLocalBackupResource(h))?this.userDataSyncBackupStoreService.resolveContent(this.resource,h):null}async resolvePreviewContent(c){const h=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(h)for(const m of h.resourcePreviews){if(this.extUri.isEqual(m.acceptedResource,c))return m.acceptResult?m.acceptResult.content:null;if(this.extUri.isEqual(m.remoteResource,c))return m.remoteContent;if(this.extUri.isEqual(m.localResource,c))return m.localContent}return null}async resetLocal(){try{await this.fileService.del(this.lastSyncResource)}catch{}}async doGenerateSyncResourcePreview(c,h,m,P,_){const O=await this.isRemoteDataFromCurrentMachine(c),M=await this.generateSyncPreview(c,h,O,P,_),k=[];for(const U of M){const N=U.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(U.localChange===0&&U.remoteChange===0)k.push({...U,acceptedResource:N,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const V=m?await this.getMergeResult(U,_):void 0;if(_.isCancellationRequested)break;await this.fileService.writeFile(U.previewResource,L.VSBuffer.fromString(V?.content||""));const $=V&&!V.hasConflicts?await this.getAcceptResult(U,U.previewResource,void 0,_):void 0;k.push({...U,acceptResult:$,mergeState:V?.hasConflicts?"conflict":$?"accepted":"preview",localChange:$?$.localChange:V?V.localChange:U.localChange,remoteChange:$?$.remoteChange:V?V.remoteChange:U.remoteChange})}}return{remoteUserData:c,lastSyncUserData:h,resourcePreviews:k,isLastSyncFromCurrentMachine:O}}async getLastSyncUserData(){try{const c=await this.fileService.readFile(this.lastSyncResource),h=JSON.parse(c.value.toString()),m=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=h.version&&m&&h.version!==m,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${h.version} is not compatible with current sync state version ${m}.`),await this.resetLocal(),null;const P=h;if(P.content===null)return{ref:h.ref,syncData:null};const _=JSON.parse(P.content);if(r(_))return{...h,syncData:_,content:void 0}}catch(c){c instanceof v.FileOperationError&&c.fileOperationResult===1||this.logService.error(c)}return null}async updateLastSyncUserData(c,h={}){if(h.ref||h.content||h.version)throw new Error("Cannot have core properties as additional");const m=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource),P={ref:c.ref,content:c.syncData?JSON.stringify(c.syncData):null,version:m,...h};await this.fileService.writeFile(this.lastSyncResource,L.VSBuffer.fromString(JSON.stringify(P)))}async getRemoteUserData(c){const{ref:h,content:m}=await this.getUserData(c);let P=null;return m!==null&&(P=this.parseSyncData(m)),{ref:h,syncData:P}}parseSyncData(c){try{const h=JSON.parse(c);if(r(h))return h}catch(h){this.logService.error(h)}throw new l.UserDataSyncError((0,f.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async getUserData(c){if((0,I.isString)(c)){const h=await this.userDataSyncStoreService.resolveContent(this.resource,c);return{ref:c,content:h}}else{const h=c?{ref:c.ref,content:c.syncData?JSON.stringify(c.syncData):null}:null;return this.userDataSyncStoreService.read(this.resource,h,this.syncHeaders)}}async updateRemoteUserData(c,h){const m=await this.currentMachineIdPromise,P={version:this.version,machineId:m,content:c};return h=await this.userDataSyncStoreService.write(this.resource,JSON.stringify(P),h,this.syncHeaders),{ref:h,syncData:P}}async backupLocal(c){const h={version:this.version,content:c};return this.userDataSyncBackupStoreService.backup(this.resource,JSON.stringify(h))}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}getUserDataSyncConfiguration(){return this.configurationService.getValue(l.USER_DATA_SYNC_CONFIGURATION_SCOPE)}};a=de([Y(1,v.IFileService),Y(2,u.IEnvironmentService),Y(3,w.IStorageService),Y(4,l.IUserDataSyncStoreService),Y(5,l.IUserDataSyncBackupStoreService),Y(6,l.IUserDataSyncEnablementService),Y(7,y.ITelemetryService),Y(8,l.IUserDataSyncLogService),Y(9,S.IConfigurationService),Y(10,p.IUriIdentityService)],a),e.AbstractSynchroniser=a;let i=class extends a{constructor(c,h,m,P,_,O,M,k,U,N,V,$){super(h,m,P,_,O,M,k,U,N,V,$);this.file=c,this._register(this.fileService.watch(this.extUri.dirname(c))),this._register(this.fileService.onDidFilesChange(G=>this.onFileChanges(G)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch{return null}}async updateLocalFileContent(c,h,m){try{h?await this.fileService.writeFile(this.file,L.VSBuffer.fromString(c),m?void 0:h):await this.fileService.createFile(this.file,L.VSBuffer.fromString(c),{overwrite:m})}catch(P){throw P instanceof v.FileOperationError&&P.fileOperationResult===1||P instanceof v.FileOperationError&&P.fileOperationResult===3?new l.UserDataSyncError(P.message,"LocalPreconditionFailed"):P}}onFileChanges(c){!c.contains(this.file)||this.triggerLocalChange()}};i=de([Y(2,v.IFileService),Y(3,u.IEnvironmentService),Y(4,w.IStorageService),Y(5,l.IUserDataSyncStoreService),Y(6,l.IUserDataSyncBackupStoreService),Y(7,l.IUserDataSyncEnablementService),Y(8,y.ITelemetryService),Y(9,l.IUserDataSyncLogService),Y(10,S.IConfigurationService),Y(11,p.IUriIdentityService)],i),e.AbstractFileSynchroniser=i;let t=class extends i{constructor(c,h,m,P,_,O,M,k,U,N,V,$,G){super(c,h,m,P,_,O,M,k,U,N,$,G);this.userDataSyncUtilService=V,this._formattingOptions=void 0}hasErrors(c){const h=[];return(0,R.parse)(c,h,{allowEmptyContent:!0,allowTrailingComma:!0}),h.length>0}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};t=de([Y(2,v.IFileService),Y(3,u.IEnvironmentService),Y(4,w.IStorageService),Y(5,l.IUserDataSyncStoreService),Y(6,l.IUserDataSyncBackupStoreService),Y(7,l.IUserDataSyncEnablementService),Y(8,y.ITelemetryService),Y(9,l.IUserDataSyncLogService),Y(10,l.IUserDataSyncUtilService),Y(11,S.IConfigurationService),Y(12,p.IUriIdentityService)],t),e.AbstractJsonFileSynchroniser=t;let o=class{constructor(c,h,m,P,_){this.resource=c,this.environmentService=h,this.logService=m,this.fileService=P,this.extUri=_.extUri,this.lastSyncResource=(0,l.getLastSyncResourceUri)(this.resource,h,this.extUri)}async initialize({ref:c,content:h}){if(!h){this.logService.info("Remote content does not exist.",this.resource);return}const m=this.parseSyncData(h);if(!!m)try{await this.doInitialize({ref:c,syncData:m})}catch(P){this.logService.error(P)}}parseSyncData(c){try{const h=JSON.parse(c);if(r(h))return h}catch(h){this.logService.error(h)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(c,h={}){const m={ref:c.ref,content:c.syncData?JSON.stringify(c.syncData):null,...h};await this.fileService.writeFile(this.lastSyncResource,L.VSBuffer.fromString(JSON.stringify(m)))}};o=de([Y(1,u.IEnvironmentService),Y(2,d.ILogService),Y(3,v.IFileService),Y(4,p.IUriIdentityService)],o),e.AbstractInitializer=o}),define(ne[227],ie([0,1,5,23,9,3,49,27,7,20,13,30,31,63,14,8,24,21,34,47,224,98,25]),function(J,e,D,n,L,T,A,R,b,E,I,C,f,S,u,v,d,g,w,y,p,l,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.ExtensionsSynchroniser=void 0;async function a(o,s){const c=JSON.parse(o.content);if(o.version===1||o.version===2){const h=(await s.getInstalled(0)).filter(m=>m.isBuiltin);for(const m of c)o.version===1&&(m.enabled===!1&&(m.disabled=!0),delete m.enabled),o.version===2&&h.every(P=>!(0,f.areSameExtensions)(P.identifier,m.identifier))&&(m.installed=!0)}return c}let i=class mt extends y.AbstractSynchroniser{constructor(s,c,h,m,P,_,O,M,k,U,N,V,$,G,te){super("extensions",c,s,h,m,P,V,$,k,N,te);this.extensionManagementService=_,this.extensionEnablementService=O,this.ignoredExtensionsManagementService=M,this.extensionGalleryService=U,this.extensionStorageService=G,this.version=5,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.localResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(T.Event.debounce(T.Event.any(T.Event.filter(this.extensionManagementService.onDidInstallExtensions,W=>W.some(({local:j})=>!!j)),T.Event.filter(this.extensionManagementService.onDidUninstallExtension,W=>!W.error),this.extensionEnablementService.onDidChangeEnablement,this.extensionStorageService.onDidChangeExtensionStorageToSync),()=>{},500)(()=>this.triggerLocalChange()))}async generateSyncPreview(s,c){const h=s.syncData?await a(s.syncData,this.extensionManagementService):null,m=c?.skippedExtensions||[],P=c?.syncData?await a(c.syncData,this.extensionManagementService):null,_=await this.extensionManagementService.getInstalled(void 0,!0),O=this.getLocalExtensions(_),M=this.ignoredExtensionsManagementService.getIgnoredExtensions(_);h?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:k,remote:U}=(0,p.merge)(O,h,P,m,M),N={local:k,remote:U,content:this.getPreviewContent(O,k.added,k.updated,k.removed),localChange:k.added.length>0||k.removed.length>0||k.updated.length>0?2:0,remoteChange:U!==null?2:0};return[{skippedExtensions:m,localResource:this.localResource,localContent:this.stringify(O,!1),localExtensions:O,remoteResource:this.remoteResource,remoteContent:h?this.stringify(h,!1):null,previewResource:this.previewResource,previewResult:N,localChange:N.localChange,remoteChange:N.remoteChange,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(s){const c=s.syncData?await a(s.syncData,this.extensionManagementService):null,h=await this.extensionManagementService.getInstalled(void 0,!0),m=this.getLocalExtensions(h),P=this.ignoredExtensionsManagementService.getIgnoredExtensions(h),{remote:_}=(0,p.merge)(m,c,c,s.skippedExtensions||[],P);return _!==null}getPreviewContent(s,c,h,m){const P=[...c,...h],_=new Set,O=M=>{_.add(M.id.toLowerCase()),M.uuid&&_.add(M.uuid)};P.forEach(({identifier:M})=>O(M)),m.forEach(O);for(const M of s)_.has(M.identifier.id.toLowerCase())||M.identifier.uuid&&_.has(M.identifier.uuid)||P.push(M);return this.stringify(P,!1)}async getMergeResult(s,c){return{...s.previewResult,hasConflicts:!1}}async getAcceptResult(s,c,h,m){if(this.extUri.isEqual(c,this.localResource))return this.acceptLocal(s);if(this.extUri.isEqual(c,this.remoteResource))return this.acceptRemote(s);if(this.extUri.isEqual(c,this.previewResource))return s.previewResult;throw new Error(`Invalid Resource: ${c.toString()}`)}async acceptLocal(s){const c=await this.extensionManagementService.getInstalled(),h=this.ignoredExtensionsManagementService.getIgnoredExtensions(c),m=(0,p.merge)(s.localExtensions,null,null,s.skippedExtensions,h),{local:P,remote:_}=m;return{content:s.localContent,local:P,remote:_,localChange:P.added.length>0||P.removed.length>0||P.updated.length>0?2:0,remoteChange:_!==null?2:0}}async acceptRemote(s){const c=await this.extensionManagementService.getInstalled(),h=this.ignoredExtensionsManagementService.getIgnoredExtensions(c),m=s.remoteContent?JSON.parse(s.remoteContent):null;if(m!==null){const P=(0,p.merge)(s.localExtensions,m,s.localExtensions,[],h),{local:_,remote:O}=P;return{content:s.remoteContent,local:_,remote:O,localChange:_.added.length>0||_.removed.length>0||_.updated.length>0?2:0,remoteChange:O!==null?2:0}}else return{content:s.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(s,c,h,m){let{skippedExtensions:P,localExtensions:_}=h[0][0],{local:O,remote:M,localChange:k,remoteChange:U}=h[0][1];if(k===0&&U===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),k!==0&&(await this.backupLocal(JSON.stringify(_)),P=await this.updateLocalExtensions(O.added,O.removed,O.updated,P)),M){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const N=JSON.stringify(M.all);s=await this.updateRemoteUserData(N,m?null:s.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions.${M.added.length?` Added: ${JSON.stringify(M.added.map(V=>V.identifier.id))}.`:""}${M.updated.length?` Updated: ${JSON.stringify(M.updated.map(V=>V.identifier.id))}.`:""}${M.removed.length?` Removed: ${JSON.stringify(M.removed.map(V=>V.identifier.id))}.`:""}`)}c?.ref!==s.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),await this.updateLastSyncUserData(s,{skippedExtensions:P}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions.${P.length?` Skipped: ${JSON.stringify(P.map(N=>N.identifier.id))}.`:""}`))}async getAssociatedResources({uri:s}){return[{resource:this.extUri.joinPath(s,"extensions.json"),comparableResource:mt.EXTENSIONS_DATA_URI}]}async resolveContent(s){if(this.extUri.isEqual(s,mt.EXTENSIONS_DATA_URI)){const h=await this.extensionManagementService.getInstalled(),m=this.ignoredExtensionsManagementService.getIgnoredExtensions(h),P=this.getLocalExtensions(h).filter(_=>!m.some(O=>(0,f.areSameExtensions)({id:O},_.identifier)));return this.stringify(P,!0)}if(this.extUri.isEqual(this.remoteResource,s)||this.extUri.isEqual(this.localResource,s)||this.extUri.isEqual(this.acceptedResource,s)){const h=await this.resolvePreviewContent(s);return h&&this.stringify(JSON.parse(h),!0)}let c=await super.resolveContent(s);if(c)return c;if(c=await super.resolveContent(this.extUri.dirname(s)),c){const h=this.parseSyncData(c);if(h)switch(this.extUri.basename(s)){case"extensions.json":return this.stringify(this.parseExtensions(h),!0)}}return null}stringify(s,c){return s.sort((h,m)=>!h.identifier.uuid&&m.identifier.uuid?-1:h.identifier.uuid&&!m.identifier.uuid?1:(0,R.compare)(h.identifier.id,m.identifier.id)),c?(0,A.toFormattedString)(s,{}):JSON.stringify(s)}async hasLocalData(){try{const s=await this.extensionManagementService.getInstalled();if(this.getLocalExtensions(s).some(h=>h.installed||h.disabled))return!0}catch{}return!1}async updateLocalExtensions(s,c,h,m){const P=[],_=[],O=await this.extensionManagementService.getInstalled();if(c.length){const k=O.filter(({identifier:U,isBuiltin:N})=>!N&&c.some(V=>(0,f.areSameExtensions)(U,V)));await D.Promises.settled(k.map(async U=>{this.logService.trace(`${this.syncResourceLogLabel}: Uninstalling local extension...`,U.identifier.id),await this.extensionManagementService.uninstall(U,{donotIncludePack:!0,donotCheckDependents:!0}),this.logService.info(`${this.syncResourceLogLabel}: Uninstalled local extension.`,U.identifier.id),P.push(U.identifier)}))}(s.length||h.length)&&await D.Promises.settled([...s,...h].map(async k=>{const U=O.find(V=>(0,f.areSameExtensions)(V.identifier,k.identifier));if(U&&U.isBuiltin){k.state&&U.manifest.version===k.version&&this.updateExtensionState(k.state,U,U.manifest.version),this.extensionEnablementService.getDisabledExtensions().some($=>(0,f.areSameExtensions)($,k.identifier))!==!!k.disabled&&(k.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,k.identifier.id),await this.extensionEnablementService.disableExtension(k.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,k.identifier.id)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,k.identifier.id),await this.extensionEnablementService.enableExtension(k.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,k.identifier.id))),P.push(k.identifier);return}const N=(await this.extensionGalleryService.getExtensions([{...k.identifier,preRelease:k.preRelease}],n.CancellationToken.None))[0];if(k.state&&(U?U.manifest.version===k.version:!!N)&&this.updateExtensionState(k.state,U||N,U?.manifest.version),N)try{this.extensionEnablementService.getDisabledExtensions().some($=>(0,f.areSameExtensions)($,k.identifier))!==!!k.disabled&&(k.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,k.identifier.id,N.version),await this.extensionEnablementService.disableExtension(N.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,k.identifier.id,N.version)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,k.identifier.id,N.version),await this.extensionEnablementService.enableExtension(N.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,k.identifier.id,N.version))),(!U||U.preRelease!==k.preRelease)&&(await this.extensionManagementService.canInstall(N)?(this.logService.trace(`${this.syncResourceLogLabel}: Installing extension...`,k.identifier.id,N.version),await this.extensionManagementService.installFromGallery(N,{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installPreReleaseVersion:k.preRelease}),this.logService.info(`${this.syncResourceLogLabel}: Installed extension.`,k.identifier.id,N.version),P.push(N.identifier)):(this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because it cannot be installed.`,N.displayName||N.identifier.id),_.push(k)))}catch(V){_.push(k),V instanceof C.ExtensionManagementError&&[C.ExtensionManagementErrorCode.Incompatible,C.ExtensionManagementErrorCode.IncompatiblePreRelease,C.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(V.code)?this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the compatible extension is not found.`,N.displayName||N.identifier.id):(this.logService.error(V),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension`,N.displayName||N.identifier.id))}else _.push(k),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the extension is not found.`,k.identifier.id)}));const M=[];for(const k of m)P.some(U=>(0,f.areSameExtensions)(U,k.identifier))||M.push(k);for(const k of _)M.some(U=>(0,f.areSameExtensions)(U.identifier,k.identifier))||M.push(k);return M}updateExtensionState(s,c,h){const m=this.extensionStorageService.getExtensionState(c,!0)||{},P=h?this.extensionStorageService.getKeysForSync({id:c.identifier.id,version:h}):void 0;P?P.forEach(_=>{m[_]=s[_]}):Object.keys(s).forEach(_=>m[_]=s[_]),this.extensionStorageService.setExtensionState(c,m,!0)}parseExtensions(s){return JSON.parse(s.content)}getLocalExtensions(s){const c=this.extensionEnablementService.getDisabledExtensions();return s.map(h=>{const{identifier:m,isBuiltin:P,manifest:_,preRelease:O}=h,M={identifier:m,preRelease:O,version:_.version};c.some(k=>(0,f.areSameExtensions)(k,m))&&(M.disabled=!0),P||(M.installed=!0);try{const k=this.extensionStorageService.getKeysForSync({id:m.id,version:_.version});if(k){const U=this.extensionStorageService.getExtensionState(h,!0)||{};M.state=Object.keys(U).reduce((N,V)=>(k.includes(V)&&(N[V]=U[V]),N),{})}}catch(k){this.logService.info(`${this.syncResourceLogLabel}: Error while parsing extension state`,(0,L.getErrorMessage)(k))}return M})}};i.EXTENSIONS_DATA_URI=b.URI.from({scheme:r.USER_DATA_SYNC_SCHEME,authority:"extensions",path:"/extensions.json"}),i=de([Y(0,I.IEnvironmentService),Y(1,u.IFileService),Y(2,d.IStorageService),Y(3,r.IUserDataSyncStoreService),Y(4,r.IUserDataSyncBackupStoreService),Y(5,C.IExtensionManagementService),Y(6,C.IGlobalExtensionEnablementService),Y(7,l.IIgnoredExtensionsManagementService),Y(8,r.IUserDataSyncLogService),Y(9,C.IExtensionGalleryService),Y(10,E.IConfigurationService),Y(11,r.IUserDataSyncEnablementService),Y(12,g.ITelemetryService),Y(13,S.IExtensionStorageService),Y(14,w.IUriIdentityService)],i),e.ExtensionsSynchroniser=i;let t=class extends y.AbstractInitializer{constructor(s,c,h,m,P,_){super("extensions",m,P,h,_);this.extensionManagementService=s,this.ignoredExtensionsManagementService=c}async parseExtensions(s){return s.syncData?await a(s.syncData,this.extensionManagementService):null}generatePreview(s,c){const h=[],m=[],P=[];for(const _ of s){if(this.ignoredExtensionsManagementService.hasToNeverSyncExtension(_.identifier.id))continue;const O=c.find(M=>(0,f.areSameExtensions)(M.identifier,_.identifier));O?(h.push(O),_.disabled&&P.push(_.identifier)):_.installed&&(m.push(_.identifier),_.disabled&&P.push(_.identifier))}return{installedExtensions:h,newExtensions:m,disabledExtensions:P,remoteExtensions:s}}};t=de([Y(0,C.IExtensionManagementService),Y(1,l.IIgnoredExtensionsManagementService),Y(2,u.IFileService),Y(3,I.IEnvironmentService),Y(4,v.ILogService),Y(5,w.IUriIdentityService)],t),e.AbstractExtensionsInitializer=t}),define(ne[228],ie([0,1,28,25]),function(J,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function L(R,b,E,I,C){if(!b)return{remote:Object.keys(R).length>0?R:null,local:{added:{},removed:[],updated:{}}};const f=T(R,b);if(f.added.size===0&&f.removed.size===0&&f.updated.size===0)return{remote:null,local:{added:{},removed:[],updated:{}}};const S=E?T(E,b):{added:Object.keys(b).reduce((w,y)=>(w.add(y),w),new Set),removed:new Set,updated:new Set},u=E?T(E,R):{added:Object.keys(R).reduce((w,y)=>(w.add(y),w),new Set),removed:new Set,updated:new Set},v={added:{},removed:[],updated:{}},d=D.deepClone(b),g=!E;for(const w of u.added.values())w!==n.SYNC_SERVICE_URL_TYPE&&g&&S.added.has(w)||(d[w]=R[w]);for(const w of u.updated.values())d[w]=R[w];for(const w of u.removed.values())I.unregistered.includes(w)||delete d[w];for(const w of S.added.values()){const y=b[w];if(I.machine.includes(w)){C.info(`GlobalState: Skipped adding ${w} in local storage because it is declared as machine scoped.`);continue}if(E&&u.added.has(w))continue;const p=R[w];p&&p.value===y.value||w===n.SYNC_SERVICE_URL_TYPE&&g&&u.added.has(w)||(p?v.updated[w]=y:v.added[w]=y)}for(const w of S.updated.values()){const y=b[w];if(I.machine.includes(w)){C.info(`GlobalState: Skipped updating ${w} in local storage because it is declared as machine scoped.`);continue}if(u.updated.has(w)||u.removed.has(w))continue;const p=R[w];p&&p.value===y.value||(v.updated[w]=y)}for(const w of S.removed.values()){if(I.machine.includes(w)){C.trace(`GlobalState: Skipped removing ${w} in local storage because it is declared as machine scoped.`);continue}u.updated.has(w)||u.removed.has(w)||v.removed.push(w)}return{local:v,remote:A(d,b)?null:d}}e.merge=L;function T(R,b){const E=Object.keys(R),I=Object.keys(b),C=I.filter(u=>E.indexOf(u)===-1).reduce((u,v)=>(u.add(v),u),new Set),f=E.filter(u=>I.indexOf(u)===-1).reduce((u,v)=>(u.add(v),u),new Set),S=new Set;for(const u of E){if(f.has(u))continue;const v=R[u],d=b[u];D.equals(v,d)||S.add(u)}return{added:C,removed:f,updated:S}}function A(R,b){const{added:E,removed:I,updated:C}=T(R,b);return E.size===0&&I.size===0&&C.size===0}}),define(ne[229],ie([0,1,17,9,3,35,49,4,7,29,20,13,14,8,46,24,21,34,47,53,228,25]),function(J,e,D,n,L,T,A,R,b,E,I,C,f,S,u,v,d,g,w,y,p,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.GlobalStateSynchroniser=void 0;const r="globalState.argv.",a=["locale"];function i(h,m){const P=h.storage?Object.keys(h.storage).sort():[],_={};return P.forEach(O=>_[O]=h.storage[O]),h.storage=_,m?(0,A.toFormattedString)(h,{}):JSON.stringify(h)}const t=1;let o=class vt extends w.AbstractSynchroniser{constructor(m,P,_,O,M,k,U,N,V,$){super("globalState",m,M,V,P,_,k,U,O,N,$);this.storageService=V,this.version=t,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.localResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(m.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(L.Event.any(L.Event.filter(m.onDidFilesChange,G=>G.contains(this.environmentService.argvResource)),L.Event.filter(V.onDidChangeValue,G=>G.scope===0&&G.target!==void 0?G.target===0:V.keys(0,0).includes(G.key)),this.storageService.onDidChangeTarget)(()=>this.triggerLocalChange()))}async generateSyncPreview(m,P,_){const O=m.syncData?JSON.parse(m.syncData.content):null;P=P===null&&_?m:P;const M=P&&P.syncData?JSON.parse(P.syncData.content):null,k=await this.getLocalGlobalState();O?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const U=this.getStorageKeys(M),{local:N,remote:V}=(0,p.merge)(k.storage,O?O.storage:null,M?M.storage:null,U,this.logService),$={content:null,local:N,remote:V,localChange:Object.keys(N.added).length>0||Object.keys(N.updated).length>0||N.removed.length>0?2:0,remoteChange:V!==null?2:0};return[{localResource:this.localResource,localContent:i(k,!1),localUserData:k,remoteResource:this.remoteResource,remoteContent:O?i(O,!1):null,previewResource:this.previewResource,previewResult:$,localChange:$.localChange,remoteChange:$.remoteChange,acceptedResource:this.acceptedResource,storageKeys:U}]}async hasRemoteChanged(m){const P=m.syncData?JSON.parse(m.syncData.content):null;if(P===null)return!0;const _=await this.getLocalGlobalState(),O=this.getStorageKeys(P),{remote:M}=(0,p.merge)(_.storage,P.storage,P.storage,O,this.logService);return M!==null}async getMergeResult(m,P){return{...m.previewResult,hasConflicts:!1}}async getAcceptResult(m,P,_,O){if(this.extUri.isEqual(P,this.localResource))return this.acceptLocal(m);if(this.extUri.isEqual(P,this.remoteResource))return this.acceptRemote(m);if(this.extUri.isEqual(P,this.previewResource))return m.previewResult;throw new Error(`Invalid Resource: ${P.toString()}`)}async acceptLocal(m){return{content:m.localContent,local:{added:{},removed:[],updated:{}},remote:m.localUserData.storage,localChange:0,remoteChange:2}}async acceptRemote(m){if(m.remoteContent!==null){const P=JSON.parse(m.remoteContent),{local:_,remote:O}=(0,p.merge)(m.localUserData.storage,P.storage,null,m.storageKeys,this.logService);return{content:m.remoteContent,local:_,remote:O,localChange:Object.keys(_.added).length>0||Object.keys(_.updated).length>0||_.removed.length>0?2:0,remoteChange:O!==null?2:0}}else return{content:m.remoteContent,local:{added:{},removed:[],updated:{}},remote:null,localChange:0,remoteChange:0}}async applyResult(m,P,_,O){let{localUserData:M}=_[0][0],{local:k,remote:U,localChange:N,remoteChange:V}=_[0][1];if(N===0&&V===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),N!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(M)),await this.writeLocalGlobalState(k),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),V!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const $=JSON.stringify({storage:U});m=await this.updateRemoteUserData($,O?null:m.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state`)}P?.ref!==m.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(m),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async getAssociatedResources({uri:m}){return[{resource:this.extUri.joinPath(m,"globalState.json"),comparableResource:vt.GLOBAL_STATE_DATA_URI}]}async resolveContent(m){if(this.extUri.isEqual(m,vt.GLOBAL_STATE_DATA_URI)){const _=await this.getLocalGlobalState();return i(_,!0)}if(this.extUri.isEqual(this.remoteResource,m)||this.extUri.isEqual(this.localResource,m)||this.extUri.isEqual(this.acceptedResource,m)){const _=await this.resolvePreviewContent(m);return _&&i(JSON.parse(_),!0)}let P=await super.resolveContent(m);if(P)return P;if(P=await super.resolveContent(this.extUri.dirname(m)),P){const _=this.parseSyncData(P);if(_)switch(this.extUri.basename(m)){case"globalState.json":return i(JSON.parse(_.content),!0)}}return null}async hasLocalData(){try{const{storage:m}=await this.getLocalGlobalState();if(Object.keys(m).length>1||m[`${r}.locale`]?.value!=="en")return!0}catch{}return!1}async getLocalGlobalState(){const m={},P=await this.getLocalArgvContent(),_=(0,T.parse)(P);for(const O of a)_[O]!==void 0&&(m[`${r}${O}`]={version:1,value:_[O]});for(const O of this.storageService.keys(0,0)){const M=this.storageService.get(O,0);M&&(m[O]={version:1,value:M})}return{storage:m}}async getLocalArgvContent(){try{this.logService.debug("GlobalStateSync#getLocalArgvContent",this.environmentService.argvResource);const m=await this.fileService.readFile(this.environmentService.argvResource);return this.logService.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.environmentService.argvResource),m.value.toString()}catch(m){this.logService.debug((0,n.getErrorMessage)(m))}return"{}"}async writeLocalGlobalState({added:m,removed:P,updated:_}){const O={},M={},k=(N,V)=>{for(const $ of N){if($.startsWith(r)){O[$.substring(r.length)]=V?V[$].value:void 0;continue}if(V){const G=V[$];G.value!==String(this.storageService.get($,0))&&(M[$]=G.value)}else this.storageService.get($,0)!==void 0&&(M[$]=void 0)}};if(k(Object.keys(m),m),k(Object.keys(_),_),k(P),Object.keys(O).length&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.updateArgv(O),this.logService.info(`${this.syncResourceLogLabel}: Updated locale`)),Object.keys(M).length){this.logService.trace(`${this.syncResourceLogLabel}: Updating global state...`);for(const N of Object.keys(M))this.storageService.store(N,M[N],0,0);this.logService.info(`${this.syncResourceLogLabel}: Updated global state`,Object.keys(M))}}async updateArgv(m){const P=await this.getLocalArgvContent();let _=P;for(const O of Object.keys(m))_=(0,y.edit)(_,[O],m[O],{});P!==_&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,D.VSBuffer.fromString(_)),this.logService.info(`${this.syncResourceLogLabel}: Updated locale.`))}getStorageKeys(m){const P=this.storageService.keys(0,0),_=this.storageService.keys(0,1),O=[...P,..._],M=m?.storage?Object.keys(m.storage).filter(k=>!k.startsWith(r)&&!O.includes(k)&&this.storageService.get(k,0)!==void 0):[];if(!R.isWeb){const k=[...l.ALL_SYNC_RESOURCES.map(U=>(0,l.getEnablementKey)(U)),l.SYNC_SERVICE_URL_TYPE];M.push(...k),_.push(...k)}return{user:P,machine:_,unregistered:M}}};o.GLOBAL_STATE_DATA_URI=b.URI.from({scheme:l.USER_DATA_SYNC_SCHEME,authority:"globalState",path:"/globalState.json"}),o=de([Y(0,f.IFileService),Y(1,l.IUserDataSyncStoreService),Y(2,l.IUserDataSyncBackupStoreService),Y(3,l.IUserDataSyncLogService),Y(4,C.IEnvironmentService),Y(5,l.IUserDataSyncEnablementService),Y(6,d.ITelemetryService),Y(7,I.IConfigurationService),Y(8,v.IStorageService),Y(9,g.IUriIdentityService)],o),e.GlobalStateSynchroniser=o;let s=class extends w.AbstractInitializer{constructor(m,P,_,O,M){super("globalState",_,O,P,M);this.storageService=m}async doInitialize(m){const P=m.syncData?JSON.parse(m.syncData.content):null;if(!P){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const _={},O={};for(const M of Object.keys(P.storage))M.startsWith(r)?_[M.substring(r.length)]=P.storage[M].value:this.storageService.get(M,0)===void 0&&(O[M]=P.storage[M].value);if(Object.keys(_).length){let M="{}";try{M=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch{}for(const k of Object.keys(_))M=(0,y.edit)(M,[k],_[k],{});await this.fileService.writeFile(this.environmentService.argvResource,D.VSBuffer.fromString(M))}if(Object.keys(O).length)for(const M of Object.keys(O))this.storageService.store(M,O[M],0,0)}};s=de([Y(0,v.IStorageService),Y(1,f.IFileService),Y(2,C.IEnvironmentService),Y(3,l.IUserDataSyncLogService),Y(4,g.IUriIdentityService)],s),e.GlobalStateInitializer=s;let c=class{constructor(m,P,_,O,M){this.userDataSyncStoreClient=m,this.storageService=P,this.environmentService=_,this.fileService=O,this.logService=M}getSyncStoreType(m){return this.parseGlobalState(m)?.storage[l.SYNC_SERVICE_URL_TYPE]?.value}async sync(m){const P=(0,l.createSyncHeaders)((0,E.generateUuid)());try{return await this.doSync(m,P)}catch(_){if(_ instanceof l.UserDataSyncError)switch(_.code){case"PreconditionFailed":return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(m,P)}throw _}}async doSync(m,P){const _=await this.userDataSyncStoreClient.read("globalState",null,P),O=this.parseGlobalState(_)||{storage:{}};O.storage[l.SYNC_SERVICE_URL_TYPE]={value:m,version:t};const M=await(0,u.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),k={version:t,machineId:M,content:i(O,!1)};await this.userDataSyncStoreClient.write("globalState",JSON.stringify(k),_.ref,P)}parseGlobalState({content:m}){if(!m)return null;const P=JSON.parse(m);if((0,w.isSyncData)(P))return P?JSON.parse(P.content):null;throw new Error("Invalid remote data")}};c=de([Y(1,v.IStorageService),Y(2,C.IEnvironmentService),Y(3,f.IFileService),Y(4,S.ILogService)],c),e.UserDataSyncStoreTypeSynchronizer=c}),define(ne[230],ie([0,1,16,17,3,35,4,15,144,20,13,14,24,21,34,47,225,25]),function(J,e,D,n,L,T,A,R,b,E,I,C,f,S,u,v,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function w(l,r,a){try{const i=JSON.parse(l);if(!r)return(0,R.isUndefined)(i.all)?null:i.all;switch(A.OS){case 2:return(0,R.isUndefined)(i.mac)?null:i.mac;case 3:return(0,R.isUndefined)(i.linux)?null:i.linux;case 1:return(0,R.isUndefined)(i.windows)?null:i.windows}}catch(i){return a.error(i),null}}e.getKeybindingsContentFromSyncContent=w;let y=class extends v.AbstractJsonFileSynchroniser{constructor(r,a,i,t,o,s,c,h,m,P,_){super(c.keybindingsResource,"keybindings",s,c,h,r,a,o,P,i,m,t,_);this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.localResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(L.Event.filter(t.onDidChangeConfiguration,O=>O.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(r,a,i,t){const o=r.syncData?w(r.syncData.content,t.keybindingsPerPlatform??this.syncKeybindingsPerPlatform(),this.logService):null;a=a===null&&i?r:a;const s=a?this.getKeybindingsContentFromLastSyncUserData(a):null,c=await this.getLocalFileContent(),h=await this.getFormattingOptions();let m=null,P=!1,_=!1,O=!1;if(o){let k=c?c.value.toString():"[]";if(k=k||"[]",this.hasErrors(k))throw new g.UserDataSyncError((0,b.localize)(0,null),"LocalInvalidContent",this.resource);if(!s||s!==k||s!==o){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const U=await(0,d.merge)(k,o,s,h,this.userDataSyncUtilService);U.hasChanges&&(m=U.mergeContent,O=U.hasConflicts,P=O||U.mergeContent!==k,_=O||U.mergeContent!==o)}}else c&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),m=c.value.toString(),_=!0);const M={content:m,localChange:P?c?2:1:0,remoteChange:_?2:0,hasConflicts:O};return[{fileContent:c,localResource:this.localResource,localContent:c?c.value.toString():null,localChange:M.localChange,remoteResource:this.remoteResource,remoteContent:o,remoteChange:M.remoteChange,previewResource:this.previewResource,previewResult:M,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(r){const a=this.getKeybindingsContentFromLastSyncUserData(r);if(a===null)return!0;const i=await this.getLocalFileContent(),t=i?i.value.toString():"",o=await this.getFormattingOptions(),s=await(0,d.merge)(t||"[]",a,a,o,this.userDataSyncUtilService);return s.hasConflicts||s.mergeContent!==a}async getMergeResult(r,a){return r.previewResult}async getAcceptResult(r,a,i,t){if(this.extUri.isEqual(a,this.localResource))return{content:r.fileContent?r.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(a,this.remoteResource))return{content:r.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(a,this.previewResource))return i===void 0?{content:r.previewResult.content,localChange:r.previewResult.localChange,remoteChange:r.previewResult.remoteChange}:{content:i,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${a.toString()}`)}async applyResult(r,a,i,t){const{fileContent:o}=i[0][0];let{content:s,localChange:c,remoteChange:h}=i[0][1];if(c===0&&h===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),s!==null&&(s=s.trim(),s=s||"[]",this.hasErrors(s)))throw new g.UserDataSyncError((0,b.localize)(1,null),"LocalInvalidContent",this.resource);if(c!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),o&&await this.backupLocal(this.toSyncContent(o.value.toString())),await this.updateLocalFileContent(s||"[]",o,t),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),h!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const m=this.toSyncContent(s||"[]",r.syncData?.content);r=await this.updateRemoteUserData(m,t?null:r.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch{}a?.ref!==r.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(r,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const r=await this.getLocalFileContent();if(r){const a=(0,T.parse)(r.value.toString());if((0,D.isNonEmptyArray)(a))return!0}}catch(r){if(r.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:r}){const a=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(r,"keybindings.json"),comparableResource:a}]}async resolveContent(r){if(this.extUri.isEqual(this.remoteResource,r)||this.extUri.isEqual(this.localResource,r)||this.extUri.isEqual(this.acceptedResource,r))return this.resolvePreviewContent(r);let a=await super.resolveContent(r);if(a)return a;if(a=await super.resolveContent(this.extUri.dirname(r)),a){const i=this.parseSyncData(a);if(i)switch(this.extUri.basename(r)){case"keybindings.json":return w(i.content,this.syncKeybindingsPerPlatform(),this.logService)}}return null}getKeybindingsContentFromLastSyncUserData(r){return!r.syncData||r.platformSpecific!==void 0&&r.platformSpecific!==this.syncKeybindingsPerPlatform()?null:w(r.syncData.content,this.syncKeybindingsPerPlatform(),this.logService)}toSyncContent(r,a){let i={};try{i=JSON.parse(a||"{}")}catch(t){this.logService.error(t)}switch(this.syncKeybindingsPerPlatform()?delete i.all:i.all=r,A.OS){case 2:i.mac=r;break;case 3:i.linux=r;break;case 1:i.windows=r;break}return JSON.stringify(i)}syncKeybindingsPerPlatform(){return!!this.configurationService.getValue("settingsSync.keybindingsPerPlatform")}};y=de([Y(0,g.IUserDataSyncStoreService),Y(1,g.IUserDataSyncBackupStoreService),Y(2,g.IUserDataSyncLogService),Y(3,E.IConfigurationService),Y(4,g.IUserDataSyncEnablementService),Y(5,C.IFileService),Y(6,I.IEnvironmentService),Y(7,f.IStorageService),Y(8,g.IUserDataSyncUtilService),Y(9,S.ITelemetryService),Y(10,u.IUriIdentityService)],y),e.KeybindingsSynchroniser=y;let p=class extends v.AbstractInitializer{constructor(r,a,i,t){super("keybindings",a,i,r,t)}async doInitialize(r){const a=r.syncData?this.getKeybindingsContentFromSyncContent(r.syncData.content):null;if(!a){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.environmentService.keybindingsResource,n.VSBuffer.fromString(a)),await this.updateLastSyncUserData(r)}async isEmpty(){try{const r=await this.fileService.readFile(this.environmentService.settingsResource),a=(0,T.parse)(r.value.toString());return!(0,D.isNonEmptyArray)(a)}catch(r){return r.fileOperationResult===1}}getKeybindingsContentFromSyncContent(r){try{return w(r,!0,this.logService)}catch(a){return this.logService.error(a),null}}};p=de([Y(0,C.IFileService),Y(1,I.IEnvironmentService),Y(2,g.IUserDataSyncLogService),Y(3,u.IUriIdentityService)],p),e.KeybindingsInitializer=p}),define(ne[231],ie([0,1,16,35,69,49,28,53,25]),function(J,e,D,n,L,T,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.getIgnoredSettings=void 0;function E(s,c,h){let m=[];h?m=C(h):m=I(c);const P=[],_=[...(0,b.getDisallowedIgnoredSettings)()];if(Array.isArray(m))for(const O of m)O.startsWith("-")?_.push(O.substring(1)):P.push(O);return(0,D.distinct)([...s,...P].filter(O=>_.indexOf(O)===-1))}e.getIgnoredSettings=E;function I(s){let c=s.inspect("settingsSync.ignoredSettings").userValue;return c!==void 0||(c=s.inspect("sync.ignoredSettings").userValue,c!==void 0)?c:s.getValue("settingsSync.ignoredSettings")||[]}function C(s){const c=(0,n.parse)(s);return c?c["settingsSync.ignoredSettings"]||c["sync.ignoredSettings"]||[]:[]}function f(s,c,h,m){if(h.length){const P=o(c),_=(0,n.parse)(c),O=(0,n.parse)(s),M=[];for(const k of h){const U=_[k],N=O[k];U===void 0?s=R.edit(s,[k],void 0,m):N!==void 0?s=R.edit(s,[k],U,m):M.push(l(k,P))}M.sort((k,U)=>k.startOffset-U.startOffset),M.forEach(k=>s=g(k.setting.key,c,s,m))}return s}e.updateIgnoredSettings=f;function S(s,c,h,m,P,_){const O=f(s,c,m,_),M=h!==O,k=h!==c;if(!M&&!k)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(M&&!k)return{conflictsSettings:[],localContent:null,remoteContent:O,hasConflicts:!1};if(k&&!M)return{conflictsSettings:[],localContent:f(c,s,m,_),remoteContent:null,hasConflicts:!1};if(h===null&&v(s)){const z=u(s,c,m)?null:f(c,s,m,_);return{conflictsSettings:[],localContent:z,remoteContent:null,hasConflicts:!1}}let U=s,N=c;const V=(0,n.parse)(s),$=(0,n.parse)(c),G=h?(0,n.parse)(h):null,te=m.reduce((z,q)=>(z.add(q),z),new Set),W=d(V,$,te),j=d(G,V,te),K=d(G,$,te),H=new Map,Q=new Set,Z=z=>{Q.add(z);const q=P.filter(({key:ee})=>ee===z)[0];q?(U=R.edit(U,[z],q.value,_),N=R.edit(N,[z],q.value,_)):H.set(z,{key:z,localValue:V[z],remoteValue:$[z]})};for(const z of j.removed.values())K.updated.has(z)?Z(z):N=R.edit(N,[z],void 0,_);for(const z of K.removed.values())Q.has(z)||(j.updated.has(z)?Z(z):U=R.edit(U,[z],void 0,_));for(const z of j.updated.values())Q.has(z)||(K.updated.has(z)?W.updated.has(z)&&Z(z):N=R.edit(N,[z],V[z],_));for(const z of K.updated.values())Q.has(z)||(j.updated.has(z)?W.updated.has(z)&&Z(z):U=R.edit(U,[z],$[z],_));for(const z of j.added.values())Q.has(z)||(K.added.has(z)?W.updated.has(z)&&Z(z):N=g(z,U,N,_));for(const z of K.added.values())Q.has(z)||(j.added.has(z)?W.updated.has(z)&&Z(z):U=g(z,N,U,_));const B=H.size>0||!u(U,N,m),F=B||!u(U,s,[]),x=B||!u(N,c,[]);return{localContent:F?U:null,remoteContent:x?N:null,conflictsSettings:[...H.values()],hasConflicts:B}}e.merge=S;function u(s,c,h){if(s===c)return!0;const m=(0,n.parse)(s),P=(0,n.parse)(c),_=h.reduce((k,U)=>(k.add(U),k),new Set),O=o(s).filter(k=>!(k.setting&&_.has(k.setting.key))),M=o(c).filter(k=>!(k.setting&&_.has(k.setting.key)));if(O.length!==M.length)return!1;for(let k=0;k<O.length;k++){const U=O[k],N=M[k];if(U.setting&&N.setting){if(U.setting.key!==N.setting.key||!A.equals(m[U.setting.key],P[U.setting.key]))return!1}else if(!U.setting&&!N.setting){if(U.value!==N.value)return!1}else return!1}return!0}e.areSame=u;function v(s){return s?o(s).length===0:!0}e.isEmpty=v;function d(s,c,h){const m=s?Object.keys(s).filter(k=>!h.has(k)):[],P=Object.keys(c).filter(k=>!h.has(k)),_=P.filter(k=>m.indexOf(k)===-1).reduce((k,U)=>(k.add(U),k),new Set),O=m.filter(k=>P.indexOf(k)===-1).reduce((k,U)=>(k.add(U),k),new Set),M=new Set;if(s)for(const k of m){if(O.has(k))continue;const U=s[k],N=c[k];A.equals(U,N)||M.add(k)}return{added:_,removed:O,updated:M}}function g(s,c,h,m){const P=(0,n.parse)(c),_=o(c),O=o(h),M=w(s,_,O);return y(h,s,P[s],M,O,m)}e.addSetting=g;function w(s,c,h){const m=c.findIndex(_=>_.setting?.key===s),P=c[m-1];if(P){if(P.setting){const O=l(P.setting.key,h);if(O)return{index:h.indexOf(O),insertAfter:!0}}else{const O=r(m,c);if(O){const M=l(O.setting.key,h);if(M){const k=a(h.indexOf(M),h),U=i(c,O,c[m]);if(k){const N=i(h,M,k),V=t(U,N);return V?{index:h.indexOf(V),insertAfter:!0}:{index:h.indexOf(k),insertAfter:!1}}else{const N=i(h,M,h[h.length-1]),V=t(U,N);return V?{index:h.indexOf(V),insertAfter:!0}:{index:h.length-1,insertAfter:!0}}}}}const _=c[m+1];if(_)if(_.setting){const O=l(_.setting.key,h);if(O)return{index:h.indexOf(O),insertAfter:!1}}else{const O=a(m,c);if(O){const M=l(O.setting.key,h);if(M){const k=r(h.indexOf(M),h),U=i(c,c[m],O);if(k){const N=i(h,k,M),V=t(U.reverse(),N.reverse());return V?{index:h.indexOf(V),insertAfter:!1}:{index:h.indexOf(k),insertAfter:!0}}else{const N=i(h,h[0],M),V=t(U.reverse(),N.reverse());return V?{index:h.indexOf(V),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:h.length-1,insertAfter:!0}}function y(s,c,h,m,P,_){let O;return m.index===-1?O=(0,L.setProperty)(s,[c],h,_):O=p(s,c,h,m,P,_).map(M=>(0,L.withFormatting)(s,M,_)[0]),(0,L.applyEdits)(s,O)}function p(s,c,h,m,P,_){const O=`${JSON.stringify(c)}: ${JSON.stringify(h)}`,M=(0,T.getEOL)(_,s),k=P[m.index];if(m.insertAfter){const U=[];if(k.setting)U.push({offset:k.endOffset,length:0,content:","+O});else{const N=a(m.index,P),V=r(m.index,P),$=V?.setting?.commaOffset;V&&$===void 0&&U.push({offset:V.endOffset,length:0,content:","});const G=$!==void 0&&$>k.endOffset;U.push({offset:G?$+1:k.endOffset,length:0,content:N?M+O+",":M+O})}return U}else{if(k.setting)return[{offset:k.startOffset,length:0,content:O+","}];const U=(P[m.index-1]&&!P[m.index-1].setting?M:"")+O+(a(m.index,P)?",":"")+M;return[{offset:k.startOffset,length:0,content:U}]}}function l(s,c){return c.filter(h=>h.setting?.key===s)[0]}function r(s,c){for(let h=s-1;h>=0;h--)if(c[h].setting)return c[h]}function a(s,c){for(let h=s+1;h<c.length;h++)if(c[h].setting)return c[h]}function i(s,c,h){const m=s.indexOf(c),P=s.indexOf(h);return s.filter((_,O)=>m<O&&O<P)}function t(s,c){if(s.length&&c.length){let h=0;for(;h<c.length&&h<s.length;h++)if(s[h].value!==c[h].value)return c[h-1];return c[h-1]}}function o(s){const c=[];let h=-1,m,P;const _={onObjectBegin:O=>{h++},onObjectProperty:(O,M,k)=>{h===0&&(m=M,P=O)},onObjectEnd:(O,M)=>{h--,h===0&&c.push({startOffset:m,endOffset:O+M,value:s.substring(m,O+M),setting:{key:P,commaOffset:void 0}})},onArrayBegin:(O,M)=>{h++},onArrayEnd:(O,M)=>{h--,h===0&&c.push({startOffset:m,endOffset:O+M,value:s.substring(m,O+M),setting:{key:P,commaOffset:void 0}})},onLiteralValue:(O,M,k)=>{h===0&&c.push({startOffset:m,endOffset:M+k,value:s.substring(m,M+k),setting:{key:P,commaOffset:void 0}})},onSeparator:(O,M,k)=>{if(h===0&&O===","){let U=c.length-1;for(;U>=0&&!c[U].setting;U--);const N=c[U];N&&c.splice(U,1,{startOffset:N.startOffset,endOffset:N.endOffset,value:N.value,setting:{key:N.setting.key,commaOffset:M}})}},onComment:(O,M)=>{h===0&&c.push({startOffset:O,endOffset:O+M,value:s.substring(O,O+M)})}};return(0,n.visit)(s,_),c}}),define(ne[232],ie([0,1,17,3,145,20,89,13,30,14,24,21,34,47,53,231,25]),function(J,e,D,n,L,T,A,R,b,E,I,C,f,S,u,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function g(l){return l&&l.settings&&typeof l.settings=="string"&&Object.keys(l).length===1}function w(l){const r=JSON.parse(l);return g(r)?r:{settings:l}}e.parseSettingsSyncContent=w;let y=class extends S.AbstractJsonFileSynchroniser{constructor(r,a,i,t,o,s,c,h,m,P,_,O){super(a.settingsResource,"settings",r,a,i,t,o,m,P,s,c,h,O);this.extensionManagementService=_,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.localResource=this.previewResource.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async getRemoteUserDataSyncConfiguration(r){const a=await this.getLastSyncUserData(),i=await this.getLatestRemoteUserData(r,a),t=this.getSettingsSyncContent(i),o=new A.ConfigurationModelParser(d.USER_DATA_SYNC_CONFIGURATION_SCOPE);return t?.settings&&o.parse(t.settings),o.configurationModel.getValue(d.USER_DATA_SYNC_CONFIGURATION_SCOPE)||{}}async generateSyncPreview(r,a,i){const t=await this.getLocalFileContent(),o=await this.getFormattingOptions(),s=this.getSettingsSyncContent(r);a=a===null&&i?r:a;const c=a?this.getSettingsSyncContent(a):null,h=await this.getIgnoredSettings();let m=null,P=!1,_=!1,O=!1;if(s){let k=t?t.value.toString().trim():"{}";k=k||"{}",this.validateContent(k),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const U=(0,v.merge)(k,s.settings,c?c.settings:null,h,[],o);m=U.localContent||U.remoteContent,P=U.localContent!==null,_=U.remoteContent!==null,O=U.hasConflicts}else t&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),m=t.value.toString(),_=!0);const M={content:m,localChange:P?2:0,remoteChange:_?2:0,hasConflicts:O};return[{fileContent:t,localResource:this.localResource,localContent:t?t.value.toString():null,localChange:M.localChange,remoteResource:this.remoteResource,remoteContent:s?s.settings:null,remoteChange:M.remoteChange,previewResource:this.previewResource,previewResult:M,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(r){const a=this.getSettingsSyncContent(r);if(a===null)return!0;const i=await this.getLocalFileContent(),t=i?i.value.toString().trim():"",o=await this.getIgnoredSettings(),s=await this.getFormattingOptions();return(0,v.merge)(t||"{}",a.settings,a.settings,o,[],s).remoteContent!==null}async getMergeResult(r,a){const i=await this.getFormattingOptions(),t=await this.getIgnoredSettings();return{...r.previewResult,content:r.previewResult.content?(0,v.updateIgnoredSettings)(r.previewResult.content,"{}",t,i):null}}async getAcceptResult(r,a,i,t){const o=await this.getFormattingOptions(),s=await this.getIgnoredSettings();if(this.extUri.isEqual(a,this.localResource))return{content:r.fileContent?(0,v.updateIgnoredSettings)(r.fileContent.value.toString(),"{}",s,o):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(a,this.remoteResource))return{content:r.remoteContent!==null?(0,v.updateIgnoredSettings)(r.remoteContent,r.fileContent?r.fileContent.value.toString():"{}",s,o):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(a,this.previewResource))return i===void 0?{content:r.previewResult.content,localChange:r.previewResult.localChange,remoteChange:r.previewResult.remoteChange}:{content:i!==null?(0,v.updateIgnoredSettings)(i,r.fileContent?r.fileContent.value.toString():"{}",s,o):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${a.toString()}`)}async applyResult(r,a,i,t){const{fileContent:o}=i[0][0];let{content:s,localChange:c,remoteChange:h}=i[0][1];if(c===0&&h===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),s=s?s.trim():"{}",s=s||"{}",this.validateContent(s),c!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),o&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(o.value.toString()))),await this.updateLocalFileContent(s,o,t),await this.configurationService.reloadConfiguration(2),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),h!==0){const m=await this.getFormattingOptions(),P=this.getSettingsSyncContent(r),_=await this.getIgnoredSettings(s);s=(0,v.updateIgnoredSettings)(s,P?P.settings:"{}",_,m),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),r=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(s)),t?null:r.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch{}a?.ref!==r.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(r),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const r=await this.getLocalFileContent();if(r){const a=await this.getFormattingOptions(),i=(0,u.edit)(r.value.toString(),[d.CONFIGURATION_SYNC_STORE_KEY],void 0,a);return!(0,v.isEmpty)(i)}}catch(r){if(r.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:r}){const a=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(r,"settings.json"),comparableResource:a}]}async resolveContent(r){if(this.extUri.isEqual(this.remoteResource,r)||this.extUri.isEqual(this.localResource,r)||this.extUri.isEqual(this.acceptedResource,r))return this.resolvePreviewContent(r);let a=await super.resolveContent(r);if(a)return a;if(a=await super.resolveContent(this.extUri.dirname(r)),a){const i=this.parseSyncData(a);if(i){const t=this.parseSettingsSyncContent(i.content);if(t)switch(this.extUri.basename(r)){case"settings.json":return t.settings}}}return null}async resolvePreviewContent(r){let a=await super.resolvePreviewContent(r);if(a){const i=await this.getFormattingOptions(),t=await this.getIgnoredSettings();a=(0,v.updateIgnoredSettings)(a,"{}",t,i)}return a}getSettingsSyncContent(r){return r.syncData?this.parseSettingsSyncContent(r.syncData.content):null}parseSettingsSyncContent(r){try{return w(r)}catch(a){this.logService.error(a)}return null}toSettingsSyncContent(r){return{settings:r}}async getIgnoredSettings(r){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const i=n.Event.any(n.Event.filter(this.extensionManagementService.onDidInstallExtensions,t=>t.some(({local:o})=>!!o)),n.Event.filter(this.extensionManagementService.onDidUninstallExtension,t=>!t.error))(()=>{i.dispose(),this._defaultIgnoredSettings=void 0})}const a=await this._defaultIgnoredSettings;return(0,v.getIgnoredSettings)(a,this.configurationService,r)}validateContent(r){if(this.hasErrors(r))throw new d.UserDataSyncError((0,L.localize)(0,null),"LocalInvalidContent",this.resource)}};y=de([Y(0,E.IFileService),Y(1,R.IEnvironmentService),Y(2,I.IStorageService),Y(3,d.IUserDataSyncStoreService),Y(4,d.IUserDataSyncBackupStoreService),Y(5,d.IUserDataSyncLogService),Y(6,d.IUserDataSyncUtilService),Y(7,T.IConfigurationService),Y(8,d.IUserDataSyncEnablementService),Y(9,C.ITelemetryService),Y(10,b.IExtensionManagementService),Y(11,f.IUriIdentityService)],y),e.SettingsSynchroniser=y;let p=class extends S.AbstractInitializer{constructor(r,a,i,t){super("settings",a,i,r,t)}async doInitialize(r){const a=r.syncData?this.parseSettingsSyncContent(r.syncData.content):null;if(!a){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.environmentService.settingsResource,D.VSBuffer.fromString(a.settings)),await this.updateLastSyncUserData(r)}async isEmpty(){try{const r=await this.fileService.readFile(this.environmentService.settingsResource);return(0,v.isEmpty)(r.value.toString().trim())}catch(r){return r.fileOperationResult===1}}parseSettingsSyncContent(r){try{return w(r)}catch(a){this.logService.error(a)}return null}};p=de([Y(0,E.IFileService),Y(1,R.IEnvironmentService),Y(2,d.IUserDataSyncLogService),Y(3,f.IUriIdentityService)],p),e.SettingsInitializer=p}),define(ne[233],ie([0,1,17,3,28,20,13,14,24,21,34,47,226,25]),function(J,e,D,n,L,T,A,R,b,E,I,C,f,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=void 0;let u=class extends C.AbstractSynchroniser{constructor(g,w,y,p,l,r,a,i,t,o){super("snippets",w,g,y,p,l,i,t,r,a,o);this.version=1,this.snippetsFolder=g.snippetsHome,this._register(this.fileService.watch(g.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(n.Event.filter(this.fileService.onDidFilesChange,s=>s.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(g,w,y){const p=await this.getSnippetsFileContents(),l=this.toSnippetsContents(p),r=g.syncData?this.parseSnippets(g.syncData):null;w=w===null&&y?g:w;const a=w&&w.syncData?this.parseSnippets(w.syncData):null;r?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const i=(0,f.merge)(l,r,a);return this.getResourcePreviews(i,p,r||{})}async hasRemoteChanged(g){const w=g.syncData?this.parseSnippets(g.syncData):null;if(w===null)return!0;const y=await this.getSnippetsFileContents(),p=this.toSnippetsContents(y),l=(0,f.merge)(p,w,w);return Object.keys(l.remote.added).length>0||Object.keys(l.remote.updated).length>0||l.remote.removed.length>0||l.conflicts.length>0}async getMergeResult(g,w){return g.previewResult}async getAcceptResult(g,w,y,p){if(this.extUri.isEqualOrParent(w,this.syncPreviewFolder.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:g.fileContent?g.fileContent.value.toString():null,localChange:0,remoteChange:g.fileContent?g.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(w,this.syncPreviewFolder.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:g.remoteContent,localChange:g.remoteContent!==null?g.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(w,this.syncPreviewFolder))return y===void 0?{content:g.previewResult.content,localChange:g.previewResult.localChange,remoteChange:g.previewResult.remoteChange}:{content:y,localChange:y===null?g.fileContent!==null?3:0:2,remoteChange:y===null?g.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${w.toString()}`)}async applyResult(g,w,y,p){const l=y.map(([r,a])=>({...r,acceptResult:a}));l.every(({localChange:r,remoteChange:a})=>r===0&&a===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),l.some(({localChange:r})=>r!==0)&&(await this.updateLocalBackup(l),await this.updateLocalSnippets(l,p)),l.some(({remoteChange:r})=>r!==0)&&(g=await this.updateRemoteSnippets(l,g,p)),w?.ref!==g.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(g),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:r}of l)try{await this.fileService.del(r)}catch{}}getResourcePreviews(g,w,y){const p=new Map;for(const l of Object.keys(g.local.added)){const r={content:g.local.added[l],hasConflicts:!1,localChange:1,remoteChange:0};p.set(l,{fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:y[l],previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of Object.keys(g.local.updated)){const r={content:g.local.updated[l],hasConflicts:!1,localChange:2,remoteChange:0};p.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[l],localContent:w[l].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:y[l],previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of g.local.removed){const r={content:null,hasConflicts:!1,localChange:3,remoteChange:0};p.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[l],localContent:w[l].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of Object.keys(g.remote.added)){const r={content:g.remote.added[l],hasConflicts:!1,localChange:0,remoteChange:1};p.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[l],localContent:w[l].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of Object.keys(g.remote.updated)){const r={content:g.remote.updated[l],hasConflicts:!1,localChange:0,remoteChange:2};p.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[l],localContent:w[l].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:y[l],previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of g.remote.removed){const r={content:null,hasConflicts:!1,localChange:0,remoteChange:3};p.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:y[l],previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of g.conflicts){const r={content:w[l]?w[l].value.toString():null,hasConflicts:!0,localChange:w[l]?2:1,remoteChange:y[l]?2:1};p.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[l]||null,localContent:w[l]?w[l].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:y[l]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of Object.keys(w))if(!p.has(l)){const r={content:w[l]?w[l].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0};p.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[l]||null,localContent:w[l]?w[l].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:y[l]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...p.values()]}async getAssociatedResources({uri:g}){let w=await super.resolveContent(g);if(w){const y=this.parseSyncData(w);if(y){const p=this.parseSnippets(y),l=[];for(const r of Object.keys(p)){const a=this.extUri.joinPath(g,r),i=this.extUri.joinPath(this.snippetsFolder,r),t=await this.fileService.exists(i);l.push({resource:a,comparableResource:t?i:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"})})}return l}}return[]}async resolveContent(g){if(this.extUri.isEqualOrParent(g,this.syncPreviewFolder.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(g,this.syncPreviewFolder.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(g,this.syncPreviewFolder.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})))return this.resolvePreviewContent(g);let w=await super.resolveContent(g);if(w)return w;if(w=await super.resolveContent(this.extUri.dirname(g)),w){const y=this.parseSyncData(w);if(y)return this.parseSnippets(y)[this.extUri.basename(g)]||null}return null}async hasLocalData(){try{const g=await this.getSnippetsFileContents();if(Object.keys(g).length)return!0}catch{}return!1}async updateLocalBackup(g){const w={};for(const y of g)y.fileContent&&(w[this.extUri.basename(y.localResource)]=y.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(w)))}async updateLocalSnippets(g,w){for(const{fileContent:y,acceptResult:p,localResource:l,remoteResource:r,localChange:a}of g)if(a!==0){const i=r?this.extUri.basename(r):this.extUri.basename(l),t=this.extUri.joinPath(this.snippetsFolder,i);a===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(t)),await this.fileService.del(t),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(t))):a===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(t)),await this.fileService.createFile(t,D.VSBuffer.fromString(p.content),{overwrite:w}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(t))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(t)),await this.fileService.writeFile(t,D.VSBuffer.fromString(p.content),w?void 0:y),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(t)))}}async updateRemoteSnippets(g,w,y){const p=w.syncData?this.parseSnippets(w.syncData):{},l=(0,L.deepClone)(p);for(const{acceptResult:r,localResource:a,remoteResource:i,remoteChange:t}of g)if(t!==0){const o=a?this.extUri.basename(a):this.extUri.basename(i);t===3?delete l[o]:l[o]=r.content}return(0,f.areSame)(p,l)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),w=await this.updateRemoteUserData(JSON.stringify(l),y?null:w.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),w}parseSnippets(g){return JSON.parse(g.content)}toSnippetsContents(g){const w={};for(const y of Object.keys(g))w[y]=g[y].value.toString();return w}async getSnippetsFileContents(){const g={};let w;try{w=await this.fileService.resolve(this.snippetsFolder)}catch(y){if(y instanceof R.FileOperationError&&y.fileOperationResult===1)return g;throw y}for(const y of w.children||[]){const p=y.resource,l=this.extUri.extname(p);if(l===".json"||l===".code-snippets"){const r=this.extUri.relativePath(this.snippetsFolder,p),a=await this.fileService.readFile(p);g[r]=a}}return g}};u=de([Y(0,A.IEnvironmentService),Y(1,R.IFileService),Y(2,b.IStorageService),Y(3,S.IUserDataSyncStoreService),Y(4,S.IUserDataSyncBackupStoreService),Y(5,S.IUserDataSyncLogService),Y(6,T.IConfigurationService),Y(7,S.IUserDataSyncEnablementService),Y(8,E.ITelemetryService),Y(9,I.IUriIdentityService)],u),e.SnippetsSynchroniser=u;let v=class extends C.AbstractInitializer{constructor(g,w,y,p){super("snippets",w,y,g,p)}async doInitialize(g){const w=g.syncData?JSON.parse(g.syncData.content):null;if(!w){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const p of Object.keys(w)){const l=w[p];if(l){const r=this.extUri.joinPath(this.environmentService.snippetsHome,p);await this.fileService.createFile(r,D.VSBuffer.fromString(l)),this.logService.info("Created snippet",this.extUri.basename(r))}}await this.updateLastSyncUserData(g)}async isEmpty(){try{return!(await this.fileService.resolve(this.environmentService.snippetsHome)).children?.length}catch(g){return g.fileOperationResult===1}}};v=de([Y(0,R.IFileService),Y(1,A.IEnvironmentService),Y(2,S.IUserDataSyncLogService),Y(3,I.IUriIdentityService)],v),e.SnippetsInitializer=v}),define(ne[64],ie([0,1,3,2,6,25]),function(J,e,D,n,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,L.createDecorator)("IUserDataSyncAccountService");let A=class extends n.Disposable{constructor(b,E){super();this.userDataSyncStoreService=b,this.logService=E,this._onDidChangeAccount=this._register(new D.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new D.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(b.onTokenFailed(()=>{this.logService.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.wasTokenFailed),this.updateAccount(void 0),this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(b.onTokenSucceed(()=>this.wasTokenFailed=!1))}get account(){return this._account}async updateAccount(b){(b&&this._account?b.token!==this._account.token||b.authenticationProviderId!==this._account.authenticationProviderId:b!==this._account)&&(this._account=b,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(b))}};A=de([Y(0,T.IUserDataSyncStoreService),Y(1,T.IUserDataSyncLogService)],A),e.UserDataSyncAccountService=A}),define(ne[234],ie([0,1,5,17,57,2,19,20,13,14,25]),function(J,e,D,n,L,T,A,R,b,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let C=class extends T.Disposable{constructor(S,u,v,d){super();this.environmentService=S,this.fileService=u,this.configurationService=v,this.logService=d,I.ALL_SYNC_RESOURCES.forEach(g=>this.cleanUpBackup(g))}async getAllRefs(S){const u=(0,A.joinPath)(this.environmentService.userDataSyncHome,S),v=await this.fileService.resolve(u);return v.children?v.children.filter(g=>g.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(g.name)).sort().reverse().map(g=>({ref:g.name,created:this.getCreationTime(g)})):[]}async resolveContent(S,u){if(!u){const v=await this.getAllRefs(S);v.length&&(u=v[v.length-1].ref)}if(u){const v=(0,A.joinPath)(this.environmentService.userDataSyncHome,S,u);return(await this.fileService.readFile(v)).value.toString()}return null}async backup(S,u){const v=(0,A.joinPath)(this.environmentService.userDataSyncHome,S),d=(0,A.joinPath)(v,`${(0,L.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(d,n.VSBuffer.fromString(u))}catch(g){this.logService.error(g)}try{this.cleanUpBackup(S)}catch{}}async cleanUpBackup(S){const u=(0,A.joinPath)(this.environmentService.userDataSyncHome,S);try{try{if(!await this.fileService.exists(u))return}catch{return}const v=await this.fileService.resolve(u);if(v.children){const d=v.children.filter(p=>p.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(p.name)).sort(),g=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let w=d.filter(p=>Date.now()-this.getCreationTime(p)>g);const y=d.length-w.length;y<10&&(w=w.slice(10-y)),await D.Promises.settled(w.map(async p=>{this.logService.info("Deleting from backup",p.resource.path),await this.fileService.del(p.resource)}))}}catch(v){this.logService.error(v)}}getCreationTime(S){return S.ctime||new Date(parseInt(S.name.substring(0,4)),parseInt(S.name.substring(4,6))-1,parseInt(S.name.substring(6,8)),parseInt(S.name.substring(9,11)),parseInt(S.name.substring(11,13)),parseInt(S.name.substring(13,15))).getTime()}};C=de([Y(0,b.IEnvironmentService),Y(1,E.IFileService),Y(2,R.IConfigurationService),Y(3,I.IUserDataSyncLogService)],C),e.UserDataSyncBackupStoreService=C}),define(ne[235],ie([0,1,3,2,4,13,24,21,25]),function(J,e,D,n,L,T,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncEnablementService=void 0;const E="sync.enable";let I=class extends n.Disposable{constructor(f,S,u,v){super();this.storageService=f,this.telemetryService=S,this.environmentService=u,this.userDataSyncStoreManagementService=v,this._onDidChangeEnablement=new D.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._onDidChangeResourceEnablement=new D.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(f.onDidChangeValue(d=>this.onDidStorageChange(d)))}isEnabled(){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(E,0,!1)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(f){f&&!this.canToggleEnablement()||(this.telemetryService.publicLog2(E,{enabled:f}),this.storageService.store(E,f,0,1))}isResourceEnabled(f){return this.storageService.getBoolean((0,b.getEnablementKey)(f),0,!0)}setResourceEnablement(f,S){if(this.isResourceEnabled(f)!==S){const u=(0,b.getEnablementKey)(f);this.telemetryService.publicLog2(u,{enabled:S}),this.storeResourceEnablement(u,S)}}getResourceSyncStateVersion(f){}storeResourceEnablement(f,S){this.storageService.store(f,S,0,L.isWeb?0:1)}onDidStorageChange(f){if(f.scope!==0)return;if(E===f.key){this._onDidChangeEnablement.fire(this.isEnabled());return}const S=b.ALL_SYNC_RESOURCES.filter(u=>(0,b.getEnablementKey)(u)===f.key)[0];if(S){this._onDidChangeResourceEnablement.fire([S,this.isResourceEnabled(S)]);return}}};I=de([Y(0,A.IStorageService),Y(1,R.ITelemetryService),Y(2,T.IEnvironmentService),Y(3,b.IUserDataSyncStoreManagementService)],I),e.UserDataSyncEnablementService=I}),define(ne[236],ie([0,1,2,7]),function(J,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class L{constructor(f){this.service=f}listen(f,S){switch(S){case"onError":return this.service.onError}throw new Error(`Event not found: ${S}`)}call(f,S,u){switch(S){case"triggerSync":return this.service.triggerSync(u[0],u[1],u[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(u[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=L;class T{constructor(f){this.service=f}listen(f,S){throw new Error(`Event not found: ${S}`)}call(f,S,u){switch(S){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(u[0]);case"resolveFormattingOptions":return this.service.resolveFormattingOptions(n.URI.revive(u[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=T;class A{constructor(f){this.channel=f}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(f){return this.channel.call("resolveUserKeybindings",[f])}async resolveFormattingOptions(f){return this.channel.call("resolveFormattingOptions",[f])}}e.UserDataSyncUtilServiceClient=A;class R{constructor(f){this.service=f}listen(f,S){switch(S){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${S}`)}async call(f,S,u){switch(S){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(u[0],u[1]);case"setEnablement":return this.service.setEnablement(u[0],u[1])}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=R;class b{constructor(f){this.service=f}listen(f,S){switch(S){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${S}`)}call(f,S,u){switch(S){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(u)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=b;class E{constructor(f){this.service=f}listen(f,S){switch(S){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${S}`)}call(f,S,u){switch(S){case"switch":return this.service.switch(u[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=E;class I extends D.Disposable{constructor(f){super();this.channel=f,this.onDidChangeUserDataSyncStore=this.channel.listen("onDidChangeUserDataSyncStore")}async switch(f){return this.channel.call("switch",[f])}async getPreviousUserDataSyncStore(){const f=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(f)}revive(f){return{url:n.URI.revive(f.url),type:f.type,defaultUrl:n.URI.revive(f.defaultUrl),insidersUrl:n.URI.revive(f.insidersUrl),stableUrl:n.URI.revive(f.stableUrl),canSwitch:f.canSwitch,authenticationProviders:f.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=I}),define(ne[237],ie([0,1,13,8]),function(J,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let L=class extends n.AbstractLogger{constructor(A,R){super();this.logger=this._register(A.createLogger(R.userDataSyncLogResource,{name:"settingssync"}))}trace(A,...R){this.logger.trace(A,...R)}debug(A,...R){this.logger.debug(A,...R)}info(A,...R){this.logger.info(A,...R)}warn(A,...R){this.logger.warn(A,...R)}error(A,...R){this.logger.error(A,...R)}critical(A,...R){this.logger.critical(A,...R)}flush(){this.logger.flush()}};L=de([Y(0,n.ILoggerService),Y(1,D.IEnvironmentService)],L),e.UserDataSyncLogService=L}),define(ne[65],ie([0,1,3,2,4,27,148,13,14,6,26,46,24,25]),function(J,e,D,n,L,T,A,R,b,E,I,C,f,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.isWebPlatform=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,E.createDecorator)("IUserDataSyncMachinesService");const u="sync.currentMachineName",v="Safari",d="Chrome",g="Edge",w="Firefox",y="Android";function p(a){switch(a){case v:case d:case g:case w:case y:case(0,L.PlatformToString)(0):return!0}return!1}e.isWebPlatform=p;function l(){return L.isSafari?v:L.isChrome?d:L.isEdge?g:L.isFirefox?w:L.isAndroid?y:(0,L.PlatformToString)(L.isWeb?0:L.platform)}let r=class Ze extends n.Disposable{constructor(i,t,o,s,c,h){super();this.storageService=o,this.userDataSyncStoreService=s,this.logService=c,this.productService=h,this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,C.getServiceMachineId)(i,t,o)}async getMachines(i){const t=await this.currentMachineIdPromise;return(await this.readMachinesData(i)).machines.map(s=>({...s,isCurrent:s.id===t}))}async addCurrentMachine(i){const t=await this.currentMachineIdPromise,o=await this.readMachinesData(i);o.machines.some(({id:s})=>s===t)||(o.machines.push({id:t,name:this.computeCurrentMachineName(o.machines),platform:l()}),await this.writeMachinesData(o))}async removeCurrentMachine(i){const t=await this.currentMachineIdPromise,o=await this.readMachinesData(i),s=o.machines.filter(({id:c})=>c!==t);s.length!==o.machines.length&&(o.machines=s,await this.writeMachinesData(o))}async renameMachine(i,t,o){const s=await this.readMachinesData(o),c=s.machines.find(({id:h})=>h===i);if(c){c.name=t,await this.writeMachinesData(s);const h=await this.currentMachineIdPromise;i===h&&this.storageService.store(u,t,0,1)}}async setEnablement(i,t){const o=await this.readMachinesData(),s=o.machines.find(({id:c})=>c===i);s&&(s.disabled=t?void 0:!0,await this.writeMachinesData(o))}computeCurrentMachineName(i){const t=this.storageService.get(u,0);if(t)return t;const o=`${this.productService.embedderIdentifier?`${this.productService.embedderIdentifier} - `:""}${l()} (${this.productService.nameShort})`,s=new RegExp(`${(0,T.escapeRegExpCharacters)(o)}\\s#(\\d+)`);let c=0;for(const h of i){const m=s.exec(h.name),P=m?parseInt(m[1]):0;c=P>c?P:c}return`${o} #${c+1}`}async readMachinesData(i){this.userData=await this.readUserData(i);const t=this.parse(this.userData);if(t.version!==Ze.VERSION)throw new Error((0,A.localize)(0,null,this.productService.nameLong));return t}async writeMachinesData(i){const t=JSON.stringify(i),o=await this.userDataSyncStoreService.write(Ze.RESOURCE,t,this.userData?.ref||null);this.userData={ref:o,content:t},this._onDidChange.fire()}async readUserData(i){if(this.userData){const t=i&&i.latest?i.latest[Ze.RESOURCE]:void 0;if(this.userData.ref===t)return this.userData;if(t===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.read(Ze.RESOURCE,this.userData)}parse(i){if(i.content!==null)try{return JSON.parse(i.content)}catch(t){this.logService.error(t)}return{version:Ze.VERSION,machines:[]}}};r.VERSION=1,r.RESOURCE="machines",r=de([Y(0,R.IEnvironmentService),Y(1,b.IFileService),Y(2,f.IStorageService),Y(3,S.IUserDataSyncStoreService),Y(4,S.IUserDataSyncLogService),Y(5,I.IProductService)],r),e.UserDataSyncMachinesService=r}),define(ne[238],ie([0,1,5,57,37,9,3,2,4,19,7,146,26,24,21,25,64,65]),function(J,e,D,n,L,T,A,R,b,E,I,C,f,S,u,v,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;const w="sync.disableMachineEventually",y="sync.sessionId",p="sync.storeUrl",l="sync.productQuality";let r=class extends R.Disposable{constructor(t,o,s,c,h,m,P,_,O,M){super();this.userDataSyncStoreManagementService=o,this.userDataSyncStoreService=s,this.userDataSyncEnablementService=c,this.userDataSyncService=h,this.logService=m,this.userDataSyncAccountService=P,this.telemetryService=_,this.userDataSyncMachinesService=O,this.storageService=M,this.autoSync=this._register(new R.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this._onError=this._register(new A.Emitter),this.onError=this._onError.event,this.sources=[],this.syncTriggerDelayer=this._register(new D.Delayer(0)),this.lastSyncUrl=this.syncUrl,this.syncUrl=o.userDataSyncStore?.url,this.previousProductQuality=this.productQuality,this.productQuality=t.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(o.onDidChangeUserDataSyncStore(()=>{(0,E.isEqual)(this.syncUrl,o.userDataSyncStore?.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=o.userDataSyncStore?.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(P.onDidChangeAccount(()=>this.updateAutoSync())),this._register(s.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(A.Event.debounce(h.onDidChangeLocal,(k,U)=>k?[...k,U]:[U],1e3)(k=>this.triggerSync(k,!1,!1))),this._register(A.Event.filter(this.userDataSyncEnablementService.onDidChangeResourceEnablement,([,k])=>k)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}get syncUrl(){const t=this.storageService.get(p,0);return t?I.URI.parse(t):void 0}set syncUrl(t){t?this.storageService.store(p,t.toString(),0,1):this.storageService.remove(p,0)}get productQuality(){return this.storageService.get(l,0)}set productQuality(t){t?this.storageService.store(l,t,0,1):this.storageService.remove(l,0)}updateAutoSync(){const{enabled:t,message:o}=this.isAutoSyncEnabled();t?this.autoSync.value===void 0&&(this.autoSync.value=new a(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(s=>this.onDidFinishSync(s))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(o&&this.logService.info(o),this.autoSync.clear()):o&&this.userDataSyncEnablementService.isEnabled()&&this.logService.info(o))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,n.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(t,o,s){try{this.userDataSyncAccountService.account&&!s&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(y,0),t?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(c){if(o)this.logService.error(c),this.updateEnablement(!1);else throw c}}updateEnablement(t){this.userDataSyncEnablementService.isEnabled()!==t&&(this.userDataSyncEnablementService.setEnablement(t),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(t){if(!t){this.successiveFailures=0;return}const o=v.UserDataSyncError.toUserDataSyncError(t);o instanceof v.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:o.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),o.code==="SessionExpired"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):o.code==="TurnedOff"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):o.code==="LocalTooManyRequests"||o.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):o.code==="UpgradeRequired"||o.code==="Gone"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):o.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${o.resource} content with newer version than of client. Requires client upgrade.`)):o.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${o.resource} content with older version than of client. Requires server reset.`)):o.code==="ServiceChanged"||o.code==="DefaultServiceChanged"?b.isWeb&&o.code==="DefaultServiceChanged"&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(o),this.successiveFailures++),this._onError.fire(o)}async disableMachineEventually(){this.storageService.store(w,!0,0,1),await(0,D.timeout)(1e3*60*10),!!this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(w,0,!1)}stopDisableMachineEventually(){this.storageService.remove(w,0)}async triggerSync(t,o,s){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(o&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...t),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources),this.telemetryService.publicLog2("sync/triggered",{sources:this.sources}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",s)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 1e3}};r=de([Y(0,f.IProductService),Y(1,v.IUserDataSyncStoreManagementService),Y(2,v.IUserDataSyncStoreService),Y(3,v.IUserDataSyncEnablementService),Y(4,v.IUserDataSyncService),Y(5,v.IUserDataSyncLogService),Y(6,d.IUserDataSyncAccountService),Y(7,u.ITelemetryService),Y(8,g.IUserDataSyncMachinesService),Y(9,S.IStorageService)],r),e.UserDataAutoSyncService=r;class a extends R.Disposable{constructor(t,o,s,c,h,m,P,_){super();this.lastSyncUrl=t,this.interval=o,this.userDataSyncStoreManagementService=s,this.userDataSyncStoreService=c,this.userDataSyncService=h,this.userDataSyncMachinesService=m,this.logService=P,this.storageService=_,this.intervalHandler=this._register(new R.MutableDisposable),this._onDidStartSync=this._register(new A.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new A.Emitter),this.onDidFinishSync=this._onDidFinishSync.event,this.manifest=null}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,R.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask&&this.syncTask.stop(),this.logService.info("Auto Sync: Stopped")})),this.logService.info("Auto Sync: Started"),this.sync(a.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,D.disposableTimeout)(()=>this.sync(a.INTERVAL_SYNCING,!1),this.interval)}sync(t,o){const s=(0,D.createCancelablePromise)(async c=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(h){if((0,T.isCancellationError)(h))return}return this.doSync(t,o,c)});return this.syncPromise=s,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){return this.lastSyncUrl!==void 0&&!(0,E.isEqual)(this.lastSyncUrl,this.userDataSyncStoreManagementService.userDataSyncStore?.url)}async hasDefaultServiceChanged(){const t=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),o=this.userDataSyncStoreManagementService.userDataSyncStore;return!!o&&!!t&&(!(0,E.isEqual)(o.defaultUrl,t.defaultUrl)||!(0,E.isEqual)(o.insidersUrl,t.insidersUrl)||!(0,E.isEqual)(o.stableUrl,t.stableUrl))}async doSync(t,o,s){this.logService.info(`Auto Sync: Triggered by ${t}`),this._onDidStartSync.fire();let c;try{if(this.syncTask=await this.userDataSyncService.createSyncTask(this.manifest,o),s.isCancellationRequested)return;if(this.manifest=this.syncTask.manifest,this.manifest===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new v.UserDataAutoSyncError((0,C.localize)(0,null),"DefaultServiceChanged"):new v.UserDataAutoSyncError((0,C.localize)(1,null),"ServiceChanged"):new v.UserDataAutoSyncError((0,C.localize)(2,null),"TurnedOff");const h=this.storageService.get(y,0);if(h&&this.manifest&&h!==this.manifest.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new v.UserDataAutoSyncError((0,C.localize)(3,null),"DefaultServiceChanged"):new v.UserDataAutoSyncError((0,C.localize)(4,null),"ServiceChanged"):new v.UserDataAutoSyncError((0,C.localize)(5,null),"SessionExpired");const m=await this.userDataSyncMachinesService.getMachines(this.manifest||void 0);if(s.isCancellationRequested)return;const P=m.find(_=>_.isCurrent);if(P?.disabled)throw new v.UserDataAutoSyncError((0,C.localize)(6,null),"TurnedOff");if(await this.syncTask.run(),this.manifest===null)try{this.manifest=await this.userDataSyncStoreService.manifest(null)}catch(_){throw new v.UserDataAutoSyncError((0,L.toErrorMessage)(_),_ instanceof v.UserDataSyncError?_.code:"Unknown")}if(this.manifest&&this.manifest.session!==h&&this.storageService.store(y,this.manifest.session,0,1),s.isCancellationRequested)return;P||await this.userDataSyncMachinesService.addCurrentMachine(this.manifest||void 0)}catch(h){this.logService.error(h),c=h}this._onDidFinishSync.fire(c)}register(t){return super._register(t)}}a.INTERVAL_SYNCING="Interval"}),define(ne[239],ie([0,1,16,5,37,3,2,19,15,29,20,30,6,24,21,227,229,230,232,233,25]),function(J,e,D,n,L,T,A,R,b,E,I,C,f,S,u,v,d,g,w,y,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const l="sync.lastSyncTime";let r=class extends A.Disposable{constructor(s,c,h,m,P,_,O,M){super();this.userDataSyncStoreService=s,this.userDataSyncStoreManagementService=c,this.instantiationService=h,this.configurationService=m,this.logService=P,this.telemetryService=_,this.storageService=O,this.userDataSyncEnablementService=M,this._status="uninitialized",this._onDidChangeStatus=this._register(new T.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._onDidChangeLocal=this._register(new T.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new T.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new T.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new T.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new T.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new T.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.synchronizers=this._register(new A.MutableDisposable),this.updateStatus([]),this._lastSyncTime=this.storageService.getNumber(l,0,void 0)}get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}async createSyncTask(s,c){this.checkEnablement();const h=(0,E.generateUuid)();try{const M=(0,p.createSyncHeaders)(h);c&&(M["Cache-Control"]="no-cache"),s=await this.userDataSyncStoreService.manifest(s,M)}catch(M){const k=p.UserDataSyncError.toUserDataSyncError(M);throw this.reportUserDataSyncError(k,h),k}let m=!1;const P=this,_=this.getEnabledSynchronizers();let O;return{manifest:s,async run(){if(m)throw new Error("Can run a task only once");return O=(0,n.createCancelablePromise)(M=>P.sync(_,s,h,M)),O.finally(()=>O=void 0)},async stop(){if(O&&O.cancel(),P.status!=="idle")return P.stop(_)}}}async createManualSyncTask(){if(this.checkEnablement(),this.userDataSyncEnablementService.isEnabled())throw new p.UserDataSyncError("Cannot start manual sync when sync is enabled","LocalError");const s=(0,E.generateUuid)(),c=(0,p.createSyncHeaders)(s);let h;try{h=await this.userDataSyncStoreService.manifest(null,c)}catch(P){const _=p.UserDataSyncError.toUserDataSyncError(P);throw this.reportUserDataSyncError(_,s),_}await this.resetLocal();const m=this.getEnabledSynchronizers();return new a(s,h,c,m,()=>this.resetLocal(),this.configurationService,this.logService)}async sync(s,c,h,m){if(m.isCancellationRequested||!s.length)return;const P=new Date().getTime();this._syncErrors=[];try{this.logService.trace("Sync started."),this.status!=="hasConflicts"&&this.setStatus("syncing");const _=(0,p.createSyncHeaders)(h);for(const O of s){if(m.isCancellationRequested||!this.userDataSyncEnablementService.isResourceEnabled(O.resource))return;try{await O.sync(c,_)}catch(M){let k=!1;if(M instanceof p.UserDataSyncError)switch(M.code){case"TooLarge":M=new p.UserDataSyncError(M.message,M.code,O.resource),k=!0;break;case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":k=!0;break}const U=p.UserDataSyncError.toUserDataSyncError(M);if(this.reportUserDataSyncError(U,h),k)throw U;this.logService.error(M),this.logService.error(`${O.resource}: ${(0,L.toErrorMessage)(M)}`),this._syncErrors.push([O.resource,U])}}this.logService.info(`Sync done. Took ${new Date().getTime()-P}ms`),this.updateLastSyncTime()}catch(_){const O=p.UserDataSyncError.toUserDataSyncError(_);throw this.reportUserDataSyncError(O,h),O}finally{this.updateStatus(s),this._onSyncErrors.fire(this._syncErrors)}}async stop(s){if(this.status!=="idle")for(const c of s)try{c.status!=="idle"&&await c.stop()}catch(h){this.logService.error(h)}}async replace(s){this.checkEnablement(),await this.performSynchronizerAction(async c=>{if(await c.replace(s))return!0})}async accept(s,c,h,m){this.checkEnablement(),await this.performSynchronizerAction(async P=>{if(P.resource===s)return await P.accept(c,h),m&&await P.apply(!1,(0,p.createSyncHeaders)((0,E.generateUuid)())),!0})}async resolveContent(s){return this.performSynchronizerAction(async c=>{const h=await c.resolveContent(s);if(h)return h})}async getRemoteSyncResourceHandles(s){return await this.performSynchronizerAction(async h=>{if(h.resource===s)return h.getRemoteSyncResourceHandles()})||[]}async getLocalSyncResourceHandles(s){return await this.performSynchronizerAction(async h=>{if(h.resource===s)return h.getLocalSyncResourceHandles()})||[]}async getAssociatedResources(s,c){return await this.performSynchronizerAction(async m=>{if(m.resource===s)return m.getAssociatedResources(c)})||[]}async getMachineId(s,c){return await this.performSynchronizerAction(async m=>{if(m.resource===s)return await m.getMachineId(c)||null})||void 0}async hasLocalData(){return!!await this.performSynchronizerAction(async c=>{if(c.resource!=="globalState"&&await c.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.performSynchronizerAction(async c=>{if(await c.hasPreviouslySynced())return!0})}async reset(){this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(s){this.logService.error(s)}this._onDidResetRemote.fire()}async resetLocal(){if(this.checkEnablement(),this.storageService.remove(l,0),this.synchronizers.value){for(const s of this.synchronizers.value.enabled)try{await s.resetLocal()}catch(c){this.logService.error(`${s.resource}: ${(0,L.toErrorMessage)(c)}`),this.logService.error(c)}this.synchronizers.value=void 0}this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async performSynchronizerAction(s){const c=new A.DisposableStore;try{const h=this.synchronizers.value||c.add(this.instantiationService.createInstance(i,()=>{},()=>{},()=>{})),m=[...h.enabled,...h.disabled.map(P=>c.add(h.createSynchronizer(P)))];for(const P of m){const _=await s(P);if(!(0,b.isUndefined)(_))return _}return null}finally{c.dispose()}}setStatus(s){const c=this._status;this._status!==s&&(this._status=s,this._onDidChangeStatus.fire(s),c==="hasConflicts"&&this.updateLastSyncTime())}updateStatus(s){this.updateConflicts(s);const c=this.computeStatus(s);this.setStatus(c)}updateConflicts(s){const c=this.computeConflicts(s);(0,D.equals)(this._conflicts,c,([h,m],[P,_])=>h===h&&(0,D.equals)(m,_,(O,M)=>(0,R.isEqual)(O.previewResource,M.previewResource)))||(this._conflicts=this.computeConflicts(s),this._onDidChangeConflicts.fire(c))}computeConflicts(s){return s.filter(c=>c.status==="hasConflicts").map(c=>[c.resource,c.conflicts.map(t)])}computeStatus(s){return this.userDataSyncStoreManagementService.userDataSyncStore?s.some(c=>c.status==="hasConflicts")?"hasConflicts":s.some(c=>c.status==="syncing")?"syncing":"idle":"uninitialized"}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(l,this._lastSyncTime,0,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}reportUserDataSyncError(s,c){this.telemetryService.publicLog2("sync/error",{code:s.code,serverCode:s instanceof p.UserDataSyncStoreError?String(s.serverCode):void 0,url:s instanceof p.UserDataSyncStoreError?s.url:void 0,resource:s.resource,executionId:c,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()})}getEnabledSynchronizers(){return this.synchronizers.value||(this.synchronizers.value=this.instantiationService.createInstance(i,s=>this.updateStatus(s),s=>this.updateConflicts(s),s=>this._onDidChangeLocal.fire(s))),this.synchronizers.value.enabled}checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};r=de([Y(0,p.IUserDataSyncStoreService),Y(1,p.IUserDataSyncStoreManagementService),Y(2,f.IInstantiationService),Y(3,I.IConfigurationService),Y(4,p.IUserDataSyncLogService),Y(5,u.ITelemetryService),Y(6,S.IStorageService),Y(7,p.IUserDataSyncEnablementService)],r),e.UserDataSyncService=r;class a extends A.Disposable{constructor(s,c,h,m,P,_,O){super();this.id=s,this.manifest=c,this.syncHeaders=h,this.synchronisers=m,this.onStop=P,this.configurationService=_,this.logService=O,this.synchronizingResources=[],this._onSynchronizeResources=this._register(new T.Emitter),this.onSynchronizeResources=this._onSynchronizeResources.event,this.isDisposed=!1}get status(){return this.synchronisers.some(s=>s.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(s=>s.status==="syncing")?"syncing":"idle"}async preview(){try{if(this.isDisposed)throw new Error("Disposed");return this.previewsPromise||(this.previewsPromise=(0,n.createCancelablePromise)(s=>this.getPreviews(s))),this.previews||(this.previews=await this.previewsPromise),this.previews}catch(s){throw this.logService.error(s),s}}async accept(s,c){try{return await this.performAction(s,h=>h.accept(s,c))}catch(h){throw this.logService.error(h),h}}async merge(s){try{return s?await this.performAction(s,c=>c.merge(s)):await this.mergeAll()}catch(c){throw this.logService.error(c),c}}async discard(s){try{return await this.performAction(s,c=>c.discard(s))}catch(c){throw this.logService.error(c),c}}async discardConflicts(){try{if(!this.previews)throw new Error("Missing preview. Create preview and try again.");if(this.synchronizingResources.length)throw new Error("Cannot discard while synchronizing resources");const s=[];for(const[,c]of this.previews)for(const h of c.resourcePreviews)h.mergeState==="conflict"&&s.push(h.previewResource);for(const c of s)await this.discard(c);return this.previews}catch(s){throw this.logService.error(s),s}}async apply(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");const s=[];for(const[c,h]of this.previews){this.synchronizingResources.push([c,h.resourcePreviews.map(_=>_.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const m=this.synchronisers.find(_=>_.resource===c);for(const _ of h.resourcePreviews)(_.localChange!==0||_.remoteChange!==0)&&_.mergeState==="preview"&&await m.merge(_.previewResource);const P=await m.apply(!1,this.syncHeaders);P&&s.push(this.toSyncResourcePreview(m.resource,P)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(_=>_[0]===c),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=s,this.previews}catch(s){throw this.logService.error(s),s}}async pull(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[s,c]of this.previews){this.synchronizingResources.push([s,c.resourcePreviews.map(m=>m.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const h=this.synchronisers.find(m=>m.resource===s);for(const m of c.resourcePreviews)await h.accept(m.remoteResource);await h.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(m=>m[0]===s),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(s){throw this.logService.error(s),s}}async push(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[s,c]of this.previews){this.synchronizingResources.push([s,c.resourcePreviews.map(m=>m.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const h=this.synchronisers.find(m=>m.resource===s);for(const m of c.resourcePreviews)await h.accept(m.localResource);await h.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(m=>m[0]===s),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(s){throw this.logService.error(s),s}}async stop(){await this.onStop(),this.reset()}async performAction(s,c){if(!this.previews)throw new Error("Missing preview. Create preview and try again.");const h=this.previews.findIndex(([,N])=>N.resourcePreviews.some(({localResource:V,previewResource:$,remoteResource:G})=>(0,R.isEqual)(s,V)||(0,R.isEqual)(s,$)||(0,R.isEqual)(s,G)));if(h===-1)return this.previews;const[m,P]=this.previews[h],_=P.resourcePreviews.find(({localResource:N,remoteResource:V,previewResource:$})=>(0,R.isEqual)(N,s)||(0,R.isEqual)(V,s)||(0,R.isEqual)($,s));if(!_)return this.previews;let O=this.synchronizingResources.find(N=>N[0]===m);O||(O=[m,[]],this.synchronizingResources.push(O)),O[1].some(N=>(0,R.isEqual)(N,_.localResource))||(O[1].push(_.localResource),this._onSynchronizeResources.fire(this.synchronizingResources));const M=this.synchronisers.find(N=>N.resource===this.previews[h][0]),k=await c(M);k?this.previews.splice(h,1,this.toSyncResourcePreview(M.resource,k)):this.previews.splice(h,1);const U=this.synchronizingResources.findIndex(N=>N[0]===m);return this.synchronizingResources[U][1].splice(O[1].findIndex(N=>(0,R.isEqual)(N,_.localResource)),1),O[1].length||(this.synchronizingResources.splice(U,1),this._onSynchronizeResources.fire(this.synchronizingResources)),this.previews}async mergeAll(){if(!this.previews)throw new Error("You need to create preview before merging or applying");if(this.synchronizingResources.length)throw new Error("Cannot merge or apply while synchronizing resources");const s=[];for(const[c,h]of this.previews){this.synchronizingResources.push([c,h.resourcePreviews.map(_=>_.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const m=this.synchronisers.find(_=>_.resource===c);let P=h;for(const _ of h.resourcePreviews)(_.localChange!==0||_.remoteChange!==0)&&_.mergeState==="preview"&&(P=await m.merge(_.previewResource));P&&s.push(this.toSyncResourcePreview(m.resource,P)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(_=>_[0]===c),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=s,this.previews}async getPreviews(s){const c=[],h=await this.getUserDataSyncConfiguration();for(const m of this.synchronisers){if(s.isCancellationRequested)return[];const P=await m.preview(this.manifest,h,this.syncHeaders);P&&c.push(this.toSyncResourcePreview(m.resource,P))}return c}async getUserDataSyncConfiguration(){const s=this.configurationService.getValue(p.USER_DATA_SYNC_CONFIGURATION_SCOPE),c=await this.synchronisers.find(h=>h instanceof w.SettingsSynchroniser).getRemoteUserDataSyncConfiguration(this.manifest);return{...s,...c}}toSyncResourcePreview(s,c){return[s,{isLastSyncFromCurrentMachine:c.isLastSyncFromCurrentMachine,resourcePreviews:c.resourcePreviews.map(t)}]}reset(){this.previewsPromise&&(this.previewsPromise.cancel(),this.previewsPromise=void 0),this.previews=void 0,this.synchronizingResources=[]}dispose(){this.reset(),this.isDisposed=!0}}let i=class extends A.Disposable{constructor(s,c,h,m,P,_,O){super();this.onDidChangeStatus=s,this.onDidChangeConflicts=c,this.onDidChangeLocal=h,this.userDataSyncEnablementService=m,this.instantiationService=P,this.extensionGalleryService=_,this.logService=O,this._enabled=[],this._register(m.onDidChangeResourceEnablement(([M,k])=>this.onDidChangeResourceEnablement(M,k))),this._register((0,A.toDisposable)(()=>this._enabled.splice(0,this._enabled.length).forEach(([,,M])=>M.dispose())));for(const M of p.ALL_SYNC_RESOURCES)m.isResourceEnabled(M)&&this.registerSynchronizer(M)}get enabled(){return this._enabled.sort((s,c)=>s[1]-c[1]).map(([s])=>s)}get disabled(){return p.ALL_SYNC_RESOURCES.filter(s=>!this.userDataSyncEnablementService.isResourceEnabled(s))}onDidChangeResourceEnablement(s,c){c?this.registerSynchronizer(s):this.deRegisterSynchronizer(s)}registerSynchronizer(s){if(this._enabled.some(([P])=>P.resource===s))return;if(s==="extensions"&&!this.extensionGalleryService.isEnabled()){this.logService.info("Skipping extensions sync because gallery is not configured");return}const c=new A.DisposableStore,h=c.add(this.createSynchronizer(s));c.add(h.onDidChangeStatus(()=>this.onDidChangeStatus(this.enabled))),c.add(h.onDidChangeConflicts(()=>this.onDidChangeConflicts(this.enabled))),c.add(h.onDidChangeLocal(()=>this.onDidChangeLocal(s)));const m=this.getOrder(s);this._enabled.push([h,m,c])}deRegisterSynchronizer(s){const c=this._enabled.findIndex(([h])=>h.resource===s);if(c!==-1){const h=this._enabled.splice(c,1);for(const[m,,P]of h){if(m.status!=="idle"){const _=m.conflicts.length>0;m.stop(),_&&this.onDidChangeConflicts(this.enabled),this.onDidChangeStatus(this.enabled)}P.dispose()}}}createSynchronizer(s){switch(s){case"settings":return this.instantiationService.createInstance(w.SettingsSynchroniser);case"keybindings":return this.instantiationService.createInstance(g.KeybindingsSynchroniser);case"snippets":return this.instantiationService.createInstance(y.SnippetsSynchroniser);case"globalState":return this.instantiationService.createInstance(d.GlobalStateSynchroniser);case"extensions":return this.instantiationService.createInstance(v.ExtensionsSynchroniser)}}getOrder(s){switch(s){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"globalState":return 3;case"extensions":return 4}}};i=de([Y(3,p.IUserDataSyncEnablementService),Y(4,f.IInstantiationService),Y(5,C.IExtensionGalleryService),Y(6,p.IUserDataSyncLogService)],i);function t(o){return{localResource:o.localResource,previewResource:o.previewResource,remoteResource:o.remoteResource,acceptedResource:o.acceptedResource,localChange:o.localChange,remoteChange:o.remoteChange,mergeState:o.mergeState}}}),define(ne[240],ie([0,1,3,2,15,7,25]),function(J,e,D,n,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;class R{constructor(C,f){this.service=C,this.logService=f,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new D.Emitter}listen(C,f){switch(f){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${f}`)}async call(C,f,S){try{return await this._call(C,f,S)}catch(u){throw this.logService.error(u),u}}async _call(C,f,S){switch(f){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"replace":return this.service.replace(T.URI.revive(S[0]));case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"accept":return this.service.accept(S[0],T.URI.revive(S[1]),S[2],S[3]);case"resolveContent":return this.service.resolveContent(T.URI.revive(S[0]));case"getLocalSyncResourceHandles":return this.service.getLocalSyncResourceHandles(S[0]);case"getRemoteSyncResourceHandles":return this.service.getRemoteSyncResourceHandles(S[0]);case"getAssociatedResources":return this.service.getAssociatedResources(S[0],{created:S[1].created,uri:T.URI.revive(S[1].uri)});case"getMachineId":return this.service.getMachineId(S[0],{created:S[1].created,uri:T.URI.revive(S[1].uri)});case"createManualSyncTask":return this.createManualSyncTask()}if(f.startsWith("manualSync/")){const u=f.substring("manualSync/".length),v=S[0],d=this.getManualSyncTask(v);switch(S=S.slice(1),u){case"preview":return d.preview();case"accept":return d.accept(T.URI.revive(S[0]),S[1]);case"merge":return d.merge(T.URI.revive(S[0]));case"discard":return d.discard(T.URI.revive(S[0]));case"discardConflicts":return d.discardConflicts();case"apply":return d.apply();case"pull":return d.pull();case"push":return d.push();case"stop":return d.stop();case"_getStatus":return d.status;case"dispose":return this.disposeManualSyncTask(d)}}throw new Error("Invalid call")}getManualSyncTask(C){const f=this.manualSyncTasks.get(this.createKey(C));if(!f)throw new Error(`Manual sync taks not found: ${C}`);return f.manualSyncTask}async createManualSyncTask(){const C=new n.DisposableStore,f=C.add(await this.service.createManualSyncTask());return C.add(f.onSynchronizeResources(S=>this.onManualSynchronizeResources.fire({manualSyncTaskId:f.id,data:S}))),this.manualSyncTasks.set(this.createKey(f.id),{manualSyncTask:f,disposables:C}),{id:f.id,manifest:f.manifest,status:f.status}}disposeManualSyncTask(C){C.dispose();const f=this.createKey(C.id);this.manualSyncTasks.get(f)?.disposables.dispose(),this.manualSyncTasks.delete(f)}createKey(C){return`manualSyncTask-${C}`}}e.UserDataSyncChannel=R;class b extends n.Disposable{constructor(C){super();this._status="uninitialized",this._onDidChangeStatus=this._register(new D.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new D.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new D.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new D.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(f,S,u){return C.call(f,S,u).then(null,v=>{throw A.UserDataSyncError.toUserDataSyncError(v)})},listen(f,S){return C.listen(f,S)}},this.channel.call("_getInitialData").then(([f,S,u])=>{this.updateStatus(f),this.updateConflicts(S),u&&this.updateLastSyncTime(u),this._register(this.channel.listen("onDidChangeStatus")(v=>this.updateStatus(v))),this._register(this.channel.listen("onDidChangeLastSyncTime")(v=>this.updateLastSyncTime(v)))}),this._register(this.channel.listen("onDidChangeConflicts")(f=>this.updateConflicts(f))),this._register(this.channel.listen("onSyncErrors")(f=>this._onSyncErrors.fire(f.map(([S,u])=>[S,A.UserDataSyncError.toUserDataSyncError(u)]))))}get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const{id:C,manifest:f,status:S}=await this.channel.call("createManualSyncTask"),u=this,v=new E(C,f,S,{async call(d,g,w){return u.channel.call(`manualSync/${d}`,[C,...(0,L.isArray)(g)?g:[g]],w)},listen(d,g){return D.Event.map(D.Event.filter(u.channel.listen(`manualSync/${d}`,g),w=>!v.isDiposed()&&w.manualSyncTaskId===C),w=>w.data)}});return v}replace(C){return this.channel.call("replace",[C])}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(C,f,S,u){return this.channel.call("accept",[C,f,S,u])}resolveContent(C){return this.channel.call("resolveContent",[C])}async getLocalSyncResourceHandles(C){return(await this.channel.call("getLocalSyncResourceHandles",[C])).map(({created:S,uri:u})=>({created:S,uri:T.URI.revive(u)}))}async getRemoteSyncResourceHandles(C){return(await this.channel.call("getRemoteSyncResourceHandles",[C])).map(({created:S,uri:u})=>({created:S,uri:T.URI.revive(u)}))}async getAssociatedResources(C,f){return(await this.channel.call("getAssociatedResources",[C,f])).map(({resource:u,comparableResource:v})=>({resource:T.URI.revive(u),comparableResource:T.URI.revive(v)}))}async getMachineId(C,f){return this.channel.call("getMachineId",[C,f])}async updateStatus(C){this._status=C,this._onDidChangeStatus.fire(C)}async updateConflicts(C){this._conflicts=C.map(([f,S])=>[f,S.map(u=>({...u,localResource:T.URI.revive(u.localResource),remoteResource:T.URI.revive(u.remoteResource),previewResource:T.URI.revive(u.previewResource)}))]),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(C){this._lastSyncTime!==C&&(this._lastSyncTime=C,this._onDidChangeLastSyncTime.fire(C))}}e.UserDataSyncChannelClient=b;class E extends n.Disposable{constructor(C,f,S,u){super();this.id=C,this.manifest=f,this._disposed=!1,this._status=S;const v=this;this.channel={async call(d,g,w){try{const y=await u.call(d,g,w);return v.isDiposed()||(v._status=await u.call("_getStatus")),y}catch(y){throw A.UserDataSyncError.toUserDataSyncError(y)}},listen(d,g){return u.listen(d,g)}}}get onSynchronizeResources(){return this.channel.listen("onSynchronizeResources")}get status(){return this._status}async preview(){const C=await this.channel.call("preview");return this.deserializePreviews(C)}async accept(C,f){const S=await this.channel.call("accept",[C,f]);return this.deserializePreviews(S)}async merge(C){const f=await this.channel.call("merge",[C]);return this.deserializePreviews(f)}async discard(C){const f=await this.channel.call("discard",[C]);return this.deserializePreviews(f)}async discardConflicts(){const C=await this.channel.call("discardConflicts");return this.deserializePreviews(C)}async apply(){const C=await this.channel.call("apply");return this.deserializePreviews(C)}pull(){return this.channel.call("pull")}push(){return this.channel.call("push")}stop(){return this.channel.call("stop")}isDiposed(){return this._disposed}dispose(){this._disposed=!0,this.channel.call("dispose")}deserializePreviews(C){return C.map(([f,S])=>[f,{isLastSyncFromCurrentMachine:S.isLastSyncFromCurrentMachine,resourcePreviews:S.resourcePreviews.map(u=>({...u,localResource:T.URI.revive(u.localResource),remoteResource:T.URI.revive(u.remoteResource),previewResource:T.URI.revive(u.previewResource),acceptedResource:T.URI.revive(u.acceptedResource)}))}])}}}),define(ne[241],ie([0,1,5,23,9,3,2,102,4,19,15,7,29,20,13,14,26,43,46,24,25]),function(J,e,D,n,L,T,A,R,b,E,I,C,f,S,u,v,d,g,w,y,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const l="sync.previous.store",r="sync.donot-make-requests-until",a="sync.user-session-id",i="sync.machine-session-id",t=100,o=1e3*60*5;let s=class extends A.Disposable{constructor(O,M,k){super();this.productService=O,this.configurationService=M,this.storageService=k,this._onDidChangeUserDataSyncStore=this._register(new T.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore(),this._register(T.Event.filter(k.onDidChangeValue,U=>U.key===p.SYNC_SERVICE_URL_TYPE&&U.scope===0&&this.userDataSyncStoreType!==this.userDataSyncStore?.type)(()=>this.updateUserDataSyncStore()))}get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(p.SYNC_SERVICE_URL_TYPE,0)}set userDataSyncStoreType(O){this.storageService.store(p.SYNC_SERVICE_URL_TYPE,O,0,b.isWeb?0:1)}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[p.CONFIGURATION_SYNC_STORE_KEY],this.configurationService.getValue(p.CONFIGURATION_SYNC_STORE_KEY)),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(O,M){O=b.isWeb&&O?.web?{...O,...O.web}:O;const k={...O||{},...M||{}};if(k&&(0,I.isString)(k.url)&&(0,I.isObject)(k.authenticationProviders)&&Object.keys(k.authenticationProviders).every(U=>(0,I.isArray)(k.authenticationProviders[U].scopes))){const U=k,N=!!U.canSwitch&&!M?.url,V=U.url===U.insidersUrl?"insiders":"stable",$=(N?this.userDataSyncStoreType:void 0)||V,G=M?.url||($==="insiders"?U.insidersUrl:$==="stable"?U.stableUrl:U.url);return{url:C.URI.parse(G),type:$,defaultType:V,defaultUrl:C.URI.parse(U.url),stableUrl:C.URI.parse(U.stableUrl),insidersUrl:C.URI.parse(U.insidersUrl),canSwitch:N,authenticationProviders:Object.keys(U.authenticationProviders).reduce((te,W)=>(te.push({id:W,scopes:U.authenticationProviders[W].scopes}),te),[])}}}};s=de([Y(0,d.IProductService),Y(1,S.IConfigurationService),Y(2,y.IStorageService)],s),e.AbstractUserDataSyncStoreManagementService=s;let c=class extends s{constructor(O,M,k){super(O,M,k);const U=this.storageService.get(l,0);U&&(this.previousConfigurationSyncStore=JSON.parse(U));const N=this.productService[p.CONFIGURATION_SYNC_STORE_KEY];N?this.storageService.store(l,JSON.stringify(N),0,1):this.storageService.remove(l,0)}async switch(O){O!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=O,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};c=de([Y(0,d.IProductService),Y(1,S.IConfigurationService),Y(2,y.IStorageService)],c),e.UserDataSyncStoreManagementService=c;let h=class extends A.Disposable{constructor(O,M,k,U,N,V,$){super();this.requestService=k,this.logService=U,this.storageService=$,this._onTokenFailed=this._register(new T.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new T.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new T.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(O),this.commonHeadersPromise=(0,w.getServiceMachineId)(N,V,$).then(G=>{const te={"X-Client-Name":`${M.applicationName}${b.isWeb?"-web":""}`,"X-Client-Version":M.version};return M.commit&&(te["X-Client-Commit"]=M.commit),te}),this.session=new P(t,o,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,A.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}setAuthToken(O,M){this.authToken={token:O,type:M}}updateUserDataSyncStoreUrl(O){this.userDataSyncStoreUrl=O?(0,E.joinPath)(O,"v1"):void 0}initDonotMakeRequestsUntil(){const O=this.storageService.getNumber(r,0);O&&Date.now()<O&&this.setDonotMakeRequestsUntil(new Date(O))}setDonotMakeRequestsUntil(O){this._donotMakeRequestsUntil?.getTime()!==O?.getTime()&&(this._donotMakeRequestsUntil=O,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(r,this._donotMakeRequestsUntil.getTime(),0,1),this.resetDonotMakeRequestsUntilPromise=(0,D.createCancelablePromise)(M=>(0,D.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),M).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,M=>null)):this.storageService.remove(r,0),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllRefs(O){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const M=(0,E.joinPath)(this.userDataSyncStoreUrl,"resource",O),k={},U=await this.request(M.toString(),{type:"GET",headers:k},[],n.CancellationToken.None);return(await(0,g.asJson)(U)||[]).map(({url:V,created:$})=>({ref:(0,E.relativePath)(M,M.with({path:V})),created:$*1e3}))}async resolveContent(O,M){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const k=(0,E.joinPath)(this.userDataSyncStoreUrl,"resource",O,M).toString(),U={};U["Cache-Control"]="no-cache";const N=await this.request(k,{type:"GET",headers:U},[],n.CancellationToken.None);return await(0,g.asText)(N)}async delete(O){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const M=(0,E.joinPath)(this.userDataSyncStoreUrl,"resource",O).toString(),k={};await this.request(M,{type:"DELETE",headers:k},[],n.CancellationToken.None)}async read(O,M,k={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const U=(0,E.joinPath)(this.userDataSyncStoreUrl,"resource",O,"latest").toString();k={...k},k["Cache-Control"]="no-cache",M&&(k["If-None-Match"]=M.ref);const N=await this.request(U,{type:"GET",headers:k},[304],n.CancellationToken.None);let V=null;if(N.res.statusCode===304&&(V=M),V===null){const $=N.res.headers.etag;if(!$)throw new p.UserDataSyncStoreError("Server did not return the ref",U,"NoRef",N.res.statusCode,N.res.headers[p.HEADER_OPERATION_ID]);const G=await(0,g.asText)(N);if(!G&&N.res.statusCode===304)throw new p.UserDataSyncStoreError("Empty response",U,"EmptyResponse",N.res.statusCode,N.res.headers[p.HEADER_OPERATION_ID]);V={ref:$,content:G}}return V}async write(O,M,k,U={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const N=(0,E.joinPath)(this.userDataSyncStoreUrl,"resource",O).toString();U={...U},U["Content-Type"]=R.Mimes.text,k&&(U["If-Match"]=k);const V=await this.request(N,{type:"POST",data:M,headers:U},[],n.CancellationToken.None),$=V.res.headers.etag;if(!$)throw new p.UserDataSyncStoreError("Server did not return the ref",N,"NoRef",V.res.statusCode,V.res.headers[p.HEADER_OPERATION_ID]);return $}async manifest(O,M={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const k=(0,E.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();M={...M},M["Content-Type"]="application/json",O&&(M["If-None-Match"]=O.ref);const U=await this.request(k,{type:"GET",headers:M},[304],n.CancellationToken.None);let N=null;if(U.res.statusCode===304&&(N=O),!N){const $=U.res.headers.etag;if(!$)throw new p.UserDataSyncStoreError("Server did not return the ref",k,"NoRef",U.res.statusCode,U.res.headers[p.HEADER_OPERATION_ID]);const G=await(0,g.asText)(U);if(!G&&U.res.statusCode===304)throw new p.UserDataSyncStoreError("Empty response",k,"EmptyResponse",U.res.statusCode,U.res.headers[p.HEADER_OPERATION_ID]);G&&(N={...JSON.parse(G),ref:$})}const V=this.storageService.get(a,0);return V&&N&&V!==N.session&&this.clearSession(),N===null&&V&&this.clearSession(),N&&this.storageService.store(a,N.session,0,1),N}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const O=(0,E.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),M={"Content-Type":R.Mimes.text};await this.request(O,{type:"DELETE",headers:M},[],n.CancellationToken.None),this.clearSession()}clearSession(){this.storageService.remove(a,0),this.storageService.remove(i,0)}async request(O,M,k,U){if(!this.authToken)throw new p.UserDataSyncStoreError("No Auth Token Available",O,"Unauthorized",void 0,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new p.UserDataSyncStoreError(`${M.type} request '${O}' failed because of too many requests (429).`,O,"TooManyRequestsAndRetryAfter",void 0,void 0);this.setDonotMakeRequestsUntil(void 0);const N=await this.commonHeadersPromise;M.headers={...M.headers||{},...N,"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`},this.addSessionHeaders(M.headers),this.logService.trace("Sending request to server",{url:O,type:M.type,headers:{...M.headers,authorization:void 0}});let V;try{V=await this.session.request(O,M,U)}catch(W){if(!(W instanceof p.UserDataSyncStoreError)){let j="RequestFailed";const K=(0,L.getErrorMessage)(W).toLowerCase();K.includes("xhr timeout")?j="RequestTimeout":K.includes("protocol")&&K.includes("not supported")?j="RequestProtocolNotSupported":K.includes("request path contains unescaped characters")?j="RequestPathNotEscaped":K.includes("headers must be an object")?j="RequestHeadersNotObject":(0,L.isCancellationError)(W)&&(j="RequestCanceled"),W=new p.UserDataSyncStoreError(`Connection refused for the request '${O}'.`,O,j,void 0,void 0)}throw this.logService.info("Request failed",O),W}const $=V.res.headers[p.HEADER_OPERATION_ID],G={url:O,status:V.res.statusCode,"execution-id":M.headers[p.HEADER_EXECUTION_ID],"operation-id":$},te=(0,g.isSuccess)(V)||V.res.statusCode&&k.indexOf(V.res.statusCode)!==-1;if(te?this.logService.trace("Request succeeded",G):this.logService.info("Request failed",G),V.res.statusCode===401)throw this.authToken=void 0,this._onTokenFailed.fire(),new p.UserDataSyncStoreError(`Request '${O}' failed because of Unauthorized (401).`,O,"Unauthorized",V.res.statusCode,$);if(this._onTokenSucceed.fire(),V.res.statusCode===409)throw new p.UserDataSyncStoreError(`${M.type} request '${O}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,O,"Conflict",V.res.statusCode,$);if(V.res.statusCode===410)throw new p.UserDataSyncStoreError(`${M.type} request '${O}' failed because the requested resource is not longer available (410).`,O,"Gone",V.res.statusCode,$);if(V.res.statusCode===412)throw new p.UserDataSyncStoreError(`${M.type} request '${O}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,O,"PreconditionFailed",V.res.statusCode,$);if(V.res.statusCode===413)throw new p.UserDataSyncStoreError(`${M.type} request '${O}' failed because of too large payload (413).`,O,"TooLarge",V.res.statusCode,$);if(V.res.statusCode===426)throw new p.UserDataSyncStoreError(`${M.type} request '${O}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,O,"UpgradeRequired",V.res.statusCode,$);if(V.res.statusCode===429){const W=V.res.headers["retry-after"];throw W?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(W)*1e3)),new p.UserDataSyncStoreError(`${M.type} request '${O}' failed because of too many requests (429).`,O,"TooManyRequestsAndRetryAfter",V.res.statusCode,$)):new p.UserDataSyncStoreError(`${M.type} request '${O}' failed because of too many requests (429).`,O,"RemoteTooManyRequests",V.res.statusCode,$)}if(!te)throw new p.UserDataSyncStoreError("Server returned "+V.res.statusCode,O,"Unknown",V.res.statusCode,$);return V}addSessionHeaders(O){let M=this.storageService.get(i,0);M===void 0&&(M=(0,f.generateUuid)(),this.storageService.store(i,M,0,1)),O["X-Machine-Session-Id"]=M;const k=this.storageService.get(a,0);k!==void 0&&(O["X-User-Session-Id"]=k)}};h=de([Y(1,d.IProductService),Y(2,g.IRequestService),Y(3,p.IUserDataSyncLogService),Y(4,u.IEnvironmentService),Y(5,v.IFileService),Y(6,y.IStorageService)],h),e.UserDataSyncStoreClient=h;let m=class extends h{constructor(O,M,k,U,N,V,$){super(O.userDataSyncStore?.url,M,k,U,N,V,$);this._register(O.onDidChangeUserDataSyncStore(()=>this.updateUserDataSyncStoreUrl(O.userDataSyncStore?.url)))}};m=de([Y(0,p.IUserDataSyncStoreManagementService),Y(1,d.IProductService),Y(2,g.IRequestService),Y(3,p.IUserDataSyncLogService),Y(4,u.IEnvironmentService),Y(5,v.IFileService),Y(6,y.IStorageService)],m),e.UserDataSyncStoreService=m;class P{constructor(O,M,k,U){this.limit=O,this.interval=M,this.requestService=k,this.logService=U,this.requests=[],this.startTime=void 0}request(O,M,k){if(this.isExpired()&&this.reset(),M.url=O,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new p.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,O,"LocalTooManyRequests",void 0,void 0);return this.startTime=this.startTime||new Date,this.requests.push(O),this.requestService.request(M,k)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=P}),define(ne[242],ie([0,1,3,60,26,24,21,238,25,64,65]),function(J,e,D,n,L,T,A,R,b,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let C=class extends R.UserDataAutoSyncService{constructor(S,u,v,d,g,w,y,p,l,r,a){super(S,u,v,d,g,y,p,l,r,a);this._register(D.Event.debounce(D.Event.any(D.Event.map(w.onDidFocusWindow,()=>"windowFocus"),D.Event.map(w.onDidOpenWindow,()=>"windowOpen")),(i,t)=>i?[...i,t]:[t],1e3)(i=>this.triggerSync(i,!0,!1)))}};C=de([Y(0,L.IProductService),Y(1,b.IUserDataSyncStoreManagementService),Y(2,b.IUserDataSyncStoreService),Y(3,b.IUserDataSyncEnablementService),Y(4,b.IUserDataSyncService),Y(5,n.INativeHostService),Y(6,b.IUserDataSyncLogService),Y(7,E.IUserDataSyncAccountService),Y(8,A.ITelemetryService),Y(9,I.IUserDataSyncMachinesService),Y(10,T.IStorageService)],C),e.UserDataAutoSyncService=C}),define(ne[243],ie([0,1,5,3,2]),function(J,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class T extends L.Disposable{constructor({onDidOpenWindow:R,onDidFocusWindow:b,getActiveWindowId:E}){super();this.disposables=this._register(new L.DisposableStore),n.Event.latch(n.Event.any(R,b))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,D.createCancelablePromise)(()=>E()),(async()=>{try{const C=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:C}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(R){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=R}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=T}),define(ne[66],ie([0,1,50,5,10,15,22,124,255,256]),function(J,e,D,n,L,T,A,R,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class I extends Error{constructor(r,a){let i=a.message;switch(r){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i);this.type=r,this.cause=a}}e.ExtractError=I;function C(l){const r=l.externalFileAttributes>>16||33188;return[448,56,7].map(a=>r&a).reduce((a,i)=>a+i,r&61440)}function f(l){if(l instanceof I)return l;let r;return/end of central directory record signature not found/.test(l.message)&&(r="CorruptZip"),new I(r,l)}function S(l,r,a,i,t,o){const s=L.dirname(r),c=L.join(i,s);if(!c.startsWith(i))return Promise.reject(new Error(R.localize(0,null,r)));const h=L.join(i,r);let m;return o.onCancellationRequested(()=>{m&&m.destroy()}),Promise.resolve(A.Promises.mkdir(c,{recursive:!0})).then(()=>new Promise((P,_)=>{if(!o.isCancellationRequested)try{m=(0,D.createWriteStream)(h,{mode:a}),m.once("close",()=>P()),m.once("error",_),l.once("error",_),l.pipe(m)}catch(O){_(O)}}))}function u(l,r,a,i){let t=(0,n.createCancelablePromise)(()=>Promise.resolve()),o=0;return i.onCancellationRequested(()=>{t.cancel(),l.close()}),new Promise((s,c)=>{const h=new n.Sequencer,m=P=>{P.isCancellationRequested||(o++,l.readEntry())};l.once("error",c),l.once("close",()=>t.then(()=>{i.isCancellationRequested||l.entryCount===o?s():c(new I("Incomplete",new Error(R.localize(1,null,o,l.entryCount))))},c)),l.readEntry(),l.on("entry",P=>{if(i.isCancellationRequested)return;if(!a.sourcePathRegex.test(P.fileName)){m(i);return}const _=P.fileName.replace(a.sourcePathRegex,"");if(/\/$/.test(_)){const k=L.join(r,_);t=(0,n.createCancelablePromise)(U=>A.Promises.mkdir(k,{recursive:!0}).then(()=>m(U)).then(void 0,c));return}const O=d(l,P),M=C(P);t=(0,n.createCancelablePromise)(k=>h.queue(()=>O.then(U=>S(U,_,M,r,a,k).then(()=>m(k)))).then(null,c))})})}function v(l,r=!1){return new Promise((a,i)=>{(0,b.open)(l,r?{lazyEntries:!0}:void 0,(t,o)=>{t?i(f(t)):a((0,T.assertIsDefined)(o))})})}function d(l,r){return new Promise((a,i)=>{l.openReadStream(r,(t,o)=>{t?i(f(t)):a((0,T.assertIsDefined)(o))})})}function g(l,r){return new Promise((a,i)=>{const t=new E.ZipFile;r.forEach(s=>{s.contents?t.addBuffer(typeof s.contents=="string"?Buffer.from(s.contents,"utf8"):s.contents,s.path):s.localPath&&t.addFile(s.localPath,s.path)}),t.end();const o=(0,D.createWriteStream)(l);t.outputStream.pipe(o),t.outputStream.once("error",i),o.once("error",i),o.once("finish",()=>a(l))})}e.zip=g;function w(l,r,a={},i){const t=new RegExp(a.sourcePath?`^${a.sourcePath}`:"");let o=v(l,!0);return a.overwrite&&(o=o.then(s=>A.Promises.rm(r).then(()=>s))),o.then(s=>u(s,r,{sourcePathRegex:t},i))}e.extract=w;function y(l,r){return v(l).then(a=>new Promise((i,t)=>{a.on("entry",o=>{o.fileName===r&&d(a,o).then(s=>i(s),s=>t(s))}),a.once("close",()=>t(new Error(R.localize(2,null,r))))}))}function p(l,r){return y(l,r).then(a=>new Promise((i,t)=>{const o=[];a.once("error",t),a.on("data",s=>o.push(s)),a.on("end",()=>i(Buffer.concat(o)))}))}e.buffer=p}),define(ne[244],ie([0,1,66,133]),function(J,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function L(T){return(0,D.buffer)(T,"extension/package.json").then(A=>{try{return JSON.parse(A.toString("utf8"))}catch{throw new Error((0,n.localize)(0,null))}})}e.getManifest=L}),define(ne[245],ie([0,1,16,5,9,2,18,10,4,19,61,7,29,22,66,134,13,30,31,155,14,8,26]),function(J,e,D,n,L,T,A,R,b,E,I,C,f,S,u,v,d,g,w,y,p,l,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScanner=void 0;let a=class extends T.Disposable{constructor(t,o,s,c,h){super();this.beforeRemovingExtension=t,this.fileService=o,this.logService=s,this.environmentService=c,this.productService=h,this._devSystemExtensionsPath=null,this.systemExtensionsPath=c.builtinExtensionsPath,this.extensionsPath=c.extensionsPath,this.uninstalledPath=R.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new n.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(t){const o=[];(t===null||t===0)&&o.push(this.scanSystemExtensions().then(null,s=>Promise.reject(new g.ExtensionManagementError(this.joinErrors(s).message,g.ExtensionManagementErrorCode.Internal)))),(t===null||t===1)&&o.push(this.scanUserExtensions(!0).then(null,s=>Promise.reject(new g.ExtensionManagementError(this.joinErrors(s).message,g.ExtensionManagementErrorCode.Internal))));try{const s=await Promise.all(o);return(0,D.flatten)(s)}catch(s){throw this.joinErrors(s)}}async scanUserExtensions(t){this.logService.trace("Started scanning user extensions");let[o,s]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return s=s.filter(c=>!o[new w.ExtensionIdentifierWithVersion(c.identifier,c.manifest.version).key()]),t&&(s=(0,w.groupByExtension)(s,h=>h.identifier).map(h=>h.sort((m,P)=>I.rcompare(m.manifest.version,P.manifest.version))[0])),this.logService.trace("Scanned user extensions:",s.length),s}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(t,o,s,c){const h=t.key(),m=R.join(this.extensionsPath,`.${(0,f.generateUuid)()}`),P=R.join(this.extensionsPath,h);try{await S.Promises.rm(P)}catch{try{await S.Promises.rm(P)}catch{}throw new g.ExtensionManagementError((0,v.localize)(0,null,P,t.id),g.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(t,o,m,c);let _=await this.scanExtension(C.URI.file(m),1);if(!_)throw new Error((0,v.localize)(1,null,m));await this.storeMetadata(_,{...s,installedTimestamp:Date.now()});try{await this.rename(t,m,P,Date.now()+2*60*1e3),this.logService.info("Renamed to",P)}catch(O){try{await S.Promises.rm(m)}catch{}if(O.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",t.id);else throw this.logService.info(`Rename failed because of ${(0,L.getErrorMessage)(O)}. Deleted from extracted location`,m),O}try{_=await this.scanExtension(C.URI.file(P),1)}catch{}if(_)return _;throw new Error((0,v.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(t,o){return this.setMetadata(t,o),await this.storeMetadata(t,{...o,installedTimestamp:t.installedTimestamp}),t}async storeMetadata(t,o){o.isMachineScoped=o.isMachineScoped||void 0,o.isBuiltin=o.isBuiltin||void 0,o.installedTimestamp=o.installedTimestamp||void 0;const s=R.join(t.location.fsPath,"package.json"),c=await S.Promises.readFile(s,"utf8"),{manifest:h}=await this.parseManifest(c);return h.__metadata=o,await S.Promises.writeFile(s,JSON.stringify(h,null,"	")),t}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...t){const o=t.map(s=>new w.ExtensionIdentifierWithVersion(s.identifier,s.manifest.version));await this.withUninstalledExtensions(s=>{o.forEach(c=>s[c.key()]=!0)})}async setInstalled(t){await this.withUninstalledExtensions(c=>delete c[t.key()]);const s=(await this.scanExtensions(1)).find(c=>new w.ExtensionIdentifierWithVersion(c.identifier,c.manifest.version).equals(t))||null;return s?(await this.storeMetadata(s,{installedTimestamp:Date.now()}),this.scanExtension(s.location,1)):null}async withUninstalledExtensions(t){return this.uninstalledFileLimiter.queue(async()=>{let o;try{o=await S.Promises.readFile(this.uninstalledPath,"utf8")}catch(c){if(c.code!=="ENOENT")throw c}let s={};if(o)try{s=JSON.parse(o)}catch{}return t&&(t(s),Object.keys(s).length?await S.Promises.writeFile(this.uninstalledPath,JSON.stringify(s)):await S.Promises.rm(this.uninstalledPath)),s})}async removeExtension(t,o){this.logService.trace(`Deleting ${o} extension from disk`,t.identifier.id,t.location.fsPath),await S.Promises.rm(t.location.fsPath),this.logService.info("Deleted from disk",t.identifier.id,t.location.fsPath)}async removeUninstalledExtension(t){await this.removeExtension(t,"uninstalled"),await this.withUninstalledExtensions(o=>delete o[new w.ExtensionIdentifierWithVersion(t.identifier,t.manifest.version).key()])}async extractAtLocation(t,o,s,c){this.logService.trace(`Started extracting the extension from ${o} to ${s}`);try{await S.Promises.rm(s)}catch(h){throw new g.ExtensionManagementError(this.joinErrors(h).message,g.ExtensionManagementErrorCode.Delete)}try{await(0,u.extract)(o,s,{sourcePath:"extension",overwrite:!0},c),this.logService.info(`Extracted extension to ${s}:`,t.id)}catch(h){try{await S.Promises.rm(s)}catch{}let m=g.ExtensionManagementErrorCode.Extract;throw h instanceof u.ExtractError&&(h.type==="CorruptZip"?m=g.ExtensionManagementErrorCode.CorruptZip:h.type==="Incomplete"&&(m=g.ExtensionManagementErrorCode.IncompleteZip)),new g.ExtensionManagementError(h.message,m)}}async rename(t,o,s,c){try{await S.Promises.rename(o,s)}catch(h){if(b.isWindows&&h&&h.code==="EPERM"&&Date.now()<c)return this.logService.info(`Failed renaming ${o} to ${s} with 'EPERM' error. Trying again...`,t.id),this.rename(t,o,s,c);throw new g.ExtensionManagementError(h.message||(0,v.localize)(3,null,o,s),h.code||g.ExtensionManagementErrorCode.Rename)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const t=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return t;const o=this.scanDevSystemExtensions(),[s,c]=await Promise.all([t,o]);return[...s,...c]}async scanExtensionsInDir(t,o){const s=new n.Limiter(10),c=await this.fileService.resolve(C.URI.file(t));return c.children?(await Promise.all(c.children.filter(m=>m.isDirectory).map(m=>s.queue(async()=>o===1&&(0,E.basename)(m.resource).indexOf(".")===0?null:this.scanExtension(m.resource,o))))).filter(m=>m&&m.identifier):[]}async scanExtension(t,o){try{const s=await this.fileService.resolve(t);if(s.children){const{manifest:c,metadata:h}=await this.readManifest(t.fsPath),m=s.children.find(({name:M})=>/^readme(\.txt|\.md|)$/i.test(M))?.resource,P=s.children.find(({name:M})=>/^changelog(\.txt|\.md|)$/i.test(M))?.resource,_={id:(0,w.getGalleryExtensionId)(c.publisher,c.name)},O={type:o,identifier:_,manifest:c,location:t,readmeUrl:m,changelogUrl:P,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:o===0};return this.setMetadata(O,h),O}}catch(s){o!==0&&this.logService.trace(s)}return null}async scanDefaultSystemExtensions(){const t=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",t.length),t}async scanDevSystemExtensions(){const t=this.getDevSystemExtensionsList();if(t.length){const o=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",o.length),o.filter(s=>t.some(c=>(0,w.areSameExtensions)(s.identifier,{id:c})))}else return[]}setMetadata(t,o){t.publisherDisplayName=o?.publisherDisplayName||null,t.publisherId=o?.publisherId||null,t.identifier.uuid=o?.id,t.isMachineScoped=!!o?.isMachineScoped,t.isPreReleaseVersion=!!o?.isPreReleaseVersion,t.preRelease=!!o?.preRelease,t.isBuiltin=t.type===0||!!o?.isBuiltin,t.installedTimestamp=o?.installedTimestamp}async removeUninstalledExtensions(){const t=await this.getUninstalledExtensions(),o=await this.scanAllUserExtensions(),s=new Set;for(const m of o)t[new w.ExtensionIdentifierWithVersion(m.identifier,m.manifest.version).key()]||s.add(m.identifier.id.toLowerCase());const c=(0,w.groupByExtension)(o,m=>m.identifier);await n.Promises.settled(c.map(async m=>{const P=m.sort((_,O)=>I.rcompare(_.manifest.version,O.manifest.version))[0];s.has(P.identifier.id.toLowerCase())||await this.beforeRemovingExtension(P)}));const h=o.filter(m=>t[new w.ExtensionIdentifierWithVersion(m.identifier,m.manifest.version).key()]);await n.Promises.settled(h.map(m=>this.removeUninstalledExtension(m)))}async removeOutdatedExtensions(){const t=await this.scanAllUserExtensions(),o=[],s=(0,w.groupByExtension)(t,c=>c.identifier);o.push(...(0,D.flatten)(s.map(c=>c.sort((h,m)=>I.rcompare(h.manifest.version,m.manifest.version)).slice(1)))),await n.Promises.settled(o.map(c=>this.removeExtension(c,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(t=>t.name)}joinErrors(t){const o=Array.isArray(t)?t:[t];return o.length===1?o[0]instanceof Error?o[0]:new Error(o[0]):o.reduce((s,c)=>new Error(`${s.message}${s.message?",":""}${c instanceof Error?c.message:c}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=R.normalize(R.join(A.FileAccess.asFileUri("",J).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(t){const o=[S.Promises.readFile(R.join(t,"package.json"),"utf8").then(m=>this.parseManifest(m)),S.Promises.readFile(R.join(t,"package.nls.json"),"utf8").then(void 0,m=>m.code!=="ENOENT"?Promise.reject(m):"{}").then(m=>JSON.parse(m))],[{manifest:s,metadata:c},h]=await Promise.all(o);return{manifest:(0,y.localizeManifest)(s,h),metadata:c}}parseManifest(t){return new Promise((o,s)=>{try{const c=JSON.parse(t),h=c.__metadata||null;o({manifest:c,metadata:h})}catch{s(new Error((0,v.localize)(4,null)))}})}};a=de([Y(1,p.IFileService),Y(2,l.ILogService),Y(3,d.INativeEnvironmentService),Y(4,r.IProductService)],a),e.ExtensionsScanner=a}),define(ne[246],ie([0,1,37,9,18,10,4,32,19,61,7,29,22,66,132,81,13,207,30,31,189,174,244,190,245,221,78,14,6,8,26,21,34]),function(J,e,D,n,L,T,A,R,b,E,I,C,f,S,u,v,d,g,w,y,p,l,r,a,i,t,o,s,c,h,m,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=void 0;let O=class extends g.AbstractExtensionManagementService{constructor($,G,te,W,j,K,H,Q,Z){super($,G,te,Q);this.environmentService=W,this.downloadService=j,this.fileService=H;const B=this._register(K.createInstance(l.ExtensionsLifecycle));this.extensionsScanner=this._register(K.createInstance(i.ExtensionsScanner,x=>B.postUninstall(x))),this.manifestCache=this._register(new a.ExtensionsManifestCache(W,this)),this.extensionsDownloader=this._register(K.createInstance(p.ExtensionsDownloader));const F=this._register(new t.ExtensionsWatcher(this,H,W,te,Z));this._register(F.onDidChangeExtensionsByAnotherSource(({added:x,removed:z})=>{x.length&&this._onDidInstallExtensions.fire(x.map(q=>({identifier:q.identifier,operation:1,local:q}))),z.forEach(q=>this._onDidUninstallExtension.fire({identifier:q}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(async()=>{const $=await this.isAlpineLinux(),G=(0,w.getTargetPlatform)($?"alpine":A.platform,R.arch);return this.logService.debug("ExtensionManagementService#TargetPlatform:",G),G})()),this._targetPlatformPromise}async isAlpineLinux(){if(!A.isLinux)return!1;let $;try{$=(await this.fileService.readFile(I.URI.file("/etc/os-release"))).value.toString()}catch{try{$=(await this.fileService.readFile(I.URI.file("/usr/lib/os-release"))).value.toString()}catch(te){this.logService.debug("Error while getting the os-release file.",(0,n.getErrorMessage)(te))}}return!!$&&($.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async zip($){this.logService.trace("ExtensionManagementService#zip",$.identifier.id);const G=await this.collectFiles($),te=await(0,S.zip)((0,b.joinPath)(this.environmentService.tmpDir,(0,C.generateUuid)()).fsPath,G);return I.URI.file(te)}async unzip($){return this.logService.trace("ExtensionManagementService#unzip",$.toString()),(await this.install($)).identifier}async getManifest($){const G=await this.downloadVsix($),te=T.resolve(G.fsPath);return(0,r.getManifest)(te)}getInstalled($=null){return this.extensionsScanner.scanExtensions($)}async install($,G={}){this.logService.trace("ExtensionManagementService#install",$.toString());const te=await this.downloadVsix($),W=await(0,r.getManifest)(T.resolve(te.fsPath));if(W.engines&&W.engines.vscode&&!(0,o.isEngineValid)(W.engines.vscode,this.productService.version,this.productService.date))throw new Error(u.localize(0,null,(0,y.getGalleryExtensionId)(W.publisher,W.name),this.productService.version));return this.installExtension(W,te,G)}async updateMetadata($,G){this.logService.trace("ExtensionManagementService#updateMetadata",$.identifier.id);const te={...$.manifest.__metadata||{},...G};return G.isPreReleaseVersion&&(te.preRelease=!0),$=await this.extensionsScanner.saveMetadataForLocalExtension($,te),this.manifestCache.invalidate(),$}async updateExtensionScope($,G){return this.logService.trace("ExtensionManagementService#updateExtensionScope",$.identifier.id),$=await this.extensionsScanner.saveMetadataForLocalExtension($,{...$.manifest.__metadata||{},isMachineScoped:G}),this.manifestCache.invalidate(),$}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix($){if($.scheme===L.Schemas.file)return $;const G=(0,b.joinPath)(this.environmentService.tmpDir,(0,C.generateUuid)());return await this.downloadService.download($,G),G}createInstallExtensionTask($,G,te){return I.URI.isUri(G)?new U($,G,te,this.galleryService,this.extensionsScanner,this.logService):new k(G,te,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask($,G){return new N($,G,this.extensionsScanner)}async collectFiles($){const G=async W=>{let j=await f.Promises.readdir(W);j=j.map(Q=>T.join(W,Q));const K=await Promise.all(j.map(Q=>f.Promises.stat(Q)));let H=Promise.resolve([]);return K.forEach((Q,Z)=>{const B=j[Z];Q.isFile()&&(H=H.then(F=>[...F,B])),Q.isDirectory()&&(H=H.then(F=>G(B).then(x=>[...F,...x])))}),H};return(await G($.location.fsPath)).map(W=>({path:`extension/${T.relative($.location.fsPath,W)}`,localPath:W}))}};O=de([Y(0,w.IExtensionGalleryService),Y(1,P.ITelemetryService),Y(2,h.ILogService),Y(3,d.INativeEnvironmentService),Y(4,v.IDownloadService),Y(5,c.IInstantiationService),Y(6,s.IFileService),Y(7,m.IProductService),Y(8,_.IUriIdentityService)],O),e.ExtensionManagementService=O;class M extends g.AbstractExtensionTask{constructor($,G,te,W){super();this.identifier=$,this.source=G,this.extensionsScanner=te,this.logService=W,this._operation=2}get operation(){return this._operation}async installExtension($,G){try{const te=await this.unsetUninstalledAndGetLocal($.identifierWithVersion);if(te)return $.metadata?this.extensionsScanner.saveMetadataForLocalExtension(te,{...te.manifest.__metadata||{},...$.metadata}):te}catch{throw A.isMacintosh?new w.ExtensionManagementError(u.localize(1,null),w.ExtensionManagementErrorCode.Internal):new w.ExtensionManagementError(u.localize(2,null),w.ExtensionManagementErrorCode.Internal)}return this.extract($,G)}async unsetUninstalledAndGetLocal($){if(!await this.isUninstalled($))return null;this.logService.trace("Removing the extension from uninstalled list:",$.id);const te=await this.extensionsScanner.setInstalled($);return this.logService.info("Removed the extension from uninstalled list:",$.id),te}async isUninstalled($){return!!(await this.extensionsScanner.getUninstalledExtensions())[$.key()]}async extract({zipPath:$,identifierWithVersion:G,metadata:te},W){let j=await this.extensionsScanner.extractUserExtension(G,$,te,W);return this.logService.info("Extracting completed.",G.id),j}}class k extends M{constructor($,G,te,W,j){super($.identifier,$,W,j);this.gallery=$,this.options=G,this.extensionsDownloader=te}async doRun($){const te=(await this.extensionsScanner.scanExtensions(null)).find(j=>(0,y.areSameExtensions)(j.identifier,this.gallery.identifier));te&&(this._operation=3);const W=await this.downloadInstallableExtension(this.gallery,this._operation);W.metadata.isMachineScoped=this.options.isMachineScoped||te?.isMachineScoped,W.metadata.isBuiltin=this.options.isBuiltin||te?.isBuiltin,W.metadata.isPreReleaseVersion=this.gallery.properties.isPreReleaseVersion,W.metadata.preRelease=this.gallery.hasPreReleaseVersion?this.gallery.properties.isPreReleaseVersion:te?.preRelease||this.options.installPreReleaseVersion;try{const j=await this.installExtension(W,$);return te&&E.neq(te.manifest.version,this.gallery.version)&&await this.extensionsScanner.setUninstalled(te),j}catch(j){throw await this.deleteDownloadedVSIX(W.zipPath),j}}async deleteDownloadedVSIX($){try{await this.extensionsDownloader.delete(I.URI.file($))}catch(G){this.logService.warn("Error while deleting the downloaded vsix",$.toString(),(0,n.getErrorMessage)(G))}}async downloadInstallableExtension($,G){const te={id:$.identifier.uuid,publisherId:$.publisherId,publisherDisplayName:$.publisherDisplayName};let W;try{this.logService.trace("Started downloading extension:",$.identifier.id),W=(await this.extensionsDownloader.downloadExtension($,G)).fsPath,this.logService.info("Downloaded extension:",$.identifier.id,W)}catch(j){throw new w.ExtensionManagementError((0,g.joinErrors)(j).message,w.ExtensionManagementErrorCode.Download)}try{const j=await(0,r.getManifest)(W);return{zipPath:W,identifierWithVersion:new y.ExtensionIdentifierWithVersion($.identifier,j.version),metadata:te}}catch(j){throw await this.deleteDownloadedVSIX(W),new w.ExtensionManagementError((0,g.joinErrors)(j).message,w.ExtensionManagementErrorCode.Invalid)}}}class U extends M{constructor($,G,te,W,j,K){super({id:(0,y.getGalleryExtensionId)($.publisher,$.name)},G,j,K);this.manifest=$,this.location=G,this.options=te,this.galleryService=W}async doRun($){const G=new y.ExtensionIdentifierWithVersion(this.identifier,this.manifest.version),W=(await this.extensionsScanner.scanExtensions(1)).find(K=>(0,y.areSameExtensions)(this.identifier,K.identifier)),j=await this.getMetadata(this.identifier.id,this.manifest.version,$);if(j.isMachineScoped=this.options.isMachineScoped||W?.isMachineScoped,j.isBuiltin=this.options.isBuiltin||W?.isBuiltin,W)if(this._operation=3,G.equals(new y.ExtensionIdentifierWithVersion(W.identifier,W.manifest.version)))try{await this.extensionsScanner.removeExtension(W,"existing")}catch{throw new Error(u.localize(3,null,this.manifest.displayName||this.manifest.name))}else E.gt(W.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(W);else{const K=await this.unsetUninstalledAndGetLocal(G);if(K)try{await this.extensionsScanner.removeExtension(K,"existing")}catch{throw new Error(u.localize(4,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:T.resolve(this.location.fsPath),identifierWithVersion:G,metadata:j},$)}async getMetadata($,G,te){try{let[W]=await this.galleryService.getExtensions([{id:$,version:G}],te);if(W||([W]=await this.galleryService.getExtensions([{id:$}],te)),W)return{id:W.identifier.uuid,publisherDisplayName:W.publisherDisplayName,publisherId:W.publisherId,isPreReleaseVersion:W.properties.isPreReleaseVersion,preRelease:W.properties.isPreReleaseVersion||this.options.installPreReleaseVersion}}catch{}return{}}}class N extends g.AbstractExtensionTask{constructor($,G,te){super();this.extension=$,this.options=G,this.extensionsScanner=te}async doRun($){const G=[],te=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const W=new y.ExtensionIdentifierWithVersion(this.extension.identifier,this.extension.manifest.version);G.push(...te.filter(j=>W.equals(new y.ExtensionIdentifierWithVersion(j.identifier,j.manifest.version))))}else G.push(...te.filter(W=>(0,y.areSameExtensions)(W.identifier,this.extension.identifier)));if(!G.length)throw new Error(u.localize(5,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...G),this.options.remove)for(const W of G)try{$.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(W)}catch(j){throw new Error(u.localize(6,null,(0,D.toErrorMessage)(j)))}}}}),define(ne[247],ie([0,1,83,56,33,17,9,3,2,10,4,29,36,73,257]),function(J,e,D,n,L,T,A,R,b,E,I,C,f,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class v{constructor(P,_=""){this.debugLabel=_,this.socket=P,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=O=>{if(this.traceSocketEvent("error",{code:O?.code,message:O?.message}),O){if(O.code==="EPIPE")return;(0,A.onUnexpectedError)(O)}},this.socket.on("error",this._errorListener)}traceSocketEvent(P,_){S.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,P,_)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(P){const _=O=>{this.traceSocketEvent("read",O),P(T.VSBuffer.wrap(O))};return this.socket.on("data",_),{dispose:()=>this.socket.off("data",_)}}onClose(P){const _=O=>{this.traceSocketEvent("close",{hadError:O}),P({type:0,hadError:O,error:void 0})};return this.socket.on("close",_),{dispose:()=>this.socket.off("close",_)}}onEnd(P){const _=()=>{this.traceSocketEvent("nodeEndReceived"),P()};return this.socket.on("end",_),{dispose:()=>this.socket.off("end",_)}}write(P){if(!this.socket.destroyed)try{this.traceSocketEvent("write",P),this.socket.write(P.buffer,_=>{if(_){if(_.code==="EPIPE")return;(0,A.onUnexpectedError)(_)}})}catch(_){if(_.code==="EPIPE")return;(0,A.onUnexpectedError)(_)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((P,_)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),P();return}const O=()=>{this.socket.off("close",O),this.socket.off("end",O),this.socket.off("error",O),this.socket.off("timeout",O),this.socket.off("drain",O),this.traceSocketEvent("nodeDrainEnd"),P()};this.socket.on("close",O),this.socket.on("end",O),this.socket.on("error",O),this.socket.on("timeout",O),this.socket.on("drain",O)})}}e.NodeSocket=v;var d;(function(m){m[m.MinHeaderByteSize=2]="MinHeaderByteSize"})(d||(d={}));var g;(function(m){m[m.PeekHeader=1]="PeekHeader",m[m.ReadHeader=2]="ReadHeader",m[m.ReadBody=3]="ReadBody",m[m.Fin=4]="Fin"})(g||(g={}));class w extends b.Disposable{constructor(P,_,O,M){super();this._onData=this._register(new R.Emitter),this._onClose=this._register(new R.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=P,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:_,inflateBytesLength:O?.byteLength||0,recordInflateBytes:M}),this._flowManager=this._register(new y(this,_,O,M,this._onData,(k,U)=>this._write(k,U))),this._register(this._flowManager.onError(k=>{console.error(k),(0,A.onUnexpectedError)(k),this._onClose.fire({type:0,hadError:!0,error:k})})),this._incomingData=new S.ChunkStream,this._register(this.socket.onData(k=>this._acceptChunk(k))),this._register(this.socket.onClose(k=>this._onClose.fire(k)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(P,_){this.socket.traceSocketEvent(P,_)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(P){return this._onData.event(P)}onClose(P){return this._onClose.event(P)}onEnd(P){return this.socket.onEnd(P)}write(P){this._flowManager.writeMessage(P)}_write(P,_){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",P);let O=2;P.byteLength<126?O+=0:P.byteLength<2**16?O+=2:O+=8;const M=T.VSBuffer.alloc(O);if(_?M.writeUInt8(194,0):M.writeUInt8(130,0),P.byteLength<126)M.writeUInt8(P.byteLength,1);else if(P.byteLength<2**16){M.writeUInt8(126,1);let k=1;M.writeUInt8(P.byteLength>>>8&255,++k),M.writeUInt8(P.byteLength>>>0&255,++k)}else{M.writeUInt8(127,1);let k=1;M.writeUInt8(0,++k),M.writeUInt8(0,++k),M.writeUInt8(0,++k),M.writeUInt8(0,++k),M.writeUInt8(P.byteLength>>>24&255,++k),M.writeUInt8(P.byteLength>>>16&255,++k),M.writeUInt8(P.byteLength>>>8&255,++k),M.writeUInt8(P.byteLength>>>0&255,++k)}this.socket.write(T.VSBuffer.concat([M,P]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(P){if(P.byteLength!==0){for(this._incomingData.acceptChunk(P);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const _=this._incomingData.peek(this._state.readLen),O=_.readUInt8(0),M=(O&128)>>>7,k=(O&64)>>>6,U=_.readUInt8(1),N=(U&128)>>>7,V=U&127;this._state.state=2,this._state.readLen=2+(N?4:0)+(V===126?2:0)+(V===127?8:0),this._state.fin=M,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(k)),this._state.firstFrameOfMessage=Boolean(M),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const _=this._incomingData.read(this._state.readLen),O=_.readUInt8(1),M=(O&128)>>>7;let k=O&127,U=1;k===126?k=_.readUInt8(++U)*2**8+_.readUInt8(++U):k===127&&(k=_.readUInt8(++U)*0+_.readUInt8(++U)*0+_.readUInt8(++U)*0+_.readUInt8(++U)*0+_.readUInt8(++U)*2**24+_.readUInt8(++U)*2**16+_.readUInt8(++U)*2**8+_.readUInt8(++U));let N=0;M&&(N=_.readUInt8(++U)*2**24+_.readUInt8(++U)*2**16+_.readUInt8(++U)*2**8+_.readUInt8(++U)),this._state.state=3,this._state.readLen=k,this._state.mask=N,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const _=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",_),r(_,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",_),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(_,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await R.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=w;class y extends b.Disposable{constructor(P,_,O,M,k,U){super();this._tracer=P,this._onData=k,this._writeFn=U,this._onError=this._register(new R.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new R.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,_?(this._zlibInflateStream=this._register(new p(this._tracer,M,O,{windowBits:15})),this._zlibDeflateStream=this._register(new l(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(N=>this._onError.fire(N))),this._register(this._zlibDeflateStream.onError(N=>this._onError.fire(N)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:T.VSBuffer.alloc(0)}writeMessage(P){this._writeQueue.push(P),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const P=this._writeQueue.shift();if(this._zlibDeflateStream){const _=await this._deflateMessage(this._zlibDeflateStream,P);this._writeFn(_,!0)}else this._writeFn(P,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(P,_){return new Promise((O,M)=>{P.write(_),P.flush(k=>O(k))})}acceptFrame(P,_,O){this._readQueue.push({data:P,isCompressed:_,isLastFrameOfMessage:O}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const P=this._readQueue.shift();if(this._zlibInflateStream&&P.isCompressed){const _=await this._inflateFrame(this._zlibInflateStream,P.data,P.isLastFrameOfMessage);this._onData.fire(_)}else this._onData.fire(P.data)}this._isProcessingReadQueue=!1}}_inflateFrame(P,_,O){return new Promise((M,k)=>{P.write(_),O&&P.write(T.VSBuffer.fromByteArray([0,0,255,255])),P.flush(U=>M(U))})}}class p extends b.Disposable{constructor(P,_,O,M){super();this._tracer=P,this._recordInflateBytes=_,this._onError=this._register(new R.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=u.createInflateRaw(M),this._zlibInflate.on("error",k=>{this._tracer.traceSocketEvent("zlibInflateError",{message:k?.message,code:k?.code}),this._onError.fire(k)}),this._zlibInflate.on("data",k=>{this._tracer.traceSocketEvent("zlibInflateData",k),this._pendingInflateData.push(T.VSBuffer.wrap(k))}),O&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",O.buffer),this._zlibInflate.write(O.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?T.VSBuffer.concat(this._recordedInflateBytes):T.VSBuffer.alloc(0)}write(P){this._recordInflateBytes&&this._recordedInflateBytes.push(P.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",P),this._zlibInflate.write(P.buffer)}flush(P){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const _=T.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,P(_)})}}class l extends b.Disposable{constructor(P,_){super();this._tracer=P,this._onError=this._register(new R.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=u.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",O=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:O?.message,code:O?.code}),this._onError.fire(O)}),this._zlibDeflate.on("data",O=>{this._tracer.traceSocketEvent("zlibDeflateData",O),this._pendingDeflateData.push(T.VSBuffer.wrap(O))})}write(P){this._tracer.traceSocketEvent("zlibDeflateWrite",P.buffer),this._zlibDeflate.write(P.buffer)}flush(P){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let _=T.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,_=_.slice(0,_.byteLength-4),P(_)})}}function r(m,P){if(P===0)return;let _=m.byteLength>>>2;for(let V=0;V<_;V++){const $=m.readUInt32BE(V*4);m.writeUInt32BE($^P,V*4)}let O=_*4,M=m.byteLength-O;const k=P>>>24&255,U=P>>>16&255,N=P>>>8&255;M>=1&&m.writeUInt8(m.readUInt8(O)^k,O),M>=2&&m.writeUInt8(m.readUInt8(O+1)^U,O+1),M>=3&&m.writeUInt8(m.readUInt8(O+2)^N,O+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const a={[2]:107,[1]:103};function i(){const m=(0,C.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${m}-sock`;let P;return e.XDG_RUNTIME_DIR?P=(0,E.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${m}.sock`):P=(0,E.join)((0,L.tmpdir)(),`vscode-ipc-${m}.sock`),o(P),P}e.createRandomIPCHandle=i;function t(m,P,_){const O=(0,D.createHash)("md5").update(m).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${O}-${_}-${P}-sock`;let M;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?M=(0,E.join)(e.XDG_RUNTIME_DIR,`vscode-${O.substr(0,8)}-${_}-${P}.sock`):M=(0,E.join)(m,`${_}-${P}.sock`),o(M),M}e.createStaticIPCHandle=t;function o(m){const P=a[I.platform];typeof P=="number"&&m.length>=P&&console.warn(`WARNING: IPC handle "${m}" is longer than ${P} chars, try a shorter --user-data-dir`)}class s extends f.IPCServer{constructor(P){super(s.toClientConnectionEvent(P));this.server=P}static toClientConnectionEvent(P){const _=R.Event.fromNodeEventEmitter(P,"connection");return R.Event.map(_,O=>({protocol:new S.Protocol(new v(O,"ipc-server-connection")),onDidClientDisconnect:R.Event.once(R.Event.fromNodeEventEmitter(O,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=s;function c(m){return new Promise((P,_)=>{const O=(0,n.createServer)();O.on("error",_),O.listen(m,()=>{O.removeListener("error",_),P(new s(O))})})}e.serve=c;function h(m,P){return new Promise((_,O)=>{const M=(0,n.createConnection)(m,()=>{M.removeListener("error",O),_(S.Client.fromSocket(new v(M,`ipc-client${P}`),P))});M.once("error",O)})}e.connect=h}),define(ne[248],ie([0,1,56,247]),function(J,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(L,T,A,R,b){const E=C=>b(C,void 0),I=D.createConnection({host:L,port:T},()=>{I.removeListener("error",E);const C=Buffer.alloc(16);for(let v=0;v<16;v++)C[v]=Math.round(Math.random()*256);const f=C.toString("base64"),S=[`GET ws://${/:/.test(L)?`[${L}]`:L}:${T}/?${A}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${f}`];I.write(S.join(`\r
`)+`\r
\r
`);const u=v=>{v.toString().indexOf(`\r
\r
`)>=0&&(I.off("data",u),b(void 0,new n.NodeSocket(I,R)))};I.on("data",u)});I.setNoDelay(!0),I.once("error",E)}}}),define(ne[249],ie([0,1,56,115,248,5,2,20,8,26,185,62,92]),function(J,e,D,n,L,T,A,R,b,E,I,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function S(w,y,p,l,r){let a;for(let i=3;i&&(a&&a.dispose(),a=await new u(w,y,p,l,r).waitForReady(),!(r&&n.BROWSER_RESTRICTED_PORTS[r]||!n.BROWSER_RESTRICTED_PORTS[a.tunnelLocalPort]));i--);return a}class u extends A.Disposable{constructor(y,p,l,r,a){super();this.defaultTunnelHost=p,this.suggestedLocalPort=a,this.privacy=C.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=y,this._server=D.createServer(),this._barrier=new T.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=i=>this._onConnection(i),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=r,this.tunnelRemoteHost=l}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(p=>{p()})}async waitForReady(){let y=await(0,n.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),p=null;return this._server.listen(y,this.defaultTunnelHost),await this._barrier.wait(),p=this._server.address(),p||(y=0,this._server.listen(y,this.defaultTunnelHost),await this._barrier.wait(),p=this._server.address()),this.tunnelLocalPort=p.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${p.port}`,this}async _onConnection(y){y.pause();const p=(0,C.isLocalhost)(this.tunnelRemoteHost)||(0,C.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,l=await(0,I.connectRemoteAgentTunnel)(this._options,p,this.tunnelRemotePort),r=l.getSocket().socket,a=l.readEntireBuffer();l.dispose(),a.byteLength>0&&y.write(a.buffer),y.on("end",()=>{this._socketsDispose.delete(y.localAddress),r.end()}),y.on("close",()=>r.end()),y.on("error",()=>{this._socketsDispose.delete(y.localAddress),r.destroy()}),r.on("end",()=>y.end()),r.on("close",()=>y.end()),r.on("error",()=>{y.destroy()}),y.pipe(r),r.pipe(y),this._socketsDispose.set(y.localAddress,()=>{y.end(),r.end()})}}let v=class extends C.AbstractTunnelService{constructor(y,p,l,r,a){super(p);this.socketFactory=y,this.signService=l,this.productService=r,this.configurationService=a}get defaultTunnelHost(){const y=this.configurationService.getValue("remote.localPortHost");return!y||y==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(y,p,l,r,a,i,t){const o=this.getTunnelFromMap(p,l);if(o)return++o.refcount,o.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,p,l,r,a,i,t);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${p}:${l} on local port ${r}.`);const s={commit:this.productService.commit,socketFactory:this.socketFactory,addressProvider:y,signService:this.signService,logService:this.logService,ipcLogger:null},c=S(s,this.defaultTunnelHost,p,l,r);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(p,l,c),c}}};v=de([Y(1,b.ILogService),Y(2,f.ISignService),Y(3,E.IProductService),Y(4,R.IConfigurationService)],v),e.BaseTunnelService=v;let d=class extends v{constructor(y,p,l,r){super(L.nodeSocketFactory,y,p,l,r)}};d=de([Y(0,b.ILogService),Y(1,f.ISignService),Y(2,E.IProductService),Y(3,R.IConfigurationService)],d),e.TunnelService=d;let g=class extends A.Disposable{constructor(y,p,l,r){super();this.logService=y,this.productService=p,this.signService=l,this.configurationService=r,this._tunnelServices=new Map}async openTunnel(y,p,l,r,a,i,t,o){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${l}:${r} on local port ${a}.`),!this._tunnelServices.has(y)){const s=new d(this.logService,this.signService,this.productService,this.configurationService);this._register(s),this._tunnelServices.set(y,s),s.onTunnelClosed(async()=>{(await s.tunnels).length===0&&(s.dispose(),this._tunnelServices.delete(y))})}return this._tunnelServices.get(y).openTunnel(p,l,r,a,i,t,o)}};g=de([Y(0,b.ILogService),Y(1,E.IProductService),Y(2,f.ISignService),Y(3,R.IConfigurationService)],g),e.SharedTunnelsService=g}),define(ne[258],ie([0,1,74,33,37,9,2,18,19,7,36,118,179,202,180,171,172,173,158,160,20,183,80,206,81,195,13,199,201,210,30,187,208,246,82,156,14,176,178,51,6,168,85,169,170,59,191,8,86,60,87,26,194,43,24,204,205,21,93,94,95,44,211,212,96,214,220,63,98,25,64,234,236,237,65,235,239,240,241,242,243,92,200,62,249,192,193,91,198,209,34,222,4,223,163,182,181]),function(J,e,D,n,L,T,A,R,b,E,I,C,f,S,u,v,d,g,w,y,p,l,r,a,i,t,o,s,c,h,m,P,_,O,M,k,U,N,V,$,G,te,W,j,K,H,Q,Z,B,F,x,z,q,ee,se,ce,ue,ve,pe,Ie,Ee,ye,be,Re,Fe,Me,qe,xe,re,ae,he,we,Ce,Ne,Te,Oe,_e,X,oe,le,fe,ge,Le,Se,De,ke,Pe,Ae,$e,je,Be,Pt,Rt,Dt,pt,kt,St){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class Lt extends A.Disposable{constructor(me){super();this.configuration=me,this.server=this._register(new C.Server),this.sharedProcessWorkerService=void 0,this.registerListeners()}registerListeners(){const me=()=>this.dispose();process.once("exit",me),D.ipcRenderer.once("vscode:electron-main->shared-process=exit",me);const Ue="vscode:electron-main->shared-process=disposeWorker",We=(Ye,ze)=>this.onDisposeWorker(ze);D.ipcRenderer.on(Ue,We),this._register((0,A.toDisposable)(()=>D.ipcRenderer.removeListener(Ue,We)))}onDisposeWorker(me){this.sharedProcessWorkerService?.disposeWorker(me)}async open(){const me=await this.initServices();(0,ae.registerConfiguration)(),me.invokeFunction(Ue=>{const We=Ue.get(Z.ILogService);We.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Ue),this.registerErrorHandler(We)}),this._register((0,A.combinedDisposable)(me.createInstance(f.CodeCacheCleaner,this.configuration.codeCachePath),me.createInstance(u.LanguagePackCachedDataCleaner),me.createInstance(g.StorageDataCleaner,this.configuration.backupWorkspacesPath),me.createInstance(d.LogsDataCleaner),me.createInstance(v.LocalizationsUpdater),me.createInstance(S.ExtensionsCleaner)))}async initServices(){const me=new W.ServiceCollection,Ue={_serviceBrand:void 0,...x.default};me.set(z.IProductService,Ue);const We=new I.StaticRouter(Ge=>Ge==="main"),Ye=new j.MessagePortMainProcessService(this.server,We);me.set(K.IMainProcessService,Ye);const ze=new s.SharedProcessEnvironmentService(this.configuration.args,Ue);me.set(o.INativeEnvironmentService,ze);const it=new B.LogLevelChannelClient(this.server.getChannel("logLevel",We)),Xe=new B.LoggerChannelClient(this.configuration.logLevel,it.onDidChangeLogLevel,Ye.getChannel("logger"));me.set(Z.ILoggerService,Xe);const ot=this._register(new Z.MultiplexLogService([this._register(new Z.ConsoleLogger(this.configuration.logLevel)),this._register(Xe.createLogger((0,b.joinPath)(E.URI.file(ze.logsPath),"sharedprocess.log"),{name:"sharedprocess"}))])),Je=this._register(new B.FollowerLogService(it,ot));me.set(Z.ILogService,Je),this.sharedProcessWorkerService=new $e.SharedProcessWorkerService(Je,Ue,ze),me.set(Ae.ISharedProcessWorkerService,this.sharedProcessWorkerService);const Ve=this._register(new N.FileService(Je));me.set(U.IFileService,Ve);const at=this._register(new V.DiskFileSystemProvider(Je));Ve.registerProvider(R.Schemas.file,at);const ct=this._register(new Dt.FileUserDataProvider(R.Schemas.file,this._register(new pt.DiskFileSystemProviderClient(Ye.getChannel(pt.LOCAL_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:Rt.isLinux})),R.Schemas.userData,Ve,Je));Ve.registerProvider(R.Schemas.userData,ct);const He=this._register(new l.ConfigurationService(ze.settingsResource,Ve));me.set(p.IConfigurationService,He);const et=new ce.NativeStorageService(void 0,Ye,ze);me.set(se.IStorageService,et),this._register((0,A.toDisposable)(()=>et.flush())),await Promise.all([He.initialize(),et.initialize()]),me.set(Be.IUriIdentityService,new Pt.UriIdentityService(Ve)),me.set(ee.IRequestService,new $.SyncDescriptor(q.RequestService)),me.set(w.IChecksumService,new $.SyncDescriptor(y.ChecksumService)),me.set(St.IV8InspectProfilingService,new $.SyncDescriptor(kt.InspectProfilingService));const rt=I.ProxyChannel.toService(Ye.getChannel("nativeHost"),{context:this.configuration.windowId});me.set(F.INativeHostService,rt),me.set(i.IDownloadService,new $.SyncDescriptor(t.DownloadService));const lt=this._register(new fe.ActiveWindowManager(rt)),ut=new I.StaticRouter(Ge=>lt.getActiveClientId().then(dt=>Ge===dt));me.set(M.IExtensionRecommendationNotificationService,new k.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",ut)));const ht=new je.AssignmentService(this.configuration.machineId,He,Ue);let tt;const Qe=[];if((0,ye.supportsTelemetry)(Ue,ze)){const Ge=new Ie.TelemetryLogAppender(Xe,ze);Qe.push(Ge);const{appRoot:dt,extensionsPath:_t,installSourcePath:Ot}=ze;if(Ue.aiConfig&&Ue.aiConfig.asimovKey){const st=await ht.getTreatment("telemetryMigration")??!1,ft=Ue.quality!=="stable";if(ft&&st){const bt=new be.AppInsightsAppender("monacoworkbench",null,Ue.aiConfig.asimovKey,st,!0);this._register((0,A.toDisposable)(()=>bt.flush())),Qe.push(bt)}const Et=new be.AppInsightsAppender("monacoworkbench",null,Ue.aiConfig.asimovKey,ft?!1:st,st&&ft);this._register((0,A.toDisposable)(()=>Et.flush())),Qe.push(Et)}tt=new Ee.TelemetryService({appenders:Qe,commonProperties:(0,ue.resolveCommonProperties)(Ve,(0,n.release)(),(0,n.hostname)(),process.arch,Ue.commit,Ue.version,this.configuration.machineId,Ue.msftInternalDomains,Ot),sendErrorTelemetry:!0,piiPaths:[dt,_t]},He)}else{tt=ye.NullTelemetryService;const Ge=ye.NullAppender;Qe.push(Ge)}this.server.registerChannel("telemetryAppender",new pe.TelemetryAppenderChannel(Qe)),me.set(ve.ITelemetryService,tt);const At=new Re.CustomEndpointTelemetryService(He,tt,Xe,ze);me.set(ve.ICustomEndpointTelemetryService,At),me.set(m.IExtensionManagementService,new $.SyncDescriptor(O.ExtensionManagementService)),me.set(m.IExtensionGalleryService,new $.SyncDescriptor(h.ExtensionGalleryService)),me.set(m.IExtensionTipsService,new $.SyncDescriptor(_.ExtensionTipsService)),me.set(H.ILocalizationsService,new $.SyncDescriptor(Q.LocalizationsService)),me.set(r.IDiagnosticsService,new $.SyncDescriptor(a.DiagnosticsService)),me.set(he.IUserDataSyncAccountService,new $.SyncDescriptor(he.UserDataSyncAccountService)),me.set(ae.IUserDataSyncLogService,new $.SyncDescriptor(Ne.UserDataSyncLogService)),me.set(ae.IUserDataSyncUtilService,new Ce.UserDataSyncUtilServiceClient(this.server.getChannel("userDataSyncUtil",Ge=>Ge.ctx!=="main"))),me.set(m.IGlobalExtensionEnablementService,new $.SyncDescriptor(c.GlobalExtensionEnablementService)),me.set(re.IIgnoredExtensionsManagementService,new $.SyncDescriptor(re.IgnoredExtensionsManagementService)),me.set(xe.IExtensionStorageService,new $.SyncDescriptor(xe.ExtensionStorageService)),me.set(ae.IUserDataSyncStoreManagementService,new $.SyncDescriptor(oe.UserDataSyncStoreManagementService)),me.set(ae.IUserDataSyncStoreService,new $.SyncDescriptor(oe.UserDataSyncStoreService)),me.set(Te.IUserDataSyncMachinesService,new $.SyncDescriptor(Te.UserDataSyncMachinesService)),me.set(ae.IUserDataSyncBackupStoreService,new $.SyncDescriptor(we.UserDataSyncBackupStoreService)),me.set(ae.IUserDataSyncEnablementService,new $.SyncDescriptor(Oe.UserDataSyncEnablementService)),me.set(ae.IUserDataSyncService,new $.SyncDescriptor(_e.UserDataSyncService));const wt=new qe.PtyHostService({graceTime:6e4,shortGraceTime:6e3,scrollback:He.getValue("terminal.integrated.persistentSessionScrollback")??100},He,ze,Je,tt);return await wt.initialize(),me.set(Me.ILocalPtyService,this._register(wt)),me.set(ge.ISignService,new $.SyncDescriptor(Le.SignService)),me.set(Se.ISharedTunnelsService,new $.SyncDescriptor(De.SharedTunnelsService)),me.set(ke.ISharedProcessTunnelService,new $.SyncDescriptor(Pe.SharedProcessTunnelService)),new te.InstantiationService(me)}initChannels(me){const Ue=new P.ExtensionManagementChannel(me.get(m.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Ue);const We=I.ProxyChannel.fromService(me.get(H.ILocalizationsService));this.server.registerChannel("localizations",We);const Ye=I.ProxyChannel.fromService(me.get(r.IDiagnosticsService));this.server.registerChannel("diagnostics",Ye);const ze=new P.ExtensionTipsChannel(me.get(m.IExtensionTipsService));this.server.registerChannel("extensionTipsService",ze);const it=I.ProxyChannel.fromService(me.get(w.IChecksumService));this.server.registerChannel("checksum",it);const Xe=I.ProxyChannel.fromService(me.get(St.IV8InspectProfilingService));this.server.registerChannel("v8InspectProfiling",Xe);const ot=new Ce.UserDataSyncMachinesServiceChannel(me.get(Te.IUserDataSyncMachinesService));this.server.registerChannel("userDataSyncMachines",ot);const Je=I.ProxyChannel.fromService(me.get(ve.ICustomEndpointTelemetryService));this.server.registerChannel("customEndpointTelemetry",Je);const Ve=new Ce.UserDataSyncAccountServiceChannel(me.get(he.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",Ve);const at=new Ce.UserDataSyncStoreManagementServiceChannel(me.get(ae.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",at);const ct=new X.UserDataSyncChannel(me.get(ae.IUserDataSyncService),me.get(Z.ILogService));this.server.registerChannel("userDataSync",ct);const He=this._register(me.get(G.IInstantiationService).createInstance(le.UserDataAutoSyncService)),et=new Ce.UserDataAutoSyncChannel(He);this.server.registerChannel("userDataAutoSync",et);const rt=me.get(Me.ILocalPtyService),lt=I.ProxyChannel.fromService(rt);this.server.registerChannel(Fe.TerminalIpcChannels.LocalPty,lt);const ut=I.ProxyChannel.fromService(me.get(ke.ISharedProcessTunnelService));this.server.registerChannel(ke.ipcSharedProcessTunnelChannelName,ut);const ht=I.ProxyChannel.fromService(me.get(Ae.ISharedProcessWorkerService));this.server.registerChannel(Ae.ipcSharedProcessWorkerChannelName,ht)}registerErrorHandler(me){window.addEventListener("unhandledrejection",Ue=>{(0,T.onUnexpectedError)(Ue.reason),Ue.preventDefault()}),(0,T.setUnexpectedErrorHandler)(Ue=>{const We=(0,L.toErrorMessage)(Ue,!0);!We||me.error(`[uncaught exception in sharedProcess]: ${We}`)})}}async function Tt(yt){const me=new Lt(yt);D.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await me.open(),D.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=Tt})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/0c6d1e9f7ef648cfa50733abb62388bc0791856a/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
