/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ve=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/base/common/path","vs/base/common/network","vs/base/common/platform","vs/platform/log/common/log","vs/base/common/async","vs/workbench/api/common/extHostRpcService","vs/workbench/api/common/extHostTypeConverters","vs/base/common/errors","vs/base/common/arrays","vs/base/common/types","vs/nls","vs/nls!vs/workbench/services/extensions/node/extensionHostProcess","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/base/common/map","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/base/common/extpath","vs/base/node/pfs","vs/workbench/services/search/common/search","vs/base/common/glob","vs/base/common/uuid","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","child_process","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostExtensionService","vs/base/common/process","vs/editor/common/core/range","vs/platform/files/common/files","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/stopwatch","vs/base/common/severity","vs/editor/common/core/position","vs/base/common/errorMessage","vs/platform/registry/common/platform","vs/workbench/api/common/extHostTunnelService","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDebugService","vs/base/common/assert","vs/base/common/decorators","vs/base/common/json","vs/base/common/hash","vs/base/common/marshalling","fs","vs/platform/instantiation/common/extensions","vs/platform/contextkey/common/contextkey","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostSearch","vs/base/common/codicons","vs/base/common/collections","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/iterator","vs/base/common/normalization","vs/base/common/labels","os","vs/editor/common/languages/languageSelector","vs/editor/common/languages","vs/platform/instantiation/common/serviceCollection","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/api/common/shared/webview","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/numbers","vs/base/common/mime","vs/base/common/processes","vs/base/common/stream","vs/base/common/filters","vs/base/common/htmlContent","vs/base/common/uint","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","string_decoder","vs/base/node/extpath","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/base/node/processes","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/descriptors","vs/platform/configuration/common/configuration","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/remote/common/tunnel","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/debug/common/abstractDebugAdapter","net","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testCollection","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/parts/ipc/node/ipc.net","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/cache","vs/base/common/iconLabels","vs/base/node/decoder","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/languages/tokenizationRegistry","vs/editor/common/model/textModelSearch","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/api/node/extHostTunnelService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/model","vs/editor/common/languages/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagement","vs/platform/sign/node/signService","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/editor","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/output/common/output","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","vs/workbench/services/textfile/common/encoding","vs/workbench/services/views/common/treeViewsDragAndDropService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/services/extensions/node/proxyResolver","http","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHost.node.services","vs/workbench/services/extensions/node/extensionHostProcessSetup","util","vs/base/common/marked/marked","https","tls","vscode-proxy-agent","events","vscode-regexpp","crypto","zlib","minimist","vs/workbench/services/extensions/node/extensionHostProcess"],we=function(Z){for(var e=[],h=0,t=Z.length;h<t;h++)e[h]=ve[Z[h]];return e};define(ve[55],we([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function h(t,I){if(!t)throw new Error(I?`Assertion failed (${I})`:"Assertion Failed")}e.ok=h}),define(ve[74],we([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function h(R){return R?R.replace(/\$\((.*?)\)/g,(k,D)=>` ${D} `).trim():""}e.getCodiconAriaLabel=h;class t{constructor(k,D,P){this.id=k,this.definition=D,this.description=P,t._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t._allCodicons}}e.Codicon=t,t._allCodicons=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",{fontCharacter:"\\ea71"}),t.closeDirty=new t("close-dirty",{fontCharacter:"\\ea71"}),t.debugBreakpoint=new t("debug-breakpoint",{fontCharacter:"\\ea71"}),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),t.debugHint=new t("debug-hint",{fontCharacter:"\\ea71"}),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circleOutline=new t("circle-outline",{fontCharacter:"\\eabc"}),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.debugStackframeDot=new t("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLargeOutline=new t("circle-large-outline",{fontCharacter:"\\ebb5"}),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);function I(R,k){const D=["codicon","codicon-"+R];return k&&D.push("codicon-modifier-"+k),D}e.getClassNamesArray=I;var y;(function(R){R.iconNameSegment="[A-Za-z0-9]+",R.iconNameExpression="[A-Za-z0-9-]+",R.iconModifierExpression="~[A-Za-z]+",R.iconNameCharacter="[A-Za-z0-9~-]";const k=new RegExp(`^(${R.iconNameExpression})(${R.iconModifierExpression})?$`);function D(C){if(C instanceof t)return["codicon","codicon-"+C.id];const l=k.exec(C.id);if(!l)return D(t.error);let[,E,p]=l;const m=["codicon","codicon-"+E];return p&&m.push("codicon-modifier-"+p.substr(1)),m}R.asClassNameArray=D;function P(C){return D(C).join(" ")}R.asClassName=P;function L(C){return"."+D(C).join(".")}R.asCSSSelector=L})(y=e.CSSIcon||(e.CSSIcon={}))}),define(ve[75],we([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const h=Object.prototype.hasOwnProperty;function t(L){const C=[];for(let l in L)h.call(L,l)&&C.push(L[l]);return C}e.values=t;function I(L,C){for(let l in L)if(h.call(L,l)&&C({key:l,value:L[l]},function(){delete L[l]})===!1)return}e.forEach=I;function y(L,C){const l=Object.create(null);for(const E of L){const p=C(E);let m=l[p];m||(m=l[p]=[]),m.push(E)}return l}e.groupBy=y;function R(L){const C=Object.create(null);return L&&L.forEach((l,E)=>{C[E]=l}),C}e.fromMap=R;function k(L,C){const l=[],E=[];for(let p of L)C.has(p)||l.push(p);for(let p of C)L.has(p)||E.push(p);return{removed:l,added:E}}e.diffSets=k;function D(L,C){const l=[],E=[];for(let[p,m]of L)C.has(p)||l.push(m);for(let[p,m]of C)L.has(p)||E.push(m);return{removed:l,added:E}}e.diffMaps=D;class P{constructor(){this.map=new Map}add(C,l){let E=this.map.get(C);E||(E=new Set,this.map.set(C,E)),E.add(l)}delete(C,l){const E=this.map.get(C);!E||(E.delete(l),E.size===0&&this.map.delete(C))}forEach(C,l){const E=this.map.get(C);!E||E.forEach(l)}}e.SetMap=P}),define(ve[56],we([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function h(R){return(k,D,P)=>{let L=null,C=null;if(typeof P.value=="function"?(L="value",C=P.value):typeof P.get=="function"&&(L="get",C=P.get),!C)throw new Error("not supported");P[L]=R(C,D)}}e.createDecorator=h;function t(R,k,D){let P=null,L=null;if(typeof D.value=="function"?(P="value",L=D.value,L.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof D.get=="function"&&(P="get",L=D.get),!L)throw new Error("not supported");const C=`$memoize$${k}`;D[P]=function(...l){return this.hasOwnProperty(C)||Object.defineProperty(this,C,{configurable:!1,enumerable:!1,writable:!1,value:L.apply(this,l)}),this[C]}}e.memoize=t;function I(R,k,D){return h((P,L)=>{const C=`$debounce$${L}`,l=`$debounce$result$${L}`;return function(...E){this[l]||(this[l]=D?D():void 0),clearTimeout(this[C]),k&&(this[l]=k(this[l],...E),E=[this[l]]),this[C]=setTimeout(()=>{P.apply(this,E),this[l]=D?D():void 0},R)}})}e.debounce=I;function y(R,k,D){return h((P,L)=>{const C=`$throttle$timer$${L}`,l=`$throttle$result$${L}`,E=`$throttle$lastRun$${L}`,p=`$throttle$pending$${L}`;return function(...m){if(this[l]||(this[l]=D?D():void 0),(this[E]===null||this[E]===void 0)&&(this[E]=-Number.MAX_VALUE),k&&(this[l]=k(this[l],...m)),this[p])return;const b=this[E]+R;b<=Date.now()?(this[E]=Date.now(),P.apply(this,[this[l]]),this[l]=D?D():void 0):(this[p]=!0,this[C]=setTimeout(()=>{this[p]=!1,this[E]=Date.now(),P.apply(this,[this[l]]),this[l]=D?D():void 0},b-Date.now()))}})}e.throttle=y}),define(ve[16],we([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class h{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(n){setTimeout(()=>{throw n.stack?new Error(n.message+`

`+n.stack):n},0)}}addListener(n){return this.listeners.push(n),()=>{this._removeListener(n)}}emit(n){this.listeners.forEach(S=>{S(n)})}_removeListener(n){this.listeners.splice(this.listeners.indexOf(n),1)}setUnexpectedErrorHandler(n){this.unexpectedErrorHandler=n}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(n){this.unexpectedErrorHandler(n),this.emit(n)}onUnexpectedExternalError(n){this.unexpectedErrorHandler(n)}}e.ErrorHandler=h,e.errorHandler=new h;function t(d){e.errorHandler.setUnexpectedErrorHandler(d)}e.setUnexpectedErrorHandler=t;function I(d){D(d)||e.errorHandler.onUnexpectedError(d)}e.onUnexpectedError=I;function y(d){D(d)||e.errorHandler.onUnexpectedExternalError(d)}e.onUnexpectedExternalError=y;function R(d){if(d instanceof Error){let{name:n,message:S}=d;const o=d.stacktrace||d.stack;return{$isError:!0,name:n,message:S,stack:o}}return d}e.transformErrorForSerialization=R;const k="Canceled";function D(d){return d instanceof P?!0:d instanceof Error&&d.name===k&&d.message===k}e.isCancellationError=D;class P extends Error{constructor(){super(k);this.name=this.message}}e.CancellationError=P;function L(){const d=new Error(k);return d.name=d.message,d}e.canceled=L;function C(d){return d?new Error(`Illegal argument: ${d}`):new Error("Illegal argument")}e.illegalArgument=C;function l(d){return d?new Error(`Illegal state: ${d}`):new Error("Illegal state")}e.illegalState=l;function E(d){return d?new Error(`readonly property '${d} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=E;function p(d){const n=new Error(`${d} has been disposed`);return n.name="DISPOSED",n}e.disposed=p;function m(d){return d?d.message?d.message:d.stack?d.stack.split(`
`)[0]:String(d):"Error"}e.getErrorMessage=m;class b extends Error{constructor(n){super("NotImplemented");n&&(this.message=n)}}e.NotImplementedError=b;class F extends Error{constructor(n){super("NotSupported");n&&(this.message=n)}}e.NotSupportedError=F;class _ extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=_;function g(d){const n=d;return n instanceof Error&&Array.isArray(n.actions)}e.isErrorWithActions=g;function s(d,n=Object.create(null)){const S=new Error(d);return n.actions&&(S.actions=n.actions),S}e.createErrorWithActions=s}),define(ve[17],we([0,1,16]),function(Z,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.compareBy=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function t(J,K=0){return J[J.length-(1+K)]}e.tail=t;function I(J){if(J.length===0)throw new Error("Invalid tail call");return[J.slice(0,J.length-1),J[J.length-1]]}e.tail2=I;function y(J,K,oe=(fe,pe)=>fe===pe){if(J===K)return!0;if(!J||!K||J.length!==K.length)return!1;for(let fe=0,pe=J.length;fe<pe;fe++)if(!oe(J[fe],K[fe]))return!1;return!0}e.equals=y;function R(J,K,oe){let fe=0,pe=J.length-1;for(;fe<=pe;){const Te=(fe+pe)/2|0,xe=oe(J[Te],K);if(xe<0)fe=Te+1;else if(xe>0)pe=Te-1;else return Te}return-(fe+1)}e.binarySearch=R;function k(J,K){let oe=0,fe=J.length;if(fe===0)return 0;for(;oe<fe;){const pe=Math.floor((oe+fe)/2);K(J[pe])?fe=pe:oe=pe+1}return oe}e.findFirstInSorted=k;function D(J,K,oe){if(J=J|0,J>=K.length)throw new TypeError("invalid index");let fe=K[Math.floor(K.length*Math.random())],pe=[],Te=[],xe=[];for(let Ge of K){const Qe=oe(Ge,fe);Qe<0?pe.push(Ge):Qe>0?Te.push(Ge):xe.push(Ge)}return J<pe.length?D(J,pe,oe):J<pe.length+xe.length?xe[0]:D(J-(pe.length+xe.length),Te,oe)}e.quickSelect=D;function P(J,K){const oe=[];let fe;for(const pe of J.slice(0).sort(K))!fe||K(fe[0],pe)!==0?(fe=[pe],oe.push(fe)):fe.push(pe);return oe}e.groupBy=P;function L(J,K,oe){const fe=[];function pe(Ge,Qe,q){if(Qe===0&&q.length===0)return;const te=fe[fe.length-1];te&&te.start+te.deleteCount===Ge?(te.deleteCount+=Qe,te.toInsert.push(...q)):fe.push({start:Ge,deleteCount:Qe,toInsert:q})}let Te=0,xe=0;for(;;){if(Te===J.length){pe(Te,0,K.slice(xe));break}if(xe===K.length){pe(Te,J.length-Te,[]);break}const Ge=J[Te],Qe=K[xe],q=oe(Ge,Qe);q===0?(Te+=1,xe+=1):q<0?(pe(Te,1,[]),Te+=1):q>0&&(pe(Te,0,[Qe]),xe+=1)}return fe}e.sortedDiff=L;function C(J,K,oe){const fe=L(J,K,oe),pe=[],Te=[];for(const xe of fe)pe.push(...J.slice(xe.start,xe.start+xe.deleteCount)),Te.push(...xe.toInsert);return{removed:pe,added:Te}}e.delta=C;function l(J,K,oe){if(oe===0)return[];const fe=J.slice(0,oe).sort(K);return p(J,K,fe,oe,J.length),fe}e.top=l;function E(J,K,oe,fe,pe){return oe===0?Promise.resolve([]):new Promise((Te,xe)=>{(async()=>{const Ge=J.length,Qe=J.slice(0,oe).sort(K);for(let q=oe,te=Math.min(oe+fe,Ge);q<Ge;q=te,te=Math.min(te+fe,Ge)){if(q>oe&&await new Promise(G=>setTimeout(G)),pe&&pe.isCancellationRequested)throw(0,h.canceled)();p(J,K,Qe,q,te)}return Qe})().then(Te,xe)})}e.topAsync=E;function p(J,K,oe,fe,pe){for(const Te=oe.length;fe<pe;fe++){const xe=J[fe];if(K(xe,oe[Te-1])<0){oe.pop();const Ge=k(oe,Qe=>K(xe,Qe)<0);oe.splice(Ge,0,xe)}}}function m(J){return J.filter(K=>!!K)}e.coalesce=m;function b(J){let K=0;for(let oe=0;oe<J.length;oe++)J[oe]&&(J[K]=J[oe],K+=1);J.length=K}e.coalesceInPlace=b;function F(J,K,oe){J.splice(oe,0,J.splice(K,1)[0])}e.move=F;function _(J){return!Array.isArray(J)||J.length===0}e.isFalsyOrEmpty=_;function g(J){return Array.isArray(J)&&J.length>0}e.isNonEmptyArray=g;function s(J,K=oe=>oe){const oe=new Set;return J.filter(fe=>{const pe=K(fe);return oe.has(pe)?!1:(oe.add(pe),!0)})}e.distinct=s;function d(J){const K=new Set;return oe=>{const fe=J(oe);return K.has(fe)?!1:(K.add(fe),!0)}}e.uniqueFilter=d;function n(J,K){const oe=S(J,K);if(oe!==-1)return J[oe]}e.findLast=n;function S(J,K){for(let oe=J.length-1;oe>=0;oe--){const fe=J[oe];if(K(fe))return oe}return-1}e.lastIndex=S;function o(J,K){return J.length>0?J[0]:K}e.firstOrDefault=o;function i(J,K,oe=(fe,pe)=>fe===pe){let fe=0;for(let pe=0,Te=Math.min(J.length,K.length);pe<Te&&oe(J[pe],K[pe]);pe++)fe++;return fe}e.commonPrefixLength=i;function r(J){return[].concat(...J)}e.flatten=r;function c(J,K){let oe=typeof K=="number"?J:0;typeof K=="number"?oe=J:(oe=0,K=J);const fe=[];if(oe<=K)for(let pe=oe;pe<K;pe++)fe.push(pe);else for(let pe=oe;pe>K;pe--)fe.push(pe);return fe}e.range=c;function a(J,K,oe){return J.reduce((fe,pe)=>(fe[K(pe)]=oe?oe(pe):pe,fe),Object.create(null))}e.index=a;function u(J,K){return J.push(K),()=>f(J,K)}e.insert=u;function f(J,K){const oe=J.indexOf(K);if(oe>-1)return J.splice(oe,1),K}e.remove=f;function v(J,K,oe){const fe=J.slice(0,K),pe=J.slice(K);return fe.concat(oe,pe)}e.arrayInsert=v;function w(J,K){let oe;if(typeof K=="number"){let fe=K;oe=()=>{const pe=Math.sin(fe++)*179426549;return pe-Math.floor(pe)}}else oe=Math.random;for(let fe=J.length-1;fe>0;fe-=1){const pe=Math.floor(oe()*(fe+1)),Te=J[fe];J[fe]=J[pe],J[pe]=Te}}e.shuffle=w;function A(J,K){const oe=J.indexOf(K);oe>-1&&(J.splice(oe,1),J.unshift(K))}e.pushToStart=A;function M(J,K){const oe=J.indexOf(K);oe>-1&&(J.splice(oe,1),J.push(K))}e.pushToEnd=M;function T(J,K){return Array.isArray(J)?J.map(K):K(J)}e.mapArrayOrNot=T;function O(J){return Array.isArray(J)?J:[J]}e.asArray=O;function U(J){return J[Math.floor(Math.random()*J.length)]}e.getRandomElement=U;function V(J,K){for(const oe of J){const fe=K(oe);if(fe!==void 0)return fe}}e.mapFind=V;function x(J,K,oe){const fe=$(J,K),pe=J.length,Te=oe.length;J.length=pe+Te;for(let xe=pe-1;xe>=fe;xe--)J[xe+Te]=J[xe];for(let xe=0;xe<Te;xe++)J[xe+fe]=oe[xe]}e.insertInto=x;function N(J,K,oe,fe){const pe=$(J,K),Te=J.splice(pe,oe);return x(J,pe,fe),Te}e.splice=N;function $(J,K){return K<0?Math.max(K+J.length,0):Math.min(K,J.length)}function B(J,K){return(oe,fe)=>K(J(oe),J(fe))}e.compareBy=B;const z=(J,K)=>J-K;e.numberComparator=z;function W(J,K){if(J.length===0)return;let oe=J[0];for(let fe=1;fe<J.length;fe++){const pe=J[fe];K(pe,oe)>0&&(oe=pe)}return oe}e.findMaxBy=W;function Y(J,K){if(J.length===0)return;let oe=J[0];for(let fe=1;fe<J.length;fe++){const pe=J[fe];K(pe,oe)>=0&&(oe=pe)}return oe}e.findLastMaxBy=Y;function ie(J,K){return W(J,(oe,fe)=>-K(oe,fe))}e.findMinBy=ie;class ne{constructor(K){this.items=K,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(K){let oe=this.firstIdx;for(;oe<this.items.length&&K(this.items[oe]);)oe++;const fe=oe===this.firstIdx?null:this.items.slice(this.firstIdx,oe);return this.firstIdx=oe,fe}takeFromEndWhile(K){let oe=this.lastIdx;for(;oe>=0&&K(this.items[oe]);)oe--;const fe=oe===this.lastIdx?null:this.items.slice(oe+1,this.lastIdx+1);return this.lastIdx=oe,fe}peek(){return this.items[this.firstIdx]}dequeue(){const K=this.items[this.firstIdx];return this.firstIdx++,K}takeCount(K){const oe=this.items.slice(this.firstIdx,this.firstIdx+K);return this.firstIdx+=K,oe}}e.ArrayQueue=ne}),define(ve[76],we([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function h(t){const I=this;let y=!1,R;return function(){return y||(y=!0,R=t.apply(I,arguments)),R}}e.once=h}),define(ve[77],we([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class h{constructor(I){this._prefix=I,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=h,e.defaultGenerator=new h("id#")}),define(ve[78],we([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var h;(function(t){function I(d){return d&&typeof d=="object"&&typeof d[Symbol.iterator]=="function"}t.is=I;const y=Object.freeze([]);function R(){return y}t.empty=R;function*k(d){yield d}t.single=k;function D(d){return d||y}t.from=D;function P(d){return!d||d[Symbol.iterator]().next().done===!0}t.isEmpty=P;function L(d){return d[Symbol.iterator]().next().value}t.first=L;function C(d,n){for(const S of d)if(n(S))return!0;return!1}t.some=C;function l(d,n){for(const S of d)if(n(S))return S}t.find=l;function*E(d,n){for(const S of d)n(S)&&(yield S)}t.filter=E;function*p(d,n){let S=0;for(const o of d)yield n(o,S++)}t.map=p;function*m(...d){for(const n of d)for(const S of n)yield S}t.concat=m;function*b(d){for(const n of d)for(const S of n)yield S}t.concatNested=b;function F(d,n,S){let o=S;for(const i of d)o=n(o,i);return o}t.reduce=F;function*_(d,n,S=d.length){for(n<0&&(n+=d.length),S<0?S+=d.length:S>d.length&&(S=d.length);n<S;n++)yield d[n]}t.slice=_;function g(d,n=Number.POSITIVE_INFINITY){const S=[];if(n===0)return[S,d];const o=d[Symbol.iterator]();for(let i=0;i<n;i++){const r=o.next();if(r.done)return[S,t.empty()];S.push(r.value)}return[S,{[Symbol.iterator](){return o}}]}t.consume=g;function s(d,n,S=(o,i)=>o===i){const o=d[Symbol.iterator](),i=n[Symbol.iterator]();for(;;){const r=o.next(),c=i.next();if(r.done!==c.done)return!1;if(r.done)return!0;if(!S(r.value,c.value))return!1}}t.equals=s})(h=e.Iterable||(e.Iterable={}))}),define(ve[57],we([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var h;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(h=e.ScanError||(e.ScanError={}));var t;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var I;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(I=e.ParseErrorCode||(e.ParseErrorCode={}));var y;(function(n){n.DEFAULT={allowTrailingComma:!0}})(y=e.ParseOptions||(e.ParseOptions={}));function R(n,S=!1){let o=0,i=n.length,r="",c=0,a=16,u=0;function f(U){let V=0,x=0;for(;V<U;){const N=n.charCodeAt(o);if(N>=48&&N<=57)x=x*16+N-48;else if(N>=65&&N<=70)x=x*16+N-65+10;else if(N>=97&&N<=102)x=x*16+N-97+10;else break;o++,V++}return V<U&&(x=-1),x}function v(U){o=U,r="",c=0,a=16,u=0}function w(){const U=o;if(n.charCodeAt(o)===48)o++;else for(o++;o<n.length&&P(n.charCodeAt(o));)o++;if(o<n.length&&n.charCodeAt(o)===46)if(o++,o<n.length&&P(n.charCodeAt(o)))for(o++;o<n.length&&P(n.charCodeAt(o));)o++;else return u=3,n.substring(U,o);let V=o;if(o<n.length&&(n.charCodeAt(o)===69||n.charCodeAt(o)===101))if(o++,(o<n.length&&n.charCodeAt(o)===43||n.charCodeAt(o)===45)&&o++,o<n.length&&P(n.charCodeAt(o))){for(o++;o<n.length&&P(n.charCodeAt(o));)o++;V=o}else u=3;return n.substring(U,V)}function A(){let U="",V=o;for(;;){if(o>=i){U+=n.substring(V,o),u=2;break}const x=n.charCodeAt(o);if(x===34){U+=n.substring(V,o),o++;break}if(x===92){if(U+=n.substring(V,o),o++,o>=i){u=2;break}switch(n.charCodeAt(o++)){case 34:U+='"';break;case 92:U+="\\";break;case 47:U+="/";break;case 98:U+="\b";break;case 102:U+="\f";break;case 110:U+=`
`;break;case 114:U+="\r";break;case 116:U+="	";break;case 117:{const $=f(4);$>=0?U+=String.fromCharCode($):u=4;break}default:u=5}V=o;continue}if(x>=0&&x<=31)if(D(x)){U+=n.substring(V,o),u=2;break}else u=6;o++}return U}function M(){if(r="",u=0,c=o,o>=i)return c=i,a=17;let U=n.charCodeAt(o);if(k(U)){do o++,r+=String.fromCharCode(U),U=n.charCodeAt(o);while(k(U));return a=15}if(D(U))return o++,r+=String.fromCharCode(U),U===13&&n.charCodeAt(o)===10&&(o++,r+=`
`),a=14;switch(U){case 123:return o++,a=1;case 125:return o++,a=2;case 91:return o++,a=3;case 93:return o++,a=4;case 58:return o++,a=6;case 44:return o++,a=5;case 34:return o++,r=A(),a=10;case 47:{const V=o-1;if(n.charCodeAt(o+1)===47){for(o+=2;o<i&&!D(n.charCodeAt(o));)o++;return r=n.substring(V,o),a=12}if(n.charCodeAt(o+1)===42){o+=2;const x=i-1;let N=!1;for(;o<x;){if(n.charCodeAt(o)===42&&n.charCodeAt(o+1)===47){o+=2,N=!0;break}o++}return N||(o++,u=1),r=n.substring(V,o),a=13}return r+=String.fromCharCode(U),o++,a=16}case 45:if(r+=String.fromCharCode(U),o++,o===i||!P(n.charCodeAt(o)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=w(),a=11;default:for(;o<i&&T(U);)o++,U=n.charCodeAt(o);if(c!==o){switch(r=n.substring(c,o),r){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return r+=String.fromCharCode(U),o++,a=16}}function T(U){if(k(U)||D(U))return!1;switch(U){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function O(){let U;do U=M();while(U>=12&&U<=15);return U}return{setPosition:v,getPosition:()=>o,scan:S?O:M,getToken:()=>a,getTokenValue:()=>r,getTokenOffset:()=>c,getTokenLength:()=>o-c,getTokenError:()=>u}}e.createScanner=R;function k(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function D(n){return n===10||n===13||n===8232||n===8233}function P(n){return n>=48&&n<=57}var L;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(L||(L={}));function C(n,S){const o=[],i=new Object;let r;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function u(f,v,w,A){c.value=f,c.offset=v,c.length=w,c.type=A,c.colonOffset=void 0,r=c}try{g(n,{onObjectBegin:(f,v)=>{if(S<=f)throw i;r=void 0,a=S>f,o.push("")},onObjectProperty:(f,v,w)=>{if(S<v||(u(f,v,w,"property"),o[o.length-1]=f,S<=v+w))throw i},onObjectEnd:(f,v)=>{if(S<=f)throw i;r=void 0,o.pop()},onArrayBegin:(f,v)=>{if(S<=f)throw i;r=void 0,o.push(0)},onArrayEnd:(f,v)=>{if(S<=f)throw i;r=void 0,o.pop()},onLiteralValue:(f,v,w)=>{if(S<v||(u(f,v,w,d(f)),S<=v+w))throw i},onSeparator:(f,v,w)=>{if(S<=v)throw i;if(f===":"&&r&&r.type==="property")r.colonOffset=v,a=!1,r=void 0;else if(f===","){const A=o[o.length-1];typeof A=="number"?o[o.length-1]=A+1:(a=!0,o[o.length-1]=""),r=void 0}}})}catch(f){if(f!==i)throw f}return{path:o,previousNode:r,isAtPropertyKey:a,matches:f=>{let v=0;for(let w=0;v<f.length&&w<o.length;w++)if(f[v]===o[w]||f[v]==="*")v++;else if(f[v]!=="**")return!1;return v===f.length}}}e.getLocation=C;function l(n,S=[],o=y.DEFAULT){let i=null,r=[];const c=[];function a(f){Array.isArray(r)?r.push(f):i!==null&&(r[i]=f)}return g(n,{onObjectBegin:()=>{const f={};a(f),c.push(r),r=f,i=null},onObjectProperty:f=>{i=f},onObjectEnd:()=>{r=c.pop()},onArrayBegin:()=>{const f=[];a(f),c.push(r),r=f,i=null},onArrayEnd:()=>{r=c.pop()},onLiteralValue:a,onError:(f,v,w)=>{S.push({error:f,offset:v,length:w})}},o),r[0]}e.parse=l;function E(n,S=[],o=y.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(f){i.type==="property"&&(i.length=f-i.offset,i=i.parent)}function c(f){return i.children.push(f),f}g(n,{onObjectBegin:f=>{i=c({type:"object",offset:f,length:-1,parent:i,children:[]})},onObjectProperty:(f,v,w)=>{i=c({type:"property",offset:v,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:f,offset:v,length:w,parent:i})},onObjectEnd:(f,v)=>{i.length=f+v-i.offset,i=i.parent,r(f+v)},onArrayBegin:(f,v)=>{i=c({type:"array",offset:f,length:-1,parent:i,children:[]})},onArrayEnd:(f,v)=>{i.length=f+v-i.offset,i=i.parent,r(f+v)},onLiteralValue:(f,v,w)=>{c({type:d(f),offset:v,length:w,parent:i,value:f}),r(v+w)},onSeparator:(f,v,w)=>{i.type==="property"&&(f===":"?i.colonOffset=v:f===","&&r(v))},onError:(f,v,w)=>{S.push({error:f,offset:v,length:w})}},o);const u=i.children[0];return u&&delete u.parent,u}e.parseTree=E;function p(n,S){if(!n)return;let o=n;for(let i of S)if(typeof i=="string"){if(o.type!=="object"||!Array.isArray(o.children))return;let r=!1;for(const c of o.children)if(Array.isArray(c.children)&&c.children[0].value===i){o=c.children[1],r=!0;break}if(!r)return}else{const r=i;if(o.type!=="array"||r<0||!Array.isArray(o.children)||r>=o.children.length)return;o=o.children[r]}return o}e.findNodeAtLocation=p;function m(n){if(!n.parent||!n.parent.children)return[];const S=m(n.parent);if(n.parent.type==="property"){const o=n.parent.children[0].value;S.push(o)}else if(n.parent.type==="array"){const o=n.parent.children.indexOf(n);o!==-1&&S.push(o)}return S}e.getNodePath=m;function b(n){switch(n.type){case"array":return n.children.map(b);case"object":{const S=Object.create(null);for(let o of n.children){const i=o.children[1];i&&(S[o.children[0].value]=b(i))}return S}case"null":case"string":case"number":case"boolean":return n.value;default:return}}e.getNodeValue=b;function F(n,S,o=!1){return S>=n.offset&&S<n.offset+n.length||o&&S===n.offset+n.length}e.contains=F;function _(n,S,o=!1){if(F(n,S,o)){const i=n.children;if(Array.isArray(i))for(let r=0;r<i.length&&i[r].offset<=S;r++){const c=_(i[r],S,o);if(c)return c}return n}}e.findNodeAtOffset=_;function g(n,S,o=y.DEFAULT){const i=R(n,!1);function r(ne){return ne?()=>ne(i.getTokenOffset(),i.getTokenLength()):()=>!0}function c(ne){return ne?J=>ne(J,i.getTokenOffset(),i.getTokenLength()):()=>!0}const a=r(S.onObjectBegin),u=c(S.onObjectProperty),f=r(S.onObjectEnd),v=r(S.onArrayBegin),w=r(S.onArrayEnd),A=c(S.onLiteralValue),M=c(S.onSeparator),T=r(S.onComment),O=c(S.onError),U=o&&o.disallowComments,V=o&&o.allowTrailingComma;function x(){for(;;){const ne=i.scan();switch(i.getTokenError()){case 4:N(14);break;case 5:N(15);break;case 3:N(13);break;case 1:U||N(11);break;case 2:N(12);break;case 6:N(16);break}switch(ne){case 12:case 13:U?N(10):T();break;case 16:N(1);break;case 15:case 14:break;default:return ne}}}function N(ne,J=[],K=[]){if(O(ne),J.length+K.length>0){let oe=i.getToken();for(;oe!==17;){if(J.indexOf(oe)!==-1){x();break}else if(K.indexOf(oe)!==-1)break;oe=x()}}}function $(ne){const J=i.getTokenValue();return ne?A(J):u(J),x(),!0}function B(){switch(i.getToken()){case 11:{let ne=0;try{ne=JSON.parse(i.getTokenValue()),typeof ne!="number"&&(N(2),ne=0)}catch{N(2)}A(ne);break}case 7:A(null);break;case 8:A(!0);break;case 9:A(!1);break;default:return!1}return x(),!0}function z(){return i.getToken()!==10?(N(3,[],[2,5]),!1):($(!1),i.getToken()===6?(M(":"),x(),ie()||N(4,[],[2,5])):N(5,[],[2,5]),!0)}function W(){a(),x();let ne=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(ne||N(4,[],[]),M(","),x(),i.getToken()===2&&V)break}else ne&&N(6,[],[]);z()||N(4,[],[2,5]),ne=!0}return f(),i.getToken()!==2?N(7,[2],[]):x(),!0}function Y(){v(),x();let ne=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(ne||N(4,[],[]),M(","),x(),i.getToken()===4&&V)break}else ne&&N(6,[],[]);ie()||N(4,[],[4,5]),ne=!0}return w(),i.getToken()!==4?N(8,[4],[]):x(),!0}function ie(){switch(i.getToken()){case 3:return Y();case 1:return W();case 10:return $(!0);default:return B()}}return x(),i.getToken()===17?o.allowEmptyContent?!0:(N(4,[],[]),!1):ie()?(i.getToken()!==17&&N(9,[],[]),!0):(N(4,[],[]),!1)}e.visit=g;function s(n,S){let o=R(n),i=[],r,c=0,a;do switch(a=o.getPosition(),r=o.scan(),r){case 12:case 13:case 17:c!==a&&i.push(n.substring(c,a)),S!==void 0&&i.push(o.getTokenValue().replace(/[^\r\n]/g,S)),c=o.getPosition();break}while(r!==17);return i.join("")}e.stripComments=s;function d(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=d}),define(ve[140],we([0,1,57]),function(Z,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function t(P,L,C){let l,E,p,m,b;if(L){for(m=L.offset,b=m+L.length,p=m;p>0&&!D(P,p-1);)p--;let a=b;for(;a<P.length&&!D(P,a);)a++;E=P.substring(p,a),l=R(E,C)}else E=P,l=0,p=0,m=0,b=P.length;const F=k(C,P);let _=!1,g=0,s;C.insertSpaces?s=y(" ",C.tabSize||4):s="	";const d=(0,h.createScanner)(E,!1);let n=!1;function S(){return F+y(s,l+g)}function o(){let a=d.scan();for(_=!1;a===15||a===14;)_=_||a===14,a=d.scan();return n=a===16||d.getTokenError()!==0,a}const i=[];function r(a,u,f){!n&&u<b&&f>m&&P.substring(u,f)!==a&&i.push({offset:u,length:f-u,content:a})}let c=o();if(c!==17){const a=d.getTokenOffset()+p,u=y(s,l);r(u,p,a)}for(;c!==17;){let a=d.getTokenOffset()+d.getTokenLength()+p,u=o(),f="";for(;!_&&(u===12||u===13);){const w=d.getTokenOffset()+p;r(" ",a,w),a=d.getTokenOffset()+d.getTokenLength()+p,f=u===12?S():"",u=o()}if(u===2)c!==1&&(g--,f=S());else if(u===4)c!==3&&(g--,f=S());else{switch(c){case 3:case 1:g++,f=S();break;case 5:case 12:f=S();break;case 13:_?f=S():f=" ";break;case 6:f=" ";break;case 10:if(u===6){f="";break}case 7:case 8:case 9:case 11:case 2:case 4:u===12||u===13?f=" ":u!==5&&u!==17&&(n=!0);break;case 16:n=!0;break}_&&(u===12||u===13)&&(f=S())}const v=d.getTokenOffset()+p;r(f,a,v),c=u}return i}e.format=t;function I(P,L){const C=JSON.stringify(P,void 0,L.insertSpaces?L.tabSize||4:"	");return L.eol!==void 0?C.replace(/\r\n|\r|\n/g,L.eol):C}e.toFormattedString=I;function y(P,L){let C="";for(let l=0;l<L;l++)C+=P;return C}function R(P,L){let C=0,l=0;const E=L.tabSize||4;for(;C<P.length;){const p=P.charAt(C);if(p===" ")l++;else if(p==="	")l+=E;else break;C++}return Math.floor(l/E)}function k(P,L){for(let C=0;C<L.length;C++){const l=L.charAt(C);if(l==="\r")return C+1<L.length&&L.charAt(C+1)===`
`?`\r
`:"\r";if(l===`
`)return`
`}return P&&P.eol||`
`}e.getEOL=k;function D(P,L){return`\r
`.indexOf(P.charAt(L))!==-1}e.isEOL=D}),define(ve[141],we([0,1,57,140]),function(Z,e,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function I(P,L,C){return y(P,L,void 0,C)}e.removeProperty=I;function y(P,L,C,l,E){const p=L.slice(),m=[],b=(0,h.parseTree)(P,m);let F,_;for(;p.length>0&&(_=p.pop(),F=(0,h.findNodeAtLocation)(b,p),F===void 0&&C!==void 0);)typeof _=="string"?C={[_]:C}:C=[C];if(F)if(F.type==="object"&&typeof _=="string"&&Array.isArray(F.children)){const g=(0,h.findNodeAtLocation)(F,[_]);if(g!==void 0)if(C===void 0){if(!g.parent)throw new Error("Malformed AST");const s=F.children.indexOf(g.parent);let d,n=g.parent.offset+g.parent.length;if(s>0){const S=F.children[s-1];d=S.offset+S.length}else d=F.offset+1,F.children.length>1&&(n=F.children[1].offset);return R(P,{offset:d,length:n-d,content:""},l)}else return R(P,{offset:g.offset,length:g.length,content:JSON.stringify(C)},l);else{if(C===void 0)return[];const s=`${JSON.stringify(_)}: ${JSON.stringify(C)}`,d=E?E(F.children.map(S=>S.children[0].value)):F.children.length;let n;if(d>0){const S=F.children[d-1];n={offset:S.offset+S.length,length:0,content:","+s}}else F.children.length===0?n={offset:F.offset+1,length:0,content:s}:n={offset:F.offset+1,length:0,content:s+","};return R(P,n,l)}}else if(F.type==="array"&&typeof _=="number"&&Array.isArray(F.children))if(C!==void 0){const g=`${JSON.stringify(C)}`;let s;if(F.children.length===0||_===0)s={offset:F.offset+1,length:0,content:F.children.length===0?g:g+","};else{const d=_===-1||_>F.children.length?F.children.length:_,n=F.children[d-1];s={offset:n.offset+n.length,length:0,content:","+g}}return R(P,s,l)}else{const g=_,s=F.children[g];let d;if(F.children.length===1)d={offset:F.offset+1,length:F.length-2,content:""};else if(F.children.length-1===g){const n=F.children[g-1],S=n.offset+n.length,o=F.offset+F.length;d={offset:S,length:o-2-S,content:""}}else d={offset:s.offset,length:F.children[g+1].offset-s.offset,content:""};return R(P,d,l)}else throw new Error(`Can not add ${typeof _!="number"?"index":"property"} to parent of type ${F.type}`);else{if(C===void 0)throw new Error("Can not delete in empty document");return R(P,{offset:b?b.offset:0,length:b?b.length:0,content:JSON.stringify(C)},l)}}e.setProperty=y;function R(P,L,C){let l=k(P,L),E=L.offset,p=L.offset+L.content.length;if(L.length===0||L.content.length===0){for(;E>0&&!(0,t.isEOL)(l,E-1);)E--;for(;p<l.length&&!(0,t.isEOL)(l,p);)p++}const m=(0,t.format)(l,{offset:E,length:p-E},C);for(let F=m.length-1;F>=0;F--){const _=m[F];l=k(l,_),E=Math.min(E,_.offset),p=Math.max(p,_.offset+_.length),p+=_.content.length-_.length}const b=P.length-(l.length-p)-E;return[{offset:E,length:b,content:l.substring(E,p)}]}e.withFormatting=R;function k(P,L){return P.substring(0,L.offset)+L.content+P.substring(L.offset+L.length)}e.applyEdit=k;function D(P,L){let C=L.slice(0).sort((E,p)=>{const m=E.offset-p.offset;return m===0?E.length-p.length:m}),l=P.length;for(let E=C.length-1;E>=0;E--){let p=C[E];if(p.offset+p.length<=l)P=k(P,p);else throw new Error("Overlapping edit");l=p.offset}return P}e.applyEdits=D}),define(ve[92],we([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class h{constructor(I){this.executor=I,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(I){this._error=I}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(I){return new h(()=>I(this.getValue()))}}e.Lazy=h}),define(ve[6],we([0,1,76,78]),function(Z,e,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const I=!1;let y=null;function R(i){y=i}if(e.setDisposableTracker=R,I){const i="__is_disposable_tracked__";R(new class{trackDisposable(r){const c=new Error("Potentially leaked disposable").stack;setTimeout(()=>{r[i]||console.log(c)},3e3)}setParent(r,c){if(r&&r!==_.None)try{r[i]=!0}catch{}}markAsDisposed(r){if(r&&r!==_.None)try{r[i]=!0}catch{}}markAsSingleton(r){}})}function k(i){return y?.trackDisposable(i),i}function D(i){y?.markAsDisposed(i)}function P(i,r){y?.setParent(i,r)}function L(i,r){if(!!y)for(const c of i)y.setParent(c,r)}function C(i){return y?.markAsSingleton(i),i}e.markAsSingleton=C;class l extends Error{constructor(r){super(`Encountered errors while disposing of store. Errors: [${r.join(", ")}]`);this.errors=r}}e.MultiDisposeError=l;function E(i){return typeof i.dispose=="function"&&i.dispose.length===0}e.isDisposable=E;function p(i){if(t.Iterable.is(i)){let r=[];for(const c of i)if(c)try{c.dispose()}catch(a){r.push(a)}if(r.length===1)throw r[0];if(r.length>1)throw new l(r);return Array.isArray(i)?[]:i}else if(i)return i.dispose(),i}e.dispose=p;function m(...i){const r=b(()=>p(i));return L(i,r),r}e.combinedDisposable=m;function b(i){const r=k({dispose:(0,h.once)(()=>{D(r),i()})});return r}e.toDisposable=b;class F{constructor(){this._toDispose=new Set,this._isDisposed=!1,k(this)}dispose(){this._isDisposed||(D(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{p(this._toDispose.values())}finally{this._toDispose.clear()}}add(r){if(!r)return r;if(r===this)throw new Error("Cannot register a disposable on itself!");return P(r,this),this._isDisposed?F.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(r),r}}e.DisposableStore=F,F.DISABLE_DISPOSED_WARNING=!1;class _{constructor(){this._store=new F,k(this),P(this._store,this)}dispose(){D(this),this._store.dispose()}_register(r){if(r===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(r)}}e.Disposable=_,_.None=Object.freeze({dispose(){}});class g{constructor(){this._isDisposed=!1,k(this)}get value(){return this._isDisposed?void 0:this._value}set value(r){this._isDisposed||r===this._value||(this._value?.dispose(),r&&P(r,this),this._value=r)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,D(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const r=this._value;return this._value=void 0,r&&P(r,null),r}}e.MutableDisposable=g;class s{constructor(r){this._disposable=r,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=s;class d{constructor(){this.references=new Map}acquire(r,...c){let a=this.references.get(r);a||(a={counter:0,object:this.createReferencedObject(r,...c)},this.references.set(r,a));const{object:u}=a,f=(0,h.once)(()=>{--a.counter==0&&(this.destroyReferencedObject(r,a.object),this.references.delete(r))});return a.counter++,{object:u,dispose:f}}}e.ReferenceCollection=d;class n{constructor(r){this.referenceCollection=r}async acquire(r,...c){const a=this.referenceCollection.acquire(r,...c);try{return{object:await a.object,dispose:()=>a.dispose()}}catch(u){throw a.dispose(),u}}}e.AsyncReferenceCollection=n;class S{constructor(r){this.object=r}dispose(){}}e.ImmortalReference=S;function o(i){const r=new F;try{i(r)}finally{r.dispose()}}e.disposeOnReturn=o}),define(ve[93],we([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class h{constructor(y){this.element=y,this.next=h.Undefined,this.prev=h.Undefined}}h.Undefined=new h(void 0);class t{constructor(){this._first=h.Undefined,this._last=h.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===h.Undefined}clear(){let y=this._first;for(;y!==h.Undefined;){const R=y.next;y.prev=h.Undefined,y.next=h.Undefined,y=R}this._first=h.Undefined,this._last=h.Undefined,this._size=0}unshift(y){return this._insert(y,!1)}push(y){return this._insert(y,!0)}_insert(y,R){const k=new h(y);if(this._first===h.Undefined)this._first=k,this._last=k;else if(R){const P=this._last;this._last=k,k.prev=P,P.next=k}else{const P=this._first;this._first=k,k.next=P,P.prev=k}this._size+=1;let D=!1;return()=>{D||(D=!0,this._remove(k))}}shift(){if(this._first!==h.Undefined){const y=this._first.element;return this._remove(this._first),y}}pop(){if(this._last!==h.Undefined){const y=this._last.element;return this._remove(this._last),y}}_remove(y){if(y.prev!==h.Undefined&&y.next!==h.Undefined){const R=y.prev;R.next=y.next,y.next.prev=R}else y.prev===h.Undefined&&y.next===h.Undefined?(this._first=h.Undefined,this._last=h.Undefined):y.next===h.Undefined?(this._last=this._last.prev,this._last.next=h.Undefined):y.prev===h.Undefined&&(this._first=this._first.next,this._first.prev=h.Undefined);this._size-=1}*[Symbol.iterator](){let y=this._first;for(;y!==h.Undefined;)yield y.element,y=y.next}}e.LinkedList=t}),function(Z,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(Z=typeof globalThis!="undefined"?globalThis:Z||self,Z.marked=e())}(this,function(){"use strict";function Z(Le,Ae){for(var De=0;De<Ae.length;De++){var ce=Ae[De];ce.enumerable=ce.enumerable||!1,ce.configurable=!0,"value"in ce&&(ce.writable=!0),Object.defineProperty(Le,ce.key,ce)}}function e(Le,Ae,De){return Ae&&Z(Le.prototype,Ae),De&&Z(Le,De),Le}function h(Le,Ae){if(!!Le){if(typeof Le=="string")return t(Le,Ae);var De=Object.prototype.toString.call(Le).slice(8,-1);if(De==="Object"&&Le.constructor&&(De=Le.constructor.name),De==="Map"||De==="Set")return Array.from(Le);if(De==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(De))return t(Le,Ae)}}function t(Le,Ae){(Ae==null||Ae>Le.length)&&(Ae=Le.length);for(var De=0,ce=new Array(Ae);De<Ae;De++)ce[De]=Le[De];return ce}function I(Le,Ae){var De=typeof Symbol!="undefined"&&Le[Symbol.iterator]||Le["@@iterator"];if(De)return(De=De.call(Le)).next.bind(De);if(Array.isArray(Le)||(De=h(Le))||Ae&&Le&&typeof Le.length=="number"){De&&(Le=De);var ce=0;return function(){return ce>=Le.length?{done:!0}:{done:!1,value:Le[ce++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}var y={exports:{}};function R(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function k(Le){y.exports.defaults=Le}y.exports={defaults:R(),getDefaults:R,changeDefaults:k};var D=/[&<>"']/,P=/[&<>"']/g,L=/[<>"']|&(?!#?\w+;)/,C=/[<>"']|&(?!#?\w+;)/g,l={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},E=function(Ae){return l[Ae]};function p(Le,Ae){if(Ae){if(D.test(Le))return Le.replace(P,E)}else if(L.test(Le))return Le.replace(C,E);return Le}var m=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function b(Le){return Le.replace(m,function(Ae,De){return De=De.toLowerCase(),De==="colon"?":":De.charAt(0)==="#"?De.charAt(1)==="x"?String.fromCharCode(parseInt(De.substring(2),16)):String.fromCharCode(+De.substring(1)):""})}var F=/(^|[^\[])\^/g;function _(Le,Ae){Le=Le.source||Le,Ae=Ae||"";var De={replace:function(de,be){return be=be.source||be,be=be.replace(F,"$1"),Le=Le.replace(de,be),De},getRegex:function(){return new RegExp(Le,Ae)}};return De}var g=/[^\w:]/g,s=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function d(Le,Ae,De){if(Le){var ce;try{ce=decodeURIComponent(b(De)).replace(g,"").toLowerCase()}catch{return null}if(ce.indexOf("javascript:")===0||ce.indexOf("vbscript:")===0||ce.indexOf("data:")===0)return null}Ae&&!s.test(De)&&(De=r(Ae,De));try{De=encodeURI(De).replace(/%25/g,"%")}catch{return null}return De}var n={},S=/^[^:]+:\/*[^/]*$/,o=/^([^:]+:)[\s\S]*$/,i=/^([^:]+:\/*[^/]*)[\s\S]*$/;function r(Le,Ae){n[" "+Le]||(S.test(Le)?n[" "+Le]=Le+"/":n[" "+Le]=f(Le,"/",!0)),Le=n[" "+Le];var De=Le.indexOf(":")===-1;return Ae.substring(0,2)==="//"?De?Ae:Le.replace(o,"$1")+Ae:Ae.charAt(0)==="/"?De?Ae:Le.replace(i,"$1")+Ae:Le+Ae}var c={exec:function(){}};function a(Le){for(var Ae=1,De,ce;Ae<arguments.length;Ae++){De=arguments[Ae];for(ce in De)Object.prototype.hasOwnProperty.call(De,ce)&&(Le[ce]=De[ce])}return Le}function u(Le,Ae){var De=Le.replace(/\|/g,function(be,Ce,Oe){for(var Ke=!1,$e=Ce;--$e>=0&&Oe[$e]==="\\";)Ke=!Ke;return Ke?"|":" |"}),ce=De.split(/ \|/),de=0;if(ce[0].trim()||ce.shift(),ce[ce.length-1].trim()||ce.pop(),ce.length>Ae)ce.splice(Ae);else for(;ce.length<Ae;)ce.push("");for(;de<ce.length;de++)ce[de]=ce[de].trim().replace(/\\\|/g,"|");return ce}function f(Le,Ae,De){var ce=Le.length;if(ce===0)return"";for(var de=0;de<ce;){var be=Le.charAt(ce-de-1);if(be===Ae&&!De)de++;else if(be!==Ae&&De)de++;else break}return Le.substr(0,ce-de)}function v(Le,Ae){if(Le.indexOf(Ae[1])===-1)return-1;for(var De=Le.length,ce=0,de=0;de<De;de++)if(Le[de]==="\\")de++;else if(Le[de]===Ae[0])ce++;else if(Le[de]===Ae[1]&&(ce--,ce<0))return de;return-1}function w(Le){Le&&Le.sanitize&&!Le.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function A(Le,Ae){if(Ae<1)return"";for(var De="";Ae>1;)Ae&1&&(De+=Le),Ae>>=1,Le+=Le;return De+Le}var M={escape:p,unescape:b,edit:_,cleanUrl:d,resolveUrl:r,noopTest:c,merge:a,splitCells:u,rtrim:f,findClosingBracket:v,checkSanitizeDeprecation:w,repeatString:A},T=y.exports.defaults,O=M.rtrim,U=M.splitCells,V=M.escape,x=M.findClosingBracket;function N(Le,Ae,De,ce){var de=Ae.href,be=Ae.title?V(Ae.title):null,Ce=Le[1].replace(/\\([\[\]])/g,"$1");if(Le[0].charAt(0)!=="!"){ce.state.inLink=!0;var Oe={type:"link",raw:De,href:de,title:be,text:Ce,tokens:ce.inlineTokens(Ce,[])};return ce.state.inLink=!1,Oe}else return{type:"image",raw:De,href:de,title:be,text:V(Ce)}}function $(Le,Ae){var De=Le.match(/^(\s+)(?:```)/);if(De===null)return Ae;var ce=De[1];return Ae.split(`
`).map(function(de){var be=de.match(/^\s+/);if(be===null)return de;var Ce=be[0];return Ce.length>=ce.length?de.slice(ce.length):de}).join(`
`)}var B=function(){function Le(De){this.options=De||T}var Ae=Le.prototype;return Ae.space=function(ce){var de=this.rules.block.newline.exec(ce);if(de)return de[0].length>1?{type:"space",raw:de[0]}:{raw:`
`}},Ae.code=function(ce){var de=this.rules.block.code.exec(ce);if(de){var be=de[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:de[0],codeBlockStyle:"indented",text:this.options.pedantic?be:O(be,`
`)}}},Ae.fences=function(ce){var de=this.rules.block.fences.exec(ce);if(de){var be=de[0],Ce=$(be,de[3]||"");return{type:"code",raw:be,lang:de[2]?de[2].trim():de[2],text:Ce}}},Ae.heading=function(ce){var de=this.rules.block.heading.exec(ce);if(de){var be=de[2].trim();if(/#$/.test(be)){var Ce=O(be,"#");(this.options.pedantic||!Ce||/ $/.test(Ce))&&(be=Ce.trim())}var Oe={type:"heading",raw:de[0],depth:de[1].length,text:be,tokens:[]};return this.lexer.inline(Oe.text,Oe.tokens),Oe}},Ae.hr=function(ce){var de=this.rules.block.hr.exec(ce);if(de)return{type:"hr",raw:de[0]}},Ae.blockquote=function(ce){var de=this.rules.block.blockquote.exec(ce);if(de){var be=de[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:de[0],tokens:this.lexer.blockTokens(be,[]),text:be}}},Ae.list=function(ce){var de=this.rules.block.list.exec(ce);if(de){var be,Ce,Oe,Ke,$e,Ze,lt,ct,He,Ee,_e=de[1].trim(),he=_e.length>1,X={type:"list",raw:"",ordered:he,start:he?+_e.slice(0,-1):"",loose:!1,items:[]};_e=he?"\\d{1,9}\\"+_e.slice(-1):"\\"+_e,this.options.pedantic&&(_e=he?_e:"[*+-]");for(var Ie=new RegExp("^( {0,3}"+_e+")((?: [^\\n]*| *)(?:\\n[^\\n]*)*(?:\\n|$))");ce&&!(this.rules.block.hr.test(ce)||!(de=Ie.exec(ce)));){He=de[2].split(`
`),this.options.pedantic?(Ke=2,Ee=He[0].trimLeft()):(Ke=de[2].search(/[^ ]/),Ke=de[1].length+(Ke>4?1:Ke),Ee=He[0].slice(Ke-de[1].length)),Ze=!1,be=de[0],!He[0]&&/^ *$/.test(He[1])&&(be=de[1]+He.slice(0,2).join(`
`)+`
`,X.loose=!0,He=[]);var Ne=new RegExp("^ {0,"+Math.min(3,Ke-1)+"}(?:[*+-]|\\d{1,9}[.)])");for($e=1;$e<He.length;$e++){if(ct=He[$e],this.options.pedantic&&(ct=ct.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),Ne.test(ct)){be=de[1]+He.slice(0,$e).join(`
`)+`
`;break}if(!Ze){ct.trim()||(Ze=!0),ct.search(/[^ ]/)>=Ke?Ee+=`
`+ct.slice(Ke):Ee+=`
`+ct;continue}if(ct.search(/[^ ]/)>=Ke||!ct.trim()){Ee+=`
`+ct.slice(Ke);continue}else{be=de[1]+He.slice(0,$e).join(`
`)+`
`;break}}X.loose||(lt?X.loose=!0:/\n *\n *$/.test(be)&&(lt=!0)),this.options.gfm&&(Ce=/^\[[ xX]\] /.exec(Ee),Ce&&(Oe=Ce[0]!=="[ ] ",Ee=Ee.replace(/^\[[ xX]\] +/,""))),X.items.push({type:"list_item",raw:be,task:!!Ce,checked:Oe,loose:!1,text:Ee}),X.raw+=be,ce=ce.slice(be.length)}X.items[X.items.length-1].raw=be.trimRight(),X.items[X.items.length-1].text=Ee.trimRight(),X.raw=X.raw.trimRight();var Ye=X.items.length;for($e=0;$e<Ye;$e++)this.lexer.state.top=!1,X.items[$e].tokens=this.lexer.blockTokens(X.items[$e].text,[]),X.items[$e].tokens.some(function(Xe){return Xe.type==="space"})&&(X.loose=!0,X.items[$e].loose=!0);return X}},Ae.html=function(ce){var de=this.rules.block.html.exec(ce);if(de){var be={type:"html",raw:de[0],pre:!this.options.sanitizer&&(de[1]==="pre"||de[1]==="script"||de[1]==="style"),text:de[0]};return this.options.sanitize&&(be.type="paragraph",be.text=this.options.sanitizer?this.options.sanitizer(de[0]):V(de[0]),be.tokens=[],this.lexer.inline(be.text,be.tokens)),be}},Ae.def=function(ce){var de=this.rules.block.def.exec(ce);if(de){de[3]&&(de[3]=de[3].substring(1,de[3].length-1));var be=de[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:be,raw:de[0],href:de[2],title:de[3]}}},Ae.table=function(ce){var de=this.rules.block.table.exec(ce);if(de){var be={type:"table",header:U(de[1]).map(function(lt){return{text:lt}}),align:de[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:de[3]?de[3].replace(/\n$/,"").split(`
`):[]};if(be.header.length===be.align.length){be.raw=de[0];var Ce=be.align.length,Oe,Ke,$e,Ze;for(Oe=0;Oe<Ce;Oe++)/^ *-+: *$/.test(be.align[Oe])?be.align[Oe]="right":/^ *:-+: *$/.test(be.align[Oe])?be.align[Oe]="center":/^ *:-+ *$/.test(be.align[Oe])?be.align[Oe]="left":be.align[Oe]=null;for(Ce=be.rows.length,Oe=0;Oe<Ce;Oe++)be.rows[Oe]=U(be.rows[Oe],be.header.length).map(function(lt){return{text:lt}});for(Ce=be.header.length,Ke=0;Ke<Ce;Ke++)be.header[Ke].tokens=[],this.lexer.inlineTokens(be.header[Ke].text,be.header[Ke].tokens);for(Ce=be.rows.length,Ke=0;Ke<Ce;Ke++)for(Ze=be.rows[Ke],$e=0;$e<Ze.length;$e++)Ze[$e].tokens=[],this.lexer.inlineTokens(Ze[$e].text,Ze[$e].tokens);return be}}},Ae.lheading=function(ce){var de=this.rules.block.lheading.exec(ce);if(de){var be={type:"heading",raw:de[0],depth:de[2].charAt(0)==="="?1:2,text:de[1],tokens:[]};return this.lexer.inline(be.text,be.tokens),be}},Ae.paragraph=function(ce){var de=this.rules.block.paragraph.exec(ce);if(de){var be={type:"paragraph",raw:de[0],text:de[1].charAt(de[1].length-1)===`
`?de[1].slice(0,-1):de[1],tokens:[]};return this.lexer.inline(be.text,be.tokens),be}},Ae.text=function(ce){var de=this.rules.block.text.exec(ce);if(de){var be={type:"text",raw:de[0],text:de[0],tokens:[]};return this.lexer.inline(be.text,be.tokens),be}},Ae.escape=function(ce){var de=this.rules.inline.escape.exec(ce);if(de)return{type:"escape",raw:de[0],text:V(de[1])}},Ae.tag=function(ce){var de=this.rules.inline.tag.exec(ce);if(de)return!this.lexer.state.inLink&&/^<a /i.test(de[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(de[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(de[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(de[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:de[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(de[0]):V(de[0]):de[0]}},Ae.link=function(ce){var de=this.rules.inline.link.exec(ce);if(de){var be=de[2].trim();if(!this.options.pedantic&&/^</.test(be)){if(!/>$/.test(be))return;var Ce=O(be.slice(0,-1),"\\");if((be.length-Ce.length)%2==0)return}else{var Oe=x(de[2],"()");if(Oe>-1){var Ke=de[0].indexOf("!")===0?5:4,$e=Ke+de[1].length+Oe;de[2]=de[2].substring(0,Oe),de[0]=de[0].substring(0,$e).trim(),de[3]=""}}var Ze=de[2],lt="";if(this.options.pedantic){var ct=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ze);ct&&(Ze=ct[1],lt=ct[3])}else lt=de[3]?de[3].slice(1,-1):"";return Ze=Ze.trim(),/^</.test(Ze)&&(this.options.pedantic&&!/>$/.test(be)?Ze=Ze.slice(1):Ze=Ze.slice(1,-1)),N(de,{href:Ze&&Ze.replace(this.rules.inline._escapes,"$1"),title:lt&&lt.replace(this.rules.inline._escapes,"$1")},de[0],this.lexer)}},Ae.reflink=function(ce,de){var be;if((be=this.rules.inline.reflink.exec(ce))||(be=this.rules.inline.nolink.exec(ce))){var Ce=(be[2]||be[1]).replace(/\s+/g," ");if(Ce=de[Ce.toLowerCase()],!Ce||!Ce.href){var Oe=be[0].charAt(0);return{type:"text",raw:Oe,text:Oe}}return N(be,Ce,be[0],this.lexer)}},Ae.emStrong=function(ce,de,be){be===void 0&&(be="");var Ce=this.rules.inline.emStrong.lDelim.exec(ce);if(!!Ce&&!(Ce[3]&&be.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Oe=Ce[1]||Ce[2]||"";if(!Oe||Oe&&(be===""||this.rules.inline.punctuation.exec(be))){var Ke=Ce[0].length-1,$e,Ze,lt=Ke,ct=0,He=Ce[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(He.lastIndex=0,de=de.slice(-1*ce.length+Ke);(Ce=He.exec(de))!=null;)if($e=Ce[1]||Ce[2]||Ce[3]||Ce[4]||Ce[5]||Ce[6],!!$e){if(Ze=$e.length,Ce[3]||Ce[4]){lt+=Ze;continue}else if((Ce[5]||Ce[6])&&Ke%3&&!((Ke+Ze)%3)){ct+=Ze;continue}if(lt-=Ze,!(lt>0)){if(Ze=Math.min(Ze,Ze+lt+ct),Math.min(Ke,Ze)%2){var Ee=ce.slice(1,Ke+Ce.index+Ze);return{type:"em",raw:ce.slice(0,Ke+Ce.index+Ze+1),text:Ee,tokens:this.lexer.inlineTokens(Ee,[])}}var _e=ce.slice(2,Ke+Ce.index+Ze-1);return{type:"strong",raw:ce.slice(0,Ke+Ce.index+Ze+1),text:_e,tokens:this.lexer.inlineTokens(_e,[])}}}}}},Ae.codespan=function(ce){var de=this.rules.inline.code.exec(ce);if(de){var be=de[2].replace(/\n/g," "),Ce=/[^ ]/.test(be),Oe=/^ /.test(be)&&/ $/.test(be);return Ce&&Oe&&(be=be.substring(1,be.length-1)),be=V(be,!0),{type:"codespan",raw:de[0],text:be}}},Ae.br=function(ce){var de=this.rules.inline.br.exec(ce);if(de)return{type:"br",raw:de[0]}},Ae.del=function(ce){var de=this.rules.inline.del.exec(ce);if(de)return{type:"del",raw:de[0],text:de[2],tokens:this.lexer.inlineTokens(de[2],[])}},Ae.autolink=function(ce,de){var be=this.rules.inline.autolink.exec(ce);if(be){var Ce,Oe;return be[2]==="@"?(Ce=V(this.options.mangle?de(be[1]):be[1]),Oe="mailto:"+Ce):(Ce=V(be[1]),Oe=Ce),{type:"link",raw:be[0],text:Ce,href:Oe,tokens:[{type:"text",raw:Ce,text:Ce}]}}},Ae.url=function(ce,de){var be;if(be=this.rules.inline.url.exec(ce)){var Ce,Oe;if(be[2]==="@")Ce=V(this.options.mangle?de(be[0]):be[0]),Oe="mailto:"+Ce;else{var Ke;do Ke=be[0],be[0]=this.rules.inline._backpedal.exec(be[0])[0];while(Ke!==be[0]);Ce=V(be[0]),be[1]==="www."?Oe="http://"+Ce:Oe=Ce}return{type:"link",raw:be[0],text:Ce,href:Oe,tokens:[{type:"text",raw:Ce,text:Ce}]}}},Ae.inlineText=function(ce,de){var be=this.rules.inline.text.exec(ce);if(be){var Ce;return this.lexer.state.inRawBlock?Ce=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(be[0]):V(be[0]):be[0]:Ce=V(this.options.smartypants?de(be[0]):be[0]),{type:"text",raw:be[0],text:Ce}}},Le}(),z=M.noopTest,W=M.edit,Y=M.merge,ie={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,table:z,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};ie._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,ie._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,ie.def=W(ie.def).replace("label",ie._label).replace("title",ie._title).getRegex(),ie.bullet=/(?:[*+-]|\d{1,9}[.)])/,ie.listItemStart=W(/^( *)(bull) */).replace("bull",ie.bullet).getRegex(),ie.list=W(ie.list).replace(/bull/g,ie.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+ie.def.source+")").getRegex(),ie._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",ie._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,ie.html=W(ie.html,"i").replace("comment",ie._comment).replace("tag",ie._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),ie.paragraph=W(ie._paragraph).replace("hr",ie.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ie._tag).getRegex(),ie.blockquote=W(ie.blockquote).replace("paragraph",ie.paragraph).getRegex(),ie.normal=Y({},ie),ie.gfm=Y({},ie.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)\\|?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),ie.gfm.table=W(ie.gfm.table).replace("hr",ie.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ie._tag).getRegex(),ie.pedantic=Y({},ie.normal,{html:W(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",ie._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:z,paragraph:W(ie.normal._paragraph).replace("hr",ie.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",ie.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var ne={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:z,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_*]*?\*[^_*]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^_*]*?\_[^_*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:z,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};ne._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",ne.punctuation=W(ne.punctuation).replace(/punctuation/g,ne._punctuation).getRegex(),ne.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,ne.escapedEmSt=/\\\*|\\_/g,ne._comment=W(ie._comment).replace("(?:-->|$)","-->").getRegex(),ne.emStrong.lDelim=W(ne.emStrong.lDelim).replace(/punct/g,ne._punctuation).getRegex(),ne.emStrong.rDelimAst=W(ne.emStrong.rDelimAst,"g").replace(/punct/g,ne._punctuation).getRegex(),ne.emStrong.rDelimUnd=W(ne.emStrong.rDelimUnd,"g").replace(/punct/g,ne._punctuation).getRegex(),ne._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,ne._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,ne._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,ne.autolink=W(ne.autolink).replace("scheme",ne._scheme).replace("email",ne._email).getRegex(),ne._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,ne.tag=W(ne.tag).replace("comment",ne._comment).replace("attribute",ne._attribute).getRegex(),ne._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,ne._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,ne._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,ne.link=W(ne.link).replace("label",ne._label).replace("href",ne._href).replace("title",ne._title).getRegex(),ne.reflink=W(ne.reflink).replace("label",ne._label).getRegex(),ne.reflinkSearch=W(ne.reflinkSearch,"g").replace("reflink",ne.reflink).replace("nolink",ne.nolink).getRegex(),ne.normal=Y({},ne),ne.pedantic=Y({},ne.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:W(/^!?\[(label)\]\((.*?)\)/).replace("label",ne._label).getRegex(),reflink:W(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",ne._label).getRegex()}),ne.gfm=Y({},ne.normal,{escape:W(ne.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),ne.gfm.url=W(ne.gfm.url,"i").replace("email",ne.gfm._extended_email).getRegex(),ne.breaks=Y({},ne.gfm,{br:W(ne.br).replace("{2,}","*").getRegex(),text:W(ne.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var J={block:ie,inline:ne},K=B,oe=y.exports.defaults,fe=J.block,pe=J.inline,Te=M.repeatString;function xe(Le){return Le.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function Ge(Le){var Ae="",De,ce,de=Le.length;for(De=0;De<de;De++)ce=Le.charCodeAt(De),Math.random()>.5&&(ce="x"+ce.toString(16)),Ae+="&#"+ce+";";return Ae}var Qe=function(){function Le(De){this.tokens=[],this.tokens.links=Object.create(null),this.options=De||oe,this.options.tokenizer=this.options.tokenizer||new K,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var ce={block:fe.normal,inline:pe.normal};this.options.pedantic?(ce.block=fe.pedantic,ce.inline=pe.pedantic):this.options.gfm&&(ce.block=fe.gfm,this.options.breaks?ce.inline=pe.breaks:ce.inline=pe.gfm),this.tokenizer.rules=ce}Le.lex=function(ce,de){var be=new Le(de);return be.lex(ce)},Le.lexInline=function(ce,de){var be=new Le(de);return be.inlineTokens(ce)};var Ae=Le.prototype;return Ae.lex=function(ce){ce=ce.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(ce,this.tokens);for(var de;de=this.inlineQueue.shift();)this.inlineTokens(de.src,de.tokens);return this.tokens},Ae.blockTokens=function(ce,de){var be=this;de===void 0&&(de=[]),this.options.pedantic&&(ce=ce.replace(/^ +$/gm,""));for(var Ce,Oe,Ke,$e;ce;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(lt){return(Ce=lt.call({lexer:be},ce,de))?(ce=ce.substring(Ce.raw.length),de.push(Ce),!0):!1}))){if(Ce=this.tokenizer.space(ce)){ce=ce.substring(Ce.raw.length),Ce.type&&de.push(Ce);continue}if(Ce=this.tokenizer.code(ce)){ce=ce.substring(Ce.raw.length),Oe=de[de.length-1],Oe&&(Oe.type==="paragraph"||Oe.type==="text")?(Oe.raw+=`
`+Ce.raw,Oe.text+=`
`+Ce.text,this.inlineQueue[this.inlineQueue.length-1].src=Oe.text):de.push(Ce);continue}if(Ce=this.tokenizer.fences(ce)){ce=ce.substring(Ce.raw.length),de.push(Ce);continue}if(Ce=this.tokenizer.heading(ce)){ce=ce.substring(Ce.raw.length),de.push(Ce);continue}if(Ce=this.tokenizer.hr(ce)){ce=ce.substring(Ce.raw.length),de.push(Ce);continue}if(Ce=this.tokenizer.blockquote(ce)){ce=ce.substring(Ce.raw.length),de.push(Ce);continue}if(Ce=this.tokenizer.list(ce)){ce=ce.substring(Ce.raw.length),de.push(Ce);continue}if(Ce=this.tokenizer.html(ce)){ce=ce.substring(Ce.raw.length),de.push(Ce);continue}if(Ce=this.tokenizer.def(ce)){ce=ce.substring(Ce.raw.length),Oe=de[de.length-1],Oe&&(Oe.type==="paragraph"||Oe.type==="text")?(Oe.raw+=`
`+Ce.raw,Oe.text+=`
`+Ce.raw,this.inlineQueue[this.inlineQueue.length-1].src=Oe.text):this.tokens.links[Ce.tag]||(this.tokens.links[Ce.tag]={href:Ce.href,title:Ce.title});continue}if(Ce=this.tokenizer.table(ce)){ce=ce.substring(Ce.raw.length),de.push(Ce);continue}if(Ce=this.tokenizer.lheading(ce)){ce=ce.substring(Ce.raw.length),de.push(Ce);continue}if(Ke=ce,this.options.extensions&&this.options.extensions.startBlock&&function(){var lt=1/0,ct=ce.slice(1),He=void 0;be.options.extensions.startBlock.forEach(function(Ee){He=Ee.call({lexer:this},ct),typeof He=="number"&&He>=0&&(lt=Math.min(lt,He))}),lt<1/0&&lt>=0&&(Ke=ce.substring(0,lt+1))}(),this.state.top&&(Ce=this.tokenizer.paragraph(Ke))){Oe=de[de.length-1],$e&&Oe.type==="paragraph"?(Oe.raw+=`
`+Ce.raw,Oe.text+=`
`+Ce.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Oe.text):de.push(Ce),$e=Ke.length!==ce.length,ce=ce.substring(Ce.raw.length);continue}if(Ce=this.tokenizer.text(ce)){ce=ce.substring(Ce.raw.length),Oe=de[de.length-1],Oe&&Oe.type==="text"?(Oe.raw+=`
`+Ce.raw,Oe.text+=`
`+Ce.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Oe.text):de.push(Ce);continue}if(ce){var Ze="Infinite loop on byte: "+ce.charCodeAt(0);if(this.options.silent){console.error(Ze);break}else throw new Error(Ze)}}return this.state.top=!0,de},Ae.inline=function(ce,de){this.inlineQueue.push({src:ce,tokens:de})},Ae.inlineTokens=function(ce,de){var be=this;de===void 0&&(de=[]);var Ce,Oe,Ke,$e=ce,Ze,lt,ct;if(this.tokens.links){var He=Object.keys(this.tokens.links);if(He.length>0)for(;(Ze=this.tokenizer.rules.inline.reflinkSearch.exec($e))!=null;)He.includes(Ze[0].slice(Ze[0].lastIndexOf("[")+1,-1))&&($e=$e.slice(0,Ze.index)+"["+Te("a",Ze[0].length-2)+"]"+$e.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ze=this.tokenizer.rules.inline.blockSkip.exec($e))!=null;)$e=$e.slice(0,Ze.index)+"["+Te("a",Ze[0].length-2)+"]"+$e.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ze=this.tokenizer.rules.inline.escapedEmSt.exec($e))!=null;)$e=$e.slice(0,Ze.index)+"++"+$e.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ce;)if(lt||(ct=""),lt=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(_e){return(Ce=_e.call({lexer:be},ce,de))?(ce=ce.substring(Ce.raw.length),de.push(Ce),!0):!1}))){if(Ce=this.tokenizer.escape(ce)){ce=ce.substring(Ce.raw.length),de.push(Ce);continue}if(Ce=this.tokenizer.tag(ce)){ce=ce.substring(Ce.raw.length),Oe=de[de.length-1],Oe&&Ce.type==="text"&&Oe.type==="text"?(Oe.raw+=Ce.raw,Oe.text+=Ce.text):de.push(Ce);continue}if(Ce=this.tokenizer.link(ce)){ce=ce.substring(Ce.raw.length),de.push(Ce);continue}if(Ce=this.tokenizer.reflink(ce,this.tokens.links)){ce=ce.substring(Ce.raw.length),Oe=de[de.length-1],Oe&&Ce.type==="text"&&Oe.type==="text"?(Oe.raw+=Ce.raw,Oe.text+=Ce.text):de.push(Ce);continue}if(Ce=this.tokenizer.emStrong(ce,$e,ct)){ce=ce.substring(Ce.raw.length),de.push(Ce);continue}if(Ce=this.tokenizer.codespan(ce)){ce=ce.substring(Ce.raw.length),de.push(Ce);continue}if(Ce=this.tokenizer.br(ce)){ce=ce.substring(Ce.raw.length),de.push(Ce);continue}if(Ce=this.tokenizer.del(ce)){ce=ce.substring(Ce.raw.length),de.push(Ce);continue}if(Ce=this.tokenizer.autolink(ce,Ge)){ce=ce.substring(Ce.raw.length),de.push(Ce);continue}if(!this.state.inLink&&(Ce=this.tokenizer.url(ce,Ge))){ce=ce.substring(Ce.raw.length),de.push(Ce);continue}if(Ke=ce,this.options.extensions&&this.options.extensions.startInline&&function(){var _e=1/0,he=ce.slice(1),X=void 0;be.options.extensions.startInline.forEach(function(Ie){X=Ie.call({lexer:this},he),typeof X=="number"&&X>=0&&(_e=Math.min(_e,X))}),_e<1/0&&_e>=0&&(Ke=ce.substring(0,_e+1))}(),Ce=this.tokenizer.inlineText(Ke,xe)){ce=ce.substring(Ce.raw.length),Ce.raw.slice(-1)!=="_"&&(ct=Ce.raw.slice(-1)),lt=!0,Oe=de[de.length-1],Oe&&Oe.type==="text"?(Oe.raw+=Ce.raw,Oe.text+=Ce.text):de.push(Ce);continue}if(ce){var Ee="Infinite loop on byte: "+ce.charCodeAt(0);if(this.options.silent){console.error(Ee);break}else throw new Error(Ee)}}return de},e(Le,null,[{key:"rules",get:function(){return{block:fe,inline:pe}}}]),Le}(),q=y.exports.defaults,te=M.cleanUrl,G=M.escape,Q=function(){function Le(De){this.options=De||q}var Ae=Le.prototype;return Ae.code=function(ce,de,be){var Ce=(de||"").match(/\S*/)[0];if(this.options.highlight){var Oe=this.options.highlight(ce,Ce);Oe!=null&&Oe!==ce&&(be=!0,ce=Oe)}return ce=ce.replace(/\n$/,"")+`
`,Ce?'<pre><code class="'+this.options.langPrefix+G(Ce,!0)+'">'+(be?ce:G(ce,!0))+`</code></pre>
`:"<pre><code>"+(be?ce:G(ce,!0))+`</code></pre>
`},Ae.blockquote=function(ce){return`<blockquote>
`+ce+`</blockquote>
`},Ae.html=function(ce){return ce},Ae.heading=function(ce,de,be,Ce){return this.options.headerIds?"<h"+de+' id="'+this.options.headerPrefix+Ce.slug(be)+'">'+ce+"</h"+de+`>
`:"<h"+de+">"+ce+"</h"+de+`>
`},Ae.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},Ae.list=function(ce,de,be){var Ce=de?"ol":"ul",Oe=de&&be!==1?' start="'+be+'"':"";return"<"+Ce+Oe+`>
`+ce+"</"+Ce+`>
`},Ae.listitem=function(ce){return"<li>"+ce+`</li>
`},Ae.checkbox=function(ce){return"<input "+(ce?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},Ae.paragraph=function(ce){return"<p>"+ce+`</p>
`},Ae.table=function(ce,de){return de&&(de="<tbody>"+de+"</tbody>"),`<table>
<thead>
`+ce+`</thead>
`+de+`</table>
`},Ae.tablerow=function(ce){return`<tr>
`+ce+`</tr>
`},Ae.tablecell=function(ce,de){var be=de.header?"th":"td",Ce=de.align?"<"+be+' align="'+de.align+'">':"<"+be+">";return Ce+ce+"</"+be+`>
`},Ae.strong=function(ce){return"<strong>"+ce+"</strong>"},Ae.em=function(ce){return"<em>"+ce+"</em>"},Ae.codespan=function(ce){return"<code>"+ce+"</code>"},Ae.br=function(){return this.options.xhtml?"<br/>":"<br>"},Ae.del=function(ce){return"<del>"+ce+"</del>"},Ae.link=function(ce,de,be){if(ce=te(this.options.sanitize,this.options.baseUrl,ce),ce===null)return be;var Ce='<a href="'+G(ce)+'"';return de&&(Ce+=' title="'+de+'"'),Ce+=">"+be+"</a>",Ce},Ae.image=function(ce,de,be){if(ce=te(this.options.sanitize,this.options.baseUrl,ce),ce===null)return be;var Ce='<img src="'+ce+'" alt="'+be+'"';return de&&(Ce+=' title="'+de+'"'),Ce+=this.options.xhtml?"/>":">",Ce},Ae.text=function(ce){return ce},Le}(),ae=function(){function Le(){}var Ae=Le.prototype;return Ae.strong=function(ce){return ce},Ae.em=function(ce){return ce},Ae.codespan=function(ce){return ce},Ae.del=function(ce){return ce},Ae.html=function(ce){return ce},Ae.text=function(ce){return ce},Ae.link=function(ce,de,be){return""+be},Ae.image=function(ce,de,be){return""+be},Ae.br=function(){return""},Le}(),me=function(){function Le(){this.seen={}}var Ae=Le.prototype;return Ae.serialize=function(ce){return ce.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},Ae.getNextSafeSlug=function(ce,de){var be=ce,Ce=0;if(this.seen.hasOwnProperty(be)){Ce=this.seen[ce];do Ce++,be=ce+"-"+Ce;while(this.seen.hasOwnProperty(be))}return de||(this.seen[ce]=Ce,this.seen[be]=0),be},Ae.slug=function(ce,de){de===void 0&&(de={});var be=this.serialize(ce);return this.getNextSafeSlug(be,de.dryrun)},Le}(),ke=Q,We=ae,Je=me,it=y.exports.defaults,st=M.unescape,ot=function(){function Le(De){this.options=De||it,this.options.renderer=this.options.renderer||new ke,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new We,this.slugger=new Je}Le.parse=function(ce,de){var be=new Le(de);return be.parse(ce)},Le.parseInline=function(ce,de){var be=new Le(de);return be.parseInline(ce)};var Ae=Le.prototype;return Ae.parse=function(ce,de){de===void 0&&(de=!0);var be="",Ce,Oe,Ke,$e,Ze,lt,ct,He,Ee,_e,he,X,Ie,Ne,Ye,Xe,pt,St,yt,ft=ce.length;for(Ce=0;Ce<ft;Ce++){if(_e=ce[Ce],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[_e.type]&&(yt=this.options.extensions.renderers[_e.type].call({parser:this},_e),yt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(_e.type))){be+=yt||"";continue}switch(_e.type){case"space":continue;case"hr":{be+=this.renderer.hr();continue}case"heading":{be+=this.renderer.heading(this.parseInline(_e.tokens),_e.depth,st(this.parseInline(_e.tokens,this.textRenderer)),this.slugger);continue}case"code":{be+=this.renderer.code(_e.text,_e.lang,_e.escaped);continue}case"table":{for(He="",ct="",$e=_e.header.length,Oe=0;Oe<$e;Oe++)ct+=this.renderer.tablecell(this.parseInline(_e.header[Oe].tokens),{header:!0,align:_e.align[Oe]});for(He+=this.renderer.tablerow(ct),Ee="",$e=_e.rows.length,Oe=0;Oe<$e;Oe++){for(lt=_e.rows[Oe],ct="",Ze=lt.length,Ke=0;Ke<Ze;Ke++)ct+=this.renderer.tablecell(this.parseInline(lt[Ke].tokens),{header:!1,align:_e.align[Ke]});Ee+=this.renderer.tablerow(ct)}be+=this.renderer.table(He,Ee);continue}case"blockquote":{Ee=this.parse(_e.tokens),be+=this.renderer.blockquote(Ee);continue}case"list":{for(he=_e.ordered,X=_e.start,Ie=_e.loose,$e=_e.items.length,Ee="",Oe=0;Oe<$e;Oe++)Ye=_e.items[Oe],Xe=Ye.checked,pt=Ye.task,Ne="",Ye.task&&(St=this.renderer.checkbox(Xe),Ie?Ye.tokens.length>0&&Ye.tokens[0].type==="paragraph"?(Ye.tokens[0].text=St+" "+Ye.tokens[0].text,Ye.tokens[0].tokens&&Ye.tokens[0].tokens.length>0&&Ye.tokens[0].tokens[0].type==="text"&&(Ye.tokens[0].tokens[0].text=St+" "+Ye.tokens[0].tokens[0].text)):Ye.tokens.unshift({type:"text",text:St}):Ne+=St),Ne+=this.parse(Ye.tokens,Ie),Ee+=this.renderer.listitem(Ne,pt,Xe);be+=this.renderer.list(Ee,he,X);continue}case"html":{be+=this.renderer.html(_e.text);continue}case"paragraph":{be+=this.renderer.paragraph(this.parseInline(_e.tokens));continue}case"text":{for(Ee=_e.tokens?this.parseInline(_e.tokens):_e.text;Ce+1<ft&&ce[Ce+1].type==="text";)_e=ce[++Ce],Ee+=`
`+(_e.tokens?this.parseInline(_e.tokens):_e.text);be+=de?this.renderer.paragraph(Ee):Ee;continue}default:{var wt='Token with "'+_e.type+'" type was not found.';if(this.options.silent){console.error(wt);return}else throw new Error(wt)}}}return be},Ae.parseInline=function(ce,de){de=de||this.renderer;var be="",Ce,Oe,Ke,$e=ce.length;for(Ce=0;Ce<$e;Ce++){if(Oe=ce[Ce],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Oe.type]&&(Ke=this.options.extensions.renderers[Oe.type].call({parser:this},Oe),Ke!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Oe.type))){be+=Ke||"";continue}switch(Oe.type){case"escape":{be+=de.text(Oe.text);break}case"html":{be+=de.html(Oe.text);break}case"link":{be+=de.link(Oe.href,Oe.title,this.parseInline(Oe.tokens,de));break}case"image":{be+=de.image(Oe.href,Oe.title,Oe.text);break}case"strong":{be+=de.strong(this.parseInline(Oe.tokens,de));break}case"em":{be+=de.em(this.parseInline(Oe.tokens,de));break}case"codespan":{be+=de.codespan(Oe.text);break}case"br":{be+=de.br();break}case"del":{be+=de.del(this.parseInline(Oe.tokens,de));break}case"text":{be+=de.text(Oe.text);break}default:{var Ze='Token with "'+Oe.type+'" type was not found.';if(this.options.silent){console.error(Ze);return}else throw new Error(Ze)}}}return be},Le}(),tt=Qe,rt=ot,gt=B,Ue=Q,It=ae,ee=me,re=M.merge,Se=M.checkSanitizeDeprecation,se=M.escape,ye=y.exports.getDefaults,Me=y.exports.changeDefaults,qe=y.exports.defaults;function Ve(Le,Ae,De){if(typeof Le=="undefined"||Le===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Le!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Le)+", string expected");if(typeof Ae=="function"&&(De=Ae,Ae=null),Ae=re({},Ve.defaults,Ae||{}),Se(Ae),De){var ce=Ae.highlight,de;try{de=tt.lex(Le,Ae)}catch(Ke){return De(Ke)}var be=function($e){var Ze;if(!$e)try{Ae.walkTokens&&Ve.walkTokens(de,Ae.walkTokens),Ze=rt.parse(de,Ae)}catch(lt){$e=lt}return Ae.highlight=ce,$e?De($e):De(null,Ze)};if(!ce||ce.length<3||(delete Ae.highlight,!de.length))return be();var Ce=0;Ve.walkTokens(de,function(Ke){Ke.type==="code"&&(Ce++,setTimeout(function(){ce(Ke.text,Ke.lang,function($e,Ze){if($e)return be($e);Ze!=null&&Ze!==Ke.text&&(Ke.text=Ze,Ke.escaped=!0),Ce--,Ce===0&&be()})},0))}),Ce===0&&be();return}try{var Oe=tt.lex(Le,Ae);return Ae.walkTokens&&Ve.walkTokens(Oe,Ae.walkTokens),rt.parse(Oe,Ae)}catch(Ke){if(Ke.message+=`
Please report this to https://github.com/markedjs/marked.`,Ae.silent)return"<p>An error occurred:</p><pre>"+se(Ke.message+"",!0)+"</pre>";throw Ke}}Ve.options=Ve.setOptions=function(Le){return re(Ve.defaults,Le),Me(Ve.defaults),Ve},Ve.getDefaults=ye,Ve.defaults=qe,Ve.use=function(){for(var Le=this,Ae=arguments.length,De=new Array(Ae),ce=0;ce<Ae;ce++)De[ce]=arguments[ce];var de=re.apply(void 0,[{}].concat(De)),be=Ve.defaults.extensions||{renderers:{},childTokens:{}},Ce;De.forEach(function(Oe){if(Oe.extensions&&(Ce=!0,Oe.extensions.forEach(function($e){if(!$e.name)throw new Error("extension name required");if($e.renderer){var Ze=be.renderers?be.renderers[$e.name]:null;Ze?be.renderers[$e.name]=function(){for(var lt=arguments.length,ct=new Array(lt),He=0;He<lt;He++)ct[He]=arguments[He];var Ee=$e.renderer.apply(this,ct);return Ee===!1&&(Ee=Ze.apply(this,ct)),Ee}:be.renderers[$e.name]=$e.renderer}if($e.tokenizer){if(!$e.level||$e.level!=="block"&&$e.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");be[$e.level]?be[$e.level].unshift($e.tokenizer):be[$e.level]=[$e.tokenizer],$e.start&&($e.level==="block"?be.startBlock?be.startBlock.push($e.start):be.startBlock=[$e.start]:$e.level==="inline"&&(be.startInline?be.startInline.push($e.start):be.startInline=[$e.start]))}$e.childTokens&&(be.childTokens[$e.name]=$e.childTokens)})),Oe.renderer&&function(){var $e=Ve.defaults.renderer||new Ue,Ze=function(He){var Ee=$e[He];$e[He]=function(){for(var _e=arguments.length,he=new Array(_e),X=0;X<_e;X++)he[X]=arguments[X];var Ie=Oe.renderer[He].apply($e,he);return Ie===!1&&(Ie=Ee.apply($e,he)),Ie}};for(var lt in Oe.renderer)Ze(lt);de.renderer=$e}(),Oe.tokenizer&&function(){var $e=Ve.defaults.tokenizer||new gt,Ze=function(He){var Ee=$e[He];$e[He]=function(){for(var _e=arguments.length,he=new Array(_e),X=0;X<_e;X++)he[X]=arguments[X];var Ie=Oe.tokenizer[He].apply($e,he);return Ie===!1&&(Ie=Ee.apply($e,he)),Ie}};for(var lt in Oe.tokenizer)Ze(lt);de.tokenizer=$e}(),Oe.walkTokens){var Ke=Ve.defaults.walkTokens;de.walkTokens=function($e){Oe.walkTokens.call(Le,$e),Ke&&Ke($e)}}Ce&&(de.extensions=be),Ve.setOptions(de)})},Ve.walkTokens=function(Le,Ae){for(var De=function(){var Ce=de.value;switch(Ae(Ce),Ce.type){case"table":{for(var Oe=I(Ce.header),Ke;!(Ke=Oe()).done;){var $e=Ke.value;Ve.walkTokens($e.tokens,Ae)}for(var Ze=I(Ce.rows),lt;!(lt=Ze()).done;)for(var ct=lt.value,He=I(ct),Ee;!(Ee=He()).done;){var _e=Ee.value;Ve.walkTokens(_e.tokens,Ae)}break}case"list":{Ve.walkTokens(Ce.items,Ae);break}default:Ve.defaults.extensions&&Ve.defaults.extensions.childTokens&&Ve.defaults.extensions.childTokens[Ce.type]?Ve.defaults.extensions.childTokens[Ce.type].forEach(function(he){Ve.walkTokens(Ce[he],Ae)}):Ce.tokens&&Ve.walkTokens(Ce.tokens,Ae)}},ce=I(Le),de;!(de=ce()).done;)De()},Ve.parseInline=function(Le,Ae){if(typeof Le=="undefined"||Le===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Le!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Le)+", string expected");Ae=re({},Ve.defaults,Ae||{}),Se(Ae);try{var De=tt.lexInline(Le,Ae);return Ae.walkTokens&&Ve.walkTokens(De,Ae.walkTokens),rt.parseInline(De,Ae)}catch(ce){if(ce.message+=`
Please report this to https://github.com/markedjs/marked.`,Ae.silent)return"<p>An error occurred:</p><pre>"+se(ce.message+"",!0)+"</pre>";throw ce}},Ve.Parser=rt,Ve.parser=rt.parse,Ve.Renderer=Ue,Ve.TextRenderer=It,Ve.Lexer=tt,Ve.lexer=tt.lex,Ve.Tokenizer=gt,Ve.Slugger=ee,Ve.parse=Ve;var ut=Ve;return ut}),define(ve[94],we([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function h(k,D,P){return Math.min(Math.max(k,D),P)}e.clamp=h;function t(k,D){return(D+k%D)%D}e.rot=t;class I{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=I;class y{constructor(){this._n=1,this._val=0}update(D){return this._val=this._val+(D-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=y;class R{constructor(D){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(D),this._values.fill(0,0,D)}update(D){const P=this._values[this._index];return this._values[this._index]=D,this._index=(this._index+1)%this._values.length,this._sum-=P,this._sum+=D,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=R}),function(){function Z(I){const y=[];typeof I=="number"&&y.push("code/timeOrigin",I);function R(D){y.push(D,Date.now())}function k(){const D=[];for(let P=0;P<y.length;P+=2)D.push({name:y[P],startTime:y[P+1]});return D}return{mark:R,getMarks:k}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?Z():{mark(I){performance.mark(I)},getMarks(){let I=performance.timeOrigin;typeof I!="number"&&(I=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const y=[{name:"code/timeOrigin",startTime:Math.round(I)}];for(const R of performance.getEntriesByType("mark"))y.push({name:R.name,startTime:Math.round(I+R.startTime)});return y}};if(typeof process=="object"){const I=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Z(I)}else return console.trace("perf-util loaded in UNKNOWN environment"),Z()}function h(I){return I.MonacoPerformanceMarks||(I.MonacoPerformanceMarks=e()),I.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return h(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=h(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=h(t))}(),define(ve[11],we([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const h="en";let t=!1,I=!1,y=!1,R=!1,k=!1,D=!1,P=!1,L=!1,C,l=h,E,p;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let m;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?m=e.globals.vscode.process:typeof process!="undefined"&&(m=process);const b=typeof m?.versions?.electron=="string",F=b&&m?.type==="renderer";if(e.isElectronSandboxed=F&&m?.sandboxed,typeof navigator=="object"&&!F)p=navigator.userAgent,t=p.indexOf("Windows")>=0,I=p.indexOf("Macintosh")>=0,L=(p.indexOf("Macintosh")>=0||p.indexOf("iPad")>=0||p.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,y=p.indexOf("Linux")>=0,D=!0,C=navigator.language,l=C;else if(typeof m=="object"){t=m.platform==="win32",I=m.platform==="darwin",y=m.platform==="linux",R=y&&!!m.env.SNAP&&!!m.env.SNAP_REVISION,P=b,C=h,l=h;const r=m.env.VSCODE_NLS_CONFIG;if(r)try{const c=JSON.parse(r),a=c.availableLanguages["*"];C=c.locale,l=a||h,E=c._translationsConfigFile}catch{}k=!0}else console.error("Unable to resolve platform.");var _;(function(r){r[r.Web=0]="Web",r[r.Mac=1]="Mac",r[r.Linux=2]="Linux",r[r.Windows=3]="Windows"})(_=e.Platform||(e.Platform={}));function g(r){switch(r){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=g;let s=0;I?s=1:t?s=3:y&&(s=2),e.isWindows=t,e.isMacintosh=I,e.isLinux=y,e.isLinuxSnap=R,e.isNative=k,e.isElectron=P,e.isWeb=D,e.isIOS=L,e.platform=s,e.userAgent=p,e.language=l;var d;(function(r){function c(){return e.language}r.value=c;function a(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}r.isDefaultVariant=a;function u(){return e.language==="en"}r.isDefault=u})(d=e.Language||(e.Language={})),e.locale=C,e.translationsConfigFile=E,e.setTimeout0=(()=>{if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let r=[];e.globals.addEventListener("message",a=>{if(a.data&&a.data.vscodeScheduleAsyncWork)for(let u=0,f=r.length;u<f;u++){const v=r[u];if(v.id===a.data.vscodeScheduleAsyncWork){r.splice(u,1),v.callback();return}}});let c=0;return a=>{const u=++c;r.push({id:u,callback:a}),e.globals.postMessage({vscodeScheduleAsyncWork:u},"*")}}return r=>setTimeout(r)})();var n;(function(r){r[r.Windows=1]="Windows",r[r.Macintosh=2]="Macintosh",r[r.Linux=3]="Linux"})(n=e.OperatingSystem||(e.OperatingSystem={})),e.OS=I||L?2:t?1:3;let S=!0,o=!1;function i(){if(!o){o=!0;const r=new Uint8Array(2);r[0]=1,r[1]=2,S=new Uint16Array(r.buffer)[0]===(2<<8)+1}return S}e.isLittleEndian=i,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(ve[40],we([0,1,11]),function(Z,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;if(typeof h.globals.vscode!="undefined"&&typeof h.globals.vscode.process!="undefined"){const I=h.globals.vscode.process;t={get platform(){return I.platform},get arch(){return I.arch},get env(){return I.env},cwd(){return I.cwd()}}}else typeof process!="undefined"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return h.isWindows?"win32":h.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch}),define(ve[9],we([0,1,40]),function(Z,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const t=65,I=97,y=90,R=122,k=46,D=47,P=92,L=58,C=63;class l extends Error{constructor(s,d,n){let S;typeof d=="string"&&d.indexOf("not ")===0?(S="must not be",d=d.replace(/^not /,"")):S="must be";const o=s.indexOf(".")!==-1?"property":"argument";let i=`The "${s}" ${o} ${S} of type ${d}`;i+=`. Received type ${typeof n}`;super(i);this.code="ERR_INVALID_ARG_TYPE"}}function E(g,s){if(typeof g!="string")throw new l(s,"string",g)}function p(g){return g===D||g===P}function m(g){return g===D}function b(g){return g>=t&&g<=y||g>=I&&g<=R}function F(g,s,d,n){let S="",o=0,i=-1,r=0,c=0;for(let a=0;a<=g.length;++a){if(a<g.length)c=g.charCodeAt(a);else{if(n(c))break;c=D}if(n(c)){if(!(i===a-1||r===1))if(r===2){if(S.length<2||o!==2||S.charCodeAt(S.length-1)!==k||S.charCodeAt(S.length-2)!==k){if(S.length>2){const u=S.lastIndexOf(d);u===-1?(S="",o=0):(S=S.slice(0,u),o=S.length-1-S.lastIndexOf(d)),i=a,r=0;continue}else if(S.length!==0){S="",o=0,i=a,r=0;continue}}s&&(S+=S.length>0?`${d}..`:"..",o=2)}else S.length>0?S+=`${d}${g.slice(i+1,a)}`:S=g.slice(i+1,a),o=a-i-1;i=a,r=0}else c===k&&r!==-1?++r:r=-1}return S}function _(g,s){if(s===null||typeof s!="object")throw new l("pathObject","Object",s);const d=s.dir||s.root,n=s.base||`${s.name||""}${s.ext||""}`;return d?d===s.root?`${d}${n}`:`${d}${g}${n}`:n}e.win32={resolve(...g){let s="",d="",n=!1;for(let S=g.length-1;S>=-1;S--){let o;if(S>=0){if(o=g[S],E(o,"path"),o.length===0)continue}else s.length===0?o=h.cwd():(o=h.env[`=${s}`]||h.cwd(),(o===void 0||o.slice(0,2).toLowerCase()!==s.toLowerCase()&&o.charCodeAt(2)===P)&&(o=`${s}\\`));const i=o.length;let r=0,c="",a=!1;const u=o.charCodeAt(0);if(i===1)p(u)&&(r=1,a=!0);else if(p(u))if(a=!0,p(o.charCodeAt(1))){let f=2,v=f;for(;f<i&&!p(o.charCodeAt(f));)f++;if(f<i&&f!==v){const w=o.slice(v,f);for(v=f;f<i&&p(o.charCodeAt(f));)f++;if(f<i&&f!==v){for(v=f;f<i&&!p(o.charCodeAt(f));)f++;(f===i||f!==v)&&(c=`\\\\${w}\\${o.slice(v,f)}`,r=f)}}}else r=1;else b(u)&&o.charCodeAt(1)===L&&(c=o.slice(0,2),r=2,i>2&&p(o.charCodeAt(2))&&(a=!0,r=3));if(c.length>0)if(s.length>0){if(c.toLowerCase()!==s.toLowerCase())continue}else s=c;if(n){if(s.length>0)break}else if(d=`${o.slice(r)}\\${d}`,n=a,a&&s.length>0)break}return d=F(d,!n,"\\",p),n?`${s}\\${d}`:`${s}${d}`||"."},normalize(g){E(g,"path");const s=g.length;if(s===0)return".";let d=0,n,S=!1;const o=g.charCodeAt(0);if(s===1)return m(o)?"\\":g;if(p(o))if(S=!0,p(g.charCodeAt(1))){let r=2,c=r;for(;r<s&&!p(g.charCodeAt(r));)r++;if(r<s&&r!==c){const a=g.slice(c,r);for(c=r;r<s&&p(g.charCodeAt(r));)r++;if(r<s&&r!==c){for(c=r;r<s&&!p(g.charCodeAt(r));)r++;if(r===s)return`\\\\${a}\\${g.slice(c)}\\`;r!==c&&(n=`\\\\${a}\\${g.slice(c,r)}`,d=r)}}}else d=1;else b(o)&&g.charCodeAt(1)===L&&(n=g.slice(0,2),d=2,s>2&&p(g.charCodeAt(2))&&(S=!0,d=3));let i=d<s?F(g.slice(d),!S,"\\",p):"";return i.length===0&&!S&&(i="."),i.length>0&&p(g.charCodeAt(s-1))&&(i+="\\"),n===void 0?S?`\\${i}`:i:S?`${n}\\${i}`:`${n}${i}`},isAbsolute(g){E(g,"path");const s=g.length;if(s===0)return!1;const d=g.charCodeAt(0);return p(d)||s>2&&b(d)&&g.charCodeAt(1)===L&&p(g.charCodeAt(2))},join(...g){if(g.length===0)return".";let s,d;for(let o=0;o<g.length;++o){const i=g[o];E(i,"path"),i.length>0&&(s===void 0?s=d=i:s+=`\\${i}`)}if(s===void 0)return".";let n=!0,S=0;if(typeof d=="string"&&p(d.charCodeAt(0))){++S;const o=d.length;o>1&&p(d.charCodeAt(1))&&(++S,o>2&&(p(d.charCodeAt(2))?++S:n=!1))}if(n){for(;S<s.length&&p(s.charCodeAt(S));)S++;S>=2&&(s=`\\${s.slice(S)}`)}return e.win32.normalize(s)},relative(g,s){if(E(g,"from"),E(s,"to"),g===s)return"";const d=e.win32.resolve(g),n=e.win32.resolve(s);if(d===n||(g=d.toLowerCase(),s=n.toLowerCase(),g===s))return"";let S=0;for(;S<g.length&&g.charCodeAt(S)===P;)S++;let o=g.length;for(;o-1>S&&g.charCodeAt(o-1)===P;)o--;const i=o-S;let r=0;for(;r<s.length&&s.charCodeAt(r)===P;)r++;let c=s.length;for(;c-1>r&&s.charCodeAt(c-1)===P;)c--;const a=c-r,u=i<a?i:a;let f=-1,v=0;for(;v<u;v++){const A=g.charCodeAt(S+v);if(A!==s.charCodeAt(r+v))break;A===P&&(f=v)}if(v!==u){if(f===-1)return n}else{if(a>u){if(s.charCodeAt(r+v)===P)return n.slice(r+v+1);if(v===2)return n.slice(r+v)}i>u&&(g.charCodeAt(S+v)===P?f=v:v===2&&(f=3)),f===-1&&(f=0)}let w="";for(v=S+f+1;v<=o;++v)(v===o||g.charCodeAt(v)===P)&&(w+=w.length===0?"..":"\\..");return r+=f,w.length>0?`${w}${n.slice(r,c)}`:(n.charCodeAt(r)===P&&++r,n.slice(r,c))},toNamespacedPath(g){if(typeof g!="string")return g;if(g.length===0)return"";const s=e.win32.resolve(g);if(s.length<=2)return g;if(s.charCodeAt(0)===P){if(s.charCodeAt(1)===P){const d=s.charCodeAt(2);if(d!==C&&d!==k)return`\\\\?\\UNC\\${s.slice(2)}`}}else if(b(s.charCodeAt(0))&&s.charCodeAt(1)===L&&s.charCodeAt(2)===P)return`\\\\?\\${s}`;return g},dirname(g){E(g,"path");const s=g.length;if(s===0)return".";let d=-1,n=0;const S=g.charCodeAt(0);if(s===1)return p(S)?g:".";if(p(S)){if(d=n=1,p(g.charCodeAt(1))){let r=2,c=r;for(;r<s&&!p(g.charCodeAt(r));)r++;if(r<s&&r!==c){for(c=r;r<s&&p(g.charCodeAt(r));)r++;if(r<s&&r!==c){for(c=r;r<s&&!p(g.charCodeAt(r));)r++;if(r===s)return g;r!==c&&(d=n=r+1)}}}}else b(S)&&g.charCodeAt(1)===L&&(d=s>2&&p(g.charCodeAt(2))?3:2,n=d);let o=-1,i=!0;for(let r=s-1;r>=n;--r)if(p(g.charCodeAt(r))){if(!i){o=r;break}}else i=!1;if(o===-1){if(d===-1)return".";o=d}return g.slice(0,o)},basename(g,s){s!==void 0&&E(s,"ext"),E(g,"path");let d=0,n=-1,S=!0,o;if(g.length>=2&&b(g.charCodeAt(0))&&g.charCodeAt(1)===L&&(d=2),s!==void 0&&s.length>0&&s.length<=g.length){if(s===g)return"";let i=s.length-1,r=-1;for(o=g.length-1;o>=d;--o){const c=g.charCodeAt(o);if(p(c)){if(!S){d=o+1;break}}else r===-1&&(S=!1,r=o+1),i>=0&&(c===s.charCodeAt(i)?--i==-1&&(n=o):(i=-1,n=r))}return d===n?n=r:n===-1&&(n=g.length),g.slice(d,n)}for(o=g.length-1;o>=d;--o)if(p(g.charCodeAt(o))){if(!S){d=o+1;break}}else n===-1&&(S=!1,n=o+1);return n===-1?"":g.slice(d,n)},extname(g){E(g,"path");let s=0,d=-1,n=0,S=-1,o=!0,i=0;g.length>=2&&g.charCodeAt(1)===L&&b(g.charCodeAt(0))&&(s=n=2);for(let r=g.length-1;r>=s;--r){const c=g.charCodeAt(r);if(p(c)){if(!o){n=r+1;break}continue}S===-1&&(o=!1,S=r+1),c===k?d===-1?d=r:i!==1&&(i=1):d!==-1&&(i=-1)}return d===-1||S===-1||i===0||i===1&&d===S-1&&d===n+1?"":g.slice(d,S)},format:_.bind(null,"\\"),parse(g){E(g,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(g.length===0)return s;const d=g.length;let n=0,S=g.charCodeAt(0);if(d===1)return p(S)?(s.root=s.dir=g,s):(s.base=s.name=g,s);if(p(S)){if(n=1,p(g.charCodeAt(1))){let f=2,v=f;for(;f<d&&!p(g.charCodeAt(f));)f++;if(f<d&&f!==v){for(v=f;f<d&&p(g.charCodeAt(f));)f++;if(f<d&&f!==v){for(v=f;f<d&&!p(g.charCodeAt(f));)f++;f===d?n=f:f!==v&&(n=f+1)}}}}else if(b(S)&&g.charCodeAt(1)===L){if(d<=2)return s.root=s.dir=g,s;if(n=2,p(g.charCodeAt(2))){if(d===3)return s.root=s.dir=g,s;n=3}}n>0&&(s.root=g.slice(0,n));let o=-1,i=n,r=-1,c=!0,a=g.length-1,u=0;for(;a>=n;--a){if(S=g.charCodeAt(a),p(S)){if(!c){i=a+1;break}continue}r===-1&&(c=!1,r=a+1),S===k?o===-1?o=a:u!==1&&(u=1):o!==-1&&(u=-1)}return r!==-1&&(o===-1||u===0||u===1&&o===r-1&&o===i+1?s.base=s.name=g.slice(i,r):(s.name=g.slice(i,o),s.base=g.slice(i,r),s.ext=g.slice(o,r))),i>0&&i!==n?s.dir=g.slice(0,i-1):s.dir=s.root,s},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...g){let s="",d=!1;for(let n=g.length-1;n>=-1&&!d;n--){const S=n>=0?g[n]:h.cwd();E(S,"path"),S.length!==0&&(s=`${S}/${s}`,d=S.charCodeAt(0)===D)}return s=F(s,!d,"/",m),d?`/${s}`:s.length>0?s:"."},normalize(g){if(E(g,"path"),g.length===0)return".";const s=g.charCodeAt(0)===D,d=g.charCodeAt(g.length-1)===D;return g=F(g,!s,"/",m),g.length===0?s?"/":d?"./":".":(d&&(g+="/"),s?`/${g}`:g)},isAbsolute(g){return E(g,"path"),g.length>0&&g.charCodeAt(0)===D},join(...g){if(g.length===0)return".";let s;for(let d=0;d<g.length;++d){const n=g[d];E(n,"path"),n.length>0&&(s===void 0?s=n:s+=`/${n}`)}return s===void 0?".":e.posix.normalize(s)},relative(g,s){if(E(g,"from"),E(s,"to"),g===s||(g=e.posix.resolve(g),s=e.posix.resolve(s),g===s))return"";const d=1,n=g.length,S=n-d,o=1,i=s.length-o,r=S<i?S:i;let c=-1,a=0;for(;a<r;a++){const f=g.charCodeAt(d+a);if(f!==s.charCodeAt(o+a))break;f===D&&(c=a)}if(a===r)if(i>r){if(s.charCodeAt(o+a)===D)return s.slice(o+a+1);if(a===0)return s.slice(o+a)}else S>r&&(g.charCodeAt(d+a)===D?c=a:a===0&&(c=0));let u="";for(a=d+c+1;a<=n;++a)(a===n||g.charCodeAt(a)===D)&&(u+=u.length===0?"..":"/..");return`${u}${s.slice(o+c)}`},toNamespacedPath(g){return g},dirname(g){if(E(g,"path"),g.length===0)return".";const s=g.charCodeAt(0)===D;let d=-1,n=!0;for(let S=g.length-1;S>=1;--S)if(g.charCodeAt(S)===D){if(!n){d=S;break}}else n=!1;return d===-1?s?"/":".":s&&d===1?"//":g.slice(0,d)},basename(g,s){s!==void 0&&E(s,"ext"),E(g,"path");let d=0,n=-1,S=!0,o;if(s!==void 0&&s.length>0&&s.length<=g.length){if(s===g)return"";let i=s.length-1,r=-1;for(o=g.length-1;o>=0;--o){const c=g.charCodeAt(o);if(c===D){if(!S){d=o+1;break}}else r===-1&&(S=!1,r=o+1),i>=0&&(c===s.charCodeAt(i)?--i==-1&&(n=o):(i=-1,n=r))}return d===n?n=r:n===-1&&(n=g.length),g.slice(d,n)}for(o=g.length-1;o>=0;--o)if(g.charCodeAt(o)===D){if(!S){d=o+1;break}}else n===-1&&(S=!1,n=o+1);return n===-1?"":g.slice(d,n)},extname(g){E(g,"path");let s=-1,d=0,n=-1,S=!0,o=0;for(let i=g.length-1;i>=0;--i){const r=g.charCodeAt(i);if(r===D){if(!S){d=i+1;break}continue}n===-1&&(S=!1,n=i+1),r===k?s===-1?s=i:o!==1&&(o=1):s!==-1&&(o=-1)}return s===-1||n===-1||o===0||o===1&&s===n-1&&s===d+1?"":g.slice(s,n)},format:_.bind(null,"/"),parse(g){E(g,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(g.length===0)return s;const d=g.charCodeAt(0)===D;let n;d?(s.root="/",n=1):n=0;let S=-1,o=0,i=-1,r=!0,c=g.length-1,a=0;for(;c>=n;--c){const u=g.charCodeAt(c);if(u===D){if(!r){o=c+1;break}continue}i===-1&&(r=!1,i=c+1),u===k?S===-1?S=c:a!==1&&(a=1):S!==-1&&(a=-1)}if(i!==-1){const u=o===0&&d?1:o;S===-1||a===0||a===1&&S===i-1&&S===o+1?s.base=s.name=g.slice(u,i):(s.name=g.slice(u,S),s.base=g.slice(u,i),s.ext=g.slice(S,i))}return o>0?s.dir=g.slice(0,o-1):d&&(s.dir="/"),s},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=h.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=h.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=h.platform==="win32"?e.win32.join:e.posix.join,e.resolve=h.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=h.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=h.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=h.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=h.platform==="win32"?e.win32.extname:e.posix.extname,e.format=h.platform==="win32"?e.win32.format:e.posix.format,e.parse=h.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=h.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=h.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=h.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(ve[95],we([0,1,9]),function(Z,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0;var t;(function(C){C.text="text/plain",C.binary="application/octet-stream",C.unknown="application/unknown",C.markdown="text/markdown",C.latex="text/latex"})(t=e.Mimes||(e.Mimes={}));const I={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},y={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function R(C){const l=(0,h.extname)(C),E=I[l.toLowerCase()];return E!==void 0?E:k(C)}e.getMediaOrTextMime=R;function k(C){const l=(0,h.extname)(C);return y[l.toLowerCase()]}e.getMediaMime=k;function D(C){for(const l in y)if(y[l]===C)return l}e.getExtensionForMimeType=D;const P=/^(.+)\/(.+?)(;.+)?$/;function L(C,l){const E=P.exec(C);return E?`${E[1].toLowerCase()}/${E[2].toLowerCase()}${E[3]??""}`:l?void 0:C}e.normalizeMimeType=L}),define(ve[96],we([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var h;(function(y){y[y.stdout=0]="stdout",y[y.stderr=1]="stderr"})(h=e.Source||(e.Source={}));var t;(function(y){y[y.Success=0]="Success",y[y.Unknown=1]="Unknown",y[y.AccessDenied=2]="AccessDenied",y[y.ProcessNotFound=3]="ProcessNotFound"})(t=e.TerminateResponseCode||(e.TerminateResponseCode={}));function I(y,...R){const k=R.reduce((L,C)=>(L[C]=!0,L),{}),D=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(y).filter(L=>!k[L]).forEach(L=>{for(let C=0;C<D.length;C++)if(L.search(D[C])!==-1){delete y[L];break}})}e.sanitizeProcessEnvironment=I}),define(ve[46],we([0,1,11]),function(Z,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const t=h.globals.performance&&typeof h.globals.performance.now=="function";class I{constructor(R){this._highResolution=t&&R,this._startTime=this._now(),this._stopTime=-1}static create(R=!0){return new I(R)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?h.globals.performance.now():Date.now()}}e.StopWatch=I}),define(ve[3],we([0,1,16,76,6,93,46]),function(Z,e,h,t,I,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var k;(function(s){s.None=()=>I.Disposable.None;function d($){return(B,z=null,W)=>{let Y=!1,ie;return ie=$(ne=>{if(!Y)return ie?ie.dispose():Y=!0,B.call(z,ne)},null,W),Y&&ie.dispose(),ie}}s.once=d;function n($,B){return a((z,W=null,Y)=>$(ie=>z.call(W,B(ie)),null,Y))}s.map=n;function S($,B){return a((z,W=null,Y)=>$(ie=>{B(ie),z.call(W,ie)},null,Y))}s.forEach=S;function o($,B){return a((z,W=null,Y)=>$(ie=>B(ie)&&z.call(W,ie),null,Y))}s.filter=o;function i($){return $}s.signal=i;function r(...$){return(B,z=null,W)=>(0,I.combinedDisposable)(...$.map(Y=>Y(ie=>B.call(z,ie),null,W)))}s.any=r;function c($,B,z){let W=z;return n($,Y=>(W=B(W,Y),W))}s.reduce=c;function a($){let B;const z=new l({onFirstListenerAdd(){B=$(z.fire,z)},onLastListenerRemove(){B.dispose()}});return z.event}function u($,B,z,W=100,Y=!1){let ie,ne,J=0;return $(K=>{J++,ie=z(ie,K),Y&&!ne&&(B(ie),ie=void 0),clearTimeout(ne),ne=setTimeout(()=>{const oe=ie;ie=void 0,ne=void 0,(!Y||J>1)&&B(oe),J=0},W)})}s.debouncedListener=u;function f($,B,z=100,W=!1,Y){let ie,ne,J,K=0;const oe=new l({leakWarningThreshold:Y,onFirstListenerAdd(){ie=$(fe=>{K++,ne=B(ne,fe),W&&!J&&(oe.fire(ne),ne=void 0),clearTimeout(J),J=setTimeout(()=>{const pe=ne;ne=void 0,J=void 0,(!W||K>1)&&oe.fire(pe),K=0},z)})},onLastListenerRemove(){ie.dispose()}});return oe.event}s.debounce=f;function v($,B=(z,W)=>z===W){let z=!0,W;return o($,Y=>{const ie=z||!B(Y,W);return z=!1,W=Y,ie})}s.latch=v;function w($,B){return[s.filter($,B),s.filter($,z=>!B(z))]}s.split=w;function A($,B=!1,z=[]){let W=z.slice(),Y=$(J=>{W?W.push(J):ne.fire(J)});const ie=()=>{W&&W.forEach(J=>ne.fire(J)),W=null},ne=new l({onFirstListenerAdd(){Y||(Y=$(J=>ne.fire(J)))},onFirstListenerDidAdd(){W&&(B?setTimeout(ie):ie())},onLastListenerRemove(){Y&&Y.dispose(),Y=null}});return ne.event}s.buffer=A;class M{constructor(B){this.event=B}map(B){return new M(n(this.event,B))}forEach(B){return new M(S(this.event,B))}filter(B){return new M(o(this.event,B))}reduce(B,z){return new M(c(this.event,B,z))}latch(){return new M(v(this.event))}debounce(B,z=100,W=!1,Y){return new M(f(this.event,B,z,W,Y))}on(B,z,W){return this.event(B,z,W)}once(B,z,W){return d(this.event)(B,z,W)}}function T($){return new M($)}s.chain=T;function O($,B,z=W=>W){const W=(...J)=>ne.fire(z(...J)),Y=()=>$.on(B,W),ie=()=>$.removeListener(B,W),ne=new l({onFirstListenerAdd:Y,onLastListenerRemove:ie});return ne.event}s.fromNodeEventEmitter=O;function U($,B,z=W=>W){const W=(...J)=>ne.fire(z(...J)),Y=()=>$.addEventListener(B,W),ie=()=>$.removeEventListener(B,W),ne=new l({onFirstListenerAdd:Y,onLastListenerRemove:ie});return ne.event}s.fromDOMEventEmitter=U;function V($){return new Promise(B=>d($)(B))}s.toPromise=V;function x($,B){return B(void 0),$(z=>B(z))}s.runAndSubscribe=x;function N($,B){let z=null;function W(ie){z?.dispose(),z=new I.DisposableStore,B(ie,z)}W(void 0);const Y=$(ie=>W(ie));return(0,I.toDisposable)(()=>{Y.dispose(),z?.dispose()})}s.runAndSubscribeWithStore=N})(k=e.Event||(e.Event={}));class D{constructor(d){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${d}_${D._idPool++}`}start(d){this._stopWatch=new R.StopWatch(!0),this._listenerCount=d}stop(){if(this._stopWatch){const d=this._stopWatch.elapsed();this._elapsedOverall+=d,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${d.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}D._idPool=0;let P=-1;function L(s){const d=P;return P=s,{dispose(){P=d}}}e.setGlobalLeakWarningThreshold=L;class C{constructor(d,n=Math.random().toString(18).slice(2,5)){this.customThreshold=d,this.name=n,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(d){let n=P;if(typeof this.customThreshold=="number"&&(n=this.customThreshold),n<=0||d<n)return;this._stacks||(this._stacks=new Map);const S=new Error().stack.split(`
`).slice(3).join(`
`),o=this._stacks.get(S)||0;if(this._stacks.set(S,o+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=n*.5;let i,r=0;for(const[c,a]of this._stacks)(!i||r<a)&&(i=c,r=a);console.warn(`[${this.name}] potential listener LEAK detected, having ${d} listeners already. MOST frequent listener (${r}):`),console.warn(i)}return()=>{const i=this._stacks.get(S)||0;this._stacks.set(S,i-1)}}}class l{constructor(d){this._disposed=!1,this._options=d,this._leakageMon=P>0?new C(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new D(this._options._profName):void 0}get event(){return this._event||(this._event=(d,n,S)=>{this._listeners||(this._listeners=new y.LinkedList);const o=this._listeners.isEmpty();o&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const i=this._listeners.push(n?[d,n]:d);o&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,d,n);const r=this._leakageMon?.check(this._listeners.size),c=(0,I.toDisposable)(()=>{r&&r(),this._disposed||(i(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return S instanceof I.DisposableStore?S.add(c):Array.isArray(S)&&S.push(c),c}),this._event}fire(d){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new y.LinkedList);for(let n of this._listeners)this._deliveryQueue.push([n,d]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[n,S]=this._deliveryQueue.shift();try{typeof n=="function"?n.call(void 0,S):n[0].call(n[1],S)}catch(o){(0,h.onUnexpectedError)(o)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=l;class E extends l{async fireAsync(d,n,S){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new y.LinkedList);for(const o of this._listeners)this._asyncDeliveryQueue.push([o,d]);for(;this._asyncDeliveryQueue.size>0&&!n.isCancellationRequested;){const[o,i]=this._asyncDeliveryQueue.shift(),r=[],c={...i,token:n,waitUntil:a=>{if(Object.isFrozen(r))throw new Error("waitUntil can NOT be called asynchronous");S&&(a=S(a,typeof o=="function"?o:o[0])),r.push(a)}};try{typeof o=="function"?o.call(void 0,c):o[0].call(o[1],c)}catch(a){(0,h.onUnexpectedError)(a);continue}Object.freeze(r),await Promise.allSettled(r).then(a=>{for(const u of a)u.status==="rejected"&&(0,h.onUnexpectedError)(u.reason)})}}}}e.AsyncEmitter=E;class p extends l{constructor(d){super(d);this._isPaused=0,this._eventQueue=new y.LinkedList,this._mergeFn=d?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const d=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(d))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(d){this._listeners&&(this._isPaused!==0?this._eventQueue.push(d):super.fire(d))}}e.PauseableEmitter=p;class m extends p{constructor(d){super(d);this._delay=d.delay??100}fire(d){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(d)}}e.DebounceEmitter=m;class b extends l{constructor(d){super(d);this._queuedEvents=[],this._mergeFn=d?.merge}fire(d){this._queuedEvents.push(d),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(n=>super.fire(n)),this._queuedEvents=[]})}}e.MicrotaskEmitter=b;class F{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new l({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(d){const n={event:d,listener:null};this.events.push(n),this.hasListeners&&this.hook(n);const S=()=>{this.hasListeners&&this.unhook(n);const o=this.events.indexOf(n);this.events.splice(o,1)};return(0,I.toDisposable)((0,t.once)(S))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(d=>this.hook(d))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(d=>this.unhook(d))}hook(d){d.listener=d.event(n=>this.emitter.fire(n))}unhook(d){d.listener&&d.listener.dispose(),d.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=F;class _{constructor(){this.buffers=[]}wrapEvent(d){return(n,S,o)=>d(i=>{const r=this.buffers[this.buffers.length-1];r?r.push(()=>n.call(S,i)):n.call(S,i)},void 0,o)}bufferEvents(d){const n=[];this.buffers.push(n);const S=d();return this.buffers.pop(),n.forEach(o=>o()),S}}e.EventBufferer=_;class g{constructor(){this.listening=!1,this.inputEvent=k.None,this.inputEventListener=I.Disposable.None,this.emitter=new l({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(d){this.inputEvent=d,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=d(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=g}),define(ve[21],we([0,1,3]),function(Z,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const t=Object.freeze(function(k,D){const P=setTimeout(k.bind(D),0);return{dispose(){clearTimeout(P)}}});var I;(function(k){function D(P){return P===k.None||P===k.Cancelled||P instanceof y?!0:!P||typeof P!="object"?!1:typeof P.isCancellationRequested=="boolean"&&typeof P.onCancellationRequested=="function"}k.isCancellationToken=D,k.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:h.Event.None}),k.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(I=e.CancellationToken||(e.CancellationToken={}));class y{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?t:(this._emitter||(this._emitter=new h.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class R{constructor(D){this._token=void 0,this._parentListener=void 0,this._parentListener=D&&D.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new y),this._token}cancel(){this._token?this._token instanceof y&&this._token.cancel():this._token=I.Cancelled}dispose(D=!1){D&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof y&&this._token.dispose():this._token=I.None}}e.CancellationTokenSource=R}),define(ve[142],we([0,1,21]),function(Z,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCachedComputed=e.Cache=void 0;class t{constructor(R){this.task=R,this.result=null}get(){if(this.result)return this.result;const R=new h.CancellationTokenSource,k=this.task(R.token);return this.result={promise:k,dispose:()=>{this.result=null,R.cancel(),R.dispose()}},this.result}}e.Cache=t;class I{constructor(R){this.computeFn=R,this.lastCache=void 0,this.lastArgKey=void 0}get(R){const k=JSON.stringify(R);return this.lastArgKey!==k&&(this.lastArgKey=k,this.lastCache=this.computeFn(R)),this.lastCache}}e.LRUCachedComputed=I}),define(ve[97],we([0,1,16,6]),function(Z,e,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function I(g){const s=g;return s?[s.on,s.pause,s.resume,s.destroy].every(d=>typeof d=="function"):!1}e.isReadableStream=I;function y(g){const s=g;return s?I(s.stream)&&Array.isArray(s.buffer)&&typeof s.ended=="boolean":!1}e.isReadableBufferedStream=y;function R(g,s){return new k(g,s)}e.newWriteableStream=R;class k{constructor(s,d){this.reducer=s,this.options=d,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(s){if(!this.state.destroyed){if(this.state.flowing)this.emitData(s);else if(this.buffer.data.push(s),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(d=>this.pendingWritePromises.push(d))}}error(s){this.state.destroyed||(this.state.flowing?this.emitError(s):this.buffer.error.push(s))}end(s){this.state.destroyed||(typeof s!="undefined"&&this.write(s),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(s){this.listeners.data.slice(0).forEach(d=>d(s))}emitError(s){this.listeners.error.length===0?(0,h.onUnexpectedError)(s):this.listeners.error.slice(0).forEach(d=>d(s))}emitEnd(){this.listeners.end.slice(0).forEach(s=>s())}on(s,d){if(!this.state.destroyed)switch(s){case"data":this.listeners.data.push(d),this.resume();break;case"end":this.listeners.end.push(d),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(d),this.state.flowing&&this.flowErrors();break}}removeListener(s,d){if(this.state.destroyed)return;let n;switch(s){case"data":n=this.listeners.data;break;case"end":n=this.listeners.end;break;case"error":n=this.listeners.error;break}if(n){const S=n.indexOf(d);S>=0&&n.splice(S,1)}}flowData(){if(this.buffer.data.length>0){const s=this.reducer(this.buffer.data);this.emitData(s),this.buffer.data.length=0;const d=[...this.pendingWritePromises];this.pendingWritePromises.length=0,d.forEach(n=>n())}}flowErrors(){if(this.listeners.error.length>0){for(const s of this.buffer.error)this.emitError(s);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function D(g,s){const d=[];let n;for(;(n=g.read())!==null;)d.push(n);return s(d)}e.consumeReadable=D;function P(g,s,d){const n=[];let S;for(;(S=g.read())!==null&&n.length<d;)n.push(S);return S===null&&n.length>0?s(n):{read:()=>{if(n.length>0)return n.shift();if(typeof S!="undefined"){const o=S;return S=void 0,o}return g.read()}}}e.peekReadable=P;function L(g,s){return new Promise((d,n)=>{const S=[];C(g,{onData:o=>{s&&S.push(o)},onError:o=>{s?n(o):d(void 0)},onEnd:()=>{d(s?s(S):void 0)}})})}e.consumeStream=L;function C(g,s){let d=!1;return g.on("error",n=>{d||s.onError(n)}),g.on("end",()=>{d||s.onEnd()}),g.on("data",n=>{d||s.onData(n)}),(0,t.toDisposable)(()=>d=!0)}e.listenStream=C;function l(g,s){return new Promise((d,n)=>{const S=new t.DisposableStore,o=[],i=a=>{if(o.push(a),o.length>s)return S.dispose(),g.pause(),d({stream:g,buffer:o,ended:!1})},r=a=>n(a),c=()=>d({stream:g,buffer:o,ended:!0});S.add((0,t.toDisposable)(()=>g.removeListener("error",r))),g.on("error",r),S.add((0,t.toDisposable)(()=>g.removeListener("end",c))),g.on("end",c),S.add((0,t.toDisposable)(()=>g.removeListener("data",i))),g.on("data",i)})}e.peekStream=l;function E(g,s){const d=R(s);return d.end(g),d}e.toStream=E;function p(){const g=R(()=>{throw new Error("not supported")});return g.end(),g}e.emptyStream=p;function m(g){let s=!1;return{read:()=>s?null:(s=!0,g)}}e.toReadable=m;function b(g,s,d){const n=R(d);return C(g,{onData:S=>n.write(s.data(S)),onError:S=>n.error(s.error?s.error(S):S),onEnd:()=>n.end()}),n}e.transform=b;function F(g,s,d){let n=!1;return{read:()=>{const S=s.read();return n?S:(n=!0,S!==null?d([g,S]):g)}}}e.prefixedReadable=F;function _(g,s,d){let n=!1;const S=R(d);return C(s,{onData:o=>n?S.write(o):(n=!0,S.write(d([g,o]))),onError:o=>S.error(o),onEnd:()=>{n||(n=!0,S.write(g)),S.end()}}),S}e.prefixedStream=_}),define(ve[22],we([0,1,97]),function(Z,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer!="undefined";let I,y;class R{constructor(u){this.buffer=u,this.byteLength=this.buffer.byteLength}static alloc(u){return t?new R(Buffer.allocUnsafe(u)):new R(new Uint8Array(u))}static wrap(u){return t&&!Buffer.isBuffer(u)&&(u=Buffer.from(u.buffer,u.byteOffset,u.byteLength)),new R(u)}static fromString(u,f){return!(f?.dontUseNodeBuffer||!1)&&t?new R(Buffer.from(u)):(I||(I=new TextEncoder),new R(I.encode(u)))}static fromByteArray(u){const f=R.alloc(u.length);for(let v=0,w=u.length;v<w;v++)f.buffer[v]=u[v];return f}static concat(u,f){if(typeof f=="undefined"){f=0;for(let A=0,M=u.length;A<M;A++)f+=u[A].byteLength}const v=R.alloc(f);let w=0;for(let A=0,M=u.length;A<M;A++){const T=u[A];v.set(T,w),w+=T.byteLength}return v}clone(){const u=R.alloc(this.byteLength);return u.set(this),u}toString(){return t?this.buffer.toString():(y||(y=new TextDecoder),y.decode(this.buffer))}slice(u,f){return new R(this.buffer.subarray(u,f))}set(u,f){if(u instanceof R)this.buffer.set(u.buffer,f);else if(u instanceof Uint8Array)this.buffer.set(u,f);else if(u instanceof ArrayBuffer)this.buffer.set(new Uint8Array(u),f);else if(ArrayBuffer.isView(u))this.buffer.set(new Uint8Array(u.buffer,u.byteOffset,u.byteLength),f);else throw new Error("Unkown argument 'array'")}readUInt32BE(u){return P(this.buffer,u)}writeUInt32BE(u,f){L(this.buffer,u,f)}readUInt32LE(u){return C(this.buffer,u)}writeUInt32LE(u,f){l(this.buffer,u,f)}readUInt8(u){return E(this.buffer,u)}writeUInt8(u,f){p(this.buffer,u,f)}}e.VSBuffer=R;function k(a,u){return a[u+0]<<0>>>0|a[u+1]<<8>>>0}e.readUInt16LE=k;function D(a,u,f){a[f+0]=u&255,u=u>>>8,a[f+1]=u&255}e.writeUInt16LE=D;function P(a,u){return a[u]*2**24+a[u+1]*2**16+a[u+2]*2**8+a[u+3]}e.readUInt32BE=P;function L(a,u,f){a[f+3]=u,u=u>>>8,a[f+2]=u,u=u>>>8,a[f+1]=u,u=u>>>8,a[f]=u}e.writeUInt32BE=L;function C(a,u){return a[u+0]<<0>>>0|a[u+1]<<8>>>0|a[u+2]<<16>>>0|a[u+3]<<24>>>0}e.readUInt32LE=C;function l(a,u,f){a[f+0]=u&255,u=u>>>8,a[f+1]=u&255,u=u>>>8,a[f+2]=u&255,u=u>>>8,a[f+3]=u&255}e.writeUInt32LE=l;function E(a,u){return a[u]}e.readUInt8=E;function p(a,u,f){a[f]=u}e.writeUInt8=p;function m(a){return h.consumeReadable(a,u=>R.concat(u))}e.readableToBuffer=m;function b(a){return h.toReadable(a)}e.bufferToReadable=b;function F(a){return h.consumeStream(a,u=>R.concat(u))}e.streamToBuffer=F;async function _(a){return a.ended?R.concat(a.buffer):R.concat([...a.buffer,await F(a.stream)])}e.bufferedStreamToBuffer=_;function g(a){return h.toStream(a,u=>R.concat(u))}e.bufferToStream=g;function s(a){return h.transform(a,{data:u=>typeof u=="string"?R.fromString(u):R.wrap(u)},u=>R.concat(u))}e.streamToBufferReadableStream=s;function d(a){return h.newWriteableStream(u=>R.concat(u),a)}e.newWriteableBufferStream=d;function n(a,u){return h.prefixedReadable(a,u,f=>R.concat(f))}e.prefixedBufferReadable=n;function S(a,u){return h.prefixedStream(a,u,f=>R.concat(f))}e.prefixedBufferStream=S;function o(a){let u=0,f=0,v=0;const w=new Uint8Array(Math.floor(a.length/4*3)),A=T=>{switch(f){case 3:w[v++]=u|T,f=0;break;case 2:w[v++]=u|T>>>2,u=T<<6,f=3;break;case 1:w[v++]=u|T>>>4,u=T<<4,f=2;break;default:u=T<<2,f=1}};for(let T=0;T<a.length;T++){const O=a.charCodeAt(T);if(O>=65&&O<=90)A(O-65);else if(O>=97&&O<=122)A(O-97+26);else if(O>=48&&O<=57)A(O-48+52);else if(O===43||O===45)A(62);else if(O===47||O===95)A(63);else{if(O===61)break;throw new SyntaxError(`Unexpected base64 character ${a[T]}`)}}const M=v;for(;f>0;)A(0);return R.wrap(w).slice(0,M)}e.decodeBase64=o;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function c({buffer:a},u=!0,f=!1){const v=f?r:i;let w="";const A=a.byteLength%3;let M=0;for(;M<a.byteLength-A;M+=3){const T=a[M+0],O=a[M+1],U=a[M+2];w+=v[T>>>2],w+=v[(T<<4|O>>>4)&63],w+=v[(O<<2|U>>>6)&63],w+=v[U&63]}if(A===1){const T=a[M+0];w+=v[T>>>2],w+=v[T<<4&63],u&&(w+="==")}else if(A===2){const T=a[M+0],O=a[M+1];w+=v[T>>>2],w+=v[(T<<4|O>>>4)&63],w+=v[O<<2&63],u&&(w+="=")}return w}e.encodeBase64=c}),define(ve[8],we([0,1,142,92]),function(Z,e,h,t){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function y(se){return!se||typeof se!="string"?!0:se.trim().length===0}e.isFalsyOrWhitespace=y;const R=/{(\d+)}/g;function k(se,...ye){return ye.length===0?se:se.replace(R,function(Me,qe){const Ve=parseInt(qe,10);return isNaN(Ve)||Ve<0||Ve>=ye.length?Me:ye[Ve]})}e.format=k;const D=/{([^}]+)}/g;function P(se,ye){return se.replace(D,(Me,qe)=>ye[qe]??Me)}e.format2=P;function L(se){return se.replace(/[<>&]/g,function(ye){switch(ye){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ye}})}e.escape=L;function C(se){return se.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=C;function l(se,ye){let Me=0;const qe=ye.charCodeAt(0);for(let Ve=se.length-1;Ve>=0;Ve--)se.charCodeAt(Ve)===qe&&Me++;return Me}e.count=l;function E(se,ye,Me="\u2026"){return se.length<=ye?se:`${se.substr(0,ye)}${Me}`}e.truncate=E;function p(se,ye=" "){const Me=m(se,ye);return b(Me,ye)}e.trim=p;function m(se,ye){if(!se||!ye)return se;const Me=ye.length;if(Me===0||se.length===0)return se;let qe=0;for(;se.indexOf(ye,qe)===qe;)qe=qe+Me;return se.substring(qe)}e.ltrim=m;function b(se,ye){if(!se||!ye)return se;const Me=ye.length,qe=se.length;if(Me===0||qe===0)return se;let Ve=qe,ut=-1;for(;ut=se.lastIndexOf(ye,Ve-1),!(ut===-1||ut+Me!==Ve);){if(ut===0)return"";Ve=ut}return se.substring(0,Ve)}e.rtrim=b;function F(se){return se.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=F;function _(se){return se.replace(/\*/g,"")}e.stripWildcards=_;function g(se,ye,Me={}){if(!se)throw new Error("Cannot create regex from empty string");ye||(se=C(se)),Me.wholeWord&&(/\B/.test(se.charAt(0))||(se="\\b"+se),/\B/.test(se.charAt(se.length-1))||(se=se+"\\b"));let qe="";return Me.global&&(qe+="g"),Me.matchCase||(qe+="i"),Me.multiline&&(qe+="m"),Me.unicode&&(qe+="u"),new RegExp(se,qe)}e.createRegExp=g;function s(se){return se.source==="^"||se.source==="^$"||se.source==="$"||se.source==="^\\s*$"?!1:!!(se.exec("")&&se.lastIndex===0)}e.regExpLeadsToEndlessLoop=s;function d(se){return!!se.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=d;function n(se){return(se.global?"g":"")+(se.ignoreCase?"i":"")+(se.multiline?"m":"")+(se.unicode?"u":"")}e.regExpFlags=n;function S(se){return se.split(/\r\n|\r|\n/)}e.splitLines=S;function o(se){for(let ye=0,Me=se.length;ye<Me;ye++){const qe=se.charCodeAt(ye);if(qe!==32&&qe!==9)return ye}return-1}e.firstNonWhitespaceIndex=o;function i(se,ye=0,Me=se.length){for(let qe=ye;qe<Me;qe++){const Ve=se.charCodeAt(qe);if(Ve!==32&&Ve!==9)return se.substring(ye,qe)}return se.substring(ye,Me)}e.getLeadingWhitespace=i;function r(se,ye=se.length-1){for(let Me=ye;Me>=0;Me--){const qe=se.charCodeAt(Me);if(qe!==32&&qe!==9)return Me}return-1}e.lastNonWhitespaceIndex=r;function c(se,ye){return se<ye?-1:se>ye?1:0}e.compare=c;function a(se,ye,Me=0,qe=se.length,Ve=0,ut=ye.length){for(;Me<qe&&Ve<ut;Me++,Ve++){let De=se.charCodeAt(Me),ce=ye.charCodeAt(Ve);if(De<ce)return-1;if(De>ce)return 1}const Le=qe-Me,Ae=ut-Ve;return Le<Ae?-1:Le>Ae?1:0}e.compareSubstring=a;function u(se,ye){return f(se,ye,0,se.length,0,ye.length)}e.compareIgnoreCase=u;function f(se,ye,Me=0,qe=se.length,Ve=0,ut=ye.length){for(;Me<qe&&Ve<ut;Me++,Ve++){let De=se.charCodeAt(Me),ce=ye.charCodeAt(Ve);if(De===ce)continue;if(De>=128||ce>=128)return a(se.toLowerCase(),ye.toLowerCase(),Me,qe,Ve,ut);v(De)&&(De-=32),v(ce)&&(ce-=32);const de=De-ce;if(de!==0)return de}const Le=qe-Me,Ae=ut-Ve;return Le<Ae?-1:Le>Ae?1:0}e.compareSubstringIgnoreCase=f;function v(se){return se>=97&&se<=122}e.isLowerAsciiLetter=v;function w(se){return se>=65&&se<=90}e.isUpperAsciiLetter=w;function A(se,ye){return se.length===ye.length&&f(se,ye)===0}e.equalsIgnoreCase=A;function M(se,ye){const Me=ye.length;return ye.length>se.length?!1:f(se,ye,0,Me)===0}e.startsWithIgnoreCase=M;function T(se,ye){let Me,qe=Math.min(se.length,ye.length);for(Me=0;Me<qe;Me++)if(se.charCodeAt(Me)!==ye.charCodeAt(Me))return Me;return qe}e.commonPrefixLength=T;function O(se,ye){let Me,qe=Math.min(se.length,ye.length);const Ve=se.length-1,ut=ye.length-1;for(Me=0;Me<qe;Me++)if(se.charCodeAt(Ve-Me)!==ye.charCodeAt(ut-Me))return Me;return qe}e.commonSuffixLength=O;function U(se){return 55296<=se&&se<=56319}e.isHighSurrogate=U;function V(se){return 56320<=se&&se<=57343}e.isLowSurrogate=V;function x(se,ye){return(se-55296<<10)+(ye-56320)+65536}e.computeCodePoint=x;function N(se,ye,Me){const qe=se.charCodeAt(Me);if(U(qe)&&Me+1<ye){const Ve=se.charCodeAt(Me+1);if(V(Ve))return x(qe,Ve)}return qe}e.getNextCodePoint=N;function $(se,ye){const Me=se.charCodeAt(ye-1);if(V(Me)&&ye>1){const qe=se.charCodeAt(ye-2);if(U(qe))return x(qe,Me)}return Me}class B{constructor(ye,Me=0){this._str=ye,this._len=ye.length,this._offset=Me}get offset(){return this._offset}setOffset(ye){this._offset=ye}prevCodePoint(){const ye=$(this._str,this._offset);return this._offset-=ye>=65536?2:1,ye}nextCodePoint(){const ye=N(this._str,this._len,this._offset);return this._offset+=ye>=65536?2:1,ye}eol(){return this._offset>=this._len}}e.CodePointIterator=B;class z{constructor(ye,Me=0){this._iterator=new B(ye,Me)}get offset(){return this._iterator.offset}nextGraphemeLength(){const ye=tt.getInstance(),Me=this._iterator,qe=Me.offset;let Ve=ye.getGraphemeBreakType(Me.nextCodePoint());for(;!Me.eol();){const ut=Me.offset,Le=ye.getGraphemeBreakType(Me.nextCodePoint());if(st(Ve,Le)){Me.setOffset(ut);break}Ve=Le}return Me.offset-qe}prevGraphemeLength(){const ye=tt.getInstance(),Me=this._iterator,qe=Me.offset;let Ve=ye.getGraphemeBreakType(Me.prevCodePoint());for(;Me.offset>0;){const ut=Me.offset,Le=ye.getGraphemeBreakType(Me.prevCodePoint());if(st(Le,Ve)){Me.setOffset(ut);break}Ve=Le}return qe-Me.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=z;function W(se,ye){return new z(se,ye).nextGraphemeLength()}e.nextCharLength=W;function Y(se,ye){return new z(se,ye).prevGraphemeLength()}e.prevCharLength=Y;function ie(se,ye){ye>0&&V(se.charCodeAt(ye))&&ye--;const Me=ye+W(se,ye);return[Me-Y(se,Me),Me]}e.getCharContainingOffset=ie;const ne=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function J(se){return ne.test(se)}e.containsRTL=J;const K=/^[\t\n\r\x20-\x7E]*$/;function oe(se){return K.test(se)}e.isBasicASCII=oe,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function fe(se){return e.UNUSUAL_LINE_TERMINATORS.test(se)}e.containsUnusualLineTerminators=fe;function pe(se){return se>=11904&&se<=55215||se>=63744&&se<=64255||se>=65281&&se<=65374}e.isFullWidthCharacter=pe;function Te(se){return se>=127462&&se<=127487||se===8986||se===8987||se===9200||se===9203||se>=9728&&se<=10175||se===11088||se===11093||se>=127744&&se<=128591||se>=128640&&se<=128764||se>=128992&&se<=129008||se>=129280&&se<=129535||se>=129648&&se<=129782}e.isEmojiImprecise=Te;function xe(se,ye){if(se.length<ye)return se;const Me=/\b/g;let qe=0;for(;Me.test(se)&&!(se.length-Me.lastIndex<ye);)qe=Me.lastIndex,Me.lastIndex+=1;return se.substring(qe).replace(/^\s/,"")}e.lcut=xe;const Ge=/\x1B\x5B[12]?K/g,Qe=/\x1b\[\d+m/g,q=/\x1b\[0?m/g;function te(se){return se&&(se=se.replace(Ge,""),se=se.replace(Qe,""),se=se.replace(q,"")),se}e.removeAnsiEscapeCodes=te,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function G(se){return!!(se&&se.length>0&&se.charCodeAt(0)===65279)}e.startsWithUTF8BOM=G;function Q(se){return G(se)?se.substr(1):se}e.stripUTF8BOM=Q;function ae(se,ye){if(!se||!ye||se.length<ye.length)return!1;const Me=ye.length,qe=se.toLowerCase();let Ve=0,ut=-1;for(;Ve<Me;){const Le=qe.indexOf(ye[Ve],ut+1);if(Le<0)return!1;ut=Le,Ve++}return!0}e.fuzzyContains=ae;function me(se,ye=!1){return se?(ye&&(se=se.replace(/\\./g,"")),se.toLowerCase()!==se):!1}e.containsUppercaseCharacter=me;function ke(se){return se.charAt(0).toUpperCase()+se.slice(1)}e.uppercaseFirstLetter=ke;function We(se,ye=1){if(ye===0)return"";let Me=-1;do Me=se.indexOf(`
`,Me+1),ye--;while(ye>0&&Me>=0);return Me===-1?se:(se[Me-1]==="\r"&&Me--,se.substr(0,Me))}e.getNLines=We;function Je(se){const ye=90-65+1;return se=se%(2*ye),se<ye?String.fromCharCode(97+se):String.fromCharCode(65+se-ye)}e.singleLetterHash=Je;function it(se){return tt.getInstance().getGraphemeBreakType(se)}e.getGraphemeBreakType=it;function st(se,ye){return se===0?ye!==5&&ye!==7:se===2&&ye===3?!1:se===4||se===2||se===3||ye===4||ye===2||ye===3?!0:!(se===8&&(ye===8||ye===9||ye===11||ye===12)||(se===11||se===9)&&(ye===9||ye===10)||(se===12||se===10)&&ye===10||ye===5||ye===13||ye===7||se===1||se===13&&ye===14||se===6&&ye===6)}var ot;(function(se){se[se.Other=0]="Other",se[se.Prepend=1]="Prepend",se[se.CR=2]="CR",se[se.LF=3]="LF",se[se.Control=4]="Control",se[se.Extend=5]="Extend",se[se.Regional_Indicator=6]="Regional_Indicator",se[se.SpacingMark=7]="SpacingMark",se[se.L=8]="L",se[se.V=9]="V",se[se.T=10]="T",se[se.LV=11]="LV",se[se.LVT=12]="LVT",se[se.ZWJ=13]="ZWJ",se[se.Extended_Pictographic=14]="Extended_Pictographic"})(ot=e.GraphemeBreakType||(e.GraphemeBreakType={}));class tt{constructor(){this._data=rt()}static getInstance(){return tt._INSTANCE||(tt._INSTANCE=new tt),tt._INSTANCE}getGraphemeBreakType(ye){if(ye<32)return ye===10?3:ye===13?2:4;if(ye<127)return 0;const Me=this._data,qe=Me.length/3;let Ve=1;for(;Ve<=qe;)if(ye<Me[3*Ve])Ve=2*Ve;else if(ye>Me[3*Ve+1])Ve=2*Ve+1;else return Me[3*Ve+2];return 0}}tt._INSTANCE=null;function rt(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function gt(se,ye){if(se===0)return 0;const Me=Ue(se,ye);if(Me!==void 0)return Me;const qe=new B(ye,se);return qe.prevCodePoint(),qe.offset}e.getLeftDeleteOffset=gt;function Ue(se,ye){const Me=new B(ye,se);let qe=Me.prevCodePoint();for(;It(qe)||qe===65039||qe===8419;){if(Me.offset===0)return;qe=Me.prevCodePoint()}if(!Te(qe))return;let Ve=Me.offset;return Ve>0&&Me.prevCodePoint()===8205&&(Ve=Me.offset),Ve}function It(se){return 127995<=se&&se<=127999}var ee;(function(se){se[se.zwj=8205]="zwj",se[se.emojiVariantSelector=65039]="emojiVariantSelector",se[se.enclosingKeyCap=8419]="enclosingKeyCap"})(ee||(ee={})),e.noBreakWhitespace="\xA0";class re{constructor(ye){this.confusableDictionary=ye}static getInstance(ye){return re.cache.get(Array.from(ye))}static getLocales(){return re._locales.getValue()}isAmbiguous(ye){return this.confusableDictionary.has(ye)}getPrimaryConfusable(ye){return this.confusableDictionary.get(ye)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=re,I=re,re.ambiguousCharacterData=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),re.cache=new h.LRUCachedComputed(se=>{function ye(ce){const de=new Map;for(let be=0;be<ce.length;be+=2)de.set(ce[be],ce[be+1]);return de}function Me(ce,de){const be=new Map(ce);for(const[Ce,Oe]of de)be.set(Ce,Oe);return be}function qe(ce,de){if(!ce)return de;const be=new Map;for(const[Ce,Oe]of ce)de.has(Ce)&&be.set(Ce,Oe);return be}const Ve=I.ambiguousCharacterData.getValue();let ut=se.filter(ce=>!ce.startsWith("_")&&ce in Ve);ut.length===0&&(ut=["_default"]);let Le;for(const ce of ut){const de=ye(Ve[ce]);Le=qe(Le,de)}const Ae=ye(Ve._common),De=Me(Ae,Le);return new re(De)}),re._locales=new t.Lazy(()=>Object.keys(re.ambiguousCharacterData.getValue()).filter(se=>!se.startsWith("_")));class Se{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(Se.getRawData())),this._data}static isInvisibleCharacter(ye){return Se.getData().has(ye)}static get codePoints(){return Se.getData()}}e.InvisibleCharacters=Se,Se._data=void 0}),define(ve[58],we([0,1,8]),function(Z,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function t(F){return I(F,0)}e.hash=t;function I(F,_){switch(typeof F){case"object":return F===null?y(349,_):Array.isArray(F)?D(F,_):P(F,_);case"string":return k(F,_);case"boolean":return R(F,_);case"number":return y(F,_);case"undefined":return y(937,_);default:return y(617,_)}}e.doHash=I;function y(F,_){return(_<<5)-_+F|0}e.numberHash=y;function R(F,_){return y(F?433:863,_)}function k(F,_){_=y(149417,_);for(let g=0,s=F.length;g<s;g++)_=y(F.charCodeAt(g),_);return _}e.stringHash=k;function D(F,_){return _=y(104579,_),F.reduce((g,s)=>I(s,g),_)}function P(F,_){return _=y(181387,_),Object.keys(F).sort().reduce((g,s)=>(g=k(s,g),I(F[s],g)),_)}class L{constructor(){this._value=0}get value(){return this._value}hash(_){return this._value=I(_,this._value),this._value}}e.Hasher=L;var C;(function(F){F[F.BLOCK_SIZE=64]="BLOCK_SIZE",F[F.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(C||(C={}));function l(F,_,g=32){const s=g-_,d=~((1<<s)-1);return(F<<_|(d&F)>>>s)>>>0}function E(F,_=0,g=F.byteLength,s=0){for(let d=0;d<g;d++)F[_+d]=s}function p(F,_,g="0"){for(;F.length<_;)F=g+F;return F}function m(F,_=32){return F instanceof ArrayBuffer?Array.from(new Uint8Array(F)).map(g=>g.toString(16).padStart(2,"0")).join(""):p((F>>>0).toString(16),_/4)}e.toHexString=m;class b{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(_){const g=_.length;if(g===0)return;const s=this._buff;let d=this._buffLen,n=this._leftoverHighSurrogate,S,o;for(n!==0?(S=n,o=-1,n=0):(S=_.charCodeAt(0),o=0);;){let i=S;if(h.isHighSurrogate(S))if(o+1<g){const r=_.charCodeAt(o+1);h.isLowSurrogate(r)?(o++,i=h.computeCodePoint(S,r)):i=65533}else{n=S;break}else h.isLowSurrogate(S)&&(i=65533);if(d=this._push(s,d,i),o++,o<g)S=_.charCodeAt(o);else break}this._buffLen=d,this._leftoverHighSurrogate=n}_push(_,g,s){return s<128?_[g++]=s:s<2048?(_[g++]=192|(s&1984)>>>6,_[g++]=128|(s&63)>>>0):s<65536?(_[g++]=224|(s&61440)>>>12,_[g++]=128|(s&4032)>>>6,_[g++]=128|(s&63)>>>0):(_[g++]=240|(s&1835008)>>>18,_[g++]=128|(s&258048)>>>12,_[g++]=128|(s&4032)>>>6,_[g++]=128|(s&63)>>>0),g>=64&&(this._step(),g-=64,this._totalLen+=64,_[0]=_[64+0],_[1]=_[64+1],_[2]=_[64+2]),g}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),m(this._h0)+m(this._h1)+m(this._h2)+m(this._h3)+m(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,E(this._buff,this._buffLen),this._buffLen>56&&(this._step(),E(this._buff));const _=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(_/4294967296),!1),this._buffDV.setUint32(60,_%4294967296,!1),this._step()}_step(){const _=b._bigBlock32,g=this._buffDV;for(let a=0;a<64;a+=4)_.setUint32(a,g.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)_.setUint32(a,l(_.getUint32(a-12,!1)^_.getUint32(a-32,!1)^_.getUint32(a-56,!1)^_.getUint32(a-64,!1),1),!1);let s=this._h0,d=this._h1,n=this._h2,S=this._h3,o=this._h4,i,r,c;for(let a=0;a<80;a++)a<20?(i=d&n|~d&S,r=1518500249):a<40?(i=d^n^S,r=1859775393):a<60?(i=d&n|d&S|n&S,r=2400959708):(i=d^n^S,r=3395469782),c=l(s,5)+i+o+r+_.getUint32(a*4,!1)&4294967295,o=S,S=n,n=l(d,30),d=s,s=c;this._h0=this._h0+s&4294967295,this._h1=this._h1+d&4294967295,this._h2=this._h2+n&4294967295,this._h3=this._h3+S&4294967295,this._h4=this._h4+o&4294967295}}e.StringSHA1=b,b._bigBlock32=new DataView(new ArrayBuffer(320))});var nt=this&&this.__classPrivateFieldSet||function(Z,e,h,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!I:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(Z,h):I?I.value=h:e.set(Z,h),h},Fe=this&&this.__classPrivateFieldGet||function(Z,e,h,t){if(h==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?t:h==="a"?t.call(Z):t?t.value:e.get(Z)};define(ve[24],we([0,1,17,8]),function(Z,e,h,t){"use strict";var I,y,R;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function k(o,i,r){let c=o.get(i);return c===void 0&&(c=r,o.set(i,c)),c}e.getOrSet=k;function D(o){const i=[];return o.forEach((r,c)=>{i.push(`${c} => ${r}`)}),`Map(${o.size}) {${i.join(", ")}}`}e.mapToString=D;function P(o){const i=[];return o.forEach(r=>{i.push(r)}),`Set(${o.size}) {${i.join(", ")}}`}e.setToString=P;class L{constructor(){this._value="",this._pos=0}reset(i){return this._value=i,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(i){const r=i.charCodeAt(0),c=this._value.charCodeAt(this._pos);return r-c}value(){return this._value[this._pos]}}e.StringIterator=L;class C{constructor(i=!0){this._caseSensitive=i}reset(i){return this._value=i,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(i)this._from++;else break;else i=!1;return this}cmp(i){return this._caseSensitive?(0,t.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=C;class l{constructor(i=!0,r=!0){this._splitOnBackslash=i,this._caseSensitive=r}reset(i){this._from=0,this._to=0,this._value=i,this._valueLen=i.length;for(let r=i.length-1;r>=0;r--,this._valueLen--){const c=this._value.charCodeAt(r);if(!(c===47||this._splitOnBackslash&&c===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let i=!0;for(;this._to<this._valueLen;this._to++){const r=this._value.charCodeAt(this._to);if(r===47||this._splitOnBackslash&&r===92)if(i)this._from++;else break;else i=!1}return this}cmp(i){return this._caseSensitive?(0,t.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=l;var E;(function(o){o[o.Scheme=1]="Scheme",o[o.Authority=2]="Authority",o[o.Path=3]="Path",o[o.Query=4]="Query",o[o.Fragment=5]="Fragment"})(E||(E={}));class p{constructor(i){this._ignorePathCasing=i,this._states=[],this._stateIdx=0}reset(i){return this._value=i,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new l(!1,!this._ignorePathCasing(i)),this._pathIterator.reset(i.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(i){if(this._states[this._stateIdx]===1)return(0,t.compareIgnoreCase)(i,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,t.compareIgnoreCase)(i,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(i);if(this._states[this._stateIdx]===4)return(0,t.compare)(i,this._value.query);if(this._states[this._stateIdx]===5)return(0,t.compare)(i,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=p;class m{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const i=this.right;return this.right=i.left,i.left=this,this.updateHeight(),i.updateHeight(),i}rotateRight(){const i=this.left;return this.left=i.right,i.right=this,this.updateHeight(),i.updateHeight(),i}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var b;(function(o){o[o.Left=-1]="Left",o[o.Mid=0]="Mid",o[o.Right=1]="Right"})(b||(b={}));class F{constructor(i){this._iter=i}static forUris(i=()=>!1){return new F(new p(i))}static forPaths(i=!1){return new F(new l(void 0,!i))}static forStrings(){return new F(new L)}static forConfigKeys(){return new F(new C)}clear(){this._root=void 0}fill(i,r){if(r){const c=r.slice(0);(0,h.shuffle)(c);for(let a of c)this.set(a,i)}else{const c=i.slice(0);(0,h.shuffle)(c);for(let a of c)this.set(a[0],a[1])}}set(i,r){const c=this._iter.reset(i);let a;this._root||(this._root=new m,this._root.segment=c.value());const u=[];for(a=this._root;;){const v=c.cmp(a.segment);if(v>0)a.left||(a.left=new m,a.left.segment=c.value()),u.push([-1,a]),a=a.left;else if(v<0)a.right||(a.right=new m,a.right.segment=c.value()),u.push([1,a]),a=a.right;else if(c.hasNext())c.next(),a.mid||(a.mid=new m,a.mid.segment=c.value()),u.push([0,a]),a=a.mid;else break}const f=a.value;a.value=r,a.key=i;for(let v=u.length-1;v>=0;v--){const w=u[v][1];w.updateHeight();const A=w.balanceFactor();if(A<-1||A>1){const M=u[v][0],T=u[v+1][0];if(M===1&&T===1)u[v][1]=w.rotateLeft();else if(M===-1&&T===-1)u[v][1]=w.rotateRight();else if(M===1&&T===-1)w.right=u[v+1][1]=u[v+1][1].rotateRight(),u[v][1]=w.rotateLeft();else if(M===-1&&T===1)w.left=u[v+1][1]=u[v+1][1].rotateLeft(),u[v][1]=w.rotateRight();else throw new Error;if(v>0)switch(u[v-1][0]){case-1:u[v-1][1].left=u[v][1];break;case 1:u[v-1][1].right=u[v][1];break;case 0:u[v-1][1].mid=u[v][1];break}else this._root=u[0][1]}}return f}get(i){return this._getNode(i)?.value}_getNode(i){const r=this._iter.reset(i);let c=this._root;for(;c;){const a=r.cmp(c.segment);if(a>0)c=c.left;else if(a<0)c=c.right;else if(r.hasNext())r.next(),c=c.mid;else break}return c}has(i){const r=this._getNode(i);return!(r?.value===void 0&&r?.mid===void 0)}delete(i){return this._delete(i,!1)}deleteSuperstr(i){return this._delete(i,!0)}_delete(i,r){const c=this._iter.reset(i),a=[];let u=this._root;for(;u;){const f=c.cmp(u.segment);if(f>0)a.push([-1,u]),u=u.left;else if(f<0)a.push([1,u]),u=u.right;else if(c.hasNext())c.next(),a.push([0,u]),u=u.mid;else break}if(!!u){if(r?(u.left=void 0,u.mid=void 0,u.right=void 0,u.height=1):(u.key=void 0,u.value=void 0),!u.mid&&!u.value)if(u.left&&u.right){const f=this._min(u.right),{key:v,value:w,segment:A}=f;this._delete(f.key,!1),u.key=v,u.value=w,u.segment=A}else{const f=u.left??u.right;if(a.length>0){const[v,w]=a[a.length-1];switch(v){case-1:w.left=f;break;case 0:w.mid=f;break;case 1:w.right=f;break}}else this._root=f}for(let f=a.length-1;f>=0;f--){const v=a[f][1];v.updateHeight();const w=v.balanceFactor();if(w>1?(v.right.balanceFactor()>=0||(v.right=v.right.rotateRight()),a[f][1]=v.rotateLeft()):w<-1&&(v.left.balanceFactor()<=0||(v.left=v.left.rotateLeft()),a[f][1]=v.rotateRight()),f>0)switch(a[f-1][0]){case-1:a[f-1][1].left=a[f][1];break;case 1:a[f-1][1].right=a[f][1];break;case 0:a[f-1][1].mid=a[f][1];break}else this._root=a[0][1]}}}_min(i){for(;i.left;)i=i.left;return i}findSubstr(i){const r=this._iter.reset(i);let c=this._root,a;for(;c;){const u=r.cmp(c.segment);if(u>0)c=c.left;else if(u<0)c=c.right;else if(r.hasNext())r.next(),a=c.value||a,c=c.mid;else break}return c&&c.value||a}findSuperstr(i){const r=this._iter.reset(i);let c=this._root;for(;c;){const a=r.cmp(c.segment);if(a>0)c=c.left;else if(a<0)c=c.right;else if(r.hasNext())r.next(),c=c.mid;else return c.mid?this._entries(c.mid):void 0}}forEach(i){for(const[r,c]of this)i(c,r)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(i){!i||(i.left&&(yield*this._entries(i.left)),i.value&&(yield[i.key,i.value]),i.mid&&(yield*this._entries(i.mid)),i.right&&(yield*this._entries(i.right)))}_isBalanced(){const i=r=>{if(!r)return!0;const c=r.balanceFactor();return c<-1||c>1?!1:i(r.left)&&i(r.right)};return i(this._root)}}e.TernarySearchTree=F;class _{constructor(i,r){this.uri=i,this.value=r}}class g{constructor(i,r){this[I]="ResourceMap",i instanceof g?(this.map=new Map(i.map),this.toKey=r??g.defaultToKey):(this.map=new Map,this.toKey=i??g.defaultToKey)}set(i,r){return this.map.set(this.toKey(i),new _(i,r)),this}get(i){return this.map.get(this.toKey(i))?.value}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,r){typeof r!="undefined"&&(i=i.bind(r));for(let[c,a]of this.map)i(a.value,a.uri,this)}*values(){for(let i of this.map.values())yield i.value}*keys(){for(let i of this.map.values())yield i.uri}*entries(){for(let i of this.map.values())yield[i.uri,i.value]}*[(I=Symbol.toStringTag,Symbol.iterator)](){for(let[,i]of this.map)yield[i.uri,i.value]}}e.ResourceMap=g,g.defaultToKey=o=>o.toString();var s;(function(o){o[o.None=0]="None",o[o.AsOld=1]="AsOld",o[o.AsNew=2]="AsNew"})(s=e.Touch||(e.Touch={}));class d{constructor(){this[y]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(i){return this._map.has(i)}get(i,r=0){const c=this._map.get(i);if(!!c)return r!==0&&this.touch(c,r),c.value}set(i,r,c=0){let a=this._map.get(i);if(a)a.value=r,c!==0&&this.touch(a,c);else{switch(a={key:i,value:r,next:void 0,previous:void 0},c){case 0:this.addItemLast(a);break;case 1:this.addItemFirst(a);break;case 2:this.addItemLast(a);break;default:this.addItemLast(a);break}this._map.set(i,a),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const r=this._map.get(i);if(!!r)return this._map.delete(i),this.removeItem(r),this._size--,r.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}forEach(i,r){const c=this._state;let a=this._head;for(;a;){if(r?i.bind(r)(a.value,a.key,this):i(a.value,a.key,this),this._state!==c)throw new Error("LinkedMap got modified during iteration.");a=a.next}}keys(){const i=this,r=this._state;let c=this._head;const a={[Symbol.iterator](){return a},next(){if(i._state!==r)throw new Error("LinkedMap got modified during iteration.");if(c){const u={value:c.key,done:!1};return c=c.next,u}else return{value:void 0,done:!0}}};return a}values(){const i=this,r=this._state;let c=this._head;const a={[Symbol.iterator](){return a},next(){if(i._state!==r)throw new Error("LinkedMap got modified during iteration.");if(c){const u={value:c.value,done:!1};return c=c.next,u}else return{value:void 0,done:!0}}};return a}entries(){const i=this,r=this._state;let c=this._head;const a={[Symbol.iterator](){return a},next(){if(i._state!==r)throw new Error("LinkedMap got modified during iteration.");if(c){const u={value:[c.key,c.value],done:!1};return c=c.next,u}else return{value:void 0,done:!0}}};return a}[(y=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(i>=this.size)return;if(i===0){this.clear();return}let r=this._head,c=this.size;for(;r&&c>i;)this._map.delete(r.key),r=r.next,c--;this._head=r,this._size=c,r&&(r.previous=void 0),this._state++}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const r=i.next,c=i.previous;if(!r||!c)throw new Error("Invalid list");r.previous=c,c.next=r}i.next=void 0,i.previous=void 0,this._state++}touch(i,r){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(r!==1&&r!==2)){if(r===1){if(i===this._head)return;const c=i.next,a=i.previous;i===this._tail?(a.next=void 0,this._tail=a):(c.previous=a,a.next=c),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(r===2){if(i===this._tail)return;const c=i.next,a=i.previous;i===this._head?(c.previous=void 0,this._head=c):(c.previous=a,a.next=c),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((r,c)=>{i.push([c,r])}),i}fromJSON(i){this.clear();for(const[r,c]of i)this.set(r,c)}}e.LinkedMap=d;class n extends d{constructor(i,r=1){super();this._limit=i,this._ratio=Math.min(Math.max(0,r),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,r=2){return super.get(i,r)}peek(i){return super.get(i,0)}set(i,r){return super.set(i,r,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=n;class S{constructor(i){R.set(this,void 0),nt(this,R,i,"f")}get size(){return Fe(this,R,"f").size}forEach(i,r){Fe(this,R,"f").forEach(i,r)}get(i){return Fe(this,R,"f").get(i)}has(i){return Fe(this,R,"f").has(i)}entries(){return Fe(this,R,"f").entries()}keys(){return Fe(this,R,"f").keys()}values(){return Fe(this,R,"f").values()}[(R=new WeakMap,Symbol.iterator)](){return Fe(this,R,"f").entries()}}e.ReadonlyMapView=S}),define(ve[98],we([0,1,24,8]),function(Z,e,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function I(...G){return function(Q,ae){for(let me=0,ke=G.length;me<ke;me++){const We=G[me](Q,ae);if(We)return We}return null}}e.or=I,e.matchesStrictPrefix=y.bind(void 0,!1),e.matchesPrefix=y.bind(void 0,!0);function y(G,Q,ae){if(!ae||ae.length<Q.length)return null;let me;return G?me=t.startsWithIgnoreCase(ae,Q):me=ae.indexOf(Q)===0,me?Q.length>0?[{start:0,end:Q.length}]:[]:null}function R(G,Q){const ae=Q.toLowerCase().indexOf(G.toLowerCase());return ae===-1?null:[{start:ae,end:ae+G.length}]}e.matchesContiguousSubString=R;function k(G,Q){return D(G.toLowerCase(),Q.toLowerCase(),0,0)}e.matchesSubString=k;function D(G,Q,ae,me){if(ae===G.length)return[];if(me===Q.length)return null;if(G[ae]===Q[me]){let ke=null;return(ke=D(G,Q,ae+1,me+1))?F({start:me,end:me+1},ke):null}return D(G,Q,ae,me+1)}function P(G){return 97<=G&&G<=122}function L(G){return 65<=G&&G<=90}e.isUpper=L;function C(G){return 48<=G&&G<=57}function l(G){return G===32||G===9||G===10||G===13}const E=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(G=>E.add(G.charCodeAt(0)));function p(G){return l(G)||E.has(G)}function m(G,Q){return G===Q||p(G)&&p(Q)}function b(G){return P(G)||L(G)||C(G)}function F(G,Q){return Q.length===0?Q=[G]:G.end===Q[0].start?Q[0].start=G.start:Q.unshift(G),Q}function _(G,Q){for(let ae=Q;ae<G.length;ae++){const me=G.charCodeAt(ae);if(L(me)||C(me)||ae>0&&!b(G.charCodeAt(ae-1)))return ae}return G.length}function g(G,Q,ae,me){if(ae===G.length)return[];if(me===Q.length)return null;if(G[ae]!==Q[me].toLowerCase())return null;{let ke=null,We=me+1;for(ke=g(G,Q,ae+1,me+1);!ke&&(We=_(Q,We))<Q.length;)ke=g(G,Q,ae+1,We),We++;return ke===null?null:F({start:me,end:me+1},ke)}}function s(G){let Q=0,ae=0,me=0,ke=0,We=0;for(let tt=0;tt<G.length;tt++)We=G.charCodeAt(tt),L(We)&&Q++,P(We)&&ae++,b(We)&&me++,C(We)&&ke++;const Je=Q/G.length,it=ae/G.length,st=me/G.length,ot=ke/G.length;return{upperPercent:Je,lowerPercent:it,alphaPercent:st,numericPercent:ot}}function d(G){const{upperPercent:Q,lowerPercent:ae}=G;return ae===0&&Q>.6}function n(G){const{upperPercent:Q,lowerPercent:ae,alphaPercent:me,numericPercent:ke}=G;return ae>.2&&Q<.8&&me>.6&&ke<.2}function S(G){let Q=0,ae=0,me=0,ke=0;for(let We=0;We<G.length;We++)me=G.charCodeAt(We),L(me)&&Q++,P(me)&&ae++,l(me)&&ke++;return(Q===0||ae===0)&&ke===0?G.length<=30:Q<=5}function o(G,Q){if(!Q||(Q=Q.trim(),Q.length===0)||!S(G)||Q.length>60)return null;const ae=s(Q);if(!n(ae)){if(!d(ae))return null;Q=Q.toLowerCase()}let me=null,ke=0;for(G=G.toLowerCase();ke<Q.length&&(me=g(G,Q,0,ke))===null;)ke=_(Q,ke+1);return me}e.matchesCamelCase=o;function i(G,Q,ae=!1){if(!Q||Q.length===0)return null;let me=null,ke=0;for(G=G.toLowerCase(),Q=Q.toLowerCase();ke<Q.length&&(me=r(G,Q,0,ke,ae))===null;)ke=c(Q,ke+1);return me}e.matchesWords=i;function r(G,Q,ae,me,ke){if(ae===G.length)return[];if(me===Q.length)return null;if(m(G.charCodeAt(ae),Q.charCodeAt(me))){let We=null,Je=me+1;if(We=r(G,Q,ae+1,me+1,ke),!ke)for(;!We&&(Je=c(Q,Je))<Q.length;)We=r(G,Q,ae+1,Je,ke),Je++;return We===null?null:F({start:me,end:me+1},We)}else return null}function c(G,Q){for(let ae=Q;ae<G.length;ae++)if(p(G.charCodeAt(ae))||ae>0&&p(G.charCodeAt(ae-1)))return ae;return G.length}const a=I(e.matchesPrefix,o,R),u=I(e.matchesPrefix,o,k),f=new h.LRUCache(1e4);function v(G,Q,ae=!1){if(typeof G!="string"||typeof Q!="string")return null;let me=f.get(G);me||(me=new RegExp(t.convertSimple2RegExpPattern(G),"i"),f.set(G,me));const ke=me.exec(Q);return ke?[{start:ke.index,end:ke.index+ke[0].length}]:ae?u(G,Q):a(G,Q)}e.matchesFuzzy=v;function w(G,Q){const ae=pe(G,G.toLowerCase(),0,Q,Q.toLowerCase(),0,!0);return ae?M(ae):null}e.matchesFuzzy2=w;function A(G,Q,ae,me,ke,We){const Je=Math.min(13,G.length);for(;ae<Je;ae++){const it=pe(G,Q,ae,me,ke,We,!1);if(it)return it}return[0,We]}e.anyScore=A;function M(G){if(typeof G=="undefined")return[];const Q=[],ae=G[1];for(let me=G.length-1;me>1;me--){const ke=G[me]+ae,We=Q[Q.length-1];We&&We.end===ke?We.end=ke+1:Q.push({start:ke,end:ke+1})}return Q}e.createMatches=M;const T=128;function O(){const G=[],Q=[];for(let ae=0;ae<=T;ae++)Q[ae]=0;for(let ae=0;ae<=T;ae++)G.push(Q.slice(0));return G}function U(G){const Q=[];for(let ae=0;ae<=G;ae++)Q[ae]=0;return Q}const V=U(2*T),x=U(2*T),N=O(),$=O(),B=O(),z=!1;function W(G,Q,ae,me,ke){function We(it,st,ot=" "){for(;it.length<st;)it=ot+it;return it}let Je=` |   |${me.split("").map(it=>We(it,3)).join("|")}
`;for(let it=0;it<=ae;it++)it===0?Je+=" |":Je+=`${Q[it-1]}|`,Je+=G[it].slice(0,ke+1).map(st=>We(st.toString(),3)).join("|")+`
`;return Je}function Y(G,Q,ae,me){G=G.substr(Q),ae=ae.substr(me),console.log(W($,G,G.length,ae,ae.length)),console.log(W(B,G,G.length,ae,ae.length)),console.log(W(N,G,G.length,ae,ae.length))}function ie(G,Q){if(Q<0||Q>=G.length)return!1;const ae=G.codePointAt(Q);switch(ae){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!t.isEmojiImprecise(ae)}}function ne(G,Q){if(Q<0||Q>=G.length)return!1;switch(G.charCodeAt(Q)){case 32:case 9:return!0;default:return!1}}function J(G,Q,ae){return Q[G]!==ae[G]}function K(G,Q,ae,me,ke,We,Je=!1){for(;Q<ae&&ke<We;)G[Q]===me[ke]&&(Je&&(V[Q]=ke),Q+=1),ke+=1;return Q===ae}e.isPatternInWord=K;var oe;(function(G){G[G.Diag=1]="Diag",G[G.Left=2]="Left",G[G.LeftLeft=3]="LeftLeft"})(oe||(oe={}));var fe;(function(G){G.Default=[-100,0];function Q(ae){return!ae||ae.length===2&&ae[0]===-100&&ae[1]===0}G.isDefault=Q})(fe=e.FuzzyScore||(e.FuzzyScore={}));function pe(G,Q,ae,me,ke,We,Je){const it=G.length>T?T:G.length,st=me.length>T?T:me.length;if(ae>=it||We>=st||it-ae>st-We||!K(Q,ae,it,ke,We,st,!0))return;Te(it,st,ae,We,Q,ke);let ot=1,tt=1,rt=ae,gt=We;const Ue=[!1];for(ot=1,rt=ae;rt<it;ot++,rt++){const se=V[rt],ye=x[rt],Me=rt+1<it?x[rt+1]:st;for(tt=se-We+1,gt=se;gt<Me;tt++,gt++){let qe=Number.MIN_SAFE_INTEGER,Ve=!1;gt<=ye&&(qe=xe(G,Q,rt,ae,me,ke,gt,st,We,N[ot-1][tt-1]===0,Ue));let ut=0;qe!==Number.MAX_SAFE_INTEGER&&(Ve=!0,ut=qe+$[ot-1][tt-1]);const Le=gt>se,Ae=Le?$[ot][tt-1]+(N[ot][tt-1]>0?-5:0):0,De=gt>se+1&&N[ot][tt-1]>0,ce=De?$[ot][tt-2]+(N[ot][tt-2]>0?-5:0):0;if(De&&(!Le||ce>=Ae)&&(!Ve||ce>=ut))$[ot][tt]=ce,B[ot][tt]=3,N[ot][tt]=0;else if(Le&&(!Ve||Ae>=ut))$[ot][tt]=Ae,B[ot][tt]=2,N[ot][tt]=0;else if(Ve)$[ot][tt]=ut,B[ot][tt]=1,N[ot][tt]=N[ot-1][tt-1]+1;else throw new Error("not possible")}}if(z&&Y(G,ae,me,We),!Ue[0]&&!Je)return;ot--,tt--;const It=[$[ot][tt],We];let ee=0,re=0;for(;ot>=1;){let se=tt;do{const ye=B[ot][se];if(ye===3)se=se-2;else if(ye===2)se=se-1;else break}while(se>=1);ee>1&&Q[ae+ot-1]===ke[We+tt-1]&&!J(se+We-1,me,ke)&&ee+1>N[ot][se]&&(se=tt),se===tt?ee++:ee=1,re||(re=se),ot--,tt=se-1,It.push(tt)}st===it&&(It[0]+=2);const Se=re-it;return It[0]-=Se,It}e.fuzzyScore=pe;function Te(G,Q,ae,me,ke,We){let Je=G-1,it=Q-1;for(;Je>=ae&&it>=me;)ke[Je]===We[it]&&(x[Je]=it,Je--),it--}function xe(G,Q,ae,me,ke,We,Je,it,st,ot,tt){if(Q[ae]!==We[Je])return Number.MIN_SAFE_INTEGER;let rt=1,gt=!1;return Je===ae-me?rt=G[ae]===ke[Je]?7:5:J(Je,ke,We)&&(Je===0||!J(Je-1,ke,We))?(rt=G[ae]===ke[Je]?7:5,gt=!0):ie(We,Je)&&(Je===0||!ie(We,Je-1))?rt=5:(ie(We,Je-1)||ne(We,Je-1))&&(rt=5,gt=!0),rt>1&&ae===me&&(tt[0]=!0),gt||(gt=J(Je,ke,We)||ie(We,Je-1)||ne(We,Je-1)),ae===me?Je>st&&(rt-=gt?3:5):ot?rt+=gt?2:0:rt+=gt?0:1,Je+1===it&&(rt-=gt?3:5),rt}function Ge(G,Q,ae,me,ke,We,Je){return q(G,Q,ae,me,ke,We,!0,Je)}e.fuzzyScoreGracefulAggressive=Ge;function Qe(G,Q,ae,me,ke,We,Je){return q(G,Q,ae,me,ke,We,!1,Je)}e.fuzzyScoreGraceful=Qe;function q(G,Q,ae,me,ke,We,Je,it){let st=pe(G,Q,ae,me,ke,We,it);if(st&&!Je)return st;if(G.length>=3){const ot=Math.min(7,G.length-1);for(let tt=ae+1;tt<ot;tt++){const rt=te(G,tt);if(rt){const gt=pe(rt,rt.toLowerCase(),ae,me,ke,We,it);gt&&(gt[0]-=3,(!st||gt[0]>st[0])&&(st=gt))}}}return st}function te(G,Q){if(Q+1>=G.length)return;const ae=G[Q],me=G[Q+1];if(ae!==me)return G.slice(0,Q)+me+ae+G.slice(Q+2)}}),define(ve[143],we([0,1,74,98,8]),function(Z,e,h,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const y=new RegExp(`\\$\\(${h.CSSIcon.iconNameExpression}(?:${h.CSSIcon.iconModifierExpression})?\\)`,"g"),R=new RegExp(h.CSSIcon.iconNameCharacter),k=new RegExp(`(\\\\)?${y.source}`,"g");function D(b){return b.replace(k,(F,_)=>_?F:`\\${F}`)}e.escapeIcons=D;const P=new RegExp(`\\\\${y.source}`,"g");function L(b){return b.replace(P,F=>`\\${F}`)}e.markdownEscapeEscapedIcons=L;const C=new RegExp(`(\\s)?(\\\\)?${y.source}(\\s)?`,"g");function l(b){return b.indexOf(e.iconStartMarker)===-1?b:b.replace(C,(F,_,g,s)=>g?F:_||s||"")}e.stripIcons=l;function E(b){const F=b.indexOf(e.iconStartMarker);return F===-1?{text:b}:p(b,F)}e.parseLabelWithIcons=E;function p(b,F){const _=[];let g="";function s(a){if(a){g+=a;for(const u of a)_.push(S)}}let d=-1,n="",S=0,o,i,r=F;const c=b.length;for(s(b.substr(0,F));r<c;)o=b[r],i=b[r+1],o===e.iconStartMarker[0]&&i===e.iconStartMarker[1]?(d=r,s(n),n=e.iconStartMarker,r++):o===")"&&d!==-1?(S+=r-d+1,d=-1,n=""):d!==-1?R.test(o)?n+=o:(s(n),d=-1,n=""):s(o),r++;return s(n),{text:g,iconOffsets:_}}function m(b,F,_=!1){const{text:g,iconOffsets:s}=F;if(!s||s.length===0)return(0,t.matchesFuzzy)(b,g,_);const d=(0,I.ltrim)(g," "),n=g.length-d.length,S=(0,t.matchesFuzzy)(b,d,_);if(S)for(const o of S){const i=s[o.start+n]+n;o.start+=i,o.end+=i}return S}e.matchesFuzzyIconAware=m}),define(ve[99],we([0,1,16,143]),function(Z,e,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var I;(function(l){l[l.Paragraph=0]="Paragraph",l[l.Break=1]="Break"})(I=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class y{constructor(E="",p=!1){if(this.value=E,typeof this.value!="string")throw(0,h.illegalArgument)("value");typeof p=="boolean"?(this.isTrusted=p,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=p.isTrusted??void 0,this.supportThemeIcons=p.supportThemeIcons??!1,this.supportHtml=p.supportHtml??!1)}appendText(E,p=0){return this.value+=P(this.supportThemeIcons?(0,t.escapeIcons)(E):E).replace(/([ \t]+)/g,(m,b)=>"&nbsp;".repeat(b.length)).replace(/\>/gm,"\\>").replace(/\n/g,p===1?`\\
`:`

`),this}appendMarkdown(E){return this.value+=E,this}appendCodeblock(E,p){return this.value+="\n```",this.value+=E,this.value+=`
`,this.value+=p,this.value+="\n```\n",this}}e.MarkdownString=y;function R(l){return k(l)?!l.value:Array.isArray(l)?l.every(R):!0}e.isEmptyMarkdownString=R;function k(l){return l instanceof y?!0:l&&typeof l=="object"?typeof l.value=="string"&&(typeof l.isTrusted=="boolean"||l.isTrusted===void 0)&&(typeof l.supportThemeIcons=="boolean"||l.supportThemeIcons===void 0):!1}e.isMarkdownString=k;function D(l,E){return l===E?!0:!l||!E?!1:l.value===E.value&&l.isTrusted===E.isTrusted&&l.supportThemeIcons===E.supportThemeIcons}e.markdownStringEqual=D;function P(l){return l.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=P;function L(l){return l&&l.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=L;function C(l){const E=[],p=l.split("|").map(b=>b.trim());l=p[0];const m=p[1];if(m){const b=/height=(\d+)/.exec(m),F=/width=(\d+)/.exec(m),_=b?b[1]:"",g=F?F[1]:"",s=isFinite(parseInt(g)),d=isFinite(parseInt(_));s&&E.push(`width="${g}"`),d&&E.push(`height="${_}"`)}return{href:l,dimensions:E}}e.parseHrefAndDimensions=C}),define(ve[79],we([0,1,24]),function(Z,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const t=new h.LRUCache(1e4);function I(P){return D(P,"NFC",t)}e.normalizeNFC=I;const y=new h.LRUCache(1e4);function R(P){return D(P,"NFD",y)}e.normalizeNFD=R;const k=/[^\u0000-\u0080]/;function D(P,L,C){if(!P)return P;const l=C.get(P);if(l)return l;let E;return k.test(P)?E=P.normalize(L):E=P,C.set(P,E),E}e.removeAccents=function(){const P=/[\u0300-\u036f]/g;return function(L){return R(L).replace(P,"")}}()}),define(ve[47],we([0,1,8]),function(Z,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t;(function(I){I[I.Ignore=0]="Ignore",I[I.Info=1]="Info",I[I.Warning=2]="Warning",I[I.Error=3]="Error"})(t||(t={})),function(I){const y="error",R="warning",k="warn",D="info",P="ignore";function L(l){return l?h.equalsIgnoreCase(y,l)?I.Error:h.equalsIgnoreCase(R,l)||h.equalsIgnoreCase(k,l)?I.Warning:h.equalsIgnoreCase(D,l)?I.Info:I.Ignore:I.Ignore}I.fromValue=L;function C(l){switch(l){case I.Error:return y;case I.Warning:return R;case I.Info:return D;default:return P}}I.toString=C}(t||(t={})),e.default=t}),define(ve[18],we([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function h(c){return Array.isArray(c)}e.isArray=h;function t(c){return typeof c=="string"}e.isString=t;function I(c){return Array.isArray(c)&&c.every(a=>t(a))}e.isStringArray=I;function y(c){return typeof c=="object"&&c!==null&&!Array.isArray(c)&&!(c instanceof RegExp)&&!(c instanceof Date)}e.isObject=y;function R(c){return typeof c=="number"&&!isNaN(c)}e.isNumber=R;function k(c){return!!c&&typeof c[Symbol.iterator]=="function"}e.isIterable=k;function D(c){return c===!0||c===!1}e.isBoolean=D;function P(c){return typeof c=="undefined"}e.isUndefined=P;function L(c){return!C(c)}e.isDefined=L;function C(c){return P(c)||c===null}e.isUndefinedOrNull=C;function l(c,a){if(!c)throw new Error(a?`Unexpected type, expected '${a}'`:"Unexpected type")}e.assertType=l;function E(c){if(C(c))throw new Error("Assertion Failed: argument is undefined or null");return c}e.assertIsDefined=E;function p(...c){const a=[];for(let u=0;u<c.length;u++){const f=c[u];if(C(f))throw new Error(`Assertion Failed: argument at index ${u} is undefined or null`);a.push(f)}return a}e.assertAllDefined=p;const m=Object.prototype.hasOwnProperty;function b(c){if(!y(c))return!1;for(let a in c)if(m.call(c,a))return!1;return!0}e.isEmptyObject=b;function F(c){return typeof c=="function"}e.isFunction=F;function _(...c){return c.length>0&&c.every(F)}e.areFunctions=_;function g(c,a){const u=Math.min(c.length,a.length);for(let f=0;f<u;f++)s(c[f],a[f])}e.validateConstraints=g;function s(c,a){if(t(a)){if(typeof c!==a)throw new Error(`argument does not match constraint: typeof ${a}`)}else if(F(a)){try{if(c instanceof a)return}catch{}if(!C(c)&&c.constructor===a||a.length===1&&a.call(void 0,c)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=s;function d(c){let a=[],u=Object.getPrototypeOf(c);for(;Object.prototype!==u;)a=a.concat(Object.getOwnPropertyNames(u)),u=Object.getPrototypeOf(u);return a}e.getAllPropertyNames=d;function n(c){const a=[];for(const u of d(c))typeof c[u]=="function"&&a.push(u);return a}e.getAllMethodNames=n;function S(c,a){const u=v=>function(){const w=Array.prototype.slice.call(arguments,0);return a(v,w)};let f={};for(const v of c)f[v]=u(v);return f}e.createProxyObject=S;function o(c){return c===null?void 0:c}e.withNullAsUndefined=o;function i(c){return typeof c=="undefined"?null:c}e.withUndefinedAsNull=i;function r(c,a="Unreachable"){throw new Error(a)}e.assertNever=r}),define(ve[29],we([0,1,9,11,8,18]),function(Z,e,h,t,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function R(r){return r===47||r===92}e.isPathSeparator=R;function k(r){return r.replace(/[\\/]/g,h.posix.sep)}e.toSlashes=k;function D(r){return r.indexOf("/")===-1&&(r=k(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=D;function P(r,c=h.posix.sep){if(!r)return"";const a=r.length,u=r.charCodeAt(0);if(R(u)){if(R(r.charCodeAt(1))&&!R(r.charCodeAt(2))){let v=3;const w=v;for(;v<a&&!R(r.charCodeAt(v));v++);if(w!==v&&!R(r.charCodeAt(v+1))){for(v+=1;v<a;v++)if(R(r.charCodeAt(v)))return r.slice(0,v+1).replace(/[\\/]/g,c)}}return c}else if(F(u)&&r.charCodeAt(1)===58)return R(r.charCodeAt(2))?r.slice(0,2)+c:r.slice(0,2);let f=r.indexOf("://");if(f!==-1){for(f+=3;f<a;f++)if(R(r.charCodeAt(f)))return r.slice(0,f+1)}return""}e.getRoot=P;function L(r){if(!t.isWindows||!r||r.length<5)return!1;let c=r.charCodeAt(0);if(c!==92||(c=r.charCodeAt(1),c!==92))return!1;let a=2;const u=a;for(;a<r.length&&(c=r.charCodeAt(a),c!==92);a++);return!(u===a||(c=r.charCodeAt(a+1),isNaN(c)||c===92))}e.isUNC=L;const C=/[\\/:\*\?"<>\|]/g,l=/[\\/]/g,E=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function p(r,c=t.isWindows){const a=c?C:l;return!(!r||r.length===0||/^\s+$/.test(r)||(a.lastIndex=0,a.test(r))||c&&E.test(r)||r==="."||r===".."||c&&r[r.length-1]==="."||c&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=p;function m(r,c,a){const u=r===c;return!a||u?u:!r||!c?!1:(0,I.equalsIgnoreCase)(r,c)}e.isEqual=m;function b(r,c,a,u=h.sep){if(r===c)return!0;if(!r||!c||c.length>r.length)return!1;if(a){if(!(0,I.startsWithIgnoreCase)(r,c))return!1;if(c.length===r.length)return!0;let v=c.length;return c.charAt(c.length-1)===u&&v--,r.charAt(v)===u}return c.charAt(c.length-1)!==u&&(c+=u),r.indexOf(c)===0}e.isEqualOrParent=b;function F(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=F;function _(r,c){return t.isWindows&&r.endsWith(":")&&(r+=h.sep),(0,h.isAbsolute)(r)||(r=(0,h.join)(c,r)),r=(0,h.normalize)(r),t.isWindows?(r=(0,I.rtrim)(r,h.sep),r.endsWith(":")&&(r+=h.sep)):(r=(0,I.rtrim)(r,h.sep),r||(r=h.sep)),r}e.sanitizeFilePath=_;function g(r){const c=(0,h.normalize)(r);return t.isWindows?r.length>3?!1:s(c)&&(r.length===2||c.charCodeAt(2)===92):c===h.posix.sep}e.isRootOrDriveLetter=g;function s(r,c){return(c!==void 0?c:t.isWindows)?F(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=s;function d(r){return s(r)?r[0]:void 0}e.getDriveLetter=d;function n(r,c,a){return c.length>r.length?-1:r===c?0:(a&&(r=r.toLowerCase(),c=c.toLowerCase()),r.indexOf(c))}e.indexOfPath=n;function S(r){const c=r.split(":");let a,u,f;for(const v of c){const w=Number(v);(0,y.isNumber)(w)?u===void 0?u=w:f===void 0&&(f=w):a=a?[a,v].join(":"):v}if(!a)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:a,line:u!==void 0?u:void 0,column:f!==void 0?f:u!==void 0?1:void 0}}e.parseLineAndColumnAware=S;const o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function i(r,c,a=8){let u="";for(let v=0;v<a;v++)u+=o.charAt(Math.floor(Math.random()*o.length));let f;return c?f=`${c}-${u}`:f=u,r?(0,h.join)(r,f):f}e.randomPath=i}),define(ve[25],we([0,1,18]),function(Z,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function t(m){if(!m||typeof m!="object"||m instanceof RegExp)return m;const b=Array.isArray(m)?[]:{};return Object.keys(m).forEach(F=>{m[F]&&typeof m[F]=="object"?b[F]=t(m[F]):b[F]=m[F]}),b}e.deepClone=t;function I(m){if(!m||typeof m!="object")return m;const b=[m];for(;b.length>0;){const F=b.shift();Object.freeze(F);for(const _ in F)if(y.call(F,_)){const g=F[_];typeof g=="object"&&!Object.isFrozen(g)&&b.push(g)}}return m}e.deepFreeze=I;const y=Object.prototype.hasOwnProperty;function R(m,b){return k(m,b,new Set)}e.cloneAndChange=R;function k(m,b,F){if((0,h.isUndefinedOrNull)(m))return m;const _=b(m);if(typeof _!="undefined")return _;if((0,h.isArray)(m)){const g=[];for(const s of m)g.push(k(s,b,F));return g}if((0,h.isObject)(m)){if(F.has(m))throw new Error("Cannot clone recursive data-structure");F.add(m);const g={};for(let s in m)y.call(m,s)&&(g[s]=k(m[s],b,F));return F.delete(m),g}return m}function D(m,b,F=!0){return(0,h.isObject)(m)?((0,h.isObject)(b)&&Object.keys(b).forEach(_=>{_ in m?F&&((0,h.isObject)(m[_])&&(0,h.isObject)(b[_])?D(m[_],b[_],F):m[_]=b[_]):m[_]=b[_]}),m):b}e.mixin=D;function P(m,b){if(m===b)return!0;if(m==null||b===null||b===void 0||typeof m!=typeof b||typeof m!="object"||Array.isArray(m)!==Array.isArray(b))return!1;let F,_;if(Array.isArray(m)){if(m.length!==b.length)return!1;for(F=0;F<m.length;F++)if(!P(m[F],b[F]))return!1}else{const g=[];for(_ in m)g.push(_);g.sort();const s=[];for(_ in b)s.push(_);if(s.sort(),!P(g,s))return!1;for(F=0;F<g.length;F++)if(!P(m[g[F]],b[g[F]]))return!1}return!0}e.equals=P;function L(m){const b=new Set;return JSON.stringify(m,(F,_)=>{if((0,h.isObject)(_)||Array.isArray(_)){if(b.has(_))return"[Circular]";b.add(_)}return _})}e.safeStringify=L;function C(m,b,F){const _=b(m);return typeof _=="undefined"?F:_}e.getOrDefault=C;function l(m,b){const F=Object.create(null);return!m||!b||Object.keys(b).forEach(g=>{const s=m[g],d=b[g];P(s,d)||(F[g]=d)}),F}e.distinct=l;function E(m,b){const F=b.toLowerCase(),_=Object.keys(m).find(g=>g.toLowerCase()===F);return _?m[_]:m[b]}e.getCaseInsensitive=E;function p(m,b){const F=Object.create(null);for(const[_,g]of Object.entries(m))b(_,g)&&(F[_]=g);return F}e.filter=p}),define(ve[100],we([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var h;(function(y){y[y.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",y[y.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",y[y.MAX_UINT_8=255]="MAX_UINT_8",y[y.MAX_UINT_16=65535]="MAX_UINT_16",y[y.MAX_UINT_32=4294967295]="MAX_UINT_32",y[y.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(h=e.Constants||(e.Constants={}));function t(y){return y<0?0:y>255?255:y|0}e.toUint8=t;function I(y){return y<0?0:y>4294967295?4294967295:y|0}e.toUint32=I}),define(ve[2],we([0,1,9,11]),function(Z,e,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const I=/^\w[\w\d+.-]*$/,y=/^\//,R=/^\/\//;function k(o,i){if(!o.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${o.authority}", path: "${o.path}", query: "${o.query}", fragment: "${o.fragment}"}`);if(o.scheme&&!I.test(o.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(o.path){if(o.authority){if(!y.test(o.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(R.test(o.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function D(o,i){return!o&&!i?"file":o}function P(o,i){switch(o){case"https":case"http":case"file":i?i[0]!==C&&(i=C+i):i=C;break}return i}const L="",C="/",l=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class E{constructor(i,r,c,a,u,f=!1){typeof i=="object"?(this.scheme=i.scheme||L,this.authority=i.authority||L,this.path=i.path||L,this.query=i.query||L,this.fragment=i.fragment||L):(this.scheme=D(i,f),this.authority=r||L,this.path=P(this.scheme,c||L),this.query=a||L,this.fragment=u||L,k(this,f))}static isUri(i){return i instanceof E?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}get fsPath(){return g(this,!1)}with(i){if(!i)return this;let{scheme:r,authority:c,path:a,query:u,fragment:f}=i;return r===void 0?r=this.scheme:r===null&&(r=L),c===void 0?c=this.authority:c===null&&(c=L),a===void 0?a=this.path:a===null&&(a=L),u===void 0?u=this.query:u===null&&(u=L),f===void 0?f=this.fragment:f===null&&(f=L),r===this.scheme&&c===this.authority&&a===this.path&&u===this.query&&f===this.fragment?this:new m(r,c,a,u,f)}static parse(i,r=!1){const c=l.exec(i);return c?new m(c[2]||L,S(c[4]||L),S(c[5]||L),S(c[7]||L),S(c[9]||L),r):new m(L,L,L,L,L)}static file(i){let r=L;if(t.isWindows&&(i=i.replace(/\\/g,C)),i[0]===C&&i[1]===C){const c=i.indexOf(C,2);c===-1?(r=i.substring(2),i=C):(r=i.substring(2,c),i=i.substring(c)||C)}return new m("file",r,i,L,L)}static from(i){const r=new m(i.scheme,i.authority,i.path,i.query,i.fragment);return k(r,!0),r}static joinPath(i,...r){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let c;return t.isWindows&&i.scheme==="file"?c=E.file(h.win32.join(g(i,!0),...r)).path:c=h.posix.join(i.path,...r),i.with({path:c})}toString(i=!1){return s(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof E)return i;{const r=new m(i);return r._formatted=i.external,r._fsPath=i._sep===p?i.fsPath:null,r}}else return i}}e.URI=E;const p=t.isWindows?1:void 0;class m extends E{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=g(this,!1)),this._fsPath}toString(i=!1){return i?s(this,!0):(this._formatted||(this._formatted=s(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=p),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const b={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function F(o,i){let r,c=-1;for(let a=0;a<o.length;a++){const u=o.charCodeAt(a);if(u>=97&&u<=122||u>=65&&u<=90||u>=48&&u<=57||u===45||u===46||u===95||u===126||i&&u===47)c!==-1&&(r+=encodeURIComponent(o.substring(c,a)),c=-1),r!==void 0&&(r+=o.charAt(a));else{r===void 0&&(r=o.substr(0,a));const f=b[u];f!==void 0?(c!==-1&&(r+=encodeURIComponent(o.substring(c,a)),c=-1),r+=f):c===-1&&(c=a)}}return c!==-1&&(r+=encodeURIComponent(o.substring(c))),r!==void 0?r:o}function _(o){let i;for(let r=0;r<o.length;r++){const c=o.charCodeAt(r);c===35||c===63?(i===void 0&&(i=o.substr(0,r)),i+=b[c]):i!==void 0&&(i+=o[r])}return i!==void 0?i:o}function g(o,i){let r;return o.authority&&o.path.length>1&&o.scheme==="file"?r=`//${o.authority}${o.path}`:o.path.charCodeAt(0)===47&&(o.path.charCodeAt(1)>=65&&o.path.charCodeAt(1)<=90||o.path.charCodeAt(1)>=97&&o.path.charCodeAt(1)<=122)&&o.path.charCodeAt(2)===58?i?r=o.path.substr(1):r=o.path[1].toLowerCase()+o.path.substr(2):r=o.path,t.isWindows&&(r=r.replace(/\//g,"\\")),r}e.uriToFsPath=g;function s(o,i){const r=i?_:F;let c="",{scheme:a,authority:u,path:f,query:v,fragment:w}=o;if(a&&(c+=a,c+=":"),(u||a==="file")&&(c+=C,c+=C),u){let A=u.indexOf("@");if(A!==-1){const M=u.substr(0,A);u=u.substr(A+1),A=M.indexOf(":"),A===-1?c+=r(M,!1):(c+=r(M.substr(0,A),!1),c+=":",c+=r(M.substr(A+1),!1)),c+="@"}u=u.toLowerCase(),A=u.indexOf(":"),A===-1?c+=r(u,!1):(c+=r(u.substr(0,A),!1),c+=u.substr(A))}if(f){if(f.length>=3&&f.charCodeAt(0)===47&&f.charCodeAt(2)===58){const A=f.charCodeAt(1);A>=65&&A<=90&&(f=`/${String.fromCharCode(A+32)}:${f.substr(3)}`)}else if(f.length>=2&&f.charCodeAt(1)===58){const A=f.charCodeAt(0);A>=65&&A<=90&&(f=`${String.fromCharCode(A+32)}:${f.substr(2)}`)}c+=r(f,!0)}return v&&(c+="?",c+=r(v,!1)),w&&(c+="#",c+=i?w:F(w,!1)),c}function d(o){try{return decodeURIComponent(o)}catch{return o.length>3?o.substr(0,3)+d(o.substr(3)):o}}const n=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function S(o){return o.match(n)?o.replace(n,i=>d(i)):o}}),define(ve[59],we([0,1,22,8,2]),function(Z,e,h,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function y(L){return JSON.stringify(L,D)}e.stringify=y;function R(L){let C=JSON.parse(L);return C=P(C),C}e.parse=R;var k;(function(L){L[L.Uri=1]="Uri",L[L.Regexp=2]="Regexp",L[L.ScmResource=3]="ScmResource",L[L.ScmResourceGroup=4]="ScmResourceGroup",L[L.ScmProvider=5]="ScmProvider",L[L.CommentController=6]="CommentController",L[L.CommentThread=7]="CommentThread",L[L.CommentThreadReply=8]="CommentThreadReply",L[L.CommentNode=9]="CommentNode",L[L.CommentThreadNode=10]="CommentThreadNode",L[L.TimelineActionContext=11]="TimelineActionContext",L[L.NotebookCellActionContext=12]="NotebookCellActionContext",L[L.TestItemContext=13]="TestItemContext",L[L.Date=14]="Date"})(k=e.MarshalledId||(e.MarshalledId={}));function D(L,C){return C instanceof RegExp?{$mid:2,source:C.source,flags:(0,t.regExpFlags)(C)}:C}function P(L,C=0){if(!L||C>200)return L;if(typeof L=="object"){switch(L.$mid){case 1:return I.URI.revive(L);case 2:return new RegExp(L.source,L.flags);case 14:return new Date(L.source)}if(L instanceof h.VSBuffer||L instanceof Uint8Array)return L;if(Array.isArray(L))for(let l=0;l<L.length;++l)L[l]=P(L[l],C+1);else for(const l in L)Object.hasOwnProperty.call(L,l)&&(L[l]=P(L[l],C+1))}return L}e.revive=P}),define(ve[10],we([0,1,11,2]),function(Z,e,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var I;(function(k){k.inMemory="inmemory",k.vscode="vscode",k.internal="private",k.walkThrough="walkThrough",k.walkThroughSnippet="walkThroughSnippet",k.http="http",k.https="https",k.file="file",k.mailto="mailto",k.untitled="untitled",k.data="data",k.command="command",k.vscodeRemote="vscode-remote",k.vscodeRemoteResource="vscode-remote-resource",k.userData="vscode-userdata",k.vscodeCustomEditor="vscode-custom-editor",k.vscodeNotebook="vscode-notebook",k.vscodeNotebookCell="vscode-notebook-cell",k.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",k.vscodeNotebookCellOutput="vscode-notebook-cell-output",k.vscodeInteractive="vscode-interactive",k.vscodeInteractiveInput="vscode-interactive-input",k.vscodeSettings="vscode-settings",k.vscodeWorkspaceTrust="vscode-workspace-trust",k.vscodeTerminal="vscode-terminal",k.webviewPanel="webview-panel",k.vscodeWebview="vscode-webview",k.extension="extension",k.vscodeFileResource="vscode-file",k.tmp="tmp",k.vsls="vsls"})(I=e.Schemas||(e.Schemas={}));class y{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(D){this._preferredWebSchema=D}setDelegate(D){this._delegate=D}set(D,P,L){this._hosts[D]=P,this._ports[D]=L}setConnectionToken(D,P){this._connectionTokens[D]=P}rewrite(D){if(this._delegate)return this._delegate(D);const P=D.authority;let L=this._hosts[P];L&&L.indexOf(":")!==-1&&(L=`[${L}]`);const C=this._ports[P],l=this._connectionTokens[P];let E=`path=${encodeURIComponent(D.path)}`;return typeof l=="string"&&(E+=`&tkn=${encodeURIComponent(l)}`),t.URI.from({scheme:h.isWeb?this._preferredWebSchema:I.vscodeRemoteResource,authority:`${L}:${C}`,path:"/vscode-remote-resource",query:E})}}e.RemoteAuthorities=new y;class R{asBrowserUri(D,P){const L=this.toUri(D,P);return L.scheme===I.vscodeRemote?e.RemoteAuthorities.rewrite(L):L.scheme===I.file&&(h.isNative||typeof h.globals.importScripts=="function"&&h.globals.origin===`${I.vscodeFileResource}://${R.FALLBACK_AUTHORITY}`)?L.with({scheme:I.vscodeFileResource,authority:L.authority||R.FALLBACK_AUTHORITY,query:null,fragment:null}):L}asFileUri(D,P){const L=this.toUri(D,P);return L.scheme===I.vscodeFileResource?L.with({scheme:I.file,authority:L.authority!==R.FALLBACK_AUTHORITY?L.authority:null,query:null,fragment:null}):L}toUri(D,P){return t.URI.isUri(D)?D:t.URI.parse(P.toUrl(D))}}R.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new R}),define(ve[23],we([0,1,29,10,9,11,8,2]),function(Z,e,h,t,I,y,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function D(E){return(0,k.uriToFsPath)(E,!0)}e.originalFSPath=D;class P{constructor(p){this._ignorePathCasing=p}compare(p,m,b=!1){return p===m?0:(0,R.compare)(this.getComparisonKey(p,b),this.getComparisonKey(m,b))}isEqual(p,m,b=!1){return p===m?!0:!p||!m?!1:this.getComparisonKey(p,b)===this.getComparisonKey(m,b)}getComparisonKey(p,m=!1){return p.with({path:this._ignorePathCasing(p)?p.path.toLowerCase():void 0,fragment:m?null:void 0}).toString()}ignorePathCasing(p){return this._ignorePathCasing(p)}isEqualOrParent(p,m,b=!1){if(p.scheme===m.scheme){if(p.scheme===t.Schemas.file)return h.isEqualOrParent(D(p),D(m),this._ignorePathCasing(p))&&p.query===m.query&&(b||p.fragment===m.fragment);if((0,e.isEqualAuthority)(p.authority,m.authority))return h.isEqualOrParent(p.path,m.path,this._ignorePathCasing(p),"/")&&p.query===m.query&&(b||p.fragment===m.fragment)}return!1}joinPath(p,...m){return k.URI.joinPath(p,...m)}basenameOrAuthority(p){return(0,e.basename)(p)||p.authority}basename(p){return I.posix.basename(p.path)}extname(p){return I.posix.extname(p.path)}dirname(p){if(p.path.length===0)return p;let m;return p.scheme===t.Schemas.file?m=k.URI.file(I.dirname(D(p))).path:(m=I.posix.dirname(p.path),p.authority&&m.length&&m.charCodeAt(0)!==47&&(console.error(`dirname("${p.toString})) resulted in a relative path`),m="/")),p.with({path:m})}normalizePath(p){if(!p.path.length)return p;let m;return p.scheme===t.Schemas.file?m=k.URI.file(I.normalize(D(p))).path:m=I.posix.normalize(p.path),p.with({path:m})}relativePath(p,m){if(p.scheme!==m.scheme||!(0,e.isEqualAuthority)(p.authority,m.authority))return;if(p.scheme===t.Schemas.file){const _=I.relative(D(p),D(m));return y.isWindows?h.toSlashes(_):_}let b=p.path||"/",F=m.path||"/";if(this._ignorePathCasing(p)){let _=0;for(const g=Math.min(b.length,F.length);_<g&&!(b.charCodeAt(_)!==F.charCodeAt(_)&&b.charAt(_).toLowerCase()!==F.charAt(_).toLowerCase());_++);b=F.substr(0,_)+b.substr(_)}return I.posix.relative(b,F)}resolvePath(p,m){if(p.scheme===t.Schemas.file){const b=k.URI.file(I.resolve(D(p),m));return p.with({authority:b.authority,path:b.path})}return m=h.toPosixPath(m),p.with({path:I.posix.resolve(p.path,m)})}isAbsolutePath(p){return!!p.path&&p.path[0]==="/"}isEqualAuthority(p,m){return p===m||p!==void 0&&m!==void 0&&(0,R.equalsIgnoreCase)(p,m)}hasTrailingPathSeparator(p,m=I.sep){if(p.scheme===t.Schemas.file){const b=D(p);return b.length>h.getRoot(b).length&&b[b.length-1]===m}else{const b=p.path;return b.length>1&&b.charCodeAt(b.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(p.fsPath)}}removeTrailingPathSeparator(p,m=I.sep){return(0,e.hasTrailingPathSeparator)(p,m)?p.with({path:p.path.substr(0,p.path.length-1)}):p}addTrailingPathSeparator(p,m=I.sep){let b=!1;if(p.scheme===t.Schemas.file){const F=D(p);b=F!==void 0&&F.length===h.getRoot(F).length&&F[F.length-1]===m}else{m="/";const F=p.path;b=F.length===1&&F.charCodeAt(F.length-1)===47}return!b&&!(0,e.hasTrailingPathSeparator)(p,m)?p.with({path:p.path+"/"}):p}}e.ExtUri=P,e.extUri=new P(()=>!1),e.extUriBiasedIgnorePathCase=new P(E=>E.scheme===t.Schemas.file?!y.isLinux:!0),e.extUriIgnorePathCase=new P(E=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function L(E,p){const m=[];for(let b=0;b<E.length;b++){const F=p(E[b]);E.some((_,g)=>g===b?!1:(0,e.isEqualOrParent)(F,p(_)))||m.push(E[b])}return m}e.distinctParents=L;var C;(function(E){E.META_DATA_LABEL="label",E.META_DATA_DESCRIPTION="description",E.META_DATA_SIZE="size",E.META_DATA_MIME="mime";function p(m){const b=new Map;m.path.substring(m.path.indexOf(";")+1,m.path.lastIndexOf(";")).split(";").forEach(g=>{const[s,d]=g.split(":");s&&d&&b.set(s,d)});const _=m.path.substring(0,m.path.indexOf(";"));return _&&b.set(E.META_DATA_MIME,_),b}E.parseMetaData=p})(C=e.DataUri||(e.DataUri={}));function l(E,p,m){if(p){let b=E.path;return b&&b[0]!==I.posix.sep&&(b=I.posix.sep+b),E.with({scheme:m,authority:p,path:b})}return E.with({scheme:m})}e.toLocalResource=l}),define(ve[13],we([0,1,21,16,3,6,23,11]),function(Z,e,h,t,I,y,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function D(J){return!!J&&typeof J.then=="function"}e.isThenable=D;function P(J){const K=new h.CancellationTokenSource,oe=J(K.token),fe=new Promise((pe,Te)=>{const xe=K.token.onCancellationRequested(()=>{xe.dispose(),K.dispose(),Te(new t.CancellationError)});Promise.resolve(oe).then(Ge=>{xe.dispose(),K.dispose(),pe(Ge)},Ge=>{xe.dispose(),K.dispose(),Te(Ge)})});return new class{cancel(){K.cancel()}then(pe,Te){return fe.then(pe,Te)}catch(pe){return this.then(void 0,pe)}finally(pe){return fe.finally(pe)}}}e.createCancelablePromise=P;function L(J,K,oe){return new Promise((fe,pe)=>{const Te=K.onCancellationRequested(()=>{Te.dispose(),fe(oe)});J.then(fe,pe).finally(()=>Te.dispose())})}e.raceCancellation=L;function C(J,K){return new Promise((oe,fe)=>{const pe=K.onCancellationRequested(()=>{pe.dispose(),fe(new t.CancellationError)});J.then(oe,fe).finally(()=>pe.dispose())})}e.raceCancellationError=C;async function l(J){let K=-1;const oe=J.map((pe,Te)=>pe.then(xe=>(K=Te,xe))),fe=await Promise.race(oe);return J.forEach((pe,Te)=>{Te!==K&&pe.cancel()}),fe}e.raceCancellablePromises=l;function E(J,K,oe){let fe;const pe=setTimeout(()=>{fe?.(void 0),oe?.()},K);return Promise.race([J.finally(()=>clearTimeout(pe)),new Promise(Te=>fe=Te)])}e.raceTimeout=E;function p(J){return new Promise((K,oe)=>{const fe=J();D(fe)?fe.then(K,oe):K(fe)})}e.asPromise=p;class m{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(K){if(this.activePromise){if(this.queuedPromiseFactory=K,!this.queuedPromise){const oe=()=>{this.queuedPromise=null;const fe=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,fe};this.queuedPromise=new Promise(fe=>{this.activePromise.then(oe,oe).then(fe)})}return new Promise((oe,fe)=>{this.queuedPromise.then(oe,fe)})}return this.activePromise=K(),new Promise((oe,fe)=>{this.activePromise.then(pe=>{this.activePromise=null,oe(pe)},pe=>{this.activePromise=null,fe(pe)})})}}e.Throttler=m;class b{constructor(){this.current=Promise.resolve(null)}queue(K){return this.current=this.current.then(()=>K(),()=>K())}}e.Sequencer=b;class F{constructor(){this.promiseMap=new Map}queue(K,oe){const pe=(this.promiseMap.get(K)??Promise.resolve()).catch(()=>{}).then(oe).finally(()=>{this.promiseMap.get(K)===pe&&this.promiseMap.delete(K)});return this.promiseMap.set(K,pe),pe}}e.SequencerByKey=F;const _=(J,K)=>{let oe=!0;const fe=setTimeout(()=>{oe=!1,K()},J);return{isTriggered:()=>oe,dispose:()=>{clearTimeout(fe),oe=!1}}},g=J=>{let K=!0;return queueMicrotask(()=>{K&&(K=!1,J())}),{isTriggered:()=>K,dispose:()=>{K=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class s{constructor(K){this.defaultDelay=K,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(K,oe=this.defaultDelay){this.task=K,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((pe,Te)=>{this.doResolve=pe,this.doReject=Te}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const pe=this.task;return this.task=null,pe()}}));const fe=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=oe===e.MicrotaskDelay?g(fe):_(oe,fe),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(new t.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=s;class d{constructor(K){this.delayer=new s(K),this.throttler=new m}trigger(K,oe){return this.delayer.trigger(()=>this.throttler.queue(K),oe)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=d;class n{constructor(){this._isOpen=!1,this._promise=new Promise((K,oe)=>{this._completePromise=K})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=n;class S extends n{constructor(K){super();this._timeout=setTimeout(()=>this.open(),K)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=S;function o(J,K){return K?new Promise((oe,fe)=>{const pe=setTimeout(()=>{Te.dispose(),oe()},J),Te=K.onCancellationRequested(()=>{clearTimeout(pe),Te.dispose(),fe(new t.CancellationError)})}):P(oe=>o(J,oe))}e.timeout=o;function i(J,K=0){const oe=setTimeout(J,K);return(0,y.toDisposable)(()=>clearTimeout(oe))}e.disposableTimeout=i;function r(J){const K=[];let oe=0;const fe=J.length;function pe(){return oe<fe?J[oe++]():null}function Te(xe){xe!=null&&K.push(xe);const Ge=pe();return Ge?Ge.then(Te):Promise.resolve(K)}return Promise.resolve(null).then(Te)}e.sequence=r;function c(J,K=fe=>!!fe,oe=null){let fe=0;const pe=J.length,Te=()=>{if(fe>=pe)return Promise.resolve(oe);const xe=J[fe++];return Promise.resolve(xe()).then(Qe=>K(Qe)?Promise.resolve(Qe):Te())};return Te()}e.first=c;function a(J,K=fe=>!!fe,oe=null){if(J.length===0)return Promise.resolve(oe);let fe=J.length;const pe=()=>{fe=-1;for(const Te of J)Te.cancel?.()};return new Promise((Te,xe)=>{for(const Ge of J)Ge.then(Qe=>{--fe>=0&&K(Qe)?(pe(),Te(Qe)):fe===0&&Te(oe)}).catch(Qe=>{--fe>=0&&(pe(),xe(Qe))})})}e.firstParallel=a;class u{constructor(K){this._size=0,this.maxDegreeOfParalellism=K,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new I.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(K){return this._size++,new Promise((oe,fe)=>{this.outstandingPromises.push({factory:K,c:oe,e:fe}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const K=this.outstandingPromises.shift();this.runningPromises++;const oe=K.factory();oe.then(K.c,K.e),oe.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=u;class f extends u{constructor(){super(1)}}e.Queue=f;class v{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const K=new B;return this.drainers.add(K),K.p}isDrained(){for(const[,K]of this.queues)if(K.size>0)return!1;return!0}queueFor(K,oe=R.extUri){const fe=oe.getComparisonKey(K);let pe=this.queues.get(fe);return pe||(pe=new f,I.Event.once(pe.onFinished)(()=>{pe?.dispose(),this.queues.delete(fe),this.onDidQueueFinish()}),this.queues.set(fe,pe)),pe}onDidQueueFinish(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const K of this.drainers)K.complete();this.drainers.clear()}dispose(){for(const[,K]of this.queues)K.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=v;class w{constructor(K,oe){this._token=-1,typeof K=="function"&&typeof oe=="number"&&this.setIfNotSet(K,oe)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(K,oe){this.cancel(),this._token=setTimeout(()=>{this._token=-1,K()},oe)}setIfNotSet(K,oe){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,K()},oe))}}e.TimeoutTimer=w;class A{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(K,oe){this.cancel(),this._token=setInterval(()=>{K()},oe)}}e.IntervalTimer=A;class M{constructor(K,oe){this.timeoutToken=-1,this.runner=K,this.timeout=oe,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(K=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,K)}get delay(){return this.timeout}set delay(K){this.timeout=K}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=M;class T{constructor(K,oe){oe%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${oe}ms is not a multiple of 1000ms.`),this.runner=K,this.timeout=oe,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(K=this.timeout){K%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${K}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(K/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=T;class O extends M{constructor(K,oe){super(K,oe);this.units=[]}work(K){this.units.push(K),this.isScheduled()||this.schedule()}doRun(){const K=this.units;this.units=[],this.runner&&this.runner(K)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=O;class U extends y.Disposable{constructor(K,oe){super();this.options=K,this.handler=oe,this.pendingWork=[],this.throttler=this._register(new y.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(K){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+K.length>this.options.maxBufferedWork)return!1}else if(this.pending+K.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...K),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new M(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=U,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=J=>{(0,k.setTimeout0)(()=>{if(K)return;const oe=Date.now()+15;J(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,oe-Date.now())}}))});let K=!1;return{dispose(){K||(K=!0)}}}:e.runWhenIdle=(J,K)=>{const oe=requestIdleCallback(J,typeof K=="number"?{timeout:K}:void 0);let fe=!1;return{dispose(){fe||(fe=!0,cancelIdleCallback(oe))}}}}();class V{constructor(K){this._didRun=!1,this._executor=()=>{try{this._value=K()}catch(oe){this._error=oe}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=V;async function x(J,K,oe){let fe;for(let pe=0;pe<oe;pe++)try{return await J()}catch(Te){fe=Te,await o(K)}throw fe}e.retry=x;class N{hasPending(K){return this._pending?typeof K=="number"?this._pending.taskId===K:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(K,oe,fe){return this._pending={taskId:K,cancel:()=>fe?.(),promise:oe},oe.then(()=>this.donePending(K),()=>this.donePending(K)),oe}donePending(K){this._pending&&K===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const K=this._next;this._next=void 0,K.run().then(K.promiseResolve,K.promiseReject)}}setNext(K){if(this._next)this._next.run=K;else{let oe,fe;const pe=new Promise((Te,xe)=>{oe=Te,fe=xe});this._next={run:K,promise:pe,promiseResolve:oe,promiseReject:fe}}return this._next.promise}}e.TaskSequentializer=N;class ${constructor(K,oe=()=>Date.now()){this.interval=K,this.nowFn=oe,this.lastIncrementTime=0,this.value=0}increment(){const K=this.nowFn();return K-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=K,this.value=0),this.value++,this.value}}e.IntervalCounter=$;class B{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((K,oe)=>{this.completeCallback=K,this.errorCallback=oe})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(K){return new Promise(oe=>{this.completeCallback(K),this.resolved=!0,oe()})}error(K){return new Promise(oe=>{this.errorCallback(K),this.rejected=!0,oe()})}cancel(){new Promise(K=>{this.errorCallback(new t.CancellationError),this.rejected=!0,K()})}}e.DeferredPromise=B;var z;(function(J){async function K(fe){let pe;const Te=await Promise.all(fe.map(xe=>xe.then(Ge=>Ge,Ge=>{pe||(pe=Ge)})));if(typeof pe!="undefined")throw pe;return Te}J.settled=K;function oe(fe){return new Promise(async(pe,Te)=>{try{await fe(pe,Te)}catch(xe){Te(xe)}})}J.withAsyncBody=oe})(z=e.Promises||(e.Promises={}));var W;(function(J){J[J.Initial=0]="Initial",J[J.DoneOK=1]="DoneOK",J[J.DoneError=2]="DoneError"})(W||(W={}));class Y{constructor(K){this._state=0,this._results=[],this._error=null,this._onStateChanged=new I.Emitter,queueMicrotask(async()=>{const oe={emitOne:fe=>this.emitOne(fe),emitMany:fe=>this.emitMany(fe),reject:fe=>this.reject(fe)};try{await Promise.resolve(K(oe)),this.resolve()}catch(fe){this.reject(fe)}finally{oe.emitOne=void 0,oe.emitMany=void 0,oe.reject=void 0}})}static fromArray(K){return new Y(oe=>{oe.emitMany(K)})}static fromPromise(K){return new Y(async oe=>{oe.emitMany(await K)})}static fromPromises(K){return new Y(async oe=>{await Promise.all(K.map(async fe=>oe.emitOne(await fe)))})}static merge(K){return new Y(async oe=>{await Promise.all(K.map(async fe=>{for await(const pe of fe)oe.emitOne(pe)}))})}[Symbol.asyncIterator](){let K=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(K<this._results.length)return{done:!1,value:this._results[K++]};if(this._state===1)return{done:!0,value:void 0};await I.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(K,oe){return new Y(async fe=>{for await(const pe of K)fe.emitOne(oe(pe))})}map(K){return Y.map(this,K)}static filter(K,oe){return new Y(async fe=>{for await(const pe of K)oe(pe)&&fe.emitOne(pe)})}filter(K){return Y.filter(this,K)}static coalesce(K){return Y.filter(K,oe=>!!oe)}coalesce(){return Y.coalesce(this)}static async toPromise(K){const oe=[];for await(const fe of K)oe.push(fe);return oe}toPromise(){return Y.toPromise(this)}emitOne(K){this._state===0&&(this._results.push(K),this._onStateChanged.fire())}emitMany(K){this._state===0&&(this._results=this._results.concat(K),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(K){this._state===0&&(this._state=2,this._error=K,this._onStateChanged.fire())}}e.AsyncIterableObject=Y,Y.EMPTY=Y.fromArray([]);class ie extends Y{constructor(K,oe){super(oe);this._source=K}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=ie;function ne(J){const K=new h.CancellationTokenSource,oe=J(K.token);return new ie(K,async fe=>{const pe=K.token.onCancellationRequested(()=>{pe.dispose(),K.dispose(),fe.reject(new t.CancellationError)});try{for await(const Te of oe){if(K.token.isCancellationRequested)return;fe.emitOne(Te)}pe.dispose(),K.dispose()}catch(Te){pe.dispose(),K.dispose(),fe.reject(Te)}})}e.createCancelableAsyncIterable=ne}),define(ve[101],we([0,1,13,9]),function(Z,e,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const I=new h.IdleValue(()=>{const f=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:f,collatorIsNumeric:f.resolvedOptions().numeric}}),y=new h.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),R=new h.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function k(f,v,w=!1){const A=f||"",M=v||"",T=I.value.collator.compare(A,M);return I.value.collatorIsNumeric&&T===0&&A!==M?A<M?-1:1:T}e.compareFileNames=k;function D(f,v){const w=y.value.collator;return f=f||"",v=v||"",d(w,f,v)}e.compareFileNamesDefault=D;function P(f,v){const w=y.value.collator;return f=f||"",v=v||"",i(f,v)||d(w,f,v)}e.compareFileNamesUpper=P;function L(f,v){const w=y.value.collator;return f=f||"",v=v||"",o(f,v)||d(w,f,v)}e.compareFileNamesLower=L;function C(f,v){return f=f||"",v=v||"",f===v?0:f<v?-1:1}e.compareFileNamesUnicode=C;function l(f,v,w=!1){w||(f=f&&f.toLowerCase(),v=v&&v.toLowerCase());const[A,M]=g(f),[T,O]=g(v);return A!==T?A<T?-1:1:M===O?0:M<O?-1:1}e.noIntlCompareFileNames=l;function E(f,v){const[w,A]=g(f),[M,T]=g(v);let O=I.value.collator.compare(A,T);if(O===0){if(I.value.collatorIsNumeric&&A!==T)return A<T?-1:1;if(O=I.value.collator.compare(w,M),I.value.collatorIsNumeric&&O===0&&w!==M)return w<M?-1:1}return O}e.compareFileExtensions=E;function p(f,v){f=f||"",v=v||"";const w=s(f),A=s(v),M=y.value.collator,T=R.value.collator;return d(T,w,A)||d(M,f,v)}e.compareFileExtensionsDefault=p;function m(f,v){f=f||"",v=v||"";const w=s(f),A=s(v),M=y.value.collator,T=R.value.collator;return d(T,w,A)||i(f,v)||d(M,f,v)}e.compareFileExtensionsUpper=m;function b(f,v){f=f||"",v=v||"";const w=s(f),A=s(v),M=y.value.collator,T=R.value.collator;return d(T,w,A)||o(f,v)||d(M,f,v)}e.compareFileExtensionsLower=b;function F(f,v){f=f||"",v=v||"";const w=s(f).toLowerCase(),A=s(v).toLowerCase();return w!==A?w<A?-1:1:f!==v?f<v?-1:1:0}e.compareFileExtensionsUnicode=F;const _=/^(.*?)(\.([^.]*))?$/;function g(f,v=!1){const w=f?_.exec(f):[];let A=[w&&w[1]||"",w&&w[3]||""];return v&&(!A[0]&&A[1]||A[0]&&A[0].charAt(0)===".")&&(A=[A[0]+"."+A[1],""]),A}function s(f){const v=f?_.exec(f):[];return v&&v[1]&&v[1].charAt(0)!=="."&&v[3]||""}function d(f,v,w){let A=f.compare(v,w);return A!==0?A:v.length!==w.length?v.length<w.length?-1:1:0}function n(f){const v=f.charAt(0);return v.toLocaleUpperCase()!==v}function S(f){const v=f.charAt(0);return v.toLocaleLowerCase()!==v}function o(f,v){return n(f)&&S(v)?-1:S(f)&&n(v)?1:0}function i(f,v){return S(f)&&n(v)?-1:n(f)&&S(v)?1:0}function r(f,v,w=!1){return w||(f=f&&f.toLowerCase(),v=v&&v.toLowerCase()),f===v?0:f<v?-1:1}function c(f,v,w=!1){const A=f.split(t.sep),M=v.split(t.sep),T=A.length-1,O=M.length-1;let U,V;for(let x=0;;x++){if(U=T===x,V=O===x,U&&V)return k(A[x],M[x],w);if(U)return-1;if(V)return 1;const N=r(A[x],M[x],w);if(N!==0)return N}}e.comparePaths=c;function a(f,v,w){const A=f.toLowerCase(),M=v.toLowerCase(),T=u(f,v,w);if(T)return T;const O=A.endsWith(w),U=M.endsWith(w);if(O!==U)return O?-1:1;const V=k(A,M);return V!==0?V:A.localeCompare(M)}e.compareAnything=a;function u(f,v,w){const A=f.toLowerCase(),M=v.toLowerCase(),T=A.startsWith(w),O=M.startsWith(w);if(T!==O)return T?-1:1;if(T&&O){if(A.length<M.length)return-1;if(A.length>M.length)return 1}return 0}e.compareByPrefix=u}),define(ve[102],we([0,1,101,98,58,9,11,8]),function(Z,e,h,t,I,y,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const D=0,P=[D,[]];function L(N,$,B,z){if(!N||!$)return P;const W=N.length,Y=$.length;if(W<Y)return P;const ie=N.toLowerCase();return C($,B,Y,N,ie,W,z)}e.scoreFuzzy=L;function C(N,$,B,z,W,Y,ie){const ne=[],J=[];for(let pe=0;pe<B;pe++){const Te=pe*Y,xe=Te-Y,Ge=pe>0,Qe=N[pe],q=$[pe];for(let te=0;te<Y;te++){const G=te>0,Q=Te+te,ae=Q-1,me=xe+te-1,ke=G?ne[ae]:0,We=Ge&&G?ne[me]:0,Je=Ge&&G?J[me]:0;let it;!We&&Ge?it=0:it=l(Qe,q,z,W,te,Je),it&&We+it>=ke&&(ie||Ge||W.startsWith($,te))?(J[Q]=Je+1,ne[Q]=We+it):(J[Q]=D,ne[Q]=ke)}}const K=[];let oe=B-1,fe=Y-1;for(;oe>=0&&fe>=0;){const pe=oe*Y+fe;J[pe]===D||(K.push(fe),oe--),fe--}return[ne[B*Y-1],K.reverse()]}function l(N,$,B,z,W,Y){let ie=0;if(!E($,z[W]))return ie;if(ie+=1,Y>0&&(ie+=Y*5),N===B[W]&&(ie+=1),W===0)ie+=8;else{const ne=p(B.charCodeAt(W-1));ne?ie+=ne:(0,t.isUpper)(B.charCodeAt(W))&&Y===0&&(ie+=2)}return ie}function E(N,$){return N===$?!0:N==="/"||N==="\\"?$==="/"||$==="\\":!1}function p(N){switch(N){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const m=[void 0,[]];function b(N,$,B=0,z=0){const W=$;return W.values&&W.values.length>1?F(N,W.values,B,z):_(N,$,B,z)}e.scoreFuzzy2=b;function F(N,$,B,z){let W=0;const Y=[];for(const ie of $){const[ne,J]=_(N,ie,B,z);if(typeof ne!="number")return m;W+=ne,Y.push(...J)}return[W,u(Y)]}function _(N,$,B,z){const W=(0,t.fuzzyScore)($.original,$.originalLowercase,B,N,N.toLowerCase(),z,!0);return W?[W[0],(0,t.createMatches)(W)]:m}const g=Object.freeze({score:0}),s=1<<18,d=1<<17,n=1<<16;function S(N,$,B,z){const W=z.values?z.values:[z];return(0,I.hash)({[z.normalized]:{values:W.map(ie=>({value:ie.normalized,expectContiguousMatch:ie.expectContiguousMatch})),label:N,description:$,allowNonContiguousMatches:B}})}function o(N,$,B,z,W){if(!N||!$.normalized)return g;const Y=z.getItemLabel(N);if(!Y)return g;const ie=z.getItemDescription(N),ne=S(Y,ie,B,$),J=W[ne];if(J)return J;const K=i(Y,ie,z.getItemPath(N),$,B);return W[ne]=K,K}e.scoreItemFuzzy=o;function i(N,$,B,z,W){const Y=!B||!z.containsPathSeparator;return B&&(R.isLinux?z.pathNormalized===B:(0,k.equalsIgnoreCase)(z.pathNormalized,B))?{score:s,labelMatch:[{start:0,end:N.length}],descriptionMatch:$?[{start:0,end:$.length}]:void 0}:z.values&&z.values.length>1?r(N,$,B,z.values,Y,W):c(N,$,B,z,Y,W)}function r(N,$,B,z,W,Y){let ie=0;const ne=[],J=[];for(const K of z){const{score:oe,labelMatch:fe,descriptionMatch:pe}=c(N,$,B,K,W,Y);if(oe===D)return g;ie+=oe,fe&&ne.push(...fe),pe&&J.push(...pe)}return{score:ie,labelMatch:u(ne),descriptionMatch:u(J)}}function c(N,$,B,z,W,Y){if(W||!$){const[ie,ne]=L(N,z.normalized,z.normalizedLowercase,Y&&!z.expectContiguousMatch);if(ie){const J=(0,t.matchesPrefix)(z.normalized,N);let K;return J?(K=d,K+=Math.round(z.normalized.length/N.length*100)):K=n,{score:K+ie,labelMatch:J||a(ne)}}}if($){let ie=$;B&&(ie=`${$}${y.sep}`);const ne=ie.length,J=`${ie}${N}`,[K,oe]=L(J,z.normalized,z.normalizedLowercase,Y&&!z.expectContiguousMatch);if(K){const fe=a(oe),pe=[],Te=[];return fe.forEach(xe=>{xe.start<ne&&xe.end>ne?(pe.push({start:0,end:xe.end-ne}),Te.push({start:xe.start,end:ne})):xe.start>=ne?pe.push({start:xe.start-ne,end:xe.end-ne}):Te.push(xe)}),{score:K,labelMatch:pe,descriptionMatch:Te}}}return g}function a(N){const $=[];if(!N)return $;let B;for(const z of N)B&&B.end===z?B.end+=1:(B={start:z,end:z+1},$.push(B));return $}function u(N){const $=N.sort((W,Y)=>W.start-Y.start),B=[];let z;for(const W of $)!z||!f(z,W)?(z=W,B.push(W)):(z.start=Math.min(z.start,W.start),z.end=Math.max(z.end,W.end));return B}function f(N,$){return!(N.end<$.start||$.end<N.start)}function v(N,$,B,z,W,Y){const ie=o(N,B,z,W,Y),ne=o($,B,z,W,Y),J=ie.score,K=ne.score;if((J===s||K===s)&&J!==K)return J===s?-1:1;if(J>n||K>n){if(J!==K)return J>K?-1:1;if(J<d&&K<d){const Qe=A(ie.labelMatch,ne.labelMatch);if(Qe!==0)return Qe}const xe=W.getItemLabel(N)||"",Ge=W.getItemLabel($)||"";if(xe.length!==Ge.length)return xe.length-Ge.length}if(J!==K)return J>K?-1:1;const oe=Array.isArray(ie.labelMatch)&&ie.labelMatch.length>0,fe=Array.isArray(ne.labelMatch)&&ne.labelMatch.length>0;if(oe&&!fe)return-1;if(fe&&!oe)return 1;const pe=w(N,ie,W),Te=w($,ne,W);return pe&&Te&&pe!==Te?Te>pe?-1:1:M(N,$,B,W)}e.compareItemsByFuzzyScore=v;function w(N,$,B){let z=-1,W=-1;if($.descriptionMatch&&$.descriptionMatch.length?z=$.descriptionMatch[0].start:$.labelMatch&&$.labelMatch.length&&(z=$.labelMatch[0].start),$.labelMatch&&$.labelMatch.length){if(W=$.labelMatch[$.labelMatch.length-1].end,$.descriptionMatch&&$.descriptionMatch.length){const Y=B.getItemDescription(N);Y&&(W+=Y.length)}}else $.descriptionMatch&&$.descriptionMatch.length&&(W=$.descriptionMatch[$.descriptionMatch.length-1].end);return W-z}function A(N,$){if(!N&&!$||(!N||!N.length)&&(!$||!$.length))return 0;if(!$||!$.length)return-1;if(!N||!N.length)return 1;const B=N[0].start,W=N[N.length-1].end-B,Y=$[0].start,ne=$[$.length-1].end-Y;return W===ne?0:ne<W?1:-1}function M(N,$,B,z){const W=z.getItemLabel(N)||"",Y=z.getItemLabel($)||"",ie=z.getItemDescription(N),ne=z.getItemDescription($),J=W.length+(ie?ie.length:0),K=Y.length+(ne?ne.length:0);if(J!==K)return J-K;const oe=z.getItemPath(N),fe=z.getItemPath($);return oe&&fe&&oe.length!==fe.length?oe.length-fe.length:W!==Y?(0,h.compareAnything)(W,Y,B.normalized):ie&&ne&&ie!==ne?(0,h.compareAnything)(ie,ne,B.normalized):oe&&fe&&oe!==fe?(0,h.compareAnything)(oe,fe,B.normalized):0}function T(N){return N.startsWith('"')&&N.endsWith('"')}const O=" ";function U(N){typeof N!="string"&&(N="");const $=N.toLowerCase(),{pathNormalized:B,normalized:z,normalizedLowercase:W}=V(N),Y=B.indexOf(y.sep)>=0,ie=T(N);let ne;const J=N.split(O);if(J.length>1)for(const K of J){const oe=T(K),{pathNormalized:fe,normalized:pe,normalizedLowercase:Te}=V(K);pe&&(ne||(ne=[]),ne.push({original:K,originalLowercase:K.toLowerCase(),pathNormalized:fe,normalized:pe,normalizedLowercase:Te,expectContiguousMatch:oe}))}return{original:N,originalLowercase:$,pathNormalized:B,normalized:z,normalizedLowercase:W,values:ne,containsPathSeparator:Y,expectContiguousMatch:ie}}e.prepareQuery=U;function V(N){let $;R.isWindows?$=N.replace(/\//g,y.sep):$=N.replace(/\\/g,y.sep);const B=(0,k.stripWildcards)($).replace(/\s|"/g,"");return{pathNormalized:$,normalized:B,normalizedLowercase:B.toLowerCase()}}function x(N){return Array.isArray(N)?U(N.map($=>$.original).join(O)):U(N.original)}e.pieceToQuery=x}),define(ve[32],we([0,1,13,29,24,9,11,8]),function(Z,e,h,t,I,y,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function D(){return Object.create(null)}e.getEmptyExpression=D,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const P="[/\\\\]",L="[^/\\\\]",C=/\//g;function l(B){switch(B){case 0:return"";case 1:return`${L}*?`;default:return`(?:${P}|${L}+${P}|${P}${L}+)*?`}}function E(B,z){if(!B)return[];const W=[];let Y=!1,ie=!1,ne="";for(const J of B){switch(J){case z:if(!Y&&!ie){W.push(ne),ne="";continue}break;case"{":Y=!0;break;case"}":Y=!1;break;case"[":ie=!0;break;case"]":ie=!1;break}ne+=J}return ne&&W.push(ne),W}e.splitGlobAware=E;function p(B){if(!B)return"";let z="";const W=E(B,e.GLOB_SPLIT);if(W.every(Y=>Y===e.GLOBSTAR))z=".*";else{let Y=!1;W.forEach((ie,ne)=>{if(ie===e.GLOBSTAR){Y||(z+=l(2),Y=!0);return}let J=!1,K="",oe=!1,fe="";for(const pe of ie){if(pe!=="}"&&J){K+=pe;continue}if(oe&&(pe!=="]"||!fe)){let Te;pe==="-"?Te=pe:(pe==="^"||pe==="!")&&!fe?Te="^":pe===e.GLOB_SPLIT?Te="":Te=(0,k.escapeRegExpCharacters)(pe),fe+=Te;continue}switch(pe){case"{":J=!0;continue;case"[":oe=!0;continue;case"}":{z+=`(?:${E(K,",").map(Ge=>p(Ge)).join("|")})`,J=!1,K="";break}case"]":z+="["+fe+"]",oe=!1,fe="";break;case"?":z+=L;continue;case"*":z+=l(1);continue;default:z+=(0,k.escapeRegExpCharacters)(pe)}}ne<W.length-1&&(W[ne+1]!==e.GLOBSTAR||ne+2<W.length)&&(z+=P),Y=!1})}return z}const m=/^\*\*\/\*\.[\w\.-]+$/,b=/^\*\*\/([\w\.-]+)\/?$/,F=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,_=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,g=/^\*\*((\/[\w\.-]+)+)\/?$/,s=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,d=new I.LRUCache(1e4),n=function(){return!1},S=function(){return null};function o(B,z){if(!B)return S;let W;typeof B!="string"?W=B.pattern:W=B,W=W.trim();const Y=`${W}_${!!z.trimForExclusions}`;let ie=d.get(Y);if(ie)return i(ie,B);let ne;if(m.test(W)){const J=W.substr(4);ie=function(K,oe){return typeof K=="string"&&K.endsWith(J)?W:null}}else(ne=b.exec(r(W,z)))?ie=c(ne[1],W):(z.trimForExclusions?_:F).test(W)?ie=a(W,z):(ne=g.exec(r(W,z)))?ie=u(ne[1].substr(1),W,!0):(ne=s.exec(r(W,z)))?ie=u(ne[1],W,!1):ie=f(W);return d.set(Y,ie),i(ie,B)}function i(B,z){return typeof z=="string"?B:function(W,Y){return(0,t.isEqualOrParent)(W,z.base,!R.isLinux)?B(W.substr(z.base.length+1),Y):null}}function r(B,z){return z.trimForExclusions&&B.endsWith("/**")?B.substr(0,B.length-2):B}function c(B,z){const W=`/${B}`,Y=`\\${B}`,ie=function(J,K){return typeof J!="string"?null:K?K===B?z:null:J===B||J.endsWith(W)||J.endsWith(Y)?z:null},ne=[B];return ie.basenames=ne,ie.patterns=[z],ie.allBasenames=ne,ie}function a(B,z){const W=$(B.slice(1,-1).split(",").map(K=>o(K,z)).filter(K=>K!==S),B),Y=W.length;if(!Y)return S;if(Y===1)return W[0];const ie=function(K,oe){for(let fe=0,pe=W.length;fe<pe;fe++)if(W[fe](K,oe))return B;return null},ne=W.find(K=>!!K.allBasenames);ne&&(ie.allBasenames=ne.allBasenames);const J=W.reduce((K,oe)=>oe.allPaths?K.concat(oe.allPaths):K,[]);return J.length&&(ie.allPaths=J),ie}function u(B,z,W){const Y=y.sep===y.posix.sep,ie=Y?B:B.replace(C,y.sep),ne=y.sep+ie,J=y.posix.sep+B,K=W?function(oe,fe){return typeof oe=="string"&&(oe===ie||oe.endsWith(ne)||!Y&&(oe===B||oe.endsWith(J)))?z:null}:function(oe,fe){return typeof oe=="string"&&(oe===ie||!Y&&oe===B)?z:null};return K.allPaths=[(W?"*/":"./")+B],K}function f(B){try{const z=new RegExp(`^${p(B)}$`);return function(W){return z.lastIndex=0,typeof W=="string"&&z.test(W)?B:null}}catch{return S}}function v(B,z,W){return!B||typeof z!="string"?!1:w(B)(z,void 0,W)}e.match=v;function w(B,z={}){if(!B)return n;if(typeof B=="string"||O(B)){const W=o(B,z);if(W===S)return n;const Y=function(ie,ne){return!!W(ie,ne)};return W.allBasenames&&(Y.allBasenames=W.allBasenames),W.allPaths&&(Y.allPaths=W.allPaths),Y}return x(B,z)}e.parse=w;function A(B){if(!B)return;let z;return W=>(z||(z=(B()||Promise.resolve([])).then(Y=>Y?T(Y):{})),z.then(Y=>!!Y[W]))}e.hasSiblingPromiseFn=A;function M(B){if(!B)return;let z;return W=>{if(!z){const Y=B();z=Y?T(Y):{}}return!!z[W]}}e.hasSiblingFn=M;function T(B){const z={};for(const W of B)z[W]=!0;return z}function O(B){const z=B;return z?typeof z.base=="string"&&typeof z.pattern=="string":!1}e.isRelativePattern=O;function U(B){return B.allBasenames||[]}e.getBasenameTerms=U;function V(B){return B.allPaths||[]}e.getPathTerms=V;function x(B,z){const W=$(Object.getOwnPropertyNames(B).map(K=>N(K,B[K],z)).filter(K=>K!==S)),Y=W.length;if(!Y)return S;if(!W.some(K=>!!K.requiresSiblings)){if(Y===1)return W[0];const K=function(pe,Te){for(let xe=0,Ge=W.length;xe<Ge;xe++){const Qe=W[xe](pe,Te);if(Qe)return Qe}return null},oe=W.find(pe=>!!pe.allBasenames);oe&&(K.allBasenames=oe.allBasenames);const fe=W.reduce((pe,Te)=>Te.allPaths?pe.concat(Te.allPaths):pe,[]);return fe.length&&(K.allPaths=fe),K}const ie=function(K,oe,fe){let pe;for(let Te=0,xe=W.length;Te<xe;Te++){const Ge=W[Te];Ge.requiresSiblings&&fe&&(oe||(oe=(0,y.basename)(K)),pe||(pe=oe.substr(0,oe.length-(0,y.extname)(K).length)));const Qe=Ge(K,oe,pe,fe);if(Qe)return Qe}return null},ne=W.find(K=>!!K.allBasenames);ne&&(ie.allBasenames=ne.allBasenames);const J=W.reduce((K,oe)=>oe.allPaths?K.concat(oe.allPaths):K,[]);return J.length&&(ie.allPaths=J),ie}function N(B,z,W){if(z===!1)return S;const Y=o(B,W);if(Y===S)return S;if(typeof z=="boolean")return Y;if(z){const ie=z.when;if(typeof ie=="string"){const ne=(J,K,oe,fe)=>{if(!fe||!Y(J,K))return null;const pe=ie.replace("$(basename)",oe),Te=fe(pe);return(0,h.isThenable)(Te)?Te.then(xe=>xe?B:null):Te?B:null};return ne.requiresSiblings=!0,ne}}return Y}function $(B,z){const W=B.filter(K=>!!K.basenames);if(W.length<2)return B;const Y=W.reduce((K,oe)=>{const fe=oe.basenames;return fe?K.concat(fe):K},[]);let ie;if(z){ie=[];for(let K=0,oe=Y.length;K<oe;K++)ie.push(z)}else ie=W.reduce((K,oe)=>{const fe=oe.patterns;return fe?K.concat(fe):K},[]);const ne=function(K,oe){if(typeof K!="string")return null;if(!oe){let pe;for(pe=K.length;pe>0;pe--){const Te=K.charCodeAt(pe-1);if(Te===47||Te===92)break}oe=K.substr(pe)}const fe=Y.indexOf(oe);return fe!==-1?ie[fe]:null};ne.basenames=Y,ne.patterns=ie,ne.allBasenames=Y;const J=B.filter(K=>!K.basenames);return J.push(ne),J}}),define(ve[80],we([0,1,29,10,9,11,23,8,2]),function(Z,e,h,t,I,y,R,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function P(i,r,c){if(typeof i=="string"&&(i=D.URI.file(i)),c){const u=c.getWorkspaceFolder(i);if(u){const f=c.getWorkspace().folders.length>1;let v;if((0,R.isEqual)(u.uri,i)?v="":v=(0,R.relativePath)(u.uri,i),f){const w=u.name?u.name:(0,R.basename)(u.uri);v=v?w+" \u2022 "+v:w}return v}}if(i.scheme!==t.Schemas.file&&i.scheme!==t.Schemas.untitled)return i.with({query:null,fragment:null}).toString(!0);if((0,h.hasDriveLetter)(i.fsPath))return(0,I.normalize)(C(i.fsPath));let a=(0,I.normalize)(i.fsPath);return!y.isWindows&&r?.userHome&&(a=E(a,r.userHome.fsPath)),a}e.getPathLabel=P;function L(i){if(!i)return;typeof i=="string"&&(i=D.URI.file(i));const r=(0,R.basename)(i)||(i.scheme===t.Schemas.file?i.fsPath:i.path);return y.isWindows&&(0,h.isRootOrDriveLetter)(r)?C(r):r}e.getBaseLabel=L;function C(i,r){return(0,h.hasDriveLetter)(i,r)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=C;let l=Object.create(null);function E(i,r){if(y.isWindows||!i||!r)return i;let c=l.original===r?l.normalized:void 0;return c||(c=`${(0,k.rtrim)(r,I.posix.sep)}${I.posix.sep}`,l={original:r,normalized:c}),(y.isLinux?i.startsWith(c):(0,k.startsWithIgnoreCase)(i,c))&&(i=`~/${i.substr(c.length)}`),i}e.tildify=E;function p(i,r){return i.replace(/^~($|\/|\\)/,`${r}$1`)}e.untildify=p;const m="\u2026",b="\\\\",F="~";function _(i,r=I.sep){const c=new Array(i.length);let a=!1;for(let u=0;u<i.length;u++){let f=i[u];if(f===""){c[u]=`.${r}`;continue}if(!f){c[u]=f;continue}a=!0;let v="";f.indexOf(b)===0?(v=f.substr(0,f.indexOf(b)+b.length),f=f.substr(f.indexOf(b)+b.length)):f.indexOf(r)===0?(v=f.substr(0,f.indexOf(r)+r.length),f=f.substr(f.indexOf(r)+r.length)):f.indexOf(F)===0&&(v=f.substr(0,f.indexOf(F)+F.length),f=f.substr(f.indexOf(F)+F.length));const w=f.split(r);for(let A=1;a&&A<=w.length;A++)for(let M=w.length-A;a&&M>=0;M--){a=!1;let T=w.slice(M,M+A).join(r);for(let O=0;!a&&O<i.length;O++)if(O!==u&&i[O]&&i[O].indexOf(T)>-1){const U=M+A===w.length,V=M>0&&i[O].indexOf(r)>-1?r+T:T,x=i[O].endsWith(V);a=!U||x}if(!a){let O="";(w[0].endsWith(":")||v!=="")&&(M===1&&(M=0,A++,T=w[0]+r+T),M>0&&(O=w[0]+r),O=v+O),M>0&&(O=O+m+r),O=O+T,M+A<w.length&&(O=O+r+m),c[u]=O}}a&&(c[u]=f)}return c}e.shorten=_;var g;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(g||(g={}));function s(i,r=Object.create(null)){const c=[];let a=!1,u="";for(const f of i)if(f==="$"||a&&f==="{")u&&c.push({value:u,type:g.TEXT}),u="",a=!0;else if(f==="}"&&a){const v=r[u];if(typeof v=="string")v.length&&c.push({value:v,type:g.VARIABLE});else if(v){const w=c[c.length-1];(!w||w.type!==g.SEPARATOR)&&c.push({value:v.label,type:g.SEPARATOR})}u="",a=!1}else u+=f;return u&&!a&&c.push({value:u,type:g.TEXT}),c.filter((f,v)=>{if(f.type===g.SEPARATOR){const w=c[v-1],A=c[v+1];return[w,A].every(M=>M&&(M.type===g.VARIABLE||M.type===g.TEXT)&&M.value.length>0)}return!0}).map(f=>f.value).join("")}e.template=s;function d(i,r){return y.isMacintosh||r?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,y.isMacintosh?"&":"&&"):i.replace(/&&|&/g,c=>c==="&"?"&&":"&")}e.mnemonicMenuLabel=d;function n(i,r){return y.isMacintosh||r?i.replace(/\(&&\w\)|&&/g,""):y.isWindows?i.replace(/&&|&/g,c=>c==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=n;function S(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=S;function o(i){const r=i.indexOf("/")!==-1?I.posix:I.win32,c=r.basename(i),a=r.dirname(i);return c.length?{name:c,parentPath:a}:{name:a,parentPath:""}}e.splitName=o}),define(ve[103],we([0,1,2]),function(Z,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(L){return L.toJSON()}class I{constructor(C){this._uriTransformer=C}transformIncoming(C){const l=this._uriTransformer.transformIncoming(C);return l===C?C:t(h.URI.from(l))}transformOutgoing(C){const l=this._uriTransformer.transformOutgoing(C);return l===C?C:t(h.URI.from(l))}transformOutgoingURI(C){const l=this._uriTransformer.transformOutgoing(C);return l===C?C:h.URI.from(l)}transformOutgoingScheme(C){return this._uriTransformer.transformOutgoingScheme(C)}}e.URITransformer=I,e.DefaultURITransformer=new class{transformIncoming(L){return L}transformOutgoing(L){return L}transformOutgoingURI(L){return L}transformOutgoingScheme(L){return L}};function y(L,C,l){if(!L||l>200)return null;if(typeof L=="object"){if(L instanceof h.URI)return C.transformOutgoing(L);for(let E in L)if(Object.hasOwnProperty.call(L,E)){const p=y(L[E],C,l+1);p!==null&&(L[E]=p)}}return null}function R(L,C){const l=y(L,C,0);return l===null?L:l}e.transformOutgoingURIs=R;function k(L,C,l,E){if(!L||E>200)return null;if(typeof L=="object"){if(L.$mid===1)return l?h.URI.revive(C.transformIncoming(L)):C.transformIncoming(L);for(let p in L)if(Object.hasOwnProperty.call(L,p)){const m=k(L[p],C,l,E+1);m!==null&&(L[p]=m)}}return null}function D(L,C){const l=k(L,C,!1,0);return l===null?L:l}e.transformIncomingURIs=D;function P(L,C){const l=k(L,C,!0,0);return l===null?L:l}e.transformAndReviveIncomingURIs=P}),define(ve[33],we([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const h=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(D){return h.test(D)}e.isUUID=t;const I=new Uint8Array(16),y=[];for(let D=0;D<256;D++)y.push(D.toString(16).padStart(2,"0"));let R;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?R=crypto.getRandomValues.bind(crypto):R=function(D){for(let P=0;P<D.length;P++)D[P]=Math.floor(Math.random()*256);return D};function k(){R(I),I[6]=I[6]&15|64,I[8]=I[8]&63|128;let D=0,P="";return P+=y[I[D++]],P+=y[I[D++]],P+=y[I[D++]],P+=y[I[D++]],P+="-",P+=y[I[D++]],P+=y[I[D++]],P+="-",P+=y[I[D++]],P+=y[I[D++]],P+="-",P+=y[I[D++]],P+=y[I[D++]],P+="-",P+=y[I[D++]],P+=y[I[D++]],P+=y[I[D++]],P+=y[I[D++]],P+=y[I[D++]],P+=y[I[D++]],P}e.generateUuid=k}),define(ve[144],we([0,1,104]),function(Z,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class t{constructor(y="utf8"){this.stringDecoder=new h.StringDecoder(y),this.remaining=null}write(y){const R=[],k=this.remaining?this.remaining+this.stringDecoder.write(y):this.stringDecoder.write(y);if(k.length<1)return R;let D=0,P,L=D;for(;L<k.length;)if(P=k.charCodeAt(L),P===13||P===10){if(R.push(k.substring(D,L)),L++,L<k.length){const C=P;P=k.charCodeAt(L),(C===13&&P===10||C===10&&P===13)&&L++}D=L}else L++;return this.remaining=D<k.length?k.substr(D):null,R}end(){return this.remaining}}e.LineDecoder=t}),define(ve[30],we([0,1,60,81,291,13,29,79,9,11,23,2]),function(Z,e,h,t,I,y,R,k,D,P,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var l;(function(U){U[U.UNLINK=0]="UNLINK",U[U.MOVE=1]="MOVE"})(l=e.RimRafMode||(e.RimRafMode={}));async function E(U,V=l.UNLINK){if((0,R.isRootOrDriveLetter)(U))throw new Error("rimraf - will refuse to recursively delete root");return V===l.UNLINK?m(U):p(U)}async function p(U){try{const V=(0,R.randomPath)((0,t.tmpdir)());try{await h.promises.rename(U,V)}catch{return m(U)}m(V).catch(x=>{})}catch(V){if(V.code!=="ENOENT")throw V}}async function m(U){return e.Promises.rmdir(U,{recursive:!0,maxRetries:3})}function b(U){if((0,R.isRootOrDriveLetter)(U))throw new Error("rimraf - will refuse to recursively delete root");h.rmdirSync(U,{recursive:!0})}e.rimrafSync=b;async function F(U,V){return s(await(V?_(U):(0,I.promisify)(h.readdir)(U)))}async function _(U){try{return await(0,I.promisify)(h.readdir)(U,{withFileTypes:!0})}catch(N){console.warn("[node.js fs] readdir with filetypes failed with error: ",N)}const V=[],x=await F(U);for(const N of x){let $=!1,B=!1,z=!1;try{const W=await e.Promises.lstat((0,D.join)(U,N));$=W.isFile(),B=W.isDirectory(),z=W.isSymbolicLink()}catch(W){console.warn("[node.js fs] unexpected error from lstat after readdir: ",W)}V.push({name:N,isFile:()=>$,isDirectory:()=>B,isSymbolicLink:()=>z})}return V}function g(U){return s(h.readdirSync(U))}e.readdirSync=g;function s(U){return U.map(V=>typeof V=="string"?P.isMacintosh?(0,k.normalizeNFC)(V):V:(V.name=P.isMacintosh?(0,k.normalizeNFC)(V.name):V.name,V))}async function d(U){const V=await F(U),x=[];for(const N of V)await S.existsDirectory((0,D.join)(U,N))&&x.push(N);return x}function n(U,V=1e3){return new Promise(x=>{let N=!1;const $=setInterval(()=>{N||(N=!0,h.access(U,B=>{N=!1,B&&(clearInterval($),x(void 0))}))},V)})}e.whenDeleted=n;var S;(function(U){async function V($){let B;try{if(B=await e.Promises.lstat($),!B.isSymbolicLink())return{stat:B}}catch{}try{return{stat:await e.Promises.stat($),symbolicLink:B?.isSymbolicLink()?{dangling:!1}:void 0}}catch(z){if(z.code==="ENOENT"&&B)return{stat:B,symbolicLink:{dangling:!0}};if(P.isWindows&&z.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink($)),symbolicLink:{dangling:!1}}}catch(W){if(W.code==="ENOENT"&&B)return{stat:B,symbolicLink:{dangling:!0}};throw W}throw z}}U.stat=V;async function x($){try{const{stat:B,symbolicLink:z}=await U.stat($);return B.isFile()&&z?.dangling!==!0}catch{}return!1}U.existsFile=x;async function N($){try{const{stat:B,symbolicLink:z}=await U.stat($);return B.isDirectory()&&z?.dangling!==!0}catch{}return!1}U.existsDirectory=N})(S=e.SymlinkSupport||(e.SymlinkSupport={}));const o=new y.ResourceQueue;function i(U,V,x){return o.queueFor(C.URI.file(U),L.extUriBiasedIgnorePathCase).queue(()=>{const N=u(x);return new Promise(($,B)=>c(U,V,N,z=>z?B(z):$()))})}let r=!0;function c(U,V,x,N){if(!r)return h.writeFile(U,V,{mode:x.mode,flag:x.flag},N);h.open(U,x.flag,x.mode,($,B)=>{if($)return N($);h.writeFile(B,V,z=>{if(z)return h.close(B,()=>N(z));h.fdatasync(B,W=>(W&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",W),r=!1),h.close(B,Y=>N(Y))))})})}function a(U,V,x){const N=u(x);if(!r)return h.writeFileSync(U,V,{mode:N.mode,flag:N.flag});const $=h.openSync(U,N.flag,N.mode);try{h.writeFileSync($,V);try{h.fdatasyncSync($)}catch(B){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",B),r=!1}}finally{h.closeSync($)}}e.writeFileSync=a;function u(U){return U?{mode:typeof U.mode=="number"?U.mode:438,flag:typeof U.flag=="string"?U.flag:"w"}:{mode:438,flag:"w"}}async function f(U,V){if(U===V)return;async function x(N){try{const $=await e.Promises.lstat(N);if($.isDirectory()||$.isSymbolicLink())return;await e.Promises.utimes(N,$.atime,new Date)}catch{}}try{await e.Promises.rename(U,V),await x(V)}catch(N){if(U.toLowerCase()!==V.toLowerCase()&&N.code==="EXDEV"||U.endsWith("."))await v(U,V,{preserveSymlinks:!1}),await E(U,l.MOVE),await x(V);else throw N}}async function v(U,V,x){return A(U,V,{root:{source:U,target:V},options:x,handledSourcePaths:new Set})}const w=511;async function A(U,V,x){if(x.handledSourcePaths.has(U))return;x.handledSourcePaths.add(U);const{stat:N,symbolicLink:$}=await S.stat(U);if($){if(x.options.preserveSymlinks)try{return await O(U,V,x)}catch(B){console.warn("[node.js fs] copy of symlink failed: ",B)}if($.dangling)return}return N.isDirectory()?M(U,V,N.mode&w,x):T(U,V,N.mode&w)}async function M(U,V,x,N){await e.Promises.mkdir(V,{recursive:!0,mode:x});const $=await F(U);for(const B of $)await A((0,D.join)(U,B),(0,D.join)(V,B),N)}async function T(U,V,x){await e.Promises.copyFile(U,V),await e.Promises.chmod(V,x)}async function O(U,V,x){let N=await e.Promises.readlink(U);(0,R.isEqualOrParent)(N,x.root.source,!P.isLinux)&&(N=(0,D.join)(x.root.target,N.substr(x.root.source.length+1))),await e.Promises.symlink(N,V)}e.Promises=new class{get access(){return(0,I.promisify)(h.access)}get stat(){return(0,I.promisify)(h.stat)}get lstat(){return(0,I.promisify)(h.lstat)}get utimes(){return(0,I.promisify)(h.utimes)}get read(){return(U,V,x,N,$)=>new Promise((B,z)=>{h.read(U,V,x,N,$,(W,Y,ie)=>W?z(W):B({bytesRead:Y,buffer:ie}))})}get readFile(){return(0,I.promisify)(h.readFile)}get write(){return(U,V,x,N,$)=>new Promise((B,z)=>{h.write(U,V,x,N,$,(W,Y,ie)=>W?z(W):B({bytesWritten:Y,buffer:ie}))})}get appendFile(){return(0,I.promisify)(h.appendFile)}get fdatasync(){return(0,I.promisify)(h.fdatasync)}get truncate(){return(0,I.promisify)(h.truncate)}get rename(){return(0,I.promisify)(h.rename)}get copyFile(){return(0,I.promisify)(h.copyFile)}get open(){return(0,I.promisify)(h.open)}get close(){return(0,I.promisify)(h.close)}get symlink(){return(0,I.promisify)(h.symlink)}get readlink(){return(0,I.promisify)(h.readlink)}get chmod(){return(0,I.promisify)(h.chmod)}get mkdir(){return(0,I.promisify)(h.mkdir)}get unlink(){return(0,I.promisify)(h.unlink)}get rmdir(){return(0,I.promisify)(h.rmdir)}get realpath(){return(0,I.promisify)(h.realpath)}async exists(U){try{return await e.Promises.access(U),!0}catch{return!1}}get readdir(){return F}get readDirsInDir(){return d}get writeFile(){return i}get rm(){return E}get move(){return f}get copy(){return v}}}),define(ve[105],we([0,1,60,9,11,8,30]),function(Z,e,h,t,I,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function k(l){if(I.isLinux)return l;const E=(0,t.dirname)(l);if(l===E)return l;const p=((0,t.basename)(l)||l).toLowerCase();try{const b=(0,R.readdirSync)(E).filter(F=>F.toLowerCase()===p);if(b.length===1){const F=k(E);if(F)return(0,t.join)(F,b[0])}else if(b.length>1){const F=b.indexOf(p);if(F>=0){const _=k(E);if(_)return(0,t.join)(_,b[F])}}}catch{}return null}e.realcaseSync=k;async function D(l){if(I.isLinux)return l;const E=(0,t.dirname)(l);if(l===E)return l;const p=((0,t.basename)(l)||l).toLowerCase();try{const b=(await R.Promises.readdir(E)).filter(F=>F.toLowerCase()===p);if(b.length===1){const F=await D(E);if(F)return(0,t.join)(F,b[0])}else if(b.length>1){const F=b.indexOf(p);if(F>=0){const _=await D(E);if(_)return(0,t.join)(_,b[F])}}}catch{}return null}e.realcase=D;async function P(l){try{return await R.Promises.realpath(l)}catch{const p=C(l);return await R.Promises.access(p,h.constants.R_OK),p}}e.realpath=P;function L(l){try{return h.realpathSync(l)}catch{const p=C(l);return h.accessSync(p,h.constants.R_OK),p}}e.realpathSync=L;function C(l){return(0,y.rtrim)((0,t.normalize)(l),t.sep)}});var je=this&&this.__decorate||function(Z,e,h,t){var I=arguments.length,y=I<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,h):t,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")y=Reflect.decorate(Z,e,h,t);else for(var k=Z.length-1;k>=0;k--)(R=Z[k])&&(y=(I<3?R(y):I>3?R(e,h,y):R(e,h))||y);return I>3&&y&&Object.defineProperty(e,h,y),y};define(ve[106],we([0,1,17,13,22,21,56,16,3,6,59,8,18]),function(Z,e,h,t,I,y,R,k,D,P,L,C,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var E;(function(B){B[B.Promise=100]="Promise",B[B.PromiseCancel=101]="PromiseCancel",B[B.EventListen=102]="EventListen",B[B.EventDispose=103]="EventDispose"})(E=e.RequestType||(e.RequestType={}));function p(B){switch(B){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var m;(function(B){B[B.Initialize=200]="Initialize",B[B.PromiseSuccess=201]="PromiseSuccess",B[B.PromiseError=202]="PromiseError",B[B.PromiseErrorObj=203]="PromiseErrorObj",B[B.EventFire=204]="EventFire"})(m=e.ResponseType||(e.ResponseType={}));function b(B){switch(B){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var F;(function(B){B[B.Uninitialized=0]="Uninitialized",B[B.Idle=1]="Idle"})(F||(F={}));class _{constructor(z){this.buffer=z,this.pos=0}read(z){const W=this.buffer.slice(this.pos,this.pos+z);return this.pos+=W.byteLength,W}}class g{constructor(){this.buffers=[]}get buffer(){return I.VSBuffer.concat(this.buffers)}write(z){this.buffers.push(z)}}var s;(function(B){B[B.Undefined=0]="Undefined",B[B.String=1]="String",B[B.Buffer=2]="Buffer",B[B.VSBuffer=3]="VSBuffer",B[B.Array=4]="Array",B[B.Object=5]="Object"})(s||(s={}));function d(B){const z=I.VSBuffer.alloc(4);return z.writeUInt32BE(B,0),z}function n(B){return B.read(4).readUInt32BE(0)}function S(B){const z=I.VSBuffer.alloc(1);return z.writeUInt8(B,0),z}const o={Undefined:S(s.Undefined),String:S(s.String),Buffer:S(s.Buffer),VSBuffer:S(s.VSBuffer),Array:S(s.Array),Object:S(s.Object)},i=typeof Buffer!="undefined";function r(B,z){if(typeof z=="undefined")B.write(o.Undefined);else if(typeof z=="string"){const W=I.VSBuffer.fromString(z);B.write(o.String),B.write(d(W.byteLength)),B.write(W)}else if(i&&Buffer.isBuffer(z)){const W=I.VSBuffer.wrap(z);B.write(o.Buffer),B.write(d(W.byteLength)),B.write(W)}else if(z instanceof I.VSBuffer)B.write(o.VSBuffer),B.write(d(z.byteLength)),B.write(z);else if(Array.isArray(z)){B.write(o.Array),B.write(d(z.length));for(const W of z)r(B,W)}else{const W=I.VSBuffer.fromString(JSON.stringify(z));B.write(o.Object),B.write(d(W.byteLength)),B.write(W)}}function c(B){switch(B.read(1).readUInt8(0)){case s.Undefined:return;case s.String:return B.read(n(B)).toString();case s.Buffer:return B.read(n(B)).buffer;case s.VSBuffer:return B.read(n(B));case s.Array:{const W=n(B),Y=[];for(let ie=0;ie<W;ie++)Y.push(c(B));return Y}case s.Object:return JSON.parse(B.read(n(B)).toString())}}class a{constructor(z,W,Y=null,ie=1e3){this.protocol=z,this.ctx=W,this.logger=Y,this.timeoutDelay=ie,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(ne=>this.onRawMessage(ne)),this.sendResponse({type:200})}registerChannel(z,W){this.channels.set(z,W),setTimeout(()=>this.flushPendingRequests(z),0)}sendResponse(z){switch(z.type){case 200:{const W=this.send([z.type]);this.logger&&this.logger.logOutgoing(W,0,1,b(z.type));return}case 201:case 202:case 204:case 203:{const W=this.send([z.type,z.id],z.data);this.logger&&this.logger.logOutgoing(W,z.id,1,b(z.type),z.data);return}}}send(z,W=void 0){const Y=new g;return r(Y,z),r(Y,W),this.sendBuffer(Y.buffer)}sendBuffer(z){try{return this.protocol.send(z),z.byteLength}catch{return 0}}onRawMessage(z){const W=new _(z),Y=c(W),ie=c(W),ne=Y[0];switch(ne){case 100:return this.logger&&this.logger.logIncoming(z.byteLength,Y[1],1,`${p(ne)}: ${Y[2]}.${Y[3]}`,ie),this.onPromise({type:ne,id:Y[1],channelName:Y[2],name:Y[3],arg:ie});case 102:return this.logger&&this.logger.logIncoming(z.byteLength,Y[1],1,`${p(ne)}: ${Y[2]}.${Y[3]}`,ie),this.onEventListen({type:ne,id:Y[1],channelName:Y[2],name:Y[3],arg:ie});case 101:return this.logger&&this.logger.logIncoming(z.byteLength,Y[1],1,`${p(ne)}`),this.disposeActiveRequest({type:ne,id:Y[1]});case 103:return this.logger&&this.logger.logIncoming(z.byteLength,Y[1],1,`${p(ne)}`),this.disposeActiveRequest({type:ne,id:Y[1]})}}onPromise(z){const W=this.channels.get(z.channelName);if(!W){this.collectPendingRequest(z);return}const Y=new y.CancellationTokenSource;let ie;try{ie=W.call(this.ctx,z.name,z.arg,Y.token)}catch(K){ie=Promise.reject(K)}const ne=z.id;ie.then(K=>{this.sendResponse({id:ne,data:K,type:201}),this.activeRequests.delete(z.id)},K=>{K instanceof Error?this.sendResponse({id:ne,data:{message:K.message,name:K.name,stack:K.stack?K.stack.split?K.stack.split(`
`):K.stack:void 0},type:202}):this.sendResponse({id:ne,data:K,type:203}),this.activeRequests.delete(z.id)});const J=(0,P.toDisposable)(()=>Y.cancel());this.activeRequests.set(z.id,J)}onEventListen(z){const W=this.channels.get(z.channelName);if(!W){this.collectPendingRequest(z);return}const Y=z.id,ne=W.listen(this.ctx,z.name,z.arg)(J=>this.sendResponse({id:Y,data:J,type:204}));this.activeRequests.set(z.id,ne)}disposeActiveRequest(z){const W=this.activeRequests.get(z.id);W&&(W.dispose(),this.activeRequests.delete(z.id))}collectPendingRequest(z){let W=this.pendingRequests.get(z.channelName);W||(W=[],this.pendingRequests.set(z.channelName,W));const Y=setTimeout(()=>{console.error(`Unknown channel: ${z.channelName}`),z.type===100&&this.sendResponse({id:z.id,data:{name:"Unknown channel",message:`Channel name '${z.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);W.push({request:z,timeoutTimer:Y})}flushPendingRequests(z){const W=this.pendingRequests.get(z);if(W){for(const Y of W)switch(clearTimeout(Y.timeoutTimer),Y.request.type){case 100:this.onPromise(Y.request);break;case 102:this.onEventListen(Y.request);break}this.pendingRequests.delete(z)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(z=>z.dispose()),this.activeRequests.clear()}}e.ChannelServer=a;var u;(function(B){B[B.LocalSide=0]="LocalSide",B[B.OtherSide=1]="OtherSide"})(u=e.RequestInitiator||(e.RequestInitiator={}));class f{constructor(z,W=null){this.protocol=z,this.isDisposed=!1,this.state=F.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new D.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(Y=>this.onBuffer(Y)),this.logger=W}getChannel(z){const W=this;return{call(Y,ie,ne){return W.isDisposed?Promise.reject(k.canceled()):W.requestPromise(z,Y,ie,ne)},listen(Y,ie){return W.isDisposed?Promise.reject(k.canceled()):W.requestEvent(z,Y,ie)}}}requestPromise(z,W,Y,ie=y.CancellationToken.None){const ne=this.lastRequestId++,K={id:ne,type:100,channelName:z,name:W,arg:Y};if(ie.isCancellationRequested)return Promise.reject(k.canceled());let oe;return new Promise((pe,Te)=>{if(ie.isCancellationRequested)return Te(k.canceled());const xe=()=>{const te=G=>{switch(G.type){case 201:this.handlers.delete(ne),pe(G.data);break;case 202:{this.handlers.delete(ne);const Q=new Error(G.data.message);Q.stack=G.data.stack,Q.name=G.data.name,Te(Q);break}case 203:this.handlers.delete(ne),Te(G.data);break}};this.handlers.set(ne,te),this.sendRequest(K)};let Ge=null;this.state===F.Idle?xe():(Ge=(0,t.createCancelablePromise)(te=>this.whenInitialized()),Ge.then(()=>{Ge=null,xe()}));const Qe=()=>{Ge?(Ge.cancel(),Ge=null):this.sendRequest({id:ne,type:101}),Te(k.canceled())},q=ie.onCancellationRequested(Qe);oe=(0,P.combinedDisposable)((0,P.toDisposable)(Qe),q),this.activeRequests.add(oe)}).finally(()=>{this.activeRequests.delete(oe)})}requestEvent(z,W,Y){const ie=this.lastRequestId++,J={id:ie,type:102,channelName:z,name:W,arg:Y};let K=null;const oe=new D.Emitter({onFirstListenerAdd:()=>{K=(0,t.createCancelablePromise)(pe=>this.whenInitialized()),K.then(()=>{K=null,this.activeRequests.add(oe),this.sendRequest(J)})},onLastListenerRemove:()=>{K?(K.cancel(),K=null):(this.activeRequests.delete(oe),this.sendRequest({id:ie,type:103}))}}),fe=pe=>oe.fire(pe.data);return this.handlers.set(ie,fe),oe.event}sendRequest(z){switch(z.type){case 100:case 102:{const W=this.send([z.type,z.id,z.channelName,z.name],z.arg);this.logger&&this.logger.logOutgoing(W,z.id,0,`${p(z.type)}: ${z.channelName}.${z.name}`,z.arg);return}case 101:case 103:{const W=this.send([z.type,z.id]);this.logger&&this.logger.logOutgoing(W,z.id,0,p(z.type));return}}}send(z,W=void 0){const Y=new g;return r(Y,z),r(Y,W),this.sendBuffer(Y.buffer)}sendBuffer(z){try{return this.protocol.send(z),z.byteLength}catch{return 0}}onBuffer(z){const W=new _(z),Y=c(W),ie=c(W),ne=Y[0];switch(ne){case 200:return this.logger&&this.logger.logIncoming(z.byteLength,0,0,b(ne)),this.onResponse({type:Y[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(z.byteLength,Y[1],0,b(ne),ie),this.onResponse({type:Y[0],id:Y[1],data:ie})}}onResponse(z){if(z.type===200){this.state=F.Idle,this._onDidInitialize.fire();return}const W=this.handlers.get(z.id);W&&W(z)}get onDidInitializePromise(){return D.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===F.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(z=>z.dispose()),this.activeRequests.clear()}}je([R.memoize],f.prototype,"onDidInitializePromise",null),e.ChannelClient=f;class v{constructor(z){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new D.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new D.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,z(({protocol:W,onDidClientDisconnect:Y})=>{D.Event.once(W.onMessage)(ne=>{const J=new _(ne),K=c(J),oe=new a(W,K),fe=new f(W);this.channels.forEach((Te,xe)=>oe.registerChannel(xe,Te));const pe={channelServer:oe,channelClient:fe,ctx:K};this._connections.add(pe),this._onDidAddConnection.fire(pe),Y(()=>{oe.dispose(),fe.dispose(),this._connections.delete(pe),this._onDidRemoveConnection.fire(pe)})})})}get connections(){const z=[];return this._connections.forEach(W=>z.push(W)),z}getChannel(z,W){const Y=this;return{call(ie,ne,J){let K;if((0,l.isFunction)(W)){let fe=(0,h.getRandomElement)(Y.connections.filter(W));K=fe?Promise.resolve(fe):D.Event.toPromise(D.Event.filter(Y.onDidAddConnection,W))}else K=W.routeCall(Y,ie,ne);const oe=K.then(fe=>fe.channelClient.getChannel(z));return A(oe).call(ie,ne,J)},listen(ie,ne){if((0,l.isFunction)(W))return Y.getMulticastEvent(z,W,ie,ne);const J=W.routeEvent(Y,ie,ne).then(K=>K.channelClient.getChannel(z));return A(J).listen(ie,ne)}}}getMulticastEvent(z,W,Y,ie){const ne=this;let J=new P.DisposableStore;const K=new D.Emitter({onFirstListenerAdd:()=>{J=new P.DisposableStore;const oe=new D.EventMultiplexer,fe=new Map,pe=xe=>{const Qe=xe.channelClient.getChannel(z).listen(Y,ie),q=oe.add(Qe);fe.set(xe,q)},Te=xe=>{const Ge=fe.get(xe);!Ge||(Ge.dispose(),fe.delete(xe))};ne.connections.filter(W).forEach(pe),D.Event.filter(ne.onDidAddConnection,W)(pe,void 0,J),ne.onDidRemoveConnection(Te,void 0,J),oe.event(K.fire,K,J),J.add(oe)},onLastListenerRemove:()=>{J.dispose()}});return K.event}registerChannel(z,W){this.channels.set(z,W),this._connections.forEach(Y=>{Y.channelServer.registerChannel(z,W)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=v;class w{constructor(z,W,Y=null){const ie=new g;r(ie,W),z.send(ie.buffer),this.channelClient=new f(z,Y),this.channelServer=new a(z,W,Y)}getChannel(z){return this.channelClient.getChannel(z)}registerChannel(z,W){this.channelServer.registerChannel(z,W)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=w;function A(B){return{call(z,W,Y){return B.then(ie=>ie.call(z,W,Y))},listen(z,W){const Y=new D.Relay;return B.then(ie=>Y.input=ie.listen(z,W)),Y.event}}}e.getDelayedChannel=A;function M(B){let z=!1;return{call(W,Y,ie){return z?B.call(W,Y,ie):(0,t.timeout)(0).then(()=>z=!0).then(()=>B.call(W,Y,ie))},listen(W,Y){if(z)return B.listen(W,Y);const ie=new D.Relay;return(0,t.timeout)(0).then(()=>z=!0).then(()=>ie.input=B.listen(W,Y)),ie.event}}}e.getNextTickChannel=M;class T{constructor(z){this.fn=z}routeCall(z){return this.route(z)}routeEvent(z){return this.route(z)}async route(z){for(const W of z.connections)if(await Promise.resolve(this.fn(W.ctx)))return Promise.resolve(W);return await D.Event.toPromise(z.onDidAddConnection),await this.route(z)}}e.StaticRouter=T;var O;(function(B){function z(ne,J){const K=ne,oe=J&&J.disableMarshalling,fe=new Map;for(const pe in K)Y(pe)&&fe.set(pe,D.Event.buffer(K[pe],!0));return new class{listen(pe,Te,xe){const Ge=fe.get(Te);if(Ge)return Ge;if(ie(Te)){const Qe=K[Te];if(typeof Qe=="function")return Qe.call(K,xe)}throw new Error(`Event not found: ${Te}`)}call(pe,Te,xe){const Ge=K[Te];if(typeof Ge=="function"){if(!oe&&Array.isArray(xe))for(let Qe=0;Qe<xe.length;Qe++)xe[Qe]=(0,L.revive)(xe[Qe]);return Ge.apply(K,xe)}throw new Error(`Method not found: ${Te}`)}}}B.fromService=z;function W(ne,J){const K=J&&J.disableMarshalling;return new Proxy({},{get(oe,fe){if(typeof fe=="string")return J?.properties?.has(fe)?J.properties.get(fe):ie(fe)?function(pe){return ne.listen(fe,pe)}:Y(fe)?ne.listen(fe):async function(...pe){let Te;J&&!(0,l.isUndefinedOrNull)(J.context)?Te=[J.context,...pe]:Te=pe;const xe=await ne.call(fe,Te);return K?xe:(0,L.revive)(xe)};throw new Error(`Property not found: ${String(fe)}`)}})}B.toService=W;function Y(ne){return ne[0]==="o"&&ne[1]==="n"&&C.isUpperAsciiLetter(ne.charCodeAt(2))}function ie(ne){return/^onDynamic/.test(ne)&&C.isUpperAsciiLetter(ne.charCodeAt(9))}})(O=e.ProxyChannel||(e.ProxyChannel={}));const U=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function V(B){if(Array.isArray(B))return B;if(B&&typeof B=="object"&&typeof B.toString=="function"){let z=B.toString();if(z!=="[object Object]")return z}return B}function x(B){return Array.isArray(B)?B.map(V):V(B)}function N(B,z,W,Y,ie,ne,J){J=x(J);const K=U[ie],oe=K[Y%K.length];let fe=[`%c[${B}]%c[${String(z).padStart(7," ")}]%c[len: ${String(W).padStart(5," ")}]%c${String(Y).padStart(5," ")} - ${ne}`,"color: darkgreen","color: grey","color: grey",`color: ${oe}`];/\($/.test(ne)?(fe=fe.concat(J),fe.push(")")):fe.push(J),console.log.apply(console,fe)}e.logWithColors=N;class ${constructor(z,W){this._outgoingPrefix=z,this._incomingPrefix=W,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(z,W,Y,ie,ne){this._totalOutgoing+=z,N(this._outgoingPrefix,this._totalOutgoing,z,W,Y,ie,ne)}logIncoming(z,W,Y,ie,ne){this._totalIncoming+=z,N(this._incomingPrefix,this._totalIncoming,z,W,Y,ie,ne)}}e.IPCLogger=$}),define(ve[107],we([0,1,22,3,6,106]),function(Z,e,h,t,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var R;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(R=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var k;(function(i){i.enableDiagnostics=!1,i.records=[];const r=new WeakMap;let c=0;function a(f,v){if(!r.has(f)){const w=String(++c);r.set(f,w)}return r.get(f)}function u(f,v,w,A){if(!i.enableDiagnostics)return;const M=a(f,v);if(A instanceof h.VSBuffer||A instanceof Uint8Array||A instanceof ArrayBuffer||ArrayBuffer.isView(A)){const T=h.VSBuffer.alloc(A.byteLength);T.set(A),i.records.push({timestamp:Date.now(),id:M,label:v,type:w,buff:T})}else i.records.push({timestamp:Date.now(),id:M,label:v,type:w,data:A})}i.traceSocketEvent=u})(k=e.SocketDiagnostics||(e.SocketDiagnostics={}));var D;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(D=e.SocketCloseEventType||(e.SocketCloseEventType={}));let P=null;function L(){return P||(P=h.VSBuffer.alloc(0)),P}class C{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(r){this._chunks.push(r),this._totalLength+=r.byteLength}read(r){return this._read(r,!0)}peek(r){return this._read(r,!1)}_read(r,c){if(r===0)return L();if(r>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===r){const v=this._chunks[0];return c&&(this._chunks.shift(),this._totalLength-=r),v}if(this._chunks[0].byteLength>r){const v=this._chunks[0].slice(0,r);return c&&(this._chunks[0]=this._chunks[0].slice(r),this._totalLength-=r),v}let a=h.VSBuffer.alloc(r),u=0,f=0;for(;r>0;){const v=this._chunks[f];if(v.byteLength>r){const w=v.slice(0,r);a.set(w,u),u+=r,c&&(this._chunks[f]=v.slice(r),this._totalLength-=r),r-=r}else a.set(v,u),u+=v.byteLength,c?(this._chunks.shift(),this._totalLength-=v.byteLength):f++,r-=v.byteLength}return a}}e.ChunkStream=C;var l;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume"})(l||(l={}));function E(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting"}}var p;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(p=e.ProtocolConstants||(e.ProtocolConstants={}));class m{constructor(r,c,a,u){this.type=r,this.id=c,this.ack=a,this.data=u,this.writtenTime=0}get size(){return this.data.byteLength}}class b extends I.Disposable{constructor(r){super();this._onMessage=this._register(new t.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=r,this._isDisposed=!1,this._incomingData=new C,this._register(this._socket.onData(c=>this.acceptChunk(c))),this.lastReadTime=Date.now()}acceptChunk(r){if(!(!r||r.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(r);this._incomingData.byteLength>=this._state.readLen;){const c=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=c.readUInt32BE(9),this._state.messageType=c.readUInt8(0),this._state.id=c.readUInt32BE(1),this._state.ack=c.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:E(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const a=this._state.messageType,u=this._state.id,f=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",c),this._onMessage.fire(new m(a,u,f,c)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class F{constructor(r){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=r,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(r){if(this._isDisposed)return;r.writtenTime=Date.now(),this.lastWriteTime=Date.now();const c=h.VSBuffer.alloc(13);c.writeUInt8(r.type,0),c.writeUInt32BE(r.id,1),c.writeUInt32BE(r.ack,5),c.writeUInt32BE(r.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:E(r.type),id:r.id,ack:r.ack,messageSize:r.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",r.data),this._writeSoon(c,r.data)}_bufferAdd(r,c){const a=this._totalLength===0;return this._data.push(r,c),this._totalLength+=r.byteLength+c.byteLength,a}_bufferTake(){const r=h.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,r}_writeSoon(r,c){this._bufferAdd(r,c)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const r=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:r.byteLength}),this._socket.write(r)}}class _ extends I.Disposable{constructor(r){super();this._onMessage=new t.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=r,this._socketWriter=this._register(new F(this._socket)),this._socketReader=this._register(new b(this._socket)),this._register(this._socketReader.onMessage(c=>{c.type===1&&this._onMessage.fire(c.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(r){this._socketWriter.write(new m(1,0,0,r))}}e.Protocol=_;class g extends y.IPCClient{constructor(r,c,a=null){super(r,c,a);this.protocol=r}static fromSocket(r,c){return new g(new _(r),c)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const r=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),r.end()}}e.Client=g;class s{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new t.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(r){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(r):this._emitter.fire(r):this._bufferedMessages.push(r)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=s;class d{constructor(r){this.data=r,this.next=null}}class n{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let r=[],c=0,a=this._first;for(;a;)r[c++]=a.data,a=a.next;return r}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(r){const c=new d(r);if(!this._first){this._first=c,this._last=c;return}this._last.next=c,this._last=c}}class S{constructor(){this.lastRuns=[];const r=Date.now();for(let c=0;c<S._HISTORY_LENGTH;c++)this.lastRuns[c]=r-1e3*c;setInterval(()=>{for(let c=S._HISTORY_LENGTH;c>=1;c--)this.lastRuns[c]=this.lastRuns[c-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return S._INSTANCE||(S._INSTANCE=new S),S._INSTANCE}load(){const r=Date.now(),c=(1+S._HISTORY_LENGTH)*1e3;let a=0;for(let u=0;u<S._HISTORY_LENGTH;u++)r-this.lastRuns[u]<=c&&a++;return 1-a/S._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}S._HISTORY_LENGTH=10,S._INSTANCE=null;class o{constructor(r,c=null,a=S.getInstance()){this._onControlMessage=new s,this.onControlMessage=this._onControlMessage.event,this._onMessage=new s,this.onMessage=this._onMessage.event,this._onDidDispose=new s,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new s,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new s,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=a,this._isReconnecting=!1,this._outgoingUnackMsg=new n,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=r,this._socketWriter=new F(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new b(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(u=>this._receiveMessage(u))),this._socketDisposables.push(this._socket.onClose(u=>this._onSocketClose.fire(u))),c&&this._socketReader.acceptChunk(c)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._socketDisposables=(0,I.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const r=new m(5,0,0,L());this._socketWriter.write(r),this._socketWriter.flush()}sendPause(){const r=new m(7,0,0,L());this._socketWriter.write(r)}sendResume(){const r=new m(8,0,0,L());this._socketWriter.write(r)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(r,c){this._isReconnecting=!0,this._socketDisposables=(0,I.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=r,this._socketWriter=new F(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new b(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(a=>this._receiveMessage(a))),this._socketDisposables.push(this._socket.onClose(a=>this._onSocketClose.fire(a))),this._socketReader.acceptChunk(c)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const r=new m(3,0,this._incomingAckId,L());this._socketWriter.write(r);const c=this._outgoingUnackMsg.toArray();for(let a=0,u=c.length;a<u;a++)this._socketWriter.write(c[a]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(r){if(r.ack>this._outgoingAckId){this._outgoingAckId=r.ack;do{const c=this._outgoingUnackMsg.peek();if(c&&c.id<=r.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(r.type){case 0:break;case 1:{if(r.id>this._incomingMsgId)if(r.id!==this._incomingMsgId+1){const c=Date.now();c-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=c,this._socketWriter.write(new m(6,0,0,L())))}else this._incomingMsgId=r.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(r.data);break}case 2:{this._onControlMessage.fire(r.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const c=this._outgoingUnackMsg.toArray();for(let a=0,u=c.length;a<u;a++)this._socketWriter.write(c[a]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(r){const c=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const a=new m(1,c,this._incomingAckId,r);this._outgoingUnackMsg.push(a),this._isReconnecting||(this._socketWriter.write(a),this._recvAckCheck())}sendControl(r){const c=new m(2,0,0,r);this._socketWriter.write(c)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const r=Date.now()-this._incomingMsgLastTime;if(r>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-r+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const r=this._outgoingUnackMsg.peek(),c=Date.now()-r.writtenTime,a=Date.now()-this._socketReader.lastReadTime,u=Date.now()-this._lastSocketTimeoutTime;if(c>=2e4&&a>=2e4&&u>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire(void 0);return}const f=Math.max(2e4-c,2e4-a,2e4-u,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},f)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const r=new m(3,0,this._incomingAckId,L());this._socketWriter.write(r)}}e.PersistentProtocol=o}),define(ve[108],we([0,1,100]),function(Z,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class t{constructor(k){const D=(0,h.toUint8)(k);this._defaultValue=D,this._asciiMap=t._createAsciiMap(D),this._map=new Map}static _createAsciiMap(k){const D=new Uint8Array(256);for(let P=0;P<256;P++)D[P]=k;return D}set(k,D){const P=(0,h.toUint8)(D);k>=0&&k<256?this._asciiMap[k]=P:this._map.set(k,P)}get(k){return k>=0&&k<256?this._asciiMap[k]:this._map.get(k)||this._defaultValue}}e.CharacterClassifier=t;var I;(function(R){R[R.False=0]="False",R[R.True=1]="True"})(I||(I={}));class y{constructor(){this._actual=new t(0)}add(k){this._actual.set(k,1)}has(k){return this._actual.get(k)===1}}e.CharacterSet=y}),define(ve[145],we([0,1,108]),function(Z,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var t;(function(R){R[R.Regular=0]="Regular",R[R.Whitespace=1]="Whitespace",R[R.WordSeparator=2]="WordSeparator"})(t=e.WordCharacterClass||(e.WordCharacterClass={}));class I extends h.CharacterClassifier{constructor(k){super(0);for(let D=0,P=k.length;D<P;D++)this.set(k.charCodeAt(D),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=I;function y(R){const k={};return D=>(k.hasOwnProperty(D)||(k[D]=R(D)),k[D])}e.getMapForWordSeparators=y(R=>new I(R))}),define(ve[48],we([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class h{constructor(I,y){this.lineNumber=I,this.column=y}with(I=this.lineNumber,y=this.column){return I===this.lineNumber&&y===this.column?this:new h(I,y)}delta(I=0,y=0){return this.with(this.lineNumber+I,this.column+y)}equals(I){return h.equals(this,I)}static equals(I,y){return!I&&!y?!0:!!I&&!!y&&I.lineNumber===y.lineNumber&&I.column===y.column}isBefore(I){return h.isBefore(this,I)}static isBefore(I,y){return I.lineNumber<y.lineNumber?!0:y.lineNumber<I.lineNumber?!1:I.column<y.column}isBeforeOrEqual(I){return h.isBeforeOrEqual(this,I)}static isBeforeOrEqual(I,y){return I.lineNumber<y.lineNumber?!0:y.lineNumber<I.lineNumber?!1:I.column<=y.column}static compare(I,y){const R=I.lineNumber|0,k=y.lineNumber|0;if(R===k){const D=I.column|0,P=y.column|0;return D-P}return R-k}clone(){return new h(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(I){return new h(I.lineNumber,I.column)}static isIPosition(I){return I&&typeof I.lineNumber=="number"&&typeof I.column=="number"}}e.Position=h}),define(ve[41],we([0,1,48]),function(Z,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class t{constructor(y,R,k,D){y>k||y===k&&R>D?(this.startLineNumber=k,this.startColumn=D,this.endLineNumber=y,this.endColumn=R):(this.startLineNumber=y,this.startColumn=R,this.endLineNumber=k,this.endColumn=D)}isEmpty(){return t.isEmpty(this)}static isEmpty(y){return y.startLineNumber===y.endLineNumber&&y.startColumn===y.endColumn}containsPosition(y){return t.containsPosition(this,y)}static containsPosition(y,R){return!(R.lineNumber<y.startLineNumber||R.lineNumber>y.endLineNumber||R.lineNumber===y.startLineNumber&&R.column<y.startColumn||R.lineNumber===y.endLineNumber&&R.column>y.endColumn)}static strictContainsPosition(y,R){return!(R.lineNumber<y.startLineNumber||R.lineNumber>y.endLineNumber||R.lineNumber===y.startLineNumber&&R.column<=y.startColumn||R.lineNumber===y.endLineNumber&&R.column>=y.endColumn)}containsRange(y){return t.containsRange(this,y)}static containsRange(y,R){return!(R.startLineNumber<y.startLineNumber||R.endLineNumber<y.startLineNumber||R.startLineNumber>y.endLineNumber||R.endLineNumber>y.endLineNumber||R.startLineNumber===y.startLineNumber&&R.startColumn<y.startColumn||R.endLineNumber===y.endLineNumber&&R.endColumn>y.endColumn)}strictContainsRange(y){return t.strictContainsRange(this,y)}static strictContainsRange(y,R){return!(R.startLineNumber<y.startLineNumber||R.endLineNumber<y.startLineNumber||R.startLineNumber>y.endLineNumber||R.endLineNumber>y.endLineNumber||R.startLineNumber===y.startLineNumber&&R.startColumn<=y.startColumn||R.endLineNumber===y.endLineNumber&&R.endColumn>=y.endColumn)}plusRange(y){return t.plusRange(this,y)}static plusRange(y,R){let k,D,P,L;return R.startLineNumber<y.startLineNumber?(k=R.startLineNumber,D=R.startColumn):R.startLineNumber===y.startLineNumber?(k=R.startLineNumber,D=Math.min(R.startColumn,y.startColumn)):(k=y.startLineNumber,D=y.startColumn),R.endLineNumber>y.endLineNumber?(P=R.endLineNumber,L=R.endColumn):R.endLineNumber===y.endLineNumber?(P=R.endLineNumber,L=Math.max(R.endColumn,y.endColumn)):(P=y.endLineNumber,L=y.endColumn),new t(k,D,P,L)}intersectRanges(y){return t.intersectRanges(this,y)}static intersectRanges(y,R){let k=y.startLineNumber,D=y.startColumn,P=y.endLineNumber,L=y.endColumn,C=R.startLineNumber,l=R.startColumn,E=R.endLineNumber,p=R.endColumn;return k<C?(k=C,D=l):k===C&&(D=Math.max(D,l)),P>E?(P=E,L=p):P===E&&(L=Math.min(L,p)),k>P||k===P&&D>L?null:new t(k,D,P,L)}equalsRange(y){return t.equalsRange(this,y)}static equalsRange(y,R){return!!y&&!!R&&y.startLineNumber===R.startLineNumber&&y.startColumn===R.startColumn&&y.endLineNumber===R.endLineNumber&&y.endColumn===R.endColumn}getEndPosition(){return t.getEndPosition(this)}static getEndPosition(y){return new h.Position(y.endLineNumber,y.endColumn)}getStartPosition(){return t.getStartPosition(this)}static getStartPosition(y){return new h.Position(y.startLineNumber,y.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(y,R){return new t(this.startLineNumber,this.startColumn,y,R)}setStartPosition(y,R){return new t(y,R,this.endLineNumber,this.endColumn)}collapseToStart(){return t.collapseToStart(this)}static collapseToStart(y){return new t(y.startLineNumber,y.startColumn,y.startLineNumber,y.startColumn)}static fromPositions(y,R=y){return new t(y.lineNumber,y.column,R.lineNumber,R.column)}static lift(y){return y?new t(y.startLineNumber,y.startColumn,y.endLineNumber,y.endColumn):null}static isIRange(y){return y&&typeof y.startLineNumber=="number"&&typeof y.startColumn=="number"&&typeof y.endLineNumber=="number"&&typeof y.endColumn=="number"}static areIntersectingOrTouching(y,R){return!(y.endLineNumber<R.startLineNumber||y.endLineNumber===R.startLineNumber&&y.endColumn<R.startColumn||R.endLineNumber<y.startLineNumber||R.endLineNumber===y.startLineNumber&&R.endColumn<y.startColumn)}static areIntersecting(y,R){return!(y.endLineNumber<R.startLineNumber||y.endLineNumber===R.startLineNumber&&y.endColumn<=R.startColumn||R.endLineNumber<y.startLineNumber||R.endLineNumber===y.startLineNumber&&R.endColumn<=y.startColumn)}static compareRangesUsingStarts(y,R){if(y&&R){const P=y.startLineNumber|0,L=R.startLineNumber|0;if(P===L){const C=y.startColumn|0,l=R.startColumn|0;if(C===l){const E=y.endLineNumber|0,p=R.endLineNumber|0;if(E===p){const m=y.endColumn|0,b=R.endColumn|0;return m-b}return E-p}return C-l}return P-L}return(y?1:0)-(R?1:0)}static compareRangesUsingEnds(y,R){return y.endLineNumber===R.endLineNumber?y.endColumn===R.endColumn?y.startLineNumber===R.startLineNumber?y.startColumn-R.startColumn:y.startLineNumber-R.startLineNumber:y.endColumn-R.endColumn:y.endLineNumber-R.endLineNumber}static spansMultipleLines(y){return y.endLineNumber>y.startLineNumber}}e.Range=t}),define(ve[146],we([0,1,48,41]),function(Z,e,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var I;(function(R){R[R.LTR=0]="LTR",R[R.RTL=1]="RTL"})(I=e.SelectionDirection||(e.SelectionDirection={}));class y extends t.Range{constructor(k,D,P,L){super(k,D,P,L);this.selectionStartLineNumber=k,this.selectionStartColumn=D,this.positionLineNumber=P,this.positionColumn=L}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(k){return y.selectionsEqual(this,k)}static selectionsEqual(k,D){return k.selectionStartLineNumber===D.selectionStartLineNumber&&k.selectionStartColumn===D.selectionStartColumn&&k.positionLineNumber===D.positionLineNumber&&k.positionColumn===D.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(k,D){return this.getDirection()===0?new y(this.startLineNumber,this.startColumn,k,D):new y(k,D,this.startLineNumber,this.startColumn)}getPosition(){return new h.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new h.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(k,D){return this.getDirection()===0?new y(k,D,this.endLineNumber,this.endColumn):new y(this.endLineNumber,this.endColumn,k,D)}static fromPositions(k,D=k){return new y(k.lineNumber,k.column,D.lineNumber,D.column)}static fromRange(k,D){return D===0?new y(k.startLineNumber,k.startColumn,k.endLineNumber,k.endColumn):new y(k.endLineNumber,k.endColumn,k.startLineNumber,k.startColumn)}static liftSelection(k){return new y(k.selectionStartLineNumber,k.selectionStartColumn,k.positionLineNumber,k.positionColumn)}static selectionsArrEqual(k,D){if(k&&!D||!k&&D)return!1;if(!k&&!D)return!0;if(k.length!==D.length)return!1;for(let P=0,L=k.length;P<L;P++)if(!this.selectionsEqual(k[P],D[P]))return!1;return!0}static isISelection(k){return k&&typeof k.selectionStartLineNumber=="number"&&typeof k.selectionStartColumn=="number"&&typeof k.positionLineNumber=="number"&&typeof k.positionColumn=="number"}static createWithDirection(k,D,P,L,C){return C===0?new y(k,D,P,L):new y(P,L,k,D)}}e.Selection=y}),define(ve[147],we([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var h;(function(R){R[R.None=0]="None",R[R.Indent=1]="Indent",R[R.IndentOutdent=2]="IndentOutdent",R[R.Outdent=3]="Outdent"})(h=e.IndentAction||(e.IndentAction={}));class t{constructor(k){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=k.open,this.close=k.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(k.notIn))for(let D=0,P=k.notIn.length;D<P;D++)switch(k.notIn[D]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(k){switch(k){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(k,D){if(k.getTokenCount()===0)return!0;const P=k.findTokenIndexAtOffset(D-2),L=k.getStandardTokenType(P);return this.isOK(L)}_findNeutralCharacterInRange(k,D){for(let P=k;P<=D;P++){const L=String.fromCharCode(P);if(!this.open.includes(L)&&!this.close.includes(L))return L}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=t;class I{constructor(k){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const D of k)y(this.autoClosingPairsOpenByStart,D.open.charAt(0),D),y(this.autoClosingPairsOpenByEnd,D.open.charAt(D.open.length-1),D),y(this.autoClosingPairsCloseByStart,D.close.charAt(0),D),y(this.autoClosingPairsCloseByEnd,D.close.charAt(D.close.length-1),D),D.close.length===1&&D.open.length===1&&y(this.autoClosingPairsCloseSingleChar,D.close,D)}}e.AutoClosingPairs=I;function y(R,k,D){R.has(k)?R.get(k).push(D):R.set(k,[D])}}),define(ve[82],we([0,1,32,9]),function(Z,e,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function I(y,R,k,D){if(Array.isArray(y)){let P=0;for(const L of y){const C=I(L,R,k,D);if(C===10)return C;C>P&&(P=C)}return P}else{if(typeof y=="string")return D?y==="*"?5:y===k?10:0:0;if(y){const{language:P,pattern:L,scheme:C,hasAccessToAllModels:l}=y;if(!D&&!l)return 0;let E=0;if(C)if(C===R.scheme)E=10;else if(C==="*")E=5;else return 0;if(P)if(P===k)E=10;else if(P==="*")E=Math.max(E,5);else return 0;if(L){let p;if(typeof L=="string"?p=L:p={...L,base:(0,t.normalize)(L.base)},p===R.fsPath||(0,h.match)(p,R.fsPath))E=10;else return 0}return E}else return 0}}e.score=I}),define(ve[148],we([0,1,108]),function(Z,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var t;(function(E){E[E.Invalid=0]="Invalid",E[E.Start=1]="Start",E[E.H=2]="H",E[E.HT=3]="HT",E[E.HTT=4]="HTT",E[E.HTTP=5]="HTTP",E[E.F=6]="F",E[E.FI=7]="FI",E[E.FIL=8]="FIL",E[E.BeforeColon=9]="BeforeColon",E[E.AfterColon=10]="AfterColon",E[E.AlmostThere=11]="AlmostThere",E[E.End=12]="End",E[E.Accept=13]="Accept",E[E.LastKnownState=14]="LastKnownState"})(t=e.State||(e.State={}));class I{constructor(p,m,b){const F=new Uint8Array(p*m);for(let _=0,g=p*m;_<g;_++)F[_]=b;this._data=F,this.rows=p,this.cols=m}get(p,m){return this._data[p*this.cols+m]}set(p,m,b){this._data[p*this.cols+m]=b}}e.Uint8Matrix=I;class y{constructor(p){let m=0,b=0;for(let _=0,g=p.length;_<g;_++){const[s,d,n]=p[_];d>m&&(m=d),s>b&&(b=s),n>b&&(b=n)}m++,b++;const F=new I(b,m,0);for(let _=0,g=p.length;_<g;_++){const[s,d,n]=p[_];F.set(s,d,n)}this._states=F,this._maxCharCode=m}nextState(p,m){return m<0||m>=this._maxCharCode?0:this._states.get(p,m)}}e.StateMachine=y;let R=null;function k(){return R===null&&(R=new y([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),R}var D;(function(E){E[E.None=0]="None",E[E.ForceTermination=1]="ForceTermination",E[E.CannotEndIn=2]="CannotEndIn"})(D||(D={}));let P=null;function L(){if(P===null){P=new h.CharacterClassifier(0);const E=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let m=0;m<E.length;m++)P.set(E.charCodeAt(m),1);const p=".,;";for(let m=0;m<p.length;m++)P.set(p.charCodeAt(m),2)}return P}class C{static _createLink(p,m,b,F,_){let g=_-1;do{const s=m.charCodeAt(g);if(p.get(s)!==2)break;g--}while(g>F);if(F>0){const s=m.charCodeAt(F-1),d=m.charCodeAt(g);(s===40&&d===41||s===91&&d===93||s===123&&d===125)&&g--}return{range:{startLineNumber:b,startColumn:F+1,endLineNumber:b,endColumn:g+2},url:m.substring(F,g+1)}}static computeLinks(p,m=k()){const b=L(),F=[];for(let _=1,g=p.getLineCount();_<=g;_++){const s=p.getLineContent(_),d=s.length;let n=0,S=0,o=0,i=1,r=!1,c=!1,a=!1,u=!1;for(;n<d;){let f=!1;const v=s.charCodeAt(n);if(i===13){let w;switch(v){case 40:r=!0,w=0;break;case 41:w=r?0:1;break;case 91:a=!0,c=!0,w=0;break;case 93:a=!1,w=c?0:1;break;case 123:u=!0,w=0;break;case 125:w=u?0:1;break;case 39:w=o===34||o===96?0:1;break;case 34:w=o===39||o===96?0:1;break;case 96:w=o===39||o===34?0:1;break;case 42:w=o===42?1:0;break;case 124:w=o===124?1:0;break;case 32:w=a?0:1;break;default:w=b.get(v)}w===1&&(F.push(C._createLink(b,s,_,S,n)),f=!0)}else if(i===12){let w;v===91?(c=!0,w=0):w=b.get(v),w===1?f=!0:i=13}else i=m.nextState(i,v),i===0&&(f=!0);f&&(i=1,r=!1,c=!1,u=!1,S=n+1,o=v),n++}i===13&&F.push(C._createLink(b,s,_,S,d))}return F}}e.LinkComputer=C;function l(E){return!E||typeof E.getLineCount!="function"||typeof E.getLineContent!="function"?[]:C.computeLinks(E)}e.computeLinks=l}),define(ve[149],we([0,1,3,6]),function(Z,e,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class I{constructor(){this._map=new Map,this._factories=new Map,this._onDidChange=new h.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(k){this._onDidChange.fire({changedLanguages:k,changedColorMap:!1})}register(k,D){return this._map.set(k,D),this.fire([k]),(0,t.toDisposable)(()=>{this._map.get(k)===D&&(this._map.delete(k),this.fire([k]))})}registerFactory(k,D){this._factories.get(k)?.dispose();const P=new y(this,k,D);return this._factories.set(k,P),(0,t.toDisposable)(()=>{const L=this._factories.get(k);!L||L!==P||(this._factories.delete(k),L.dispose())})}async getOrCreate(k){const D=this.get(k);if(D)return D;const P=this._factories.get(k);return!P||P.isResolved?null:(await P.resolve(),this.get(k))}get(k){return this._map.get(k)||null}isResolved(k){if(this.get(k))return!0;const P=this._factories.get(k);return!!(!P||P.isResolved)}setColorMap(k){this._colorMap=k,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistry=I;class y extends t.Disposable{constructor(k,D,P){super();this._registry=k,this._languageId=D,this._factory=P,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}get isResolved(){return this._isResolved}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const k=await Promise.resolve(this._factory.createTokenizationSupport());this._isResolved=!0,k&&!this._isDisposed&&this._register(this._registry.register(this._languageId,k))}}}),define(ve[109],we([0,1,25]),function(Z,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.OverviewRulerLane=void 0;var t;(function(b){b[b.Left=1]="Left",b[b.Center=2]="Center",b[b.Right=4]="Right",b[b.Full=7]="Full"})(t=e.OverviewRulerLane||(e.OverviewRulerLane={}));var I;(function(b){b[b.Inline=1]="Inline",b[b.Gutter=2]="Gutter"})(I=e.MinimapPosition||(e.MinimapPosition={}));var y;(function(b){b[b.Both=0]="Both",b[b.Right=1]="Right",b[b.Left=2]="Left",b[b.None=3]="None"})(y=e.InjectedTextCursorStops||(e.InjectedTextCursorStops={}));var R;(function(b){b[b.TextDefined=0]="TextDefined",b[b.LF=1]="LF",b[b.CRLF=2]="CRLF"})(R=e.EndOfLinePreference||(e.EndOfLinePreference={}));var k;(function(b){b[b.LF=1]="LF",b[b.CRLF=2]="CRLF"})(k=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var D;(function(b){b[b.LF=0]="LF",b[b.CRLF=1]="CRLF"})(D=e.EndOfLineSequence||(e.EndOfLineSequence={}));class P{constructor(F){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,F.tabSize|0),this.indentSize=F.tabSize|0,this.insertSpaces=Boolean(F.insertSpaces),this.defaultEOL=F.defaultEOL|0,this.trimAutoWhitespace=Boolean(F.trimAutoWhitespace),this.bracketPairColorizationOptions=F.bracketPairColorizationOptions}equals(F){return this.tabSize===F.tabSize&&this.indentSize===F.indentSize&&this.insertSpaces===F.insertSpaces&&this.defaultEOL===F.defaultEOL&&this.trimAutoWhitespace===F.trimAutoWhitespace&&(0,h.equals)(this.bracketPairColorizationOptions,F.bracketPairColorizationOptions)}createChangeEvent(F){return{tabSize:this.tabSize!==F.tabSize,indentSize:this.indentSize!==F.indentSize,insertSpaces:this.insertSpaces!==F.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==F.trimAutoWhitespace}}}e.TextModelResolvedOptions=P;class L{constructor(F,_){this._findMatchBrand=void 0,this.range=F,this.matches=_}}e.FindMatch=L;var C;(function(b){b[b.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",b[b.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",b[b.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",b[b.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(C=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var l;(function(b){b[b.Left=0]="Left",b[b.Right=1]="Right",b[b.None=2]="None"})(l=e.PositionAffinity||(e.PositionAffinity={}));var E;(function(b){b[b.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(E=e.ModelConstants||(e.ModelConstants={}));class p{constructor(F,_,g,s,d,n){this.identifier=F,this.range=_,this.text=g,this.forceMoveMarkers=s,this.isAutoWhitespaceEdit=d,this._isTracked=n}}e.ValidAnnotatedEditOperation=p;class m{constructor(F,_,g){this.reverseEdits=F,this.changes=_,this.trimAutoWhitespaceLineNumbers=g}}e.ApplyEditsResult=m}),define(ve[150],we([0,1,8,145,48,41,109]),function(Z,e,h,t,I,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const k=999;class D{constructor(g,s,d,n){this.searchString=g,this.isRegex=s,this.matchCase=d,this.wordSeparators=n}parseSearchRequest(){if(this.searchString==="")return null;let g;this.isRegex?g=P(this.searchString):g=this.searchString.indexOf(`
`)>=0;let s=null;try{s=h.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:g,global:!0,unicode:!0})}catch{return null}if(!s)return null;let d=!this.isRegex&&!g;return d&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(d=this.matchCase),new L(s,this.wordSeparators?(0,t.getMapForWordSeparators)(this.wordSeparators):null,d?this.searchString:null)}}e.SearchParams=D;function P(_){if(!_||_.length===0)return!1;for(let g=0,s=_.length;g<s;g++)if(_.charCodeAt(g)===92){if(g++,g>=s)break;const n=_.charCodeAt(g);if(n===110||n===114||n===87)return!0}return!1}e.isMultilineRegexSource=P;class L{constructor(g,s,d){this.regex=g,this.wordSeparators=s,this.simpleSearch=d}}e.SearchData=L;function C(_,g,s){if(!s)return new R.FindMatch(_,null);const d=[];for(let n=0,S=g.length;n<S;n++)d[n]=g[n];return new R.FindMatch(_,d)}e.createFindMatch=C;class l{constructor(g){const s=[];let d=0;for(let n=0,S=g.length;n<S;n++)g.charCodeAt(n)===10&&(s[d++]=n);this._lineFeedsOffsets=s}findLineFeedCountBeforeOffset(g){const s=this._lineFeedsOffsets;let d=0,n=s.length-1;if(n===-1||g<=s[0])return 0;for(;d<n;){const S=d+((n-d)/2>>0);s[S]>=g?n=S-1:s[S+1]>=g?(d=S,n=S):d=S+1}return d+1}}class E{static findMatches(g,s,d,n,S){const o=s.parseSearchRequest();return o?o.regex.multiline?this._doFindMatchesMultiline(g,d,new F(o.wordSeparators,o.regex),n,S):this._doFindMatchesLineByLine(g,d,o,n,S):[]}static _getMultilineMatchRange(g,s,d,n,S,o){let i,r=0;n?(r=n.findLineFeedCountBeforeOffset(S),i=s+S+r):i=s+S;let c;if(n){const v=n.findLineFeedCountBeforeOffset(S+o.length)-r;c=i+o.length+v}else c=i+o.length;const a=g.getPositionAt(i),u=g.getPositionAt(c);return new y.Range(a.lineNumber,a.column,u.lineNumber,u.column)}static _doFindMatchesMultiline(g,s,d,n,S){const o=g.getOffsetAt(s.getStartPosition()),i=g.getValueInRange(s,1),r=g.getEOL()===`\r
`?new l(i):null,c=[];let a=0,u;for(d.reset(0);u=d.next(i);)if(c[a++]=C(this._getMultilineMatchRange(g,o,i,r,u.index,u[0]),u,n),a>=S)return c;return c}static _doFindMatchesLineByLine(g,s,d,n,S){const o=[];let i=0;if(s.startLineNumber===s.endLineNumber){const c=g.getLineContent(s.startLineNumber).substring(s.startColumn-1,s.endColumn-1);return i=this._findMatchesInLine(d,c,s.startLineNumber,s.startColumn-1,i,o,n,S),o}const r=g.getLineContent(s.startLineNumber).substring(s.startColumn-1);i=this._findMatchesInLine(d,r,s.startLineNumber,s.startColumn-1,i,o,n,S);for(let c=s.startLineNumber+1;c<s.endLineNumber&&i<S;c++)i=this._findMatchesInLine(d,g.getLineContent(c),c,0,i,o,n,S);if(i<S){const c=g.getLineContent(s.endLineNumber).substring(0,s.endColumn-1);i=this._findMatchesInLine(d,c,s.endLineNumber,0,i,o,n,S)}return o}static _findMatchesInLine(g,s,d,n,S,o,i,r){const c=g.wordSeparators;if(!i&&g.simpleSearch){const f=g.simpleSearch,v=f.length,w=s.length;let A=-v;for(;(A=s.indexOf(f,A+v))!==-1;)if((!c||b(c,s,w,A,v))&&(o[S++]=new R.FindMatch(new y.Range(d,A+1+n,d,A+1+v+n),null),S>=r))return S;return S}const a=new F(g.wordSeparators,g.regex);let u;a.reset(0);do if(u=a.next(s),u&&(o[S++]=C(new y.Range(d,u.index+1+n,d,u.index+1+u[0].length+n),u,i),S>=r))return S;while(u);return S}static findNextMatch(g,s,d,n){const S=s.parseSearchRequest();if(!S)return null;const o=new F(S.wordSeparators,S.regex);return S.regex.multiline?this._doFindNextMatchMultiline(g,d,o,n):this._doFindNextMatchLineByLine(g,d,o,n)}static _doFindNextMatchMultiline(g,s,d,n){const S=new I.Position(s.lineNumber,1),o=g.getOffsetAt(S),i=g.getLineCount(),r=g.getValueInRange(new y.Range(S.lineNumber,S.column,i,g.getLineMaxColumn(i)),1),c=g.getEOL()===`\r
`?new l(r):null;d.reset(s.column-1);let a=d.next(r);return a?C(this._getMultilineMatchRange(g,o,r,c,a.index,a[0]),a,n):s.lineNumber!==1||s.column!==1?this._doFindNextMatchMultiline(g,new I.Position(1,1),d,n):null}static _doFindNextMatchLineByLine(g,s,d,n){const S=g.getLineCount(),o=s.lineNumber,i=g.getLineContent(o),r=this._findFirstMatchInLine(d,i,o,s.column,n);if(r)return r;for(let c=1;c<=S;c++){const a=(o+c-1)%S,u=g.getLineContent(a+1),f=this._findFirstMatchInLine(d,u,a+1,1,n);if(f)return f}return null}static _findFirstMatchInLine(g,s,d,n,S){g.reset(n-1);const o=g.next(s);return o?C(new y.Range(d,o.index+1,d,o.index+1+o[0].length),o,S):null}static findPreviousMatch(g,s,d,n){const S=s.parseSearchRequest();if(!S)return null;const o=new F(S.wordSeparators,S.regex);return S.regex.multiline?this._doFindPreviousMatchMultiline(g,d,o,n):this._doFindPreviousMatchLineByLine(g,d,o,n)}static _doFindPreviousMatchMultiline(g,s,d,n){const S=this._doFindMatchesMultiline(g,new y.Range(1,1,s.lineNumber,s.column),d,n,10*k);if(S.length>0)return S[S.length-1];const o=g.getLineCount();return s.lineNumber!==o||s.column!==g.getLineMaxColumn(o)?this._doFindPreviousMatchMultiline(g,new I.Position(o,g.getLineMaxColumn(o)),d,n):null}static _doFindPreviousMatchLineByLine(g,s,d,n){const S=g.getLineCount(),o=s.lineNumber,i=g.getLineContent(o).substring(0,s.column-1),r=this._findLastMatchInLine(d,i,o,n);if(r)return r;for(let c=1;c<=S;c++){const a=(S+o-c-1)%S,u=g.getLineContent(a+1),f=this._findLastMatchInLine(d,u,a+1,n);if(f)return f}return null}static _findLastMatchInLine(g,s,d,n){let S=null,o;for(g.reset(0);o=g.next(s);)S=C(new y.Range(d,o.index+1,d,o.index+1+o[0].length),o,n);return S}}e.TextModelSearch=E;function p(_,g,s,d,n){if(d===0)return!0;const S=g.charCodeAt(d-1);if(_.get(S)!==0||S===13||S===10)return!0;if(n>0){const o=g.charCodeAt(d);if(_.get(o)!==0)return!0}return!1}function m(_,g,s,d,n){if(d+n===s)return!0;const S=g.charCodeAt(d+n);if(_.get(S)!==0||S===13||S===10)return!0;if(n>0){const o=g.charCodeAt(d+n-1);if(_.get(o)!==0)return!0}return!1}function b(_,g,s,d,n){return p(_,g,s,d,n)&&m(_,g,s,d,n)}e.isValidMatch=b;class F{constructor(g,s){this._wordSeparators=g,this._searchRegex=s,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(g){this._searchRegex.lastIndex=g,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(g){const s=g.length;let d;do{if(this._prevMatchStartIndex+this._prevMatchLength===s||(d=this._searchRegex.exec(g),!d))return null;const n=d.index,S=d[0].length;if(n===this._prevMatchStartIndex&&S===this._prevMatchLength){if(S===0){h.getNextCodePoint(g,s,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=n,this._prevMatchLength=S,!this._wordSeparators||b(this._wordSeparators,g,s,n,S))return d}while(d);return null}}e.Searcher=F}),define(ve[110],we([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function h(k=""){let D="(-?\\d*\\.\\d\\w*)|([^";for(const P of e.USUAL_WORD_SEPARATORS)k.indexOf(P)>=0||(D+="\\"+P);return D+="\\s]+)",new RegExp(D,"g")}e.DEFAULT_WORD_REGEXP=h();function t(k){let D=e.DEFAULT_WORD_REGEXP;if(k&&k instanceof RegExp)if(k.global)D=k;else{let P="g";k.ignoreCase&&(P+="i"),k.multiline&&(P+="m"),k.unicode&&(P+="u"),D=new RegExp(k.source,P)}return D.lastIndex=0,D}e.ensureValidWordDefinition=t;const I={maxLen:1e3,windowSize:15,timeBudget:150};function y(k,D,P,L,C=I){if(P.length>C.maxLen){let b=k-C.maxLen/2;return b<0?b=0:L+=b,P=P.substring(b,k+C.maxLen/2),y(k,D,P,L,C)}const l=Date.now(),E=k-1-L;let p=-1,m=null;for(let b=1;!(Date.now()-l>=C.timeBudget);b++){const F=E-C.windowSize*b;D.lastIndex=Math.max(0,F);const _=R(D,P,E,p);if(!_&&m||(m=_,F<=0))break;p=F}if(m){const b={word:m[0],startColumn:L+1+m.index,endColumn:L+1+m.index+m[0].length};return D.lastIndex=0,b}return null}e.getWordAtText=y;function R(k,D,P,L){let C;for(;C=k.exec(D);){const l=C.index||0;if(l<=P&&k.lastIndex>=P)return C;if(L>0&&l>L)return null}return null}}),define(ve[111],we([0,1,22,11]),function(Z,e,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var I;(function(C){C[C.Full=1]="Full",C[C.Delta=2]="Delta"})(I||(I={}));function y(C){for(let l=0,E=C.length;l<E;l+=4){const p=C[l+0],m=C[l+1],b=C[l+2],F=C[l+3];C[l+0]=F,C[l+1]=b,C[l+2]=m,C[l+3]=p}}function R(C){const l=new Uint8Array(C.buffer,C.byteOffset,C.length*4);return t.isLittleEndian()||y(l),h.VSBuffer.wrap(l)}function k(C){const l=C.buffer;if(t.isLittleEndian()||y(l),l.byteOffset%4==0)return new Uint32Array(l.buffer,l.byteOffset,l.length/4);{const E=new Uint8Array(l.byteLength);return E.set(l),new Uint32Array(E.buffer,E.byteOffset,E.length/4)}}function D(C){const l=new Uint32Array(P(C));let E=0;if(l[E++]=C.id,C.type==="full")l[E++]=1,l[E++]=C.data.length,l.set(C.data,E),E+=C.data.length;else{l[E++]=2,l[E++]=C.deltas.length;for(const p of C.deltas)l[E++]=p.start,l[E++]=p.deleteCount,p.data?(l[E++]=p.data.length,l.set(p.data,E),E+=p.data.length):l[E++]=0}return R(l)}e.encodeSemanticTokensDto=D;function P(C){let l=0;if(l+=1+1,C.type==="full")l+=1+C.data.length;else{l+=1,l+=(1+1+1)*C.deltas.length;for(const E of C.deltas)E.data&&(l+=E.data.length)}return l}function L(C){const l=k(C);let E=0;const p=l[E++];if(l[E++]===1){const _=l[E++],g=l.subarray(E,E+_);return E+=_,{id:p,type:"full",data:g}}const b=l[E++],F=[];for(let _=0;_<b;_++){const g=l[E++],s=l[E++],d=l[E++];let n;d>0&&(n=l.subarray(E,E+d),E+=d),F[_]={start:g,deleteCount:s,data:n}}return{id:p,type:"delta",deltas:F}}e.decodeSemanticTokensDto=L}),define(ve[112],we([0,1,17,100]),function(Z,e,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumIndexOfResult=e.ConstantTimePrefixSumComputer=e.PrefixSumComputer=void 0;class I{constructor(D){this.values=D,this.prefixSum=new Uint32Array(D.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(D,P){D=(0,t.toUint32)(D);const L=this.values,C=this.prefixSum,l=P.length;return l===0?!1:(this.values=new Uint32Array(L.length+l),this.values.set(L.subarray(0,D),0),this.values.set(L.subarray(D),D+l),this.values.set(P,D),D-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=D-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(C.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(D,P){return D=(0,t.toUint32)(D),P=(0,t.toUint32)(P),this.values[D]===P?!1:(this.values[D]=P,D-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=D-1),!0)}removeValues(D,P){D=(0,t.toUint32)(D),P=(0,t.toUint32)(P);const L=this.values,C=this.prefixSum;if(D>=L.length)return!1;const l=L.length-D;return P>=l&&(P=l),P===0?!1:(this.values=new Uint32Array(L.length-P),this.values.set(L.subarray(0,D),0),this.values.set(L.subarray(D+P),D),this.prefixSum=new Uint32Array(this.values.length),D-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=D-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(C.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(D){return D<0?0:(D=(0,t.toUint32)(D),this._getPrefixSum(D))}_getPrefixSum(D){if(D<=this.prefixSumValidIndex[0])return this.prefixSum[D];let P=this.prefixSumValidIndex[0]+1;P===0&&(this.prefixSum[0]=this.values[0],P++),D>=this.values.length&&(D=this.values.length-1);for(let L=P;L<=D;L++)this.prefixSum[L]=this.prefixSum[L-1]+this.values[L];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],D),this.prefixSum[D]}getIndexOf(D){D=Math.floor(D),this.getTotalSum();let P=0,L=this.values.length-1,C=0,l=0,E=0;for(;P<=L;)if(C=P+(L-P)/2|0,l=this.prefixSum[C],E=l-this.values[C],D<E)L=C-1;else if(D>=l)P=C+1;else break;return new R(C,D-E)}}e.PrefixSumComputer=I;class y{constructor(D){this._values=D,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(D){return this._ensureValid(),D===0?0:this._prefixSum[D-1]}getIndexOf(D){this._ensureValid();const P=this._indexBySum[D],L=P>0?this._prefixSum[P-1]:0;return new R(P,D-L)}removeValues(D,P){this._values.splice(D,P),this._invalidate(D)}insertValues(D,P){this._values=(0,h.arrayInsert)(this._values,D,P),this._invalidate(D)}_invalidate(D){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,D-1)}_ensureValid(){if(!this._isValid){for(let D=this._validEndIndex+1,P=this._values.length;D<P;D++){const L=this._values[D],C=D>0?this._prefixSum[D-1]:0;this._prefixSum[D]=C+L;for(let l=0;l<L;l++)this._indexBySum[C+l]=D}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(D,P){this._values[D]!==P&&(this._values[D]=P,this._invalidate(D))}}e.ConstantTimePrefixSumComputer=y;class R{constructor(D,P){this.index=D,this.remainder=P,this._prefixSumIndexOfResultBrand=void 0,this.index=D,this.remainder=P}}e.PrefixSumIndexOfResult=R}),define(ve[151],we([0,1,8,48,112]),function(Z,e,h,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class y{constructor(k,D,P,L){this._uri=k,this._lines=D,this._eol=P,this._versionId=L,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(k){k.eol&&k.eol!==this._eol&&(this._eol=k.eol,this._lineStarts=null);const D=k.changes;for(const P of D)this._acceptDeleteRange(P.range),this._acceptInsertText(new t.Position(P.range.startLineNumber,P.range.startColumn),P.text);this._versionId=k.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const k=this._eol.length,D=this._lines.length,P=new Uint32Array(D);for(let L=0;L<D;L++)P[L]=this._lines[L].length+k;this._lineStarts=new I.PrefixSumComputer(P)}}_setLineText(k,D){this._lines[k]=D,this._lineStarts&&this._lineStarts.setValue(k,this._lines[k].length+this._eol.length)}_acceptDeleteRange(k){if(k.startLineNumber===k.endLineNumber){if(k.startColumn===k.endColumn)return;this._setLineText(k.startLineNumber-1,this._lines[k.startLineNumber-1].substring(0,k.startColumn-1)+this._lines[k.startLineNumber-1].substring(k.endColumn-1));return}this._setLineText(k.startLineNumber-1,this._lines[k.startLineNumber-1].substring(0,k.startColumn-1)+this._lines[k.endLineNumber-1].substring(k.endColumn-1)),this._lines.splice(k.startLineNumber,k.endLineNumber-k.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(k.startLineNumber,k.endLineNumber-k.startLineNumber)}_acceptInsertText(k,D){if(D.length===0)return;const P=(0,h.splitLines)(D);if(P.length===1){this._setLineText(k.lineNumber-1,this._lines[k.lineNumber-1].substring(0,k.column-1)+P[0]+this._lines[k.lineNumber-1].substring(k.column-1));return}P[P.length-1]+=this._lines[k.lineNumber-1].substring(k.column-1),this._setLineText(k.lineNumber-1,this._lines[k.lineNumber-1].substring(0,k.column-1)+P[0]);const L=new Uint32Array(P.length-1);for(let C=1;C<P.length;C++)this._lines.splice(k.lineNumber+C-1,0,P[C]),L[C-1]=P[C].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(k.lineNumber,L)}}e.MirrorTextModel=y}),define(ve[152],we([19,20]),function(Z,e){return Z.create("vs/base/common/date",e)}),define(ve[153],we([0,1,152]),function(Z,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,I=t*60,y=I*24,R=y*7,k=y*30,D=y*365;function P(C,l,E){typeof C!="number"&&(C=C.getTime());const p=Math.round((new Date().getTime()-C)/1e3);if(p<-30)return(0,h.localize)(0,null,P(new Date().getTime()+p*1e3,!1));if(p<30)return(0,h.localize)(1,null);let m;return p<t?(m=p,l?m===1?E?(0,h.localize)(2,null,m):(0,h.localize)(3,null,m):E?(0,h.localize)(4,null,m):(0,h.localize)(5,null,m):m===1?E?(0,h.localize)(6,null,m):(0,h.localize)(7,null,m):E?(0,h.localize)(8,null,m):(0,h.localize)(9,null,m)):p<I?(m=Math.floor(p/t),l?m===1?E?(0,h.localize)(10,null,m):(0,h.localize)(11,null,m):E?(0,h.localize)(12,null,m):(0,h.localize)(13,null,m):m===1?E?(0,h.localize)(14,null,m):(0,h.localize)(15,null,m):E?(0,h.localize)(16,null,m):(0,h.localize)(17,null,m)):p<y?(m=Math.floor(p/I),l?m===1?E?(0,h.localize)(18,null,m):(0,h.localize)(19,null,m):E?(0,h.localize)(20,null,m):(0,h.localize)(21,null,m):m===1?E?(0,h.localize)(22,null,m):(0,h.localize)(23,null,m):E?(0,h.localize)(24,null,m):(0,h.localize)(25,null,m)):p<R?(m=Math.floor(p/y),l?m===1?(0,h.localize)(26,null,m):(0,h.localize)(27,null,m):m===1?(0,h.localize)(28,null,m):(0,h.localize)(29,null,m)):p<k?(m=Math.floor(p/R),l?m===1?E?(0,h.localize)(30,null,m):(0,h.localize)(31,null,m):E?(0,h.localize)(32,null,m):(0,h.localize)(33,null,m):m===1?E?(0,h.localize)(34,null,m):(0,h.localize)(35,null,m):E?(0,h.localize)(36,null,m):(0,h.localize)(37,null,m)):p<D?(m=Math.floor(p/k),l?m===1?E?(0,h.localize)(38,null,m):(0,h.localize)(39,null,m):E?(0,h.localize)(40,null,m):(0,h.localize)(41,null,m):m===1?E?(0,h.localize)(42,null,m):(0,h.localize)(43,null,m):E?(0,h.localize)(44,null,m):(0,h.localize)(45,null,m)):(m=Math.floor(p/D),l?m===1?E?(0,h.localize)(46,null,m):(0,h.localize)(47,null,m):E?(0,h.localize)(48,null,m):(0,h.localize)(49,null,m):m===1?E?(0,h.localize)(50,null,m):(0,h.localize)(51,null,m):E?(0,h.localize)(52,null,m):(0,h.localize)(53,null,m))}e.fromNow=P;function L(C){return C.getFullYear()+"-"+String(C.getMonth()+1).padStart(2,"0")+"-"+String(C.getDate()).padStart(2,"0")+"T"+String(C.getHours()).padStart(2,"0")+":"+String(C.getMinutes()).padStart(2,"0")+":"+String(C.getSeconds()).padStart(2,"0")+"."+(C.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=L}),define(ve[154],we([19,20]),function(Z,e){return Z.create("vs/base/common/errorMessage",e)}),define(ve[49],we([0,1,17,18,154]),function(Z,e,h,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function y(P,L){return L&&(P.stack||P.stacktrace)?I.localize(0,null,k(P),R(P.stack)||R(P.stacktrace)):k(P)}function R(P){return Array.isArray(P)?P.join(`
`):P}function k(P){return typeof P.code=="string"&&typeof P.errno=="number"&&typeof P.syscall=="string"?I.localize(1,null,P.message):P.message||I.localize(2,null)}function D(P=null,L=!1){if(!P)return I.localize(3,null);if(Array.isArray(P)){const C=h.coalesce(P),l=D(C[0],L);return C.length>1?I.localize(4,null,l,C.length):l}if(t.isString(P))return P;if(P.detail){const C=P.detail;if(C.error)return y(C.error,L);if(C.exception)return y(C.exception,L)}return P.stack?y(P,L):P.message?P.message:I.localize(5,null)}e.toErrorMessage=D}),define(ve[155],we([19,20]),function(Z,e){return Z.create("vs/base/node/processes",e)}),define(ve[113],we([0,1,37,29,10,25,9,11,40,96,18,144,30,155]),function(Z,e,h,t,I,y,R,k,D,P,L,C,l,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.removeDangerousEnvVariables=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return P.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return P.TerminateResponseCode}});function p(n){switch(n){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function m(n,S){if(k.isWindows)try{const o={stdio:["pipe","pipe","ignore"]};S&&(o.cwd=S);const i=h.execFile("taskkill",["/T","/F","/PID",n.pid.toString()],o);return new Promise(r=>{i.once("error",c=>{r({success:!1,error:c})}),i.once("exit",(c,a)=>{r(c===0?{success:!0}:{success:!1,code:c!==null?c:1})})})}catch(o){return Promise.resolve({success:!1,error:o,code:o.status?p(o.status):1})}else if(k.isLinux||k.isMacintosh)try{const o=I.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",Z).fsPath;return new Promise(i=>{h.execFile(o,[n.pid.toString()],{encoding:"utf8",shell:!0},(r,c,a)=>{i(r?{success:!1,error:r}:{success:!0})})})}catch(o){return Promise.resolve({success:!1,error:o})}else n.kill("SIGKILL");return Promise.resolve({success:!0})}function b(n){!n||(delete n.DEBUG,k.isMacintosh&&delete n.DYLD_LIBRARY_PATH,k.isLinux&&delete n.LD_PRELOAD)}e.removeDangerousEnvVariables=b;function F(n=D.env){return n.comspec||"cmd.exe"}e.getWindowsShell=F;class _{constructor(S,o,i,r){if(o!==void 0&&i!==void 0&&r!==void 0)this.cmd=S,this.args=o,this.shell=i,this.options=r;else{const c=S;this.cmd=c.command,this.shell=c.isShellCommand,this.args=c.args.slice(0),this.options=c.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const c=Object.create(null);Object.keys(D.env).forEach(a=>{c[a]=D.env[a]}),Object.keys(this.options.env).forEach(a=>{c[a]=this.options.env[a]}),this.options.env=c}}getSanitizedCommand(){let S=this.cmd.toLowerCase();const o=S.lastIndexOf(R.sep);return o!==-1&&(S=S.substring(o+1)),_.WellKnowCommands[S]?S:"other"}start(S){return k.isWindows&&(this.options&&this.options.cwd&&t.isUNC(this.options.cwd)||!this.options&&t.isUNC(D.cwd()))?Promise.reject(new Error(E.localize(0,null))):this.useExec().then(o=>{let i,r;const c=new Promise((a,u)=>{i=a,r=u});if(o){let a=this.cmd;this.args&&(a=a+" "+this.args.join(" ")),this.childProcess=h.exec(a,this.options,(u,f,v)=>{this.childProcess=null;const w=u;w&&w.killed?r({killed:this.terminateRequested,stdout:f.toString(),stderr:v.toString()}):this.handleExec(i,S,u,f,v)})}else{let a=null;const u=f=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(f,i,S,r);const v={terminated:this.terminateRequested};L.isNumber(f)&&(v.cmdCode=f),i(v)};if(this.shell&&k.isWindows){const f=y.deepClone(this.options);f.windowsVerbatimArguments=!0,f.detached=!1;let v=!1,w=!1;const A=[];let M=this.ensureQuotes(this.cmd);A.push(M.value),v=M.quoted,this.args&&this.args.forEach(O=>{M=this.ensureQuotes(O),A.push(M.value),w=w&&M.quoted});const T=["/s","/c"];v?w?T.push('"'+A.join(" ")+'"'):A.length>1?T.push('"'+A[0]+'" '+A.slice(1).join(" ")):T.push('"'+A[0]+'"'):T.push(A.join(" ")),a=h.spawn(F(),T,f)}else this.cmd&&(a=h.spawn(this.cmd,this.args,this.options));a&&(this.childProcess=a,this.childProcessPromise=Promise.resolve(a),this.pidResolve&&(this.pidResolve(L.isNumber(a.pid)?a.pid:-1),this.pidResolve=void 0),a.on("error",f=>{this.childProcess=null,r({terminated:this.terminateRequested,error:f})}),a.pid&&(this.childProcess.on("close",u),this.handleSpawn(a,i,S,r,!0)))}return c})}handleClose(S,o,i,r){}ensureQuotes(S){return _.regexp.test(S)?{value:'"'+S+'"',quoted:!0}:{value:S,quoted:S.length>0&&S[0]==='"'&&S[S.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(S=>S.pid,S=>-1):new Promise(S=>{this.pidResolve=S})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(S=>(this.terminateRequested=!0,m(S,this.options.cwd).then(o=>(o.success&&(this.childProcess=null),o))),S=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(S=>{if(!this.shell||!k.isWindows)return S(!1);const o=h.spawn(F(),["/s","/c"]);o.on("error",i=>S(!0)),o.on("exit",i=>S(!1))})}}e.AbstractProcess=_,_.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},_.regexp=/^[^"].* .*[^"]/;class g extends _{constructor(S,o,i,r){super(S,o,i,r);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(S,o,i,r,c){[r,c].forEach((a,u)=>{const f=new C.LineDecoder;f.write(a).forEach(A=>{o({line:A,source:u===0?0:1})});const w=f.end();w&&o({line:w,source:u===0?0:1})}),S({terminated:this.terminateRequested,error:i})}handleSpawn(S,o,i,r,c){const a=new C.LineDecoder,u=new C.LineDecoder;S.stdout.on("data",f=>{a.write(f).forEach(w=>i({line:w,source:0}))}),S.stderr.on("data",f=>{u.write(f).forEach(w=>i({line:w,source:1}))}),this.stdoutLineDecoder=a,this.stderrLineDecoder=u}handleClose(S,o,i,r){const c=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;c&&i({line:c,source:0});const a=this.stderrLineDecoder?this.stderrLineDecoder.end():null;a&&i({line:a,source:1})}}e.LineProcess=g;function s(n){let S=[],o=!1;const i=function(r){if(o){S.push(r);return}(!n.send(r,a=>{if(a&&console.error(a),o=!1,S.length>0){const u=S.slice(0);S=[],u.forEach(f=>i(f))}})||k.isWindows)&&(o=!0)};return{send:i}}e.createQueuedSender=s;var d;(function(n){async function S(o,i,r){if(R.isAbsolute(o))return o;if(i===void 0&&(i=D.cwd()),R.dirname(o)!=="."||(r===void 0&&L.isString(D.env.PATH)&&(r=D.env.PATH.split(R.delimiter)),r===void 0||r.length===0))return R.join(i,o);async function a(u){if(await l.Promises.exists(u)){let f;try{f=await l.Promises.stat(u)}catch(v){v.message.startsWith("EACCES")&&(f=await l.Promises.lstat(u))}return f?!f.isDirectory():!1}return!1}for(let u of r){let f;if(R.isAbsolute(u)?f=R.join(u,o):f=R.join(i,u,o),await a(f))return f;let v=f+".com";if(await a(v)||(v=f+".exe",await a(v)))return v}return R.join(i,o)}n.findExecutable=S})(d=e.win32||(e.win32={}))}),define(ve[156],we([19,20]),function(Z,e){return Z.create("vs/editor/common/config/editorOptions",e)}),define(ve[114],we([0,1,156,11,110,17,25]),function(Z,e,h,t,I,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var k;(function(ee){ee[ee.None=0]="None",ee[ee.Keep=1]="Keep",ee[ee.Brackets=2]="Brackets",ee[ee.Advanced=3]="Advanced",ee[ee.Full=4]="Full"})(k=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class D{constructor(re){this._values=re}hasChanged(re){return this._values[re]}}e.ConfigurationChangedEvent=D;class P{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=P;class L{constructor(re,Se,se,ye){this.id=re,this.name=Se,this.defaultValue=se,this.schema=ye}applyUpdate(re,Se){return l(re,Se)}compute(re,Se,se){return se}}class C{constructor(re,Se){this.newValue=re,this.didChange=Se}}e.ApplyUpdateResult=C;function l(ee,re){if(typeof ee!="object"||typeof re!="object"||!ee||!re)return new C(re,ee!==re);if(Array.isArray(ee)||Array.isArray(re)){const se=Array.isArray(ee)&&Array.isArray(re)&&y.equals(ee,re);return new C(re,se)}let Se=!1;for(const se in re)if(re.hasOwnProperty(se)){const ye=l(ee[se],re[se]);ye.didChange&&(ee[se]=ye.newValue,Se=!0)}return new C(ee,Se)}class E{constructor(re){this.schema=void 0,this.id=re,this.name="_never_",this.defaultValue=void 0}applyUpdate(re,Se){return l(re,Se)}validate(re){return this.defaultValue}}class p{constructor(re,Se,se,ye){this.id=re,this.name=Se,this.defaultValue=se,this.schema=ye}applyUpdate(re,Se){return l(re,Se)}validate(re){return typeof re=="undefined"?this.defaultValue:re}compute(re,Se,se){return se}}function m(ee,re){return typeof ee=="undefined"?re:ee==="false"?!1:Boolean(ee)}e.boolean=m;class b extends p{constructor(re,Se,se,ye=void 0){typeof ye!="undefined"&&(ye.type="boolean",ye.default=se);super(re,Se,se,ye)}validate(re){return m(re,this.defaultValue)}}function F(ee,re,Se,se){if(typeof ee=="undefined")return re;let ye=parseInt(ee,10);return isNaN(ye)?re:(ye=Math.max(Se,ye),ye=Math.min(se,ye),ye|0)}e.clampedInt=F;class _ extends p{constructor(re,Se,se,ye,Me,qe=void 0){typeof qe!="undefined"&&(qe.type="integer",qe.default=se,qe.minimum=ye,qe.maximum=Me);super(re,Se,se,qe);this.minimum=ye,this.maximum=Me}static clampedInt(re,Se,se,ye){return F(re,Se,se,ye)}validate(re){return _.clampedInt(re,this.defaultValue,this.minimum,this.maximum)}}class g extends p{constructor(re,Se,se,ye,Me){typeof Me!="undefined"&&(Me.type="number",Me.default=se);super(re,Se,se,Me);this.validationFn=ye}static clamp(re,Se,se){return re<Se?Se:re>se?se:re}static float(re,Se){if(typeof re=="number")return re;if(typeof re=="undefined")return Se;const se=parseFloat(re);return isNaN(se)?Se:se}validate(re){return this.validationFn(g.float(re,this.defaultValue))}}class s extends p{static string(re,Se){return typeof re!="string"?Se:re}constructor(re,Se,se,ye=void 0){typeof ye!="undefined"&&(ye.type="string",ye.default=se);super(re,Se,se,ye)}validate(re){return s.string(re,this.defaultValue)}}function d(ee,re,Se){return typeof ee!="string"||Se.indexOf(ee)===-1?re:ee}e.stringSet=d;class n extends p{constructor(re,Se,se,ye,Me=void 0){typeof Me!="undefined"&&(Me.type="string",Me.enum=ye,Me.default=se);super(re,Se,se,Me);this._allowedValues=ye}validate(re){return d(re,this.defaultValue,this._allowedValues)}}class S extends L{constructor(re,Se,se,ye,Me,qe,Ve=void 0){typeof Ve!="undefined"&&(Ve.type="string",Ve.enum=Me,Ve.default=ye);super(re,Se,se,Ve);this._allowedValues=Me,this._convert=qe}validate(re){return typeof re!="string"?this.defaultValue:this._allowedValues.indexOf(re)===-1?this.defaultValue:this._convert(re)}}function o(ee){switch(ee){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class i extends L{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[h.localize(0,null),h.localize(1,null),h.localize(2,null)],default:"auto",description:h.localize(3,null)})}validate(re){switch(re){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(re,Se,se){return se===0?re.accessibilitySupport:se}}class r extends L{constructor(){const re={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",re,{"editor.comments.insertSpace":{type:"boolean",default:re.insertSpace,description:h.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:re.ignoreEmptyLines,description:h.localize(5,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Se=re;return{insertSpace:m(Se.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:m(Se.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var c;(function(ee){ee[ee.Hidden=0]="Hidden",ee[ee.Blink=1]="Blink",ee[ee.Smooth=2]="Smooth",ee[ee.Phase=3]="Phase",ee[ee.Expand=4]="Expand",ee[ee.Solid=5]="Solid"})(c=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function a(ee){switch(ee){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var u;(function(ee){ee[ee.Line=1]="Line",ee[ee.Block=2]="Block",ee[ee.Underline=3]="Underline",ee[ee.LineThin=4]="LineThin",ee[ee.BlockOutline=5]="BlockOutline",ee[ee.UnderlineThin=6]="UnderlineThin"})(u=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function f(ee){switch(ee){case u.Line:return"line";case u.Block:return"block";case u.Underline:return"underline";case u.LineThin:return"line-thin";case u.BlockOutline:return"block-outline";case u.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=f;function v(ee){switch(ee){case"line":return u.Line;case"block":return u.Block;case"underline":return u.Underline;case"line-thin":return u.LineThin;case"block-outline":return u.BlockOutline;case"underline-thin":return u.UnderlineThin}}class w extends E{constructor(){super(128)}compute(re,Se,se){const ye=["monaco-editor"];return Se.get(33)&&ye.push(Se.get(33)),re.extraEditorClassName&&ye.push(re.extraEditorClassName),Se.get(66)==="default"?ye.push("mouse-default"):Se.get(66)==="copy"&&ye.push("mouse-copy"),Se.get(100)&&ye.push("showUnused"),Se.get(126)&&ye.push("showDeprecated"),ye.join(" ")}}class A extends b{constructor(){super(32,"emptySelectionClipboard",!0,{description:h.localize(6,null)})}compute(re,Se,se){return se&&re.emptySelectionClipboard}}class M extends L{constructor(){const re={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(35,"find",re,{"editor.find.cursorMoveOnType":{type:"boolean",default:re.cursorMoveOnType,description:h.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:re.seedSearchStringFromSelection,enumDescriptions:[h.localize(8,null),h.localize(9,null),h.localize(10,null)],description:h.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:re.autoFindInSelection,enumDescriptions:[h.localize(12,null),h.localize(13,null),h.localize(14,null)],description:h.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:re.globalFindClipboard,description:h.localize(16,null),included:t.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:re.addExtraSpaceOnTop,description:h.localize(17,null)},"editor.find.loop":{type:"boolean",default:re.loop,description:h.localize(18,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Se=re;return{cursorMoveOnType:m(Se.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof re.seedSearchStringFromSelection=="boolean"?re.seedSearchStringFromSelection?"always":"never":d(Se.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof re.autoFindInSelection=="boolean"?re.autoFindInSelection?"always":"never":d(Se.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:m(Se.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:m(Se.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:m(Se.loop,this.defaultValue.loop)}}}class T extends L{constructor(){super(45,"fontLigatures",T.OFF,{anyOf:[{type:"boolean",description:h.localize(19,null)},{type:"string",description:h.localize(20,null)}],description:h.localize(21,null),default:!1})}validate(re){return typeof re=="undefined"?this.defaultValue:typeof re=="string"?re==="false"?T.OFF:re==="true"?T.ON:re:Boolean(re)?T.ON:T.OFF}}e.EditorFontLigatures=T,T.OFF='"liga" off, "calt" off',T.ON='"liga" on, "calt" on';class O extends E{constructor(){super(44)}compute(re,Se,se){return re.fontInfo}}class U extends p{constructor(){super(46,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:h.localize(22,null)})}validate(re){const Se=g.float(re,this.defaultValue);return Se===0?e.EDITOR_FONT_DEFAULTS.fontSize:g.clamp(Se,6,100)}compute(re,Se,se){return re.fontInfo.fontSize}}class V extends L{constructor(){super(47,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:V.MINIMUM_VALUE,maximum:V.MAXIMUM_VALUE,errorMessage:h.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:V.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:h.localize(24,null)})}validate(re){return re==="normal"||re==="bold"?re:String(_.clampedInt(re,e.EDITOR_FONT_DEFAULTS.fontWeight,V.MINIMUM_VALUE,V.MAXIMUM_VALUE))}}V.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],V.MINIMUM_VALUE=1,V.MAXIMUM_VALUE=1e3;class x extends L{constructor(){const re={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Se={type:"string",enum:["peek","gotoAndPeek","goto"],default:re.multiple,enumDescriptions:[h.localize(25,null),h.localize(26,null),h.localize(27,null)]},se=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(51,"gotoLocation",re,{"editor.gotoLocation.multiple":{deprecationMessage:h.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:h.localize(29,null),...Se},"editor.gotoLocation.multipleTypeDefinitions":{description:h.localize(30,null),...Se},"editor.gotoLocation.multipleDeclarations":{description:h.localize(31,null),...Se},"editor.gotoLocation.multipleImplementations":{description:h.localize(32,null),...Se},"editor.gotoLocation.multipleReferences":{description:h.localize(33,null),...Se},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:re.alternativeDefinitionCommand,enum:se,description:h.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:re.alternativeTypeDefinitionCommand,enum:se,description:h.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:re.alternativeDeclarationCommand,enum:se,description:h.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:re.alternativeImplementationCommand,enum:se,description:h.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:re.alternativeReferenceCommand,enum:se,description:h.localize(38,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Se=re;return{multiple:d(Se.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Se.multipleDefinitions??d(Se.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Se.multipleTypeDefinitions??d(Se.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Se.multipleDeclarations??d(Se.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Se.multipleImplementations??d(Se.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Se.multipleReferences??d(Se.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:s.string(Se.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:s.string(Se.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:s.string(Se.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:s.string(Se.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:s.string(Se.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class N extends L{constructor(){const re={enabled:!0,delay:300,sticky:!0,above:!0};super(53,"hover",re,{"editor.hover.enabled":{type:"boolean",default:re.enabled,description:h.localize(39,null)},"editor.hover.delay":{type:"number",default:re.delay,minimum:0,maximum:1e4,description:h.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:re.sticky,description:h.localize(41,null)},"editor.hover.above":{type:"boolean",default:re.above,description:h.localize(42,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Se=re;return{enabled:m(Se.enabled,this.defaultValue.enabled),delay:_.clampedInt(Se.delay,this.defaultValue.delay,0,1e4),sticky:m(Se.sticky,this.defaultValue.sticky),above:m(Se.above,this.defaultValue.above)}}}var $;(function(ee){ee[ee.None=0]="None",ee[ee.Text=1]="Text",ee[ee.Blocks=2]="Blocks"})($=e.RenderMinimap||(e.RenderMinimap={}));class B extends E{constructor(){super(131)}compute(re,Se,se){return B.computeLayout(Se,{memory:re.memory,outerWidth:re.outerWidth,outerHeight:re.outerHeight,isDominatedByLongLines:re.isDominatedByLongLines,lineHeight:re.fontInfo.lineHeight,viewLineCount:re.viewLineCount,lineNumbersDigitCount:re.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:re.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:re.fontInfo.maxDigitWidth,pixelRatio:re.pixelRatio})}static computeContainedMinimapLineCount(re){const Se=re.height/re.lineHeight,se=re.scrollBeyondLastLine?Se-1:0,ye=(re.viewLineCount+se)/(re.pixelRatio*re.height),Me=Math.floor(re.viewLineCount/ye);return{typicalViewportLineCount:Se,extraLinesBeyondLastLine:se,desiredRatio:ye,minimapLineCount:Me}}static _computeMinimapLayout(re,Se){const se=re.outerWidth,ye=re.outerHeight,Me=re.pixelRatio;if(!re.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Me*ye),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:ye};const qe=Se.stableMinimapLayoutInput,Ve=qe&&re.outerHeight===qe.outerHeight&&re.lineHeight===qe.lineHeight&&re.typicalHalfwidthCharacterWidth===qe.typicalHalfwidthCharacterWidth&&re.pixelRatio===qe.pixelRatio&&re.scrollBeyondLastLine===qe.scrollBeyondLastLine&&re.minimap.enabled===qe.minimap.enabled&&re.minimap.side===qe.minimap.side&&re.minimap.size===qe.minimap.size&&re.minimap.showSlider===qe.minimap.showSlider&&re.minimap.renderCharacters===qe.minimap.renderCharacters&&re.minimap.maxColumn===qe.minimap.maxColumn&&re.minimap.scale===qe.minimap.scale&&re.verticalScrollbarWidth===qe.verticalScrollbarWidth&&re.isViewportWrapping===qe.isViewportWrapping,ut=re.lineHeight,Le=re.typicalHalfwidthCharacterWidth,Ae=re.scrollBeyondLastLine,De=re.minimap.renderCharacters;let ce=Me>=2?Math.round(re.minimap.scale*2):re.minimap.scale;const de=re.minimap.maxColumn,be=re.minimap.size,Ce=re.minimap.side,Oe=re.verticalScrollbarWidth,Ke=re.viewLineCount,$e=re.remainingWidth,Ze=re.isViewportWrapping,lt=De?2:3;let ct=Math.floor(Me*ye);const He=ct/Me;let Ee=!1,_e=!1,he=lt*ce,X=ce/Me,Ie=1;if(be==="fill"||be==="fit"){const{typicalViewportLineCount:ft,extraLinesBeyondLastLine:wt,desiredRatio:bt,minimapLineCount:Ut}=B.computeContainedMinimapLineCount({viewLineCount:Ke,scrollBeyondLastLine:Ae,height:ye,lineHeight:ut,pixelRatio:Me});if(Ke/Ut>1)Ee=!0,_e=!0,ce=1,he=1,X=ce/Me;else{let Ft=!1,kt=ce+1;if(be==="fit"){const Ct=Math.ceil((Ke+wt)*he);Ze&&Ve&&$e<=Se.stableFitRemainingWidth?(Ft=!0,kt=Se.stableFitMaxMinimapScale):Ft=Ct>ct}if(be==="fill"||Ft){Ee=!0;const Ct=ce;he=Math.min(ut*Me,Math.max(1,Math.floor(1/bt))),Ze&&Ve&&$e<=Se.stableFitRemainingWidth&&(kt=Se.stableFitMaxMinimapScale),ce=Math.min(kt,Math.max(1,Math.floor(he/lt))),ce>Ct&&(Ie=Math.min(2,ce/Ct)),X=ce/Me/Ie,ct=Math.ceil(Math.max(ft,Ke+wt)*he),Ze?(Se.stableMinimapLayoutInput=re,Se.stableFitRemainingWidth=$e,Se.stableFitMaxMinimapScale=ce):(Se.stableMinimapLayoutInput=null,Se.stableFitRemainingWidth=0)}}}const Ne=Math.floor(de*X),Ye=Math.min(Ne,Math.max(0,Math.floor(($e-Oe-2)*X/(Le+X)))+e.MINIMAP_GUTTER_WIDTH);let Xe=Math.floor(Me*Ye);const pt=Xe/Me;Xe=Math.floor(Xe*Ie);const St=De?1:2,yt=Ce==="left"?0:se-Ye-Oe;return{renderMinimap:St,minimapLeft:yt,minimapWidth:Ye,minimapHeightIsEditorHeight:Ee,minimapIsSampling:_e,minimapScale:ce,minimapLineHeight:he,minimapCanvasInnerWidth:Xe,minimapCanvasInnerHeight:ct,minimapCanvasOuterWidth:pt,minimapCanvasOuterHeight:He}}static computeLayout(re,Se){const se=Se.outerWidth|0,ye=Se.outerHeight|0,Me=Se.lineHeight|0,qe=Se.lineNumbersDigitCount|0,Ve=Se.typicalHalfwidthCharacterWidth,ut=Se.maxDigitWidth,Le=Se.pixelRatio,Ae=Se.viewLineCount,De=re.get(123),ce=De==="inherit"?re.get(122):De,de=ce==="inherit"?re.get(118):ce,be=re.get(121),Ce=re.get(2),Oe=Se.isDominatedByLongLines,Ke=re.get(50),$e=re.get(60).renderType!==0,Ze=re.get(61),lt=re.get(94),ct=re.get(65),He=re.get(92),Ee=He.verticalScrollbarSize,_e=He.verticalHasArrows,he=He.arrowSize,X=He.horizontalScrollbarSize,Ie=re.get(58),Ne=re.get(37);let Ye;if(typeof Ie=="string"&&/^\d+(\.\d+)?ch$/.test(Ie)){const Et=parseFloat(Ie.substr(0,Ie.length-2));Ye=_.clampedInt(Et*Ve,0,0,1e3)}else Ye=_.clampedInt(Ie,0,0,1e3);Ne&&(Ye+=16);let Xe=0;if($e){const Et=Math.max(qe,Ze);Xe=Math.round(Et*ut)}let pt=0;Ke&&(pt=Me);let St=0,yt=St+pt,ft=yt+Xe,wt=ft+Ye;const bt=se-pt-Xe-Ye;let Ut=!1,Pt=!1,Ft=-1;Ce!==2&&(ce==="inherit"&&Oe?(Ut=!0,Pt=!0):de==="on"||de==="bounded"?Pt=!0:de==="wordWrapColumn"&&(Ft=be));const kt=B._computeMinimapLayout({outerWidth:se,outerHeight:ye,lineHeight:Me,typicalHalfwidthCharacterWidth:Ve,pixelRatio:Le,scrollBeyondLastLine:lt,minimap:ct,verticalScrollbarWidth:Ee,viewLineCount:Ae,remainingWidth:bt,isViewportWrapping:Pt},Se.memory||new P);kt.renderMinimap!==0&&kt.minimapLeft===0&&(St+=kt.minimapWidth,yt+=kt.minimapWidth,ft+=kt.minimapWidth,wt+=kt.minimapWidth);const Ct=bt-kt.minimapWidth,Qt=Math.max(1,Math.floor((Ct-Ee-2)/Ve)),Vt=_e?he:0;return Pt&&(Ft=Math.max(1,Qt),de==="bounded"&&(Ft=Math.min(Ft,be))),{width:se,height:ye,glyphMarginLeft:St,glyphMarginWidth:pt,lineNumbersLeft:yt,lineNumbersWidth:Xe,decorationsLeft:ft,decorationsWidth:Ye,contentLeft:wt,contentWidth:Ct,minimap:kt,viewportColumn:Qt,isWordWrapMinified:Ut,isViewportWrapping:Pt,wrappingColumn:Ft,verticalScrollbarWidth:Ee,horizontalScrollbarHeight:X,overviewRuler:{top:Vt,width:Ee,height:ye-2*Vt,right:0}}}}e.EditorLayoutInfoComputer=B;class z extends L{constructor(){const re={enabled:!0};super(57,"lightbulb",re,{"editor.lightbulb.enabled":{type:"boolean",default:re.enabled,description:h.localize(43,null)}})}validate(re){return!re||typeof re!="object"?this.defaultValue:{enabled:m(re.enabled,this.defaultValue.enabled)}}}class W extends L{constructor(){const re={enabled:!0,fontSize:0,fontFamily:""};super(127,"inlayHints",re,{"editor.inlayHints.enabled":{type:"boolean",default:re.enabled,description:h.localize(44,null)},"editor.inlayHints.fontSize":{type:"number",default:re.fontSize,markdownDescription:h.localize(45,null)},"editor.inlayHints.fontFamily":{type:"string",default:re.fontFamily,markdownDescription:h.localize(46,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Se=re;return{enabled:m(Se.enabled,this.defaultValue.enabled),fontSize:_.clampedInt(Se.fontSize,this.defaultValue.fontSize,0,100),fontFamily:s.string(Se.fontFamily,this.defaultValue.fontFamily)}}}class Y extends g{constructor(){super(59,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,re=>g.clamp(re,0,150),{markdownDescription:h.localize(47,null)})}compute(re,Se,se){return re.fontInfo.lineHeight}}class ie extends L{constructor(){const re={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(65,"minimap",re,{"editor.minimap.enabled":{type:"boolean",default:re.enabled,description:h.localize(48,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[h.localize(49,null),h.localize(50,null),h.localize(51,null)],default:re.size,description:h.localize(52,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:re.side,description:h.localize(53,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:re.showSlider,description:h.localize(54,null)},"editor.minimap.scale":{type:"number",default:re.scale,minimum:1,maximum:3,enum:[1,2,3],description:h.localize(55,null)},"editor.minimap.renderCharacters":{type:"boolean",default:re.renderCharacters,description:h.localize(56,null)},"editor.minimap.maxColumn":{type:"number",default:re.maxColumn,description:h.localize(57,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Se=re;return{enabled:m(Se.enabled,this.defaultValue.enabled),size:d(Se.size,this.defaultValue.size,["proportional","fill","fit"]),side:d(Se.side,this.defaultValue.side,["right","left"]),showSlider:d(Se.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:m(Se.renderCharacters,this.defaultValue.renderCharacters),scale:_.clampedInt(Se.scale,1,1,3),maxColumn:_.clampedInt(Se.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function ne(ee){return ee==="ctrlCmd"?t.isMacintosh?"metaKey":"ctrlKey":"altKey"}class J extends L{constructor(){super(75,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:h.localize(58,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:h.localize(59,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Se=re;return{top:_.clampedInt(Se.top,0,0,1e3),bottom:_.clampedInt(Se.bottom,0,0,1e3)}}}class K extends L{constructor(){const re={enabled:!0,cycle:!1};super(76,"parameterHints",re,{"editor.parameterHints.enabled":{type:"boolean",default:re.enabled,description:h.localize(60,null)},"editor.parameterHints.cycle":{type:"boolean",default:re.cycle,description:h.localize(61,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Se=re;return{enabled:m(Se.enabled,this.defaultValue.enabled),cycle:m(Se.cycle,this.defaultValue.cycle)}}}class oe extends E{constructor(){super(129)}compute(re,Se,se){return re.pixelRatio}}class fe extends L{constructor(){const re={other:!0,comments:!1,strings:!1};super(79,"quickSuggestions",re,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:re.strings,description:h.localize(62,null)},comments:{type:"boolean",default:re.comments,description:h.localize(63,null)},other:{type:"boolean",default:re.other,description:h.localize(64,null)}}}],default:re,description:h.localize(65,null)});this.defaultValue=re}validate(re){if(typeof re=="boolean")return re;if(re&&typeof re=="object"){const Se=re,se={other:m(Se.other,this.defaultValue.other),comments:m(Se.comments,this.defaultValue.comments),strings:m(Se.strings,this.defaultValue.strings)};return se.other&&se.comments&&se.strings?!0:!se.other&&!se.comments&&!se.strings?!1:se}return this.defaultValue}}var pe;(function(ee){ee[ee.Off=0]="Off",ee[ee.On=1]="On",ee[ee.Relative=2]="Relative",ee[ee.Interval=3]="Interval",ee[ee.Custom=4]="Custom"})(pe=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Te extends L{constructor(){super(60,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[h.localize(66,null),h.localize(67,null),h.localize(68,null),h.localize(69,null)],default:"on",description:h.localize(70,null)})}validate(re){let Se=this.defaultValue.renderType,se=this.defaultValue.renderFn;return typeof re!="undefined"&&(typeof re=="function"?(Se=4,se=re):re==="interval"?Se=3:re==="relative"?Se=2:re==="on"?Se=1:Se=0),{renderType:Se,renderFn:se}}}function xe(ee){const re=ee.get(87);return re==="editable"?ee.get(81):re!=="on"}e.filterValidationDecorations=xe;class Ge extends L{constructor(){const re=[],Se={type:"number",description:h.localize(71,null)};super(91,"rulers",re,{type:"array",items:{anyOf:[Se,{type:["object"],properties:{column:Se,color:{type:"string",description:h.localize(72,null),format:"color-hex"}}}]},default:re,description:h.localize(73,null)})}validate(re){if(Array.isArray(re)){const Se=[];for(let se of re)if(typeof se=="number")Se.push({column:_.clampedInt(se,0,0,1e4),color:null});else if(se&&typeof se=="object"){const ye=se;Se.push({column:_.clampedInt(ye.column,0,0,1e4),color:ye.color})}return Se.sort((se,ye)=>se.column-ye.column),Se}return this.defaultValue}}function Qe(ee,re){if(typeof ee!="string")return re;switch(ee){case"hidden":return 2;case"visible":return 3;default:return 1}}class q extends L{constructor(){const re={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(92,"scrollbar",re,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[h.localize(74,null),h.localize(75,null),h.localize(76,null)],default:"auto",description:h.localize(77,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[h.localize(78,null),h.localize(79,null),h.localize(80,null)],default:"auto",description:h.localize(81,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:re.verticalScrollbarSize,description:h.localize(82,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:re.horizontalScrollbarSize,description:h.localize(83,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:re.scrollByPage,description:h.localize(84,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Se=re,se=_.clampedInt(Se.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),ye=_.clampedInt(Se.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:_.clampedInt(Se.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Qe(Se.vertical,this.defaultValue.vertical),horizontal:Qe(Se.horizontal,this.defaultValue.horizontal),useShadows:m(Se.useShadows,this.defaultValue.useShadows),verticalHasArrows:m(Se.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:m(Se.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:m(Se.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:m(Se.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:se,horizontalSliderSize:_.clampedInt(Se.horizontalSliderSize,se,0,1e3),verticalScrollbarSize:ye,verticalSliderSize:_.clampedInt(Se.verticalSliderSize,ye,0,1e3),scrollByPage:m(Se.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class te extends L{constructor(){const re={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(113,"unicodeHighlight",re,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:re.nonBasicASCII,description:h.localize(85,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:re.invisibleCharacters,description:h.localize(86,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:re.ambiguousCharacters,description:h.localize(87,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:re.includeComments,description:h.localize(88,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:re.includeStrings,description:h.localize(89,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:re.allowedCharacters,description:h.localize(90,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:re.allowedLocales,description:h.localize(91,null)}})}applyUpdate(re,Se){let se=!1;Se.allowedCharacters&&(R.equals(re.allowedCharacters,Se.allowedCharacters)||(re={...re,allowedCharacters:Se.allowedCharacters},se=!0)),Se.allowedLocales&&(R.equals(re.allowedLocales,Se.allowedLocales)||(re={...re,allowedLocales:Se.allowedLocales},se=!0));const ye=super.applyUpdate(re,Se);return se?new C(ye.newValue,!0):ye}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Se=re;return{nonBasicASCII:me(Se.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:m(Se.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:m(Se.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:me(Se.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:me(Se.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(re.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(re.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(re,Se){if(typeof re!="object"||!re)return Se;const se={};for(const[ye,Me]of Object.entries(re))Me===!0&&(se[ye]=!0);return se}}class G extends L{constructor(){const re={enabled:!0,mode:"subwordSmart"};super(55,"inlineSuggest",re,{"editor.inlineSuggest.enabled":{type:"boolean",default:re.enabled,description:h.localize(92,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Se=re;return{enabled:m(Se.enabled,this.defaultValue.enabled),mode:d(Se.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class Q extends L{constructor(){const re={enabled:e.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled};super(12,"bracketPairColorization",re,{"editor.bracketPairColorization.enabled":{type:"boolean",default:re.enabled,description:h.localize(93,null)}})}validate(re){return!re||typeof re!="object"?this.defaultValue:{enabled:m(re.enabled,this.defaultValue.enabled)}}}class ae extends L{constructor(){const re={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",re,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[h.localize(94,null),h.localize(95,null),h.localize(96,null)],default:re.bracketPairs,description:h.localize(97,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[h.localize(98,null),h.localize(99,null),h.localize(100,null)],default:re.bracketPairsHorizontal,description:h.localize(101,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:re.highlightActiveBracketPair,description:h.localize(102,null)},"editor.guides.indentation":{type:"boolean",default:re.indentation,description:h.localize(103,null)},"editor.guides.highlightActiveIndentation":{type:"boolean",default:re.highlightActiveIndentation,description:h.localize(104,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Se=re;return{bracketPairs:me(Se.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:me(Se.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:m(Se.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:m(Se.indentation,this.defaultValue.indentation),highlightActiveIndentation:m(Se.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation)}}}function me(ee,re,Se){const se=Se.indexOf(ee);return se===-1?re:Se[se]}class ke extends L{constructor(){const re={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(106,"suggest",re,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[h.localize(105,null),h.localize(106,null)],default:re.insertMode,description:h.localize(107,null)},"editor.suggest.filterGraceful":{type:"boolean",default:re.filterGraceful,description:h.localize(108,null)},"editor.suggest.localityBonus":{type:"boolean",default:re.localityBonus,description:h.localize(109,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:re.shareSuggestSelections,markdownDescription:h.localize(110,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:re.snippetsPreventQuickSuggestions,description:h.localize(111,null)},"editor.suggest.showIcons":{type:"boolean",default:re.showIcons,description:h.localize(112,null)},"editor.suggest.showStatusBar":{type:"boolean",default:re.showStatusBar,description:h.localize(113,null)},"editor.suggest.preview":{type:"boolean",default:re.preview,description:h.localize(114,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:re.showInlineDetails,description:h.localize(115,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:h.localize(116,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:h.localize(117,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:h.localize(118,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:h.localize(119,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:h.localize(120,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:h.localize(121,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:h.localize(122,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:h.localize(123,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:h.localize(124,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:h.localize(125,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:h.localize(126,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:h.localize(127,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:h.localize(128,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:h.localize(129,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:h.localize(130,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:h.localize(131,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:h.localize(132,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:h.localize(133,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:h.localize(134,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:h.localize(135,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:h.localize(136,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:h.localize(137,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:h.localize(138,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:h.localize(139,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:h.localize(140,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:h.localize(141,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:h.localize(142,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:h.localize(143,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:h.localize(144,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:h.localize(145,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:h.localize(146,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Se=re;return{insertMode:d(Se.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:m(Se.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:m(Se.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:m(Se.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:m(Se.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:m(Se.showIcons,this.defaultValue.showIcons),showStatusBar:m(Se.showStatusBar,this.defaultValue.showStatusBar),preview:m(Se.preview,this.defaultValue.preview),previewMode:d(Se.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:m(Se.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:m(Se.showMethods,this.defaultValue.showMethods),showFunctions:m(Se.showFunctions,this.defaultValue.showFunctions),showConstructors:m(Se.showConstructors,this.defaultValue.showConstructors),showDeprecated:m(Se.showDeprecated,this.defaultValue.showDeprecated),showFields:m(Se.showFields,this.defaultValue.showFields),showVariables:m(Se.showVariables,this.defaultValue.showVariables),showClasses:m(Se.showClasses,this.defaultValue.showClasses),showStructs:m(Se.showStructs,this.defaultValue.showStructs),showInterfaces:m(Se.showInterfaces,this.defaultValue.showInterfaces),showModules:m(Se.showModules,this.defaultValue.showModules),showProperties:m(Se.showProperties,this.defaultValue.showProperties),showEvents:m(Se.showEvents,this.defaultValue.showEvents),showOperators:m(Se.showOperators,this.defaultValue.showOperators),showUnits:m(Se.showUnits,this.defaultValue.showUnits),showValues:m(Se.showValues,this.defaultValue.showValues),showConstants:m(Se.showConstants,this.defaultValue.showConstants),showEnums:m(Se.showEnums,this.defaultValue.showEnums),showEnumMembers:m(Se.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:m(Se.showKeywords,this.defaultValue.showKeywords),showWords:m(Se.showWords,this.defaultValue.showWords),showColors:m(Se.showColors,this.defaultValue.showColors),showFiles:m(Se.showFiles,this.defaultValue.showFiles),showReferences:m(Se.showReferences,this.defaultValue.showReferences),showFolders:m(Se.showFolders,this.defaultValue.showFolders),showTypeParameters:m(Se.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:m(Se.showSnippets,this.defaultValue.showSnippets),showUsers:m(Se.showUsers,this.defaultValue.showUsers),showIssues:m(Se.showIssues,this.defaultValue.showIssues)}}}class We extends L{constructor(){super(102,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:h.localize(147,null),default:!0,type:"boolean"}})}validate(re){return!re||typeof re!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:m(re.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class Je extends E{constructor(){super(130)}compute(re,Se,se){return Se.get(81)?!0:re.tabFocusMode}}var it;(function(ee){ee[ee.None=0]="None",ee[ee.Same=1]="Same",ee[ee.Indent=2]="Indent",ee[ee.DeepIndent=3]="DeepIndent"})(it=e.WrappingIndent||(e.WrappingIndent={}));function st(ee){switch(ee){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class ot extends E{constructor(){super(132)}compute(re,Se,se){const ye=Se.get(131);return{isDominatedByLongLines:re.isDominatedByLongLines,isWordWrapMinified:ye.isWordWrapMinified,isViewportWrapping:ye.isViewportWrapping,wrappingColumn:ye.wrappingColumn}}}const tt="Consolas, 'Courier New', monospace",rt="Menlo, Monaco, 'Courier New', monospace",gt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:t.isMacintosh?rt:t.isLinux?gt:tt,fontWeight:"normal",fontSize:t.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!1}},e.editorOptionsRegistry=[];function Ue(ee){return e.editorOptionsRegistry[ee.id]=ee,ee}var It;(function(ee){ee[ee.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",ee[ee.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",ee[ee.accessibilitySupport=2]="accessibilitySupport",ee[ee.accessibilityPageSize=3]="accessibilityPageSize",ee[ee.ariaLabel=4]="ariaLabel",ee[ee.autoClosingBrackets=5]="autoClosingBrackets",ee[ee.autoClosingDelete=6]="autoClosingDelete",ee[ee.autoClosingOvertype=7]="autoClosingOvertype",ee[ee.autoClosingQuotes=8]="autoClosingQuotes",ee[ee.autoIndent=9]="autoIndent",ee[ee.automaticLayout=10]="automaticLayout",ee[ee.autoSurround=11]="autoSurround",ee[ee.bracketPairColorization=12]="bracketPairColorization",ee[ee.guides=13]="guides",ee[ee.codeLens=14]="codeLens",ee[ee.codeLensFontFamily=15]="codeLensFontFamily",ee[ee.codeLensFontSize=16]="codeLensFontSize",ee[ee.colorDecorators=17]="colorDecorators",ee[ee.columnSelection=18]="columnSelection",ee[ee.comments=19]="comments",ee[ee.contextmenu=20]="contextmenu",ee[ee.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",ee[ee.cursorBlinking=22]="cursorBlinking",ee[ee.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",ee[ee.cursorStyle=24]="cursorStyle",ee[ee.cursorSurroundingLines=25]="cursorSurroundingLines",ee[ee.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",ee[ee.cursorWidth=27]="cursorWidth",ee[ee.disableLayerHinting=28]="disableLayerHinting",ee[ee.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",ee[ee.domReadOnly=30]="domReadOnly",ee[ee.dragAndDrop=31]="dragAndDrop",ee[ee.emptySelectionClipboard=32]="emptySelectionClipboard",ee[ee.extraEditorClassName=33]="extraEditorClassName",ee[ee.fastScrollSensitivity=34]="fastScrollSensitivity",ee[ee.find=35]="find",ee[ee.fixedOverflowWidgets=36]="fixedOverflowWidgets",ee[ee.folding=37]="folding",ee[ee.foldingStrategy=38]="foldingStrategy",ee[ee.foldingHighlight=39]="foldingHighlight",ee[ee.foldingImportsByDefault=40]="foldingImportsByDefault",ee[ee.foldingMaximumRegions=41]="foldingMaximumRegions",ee[ee.unfoldOnClickAfterEndOfLine=42]="unfoldOnClickAfterEndOfLine",ee[ee.fontFamily=43]="fontFamily",ee[ee.fontInfo=44]="fontInfo",ee[ee.fontLigatures=45]="fontLigatures",ee[ee.fontSize=46]="fontSize",ee[ee.fontWeight=47]="fontWeight",ee[ee.formatOnPaste=48]="formatOnPaste",ee[ee.formatOnType=49]="formatOnType",ee[ee.glyphMargin=50]="glyphMargin",ee[ee.gotoLocation=51]="gotoLocation",ee[ee.hideCursorInOverviewRuler=52]="hideCursorInOverviewRuler",ee[ee.hover=53]="hover",ee[ee.inDiffEditor=54]="inDiffEditor",ee[ee.inlineSuggest=55]="inlineSuggest",ee[ee.letterSpacing=56]="letterSpacing",ee[ee.lightbulb=57]="lightbulb",ee[ee.lineDecorationsWidth=58]="lineDecorationsWidth",ee[ee.lineHeight=59]="lineHeight",ee[ee.lineNumbers=60]="lineNumbers",ee[ee.lineNumbersMinChars=61]="lineNumbersMinChars",ee[ee.linkedEditing=62]="linkedEditing",ee[ee.links=63]="links",ee[ee.matchBrackets=64]="matchBrackets",ee[ee.minimap=65]="minimap",ee[ee.mouseStyle=66]="mouseStyle",ee[ee.mouseWheelScrollSensitivity=67]="mouseWheelScrollSensitivity",ee[ee.mouseWheelZoom=68]="mouseWheelZoom",ee[ee.multiCursorMergeOverlapping=69]="multiCursorMergeOverlapping",ee[ee.multiCursorModifier=70]="multiCursorModifier",ee[ee.multiCursorPaste=71]="multiCursorPaste",ee[ee.occurrencesHighlight=72]="occurrencesHighlight",ee[ee.overviewRulerBorder=73]="overviewRulerBorder",ee[ee.overviewRulerLanes=74]="overviewRulerLanes",ee[ee.padding=75]="padding",ee[ee.parameterHints=76]="parameterHints",ee[ee.peekWidgetDefaultFocus=77]="peekWidgetDefaultFocus",ee[ee.definitionLinkOpensInPeek=78]="definitionLinkOpensInPeek",ee[ee.quickSuggestions=79]="quickSuggestions",ee[ee.quickSuggestionsDelay=80]="quickSuggestionsDelay",ee[ee.readOnly=81]="readOnly",ee[ee.renameOnType=82]="renameOnType",ee[ee.renderControlCharacters=83]="renderControlCharacters",ee[ee.renderFinalNewline=84]="renderFinalNewline",ee[ee.renderLineHighlight=85]="renderLineHighlight",ee[ee.renderLineHighlightOnlyWhenFocus=86]="renderLineHighlightOnlyWhenFocus",ee[ee.renderValidationDecorations=87]="renderValidationDecorations",ee[ee.renderWhitespace=88]="renderWhitespace",ee[ee.revealHorizontalRightPadding=89]="revealHorizontalRightPadding",ee[ee.roundedSelection=90]="roundedSelection",ee[ee.rulers=91]="rulers",ee[ee.scrollbar=92]="scrollbar",ee[ee.scrollBeyondLastColumn=93]="scrollBeyondLastColumn",ee[ee.scrollBeyondLastLine=94]="scrollBeyondLastLine",ee[ee.scrollPredominantAxis=95]="scrollPredominantAxis",ee[ee.selectionClipboard=96]="selectionClipboard",ee[ee.selectionHighlight=97]="selectionHighlight",ee[ee.selectOnLineNumbers=98]="selectOnLineNumbers",ee[ee.showFoldingControls=99]="showFoldingControls",ee[ee.showUnused=100]="showUnused",ee[ee.snippetSuggestions=101]="snippetSuggestions",ee[ee.smartSelect=102]="smartSelect",ee[ee.smoothScrolling=103]="smoothScrolling",ee[ee.stickyTabStops=104]="stickyTabStops",ee[ee.stopRenderingLineAfter=105]="stopRenderingLineAfter",ee[ee.suggest=106]="suggest",ee[ee.suggestFontSize=107]="suggestFontSize",ee[ee.suggestLineHeight=108]="suggestLineHeight",ee[ee.suggestOnTriggerCharacters=109]="suggestOnTriggerCharacters",ee[ee.suggestSelection=110]="suggestSelection",ee[ee.tabCompletion=111]="tabCompletion",ee[ee.tabIndex=112]="tabIndex",ee[ee.unicodeHighlighting=113]="unicodeHighlighting",ee[ee.unusualLineTerminators=114]="unusualLineTerminators",ee[ee.useShadowDOM=115]="useShadowDOM",ee[ee.useTabStops=116]="useTabStops",ee[ee.wordSeparators=117]="wordSeparators",ee[ee.wordWrap=118]="wordWrap",ee[ee.wordWrapBreakAfterCharacters=119]="wordWrapBreakAfterCharacters",ee[ee.wordWrapBreakBeforeCharacters=120]="wordWrapBreakBeforeCharacters",ee[ee.wordWrapColumn=121]="wordWrapColumn",ee[ee.wordWrapOverride1=122]="wordWrapOverride1",ee[ee.wordWrapOverride2=123]="wordWrapOverride2",ee[ee.wrappingIndent=124]="wrappingIndent",ee[ee.wrappingStrategy=125]="wrappingStrategy",ee[ee.showDeprecated=126]="showDeprecated",ee[ee.inlayHints=127]="inlayHints",ee[ee.editorClassName=128]="editorClassName",ee[ee.pixelRatio=129]="pixelRatio",ee[ee.tabFocusMode=130]="tabFocusMode",ee[ee.layoutInfo=131]="layoutInfo",ee[ee.wrappingInfo=132]="wrappingInfo"})(It=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ue(new b(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:h.localize(148,null)})),acceptSuggestionOnEnter:Ue(new n(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",h.localize(149,null),""],markdownDescription:h.localize(150,null)})),accessibilitySupport:Ue(new i),accessibilityPageSize:Ue(new _(3,"accessibilityPageSize",10,1,1073741824,{description:h.localize(151,null)})),ariaLabel:Ue(new s(4,"ariaLabel",h.localize(152,null))),autoClosingBrackets:Ue(new n(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",h.localize(153,null),h.localize(154,null),""],description:h.localize(155,null)})),autoClosingDelete:Ue(new n(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",h.localize(156,null),""],description:h.localize(157,null)})),autoClosingOvertype:Ue(new n(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",h.localize(158,null),""],description:h.localize(159,null)})),autoClosingQuotes:Ue(new n(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",h.localize(160,null),h.localize(161,null),""],description:h.localize(162,null)})),autoIndent:Ue(new S(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],o,{enumDescriptions:[h.localize(163,null),h.localize(164,null),h.localize(165,null),h.localize(166,null),h.localize(167,null)],description:h.localize(168,null)})),automaticLayout:Ue(new b(10,"automaticLayout",!1)),autoSurround:Ue(new n(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[h.localize(169,null),h.localize(170,null),h.localize(171,null),""],description:h.localize(172,null)})),bracketPairColorization:Ue(new Q),bracketPairGuides:Ue(new ae),stickyTabStops:Ue(new b(104,"stickyTabStops",!1,{description:h.localize(173,null)})),codeLens:Ue(new b(14,"codeLens",!0,{description:h.localize(174,null)})),codeLensFontFamily:Ue(new s(15,"codeLensFontFamily","",{description:h.localize(175,null)})),codeLensFontSize:Ue(new _(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:h.localize(176,null)})),colorDecorators:Ue(new b(17,"colorDecorators",!0,{description:h.localize(177,null)})),columnSelection:Ue(new b(18,"columnSelection",!1,{description:h.localize(178,null)})),comments:Ue(new r),contextmenu:Ue(new b(20,"contextmenu",!0)),copyWithSyntaxHighlighting:Ue(new b(21,"copyWithSyntaxHighlighting",!0,{description:h.localize(179,null)})),cursorBlinking:Ue(new S(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],a,{description:h.localize(180,null)})),cursorSmoothCaretAnimation:Ue(new b(23,"cursorSmoothCaretAnimation",!1,{description:h.localize(181,null)})),cursorStyle:Ue(new S(24,"cursorStyle",u.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],v,{description:h.localize(182,null)})),cursorSurroundingLines:Ue(new _(25,"cursorSurroundingLines",0,0,1073741824,{description:h.localize(183,null)})),cursorSurroundingLinesStyle:Ue(new n(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[h.localize(184,null),h.localize(185,null)],description:h.localize(186,null)})),cursorWidth:Ue(new _(27,"cursorWidth",0,0,1073741824,{markdownDescription:h.localize(187,null)})),disableLayerHinting:Ue(new b(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ue(new b(29,"disableMonospaceOptimizations",!1)),domReadOnly:Ue(new b(30,"domReadOnly",!1)),dragAndDrop:Ue(new b(31,"dragAndDrop",!0,{description:h.localize(188,null)})),emptySelectionClipboard:Ue(new A),extraEditorClassName:Ue(new s(33,"extraEditorClassName","")),fastScrollSensitivity:Ue(new g(34,"fastScrollSensitivity",5,ee=>ee<=0?5:ee,{markdownDescription:h.localize(189,null)})),find:Ue(new M),fixedOverflowWidgets:Ue(new b(36,"fixedOverflowWidgets",!1)),folding:Ue(new b(37,"folding",!0,{description:h.localize(190,null)})),foldingStrategy:Ue(new n(38,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[h.localize(191,null),h.localize(192,null)],description:h.localize(193,null)})),foldingHighlight:Ue(new b(39,"foldingHighlight",!0,{description:h.localize(194,null)})),foldingImportsByDefault:Ue(new b(40,"foldingImportsByDefault",!1,{description:h.localize(195,null)})),foldingMaximumRegions:Ue(new _(41,"foldingMaximumRegions",5e3,10,65e3,{description:h.localize(196,null)})),unfoldOnClickAfterEndOfLine:Ue(new b(42,"unfoldOnClickAfterEndOfLine",!1,{description:h.localize(197,null)})),fontFamily:Ue(new s(43,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:h.localize(198,null)})),fontInfo:Ue(new O),fontLigatures2:Ue(new T),fontSize:Ue(new U),fontWeight:Ue(new V),formatOnPaste:Ue(new b(48,"formatOnPaste",!1,{description:h.localize(199,null)})),formatOnType:Ue(new b(49,"formatOnType",!1,{description:h.localize(200,null)})),glyphMargin:Ue(new b(50,"glyphMargin",!0,{description:h.localize(201,null)})),gotoLocation:Ue(new x),hideCursorInOverviewRuler:Ue(new b(52,"hideCursorInOverviewRuler",!1,{description:h.localize(202,null)})),hover:Ue(new N),inDiffEditor:Ue(new b(54,"inDiffEditor",!1)),letterSpacing:Ue(new g(56,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,ee=>g.clamp(ee,-5,20),{description:h.localize(203,null)})),lightbulb:Ue(new z),lineDecorationsWidth:Ue(new p(58,"lineDecorationsWidth",10)),lineHeight:Ue(new Y),lineNumbers:Ue(new Te),lineNumbersMinChars:Ue(new _(61,"lineNumbersMinChars",5,1,300)),linkedEditing:Ue(new b(62,"linkedEditing",!1,{description:h.localize(204,null)})),links:Ue(new b(63,"links",!0,{description:h.localize(205,null)})),matchBrackets:Ue(new n(64,"matchBrackets","always",["always","near","never"],{description:h.localize(206,null)})),minimap:Ue(new ie),mouseStyle:Ue(new n(66,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ue(new g(67,"mouseWheelScrollSensitivity",1,ee=>ee===0?1:ee,{markdownDescription:h.localize(207,null)})),mouseWheelZoom:Ue(new b(68,"mouseWheelZoom",!1,{markdownDescription:h.localize(208,null)})),multiCursorMergeOverlapping:Ue(new b(69,"multiCursorMergeOverlapping",!0,{description:h.localize(209,null)})),multiCursorModifier:Ue(new S(70,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],ne,{markdownEnumDescriptions:[h.localize(210,null),h.localize(211,null)],markdownDescription:h.localize(212,null)})),multiCursorPaste:Ue(new n(71,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[h.localize(213,null),h.localize(214,null)],markdownDescription:h.localize(215,null)})),occurrencesHighlight:Ue(new b(72,"occurrencesHighlight",!0,{description:h.localize(216,null)})),overviewRulerBorder:Ue(new b(73,"overviewRulerBorder",!0,{description:h.localize(217,null)})),overviewRulerLanes:Ue(new _(74,"overviewRulerLanes",3,0,3)),padding:Ue(new J),parameterHints:Ue(new K),peekWidgetDefaultFocus:Ue(new n(77,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[h.localize(218,null),h.localize(219,null)],description:h.localize(220,null)})),definitionLinkOpensInPeek:Ue(new b(78,"definitionLinkOpensInPeek",!1,{description:h.localize(221,null)})),quickSuggestions:Ue(new fe),quickSuggestionsDelay:Ue(new _(80,"quickSuggestionsDelay",10,0,1073741824,{description:h.localize(222,null)})),readOnly:Ue(new b(81,"readOnly",!1)),renameOnType:Ue(new b(82,"renameOnType",!1,{description:h.localize(223,null),markdownDeprecationMessage:h.localize(224,null)})),renderControlCharacters:Ue(new b(83,"renderControlCharacters",!0,{description:h.localize(225,null),restricted:!0})),renderFinalNewline:Ue(new b(84,"renderFinalNewline",!0,{description:h.localize(226,null)})),renderLineHighlight:Ue(new n(85,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",h.localize(227,null)],description:h.localize(228,null)})),renderLineHighlightOnlyWhenFocus:Ue(new b(86,"renderLineHighlightOnlyWhenFocus",!1,{description:h.localize(229,null)})),renderValidationDecorations:Ue(new n(87,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ue(new n(88,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",h.localize(230,null),h.localize(231,null),h.localize(232,null),""],description:h.localize(233,null)})),revealHorizontalRightPadding:Ue(new _(89,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:Ue(new b(90,"roundedSelection",!0,{description:h.localize(234,null)})),rulers:Ue(new Ge),scrollbar:Ue(new q),scrollBeyondLastColumn:Ue(new _(93,"scrollBeyondLastColumn",5,0,1073741824,{description:h.localize(235,null)})),scrollBeyondLastLine:Ue(new b(94,"scrollBeyondLastLine",!0,{description:h.localize(236,null)})),scrollPredominantAxis:Ue(new b(95,"scrollPredominantAxis",!0,{description:h.localize(237,null)})),selectionClipboard:Ue(new b(96,"selectionClipboard",!0,{description:h.localize(238,null),included:t.isLinux})),selectionHighlight:Ue(new b(97,"selectionHighlight",!0,{description:h.localize(239,null)})),selectOnLineNumbers:Ue(new b(98,"selectOnLineNumbers",!0)),showFoldingControls:Ue(new n(99,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[h.localize(240,null),h.localize(241,null)],description:h.localize(242,null)})),showUnused:Ue(new b(100,"showUnused",!0,{description:h.localize(243,null)})),showDeprecated:Ue(new b(126,"showDeprecated",!0,{description:h.localize(244,null)})),inlayHints:Ue(new W),snippetSuggestions:Ue(new n(101,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[h.localize(245,null),h.localize(246,null),h.localize(247,null),h.localize(248,null)],description:h.localize(249,null)})),smartSelect:Ue(new We),smoothScrolling:Ue(new b(103,"smoothScrolling",!1,{description:h.localize(250,null)})),stopRenderingLineAfter:Ue(new _(105,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Ue(new ke),inlineSuggest:Ue(new G),suggestFontSize:Ue(new _(107,"suggestFontSize",0,0,1e3,{markdownDescription:h.localize(251,null)})),suggestLineHeight:Ue(new _(108,"suggestLineHeight",0,0,1e3,{markdownDescription:h.localize(252,null)})),suggestOnTriggerCharacters:Ue(new b(109,"suggestOnTriggerCharacters",!0,{description:h.localize(253,null)})),suggestSelection:Ue(new n(110,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[h.localize(254,null),h.localize(255,null),h.localize(256,null)],description:h.localize(257,null)})),tabCompletion:Ue(new n(111,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[h.localize(258,null),h.localize(259,null),h.localize(260,null)],description:h.localize(261,null)})),tabIndex:Ue(new _(112,"tabIndex",0,-1,1073741824)),unicodeHighlight:Ue(new te),unusualLineTerminators:Ue(new n(114,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[h.localize(262,null),h.localize(263,null),h.localize(264,null)],description:h.localize(265,null)})),useShadowDOM:Ue(new b(115,"useShadowDOM",!0)),useTabStops:Ue(new b(116,"useTabStops",!0,{description:h.localize(266,null)})),wordSeparators:Ue(new s(117,"wordSeparators",I.USUAL_WORD_SEPARATORS,{description:h.localize(267,null)})),wordWrap:Ue(new n(118,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[h.localize(268,null),h.localize(269,null),h.localize(270,null),h.localize(271,null)],description:h.localize(272,null)})),wordWrapBreakAfterCharacters:Ue(new s(119,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ue(new s(120,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ue(new _(121,"wordWrapColumn",80,1,1073741824,{markdownDescription:h.localize(273,null)})),wordWrapOverride1:Ue(new n(122,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ue(new n(123,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:Ue(new S(124,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],st,{enumDescriptions:[h.localize(274,null),h.localize(275,null),h.localize(276,null),h.localize(277,null)],description:h.localize(278,null)})),wrappingStrategy:Ue(new n(125,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[h.localize(279,null),h.localize(280,null)],description:h.localize(281,null)})),editorClassName:Ue(new w),pixelRatio:Ue(new oe),tabFocusMode:Ue(new Je),layoutInfo:Ue(new B),wrappingInfo:Ue(new ot)}}),define(ve[157],we([19,20]),function(Z,e){return Z.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ve[158],we([19,20]),function(Z,e){return Z.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ve[159],we([19,20]),function(Z,e){return Z.create("vs/platform/extensions/common/extensionValidator",e)}),define(ve[160],we([19,20]),function(Z,e){return Z.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ve[161],we([19,20]),function(Z,e){return Z.create("vs/platform/files/common/files",e)}),define(ve[162],we([19,20]),function(Z,e){return Z.create("vs/platform/markers/common/markers",e)}),define(ve[163],we([19,20]),function(Z,e){return Z.create("vs/platform/workspaces/common/workspaces",e)}),define(ve[164],we([19,20]),function(Z,e){return Z.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ve[165],we([19,20]),function(Z,e){return Z.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ve[166],we([19,20]),function(Z,e){return Z.create("vs/workbench/api/common/extHostProgress",e)}),define(ve[167],we([19,20]),function(Z,e){return Z.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ve[168],we([19,20]),function(Z,e){return Z.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ve[169],we([19,20]),function(Z,e){return Z.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ve[170],we([19,20]),function(Z,e){return Z.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ve[171],we([19,20]),function(Z,e){return Z.create("vs/workbench/api/node/extHostDebugService",e)}),define(ve[172],we([19,20]),function(Z,e){return Z.create("vs/workbench/api/node/extHostTunnelService",e)}),define(ve[173],we([19,20]),function(Z,e){return Z.create("vs/workbench/common/editor",e)}),define(ve[174],we([19,20]),function(Z,e){return Z.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ve[175],we([19,20]),function(Z,e){return Z.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(ve[176],we([19,20]),function(Z,e){return Z.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(ve[177],we([19,20]),function(Z,e){return Z.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(ve[178],we([19,20]),function(Z,e){return Z.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ve[179],we([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var h;(function(R){R[R.ACTIVATE=1]="ACTIVATE",R[R.RESTORE=2]="RESTORE",R[R.PRESERVE=3]="PRESERVE"})(h=e.EditorActivation||(e.EditorActivation={}));var t;(function(R){R[R.PICK=0]="PICK",R[R.DISABLED=1]="DISABLED",R[R.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(t=e.EditorResolution||(e.EditorResolution={}));var I;(function(R){R[R.API=0]="API",R[R.USER=1]="USER"})(I=e.EditorOpenContext||(e.EditorOpenContext={}));var y;(function(R){R[R.Center=0]="Center",R[R.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",R[R.NearTop=2]="NearTop",R[R.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(y=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(ve[180],we([0,1,159]),function(Z,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const t=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,I=/^-(\d{4})(\d{2})(\d{2})$/;function y(l){return l=l.trim(),l==="*"||t.test(l)}e.isValidVersionStr=y;function R(l){if(!y(l))return null;if(l=l.trim(),l==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let E=l.match(t);return E?{hasCaret:E[1]==="^",hasGreaterEquals:E[1]===">=",majorBase:E[2]==="x"?0:parseInt(E[2],10),majorMustEqual:E[2]!=="x",minorBase:E[4]==="x"?0:parseInt(E[4],10),minorMustEqual:E[4]!=="x",patchBase:E[6]==="x"?0:parseInt(E[6],10),patchMustEqual:E[6]!=="x",preRelease:E[8]||null}:null}e.parseVersion=R;function k(l){if(!l)return null;let E=l.majorBase,p=l.majorMustEqual,m=l.minorBase,b=l.minorMustEqual,F=l.patchBase,_=l.patchMustEqual;l.hasCaret&&(E===0||(b=!1),_=!1);let g=0;if(l.preRelease){const s=I.exec(l.preRelease);if(s){const[,d,n,S]=s;g=Date.UTC(Number(d),Number(n)-1,Number(S))}}return{majorBase:E,majorMustEqual:p,minorBase:m,minorMustEqual:b,patchBase:F,patchMustEqual:_,isMinimum:l.hasGreaterEquals,notBefore:g}}e.normalizeVersion=k;function D(l,E,p){let m;typeof l=="string"?m=k(R(l)):m=l;let b;E instanceof Date?b=E.getTime():typeof E=="string"&&(b=new Date(E).getTime());let F;if(typeof p=="string"?F=k(R(p)):F=p,!m||!F)return!1;let _=m.majorBase,g=m.minorBase,s=m.patchBase,d=F.majorBase,n=F.minorBase,S=F.patchBase,o=F.notBefore,i=F.majorMustEqual,r=F.minorMustEqual,c=F.patchMustEqual;return F.isMinimum?_>d?!0:_<d?!1:g>n?!0:g<n||b&&b<o?!1:s>=S:(_===1&&d===0&&(!i||!r||!c)&&(d=1,n=0,S=0,i=!0,r=!1,c=!1),_<d?!1:_>d?!i:g<n?!1:g>n?!r:s<S?!1:s>S?!c:!(b&&b<o))}e.isValidVersion=D;function P(l,E,p,m){return p.isBuiltin||typeof p.main=="undefined"?!0:C(l,E,p.engines.vscode,m)}e.isValidExtensionVersion=P;function L(l,E,p){return l==="*"||C(E,p,l)}e.isEngineValid=L;function C(l,E,p,m=[]){let b=k(R(p));if(!b)return m.push(h.localize(0,null,p)),!1;if(b.majorBase===0){if(!b.majorMustEqual||!b.minorMustEqual)return m.push(h.localize(1,null,p)),!1}else if(!b.majorMustEqual)return m.push(h.localize(2,null,p)),!1;return D(l,E,b)?!0:(m.push(h.localize(3,null,l,p)),!1)}}),define(ve[115],we([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class h{constructor(I,y=[],R=!1){this.ctor=I,this.staticArguments=y,this.supportsDelayedInstantiation=R}}e.SyncDescriptor=h}),define(ve[61],we([0,1,115]),function(Z,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const t=[];function I(R,k,D){k instanceof h.SyncDescriptor||(k=new h.SyncDescriptor(k,[],D)),t.push([R,k])}e.registerSingleton=I;function y(){return t}e.getSingletonServiceDescriptors=y}),define(ve[181],we([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class h{constructor(y){this.incoming=new Map,this.outgoing=new Map,this.data=y}}e.Node=h;class t{constructor(y){this._hashFn=y,this._nodes=new Map}roots(){const y=[];for(let R of this._nodes.values())R.outgoing.size===0&&y.push(R);return y}insertEdge(y,R){const k=this.lookupOrInsertNode(y),D=this.lookupOrInsertNode(R);k.outgoing.set(this._hashFn(R),D),D.incoming.set(this._hashFn(y),k)}removeNode(y){const R=this._hashFn(y);this._nodes.delete(R);for(let k of this._nodes.values())k.outgoing.delete(R),k.incoming.delete(R)}lookupOrInsertNode(y){const R=this._hashFn(y);let k=this._nodes.get(R);return k||(k=new h(y),this._nodes.set(R,k)),k}lookup(y){return this._nodes.get(this._hashFn(y))}isEmpty(){return this._nodes.size===0}toString(){let y=[];for(let[R,k]of this._nodes)y.push(`${R}, (incoming)[${[...k.incoming.keys()].join(", ")}], (outgoing)[${[...k.outgoing.keys()].join(",")}]`);return y.join(`
`)}findCycleSlow(){for(let[y,R]of this._nodes){const k=new Set([y]),D=this._findCycle(R,k);if(D)return D}}_findCycle(y,R){for(let[k,D]of y.outgoing){if(R.has(k))return[...R,k].join(" -> ");R.add(k);const P=this._findCycle(D,R);if(P)return P;R.delete(k)}}}e.Graph=t}),define(ve[4],we([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var h;(function(R){R.serviceIds=new Map,R.DI_TARGET="$di$target",R.DI_DEPENDENCIES="$di$dependencies";function k(D){return D[R.DI_DEPENDENCIES]||[]}R.getServiceDependencies=k})(h=e._util||(e._util={})),e.IInstantiationService=I("instantiationService");function t(R,k,D,P){k[h.DI_TARGET]===k?k[h.DI_DEPENDENCIES].push({id:R,index:D,optional:P}):(k[h.DI_DEPENDENCIES]=[{id:R,index:D,optional:P}],k[h.DI_TARGET]=k)}function I(R){if(h.serviceIds.has(R))return h.serviceIds.get(R);const k=function(D,P,L){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(k,D,L,!1)};return k.toString=()=>R,h.serviceIds.set(R,k),k}e.createDecorator=I;function y(R){return R}e.refineServiceDecorator=y}),define(ve[182],we([0,1,4]),function(Z,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,h.createDecorator)("modelService");function t(I){return!I.isTooLargeForSyncing()&&!I.isForSimpleWidget}e.shouldSynchronizeModel=t}),define(ve[183],we([0,1,3,6,82,182]),function(Z,e,h,t,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRegistry=void 0;function R(D){return typeof D=="string"?!1:Array.isArray(D)?D.every(R):!!D.exclusive}class k{constructor(){this._clock=0,this._entries=[],this._onDidChange=new h.Emitter}get onDidChange(){return this._onDidChange.event}register(P,L){let C={selector:P,provider:L,_score:-1,_time:this._clock++};return this._entries.push(C),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,t.toDisposable)(()=>{if(C){const l=this._entries.indexOf(C);l>=0&&(this._entries.splice(l,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),C=void 0)}})}has(P){return this.all(P).length>0}all(P){if(!P)return[];this._updateScores(P);const L=[];for(let C of this._entries)C._score>0&&L.push(C.provider);return L}ordered(P){const L=[];return this._orderedForEach(P,C=>L.push(C.provider)),L}orderedGroups(P){const L=[];let C,l;return this._orderedForEach(P,E=>{C&&l===E._score?C.push(E.provider):(l=E._score,C=[E.provider],L.push(C))}),L}_orderedForEach(P,L){if(!!P){this._updateScores(P);for(const C of this._entries)C._score>0&&L(C)}}_updateScores(P){const L={uri:P.uri.toString(),language:P.getLanguageId()};if(!(this._lastCandidate&&this._lastCandidate.language===L.language&&this._lastCandidate.uri===L.uri)){this._lastCandidate=L;for(let C of this._entries)if(C._score=(0,I.score)(C.selector,P.uri,P.getLanguageId(),(0,y.shouldSynchronizeModel)(P)),R(C.selector)&&C._score>0){for(let l of this._entries)l._score=0;C._score=1e3;break}this._entries.sort(k._compareByScoreAndTime)}}static _compareByScoreAndTime(P,L){return P._score<L._score?1:P._score>L._score?-1:P._time<L._time?1:P._time>L._time?-1:0}}e.LanguageFeatureRegistry=k}),define(ve[83],we([0,1,2,41,183,149,74]),function(Z,e,h,t,I,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.Command=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var k;(function(w){w[w.Null=0]="Null",w[w.PlainText=1]="PlainText"})(k=e.LanguageId||(e.LanguageId={}));var D;(function(w){w[w.NotSet=-1]="NotSet",w[w.None=0]="None",w[w.Italic=1]="Italic",w[w.Bold=2]="Bold",w[w.Underline=4]="Underline",w[w.Strikethrough=8]="Strikethrough"})(D=e.FontStyle||(e.FontStyle={}));var P;(function(w){w[w.None=0]="None",w[w.DefaultForeground=1]="DefaultForeground",w[w.DefaultBackground=2]="DefaultBackground"})(P=e.ColorId||(e.ColorId={}));var L;(function(w){w[w.Other=0]="Other",w[w.Comment=1]="Comment",w[w.String=2]="String",w[w.RegEx=3]="RegEx"})(L=e.StandardTokenType||(e.StandardTokenType={}));var C;(function(w){w[w.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",w[w.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",w[w.FONT_STYLE_MASK=15360]="FONT_STYLE_MASK",w[w.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",w[w.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",w[w.ITALIC_MASK=1024]="ITALIC_MASK",w[w.BOLD_MASK=2048]="BOLD_MASK",w[w.UNDERLINE_MASK=4096]="UNDERLINE_MASK",w[w.STRIKETHROUGH_MASK=8192]="STRIKETHROUGH_MASK",w[w.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",w[w.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",w[w.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",w[w.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",w[w.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",w[w.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",w[w.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",w[w.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",w[w.FONT_STYLE_OFFSET=10]="FONT_STYLE_OFFSET",w[w.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",w[w.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(C=e.MetadataConsts||(e.MetadataConsts={}));class l{static getLanguageId(A){return(A&255)>>>0}static getTokenType(A){return(A&768)>>>8}static getFontStyle(A){return(A&15360)>>>10}static getForeground(A){return(A&8372224)>>>14}static getBackground(A){return(A&4286578688)>>>23}static getClassNameFromMetadata(A){const M=this.getForeground(A);let T="mtk"+M;const O=this.getFontStyle(A);return O&1&&(T+=" mtki"),O&2&&(T+=" mtkb"),O&4&&(T+=" mtku"),O&8&&(T+=" mtks"),T}static getInlineStyleFromMetadata(A,M){const T=this.getForeground(A),O=this.getFontStyle(A);let U=`color: ${M[T]};`;O&1&&(U+="font-style: italic;"),O&2&&(U+="font-weight: bold;");let V="";return O&4&&(V+=" underline"),O&8&&(V+=" line-through"),V&&(U+=`text-decoration:${V};`),U}static getPresentationFromMetadata(A){const M=this.getForeground(A),T=this.getFontStyle(A);return{foreground:M,italic:Boolean(T&1),bold:Boolean(T&2),underline:Boolean(T&4),strikethrough:Boolean(T&8)}}}e.TokenMetadata=l;var E;(function(w){w[w.Method=0]="Method",w[w.Function=1]="Function",w[w.Constructor=2]="Constructor",w[w.Field=3]="Field",w[w.Variable=4]="Variable",w[w.Class=5]="Class",w[w.Struct=6]="Struct",w[w.Interface=7]="Interface",w[w.Module=8]="Module",w[w.Property=9]="Property",w[w.Event=10]="Event",w[w.Operator=11]="Operator",w[w.Unit=12]="Unit",w[w.Value=13]="Value",w[w.Constant=14]="Constant",w[w.Enum=15]="Enum",w[w.EnumMember=16]="EnumMember",w[w.Keyword=17]="Keyword",w[w.Text=18]="Text",w[w.Color=19]="Color",w[w.File=20]="File",w[w.Reference=21]="Reference",w[w.Customcolor=22]="Customcolor",w[w.Folder=23]="Folder",w[w.TypeParameter=24]="TypeParameter",w[w.User=25]="User",w[w.Issue=26]="Issue",w[w.Snippet=27]="Snippet"})(E=e.CompletionItemKind||(e.CompletionItemKind={}));var p;(function(w){const A=new Map;A.set(0,R.Codicon.symbolMethod),A.set(1,R.Codicon.symbolFunction),A.set(2,R.Codicon.symbolConstructor),A.set(3,R.Codicon.symbolField),A.set(4,R.Codicon.symbolVariable),A.set(5,R.Codicon.symbolClass),A.set(6,R.Codicon.symbolStruct),A.set(7,R.Codicon.symbolInterface),A.set(8,R.Codicon.symbolModule),A.set(9,R.Codicon.symbolProperty),A.set(10,R.Codicon.symbolEvent),A.set(11,R.Codicon.symbolOperator),A.set(12,R.Codicon.symbolUnit),A.set(13,R.Codicon.symbolValue),A.set(15,R.Codicon.symbolEnum),A.set(14,R.Codicon.symbolConstant),A.set(15,R.Codicon.symbolEnum),A.set(16,R.Codicon.symbolEnumMember),A.set(17,R.Codicon.symbolKeyword),A.set(27,R.Codicon.symbolSnippet),A.set(18,R.Codicon.symbolText),A.set(19,R.Codicon.symbolColor),A.set(20,R.Codicon.symbolFile),A.set(21,R.Codicon.symbolReference),A.set(22,R.Codicon.symbolCustomColor),A.set(23,R.Codicon.symbolFolder),A.set(24,R.Codicon.symbolTypeParameter),A.set(25,R.Codicon.account),A.set(26,R.Codicon.issues);function M(U){let V=A.get(U);return V||(console.info("No codicon found for CompletionItemKind "+U),V=R.Codicon.symbolProperty),V}w.toIcon=M;const T=new Map;T.set("method",0),T.set("function",1),T.set("constructor",2),T.set("field",3),T.set("variable",4),T.set("class",5),T.set("struct",6),T.set("interface",7),T.set("module",8),T.set("property",9),T.set("event",10),T.set("operator",11),T.set("unit",12),T.set("value",13),T.set("constant",14),T.set("enum",15),T.set("enum-member",16),T.set("enumMember",16),T.set("keyword",17),T.set("snippet",27),T.set("text",18),T.set("color",19),T.set("file",20),T.set("reference",21),T.set("customcolor",22),T.set("folder",23),T.set("type-parameter",24),T.set("typeParameter",24),T.set("account",25),T.set("issue",26);function O(U,V){let x=T.get(U);return typeof x=="undefined"&&!V&&(x=9),x}w.fromString=O})(p=e.CompletionItemKinds||(e.CompletionItemKinds={}));var m;(function(w){w[w.Deprecated=1]="Deprecated"})(m=e.CompletionItemTag||(e.CompletionItemTag={}));var b;(function(w){w[w.KeepWhitespace=1]="KeepWhitespace",w[w.InsertAsSnippet=4]="InsertAsSnippet"})(b=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var F;(function(w){w[w.Invoke=0]="Invoke",w[w.TriggerCharacter=1]="TriggerCharacter",w[w.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(F=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var _;(function(w){w[w.Automatic=0]="Automatic",w[w.Explicit=1]="Explicit"})(_=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var g;(function(w){w[w.Invoke=1]="Invoke",w[w.Auto=2]="Auto"})(g=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var s;(function(w){w[w.Invoke=1]="Invoke",w[w.TriggerCharacter=2]="TriggerCharacter",w[w.ContentChange=3]="ContentChange"})(s=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var d;(function(w){w[w.Text=0]="Text",w[w.Read=1]="Read",w[w.Write=2]="Write"})(d=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function n(w){return w&&h.URI.isUri(w.uri)&&t.Range.isIRange(w.range)&&(t.Range.isIRange(w.originSelectionRange)||t.Range.isIRange(w.targetSelectionRange))}e.isLocationLink=n;var S;(function(w){w[w.File=0]="File",w[w.Module=1]="Module",w[w.Namespace=2]="Namespace",w[w.Package=3]="Package",w[w.Class=4]="Class",w[w.Method=5]="Method",w[w.Property=6]="Property",w[w.Field=7]="Field",w[w.Constructor=8]="Constructor",w[w.Enum=9]="Enum",w[w.Interface=10]="Interface",w[w.Function=11]="Function",w[w.Variable=12]="Variable",w[w.Constant=13]="Constant",w[w.String=14]="String",w[w.Number=15]="Number",w[w.Boolean=16]="Boolean",w[w.Array=17]="Array",w[w.Object=18]="Object",w[w.Key=19]="Key",w[w.Null=20]="Null",w[w.EnumMember=21]="EnumMember",w[w.Struct=22]="Struct",w[w.Event=23]="Event",w[w.Operator=24]="Operator",w[w.TypeParameter=25]="TypeParameter"})(S=e.SymbolKind||(e.SymbolKind={}));var o;(function(w){w[w.Deprecated=1]="Deprecated"})(o=e.SymbolTag||(e.SymbolTag={}));var i;(function(w){const A=new Map;A.set(0,R.Codicon.symbolFile),A.set(1,R.Codicon.symbolModule),A.set(2,R.Codicon.symbolNamespace),A.set(3,R.Codicon.symbolPackage),A.set(4,R.Codicon.symbolClass),A.set(5,R.Codicon.symbolMethod),A.set(6,R.Codicon.symbolProperty),A.set(7,R.Codicon.symbolField),A.set(8,R.Codicon.symbolConstructor),A.set(9,R.Codicon.symbolEnum),A.set(10,R.Codicon.symbolInterface),A.set(11,R.Codicon.symbolFunction),A.set(12,R.Codicon.symbolVariable),A.set(13,R.Codicon.symbolConstant),A.set(14,R.Codicon.symbolString),A.set(15,R.Codicon.symbolNumber),A.set(16,R.Codicon.symbolBoolean),A.set(17,R.Codicon.symbolArray),A.set(18,R.Codicon.symbolObject),A.set(19,R.Codicon.symbolKey),A.set(20,R.Codicon.symbolNull),A.set(21,R.Codicon.symbolEnumMember),A.set(22,R.Codicon.symbolStruct),A.set(23,R.Codicon.symbolEvent),A.set(24,R.Codicon.symbolOperator),A.set(25,R.Codicon.symbolTypeParameter);function M(T){let O=A.get(T);return O||(console.info("No codicon found for SymbolKind "+T),O=R.Codicon.symbolProperty),O}w.toIcon=M})(i=e.SymbolKinds||(e.SymbolKinds={}));class r{constructor(A){this.value=A}}e.FoldingRangeKind=r,r.Comment=new r("comment"),r.Imports=new r("imports"),r.Region=new r("region");var c;(function(w){function A(M){return!M||typeof M!="object"?!1:typeof M.id=="string"&&typeof M.title=="string"}w.is=A})(c=e.Command||(e.Command={}));var a;(function(w){w[w.Collapsed=0]="Collapsed",w[w.Expanded=1]="Expanded"})(a=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var u;(function(w){w[w.Editing=0]="Editing",w[w.Preview=1]="Preview"})(u=e.CommentMode||(e.CommentMode={}));var f;(function(w){w[w.Other=0]="Other",w[w.Type=1]="Type",w[w.Parameter=2]="Parameter"})(f=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new I.LanguageFeatureRegistry,e.RenameProviderRegistry=new I.LanguageFeatureRegistry,e.CompletionProviderRegistry=new I.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new I.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new I.LanguageFeatureRegistry,e.HoverProviderRegistry=new I.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new I.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new I.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new I.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new I.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new I.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new I.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new I.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new I.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new I.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new I.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new I.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new I.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new I.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new I.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new I.LanguageFeatureRegistry,e.LinkProviderRegistry=new I.LanguageFeatureRegistry,e.ColorProviderRegistry=new I.LanguageFeatureRegistry,e.SelectionRangeRegistry=new I.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new I.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new I.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new I.LanguageFeatureRegistry,e.TokenizationRegistry=new y.TokenizationRegistry;var v;(function(w){w[w.None=0]="None",w[w.Option=1]="Option",w[w.Default=2]="Default",w[w.Preferred=3]="Preferred"})(v=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(ve[116],we([0,1,18,2,4]),function(Z,e,h,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,I.createDecorator)("configurationService");function y(b){return b&&typeof b=="object"&&(!b.overrideIdentifier||typeof b.overrideIdentifier=="string")&&(!b.resource||b.resource instanceof t.URI)}e.isConfigurationOverrides=y;function R(b){return b&&typeof b=="object"&&(!b.overrideIdentifiers||h.isArray(b.overrideIdentifiers))&&!b.overrideIdentifier&&(!b.resource||b.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=R;var k;(function(b){b[b.USER=1]="USER",b[b.USER_LOCAL=2]="USER_LOCAL",b[b.USER_REMOTE=3]="USER_REMOTE",b[b.WORKSPACE=4]="WORKSPACE",b[b.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",b[b.DEFAULT=6]="DEFAULT",b[b.MEMORY=7]="MEMORY"})(k=e.ConfigurationTarget||(e.ConfigurationTarget={}));function D(b){switch(b){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=D;function P(b,F){const _=Object.create(null);for(let g in b)L(_,g,b[g],F);return _}e.toValuesTree=P;function L(b,F,_,g){const s=F.split("."),d=s.pop();let n=b;for(let S=0;S<s.length;S++){let o=s[S],i=n[o];switch(typeof i){case"undefined":i=n[o]=Object.create(null);break;case"object":break;default:g(`Ignoring ${F} as ${s.slice(0,S+1).join(".")} is ${JSON.stringify(i)}`);return}n=i}if(typeof n=="object"&&n!==null)try{n[d]=_}catch{g(`Ignoring ${F} as ${s.join(".")} is ${JSON.stringify(n)}`)}else g(`Ignoring ${F} as ${s.join(".")} is ${JSON.stringify(n)}`)}e.addToValueTree=L;function C(b,F){const _=F.split(".");l(b,_)}e.removeFromValueTree=C;function l(b,F){const _=F.shift();if(F.length===0){delete b[_];return}if(Object.keys(b).indexOf(_)!==-1){const g=b[_];typeof g=="object"&&!Array.isArray(g)&&(l(g,F),Object.keys(g).length===0&&delete b[_])}}function E(b,F,_){function g(n,S){let o=n;for(const i of S){if(typeof o!="object"||o===null)return;o=o[i]}return o}const s=F.split("."),d=g(b,s);return typeof d=="undefined"?_:d}e.getConfigurationValue=E;function p(b,F,_){Object.keys(F).forEach(g=>{g!=="__proto__"&&(g in b?h.isObject(b[g])&&h.isObject(F[g])?p(b[g],F[g],_):_&&(b[g]=F[g]):b[g]=F[g])})}e.merge=p;function m(b,F,_){const g=b.inspect(F),s=b.inspect(_);return typeof g.userValue!="undefined"||typeof g.workspaceValue!="undefined"||typeof g.workspaceFolderValue!="undefined"?g.value:typeof s.userValue!="undefined"||typeof s.workspaceValue!="undefined"||typeof s.workspaceFolderValue!="undefined"?s.value:g.defaultValue}e.getMigratedSettingValue=m}),define(ve[62],we([0,1,11,8,4]),function(Z,e,h,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const y=new Map;y.set("false",!1),y.set("true",!0),y.set("isMac",h.isMacintosh),y.set("isLinux",h.isLinux),y.set("isWindows",h.isWindows),y.set("isWeb",h.isWeb),y.set("isMacNative",h.isMacintosh&&!h.isWeb),y.set("isEdge",h.isEdge),y.set("isFirefox",h.isFirefox),y.set("isChrome",h.isChrome),y.set("isSafari",h.isSafari);const R=Object.prototype.hasOwnProperty;var k;(function(M){M[M.False=0]="False",M[M.True=1]="True",M[M.Defined=2]="Defined",M[M.Not=3]="Not",M[M.Equals=4]="Equals",M[M.NotEquals=5]="NotEquals",M[M.And=6]="And",M[M.Regex=7]="Regex",M[M.NotRegex=8]="NotRegex",M[M.Or=9]="Or",M[M.In=10]="In",M[M.NotIn=11]="NotIn",M[M.Greater=12]="Greater",M[M.GreaterEquals=13]="GreaterEquals",M[M.Smaller=14]="Smaller",M[M.SmallerEquals=15]="SmallerEquals"})(k=e.ContextKeyExprType||(e.ContextKeyExprType={}));class D{static false(){return C.INSTANCE}static true(){return l.INSTANCE}static has(T){return E.create(T)}static equals(T,O){return p.create(T,O)}static notEquals(T,O){return F.create(T,O)}static regex(T,O){return o.create(T,O)}static in(T,O){return m.create(T,O)}static not(T){return _.create(T)}static and(...T){return c.create(T,null)}static or(...T){return a.create(T,null,!0)}static greater(T,O){return s.create(T,O)}static greaterEquals(T,O){return d.create(T,O)}static smaller(T,O){return n.create(T,O)}static smallerEquals(T,O){return S.create(T,O)}static deserialize(T,O=!1){if(!!T)return this._deserializeOrExpression(T,O)}static _deserializeOrExpression(T,O){let U=T.split("||");return a.create(U.map(V=>this._deserializeAndExpression(V,O)),null,!0)}static _deserializeAndExpression(T,O){let U=T.split("&&");return c.create(U.map(V=>this._deserializeOne(V,O)),null)}static _deserializeOne(T,O){if(T=T.trim(),T.indexOf("!=")>=0){let U=T.split("!=");return F.create(U[0].trim(),this._deserializeValue(U[1],O))}if(T.indexOf("==")>=0){let U=T.split("==");return p.create(U[0].trim(),this._deserializeValue(U[1],O))}if(T.indexOf("=~")>=0){let U=T.split("=~");return o.create(U[0].trim(),this._deserializeRegexValue(U[1],O))}if(T.indexOf(" in ")>=0){let U=T.split(" in ");return m.create(U[0].trim(),U[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(T)){const U=T.split(">=");return d.create(U[0].trim(),U[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(T)){const U=T.split(">");return s.create(U[0].trim(),U[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(T)){const U=T.split("<=");return S.create(U[0].trim(),U[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(T)){const U=T.split("<");return n.create(U[0].trim(),U[1].trim())}return/^\!\s*/.test(T)?_.create(T.substr(1).trim()):E.create(T)}static _deserializeValue(T,O){if(T=T.trim(),T==="true")return!0;if(T==="false")return!1;let U=/^'([^']*)'$/.exec(T);return U?U[1].trim():T}static _deserializeRegexValue(T,O){if((0,t.isFalsyOrWhitespace)(T)){if(O)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let U=T.indexOf("/"),V=T.lastIndexOf("/");if(U===V||U<0){if(O)throw new Error(`bad regexp-value '${T}', missing /-enclosure`);return console.warn(`bad regexp-value '${T}', missing /-enclosure`),null}let x=T.slice(U+1,V),N=T[V+1]==="i"?"i":"";try{return new RegExp(x,N)}catch($){if(O)throw new Error(`bad regexp-value '${T}', parse error: ${$}`);return console.warn(`bad regexp-value '${T}', parse error: ${$}`),null}}}e.ContextKeyExpr=D;function P(M,T){const O=M?M.substituteConstants():void 0,U=T?T.substituteConstants():void 0;return!O&&!U?!0:!O||!U?!1:O.equals(U)}e.expressionsAreEqualWithConstantSubstitution=P;function L(M,T){return M.cmp(T)}class C{constructor(){this.type=0}cmp(T){return this.type-T.type}equals(T){return T.type===this.type}substituteConstants(){return this}evaluate(T){return!1}serialize(){return"false"}keys(){return[]}map(T){return this}negate(){return l.INSTANCE}}e.ContextKeyFalseExpr=C,C.INSTANCE=new C;class l{constructor(){this.type=1}cmp(T){return this.type-T.type}equals(T){return T.type===this.type}substituteConstants(){return this}evaluate(T){return!0}serialize(){return"true"}keys(){return[]}map(T){return this}negate(){return C.INSTANCE}}e.ContextKeyTrueExpr=l,l.INSTANCE=new l;class E{constructor(T,O){this.key=T,this.negated=O,this.type=2}static create(T,O=null){const U=y.get(T);return typeof U=="boolean"?U?l.INSTANCE:C.INSTANCE:new E(T,O)}cmp(T){return T.type!==this.type?this.type-T.type:f(this.key,T.key)}equals(T){return T.type===this.type?this.key===T.key:!1}substituteConstants(){const T=y.get(this.key);return typeof T=="boolean"?T?l.INSTANCE:C.INSTANCE:this}evaluate(T){return!!T.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(T){return T.mapDefined(this.key)}negate(){return this.negated||(this.negated=_.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=E;class p{constructor(T,O,U){this.key=T,this.value=O,this.negated=U,this.type=4}static create(T,O,U=null){if(typeof O=="boolean")return O?E.create(T,U):_.create(T,U);const V=y.get(T);return typeof V=="boolean"?O===(V?"true":"false")?l.INSTANCE:C.INSTANCE:new p(T,O,U)}cmp(T){return T.type!==this.type?this.type-T.type:v(this.key,this.value,T.key,T.value)}equals(T){return T.type===this.type?this.key===T.key&&this.value===T.value:!1}substituteConstants(){const T=y.get(this.key);if(typeof T=="boolean"){const O=T?"true":"false";return this.value===O?l.INSTANCE:C.INSTANCE}return this}evaluate(T){return T.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(T){return T.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=F.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=p;class m{constructor(T,O){this.key=T,this.valueKey=O,this.type=10,this.negated=null}static create(T,O){return new m(T,O)}cmp(T){return T.type!==this.type?this.type-T.type:v(this.key,this.valueKey,T.key,T.valueKey)}equals(T){return T.type===this.type?this.key===T.key&&this.valueKey===T.valueKey:!1}substituteConstants(){return this}evaluate(T){const O=T.getValue(this.valueKey),U=T.getValue(this.key);return Array.isArray(O)?O.indexOf(U)>=0:typeof U=="string"&&typeof O=="object"&&O!==null?R.call(O,U):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(T){return T.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=b.create(this)),this.negated}}e.ContextKeyInExpr=m;class b{constructor(T){this._actual=T,this.type=11}static create(T){return new b(T)}cmp(T){return T.type!==this.type?this.type-T.type:this._actual.cmp(T._actual)}equals(T){return T.type===this.type?this._actual.equals(T._actual):!1}substituteConstants(){return this}evaluate(T){return!this._actual.evaluate(T)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(T){return new b(this._actual.map(T))}negate(){return this._actual}}e.ContextKeyNotInExpr=b;class F{constructor(T,O,U){this.key=T,this.value=O,this.negated=U,this.type=5}static create(T,O,U=null){if(typeof O=="boolean")return O?_.create(T,U):E.create(T,U);const V=y.get(T);return typeof V=="boolean"?O===(V?"true":"false")?C.INSTANCE:l.INSTANCE:new F(T,O,U)}cmp(T){return T.type!==this.type?this.type-T.type:v(this.key,this.value,T.key,T.value)}equals(T){return T.type===this.type?this.key===T.key&&this.value===T.value:!1}substituteConstants(){const T=y.get(this.key);if(typeof T=="boolean"){const O=T?"true":"false";return this.value===O?C.INSTANCE:l.INSTANCE}return this}evaluate(T){return T.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(T){return T.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=p.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=F;class _{constructor(T,O){this.key=T,this.negated=O,this.type=3}static create(T,O=null){const U=y.get(T);return typeof U=="boolean"?U?C.INSTANCE:l.INSTANCE:new _(T,O)}cmp(T){return T.type!==this.type?this.type-T.type:f(this.key,T.key)}equals(T){return T.type===this.type?this.key===T.key:!1}substituteConstants(){const T=y.get(this.key);return typeof T=="boolean"?T?C.INSTANCE:l.INSTANCE:this}evaluate(T){return!T.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(T){return T.mapNot(this.key)}negate(){return this.negated||(this.negated=E.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=_;function g(M,T){if(typeof M=="string"){const O=parseFloat(M);isNaN(O)||(M=O)}return typeof M=="string"||typeof M=="number"?T(M):C.INSTANCE}class s{constructor(T,O,U){this.key=T,this.value=O,this.negated=U,this.type=12}static create(T,O,U=null){return g(O,V=>new s(T,V,U))}cmp(T){return T.type!==this.type?this.type-T.type:v(this.key,this.value,T.key,T.value)}equals(T){return T.type===this.type?this.key===T.key&&this.value===T.value:!1}substituteConstants(){return this}evaluate(T){return typeof this.value=="string"?!1:parseFloat(T.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(T){return T.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=S.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=s;class d{constructor(T,O,U){this.key=T,this.value=O,this.negated=U,this.type=13}static create(T,O,U=null){return g(O,V=>new d(T,V,U))}cmp(T){return T.type!==this.type?this.type-T.type:v(this.key,this.value,T.key,T.value)}equals(T){return T.type===this.type?this.key===T.key&&this.value===T.value:!1}substituteConstants(){return this}evaluate(T){return typeof this.value=="string"?!1:parseFloat(T.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(T){return T.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=n.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=d;class n{constructor(T,O,U){this.key=T,this.value=O,this.negated=U,this.type=14}static create(T,O,U=null){return g(O,V=>new n(T,V,U))}cmp(T){return T.type!==this.type?this.type-T.type:v(this.key,this.value,T.key,T.value)}equals(T){return T.type===this.type?this.key===T.key&&this.value===T.value:!1}substituteConstants(){return this}evaluate(T){return typeof this.value=="string"?!1:parseFloat(T.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(T){return T.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=d.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=n;class S{constructor(T,O,U){this.key=T,this.value=O,this.negated=U,this.type=15}static create(T,O,U=null){return g(O,V=>new S(T,V,U))}cmp(T){return T.type!==this.type?this.type-T.type:v(this.key,this.value,T.key,T.value)}equals(T){return T.type===this.type?this.key===T.key&&this.value===T.value:!1}substituteConstants(){return this}evaluate(T){return typeof this.value=="string"?!1:parseFloat(T.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(T){return T.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=s.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=S;class o{constructor(T,O){this.key=T,this.regexp=O,this.type=7,this.negated=null}static create(T,O){return new o(T,O)}cmp(T){if(T.type!==this.type)return this.type-T.type;if(this.key<T.key)return-1;if(this.key>T.key)return 1;const O=this.regexp?this.regexp.source:"",U=T.regexp?T.regexp.source:"";return O<U?-1:O>U?1:0}equals(T){if(T.type===this.type){const O=this.regexp?this.regexp.source:"",U=T.regexp?T.regexp.source:"";return this.key===T.key&&O===U}return!1}substituteConstants(){return this}evaluate(T){let O=T.getValue(this.key);return this.regexp?this.regexp.test(O):!1}serialize(){const T=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${T}`}keys(){return[this.key]}map(T){return T.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=i.create(this)),this.negated}}e.ContextKeyRegexExpr=o;class i{constructor(T){this._actual=T,this.type=8}static create(T){return new i(T)}cmp(T){return T.type!==this.type?this.type-T.type:this._actual.cmp(T._actual)}equals(T){return T.type===this.type?this._actual.equals(T._actual):!1}substituteConstants(){return this}evaluate(T){return!this._actual.evaluate(T)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(T){return new i(this._actual.map(T))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=i;function r(M){let T=null;for(let O=0,U=M.length;O<U;O++){const V=M[O].substituteConstants();if(M[O]!==V&&T===null){T=[];for(let x=0;x<O;x++)T[x]=M[x]}T!==null&&(T[O]=V)}return T===null?M:T}class c{constructor(T,O){this.expr=T,this.negated=O,this.type=6}static create(T,O){return c._normalizeArr(T,O)}cmp(T){if(T.type!==this.type)return this.type-T.type;if(this.expr.length<T.expr.length)return-1;if(this.expr.length>T.expr.length)return 1;for(let O=0,U=this.expr.length;O<U;O++){const V=L(this.expr[O],T.expr[O]);if(V!==0)return V}return 0}equals(T){if(T.type===this.type){if(this.expr.length!==T.expr.length)return!1;for(let O=0,U=this.expr.length;O<U;O++)if(!this.expr[O].equals(T.expr[O]))return!1;return!0}return!1}substituteConstants(){const T=r(this.expr);return T===this.expr?this:c.create(T,this.negated)}evaluate(T){for(let O=0,U=this.expr.length;O<U;O++)if(!this.expr[O].evaluate(T))return!1;return!0}static _normalizeArr(T,O){const U=[];let V=!1;for(const x of T)if(!!x){if(x.type===1){V=!0;continue}if(x.type===0)return C.INSTANCE;if(x.type===6){U.push(...x.expr);continue}U.push(x)}if(U.length===0&&V)return l.INSTANCE;if(U.length!==0){if(U.length===1)return U[0];U.sort(L);for(let x=1;x<U.length;x++)U[x-1].equals(U[x])&&(U.splice(x,1),x--);if(U.length===1)return U[0];for(;U.length>1;){const x=U[U.length-1];if(x.type!==9)break;U.pop();const N=U.pop(),$=U.length===0,B=a.create(x.expr.map(z=>c.create([z,N],null)),null,$);B&&(U.push(B),U.sort(L))}return U.length===1?U[0]:new c(U,O)}}serialize(){return this.expr.map(T=>T.serialize()).join(" && ")}keys(){const T=[];for(let O of this.expr)T.push(...O.keys());return T}map(T){return new c(this.expr.map(O=>O.map(T)),null)}negate(){if(!this.negated){const T=[];for(let O of this.expr)T.push(O.negate());this.negated=a.create(T,this,!0)}return this.negated}}class a{constructor(T,O){this.expr=T,this.negated=O,this.type=9}static create(T,O,U){return a._normalizeArr(T,O,U)}cmp(T){if(T.type!==this.type)return this.type-T.type;if(this.expr.length<T.expr.length)return-1;if(this.expr.length>T.expr.length)return 1;for(let O=0,U=this.expr.length;O<U;O++){const V=L(this.expr[O],T.expr[O]);if(V!==0)return V}return 0}equals(T){if(T.type===this.type){if(this.expr.length!==T.expr.length)return!1;for(let O=0,U=this.expr.length;O<U;O++)if(!this.expr[O].equals(T.expr[O]))return!1;return!0}return!1}substituteConstants(){const T=r(this.expr);return T===this.expr?this:a.create(T,this.negated,!1)}evaluate(T){for(let O=0,U=this.expr.length;O<U;O++)if(this.expr[O].evaluate(T))return!0;return!1}static _normalizeArr(T,O,U){let V=[],x=!1;if(T){for(let N=0,$=T.length;N<$;N++){const B=T[N];if(!!B){if(B.type===0){x=!0;continue}if(B.type===1)return l.INSTANCE;if(B.type===9){V=V.concat(B.expr);continue}V.push(B)}}if(V.length===0&&x)return C.INSTANCE;V.sort(L)}if(V.length!==0){if(V.length===1)return V[0];for(let N=1;N<V.length;N++)V[N-1].equals(V[N])&&(V.splice(N,1),N--);if(V.length===1)return V[0];if(U){for(let N=0;N<V.length;N++)for(let $=N+1;$<V.length;$++)w(V[N],V[$])&&(V.splice($,1),$--);if(V.length===1)return V[0]}return new a(V,O)}}serialize(){return this.expr.map(T=>T.serialize()).join(" || ")}keys(){const T=[];for(let O of this.expr)T.push(...O.keys());return T}map(T){return new a(this.expr.map(O=>O.map(T)),null)}negate(){if(!this.negated){let T=[];for(let O of this.expr)T.push(O.negate());for(;T.length>1;){const O=T.shift(),U=T.shift(),V=[];for(const N of A(O))for(const $ of A(U))V.push(c.create([N,$],null));const x=T.length===0;T.unshift(a.create(V,null,x))}this.negated=T[0]}return this.negated}}class u extends E{constructor(T,O,U){super(T,null);this._defaultValue=O,typeof U=="object"?u._info.push({...U,key:T}):U!==!0&&u._info.push({key:T,description:U,type:O!=null?typeof O:void 0})}static all(){return u._info.values()}bindTo(T){return T.createKey(this.key,this._defaultValue)}getValue(T){return T.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(T){return p.create(this.key,T)}notEqualsTo(T){return F.create(this.key,T)}}e.RawContextKey=u,u._info=[],e.IContextKeyService=(0,I.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function f(M,T){return M<T?-1:M>T?1:0}function v(M,T,O,U){return M<O?-1:M>O?1:T<U?-1:T>U?1:0}function w(M,T){if(T.type===6&&M.type!==9&&M.type!==6){for(const V of T.expr)if(M.equals(V))return!0}const O=M.negate(),U=A(O).concat(A(T));U.sort(L);for(let V=0;V<U.length;V++){const N=U[V].negate();for(let $=V+1;$<U.length;$++){const B=U[$];if(N.equals(B))return!0}}return!1}e.implies=w;function A(M){return M.type===9?M.expr:[M]}}),define(ve[184],we([0,1,4]),function(Z,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,h.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,h.refineServiceDecorator)(e.IEnvironmentService)}),define(ve[185],we([0,1,4]),function(Z,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,h.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,h.createDecorator)("externalTerminal")}),define(ve[186],we([0,1,37,10,9,11,96,30,113,160,185]),function(Z,e,h,t,I,y,R,k,D,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const C=P.localize(0,null);class l{async getDefaultTerminalForPlatforms(){return{windows:E.getDefaultTerminalWindows(),linux:await m.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class E extends l{openTerminal(s,d){return this.spawnTerminal(h,s,D.getWindowsShell(),d)}spawnTerminal(s,d,n,S){const o=d.windowsExec||E.getDefaultTerminalWindows();S&&S[1]===":"&&(S=S[0].toUpperCase()+S.substr(1));const i=I.basename(o).toLowerCase();if(i==="cmder"||i==="cmder.exe")return s.spawn(o,S?[S]:void 0),Promise.resolve(void 0);const r=["/c","start","/wait"];return o.indexOf(" ")>=0&&r.push('""'),r.push(o),(i==="wt"||i==="wt.exe")&&r.push("-d ."),new Promise((c,a)=>{const u=b(process),f=s.spawn(n,r,{cwd:S,env:u});f.on("error",a),f.on("exit",()=>c())})}runInTerminal(s,d,n,S,o){const i="windowsExec"in o&&o.windowsExec?o.windowsExec:E.getDefaultTerminalWindows();return new Promise((r,c)=>{const a=`"${d} - ${C}"`,u=`""${n.join('" "')}" & pause"`,f=["/c","start",a,"/wait",i,"/c",u],v=Object.assign({},b(process),S);Object.keys(v).filter(M=>v[M]===null).forEach(M=>delete v[M]);const w={cwd:d,env:v,windowsVerbatimArguments:!0};h.spawn(E.CMD,f,w).on("error",M=>{c(F(M))}),r(void 0)})}static getDefaultTerminalWindows(){if(!E._DEFAULT_TERMINAL_WINDOWS){const s=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");E._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${s?"Sysnative":"System32"}\\cmd.exe`}return E._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=E,E.CMD="cmd.exe";class p extends l{openTerminal(s,d){return this.spawnTerminal(h,s,d)}runInTerminal(s,d,n,S,o){const i=o.osxExec||L.DEFAULT_TERMINAL_OSX;return new Promise((r,c)=>{if(i===L.DEFAULT_TERMINAL_OSX||i==="iTerm.app"){const a=i===L.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",f=[t.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${a}.scpt`,Z).fsPath,"-t",s||C,"-w",d];for(let A of n)f.push("-a"),f.push(A);if(S){const A=Object.assign({},b(process),S);for(let M in A){const T=A[M];T===null?(f.push("-u"),f.push(M)):(f.push("-e"),f.push(`${M}=${T}`))}}let v="";const w=h.spawn(p.OSASCRIPT,f);w.on("error",A=>{c(F(A))}),w.stderr.on("data",A=>{v+=A.toString()}),w.on("exit",A=>{if(A===0)r(void 0);else if(v){const M=v.split(`
`,1);c(new Error(M[0]))}else c(new Error(P.localize(1,null,a,A)))})}else c(new Error(P.localize(2,null,i)))})}spawnTerminal(s,d,n){const S=d.osxExec||L.DEFAULT_TERMINAL_OSX;return new Promise((o,i)=>{const r=["-a",S];n&&r.push(n);const c=b(process),a=s.spawn("/usr/bin/open",r,{cwd:n,env:c});a.on("error",i),a.on("exit",()=>o())})}}e.MacExternalTerminalService=p,p.OSASCRIPT="/usr/bin/osascript";class m extends l{openTerminal(s,d){return this.spawnTerminal(h,s,d)}runInTerminal(s,d,n,S,o){const i=o.linuxExec?Promise.resolve(o.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((r,c)=>{let a=[];i.then(u=>{u.indexOf("gnome-terminal")>=0?a.push("-x"):a.push("-e"),a.push("bash"),a.push("-c");const f=`${_(n)}; echo; read -p "${m.WAIT_MESSAGE}" -n1;`;a.push(`''${f}''`);const v=Object.assign({},b(process),S);Object.keys(v).filter(T=>v[T]===null).forEach(T=>delete v[T]);const w={cwd:d,env:v};let A="";const M=h.spawn(u,a,w);M.on("error",T=>{c(F(T))}),M.stderr.on("data",T=>{A+=T.toString()}),M.on("exit",T=>{if(T===0)r(void 0);else if(A){const O=A.split(`
`,1);c(new Error(O[0]))}else c(new Error(P.localize(4,null,u,T)))})})})}static async getDefaultTerminalLinuxReady(){if(!m._DEFAULT_TERMINAL_LINUX_READY)if(!y.isLinux)m._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const s=await k.Promises.exists("/etc/debian_version");m._DEFAULT_TERMINAL_LINUX_READY=new Promise(d=>{s?d("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?d("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?d("konsole"):process.env.COLORTERM?d(process.env.COLORTERM):process.env.TERM?d(process.env.TERM):d("xterm")})}return m._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(s,d,n){const S=d.linuxExec?Promise.resolve(d.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((o,i)=>{S.then(r=>{const c=b(process),a=s.spawn(r,[],{cwd:n,env:c});a.on("error",i),a.on("exit",()=>o())})})}}e.LinuxExternalTerminalService=m,m.WAIT_MESSAGE=P.localize(3,null);function b(g){const s={...g.env};return(0,R.sanitizeProcessEnvironment)(s),s}function F(g){return"errno"in g&&g.errno==="ENOENT"&&"path"in g&&typeof g.path=="string"?new Error(P.localize(5,null,g.path)):g}function _(g){let s="";for(let d of g)d.indexOf(" ")>=0?s+='"'+d+'"':s+=d,s+=" ";return s}}),define(ve[42],we([0,1,24,9,8,18,2,161,4]),function(Z,e,h,t,I,y,R,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,D.createDecorator)("fileService");function P(x){return x.create===!0}e.isFileOpenForWriteOptions=P;var L;(function(x){x[x.Unknown=0]="Unknown",x[x.File=1]="File",x[x.Directory=2]="Directory",x[x.SymbolicLink=64]="SymbolicLink"})(L=e.FileType||(e.FileType={}));var C;(function(x){x[x.Readonly=1]="Readonly"})(C=e.FilePermission||(e.FilePermission={}));var l;(function(x){x[x.FileReadWrite=2]="FileReadWrite",x[x.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",x[x.FileReadStream=16]="FileReadStream",x[x.FileFolderCopy=8]="FileFolderCopy",x[x.PathCaseSensitive=1024]="PathCaseSensitive",x[x.Readonly=2048]="Readonly",x[x.Trash=4096]="Trash",x[x.FileWriteUnlock=8192]="FileWriteUnlock",x[x.FileAtomicRead=16384]="FileAtomicRead"})(l=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function E(x){return!!(x.capabilities&2)}e.hasReadWriteCapability=E;function p(x){return!!(x.capabilities&8)}e.hasFileFolderCopyCapability=p;function m(x){return!!(x.capabilities&4)}e.hasOpenReadWriteCloseCapability=m;function b(x){return!!(x.capabilities&16)}e.hasFileReadStreamCapability=b;function F(x){return E(x)?!!(x.capabilities&16384):!1}e.hasFileAtomicReadCapability=F;var _;(function(x){x.FileExists="EntryExists",x.FileNotFound="EntryNotFound",x.FileNotADirectory="EntryNotADirectory",x.FileIsADirectory="EntryIsADirectory",x.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",x.FileTooLarge="EntryTooLarge",x.FileWriteLocked="EntryWriteLocked",x.NoPermissions="NoPermissions",x.Unavailable="Unavailable",x.Unknown="Unknown"})(_=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class g extends Error{constructor(N,$){super(N);this.code=$}}e.FileSystemProviderError=g;function s(x,N){const $=new g(x.toString(),N);return n($,N),$}e.createFileSystemProviderError=s;function d(x){return x||s((0,k.localize)(0,null),_.Unknown)}e.ensureFileSystemProviderError=d;function n(x,N){return x.name=N?`${N} (FileSystemError)`:"FileSystemError",x}e.markAsFileSystemProviderError=n;function S(x){if(!x)return _.Unknown;if(x instanceof g)return x.code;const N=/^(.+) \(FileSystemError\)$/.exec(x.name);if(!N)return _.Unknown;switch(N[1]){case _.FileExists:return _.FileExists;case _.FileIsADirectory:return _.FileIsADirectory;case _.FileNotADirectory:return _.FileNotADirectory;case _.FileNotFound:return _.FileNotFound;case _.FileExceedsMemoryLimit:return _.FileExceedsMemoryLimit;case _.FileTooLarge:return _.FileTooLarge;case _.FileWriteLocked:return _.FileWriteLocked;case _.NoPermissions:return _.NoPermissions;case _.Unavailable:return _.Unavailable}return _.Unknown}e.toFileSystemProviderErrorCode=S;function o(x){if(x instanceof f)return x.fileOperationResult;switch(S(x)){case _.FileNotFound:return 1;case _.FileIsADirectory:return 0;case _.FileNotADirectory:return 10;case _.FileWriteLocked:return 5;case _.NoPermissions:return 6;case _.FileExists:return 4;case _.FileExceedsMemoryLimit:return 9;case _.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=o;var i;(function(x){x[x.CREATE=0]="CREATE",x[x.DELETE=1]="DELETE",x[x.MOVE=2]="MOVE",x[x.COPY=3]="COPY"})(i=e.FileOperation||(e.FileOperation={}));class r{constructor(N,$,B){this.resource=N,this.operation=$,this.target=B}isOperation(N){return this.operation===N}}e.FileOperationEvent=r;var c;(function(x){x[x.UPDATED=0]="UPDATED",x[x.ADDED=1]="ADDED",x[x.DELETED=2]="DELETED"})(c=e.FileChangeType||(e.FileChangeType={}));class a{constructor(N,$){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=N;const B=new Map;for(const z of N){const W=B.get(z.type);switch(W?W.push([z.resource,z]):B.set(z.type,[[z.resource,z]]),z.type){case 1:this.rawAdded.push(z.resource);break;case 0:this.rawUpdated.push(z.resource);break;case 2:this.rawDeleted.push(z.resource);break}}for(const[z,W]of B)switch(z){case 1:this.added=h.TernarySearchTree.forUris(()=>$),this.added.fill(W);break;case 0:this.updated=h.TernarySearchTree.forUris(()=>$),this.updated.fill(W);break;case 2:this.deleted=h.TernarySearchTree.forUris(()=>$),this.deleted.fill(W);break}}contains(N,...$){return this.doContains(N,{includeChildren:!1},...$)}affects(N,...$){return this.doContains(N,{includeChildren:!0},...$)}doContains(N,$,...B){if(!N)return!1;const z=B.length>0;return!!((!z||B.includes(1))&&(this.added?.get(N)||$.includeChildren&&this.added?.findSuperstr(N))||(!z||B.includes(0))&&(this.updated?.get(N)||$.includeChildren&&this.updated?.findSuperstr(N))||(!z||B.includes(2))&&(this.deleted?.findSubstr(N)||$.includeChildren&&this.deleted?.findSuperstr(N)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=a;function u(x,N,$){return!x||!N||x===N||N.length>x.length?!1:(N.charAt(N.length-1)!==t.sep&&(N+=t.sep),$?(0,I.startsWithIgnoreCase)(x,N):x.indexOf(N)===0)}e.isParent=u;class f extends Error{constructor(N,$,B){super(N);this.fileOperationResult=$,this.options=B}}e.FileOperationError=f;class v extends f{constructor(N,$,B){super(N,2,B);this.stat=$}}e.NotModifiedSinceFileOperationError=v;var w;(function(x){x[x.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",x[x.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",x[x.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",x[x.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",x[x.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",x[x.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",x[x.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",x[x.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",x[x.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",x[x.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",x[x.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",x[x.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(w=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var A;(function(x){x[x.FILE=0]="FILE",x[x.FOLDER=1]="FOLDER",x[x.ROOT_FOLDER=2]="ROOT_FOLDER"})(A=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function M(x){if(!(typeof x.size!="number"||typeof x.mtime!="number"))return x.mtime.toString(29)+x.size.toString(31)}e.etag=M;async function T(x,N){if(!N.hasProvider(R.URI.from({scheme:x.scheme})))return new Promise($=>{const B=N.onDidChangeFileSystemProviderRegistrations(z=>{z.scheme===x.scheme&&z.added&&(B.dispose(),$())})})}e.whenProviderRegistered=T,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class O{static formatSize(N){return(0,y.isNumber)(N)||(N=0),N<O.KB?(0,k.localize)(1,null,N.toFixed(0)):N<O.MB?(0,k.localize)(2,null,(N/O.KB).toFixed(2)):N<O.GB?(0,k.localize)(3,null,(N/O.MB).toFixed(2)):N<O.TB?(0,k.localize)(4,null,(N/O.GB).toFixed(2)):(0,k.localize)(5,null,(N/O.TB).toFixed(2))}}e.ByteSize=O,O.KB=1024,O.MB=O.KB*O.KB,O.GB=O.MB*O.KB,O.TB=O.GB*O.KB;var U;(function(x){x[x.IA32=0]="IA32",x[x.OTHER=1]="OTHER"})(U=e.Arch||(e.Arch={}));function V(x){return{maxFileSize:x===0?300*O.MB:16*O.GB,maxHeapSize:x===0?700*O.MB:2*700*O.MB}}e.getPlatformLimits=V}),define(ve[84],we([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class h{constructor(...I){this._entries=new Map;for(let[y,R]of I)this.set(y,R)}set(I,y){const R=this._entries.get(I);return this._entries.set(I,y),R}has(I){return this._entries.has(I)}get(I){return this._entries.get(I)}}e.ServiceCollection=h}),define(ve[187],we([0,1,13,16,115,181,4,84]),function(Z,e,h,t,I,y,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const D=!1;class P extends Error{constructor(p){super("cyclic dependency between services");this.message=p.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${p.toString()}`}}class L{constructor(p=new k.ServiceCollection,m=!1,b){this._activeInstantiations=new Set,this._services=p,this._strict=m,this._parent=b,this._services.set(R.IInstantiationService,this)}createChild(p){return new L(p,this._strict,this)}invokeFunction(p,...m){let b=l.traceInvocation(p),F=!1;try{return p({get:g=>{if(F)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const s=this._getOrCreateServiceInstance(g,b);if(!s)throw new Error(`[invokeFunction] unknown service '${g}'`);return s}},...m)}finally{F=!0,b.stop()}}createInstance(p,...m){let b,F;return p instanceof I.SyncDescriptor?(b=l.traceCreation(p.ctor),F=this._createInstance(p.ctor,p.staticArguments.concat(m),b)):(b=l.traceCreation(p),F=this._createInstance(p,m,b)),b.stop(),F}_createInstance(p,m=[],b){let F=R._util.getServiceDependencies(p).sort((s,d)=>s.index-d.index),_=[];for(const s of F){let d=this._getOrCreateServiceInstance(s.id,b);if(!d&&this._strict&&!s.optional)throw new Error(`[createInstance] ${p.name} depends on UNKNOWN service ${s.id}.`);_.push(d)}let g=F.length>0?F[0].index:m.length;if(m.length!==g){console.warn(`[createInstance] First service dependency of ${p.name} at position ${g+1} conflicts with ${m.length} static arguments`);let s=g-m.length;s>0?m=m.concat(new Array(s)):m=m.slice(0,g)}return new p(...[...m,..._])}_setServiceInstance(p,m){if(this._services.get(p)instanceof I.SyncDescriptor)this._services.set(p,m);else if(this._parent)this._parent._setServiceInstance(p,m);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(p){let m=this._services.get(p);return!m&&this._parent?this._parent._getServiceInstanceOrDescriptor(p):m}_getOrCreateServiceInstance(p,m){let b=this._getServiceInstanceOrDescriptor(p);return b instanceof I.SyncDescriptor?this._safeCreateAndCacheServiceInstance(p,b,m.branch(p,!0)):(m.branch(p,!1),b)}_safeCreateAndCacheServiceInstance(p,m,b){if(this._activeInstantiations.has(p))throw new Error(`illegal state - RECURSIVELY instantiating service '${p}'`);this._activeInstantiations.add(p);try{return this._createAndCacheServiceInstance(p,m,b)}finally{this._activeInstantiations.delete(p)}}_createAndCacheServiceInstance(p,m,b){const F=new y.Graph(s=>s.id.toString());let _=0;const g=[{id:p,desc:m,_trace:b}];for(;g.length;){const s=g.pop();if(F.lookupOrInsertNode(s),_++>1e3)throw new P(F);for(let d of R._util.getServiceDependencies(s.desc.ctor)){let n=this._getServiceInstanceOrDescriptor(d.id);if(!n&&!d.optional&&console.warn(`[createInstance] ${p} depends on ${d.id} which is NOT registered.`),n instanceof I.SyncDescriptor){const S={id:d.id,desc:n,_trace:s._trace.branch(d.id,!0)};F.insertEdge(s,S),g.push(S)}}}for(;;){const s=F.roots();if(s.length===0){if(!F.isEmpty())throw new P(F);break}for(const{data:d}of s){if(this._getServiceInstanceOrDescriptor(d.id)instanceof I.SyncDescriptor){const S=this._createServiceInstanceWithOwner(d.id,d.desc.ctor,d.desc.staticArguments,d.desc.supportsDelayedInstantiation,d._trace);this._setServiceInstance(d.id,S)}F.removeNode(d)}}return this._getServiceInstanceOrDescriptor(p)}_createServiceInstanceWithOwner(p,m,b=[],F,_){if(this._services.get(p)instanceof I.SyncDescriptor)return this._createServiceInstance(m,b,F,_);if(this._parent)return this._parent._createServiceInstanceWithOwner(p,m,b,F,_);throw new Error(`illegalState - creating UNKNOWN service instance ${m.name}`)}_createServiceInstance(p,m=[],b,F){if(b){const _=new h.IdleValue(()=>this._createInstance(p,m,F));return new Proxy(Object.create(null),{get(g,s){if(s in g)return g[s];let d=_.value,n=d[s];return typeof n!="function"||(n=n.bind(d),g[s]=n),n},set(g,s,d){return _.value[s]=d,!0}})}else return this._createInstance(p,m,F)}}e.InstantiationService=L;var C;(function(E){E[E.Creation=0]="Creation",E[E.Invocation=1]="Invocation",E[E.Branch=2]="Branch"})(C||(C={}));class l{constructor(p,m){this.type=p,this.name=m,this._start=Date.now(),this._dep=[]}static traceInvocation(p){return D?new l(1,p.name||p.toString().substring(0,42).replace(/\n/g,"")):l._None}static traceCreation(p){return D?new l(0,p.name):l._None}branch(p,m){let b=new l(2,p.toString());return this._dep.push([p,m,b]),b}stop(){let p=Date.now()-this._start;l._totals+=p;let m=!1;function b(_,g){let s=[],d=new Array(_+1).join("	");for(const[n,S,o]of g._dep)if(S&&o){m=!0,s.push(`${d}CREATES -> ${n}`);let i=b(_+1,o);i&&s.push(i)}else s.push(`${d}uses -> ${n}`);return s.join(`
`)}let F=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${b(1,this)}`,`DONE, took ${p.toFixed(2)}ms (grand total ${l._totals.toFixed(2)}ms)`];(p>2||m)&&console.log(F.join(`
`))}}e.Trace=l,l._None=new class extends l{constructor(){super(-1,null)}stop(){}branch(){return this}},l._totals=0}),define(ve[12],we([0,1,49,3,6,11,4]),function(Z,e,h,t,I,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,R.createDecorator)("logService"),e.ILoggerService=(0,R.createDecorator)("loggerService");function k(){return new Date().toISOString()}var D;(function(S){S[S.Trace=0]="Trace",S[S.Debug=1]="Debug",S[S.Info=2]="Info",S[S.Warning=3]="Warning",S[S.Error=4]="Error",S[S.Critical=5]="Critical",S[S.Off=6]="Off"})(D=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=D.Info;function P(S,o,i){switch(o){case D.Trace:S.trace(i);break;case D.Debug:S.debug(i);break;case D.Info:S.info(i);break;case D.Warning:S.warn(i);break;case D.Error:S.error(i);break;case D.Critical:S.critical(i);break;default:throw new Error("Invalid log level")}}e.log=P;function L(S){let o="";for(let i=0;i<S.length;i++){let r=S[i];if(typeof r=="object")try{r=JSON.stringify(r)}catch{}o+=(i>0?" ":"")+r}return o}e.format=L;class C extends I.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new t.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(o){this.level!==o&&(this.level=o,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=C;class l extends C{constructor(o){super();this.logAlways=o}checkLogLevel(o){return this.logAlways||this.getLevel()<=o}trace(o,...i){this.checkLogLevel(D.Trace)&&this.log(D.Trace,L([o,...i]))}debug(o,...i){this.checkLogLevel(D.Debug)&&this.log(D.Debug,L([o,...i]))}info(o,...i){this.checkLogLevel(D.Info)&&this.log(D.Info,L([o,...i]))}warn(o,...i){this.checkLogLevel(D.Warning)&&this.log(D.Warning,L([o,...i]))}error(o,...i){if(this.checkLogLevel(D.Error))if(o instanceof Error){const r=Array.prototype.slice.call(arguments);r[0]=o.stack,this.log(D.Error,L(r))}else this.log(D.Error,L([o,...i]))}critical(o,...i){this.checkLogLevel(D.Critical)&&this.log(D.Critical,L([o,...i]))}flush(){}}e.AbstractMessageLogger=l;class E extends C{constructor(o=e.DEFAULT_LOG_LEVEL){super();this.setLevel(o),this.useColors=!y.isWindows}trace(o,...i){this.getLevel()<=D.Trace&&(this.useColors?console.log(`[90m[main ${k()}][0m`,o,...i):console.log(`[main ${k()}]`,o,...i))}debug(o,...i){this.getLevel()<=D.Debug&&(this.useColors?console.log(`[90m[main ${k()}][0m`,o,...i):console.log(`[main ${k()}]`,o,...i))}info(o,...i){this.getLevel()<=D.Info&&(this.useColors?console.log(`[90m[main ${k()}][0m`,o,...i):console.log(`[main ${k()}]`,o,...i))}warn(o,...i){this.getLevel()<=D.Warning&&(this.useColors?console.warn(`[93m[main ${k()}][0m`,o,...i):console.warn(`[main ${k()}]`,o,...i))}error(o,...i){this.getLevel()<=D.Error&&(this.useColors?console.error(`[91m[main ${k()}][0m`,o,...i):console.error(`[main ${k()}]`,o,...i))}critical(o,...i){this.getLevel()<=D.Critical&&(this.useColors?console.error(`[90m[main ${k()}][0m`,o,...i):console.error(`[main ${k()}]`,o,...i))}dispose(){}flush(){}}e.ConsoleMainLogger=E;class p extends C{constructor(o=e.DEFAULT_LOG_LEVEL){super();this.setLevel(o)}trace(o,...i){this.getLevel()<=D.Trace&&console.log("%cTRACE","color: #888",o,...i)}debug(o,...i){this.getLevel()<=D.Debug&&console.log("%cDEBUG","background: #eee; color: #888",o,...i)}info(o,...i){this.getLevel()<=D.Info&&console.log("%c INFO","color: #33f",o,...i)}warn(o,...i){this.getLevel()<=D.Warning&&console.log("%c WARN","color: #993",o,...i)}error(o,...i){this.getLevel()<=D.Error&&console.log("%c  ERR","color: #f33",o,...i)}critical(o,...i){this.getLevel()<=D.Critical&&console.log("%cCRITI","background: #f33; color: white",o,...i)}dispose(){}flush(){}}e.ConsoleLogger=p;class m extends C{constructor(o,i=e.DEFAULT_LOG_LEVEL){super();this.adapter=o,this.setLevel(i)}trace(o,...i){this.getLevel()<=D.Trace&&this.adapter.log(D.Trace,[this.extractMessage(o),...i])}debug(o,...i){this.getLevel()<=D.Debug&&this.adapter.log(D.Debug,[this.extractMessage(o),...i])}info(o,...i){this.getLevel()<=D.Info&&this.adapter.log(D.Info,[this.extractMessage(o),...i])}warn(o,...i){this.getLevel()<=D.Warning&&this.adapter.log(D.Warning,[this.extractMessage(o),...i])}error(o,...i){this.getLevel()<=D.Error&&this.adapter.log(D.Error,[this.extractMessage(o),...i])}critical(o,...i){this.getLevel()<=D.Critical&&this.adapter.log(D.Critical,[this.extractMessage(o),...i])}extractMessage(o){return typeof o=="string"?o:(0,h.toErrorMessage)(o,this.getLevel()<=D.Trace)}dispose(){}flush(){}}e.AdapterLogger=m;class b extends C{constructor(o){super();this.logServices=o,o.length&&this.setLevel(o[0].getLevel())}setLevel(o){for(const i of this.logServices)i.setLevel(o);super.setLevel(o)}trace(o,...i){for(const r of this.logServices)r.trace(o,...i)}debug(o,...i){for(const r of this.logServices)r.debug(o,...i)}info(o,...i){for(const r of this.logServices)r.info(o,...i)}warn(o,...i){for(const r of this.logServices)r.warn(o,...i)}error(o,...i){for(const r of this.logServices)r.error(o,...i)}critical(o,...i){for(const r of this.logServices)r.critical(o,...i)}flush(){for(const o of this.logServices)o.flush()}dispose(){for(const o of this.logServices)o.dispose()}}e.MultiplexLogService=b;class F extends I.Disposable{constructor(o){super();this.logger=o,this._register(o)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(o){this.logger.setLevel(o)}getLevel(){return this.logger.getLevel()}trace(o,...i){this.logger.trace(o,...i)}debug(o,...i){this.logger.debug(o,...i)}info(o,...i){this.logger.info(o,...i)}warn(o,...i){this.logger.warn(o,...i)}error(o,...i){this.logger.error(o,...i)}critical(o,...i){this.logger.critical(o,...i)}flush(){this.logger.flush()}}e.LogService=F;class _ extends I.Disposable{constructor(o,i){super();this.logLevel=o,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(r=>{this.logLevel=r,this.logLevelChangeableLoggers.forEach(c=>c.setLevel(r))}))}getLogger(o){return this.loggers.get(o.toString())}createLogger(o,i){let r=this.loggers.get(o.toString());return r||(r=this.doCreateLogger(o,i?.always?D.Trace:this.logLevel,i),this.loggers.set(o.toString(),r),i?.always||this.logLevelChangeableLoggers.push(r)),r}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(o=>o.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=_;class g{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(o){}getLevel(){return D.Info}trace(o,...i){}debug(o,...i){}info(o,...i){}warn(o,...i){}error(o,...i){}critical(o,...i){}dispose(){}flush(){}}e.NullLogService=g;function s(S){if(S.verbose)return D.Trace;if(typeof S.logLevel=="string"){const o=d(S.logLevel.toLowerCase());if(o!==void 0)return o}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=s;function d(S){switch(S){case"trace":return D.Trace;case"debug":return D.Debug;case"info":return D.Info;case"warn":return D.Warning;case"error":return D.Error;case"critical":return D.Critical;case"off":return D.Off}}e.parseLogLevel=d;function n(S){switch(S){case D.Trace:return"trace";case D.Debug:return"debug";case D.Info:return"info";case D.Warning:return"warn";case D.Error:return"error";case D.Critical:return"critical";case D.Off:return"off"}}e.LogLevelToString=n}),define(ve[188],we([0,1,42,12]),function(Z,e,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;async function I(k,D,P,L,C){try{const l=await new Promise((p,m)=>{Z(["spdlog"],p,m)});l.setFlushOn(t.LogLevel.Trace);const E=await l.createAsyncRotatingLogger(k,D,P,L);return C&&E.clearFormatters(),E}catch(l){console.error(l)}return null}function y(k,D,P){switch(D){case t.LogLevel.Trace:k.trace(P);break;case t.LogLevel.Debug:k.debug(P);break;case t.LogLevel.Info:k.info(P);break;case t.LogLevel.Warning:k.warn(P);break;case t.LogLevel.Error:k.error(P);break;case t.LogLevel.Critical:k.critical(P);break;default:throw new Error("Invalid log level")}}class R extends t.AbstractMessageLogger{constructor(D,P,L,C,l){super();this.buffer=[],this.setLevel(l),this._loggerCreationPromise=this._createSpdLogLogger(D,P,L,C),this._register(this.onDidChangeLogLevel(E=>{this._logger&&this._logger.setLevel(E)}))}async _createSpdLogLogger(D,P,L,C){const l=L?6:1,E=30/l*h.ByteSize.MB,p=await I(D,P,E,l,C);if(p){this._logger=p,this._logger.setLevel(this.getLevel());for(const{level:m,message:b}of this.buffer)y(this._logger,m,b);this.buffer=[]}}log(D,P){this._logger?y(this._logger,D,P):this.getLevel()<=D&&this.buffer.push({level:D,message:P})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=R}),define(ve[117],we([0,1,47,162,4]),function(Z,e,h,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var y;(function(D){D[D.Unnecessary=1]="Unnecessary",D[D.Deprecated=2]="Deprecated"})(y=e.MarkerTag||(e.MarkerTag={}));var R;(function(D){D[D.Hint=1]="Hint",D[D.Info=2]="Info",D[D.Warning=4]="Warning",D[D.Error=8]="Error"})(R=e.MarkerSeverity||(e.MarkerSeverity={})),function(D){function P(p,m){return m-p}D.compare=P;const L=Object.create(null);L[D.Error]=(0,t.localize)(0,null),L[D.Warning]=(0,t.localize)(1,null),L[D.Info]=(0,t.localize)(2,null);function C(p){return L[p]||""}D.toString=C;function l(p){switch(p){case h.default.Error:return D.Error;case h.default.Warning:return D.Warning;case h.default.Info:return D.Info;case h.default.Ignore:return D.Hint}}D.fromSeverity=l;function E(p){switch(p){case D.Error:return h.default.Error;case D.Warning:return h.default.Warning;case D.Info:return h.default.Info;case D.Hint:return h.default.Ignore}}D.toSeverity=E}(R=e.MarkerSeverity||(e.MarkerSeverity={}));var k;(function(D){const P="";function L(l){return C(l,!0)}D.makeKey=L;function C(l,E){let p=[P];return l.source?p.push(l.source.replace("\xA6","\\\xA6")):p.push(P),l.code?typeof l.code=="string"?p.push(l.code.replace("\xA6","\\\xA6")):p.push(l.code.value.replace("\xA6","\\\xA6")):p.push(P),l.severity!==void 0&&l.severity!==null?p.push(R.toString(l.severity)):p.push(P),l.message&&E?p.push(l.message.replace("\xA6","\\\xA6")):p.push(P),l.startLineNumber!==void 0&&l.startLineNumber!==null?p.push(l.startLineNumber.toString()):p.push(P),l.startColumn!==void 0&&l.startColumn!==null?p.push(l.startColumn.toString()):p.push(P),l.endLineNumber!==void 0&&l.endLineNumber!==null?p.push(l.endLineNumber.toString()):p.push(P),l.endColumn!==void 0&&l.endColumn!==null?p.push(l.endColumn.toString()):p.push(P),p.push(P),p.join("\xA6")}D.makeKeyOptionalMessage=C})(k=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,I.createDecorator)("markerService")}),define(ve[189],we([0,1,3,47,4]),function(Z,e,h,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=t.default,e.INotificationService=(0,I.createDecorator)("notificationService");var y;(function(P){P[P.WORKSPACE=0]="WORKSPACE",P[P.GLOBAL=1]="GLOBAL"})(y=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var R;(function(P){P[P.OFF=0]="OFF",P[P.SILENT=1]="SILENT",P[P.ERROR=2]="ERROR"})(R=e.NotificationsFilter||(e.NotificationsFilter={}));class k{constructor(){this.progress=new D,this.onDidClose=h.Event.None,this.onDidChangeVisibility=h.Event.None}updateSeverity(L){}updateMessage(L){}updateActions(L){}close(){}}e.NoOpNotification=k;class D{infinite(){}done(){}total(L){}worked(L){}}e.NoOpProgress=D}),define(ve[190],we([0,1,6,8,2,4]),function(Z,e,h,t,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesSomeScheme=e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,y.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return h.Disposable.None},registerValidator(){return h.Disposable.None},registerExternalUriResolver(){return h.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return h.Disposable.None},async open(){return!1},async resolveExternalUri(D){return{resolved:D,dispose(){}}}});function R(D,P){return I.URI.isUri(D)?(0,t.equalsIgnoreCase)(D.scheme,P):(0,t.startsWithIgnoreCase)(D,P+":")}e.matchesScheme=R;function k(D,...P){return P.some(L=>R(D,L))}e.matchesSomeScheme=k}),define(ve[191],we([0,1,10,11,40,23]),function(Z,e,h,t,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let R;if(typeof t.globals.vscode!="undefined"&&typeof t.globals.vscode.context!="undefined"){const k=t.globals.vscode.context.configuration();if(k)R=k.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof Z?.__$__nodeRequire=="function"){const k=(0,y.dirname)(h.FileAccess.asFileUri("",Z));R=Z.__$__nodeRequire((0,y.joinPath)(k,"product.json").fsPath);const D=Z.__$__nodeRequire((0,y.joinPath)(k,"package.json").fsPath);I.env.VSCODE_DEV&&Object.assign(R,{nameShort:`${R.nameShort} Dev`,nameLong:`${R.nameLong} Dev`,dataFolderName:`${R.dataFolderName}-dev`}),Object.assign(R,{version:D.version})}else R={},Object.keys(R).length===0&&Object.assign(R,{version:"1.64.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=R});var ze=this&&this.__param||function(Z,e){return function(h,t){e(h,t,Z)}};define(ve[118],we([0,1,13,21,6,4]),function(Z,e,h,t,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,y.createDecorator)("progressService");var R;(function(L){L[L.Explorer=1]="Explorer",L[L.Scm=3]="Scm",L[L.Extensions=5]="Extensions",L[L.Window=10]="Window",L[L.Notification=15]="Notification",L[L.Dialog=20]="Dialog"})(R=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class k{constructor(C){this.callback=C}get value(){return this._value}report(C){this._value=C,this.callback(this._value)}}e.Progress=k,k.None=Object.freeze({report(){}});let D=class extends I.Disposable{constructor(C,l){super();this.deferred=new h.DeferredPromise,l.withProgress(C,E=>(this.reporter=E,this.lastStep&&E.report(this.lastStep),this.deferred.p)),this._register((0,I.toDisposable)(()=>this.deferred.complete()))}report(C){this.reporter?this.reporter.report(C):this.lastStep=C}};D=je([ze(1,e.IProgressService)],D),e.UnmanagedProgress=D;class P extends I.Disposable{constructor(C){super();this.progressIndicator=C,this.currentOperationId=0,this.currentOperationDisposables=this._register(new I.DisposableStore)}start(C){this.stop();const l=++this.currentOperationId,E=new t.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{l===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},C),this.currentOperationDisposables.add((0,I.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,I.toDisposable)(()=>E.cancel())),this.currentOperationDisposables.add((0,I.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:l,token:E.token,stop:()=>this.doStop(l),isCurrent:()=>this.currentOperationId===l}}stop(){this.doStop(this.currentOperationId)}doStop(C){this.currentOperationId===C&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=P,e.IEditorProgressService=(0,y.createDecorator)("editorProgressService")}),define(ve[50],we([0,1,55,18]),function(Z,e,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class I{constructor(){this.data=new Map}add(R,k){h.ok(t.isString(R)),h.ok(t.isObject(k)),h.ok(!this.data.has(R),"There is already an extension with this id"),this.data.set(R,k)}knows(R){return this.data.has(R)}as(R){return this.data.get(R)||null}}e.Registry=new I}),define(ve[192],we([0,1,3,50]),function(Z,e,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function I(k){return k.length>0&&k.charAt(k.length-1)==="#"?k.substring(0,k.length-1):k}class y{constructor(){this._onDidChangeSchema=new h.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(D,P){this.schemasById[I(D)]=P,this._onDidChangeSchema.fire(D)}notifySchemaChanged(D){this._onDidChangeSchema.fire(D)}getSchemaContributions(){return{schemas:this.schemasById}}}const R=new y;t.Registry.add(e.Extensions.JSONContribution,R)}),define(ve[119],we([0,1,17,3,18,157,192,50]),function(Z,e,h,t,I,y,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var D;(function(s){s.Multiline="multilineText",s.Singleline="singlelineText"})(D=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var P;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.MACHINE=2]="MACHINE",s[s.WINDOW=3]="WINDOW",s[s.RESOURCE=4]="RESOURCE",s[s.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",s[s.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(P=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const L=k.Registry.as(R.Extensions.JSONContribution);class C{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new t.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new t.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:y.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},L.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(d,n=!0){this.registerConfigurations([d],n)}registerConfigurations(d,n=!0){const S=this.doRegisterConfigurations(d,n);L.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:S})}deregisterConfigurations(d){const n=this.doDeregisterConfigurations(d);L.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n})}updateConfigurations({add:d,remove:n}){const S=[];S.push(...this.doDeregisterConfigurations(n)),S.push(...this.doRegisterConfigurations(d,!1)),L.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,h.distinct)(S)})}registerDefaultConfigurations(d){const n=[],S=[];for(const{overrides:o,source:i}of d)for(const r in o)if(n.push(r),e.OVERRIDE_PROPERTY_REGEX.test(r)){const c={...this.configurationDefaultsOverrides.get(r)?.value||{},...o[r]};this.configurationDefaultsOverrides.set(r,{source:i,value:c});const a={type:"object",default:c,description:y.localize(1,null,r),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:c,source:I.isString(i)?void 0:i};S.push(...p(r)),this.configurationProperties[r]=a,this.defaultLanguageConfigurationOverridesNode.properties[r]=a}else{this.configurationDefaultsOverrides.set(r,{value:o[r],source:i});const c=this.configurationProperties[r];c&&(this.updatePropertyDefaultValue(r,c),this.updateSchema(r,c))}this.registerOverrideIdentifiers(S),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n,defaultsOverrides:!0})}deregisterDefaultConfigurations(d){const n=[];for(const{overrides:S,source:o}of d)for(const i in S){const r=this.configurationDefaultsOverrides.get(i),c=I.isString(o)?o:o?.id,a=I.isString(r?.source)?r?.source:r?.source?.id;if(c===a)if(n.push(i),this.configurationDefaultsOverrides.delete(i),e.OVERRIDE_PROPERTY_REGEX.test(i))delete this.configurationProperties[i],delete this.defaultLanguageConfigurationOverridesNode.properties[i];else{const u=this.configurationProperties[i];u&&(this.updatePropertyDefaultValue(i,u),this.updateSchema(i,u))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...d){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(d){for(const n of d)this.overrideIdentifiers.add(n);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(d,n){const S=[];return d.forEach(o=>{S.push(...this.validateAndRegisterProperties(o,n,o.extensionInfo,o.restrictedProperties)),this.configurationContributors.push(o),this.registerJSONConfiguration(o)}),S}doDeregisterConfigurations(d){const n=[],S=o=>{if(o.properties)for(const i in o.properties)n.push(i),delete this.configurationProperties[i],this.removeFromSchema(i,o.properties[i]);o.allOf&&o.allOf.forEach(i=>S(i))};for(const o of d){S(o);const i=this.configurationContributors.indexOf(o);i!==-1&&this.configurationContributors.splice(i,1)}return n}validateAndRegisterProperties(d,n=!0,S,o,i=3){i=I.isUndefinedOrNull(d.scope)?i:d.scope;let r=[],c=d.properties;if(c)for(let u in c){if(n&&_(u)){delete c[u];continue}const f=c[u];if(f.source=S,f.defaultDefaultValue=c[u].default,this.updatePropertyDefaultValue(u,f),e.OVERRIDE_PROPERTY_REGEX.test(u)?f.scope=void 0:(f.scope=I.isUndefinedOrNull(f.scope)?i:f.scope,f.restricted=I.isUndefinedOrNull(f.restricted)?!!o?.includes(u):f.restricted),c[u].hasOwnProperty("included")&&!c[u].included){this.excludedConfigurationProperties[u]=c[u],delete c[u];continue}else this.configurationProperties[u]=c[u];!c[u].deprecationMessage&&c[u].markdownDeprecationMessage&&(c[u].deprecationMessage=c[u].markdownDeprecationMessage),r.push(u)}let a=d.allOf;if(a)for(let u of a)r.push(...this.validateAndRegisterProperties(u,n,S,o,i));return r}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(d){const n=S=>{let o=S.properties;if(o)for(const r in o)this.updateSchema(r,o[r]);let i=S.allOf;i&&i.forEach(n)};n(d)}updateSchema(d,n){switch(e.allSettings.properties[d]=n,n.scope){case 1:e.applicationSettings.properties[d]=n;break;case 2:e.machineSettings.properties[d]=n;break;case 6:e.machineOverridableSettings.properties[d]=n;break;case 3:e.windowSettings.properties[d]=n;break;case 4:e.resourceSettings.properties[d]=n;break;case 5:e.resourceSettings.properties[d]=n,this.resourceLanguageSettingsSchema.properties[d]=n;break}}removeFromSchema(d,n){switch(delete e.allSettings.properties[d],n.scope){case 1:delete e.applicationSettings.properties[d];break;case 2:delete e.machineSettings.properties[d];break;case 6:delete e.machineOverridableSettings.properties[d];break;case 3:delete e.windowSettings.properties[d];break;case 4:case 5:delete e.resourceSettings.properties[d],delete this.resourceLanguageSettingsSchema.properties[d];break}}updateOverridePropertyPatternKey(){for(const d of this.overrideIdentifiers.values()){const n=`[${d}]`,S={type:"object",description:y.localize(2,null),errorMessage:y.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(n,S),e.allSettings.properties[n]=S,e.applicationSettings.properties[n]=S,e.machineSettings.properties[n]=S,e.machineOverridableSettings.properties[n]=S,e.windowSettings.properties[n]=S,e.resourceSettings.properties[n]=S}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const d={type:"object",description:y.localize(4,null),errorMessage:y.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=d,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=d,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=d,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=d,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=d,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=d,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(d,n){const S=this.configurationDefaultsOverrides.get(d);let o=S?.value,i=S?.source;I.isUndefined(o)&&(o=n.defaultDefaultValue,i=void 0),I.isUndefined(o)&&(o=b(n.type)),n.default=o,n.defaultValueSource=i}}const l="\\[([^\\]]+)\\]",E=new RegExp(l,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${l})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function p(s){const d=[];if(e.OVERRIDE_PROPERTY_REGEX.test(s)){let n=E.exec(s);for(;n?.length;){const S=n[1].trim();S&&d.push(S),n=E.exec(s)}}return(0,h.distinct)(d)}e.overrideIdentifiersFromKey=p;function m(s){return s.reduce((d,n)=>`${d}[${n}]`,"")}e.keyFromOverrideIdentifiers=m;function b(s){switch(Array.isArray(s)?s[0]:s){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=b;const F=new C;k.Registry.add(e.Extensions.Configuration,F);function _(s){return s.trim()?e.OVERRIDE_PROPERTY_REGEX.test(s)?y.localize(7,null,s):F.getConfigurationProperties()[s]!==void 0?y.localize(8,null,s):null:y.localize(6,null)}e.validateProperty=_;function g(){const s=[],d=F.getConfigurationProperties();for(const n of Object.keys(d))s.push([n,d[n].scope]);return s.push(["launch",4]),s.push(["task",4]),s}e.getScopes=g}),define(ve[193],we([0,1,17,3,57,6,24,25,18,2,116,119,50]),function(Z,e,h,t,I,y,R,k,D,P,L,C,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class E{constructor(o={},i=[],r=[]){this._contents=o,this._keys=i,this._overrides=r,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(o){return o?(0,L.getConfigurationValue)(this.contents,o):this.contents}getOverrideValue(o,i){const r=this.getContentsForOverrideIdentifer(i);return r?o?(0,L.getConfigurationValue)(r,o):r:void 0}getKeysForOverrideIdentifier(o){const i=[];for(const r of this.overrides)r.identifiers.includes(o)&&i.push(...r.keys);return h.distinct(i)}getAllOverrideIdentifiers(){const o=[];for(const i of this.overrides)o.push(...i.identifiers);return h.distinct(o)}override(o){let i=this.overrideConfigurations.get(o);return i||(i=this.createOverrideConfigurationModel(o),this.overrideConfigurations.set(o,i)),i}merge(...o){const i=k.deepClone(this.contents),r=k.deepClone(this.overrides),c=[...this.keys];for(const a of o){this.mergeContents(i,a.contents);for(const u of a.overrides){const[f]=r.filter(v=>h.equals(v.identifiers,u.identifiers));f?(this.mergeContents(f.contents,u.contents),f.keys.push(...u.keys),f.keys=h.distinct(f.keys)):r.push(k.deepClone(u))}for(const u of a.keys)c.indexOf(u)===-1&&c.push(u)}return new E(i,c,r)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(o){const i=this.getContentsForOverrideIdentifer(o);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let r={};for(const c of h.distinct([...Object.keys(this.contents),...Object.keys(i)])){let a=this.contents[c],u=i[c];u&&(typeof a=="object"&&typeof u=="object"?(a=k.deepClone(a),this.mergeContents(a,u)):a=u),r[c]=a}return new E(r,this.keys,this.overrides)}mergeContents(o,i){for(const r of Object.keys(i)){if(r in o&&D.isObject(o[r])&&D.isObject(i[r])){this.mergeContents(o[r],i[r]);continue}o[r]=k.deepClone(i[r])}}checkAndFreeze(o){return this.isFrozen&&!Object.isFrozen(o)?k.deepFreeze(o):o}getContentsForOverrideIdentifer(o){let i=null,r=null;const c=a=>{a&&(r?this.mergeContents(r,a):r=k.deepClone(a))};for(const a of this.overrides)h.equals(a.identifiers,[o])?i=a.contents:a.identifiers.includes(o)&&c(a.contents);return c(i),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(o,i){this.addKey(o),(0,L.addToValueTree)(this.contents,o,i,r=>{throw new Error(r)})}removeValue(o){this.removeKey(o)&&(0,L.removeFromValueTree)(this.contents,o)}addKey(o){let i=this.keys.length;for(let r=0;r<i;r++)o.indexOf(this.keys[r])===0&&(i=r);this.keys.splice(i,1,o)}removeKey(o){let i=this.keys.indexOf(o);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=E;class p extends E{constructor(o={}){const i=l.Registry.as(C.Extensions.Configuration).getConfigurationProperties(),r=Object.keys(i),c=Object.create(null),a=[];for(const u in i){const f=o[u],v=f!==void 0?f:i[u].default;(0,L.addToValueTree)(c,u,v,w=>console.error(`Conflict in default settings: ${w}`))}for(const u of Object.keys(c))C.OVERRIDE_PROPERTY_REGEX.test(u)&&a.push({identifiers:(0,C.overrideIdentifiersFromKey)(u),keys:Object.keys(c[u]),contents:(0,L.toValuesTree)(c[u],f=>console.error(`Conflict in default settings file: ${f}`))});super(c,r,a)}}e.DefaultConfigurationModel=p;class m{constructor(o){this._name=o,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new E}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(o,i){if(!D.isUndefinedOrNull(o)){const r=this.doParseContent(o);this.parseRaw(r,i)}}reparse(o){this._raw&&this.parseRaw(this._raw,o)}parseRaw(o,i){this._raw=o;const{contents:r,keys:c,overrides:a,restricted:u}=this.doParseRaw(o,i);this._configurationModel=new E(r,c,a),this._restrictedConfigurations=u||[]}doParseContent(o){let i={},r=null,c=[],a=[],u=[];function f(w){Array.isArray(c)?c.push(w):r!==null&&(c[r]=w)}let v={onObjectBegin:()=>{let w={};f(w),a.push(c),c=w,r=null},onObjectProperty:w=>{r=w},onObjectEnd:()=>{c=a.pop()},onArrayBegin:()=>{let w=[];f(w),a.push(c),c=w,r=null},onArrayEnd:()=>{c=a.pop()},onLiteralValue:f,onError:(w,A,M)=>{u.push({error:w,offset:A,length:M})}};if(o)try{I.visit(o,v),i=c[0]||{}}catch(w){console.error(`Error while parsing settings file ${this._name}: ${w}`),this._parseErrors=[w]}return i}doParseRaw(o,i){const r=l.Registry.as(C.Extensions.Configuration).getConfigurationProperties(),c=this.filter(o,r,!0,i);o=c.raw;const a=(0,L.toValuesTree)(o,v=>console.error(`Conflict in settings file ${this._name}: ${v}`)),u=Object.keys(o),f=this.toOverrides(o,v=>console.error(`Conflict in settings file ${this._name}: ${v}`));return{contents:a,keys:u,overrides:f,restricted:c.restricted}}filter(o,i,r,c){if(!c?.scopes&&!c?.skipRestricted)return{raw:o,restricted:[]};const a={},u=[];for(let f in o)if(C.OVERRIDE_PROPERTY_REGEX.test(f)&&r){const v=this.filter(o[f],i,!1,c);a[f]=v.raw,u.push(...v.restricted)}else{const v=i[f],w=v?typeof v.scope!="undefined"?v.scope:3:void 0;v?.restricted&&u.push(f),(w===void 0||c.scopes===void 0||c.scopes.includes(w))&&(c.skipRestricted&&v?.restricted||(a[f]=o[f]))}return{raw:a,restricted:u}}toOverrides(o,i){const r=[];for(const c of Object.keys(o))if(C.OVERRIDE_PROPERTY_REGEX.test(c)){const a={};for(const u in o[c])a[u]=o[c][u];r.push({identifiers:(0,C.overrideIdentifiersFromKey)(c),keys:Object.keys(a),contents:(0,L.toValuesTree)(a,i)})}return r}}e.ConfigurationModelParser=m;class b extends y.Disposable{constructor(o,i,r,c){super();this.userSettingsResource=o,this.scopes=i,this.fileService=c,this._onDidChange=this._register(new t.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new m(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(t.Event.filter(this.fileService.onDidFilesChange,a=>a.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const o=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(o.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new E}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=b;class F{constructor(o,i,r=new E,c=new E,a=new R.ResourceMap,u=new E,f=new R.ResourceMap,v=!0){this._defaultConfiguration=o,this._localUserConfiguration=i,this._remoteUserConfiguration=r,this._workspaceConfiguration=c,this._folderConfigurations=a,this._memoryConfiguration=u,this._memoryConfigurationByResource=f,this._freeze=v,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new R.ResourceMap,this._userConfiguration=null}getValue(o,i,r){return this.getConsolidateConfigurationModel(i,r).getValue(o)}updateValue(o,i,r={}){let c;r.resource?(c=this._memoryConfigurationByResource.get(r.resource),c||(c=new E,this._memoryConfigurationByResource.set(r.resource,c))):c=this._memoryConfiguration,i===void 0?c.removeValue(o):c.setValue(o,i),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(o,i,r){const c=this.getConsolidateConfigurationModel(i,r),a=this.getFolderConfigurationModelForResource(i.resource,r),u=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,f=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(o):this._defaultConfiguration.freeze().getValue(o),v=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(o):this.userConfiguration.freeze().getValue(o),w=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(o):this.localUserConfiguration.freeze().getValue(o),A=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(o):this.remoteUserConfiguration.freeze().getValue(o),M=r?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(o):this._workspaceConfiguration.freeze().getValue(o):void 0,T=a?i.overrideIdentifier?a.freeze().override(i.overrideIdentifier).getValue(o):a.freeze().getValue(o):void 0,O=i.overrideIdentifier?u.override(i.overrideIdentifier).getValue(o):u.getValue(o),U=c.getValue(o),V=h.distinct(h.flatten(c.overrides.map(x=>x.identifiers))).filter(x=>c.getOverrideValue(o,x)!==void 0);return{defaultValue:f,userValue:v,userLocalValue:w,userRemoteValue:A,workspaceValue:M,workspaceFolderValue:T,memoryValue:O,value:U,default:f!==void 0?{value:this._defaultConfiguration.freeze().getValue(o),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(o,i.overrideIdentifier):void 0}:void 0,user:v!==void 0?{value:this.userConfiguration.freeze().getValue(o),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(o,i.overrideIdentifier):void 0}:void 0,userLocal:w!==void 0?{value:this.localUserConfiguration.freeze().getValue(o),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(o,i.overrideIdentifier):void 0}:void 0,userRemote:A!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(o),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(o,i.overrideIdentifier):void 0}:void 0,workspace:M!==void 0?{value:this._workspaceConfiguration.freeze().getValue(o),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(o,i.overrideIdentifier):void 0}:void 0,workspaceFolder:T!==void 0?{value:a?.freeze().getValue(o),override:i.overrideIdentifier?a?.freeze().getOverrideValue(o,i.overrideIdentifier):void 0}:void 0,memory:O!==void 0?{value:u.getValue(o),override:i.overrideIdentifier?u.getOverrideValue(o,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:V.length?V:void 0}}keys(o){const i=this.getFolderConfigurationModelForResource(void 0,o);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(o){this._defaultConfiguration=o,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(o){this._localUserConfiguration=o,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(o){this._remoteUserConfiguration=o,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(o){this._workspaceConfiguration=o,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(o,i){this._folderConfigurations.set(o,i),this._foldersConsolidatedConfigurations.delete(o)}deleteFolderConfiguration(o){this.folderConfigurations.delete(o),this._foldersConsolidatedConfigurations.delete(o)}compareAndUpdateDefaultConfiguration(o,i){const r=[];if(!i){const{added:c,updated:a,removed:u}=d(this._defaultConfiguration,o);i=[...c,...a,...u]}for(const c of i)for(const a of(0,C.overrideIdentifiersFromKey)(c)){const u=this._defaultConfiguration.getKeysForOverrideIdentifier(a),f=o.getKeysForOverrideIdentifier(a),v=[...f.filter(w=>u.indexOf(w)===-1),...u.filter(w=>f.indexOf(w)===-1),...u.filter(w=>!k.equals(this._defaultConfiguration.override(a).getValue(w),o.override(a).getValue(w)))];r.push([a,v])}return this.updateDefaultConfiguration(o),{keys:i,overrides:r}}compareAndUpdateLocalUserConfiguration(o){const{added:i,updated:r,removed:c,overrides:a}=d(this.localUserConfiguration,o),u=[...i,...r,...c];return u.length&&this.updateLocalUserConfiguration(o),{keys:u,overrides:a}}compareAndUpdateRemoteUserConfiguration(o){const{added:i,updated:r,removed:c,overrides:a}=d(this.remoteUserConfiguration,o);let u=[...i,...r,...c];return u.length&&this.updateRemoteUserConfiguration(o),{keys:u,overrides:a}}compareAndUpdateWorkspaceConfiguration(o){const{added:i,updated:r,removed:c,overrides:a}=d(this.workspaceConfiguration,o);let u=[...i,...r,...c];return u.length&&this.updateWorkspaceConfiguration(o),{keys:u,overrides:a}}compareAndUpdateFolderConfiguration(o,i){const r=this.folderConfigurations.get(o),{added:c,updated:a,removed:u,overrides:f}=d(r,i);let v=[...c,...a,...u];return(v.length||!r)&&this.updateFolderConfiguration(o,i),{keys:v,overrides:f}}compareAndDeleteFolderConfiguration(o){const i=this.folderConfigurations.get(o);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(o);const{added:r,updated:c,removed:a,overrides:u}=d(i,void 0);return{keys:[...r,...c,...a],overrides:u}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(o,i){let r=this.getConsolidatedConfigurationModelForResource(o,i);return o.overrideIdentifier?r.override(o.overrideIdentifier):r}getConsolidatedConfigurationModelForResource({resource:o},i){let r=this.getWorkspaceConsolidatedConfiguration();if(i&&o){const c=i.getFolder(o);c&&(r=this.getFolderConsolidatedConfiguration(c.uri)||r);const a=this._memoryConfigurationByResource.get(o);a&&(r=r.merge(a))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(o){let i=this._foldersConsolidatedConfigurations.get(o);if(!i){const r=this.getWorkspaceConsolidatedConfiguration(),c=this._folderConfigurations.get(o);c?(i=r.merge(c),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(o,i)):i=r}return i}getFolderConfigurationModelForResource(o,i){if(i&&o){const r=i.getFolder(o);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((o,i)=>{const{contents:r,overrides:c,keys:a}=this._folderConfigurations.get(i);return o.push([i,{contents:r,overrides:c,keys:a}]),o},[])}}allKeys(){const o=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>o.add(i)),this.userConfiguration.freeze().keys.forEach(i=>o.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>o.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(r=>o.add(r))),[...o.values()]}allOverrideIdentifiers(){const o=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>o.add(i)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>o.add(i)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>o.add(i)),this._folderConfigurations.forEach(i=>i.freeze().getAllOverrideIdentifiers().forEach(r=>o.add(r))),[...o.values()]}getAllKeysForOverrideIdentifier(o){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(o).forEach(r=>i.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(o).forEach(r=>i.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(o).forEach(r=>i.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(o).forEach(c=>i.add(c))),[...i.values()]}static parse(o){const i=this.parseConfigurationModel(o.defaults),r=this.parseConfigurationModel(o.user),c=this.parseConfigurationModel(o.workspace),a=o.folders.reduce((u,f)=>(u.set(P.URI.revive(f[0]),this.parseConfigurationModel(f[1])),u),new R.ResourceMap);return new F(i,r,new E,c,a,new E,new R.ResourceMap,!1)}static parseConfigurationModel(o){return new E(o.contents,o.keys,o.overrides).freeze()}}e.Configuration=F;function _(...S){if(S.length===0)return{keys:[],overrides:[]};if(S.length===1)return S[0];const o=new Set,i=new Map;for(const c of S)c.keys.forEach(a=>o.add(a)),c.overrides.forEach(([a,u])=>{const f=(0,R.getOrSet)(i,a,new Set);u.forEach(v=>f.add(v))});const r=[];return i.forEach((c,a)=>r.push([a,[...c.values()]])),{keys:[...o.values()],overrides:r}}e.mergeChanges=_;class g{constructor(o,i,r,c){this.change=o,this.previous=i,this.currentConfiguraiton=r,this.currentWorkspace=c,this._previousConfiguration=void 0;const a=new Set;o.keys.forEach(f=>a.add(f)),o.overrides.forEach(([,f])=>f.forEach(v=>a.add(v))),this.affectedKeys=[...a.values()];const u=new E;this.affectedKeys.forEach(f=>u.setValue(f,{})),this.affectedKeysTree=u.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=F.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(o,i){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,o)){if(i){const r=this.previousConfiguration?this.previousConfiguration.getValue(o,i,this.previous?.workspace):void 0,c=this.currentConfiguraiton.getValue(o,i,this.currentWorkspace);return!k.equals(r,c)}return!0}return!1}doesAffectedKeysTreeContains(o,i){let r=(0,L.toValuesTree)({[i]:!0},()=>{}),c;for(;typeof r=="object"&&(c=Object.keys(r)[0]);){if(o=o[c],!o)return!1;r=r[c]}return!0}}e.ConfigurationChangeEvent=g;class s extends g{constructor(o,i,r,c){super({keys:o.allKeys(),overrides:[]},void 0,o,i);this.source=r,this.sourceConfig=c}}e.AllKeysConfigurationChangeEvent=s;function d(S,o){const{added:i,removed:r,updated:c}=n(o,S),a=[],u=S?.getAllOverrideIdentifiers()||[],f=o?.getAllOverrideIdentifiers()||[];if(o){const v=f.filter(w=>!u.includes(w));for(const w of v)a.push([w,o.getKeysForOverrideIdentifier(w)])}if(S){const v=u.filter(w=>!f.includes(w));for(const w of v)a.push([w,S.getKeysForOverrideIdentifier(w)])}if(o&&S){for(const v of u)if(f.includes(v)){const w=n({contents:S.getOverrideValue(void 0,v)||{},keys:S.getKeysForOverrideIdentifier(v)},{contents:o.getOverrideValue(void 0,v)||{},keys:o.getKeysForOverrideIdentifier(v)});a.push([v,[...w.added,...w.removed,...w.updated]])}}return{added:i,removed:r,updated:c,overrides:a}}function n(S,o){const i=S?o?S.keys.filter(a=>o.keys.indexOf(a)===-1):[...S.keys]:[],r=o?S?o.keys.filter(a=>S.keys.indexOf(a)===-1):[...o.keys]:[],c=[];if(S&&o){for(const a of o.keys)if(S.keys.indexOf(a)!==-1){const u=(0,L.getConfigurationValue)(o.contents,a),f=(0,L.getConfigurationValue)(S.contents,a);k.equals(u,f)||c.push(a)}}return{added:i,removed:r,updated:c}}}),define(ve[120],we([0,1,4]),function(Z,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,h.createDecorator)("remoteAuthorityResolverService");var t;(function(y){y.Unknown="Unknown",y.NotAvailable="NotAvailable",y.TemporarilyNotAvailable="TemporarilyNotAvailable",y.NoResolverFound="NoResolverFound"})(t=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class I extends Error{constructor(R,k=t.Unknown,D){super(R);this._message=R,this._code=k,this._detail=D,this.isHandled=k===t.NotAvailable&&D===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,I.prototype)}static isTemporarilyNotAvailable(R){return R instanceof I&&R._code===t.TemporarilyNotAvailable}static isNoResolverFound(R){return R instanceof I&&R._code===t.NoResolverFound}static isHandled(R){return R instanceof I&&R.isHandled}}e.RemoteAuthorityResolverError=I}),define(ve[63],we([0,1,10]),function(Z,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function t(P){return P.scheme===h.Schemas.vscodeRemote?P.authority:void 0}e.getRemoteAuthority=t;function I(P){if(!P)return;const L=P.indexOf("+");return L<0?P:P.substr(0,L)}e.getRemoteName=I;function y(P){return P.scheme!==h.Schemas.file&&P.scheme!==h.Schemas.vscodeRemote}e.isVirtualResource=y;function R(P){if(P.folders.length)return P.folders.every(L=>y(L.uri))?P.folders[0].uri:void 0;if(P.configuration&&y(P.configuration))return P.configuration}e.getVirtualWorkspaceLocation=R;function k(P){return R(P)?.scheme}e.getVirtualWorkspaceScheme=k;function D(P){return R(P)!==void 0}e.isVirtualWorkspace=D}),define(ve[27],we([0,1,8,4,63]),function(Z,e,h,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function y(l){if(typeof l=="object"&&l!==null&&l.supported!==!0)return l.description}e.getWorkspaceSupportTypeMessage=y;function R(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(!l.uuid||typeof l.uuid=="string")}e.isIExtensionIdentifier=R,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var k;(function(l){l[l.System=0]="System",l[l.User=1]="User"})(k=e.ExtensionType||(e.ExtensionType={}));class D{constructor(E){this.value=E,this._lower=E.toLowerCase()}static equals(E,p){if(typeof E=="undefined"||E===null)return typeof p=="undefined"||p===null;if(typeof p=="undefined"||p===null)return!1;if(typeof E=="string"||typeof p=="string"){let m=typeof E=="string"?E:E.value,b=typeof p=="string"?p:p.value;return h.equalsIgnoreCase(m,b)}return E._lower===p._lower}static toKey(E){return typeof E=="string"?E.toLowerCase():E._lower}}e.ExtensionIdentifier=D;function P(l){return l.contributes&&l.contributes.localizations?l.contributes.localizations.length>0:!1}e.isLanguagePackExtension=P;function L(l){return l.contributes&&l.contributes.authentication?l.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=L;function C(l,E){if(E){const p=`onResolveRemoteAuthority:${(0,I.getRemoteName)(E)}`;return l.activationEvents?.indexOf(p)!==-1}return!1}e.isResolverExtension=C,e.IBuiltinExtensionsScannerService=(0,t.createDecorator)("IBuiltinExtensionsScannerService")}),define(ve[121],we([0,1,8,27]),function(Z,e,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function I(p,m){return p.uuid&&m.uuid?p.uuid===m.uuid:p.id===m.id?!0:(0,h.compareIgnoreCase)(p.id,m.id)===0}e.areSameExtensions=I;class y{constructor(m,b){this.version=b,this.id=m.id,this.uuid=m.uuid}key(){return`${this.id}-${this.version}`}equals(m){return m instanceof y?I(this,m)&&this.version===m.version:!1}}e.ExtensionIdentifierWithVersion=y;function R(p,m){return`${p}.${m}`}e.getExtensionId=R;function k(p){return p.toLocaleLowerCase()}e.adoptToGalleryExtensionId=k;function D(p,m){return k(R(p,m))}e.getGalleryExtensionId=D;function P(p,m){const b=[],F=_=>{for(const g of b)if(g.some(s=>I(m(s),m(_))))return g;return null};for(const _ of p){const g=F(_);g?g.push(_):b.push([_])}return b}e.groupByExtension=P;function L(p){return{id:p.identifier.id,name:p.manifest.name,galleryId:null,publisherId:p.publisherId,publisherName:p.manifest.publisher,publisherDisplayName:p.publisherDisplayName,dependencies:p.manifest.extensionDependencies&&p.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=L;function C(p){return{id:p.identifier.id,name:p.name,galleryId:p.identifier.uuid,publisherId:p.publisherId,publisherName:p.publisher,publisherDisplayName:p.publisherDisplayName,isPreReleaseVersion:p.properties.isPreReleaseVersion,dependencies:!!(p.properties.dependencies&&p.properties.dependencies.length>0),...p.telemetryData}}e.getGalleryExtensionTelemetryData=C,e.BetterMergeId=new t.ExtensionIdentifier("pprice.better-merge");function l(p){const m=new Set;if(p.malicious)for(const b of p.malicious)m.add(b.id);return m}e.getMaliciousExtensionsSet=l;function E(p,m){const b=[],F=m.manifest.extensionDependencies?.slice(0)??[];for(;F.length;){const _=F.shift();if(_&&b.every(g=>!I(g.identifier,{id:_}))){const g=p.filter(s=>I(s.identifier,{id:_}));g.length===1&&(b.push(g[0]),F.push(...g[0].manifest.extensionDependencies?.slice(0)??[]))}}return b}e.getExtensionDependencies=E}),define(ve[194],we([0,1,10,158,121,4]),function(Z,e,h,t,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.getIdAndVersion=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";const R=/^([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;function k(n){const S=R.exec(n);return S&&S[1]?[(0,I.adoptToGalleryExtensionId)(S[1]),S[2]]:[(0,I.adoptToGalleryExtensionId)(n),void 0]}e.getIdAndVersion=k;var D;(function(n){n.WIN32_X64="win32-x64",n.WIN32_IA32="win32-ia32",n.WIN32_ARM64="win32-arm64",n.LINUX_X64="linux-x64",n.LINUX_ARM64="linux-arm64",n.LINUX_ARMHF="linux-armhf",n.ALPINE_X64="alpine-x64",n.ALPINE_ARM64="alpine-arm64",n.DARWIN_X64="darwin-x64",n.DARWIN_ARM64="darwin-arm64",n.WEB="web",n.UNIVERSAL="universal",n.UNKNOWN="unknown",n.UNDEFINED="undefined"})(D=e.TargetPlatform||(e.TargetPlatform={}));function P(n){switch(n){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=P;function L(n){switch(n){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=L;function C(n,S){switch(n){case 3:return S==="x64"?"win32-x64":S==="ia32"?"win32-ia32":S==="arm64"?"win32-arm64":"unknown";case 2:return S==="x64"?"linux-x64":S==="arm64"?"linux-arm64":S==="arm"?"linux-armhf":"unknown";case"alpine":return S==="x64"?"alpine-x64":S==="arm64"?"alpine-arm64":"unknown";case 1:return S==="x64"?"darwin-x64":S==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=C;function l(n,S){return S==="web"&&!n.includes("web")}e.isNotWebExtensionInWebTargetPlatform=l;function E(n,S,o){return l(S,o)?!1:n==="undefined"||n==="universal"?!0:n==="unknown"?!1:n===o?!0:p(o).includes(n)}e.isTargetPlatformCompatible=E;function p(n){switch(n){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=p;function m(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}e.isIExtensionIdentifier=m;var b;(function(n){n[n.NoneOrRelevance=0]="NoneOrRelevance",n[n.LastUpdatedDate=1]="LastUpdatedDate",n[n.Title=2]="Title",n[n.PublisherName=3]="PublisherName",n[n.InstallCount=4]="InstallCount",n[n.PublishedDate=10]="PublishedDate",n[n.AverageRating=6]="AverageRating",n[n.WeightedRating=12]="WeightedRating"})(b=e.SortBy||(e.SortBy={}));var F;(function(n){n[n.Default=0]="Default",n[n.Ascending=1]="Ascending",n[n.Descending=2]="Descending"})(F=e.SortOrder||(e.SortOrder={}));var _;(function(n){n.Install="install",n.Uninstall="uninstall"})(_=e.StatisticType||(e.StatisticType={}));var g;(function(n){n[n.None=1]="None",n[n.Install=2]="Install",n[n.Update=3]="Update",n[n.Migrate=4]="Migrate"})(g=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,y.createDecorator)("extensionGalleryService");var s;(function(n){n.Unsupported="Unsupported",n.UnsupportedPreRelease="UnsupportedPreRelease",n.Malicious="Malicious",n.Incompatible="Incompatible",n.IncompatiblePreRelease="IncompatiblePreRelease",n.IncompatibleTargetPlatform="IncompatibleTargetPlatform",n.ReleaseVersionNotFound="ReleaseVersionNotFound",n.Invalid="Invalid",n.Download="Download",n.Extract="Extract",n.Delete="Delete",n.Rename="Rename",n.CorruptZip="CorruptZip",n.IncompleteZip="IncompleteZip",n.Internal="Internal"})(s=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class d extends Error{constructor(S,o){super(S);this.code=o,this.name=o}}e.ExtensionManagementError=d,e.IExtensionManagementService=(0,y.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,y.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,y.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=h.FileAccess.asBrowserUri("./media/defaultIcon.png",Z).toString(!0),e.ExtensionsLabel=(0,t.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,t.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,y.createDecorator)("IExtensionManagementCLIService")}),define(ve[122],we([0,1,3,11,4,12]),function(Z,e,h,t,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,I.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,I.createDecorator)("sharedTunnelsService");var R;(function(p){p.Http="http",p.Https="https"})(R=e.TunnelProtocol||(e.TunnelProtocol={}));var k;(function(p){p.ConstantPrivate="constantPrivate",p.Private="private",p.Public="public"})(k=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var D;(function(p){p[p.Notify=1]="Notify",p[p.OpenBrowser=2]="OpenBrowser",p[p.OpenPreview=3]="OpenPreview",p[p.Silent=4]="Silent",p[p.Ignore=5]="Ignore",p[p.OpenBrowserOnce=6]="OpenBrowserOnce"})(D=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function P(p){if(p.scheme!=="http"&&p.scheme!=="https")return;const m=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(p.authority);if(!!m)return{address:m[1],port:+m[2]}}e.extractLocalHostUriMetaDataForPortMapping=P,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function L(p){return e.LOCALHOST_ADDRESSES.indexOf(p)>=0}e.isLocalhost=L,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function C(p){return e.ALL_INTERFACES_ADDRESSES.indexOf(p)>=0}e.isAllInterfaces=C;function l(p,m){return m?m!==1&&p<1024:!t.isWindows&&p<1024}e.isPortPrivileged=l;let E=class{constructor(m){this.logService=m,this._onTunnelOpened=new h.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new h.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new h.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(m){return this._tunnelProvider=m,m?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(m){this._canElevate=m.elevation,this._privacyOptions=m.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const m=[],b=Array.from(this._tunnels.values());for(let F of b){const _=Array.from(F.values());for(let g of _){const s=await g.value;s&&m.push(s)}}return m}async dispose(){for(const m of this._tunnels.values()){for(const{value:b}of m.values())await b.then(F=>F?.dispose());m.clear()}this._tunnels.clear()}openTunnel(m,b,F,_,g=!1,s=k.Private,d){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${b}:${F} on local port ${_}.`),!m)return;b||(b="localhost");const n=this.retainOrCreateTunnel(m,b,F,_,g,s,d);return n?n.then(S=>{if(!S){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(b,F);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const o=this.makeTunnel(S);return(S.tunnelRemoteHost!==b||S.tunnelRemotePort!==F)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(o),o}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),n)}makeTunnel(m){return{tunnelRemotePort:m.tunnelRemotePort,tunnelRemoteHost:m.tunnelRemoteHost,tunnelLocalPort:m.tunnelLocalPort,localAddress:m.localAddress,privacy:m.privacy,protocol:m.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${m.tunnelRemoteHost}:${m.tunnelRemotePort} `);const b=this._tunnels.get(m.tunnelRemoteHost);if(b){const F=b.get(m.tunnelRemotePort);F&&(F.refcount--,await this.tryDisposeTunnel(m.tunnelRemoteHost,m.tunnelRemotePort,F))}}}}async tryDisposeTunnel(m,b,F){if(F.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${m}:${b}.`);const _=F.value.then(async g=>{g&&(await g.dispose(!0),this._onTunnelClosed.fire({host:g.tunnelRemoteHost,port:g.tunnelRemotePort}))});return this._tunnels.has(m)&&this._tunnels.get(m).delete(b),_}}async closeTunnel(m,b){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${m}:${b} `);const F=this._tunnels.get(m);if(F&&F.has(b)){const _=F.get(b);_.refcount=0,await this.tryDisposeTunnel(m,b,_)}}addTunnelToMap(m,b,F){this._tunnels.has(m)||this._tunnels.set(m,new Map),this._tunnels.get(m).set(b,{refcount:1,value:F})}async removeEmptyTunnelFromMap(m,b){const F=this._tunnels.get(m);F&&(await F.get(b)||F.delete(b),F.size===0&&this._tunnels.delete(m))}getTunnelFromMap(m,b){let F=[m];L(m)?(F.push(...e.LOCALHOST_ADDRESSES),F.push(...e.ALL_INTERFACES_ADDRESSES)):C(m)&&F.push(...e.ALL_INTERFACES_ADDRESSES);const _=F.map(g=>this._tunnels.get(g));for(const g of _){const s=g?.get(b);if(s)return s}}canTunnel(m){return!!P(m)}createWithProvider(m,b,F,_,g,s,d){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${b}:${F} on local port ${_}.`);const S={elevationRequired:g?l(_===void 0?F:_):!1},o={remoteAddress:{host:b,port:F},localAddressPort:_,privacy:s,public:s!==k.Private,protocol:d},i=m.forwardPort(o,S);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),i&&this.addTunnelToMap(b,F,i),i}};E=je([ze(0,y.ILogService)],E),e.AbstractTunnelService=E}),define(ve[195],we([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class h{constructor(){this.validators=new Map}vsda(){return new Promise((I,y)=>Z(["vsda"],I,y))}async createNewMessage(I){try{const y=await this.vsda(),R=new y.validator;if(R){const k=String(h._nextId++);return this.validators.set(k,R),{id:k,data:R.createNewMessage(I)}}}catch{}return{id:"",data:I}}async validate(I,y){if(!I.id)return!0;const R=this.validators.get(I.id);if(!R)return!1;this.validators.delete(I.id);try{return R.validate(y)==="ok"}catch{return!1}}async sign(I){try{const y=await this.vsda(),R=new y.signer;if(R)return R.sign(I)}catch{}return I}}e.SignService=h,h._nextId=1}),define(ve[196],we([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class h{constructor(I){this._callback=I,this._terminalBufferMap=new Map}dispose(){for(const I of this._terminalBufferMap.values())I.dispose()}startBuffering(I,y,R=5){let k;return k=y(D=>{const P=typeof D=="string"?D:D.data;let L=this._terminalBufferMap.get(I);if(L){L.data.push(P);return}const C=setTimeout(()=>this.flushBuffer(I),R);L={data:[P],timeoutId:C,dispose:()=>{clearTimeout(C),this.flushBuffer(I),k.dispose()}},this._terminalBufferMap.set(I,L)}),k}stopBuffering(I){const y=this._terminalBufferMap.get(I);y&&y.dispose()}flushBuffer(I){const y=this._terminalBufferMap.get(I);y&&(this._terminalBufferMap.delete(I),this._callback(I,y.data.join("")))}}e.TerminalDataBufferer=h}),define(ve[197],we([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var h;(function(t){t.DARK="dark",t.LIGHT="light",t.HIGH_CONTRAST="hc"})(h=e.ColorScheme||(e.ColorScheme={}))}),define(ve[85],we([0,1,74,3,6,4,50,197]),function(Z,e,h,t,I,y,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,y.createDecorator)("themeService");var D;(function(b){function F(_){return _&&typeof _=="object"&&typeof _.id=="string"}b.isThemeColor=F})(D=e.ThemeColor||(e.ThemeColor={}));function P(b){return{id:b}}e.themeColorFromId=P;var L;(function(b){function F(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color=="undefined"||D.isThemeColor(i.color))}b.isThemeIcon=F;const _=new RegExp(`^\\$\\((${h.CSSIcon.iconNameExpression}(?:${h.CSSIcon.iconModifierExpression})?)\\)$`);function g(i){const r=_.exec(i);if(!r)return;let[,c]=r;return{id:c}}b.fromString=g;function s(i){return{id:i}}b.fromId=s;function d(i,r){let c=i.id;const a=c.lastIndexOf("~");return a!==-1&&(c=c.substring(0,a)),r&&(c=`${c}~${r}`),{id:c}}b.modify=d;function n(i){const r=i.id.lastIndexOf("~");if(r!==-1)return i.id.substring(r+1)}b.getModifier=n;function S(i,r){return i.id===r.id&&i.color?.id===r.color?.id}b.isEqual=S;function o(i,r){return{id:i.id,color:r?P(r):void 0}}b.asThemeIcon=o,b.asClassNameArray=h.CSSIcon.asClassNameArray,b.asClassName=h.CSSIcon.asClassName,b.asCSSSelector=h.CSSIcon.asCSSSelector})(L=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=h.Codicon.file,e.FolderThemeIcon=h.Codicon.folder;function C(b){switch(b){case k.ColorScheme.DARK:return"vs-dark";case k.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=C,e.Extensions={ThemingContribution:"base.contributions.theming"};class l{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new t.Emitter}onColorThemeChange(F){return this.themingParticipants.push(F),this.onThemingParticipantAddedEmitter.fire(F),(0,I.toDisposable)(()=>{const _=this.themingParticipants.indexOf(F);this.themingParticipants.splice(_,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let E=new l;R.Registry.add(e.Extensions.ThemingContribution,E);function p(b){return E.onColorThemeChange(b)}e.registerThemingParticipant=p;class m extends I.Disposable{constructor(F){super();this.themeService=F,this.theme=F.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(_=>this.onThemeChange(_)))}onThemeChange(F){this.theme=F,this.updateStyles()}updateStyles(){}getColor(F,_){let g=this.theme.getColor(F);return g&&_&&(g=_(g,this.theme)),g?g.toString():null}}e.Themable=m}),define(ve[43],we([0,1,24,23,2,4]),function(Z,e,h,t,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,y.createDecorator)("contextService");var R;(function(l){l[l.EMPTY=1]="EMPTY",l[l.FOLDER=2]="FOLDER",l[l.WORKSPACE=3]="WORKSPACE"})(R=e.WorkbenchState||(e.WorkbenchState={}));function k(l){const E=l;return!!(E&&typeof E=="object"&&typeof E.id=="string"&&Array.isArray(E.folders))}e.isWorkspace=k;function D(l){const E=l;return!!(E&&typeof E=="object"&&I.URI.isUri(E.uri)&&typeof E.name=="string"&&typeof E.toResource=="function")}e.isWorkspaceFolder=D;class P{constructor(E,p,m,b,F){this._id=E,this._transient=m,this._configuration=b,this._ignorePathCasing=F,this._foldersMap=h.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=p}update(E){this._id=E.id,this._configuration=E.configuration,this._transient=E.transient,this._ignorePathCasing=E._ignorePathCasing,this.folders=E.folders}get folders(){return this._folders}set folders(E){this._folders=E,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(E){this._configuration=E}getFolder(E){return E&&this._foldersMap.findSubstr(E.with({scheme:E.scheme,authority:E.authority,path:E.path}))||null}updateFoldersMap(){this._foldersMap=h.TernarySearchTree.forUris(this._ignorePathCasing);for(const E of this.folders)this._foldersMap.set(E.uri,E)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=P;class L{constructor(E,p){this.raw=p,this.uri=E.uri,this.index=E.index,this.name=E.name}toResource(E){return(0,t.joinPath)(this.uri,E)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=L;function C(l){return new L({uri:l,index:0,name:(0,t.basenameOrAuthority)(l)},{uri:l.toString()})}e.toWorkspaceFolder=C}),define(ve[198],we([0,1,29,57,141,80,10,9,11,23,2,163,4,63,43]),function(Z,e,h,t,I,y,R,k,D,P,L,C,l,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isWorkspaceBackupInfo=e.isFolderBackupInfo=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const m=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,C.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function b(N){return(typeof N=="string"?(0,k.extname)(N):(0,P.extname)(N))===m}e.hasWorkspaceFileExtension=b,e.IWorkspacesService=(0,l.createDecorator)("workspacesService");function F(N){return N.hasOwnProperty("workspace")}e.isRecentWorkspace=F;function _(N){return N.hasOwnProperty("folderUri")}e.isRecentFolder=_;function g(N){return N.hasOwnProperty("fileUri")}e.isRecentFile=g;function s(N){return N&&N.hasOwnProperty("folderUri")}e.isFolderBackupInfo=s;function d(N){return N&&N.hasOwnProperty("workspace")}e.isWorkspaceBackupInfo=d;function n(N){const $=N;return typeof $?.id=="string"&&L.URI.isUri($.uri)}e.isSingleFolderWorkspaceIdentifier=n;function S(N){if(N.configuration)return{id:N.id,configPath:N.configuration};if(N.folders.length===1)return{id:N.id,uri:N.folders[0].uri}}e.toWorkspaceIdentifier=S;function o(N){const $=N;return typeof $?.id=="string"&&L.URI.isUri($.configPath)}e.isWorkspaceIdentifier=o;function i(N){const $=N;if($?.uri)return{id:$.id,uri:L.URI.revive($.uri)};const B=N;if(B?.configPath)return{id:B.id,configPath:L.URI.revive(B.configPath)};if(N?.id)return{id:N.id}}e.reviveIdentifier=i;function r(N,$){return P.extUriBiasedIgnorePathCase.isEqualOrParent(N,$.untitledWorkspacesHome)}e.isUntitledWorkspace=r;function c(N){return a(N)||u(N)}e.isStoredWorkspaceFolder=c;function a(N){const $=N;return typeof $?.path=="string"&&(!$.name||typeof $.name=="string")}e.isRawFileWorkspaceFolder=a;function u(N){const $=N;return typeof $?.uri=="string"&&(!$.name||typeof $.name=="string")}e.isRawUriWorkspaceFolder=u;function f(N,$,B,z,W=!D.isWindows,Y){if(N.scheme!==z.scheme)return{name:B,uri:N.toString(!0)};let ie=$?void 0:Y.relativePath(z,N);if(ie!==void 0)ie.length===0?ie=".":D.isWindows&&N.scheme===R.Schemas.file&&!W&&(ie=ie.replace(/\//g,"\\"));else if(N.scheme===R.Schemas.file)ie=N.fsPath,D.isWindows&&(ie=(0,y.normalizeDriveLetter)(ie),W&&(ie=(0,h.toSlashes)(ie)));else{if(!Y.isEqualAuthority(N.authority,z.authority))return{name:B,uri:N.toString(!0)};ie=N.path}return{name:B,path:ie}}e.getStoredWorkspaceFolder=f;function v(N,$,B){let z=[],W=new Set;const Y=B.dirname($);for(let ie of N){let ne;if(a(ie))ie.path&&(ne=B.resolvePath(Y,ie.path));else if(u(ie))try{ne=L.URI.parse(ie.uri),ne.path[0]!=="/"&&(ne=ne.with({path:"/"+ne.path}))}catch(J){console.warn(J)}if(ne){let J=B.getComparisonKey(ne);if(!W.has(J)){W.add(J);const K=ie.name||B.basenameOrAuthority(ne);z.push(new p.WorkspaceFolder({uri:ne,name:K,index:z.length},ie))}}}return z}e.toWorkspaceFolders=v;function w(N,$,B,z,W){let Y=A($,N);const ie=W.dirname($),ne=W.dirname(z),J=[],K=M(Y.folders);for(const Te of Y.folders){const xe=a(Te)?W.resolvePath(ie,Te.path):L.URI.parse(Te.uri);let Ge;B?Ge=!1:Ge=!a(Te)||(0,k.isAbsolute)(Te.path),J.push(f(xe,Ge,Te.name,ne,K,W))}const oe={insertSpaces:!1,tabSize:4,eol:D.isLinux||D.isMacintosh?`
`:`\r
`},fe=I.setProperty(N,["folders"],J,oe);let pe=I.applyEdits(N,fe);return(0,P.isEqualAuthority)(Y.remoteAuthority,(0,E.getRemoteAuthority)(z))&&(pe=I.applyEdits(pe,I.removeProperty(pe,["remoteAuthority"],oe))),pe}e.rewriteWorkspaceFileForNewLocation=w;function A(N,$){let B=t.parse($);if(B&&Array.isArray(B.folders))B.folders=B.folders.filter(z=>c(z));else throw new Error(`${N} looks like an invalid workspace file.`);return B}function M(N){return D.isWindows?N.some($=>a($)&&$.path.indexOf("/")>=0):!0}e.useSlashForPath=M;function T(N){return N.workspace&&typeof N.workspace=="object"&&typeof N.workspace.id=="string"&&typeof N.workspace.configPath=="string"}function O(N){return typeof N.folderUri=="string"}function U(N){return typeof N.fileUri=="string"}function V(N,$){const B={workspaces:[],files:[]};if(N){const z=function(Y,ie){for(let ne=0;ne<Y.length;ne++)try{ie(Y[ne],ne)}catch(J){$.warn(`Error restoring recent entry ${JSON.stringify(Y[ne])}: ${J.toString()}. Skip entry.`)}},W=N;if(Array.isArray(W.entries))z(W.entries,Y=>{const ie=Y.label,ne=Y.remoteAuthority;T(Y)?B.workspaces.push({label:ie,remoteAuthority:ne,workspace:{id:Y.workspace.id,configPath:L.URI.parse(Y.workspace.configPath)}}):O(Y)?B.workspaces.push({label:ie,remoteAuthority:ne,folderUri:L.URI.parse(Y.folderUri)}):U(Y)&&B.files.push({label:ie,remoteAuthority:ne,fileUri:L.URI.parse(Y.fileUri)})});else{const Y=N;Array.isArray(Y.workspaces3)&&z(Y.workspaces3,(ie,ne)=>{const J=Array.isArray(Y.workspaceLabels)&&Y.workspaceLabels[ne]||void 0;typeof ie=="object"&&typeof ie.id=="string"&&typeof ie.configURIPath=="string"?B.workspaces.push({label:J,workspace:{id:ie.id,configPath:L.URI.parse(ie.configURIPath)}}):typeof ie=="string"&&B.workspaces.push({label:J,folderUri:L.URI.parse(ie)})}),Array.isArray(Y.files2)&&z(Y.files2,(ie,ne)=>{const J=Array.isArray(Y.fileLabels)&&Y.fileLabels[ne]||void 0;typeof ie=="string"&&B.files.push({label:J,fileUri:L.URI.parse(ie)})})}}return B}e.restoreRecentlyOpened=V;function x(N){const $={entries:[]};for(const B of N.workspaces)_(B)?$.entries.push({folderUri:B.folderUri.toString(),label:B.label,remoteAuthority:B.remoteAuthority}):$.entries.push({workspace:{id:B.workspace.id,configPath:B.workspace.configPath.toString()},label:B.label,remoteAuthority:B.remoteAuthority});for(const B of N.files)$.entries.push({fileUri:B.fileUri.toString(),label:B.label,remoteAuthority:B.remoteAuthority});return $}e.toStoreData=x}),define(ve[86],we([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class h{constructor(I){this.id=I,this._data=new Map,this._idPool=1}add(I){const y=this._idPool++;return this._data.set(y,I),this.logDebugInfo(),y}get(I,y){return this._data.has(I)?this._data.get(I)[y]:void 0}delete(I){this._data.delete(I),this.logDebugInfo()}logDebugInfo(){!h.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=h,h.enableDebugLogging=!1}),define(ve[44],we([0,1,10,23,4]),function(Z,e,h,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class y{constructor(){this._systemSchemes=new Set(Object.keys(h.Schemas)),this._providerInfo=new Map,this.extUri=new t.ExtUri(k=>{const D=this._providerInfo.get(k.scheme);return!(D===void 0||D&1024)})}$acceptProviderInfos(k,D){D===null?this._providerInfo.delete(k.scheme):this._providerInfo.set(k.scheme,D)}isFreeScheme(k){return!this._providerInfo.has(k)&&!this._systemSchemes.has(k)}getCapabilities(k){return this._providerInfo.get(k)}}e.ExtHostFileSystemInfo=y,e.IExtHostFileSystemInfo=(0,I.createDecorator)("IExtHostFileSystemInfo")}),define(ve[26],we([0,1,4]),function(Z,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,h.createDecorator)("IExtHostInitDataService")}),define(ve[199],we([0,1,13]),function(Z,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class t{constructor(R,k,D){this._deferredPromises=new Map,this._id=R,this._shared=k,this._storage=D,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(P=>(this._value=P,this)),this._storageListener=this._storage.onDidChangeStorage(P=>{P.shared===this._shared&&P.key===this._id&&(this._value=P.value)}),this._scheduler=new h.RunOnceScheduler(()=>{const P=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const L of P.values())L.complete()}catch(L){for(const C of P.values())C.error(L)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,R])=>R!==void 0).map(([R])=>R)}get whenReady(){return this._init}get(R,k){let D=this._value[R];return typeof D=="undefined"&&(D=k),D}update(R,k){this._value[R]=k;let D=this._deferredPromises.get(R);if(D!==void 0)return D.p;const P=new h.DeferredPromise;return this._deferredPromises.set(R,P),this._scheduler.isScheduled()||this._scheduler.schedule(),P.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=t;class I extends t{constructor(R,k){super(R.identifier.value,!0,k);this._extension=R}setKeysForSync(R){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},R)}}e.ExtensionGlobalMemento=I}),define(ve[200],we([0,1,3,2,12]),function(Z,e,h,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let y=class{constructor(k,D){this._logService=k,this._notebooksAndEditors=D,this._onDidChangeNotebookDocumentMetadata=new h.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new h.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(k,D,P){this._notebooksAndEditors.getNotebookDocument(t.URI.revive(k)).acceptModelChanged(D.value,P)}$acceptDirtyStateChanged(k,D){this._notebooksAndEditors.getNotebookDocument(t.URI.revive(k)).acceptDirty(D)}$acceptModelSaved(k){const D=this._notebooksAndEditors.getNotebookDocument(t.URI.revive(k));this._onDidSaveNotebookDocument.fire(D.apiNotebook)}$acceptDocumentPropertiesChanged(k,D){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",k.path,D);const P=this._notebooksAndEditors.getNotebookDocument(t.URI.revive(k));P.acceptDocumentPropertiesChanged(D),D.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:P.apiNotebook})}};y=je([ze(0,I.ILogService)],y),e.ExtHostNotebookDocuments=y}),define(ve[14],we([0,1,4]),function(Z,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,h.createDecorator)("IExtHostRpcService");class t{constructor(y){this.getProxy=y.getProxy.bind(y),this.set=y.set.bind(y),this.assertRegistered=y.assertRegistered.bind(y),this.drain=y.drain.bind(y)}}e.ExtHostRpcService=t});var nt=this&&this.__classPrivateFieldSet||function(Z,e,h,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!I:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(Z,h):I?I.value=h:e.set(Z,h),h},Fe=this&&this.__classPrivateFieldGet||function(Z,e,h,t){if(h==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?t:h==="a"?t.call(Z):t?t.value:e.get(Z)};define(ve[201],we([0,1,27,3]),function(Z,e,h,t){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class y{constructor(k,D){I.set(this,void 0),this._onDidChange=new t.Emitter,this.onDidChange=this._onDidChange.event,this._id=h.ExtensionIdentifier.toKey(k.identifier),nt(this,I,D,"f"),Fe(this,I,"f").onDidChangePassword(P=>{P.extensionId===this._id&&this._onDidChange.fire({key:P.key})})}get(k){return Fe(this,I,"f").get(this._id,k)}store(k,D){return Fe(this,I,"f").store(this._id,k,D)}delete(k){return Fe(this,I,"f").delete(this._id,k)}}e.ExtensionSecrets=y,I=new WeakMap}),define(ve[123],we([0,1,4,3]),function(Z,e,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class I{constructor(){this._onDidChangeTelemetryEnabled=new t.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(R){this._enabled=R}$onDidChangeTelemetryEnabled(R){this._enabled=R,this._onDidChangeTelemetryEnabled.fire(R)}}e.ExtHostTelemetry=I,e.IExtHostTelemetry=(0,h.createDecorator)("IExtHostTelemetry")}),define(ve[64],we([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var h;(function(_){_[_.Upsert=0]="Upsert",_[_.RemoveChild=1]="RemoveChild",_[_.Invalidated=2]="Invalidated",_[_.SetProp=3]="SetProp",_[_.Bulk=4]="Bulk"})(h=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const t=new WeakMap,I=(_,g)=>{const s={controllerId:g};return t.set(_,s),s};e.createPrivateApiFor=I;const y=_=>t.get(_);e.getPrivateApiFor=y;const R=(_,g,s,d)=>{let n=s;return{enumerable:!0,configurable:!1,get(){return n},set(S){if(!d(n,S)){const o=n;n=S,_.listener?.({op:3,key:g,value:S,previous:o})}}}},k=(_,g)=>_===g,D={range:(_,g)=>_===g?!0:!_||!g?!1:_.isEqual(g),label:k,description:k,busy:k,error:k,canResolveChildren:k,tags:(_,g)=>!(_.length!==g.length||_.some(s=>!g.find(d=>s.id===d.id)))},P=Object.keys(D),L=(_,g)=>({range:R(_,"range",void 0,D.range),label:R(_,"label",g,D.label),description:R(_,"description",void 0,D.description),canResolveChildren:R(_,"canResolveChildren",!1,D.canResolveChildren),busy:R(_,"busy",!1,D.busy),error:R(_,"error",void 0,D.error),tags:R(_,"tags",[],D.tags)}),C=(_,g)=>{const s=new Map;for(const d of P)D[d](_[d],g[d])||s.set(d,g[d]);return s};e.diffTestItems=C;class l extends Error{constructor(g){super(`Attempted to insert a duplicate test item ID ${g}`)}}e.DuplicateTestItemError=l;class E extends Error{constructor(g){super(`TestItem with ID "${g}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=E;class p extends Error{constructor(g,s,d){super(`TestItem with ID "${g}" is from controller "${s}" and cannot be added as a child of an item from controller "${d}".`)}}e.MixedTestItemController=p;const m=_=>{const g=(0,e.getPrivateApiFor)(_);let s=new Map;return{get size(){return s.size},forEach(d,n){for(const S of s.values())d.call(n,S,this)},replace(d){const n=new Map,S=new Set(s.keys()),o={op:4,ops:[]};for(const i of d){if(!(i instanceof b))throw new E(i.id);const r=(0,e.getPrivateApiFor)(i).controllerId;if(r!==g.controllerId)throw new p(i.id,r,g.controllerId);if(n.has(i.id))throw new l(i.id);n.set(i.id,i),S.delete(i.id),o.ops.push({op:0,item:i})}for(const i of S.keys())o.ops.push({op:1,id:i});g.listener?.(o),s=n},add(d){if(!(d instanceof b))throw new E(d.id);s.set(d.id,d),g.listener?.({op:0,item:d})},delete(d){s.delete(d)&&g.listener?.({op:1,id:d})},get(d){return s.get(d)},toJSON(){return Array.from(s.values())},[Symbol.iterator](){return s.values()}}};class b{constructor(g,s,d,n){if(s.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(s)} symbol`);const S=(0,e.createPrivateApiFor)(this,g);Object.defineProperties(this,{id:{value:s,enumerable:!0,writable:!1},uri:{value:n,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return S.parent instanceof F?void 0:S.parent}},children:{value:m(this),enumerable:!0,writable:!1},...L(S,d)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=b;class F extends b{constructor(g,s){super(g,g,s,void 0)}}e.TestItemRootImpl=F}),define(ve[51],we([0,1,4,122,3,14]),function(Z,e,h,t,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var R;(function(D){function P(C){return{remoteAddress:C.remoteAddress,localAddress:C.localAddress,public:!!C.public,privacy:C.privacy??(C.public?t.TunnelPrivacyId.Public:t.TunnelPrivacyId.Private),protocol:C.protocol}}D.fromApiTunnel=P;function L(C){return{remoteAddress:{host:C.tunnelRemoteHost,port:C.tunnelRemotePort},localAddress:C.localAddress,public:C.privacy!==t.TunnelPrivacyId.ConstantPrivate&&C.privacy!==t.TunnelPrivacyId.ConstantPrivate,privacy:C.privacy,protocol:C.protocol}}D.fromServiceTunnel=L})(R=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,h.createDecorator)("IExtHostTunnelService");let k=class{constructor(P){this.onDidChangeTunnels=new I.Emitter().event}async $applyCandidateFilter(P){return P}async openTunnel(P,L){}async getTunnels(){return[]}async setTunnelFactory(P){return{dispose:()=>{}}}registerPortsAttributesProvider(P,L){return{dispose:()=>{}}}async $providePortAttributes(P,L,C,l,E){return[]}async $forwardPort(P,L){}async $closeTunnel(P){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};k=je([ze(0,y.IExtHostRpcService)],k),e.ExtHostTunnelService=k});var nt=this&&this.__classPrivateFieldSet||function(Z,e,h,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!I:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(Z,h):I?I.value=h:e.set(Z,h),h},Fe=this&&this.__classPrivateFieldGet||function(Z,e,h,t){if(h==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?t:h==="a"?t.call(Z):t?t.value:e.get(Z)};define(ve[7],we([0,1,17,16,99,24,95,8,18,2,33,42,120]),function(Z,e,h,t,I,y,R,k,D,P,L,C,l){"use strict";var E,p,m,b,F,_,g,s,d,n,S,o,i,r,c,a,u,f,v,w;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeDataTransfer=e.TreeDataTransferItem=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function A(j){function H(){return Reflect.construct(j,arguments,this.constructor)}return Object.defineProperty(H,"name",Object.getOwnPropertyDescriptor(j,"name")),Object.setPrototypeOf(H,j),Object.setPrototypeOf(H.prototype,j.prototype),H}let M=F=class{constructor(H){E.set(this,void 0),nt(this,E,H,"f")}static from(...H){let ue=H;return new F(function(){if(ue){for(const Pe of ue)Pe&&typeof Pe.dispose=="function"&&Pe.dispose();ue=void 0}})}dispose(){typeof Fe(this,E,"f")=="function"&&(Fe(this,E,"f").call(this),nt(this,E,void 0,"f"))}};E=new WeakMap,M=F=je([A],M),e.Disposable=M;let T=_=class{constructor(H,ue){if(H<0)throw(0,t.illegalArgument)("line must be non-negative");if(ue<0)throw(0,t.illegalArgument)("character must be non-negative");this._line=H,this._character=ue}static Min(...H){if(H.length===0)throw new TypeError;let ue=H[0];for(let Pe=1;Pe<H.length;Pe++){const et=H[Pe];et.isBefore(ue)&&(ue=et)}return ue}static Max(...H){if(H.length===0)throw new TypeError;let ue=H[0];for(let Pe=1;Pe<H.length;Pe++){const et=H[Pe];et.isAfter(ue)&&(ue=et)}return ue}static isPosition(H){if(!H)return!1;if(H instanceof _)return!0;let{line:ue,character:Pe}=H;return typeof ue=="number"&&typeof Pe=="number"}get line(){return this._line}get character(){return this._character}isBefore(H){return this._line<H._line?!0:H._line<this._line?!1:this._character<H._character}isBeforeOrEqual(H){return this._line<H._line?!0:H._line<this._line?!1:this._character<=H._character}isAfter(H){return!this.isBeforeOrEqual(H)}isAfterOrEqual(H){return!this.isBefore(H)}isEqual(H){return this._line===H._line&&this._character===H._character}compareTo(H){return this._line<H._line?-1:this._line>H.line?1:this._character<H._character?-1:this._character>H._character?1:0}translate(H,ue=0){if(H===null||ue===null)throw(0,t.illegalArgument)();let Pe;return typeof H=="undefined"?Pe=0:typeof H=="number"?Pe=H:(Pe=typeof H.lineDelta=="number"?H.lineDelta:0,ue=typeof H.characterDelta=="number"?H.characterDelta:0),Pe===0&&ue===0?this:new _(this.line+Pe,this.character+ue)}with(H,ue=this.character){if(H===null||ue===null)throw(0,t.illegalArgument)();let Pe;return typeof H=="undefined"?Pe=this.line:typeof H=="number"?Pe=H:(Pe=typeof H.line=="number"?H.line:this.line,ue=typeof H.character=="number"?H.character:this.character),Pe===this.line&&ue===this.character?this:new _(Pe,ue)}toJSON(){return{line:this.line,character:this.character}}};T=_=je([A],T),e.Position=T;let O=g=class{constructor(H,ue,Pe,et){let at,dt;if(typeof H=="number"&&typeof ue=="number"&&typeof Pe=="number"&&typeof et=="number"?(at=new T(H,ue),dt=new T(Pe,et)):H instanceof T&&ue instanceof T&&(at=H,dt=ue),!at||!dt)throw new Error("Invalid arguments");at.isBefore(dt)?(this._start=at,this._end=dt):(this._start=dt,this._end=at)}static isRange(H){return H instanceof g?!0:H?T.isPosition(H.start)&&T.isPosition(H.end):!1}get start(){return this._start}get end(){return this._end}contains(H){return H instanceof g?this.contains(H._start)&&this.contains(H._end):H instanceof T?!(H.isBefore(this._start)||this._end.isBefore(H)):!1}isEqual(H){return this._start.isEqual(H._start)&&this._end.isEqual(H._end)}intersection(H){const ue=T.Max(H.start,this._start),Pe=T.Min(H.end,this._end);if(!ue.isAfter(Pe))return new g(ue,Pe)}union(H){if(this.contains(H))return this;if(H.contains(this))return H;const ue=T.Min(H.start,this._start),Pe=T.Max(H.end,this.end);return new g(ue,Pe)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(H,ue=this.end){if(H===null||ue===null)throw(0,t.illegalArgument)();let Pe;return H?T.isPosition(H)?Pe=H:(Pe=H.start||this.start,ue=H.end||this.end):Pe=this.start,Pe.isEqual(this._start)&&ue.isEqual(this.end)?this:new g(Pe,ue)}toJSON(){return[this.start,this.end]}};O=g=je([A],O),e.Range=O;let U=s=class extends O{constructor(H,ue,Pe,et){let at,dt;if(typeof H=="number"&&typeof ue=="number"&&typeof Pe=="number"&&typeof et=="number"?(at=new T(H,ue),dt=new T(Pe,et)):H instanceof T&&ue instanceof T&&(at=H,dt=ue),!at||!dt)throw new Error("Invalid arguments");super(at,dt);this._anchor=at,this._active=dt}static isSelection(H){return H instanceof s?!0:H?O.isRange(H)&&T.isPosition(H.anchor)&&T.isPosition(H.active)&&typeof H.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};U=s=je([A],U),e.Selection=U;class V{constructor(H,ue,Pe){if(typeof H!="string"||H.length===0)throw(0,t.illegalArgument)("host");if(typeof ue!="number"||ue===0||Math.round(ue)!==ue)throw(0,t.illegalArgument)("port");if(typeof Pe!="undefined"&&(typeof Pe!="string"||Pe.length===0||!/^[0-9A-Za-z\-]+$/.test(Pe)))throw(0,t.illegalArgument)("connectionToken");this.host=H,this.port=Math.round(ue),this.connectionToken=Pe}}e.ResolvedAuthority=V;class x extends Error{constructor(H,ue=l.RemoteAuthorityResolverErrorCode.Unknown,Pe){super(H);this._message=H,this._code=ue,this._detail=Pe,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,x.prototype)}static NotAvailable(H,ue){return new x(H,l.RemoteAuthorityResolverErrorCode.NotAvailable,ue)}static TemporarilyNotAvailable(H){return new x(H,l.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=x;var N;(function(j){j[j.LF=1]="LF",j[j.CRLF=2]="CRLF"})(N=e.EndOfLine||(e.EndOfLine={}));var $;(function(j){j[j.Replace=1]="Replace",j[j.Append=2]="Append",j[j.Prepend=3]="Prepend"})($=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let B=d=class{constructor(H,ue){this._range=H,this._newText=ue}static isTextEdit(H){return H instanceof d?!0:H?O.isRange(H)&&typeof H.newText=="string":!1}static replace(H,ue){return new d(H,ue)}static insert(H,ue){return d.replace(new O(H,H),ue)}static delete(H){return d.replace(H,"")}static setEndOfLine(H){const ue=new d(new O(new T(0,0),new T(0,0)),"");return ue.newEol=H,ue}get range(){return this._range}set range(H){if(H&&!O.isRange(H))throw(0,t.illegalArgument)("range");this._range=H}get newText(){return this._newText||""}set newText(H){if(H&&typeof H!="string")throw(0,t.illegalArgument)("newText");this._newText=H}get newEol(){return this._newEol}set newEol(H){if(H&&typeof H!="number")throw(0,t.illegalArgument)("newEol");this._newEol=H}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};B=d=je([A],B),e.TextEdit=B;var z;(function(j){j[j.File=1]="File",j[j.Text=2]="Text",j[j.Cell=3]="Cell",j[j.CellReplace=5]="CellReplace"})(z=e.FileEditType||(e.FileEditType={}));let W=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(H,ue,Pe,et){this._edits.push({_type:1,from:H,to:ue,options:Pe,metadata:et})}createFile(H,ue,Pe){this._edits.push({_type:1,from:void 0,to:H,options:ue,metadata:Pe})}deleteFile(H,ue,Pe){this._edits.push({_type:1,from:H,to:void 0,options:ue,metadata:Pe})}replaceNotebookMetadata(H,ue,Pe){this._edits.push({_type:3,metadata:Pe,uri:H,edit:{editType:5,metadata:ue},notebookMetadata:ue})}replaceNotebookCells(H,ue,Pe,et,at){let dt,mt,At=[],Lt;if(Ht.isNotebookRange(ue)&&Bt.isNotebookCellDataArray(Pe)&&!Bt.isNotebookCellDataArray(et)?(dt=ue.start,mt=ue.end,At=Pe,Lt=et):typeof ue=="number"&&typeof Pe=="number"&&Bt.isNotebookCellDataArray(et)&&(dt=ue,mt=Pe,At=et,Lt=at),dt===void 0||mt===void 0)throw new Error("Invalid arguments");(dt!==mt||At.length>0)&&this._edits.push({_type:5,uri:H,index:dt,count:mt-dt,cells:At,metadata:Lt})}replaceNotebookCellMetadata(H,ue,Pe,et){this._edits.push({_type:3,metadata:et,uri:H,edit:{editType:8,index:ue,metadata:Pe}})}replace(H,ue,Pe,et){this._edits.push({_type:2,uri:H,edit:new B(ue,Pe),metadata:et})}insert(H,ue,Pe,et){this.replace(H,new O(ue,ue),Pe,et)}delete(H,ue,Pe){this.replace(H,ue,"",Pe)}has(H){return this._edits.some(ue=>ue._type===2&&ue.uri.toString()===H.toString())}set(H,ue){if(ue)for(const Pe of ue)Pe&&this._edits.push({_type:2,uri:H,edit:Pe});else{for(let Pe=0;Pe<this._edits.length;Pe++){const et=this._edits[Pe];et._type===2&&et.uri.toString()===H.toString()&&(this._edits[Pe]=void 0)}(0,h.coalesceInPlace)(this._edits)}}get(H){const ue=[];for(let Pe of this._edits)Pe._type===2&&Pe.uri.toString()===H.toString()&&ue.push(Pe.edit);return ue}entries(){const H=new y.ResourceMap;for(let ue of this._edits)if(ue._type===2){let Pe=H.get(ue.uri);Pe||(Pe=[ue.uri,[]],H.set(ue.uri,Pe)),Pe[1].push(ue.edit)}return[...H.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};W=je([A],W),e.WorkspaceEdit=W;let Y=n=class{constructor(H){this._tabstop=1,this.value=H||""}static isSnippetString(H){return H instanceof n?!0:H?typeof H.value=="string":!1}static _escape(H){return H.replace(/\$|}|\\/g,"\\$&")}appendText(H){return this.value+=n._escape(H),this}appendTabstop(H=this._tabstop++){return this.value+="$",this.value+=H,this}appendPlaceholder(H,ue=this._tabstop++){if(typeof H=="function"){const Pe=new n;Pe._tabstop=this._tabstop,H(Pe),this._tabstop=Pe._tabstop,H=Pe.value}else H=n._escape(H);return this.value+="${",this.value+=ue,this.value+=":",this.value+=H,this.value+="}",this}appendChoice(H,ue=this._tabstop++){const Pe=H.map(et=>et.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ue,this.value+="|",this.value+=Pe,this.value+="|}",this}appendVariable(H,ue){if(typeof ue=="function"){const Pe=new n;Pe._tabstop=this._tabstop,ue(Pe),this._tabstop=Pe._tabstop,ue=Pe.value}else typeof ue=="string"&&(ue=ue.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=H,ue&&(this.value+=":",this.value+=ue),this.value+="}",this}};Y=n=je([A],Y),e.SnippetString=Y;var ie;(function(j){j[j.Unnecessary=1]="Unnecessary",j[j.Deprecated=2]="Deprecated"})(ie=e.DiagnosticTag||(e.DiagnosticTag={}));var ne;(function(j){j[j.Hint=3]="Hint",j[j.Information=2]="Information",j[j.Warning=1]="Warning",j[j.Error=0]="Error"})(ne=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let J=S=class{constructor(H,ue){if(this.uri=H,ue)if(ue instanceof O)this.range=ue;else if(ue instanceof T)this.range=new O(ue,ue);else throw new Error("Illegal argument")}static isLocation(H){return H instanceof S?!0:H?O.isRange(H.range)&&P.URI.isUri(H.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};J=S=je([A],J),e.Location=J;let K=class{constructor(H,ue){this.location=H,this.message=ue}static is(H){return H?typeof H.message=="string"&&H.location&&O.isRange(H.location.range)&&P.URI.isUri(H.location.uri):!1}static isEqual(H,ue){return H===ue?!0:!H||!ue?!1:H.message===ue.message&&H.location.range.isEqual(ue.location.range)&&H.location.uri.toString()===ue.location.uri.toString()}};K=je([A],K),e.DiagnosticRelatedInformation=K;let oe=class{constructor(H,ue,Pe=ne.Error){if(!O.isRange(H))throw new TypeError("range must be set");if(!ue)throw new TypeError("message must be set");this.range=H,this.message=ue,this.severity=Pe}toJSON(){return{severity:ne[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(H,ue){return H===ue?!0:!H||!ue?!1:H.message===ue.message&&H.severity===ue.severity&&H.code===ue.code&&H.severity===ue.severity&&H.source===ue.source&&H.range.isEqual(ue.range)&&(0,h.equals)(H.tags,ue.tags)&&(0,h.equals)(H.relatedInformation,ue.relatedInformation,K.isEqual)}};oe=je([A],oe),e.Diagnostic=oe;let fe=class{constructor(H,ue){if(!H)throw new Error("Illegal argument, contents must be defined");Array.isArray(H)?this.contents=H:this.contents=[H],this.range=ue}};fe=je([A],fe),e.Hover=fe;var pe;(function(j){j[j.Text=0]="Text",j[j.Read=1]="Read",j[j.Write=2]="Write"})(pe=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Te=class{constructor(H,ue=pe.Text){this.range=H,this.kind=ue}toJSON(){return{range:this.range,kind:pe[this.kind]}}};Te=je([A],Te),e.DocumentHighlight=Te;var xe;(function(j){j[j.File=0]="File",j[j.Module=1]="Module",j[j.Namespace=2]="Namespace",j[j.Package=3]="Package",j[j.Class=4]="Class",j[j.Method=5]="Method",j[j.Property=6]="Property",j[j.Field=7]="Field",j[j.Constructor=8]="Constructor",j[j.Enum=9]="Enum",j[j.Interface=10]="Interface",j[j.Function=11]="Function",j[j.Variable=12]="Variable",j[j.Constant=13]="Constant",j[j.String=14]="String",j[j.Number=15]="Number",j[j.Boolean=16]="Boolean",j[j.Array=17]="Array",j[j.Object=18]="Object",j[j.Key=19]="Key",j[j.Null=20]="Null",j[j.EnumMember=21]="EnumMember",j[j.Struct=22]="Struct",j[j.Event=23]="Event",j[j.Operator=24]="Operator",j[j.TypeParameter=25]="TypeParameter"})(xe=e.SymbolKind||(e.SymbolKind={}));var Ge;(function(j){j[j.Deprecated=1]="Deprecated"})(Ge=e.SymbolTag||(e.SymbolTag={}));let Qe=o=class{constructor(H,ue,Pe,et,at){this.name=H,this.kind=ue,this.containerName=at,typeof Pe=="string"&&(this.containerName=Pe),et instanceof J?this.location=et:Pe instanceof O&&(this.location=new J(et,Pe)),o.validate(this)}static validate(H){if(!H.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:xe[this.kind],location:this.location,containerName:this.containerName}}};Qe=o=je([A],Qe),e.SymbolInformation=Qe;let q=i=class{constructor(H,ue,Pe,et,at){this.name=H,this.detail=ue,this.kind=Pe,this.range=et,this.selectionRange=at,this.children=[],i.validate(this)}static validate(H){if(!H.name)throw new Error("name must not be falsy");if(!H.range.contains(H.selectionRange))throw new Error("selectionRange must be contained in fullRange");H.children&&H.children.forEach(i.validate)}};q=i=je([A],q),e.DocumentSymbol=q;var te;(function(j){j[j.Invoke=1]="Invoke",j[j.Automatic=2]="Automatic"})(te=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let G=class{constructor(H,ue){this.title=H,this.kind=ue}};G=je([A],G),e.CodeAction=G;let Q=r=class{constructor(H){this.value=H}append(H){return new r(this.value?this.value+r.sep+H:H)}intersects(H){return this.contains(H)||H.contains(this)}contains(H){return this.value===H.value||H.value.startsWith(this.value+r.sep)}};Q.sep=".",Q=r=je([A],Q),e.CodeActionKind=Q,Q.Empty=new Q(""),Q.QuickFix=Q.Empty.append("quickfix"),Q.Refactor=Q.Empty.append("refactor"),Q.RefactorExtract=Q.Refactor.append("extract"),Q.RefactorInline=Q.Refactor.append("inline"),Q.RefactorRewrite=Q.Refactor.append("rewrite"),Q.Source=Q.Empty.append("source"),Q.SourceOrganizeImports=Q.Source.append("organizeImports"),Q.SourceFixAll=Q.Source.append("fixAll");let ae=class{constructor(H,ue){if(this.range=H,this.parent=ue,ue&&!ue.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};ae=je([A],ae),e.SelectionRange=ae;class me{constructor(H,ue,Pe,et,at,dt){this.kind=H,this.name=ue,this.detail=Pe,this.uri=et,this.range=at,this.selectionRange=dt}}e.CallHierarchyItem=me;class ke{constructor(H,ue){this.fromRanges=ue,this.from=H}}e.CallHierarchyIncomingCall=ke;class We{constructor(H,ue){this.fromRanges=ue,this.to=H}}e.CallHierarchyOutgoingCall=We;var Je;(function(j){j[j.Information=0]="Information",j[j.Warning=1]="Warning",j[j.Error=2]="Error"})(Je=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let it=class{constructor(H,ue){this.range=H,this.command=ue}get isResolved(){return!!this.command}};it=je([A],it),e.CodeLens=it;let st=c=class{constructor(H,ue=!1){p.set(this,void 0),nt(this,p,new I.MarkdownString(H,{supportThemeIcons:ue}),"f")}static isMarkdownString(H){return H instanceof c?!0:H&&H.appendCodeblock&&H.appendMarkdown&&H.appendText&&H.value!==void 0}get value(){return Fe(this,p,"f").value}set value(H){Fe(this,p,"f").value=H}get isTrusted(){return Fe(this,p,"f").isTrusted}set isTrusted(H){Fe(this,p,"f").isTrusted=H}get supportThemeIcons(){return Fe(this,p,"f").supportThemeIcons}set supportThemeIcons(H){Fe(this,p,"f").supportThemeIcons=H}get supportHtml(){return Fe(this,p,"f").supportHtml}set supportHtml(H){Fe(this,p,"f").supportHtml=H}appendText(H){return Fe(this,p,"f").appendText(H),this}appendMarkdown(H){return Fe(this,p,"f").appendMarkdown(H),this}appendCodeblock(H,ue){return Fe(this,p,"f").appendCodeblock(ue??"",H),this}};p=new WeakMap,st=c=je([A],st),e.MarkdownString=st;let ot=class{constructor(H,ue){this.label=H,this.documentation=ue}};ot=je([A],ot),e.ParameterInformation=ot;let tt=class{constructor(H,ue){this.label=H,this.documentation=ue,this.parameters=[]}};tt=je([A],tt),e.SignatureInformation=tt;let rt=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};rt=je([A],rt),e.SignatureHelp=rt;var gt;(function(j){j[j.Invoke=1]="Invoke",j[j.TriggerCharacter=2]="TriggerCharacter",j[j.ContentChange=3]="ContentChange"})(gt=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Ue;(function(j){j[j.Other=0]="Other",j[j.Type=1]="Type",j[j.Parameter=2]="Parameter"})(Ue=e.InlayHintKind||(e.InlayHintKind={}));let It=class{constructor(H){this.label=H}};It=je([A],It),e.InlayHintLabelPart=It;let ee=class{constructor(H,ue,Pe){this.label=H,this.position=ue,this.kind=Pe}};ee=je([A],ee),e.InlayHint=ee;var re;(function(j){j[j.Invoke=0]="Invoke",j[j.TriggerCharacter=1]="TriggerCharacter",j[j.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(re=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Se;(function(j){j[j.Text=0]="Text",j[j.Method=1]="Method",j[j.Function=2]="Function",j[j.Constructor=3]="Constructor",j[j.Field=4]="Field",j[j.Variable=5]="Variable",j[j.Class=6]="Class",j[j.Interface=7]="Interface",j[j.Module=8]="Module",j[j.Property=9]="Property",j[j.Unit=10]="Unit",j[j.Value=11]="Value",j[j.Enum=12]="Enum",j[j.Keyword=13]="Keyword",j[j.Snippet=14]="Snippet",j[j.Color=15]="Color",j[j.File=16]="File",j[j.Reference=17]="Reference",j[j.Folder=18]="Folder",j[j.EnumMember=19]="EnumMember",j[j.Constant=20]="Constant",j[j.Struct=21]="Struct",j[j.Event=22]="Event",j[j.Operator=23]="Operator",j[j.TypeParameter=24]="TypeParameter",j[j.User=25]="User",j[j.Issue=26]="Issue"})(Se=e.CompletionItemKind||(e.CompletionItemKind={}));var se;(function(j){j[j.Deprecated=1]="Deprecated"})(se=e.CompletionItemTag||(e.CompletionItemTag={}));let ye=class{constructor(H,ue){this.label=H,this.kind=ue}toJSON(){return{label:this.label,kind:this.kind&&Se[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};ye=je([A],ye),e.CompletionItem=ye;let Me=class{constructor(H=[],ue=!1){this.items=H,this.isIncomplete=ue}};Me=je([A],Me),e.CompletionList=Me;let qe=class{constructor(H,ue,Pe){this.text=H,this.range=ue,this.command=Pe}};qe=je([A],qe),e.InlineSuggestion=qe;let Ve=class{constructor(H){this.items=H}};Ve=je([A],Ve),e.InlineSuggestions=Ve;var ut;(function(j){j[j.Active=-1]="Active",j[j.Beside=-2]="Beside",j[j.One=1]="One",j[j.Two=2]="Two",j[j.Three=3]="Three",j[j.Four=4]="Four",j[j.Five=5]="Five",j[j.Six=6]="Six",j[j.Seven=7]="Seven",j[j.Eight=8]="Eight",j[j.Nine=9]="Nine"})(ut=e.ViewColumn||(e.ViewColumn={}));var Le;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(Le=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Ae;(function(j){j[j.Off=0]="Off",j[j.On=1]="On",j[j.Relative=2]="Relative"})(Ae=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var De;(function(j){j[j.Manual=1]="Manual",j[j.AfterDelay=2]="AfterDelay",j[j.FocusOut=3]="FocusOut"})(De=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var ce;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(ce=e.TextEditorRevealType||(e.TextEditorRevealType={}));var de;(function(j){j[j.Keyboard=1]="Keyboard",j[j.Mouse=2]="Mouse",j[j.Command=3]="Command"})(de=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var be;(function(j){j[j.Undo=1]="Undo",j[j.Redo=2]="Redo"})(be=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var Ce;(function(j){j[j.OpenOpen=0]="OpenOpen",j[j.ClosedClosed=1]="ClosedClosed",j[j.OpenClosed=2]="OpenClosed",j[j.ClosedOpen=3]="ClosedOpen"})(Ce=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(j){function H(ue){switch(ue){case"keyboard":return j.Keyboard;case"mouse":return j.Mouse;case"api":return j.Command}}j.fromValue=H}(de=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Oe=class{constructor(H,ue){if(ue&&!P.URI.isUri(ue))throw(0,t.illegalArgument)("target");if(!O.isRange(H)||H.isEmpty)throw(0,t.illegalArgument)("range");this.range=H,this.target=ue}};Oe=je([A],Oe),e.DocumentLink=Oe;let Ke=class{constructor(H,ue,Pe,et){this.red=H,this.green=ue,this.blue=Pe,this.alpha=et}};Ke=je([A],Ke),e.Color=Ke;let $e=class{constructor(H,ue){if(ue&&!(ue instanceof Ke))throw(0,t.illegalArgument)("color");if(!O.isRange(H)||H.isEmpty)throw(0,t.illegalArgument)("range");this.range=H,this.color=ue}};$e=je([A],$e),e.ColorInformation=$e;let Ze=class{constructor(H){if(!H||typeof H!="string")throw(0,t.illegalArgument)("label");this.label=H}};Ze=je([A],Ze),e.ColorPresentation=Ze;var lt;(function(j){j[j.RGB=0]="RGB",j[j.HEX=1]="HEX",j[j.HSL=2]="HSL"})(lt=e.ColorFormat||(e.ColorFormat={}));var ct;(function(j){j[j.Error=0]="Error",j[j.Warning=1]="Warning",j[j.Information=2]="Information"})(ct=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class He{constructor(H,ue,Pe){if(this.startIndex=H,this.length=ue,this.tooltip=Pe,typeof H!="number"||H<0)throw(0,t.illegalArgument)("startIndex");if(typeof ue!="number"||ue<1)throw(0,t.illegalArgument)("length");if(Pe!==void 0&&typeof Pe!="string")throw(0,t.illegalArgument)("tooltip")}}e.TerminalLink=He;var Ee;(function(j){j[j.Panel=1]="Panel",j[j.Editor=2]="Editor"})(Ee=e.TerminalLocation||(e.TerminalLocation={}));class _e{constructor(H){this.options=H,typeof H!="object"&&(0,t.illegalArgument)("options")}}e.TerminalProfile=_e;var he;(function(j){j[j.Always=1]="Always",j[j.Silent=2]="Silent",j[j.Never=3]="Never"})(he=e.TaskRevealKind||(e.TaskRevealKind={}));var X;(function(j){j[j.Shared=1]="Shared",j[j.Dedicated=2]="Dedicated",j[j.New=3]="New"})(X=e.TaskPanelKind||(e.TaskPanelKind={}));let Ie=a=class{constructor(H,ue){if(this.label=ue,typeof H!="string"||typeof ue!="string")throw(0,t.illegalArgument)("name");this._id=H}static from(H){switch(H){case"clean":return a.Clean;case"build":return a.Build;case"rebuild":return a.Rebuild;case"test":return a.Test;default:return}}get id(){return this._id}};Ie.Clean=new a("clean","Clean"),Ie.Build=new a("build","Build"),Ie.Rebuild=new a("rebuild","Rebuild"),Ie.Test=new a("test","Test"),Ie=a=je([A],Ie),e.TaskGroup=Ie;function Ne(j){let H="";for(let ue=0;ue<j.length;ue++)H+=j[ue].replace(/,/g,",,")+",";return H}let Ye=class{constructor(H,ue,Pe){if(typeof H!="string")throw(0,t.illegalArgument)("process");this._args=[],this._process=H,ue!==void 0&&(Array.isArray(ue)?(this._args=ue,this._options=Pe):this._options=ue)}get process(){return this._process}set process(H){if(typeof H!="string")throw(0,t.illegalArgument)("process");this._process=H}get args(){return this._args}set args(H){Array.isArray(H)||(H=[]),this._args=H}get options(){return this._options}set options(H){this._options=H}computeId(){const H=[];if(H.push("process"),this._process!==void 0&&H.push(this._process),this._args&&this._args.length>0)for(let ue of this._args)H.push(ue);return Ne(H)}};Ye=je([A],Ye),e.ProcessExecution=Ye;let Xe=class{constructor(H,ue,Pe){if(this._args=[],Array.isArray(ue)){if(!H)throw(0,t.illegalArgument)("command can't be undefined or null");if(typeof H!="string"&&typeof H.value!="string")throw(0,t.illegalArgument)("command");this._command=H,this._args=ue,this._options=Pe}else{if(typeof H!="string")throw(0,t.illegalArgument)("commandLine");this._commandLine=H,this._options=ue}}get commandLine(){return this._commandLine}set commandLine(H){if(typeof H!="string")throw(0,t.illegalArgument)("commandLine");this._commandLine=H}get command(){return this._command?this._command:""}set command(H){if(typeof H!="string"&&typeof H.value!="string")throw(0,t.illegalArgument)("command");this._command=H}get args(){return this._args}set args(H){this._args=H||[]}get options(){return this._options}set options(H){this._options=H}computeId(){const H=[];if(H.push("shell"),this._commandLine!==void 0&&H.push(this._commandLine),this._command!==void 0&&H.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let ue of this._args)H.push(typeof ue=="string"?ue:ue.value);return Ne(H)}};Xe=je([A],Xe),e.ShellExecution=Xe;var pt;(function(j){j[j.Escape=1]="Escape",j[j.Strong=2]="Strong",j[j.Weak=3]="Weak"})(pt=e.ShellQuoting||(e.ShellQuoting={}));var St;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace"})(St=e.TaskScope||(e.TaskScope={}));class yt{constructor(H){this._callback=H}computeId(){return"customExecution"+(0,L.generateUuid)()}set callback(H){this._callback=H}get callback(){return this._callback}}e.CustomExecution=yt;let ft=u=class{constructor(H,ue,Pe,et,at,dt){this.__deprecated=!1,this._definition=this.definition=H;let mt;typeof ue=="string"?(this._name=this.name=ue,this._source=this.source=Pe,this.execution=et,mt=at,this.__deprecated=!0):ue===St.Global||ue===St.Workspace?(this.target=ue,this._name=this.name=Pe,this._source=this.source=et,this.execution=at,mt=dt):(this.target=ue,this._name=this.name=Pe,this._source=this.source=et,this.execution=at,mt=dt),typeof mt=="string"?(this._problemMatchers=[mt],this._hasDefinedMatchers=!0):Array.isArray(mt)?(this._problemMatchers=mt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(H){this.__id=H}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Ye?this._definition={type:u.ProcessType,id:this._execution.computeId()}:this._execution instanceof Xe?this._definition={type:u.ShellType,id:this._execution.computeId()}:this._execution instanceof yt?this._definition={type:u.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:u.EmptyType,id:(0,L.generateUuid)()}}get definition(){return this._definition}set definition(H){if(H==null)throw(0,t.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=H}get scope(){return this._scope}set target(H){this.clear(),this._scope=H}get name(){return this._name}set name(H){if(typeof H!="string")throw(0,t.illegalArgument)("name");this.clear(),this._name=H}get execution(){return this._execution}set execution(H){H===null&&(H=void 0),this.clear(),this._execution=H;const ue=this._definition.type;(u.EmptyType===ue||u.ProcessType===ue||u.ShellType===ue||u.ExtensionCallbackType===ue)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(H){if(Array.isArray(H))this.clear(),this._problemMatchers=H,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(H){H!==!0&&H!==!1&&(H=!1),this.clear(),this._isBackground=H}get source(){return this._source}set source(H){if(typeof H!="string"||H.length===0)throw(0,t.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=H}get group(){return this._group}set group(H){H===null&&(H=void 0),this.clear(),this._group=H}get detail(){return this._detail}set detail(H){H===null&&(H=void 0),this._detail=H}get presentationOptions(){return this._presentationOptions}set presentationOptions(H){H==null&&(H=Object.create(null)),this.clear(),this._presentationOptions=H}get runOptions(){return this._runOptions}set runOptions(H){H==null&&(H=Object.create(null)),this.clear(),this._runOptions=H}};ft.ExtensionCallbackType="customExecution",ft.ProcessType="process",ft.ShellType="shell",ft.EmptyType="$empty",ft=u=je([A],ft),e.Task=ft;var wt;(function(j){j[j.SourceControl=1]="SourceControl",j[j.Window=10]="Window",j[j.Notification=15]="Notification"})(wt=e.ProgressLocation||(e.ProgressLocation={}));let bt=class{constructor(H,ue=Ut.None){this.collapsibleState=ue,P.URI.isUri(H)?this.resourceUri=H:this.label=H}};bt=je([A],bt),e.TreeItem=bt;var Ut;(function(j){j[j.None=0]="None",j[j.Collapsed=1]="Collapsed",j[j.Expanded=2]="Expanded"})(Ut=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let Pt=class{constructor(H){this._value=H}async asString(){return JSON.stringify(this._value)}};Pt=je([A],Pt),e.TreeDataTransferItem=Pt;let Ft=class{constructor(){this._items=new Map}get(H){return this._items.get(H)}set(H,ue){this._items.set(H,ue)}forEach(H){this._items.forEach(H)}};Ft=je([A],Ft),e.TreeDataTransfer=Ft;let kt=class{constructor(H,ue){this.id=H,this.color=ue}};kt=je([A],kt),e.ThemeIcon=kt,kt.File=new kt("file"),kt.Folder=new kt("folder");let Ct=class{constructor(H){this.id=H}};Ct=je([A],Ct),e.ThemeColor=Ct;var Qt;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace",j[j.WorkspaceFolder=3]="WorkspaceFolder"})(Qt=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Vt=class{constructor(H,ue){if(typeof H!="string"&&(!H||!P.URI.isUri(H)&&!P.URI.isUri(H.uri)))throw(0,t.illegalArgument)("base");if(typeof ue!="string")throw(0,t.illegalArgument)("pattern");typeof H=="string"?this.baseUri=P.URI.file(H):P.URI.isUri(H)?this.baseUri=H:this.baseUri=H.uri,this.pattern=ue}get base(){return this._base}set base(H){this._base=H,this._baseUri=P.URI.file(H)}get baseUri(){return this._baseUri}set baseUri(H){this._baseUri=H,this._base=H.fsPath}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};Vt=je([A],Vt),e.RelativePattern=Vt;let Et=class{constructor(H,ue,Pe,et){this.enabled=typeof H=="boolean"?H:!0,typeof ue=="string"&&(this.condition=ue),typeof Pe=="string"&&(this.hitCondition=Pe),typeof et=="string"&&(this.logMessage=et)}get id(){return this._id||(this._id=(0,L.generateUuid)()),this._id}};Et=je([A],Et),e.Breakpoint=Et;let Xt=class extends Et{constructor(H,ue,Pe,et,at){super(ue,Pe,et,at);if(H===null)throw(0,t.illegalArgument)("location");this.location=H}};Xt=je([A],Xt),e.SourceBreakpoint=Xt;let qt=class extends Et{constructor(H,ue,Pe,et,at){super(ue,Pe,et,at);this.functionName=H}};qt=je([A],qt),e.FunctionBreakpoint=qt;let Yt=class extends Et{constructor(H,ue,Pe,et,at,dt,mt){super(et,at,dt,mt);if(!ue)throw(0,t.illegalArgument)("dataId");this.label=H,this.dataId=ue,this.canPersist=Pe}};Yt=je([A],Yt),e.DataBreakpoint=Yt;let ai=class{constructor(H,ue,Pe){this.command=H,this.args=ue||[],this.options=Pe}};ai=je([A],ai),e.DebugAdapterExecutable=ai;let Rt=class{constructor(H,ue){this.port=H,this.host=ue}};Rt=je([A],Rt),e.DebugAdapterServer=Rt;let Jt=class{constructor(H){this.path=H}};Jt=je([A],Jt),e.DebugAdapterNamedPipeServer=Jt;let li=class{constructor(H){this.implementation=H}};li=je([A],li),e.DebugAdapterInlineImplementation=li;let jt=class{constructor(H,ue){this.range=H,this.expression=ue}};jt=je([A],jt),e.EvaluatableExpression=jt;var Zt;(function(j){j[j.Automatic=0]="Automatic",j[j.Explicit=1]="Explicit"})(Zt=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let vt=class{constructor(H,ue){this.range=H,this.text=ue}};vt=je([A],vt),e.InlineValueText=vt;let ci=class{constructor(H,ue,Pe=!0){this.range=H,this.variableName=ue,this.caseSensitiveLookup=Pe}};ci=je([A],ci),e.InlineValueVariableLookup=ci;let Ot=class{constructor(H,ue){this.range=H,this.expression=ue}};Ot=je([A],Ot),e.InlineValueEvaluatableExpression=Ot;let $t=class{constructor(H,ue){this.frameId=H,this.stoppedLocation=ue}};$t=je([A],$t),e.InlineValueContext=$t;var vi;(function(j){j[j.Changed=1]="Changed",j[j.Created=2]="Created",j[j.Deleted=3]="Deleted"})(vi=e.FileChangeType||(e.FileChangeType={}));let ui=f=class extends Error{constructor(H,ue=C.FileSystemProviderErrorCode.Unknown,Pe){super(P.URI.isUri(H)?H.toString(!0):H);this.code=Pe?.name??"Unknown",(0,C.markAsFileSystemProviderError)(this,ue),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,f.prototype),typeof Error.captureStackTrace=="function"&&typeof Pe=="function"&&Error.captureStackTrace(this,Pe)}static FileExists(H){return new f(H,C.FileSystemProviderErrorCode.FileExists,f.FileExists)}static FileNotFound(H){return new f(H,C.FileSystemProviderErrorCode.FileNotFound,f.FileNotFound)}static FileNotADirectory(H){return new f(H,C.FileSystemProviderErrorCode.FileNotADirectory,f.FileNotADirectory)}static FileIsADirectory(H){return new f(H,C.FileSystemProviderErrorCode.FileIsADirectory,f.FileIsADirectory)}static NoPermissions(H){return new f(H,C.FileSystemProviderErrorCode.NoPermissions,f.NoPermissions)}static Unavailable(H){return new f(H,C.FileSystemProviderErrorCode.Unavailable,f.Unavailable)}};ui=f=je([A],ui),e.FileSystemError=ui;let ei=class{constructor(H,ue,Pe){this.start=H,this.end=ue,this.kind=Pe}};ei=je([A],ei),e.FoldingRange=ei;var Ci;(function(j){j[j.Comment=1]="Comment",j[j.Imports=2]="Imports",j[j.Region=3]="Region"})(Ci=e.FoldingRangeKind||(e.FoldingRangeKind={}));var wi;(function(j){j[j.Collapsed=0]="Collapsed",j[j.Expanded=1]="Expanded"})(wi=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var ti;(function(j){j[j.Editing=0]="Editing",j[j.Preview=1]="Preview"})(ti=e.CommentMode||(e.CommentMode={}));class Di{constructor(H,ue=[]){this.tokenTypes=H,this.tokenModifiers=ue}}e.SemanticTokensLegend=Di;function di(j){return typeof j=="undefined"||(0,D.isStringArray)(j)}class Gt{constructor(H){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,H){this._hasLegend=!0;for(let ue=0,Pe=H.tokenTypes.length;ue<Pe;ue++)this._tokenTypeStrToInt.set(H.tokenTypes[ue],ue);for(let ue=0,Pe=H.tokenModifiers.length;ue<Pe;ue++)this._tokenModifierStrToInt.set(H.tokenModifiers[ue],ue)}}push(H,ue,Pe,et,at){if(typeof H=="number"&&typeof ue=="number"&&typeof Pe=="number"&&typeof et=="number"&&(typeof at=="number"||typeof at=="undefined"))return typeof at=="undefined"&&(at=0),this._pushEncoded(H,ue,Pe,et,at);if(O.isRange(H)&&typeof ue=="string"&&di(Pe))return this._push(H,ue,Pe);throw(0,t.illegalArgument)()}_push(H,ue,Pe){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(H.start.line!==H.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ue))throw new Error("`tokenType` is not in the provided legend");const et=H.start.line,at=H.start.character,dt=H.end.character-H.start.character,mt=this._tokenTypeStrToInt.get(ue);let At=0;if(Pe)for(const Lt of Pe){if(!this._tokenModifierStrToInt.has(Lt))throw new Error("`tokenModifier` is not in the provided legend");const Nt=this._tokenModifierStrToInt.get(Lt);At|=1<<Nt>>>0}this._pushEncoded(et,at,dt,mt,At)}_pushEncoded(H,ue,Pe,et,at){if(this._dataIsSortedAndDeltaEncoded&&(H<this._prevLine||H===this._prevLine&&ue<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const At=this._data.length/5|0;let Lt=0,Nt=0;for(let Wt=0;Wt<At;Wt++){let zt=this._data[5*Wt],gi=this._data[5*Wt+1];zt===0?(zt=Lt,gi+=Nt):zt+=Lt,this._data[5*Wt]=zt,this._data[5*Wt+1]=gi,Lt=zt,Nt=gi}}let dt=H,mt=ue;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(dt-=this._prevLine,dt===0&&(mt-=this._prevChar)),this._data[this._dataLen++]=dt,this._data[this._dataLen++]=mt,this._data[this._dataLen++]=Pe,this._data[this._dataLen++]=et,this._data[this._dataLen++]=at,this._prevLine=H,this._prevChar=ue}static _sortAndDeltaEncode(H){let ue=[];const Pe=H.length/5|0;for(let mt=0;mt<Pe;mt++)ue[mt]=mt;ue.sort((mt,At)=>{const Lt=H[5*mt],Nt=H[5*At];if(Lt===Nt){const Wt=H[5*mt+1],zt=H[5*At+1];return Wt-zt}return Lt-Nt});const et=new Uint32Array(H.length);let at=0,dt=0;for(let mt=0;mt<Pe;mt++){const At=5*ue[mt],Lt=H[At+0],Nt=H[At+1],Wt=H[At+2],zt=H[At+3],gi=H[At+4],xi=Lt-at,Ji=xi===0?Nt-dt:Nt,pi=5*mt;et[pi+0]=xi,et[pi+1]=Ji,et[pi+2]=Wt,et[pi+3]=zt,et[pi+4]=gi,at=Lt,dt=Nt}return et}build(H){return this._dataIsSortedAndDeltaEncoded?new hi(new Uint32Array(this._data),H):new hi(Gt._sortAndDeltaEncode(this._data),H)}}e.SemanticTokensBuilder=Gt;class hi{constructor(H,ue){this.resultId=ue,this.data=H}}e.SemanticTokens=hi;class ki{constructor(H,ue,Pe){this.start=H,this.deleteCount=ue,this.data=Pe}}e.SemanticTokensEdit=ki;class Kt{constructor(H,ue){this.resultId=ue,this.edits=H}}e.SemanticTokensEdits=Kt;var Ii;(function(j){j[j.Separate=0]="Separate",j[j.MergeWithParent=1]="MergeWithParent"})(Ii=e.DebugConsoleMode||(e.DebugConsoleMode={}));var Pi;(function(j){j[j.Initial=1]="Initial",j[j.Dynamic=2]="Dynamic"})(Pi=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let ii=class{constructor(){}};ii.Back={iconPath:new kt("arrow-left")},ii=je([A],ii),e.QuickInputButtons=ii;var Ai;(function(j){j[j.Separator=-1]="Separator",j[j.Default=1]="Default"})(Ai=e.QuickPickItemKind||(e.QuickPickItemKind={}));var fi;(function(j){j[j.UI=1]="UI",j[j.Workspace=2]="Workspace"})(fi=e.ExtensionKind||(e.ExtensionKind={}));class bi{constructor(H,ue,Pe){this.badge=H,this.tooltip=ue,this.color=Pe}static validate(H){if(H.badge){let ue=(0,k.nextCharLength)(H.badge,0);if(ue<H.badge.length&&(ue+=(0,k.nextCharLength)(H.badge,ue)),H.badge.length>ue)throw new Error("The 'badge'-property must be undefined or a short character")}if(!H.color&&!H.badge&&!H.tooltip)throw new Error("The decoration is empty");return!0}}e.FileDecoration=bi;let ni=class{constructor(H){this.kind=H}};ni=je([A],ni),e.ColorTheme=ni;var Be;(function(j){j[j.Light=1]="Light",j[j.Dark=2]="Dark",j[j.HighContrast=3]="HighContrast"})(Be=e.ColorThemeKind||(e.ColorThemeKind={}));class Ht{constructor(H,ue){if(H<0)throw(0,t.illegalArgument)("start must be positive");if(ue<0)throw(0,t.illegalArgument)("end must be positive");H<=ue?(this._start=H,this._end=ue):(this._start=ue,this._end=H)}static isNotebookRange(H){return H instanceof Ht?!0:H?typeof H.start=="number"&&typeof H.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(H){let ue=this._start,Pe=this._end;return H.start!==void 0&&(ue=H.start),H.end!==void 0&&(Pe=H.end),ue===this._start&&Pe===this._end?this:new Ht(ue,Pe)}}e.NotebookRange=Ht;class Bt{constructor(H,ue,Pe,et,at,dt,mt){this.kind=H,this.value=ue,this.languageId=Pe,this.mime=et,this.outputs=at??[],this.metadata=dt,this.executionSummary=mt,Bt.validate(this)}static validate(H){if(typeof H.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof H.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof H.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(H){return Array.isArray(H)&&H.every(ue=>Bt.isNotebookCellData(ue))}static isNotebookCellData(H){return!0}}e.NotebookCellData=Bt;class _t{constructor(H){this.cells=H}}e.NotebookData=_t;class Mt{constructor(H,ue){this.data=H,this.mime=ue;const Pe=(0,R.normalizeMimeType)(ue,!0);if(!Pe)throw new Error(`INVALID mime type: ${ue}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Pe}static isNotebookCellOutputItem(H){return H instanceof Mt?!0:H?typeof H.mime=="string"&&H.data instanceof Uint8Array:!1}static error(H){const ue={name:H.name,message:H.message,stack:H.stack};return Mt.json(ue,"application/vnd.code.notebook.error")}static stdout(H){return Mt.text(H,"application/vnd.code.notebook.stdout")}static stderr(H){return Mt.text(H,"application/vnd.code.notebook.stderr")}static bytes(H,ue="application/octet-stream"){return new Mt(H,ue)}static text(H,ue=R.Mimes.text){const Pe=Fe(Mt,m,"f",b).encode(String(H));return new Mt(Pe,ue)}static json(H,ue="application/json"){const Pe=JSON.stringify(H,void 0,"	");return Mt.text(Pe,ue)}}e.NotebookCellOutputItem=Mt,m=Mt,b={value:new TextEncoder};class ri{constructor(H,ue,Pe){this.items=ri.ensureUniqueMimeTypes(H,!0),typeof ue=="string"?(this.id=ue,this.metadata=Pe):(this.id=(0,L.generateUuid)(),this.metadata=ue??Pe)}static isNotebookCellOutput(H){return H instanceof ri?!0:!H||typeof H!="object"?!1:typeof H.id=="string"&&(0,D.isArray)(H.items)}static ensureUniqueMimeTypes(H,ue=!1){const Pe=new Set,et=new Set;for(let at=0;at<H.length;at++){const dt=H[at],mt=(0,R.normalizeMimeType)(dt.mime);if(!Pe.has(mt)){Pe.add(mt);continue}et.add(at),ue&&console.warn(`DUPLICATED mime type '${dt.mime}' will be dropped`)}return et.size===0?H:H.filter((at,dt)=>!et.has(dt))}}e.NotebookCellOutput=ri;var Ei;(function(j){j[j.Markup=1]="Markup",j[j.Code=2]="Code"})(Ei=e.NotebookCellKind||(e.NotebookCellKind={}));var Si;(function(j){j[j.Idle=1]="Idle",j[j.Pending=2]="Pending",j[j.Executing=3]="Executing"})(Si=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Ti;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(Ti=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Ri;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(Ri=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Li{constructor(H,ue){this.text=H,this.alignment=ue}}e.NotebookCellStatusBarItem=Li;var Fi;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred"})(Fi=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class _i{constructor(H,ue=[]){this.uri=H,this.provides=(0,h.asArray)(ue)}}e.NotebookRendererScript=_i;let mi=class{constructor(H,ue){this.label=H,this.timestamp=ue}};mi=je([A],mi),e.TimelineItem=mi;var Mi;(function(j){j[j.Production=1]="Production",j[j.Development=2]="Development",j[j.Test=3]="Test"})(Mi=e.ExtensionMode||(e.ExtensionMode={}));var Oi;(function(j){j[j.Node=1]="Node",j[j.Webworker=2]="Webworker"})(Oi=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Ni;(function(j){j[j.Other=0]="Other",j[j.Comment=1]="Comment",j[j.String=2]="String",j[j.RegEx=3]="RegEx"})(Ni=e.StandardTokenType||(e.StandardTokenType={}));class Ui{constructor(H,ue){this.ranges=H,this.wordPattern=ue}}e.LinkedEditingRanges=Ui;class le{constructor(H,ue){this._port=H,this._autoForwardAction=ue}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=le;var ge;(function(j){j[j.Queued=1]="Queued",j[j.Running=2]="Running",j[j.Passed=3]="Passed",j[j.Failed=4]="Failed",j[j.Skipped=5]="Skipped",j[j.Errored=6]="Errored"})(ge=e.TestResultState||(e.TestResultState={}));var Re;(function(j){j[j.Run=1]="Run",j[j.Debug=2]="Debug",j[j.Coverage=3]="Coverage"})(Re=e.TestRunProfileKind||(e.TestRunProfileKind={}));let ht=class{constructor(H=void 0,ue=void 0,Pe=void 0){this.include=H,this.exclude=ue,this.profile=Pe}};ht=je([A],ht),e.TestRunRequest=ht;let Dt=v=class{constructor(H){this.message=H}static diff(H,ue,Pe){const et=new v(H);return et.expectedOutput=ue,et.actualOutput=Pe,et}};Dt=v=je([A],Dt),e.TestMessage=Dt;let Tt=class{constructor(H){this.id=H}};Tt=je([A],Tt),e.TestTag=Tt;let si=class{constructor(H,ue){this.covered=H,this.total=ue}};si=je([A],si),e.CoveredCount=si;let Bi=w=class{constructor(H,ue,Pe,et){this.uri=H,this.statementCoverage=ue,this.branchCoverage=Pe,this.functionCoverage=et}static fromDetails(H,ue){const Pe=new si(0,0),et=new si(0,0),at=new si(0,0);for(const mt of ue)if("branches"in mt){Pe.total+=1,Pe.covered+=mt.executionCount>0?1:0;for(const At of mt.branches)et.total+=1,et.covered+=At.executionCount>0?1:0}else at.total+=1,at.covered+=mt.executionCount>0?1:0;const dt=new w(H,Pe,et.total>0?et:void 0,at.total>0?at:void 0);return dt.detailedCoverage=ue,dt}};Bi=w=je([A],Bi),e.FileCoverage=Bi;let Wi=class{constructor(H,ue,Pe=[]){this.executionCount=H,this.location=ue,this.branches=Pe}};Wi=je([A],Wi),e.StatementCoverage=Wi;let $i=class{constructor(H,ue){this.executionCount=H,this.location=ue}};$i=je([A],$i),e.BranchCoverage=$i;let Hi=class{constructor(H,ue){this.executionCount=H,this.location=ue}};Hi=je([A],Hi),e.FunctionCoverage=Hi;var Ki;(function(j){j[j.None=0]="None",j[j.Option=1]="Option",j[j.Default=2]="Default",j[j.Preferred=3]="Preferred"})(Ki=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Qi;(function(j){j[j.Untrusted=0]="Untrusted",j[j.Trusted=1]="Trusted",j[j.Unspecified=2]="Unspecified"})(Qi=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Xi;(function(j){j[j.Notify=1]="Notify",j[j.OpenBrowser=2]="OpenBrowser",j[j.OpenPreview=3]="OpenPreview",j[j.Silent=4]="Silent",j[j.Ignore=5]="Ignore",j[j.OpenBrowserOnce=6]="OpenBrowserOnce"})(Xi=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class Yi{constructor(H,ue,Pe,et,at,dt){this.kind=H,this.name=ue,this.detail=Pe,this.uri=et,this.range=at,this.selectionRange=dt}}e.TypeHierarchyItem=Yi}),define(ve[124],we([0,1,55,10,8,151,110,7,17]),function(Z,e,h,t,I,y,R,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const P=new Map;function L(p,m){m?P.set(p,m):P.delete(p)}e.setWordDefinitionFor=L;function C(p){return P.get(p)}e.getWordDefinitionFor=C;class l extends y.MirrorTextModel{constructor(m,b,F,_,g,s,d,n){super(b,F,_,g);this._proxy=m,this._languageId=s,this._isDirty=d,this._notebook=n,this._isDisposed=!1}dispose(){(0,h.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(m){return(0,D.equals)(this._lines,m)}get document(){if(!this._document){const m=this;this._document={get uri(){return m._uri},get fileName(){return m._uri.fsPath},get isUntitled(){return m._uri.scheme===t.Schemas.untitled},get languageId(){return m._languageId},get version(){return m._versionId},get isClosed(){return m._isDisposed},get isDirty(){return m._isDirty},get notebook(){return m._notebook},save(){return m._save()},getText(b){return b?m._getTextInRange(b):m.getText()},get eol(){return m._eol===`
`?k.EndOfLine.LF:k.EndOfLine.CRLF},get lineCount(){return m._lines.length},lineAt(b){return m._lineAt(b)},offsetAt(b){return m._offsetAt(b)},positionAt(b){return m._positionAt(b)},validateRange(b){return m._validateRange(b)},validatePosition(b){return m._validatePosition(b)},getWordRangeAtPosition(b,F){return m._getWordRangeAtPosition(b,F)}}}return Object.freeze(this._document)}_acceptLanguageId(m){(0,h.ok)(!this._isDisposed),this._languageId=m}_acceptIsDirty(m){(0,h.ok)(!this._isDisposed),this._isDirty=m}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(m){const b=this._validateRange(m);if(b.isEmpty)return"";if(b.isSingleLine)return this._lines[b.start.line].substring(b.start.character,b.end.character);const F=this._eol,_=b.start.line,g=b.end.line,s=[];s.push(this._lines[_].substring(b.start.character));for(let d=_+1;d<g;d++)s.push(this._lines[d]);return s.push(this._lines[g].substring(0,b.end.character)),s.join(F)}_lineAt(m){let b;if(m instanceof k.Position?b=m.line:typeof m=="number"&&(b=m),typeof b!="number"||b<0||b>=this._lines.length||Math.floor(b)!==b)throw new Error("Illegal value for `line`");return new E(b,this._lines[b],b===this._lines.length-1)}_offsetAt(m){return m=this._validatePosition(m),this._ensureLineStarts(),this._lineStarts.getPrefixSum(m.line-1)+m.character}_positionAt(m){m=Math.floor(m),m=Math.max(0,m),this._ensureLineStarts();const b=this._lineStarts.getIndexOf(m),F=this._lines[b.index].length;return new k.Position(b.index,Math.min(b.remainder,F))}_validateRange(m){if(!(m instanceof k.Range))throw new Error("Invalid argument");const b=this._validatePosition(m.start),F=this._validatePosition(m.end);return b===m.start&&F===m.end?m:new k.Range(b.line,b.character,F.line,F.character)}_validatePosition(m){if(!(m instanceof k.Position))throw new Error("Invalid argument");if(this._lines.length===0)return m.with(0,0);let{line:b,character:F}=m,_=!1;if(b<0)b=0,F=0,_=!0;else if(b>=this._lines.length)b=this._lines.length-1,F=this._lines[b].length,_=!0;else{const g=this._lines[b].length;F<0?(F=0,_=!0):F>g&&(F=g,_=!0)}return _?new k.Position(b,F):m}_getWordRangeAtPosition(m,b){const F=this._validatePosition(m);if(!b)b=C(this._languageId);else if((0,I.regExpLeadsToEndlessLoop)(b))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${b.source}' because it matches the empty string.`);const _=(0,R.getWordAtText)(F.character+1,(0,R.ensureValidWordDefinition)(b),this._lines[F.line],0);if(_)return new k.Range(F.line,_.startColumn-1,F.line,_.endColumn-1)}}e.ExtHostDocumentData=l;class E{constructor(m,b,F){this._line=m,this._text=b,this._isLastLine=F}get lineNumber(){return this._line}get text(){return this._text}get range(){return new k.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new k.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=E}),define(ve[202],we([0,1,7,3,112,6,82,24,2,33]),function(Z,e,h,t,I,y,R,k,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class L{constructor(l,E,p,m){this._notebook=p,this._selector=m,this._disposables=new y.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new t.Emitter,this.onDidChange=this._onDidChange.event,this.uri=D.URI.from({scheme:"vscode-concat-doc",path:(0,P.generateUuid)()}),this._init(),this._disposables.add(E.onDidChangeDocument(F=>{const _=this._cellUris.get(F.document.uri);_!==void 0&&(this._cellLengths.setValue(_,this._cells[_].document.getText().length+1),this._cellLines.setValue(_,this._cells[_].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const b=F=>{F===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(l.onDidChangeNotebookCells(F=>b(F.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new k.ResourceMap;const l=[],E=[];for(const p of this._notebook.getCells())p.kind===h.NotebookCellKind.Code&&(!this._selector||(0,R.score)(this._selector,p.document.uri,p.document.languageId,!0))&&(this._cellUris.set(p.document.uri,this._cells.length),this._cells.push(p),l.push(p.document.getText().length+1),E.push(p.document.lineCount));this._cellLengths=new I.PrefixSumComputer(new Uint32Array(l)),this._cellLines=new I.PrefixSumComputer(new Uint32Array(E))}get version(){return this._versionId}getText(l){if(!l){let _="";for(const g of this._cells)_+=g.document.getText()+`
`;return _=_.slice(0,-1),_}if(l.isEmpty)return"";const E=this.locationAt(l.start),p=this.locationAt(l.end),m=this._cellUris.get(E.uri),b=this._cellUris.get(p.uri);if(m===void 0||b===void 0)return"";if(m===b)return this._cells[m].document.getText(new h.Range(E.range.start,p.range.end));const F=[this._cells[m].document.getText(new h.Range(E.range.start,new h.Position(this._cells[m].document.lineCount,0)))];for(let _=m+1;_<b;_++)F.push(this._cells[_].document.getText());return F.push(this._cells[b].document.getText(new h.Range(new h.Position(0,0),p.range.end))),F.join(`
`)}offsetAt(l){const E=this._cellLines.getIndexOf(l.line),p=this._cellLengths.getPrefixSum(E.index-1),m=this._cells[E.index].document.offsetAt(l.with(E.remainder));return p+m}positionAt(l){if(typeof l=="number"){const p=this._cellLengths.getIndexOf(l),m=this._cellLines.getPrefixSum(p.index-1);return this._cells[p.index].document.positionAt(p.remainder).translate(m)}const E=this._cellUris.get(l.uri);if(E!==void 0){const p=this._cellLines.getPrefixSum(E-1);return new h.Position(p+l.range.start.line,l.range.start.character)}return new h.Position(0,0)}locationAt(l){h.Range.isRange(l)||(l=new h.Range(l,l));const E=this._cellLines.getIndexOf(l.start.line);let p=E;l.isEmpty||(p=this._cellLines.getIndexOf(l.end.line));const m=new h.Position(E.remainder,l.start.character),b=new h.Position(p.remainder,l.end.character),F=new h.Range(m,b),_=this._cells[E.index];return new h.Location(_.document.uri,_.document.validateRange(F))}contains(l){return this._cellUris.has(l)}validateRange(l){const E=this.validatePosition(l.start),p=this.validatePosition(l.end);return l.with(E,p)}validatePosition(l){const E=this._cellLines.getIndexOf(l.line),p=new h.Position(E.remainder,l.character),m=this._cells[E.index].document.validatePosition(p),b=this._cellLines.getPrefixSum(E.index-1);return new h.Position(b+m.line,m.character)}}e.ExtHostNotebookConcatDocument=L}),define(ve[203],we([0,1,7,14,3]),function(Z,e,h,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let y=class{constructor(k){this._actual=new h.ColorTheme(h.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new I.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(k){let D=k==="light"?h.ColorThemeKind.Light:k==="dark"?h.ColorThemeKind.Dark:h.ColorThemeKind.HighContrast;this._actual=new h.ColorTheme(D),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};y=je([ze(0,t.IExtHostRpcService)],y),e.ExtHostTheming=y}),define(ve[65],we([0,1,4]),function(Z,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,h.createDecorator)("IURITransformerService");class t{constructor(y){y?(this.transformIncoming=y.transformIncoming.bind(y),this.transformOutgoing=y.transformOutgoing.bind(y),this.transformOutgoingURI=y.transformOutgoingURI.bind(y),this.transformOutgoingScheme=y.transformOutgoingScheme.bind(y)):(this.transformIncoming=R=>R,this.transformOutgoing=R=>R,this.transformOutgoingURI=R=>R,this.transformOutgoingScheme=R=>R)}}e.URITransformerService=t}),define(ve[204],we([0,1,22]),function(Z,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class t{constructor(){this.buffers=[]}add(D){let P=this.buffers.indexOf(D);return P<0&&(P=this.buffers.length,this.buffers.push(D)),P}}function I(k,D){if(D.serializeBuffersForPostMessage){const P=new t,L=(E,p)=>{if(p instanceof ArrayBuffer){const m=P.add(p);return{$$vscode_array_buffer_reference$$:!0,index:m}}else if(ArrayBuffer.isView(p)){const m=y(p);if(m){const b=P.add(p.buffer);return{$$vscode_array_buffer_reference$$:!0,index:b,view:{type:m,byteLength:p.byteLength,byteOffset:p.byteOffset}}}}return p},C=JSON.stringify(k,L),l=P.buffers.map(E=>{const p=new Uint8Array(E);return h.VSBuffer.wrap(p)});return{message:C,buffers:l}}else return{message:JSON.stringify(k),buffers:[]}}e.serializeWebviewMessage=I;function y(k){switch(k.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function R(k,D){const P=D.map(l=>{const E=new ArrayBuffer(l.byteLength);return new Uint8Array(E).set(l.buffer),E}),L=D.length?(l,E)=>{if(typeof E=="object"&&E.$$vscode_array_buffer_reference$$){const p=E,{index:m}=p,b=P[m];if(p.view)switch(p.view.type){case 1:return new Int8Array(b,p.view.byteOffset,p.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(b,p.view.byteOffset,p.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(b,p.view.byteOffset,p.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(b,p.view.byteOffset,p.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(b,p.view.byteOffset,p.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(b,p.view.byteOffset,p.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(b,p.view.byteOffset,p.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(b,p.view.byteOffset,p.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(b,p.view.byteOffset,p.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(b,p.view.byteOffset,p.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(b,p.view.byteOffset,p.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return b}return E}:void 0;return{message:JSON.parse(k,L),arrayBuffers:P}}e.deserializeWebviewMessage=R}),define(ve[205],we([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var h;(function(t){function I(R){const k=new Map;return R.types.forEach((D,P)=>{k.set(D,{asString:async()=>R.items[P].asString})}),k}t.toITreeDataTransfer=I;async function y(R){const k={types:[],items:[]},D=Array.from(R.entries());for(const P of D)k.types.push(P[0]),k.items.push({asString:await P[1].asString()});return k}t.toTreeDataTransferDTO=y})(h=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(ve[87],we([0,1,10,2]),function(Z,e,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function I(k,D){return k.scheme===h.Schemas.http||k.scheme===h.Schemas.https?k:(D&&D.authority&&D.isRemote&&k.scheme===h.Schemas.file&&(k=t.URI.from({scheme:h.Schemas.vscodeRemote,authority:D.authority,path:k.path})),t.URI.from({scheme:h.Schemas.https,authority:`${k.scheme}+${y(k.authority)}.${e.webviewRootResourceAuthority}`,path:k.path,fragment:k.fragment,query:k.query}))}e.asWebviewUri=I;function y(k){return k.replace(/./g,D=>{const P=D.charCodeAt(0);return P>=97&&P<=122||P>=65&&P<=90||P>=48&&P<=57?D:"-"+P.toString(16).padStart(4,"0")})}function R(k){return k.replace(/-([0-9a-f]{4})/g,(D,P)=>String.fromCharCode(parseInt(P,16)))}e.decodeAuthority=R}),define(ve[206],we([0,1,3,6,87]),function(Z,e,h,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class y{constructor(k,D,P){this._proxy=k,this._editors=D,this._initData=P,this._handlePool=0,this._disposables=new t.DisposableStore,this._insets=new Map,this._disposables.add(D.onDidChangeVisibleTextEditors(()=>{const L=D.getVisibleTextEditors();for(const C of this._insets.values())L.indexOf(C.editor)<0&&C.inset.dispose()}))}dispose(){this._insets.forEach(k=>k.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(k,D,P,L,C){let l;for(const g of this._editors.getVisibleTextEditors(!0))if(g.value===k){l=g;break}if(!l)throw new Error("not a visible editor");const E=this,p=this._handlePool++,m=new h.Emitter,b=new h.Emitter,F=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(g){return(0,I.asWebviewUri)(g,E._initData.remote)}get cspSource(){return I.webviewGenericCspSource}set options(g){this._options=g,E._proxy.$setOptions(p,g)}get options(){return this._options}set html(g){this._html=g,E._proxy.$setHtml(p,g)}get html(){return this._html}get onDidReceiveMessage(){return m.event}postMessage(g){return E._proxy.$postMessage(p,g)}},_=new class{constructor(){this.editor=k,this.line=D,this.height=P,this.webview=F,this.onDidDispose=b.event}dispose(){E._insets.has(p)&&(E._insets.delete(p),E._proxy.$disposeEditorInset(p),b.fire(),b.dispose(),m.dispose())}};return this._proxy.$createEditorInset(p,l.id,l.value.document.uri,D+1,P,L||{},C.identifier,C.extensionLocation),this._insets.set(p,{editor:k,inset:_,onDidReceiveMessage:m}),_}$onDidDispose(k){const D=this._insets.get(k);D&&D.inset.dispose()}$onDidReceiveMessage(k,D){const P=this._insets.get(k);P&&P.onDidReceiveMessage.fire(D)}}e.ExtHostEditorInsets=y}),define(ve[207],we([0,1,173,18,2,6,4,62,50,42,17,10]),function(Z,e,h,t,I,y,R,k,D,P,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.EditorTabsVisibleContext=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLockedContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.SideBySideEditorActiveContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorCanSplitInGroupContext=e.ActiveEditorCanRevertContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,h.localize)(0,null),providerDisplayName:(0,h.localize)(1,null)},e.ActiveEditorDirtyContext=new k.RawContextKey("activeEditorIsDirty",!1,(0,h.localize)(2,null)),e.ActiveEditorPinnedContext=new k.RawContextKey("activeEditorIsNotPreview",!1,(0,h.localize)(3,null)),e.ActiveEditorStickyContext=new k.RawContextKey("activeEditorIsPinned",!1,(0,h.localize)(4,null)),e.ActiveEditorReadonlyContext=new k.RawContextKey("activeEditorIsReadonly",!1,(0,h.localize)(5,null)),e.ActiveEditorCanRevertContext=new k.RawContextKey("activeEditorCanRevert",!1,(0,h.localize)(6,null)),e.ActiveEditorCanSplitInGroupContext=new k.RawContextKey("activeEditorCanSplitInGroup",!0),e.ActiveEditorContext=new k.RawContextKey("activeEditor",null,{type:"string",description:(0,h.localize)(7,null)}),e.ActiveEditorAvailableEditorIdsContext=new k.RawContextKey("activeEditorAvailableEditorIds","",(0,h.localize)(8,null)),e.TextCompareEditorVisibleContext=new k.RawContextKey("textCompareEditorVisible",!1,(0,h.localize)(9,null)),e.TextCompareEditorActiveContext=new k.RawContextKey("textCompareEditorActive",!1,(0,h.localize)(10,null)),e.SideBySideEditorActiveContext=new k.RawContextKey("sideBySideEditorActive",!1,(0,h.localize)(11,null)),e.EditorGroupEditorsCountContext=new k.RawContextKey("groupEditorsCount",0,(0,h.localize)(12,null)),e.ActiveEditorGroupEmptyContext=new k.RawContextKey("activeEditorGroupEmpty",!1,(0,h.localize)(13,null)),e.ActiveEditorGroupIndexContext=new k.RawContextKey("activeEditorGroupIndex",0,(0,h.localize)(14,null)),e.ActiveEditorGroupLastContext=new k.RawContextKey("activeEditorGroupLast",!1,(0,h.localize)(15,null)),e.ActiveEditorGroupLockedContext=new k.RawContextKey("activeEditorGroupLocked",!1,(0,h.localize)(16,null)),e.MultipleEditorGroupsContext=new k.RawContextKey("multipleEditorGroups",!1,(0,h.localize)(17,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new k.RawContextKey("editorIsOpen",!1,(0,h.localize)(18,null)),e.InEditorZenModeContext=new k.RawContextKey("inZenMode",!1,(0,h.localize)(19,null)),e.IsCenteredLayoutContext=new k.RawContextKey("isCenteredLayout",!1,(0,h.localize)(20,null)),e.SplitEditorsVertically=new k.RawContextKey("splitEditorsVertically",!1,(0,h.localize)(21,null)),e.EditorAreaVisibleContext=new k.RawContextKey("editorAreaVisible",!0,(0,h.localize)(22,null)),e.EditorTabsVisibleContext=new k.RawContextKey("editorTabsVisible",!0,(0,h.localize)(23,null)),e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function l(O,U,V){for(const x of V.visibleEditorPanes)if(x.group.id===U&&O.matches(x.input))return x.getViewState()}e.findViewStateForEditor=l;function E(O){if(d(O))return!1;const U=O;return I.URI.isUri(U?.resource)}e.isResourceEditorInput=E;function p(O){if(d(O))return!1;const U=O;return U?.original!==void 0&&U.modified!==void 0}e.isResourceDiffEditorInput=p;function m(O){if(d(O)||p(O))return!1;const U=O;return U?.primary!==void 0&&U.secondary!==void 0}e.isResourceSideBySideEditorInput=m;function b(O){if(d(O))return!1;const U=O;return U?U.resource===void 0||U.resource.scheme===C.Schemas.untitled||U.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=b;var F;(function(O){O[O.SHORT=0]="SHORT",O[O.MEDIUM=1]="MEDIUM",O[O.LONG=2]="LONG"})(F=e.Verbosity||(e.Verbosity={}));var _;(function(O){O[O.EXPLICIT=1]="EXPLICIT",O[O.AUTO=2]="AUTO",O[O.FOCUS_CHANGE=3]="FOCUS_CHANGE",O[O.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(_=e.SaveReason||(e.SaveReason={}));var g;(function(O){O[O.None=0]="None",O[O.Readonly=2]="Readonly",O[O.Untitled=4]="Untitled",O[O.Singleton=8]="Singleton",O[O.RequiresTrust=16]="RequiresTrust",O[O.CanSplitInGroup=32]="CanSplitInGroup",O[O.ForceDescription=64]="ForceDescription"})(g=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class s extends y.Disposable{}e.AbstractEditorInput=s;function d(O){return O instanceof s}e.isEditorInput=d;function n(O){const U=O;return I.URI.isUri(U?.preferredResource)}function S(O){const U=O;return d(U?.primary)&&d(U?.secondary)}e.isSideBySideEditorInput=S;function o(O){const U=O;return d(U?.modified)&&d(U?.original)}e.isDiffEditorInput=o;function i(O){return d(O?.editor)}e.isEditorInputWithOptions=i;function r(O){const U=O;return i(O)&&U?.group!==void 0}e.isEditorInputWithOptionsAndGroup=r;function c(O){const U=O;return typeof U?.groupId=="number"&&d(U.editor)}e.isEditorIdentifier=c;var a;(function(O){O[O.UNKNOWN=0]="UNKNOWN",O[O.REPLACE=1]="REPLACE",O[O.MOVE=2]="MOVE",O[O.UNPIN=3]="UNPIN"})(a=e.EditorCloseContext||(e.EditorCloseContext={}));var u;(function(O){O[O.GROUP_ACTIVE=0]="GROUP_ACTIVE",O[O.GROUP_INDEX=1]="GROUP_INDEX",O[O.GROUP_LOCKED=2]="GROUP_LOCKED",O[O.EDITOR_OPEN=3]="EDITOR_OPEN",O[O.EDITOR_CLOSE=4]="EDITOR_CLOSE",O[O.EDITOR_MOVE=5]="EDITOR_MOVE",O[O.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",O[O.EDITOR_LABEL=7]="EDITOR_LABEL",O[O.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",O[O.EDITOR_PIN=9]="EDITOR_PIN",O[O.EDITOR_STICKY=10]="EDITOR_STICKY",O[O.EDITOR_DIRTY=11]="EDITOR_DIRTY",O[O.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(u=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var f;(function(O){O[O.PRIMARY=1]="PRIMARY",O[O.SECONDARY=2]="SECONDARY",O[O.BOTH=3]="BOTH",O[O.ANY=4]="ANY"})(f=e.SideBySideEditor||(e.SideBySideEditor={}));class v{getOriginalUri(U,V){if(!U)return;if(V?.supportSideBySide){const{primary:N,secondary:$}=this.getSideEditors(U);if(N&&$){if(V?.supportSideBySide===f.BOTH)return{primary:this.getOriginalUri(N,{filterByScheme:V.filterByScheme}),secondary:this.getOriginalUri($,{filterByScheme:V.filterByScheme})};if(V?.supportSideBySide===f.ANY)return this.getOriginalUri(N,{filterByScheme:V.filterByScheme})??this.getOriginalUri($,{filterByScheme:V.filterByScheme});U=V.supportSideBySide===f.PRIMARY?N:$}}if(p(U)||m(U))return;const x=n(U)?U.preferredResource:U.resource;return!x||!V||!V.filterByScheme?x:this.filterUri(x,V.filterByScheme)}getSideEditors(U){return S(U)||m(U)?{primary:U.primary,secondary:U.secondary}:o(U)||p(U)?{primary:U.modified,secondary:U.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(U,V){if(!U)return;if(V?.supportSideBySide){const{primary:N,secondary:$}=this.getSideEditors(U);if(N&&$){if(V?.supportSideBySide===f.BOTH)return{primary:this.getCanonicalUri(N,{filterByScheme:V.filterByScheme}),secondary:this.getCanonicalUri($,{filterByScheme:V.filterByScheme})};if(V?.supportSideBySide===f.ANY)return this.getCanonicalUri(N,{filterByScheme:V.filterByScheme})??this.getCanonicalUri($,{filterByScheme:V.filterByScheme});U=V.supportSideBySide===f.PRIMARY?N:$}}if(p(U)||m(U))return;const x=U.resource;return!x||!V||!V.filterByScheme?x:this.filterUri(x,V.filterByScheme)}filterUri(U,V){if(Array.isArray(V)){if(V.some(x=>U.scheme===x))return U}else if(V===U.scheme)return U}}e.EditorResourceAccessor=new v;var w;(function(O){O[O.LEFT=0]="LEFT",O[O.RIGHT=1]="RIGHT"})(w=e.CloseDirection||(e.CloseDirection={}));class A{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(U){const V=this.instantiationService=U.get(R.IInstantiationService);for(const[x,N]of this.editorSerializerConstructors)this.createEditorSerializer(x,N,V);this.editorSerializerConstructors.clear()}createEditorSerializer(U,V,x){const N=x.createInstance(V);this.editorSerializerInstances.set(U,N)}registerFileEditorFactory(U){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=U}getFileEditorFactory(){return(0,t.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(U,V){if(this.editorSerializerConstructors.has(U)||this.editorSerializerInstances.has(U))throw new Error(`A editor serializer with type ID '${U}' was already registered.`);return this.instantiationService?this.createEditorSerializer(U,V,this.instantiationService):this.editorSerializerConstructors.set(U,V),(0,y.toDisposable)(()=>{this.editorSerializerConstructors.delete(U),this.editorSerializerInstances.delete(U)})}getEditorSerializer(U){return this.editorSerializerInstances.get(typeof U=="string"?U:U.typeId)}}D.Registry.add(e.EditorExtensions.EditorFactory,new A);async function M(O,U){if(!O||!O.length)return[];const V=await Promise.all(O.map(async x=>{const N=I.URI.revive(x.fileUri);if(!N||!await U.canHandleResource(N))return;let B=x.exists,z=x.type;if(typeof B!="boolean"||typeof z!="number")try{z=(await U.resolve(N)).isDirectory?P.FileType.Directory:P.FileType.Unknown,B=!0}catch{B=!1}if(!B&&x.openOnlyIfExists||z===P.FileType.Directory)return;const W={selection:B?x.selection:void 0,pinned:!0,override:x.editorOverrideId};let Y;return B?Y={resource:N,options:W}:Y={resource:N,options:W,forceUntitled:!0},Y}));return(0,L.coalesce)(V)}e.pathsToEditors=M;var T;(function(O){O[O.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",O[O.SEQUENTIAL=1]="SEQUENTIAL"})(T=e.EditorsOrder||(e.EditorsOrder={}))}),define(ve[125],we([0,1,3,13,174]),function(Z,e,h,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class y{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new h.Emitter,this._onExit=new h.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(k){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=k}onEvent(k){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=k}onRequest(k){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=k}sendResponse(k){k.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${k.command}`)):this.internalSend("response",k)}sendRequest(k,D,P,L){const C={command:k};if(D&&Object.keys(D).length>0&&(C.arguments=D),this.internalSend("request",C),typeof L=="number"){const l=setTimeout(()=>{clearTimeout(l);const E=this.pendingRequests.get(C.seq);if(E){this.pendingRequests.delete(C.seq);const p={type:"response",seq:0,request_seq:C.seq,success:!1,command:k,message:(0,I.localize)(0,null,L,k)};E(p)}},L)}return P&&this.pendingRequests.set(C.seq,P),C.seq}acceptMessage(k){this.messageCallback?this.messageCallback(k):(this.queue.push(k),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(k,D){return k.type!=="event"||D.type!=="event"}async processQueue(){let k;for(;this.queue.length;){if((!k||this.needsTaskBoundaryBetween(this.queue[0],k))&&await(0,t.timeout)(0),k=this.queue.shift(),!k)return;switch(k.type){case"event":this.eventCallback&&this.eventCallback(k);break;case"request":this.requestCallback&&this.requestCallback(k);break;case"response":{const D=k,P=this.pendingRequests.get(D.request_seq);P&&(this.pendingRequests.delete(D.request_seq),P(D));break}}}}internalSend(k,D){D.type=k,D.seq=this.sequence++,this.sendMessage(D)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const k=new Map;this.pendingRequests.forEach((D,P)=>k.set(P,D)),await(0,t.timeout)(500),k.forEach((D,P)=>{D({type:"response",seq:0,request_seq:P,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(P)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=y}),define(ve[208],we([0,1,8,2,9,25,10]),function(Z,e,h,t,I,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const k=/{([^}]+)}/g;function D(o,i,r){return o.replace(k,function(c,a){return i&&a.length>0&&a[0]!=="_"?c:r&&r.hasOwnProperty(a)?r[a]:c})}e.formatPII=D;function P(o){const i={};for(const r of Object.keys(o))r.startsWith("!")||(i[r]=o[r]);return i}e.filterExceptionsFromTelemetry=P;function L(o){return o.configuration.request==="attach"&&!C(o)&&(!o.parentSession||L(o.parentSession))}e.isSessionAttach=L;function C(o){let i=o.configuration.type;if(!!i)return i==="vslsShare"&&(i=o.configuration.adapterProxy.configuration.type),(0,h.equalsIgnoreCase)(i,"extensionhost")||(0,h.equalsIgnoreCase)(i,"pwa-extensionhost")?o:o.parentSession?C(o.parentSession):void 0}e.getExtensionHostDebugSession=C;function l(o){return o.type&&(o.label||o.program||o.runtime)}e.isDebuggerMainContribution=l;function E(o,i,r){let c,a=0;const u=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let f=null;for(;f=u.exec(o);){const v=f.index+1,w=v+f[0].length;if(v<=i&&w>=r){c=f[0],a=v;break}}if(c){const v=/\w+/g;let w=null;for(;(w=v.exec(c))&&!(w.index+1+a+w[0].length>=r););w&&(c=c.substring(0,v.lastIndex))}return c?{start:a,end:a+c.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=E;const p=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function m(o){return!!(o&&o.match(p))}e.isUri=m;function b(o){if(typeof o.path=="string"&&!(typeof o.sourceReference=="number"&&o.sourceReference>0)){if(m(o.path))return t.URI.parse(o.path);if((0,I.isAbsolute)(o.path))return t.URI.file(o.path)}return o.path}function F(o){if(typeof o.path=="object"){const i=t.URI.revive(o.path);if(i)return i.scheme===R.Schemas.file?i.fsPath:i.toString()}return o.path}function _(o,i){const r=i?b:F,c=(0,y.deepClone)(o);return s(c,(a,u)=>{a&&u&&(u.path=r(u))}),c}e.convertToDAPaths=_;function g(o,i){const r=i?b:F,c=(0,y.deepClone)(o);return s(c,(a,u)=>{!a&&u&&(u.path=r(u))}),c}e.convertToVSCPaths=g;function s(o,i){switch(o.type){case"event":{const r=o;switch(r.event){case"output":i(!1,r.body.source);break;case"loadedSource":i(!1,r.body.source);break;case"breakpoint":i(!1,r.body.breakpoint.source);break;default:break}break}case"request":{const r=o;switch(r.command){case"setBreakpoints":i(!0,r.arguments.source);break;case"breakpointLocations":i(!0,r.arguments.source);break;case"source":i(!0,r.arguments.source);break;case"gotoTargets":i(!0,r.arguments.source);break;case"launchVSCode":r.arguments.args.forEach(c=>i(!1,c));break;default:break}break}case"response":{const r=o;if(r.success&&r.body)switch(r.command){case"stackTrace":r.body.stackFrames.forEach(c=>i(!1,c.source));break;case"loadedSources":r.body.sources.forEach(c=>i(!1,c));break;case"scopes":r.body.scopes.forEach(c=>i(!1,c.source));break;case"setFunctionBreakpoints":r.body.breakpoints.forEach(c=>i(!1,c.source));break;case"setBreakpoints":r.body.breakpoints.forEach(c=>i(!1,c.source));break;default:break}break}}}function d(o){return o.filter(i=>!i.presentation?.hidden).sort((i,r)=>i.presentation?r.presentation?i.presentation.group?r.presentation.group?i.presentation.group!==r.presentation.group?i.presentation.group.localeCompare(r.presentation.group):n(i.presentation.order,r.presentation.order):-1:r.presentation.group?1:n(i.presentation.order,r.presentation.order):-1:r.presentation?1:0)}e.getVisibleAndSorted=d;function n(o,i){return typeof o!="number"?typeof i!="number"?0:1:typeof i!="number"?-1:o-i}async function S(o,i){const r=o.getValue("debug.saveBeforeStart",{overrideIdentifier:i.activeTextEditorLanguageId});if(r!=="none"&&(await i.saveAll(),r==="allEditorsInActiveGroup")){const c=i.activeEditorPane;c&&c.input.resource?.scheme===R.Schemas.untitled&&await i.save({editor:c.input,groupId:c.group.id})}await o.reloadConfiguration()}e.saveAllBeforeDebugStart=S}),define(ve[209],we([0,1,30,37,175,126,9,8,25,11,194,125]),function(Z,e,h,t,I,y,R,k,D,P,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class l extends C.AbstractDebugAdapter{constructor(){super();this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(_,g){this.outputStream=g,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,_.on("data",s=>this.handleData(s))}sendMessage(_){if(this.outputStream){const g=JSON.stringify(_);this.outputStream.write(`Content-Length: ${Buffer.byteLength(g,"utf8")}${l.TWO_CRLF}${g}`,"utf8")}}handleData(_){for(this.rawData=Buffer.concat([this.rawData,_]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const g=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,g.length>0)try{this.acceptMessage(JSON.parse(g))}catch(s){this._onError.fire(new Error((s.message||s)+`
`+g))}continue}}else{const g=this.rawData.indexOf(l.TWO_CRLF);if(g!==-1){const d=this.rawData.toString("utf8",0,g).split(l.HEADER_LINESEPARATOR);for(const n of d){const S=n.split(l.HEADER_FIELDSEPARATOR);S[0]==="Content-Length"&&(this.contentLength=Number(S[1]))}this.rawData=this.rawData.slice(g+l.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=l,l.TWO_CRLF=`\r
\r
`,l.HEADER_LINESEPARATOR=/\r?\n/,l.HEADER_FIELDSEPARATOR=/: */;class E extends l{startSession(){return new Promise((_,g)=>{let s=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),_(),s=!0}),this.socket.on("close",()=>{s?this._onError.fire(new Error("connection closed")):g(new Error("connection closed"))}),this.socket.on("error",d=>{s?this._onError.fire(d):g(d)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=E;class p extends E{constructor(_){super();this.adapterServer=_}createConnection(_){return y.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",_)}}e.SocketDebugAdapter=p;class m extends E{constructor(_){super();this.adapterServer=_}createConnection(_){return y.createConnection(this.adapterServer.path,_)}}e.NamedPipeDebugAdapter=m;class b extends l{constructor(_,g,s){super();this.adapterExecutable=_,this.debugType=g,this.outputService=s}async startSession(){const _=this.adapterExecutable.command,g=this.adapterExecutable.args,s=this.adapterExecutable.options||{};try{if(_)if(R.isAbsolute(_)){if(!await h.Promises.exists(_))throw new Error(I.localize(0,null,_))}else _.indexOf("/")<0&&_.indexOf("\\")<0;else throw new Error(I.localize(1,null,this.debugType));let d=process.env;if(s.env&&Object.keys(s.env).length>0&&(d=D.mixin(D.deepClone(process.env),s.env)),_==="node")if(Array.isArray(g)&&g.length>0){const S=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,o={env:d,execArgv:S?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};s.cwd&&(o.cwd=s.cwd);const i=t.fork(g[0],g.slice(1),o);if(!i.pid)throw new Error(I.localize(2,null,g[0]));this.serverProcess=i}else throw new Error(I.localize(3,null));else{const S={env:d};s.cwd&&(S.cwd=s.cwd),this.serverProcess=t.spawn(_,g,S)}this.serverProcess.on("error",S=>{this._onError.fire(S)}),this.serverProcess.on("exit",(S,o)=>{this._onExit.fire(S)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",S=>{this._onError.fire(S)}),this.serverProcess.stdin.on("error",S=>{this._onError.fire(S)});const n=this.outputService;if(n){const S=o=>o.toString().replace(/\r?\n$/mg,"");this.serverProcess.stderr.on("data",o=>{const i=n.getChannel(L.ExtensionsChannelId);i&&i.append(S(o))})}else this.serverProcess.stderr.resume();this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(d){this._onError.fire(d)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),P.isWindows?new Promise((_,g)=>{const s=t.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(d,n,S){if(d)return g(d)});s.on("exit",_),s.on("error",g)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(_,g){if(!_)return;const s=Object.create(null);_.runtime&&(_.runtime.indexOf("./")===0?s.runtime=R.join(g,_.runtime):s.runtime=_.runtime),_.runtimeArgs&&(s.runtimeArgs=_.runtimeArgs),_.program&&(R.isAbsolute(_.program)?s.program=_.program:s.program=R.join(g,_.program)),_.args&&(s.args=_.args);const d=_;return d.win&&(s.win=b.extract(d.win,g)),d.winx86&&(s.winx86=b.extract(d.winx86,g)),d.windows&&(s.windows=b.extract(d.windows,g)),d.osx&&(s.osx=b.extract(d.osx,g)),d.linux&&(s.linux=b.extract(d.linux,g)),s}static platformAdapterExecutable(_,g){let s=Object.create(null);g=g.toLowerCase();for(const r of _)if(r.contributes){const c=r.contributes.debuggers;c&&c.length>0&&c.filter(a=>typeof a.type=="string"&&k.equalsIgnoreCase(a.type,g)).forEach(a=>{const u=b.extract(a,r.extensionLocation.fsPath);s=D.mixin(s,u,r.isBuiltin)})}let d;P.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?d=s.winx86||s.win||s.windows:P.isWindows?d=s.win||s.windows:P.isMacintosh?d=s.osx:P.isLinux&&(d=s.linux),d=d||s;const n=d.program||s.program,S=d.args||s.args,o=d.runtime||s.runtime,i=d.runtimeArgs||s.runtimeArgs;if(o)return{type:"executable",command:o,args:(i||[]).concat(typeof n=="string"?[n]:[]).concat(S||[])};if(n)return{type:"executable",command:n,args:S||[]}}}e.ExecutableDebugAdapter=b}),define(ve[210],we([0,1,37,11,29,186]),function(Z,e,h,t,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=e.runInExternalTerminal=void 0;function R(l,E){return new Promise((p,m)=>{let b="";const F=h.spawn(l,E);F.pid&&F.stdout.on("data",_=>{b+=_.toString()}),F.on("error",_=>{m(_)}),F.on("close",_=>{p(b)})})}let k;function D(l,E){if(!k)if(t.isWindows)k=new y.WindowsExternalTerminalService;else if(t.isMacintosh)k=new y.MacExternalTerminalService;else if(t.isLinux)k=new y.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const p=E.getConfiguration("terminal");return k.runInTerminal(l.title,l.cwd,l.args,l.env||{},p.external||{})}e.runInExternalTerminal=D;async function P(l){if(l)if(t.isWindows){const E=await new Promise((p,m)=>{Z(["windows-process-tree"],p,m)});return new Promise(p=>{E.getProcessTree(l,m=>{p(m.children.length>0)})})}else return R("/usr/bin/pgrep",["-lP",String(l)]).then(E=>{const p=E.trim();return!(p.length===0||p.indexOf(" tmux")>=0)},E=>!0);return Promise.resolve(!0)}e.hasChildProcesses=P;var L;(function(l){l[l.cmd=0]="cmd",l[l.powershell=1]="powershell",l[l.bash=2]="bash"})(L||(L={}));function C(l,E,p,m){l=l.trim().toLowerCase();let b;l.indexOf("powershell")>=0||l.indexOf("pwsh")>=0?b=1:l.indexOf("cmd.exe")>=0?b=0:l.indexOf("bash")>=0?b=2:t.isWindows?b=0:b=2;let F,_=" ";switch(b){case 1:if(F=g=>(g=g.replace(/\'/g,"''"),g.length>0&&g.charAt(g.length-1)==="\\"?`'${g}\\'`:`'${g}'`),p){const g=(0,I.getDriveLetter)(p);g&&(_+=`${g}:; `),_+=`cd ${F(p)}; `}if(m)for(const g in m){const s=m[g];s===null?_+=`Remove-Item env:${g}; `:_+=`\${env:${g}}='${s}'; `}if(E.length>0){const g=F(E.shift());_+=g[0]==="'"?`& ${g} `:`${g} `;for(const s of E)_+=`${F(s)} `}break;case 0:if(F=g=>(g=g.replace(/\"/g,'""'),g.indexOf(" ")>=0||g.indexOf('"')>=0||g.length===0?`"${g}"`:g),p){const g=(0,I.getDriveLetter)(p);g&&(_+=`${g}: && `),_+=`cd ${F(p)} && `}if(m){_+='cmd /C "';for(const g in m){let s=m[g];s===null?_+=`set "${g}=" && `:(s=s.replace(/[\^\&\|\<\>]/g,d=>`^${d}`),_+=`set "${g}=${s}" && `)}}for(const g of E)_+=`${F(g)} `;m&&(_+='"');break;case 2:{F=s=>(s=s.replace(/(["'\\\$])/g,"\\$1"),s.indexOf(" ")>=0||s.indexOf(";")>=0||s.length===0?`"${s}"`:s);const g=s=>/[^\w@%\/+=,.:^-]/.test(s)?`'${s.replace(/'/g,"'\\''")}'`:s;if(p&&(_+=`cd ${F(p)} ; `),m){_+="/usr/bin/env";for(const s in m){const d=m[s];d===null?_+=` -u ${g(s)}`:_+=` ${g(`${s}=${d}`)}`}_+=" "}for(const s of E)_+=`${F(s)} `;break}}return _}e.prepareCommand=C}),define(ve[127],we([0,1,32,78,95,10,9,11,62]),function(Z,e,h,t,I,y,R,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var P;(function(v){v[v.Markup=1]="Markup",v[v.Code=2]="Code"})(P=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",I.Mimes.latex,I.Mimes.markdown,"image/png","image/jpeg",I.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[I.Mimes.latex,I.Mimes.markdown,"application/json",I.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var L;(function(v){v[v.Running=1]="Running",v[v.Idle=2]="Idle"})(L=e.NotebookRunState||(e.NotebookRunState={}));var C;(function(v){v[v.Pending=2]="Pending",v[v.Executing=3]="Executing"})(C=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var l;(function(v){v[v.WithHardKernelDependency=0]="WithHardKernelDependency",v[v.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",v[v.Pure=2]="Pure",v[v.Never=3]="Never"})(l=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var E;(function(v){v.Always="always",v.Never="never",v.Optional="optional"})(E=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var p;(function(v){v[v.ModelChange=1]="ModelChange",v[v.Move=2]="Move",v[v.ChangeLanguage=5]="ChangeLanguage",v[v.Initialize=6]="Initialize",v[v.ChangeCellMetadata=7]="ChangeCellMetadata",v[v.Output=8]="Output",v[v.OutputItem=9]="OutputItem",v[v.ChangeCellContent=10]="ChangeCellContent",v[v.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",v[v.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",v[v.ChangeCellMime=13]="ChangeCellMime",v[v.Unknown=100]="Unknown"})(p=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var m;(function(v){v[v.Handle=0]="Handle",v[v.Index=1]="Index"})(m=e.SelectionStateType||(e.SelectionStateType={}));var b;(function(v){v[v.Replace=1]="Replace",v[v.Output=2]="Output",v[v.Metadata=3]="Metadata",v[v.CellLanguage=4]="CellLanguage",v[v.DocumentMetadata=5]="DocumentMetadata",v[v.Move=6]="Move",v[v.OutputItems=7]="OutputItems",v[v.PartialMetadata=8]="PartialMetadata",v[v.PartialInternalMetadata=9]="PartialInternalMetadata"})(b=e.CellEditType||(e.CellEditType={}));var F;(function(v){v.scheme=y.Schemas.vscodeNotebookCell;const w=/^ch(\d{7,})/;function A(x,N){return x.with({scheme:v.scheme,fragment:`ch${N.toString().padStart(7,"0")}${x.scheme!==y.Schemas.file?x.scheme:""}`})}v.generate=A;function M(x){if(x.scheme!==v.scheme)return;const N=w.exec(x.fragment);return N?{handle:Number(N[1]),notebook:x.with({scheme:x.fragment.substring(N[0].length)||y.Schemas.file,fragment:null})}:void 0}v.parse=M;function T(x,N,$){return x.with({scheme:y.Schemas.vscodeNotebookCellOutput,fragment:`ch${N.toString().padStart(7,"0")},${$??""},${x.scheme!==y.Schemas.file?x.scheme:""}`})}v.generateCellOutputUri=T;function O(x){if(x.scheme!==y.Schemas.vscodeNotebookCellOutput)return;const N=/^ch(\d{7,})\,([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(x.fragment);if(!N)return;const $=Number(N[1]),B=N[2]&&N[2]!==""?N[2]:void 0,z=N[3];return{handle:$,outputId:B,notebook:x.with({scheme:z||y.Schemas.file,fragment:null})}}v.parseCellOutputUri=O;function U(x,N,$){return x.with({scheme:$,fragment:`ch${N.toString().padStart(7,"0")}${x.scheme!==y.Schemas.file?x.scheme:""}`})}v.generateCellUri=U;function V(x,N){if(x.scheme!==N)return;const $=w.exec(x.fragment);return $?{handle:Number($[1]),notebook:x.with({scheme:x.fragment.substring($[0].length)||y.Schemas.file,fragment:null})}:void 0}v.parseCellUri=V})(F=e.CellUri||(e.CellUri={}));const _=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[I.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function g(v){return _.get(v)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=g;function s(v){return _.get(v)?.supportedByCore??!1}e.mimeTypeSupportedByCore=s;function d(v){return _.get(v)?.mergeable??!1}e.mimeTypeIsMergeable=d;const n=v=>k.isWindows?v.replace(/\//g,"\\"):v;class S{constructor(w=[],A=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=A,this.order=[...new Set(w)].map(M=>({pattern:M,matches:h.parse(n(M))}))}sort(w){const A=new Map(t.Iterable.map(w,T=>[T,n(T)]));let M=[];for(const{matches:T}of this.order)for(const[O,U]of A)if(T(U)){M.push(O),A.delete(O);break}return A.size&&(M=M.concat([...A.keys()].sort((T,O)=>this.defaultOrder.indexOf(T)-this.defaultOrder.indexOf(O)))),M}prioritize(w,A){const M=this.findIndex(w);if(M===-1){this.order.unshift({pattern:w,matches:h.parse(n(w))});return}const T=new Set(A.map(U=>this.findIndex(U,M)));T.delete(-1);const O=Array.from(T).sort();this.order.splice(M+1,0,...O.map(U=>this.order[U]));for(let U=O.length-1;U>=0;U--)this.order.splice(O[U],1)}toArray(){return this.order.map(w=>w.pattern)}findIndex(w,A=this.order.length){const M=n(w);for(let T=0;T<A;T++)if(this.order[T].matches(M))return T;return-1}}e.MimeTypeDisplayOrder=S;function o(v,w,A,M=(T,O)=>T===O){const T=[];function O(x,N,$){if(N===0&&$.length===0)return;const B=T[T.length-1];B&&B.start+B.deleteCount===x?(B.deleteCount+=N,B.toInsert.push(...$)):T.push({start:x,deleteCount:N,toInsert:$})}let U=0,V=0;for(;;){if(U===v.length){O(U,0,w.slice(V));break}if(V===w.length){O(U,v.length-U,[]);break}const x=v[U],N=w[V];if(M(x,N)){U+=1,V+=1;continue}A(N)?(O(U,1,[]),U+=1):(O(U,0,[N]),V+=1)}return T}e.diff=o,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new D.RawContextKey("notebookEditorCursorAtBoundary","none");var i;(function(v){v.default="default",v.option="option"})(i=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function r(v){const w=v;return!!((typeof w.include=="string"||h.isRelativePattern(w.include))&&(typeof w.exclude=="string"||h.isRelativePattern(w.exclude)))}e.isDocumentExcludePattern=r;function c(v,w,A){if(Array.isArray(v.viewType)&&v.viewType.indexOf(w)>=0||v.viewType===w)return!0;if(v.filenamePattern){const M=r(v.filenamePattern)?v.filenamePattern.include:v.filenamePattern,T=r(v.filenamePattern)?v.filenamePattern.exclude:void 0;if(h.match(M,(0,R.basename)(A.fsPath).toLowerCase()))return!(T&&h.match(T,(0,R.basename)(A.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=c;class a{constructor(w){this.textModel=w}getElements(){const w=new Int32Array(this.textModel.cells.length);for(let A=0;A<this.textModel.cells.length;A++)w[A]=this.textModel.cells[A].getHashValue();return w}}e.CellSequence=a,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode"};var u;(function(v){v[v.Left=1]="Left",v[v.Right=2]="Right"})(u=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class f{static create(w){return`${f._prefix}${w}`}static parse(w){if(w.startsWith(f._prefix))return w.substring(f._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=f,f._prefix="notebook/"}),define(ve[211],we([0,1,4]),function(Z,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var t;(function(I){I[I.Output=1]="Output",I[I.OutputItems=2]="OutputItems",I[I.ExecutionState=3]="ExecutionState"})(t=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,h.createDecorator)("INotebookExecutionService")}),define(ve[212],we([0,1,4,62]),function(Z,e,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new t.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new t.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new t.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,h.createDecorator)(e.OUTPUT_SERVICE_ID);var I;(function(y){y[y.Append=1]="Append",y[y.Replace=2]="Replace",y[y.Clear=3]="Clear"})(I=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={}))}),define(ve[213],we([0,1,177,4,62]),function(Z,e,h,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new I.RawContextKey("customExecutionSupported",!0,h.localize(0,null)),e.ShellExecutionSupportedContext=new I.RawContextKey("shellExecutionSupported",!1,h.localize(1,null)),e.ProcessExecutionSupportedContext=new I.RawContextKey("processExecutionSupported",!1,h.localize(2,null)),e.ITaskService=(0,t.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(ve[214],we([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function h(I){return[...I.entries()]}e.serializeEnvironmentVariableCollection=h;function t(I){return new Map(I)}e.deserializeEnvironmentVariableCollection=t}),define(ve[128],we([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.TestMessageType=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var h;(function(C){C[C.Unset=0]="Unset",C[C.Queued=1]="Queued",C[C.Running=2]="Running",C[C.Passed=3]="Passed",C[C.Failed=4]="Failed",C[C.Skipped=5]="Skipped",C[C.Errored=6]="Errored"})(h=e.TestResultState||(e.TestResultState={}));var t;(function(C){C[C.Run=2]="Run",C[C.Debug=4]="Debug",C[C.Coverage=8]="Coverage",C[C.HasNonDefaultProfile=16]="HasNonDefaultProfile",C[C.HasConfigurable=32]="HasConfigurable"})(t=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var I;(function(C){C[C.Error=0]="Error",C[C.Info=1]="Info"})(I=e.TestMessageType||(e.TestMessageType={}));var y;(function(C){C[C.NotExpandable=0]="NotExpandable",C[C.Expandable=1]="Expandable",C[C.BusyExpanding=2]="BusyExpanding",C[C.Expanded=3]="Expanded"})(y=e.TestItemExpandState||(e.TestItemExpandState={}));const R=(C,l)=>{l.expand!==void 0&&(C.expand=l.expand),l.item!==void 0&&(C.item=C.item?Object.assign(C.item,l.item):l.item)};e.applyTestItemUpdate=R;var k;(function(C){C[C.Function=0]="Function",C[C.Statement=1]="Statement"})(k=e.DetailType||(e.DetailType={}));var D;(function(C){C[C.Add=0]="Add",C[C.Update=1]="Update",C[C.Remove=2]="Remove",C[C.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",C[C.Retire=4]="Retire",C[C.AddTag=5]="AddTag",C[C.RemoveTag=6]="RemoveTag"})(D=e.TestDiffOpType||(e.TestDiffOpType={}));class P{add(l){}update(l){}remove(l,E){}complete(){}}e.IncrementalChangeCollector=P;class L{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(l){const E=this.createChangeCollector();for(const p of l)switch(p[0]){case 0:{const m=p[1];if(m.parent){if(this.items.has(m.parent)){const b=this.items.get(m.parent);b.children.add(m.item.extId);const F=this.createItem(m,b);this.items.set(m.item.extId,F),E.add(F)}}else{const b=this.createItem(m);this.roots.add(b),this.items.set(m.item.extId,b),E.add(b)}m.expand===2&&this.busyControllerCount++;break}case 1:{const m=p[1],b=this.items.get(m.extId);if(!b)break;m.expand!==void 0&&(b.expand===2&&this.busyControllerCount--,m.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(b,m),E.update(b);break}case 2:{const m=this.items.get(p[1]);if(!m)break;m.parent?this.items.get(m.parent).children.delete(m.item.extId):this.roots.delete(m);const b=[[p[1]]];for(;b.length;)for(const F of b.pop()){const _=this.items.get(F);_&&(b.push(_.children),this.items.delete(F),E.remove(_,_!==m),_.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(p[1]);break;case 3:this.updatePendingRoots(p[1]);break;case 5:this._tags.set(p[1].id,p[1]);break;case 6:this._tags.delete(p[1]);break}E.complete()}retireTest(l){}updatePendingRoots(l){this.pendingRootCount+=l}createChangeCollector(){return new P}}e.AbstractIncrementalTestCollection=L}),define(ve[88],we([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var h;(function(y){y.Delimiter="\0"})(h=e.TestIdPathParts||(e.TestIdPathParts={}));var t;(function(y){y[y.IsSame=0]="IsSame",y[y.Disconnected=1]="Disconnected",y[y.IsChild=2]="IsChild",y[y.IsParent=3]="IsParent"})(t=e.TestPosition||(e.TestPosition={}));class I{constructor(R,k=R.length){if(this.path=R,this.viewEnd=k,R.length===0||k<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(R,k,D=R.parent){if(R.id===k)return new I([k]);let P=[R.id];for(let L=D;L&&L.id!==k;L=L.parent)P.push(L.id);return P.push(k),new I(P.reverse())}static isRoot(R){return!R.includes("\0")}static root(R){const k=R.indexOf("\0");return k===-1?R:R.slice(0,k)}static fromString(R){return new I(R.split("\0"))}static join(R,k){return new I([...R.path,k])}static joinToString(R,k){return R.toString()+"\0"+k}static compare(R,k){return R===k?0:k.startsWith(R+"\0")?2:R.startsWith(k+"\0")?3:1}get parentId(){return this.viewEnd>1?new I(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let R=1;R<=this.viewEnd;R++)yield new I(this.path,R)}compare(R){if(typeof R=="string")return I.compare(this.toString(),R);for(let k=0;k<R.viewEnd&&k<this.viewEnd;k++)if(R.path[k]!==this.path[k])return 1;return R.viewEnd>this.viewEnd?2:R.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let R=1;R<this.viewEnd;R++)this.stringifed+="\0",this.stringifed+=this.path[R]}return this.stringifed}}e.TestId=I}),define(ve[215],we([0,1,9,40,18,25,11,80,178]),function(Z,e,h,t,I,y,R,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class P{constructor(C,l,E){this._contributedVariables=new Map,this._context=C,this._labelService=l,E&&(this._envVariablesPromise=E.then(p=>this.prepareEnv(p)))}prepareEnv(C){if(R.isWindows){const l=Object.create(null);return Object.keys(C).forEach(E=>{l[E.toLowerCase()]=C[E]}),l}return C}resolveWithEnvironment(C,l,E){return this.recursiveResolve(this.prepareEnv(C),l?l.uri:void 0,E)}async resolveAsync(C,l){return this.recursiveResolve(await this._envVariablesPromise,C?C.uri:void 0,l)}async resolveAnyBase(C,l,E,p){const m=y.deepClone(l);return R.isWindows&&m.windows?Object.keys(m.windows).forEach(b=>m[b]=m.windows[b]):R.isMacintosh&&m.osx?Object.keys(m.osx).forEach(b=>m[b]=m.osx[b]):R.isLinux&&m.linux&&Object.keys(m.linux).forEach(b=>m[b]=m.linux[b]),delete m.windows,delete m.osx,delete m.linux,this.recursiveResolve(await this._envVariablesPromise,C?C.uri:void 0,m,E,p)}async resolveAnyAsync(C,l,E){return this.resolveAnyBase(C,l,E)}async resolveAnyMap(C,l,E){const p=new Map;return{newConfig:await this.resolveAnyBase(C,l,E,p),resolvedVariables:p}}resolveWithInteractionReplace(C,l,E,p){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(C,l,E,p){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(C,l){if(this._contributedVariables.has(C))throw new Error("Variable "+C+" is contributed twice.");this._contributedVariables.set(C,l)}recursiveResolve(C,l,E,p,m){if(I.isString(E))return this.resolveString(C,l,E,p,m);if(I.isArray(E))return E.map(b=>this.recursiveResolve(C,l,b,p,m));if(I.isObject(E)){let b=Object.create(null);return Object.keys(E).forEach(F=>{const _=this.resolveString(C,l,F,p,m);b[_]=this.recursiveResolve(C,l,E[F],p,m)}),b}return E}resolveString(C,l,E,p,m){return E.replace(P.VARIABLE_REGEXP,(F,_)=>{if(_.includes(P.VARIABLE_LHS))return F;let g=this.evaluateSingleVariable(C,F,_,l,p);return m&&m.set(_,g),g!==F&&I.isString(g)&&g.match(P.VARIABLE_REGEXP)&&(g=this.resolveString(C,l,g,p,m)),g})}fsPath(C){return this._labelService?this._labelService.getUriLabel(C,{noPrefix:!0}):C.fsPath}evaluateSingleVariable(C,l,E,p,m){let b;const F=E.split(":");F.length>1&&(E=F[0],b=F[1]);const _=()=>{const d=this._context.getFilePath();if(d)return d;throw new Error((0,D.localize)(0,null,l))},g=()=>{const d=_();if(this._context.getWorkspaceFolderPathForFile){const n=this._context.getWorkspaceFolderPathForFile();if(n)return n}throw new Error((0,D.localize)(1,null,l,h.basename(d)))},s=()=>{if(b){const d=this._context.getFolderUri(b);if(d)return d;throw new Error((0,D.localize)(2,null,l,b))}if(p)return p;throw this._context.getWorkspaceFolderCount()>1?new Error((0,D.localize)(3,null,l)):new Error((0,D.localize)(4,null,l))};switch(E){case"env":if(b){if(C){const d=C[R.isWindows?b.toLowerCase():b];if(I.isString(d))return d}return""}throw new Error((0,D.localize)(5,null,l));case"config":if(b){const d=this._context.getConfigurationValue(p,b);if(I.isUndefinedOrNull(d))throw new Error((0,D.localize)(6,null,l,b));if(I.isObject(d))throw new Error((0,D.localize)(7,null,l,b));return d}throw new Error((0,D.localize)(8,null,l));case"command":return this.resolveFromMap(l,b,m,"command");case"input":return this.resolveFromMap(l,b,m,"input");default:switch(E){case"workspaceRoot":case"workspaceFolder":return(0,k.normalizeDriveLetter)(this.fsPath(s()));case"cwd":return p||b?(0,k.normalizeDriveLetter)(this.fsPath(s())):t.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return h.basename(this.fsPath(s()));case"lineNumber":{const d=this._context.getLineNumber();if(d)return d;throw new Error((0,D.localize)(9,null,l))}case"selectedText":{const d=this._context.getSelectedText();if(d)return d;throw new Error((0,D.localize)(10,null,l))}case"file":return _();case"fileWorkspaceFolder":return g();case"relativeFile":return p||b?h.relative(this.fsPath(s()),_()):_();case"relativeFileDirname":{const d=h.dirname(_());if(p||b){const n=h.relative(this.fsPath(s()),d);return n.length===0?".":n}return d}case"fileDirname":return h.dirname(_());case"fileExtname":return h.extname(_());case"fileBasename":return h.basename(_());case"fileBasenameNoExtension":{const d=h.basename(_());return d.slice(0,d.length-h.extname(d).length)}case"fileDirnameBasename":return h.basename(h.dirname(_()));case"execPath":{const d=this._context.getExecPath();return d||l}case"execInstallFolder":{const d=this._context.getAppRoot();return d||l}case"pathSeparator":return h.sep;default:try{const d=b?`${E}:${b}`:E;return this.resolveFromMap(l,d,m,void 0)}catch{return l}}}}resolveFromMap(C,l,E,p){if(l&&E){const m=p===void 0?E[l]:E[p+":"+l];if(typeof m=="string")return m;throw new Error((0,D.localize)(11,null,C))}return C}}e.AbstractVariableResolverService=P,P.VARIABLE_LHS="${",P.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(ve[129],we([0,1,4,207]),function(Z,e,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,h.createDecorator)("editorGroupsService");var I;(function(p){p[p.UP=0]="UP",p[p.DOWN=1]="DOWN",p[p.LEFT=2]="LEFT",p[p.RIGHT=3]="RIGHT"})(I=e.GroupDirection||(e.GroupDirection={}));var y;(function(p){p[p.HORIZONTAL=0]="HORIZONTAL",p[p.VERTICAL=1]="VERTICAL"})(y=e.GroupOrientation||(e.GroupOrientation={}));var R;(function(p){p[p.FIRST=0]="FIRST",p[p.LAST=1]="LAST",p[p.NEXT=2]="NEXT",p[p.PREVIOUS=3]="PREVIOUS"})(R=e.GroupLocation||(e.GroupLocation={}));var k;(function(p){p[p.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",p[p.EVEN=1]="EVEN",p[p.TOGGLE=2]="TOGGLE"})(k=e.GroupsArrangement||(e.GroupsArrangement={}));var D;(function(p){p[p.COPY_EDITORS=0]="COPY_EDITORS",p[p.MOVE_EDITORS=1]="MOVE_EDITORS"})(D=e.MergeGroupMode||(e.MergeGroupMode={}));function P(p){const m=p;return(0,t.isEditorInput)(m?.editor)&&(0,t.isEditorInput)(m?.replacement)}e.isEditorReplacement=P;var L;(function(p){p[p.CREATION_TIME=0]="CREATION_TIME",p[p.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",p[p.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(L=e.GroupsOrder||(e.GroupsOrder={}));var C;(function(p){p[p.NEW_EDITOR=1]="NEW_EDITOR",p[p.MOVE_EDITOR=2]="MOVE_EDITOR",p[p.COPY_EDITOR=3]="COPY_EDITOR"})(C=e.OpenEditorContext||(e.OpenEditorContext={}));function l(p){const m=p;return!!m&&typeof m.id=="number"&&Array.isArray(m.editors)}e.isEditorGroup=l;function E(p){return p.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=E}),define(ve[216],we([0,1,4,129]),function(Z,e,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,h.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function I(y){const R=y;return typeof y=="number"||(0,t.isEditorGroup)(R)}e.isPreferredGroup=I}),define(ve[15],we([0,1,17,22,99,292,59,25,18,2,41,83,179,117,64,127,88,216,7]),function(Z,e,h,t,I,y,R,k,D,P,L,C,l,E,p,m,b,F,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var g;(function(Ee){function _e(X){const{selectionStartLineNumber:Ie,selectionStartColumn:Ne,positionLineNumber:Ye,positionColumn:Xe}=X,pt=new _.Position(Ie-1,Ne-1),St=new _.Position(Ye-1,Xe-1);return new _.Selection(pt,St)}Ee.to=_e;function he(X){const{anchor:Ie,active:Ne}=X;return{selectionStartLineNumber:Ie.line+1,selectionStartColumn:Ie.character+1,positionLineNumber:Ne.line+1,positionColumn:Ne.character+1}}Ee.from=he})(g=e.Selection||(e.Selection={}));var s;(function(Ee){function _e(X){if(!X)return;const{start:Ie,end:Ne}=X;return{startLineNumber:Ie.line+1,startColumn:Ie.character+1,endLineNumber:Ne.line+1,endColumn:Ne.character+1}}Ee.from=_e;function he(X){if(!X)return;const{startLineNumber:Ie,startColumn:Ne,endLineNumber:Ye,endColumn:Xe}=X;return new _.Range(Ie-1,Ne-1,Ye-1,Xe-1)}Ee.to=he})(s=e.Range||(e.Range={}));var d;(function(Ee){function _e(he){switch(he){case 1:return _.StandardTokenType.Comment;case 0:return _.StandardTokenType.Other;case 3:return _.StandardTokenType.RegEx;case 2:return _.StandardTokenType.String}}Ee.to=_e})(d=e.TokenType||(e.TokenType={}));var n;(function(Ee){function _e(X){return new _.Position(X.lineNumber-1,X.column-1)}Ee.to=_e;function he(X){return{lineNumber:X.line+1,column:X.character+1}}Ee.from=he})(n=e.Position||(e.Position={}));var S;(function(Ee){function _e(Ie,Ne){return(0,h.coalesce)((0,h.asArray)(Ie).map(Ye=>he(Ye,Ne)))}Ee.from=_e;function he(Ie,Ne){if(typeof Ie=="string")return{$serialized:!0,language:Ie};if(Ie)return{$serialized:!0,language:Ie.language,scheme:X(Ie.scheme,Ne),pattern:Se.from(Ie.pattern)??void 0,exclusive:Ie.exclusive}}function X(Ie,Ne){return Ne&&typeof Ie=="string"?Ne.transformOutgoingScheme(Ie):Ie}})(S=e.DocumentSelector||(e.DocumentSelector={}));var o;(function(Ee){function _e(X){switch(X){case _.DiagnosticTag.Unnecessary:return 1;case _.DiagnosticTag.Deprecated:return 2}}Ee.from=_e;function he(X){switch(X){case 1:return _.DiagnosticTag.Unnecessary;case 2:return _.DiagnosticTag.Deprecated;default:return}}Ee.to=he})(o=e.DiagnosticTag||(e.DiagnosticTag={}));var i;(function(Ee){function _e(X){let Ie;return X.code&&((0,D.isString)(X.code)||(0,D.isNumber)(X.code)?Ie=String(X.code):Ie={value:String(X.code.value),target:X.code.target}),{...s.from(X.range),message:X.message,source:X.source,code:Ie,severity:c.from(X.severity),relatedInformation:X.relatedInformation&&X.relatedInformation.map(r.from),tags:Array.isArray(X.tags)?(0,h.coalesce)(X.tags.map(o.from)):void 0}}Ee.from=_e;function he(X){const Ie=new _.Diagnostic(s.to(X),X.message,c.to(X.severity));return Ie.source=X.source,Ie.code=(0,D.isString)(X.code)?X.code:X.code?.value,Ie.relatedInformation=X.relatedInformation&&X.relatedInformation.map(r.to),Ie.tags=X.tags&&(0,h.coalesce)(X.tags.map(o.to)),Ie}Ee.to=he})(i=e.Diagnostic||(e.Diagnostic={}));var r;(function(Ee){function _e(X){return{...s.from(X.location.range),message:X.message,resource:X.location.uri}}Ee.from=_e;function he(X){return new _.DiagnosticRelatedInformation(new _.Location(X.resource,s.to(X)),X.message)}Ee.to=he})(r=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var c;(function(Ee){function _e(X){switch(X){case _.DiagnosticSeverity.Error:return E.MarkerSeverity.Error;case _.DiagnosticSeverity.Warning:return E.MarkerSeverity.Warning;case _.DiagnosticSeverity.Information:return E.MarkerSeverity.Info;case _.DiagnosticSeverity.Hint:return E.MarkerSeverity.Hint}return E.MarkerSeverity.Error}Ee.from=_e;function he(X){switch(X){case E.MarkerSeverity.Info:return _.DiagnosticSeverity.Information;case E.MarkerSeverity.Warning:return _.DiagnosticSeverity.Warning;case E.MarkerSeverity.Error:return _.DiagnosticSeverity.Error;case E.MarkerSeverity.Hint:return _.DiagnosticSeverity.Hint;default:return _.DiagnosticSeverity.Error}}Ee.to=he})(c=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var a;(function(Ee){function _e(X){return typeof X=="number"&&X>=_.ViewColumn.One?X-1:X===_.ViewColumn.Beside?F.SIDE_GROUP:F.ACTIVE_GROUP}Ee.from=_e;function he(X){if(typeof X=="number"&&X>=0)return X+1;throw new Error("invalid 'EditorGroupColumn'")}Ee.to=he})(a=e.ViewColumn||(e.ViewColumn={}));function u(Ee){return typeof Ee.range!="undefined"}function f(Ee){return Ee.length===0?!0:!!u(Ee[0])}e.isDecorationOptionsArr=f;var v;(function(Ee){function _e(Xe){return Xe.map(Ee.from)}Ee.fromMany=_e;function he(Xe){return Xe&&typeof Xe=="object"&&typeof Xe.language=="string"&&typeof Xe.value=="string"}function X(Xe){let pt;if(he(Xe)){const{language:wt,value:bt}=Xe;pt={value:"```"+wt+`
`+bt+"\n```\n"}}else _.MarkdownString.isMarkdownString(Xe)?pt={value:Xe.value,isTrusted:Xe.isTrusted,supportThemeIcons:Xe.supportThemeIcons,supportHtml:Xe.supportHtml}:typeof Xe=="string"?pt={value:Xe}:pt={value:""};const St=Object.create(null);pt.uris=St;const yt=wt=>{try{let bt=P.URI.parse(wt,!0);bt=bt.with({query:Ie(bt.query,St)}),St[wt]=bt}catch{}return""},ft=new y.Renderer;return ft.link=yt,ft.image=wt=>yt(I.parseHrefAndDimensions(wt).href),y(pt.value,{renderer:ft}),pt}Ee.from=X;function Ie(Xe,pt){if(!Xe)return Xe;let St;try{St=(0,R.parse)(Xe)}catch{}if(!St)return Xe;let yt=!1;return St=(0,k.cloneAndChange)(St,ft=>{if(P.URI.isUri(ft)){const wt=`__uri_${Math.random().toString(16).slice(2,8)}`;return pt[wt]=ft,yt=!0,wt}else return}),yt?JSON.stringify(St):Xe}function Ne(Xe){const pt=new _.MarkdownString(Xe.value,Xe.supportThemeIcons);return pt.isTrusted=Xe.isTrusted,pt.supportHtml=Xe.supportHtml,pt}Ee.to=Ne;function Ye(Xe){if(!!Xe)return typeof Xe=="string"?Xe:Ee.from(Xe)}Ee.fromStrict=Ye})(v=e.MarkdownString||(e.MarkdownString={}));function w(Ee){return f(Ee)?Ee.map(_e=>({range:s.from(_e.range),hoverMessage:Array.isArray(_e.hoverMessage)?v.fromMany(_e.hoverMessage):_e.hoverMessage?v.from(_e.hoverMessage):void 0,renderOptions:_e.renderOptions})):Ee.map(_e=>({range:s.from(_e)}))}e.fromRangeOrRangeWithMessage=w;function A(Ee){return typeof Ee=="undefined"?Ee:typeof Ee=="string"?P.URI.file(Ee):Ee}e.pathOrURIToURI=A;var M;(function(Ee){function _e(he){return typeof he=="undefined"?he:{contentText:he.contentText,contentIconPath:he.contentIconPath?A(he.contentIconPath):void 0,border:he.border,borderColor:he.borderColor,fontStyle:he.fontStyle,fontWeight:he.fontWeight,textDecoration:he.textDecoration,color:he.color,backgroundColor:he.backgroundColor,margin:he.margin,width:he.width,height:he.height}}Ee.from=_e})(M=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var T;(function(Ee){function _e(he){return typeof he=="undefined"?he:{backgroundColor:he.backgroundColor,outline:he.outline,outlineColor:he.outlineColor,outlineStyle:he.outlineStyle,outlineWidth:he.outlineWidth,border:he.border,borderColor:he.borderColor,borderRadius:he.borderRadius,borderSpacing:he.borderSpacing,borderStyle:he.borderStyle,borderWidth:he.borderWidth,fontStyle:he.fontStyle,fontWeight:he.fontWeight,textDecoration:he.textDecoration,cursor:he.cursor,color:he.color,opacity:he.opacity,letterSpacing:he.letterSpacing,gutterIconPath:he.gutterIconPath?A(he.gutterIconPath):void 0,gutterIconSize:he.gutterIconSize,overviewRulerColor:he.overviewRulerColor,before:he.before?M.from(he.before):void 0,after:he.after?M.from(he.after):void 0}}Ee.from=_e})(T=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var O;(function(Ee){function _e(he){if(typeof he=="undefined")return he;switch(he){case _.DecorationRangeBehavior.OpenOpen:return 0;case _.DecorationRangeBehavior.ClosedClosed:return 1;case _.DecorationRangeBehavior.OpenClosed:return 2;case _.DecorationRangeBehavior.ClosedOpen:return 3}}Ee.from=_e})(O=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var U;(function(Ee){function _e(he){return{isWholeLine:he.isWholeLine,rangeBehavior:he.rangeBehavior?O.from(he.rangeBehavior):void 0,overviewRulerLane:he.overviewRulerLane,light:he.light?T.from(he.light):void 0,dark:he.dark?T.from(he.dark):void 0,backgroundColor:he.backgroundColor,outline:he.outline,outlineColor:he.outlineColor,outlineStyle:he.outlineStyle,outlineWidth:he.outlineWidth,border:he.border,borderColor:he.borderColor,borderRadius:he.borderRadius,borderSpacing:he.borderSpacing,borderStyle:he.borderStyle,borderWidth:he.borderWidth,fontStyle:he.fontStyle,fontWeight:he.fontWeight,textDecoration:he.textDecoration,cursor:he.cursor,color:he.color,opacity:he.opacity,letterSpacing:he.letterSpacing,gutterIconPath:he.gutterIconPath?A(he.gutterIconPath):void 0,gutterIconSize:he.gutterIconSize,overviewRulerColor:he.overviewRulerColor,before:he.before?M.from(he.before):void 0,after:he.after?M.from(he.after):void 0}}Ee.from=_e})(U=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var V;(function(Ee){function _e(X){return{text:X.newText,eol:X.newEol&&gt.from(X.newEol),range:s.from(X.range)}}Ee.from=_e;function he(X){const Ie=new _.TextEdit(s.to(X.range),X.text);return Ie.newEol=typeof X.eol=="undefined"?void 0:gt.to(X.eol),Ie}Ee.to=he})(V=e.TextEdit||(e.TextEdit={}));var x;(function(Ee){function _e(X,Ie,Ne){const Ye={edits:[]};if(X instanceof _.WorkspaceEdit)for(let Xe of X._allEntries())if(Xe._type===1)Ye.edits.push({_type:1,oldUri:Xe.from,newUri:Xe.to,options:Xe.options,metadata:Xe.metadata});else if(Xe._type===2){const pt=Ie?.getDocument(Xe.uri);Ye.edits.push({_type:2,resource:Xe.uri,edit:V.from(Xe.edit),modelVersionId:pt?.version,metadata:Xe.metadata})}else Xe._type===3?Ye.edits.push({_type:3,metadata:Xe.metadata,resource:Xe.uri,edit:Xe.edit,notebookMetadata:Xe.notebookMetadata,notebookVersionId:Ne?.getNotebookDocument(Xe.uri,!0)?.apiNotebook.version}):Xe._type===5&&Ye.edits.push({_type:3,metadata:Xe.metadata,resource:Xe.uri,notebookVersionId:Ne?.getNotebookDocument(Xe.uri,!0)?.apiNotebook.version,edit:{editType:1,index:Xe.index,count:Xe.count,cells:Xe.cells.map(ut.from)}});return Ye}Ee.from=_e;function he(X){const Ie=new _.WorkspaceEdit;for(const Ne of X.edits)Ne.edit?Ie.replace(P.URI.revive(Ne.resource),s.to(Ne.edit.range),Ne.edit.text):Ie.renameFile(P.URI.revive(Ne.oldUri),P.URI.revive(Ne.newUri),Ne.options);return Ie}Ee.to=he})(x=e.WorkspaceEdit||(e.WorkspaceEdit={}));var N;(function(Ee){const _e=Object.create(null);_e[_.SymbolKind.File]=0,_e[_.SymbolKind.Module]=1,_e[_.SymbolKind.Namespace]=2,_e[_.SymbolKind.Package]=3,_e[_.SymbolKind.Class]=4,_e[_.SymbolKind.Method]=5,_e[_.SymbolKind.Property]=6,_e[_.SymbolKind.Field]=7,_e[_.SymbolKind.Constructor]=8,_e[_.SymbolKind.Enum]=9,_e[_.SymbolKind.Interface]=10,_e[_.SymbolKind.Function]=11,_e[_.SymbolKind.Variable]=12,_e[_.SymbolKind.Constant]=13,_e[_.SymbolKind.String]=14,_e[_.SymbolKind.Number]=15,_e[_.SymbolKind.Boolean]=16,_e[_.SymbolKind.Array]=17,_e[_.SymbolKind.Object]=18,_e[_.SymbolKind.Key]=19,_e[_.SymbolKind.Null]=20,_e[_.SymbolKind.EnumMember]=21,_e[_.SymbolKind.Struct]=22,_e[_.SymbolKind.Event]=23,_e[_.SymbolKind.Operator]=24,_e[_.SymbolKind.TypeParameter]=25;function he(Ie){return typeof _e[Ie]=="number"?_e[Ie]:6}Ee.from=he;function X(Ie){for(const Ne in _e)if(_e[Ne]===Ie)return Number(Ne);return _.SymbolKind.Property}Ee.to=X})(N=e.SymbolKind||(e.SymbolKind={}));var $;(function(Ee){function _e(X){switch(X){case _.SymbolTag.Deprecated:return 1}}Ee.from=_e;function he(X){switch(X){case 1:return _.SymbolTag.Deprecated}}Ee.to=he})($=e.SymbolTag||(e.SymbolTag={}));var B;(function(Ee){function _e(X){return{name:X.name,kind:N.from(X.kind),tags:X.tags&&X.tags.map($.from),containerName:X.containerName,location:ne.from(X.location)}}Ee.from=_e;function he(X){const Ie=new _.SymbolInformation(X.name,N.to(X.kind),X.containerName,ne.to(X.location));return Ie.tags=X.tags&&X.tags.map($.to),Ie}Ee.to=he})(B=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var z;(function(Ee){function _e(X){const Ie={name:X.name||"!!MISSING: name!!",detail:X.detail,range:s.from(X.range),selectionRange:s.from(X.selectionRange),kind:N.from(X.kind),tags:X.tags?.map($.from)??[]};return X.children&&(Ie.children=X.children.map(_e)),Ie}Ee.from=_e;function he(X){const Ie=new _.DocumentSymbol(X.name,X.detail,N.to(X.kind),s.to(X.range),s.to(X.selectionRange));return(0,h.isNonEmptyArray)(X.tags)&&(Ie.tags=X.tags.map($.to)),X.children&&(Ie.children=X.children.map(he)),Ie}Ee.to=he})(z=e.DocumentSymbol||(e.DocumentSymbol={}));var W;(function(Ee){function _e(X){const Ie=new _.CallHierarchyItem(N.to(X.kind),X.name,X.detail||"",P.URI.revive(X.uri),s.to(X.range),s.to(X.selectionRange));return Ie._sessionId=X._sessionId,Ie._itemId=X._itemId,Ie}Ee.to=_e;function he(X,Ie,Ne){if(Ie=Ie??X._sessionId,Ne=Ne??X._itemId,Ie===void 0||Ne===void 0)throw new Error("invalid item");return{_sessionId:Ie,_itemId:Ne,name:X.name,detail:X.detail,kind:N.from(X.kind),uri:X.uri,range:s.from(X.range),selectionRange:s.from(X.selectionRange),tags:X.tags?.map($.from)}}Ee.from=he})(W=e.CallHierarchyItem||(e.CallHierarchyItem={}));var Y;(function(Ee){function _e(he){return new _.CallHierarchyIncomingCall(W.to(he.from),he.fromRanges.map(X=>s.to(X)))}Ee.to=_e})(Y=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var ie;(function(Ee){function _e(he){return new _.CallHierarchyOutgoingCall(W.to(he.to),he.fromRanges.map(X=>s.to(X)))}Ee.to=_e})(ie=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var ne;(function(Ee){function _e(X){return{range:X.range&&s.from(X.range),uri:X.uri}}Ee.from=_e;function he(X){return new _.Location(P.URI.revive(X.uri),s.to(X.range))}Ee.to=he})(ne=e.location||(e.location={}));var J;(function(Ee){function _e(X){const Ie=X,Ne=X;return{originSelectionRange:Ie.originSelectionRange?s.from(Ie.originSelectionRange):void 0,uri:Ie.targetUri?Ie.targetUri:Ne.uri,range:s.from(Ie.targetRange?Ie.targetRange:Ne.range),targetSelectionRange:Ie.targetSelectionRange?s.from(Ie.targetSelectionRange):void 0}}Ee.from=_e;function he(X){return{targetUri:P.URI.revive(X.uri),targetRange:s.to(X.range),targetSelectionRange:X.targetSelectionRange?s.to(X.targetSelectionRange):void 0,originSelectionRange:X.originSelectionRange?s.to(X.originSelectionRange):void 0}}Ee.to=he})(J=e.DefinitionLink||(e.DefinitionLink={}));var K;(function(Ee){function _e(X){return{range:s.from(X.range),contents:v.fromMany(X.contents)}}Ee.from=_e;function he(X){return new _.Hover(X.contents.map(v.to),s.to(X.range))}Ee.to=he})(K=e.Hover||(e.Hover={}));var oe;(function(Ee){function _e(X){return{range:s.from(X.range),expression:X.expression}}Ee.from=_e;function he(X){return new _.EvaluatableExpression(s.to(X.range),X.expression)}Ee.to=he})(oe=e.EvaluatableExpression||(e.EvaluatableExpression={}));var fe;(function(Ee){function _e(X){if(X instanceof _.InlineValueText)return{type:"text",range:s.from(X.range),text:X.text};if(X instanceof _.InlineValueVariableLookup)return{type:"variable",range:s.from(X.range),variableName:X.variableName,caseSensitiveLookup:X.caseSensitiveLookup};if(X instanceof _.InlineValueEvaluatableExpression)return{type:"expression",range:s.from(X.range),expression:X.expression};throw new Error("Unknown 'InlineValue' type")}Ee.from=_e;function he(X){switch(X.type){case"text":return{range:s.to(X.range),text:X.text};case"variable":return{range:s.to(X.range),variableName:X.variableName,caseSensitiveLookup:X.caseSensitiveLookup};case"expression":return{range:s.to(X.range),expression:X.expression}}}Ee.to=he})(fe=e.InlineValue||(e.InlineValue={}));var pe;(function(Ee){function _e(X){return{frameId:X.frameId,stoppedLocation:s.from(X.stoppedLocation)}}Ee.from=_e;function he(X){return new _.InlineValueContext(X.frameId,s.to(X.stoppedLocation))}Ee.to=he})(pe=e.InlineValueContext||(e.InlineValueContext={}));var Te;(function(Ee){function _e(X){return{range:s.from(X.range),kind:X.kind}}Ee.from=_e;function he(X){return new _.DocumentHighlight(s.to(X.range),X.kind)}Ee.to=he})(Te=e.DocumentHighlight||(e.DocumentHighlight={}));var xe;(function(Ee){function _e(he){switch(he){case 1:return _.CompletionTriggerKind.TriggerCharacter;case 2:return _.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return _.CompletionTriggerKind.Invoke}}Ee.to=_e})(xe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Ge;(function(Ee){function _e(he){return{triggerKind:xe.to(he.triggerKind),triggerCharacter:he.triggerCharacter}}Ee.to=_e})(Ge=e.CompletionContext||(e.CompletionContext={}));var Qe;(function(Ee){function _e(X){switch(X){case _.CompletionItemTag.Deprecated:return 1}}Ee.from=_e;function he(X){switch(X){case 1:return _.CompletionItemTag.Deprecated}}Ee.to=he})(Qe=e.CompletionItemTag||(e.CompletionItemTag={}));var q;(function(Ee){const _e=new Map([[_.CompletionItemKind.Method,0],[_.CompletionItemKind.Function,1],[_.CompletionItemKind.Constructor,2],[_.CompletionItemKind.Field,3],[_.CompletionItemKind.Variable,4],[_.CompletionItemKind.Class,5],[_.CompletionItemKind.Interface,7],[_.CompletionItemKind.Struct,6],[_.CompletionItemKind.Module,8],[_.CompletionItemKind.Property,9],[_.CompletionItemKind.Unit,12],[_.CompletionItemKind.Value,13],[_.CompletionItemKind.Constant,14],[_.CompletionItemKind.Enum,15],[_.CompletionItemKind.EnumMember,16],[_.CompletionItemKind.Keyword,17],[_.CompletionItemKind.Snippet,27],[_.CompletionItemKind.Text,18],[_.CompletionItemKind.Color,19],[_.CompletionItemKind.File,20],[_.CompletionItemKind.Reference,21],[_.CompletionItemKind.Folder,23],[_.CompletionItemKind.Event,10],[_.CompletionItemKind.Operator,11],[_.CompletionItemKind.TypeParameter,24],[_.CompletionItemKind.Issue,26],[_.CompletionItemKind.User,25]]);function he(Ne){return _e.get(Ne)??9}Ee.from=he;const X=new Map([[0,_.CompletionItemKind.Method],[1,_.CompletionItemKind.Function],[2,_.CompletionItemKind.Constructor],[3,_.CompletionItemKind.Field],[4,_.CompletionItemKind.Variable],[5,_.CompletionItemKind.Class],[7,_.CompletionItemKind.Interface],[6,_.CompletionItemKind.Struct],[8,_.CompletionItemKind.Module],[9,_.CompletionItemKind.Property],[12,_.CompletionItemKind.Unit],[13,_.CompletionItemKind.Value],[14,_.CompletionItemKind.Constant],[15,_.CompletionItemKind.Enum],[16,_.CompletionItemKind.EnumMember],[17,_.CompletionItemKind.Keyword],[27,_.CompletionItemKind.Snippet],[18,_.CompletionItemKind.Text],[19,_.CompletionItemKind.Color],[20,_.CompletionItemKind.File],[21,_.CompletionItemKind.Reference],[23,_.CompletionItemKind.Folder],[10,_.CompletionItemKind.Event],[11,_.CompletionItemKind.Operator],[24,_.CompletionItemKind.TypeParameter],[25,_.CompletionItemKind.User],[26,_.CompletionItemKind.Issue]]);function Ie(Ne){return X.get(Ne)??_.CompletionItemKind.Property}Ee.to=Ie})(q=e.CompletionItemKind||(e.CompletionItemKind={}));var te;(function(Ee){function _e(he,X){const Ie=new _.CompletionItem(he.label);return Ie.insertText=he.insertText,Ie.kind=q.to(he.kind),Ie.tags=he.tags?.map(Qe.to),Ie.detail=he.detail,Ie.documentation=I.isMarkdownString(he.documentation)?v.to(he.documentation):he.documentation,Ie.sortText=he.sortText,Ie.filterText=he.filterText,Ie.preselect=he.preselect,Ie.commitCharacters=he.commitCharacters,L.Range.isIRange(he.range)?Ie.range=s.to(he.range):typeof he.range=="object"&&(Ie.range={inserting:s.to(he.range.insert),replacing:s.to(he.range.replace)}),Ie.keepWhitespace=typeof he.insertTextRules=="undefined"?!1:Boolean(he.insertTextRules&1),typeof he.insertTextRules!="undefined"&&he.insertTextRules&4?Ie.insertText=new _.SnippetString(he.insertText):(Ie.insertText=he.insertText,Ie.textEdit=Ie.range instanceof _.Range?new _.TextEdit(Ie.range,Ie.insertText):void 0),he.additionalTextEdits&&he.additionalTextEdits.length>0&&(Ie.additionalTextEdits=he.additionalTextEdits.map(Ne=>V.to(Ne))),Ie.command=X&&he.command?X.fromInternal(he.command):void 0,Ie}Ee.to=_e})(te=e.CompletionItem||(e.CompletionItem={}));var G;(function(Ee){function _e(X){return{label:X.label,documentation:X.documentation?v.fromStrict(X.documentation):void 0}}Ee.from=_e;function he(X){return{label:X.label,documentation:I.isMarkdownString(X.documentation)?v.to(X.documentation):X.documentation}}Ee.to=he})(G=e.ParameterInformation||(e.ParameterInformation={}));var Q;(function(Ee){function _e(X){return{label:X.label,documentation:X.documentation?v.fromStrict(X.documentation):void 0,parameters:Array.isArray(X.parameters)?X.parameters.map(G.from):[],activeParameter:X.activeParameter}}Ee.from=_e;function he(X){return{label:X.label,documentation:I.isMarkdownString(X.documentation)?v.to(X.documentation):X.documentation,parameters:Array.isArray(X.parameters)?X.parameters.map(G.to):[],activeParameter:X.activeParameter}}Ee.to=he})(Q=e.SignatureInformation||(e.SignatureInformation={}));var ae;(function(Ee){function _e(X){return{activeSignature:X.activeSignature,activeParameter:X.activeParameter,signatures:Array.isArray(X.signatures)?X.signatures.map(Q.from):[]}}Ee.from=_e;function he(X){return{activeSignature:X.activeSignature,activeParameter:X.activeParameter,signatures:Array.isArray(X.signatures)?X.signatures.map(Q.to):[]}}Ee.to=he})(ae=e.SignatureHelp||(e.SignatureHelp={}));var me;(function(Ee){function _e(he,X){const Ie=new _.InlayHint(typeof X.label=="string"?X.label:X.label.map(ke.to.bind(void 0,he)),n.to(X.position),We.to(X.kind));return Ie.tooltip=I.isMarkdownString(X.tooltip)?v.to(X.tooltip):X.tooltip,Ie.paddingLeft=X.paddingLeft,Ie.paddingRight=X.paddingRight,Ie}Ee.to=_e})(me=e.InlayHint||(e.InlayHint={}));var ke;(function(Ee){function _e(he,X){const Ie=new _.InlayHintLabelPart(X.label);return Ie.tooltip=I.isMarkdownString(X.tooltip)?v.to(X.tooltip):X.tooltip,C.Command.is(X.command)?Ie.command=he.fromInternal(X.command):X.location&&(Ie.location=ne.to(X.location)),Ie}Ee.to=_e})(ke=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var We;(function(Ee){function _e(X){return X}Ee.from=_e;function he(X){return X}Ee.to=he})(We=e.InlayHintKind||(e.InlayHintKind={}));var Je;(function(Ee){function _e(X){return{range:s.from(X.range),url:X.target,tooltip:X.tooltip}}Ee.from=_e;function he(X){let Ie;if(X.url)try{Ie=typeof X.url=="string"?P.URI.parse(X.url,!0):P.URI.revive(X.url)}catch{}return new _.DocumentLink(s.to(X.range),Ie)}Ee.to=he})(Je=e.DocumentLink||(e.DocumentLink={}));var it;(function(Ee){function _e(X){const Ie=new _.ColorPresentation(X.label);return X.textEdit&&(Ie.textEdit=V.to(X.textEdit)),X.additionalTextEdits&&(Ie.additionalTextEdits=X.additionalTextEdits.map(Ne=>V.to(Ne))),Ie}Ee.to=_e;function he(X){return{label:X.label,textEdit:X.textEdit?V.from(X.textEdit):void 0,additionalTextEdits:X.additionalTextEdits?X.additionalTextEdits.map(Ie=>V.from(Ie)):void 0}}Ee.from=he})(it=e.ColorPresentation||(e.ColorPresentation={}));var st;(function(Ee){function _e(X){return new _.Color(X[0],X[1],X[2],X[3])}Ee.to=_e;function he(X){return[X.red,X.green,X.blue,X.alpha]}Ee.from=he})(st=e.Color||(e.Color={}));var ot;(function(Ee){function _e(X){return{range:s.from(X.range)}}Ee.from=_e;function he(X){return new _.SelectionRange(s.to(X.range))}Ee.to=he})(ot=e.SelectionRange||(e.SelectionRange={}));var tt;(function(Ee){function _e(he){switch(he){case 2:return _.TextDocumentSaveReason.AfterDelay;case 1:return _.TextDocumentSaveReason.Manual;case 3:case 4:return _.TextDocumentSaveReason.FocusOut}}Ee.to=_e})(tt=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var rt;(function(Ee){function _e(X){switch(X){case _.TextEditorLineNumbersStyle.Off:return 0;case _.TextEditorLineNumbersStyle.Relative:return 2;case _.TextEditorLineNumbersStyle.On:default:return 1}}Ee.from=_e;function he(X){switch(X){case 0:return _.TextEditorLineNumbersStyle.Off;case 2:return _.TextEditorLineNumbersStyle.Relative;case 1:default:return _.TextEditorLineNumbersStyle.On}}Ee.to=he})(rt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var gt;(function(Ee){function _e(X){if(X===_.EndOfLine.CRLF)return 1;if(X===_.EndOfLine.LF)return 0}Ee.from=_e;function he(X){if(X===1)return _.EndOfLine.CRLF;if(X===0)return _.EndOfLine.LF}Ee.to=he})(gt=e.EndOfLine||(e.EndOfLine={}));var Ue;(function(Ee){function _e(he){if(typeof he=="object")return he.viewId;switch(he){case _.ProgressLocation.SourceControl:return 3;case _.ProgressLocation.Window:return 10;case _.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Ee.from=_e})(Ue=e.ProgressLocation||(e.ProgressLocation={}));var It;(function(Ee){function _e(he){const X={start:he.start+1,end:he.end+1};return he.kind&&(X.kind=ee.from(he.kind)),X}Ee.from=_e})(It=e.FoldingRange||(e.FoldingRange={}));var ee;(function(Ee){function _e(he){if(he)switch(he){case _.FoldingRangeKind.Comment:return C.FoldingRangeKind.Comment;case _.FoldingRangeKind.Imports:return C.FoldingRangeKind.Imports;case _.FoldingRangeKind.Region:return C.FoldingRangeKind.Region}}Ee.from=_e})(ee=e.FoldingRangeKind||(e.FoldingRangeKind={}));var re;(function(Ee){function _e(he){if(he)return{pinned:typeof he.preview=="boolean"?!he.preview:void 0,inactive:he.background,preserveFocus:he.preserveFocus,selection:typeof he.selection=="object"?s.from(he.selection):void 0,override:typeof he.override=="boolean"?l.EditorResolution.DISABLED:void 0}}Ee.from=_e})(re=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Se;(function(Ee){function _e(Ne){return Ne instanceof _.RelativePattern?Ne.toJSON():typeof Ne=="string"?Ne:he(Ne)||X(Ne)?new _.RelativePattern(Ne.baseUri??Ne.base,Ne.pattern).toJSON():Ne}Ee.from=_e;function he(Ne){const Ye=Ne;return Ye?P.URI.isUri(Ye.baseUri)&&typeof Ye.pattern=="string":!1}function X(Ne){const Ye=Ne;return Ye?typeof Ye.base=="string"&&typeof Ye.pattern=="string":!1}function Ie(Ne){return typeof Ne=="string"?Ne:new _.RelativePattern(P.URI.revive(Ne.baseUri),Ne.pattern)}Ee.to=Ie})(Se=e.GlobPattern||(e.GlobPattern={}));var se;(function(Ee){function _e(he){if(he){if(Array.isArray(he))return he.map(_e);if(typeof he=="string")return he;{const X=he;return{language:X.language,scheme:X.scheme,pattern:Se.from(X.pattern),exclusive:X.exclusive}}}else return}Ee.from=_e})(se=e.LanguageSelector||(e.LanguageSelector={}));var ye;(function(Ee){function _e(X){return{start:X.start,end:X.end}}Ee.from=_e;function he(X){return new _.NotebookRange(X.start,X.end)}Ee.to=he})(ye=e.NotebookRange||(e.NotebookRange={}));var Me;(function(Ee){function _e(X){return{timing:typeof X.runStartTime=="number"&&typeof X.runEndTime=="number"?{startTime:X.runStartTime,endTime:X.runEndTime}:void 0,executionOrder:X.executionOrder,success:X.lastRunSuccess}}Ee.to=_e;function he(X){return{lastRunSuccess:X.success,runStartTime:X.timing?.startTime,runEndTime:X.timing?.endTime,executionOrder:X.executionOrder}}Ee.from=he})(Me=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var qe;(function(Ee){function _e(X){switch(X){case _.NotebookCellKind.Markup:return m.CellKind.Markup;case _.NotebookCellKind.Code:default:return m.CellKind.Code}}Ee.from=_e;function he(X){switch(X){case m.CellKind.Markup:return _.NotebookCellKind.Markup;case m.CellKind.Code:default:return _.NotebookCellKind.Code}}Ee.to=he})(qe=e.NotebookCellKind||(e.NotebookCellKind={}));var Ve;(function(Ee){function _e(X){const Ie={metadata:X.metadata??Object.create(null),cells:[]};for(let Ne of X.cells)_.NotebookCellData.validate(Ne),Ie.cells.push(ut.from(Ne));return Ie}Ee.from=_e;function he(X){const Ie=new _.NotebookData(X.cells.map(ut.to));return(0,D.isEmptyObject)(X.metadata)||(Ie.metadata=X.metadata),Ie}Ee.to=he})(Ve=e.NotebookData||(e.NotebookData={}));var ut;(function(Ee){function _e(X){return{cellKind:qe.from(X.kind),language:X.languageId,mime:X.mime,source:X.value,metadata:X.metadata,internalMetadata:Me.from(X.executionSummary??{}),outputs:X.outputs?X.outputs.map(Ae.from):[]}}Ee.from=_e;function he(X){return new _.NotebookCellData(qe.to(X.cellKind),X.source,X.language,X.mime,X.outputs?X.outputs.map(Ae.to):void 0,X.metadata,X.internalMetadata?Me.to(X.internalMetadata):void 0)}Ee.to=he})(ut=e.NotebookCellData||(e.NotebookCellData={}));var Le;(function(Ee){function _e(X){return{mime:X.mime,valueBytes:t.VSBuffer.wrap(X.data)}}Ee.from=_e;function he(X){return new _.NotebookCellOutputItem(X.valueBytes.buffer,X.mime)}Ee.to=he})(Le=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Ae;(function(Ee){function _e(X){return{outputId:X.id,items:X.items.map(Le.from),metadata:X.metadata}}Ee.from=_e;function he(X){const Ie=X.items.map(Le.to);return new _.NotebookCellOutput(Ie,X.outputId,X.metadata)}Ee.to=he})(Ae=e.NotebookCellOutput||(e.NotebookCellOutput={}));var De;(function(Ee){function _e(Ie){return X(Ie)?{include:(0,D.withNullAsUndefined)(Se.from(Ie.include)),exclude:(0,D.withNullAsUndefined)(Se.from(Ie.exclude))}:(0,D.withNullAsUndefined)(Se.from(Ie))}Ee.from=_e;function he(Ie){return X(Ie)?{include:Se.to(Ie.include),exclude:Se.to(Ie.exclude)}:Se.to(Ie)}Ee.to=he;function X(Ie){const Ne=Ie;return Ne?!!Ne.include&&!!Ne.exclude:!1}})(De=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var ce;(function(Ee){function _e(he){return{backgroundColor:he.backgroundColor,borderColor:he.borderColor,top:he.top?M.from(he.top):void 0}}Ee.from=_e})(ce=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var de;(function(Ee){function _e(he,X,Ie){const Ne=typeof he.command=="string"?{title:"",command:he.command}:he.command;return{alignment:he.alignment===_.NotebookCellStatusBarAlignment.Left?1:2,command:X.toInternal(Ne,Ie),text:he.text,tooltip:he.tooltip,accessibilityInformation:he.accessibilityInformation,priority:he.priority}}Ee.from=_e})(de=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var be;(function(Ee){function _e(he){return{transientOutputs:he?.transientOutputs??!1,transientCellMetadata:he?.transientCellMetadata??{},transientDocumentMetadata:he?.transientDocumentMetadata??{}}}Ee.from=_e})(be=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Ce;(function(Ee){function _e(X){return{uri:X.uri,provides:X.provides}}Ee.from=_e;function he(X){return new _.NotebookRendererScript(P.URI.revive(X.uri),X.provides)}Ee.to=he})(Ce=e.NotebookRendererScript||(e.NotebookRendererScript={}));var Oe;(function(Ee){function _e(X){return{message:v.fromStrict(X.message)||"",type:0,expected:X.expectedOutput,actual:X.actualOutput,location:X.location?ne.from(X.location):void 0}}Ee.from=_e;function he(X){const Ie=new _.TestMessage(typeof X.message=="string"?X.message:v.to(X.message));return Ie.actualOutput=X.actual,Ie.expectedOutput=X.expected,Ie.location=X.location?ne.to(X.location):void 0,Ie}Ee.to=he})(Oe=e.TestMessage||(e.TestMessage={}));var Ke;(function(Ee){let _e;(function(he){he.Delimiter="\0"})(_e||(_e={})),Ee.namespace=(he,X)=>he+"\0"+X,Ee.denamespace=he=>{const X=he.indexOf("\0");return{ctrlId:he.slice(0,X),tagId:he.slice(X+1)}}})(Ke=e.TestTag||(e.TestTag={}));var $e;(function(Ee){function _e(Ne){const Ye=(0,p.getPrivateApiFor)(Ne).controllerId;return{extId:b.TestId.fromExtHostTestItem(Ne,Ye).toString(),label:Ne.label,uri:Ne.uri,tags:Ne.tags.map(Xe=>Ke.namespace(Ye,Xe.id)),range:s.from(Ne.range)||null,description:Ne.description||null,error:Ne.error&&v.fromStrict(Ne.error)||null}}Ee.from=_e;function he(Ne){return{parent:void 0,error:void 0,id:b.TestId.fromString(Ne.extId).localId,label:Ne.label,uri:P.URI.revive(Ne.uri),tags:(Ne.tags||[]).map(Ye=>{const{tagId:Xe}=Ke.denamespace(Ye);return new _.TestTag(Xe)}),range:s.to(Ne.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:Ne.description||void 0}}Ee.toPlain=he;function X(Ne){const Ye=b.TestId.fromString(Ne.extId),Xe=new p.TestItemImpl(Ye.controllerId,Ye.localId,Ne.label,P.URI.revive(Ne.uri));return Xe.range=s.to(Ne.range||void 0),Xe.description=Ne.description||void 0,Xe}function Ie(Ne){let Ye;for(const Xe of Ne.tests){const pt=X(Xe.item);(0,p.getPrivateApiFor)(pt).parent=Ye,Ye=pt}return Ye}Ee.toItemFromContext=Ie})($e=e.TestItem||(e.TestItem={})),function(Ee){function _e(X){return{id:X.id}}Ee.from=_e;function he(X){return new _.TestTag(X.id)}Ee.to=he}(Ke=e.TestTag||(e.TestTag={}));var Ze;(function(Ee){const _e=(X,Ie)=>{const Ne={...$e.toPlain(X.item),parent:void 0,taskStates:X.tasks.map(Ye=>({state:Ye.state,duration:Ye.duration,messages:Ye.messages.filter(Xe=>Xe.type===0).map(Oe.to)})),children:X.children.map(Ye=>Ie.get(Ye)).filter(D.isDefined).map(Ye=>_e(Ye,Ie))};for(const Ye of Ne.children)Ye.parent=Ne;return Ne};function he(X){const Ie=[],Ne=new Map;for(const Ye of X.items)Ne.set(Ye.item.extId,Ye),X.request.targets.some(Xe=>Xe.controllerId===Ye.controllerId&&Xe.testIds.includes(Ye.item.extId))&&Ie.push(Ye);return{completedAt:X.completedAt,results:Ie.map(Ye=>_e(Ye,Ne))}}Ee.to=he})(Ze=e.TestResults||(e.TestResults={}));var lt;(function(Ee){function _e(Ne){return{covered:Ne.covered,total:Ne.covered}}function he(Ne){return"line"in Ne?n.from(Ne):s.from(Ne)}function X(Ne){return"branches"in Ne?{count:Ne.executionCount,location:he(Ne.location),type:1,branches:Ne.branches.length?Ne.branches.map(Ye=>({count:Ye.executionCount,location:Ye.location&&he(Ye.location)})):void 0}:{type:0,count:Ne.executionCount,location:he(Ne.location)}}Ee.fromDetailed=X;function Ie(Ne){return{uri:Ne.uri,statement:_e(Ne.statementCoverage),branch:Ne.branchCoverage&&_e(Ne.branchCoverage),function:Ne.functionCoverage&&_e(Ne.functionCoverage),details:Ne.detailedCoverage?.map(X)}}Ee.fromFile=Ie})(lt=e.TestCoverage||(e.TestCoverage={}));var ct;(function(Ee){function _e(he){switch(he){case 1:return _.CodeActionTriggerKind.Invoke;case 2:return _.CodeActionTriggerKind.Automatic}}Ee.to=_e})(ct=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var He;(function(Ee){function _e(X){const Ie=new _.TypeHierarchyItem(N.to(X.kind),X.name,X.detail||"",P.URI.revive(X.uri),s.to(X.range),s.to(X.selectionRange));return Ie._sessionId=X._sessionId,Ie._itemId=X._itemId,Ie}Ee.to=_e;function he(X,Ie,Ne){if(Ie=Ie??X._sessionId,Ne=Ne??X._itemId,Ie===void 0||Ne===void 0)throw new Error("invalid item");return{_sessionId:Ie,_itemId:Ne,kind:N.from(X.kind),name:X.name,detail:X.detail??"",uri:X.uri,range:s.from(X.range),selectionRange:s.from(X.selectionRange),tags:X.tags?.map($.from)}}Ee.from=he})(He=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(ve[217],we([0,1,2,16,7,15,93]),function(Z,e,h,t,I,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class k{constructor(P,L,C,l={timeout:1500,errors:3}){this._logService=P,this._documents=L,this._mainThreadBulkEdits=C,this._thresholds=l,this._callbacks=new R.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(P){return(L,C,l)=>{const p={dispose:this._callbacks.push([L,C,P])};return Array.isArray(l)&&l.push(p),p}}async $participateInSave(P,L){const C=h.URI.revive(P);let l=!1;const E=setTimeout(()=>l=!0,this._thresholds.timeout),p=[];try{for(let m of[...this._callbacks]){if(l)break;const b=this._documents.getDocument(C),F=await this._deliverEventAsyncAndBlameBadListeners(m,{document:b,reason:y.TextDocumentSaveReason.to(L)});p.push(F)}}finally{clearTimeout(E)}return p}_deliverEventAsyncAndBlameBadListeners([P,L,C],l){const E=this._badListeners.get(P);return typeof E=="number"&&E>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(C,P,L,l).then(()=>!0,p=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' threw ERROR`),this._logService.error(p),!(p instanceof Error)||p.message!=="concurrent_edits"){const m=this._badListeners.get(P);this._badListeners.set(P,m?m+1:1),typeof m=="number"&&m>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(P,L,C,l){const E=[],p=Date.now(),{document:m,reason:b}=l,{version:F}=m,_=Object.freeze({document:m,reason:b,waitUntil(g){if(Object.isFrozen(E))throw(0,t.illegalState)("waitUntil can not be called async");E.push(Promise.resolve(g))}});try{L.apply(C,[_])}catch(g){return Promise.reject(g)}return Object.freeze(E),new Promise((g,s)=>{const d=setTimeout(()=>s(new Error("timeout")),this._thresholds.timeout);return Promise.all(E).then(n=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' finished after ${Date.now()-p}ms`),clearTimeout(d),g(n)}).catch(n=>{clearTimeout(d),s(n)})}).then(g=>{const s={edits:[]};for(const d of g)if(Array.isArray(d)&&d.every(n=>n instanceof I.TextEdit))for(const{newText:n,newEol:S,range:o}of d)s.edits.push({_type:2,resource:m.uri,edit:{range:o&&y.Range.from(o),text:n,eol:S&&y.EndOfLine.from(S)}});if(s.edits.length!==0)return F===m.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(s):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=k}),define(ve[218],we([0,1,10,25,2,15,127]),function(Z,e,h,t,I,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class k{constructor(C,l,E,p){this.start=C,this.deletedCount=l,this.deletedItems=E,this.items=p}static asApiEvents(C){return C.map(l=>({start:l.start,deletedCount:l.deletedCount,deletedItems:l.deletedItems,items:l.items.map(E=>E.apiCell)}))}}class D{constructor(C,l,E){this.notebook=C,this._extHostDocument=l,this._cellData=E,this.handle=E.handle,this.uri=I.URI.revive(E.uri),this.cellKind=E.cellKind,this._outputs=E.outputs.map(y.NotebookCellOutput.to),this._internalMetadata=E.internalMetadata??{},this._metadata=Object.freeze(E.metadata??{}),this._previousResult=Object.freeze(y.NotebookCellExecutionSummary.to(E.internalMetadata??{}))}static asModelAddData(C,l){return{EOL:l.eol,lines:l.source,languageId:l.language,uri:l.uri,isDirty:!1,versionId:1,notebook:C}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const C=this,l=this._extHostDocument.getDocument(this.uri);if(!l)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return C.notebook.getCellIndex(C)},notebook:C.notebook.apiNotebook,kind:y.NotebookCellKind.to(this._cellData.cellKind),document:l.document,get mime(){return C._mime},set mime(E){C._mime=E},get outputs(){return C._outputs.slice(0)},get metadata(){return C._metadata},get executionSummary(){return C._previousResult}})}return this._apiCell}setOutputs(C){this._outputs=C.map(y.NotebookCellOutput.to)}setOutputItems(C,l,E){const p=E.map(y.NotebookCellOutputItem.to),m=this._outputs.find(b=>b.id===C);m&&(l||(m.items.length=0),m.items.push(...p))}setMetadata(C){this._metadata=Object.freeze(C)}setInternalMetadata(C){this._internalMetadata=C,this._previousResult=Object.freeze(y.NotebookCellExecutionSummary.to(C))}setMime(C){}}e.ExtHostCell=D;class P{constructor(C,l,E,p,m,b){this._proxy=C,this._textDocumentsAndEditors=l,this._textDocuments=E,this._emitter=p,this.uri=m,this.handle=P._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=b.viewType,this._metadata=Object.freeze(b.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,b.cells]],!0),this._versionId=b.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const C=this;this._notebook={get uri(){return C.uri},get version(){return C._versionId},get notebookType(){return C._notebookType},get isDirty(){return C._isDirty},get isUntitled(){return C.uri.scheme===h.Schemas.untitled},get isClosed(){return C._disposed},get metadata(){return C._metadata},get cellCount(){return C._cells.length},cellAt(l){return l=C._validateIndex(l),C._cells[l].apiCell},getCells(l){return(l?C._getCells(l):C._cells).map(p=>p.apiCell)},save(){return C._save()}}}return this._notebook}updateBackup(C){this._backup?.delete(),this._backup=C}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(C){C.metadata&&(this._metadata=Object.freeze({...this._metadata,...C.metadata}))}acceptDirty(C){this._isDirty=C}acceptModelChanged(C,l){this._versionId=C.versionId,this._isDirty=l;for(const E of C.rawEvents)E.kind===R.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(E.changes,!1):E.kind===R.NotebookCellsChangeType.Move?this._moveCell(E.index,E.newIdx):E.kind===R.NotebookCellsChangeType.Output?this._setCellOutputs(E.index,E.outputs):E.kind===R.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(E.index,E.outputId,E.append,E.outputItems):E.kind===R.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(E.index,E.language):E.kind===R.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(E.index,E.mime):E.kind===R.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(E.index,E.metadata):E.kind===R.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(E.index,E.internalMetadata)}_validateIndex(C){return C=C|0,C<0?0:C>=this._cells.length?this._cells.length-1:C}_validateRange(C){let l=C.start|0,E=C.end|0;return l<0&&(l=0),E>this._cells.length&&(E=this._cells.length),C.with({start:l,end:E})}_getCells(C){C=this._validateRange(C);const l=[];for(let E=C.start;E<C.end;E++)l.push(this._cells[E]);return l}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(C,l){if(this._disposed)return;const E=[],p=[],m=[];C.reverse().forEach(b=>{const _=b[2].map(d=>{const n=new D(this,this._textDocumentsAndEditors,d);return l||p.push(D.asModelAddData(this.apiNotebook,d)),n}),g=new k(b[0],b[1],[],_),s=this._cells.splice(b[0],b[1],..._);for(const d of s)m.push(d.uri),g.deletedItems.push(d.apiCell);E.push(g)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:p,removedDocuments:m}),l||this._emitter.emitModelChange((0,t.deepFreeze)({document:this.apiNotebook,changes:k.asApiEvents(E)}))}_moveCell(C,l){const E=this._cells.splice(C,1);this._cells.splice(l,0,...E);const p=[new k(C,1,E.map(m=>m.apiCell),[]),new k(l,0,[],E)];this._emitter.emitModelChange((0,t.deepFreeze)({document:this.apiNotebook,changes:k.asApiEvents(p)}))}_setCellOutputs(C,l){const E=this._cells[C];E.setOutputs(l),this._emitter.emitCellOutputsChange((0,t.deepFreeze)({document:this.apiNotebook,cells:[E.apiCell]}))}_setCellOutputItems(C,l,E,p){const m=this._cells[C];m.setOutputItems(l,E,p),this._emitter.emitCellOutputsChange((0,t.deepFreeze)({document:this.apiNotebook,cells:[m.apiCell]}))}_changeCellLanguage(C,l){const E=this._cells[C];E.apiCell.document.languageId!==l&&this._textDocuments.$acceptModelLanguageChanged(E.uri,l)}_changeCellMime(C,l){const E=this._cells[C];E.apiCell.mime=l}_changeCellMetadata(C,l){const E=this._cells[C],p=E.apiCell.metadata;E.setMetadata(l);const m=E.apiCell.metadata;(0,t.equals)(p,m)||this._emitter.emitCellMetadataChange((0,t.deepFreeze)({document:this.apiNotebook,cell:E.apiCell}))}_changeCellInternalMetadata(C,l){this._cells[C].setInternalMetadata(l)}getCellFromApiCell(C){return this._cells.find(l=>l.apiCell===C)}getCellFromIndex(C){return this._cells[C]}getCell(C){return this._cells.find(l=>l.handle===C)}getCellIndex(C){return this._cells.indexOf(C)}}e.ExtHostNotebookDocument=P,P._handlePool=0}),define(ve[130],we([0,1,7,15,16]),function(Z,e,h,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class y{constructor(D){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=D}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(D){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:D})}replaceCellMetadata(D,P){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:D,metadata:P})}replaceCells(D,P,L){this._throwIfFinalized(),!(D===P&&L.length===0)&&this._collectedEdits.push({editType:1,index:D,count:P-D,cells:L.map(t.NotebookCellData.from)})}}class R{constructor(D,P,L,C,l,E){this.id=D,this._proxy=P,this.notebookData=L,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=l,this._visibleRanges=C,this._viewColumn=E}get apiEditor(){if(!this._editor){const D=this;this._editor={get document(){return D.notebookData.apiNotebook},get selections(){return D._selections},set selections(P){if(!Array.isArray(P)||!P.every(h.NotebookRange.isNotebookRange))throw(0,I.illegalArgument)("selections");D._selections=P,D._trySetSelections(P)},get visibleRanges(){return D._visibleRanges},revealRange(P,L){D._proxy.$tryRevealRange(D.id,t.NotebookRange.from(P),L??h.NotebookEditorRevealType.Default)},get viewColumn(){return D._viewColumn},edit(P){const L=new y(this.document.version);return P(L),D._applyEdit(L.finalize())},setDecorations(P,L){return D.setDecorations(P,L)}},R.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(D){this._visible=D}_acceptVisibleRanges(D){this._visibleRanges=D}_acceptSelections(D){this._selections=D}_trySetSelections(D){this._proxy.$trySetSelections(this.id,D.map(t.NotebookRange.from))}_acceptViewColumn(D){this._viewColumn=D}_applyEdit(D){if(D.cellEdits.length===0)return Promise.resolve(!0);const P=[];let L=-1;for(let C=0;C<D.cellEdits.length;C++){if(L<0){P.push(D.cellEdits[C]),L++;continue}const E=P[L],p=D.cellEdits[C];if(E.editType===1&&p.editType===1&&E.index===p.index){E.cells.push(...D.cellEdits[C].cells),E.count+=D.cellEdits[C].count;continue}P.push(D.cellEdits[C]),L++}return this._proxy.$tryApplyEdits(this.id,D.documentVersionId,P)}setDecorations(D,P){if(!(P.isEmpty&&!this._hasDecorationsForKey.has(D.key)))return P.isEmpty?this._hasDecorationsForKey.delete(D.key):this._hasDecorationsForKey.add(D.key),this._proxy.$trySetDecorations(this.id,t.NotebookRange.from(P),D.key)}}e.ExtHostNotebookEditor=R,R.apiEditorsToExtHost=new WeakMap}),define(ve[219],we([0,1,15,118,166,21,56,16]),function(Z,e,h,t,I,y,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class D{constructor(l){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=l}async withProgress(l,E,p){const m=this._handles++,{title:b,location:F,cancellable:_}=E,g={label:(0,I.localize)(0,null,l.displayName||l.name),id:l.identifier.value};return this._proxy.$startProgress(m,{location:h.ProgressLocation.from(F),title:b,source:g,cancellable:_},l.isUnderDevelopment?void 0:l.identifier.value).catch(k.onUnexpectedExternalError),this._withProgress(m,p,!!_)}_withProgress(l,E,p){let m;p&&(m=new y.CancellationTokenSource,this._mapHandleToCancellationSource.set(l,m));const b=_=>{this._proxy.$progressEnd(_),this._mapHandleToCancellationSource.delete(_),m&&m.dispose()};let F;try{F=E(new L(this._proxy,l),p&&m?m.token:y.CancellationToken.None)}catch(_){throw b(l),_}return F.then(_=>b(l),_=>b(l)),F}$acceptProgressCanceled(l){const E=this._mapHandleToCancellationSource.get(l);E&&(E.cancel(),this._mapHandleToCancellationSource.delete(l))}}e.ExtHostProgress=D;function P(C,l){return C.message=l.message,typeof l.increment=="number"&&(typeof C.increment=="number"?C.increment+=l.increment:C.increment=l.increment),C}class L extends t.Progress{constructor(l,E){super(p=>this.throttledReport(p));this._proxy=l,this._handle=E}throttledReport(l){this._proxy.$progressReport(this._handle,l)}}je([(0,R.throttle)(100,(C,l)=>P(C,l),()=>Object.create(null))],L.prototype,"throttledReport",null)}),define(ve[131],we([0,1,55,16,77,15,7]),function(Z,e,h,t,I,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class k{constructor(l,E,p){const m=k._Keys.nextId();l.$registerTextEditorDecorationType(E.identifier,m,y.DecorationRenderOptions.from(p)),this.value=Object.freeze({key:m,dispose(){l.$removeTextEditorDecorationType(m)}})}}e.TextEditorDecorationType=k,k._Keys=new I.IdGenerator("TextEditorDecorationType");class D{constructor(l,E){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=l,this._documentVersionId=l.version,this._undoStopBefore=E.undoStopBefore,this._undoStopAfter=E.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(l,E){this._throwIfFinalized();let p=null;if(l instanceof R.Position)p=new R.Range(l,l);else if(l instanceof R.Range)p=l;else throw new Error("Unrecognized location");this._pushEdit(p,E,!1)}insert(l,E){this._throwIfFinalized(),this._pushEdit(new R.Range(l,l),E,!0)}delete(l){this._throwIfFinalized();let E=null;if(l instanceof R.Range)E=l;else throw new Error("Unrecognized location");this._pushEdit(E,null,!0)}_pushEdit(l,E,p){const m=this._document.validateRange(l);this._collectedEdits.push({range:m,text:E,forceMoveMarkers:p})}setEndOfLine(l){if(this._throwIfFinalized(),l!==R.EndOfLine.LF&&l!==R.EndOfLine.CRLF)throw(0,t.illegalArgument)("endOfLine");this._setEndOfLine=l}}e.TextEditorEdit=D;class P{constructor(l,E,p,m){this._proxy=l,this._id=E,this._accept(p),this._logService=m;const b=this;this.value={get tabSize(){return b._tabSize},set tabSize(F){b._setTabSize(F)},get insertSpaces(){return b._insertSpaces},set insertSpaces(F){b._setInsertSpaces(F)},get cursorStyle(){return b._cursorStyle},set cursorStyle(F){b._setCursorStyle(F)},get lineNumbers(){return b._lineNumbers},set lineNumbers(F){b._setLineNumbers(F)}}}_accept(l){this._tabSize=l.tabSize,this._insertSpaces=l.insertSpaces,this._cursorStyle=l.cursorStyle,this._lineNumbers=y.TextEditorLineNumbersStyle.to(l.lineNumbers)}_validateTabSize(l){if(l==="auto")return"auto";if(typeof l=="number"){const E=Math.floor(l);return E>0?E:null}if(typeof l=="string"){const E=parseInt(l,10);return isNaN(E)?null:E>0?E:null}return null}_setTabSize(l){const E=this._validateTabSize(l);if(E!==null){if(typeof E=="number"){if(this._tabSize===E)return;this._tabSize=E}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:E}))}}_validateInsertSpaces(l){return l==="auto"?"auto":l==="false"?!1:Boolean(l)}_setInsertSpaces(l){const E=this._validateInsertSpaces(l);if(typeof E=="boolean"){if(this._insertSpaces===E)return;this._insertSpaces=E}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:E}))}_setCursorStyle(l){this._cursorStyle!==l&&(this._cursorStyle=l,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:l})))}_setLineNumbers(l){this._lineNumbers!==l&&(this._lineNumbers=l,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:y.TextEditorLineNumbersStyle.from(l)})))}assign(l){const E={};let p=!1;if(typeof l.tabSize!="undefined"){const m=this._validateTabSize(l.tabSize);m==="auto"?(p=!0,E.tabSize=m):typeof m=="number"&&this._tabSize!==m&&(this._tabSize=m,p=!0,E.tabSize=m)}if(typeof l.insertSpaces!="undefined"){const m=this._validateInsertSpaces(l.insertSpaces);m==="auto"?(p=!0,E.insertSpaces=m):this._insertSpaces!==m&&(this._insertSpaces=m,p=!0,E.insertSpaces=m)}typeof l.cursorStyle!="undefined"&&this._cursorStyle!==l.cursorStyle&&(this._cursorStyle=l.cursorStyle,p=!0,E.cursorStyle=l.cursorStyle),typeof l.lineNumbers!="undefined"&&this._lineNumbers!==l.lineNumbers&&(this._lineNumbers=l.lineNumbers,p=!0,E.lineNumbers=y.TextEditorLineNumbersStyle.from(l.lineNumbers)),p&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,E))}_warnOnError(l,E){E.catch(p=>{this._logService.warn(`ExtHostTextEditorOptions '${l}' failed:'`),this._logService.warn(p)})}}e.ExtHostTextEditorOptions=P;class L{constructor(l,E,p,m,b,F,_,g){this.id=l,this._proxy=E,this._logService=p,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=b,this._options=new P(this._proxy,this.id,F,p),this._visibleRanges=_,this._viewColumn=g;const s=this;this.value=Object.freeze({get document(){return m.getValue()},set document(d){throw(0,t.readonly)("document")},get selection(){return s._selections&&s._selections[0]},set selection(d){if(!(d instanceof R.Selection))throw(0,t.illegalArgument)("selection");s._selections=[d],s._trySetSelection()},get selections(){return s._selections},set selections(d){if(!Array.isArray(d)||d.some(n=>!(n instanceof R.Selection)))throw(0,t.illegalArgument)("selections");s._selections=d,s._trySetSelection()},get visibleRanges(){return s._visibleRanges},set visibleRanges(d){throw(0,t.readonly)("visibleRanges")},get options(){return s._options.value},set options(d){s._disposed||s._options.assign(d)},get viewColumn(){return s._viewColumn},set viewColumn(d){throw(0,t.readonly)("viewColumn")},edit(d,n={undoStopBefore:!0,undoStopAfter:!0}){if(s._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const S=new D(m.getValue(),n);return d(S),s._applyEdit(S)},insertSnippet(d,n,S={undoStopBefore:!0,undoStopAfter:!0}){if(s._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let o;if(!n||Array.isArray(n)&&n.length===0)o=s._selections.map(i=>y.Range.from(i));else if(n instanceof R.Position){const{lineNumber:i,column:r}=y.Position.from(n);o=[{startLineNumber:i,startColumn:r,endLineNumber:i,endColumn:r}]}else if(n instanceof R.Range)o=[y.Range.from(n)];else{o=[];for(const i of n)if(i instanceof R.Range)o.push(y.Range.from(i));else{const{lineNumber:r,column:c}=y.Position.from(i);o.push({startLineNumber:r,startColumn:c,endLineNumber:r,endColumn:c})}}return E.$tryInsertSnippet(l,d.value,o,S)},setDecorations(d,n){const S=n.length===0;S&&!s._hasDecorationsForKey.has(d.key)||(S?s._hasDecorationsForKey.delete(d.key):s._hasDecorationsForKey.add(d.key),s._runOnProxy(()=>{if(y.isDecorationOptionsArr(n))return E.$trySetDecorations(l,d.key,y.fromRangeOrRangeWithMessage(n));{const o=new Array(4*n.length);for(let i=0,r=n.length;i<r;i++){const c=n[i];o[4*i]=c.start.line+1,o[4*i+1]=c.start.character+1,o[4*i+2]=c.end.line+1,o[4*i+3]=c.end.character+1}return E.$trySetDecorationsFast(l,d.key,o)}}))},revealRange(d,n){s._runOnProxy(()=>E.$tryRevealRange(l,y.Range.from(d),n||R.TextEditorRevealType.Default))},show(d){E.$tryShowEditor(l,y.ViewColumn.from(d))},hide(){E.$tryHideEditor(l)}})}dispose(){(0,h.ok)(!this._disposed),this._disposed=!0}_acceptOptions(l){(0,h.ok)(!this._disposed),this._options._accept(l)}_acceptVisibleRanges(l){(0,h.ok)(!this._disposed),this._visibleRanges=l}_acceptViewColumn(l){(0,h.ok)(!this._disposed),this._viewColumn=l}_acceptSelections(l){(0,h.ok)(!this._disposed),this._selections=l}async _trySetSelection(){const l=this._selections.map(y.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,l)),this.value}_applyEdit(l){const E=l.finalize();if(E.edits.length===0&&!E.setEndOfLine)return Promise.resolve(!0);const p=E.edits.map(b=>b.range);p.sort((b,F)=>b.end.line===F.end.line?b.end.character===F.end.character?b.start.line===F.start.line?b.start.character-F.start.character:b.start.line-F.start.line:b.end.character-F.end.character:b.end.line-F.end.line);for(let b=0,F=p.length-1;b<F;b++){const _=p[b].end;if(p[b+1].start.isBefore(_))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const m=E.edits.map(b=>({range:y.Range.from(b.range),text:b.text,forceMoveMarkers:b.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,E.documentVersionId,m,{setEndOfLine:typeof E.setEndOfLine=="number"?y.EndOfLine.from(E.setEndOfLine):void 0,undoStopBefore:E.undoStopBefore,undoStopAfter:E.undoStopAfter})}_runOnProxy(l){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):l().then(()=>this,E=>(E instanceof Error&&E.name==="DISPOSED"||this._logService.warn(E),null))}}e.ExtHostTextEditor=L}),define(ve[220],we([0,1,13,3,6,18,64,15,128,88]),function(Z,e,h,t,I,y,R,k,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class L extends I.Disposable{constructor(l){super();this.controllerId=l,this.debounceSendDiff=this._register(new h.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new t.Emitter),this.root=new R.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(l){this._resolveHandler=l;for(const E of this.tree.values())this.updateExpandability(E)}collectDiff(){const l=this.diff;return this.diff=[],l}pushDiff(l){const E=this.diff[this.diff.length-1];if(E&&l[0]===1){if(E[0]===1&&E[1].extId===l[1].extId){(0,D.applyTestItemUpdate)(E[1],l[1]);return}if(E[0]===0&&E[1].item.extId===l[1].extId){(0,D.applyTestItemUpdate)(E[1],l[1]);return}}this.diff.push(l),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(l,E){const p=this.tree.get(l);if(!!p){if((p.expandLevels===void 0||E>p.expandLevels)&&(p.expandLevels=E),p.expand===1){const m=this.resolveChildren(p);return m.isOpen()?this.expandChildren(p,E-1):m.wait().then(()=>this.expandChildren(p,E-1))}else if(p.expand===3)return p.resolveBarrier?.isOpen()===!1?p.resolveBarrier.wait().then(()=>this.expandChildren(p,E-1)):this.expandChildren(p,E-1)}}dispose(){for(const l of this.tree.values())(0,R.getPrivateApiFor)(l.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(l,E){switch(E.op){case 2:this.pushDiff([4,l.fullId.toString()]);break;case 1:this.removeItem(P.TestId.joinToString(l.fullId,E.id));break;case 0:this.upsertItem(E.item,l);break;case 4:for(const p of E.ops)this.onTestItemEvent(l,p);break;case 3:{const{key:p,value:m,previous:b}=E,F=l.fullId.toString();switch(p){case"canResolveChildren":this.updateExpandability(l);break;case"tags":this.diffTagRefs(m,b,F);break;case"range":this.pushDiff([1,{extId:F,item:{range:k.Range.from(m)}}]);break;case"error":this.pushDiff([1,{extId:F,item:{error:k.MarkdownString.fromStrict(m)||null}}]);break;default:this.pushDiff([1,{extId:F,item:{[p]:m??null}}]);break}break}default:(0,y.assertNever)(E)}}upsertItem(l,E){if(!(l instanceof R.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${l.id} did not`);const p=P.TestId.fromExtHostTestItem(l,this.root.id,E?.actual),m=(0,R.getPrivateApiFor)(l);m.parent&&m.parent!==E?.actual&&m.parent.children.delete(l.id);let b=this.tree.get(p.toString());if(!b){b={fullId:p,actual:l,parent:E?p.parentId:null,expandLevels:E?.expandLevels?E.expandLevels-1:void 0,expand:0},l.tags.forEach(this.incrementTagRefs,this),this.tree.set(b.fullId.toString(),b),this.setItemParent(l,E),this.pushDiff([0,{parent:b.parent&&b.parent.toString(),controllerId:this.controllerId,expand:b.expand,item:k.TestItem.from(l)}]),this.connectItemAndChildren(l,b,E);return}if(b.actual===l){this.connectItem(l,b,E);return}const F=b.actual.children,_=b.actual,g=(0,R.diffTestItems)(_,l);(0,R.getPrivateApiFor)(_).listener=void 0,b.actual=l,b.expand=0;for(const[s,d]of g)this.onTestItemEvent(b,{op:3,key:s,value:d,previous:_[s]});this.connectItemAndChildren(l,b,E);for(const s of F)l.children.get(s.id)||this.removeItem(P.TestId.joinToString(p,s.id))}diffTagRefs(l,E,p){const m=new Set(E.map(b=>b.id));for(const b of l)m.delete(b.id)||this.incrementTagRefs(b);this.pushDiff([1,{extId:p,item:{tags:l.map(b=>k.TestTag.namespace(this.controllerId,b.id))}}]),m.forEach(this.decrementTagRefs,this)}incrementTagRefs(l){const E=this.tags.get(l.id);E?E.refCount++:(this.tags.set(l.id,{refCount:1}),this.pushDiff([5,{id:k.TestTag.namespace(this.controllerId,l.id),ctrlLabel:this.root.label}]))}decrementTagRefs(l){const E=this.tags.get(l);E&&!--E.refCount&&(this.tags.delete(l),this.pushDiff([6,k.TestTag.namespace(this.controllerId,l)]))}setItemParent(l,E){(0,R.getPrivateApiFor)(l).parent=E&&E.actual!==this.root?E.actual:void 0}connectItem(l,E,p){this.setItemParent(l,p);const m=(0,R.getPrivateApiFor)(l);m.parent=p?.actual,m.listener=b=>this.onTestItemEvent(E,b),this.updateExpandability(E)}connectItemAndChildren(l,E,p){this.connectItem(l,E,p);for(const m of l.children)this.upsertItem(m,E)}updateExpandability(l){let E;this._resolveHandler?l.resolveBarrier?E=l.resolveBarrier.isOpen()?3:2:E=l.actual.canResolveChildren?1:0:E=0,E!==l.expand&&(l.expand=E,this.pushDiff([1,{extId:l.fullId.toString(),expand:E}]),E===1&&l.expandLevels!==void 0&&this.resolveChildren(l))}expandChildren(l,E){if(E<0)return;const p=[];for(const m of l.actual.children){const b=this.expand(P.TestId.joinToString(l.fullId,m.id),E);(0,h.isThenable)(b)&&p.push(b)}if(p.length)return Promise.all(p).then(()=>{})}resolveChildren(l){if(l.resolveBarrier)return l.resolveBarrier;if(!this._resolveHandler){const b=new h.Barrier;return b.open(),b}l.expand=2,this.pushExpandStateUpdate(l);const E=l.resolveBarrier=new h.Barrier,p=b=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),l.actual!==this.root&&(l.actual.error=b.stack||b.message||String(b))};let m;try{m=this._resolveHandler(l.actual===this.root?void 0:l.actual)}catch(b){p(b)}return(0,h.isThenable)(m)?m.catch(p).then(()=>{E.open(),this.updateExpandability(l)}):(E.open(),this.updateExpandability(l)),l.resolveBarrier}pushExpandStateUpdate(l){this.pushDiff([1,{extId:l.fullId.toString(),expand:l.expand}])}removeItem(l){const E=this.tree.get(l);if(!E)throw new Error("attempting to remove non-existent child");this.pushDiff([2,l]);const p=[E];for(;p.length;){const m=p.pop();if(!!m){(0,R.getPrivateApiFor)(m.actual).listener=void 0;for(const b of m.actual.tags)this.decrementTagRefs(b.id);this.tree.delete(m.fullId.toString());for(const b of m.actual.children)p.push(this.tree.get(P.TestId.joinToString(m.fullId,b.id)))}}}flushDiff(){const l=this.collectDiff();l.length&&this.diffOpEmitter.fire(l)}}e.SingleUseTestCollection=L}),define(ve[221],we([0,1,4,184]),function(Z,e,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,h.refineServiceDecorator)(t.IEnvironmentService)}),define(ve[222],we([0,1,27,3,9]),function(Z,e,h,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class y{constructor(L){this.removedDueToLooping=L}}e.DeltaExtensionsResult=y;class R{constructor(L){this._onDidChange=new t.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=L,this._initialize()}_initialize(){this._extensionDescriptions.sort(D),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const L of this._extensionDescriptions){if(this._extensionsMap.has(h.ExtensionIdentifier.toKey(L.identifier))){console.error("Extension `"+L.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(h.ExtensionIdentifier.toKey(L.identifier),L),this._extensionsArr.push(L),Array.isArray(L.activationEvents))for(let C of L.activationEvents)C==="onUri"&&(C=`onUri:${h.ExtensionIdentifier.toKey(L.identifier)}`),this._activationMap.has(C)||this._activationMap.set(C,[]),this._activationMap.get(C).push(L)}}keepOnly(L){const C=new Set;L.forEach(l=>C.add(h.ExtensionIdentifier.toKey(l))),this._extensionDescriptions=this._extensionDescriptions.filter(l=>C.has(h.ExtensionIdentifier.toKey(l.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(L,C){L.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(L));const l=R._findLoopingExtensions(this._extensionDescriptions);if(C=C.concat(l.map(E=>E.identifier)),C.length>0){const E=new Set;C.forEach(p=>E.add(h.ExtensionIdentifier.toKey(p))),this._extensionDescriptions=this._extensionDescriptions.filter(p=>!E.has(h.ExtensionIdentifier.toKey(p.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new y(l)}static _findLoopingExtensions(L){const C=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(b){this._nodesSet.has(b)||(this._nodesSet.add(b),this._nodesArr.push(b))}addArc(b,F){this.addNode(b),this.addNode(F),this._arcs.has(b)?this._arcs.get(b).push(F):this._arcs.set(b,[F])}getArcs(b){return this._arcs.has(b)?this._arcs.get(b):[]}hasOnlyGoodArcs(b,F){const _=C.getArcs(b);for(let g=0;g<_.length;g++)if(!F.has(_[g]))return!1;return!0}getNodes(){return this._nodesArr}};let l=new Map;for(let b of L){const F=h.ExtensionIdentifier.toKey(b.identifier);if(l.set(F,b),b.extensionDependencies)for(let _ of b.extensionDependencies){const g=h.ExtensionIdentifier.toKey(_);C.addArc(F,g)}}let E=new Set;C.getNodes().filter(b=>C.getArcs(b).length===0).forEach(b=>E.add(b));let p=C.getNodes().filter(b=>!E.has(b)),m;do{m=!1;for(let b=0;b<p.length;b++){const F=p[b];C.hasOnlyGoodArcs(F,E)&&(p.splice(b,1),b--,E.add(F),m=!0)}}while(m);return p.map(b=>l.get(b))}containsActivationEvent(L){return this._activationMap.has(L)}containsExtension(L){return this._extensionsMap.has(h.ExtensionIdentifier.toKey(L))}getExtensionDescriptionsForActivationEvent(L){const C=this._activationMap.get(L);return C?C.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(L){const C=this._extensionsMap.get(h.ExtensionIdentifier.toKey(L));return C||void 0}}e.ExtensionDescriptionRegistry=R;var k;(function(P){P[P.Builtin=0]="Builtin",P[P.User=1]="User",P[P.Dev=2]="Dev"})(k||(k={}));function D(P,L){const C=P.isBuiltin?0:P.isUnderDevelopment?2:1,l=L.isBuiltin?0:L.isUnderDevelopment?2:1;if(C!==l)return C-l;const E=I.posix.basename(P.extensionLocation.path),p=I.posix.basename(L.extensionLocation.path);return E<p?-1:E>p?1:0}}),define(ve[223],we([0,1,22]),function(Z,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var t;(function(k){k[k.VersionMismatch=55]="VersionMismatch",k[k.UnexpectedError=81]="UnexpectedError"})(t=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var I;(function(k){k[k.Initialized=0]="Initialized",k[k.Ready=1]="Ready",k[k.Terminate=2]="Terminate"})(I=e.MessageType||(e.MessageType={}));function y(k){const D=h.VSBuffer.alloc(1);switch(k){case 0:D.writeUInt8(1,0);break;case 1:D.writeUInt8(2,0);break;case 2:D.writeUInt8(3,0);break}return D}e.createMessageOfType=y;function R(k,D){if(k.byteLength!==1)return!1;switch(k.readUInt8(0)){case 1:return D===0;case 2:return D===1;case 3:return D===2;default:return!1}}e.isMessageOfType=R}),define(ve[28],we([0,1,3,2,4,27,121]),function(Z,e,h,t,I,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.extensionRunningLocationToString=e.ExtensionRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new y.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:t.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,I.createDecorator)("extensionService");var k;(function(s){s[s.None=0]="None",s[s.LocalProcess=1]="LocalProcess",s[s.LocalWebWorker=2]="LocalWebWorker",s[s.Remote=3]="Remote"})(k=e.ExtensionRunningLocation||(e.ExtensionRunningLocation={}));function D(s){switch(s){case 0:return"None";case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionRunningLocationToString=D;class P{constructor(d){this.dependency=d}}e.MissingExtensionDependency=P;var L;(function(s){s[s.LocalProcess=0]="LocalProcess",s[s.LocalWebWorker=1]="LocalWebWorker",s[s.Remote=2]="Remote"})(L=e.ExtensionHostKind||(e.ExtensionHostKind={}));function C(s){switch(s){case 0:return"LocalProcess";case 1:return"LocalWebWorker";case 2:return"Remote"}}e.extensionHostKindToString=C;function l(s,d){return s.enabledApiProposals?s.enabledApiProposals.includes(d):!1}e.isProposedApiEnabled=l;function E(s,d){if(!l(s,d))throw new Error(`Extension '${s.identifier.value}' CANNOT use API proposal: ${d}.
Its package.json#enabledApiProposals-property declares: ${s.enabledApiProposals?.join(", ")??"[]"} but NOT ${d}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${s.identifier.value}`)}e.checkProposedApiEnabled=E;class p{constructor(d,n,S,o){this.codeLoadingTime=d,this.activateCallTime=n,this.activateResolvedTime=S,this.activationReason=o}}e.ActivationTimes=p;class m{constructor(d,n){this.description=d,this.value=n}}e.ExtensionPointContribution=m,e.ExtensionHostLogFileName="exthost";var b;(function(s){s[s.Normal=0]="Normal",s[s.Immediate=1]="Immediate"})(b=e.ActivationKind||(e.ActivationKind={}));function F(s){return{type:s.isBuiltin?0:1,isBuiltin:s.isBuiltin||s.isUserBuiltin,identifier:{id:(0,R.getGalleryExtensionId)(s.publisher,s.name),uuid:s.uuid},manifest:s,location:s.extensionLocation}}e.toExtension=F;function _(s,d){return{identifier:new y.ExtensionIdentifier((0,R.getExtensionId)(s.manifest.publisher,s.manifest.name)),isBuiltin:s.type===0,isUserBuiltin:s.type===1&&s.isBuiltin,isUnderDevelopment:!!d,extensionLocation:s.location,...s.manifest,uuid:s.identifier.uuid}}e.toExtensionDescription=_;class g{constructor(){this.onDidRegisterExtensions=h.Event.None,this.onDidChangeExtensionsStatus=h.Event.None,this.onDidChangeExtensions=h.Event.None,this.onWillActivateByEvent=h.Event.None,this.onDidChangeResponsiveChange=h.Event.None}activateByEvent(d){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(d){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(d){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(d){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(d,n){return Promise.resolve()}_onWillActivateExtension(d){}_onDidActivateExtension(d,n,S,o,i){}_onDidActivateExtensionError(d,n){}_onExtensionRuntimeError(d,n){}_onExtensionHostExit(d){}}e.NullExtensionService=g}),define(ve[224],we([0,1,16,27,28,12]),function(Z,e,h,t,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const R=Promise.resolve(void 0);class k{constructor(m,b,F,_){this.startup=m,this.codeLoadingTime=b,this.activateCallTime=F,this.activateResolvedTime=_}}e.ExtensionActivationTimes=k,k.NONE=new k(!1,-1,-1,-1);class D{constructor(m){this._startup=m,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(m,b){return m===-1||b===-1?-1:b-m}build(){return new k(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=D;class P{constructor(m,b,F,_,g,s){this.activationFailed=m,this.activationFailedError=b,this.activationTimes=F,this.module=_,this.exports=g,this.subscriptions=s}}e.ActivatedExtension=P;class L extends P{constructor(m){super(!1,null,m,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=L;class C extends P{constructor(){super(!1,null,k.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=C;class l extends P{constructor(m){super(!0,m,k.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=l;let E=class{constructor(m,b,F,_,g){this._logService=g,this._isDisposed=!1,this._registry=m,this._resolvedExtensionsSet=new Set,b.forEach(s=>this._resolvedExtensionsSet.add(t.ExtensionIdentifier.toKey(s))),this._hostExtensionsMap=new Map,F.forEach(s=>this._hostExtensionsMap.set(t.ExtensionIdentifier.toKey(s),s)),this._host=_,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}dispose(){this._isDisposed=!0}isActivated(m){const b=t.ExtensionIdentifier.toKey(m);return this._activatedExtensions.has(b)}getActivatedExtension(m){const b=t.ExtensionIdentifier.toKey(m),F=this._activatedExtensions.get(b);if(!F)throw new Error("Extension `"+m.value+"` is not known or not activated");return F}activateByEvent(m,b){if(this._alreadyActivatedEvents[m])return R;const F=this._registry.getExtensionDescriptionsForActivationEvent(m);return this._activateExtensions(F.map(_=>({id:_.identifier,reason:{startup:b,extensionId:_.identifier,activationEvent:m}}))).then(()=>{this._alreadyActivatedEvents[m]=!0})}activateById(m,b){const F=this._registry.getExtensionDescription(m);if(!F)throw new Error("Extension `"+m+"` is not known");return this._activateExtensions([{id:F.identifier,reason:b}])}_handleActivateRequest(m,b,F){if(this._hostExtensionsMap.has(t.ExtensionIdentifier.toKey(m.id))){b[t.ExtensionIdentifier.toKey(m.id)]=m;return}const _=this._registry.getExtensionDescription(m.id);if(!_){const d=new Error(`Cannot activate unknown extension '${m.id.value}'`);this._host.onExtensionActivationError(m.id,d,new I.MissingExtensionDependency(m.id.value)),this._activatedExtensions.set(t.ExtensionIdentifier.toKey(m.id),new l(d));return}const g=typeof _.extensionDependencies=="undefined"?[]:_.extensionDependencies;let s=!0;for(let d=0,n=g.length;d<n;d++){const S=g[d];if(this._resolvedExtensionsSet.has(t.ExtensionIdentifier.toKey(S)))continue;const o=this._activatedExtensions.get(t.ExtensionIdentifier.toKey(S));if(o&&!o.activationFailed)continue;if(o&&o.activationFailed){const a=_.displayName||_.identifier.value,u=this._registry.getExtensionDescription(S),f=u&&u.displayName||S,v=new Error(`Cannot activate the '${a}' extension because its dependency '${f}' failed to activate`);v.detail=o.activationFailedError,this._host.onExtensionActivationError(_.identifier,v,null),this._activatedExtensions.set(t.ExtensionIdentifier.toKey(_.identifier),new l(v));return}if(this._hostExtensionsMap.has(t.ExtensionIdentifier.toKey(S))){s=!1,b[t.ExtensionIdentifier.toKey(S)]={id:this._hostExtensionsMap.get(t.ExtensionIdentifier.toKey(S)),reason:m.reason};continue}const i=this._registry.getExtensionDescription(S);if(i){if(!i.main&&!i.browser)continue;s=!1,b[t.ExtensionIdentifier.toKey(S)]={id:i.identifier,reason:m.reason};continue}const r=_.displayName||_.identifier.value,c=new Error(`Cannot activate the '${r}' extension because it depends on unknown extension '${S}'`);this._host.onExtensionActivationError(_.identifier,c,new I.MissingExtensionDependency(S)),this._activatedExtensions.set(t.ExtensionIdentifier.toKey(_.identifier),new l(c));return}s?b[t.ExtensionIdentifier.toKey(_.identifier)]=m:F.push(m)}_activateExtensions(m){if(m.length===0||(m=m.filter(g=>!this._activatedExtensions.has(t.ExtensionIdentifier.toKey(g.id))),m.length===0))return Promise.resolve(void 0);const b=Object.create(null),F=[];for(let g=0,s=m.length;g<s;g++)this._handleActivateRequest(m[g],b,F);for(let g=0,s=F.length;g<s;g++){const d=t.ExtensionIdentifier.toKey(F[g].id);b[d]&&delete b[d]}const _=Object.keys(b).map(g=>b[g]);return F.length===0?Promise.all(_.map(g=>this._activateExtension(g.id,g.reason))).then(g=>{}):this._activateExtensions(_).then(g=>this._activateExtensions(F))}_activateExtension(m,b){const F=t.ExtensionIdentifier.toKey(m);if(this._activatedExtensions.has(F))return Promise.resolve(void 0);const _=this._activatingExtensions.get(F);if(_)return _;const g=this._host.actualActivateExtension(m,b).then(void 0,s=>{const d=new Error;return s&&s.name&&(d.name=s.name),s&&s.message?d.message=`Activating extension '${m.value}' failed: ${s.message}.`:d.message=`Activating extension '${m.value}' failed: ${s}.`,s&&s.stack&&(d.stack=s.stack),this._isDisposed&&h.isCancellationError(s)?new l(s):(this._host.onExtensionActivationError(m,d,null),this._logService.error(`Activating extension ${m.value} failed due to an error:`),this._logService.error(s),new l(s))}).then(s=>{this._activatedExtensions.set(F,s),this._activatingExtensions.delete(F)});return this._activatingExtensions.set(F,g),g}};E=je([ze(4,y.ILogService)],E),e.ExtensionsActivator=E}),define(ve[225],we([0,1,12,26,28]),function(Z,e,h,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let y=class extends h.LogService{constructor(k,D){super(k.createLogger(D.logFile,{name:I.ExtensionHostLogFileName}))}};y=je([ze(0,h.ILoggerService),ze(1,t.IExtHostInitDataService)],y),e.ExtHostLogService=y}),define(ve[226],we([0,1,16]),function(Z,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class t{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((y,R)=>{this._actualOk=y,this._actualErr=R,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(y){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=y,this._actual&&this._actualOk(y))}resolveErr(y){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=y,this._actual?this._actualErr(y):(0,h.onUnexpectedError)(y))}then(y,R){return this._ensureActual().then(y,R)}catch(y){return this._ensureActual().then(void 0,y)}finally(y){return this._ensureActual().finally(y)}}e.LazyPromise=t}),define(ve[52],we([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class h{constructor(D){this._proxyIdentifierBrand=void 0,this.sid=D,this.nid=++h.count}}e.ProxyIdentifier=h,h.count=0;const t=[];function I(k){const D=new h(k);return t[D.nid]=D,D}e.createProxyIdentifier=I;function y(k){return t[k].sid}e.getStringIdentifierForProxy=y;class R{constructor(D){this.value=D}}e.SerializableObjectWithBuffers=R}),define(ve[5],we([0,1,59,2,52]),function(Z,e,h,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var y;(function(_){_[_.Desktop=1]="Desktop",_[_.Web=2]="Web"})(y=e.UIKind||(e.UIKind={}));var R;(function(_){_[_.Default=0]="Default",_[_.InCenter=1]="InCenter",_[_.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",_[_.AtTop=3]="AtTop"})(R=e.TextEditorRevealType||(e.TextEditorRevealType={}));var k;(function(_){_[_.Editable=0]="Editable",_[_.SupportsHotExit=1]="SupportsHotExit"})(k=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var D;(function(_){_[_.Int8Array=1]="Int8Array",_[_.Uint8Array=2]="Uint8Array",_[_.Uint8ClampedArray=3]="Uint8ClampedArray",_[_.Int16Array=4]="Int16Array",_[_.Uint16Array=5]="Uint16Array",_[_.Int32Array=6]="Int32Array",_[_.Uint32Array=7]="Uint32Array",_[_.Float32Array=8]="Float32Array",_[_.Float64Array=9]="Float64Array",_[_.BigInt64Array=10]="BigInt64Array",_[_.BigUint64Array=11]="BigUint64Array"})(D=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var P;(function(_){_[_.Text=1]="Text",_[_.Error=2]="Error",_[_.Rich=3]="Rich"})(P=e.CellOutputKind||(e.CellOutputKind={}));var L;(function(_){_[_.Default=0]="Default",_[_.InCenter=1]="InCenter",_[_.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",_[_.AtTop=3]="AtTop"})(L=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var C;(function(_){_[_.None=0]="None",_[_.Process=1]="Process",_[_.Output=2]="Output"})(C=e.CandidatePortSource||(e.CandidatePortSource={}));class l{static mixin(g){return g._id=l._n++,g}}e.IdObject=l,l._n=0;var E;(function(_){_.label="a",_.kind="b",_.detail="c",_.documentation="d",_.sortText="e",_.filterText="f",_.preselect="g",_.insertText="h",_.insertTextRules="i",_.range="j",_.commitCharacters="k",_.additionalTextEdits="l",_.command="m",_.kindModifier="n"})(E=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var p;(function(_){_.defaultRanges="a",_.completions="b",_.isIncomplete="c",_.duration="d"})(p=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var m;(function(_){_[_.File=1]="File",_[_.Text=2]="Text",_[_.Cell=3]="Cell"})(m=e.WorkspaceEditType||(e.WorkspaceEditType={}));function b(_){if(_&&_.edits)for(const g of _.edits)typeof g.resource=="object"?g.resource=t.URI.revive(g.resource):(g.newUri=t.URI.revive(g.newUri),g.oldUri=t.URI.revive(g.oldUri)),g.metadata&&g.metadata.iconPath&&(g.metadata=(0,h.revive)(g.metadata));return _}e.reviveWorkspaceEditDto=b;var F;(function(_){_[_.Workspace=0]="Workspace",_[_.TextDocument=1]="TextDocument"})(F=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,I.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,I.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,I.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,I.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,I.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,I.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,I.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,I.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,I.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,I.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,I.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,I.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,I.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,I.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,I.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,I.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,I.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,I.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,I.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,I.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,I.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,I.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,I.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,I.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,I.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,I.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,I.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,I.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,I.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,I.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,I.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,I.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,I.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,I.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,I.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,I.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,I.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,I.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,I.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,I.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,I.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,I.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,I.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,I.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,I.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,I.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,I.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,I.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,I.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,I.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,I.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,I.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,I.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,I.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,I.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,I.createProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,I.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,I.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,I.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,I.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,I.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,I.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,I.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,I.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,I.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,I.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,I.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,I.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,I.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,I.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,I.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,I.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,I.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,I.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,I.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,I.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,I.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,I.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,I.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,I.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,I.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,I.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,I.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,I.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,I.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,I.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,I.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,I.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,I.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,I.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,I.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,I.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,I.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,I.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,I.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,I.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,I.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,I.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,I.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,I.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,I.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,I.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,I.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,I.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,I.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,I.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,I.createProxyIdentifier)("ExtHostTelemetry")}}),define(ve[89],we([0,1,5,3,4]),function(Z,e,h,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class y{constructor(k){this._onDidChangePassword=new t.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=k.getProxy(h.MainContext.MainThreadSecretState)}async $onDidChangePassword(k){this._onDidChangePassword.fire(k)}get(k,D){return this._proxy.$getPassword(k,D)}store(k,D,P){return this._proxy.$setPassword(k,D,P)}delete(k,D){return this._proxy.$deletePassword(k,D)}}e.ExtHostSecretState=y,e.IExtHostSecretState=(0,I.createDecorator)("IExtHostSecretState")}),define(ve[66],we([0,1,4,12,5,14]),function(Z,e,h,t,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,h.createDecorator)("IExtHostApiDeprecationService");let R=class{constructor(D,P){this._extHostLogService=P,this._reportedUsages=new Set,this._telemetryShape=D.getProxy(I.MainContext.MainThreadTelemetry)}report(D,P,L){const C=this.getUsageKey(D,P);this._reportedUsages.has(C)||(this._reportedUsages.add(C),P.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${D}' is deprecated. ${L}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:P.identifier.value,apiId:D}))}getUsageKey(D,P){return`${D}-${P.identifier.value}`}};R=je([ze(0,y.IExtHostRpcService),ze(1,t.ILogService)],R),e.ExtHostApiDeprecationService=R,e.NullApiDeprecationService=Object.freeze(new class{report(k,D,P){}})}),define(ve[227],we([0,1,3,5,7,27]),function(Z,e,h,t,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class R{constructor(D){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new h.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=D.getProxy(t.MainContext.MainThreadAuthentication)}$setProviders(D){return this._providers=D,Promise.resolve()}async getSession(D,P,L,C={}){const l=y.ExtensionIdentifier.toKey(D.identifier),E=this._inFlightRequests.get(l)||[],p=[...L].sort().join(" ");let m=E.find(b=>b.scopes===p);if(m)return m.result;{const b=this._getSession(D,l,P,L,C);m={scopes:p,result:b},E.push(m),this._inFlightRequests.set(l,E);try{await b}finally{const F=E.findIndex(_=>_.scopes===p);F>-1&&(E.splice(F),this._inFlightRequests.set(l,E))}return b}}async _getSession(D,P,L,C,l={}){await this._proxy.$ensureProvider(L);const E=D.displayName||D.name;return this._proxy.$getSession(L,C,P,E,l)}async removeSession(D,P){const L=this._authenticationProviders.get(D);return L?L.provider.removeSession(P):this._proxy.$removeSession(D,P)}registerAuthenticationProvider(D,P,L,C){if(this._authenticationProviders.get(D))throw new Error(`An authentication provider with id '${D}' is already registered.`);this._authenticationProviders.set(D,{label:P,provider:L,options:C??{supportsMultipleAccounts:!1}}),this._providers.find(E=>E.id===D)||this._providers.push({id:D,label:P});const l=L.onDidChangeSessions(E=>{this._proxy.$sendDidChangeSessions(D,{added:E.added??[],changed:E.changed??[],removed:E.removed??[]})});return this._proxy.$registerAuthenticationProvider(D,P,C?.supportsMultipleAccounts??!1),new I.Disposable(()=>{l.dispose(),this._authenticationProviders.delete(D);const E=this._providers.findIndex(p=>p.id===D);E>-1&&this._providers.splice(E),this._proxy.$unregisterAuthenticationProvider(D)})}$createSession(D,P){const L=this._authenticationProviders.get(D);if(L)return Promise.resolve(L.provider.createSession(P));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$removeSession(D,P){const L=this._authenticationProviders.get(D);if(L)return Promise.resolve(L.provider.removeSession(P));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$getSessions(D,P){const L=this._authenticationProviders.get(D);if(L)return Promise.resolve(L.provider.getSessions(P));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$onDidChangeAuthenticationSessions(D,P){return this._onDidChangeSessions.fire({provider:{id:D,label:P}}),Promise.resolve()}}e.ExtHostAuthentication=R}),define(ve[228],we([0,1,5,14,15]),function(Z,e,h,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let y=class{constructor(k,D){this._extHostDocumentsAndEditors=D,this._proxy=k.getProxy(h.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(k){const D=I.WorkspaceEdit.from(k,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(D)}};y=je([ze(0,t.IExtHostRpcService)],y),e.ExtHostBulkEdits=y}),define(ve[229],we([0,1,5]),function(Z,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class t{constructor(y){const R=y.getProxy(h.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return R.$readText()},writeText(k){return R.$writeText(k)}})}}e.ExtHostClipboard=t});var nt=this&&this.__classPrivateFieldSet||function(Z,e,h,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!I:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(Z,h):I?I.value=h:e.set(Z,h),h},Fe=this&&this.__classPrivateFieldGet||function(Z,e,h,t){if(h==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?t:h==="a"?t.call(Z):t?t.value:e.get(Z)};define(ve[38],we([0,1,18,7,15,25,5,17,12,59,41,48,2,6,4,14,64,22,52,49]),function(Z,e,h,t,I,y,R,k,D,P,L,C,l,E,p,m,b,F,_,g){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let d=class{constructor(c,a){s.set(this,void 0),this._commands=new Map,this._apiCommands=new Map,nt(this,s,c.getProxy(R.MainContext.MainThreadCommands),"f"),this._logService=a,this.converter=new n(this,u=>{const f=this._apiCommands.get(u);return f?.result===o.Void?f:void 0},a),this._argumentProcessors=[{processArgument(u){return(0,P.revive)(u)}},{processArgument(u){return(0,y.cloneAndChange)(u,function(f){if(L.Range.isIRange(f))return I.Range.to(f);if(C.Position.isIPosition(f))return I.Position.to(f);if(L.Range.isIRange(f.range)&&l.URI.isUri(f.uri))return I.location.to(f);if(f instanceof F.VSBuffer)return f.buffer.buffer;if(!Array.isArray(f))return f})}}]}registerArgumentProcessor(c){this._argumentProcessors.push(c)}registerApiCommand(c){const a=this.registerCommand(!1,c.id,async(...u)=>{const f=c.args.map((w,A)=>{if(!w.validate(u[A]))throw new Error(`Invalid argument '${w.name}' when running '${c.id}', received: ${u[A]}`);return w.convert(u[A])}),v=await this.executeCommand(c.internalId,...f);return c.result.convert(v,u,this.converter)},void 0,{description:c.description,args:c.args,returns:c.result.description});return this._apiCommands.set(c.id,c),new t.Disposable(()=>{a.dispose(),this._apiCommands.delete(c.id)})}registerCommand(c,a,u,f,v,w){if(this._logService.trace("ExtHostCommands#registerCommand",a),!a.trim().length)throw new Error("invalid id");if(this._commands.has(a))throw new Error(`command '${a}' already exists`);return this._commands.set(a,{callback:u,thisArg:f,description:v,extension:w}),c&&Fe(this,s,"f").$registerCommand(a),new t.Disposable(()=>{this._commands.delete(a)&&c&&Fe(this,s,"f").$unregisterCommand(a)})}executeCommand(c,...a){return this._logService.trace("ExtHostCommands#executeCommand",c),this._doExecuteCommand(c,a,!0)}async _doExecuteCommand(c,a,u){if(this._commands.has(c))return this._executeContributedCommand(c,a,!1);{let f=!1;const v=(0,y.cloneAndChange)(a,function(w){if(w instanceof t.Position)return I.Position.from(w);if(w instanceof t.Range)return I.Range.from(w);if(w instanceof t.Location)return I.location.from(w);if(t.NotebookRange.isNotebookRange(w))return I.NotebookRange.from(w);if(w instanceof ArrayBuffer)return f=!0,F.VSBuffer.wrap(new Uint8Array(w));if(w instanceof Uint8Array)return f=!0,F.VSBuffer.wrap(w);if(!Array.isArray(w))return w});try{const w=await Fe(this,s,"f").$executeCommand(c,f?new _.SerializableObjectWithBuffers(v):v,u);return(0,P.revive)(w)}catch(w){if(w instanceof Error&&w.message==="$executeCommand:retry")return this._doExecuteCommand(c,a,!1);throw w}}}async _executeContributedCommand(c,a,u){const f=this._commands.get(c);if(!f)throw new Error("Unknown command");let{callback:v,thisArg:w,description:A}=f;if(A)for(let M=0;M<A.args.length;M++)try{(0,h.validateConstraint)(a[M],A.args[M].constraint)}catch{throw new Error(`Running the contributed command: '${c}' failed. Illegal argument '${A.args[M].name}' - ${A.args[M].description}`)}try{return await v.apply(w,a)}catch(M){if(c===this.converter.delegatingCommandId){const T=this.converter.getActualCommand(...a);T&&(c=T.command)}throw this._logService.error(M,c,f.extension?.identifier),u?new class extends Error{constructor(){super((0,g.toErrorMessage)(M));this.id=c,this.source=f.extension?.displayName??f.extension?.name}}:M}}$executeContributedCommand(c,...a){return this._logService.trace("ExtHostCommands#$executeContributedCommand",c),this._commands.has(c)?(a=a.map(u=>this._argumentProcessors.reduce((f,v)=>v.processArgument(f),u)),this._executeContributedCommand(c,a,!0)):Promise.reject(new Error(`Contributed command '${c}' does not exist.`))}getCommands(c=!1){return this._logService.trace("ExtHostCommands#getCommands",c),Fe(this,s,"f").$getCommands().then(a=>(c&&(a=a.filter(u=>u[0]!=="_")),a))}$getContributedCommandHandlerDescriptions(){const c=Object.create(null);for(let[a,u]of this._commands){let{description:f}=u;f&&(c[a]=f)}return Promise.resolve(c)}};s=new WeakMap,d=je([ze(0,m.IExtHostRpcService),ze(1,D.ILogService)],d),e.ExtHostCommands=d,e.IExtHostCommands=(0,p.createDecorator)("IExtHostCommands");class n{constructor(c,a,u){this._commands=c,this._lookupApiCommand=a,this._logService=u,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(c,a){if(!c)return;const u={$ident:void 0,id:c.command,title:c.title,tooltip:c.tooltip};if(!c.command)return u;const f=this._lookupApiCommand(c.command);if(f)u.id=f.internalId,u.arguments=f.args.map((v,w)=>v.convert(c.arguments&&c.arguments[w]));else if((0,k.isNonEmptyArray)(c.arguments)){const v=++this._cachIdPool;this._cache.set(v,c),a.add((0,E.toDisposable)(()=>{this._cache.delete(v),this._logService.trace("CommandsConverter#DISPOSE",v)})),u.$ident=v,u.id=this.delegatingCommandId,u.arguments=[v],this._logService.trace("CommandsConverter#CREATE",c.command,v)}return u}fromInternal(c){return typeof c.$ident=="number"?this._cache.get(c.$ident):{command:c.id,title:c.title,arguments:c.arguments}}getActualCommand(...c){return this._cache.get(c[0])}_executeConvertedCommand(...c){const a=this.getActualCommand(...c);return this._logService.trace("CommandsConverter#EXECUTE",c[0],a?a.command:"MISSING"),a?this._commands.executeCommand(a.command,...a.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=n;class S{constructor(c,a,u,f){this.name=c,this.description=a,this.validate=u,this.convert=f}optional(){return new S(this.name,`(optional) ${this.description}`,c=>c==null||this.validate(c),c=>c===void 0?void 0:c===null?null:this.convert(c))}with(c,a){return new S(c??this.name,a??this.description,this.validate,this.convert)}}e.ApiCommandArgument=S,S.Uri=new S("uri","Uri of a text document",r=>l.URI.isUri(r),r=>r),S.Position=new S("position","A position in a text document",r=>t.Position.isPosition(r),I.Position.from),S.Range=new S("range","A range in a text document",r=>t.Range.isRange(r),I.Range.from),S.Selection=new S("selection","A selection in a text document",r=>t.Selection.isSelection(r),I.Selection.from),S.Number=new S("number","",r=>typeof r=="number",r=>r),S.String=new S("string","",r=>typeof r=="string",r=>r),S.CallHierarchyItem=new S("item","A call hierarchy item",r=>r instanceof t.CallHierarchyItem,I.CallHierarchyItem.from),S.TypeHierarchyItem=new S("item","A type hierarchy item",r=>r instanceof t.TypeHierarchyItem,I.TypeHierarchyItem.from),S.TestItem=new S("testItem","A VS Code TestItem",r=>r instanceof b.TestItemImpl,I.TestItem.from);class o{constructor(c,a){this.description=c,this.convert=a}}e.ApiCommandResult=o,o.Void=new o("no result",r=>r);class i{constructor(c,a,u,f,v){this.id=c,this.internalId=a,this.description=u,this.args=f,this.result=v}}e.ApiCommand=i}),define(ve[230],we([0,1,15,7,83,38,17,111]),function(Z,e,h,t,I,y,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const D=[new y.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",L(h.DocumentHighlight.to))),new y.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(l,E)=>{if((0,R.isFalsyOrEmpty)(l))return;class p extends t.SymbolInformation{static to(b){const F=new p(b.name,h.SymbolKind.to(b.kind),b.containerName||"",new t.Location(E[0],h.Range.to(b.range)));return F.detail=b.detail,F.range=F.location.range,F.selectionRange=h.Range.to(b.selectionRange),F.children=b.children?b.children.map(p.to):[],F}}return l.map(p.to)})),new y.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",L(h.TextEdit.to))),new y.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range,new y.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",L(h.TextEdit.to))),new y.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,new y.ApiCommandArgument("ch","Trigger character",l=>typeof l=="string",l=>l),new y.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",L(h.TextEdit.to))),new y.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",C)),new y.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",C)),new y.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",C)),new y.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",C)),new y.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location-instances.",L(h.location.to))),new y.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Hover-instances.",L(h.Hover.to))),new y.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("position","A position in a text document",l=>Array.isArray(l)&&l.every(E=>t.Position.isPosition(E)),l=>l.map(h.Position.from))],new y.ApiCommandResult("A promise that resolves to an array of ranges.",l=>l.map(E=>{let p;for(const m of E.reverse())p=new t.SelectionRange(h.Range.to(m),p);return p}))),new y.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[y.ApiCommandArgument.String.with("query","Search string")],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",l=>l.map(h.WorkspaceSymbol.to))),new y.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A CallHierarchyItem or undefined",l=>l.map(h.CallHierarchyItem.to))),new y.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",l=>l.map(h.CallHierarchyIncomingCall.to))),new y.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",l=>l.map(h.CallHierarchyOutgoingCall.to))),new y.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to a range and placeholder text.",l=>{if(!!l)return{range:h.Range.to(l.range),placeholder:l.text}})),new y.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("newName","The new symbol name")],new y.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",l=>{if(!!l){if(l.rejectReason)throw new Error(l.rejectReason);return h.WorkspaceEdit.to(l)}})),new y.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new y.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",l=>l.map(h.DocumentLink.to))),new y.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",l=>{if(!!l)return new t.SemanticTokensLegend(l.tokenTypes,l.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",l=>{if(!l)return;const E=(0,k.decodeSemanticTokensDto)(l);if(E.type==="full")return new t.SemanticTokens(E.data,void 0)})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range.optional()],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",l=>{if(!!l)return new t.SemanticTokensLegend(l.tokenTypes,l.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",l=>{if(!l)return;const E=(0,k.decodeSemanticTokensDto)(l);if(E.type==="full")return new t.SemanticTokens(E.data,void 0)})),new y.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new y.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(l,E,p)=>{if(!l)return new t.CompletionList([]);const m=l.suggestions.map(b=>h.CompletionItem.to(b,p));return new t.CompletionList(m,l.incomplete)})),new y.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new y.ApiCommandResult("A promise that resolves to SignatureHelp.",l=>{if(l)return h.SignatureHelp.to(l)})),new y.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new y.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(l,E,p)=>L(m=>new t.CodeLens(h.Range.to(m.range),m.command&&p.fromInternal(m.command)))(l))),new y.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",l=>t.Range.isRange(l),l=>t.Selection.isSelection(l)?h.Selection.from(l):h.Range.from(l)),y.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new y.ApiCommandResult("A promise that resolves to an array of Command-instances.",(l,E,p)=>L(m=>{if(m._isSynthetic){if(!m.command)throw new Error("Synthetic code actions must have a command");return p.fromInternal(m.command)}else{const b=new t.CodeAction(m.title,m.kind?new t.CodeActionKind(m.kind):void 0);return m.edit&&(b.edit=h.WorkspaceEdit.to(m.edit)),m.command&&(b.command=p.fromInternal(m.command)),b.isPreferred=m.isPreferred,b}})(l))),new y.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",l=>l?l.map(E=>new t.ColorInformation(h.Range.to(E.range),h.Color.to(E.color))):[])),new y.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new y.ApiCommandArgument("color","The color to show and insert",l=>l instanceof t.Color,h.Color.from),new y.ApiCommandArgument("context","Context object with uri and range",l=>!0,l=>({uri:l.uri,range:h.Range.from(l.range)}))],new y.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",l=>l?l.map(h.ColorPresentation.to):[])),new y.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of Inlay objects",(l,E,p)=>l.map(h.InlayHint.to.bind(void 0,p)))),new y.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new y.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",L(l=>({viewType:l.viewType,displayName:l.displayName,options:{transientOutputs:l.options.transientOutputs,transientCellMetadata:l.options.transientCellMetadata,transientDocumentMetadata:l.options.transientDocumentMetadata},filenamePattern:l.filenamePattern.map(E=>h.NotebookExclusiveDocumentPattern.to(E))})))),new y.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of InlineValue objects",l=>l.map(h.InlineValue.to))),new y.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="number"||typeof l=="object",l=>l&&(typeof l=="number"?[h.ViewColumn.from(l),void 0]:[h.ViewColumn.from(l.viewColumn),h.TextEditorOpenOptions.from(l)])).optional(),y.ApiCommandArgument.String.with("label","").optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[y.ApiCommandArgument.Uri.with("resource","Resource to open"),y.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="number"||typeof l=="object",l=>l&&(typeof l=="number"?[h.ViewColumn.from(l),void 0]:[h.ViewColumn.from(l.viewColumn),h.TextEditorOpenOptions.from(l)])).optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[y.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),y.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),y.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="object",l=>l&&[h.ViewColumn.from(l.viewColumn),h.TextEditorOpenOptions.from(l)]).optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A TypeHierarchyItem or undefined",l=>l.map(h.TypeHierarchyItem.to))),new y.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[y.ApiCommandArgument.TypeHierarchyItem],new y.ApiCommandResult("A TypeHierarchyItem or undefined",l=>l.map(h.TypeHierarchyItem.to))),new y.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[y.ApiCommandArgument.TypeHierarchyItem],new y.ApiCommandResult("A TypeHierarchyItem or undefined",l=>l.map(h.TypeHierarchyItem.to))),new y.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[y.ApiCommandArgument.TestItem],y.ApiCommandResult.Void)];class P{static register(E){D.forEach(E.registerApiCommand,E)}}e.ExtHostApiCommands=P;function L(l){return E=>{if(Array.isArray(E))return E.map(l)}}function C(l){if(!Array.isArray(l))return;const E=[];for(const p of l)I.isLocationLink(p)?E.push(h.DefinitionLink.to(p)):E.push(h.location.to(p));return E}}),define(ve[231],we([0,1,13,56,3,6,2,83,27,15,7,28,5]),function(Z,e,h,t,I,y,R,k,D,P,L,C,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function E(p,m,b){const F=p.getProxy(l.MainContext.MainThreadComments);class _{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,m.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===6){const c=this._commentControllers.get(r.handle);return c||r}else if(r&&r.$mid===7){const c=this._commentControllers.get(r.commentControlHandle);if(!c)return r;const a=c.getCommentThread(r.commentThreadHandle);return a||r}else if(r&&r.$mid===8){const c=this._commentControllers.get(r.thread.commentControlHandle);if(!c)return r;const a=c.getCommentThread(r.thread.commentThreadHandle);return a?{thread:a,text:r.text}:r}else if(r&&r.$mid===9){const c=this._commentControllers.get(r.thread.commentControlHandle);if(!c)return r;const a=c.getCommentThread(r.thread.commentThreadHandle);if(!a)return r;let u=r.commentUniqueId,f=a.getCommentByUniqueId(u);return f||r}else if(r&&r.$mid===10){const c=this._commentControllers.get(r.thread.commentControlHandle);if(!c)return r;const a=c.getCommentThread(r.thread.commentThreadHandle);if(!a)return r;let u=r.text,f=r.commentUniqueId,v=a.getCommentByUniqueId(f);return v?(v.body=u,v):r}return r}})}createCommentController(r,c,a){const u=_.handlePool++,f=new s(r,u,c,a);this._commentControllers.set(f.handle,f);const v=this._commentControllersByExtension.get(D.ExtensionIdentifier.toKey(r.identifier))||[];return v.push(f),this._commentControllersByExtension.set(D.ExtensionIdentifier.toKey(r.identifier),v),f.value}$createCommentThreadTemplate(r,c,a){const u=this._commentControllers.get(r);!u||u.$createCommentThreadTemplate(c,a)}async $updateCommentThreadTemplate(r,c,a){const u=this._commentControllers.get(r);!u||u.$updateCommentThreadTemplate(c,a)}$deleteCommentThread(r,c){const a=this._commentControllers.get(r);a&&a.$deleteCommentThread(c)}$provideCommentingRanges(r,c,a){const u=this._commentControllers.get(r);if(!u||!u.commentingRangeProvider)return Promise.resolve(void 0);const f=b.getDocument(R.URI.revive(c));return(0,h.asPromise)(()=>u.commentingRangeProvider.provideCommentingRanges(f,a)).then(v=>v?v.map(w=>P.Range.from(w)):void 0)}$toggleReaction(r,c,a,u,f){const v=this._commentControllers.get(r);return!v||!v.reactionHandler?Promise.resolve(void 0):(0,h.asPromise)(()=>{const w=v.getCommentThread(c);if(w){const A=w.getCommentByUniqueId(u.uniqueIdInThread);if(v!==void 0&&A&&v.reactionHandler)return v.reactionHandler(A,S(f))}return Promise.resolve(void 0)})}dispose(){}}_.handlePool=0;class g{constructor(r,c,a,u,f,v,w){this._commentControllerHandle=c,this._id=a,this._uri=u,this._range=f,this._comments=v,this.extensionDescription=w,this.handle=g._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new I.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new y.MutableDisposable,this._acceptInputDisposables.value=new y.DisposableStore,this._id===void 0&&(this._id=`${r}.${this.handle}`),F.$createCommentThread(c,this.handle,this._id,this._uri,P.Range.from(this._range),w.identifier),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=v,this._localDisposables.push({dispose:()=>{F.$deleteCommentThread(c,this.handle)}});const A=this;this.value={get uri(){return A.uri},get range(){return A.range},set range(M){A.range=M},get comments(){return A.comments},set comments(M){A.comments=M},get collapsibleState(){return A.collapsibleState},set collapsibleState(M){A.collapsibleState=M},get canReply(){return A.canReply},set canReply(M){A.canReply=M},get contextValue(){return A.contextValue},set contextValue(M){A.contextValue=M},get label(){return A.label},set label(M){A.label=M},dispose:()=>{A.dispose()}}}set threadId(r){this._id=r}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(r){r.isEqual(this._range)||(this._range=r,this.modifications.range=r,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(r){this._canReply!==r&&(this._canReply=r,this.modifications.canReply=r,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(r){this._label=r,this.modifications.label=r,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(r){this._contextValue=r,this.modifications.contextValue=r,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(r){this._comments=r,this.modifications.comments=r,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(r){this._collapseState=r,this.modifications.collapsibleState=r,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new y.DisposableStore);const r=a=>Object.prototype.hasOwnProperty.call(this.modifications,a),c={};r("range")&&(c.range=P.Range.from(this._range)),r("label")&&(c.label=this.label),r("contextValue")&&(c.contextValue=this.contextValue??null),r("comments")&&(c.comments=this._comments.map(a=>d(this,a,this._commentsMap))),r("collapsibleState")&&(c.collapseState=o(this._collapseState)),r("canReply")&&(c.canReply=this.canReply),this.modifications={},F.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,c)}getCommentByUniqueId(r){for(let c of this._commentsMap){let a=c[0],u=c[1];if(r===u)return a}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(r=>r.dispose())}}g._handlePool=0,je([(0,t.debounce)(100)],g.prototype,"eventuallyUpdateCommentThread",null);class s{constructor(r,c,a,u){this._extension=r,this._handle=c,this._id=a,this._label=u,this._threads=new Map,F.$registerCommentController(this.handle,a,u);const f=this;this.value=Object.freeze({id:f.id,label:f.label,get options(){return f.options},set options(v){f.options=v},get commentingRangeProvider(){return f.commentingRangeProvider},set commentingRangeProvider(v){f.commentingRangeProvider=v},get reactionHandler(){return f.reactionHandler},set reactionHandler(v){f.reactionHandler=v},createCommentThread(v,w,A){return f.createCommentThread(v,w,A).value},dispose:()=>{f.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{F.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(r){this._commentingRangeProvider=r,F.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(r){this._reactionHandler=r,F.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!r})}get options(){return this._options}set options(r){this._options=r,F.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(r,c,a,u){if(typeof r=="string"){const f=new g(this.id,this.handle,r,c,a,u,this._extension);return this._threads.set(f.handle,f),f}else{const f=new g(this.id,this.handle,void 0,r,c,a,this._extension);return this._threads.set(f.handle,f),f}}$createCommentThreadTemplate(r,c){const a=new g(this.id,this.handle,void 0,R.URI.revive(r),P.Range.to(c),[],this._extension);return a.collapsibleState=k.CommentThreadCollapsibleState.Expanded,this._threads.set(a.handle,a),a}$updateCommentThreadTemplate(r,c){let a=this._threads.get(r);a&&(a.range=P.Range.to(c))}$deleteCommentThread(r){let c=this._threads.get(r);c&&c.dispose(),this._threads.delete(r)}getCommentThread(r){return this._threads.get(r)}dispose(){this._threads.forEach(r=>{r.dispose()}),this._localDisposables.forEach(r=>r.dispose())}}function d(i,r,c){let a=c.get(r);a||(a=++i.commentHandle,c.set(r,a));const u=r.author&&r.author.iconPath?r.author.iconPath.toString():void 0;r.detail&&(0,C.checkProposedApiEnabled)(i.extensionDescription,"commentTimestamp");let f;return r.detail&&typeof r.detail!="string"?f={source:r.detail,$mid:14}:f=r.detail,{mode:r.mode,contextValue:r.contextValue,uniqueIdInThread:a,body:P.MarkdownString.from(r.body),userName:r.author.name,userIconPath:u,label:r.label,commentReactions:r.reactions?r.reactions.map(v=>n(v)):void 0,detail:f}}function n(i){return{label:i.label,iconPath:i.iconPath?P.pathOrURIToURI(i.iconPath):void 0,count:i.count,hasReacted:i.authorHasReacted}}function S(i){return{label:i.label||"",count:i.count||0,iconPath:i.iconPath?R.URI.revive(i.iconPath):"",authorHasReacted:i.hasReacted||!1}}function o(i){if(i!==void 0)switch(i){case L.CommentThreadCollapsibleState.Expanded:return k.CommentThreadCollapsibleState.Expanded;case L.CommentThreadCollapsibleState.Collapsed:return k.CommentThreadCollapsibleState.Collapsed}return k.CommentThreadCollapsibleState.Collapsed}return new _}e.createExtHostComments=E}),define(ve[132],we([0,1,2,5,7,4,14,12,17,8,9]),function(Z,e,h,t,I,y,R,k,D,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let C=class yi{constructor(E,p){this._logService=p,this._provider=new Map,this._proxy=E.getProxy(t.MainContext.MainThreadDecorations)}registerFileDecorationProvider(E,p){const m=yi._handlePool++;this._provider.set(m,{provider:E,extensionId:p}),this._proxy.$registerDecorationProvider(m,p.value);const b=E.onDidChangeFileDecorations&&E.onDidChangeFileDecorations(F=>{if(!F){this._proxy.$onDidChange(m,null);return}let _=(0,D.asArray)(F);if(_.length<=yi._maxEventSize){this._proxy.$onDidChange(m,_);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",p.value,_.length);const g=_.map(n=>({uri:n,rank:(0,P.count)(n.path,"/")})),s=(0,D.groupBy)(g,(n,S)=>n.rank-S.rank||(0,P.compare)(n.uri.path,S.uri.path));let d=[];e:for(let n of s){let S;for(let o of n){let i=(0,L.dirname)(o.uri.path);if(S!==i&&(S=i,d.push(o.uri)>=yi._maxEventSize))break e}}this._proxy.$onDidChange(m,d)});return new I.Disposable(()=>{b?.dispose(),this._proxy.$unregisterDecorationProvider(m),this._provider.delete(m)})}async $provideDecorations(E,p,m){if(!this._provider.has(E))return Object.create(null);const b=Object.create(null),{provider:F,extensionId:_}=this._provider.get(E);return await Promise.all(p.map(async g=>{try{const{uri:s,id:d}=g,n=await Promise.resolve(F.provideFileDecoration(h.URI.revive(s),m));if(!n)return;try{I.FileDecoration.validate(n),b[d]=[n.propagate,n.tooltip,n.badge,n.color]}catch(S){this._logService.warn(`INVALID decoration from extension '${_.value}': ${S}`)}}catch(s){this._logService.error(s)}})),b}};C._handlePool=0,C._maxEventSize=250,C=je([ze(0,R.IExtHostRpcService),ze(1,k.ILogService)],C),e.ExtHostDecorations=C,e.IExtHostDecorations=(0,y.createDecorator)("IExtHostDecorations")});var nt=this&&this.__classPrivateFieldSet||function(Z,e,h,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!I:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(Z,h):I?I.value=h:e.set(Z,h),h},Fe=this&&this.__classPrivateFieldGet||function(Z,e,h,t){if(h==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?t:h==="a"?t.call(Z):t?t.value:e.get(Z)};define(ve[232],we([0,1,164,117,2,5,7,15,3,12,24,44]),function(Z,e,h,t,I,y,R,k,D,P,L,C){"use strict";var l,E,p;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class m{constructor(_,g,s,d,n,S){this._name=_,this._owner=g,this._maxDiagnosticsPerFile=s,l.set(this,void 0),E.set(this,void 0),p.set(this,void 0),this._isDisposed=!1,nt(this,p,new L.ResourceMap(o=>d.getComparisonKey(o)),"f"),nt(this,l,n,"f"),nt(this,E,S,"f")}dispose(){this._isDisposed||(Fe(this,E,"f").fire([...Fe(this,p,"f").keys()]),Fe(this,l,"f")&&Fe(this,l,"f").$clear(this._owner),Fe(this,p,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(_,g){if(!_){this.clear();return}this._checkDisposed();let s=[];if(I.URI.isUri(_)){if(!g){this.delete(_);return}Fe(this,p,"f").set(_,g.slice()),s=[_]}else if(Array.isArray(_)){s=[];let n;_=[..._].sort(m._compareIndexedTuplesByUri);for(const S of _){const[o,i]=S;if((!n||o.toString()!==n.toString())&&(n&&Fe(this,p,"f").get(n).length===0&&Fe(this,p,"f").delete(n),n=o,s.push(o),Fe(this,p,"f").set(o,[])),i){const r=Fe(this,p,"f").get(o);r&&r.push(...i)}else{const r=Fe(this,p,"f").get(o);r&&(r.length=0)}}}if(Fe(this,E,"f").fire(s),!Fe(this,l,"f"))return;const d=[];for(let n of s){let S=[];const o=Fe(this,p,"f").get(n);if(o)if(o.length>this._maxDiagnosticsPerFile){S=[];const i=[R.DiagnosticSeverity.Error,R.DiagnosticSeverity.Warning,R.DiagnosticSeverity.Information,R.DiagnosticSeverity.Hint];e:for(let r=0;r<4;r++)for(let c of o)if(c.severity===i[r]&&S.push(k.Diagnostic.from(c))===this._maxDiagnosticsPerFile)break e;S.push({severity:t.MarkerSeverity.Info,message:(0,h.localize)(0,null,o.length-this._maxDiagnosticsPerFile),startLineNumber:S[S.length-1].startLineNumber,startColumn:S[S.length-1].startColumn,endLineNumber:S[S.length-1].endLineNumber,endColumn:S[S.length-1].endColumn})}else S=o.map(i=>k.Diagnostic.from(i));d.push([n,S])}Fe(this,l,"f").$changeMany(this._owner,d)}delete(_){this._checkDisposed(),Fe(this,E,"f").fire([_]),Fe(this,p,"f").delete(_),Fe(this,l,"f")&&Fe(this,l,"f").$changeMany(this._owner,[[_,void 0]])}clear(){this._checkDisposed(),Fe(this,E,"f").fire([...Fe(this,p,"f").keys()]),Fe(this,p,"f").clear(),Fe(this,l,"f")&&Fe(this,l,"f").$clear(this._owner)}forEach(_,g){this._checkDisposed();for(let s of Fe(this,p,"f").keys())_.apply(g,[s,this.get(s),this])}get(_){this._checkDisposed();const g=Fe(this,p,"f").get(_);return Array.isArray(g)?Object.freeze(g.slice(0)):[]}has(_){return this._checkDisposed(),Array.isArray(Fe(this,p,"f").get(_))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(_,g){return _[0].toString()<g[0].toString()?-1:_[0].toString()>g[0].toString()?1:0}}e.DiagnosticCollection=m,l=new WeakMap,E=new WeakMap,p=new WeakMap;let b=class oi{constructor(_,g,s){this._logService=g,this._fileSystemInfoService=s,this._collections=new Map,this._onDidChangeDiagnostics=new D.DebounceEmitter({merge:d=>d.flat(),delay:50}),this.onDidChangeDiagnostics=D.Event.map(this._onDidChangeDiagnostics.event,oi._mapper),this._proxy=_.getProxy(y.MainContext.MainThreadDiagnostics)}static _mapper(_){const g=new L.ResourceMap;for(const s of _)g.set(s,s);return{uris:Object.freeze(Array.from(g.values()))}}createDiagnosticCollection(_,g){const{_collections:s,_proxy:d,_onDidChangeDiagnostics:n,_logService:S,_fileSystemInfoService:o}=this,i=new class{$changeMany(a,u){d.$changeMany(a,u),S.trace("[DiagnosticCollection] change many (extension, owner, uris)",_.value,a,u.length===0?"CLEARING":u)}$clear(a){d.$clear(a),S.trace("[DiagnosticCollection] remove all (extension, owner)",_.value,a)}dispose(){d.dispose()}};let r;if(!g)g="_generated_diagnostic_collection_name_#"+oi._idPool++,r=g;else if(!s.has(g))r=g;else{this._logService.warn(`DiagnosticCollection with name '${g}' does already exist.`);do r=g+oi._idPool++;while(s.has(r))}return new class extends m{constructor(){super(g,r,oi._maxDiagnosticsPerFile,o.extUri,i,n);s.set(r,this)}dispose(){super.dispose(),s.delete(r)}}}getDiagnostics(_){if(_)return this._getDiagnostics(_);{const g=new Map,s=[];for(const d of this._collections.values())d.forEach((n,S)=>{let o=g.get(n.toString());typeof o=="undefined"&&(o=s.length,g.set(n.toString(),o),s.push([n,[]])),s[o][1]=s[o][1].concat(...S)});return s}}_getDiagnostics(_){let g=[];for(let s of this._collections.values())s.has(_)&&(g=g.concat(s.get(_)));return g}$acceptMarkersChange(_){if(!this._mirrorCollection){const g="_generated_mirror",s=new m(g,g,oi._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(g,s),this._mirrorCollection=s}for(const[g,s]of _)this._mirrorCollection.set(I.URI.revive(g),s.map(k.Diagnostic.to))}};b._idPool=0,b._maxDiagnosticsPerFile=1e3,b=je([ze(1,P.ILogService),ze(2,C.IExtHostFileSystemInfo)],b),e.ExtHostDiagnostics=b}),define(ve[233],we([0,1,2,5]),function(Z,e,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class I{constructor(R){this._proxy=R.getProxy(t.MainContext.MainThreadDialogs)}showOpenDialog(R){return this._proxy.$showOpenDialog(R).then(k=>k?k.map(D=>h.URI.revive(D)):void 0)}showSaveDialog(R){return this._proxy.$showSaveDialog(R).then(k=>k?h.URI.revive(k):void 0)}}e.ExtHostDialogs=I}),define(ve[234],we([0,1,16,2,7,5,10,21,8]),function(Z,e,h,t,I,y,R,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class P{constructor(C,l,E){this._documentsAndEditors=l,this._logService=E,this._documentContentProviders=new Map,this._proxy=C.getProxy(y.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(C,l){if(Object.keys(R.Schemas).indexOf(C)>=0)throw new Error(`scheme '${C}' already registered`);const E=P._handlePool++;this._documentContentProviders.set(E,l),this._proxy.$registerTextContentProvider(E,C);let p;return typeof l.onDidChange=="function"&&(p=l.onDidChange(m=>{if(m.scheme!==C){this._logService.warn(`Provider for scheme '${C}' is firing event for schema '${m.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(m)&&this.$provideTextDocumentContent(E,m).then(b=>{if(!b&&typeof b!="string")return;const F=this._documentsAndEditors.getDocument(m);if(!F)return;const _=(0,D.splitLines)(b);if(!F.equalLines(_))return this._proxy.$onVirtualDocumentChange(m,b)},h.onUnexpectedError)})),new I.Disposable(()=>{this._documentContentProviders.delete(E)&&this._proxy.$unregisterTextContentProvider(E),p&&(p.dispose(),p=void 0)})}$provideTextDocumentContent(C,l){const E=this._documentContentProviders.get(C);return E?Promise.resolve(E.provideTextDocumentContent(t.URI.revive(l),k.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${l.scheme}`))}}e.ExtHostDocumentContentProvider=P,P._handlePool=0}),define(ve[235],we([0,1,3,6,2,5,124,15,18,25,7]),function(Z,e,h,t,I,y,R,k,D,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class C{constructor(E,p){this._onDidAddDocument=new h.Emitter,this._onDidRemoveDocument=new h.Emitter,this._onDidChangeDocument=new h.Emitter,this._onDidSaveDocument=new h.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new t.DisposableStore,this._documentLoader=new Map,this._proxy=E.getProxy(y.MainContext.MainThreadDocuments),this._documentsAndEditors=p,this._documentsAndEditors.onDidRemoveDocuments(m=>{for(const b of m)this._onDidRemoveDocument.fire(b.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(m=>{for(const b of m)this._onDidAddDocument.fire(b.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(E){if(!E)return;const p=this._documentsAndEditors.getDocument(E);if(p)return p}getDocument(E){const p=this.getDocumentData(E);if(!p?.document)throw new Error(`Unable to retrieve document from URI '${E}'`);return p.document}ensureDocumentData(E){const p=this._documentsAndEditors.getDocument(E);if(p)return Promise.resolve(p);let m=this._documentLoader.get(E.toString());return m||(m=this._proxy.$tryOpenDocument(E).then(b=>{this._documentLoader.delete(E.toString());const F=I.URI.revive(b);return(0,D.assertIsDefined)(this._documentsAndEditors.getDocument(F))},b=>(this._documentLoader.delete(E.toString()),Promise.reject(b))),this._documentLoader.set(E.toString(),m)),m}createDocumentData(E){return this._proxy.$tryCreateDocument(E).then(p=>I.URI.revive(p))}$acceptModelLanguageChanged(E,p){const m=I.URI.revive(E),b=this._documentsAndEditors.getDocument(m);if(!b)throw new Error("unknown document");this._onDidRemoveDocument.fire(b.document),b._acceptLanguageId(p),this._onDidAddDocument.fire(b.document)}$acceptModelSaved(E){const p=I.URI.revive(E),m=this._documentsAndEditors.getDocument(p);if(!m)throw new Error("unknown document");this.$acceptDirtyStateChanged(E,!1),this._onDidSaveDocument.fire(m.document)}$acceptDirtyStateChanged(E,p){const m=I.URI.revive(E),b=this._documentsAndEditors.getDocument(m);if(!b)throw new Error("unknown document");b._acceptIsDirty(p),this._onDidChangeDocument.fire({document:b.document,contentChanges:[],reason:void 0})}$acceptModelChanged(E,p,m){const b=I.URI.revive(E),F=this._documentsAndEditors.getDocument(b);if(!F)throw new Error("unknown document");F._acceptIsDirty(m),F.onEvents(p);let _;p.isUndoing?_=L.TextDocumentChangeReason.Undo:p.isRedoing&&(_=L.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,P.deepFreeze)({document:F.document,contentChanges:p.changes.map(g=>({range:k.Range.to(g.range),rangeOffset:g.rangeOffset,rangeLength:g.rangeLength,text:g.text})),reason:_}))}setWordDefinitionFor(E,p){(0,R.setWordDefinitionFor)(E,p)}}e.ExtHostDocuments=C}),define(ve[45],we([0,1,55,3,6,2,4,5,124,14,131,15,12,24,10,78,92]),function(Z,e,h,t,I,y,R,k,D,P,L,C,l,E,p,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class F{constructor(s){this.value=s,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let _=class{constructor(s,d){this._extHostRpc=s,this._logService=d,this._activeEditorId=null,this._editors=new Map,this._documents=new E.ResourceMap,this._onDidAddDocuments=new t.Emitter,this._onDidRemoveDocuments=new t.Emitter,this._onDidChangeVisibleTextEditors=new t.Emitter,this._onDidChangeActiveTextEditor=new t.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(s){this.acceptDocumentsAndEditorsDelta(s)}acceptDocumentsAndEditorsDelta(s){const d=[],n=[],S=[];if(s.removedDocuments)for(const o of s.removedDocuments){const i=y.URI.revive(o),r=this._documents.get(i);r?.unref()&&(this._documents.delete(i),d.push(r.value))}if(s.addedDocuments)for(const o of s.addedDocuments){const i=y.URI.revive(o.uri);let r=this._documents.get(i);if(r&&i.scheme!==p.Schemas.vscodeNotebookCell&&i.scheme!==p.Schemas.vscodeInteractiveInput)throw new Error(`document '${i} already exists!'`);r||(r=new F(new D.ExtHostDocumentData(this._extHostRpc.getProxy(k.MainContext.MainThreadDocuments),i,o.lines,o.EOL,o.versionId,o.languageId,o.isDirty,o.notebook)),this._documents.set(i,r),n.push(r.value)),r.ref()}if(s.removedEditors)for(const o of s.removedEditors){const i=this._editors.get(o);this._editors.delete(o),i&&S.push(i)}if(s.addedEditors)for(const o of s.addedEditors){const i=y.URI.revive(o.documentUri);h.ok(this._documents.has(i),`document '${i}' does not exist`),h.ok(!this._editors.has(o.id),`editor '${o.id}' already exists!`);const r=this._documents.get(i).value,c=new L.ExtHostTextEditor(o.id,this._extHostRpc.getProxy(k.MainContext.MainThreadTextEditors),this._logService,new b.Lazy(()=>r.document),o.selections.map(C.Selection.to),o.options,o.visibleRanges.map(a=>C.Range.to(a)),typeof o.editorPosition=="number"?C.ViewColumn.to(o.editorPosition):void 0);this._editors.set(o.id,c)}s.newActiveEditor!==void 0&&(h.ok(s.newActiveEditor===null||this._editors.has(s.newActiveEditor),`active editor '${s.newActiveEditor}' does not exist`),this._activeEditorId=s.newActiveEditor),(0,I.dispose)(d),(0,I.dispose)(S),s.removedDocuments&&this._onDidRemoveDocuments.fire(d),s.addedDocuments&&this._onDidAddDocuments.fire(n),(s.removedEditors||s.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(o=>o.value)),s.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(s){return this._documents.get(s)?.value}allDocuments(){return m.Iterable.map(this._documents.values(),s=>s.value)}getEditor(s){return this._editors.get(s)}activeEditor(s){if(!this._activeEditorId)return;const d=this._editors.get(this._activeEditorId);return s?d:d?.value}allEditors(){return[...this._editors.values()]}};_=je([ze(0,P.IExtHostRpcService),ze(1,l.ILogService)],_),e.ExtHostDocumentsAndEditors=_,e.IExtHostDocumentsAndEditors=(0,R.createDecorator)("IExtHostDocumentsAndEditors")}),define(ve[53],we([0,1,15,5,2,3,4,14,13]),function(Z,e,h,t,I,y,R,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,R.createDecorator)("IExtHostEditorTabs");let P=class{constructor(C){this._onDidChangeTabs=new y.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._onDidChangeActiveTab=new y.Emitter,this.onDidChangeActiveTab=this._onDidChangeActiveTab.event,this._tabs=[],this._proxy=C.getProxy(t.MainContext.MainThreadEditorTabs)}get tabs(){return this._tabs}get activeTab(){return this._activeTab}$acceptEditorTabs(C){let l=-1;this._tabs=C.map((p,m)=>(p.isActive&&(l=m),Object.freeze({label:p.label,viewColumn:h.ViewColumn.to(p.viewColumn),index:m,resource:I.URI.revive(p.resource),additionalResourcesAndViewIds:p.additionalResourcesAndViewIds.map(({resource:b,viewId:F})=>({resource:I.URI.revive(b),viewId:F})),viewId:p.editorId,isActive:p.isActive,move:async(b,F)=>{this._proxy.$moveTab(p,b,h.ViewColumn.from(F)),await(0,D.raceTimeout)(y.Event.toPromise(this._onDidChangeTabs.event),1e3)},close:async()=>{await this._proxy.$closeTab(p),await(0,D.raceTimeout)(y.Event.toPromise(this._onDidChangeTabs.event),1e3)}}))),this._tabs=this._tabs.sort((p,m)=>p.viewColumn===m.viewColumn?p.index-m.index:p.viewColumn-m.viewColumn);const E=this._activeTab;this._activeTab=l===-1?void 0:this._tabs[l],this._activeTab!==E&&this._onDidChangeActiveTab.fire(this._activeTab),this._onDidChangeTabs.fire(this._tabs)}};P=je([ze(0,k.IExtHostRpcService)],P),e.ExtHostEditorTabs=P}),define(ve[236],we([0,1,2,5,6,7,15,148,8,22,28]),function(Z,e,h,t,I,y,R,k,D,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class C{constructor(){this._schemes=[]}add(p){this._stateMachine=void 0,this._schemes.push(p)}delete(p){const m=this._schemes.indexOf(p);m>=0&&(this._schemes.splice(m,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const p=this._schemes.sort(),m=[];let b,F,_=14,g=14;for(const s of p){let d=b?(0,D.commonPrefixLength)(b,s):0;for(d===0?F=1:F=g;d<s.length;d++)d+1===s.length?(_=g,g=9):g+=1,m.push([F,s.toUpperCase().charCodeAt(d),g]),m.push([F,s.toLowerCase().charCodeAt(d),g]),F=g;b=s,g=_}m.push([9,58,10]),m.push([10,47,12]),this._stateMachine=new k.StateMachine(m)}}provideDocumentLinks(p){this._initStateMachine();const m=[],b=k.LinkComputer.computeLinks({getLineContent(F){return p.lineAt(F-1).text},getLineCount(){return p.lineCount}},this._stateMachine);for(const F of b){const _=R.DocumentLink.to(F);_.target&&m.push(_)}return m}}class l{constructor(p,m){this._extHostLanguageFeatures=m,this._linkProvider=new C,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=p.getProxy(t.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(p,m,b,F={}){if(this._registeredSchemes.has(m))throw new Error(`a provider for the scheme '${m}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(p,"*",this._linkProvider));const _=this._handlePool++;this._linkProvider.add(m),this._registeredSchemes.add(m),this._fsProvider.set(_,b);let g=2;F.isCaseSensitive&&(g+=1024),F.isReadonly&&(g+=2048),typeof b.copy=="function"&&(g+=8),typeof b.open=="function"&&typeof b.close=="function"&&typeof b.read=="function"&&typeof b.write=="function"&&((0,L.checkProposedApiEnabled)(p,"fsChunks"),g+=4),this._proxy.$registerFileSystemProvider(_,m,g).catch(d=>{console.error(`FAILED to register filesystem provider of ${p.identifier.value}-extension for the scheme ${m}`),console.error(d)});const s=b.onDidChangeFile(d=>{const n=[];for(const S of d){let{uri:o,type:i}=S;if(o.scheme!==m)continue;let r;switch(i){case y.FileChangeType.Changed:r=0;break;case y.FileChangeType.Created:r=1;break;case y.FileChangeType.Deleted:r=2;break;default:throw new Error("Unknown FileChangeType")}n.push({resource:o,type:r})}this._proxy.$onFileSystemChange(_,n)});return(0,I.toDisposable)(()=>{s.dispose(),this._linkProvider.delete(m),this._registeredSchemes.delete(m),this._fsProvider.delete(_),this._proxy.$unregisterProvider(_)})}static _asIStat(p){const{type:m,ctime:b,mtime:F,size:_,permissions:g}=p;return{type:m,ctime:b,mtime:F,size:_,permissions:g}}$stat(p,m){return Promise.resolve(this._getFsProvider(p).stat(h.URI.revive(m))).then(b=>l._asIStat(b))}$readdir(p,m){return Promise.resolve(this._getFsProvider(p).readDirectory(h.URI.revive(m)))}$readFile(p,m){return Promise.resolve(this._getFsProvider(p).readFile(h.URI.revive(m))).then(b=>P.VSBuffer.wrap(b))}$writeFile(p,m,b,F){return Promise.resolve(this._getFsProvider(p).writeFile(h.URI.revive(m),b.buffer,F))}$delete(p,m,b){return Promise.resolve(this._getFsProvider(p).delete(h.URI.revive(m),b))}$rename(p,m,b,F){return Promise.resolve(this._getFsProvider(p).rename(h.URI.revive(m),h.URI.revive(b),F))}$copy(p,m,b,F){const _=this._getFsProvider(p);if(!_.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(_.copy(h.URI.revive(m),h.URI.revive(b),F))}$mkdir(p,m){return Promise.resolve(this._getFsProvider(p).createDirectory(h.URI.revive(m)))}$watch(p,m,b,F){const _=this._getFsProvider(p).watch(h.URI.revive(b),F);this._watches.set(m,_)}$unwatch(p,m){const b=this._watches.get(m);b&&(b.dispose(),this._watches.delete(m))}$open(p,m,b){const F=this._getFsProvider(p);if(!F.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(F.open(h.URI.revive(m),b))}$close(p,m){const b=this._getFsProvider(p);if(!b.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(b.close(m))}$read(p,m,b,F){const _=this._getFsProvider(p);if(!_.read)throw new Error('FileSystemProvider does not implement "read"');const g=P.VSBuffer.alloc(F);return Promise.resolve(_.read(m,b,g.buffer,0,F)).then(s=>g.slice(0,s))}$write(p,m,b,F){const _=this._getFsProvider(p);if(!_.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(_.write(m,b,F.buffer,0,F.byteLength))}_getFsProvider(p){const m=this._fsProvider.get(p);if(!m){const b=new Error;throw b.name="ENOPRO",b.message="no provider",b}return m}}e.ExtHostFileSystem=l}),define(ve[67],we([0,1,5,42,7,22,4,14,44,6]),function(Z,e,h,t,I,y,R,k,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let L=class xt{constructor(l,E){this._fileSystemProvider=new Map,this._proxy=l.getProxy(h.MainContext.MainThreadFileSystem);const p=this;this.value=Object.freeze({async stat(m){try{const b=p._fileSystemProvider.get(m.scheme);if(!b)return await p._proxy.$stat(m);await p._proxy.$ensureActivation(m.scheme);const F=await b.stat(m);return{type:F.type,ctime:F.ctime,mtime:F.mtime,size:F.size,permissions:F.permissions}}catch(b){xt._handleError(b)}},async readDirectory(m){try{const b=p._fileSystemProvider.get(m.scheme);return b?(await p._proxy.$ensureActivation(m.scheme),(await b.readDirectory(m)).slice()):await p._proxy.$readdir(m)}catch(b){return xt._handleError(b)}},async createDirectory(m){try{return await p._proxy.$mkdir(m)}catch(b){return xt._handleError(b)}},async readFile(m){try{const b=p._fileSystemProvider.get(m.scheme);return b?(await p._proxy.$ensureActivation(m.scheme),(await b.readFile(m)).slice()):(await p._proxy.$readFile(m)).buffer}catch(b){return xt._handleError(b)}},async writeFile(m,b){try{return await p._proxy.$writeFile(m,y.VSBuffer.wrap(b))}catch(F){return xt._handleError(F)}},async delete(m,b){try{const F=p._fileSystemProvider.get(m.scheme);return F?(await p._proxy.$ensureActivation(m.scheme),await F.delete(m,{recursive:!1,...b})):await p._proxy.$delete(m,{recursive:!1,useTrash:!1,...b})}catch(F){return xt._handleError(F)}},async rename(m,b,F){try{return await p._proxy.$rename(m,b,{overwrite:!1,...F})}catch(_){return xt._handleError(_)}},async copy(m,b,F){try{return await p._proxy.$copy(m,b,{overwrite:!1,...F})}catch(_){return xt._handleError(_)}},isWritableFileSystem(m){const b=E.getCapabilities(m);if(typeof b=="number")return!(b&2048)}})}static _handleError(l){if(l instanceof I.FileSystemError)throw l;if(!(l instanceof Error))throw new I.FileSystemError(String(l));if(l.name==="ENOPRO")throw I.FileSystemError.Unavailable(l.message);switch(l.name){case t.FileSystemProviderErrorCode.FileExists:throw I.FileSystemError.FileExists(l.message);case t.FileSystemProviderErrorCode.FileNotFound:throw I.FileSystemError.FileNotFound(l.message);case t.FileSystemProviderErrorCode.FileNotADirectory:throw I.FileSystemError.FileNotADirectory(l.message);case t.FileSystemProviderErrorCode.FileIsADirectory:throw I.FileSystemError.FileIsADirectory(l.message);case t.FileSystemProviderErrorCode.NoPermissions:throw I.FileSystemError.NoPermissions(l.message);case t.FileSystemProviderErrorCode.Unavailable:throw I.FileSystemError.Unavailable(l.message);default:throw new I.FileSystemError(l.message,l.name)}}addFileSystemProvider(l,E){return this._fileSystemProvider.set(l,E),(0,P.toDisposable)(()=>this._fileSystemProvider.delete(l))}};L=je([ze(0,k.IExtHostRpcService),ze(1,D.IExtHostFileSystemInfo)],L),e.ExtHostConsumerFileSystem=L,e.IExtHostConsumerFileSystem=(0,R.createDecorator)("IExtHostConsumerFileSystem")}),define(ve[237],we([0,1,3,32,2,5,15,7]),function(Z,e,h,t,I,y,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class D{constructor(C,l,E,p,m,b,F,_){this._onDidCreate=new h.Emitter,this._onDidChange=new h.Emitter,this._onDidDelete=new h.Emitter;const g=this.ensureWatching(C,E,m);this._config=0,b&&(this._config+=1),F&&(this._config+=2),_&&(this._config+=4);const s=(0,t.parse)(m),d=typeof m=="string",n=p(S=>{if(!b)for(let o of S.created){const i=I.URI.revive(o);s(i.fsPath)&&(!d||l.getWorkspaceFolder(i))&&this._onDidCreate.fire(i)}if(!F)for(let o of S.changed){const i=I.URI.revive(o);s(i.fsPath)&&(!d||l.getWorkspaceFolder(i))&&this._onDidChange.fire(i)}if(!_)for(let o of S.deleted){const i=I.URI.revive(o);s(i.fsPath)&&(!d||l.getWorkspaceFolder(i))&&this._onDidDelete.fire(i)}});this._disposable=k.Disposable.from(g,this._onDidCreate,this._onDidChange,this._onDidDelete,n)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}ensureWatching(C,l,E){let p=k.Disposable.from();if(typeof E=="string")return p;const m=C.getProxy(y.MainContext.MainThreadFileSystem);let b=!1;(E.pattern.includes(t.GLOBSTAR)||E.pattern.includes(t.GLOB_SPLIT))&&(b=!0);const F=Math.random();return m.$watch(l.identifier.value,F,E.baseUri,{recursive:b,excludes:[]}),k.Disposable.from({dispose:()=>m.$unwatch(F)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class P{constructor(C,l,E){this._mainContext=C,this._logService=l,this._extHostDocumentsAndEditors=E,this._onFileSystemEvent=new h.Emitter,this._onDidRenameFile=new h.Emitter,this._onDidCreateFile=new h.Emitter,this._onDidDeleteFile=new h.Emitter,this._onWillRenameFile=new h.AsyncEmitter,this._onWillCreateFile=new h.AsyncEmitter,this._onWillDeleteFile=new h.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(C,l,E,p,m,b){return new D(this._mainContext,C,l,this._onFileSystemEvent.event,R.GlobPattern.from(E),p,m,b)}$onFileEvent(C){this._onFileSystemEvent.fire(C)}$onDidRunFileOperation(C,l){switch(C){case 2:this._onDidRenameFile.fire(Object.freeze({files:l.map(E=>({oldUri:I.URI.revive(E.source),newUri:I.URI.revive(E.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:l.map(E=>I.URI.revive(E.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:l.map(E=>I.URI.revive(E.target))}));break;default:}}getOnWillRenameFileEvent(C){return this._createWillExecuteEvent(C,this._onWillRenameFile)}getOnWillCreateFileEvent(C){return this._createWillExecuteEvent(C,this._onWillCreateFile)}getOnWillDeleteFileEvent(C){return this._createWillExecuteEvent(C,this._onWillDeleteFile)}_createWillExecuteEvent(C,l){return(E,p,m)=>{const b=function(_){E.call(p,_)};return b.extension=C,l.event(b,void 0,m)}}async $onWillRunFileOperation(C,l,E,p){switch(C){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:l.map(m=>({oldUri:I.URI.revive(m.source),newUri:I.URI.revive(m.target)}))},E,p);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:l.map(m=>I.URI.revive(m.target))},E,p);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:l.map(m=>I.URI.revive(m.target))},E,p)}}async _fireWillEvent(C,l,E,p){const m=new Set,b=[];if(await C.fireAsync(l,p,async(_,g)=>{const s=Date.now(),d=await Promise.resolve(_);d instanceof k.WorkspaceEdit&&(b.push(d),m.add(g.extension.displayName??g.extension.identifier.value)),Date.now()-s>E&&this._logService.warn("SLOW file-participant",g.extension.identifier)}),p.isCancellationRequested||b.length===0)return;const F={edits:[]};for(let _ of b){let{edits:g}=R.WorkspaceEdit.from(_,this._extHostDocumentsAndEditors);F.edits=F.edits.concat(g)}return{edit:F,extensionNames:Array.from(m)}}}e.ExtHostFileSystemEventService=P}),define(ve[238],we([0,1,2,38]),function(Z,e,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class I{constructor(R,k,D,P){this._extHostNotebooks=k,this._textDocumentsAndEditors=D,this._commands=P;const L=new t.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new t.ApiCommandArgument("showOptions","Show Options",C=>!0,C=>C),new t.ApiCommandArgument("resource","Interactive resource Uri",C=>!0,C=>C),new t.ApiCommandArgument("controllerId","Notebook controller Id",C=>!0,C=>C),new t.ApiCommandArgument("title","Interactive editor title",C=>!0,C=>C)],new t.ApiCommandResult("Notebook and input URI",C=>{if(C.notebookEditorId!==void 0){const l=this._extHostNotebooks.getEditorById(C.notebookEditorId);return{notebookUri:h.URI.revive(C.notebookUri),inputUri:h.URI.revive(C.inputUri),notebookEditor:l.apiEditor}}return{notebookUri:h.URI.revive(C.notebookUri),inputUri:h.URI.revive(C.inputUri)}}));this._commands.registerApiCommand(L)}$willAddInteractiveDocument(R,k,D,P){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:k,lines:[""],languageId:D,uri:R,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(h.URI.revive(P))?.apiNotebook}]})}$willRemoveInteractiveDocument(R,k){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[R]})}}e.ExtHostInteractive=I}),define(ve[239],we([0,1,6,5]),function(Z,e,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class I{constructor(R){this._handlePool=0,this._proxy=R.getProxy(t.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(R){const k=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(k,R),(0,h.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(k)})}}e.ExtHostLabelService=I}),define(ve[240],we([0,1,2,25,15,7,5,8,41,17,18,146,21,6,111,77,86,46,16,3,13]),function(Z,e,h,t,I,y,R,k,D,P,L,C,l,E,p,m,b,F,_,g,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class d{constructor(q,te){this._documents=q,this._provider=te}async provideDocumentSymbols(q,te){const G=this._documents.getDocument(q),Q=await this._provider.provideDocumentSymbols(G,te);if(!(0,P.isFalsyOrEmpty)(Q))return Q[0]instanceof y.DocumentSymbol?Q.map(I.DocumentSymbol.from):d._asDocumentSymbolTree(Q)}static _asDocumentSymbolTree(q){q=q.slice(0).sort((Q,ae)=>{let me=Q.location.range.start.compareTo(ae.location.range.start);return me===0&&(me=ae.location.range.end.compareTo(Q.location.range.end)),me});const te=[],G=[];for(const Q of q){const ae={name:Q.name||"!!MISSING: name!!",kind:I.SymbolKind.from(Q.kind),tags:Q.tags?.map(I.SymbolTag.from)||[],detail:"",containerName:Q.containerName,range:I.Range.from(Q.location.range),selectionRange:I.Range.from(Q.location.range),children:[]};for(;;){if(G.length===0){G.push(ae),te.push(ae);break}const me=G[G.length-1];if(D.Range.containsRange(me.range,ae.range)&&!D.Range.equalsRange(me.range,ae.range)){me.children&&me.children.push(ae),G.push(ae);break}G.pop()}}return te}}class n{constructor(q,te,G){this._documents=q,this._commands=te,this._provider=G,this._cache=new b.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(q,te){const G=this._documents.getDocument(q),Q=await this._provider.provideCodeLenses(G,te);if(!Q||te.isCancellationRequested)return;const ae=this._cache.add(Q),me=new E.DisposableStore;this._disposables.set(ae,me);const ke={cacheId:ae,lenses:[]};for(let We=0;We<Q.length;We++)ke.lenses.push({cacheId:[ae,We],range:I.Range.from(Q[We].range),command:this._commands.toInternal(Q[We].command,me)});return ke}async resolveCodeLens(q,te){const G=q.cacheId&&this._cache.get(...q.cacheId);if(!G)return;let Q;if(typeof this._provider.resolveCodeLens!="function"||G.isResolved?Q=G:Q=await this._provider.resolveCodeLens(G,te),Q||(Q=G),te.isCancellationRequested)return;const ae=q.cacheId&&this._disposables.get(q.cacheId[0]);if(!!ae)return q.command=this._commands.toInternal(Q.command??n._badCmd,ae),q}releaseCodeLenses(q){this._disposables.get(q)?.dispose(),this._disposables.delete(q),this._cache.delete(q)}}n._badCmd={command:"missing",title:"!!MISSING: command!!"};function S(Qe){return Array.isArray(Qe)?Qe.map(I.DefinitionLink.from):Qe?[I.DefinitionLink.from(Qe)]:[]}class o{constructor(q,te){this._documents=q,this._provider=te}async provideDefinition(q,te,G){const Q=this._documents.getDocument(q),ae=I.Position.to(te),me=await this._provider.provideDefinition(Q,ae,G);return S(me)}}class i{constructor(q,te){this._documents=q,this._provider=te}async provideDeclaration(q,te,G){const Q=this._documents.getDocument(q),ae=I.Position.to(te),me=await this._provider.provideDeclaration(Q,ae,G);return S(me)}}class r{constructor(q,te){this._documents=q,this._provider=te}async provideImplementation(q,te,G){const Q=this._documents.getDocument(q),ae=I.Position.to(te),me=await this._provider.provideImplementation(Q,ae,G);return S(me)}}class c{constructor(q,te){this._documents=q,this._provider=te}async provideTypeDefinition(q,te,G){const Q=this._documents.getDocument(q),ae=I.Position.to(te),me=await this._provider.provideTypeDefinition(Q,ae,G);return S(me)}}class a{constructor(q,te){this._documents=q,this._provider=te}async provideHover(q,te,G){const Q=this._documents.getDocument(q),ae=I.Position.to(te),me=await this._provider.provideHover(Q,ae,G);if(!(!me||(0,P.isFalsyOrEmpty)(me.contents)))return me.range||(me.range=Q.getWordRangeAtPosition(ae)),me.range||(me.range=new y.Range(ae,ae)),I.Hover.from(me)}}class u{constructor(q,te){this._documents=q,this._provider=te}async provideEvaluatableExpression(q,te,G){const Q=this._documents.getDocument(q),ae=I.Position.to(te),me=await this._provider.provideEvaluatableExpression(Q,ae,G);if(me)return I.EvaluatableExpression.from(me)}}class f{constructor(q,te){this._documents=q,this._provider=te}async provideInlineValues(q,te,G,Q){const ae=this._documents.getDocument(q),me=await this._provider.provideInlineValues(ae,I.Range.to(te),I.InlineValueContext.to(G),Q);if(Array.isArray(me))return me.map(ke=>I.InlineValue.from(ke))}}class v{constructor(q,te){this._documents=q,this._provider=te}async provideDocumentHighlights(q,te,G){const Q=this._documents.getDocument(q),ae=I.Position.to(te),me=await this._provider.provideDocumentHighlights(Q,ae,G);if(Array.isArray(me))return me.map(I.DocumentHighlight.from)}}class w{constructor(q,te){this._documents=q,this._provider=te}async provideLinkedEditingRanges(q,te,G){const Q=this._documents.getDocument(q),ae=I.Position.to(te),me=await this._provider.provideLinkedEditingRanges(Q,ae,G);if(me&&Array.isArray(me.ranges))return{ranges:(0,P.coalesce)(me.ranges.map(I.Range.from)),wordPattern:me.wordPattern}}}class A{constructor(q,te){this._documents=q,this._provider=te}async provideReferences(q,te,G,Q){const ae=this._documents.getDocument(q),me=I.Position.to(te),ke=await this._provider.provideReferences(ae,me,G,Q);if(Array.isArray(ke))return ke.map(I.location.from)}}class M{constructor(q,te,G,Q,ae,me,ke){this._documents=q,this._commands=te,this._diagnostics=G,this._provider=Q,this._logService=ae,this._extension=me,this._apiDeprecation=ke,this._cache=new b.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(q,te,G,Q){const ae=this._documents.getDocument(q),me=C.Selection.isISelection(te)?I.Selection.to(te):I.Range.to(te),ke=[];for(const tt of this._diagnostics.getDiagnostics(q))if(me.intersection(tt.range)&&ke.push(tt)>M._maxCodeActionsPerFile)break;const We={diagnostics:ke,only:G.only?new y.CodeActionKind(G.only):void 0,triggerKind:I.CodeActionTriggerKind.to(G.trigger)},Je=await this._provider.provideCodeActions(ae,me,We,Q);if(!(0,P.isNonEmptyArray)(Je)||Q.isCancellationRequested)return;const it=this._cache.add(Je),st=new E.DisposableStore;this._disposables.set(it,st);const ot=[];for(let tt=0;tt<Je.length;tt++){const rt=Je[tt];!rt||(M._isCommand(rt)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),ot.push({_isSynthetic:!0,title:rt.title,command:this._commands.toInternal(rt,st)})):(We.only&&(rt.kind?We.only.contains(rt.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${We.only.value} 'requested but returned code action is of kind '${rt.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${We.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),ot.push({cacheId:[it,tt],title:rt.title,command:rt.command&&this._commands.toInternal(rt.command,st),diagnostics:rt.diagnostics&&rt.diagnostics.map(I.Diagnostic.from),edit:rt.edit&&I.WorkspaceEdit.from(rt.edit),kind:rt.kind&&rt.kind.value,isPreferred:rt.isPreferred,disabled:rt.disabled?.reason})))}return{cacheId:it,actions:ot}}async resolveCodeAction(q,te){const[G,Q]=q,ae=this._cache.get(G,Q);if(!ae||M._isCommand(ae)||!this._provider.resolveCodeAction)return;const me=await this._provider.resolveCodeAction(ae,te)??ae;return me?.edit?I.WorkspaceEdit.from(me.edit):void 0}releaseCodeActions(q){this._disposables.get(q)?.dispose(),this._disposables.delete(q),this._cache.delete(q)}static _isCommand(q){return typeof q.command=="string"&&typeof q.title=="string"}}M._maxCodeActionsPerFile=1e3;class T{constructor(q,te){this._documents=q,this._provider=te}async provideDocumentFormattingEdits(q,te,G){const Q=this._documents.getDocument(q),ae=await this._provider.provideDocumentFormattingEdits(Q,te,G);if(Array.isArray(ae))return ae.map(I.TextEdit.from)}}class O{constructor(q,te){this._documents=q,this._provider=te}async provideDocumentRangeFormattingEdits(q,te,G,Q){const ae=this._documents.getDocument(q),me=I.Range.to(te),ke=await this._provider.provideDocumentRangeFormattingEdits(ae,me,G,Q);if(Array.isArray(ke))return ke.map(I.TextEdit.from)}}class U{constructor(q,te){this._documents=q,this._provider=te,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(q,te,G,Q,ae){const me=this._documents.getDocument(q),ke=I.Position.to(te),We=await this._provider.provideOnTypeFormattingEdits(me,ke,G,Q,ae);if(Array.isArray(We))return We.map(I.TextEdit.from)}}class V{constructor(q,te){this._provider=q,this._logService=te,this._cache=new b.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(q,te){const G=await this._provider.provideWorkspaceSymbols(q,te);if(!(0,P.isNonEmptyArray)(G))return{symbols:[]};const Q=this._cache.add(G),ae={cacheId:Q,symbols:[]};for(let me=0;me<G.length;me++){const ke=G[me];if(!ke||!ke.name){this._logService.warn("INVALID SymbolInformation",ke);continue}ae.symbols.push({...I.WorkspaceSymbol.from(ke),cacheId:[Q,me]})}return ae}async resolveWorkspaceSymbol(q,te){if(typeof this._provider.resolveWorkspaceSymbol!="function"||!q.cacheId)return q;const G=this._cache.get(...q.cacheId);if(G){const Q=await this._provider.resolveWorkspaceSymbol(G,te);return Q&&(0,t.mixin)(q,I.WorkspaceSymbol.from(Q),!0)}}releaseWorkspaceSymbols(q){this._cache.delete(q)}}class x{constructor(q,te,G){this._documents=q,this._provider=te,this._logService=G}static supportsResolving(q){return typeof q.prepareRename=="function"}async provideRenameEdits(q,te,G,Q){const ae=this._documents.getDocument(q),me=I.Position.to(te);try{const ke=await this._provider.provideRenameEdits(ae,me,G,Q);return ke?I.WorkspaceEdit.from(ke):void 0}catch(ke){const We=x._asMessage(ke);return We?{rejectReason:We,edits:void 0}:Promise.reject(ke)}}async resolveRenameLocation(q,te,G){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const Q=this._documents.getDocument(q),ae=I.Position.to(te);try{const me=await this._provider.prepareRename(Q,ae,G);let ke,We;if(y.Range.isRange(me)?(ke=me,We=Q.getText(me)):(0,L.isObject)(me)&&(ke=me.range,We=me.placeholder),!ke||!We)return;if(ke.start.line>ae.line||ke.end.line<ae.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:I.Range.from(ke),text:We}}catch(me){const ke=x._asMessage(me);return ke?{rejectReason:ke,range:void 0,text:void 0}:Promise.reject(me)}}static _asMessage(q){return typeof q=="string"?q:q instanceof Error&&typeof q.message=="string"?q.message:void 0}}class N{constructor(q,te){this.resultId=q,this.tokens=te}}class ${constructor(q,te){this._documents=q,this._provider=te,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(q,te,G){const Q=this._documents.getDocument(q),ae=te!==0?this._previousResults.get(te):null;let me=typeof ae?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(Q,ae.resultId,G):await this._provider.provideDocumentSemanticTokens(Q,G);return ae&&this._previousResults.delete(te),me?(me=$._fixProvidedSemanticTokens(me),this._send($._convertToEdits(ae,me),me)):null}async releaseDocumentSemanticColoring(q){this._previousResults.delete(q)}static _fixProvidedSemanticTokens(q){return $._isSemanticTokens(q)?$._isCorrectSemanticTokens(q)?q:new y.SemanticTokens(new Uint32Array(q.data),q.resultId):$._isSemanticTokensEdits(q)?$._isCorrectSemanticTokensEdits(q)?q:new y.SemanticTokensEdits(q.edits.map(te=>new y.SemanticTokensEdit(te.start,te.deleteCount,te.data?new Uint32Array(te.data):te.data)),q.resultId):q}static _isSemanticTokens(q){return q&&!!q.data}static _isCorrectSemanticTokens(q){return q.data instanceof Uint32Array}static _isSemanticTokensEdits(q){return q&&Array.isArray(q.edits)}static _isCorrectSemanticTokensEdits(q){for(const te of q.edits)if(!(te.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(q,te){if(!$._isSemanticTokens(te)||!q||!q.tokens)return te;const G=q.tokens,Q=G.length,ae=te.data,me=ae.length;let ke=0;const We=Math.min(Q,me);for(;ke<We&&G[ke]===ae[ke];)ke++;if(ke===Q&&ke===me)return new y.SemanticTokensEdits([],te.resultId);let Je=0;const it=We-ke;for(;Je<it&&G[Q-Je-1]===ae[me-Je-1];)Je++;return new y.SemanticTokensEdits([{start:ke,deleteCount:Q-ke-Je,data:ae.subarray(ke,me-Je)}],te.resultId)}_send(q,te){if($._isSemanticTokens(q)){const G=this._nextResultId++;return this._previousResults.set(G,new N(q.resultId,q.data)),(0,p.encodeSemanticTokensDto)({id:G,type:"full",data:q.data})}if($._isSemanticTokensEdits(q)){const G=this._nextResultId++;return $._isSemanticTokens(te)?this._previousResults.set(G,new N(te.resultId,te.data)):this._previousResults.set(G,new N(q.resultId)),(0,p.encodeSemanticTokensDto)({id:G,type:"delta",deltas:(q.edits||[]).map(Q=>({start:Q.start,deleteCount:Q.deleteCount,data:Q.data}))})}return null}}e.DocumentSemanticTokensAdapter=$;class B{constructor(q,te){this._documents=q,this._provider=te}async provideDocumentRangeSemanticTokens(q,te,G){const Q=this._documents.getDocument(q),ae=await this._provider.provideDocumentRangeSemanticTokens(Q,I.Range.to(te),G);return ae?this._send(ae):null}_send(q){return(0,p.encodeSemanticTokensDto)({id:0,type:"full",data:q.data})}}e.DocumentRangeSemanticTokensAdapter=B;class z{constructor(q,te,G,Q,ae){this._documents=q,this._commands=te,this._provider=G,this._apiDeprecation=Q,this._extension=ae,this._cache=new b.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(q){return typeof q.resolveCompletionItem=="function"}async provideCompletionItems(q,te,G,Q){const ae=this._documents.getDocument(q),me=I.Position.to(te),ke=ae.getWordRangeAtPosition(me)||new y.Range(me,me),We=ke.with({end:me}),Je=new F.StopWatch(!0),it=await this._provider.provideCompletionItems(ae,me,Q,I.CompletionContext.to(G));if(!it||Q.isCancellationRequested)return;const st=Array.isArray(it)?new y.CompletionList(it):it,ot=z.supportsResolving(this._provider)?this._cache.add(st.items):this._cache.add([]),tt=new E.DisposableStore;this._disposables.set(ot,tt);const rt=[],gt={x:ot,b:rt,a:{replace:I.Range.from(ke),insert:I.Range.from(We)},c:st.isIncomplete||void 0,d:Je.elapsed()};for(let Ue=0;Ue<st.items.length;Ue++){const It=st.items[Ue],ee=this._convertCompletionItem(It,[ot,Ue],We,ke);rt.push(ee)}return gt}async resolveCompletionItem(q,te){if(typeof this._provider.resolveCompletionItem!="function")return;const G=this._cache.get(...q);if(!G)return;const Q=await this._provider.resolveCompletionItem(G,te);if(!!Q)return this._convertCompletionItem(Q,q)}releaseCompletionItems(q){this._disposables.get(q)?.dispose(),this._disposables.delete(q),this._cache.delete(q)}_convertCompletionItem(q,te,G,Q){const ae=this._disposables.get(te[0]);if(!ae)throw Error("DisposableStore is missing...");const me={x:te,a:q.label,b:q.kind!==void 0?I.CompletionItemKind.from(q.kind):void 0,n:q.tags&&q.tags.map(I.CompletionItemTag.from),c:q.detail,d:typeof q.documentation=="undefined"?void 0:I.MarkdownString.fromStrict(q.documentation),e:q.sortText!==q.label?q.sortText:void 0,f:q.filterText!==q.label?q.filterText:void 0,g:q.preselect||void 0,i:q.keepWhitespace?1:0,k:q.commitCharacters,l:q.additionalTextEdits&&q.additionalTextEdits.map(I.TextEdit.from),m:this._commands.toInternal(q.command,ae)};q.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),me.h=q.textEdit.newText):typeof q.insertText=="string"?me.h=q.insertText:q.insertText instanceof y.SnippetString&&(me.h=q.insertText.value,me.i|=4);let ke;return q.textEdit?ke=q.textEdit.range:q.range&&(ke=q.range),y.Range.isRange(ke)?me.j=I.Range.from(ke):ke&&(!G?.isEqual(ke.inserting)||!Q?.isEqual(ke.replacing))&&(me.j={insert:I.Range.from(ke.inserting),replace:I.Range.from(ke.replacing)}),me}}class W{constructor(q,te,G){this._documents=q,this._provider=te,this._commands=G,this._cache=new b.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(q,te,G,Q){const ae=this._documents.getDocument(q),me=I.Position.to(te),ke=await this._provider.provideInlineCompletionItems(ae,me,{selectedCompletionInfo:G.selectedSuggestionInfo?{range:I.Range.to(G.selectedSuggestionInfo.range),text:G.selectedSuggestionInfo.text,isSnippetText:G.selectedSuggestionInfo.isSnippetText,completionKind:I.CompletionItemKind.to(G.selectedSuggestionInfo.completionKind)}:void 0,triggerKind:G.triggerKind},Q);if(!ke||Q.isCancellationRequested)return;const We=(0,L.isArray)(ke)?{items:ke}:ke,Je=this._cache.add(We.items);let it;return{pid:Je,items:We.items.map((st,ot)=>{let tt;return st.command&&(it||(it=new E.DisposableStore,this._disposables.set(Je,it)),tt=this._commands.toInternal(st.command,it)),{text:st.text,range:st.range?I.Range.from(st.range):void 0,command:tt,idx:ot}})}}disposeCompletions(q){this._cache.delete(q);const te=this._disposables.get(q);te&&te.clear(),this._disposables.delete(q)}handleDidShowCompletionItem(q,te){const G=this._cache.get(q,te);G&&Y.get(this._provider).fireOnDidShowCompletionItem({completionItem:G})}}class Y{constructor(){this._onDidShowCompletionItemEmitter=new g.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(q){let te=Y.map.get(q);return te||(te=new Y,Y.map.set(q,te)),te}fireOnDidShowCompletionItem(q){this._onDidShowCompletionItemEmitter.fire(q)}}e.InlineCompletionController=Y,Y.map=new WeakMap;class ie{constructor(q,te){this._documents=q,this._provider=te,this._cache=new b.Cache("SignatureHelp")}async provideSignatureHelp(q,te,G,Q){const ae=this._documents.getDocument(q),me=I.Position.to(te),ke=this.reviveContext(G),We=await this._provider.provideSignatureHelp(ae,me,Q,ke);if(We){const Je=this._cache.add([We]);return{...I.SignatureHelp.from(We),id:Je}}}reviveContext(q){let te;if(q.activeSignatureHelp){const G=I.SignatureHelp.to(q.activeSignatureHelp),Q=this._cache.get(q.activeSignatureHelp.id,0);Q?(te=Q,te.activeSignature=G.activeSignature,te.activeParameter=G.activeParameter):te=G}return{...q,activeSignatureHelp:te}}releaseSignatureHelp(q){this._cache.delete(q)}}class ne{constructor(q,te,G,Q,ae){this._documents=q,this._commands=te,this._provider=G,this._logService=Q,this._extension=ae,this._cache=new b.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(q,te,G){const Q=this._documents.getDocument(q),ae=I.Range.to(te),me=await this._provider.provideInlayHints(Q,ae,G);if(!Array.isArray(me)||me.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for ${te}`);return}if(G.isCancellationRequested)return;const ke=this._cache.add(me);this._disposables.set(ke,new E.DisposableStore);const We={hints:[],cacheId:ke};for(let Je=0;Je<me.length;Je++)this._isValidInlayHint(me[Je],ae)&&We.hints.push(this._convertInlayHint(me[Je],[ke,Je]));return this._logService.trace(`[InlayHints] ${We.hints.length} inlay hints from '${this._extension.identifier.value}' for ${te}`),We}async resolveInlayHint(q,te){if(typeof this._provider.resolveInlayHint!="function")return;const G=this._cache.get(...q);if(!G)return;const Q=await this._provider.resolveInlayHint(G,te);if(!!Q&&!!this._isValidInlayHint(Q))return this._convertInlayHint(Q,q)}releaseHints(q){this._disposables.get(q)?.dispose(),this._disposables.delete(q),this._cache.delete(q)}_isValidInlayHint(q,te){return q.label.length===0||Array.isArray(q.label)&&q.label.every(G=>G.label.length===0)?(console.log("INVALID inlay hint, empty label",q),!1):!(te&&!te.contains(q.position))}_convertInlayHint(q,te){const G=this._disposables.get(te[0]);if(!G)throw Error("DisposableStore is missing...");const Q={label:"",cacheId:te,tooltip:q.tooltip&&I.MarkdownString.from(q.tooltip),position:I.Position.from(q.position),kind:I.InlayHintKind.from(q.kind??y.InlayHintKind.Other),paddingLeft:q.paddingLeft,paddingRight:q.paddingRight};return typeof q.label=="string"?Q.label=q.label:Q.label=q.label.map(ae=>{let me={label:ae.label};return me.tooltip=ae.tooltip&&I.MarkdownString.from(ae.tooltip),y.Location.isLocation(ae.location)?me.location=I.location.from(ae.location):ae.command&&(me.command=this._commands.toInternal(ae.command,G)),me}),Q}}class J{constructor(q,te){this._documents=q,this._provider=te,this._cache=new b.Cache("DocumentLink")}async provideLinks(q,te){const G=this._documents.getDocument(q),Q=await this._provider.provideDocumentLinks(G,te);if(!(!Array.isArray(Q)||Q.length===0)&&!te.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:Q.filter(J._validateLink).map(I.DocumentLink.from)};{const ae=this._cache.add(Q),me={links:[],cacheId:ae};for(let ke=0;ke<Q.length;ke++){if(!J._validateLink(Q[ke]))continue;const We=I.DocumentLink.from(Q[ke]);We.cacheId=[ae,ke],me.links.push(We)}return me}}}static _validateLink(q){return q.target&&q.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(q,te){if(typeof this._provider.resolveDocumentLink!="function")return;const G=this._cache.get(...q);if(!G)return;const Q=await this._provider.resolveDocumentLink(G,te);if(!(!Q||!J._validateLink(Q)))return I.DocumentLink.from(Q)}releaseLinks(q){this._cache.delete(q)}}class K{constructor(q,te){this._documents=q,this._provider=te}async provideColors(q,te){const G=this._documents.getDocument(q),Q=await this._provider.provideDocumentColors(G,te);return Array.isArray(Q)?Q.map(me=>({color:I.Color.from(me.color),range:I.Range.from(me.range)})):[]}async provideColorPresentations(q,te,G){const Q=this._documents.getDocument(q),ae=I.Range.to(te.range),me=I.Color.to(te.color),ke=await this._provider.provideColorPresentations(me,{document:Q,range:ae},G);if(!!Array.isArray(ke))return ke.map(I.ColorPresentation.from)}}class oe{constructor(q,te){this._documents=q,this._provider=te}async provideFoldingRanges(q,te,G){const Q=this._documents.getDocument(q),ae=await this._provider.provideFoldingRanges(Q,te,G);if(!!Array.isArray(ae))return ae.map(I.FoldingRange.from)}}class fe{constructor(q,te,G){this._documents=q,this._provider=te,this._logService=G}async provideSelectionRanges(q,te,G){const Q=this._documents.getDocument(q),ae=te.map(I.Position.to),me=await this._provider.provideSelectionRanges(Q,ae,G);if(!(0,P.isNonEmptyArray)(me))return[];if(me.length!==ae.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const ke=[];for(let We=0;We<ae.length;We++){const Je=[];ke.push(Je);let it=ae[We],st=me[We];for(;;){if(!st.range.contains(it))throw new Error("INVALID selection range, must contain the previous range");if(Je.push(I.SelectionRange.from(st)),!st.parent)break;it=st.range,st=st.parent}}return ke}}class pe{constructor(q,te){this._documents=q,this._provider=te,this._idPool=new m.IdGenerator(""),this._cache=new Map}async prepareSession(q,te,G){const Q=this._documents.getDocument(q),ae=I.Position.to(te),me=await this._provider.prepareCallHierarchy(Q,ae,G);if(!me)return;const ke=this._idPool.nextId();return this._cache.set(ke,new Map),Array.isArray(me)?me.map(We=>this._cacheAndConvertItem(ke,We)):[this._cacheAndConvertItem(ke,me)]}async provideCallsTo(q,te,G){const Q=this._itemFromCache(q,te);if(!Q)throw new Error("missing call hierarchy item");const ae=await this._provider.provideCallHierarchyIncomingCalls(Q,G);if(!!ae)return ae.map(me=>({from:this._cacheAndConvertItem(q,me.from),fromRanges:me.fromRanges.map(ke=>I.Range.from(ke))}))}async provideCallsFrom(q,te,G){const Q=this._itemFromCache(q,te);if(!Q)throw new Error("missing call hierarchy item");const ae=await this._provider.provideCallHierarchyOutgoingCalls(Q,G);if(!!ae)return ae.map(me=>({to:this._cacheAndConvertItem(q,me.to),fromRanges:me.fromRanges.map(ke=>I.Range.from(ke))}))}releaseSession(q){this._cache.delete(q)}_cacheAndConvertItem(q,te){const G=this._cache.get(q),Q=I.CallHierarchyItem.from(te,q,G.size.toString(36));return G.set(Q._itemId,te),Q}_itemFromCache(q,te){return this._cache.get(q)?.get(te)}}class Te{constructor(q,te){this._documents=q,this._provider=te,this._idPool=new m.IdGenerator(""),this._cache=new Map}async prepareSession(q,te,G){const Q=this._documents.getDocument(q),ae=I.Position.to(te),me=await this._provider.prepareTypeHierarchy(Q,ae,G);if(!me)return;const ke=this._idPool.nextId();return this._cache.set(ke,new Map),Array.isArray(me)?me.map(We=>this._cacheAndConvertItem(ke,We)):[this._cacheAndConvertItem(ke,me)]}async provideSupertypes(q,te,G){const Q=this._itemFromCache(q,te);if(!Q)throw new Error("missing type hierarchy item");const ae=await this._provider.provideTypeHierarchySupertypes(Q,G);if(!!ae)return ae.map(me=>this._cacheAndConvertItem(q,me))}async provideSubtypes(q,te,G){const Q=this._itemFromCache(q,te);if(!Q)throw new Error("missing type hierarchy item");const ae=await this._provider.provideTypeHierarchySubtypes(Q,G);if(!!ae)return ae.map(me=>this._cacheAndConvertItem(q,me))}releaseSession(q){this._cache.delete(q)}_cacheAndConvertItem(q,te){const G=this._cache.get(q),Q=I.TypeHierarchyItem.from(te,q,G.size.toString(36));return G.set(Q._itemId,te),Q}_itemFromCache(q,te){return this._cache.get(q)?.get(te)}}class xe{constructor(q,te){this.adapter=q,this.extension=te}}class Ge{constructor(q,te,G,Q,ae,me,ke){this._adapter=new Map,this._uriTransformer=te,this._proxy=q.getProxy(R.MainContext.MainThreadLanguageFeatures),this._documents=G,this._commands=Q,this._diagnostics=ae,this._logService=me,this._apiDeprecation=ke}_transformDocumentSelector(q){return I.DocumentSelector.from(q,this._uriTransformer)}_createDisposable(q){return new y.Disposable(()=>{this._adapter.delete(q),this._proxy.$unregister(q)})}_nextHandle(){return Ge._handlePool++}async _withAdapter(q,te,G,Q,ae){const me=this._adapter.get(q);if(!me||!(me.adapter instanceof te))return Q;const ke=Date.now();this._logService.trace(`[${me.extension.identifier.value}] INVOKE provider '${G.toString().replace(/[\r\n]/g,"")}'`);const We=G(me.adapter,me.extension);return Promise.resolve(We).catch(Je=>{(0,_.isCancellationError)(Je)||(this._logService.error(`[${me.extension.identifier.value}] provider FAILED`),this._logService.error(Je))}).finally(()=>{this._logService.trace(`[${me.extension.identifier.value}] provider DONE after ${Date.now()-ke}ms`)}),l.CancellationToken.isCancellationToken(ae)?(0,s.raceCancellationError)(We,ae):We}_addNewAdapter(q,te){const G=this._nextHandle();return this._adapter.set(G,new xe(q,te)),G}static _extLabel(q){return q.displayName||q.name}registerDocumentSymbolProvider(q,te,G,Q){const ae=this._addNewAdapter(new d(this._documents,G),q),me=Q&&Q.label||Ge._extLabel(q);return this._proxy.$registerDocumentSymbolProvider(ae,this._transformDocumentSelector(te),me),this._createDisposable(ae)}$provideDocumentSymbols(q,te,G){return this._withAdapter(q,d,Q=>Q.provideDocumentSymbols(h.URI.revive(te),G),void 0,G)}registerCodeLensProvider(q,te,G){const Q=this._nextHandle(),ae=typeof G.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(Q,new xe(new n(this._documents,this._commands.converter,G),q)),this._proxy.$registerCodeLensSupport(Q,this._transformDocumentSelector(te),ae);let me=this._createDisposable(Q);if(ae!==void 0){const ke=G.onDidChangeCodeLenses(We=>this._proxy.$emitCodeLensEvent(ae));me=y.Disposable.from(me,ke)}return me}$provideCodeLenses(q,te,G){return this._withAdapter(q,n,Q=>Q.provideCodeLenses(h.URI.revive(te),G),void 0,void 0)}$resolveCodeLens(q,te,G){return this._withAdapter(q,n,Q=>Q.resolveCodeLens(te,G),void 0,void 0)}$releaseCodeLenses(q,te){this._withAdapter(q,n,G=>Promise.resolve(G.releaseCodeLenses(te)),void 0,void 0)}registerDefinitionProvider(q,te,G){const Q=this._addNewAdapter(new o(this._documents,G),q);return this._proxy.$registerDefinitionSupport(Q,this._transformDocumentSelector(te)),this._createDisposable(Q)}$provideDefinition(q,te,G,Q){return this._withAdapter(q,o,ae=>ae.provideDefinition(h.URI.revive(te),G,Q),[],Q)}registerDeclarationProvider(q,te,G){const Q=this._addNewAdapter(new i(this._documents,G),q);return this._proxy.$registerDeclarationSupport(Q,this._transformDocumentSelector(te)),this._createDisposable(Q)}$provideDeclaration(q,te,G,Q){return this._withAdapter(q,i,ae=>ae.provideDeclaration(h.URI.revive(te),G,Q),[],Q)}registerImplementationProvider(q,te,G){const Q=this._addNewAdapter(new r(this._documents,G),q);return this._proxy.$registerImplementationSupport(Q,this._transformDocumentSelector(te)),this._createDisposable(Q)}$provideImplementation(q,te,G,Q){return this._withAdapter(q,r,ae=>ae.provideImplementation(h.URI.revive(te),G,Q),[],Q)}registerTypeDefinitionProvider(q,te,G){const Q=this._addNewAdapter(new c(this._documents,G),q);return this._proxy.$registerTypeDefinitionSupport(Q,this._transformDocumentSelector(te)),this._createDisposable(Q)}$provideTypeDefinition(q,te,G,Q){return this._withAdapter(q,c,ae=>ae.provideTypeDefinition(h.URI.revive(te),G,Q),[],Q)}registerHoverProvider(q,te,G,Q){const ae=this._addNewAdapter(new a(this._documents,G),q);return this._proxy.$registerHoverProvider(ae,this._transformDocumentSelector(te)),this._createDisposable(ae)}$provideHover(q,te,G,Q){return this._withAdapter(q,a,ae=>ae.provideHover(h.URI.revive(te),G,Q),void 0,void 0)}registerEvaluatableExpressionProvider(q,te,G,Q){const ae=this._addNewAdapter(new u(this._documents,G),q);return this._proxy.$registerEvaluatableExpressionProvider(ae,this._transformDocumentSelector(te)),this._createDisposable(ae)}$provideEvaluatableExpression(q,te,G,Q){return this._withAdapter(q,u,ae=>ae.provideEvaluatableExpression(h.URI.revive(te),G,Q),void 0,void 0)}registerInlineValuesProvider(q,te,G,Q){const ae=typeof G.onDidChangeInlineValues=="function"?this._nextHandle():void 0,me=this._addNewAdapter(new f(this._documents,G),q);this._proxy.$registerInlineValuesProvider(me,this._transformDocumentSelector(te),ae);let ke=this._createDisposable(me);if(ae!==void 0){const We=G.onDidChangeInlineValues(Je=>this._proxy.$emitInlineValuesEvent(ae));ke=y.Disposable.from(ke,We)}return ke}$provideInlineValues(q,te,G,Q,ae){return this._withAdapter(q,f,me=>me.provideInlineValues(h.URI.revive(te),G,Q,ae),void 0,void 0)}registerDocumentHighlightProvider(q,te,G){const Q=this._addNewAdapter(new v(this._documents,G),q);return this._proxy.$registerDocumentHighlightProvider(Q,this._transformDocumentSelector(te)),this._createDisposable(Q)}$provideDocumentHighlights(q,te,G,Q){return this._withAdapter(q,v,ae=>ae.provideDocumentHighlights(h.URI.revive(te),G,Q),void 0,void 0)}registerLinkedEditingRangeProvider(q,te,G){const Q=this._addNewAdapter(new w(this._documents,G),q);return this._proxy.$registerLinkedEditingRangeProvider(Q,this._transformDocumentSelector(te)),this._createDisposable(Q)}$provideLinkedEditingRanges(q,te,G,Q){return this._withAdapter(q,w,async ae=>{const me=await ae.provideLinkedEditingRanges(h.URI.revive(te),G,Q);if(me)return{ranges:me.ranges,wordPattern:me.wordPattern?Ge._serializeRegExp(me.wordPattern):void 0}},void 0,void 0)}registerReferenceProvider(q,te,G){const Q=this._addNewAdapter(new A(this._documents,G),q);return this._proxy.$registerReferenceSupport(Q,this._transformDocumentSelector(te)),this._createDisposable(Q)}$provideReferences(q,te,G,Q,ae){return this._withAdapter(q,A,me=>me.provideReferences(h.URI.revive(te),G,Q,ae),void 0,ae)}registerCodeActionProvider(q,te,G,Q){const ae=new E.DisposableStore,me=this._addNewAdapter(new M(this._documents,this._commands.converter,this._diagnostics,G,this._logService,q,this._apiDeprecation),q);return this._proxy.$registerQuickFixSupport(me,this._transformDocumentSelector(te),{providedKinds:Q?.providedCodeActionKinds?.map(ke=>ke.value),documentation:Q?.documentation?.map(ke=>({kind:ke.kind.value,command:this._commands.converter.toInternal(ke.command,ae)}))},Ge._extLabel(q),Boolean(G.resolveCodeAction)),ae.add(this._createDisposable(me)),ae}$provideCodeActions(q,te,G,Q,ae){return this._withAdapter(q,M,me=>me.provideCodeActions(h.URI.revive(te),G,Q,ae),void 0,void 0)}$resolveCodeAction(q,te,G){return this._withAdapter(q,M,Q=>Q.resolveCodeAction(te,G),void 0,void 0)}$releaseCodeActions(q,te){this._withAdapter(q,M,G=>Promise.resolve(G.releaseCodeActions(te)),void 0,void 0)}registerDocumentFormattingEditProvider(q,te,G){const Q=this._addNewAdapter(new T(this._documents,G),q);return this._proxy.$registerDocumentFormattingSupport(Q,this._transformDocumentSelector(te),q.identifier,q.displayName||q.name),this._createDisposable(Q)}$provideDocumentFormattingEdits(q,te,G,Q){return this._withAdapter(q,T,ae=>ae.provideDocumentFormattingEdits(h.URI.revive(te),G,Q),void 0,void 0)}registerDocumentRangeFormattingEditProvider(q,te,G){const Q=this._addNewAdapter(new O(this._documents,G),q);return this._proxy.$registerRangeFormattingSupport(Q,this._transformDocumentSelector(te),q.identifier,q.displayName||q.name),this._createDisposable(Q)}$provideDocumentRangeFormattingEdits(q,te,G,Q,ae){return this._withAdapter(q,O,me=>me.provideDocumentRangeFormattingEdits(h.URI.revive(te),G,Q,ae),void 0,void 0)}registerOnTypeFormattingEditProvider(q,te,G,Q){const ae=this._addNewAdapter(new U(this._documents,G),q);return this._proxy.$registerOnTypeFormattingSupport(ae,this._transformDocumentSelector(te),Q,q.identifier),this._createDisposable(ae)}$provideOnTypeFormattingEdits(q,te,G,Q,ae,me){return this._withAdapter(q,U,ke=>ke.provideOnTypeFormattingEdits(h.URI.revive(te),G,Q,ae,me),void 0,void 0)}registerWorkspaceSymbolProvider(q,te){const G=this._addNewAdapter(new V(te,this._logService),q);return this._proxy.$registerNavigateTypeSupport(G,typeof te.resolveWorkspaceSymbol=="function"),this._createDisposable(G)}$provideWorkspaceSymbols(q,te,G){return this._withAdapter(q,V,Q=>Q.provideWorkspaceSymbols(te,G),{symbols:[]},G)}$resolveWorkspaceSymbol(q,te,G){return this._withAdapter(q,V,Q=>Q.resolveWorkspaceSymbol(te,G),void 0,void 0)}$releaseWorkspaceSymbols(q,te){this._withAdapter(q,V,G=>G.releaseWorkspaceSymbols(te),void 0,void 0)}registerRenameProvider(q,te,G){const Q=this._addNewAdapter(new x(this._documents,G,this._logService),q);return this._proxy.$registerRenameSupport(Q,this._transformDocumentSelector(te),x.supportsResolving(G)),this._createDisposable(Q)}$provideRenameEdits(q,te,G,Q,ae){return this._withAdapter(q,x,me=>me.provideRenameEdits(h.URI.revive(te),G,Q,ae),void 0,void 0)}$resolveRenameLocation(q,te,G,Q){return this._withAdapter(q,x,ae=>ae.resolveRenameLocation(h.URI.revive(te),G,Q),void 0,void 0)}registerDocumentSemanticTokensProvider(q,te,G,Q){const ae=this._addNewAdapter(new $(this._documents,G),q),me=typeof G.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(ae,this._transformDocumentSelector(te),Q,me);let ke=this._createDisposable(ae);if(me){const We=G.onDidChangeSemanticTokens(Je=>this._proxy.$emitDocumentSemanticTokensEvent(me));ke=y.Disposable.from(ke,We)}return ke}$provideDocumentSemanticTokens(q,te,G,Q){return this._withAdapter(q,$,ae=>ae.provideDocumentSemanticTokens(h.URI.revive(te),G,Q),null,void 0)}$releaseDocumentSemanticTokens(q,te){this._withAdapter(q,$,G=>G.releaseDocumentSemanticColoring(te),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(q,te,G,Q){const ae=this._addNewAdapter(new B(this._documents,G),q);return this._proxy.$registerDocumentRangeSemanticTokensProvider(ae,this._transformDocumentSelector(te),Q),this._createDisposable(ae)}$provideDocumentRangeSemanticTokens(q,te,G,Q){return this._withAdapter(q,B,ae=>ae.provideDocumentRangeSemanticTokens(h.URI.revive(te),G,Q),null,void 0)}registerCompletionItemProvider(q,te,G,Q){const ae=this._addNewAdapter(new z(this._documents,this._commands.converter,G,this._apiDeprecation,q),q);return this._proxy.$registerSuggestSupport(ae,this._transformDocumentSelector(te),Q,z.supportsResolving(G),`${q.identifier.value}(${Q.join("")})`),this._createDisposable(ae)}$provideCompletionItems(q,te,G,Q,ae){return this._withAdapter(q,z,me=>me.provideCompletionItems(h.URI.revive(te),G,Q,ae),void 0,ae)}$resolveCompletionItem(q,te,G){return this._withAdapter(q,z,Q=>Q.resolveCompletionItem(te,G),void 0,G)}$releaseCompletionItems(q,te){this._withAdapter(q,z,G=>G.releaseCompletionItems(te),void 0,void 0)}registerInlineCompletionsProvider(q,te,G){const Q=this._addNewAdapter(new W(this._documents,G,this._commands.converter),q);return this._proxy.$registerInlineCompletionsSupport(Q,this._transformDocumentSelector(te)),this._createDisposable(Q)}$provideInlineCompletions(q,te,G,Q,ae){return this._withAdapter(q,W,me=>me.provideInlineCompletions(h.URI.revive(te),G,Q,ae),void 0,void 0)}$handleInlineCompletionDidShow(q,te,G){this._withAdapter(q,W,async Q=>{Q.handleDidShowCompletionItem(te,G)},void 0,void 0)}$freeInlineCompletionsList(q,te){this._withAdapter(q,W,async G=>{G.disposeCompletions(te)},void 0,void 0)}registerSignatureHelpProvider(q,te,G,Q){const ae=Array.isArray(Q)?{triggerCharacters:Q,retriggerCharacters:[]}:Q,me=this._addNewAdapter(new ie(this._documents,G),q);return this._proxy.$registerSignatureHelpProvider(me,this._transformDocumentSelector(te),ae),this._createDisposable(me)}$provideSignatureHelp(q,te,G,Q,ae){return this._withAdapter(q,ie,me=>me.provideSignatureHelp(h.URI.revive(te),G,Q,ae),void 0,void 0)}$releaseSignatureHelp(q,te){this._withAdapter(q,ie,G=>G.releaseSignatureHelp(te),void 0,void 0)}registerInlayHintsProvider(q,te,G){const Q=typeof G.onDidChangeInlayHints=="function"?this._nextHandle():void 0,ae=this._addNewAdapter(new ne(this._documents,this._commands.converter,G,this._logService,q),q);this._proxy.$registerInlayHintsProvider(ae,this._transformDocumentSelector(te),typeof G.resolveInlayHint=="function",Q);let me=this._createDisposable(ae);if(Q!==void 0){const ke=G.onDidChangeInlayHints(We=>this._proxy.$emitInlayHintsEvent(Q));me=y.Disposable.from(me,ke)}return me}$provideInlayHints(q,te,G,Q){return this._withAdapter(q,ne,ae=>ae.provideInlayHints(h.URI.revive(te),G,Q),void 0,Q)}$resolveInlayHint(q,te,G){return this._withAdapter(q,ne,Q=>Q.resolveInlayHint(te,G),void 0,G)}$releaseInlayHints(q,te){this._withAdapter(q,ne,G=>G.releaseHints(te),void 0,void 0)}registerDocumentLinkProvider(q,te,G){const Q=this._addNewAdapter(new J(this._documents,G),q);return this._proxy.$registerDocumentLinkProvider(Q,this._transformDocumentSelector(te),typeof G.resolveDocumentLink=="function"),this._createDisposable(Q)}$provideDocumentLinks(q,te,G){return this._withAdapter(q,J,Q=>Q.provideLinks(h.URI.revive(te),G),void 0,void 0)}$resolveDocumentLink(q,te,G){return this._withAdapter(q,J,Q=>Q.resolveLink(te,G),void 0,void 0)}$releaseDocumentLinks(q,te){this._withAdapter(q,J,G=>G.releaseLinks(te),void 0,void 0)}registerColorProvider(q,te,G){const Q=this._addNewAdapter(new K(this._documents,G),q);return this._proxy.$registerDocumentColorProvider(Q,this._transformDocumentSelector(te)),this._createDisposable(Q)}$provideDocumentColors(q,te,G){return this._withAdapter(q,K,Q=>Q.provideColors(h.URI.revive(te),G),[],void 0)}$provideColorPresentations(q,te,G,Q){return this._withAdapter(q,K,ae=>ae.provideColorPresentations(h.URI.revive(te),G,Q),void 0,void 0)}registerFoldingRangeProvider(q,te,G){const Q=this._nextHandle(),ae=typeof G.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(Q,new xe(new oe(this._documents,G),q)),this._proxy.$registerFoldingRangeProvider(Q,this._transformDocumentSelector(te),ae);let me=this._createDisposable(Q);if(ae!==void 0){const ke=G.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(ae));me=y.Disposable.from(me,ke)}return me}$provideFoldingRanges(q,te,G,Q){return this._withAdapter(q,oe,ae=>ae.provideFoldingRanges(h.URI.revive(te),G,Q),void 0,void 0)}registerSelectionRangeProvider(q,te,G){const Q=this._addNewAdapter(new fe(this._documents,G,this._logService),q);return this._proxy.$registerSelectionRangeProvider(Q,this._transformDocumentSelector(te)),this._createDisposable(Q)}$provideSelectionRanges(q,te,G,Q){return this._withAdapter(q,fe,ae=>ae.provideSelectionRanges(h.URI.revive(te),G,Q),[],Q)}registerCallHierarchyProvider(q,te,G){const Q=this._addNewAdapter(new pe(this._documents,G),q);return this._proxy.$registerCallHierarchyProvider(Q,this._transformDocumentSelector(te)),this._createDisposable(Q)}$prepareCallHierarchy(q,te,G,Q){return this._withAdapter(q,pe,ae=>Promise.resolve(ae.prepareSession(h.URI.revive(te),G,Q)),void 0,Q)}$provideCallHierarchyIncomingCalls(q,te,G,Q){return this._withAdapter(q,pe,ae=>ae.provideCallsTo(te,G,Q),void 0,Q)}$provideCallHierarchyOutgoingCalls(q,te,G,Q){return this._withAdapter(q,pe,ae=>ae.provideCallsFrom(te,G,Q),void 0,Q)}$releaseCallHierarchy(q,te){this._withAdapter(q,pe,G=>Promise.resolve(G.releaseSession(te)),void 0,void 0)}registerTypeHierarchyProvider(q,te,G){const Q=this._addNewAdapter(new Te(this._documents,G),q);return this._proxy.$registerTypeHierarchyProvider(Q,this._transformDocumentSelector(te)),this._createDisposable(Q)}$prepareTypeHierarchy(q,te,G,Q){return this._withAdapter(q,Te,ae=>Promise.resolve(ae.prepareSession(h.URI.revive(te),G,Q)),void 0,Q)}$provideTypeHierarchySupertypes(q,te,G,Q){return this._withAdapter(q,Te,ae=>ae.provideSupertypes(te,G,Q),void 0,Q)}$provideTypeHierarchySubtypes(q,te,G,Q){return this._withAdapter(q,Te,ae=>ae.provideSubtypes(te,G,Q),void 0,Q)}$releaseTypeHierarchy(q,te){this._withAdapter(q,Te,G=>Promise.resolve(G.releaseSession(te)),void 0,void 0)}static _serializeRegExp(q){return{pattern:q.source,flags:(0,k.regExpFlags)(q)}}static _serializeIndentationRule(q){return{decreaseIndentPattern:Ge._serializeRegExp(q.decreaseIndentPattern),increaseIndentPattern:Ge._serializeRegExp(q.increaseIndentPattern),indentNextLinePattern:q.indentNextLinePattern?Ge._serializeRegExp(q.indentNextLinePattern):void 0,unIndentedLinePattern:q.unIndentedLinePattern?Ge._serializeRegExp(q.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(q){return{beforeText:Ge._serializeRegExp(q.beforeText),afterText:q.afterText?Ge._serializeRegExp(q.afterText):void 0,previousLineText:q.previousLineText?Ge._serializeRegExp(q.previousLineText):void 0,action:q.action}}static _serializeOnEnterRules(q){return q.map(Ge._serializeOnEnterRule)}setLanguageConfiguration(q,te,G){let{wordPattern:Q}=G;if(Q&&(0,k.regExpLeadsToEndlessLoop)(Q))throw new Error(`Invalid language configuration: wordPattern '${Q}' is not allowed to match the empty string.`);Q?this._documents.setWordDefinitionFor(te,Q):this._documents.setWordDefinitionFor(te,void 0),G.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",q,"Do not use."),G.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",q,"Do not use.");const ae=this._nextHandle(),me={comments:G.comments,brackets:G.brackets,wordPattern:G.wordPattern?Ge._serializeRegExp(G.wordPattern):void 0,indentationRules:G.indentationRules?Ge._serializeIndentationRule(G.indentationRules):void 0,onEnterRules:G.onEnterRules?Ge._serializeOnEnterRules(G.onEnterRules):void 0,__electricCharacterSupport:G.__electricCharacterSupport,__characterPairSupport:G.__characterPairSupport};return this._proxy.$setLanguageConfiguration(ae,te,me),this._createDisposable(ae)}$setWordDefinitions(q){for(const te of q)this._documents.setWordDefinitionFor(te.languageId,new RegExp(te.regexSource,te.regexFlags))}}e.ExtHostLanguageFeatures=Ge,Ge._handlePool=0}),define(ve[241],we([0,1,5,15,7,47,13,6]),function(Z,e,h,t,I,y,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class D{constructor(L,C,l,E){this._documents=C,this._commands=l,this._uriTransformer=E,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=L.getProxy(h.MainContext.MainThreadLanguages)}$acceptLanguageIds(L){this._languageIds=L}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(L,C){await this._proxy.$changeLanguage(L,C);const l=this._documents.getDocumentData(L);if(!l)throw new Error(`document '${L.toString}' NOT found`);return l.document}async tokenAtPosition(L,C){const l=L.version,E=t.Position.from(C),p=await this._proxy.$tokensAtPosition(L.uri,E),m={type:I.StandardTokenType.Other,range:L.getWordRangeAtPosition(C)??new I.Range(C.line,C.character,C.line,C.character)};if(!p)return m;const b={range:t.Range.to(p.range),type:t.TokenType.to(p.type)};return!b.range.contains(C)||l!==L.version?m:b}createLanguageStatusItem(L,C,l){const E=this._handlePool++,p=this._proxy,m=this._ids,b=`${L.identifier.value}/${C}`;if(m.has(b))throw new Error(`LanguageStatusItem with id '${C}' ALREADY exists`);m.add(b);const F={selector:l,id:C,name:L.displayName??L.name,severity:I.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let _,g=new k.DisposableStore;const s=()=>{_?.dispose(),_=(0,R.disposableTimeout)(()=>{g.clear(),this._proxy.$setLanguageStatus(E,{id:b,name:F.name??L.displayName??L.name,source:L.displayName??L.name,selector:t.DocumentSelector.from(F.selector,this._uriTransformer),label:F.text,detail:F.detail??"",severity:F.severity===I.LanguageStatusSeverity.Error?y.default.Error:F.severity===I.LanguageStatusSeverity.Warning?y.default.Warning:y.default.Info,command:F.command&&this._commands.toInternal(F.command,g),accessibilityInfo:F.accessibilityInformation,busy:F.busy})},0)},d={dispose(){g.dispose(),_?.dispose(),p.$removeLanguageStatus(E),m.delete(b)},get id(){return F.id},get name(){return F.name},set name(n){F.name=n,s()},get selector(){return F.selector},set selector(n){F.selector=n,s()},get text(){return F.text},set text(n){F.text=n,s()},get detail(){return F.detail},set detail(n){F.detail=n,s()},get severity(){return F.severity},set severity(n){F.severity=n,s()},get accessibilityInformation(){return F.accessibilityInformation},set accessibilityInformation(n){F.accessibilityInformation=n,s()},get command(){return F.command},set command(n){F.command=n,s()},get busy(){return F.busy},set busy(n){F.busy=n,s()}};return s(),d}}e.ExtHostLanguages=D}),define(ve[133],we([0,1,12,5,26,14,3]),function(Z,e,h,t,I,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let k=class extends h.AbstractLoggerService{constructor(L,C){const l=new R.Emitter;super(C.logLevel,l.event);this._proxy=L.getProxy(t.MainContext.MainThreadLogger),this._onDidChangeLogLevel=this._register(l)}$setLevel(L){this._onDidChangeLogLevel.fire(L)}doCreateLogger(L,C,l){return new D(this._proxy,L,C,l)}};k=je([ze(0,y.IExtHostRpcService),ze(1,I.IExtHostInitDataService)],k),e.ExtHostLoggerService=k;class D extends h.AbstractMessageLogger{constructor(L,C,l,E){super(E?.always);this.proxy=L,this.file=C,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(l),this.proxy.$createLogger(C,E).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(L,C){const l=[[L,C]];this.isLoggerCreated?this.doLog(l):this.buffer.push(...l)}doLog(L){this.proxy.$log(this.file,L)}}}),define(ve[242],we([0,1,5,12,28]),function(Z,e,h,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function y(k){return k&&k.title}let R=class{constructor(D,P){this._logService=P,this._proxy=D.getProxy(h.MainContext.MainThreadMessageService)}showMessage(D,P,L,C,l){const E={source:{identifier:D.identifier,label:D.displayName||D.name}};let p;typeof C=="string"||y(C)?p=[C,...l]:(E.modal=C?.modal,E.useCustom=C?.useCustom,E.detail=C?.detail,p=l),E.useCustom&&(0,I.checkProposedApiEnabled)(D,"resolvers");const m=[];for(let b=0;b<p.length;b++){const F=p[b];if(typeof F=="string")m.push({title:F,handle:b,isCloseAffordance:!1});else if(typeof F=="object"){let{title:_,isCloseAffordance:g}=F;m.push({title:_,isCloseAffordance:!!g,handle:b})}else this._logService.warn("Invalid message item:",F)}return this._proxy.$showMessage(P,L,E,m).then(b=>{if(typeof b=="number")return p[b]})}};R=je([ze(1,t.ILogService)],R),e.ExtHostMessageService=R}),define(ve[243],we([0,1,22,3,58,6,24,8,18,2,86,5,15,7,52,218,130]),function(Z,e,h,t,I,y,R,k,D,P,L,C,l,E,p,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class F{constructor(g,s,d,n,S){this._textDocumentsAndEditors=d,this._textDocuments=n,this._extensionStoragePaths=S,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new R.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new t.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new t.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new t.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new t.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new t.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new t.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new t.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new L.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=g.getProxy(C.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=g.getProxy(C.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=g.getProxy(C.MainContext.MainThreadNotebookEditors),this._commandsConverter=s.converter,s.registerArgumentProcessor({processArgument:o=>{if(o&&o.$mid===12){const i=o.notebookEditor?.notebookUri,r=o.cell.handle,a=this._documents.get(i)?.getCell(r);if(a)return a.apiCell}return o}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(g=>g.apiEditor)}getEditorById(g){const s=this._editors.get(g);if(!s)throw new Error(`unknown text editor: ${g}. known editors: ${[...this._editors.keys()]} `);return s}getIdByEditor(g){for(const[s,d]of this._editors)if(d.apiEditor===g)return s}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(g,s){const d=this._documents.get(g);if(!d&&!s)throw new Error(`NO notebook document for '${g}'`);return d}_getProviderData(g){const s=this._notebookContentProviders.get(g);if(!s)throw new Error(`NO provider for '${g}'`);return s}registerNotebookContentProvider(g,s,d,n,S){if((0,k.isFalsyOrWhitespace)(s))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(s))throw new Error(`Notebook provider for '${s}' already registered`);this._notebookContentProviders.set(s,{extension:g,provider:d});let o;return d.onDidChangeNotebookContentOptions&&(o=d.onDidChangeNotebookContentOptions(()=>{const i=l.NotebookDocumentContentOptions.from(d.options);this._notebookProxy.$updateNotebookProviderOptions(s,i)})),this._notebookProxy.$registerNotebookProvider({id:g.identifier,location:g.extensionLocation},s,l.NotebookDocumentContentOptions.from(n),F._convertNotebookRegistrationData(g,S)),new E.Disposable(()=>{o?.dispose(),this._notebookContentProviders.delete(s),this._notebookProxy.$unregisterNotebookProvider(s)})}static _convertNotebookRegistrationData(g,s){if(!s)return;const d=s.filenamePattern.map(n=>l.NotebookExclusiveDocumentPattern.from(n)).filter(n=>n!==void 0);if(s.filenamePattern&&!d){console.warn(`Notebook content provider view options file name pattern is invalid ${s.filenamePattern}`);return}return{extension:g.identifier,providerDisplayName:g.displayName||g.name,displayName:s.displayName,filenamePattern:d,exclusive:s.exclusive||!1}}registerNotebookCellStatusBarItemProvider(g,s,d){const n=F._notebookStatusBarItemProviderHandlePool++,S=typeof d.onDidChangeCellStatusBarItems=="function"?F._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(n,d),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(n,S,s);let o;return S!==void 0&&(o=d.onDidChangeCellStatusBarItems(i=>this._notebookProxy.$emitCellStatusBarEvent(S))),new E.Disposable(()=>{this._notebookStatusBarItemProviders.delete(n),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(n,S),o&&o.dispose()})}async createNotebookDocument(g){const s=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:g.viewType,content:g.content&&l.NotebookData.from(g.content)});return P.URI.revive(s)}async openNotebookDocument(g){const s=this._documents.get(g);if(s)return s.apiNotebook;const d=await this._notebookDocumentsProxy.$tryOpenNotebook(g),n=this._documents.get(P.URI.revive(d));return(0,D.assertIsDefined)(n?.apiNotebook)}async showNotebookDocument(g,s){P.URI.isUri(g)&&(g=await this.openNotebookDocument(g));let d;typeof s=="object"?d={position:l.ViewColumn.from(s.viewColumn),preserveFocus:s.preserveFocus,selections:s.selections&&s.selections.map(l.NotebookRange.from),pinned:typeof s.preview=="boolean"?!s.preview:void 0}:d={preserveFocus:!1};const n=await this._notebookEditorsProxy.$tryShowNotebookDocument(g.uri,g.notebookType,d),S=n&&this._editors.get(n)?.apiEditor;if(S)return S;throw n?new Error(`Could NOT open editor for "${g.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${g.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(g,s,d,n){const S=this._notebookStatusBarItemProviders.get(g),o=P.URI.revive(s),i=this._documents.get(o);if(!i||!S)return;const r=i.getCellFromIndex(d);if(!r)return;const c=await S.provideCellStatusBarItems(r.apiCell,n);if(!c)return;const a=new y.DisposableStore,u=this._statusBarCache.add([a]),v=(Array.isArray(c)?c:[c]).map(w=>l.NotebookStatusBarItem.from(w,this._commandsConverter,a));return{cacheId:u,items:v}}$releaseNotebookCellStatusBarItems(g){this._statusBarCache.delete(g)}registerNotebookSerializer(g,s,d,n,S){if((0,k.isFalsyOrWhitespace)(s))throw new Error("viewType cannot be empty or just whitespace");const o=this._handlePool++;return this._notebookSerializer.set(o,d),this._notebookProxy.$registerNotebookSerializer(o,{id:g.identifier,location:g.extensionLocation},s,l.NotebookDocumentContentOptions.from(n),F._convertNotebookRegistrationData(g,S)),(0,y.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(o)})}async $dataToNotebook(g,s,d){const n=this._notebookSerializer.get(g);if(!n)throw new Error("NO serializer found");const S=await n.deserializeNotebook(s.buffer,d);return new p.SerializableObjectWithBuffers(l.NotebookData.from(S))}async $notebookToData(g,s,d){const n=this._notebookSerializer.get(g);if(!n)throw new Error("NO serializer found");const S=await n.serializeNotebook(l.NotebookData.to(s.value),d);return h.VSBuffer.wrap(S)}async $openNotebook(g,s,d,n,S){const{provider:o}=this._getProviderData(g),i=await o.openNotebook(P.URI.revive(s),{backupId:d,untitledDocumentData:n?.buffer},S);return new p.SerializableObjectWithBuffers({metadata:i.metadata??Object.create(null),cells:i.cells.map(l.NotebookCellData.from)})}async $saveNotebook(g,s,d){const n=this.getNotebookDocument(P.URI.revive(s)),{provider:S}=this._getProviderData(g);return await S.saveNotebook(n.apiNotebook,d),!0}async $saveNotebookAs(g,s,d,n){const S=this.getNotebookDocument(P.URI.revive(s)),{provider:o}=this._getProviderData(g);return await o.saveNotebookAs(P.URI.revive(d),S.apiNotebook,n),!0}async $backupNotebook(g,s,d){const n=this.getNotebookDocument(P.URI.revive(s)),S=this._getProviderData(g),o=this._extensionStoragePaths.workspaceValue(S.extension)??this._extensionStoragePaths.globalValue(S.extension),i=String((0,I.hash)([n.uri.toString(),this._backupIdPool++])),r=P.URI.joinPath(o,i),c=await S.provider.backupNotebook(n.apiNotebook,{destination:r},d);return n.updateBackup(c),c.id}_createExtHostEditor(g,s,d){if(this._editors.has(s))throw new Error(`editor with id ALREADY EXSIST: ${s}`);const n=new b.ExtHostNotebookEditor(s,this._notebookEditorsProxy,g,d.visibleRanges.map(l.NotebookRange.to),d.selections.map(l.NotebookRange.to),typeof d.viewColumn=="number"?l.ViewColumn.to(d.viewColumn):void 0);this._editors.set(s,n)}$acceptDocumentAndEditorsDelta(g){if(g.value.removedDocuments)for(const d of g.value.removedDocuments){const n=P.URI.revive(d),S=this._documents.get(n);S&&(S.dispose(),this._documents.delete(n),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:S.apiNotebook.getCells().map(o=>o.document.uri)}),this._onDidCloseNotebookDocument.fire(S.apiNotebook));for(const o of this._editors.values())o.notebookData.uri.toString()===n.toString()&&this._editors.delete(o.id)}if(g.value.addedDocuments){const d=[];for(const n of g.value.addedDocuments){const S=P.URI.revive(n.uri);if(this._documents.has(S))throw new Error(`adding EXISTING notebook ${S} `);const o=this,i=new m.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(r){o._onDidChangeNotebookCells.fire(r)},emitCellOutputsChange(r){o._onDidChangeCellOutputs.fire(r)},emitCellMetadataChange(r){o._onDidChangeCellMetadata.fire(r)}},S,n);d.push(...n.cells.map(r=>m.ExtHostCell.asModelAddData(i.apiNotebook,r))),this._documents.get(S)?.dispose(),this._documents.set(S,i),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:d}),this._onDidOpenNotebookDocument.fire(i.apiNotebook)}}if(g.value.addedEditors)for(const d of g.value.addedEditors){if(this._editors.has(d.id))return;const n=P.URI.revive(d.documentUri),S=this._documents.get(n);S&&this._createExtHostEditor(S,d.id,d)}const s=[];if(g.value.removedEditors)for(const d of g.value.removedEditors){const n=this._editors.get(d);n&&(this._editors.delete(d),this._activeNotebookEditor?.id===n.id&&(this._activeNotebookEditor=void 0),s.push(n))}if(g.value.visibleEditors){this._visibleNotebookEditors=g.value.visibleEditors.map(n=>this._editors.get(n)).filter(n=>!!n);const d=new Set;this._visibleNotebookEditors.forEach(n=>d.add(n.id));for(const n of this._editors.values()){const S=d.has(n.id);n._acceptVisibility(S)}this._visibleNotebookEditors=[...this._editors.values()].map(n=>n).filter(n=>n.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}g.value.newActiveEditor===null?this._activeNotebookEditor=void 0:g.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(g.value.newActiveEditor)),g.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=F,F._notebookStatusBarItemProviderHandlePool=0}),define(ve[244],we([0,1,3,77,12,5,14,15]),function(Z,e,h,t,I,y,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class D{constructor(C,l){const E=D._Keys.nextId();C.$registerNotebookEditorDecorationType(E,k.NotebookDecorationRenderOptions.from(l)),this.value={key:E,dispose(){C.$removeNotebookEditorDecorationType(E)}}}}D._Keys=new t.IdGenerator("NotebookEditorDecorationType");let P=class{constructor(C,l,E){this._logService=C,this._extHostRpc=l,this._notebooksAndEditors=E,this._onDidChangeNotebookEditorSelection=new h.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new h.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(C){return new D(this._extHostRpc.getProxy(y.MainContext.MainThreadNotebookEditors),C).value}$acceptEditorPropertiesChanged(C,l){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",C,l);const E=this._notebooksAndEditors.getEditorById(C);l.visibleRanges&&E._acceptVisibleRanges(l.visibleRanges.ranges.map(k.NotebookRange.to)),l.selections&&E._acceptSelections(l.selections.selections.map(k.NotebookRange.to)),l.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:E.apiEditor,visibleRanges:E.apiEditor.visibleRanges}),l.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:E.apiEditor,selections:E.apiEditor.selections}))}$acceptEditorViewColumns(C){for(const l in C)this._notebooksAndEditors.getEditorById(l)._acceptViewColumn(k.ViewColumn.to(C[l]))}};P=je([ze(0,I.ILogService),ze(1,R.IExtHostRpcService)],P),e.ExtHostNotebookEditors=P}),define(ve[245],we([0,1,17,13,21,3,6,24,2,27,12,5,38,15,7,87,211,28,52]),function(Z,e,h,t,I,y,R,k,D,P,L,C,l,E,p,m,b,F,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let g=class{constructor(i,r,c,a,u){this._initData=r,this._extHostNotebook=c,this._commands=a,this._logService=u,this._activeExecutions=new k.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new y.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._proxy=i.getProxy(C.MainContext.MainThreadNotebookKernels);const f=new l.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new l.ApiCommandArgument("options","Select kernel options",v=>!0,v=>{if(v&&"notebookEditor"in v&&"id"in v){const w=this._extHostNotebook.getIdByEditor(v.notebookEditor);return{id:v.id,extension:v.extension,notebookEditorId:w}}else if(v&&"notebookEditor"in v){const w=this._extHostNotebook.getIdByEditor(v.notebookEditor);if(w===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${v.notebookEditor.document.uri.toString()}`);return{notebookEditorId:w}}return v})],l.ApiCommandResult.Void);this._commands.registerApiCommand(f)}createNotebookController(i,r,c,a,u,f){for(const Y of this._kernelData.values())if(Y.controller.id===r&&P.ExtensionIdentifier.equals(i.identifier,Y.extensionId))throw new Error(`notebook controller with id '${r}' ALREADY exist`);const v=this._handlePool++,w=this;this._logService.trace(`NotebookController[${v}], CREATED by ${i.identifier.value}, ${r}`);const A=()=>console.warn(`NO execute handler from notebook controller '${V.id}' of extension: '${i.identifier}'`);let M=!1;const T=new R.DisposableStore,O=new y.Emitter,U=new y.Emitter,V={id:S(i,r),notebookType:c,extensionId:i.identifier,extensionLocation:i.extensionLocation,label:a||i.identifier.value,preloads:f?f.map(E.NotebookRendererScript.from):[]};let x=u??A,N;this._proxy.$addKernel(v,V).catch(Y=>{console.log(Y),M=!0});let $=0;const B=()=>{if(M)return;const Y=++$;Promise.resolve().then(()=>{Y===$&&this._proxy.$updateKernel(v,V)})},z=new k.ResourceMap,W={get id(){return r},get notebookType(){return V.notebookType},onDidChangeSelectedNotebooks:O.event,get label(){return V.label},set label(Y){V.label=Y??i.displayName??i.name,B()},get detail(){return V.detail??""},set detail(Y){V.detail=Y,B()},get description(){return V.description??""},set description(Y){V.description=Y,B()},get kind(){return(0,F.checkProposedApiEnabled)(i,"notebookControllerKind"),V.kind??""},set kind(Y){(0,F.checkProposedApiEnabled)(i,"notebookControllerKind"),V.kind=Y,B()},get supportedLanguages(){return V.supportedLanguages},set supportedLanguages(Y){V.supportedLanguages=Y,B()},get supportsExecutionOrder(){return V.supportsExecutionOrder??!1},set supportsExecutionOrder(Y){V.supportsExecutionOrder=Y,B()},get rendererScripts(){return V.preloads?V.preloads.map(E.NotebookRendererScript.to):[]},get executeHandler(){return x},set executeHandler(Y){x=Y??A},get interruptHandler(){return N},set interruptHandler(Y){N=Y,V.supportsInterrupt=Boolean(Y),B()},createNotebookCellExecution(Y){if(M)throw new Error("notebook controller is DISPOSED");if(!z.has(Y.notebook.uri))throw w._logService.trace(`NotebookController[${v}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(z.keys()).map(ie=>ie.toString())),new Error(`notebook controller is NOT associated to notebook: ${Y.notebook.uri.toString()}`);return w._createNotebookCellExecution(Y,S(i,this.id))},dispose:()=>{M||(this._logService.trace(`NotebookController[${v}], DISPOSED`),M=!0,this._kernelData.delete(v),T.dispose(),O.dispose(),U.dispose(),this._proxy.$removeKernel(v))},updateNotebookAffinity(Y,ie){w._proxy.$updateNotebookPriority(v,Y.uri,ie)},onDidReceiveMessage:U.event,postMessage(Y,ie){return(0,F.checkProposedApiEnabled)(i,"notebookMessaging"),w._proxy.$postMessage(v,ie&&w._extHostNotebook.getIdByEditor(ie),Y)},asWebviewUri(Y){return(0,F.checkProposedApiEnabled)(i,"notebookMessaging"),(0,m.asWebviewUri)(Y,w._initData.remote)}};return this._kernelData.set(v,{extensionId:i.identifier,controller:W,onDidReceiveMessage:U,onDidChangeSelection:O,associatedNotebooks:z}),W}$acceptNotebookAssociation(i,r,c){const a=this._kernelData.get(i);if(a){const u=this._extHostNotebook.getNotebookDocument(D.URI.revive(r));c?a.associatedNotebooks.set(u.uri,!0):a.associatedNotebooks.delete(u.uri),this._logService.trace(`NotebookController[${i}] ASSOCIATE notebook`,u.uri.toString(),c),a.onDidChangeSelection.fire({selected:c,notebook:u.apiNotebook})}}async $executeCells(i,r,c){const a=this._kernelData.get(i);if(!a)return;const u=this._extHostNotebook.getNotebookDocument(D.URI.revive(r)),f=[];for(const v of c){const w=u.getCell(v);w&&f.push(w.apiCell)}try{this._logService.trace(`NotebookController[${i}] EXECUTE cells`,u.uri.toString(),f.length),await a.controller.executeHandler.call(a.controller,f,u.apiNotebook,a.controller)}catch(v){this._logService.error(`NotebookController[${i}] execute cells FAILED`,v),console.error(v)}}async $cancelCells(i,r,c){const a=this._kernelData.get(i);if(!a)return;const u=this._extHostNotebook.getNotebookDocument(D.URI.revive(r));if(a.controller.interruptHandler)await a.controller.interruptHandler.call(a.controller,u.apiNotebook);else for(const f of c){const v=u.getCell(f);v&&this._activeExecutions.get(v.uri)?.cancel()}}$acceptKernelMessageFromRenderer(i,r,c){const a=this._kernelData.get(i);if(!a)return;const u=this._extHostNotebook.getEditorById(r);a.onDidReceiveMessage.fire(Object.freeze({editor:u.apiEditor,message:c}))}$cellExecutionChanged(i,r,c){const u=this._extHostNotebook.getNotebookDocument(D.URI.revive(i)).getCell(r);u&&this._onDidChangeCellExecutionState.fire({cell:u.apiCell,state:c??p.NotebookCellExecutionState.Idle})}_createNotebookCellExecution(i,r){if(i.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const a=this._extHostNotebook.getNotebookDocument(i.notebook.uri).getCellFromApiCell(i);if(!a)throw new Error("invalid cell");if(this._activeExecutions.has(a.uri))throw new Error(`duplicate execution for ${a.uri}`);const u=new d(r,a,this._proxy);this._activeExecutions.set(a.uri,u);const f=u.onDidChangeState(()=>{u.state===s.Resolved&&(u.dispose(),f.dispose(),this._activeExecutions.delete(a.uri))});return u.asApiObject()}};g=je([ze(4,L.ILogService)],g),e.ExtHostNotebookKernels=g;var s;(function(o){o[o.Init=0]="Init",o[o.Started=1]="Started",o[o.Resolved=2]="Resolved"})(s||(s={}));class d extends R.Disposable{constructor(i,r,c){super();this._cell=r,this._proxy=c,this._handle=d.HANDLE++,this._onDidChangeState=new y.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=s.Init,this._tokenSource=this._register(new I.CancellationTokenSource),this._collector=new n(10,a=>this.update(a)),this._executionOrder=r.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,i,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(i){await this._collector.addItem(i)}async update(i){const r=Array.isArray(i)?i:[i];return this._proxy.$updateExecution(this._handle,new _.SerializableObjectWithBuffers(r))}verifyStateForOutput(){if(this._state===s.Init)throw new Error("Must call start before modifying cell output");if(this._state===s.Resolved)throw new Error("Cannot modify cell output after calling resolve")}validateAndConvertOutputs(i){return i.map(r=>{const c=p.NotebookCellOutput.ensureUniqueMimeTypes(r.items,!0);return c===r.items?E.NotebookCellOutput.from(r):E.NotebookCellOutput.from({items:c,id:r.id,metadata:r.metadata})})}async updateOutputs(i,r,c){const a=this.validateAndConvertOutputs((0,h.asArray)(i));return this.updateSoon({editType:b.CellExecutionUpdateType.Output,append:c,outputs:a})}async updateOutputItems(i,r,c){return i=p.NotebookCellOutput.ensureUniqueMimeTypes((0,h.asArray)(i),!0),this.updateSoon({editType:b.CellExecutionUpdateType.OutputItems,items:i.map(E.NotebookCellOutputItem.from),outputId:r.id,append:c})}asApiObject(){const i=this;return Object.freeze({get token(){return i._tokenSource.token},get cell(){return i._cell.apiCell},get executionOrder(){return i._executionOrder},set executionOrder(c){i._executionOrder=c,i.update([{editType:b.CellExecutionUpdateType.ExecutionState,executionOrder:i._executionOrder}])},start(c){if(i._state===s.Resolved||i._state===s.Started)throw new Error("Cannot call start again");i._state=s.Started,i._onDidChangeState.fire(),i.update({editType:b.CellExecutionUpdateType.ExecutionState,runStartTime:c})},end(c,a){if(i._state===s.Resolved)throw new Error("Cannot call resolve twice");i._state=s.Resolved,i._onDidChangeState.fire(),i._collector.flush(),i._proxy.$completeExecution(i._handle,new _.SerializableObjectWithBuffers({runEndTime:a,lastRunSuccess:c}))},clearOutput(c){return i.verifyStateForOutput(),i.updateOutputs([],c,!1)},appendOutput(c,a){return i.verifyStateForOutput(),i.updateOutputs(c,a,!0)},replaceOutput(c,a){return i.verifyStateForOutput(),i.updateOutputs(c,a,!1)},appendOutputItems(c,a){return i.verifyStateForOutput(),i.updateOutputItems(c,a,!0)},replaceOutputItems(c,a){return i.verifyStateForOutput(),i.updateOutputItems(c,a,!1)}})}}d.HANDLE=0;class n{constructor(i,r){this.delay=i,this.callback=r,this.batch=[],this.startedTimer=Date.now()}addItem(i){return this.batch.push(i),this.currentDeferred||(this.currentDeferred=new t.DeferredPromise,this.startedTimer=Date.now(),(0,t.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const i=this.currentDeferred;this.currentDeferred=void 0;const r=this.batch;return this.batch=[],this.callback(r).finally(()=>i.complete())}}function S(o,i){return`${o.identifier.value}/${i}`}}),define(ve[246],we([0,1,3,5,130,28]),function(Z,e,h,t,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class R{constructor(D,P){this._extHostNotebook=P,this._rendererMessageEmitters=new Map,this.proxy=D.getProxy(t.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(D,P,L){const C=this._extHostNotebook.getEditorById(D);this._rendererMessageEmitters.get(P)?.fire({editor:C.apiEditor,message:L})}createRendererMessaging(D,P){if(!D.contributes?.notebookRenderer?.some(E=>E.id===P))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${P})`);const L=(0,y.isProposedApiEnabled)(D,"notebookEditor"),C=new WeakMap;return{onDidReceiveMessage:(E,p,m)=>{const b=L?E:F=>{const _={};C.set(_,F.editor),E({editor:_,message:F.message})};return this.getOrCreateEmitterFor(P).event(b,p,m)},postMessage:(E,p)=>{I.ExtHostNotebookEditor.apiEditorsToExtHost.has(E)&&([E,p]=[p,E]);const m=L?p:C.get(p),b=m&&I.ExtHostNotebookEditor.apiEditorsToExtHost.get(m);return this.proxy.$postMessage(b?.id,P,E)}}}getOrCreateEmitterFor(D){let P=this._rendererMessageEmitters.get(D);return P||(P=new h.Emitter({onLastListenerRemove:()=>{P?.dispose(),this._rendererMessageEmitters.delete(D)}}),this._rendererMessageEmitters.set(D,P),P)}}e.ExtHostNotebookRenderers=R}),define(ve[134],we([0,1,5,6,4,14,12,212,67,26,44,153,22]),function(Z,e,h,t,I,y,R,k,D,P,L,C,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.ExtHostOutputChannel=void 0;class E extends t.Disposable{constructor(b,F,_,g){super();this.id=b,this.name=F,this.logger=_,this.proxy=g,this.offset=0,this.visible=!1,this._disposed=!1}get disposed(){return this._disposed}appendLine(b){this.append(b+`
`)}append(b){this.write(b),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,k.OutputChannelUpdateMode.Append))}clear(){const b=this.offset;this.logger.flush(),this.proxy.$update(this.id,k.OutputChannelUpdateMode.Clear,b)}replace(b){const F=this.offset;this.write(b),this.proxy.$update(this.id,k.OutputChannelUpdateMode.Replace,F),this.visible&&this.logger.flush()}show(b,F){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof b=="boolean"?b:F))}hide(){this.proxy.$close(this.id)}write(b){this.offset+=l.VSBuffer.fromString(b).byteLength,this.logger.info(b)}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}e.ExtHostOutputChannel=E;let p=class{constructor(b,F,_,g,s){this.extHostFileSystem=_,this.extHostFileSystemInfo=g,this.loggerService=s,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=b.getProxy(h.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(F.logsLocation,`output_logging_${(0,C.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(b){this.visibleChannelId=b;for(const[F,_]of this.channels)_.visible=F===this.visibleChannelId}createOutputChannel(b,F){if(b=b.trim(),!b)throw new Error("illegal argument `name`. must not be falsy");const _=this.doCreateOutputChannel(b,F);return _.then(g=>{this.channels.set(g.id,g),g.visible=g.id===this.visibleChannelId}),this.createExtHostOutputChannel(b,_)}async doCreateOutputChannel(b,F){const _=await this.createOutputDirectory(),g=this.extHostFileSystemInfo.extUri.joinPath(_,`${this.namePool++}-${b.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),s=this.loggerService.createLogger(g,{always:!0,donotRotate:!0,donotUseFormatters:!0}),d=await this.proxy.$register(b,!1,g,F.identifier.value);return new E(d,b,s,this.proxy)}createOutputDirectory(){return this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation)),this.outputDirectoryPromise}createExtHostOutputChannel(b,F){let _=!1;const g=()=>{if(_)throw new Error("Channel has been closed")};return{get name(){return b},append(s){g(),F.then(d=>d.append(s))},appendLine(s){g(),F.then(d=>d.appendLine(s))},clear(){g(),F.then(s=>s.clear())},replace(s){g(),F.then(d=>d.replace(s))},show(s,d){g(),F.then(n=>n.show(s,d))},hide(){g(),F.then(s=>s.hide())},dispose(){_=!0,F.then(s=>s.dispose())}}}};p=je([ze(0,y.IExtHostRpcService),ze(1,P.IExtHostInitDataService),ze(2,D.IExtHostConsumerFileSystem),ze(3,L.IExtHostFileSystemInfo),ze(4,R.ILoggerService)],p),e.ExtHostOutputService=p,e.IExtHostOutputService=(0,I.createDecorator)("IExtHostOutputService")}),define(ve[247],we([0,1,13,21,3,6,5,2,7,16,17,47,85,28]),function(Z,e,h,t,I,y,R,k,D,P,L,C,l,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function p(m,b,F){const _=m.getProxy(R.MainContext.MainThreadQuickOpen);class g{constructor(a,u){this._sessions=new Map,this._instances=0,this._workspace=a,this._commands=u}showQuickPick(a,u,f=t.CancellationToken.None){this._onDidSelectItem=void 0;const v=Promise.resolve(a),w=++this._instances,A=_.$show(w,{title:u?.title,placeHolder:u?.placeHolder,matchOnDescription:u?.matchOnDescription,matchOnDetail:u?.matchOnDetail,ignoreFocusLost:u?.ignoreFocusOut,canPickMany:u?.canPickMany},f),M={},T=A.then(()=>M);return Promise.race([T,v]).then(O=>{if(O!==M)return v.then(U=>{const V=[];for(let x=0;x<U.length;x++){const N=U[x];typeof N=="string"?V.push({label:N,handle:x}):N.kind===D.QuickPickItemKind.Separator?V.push({type:"separator",label:N.label}):V.push({label:N.label,description:N.description,detail:N.detail,picked:N.picked,alwaysShow:N.alwaysShow,handle:x})}return u&&typeof u.onDidSelectItem=="function"&&(this._onDidSelectItem=x=>{u.onDidSelectItem(U[x])}),_.$setItems(w,V),A.then(x=>{if(typeof x=="number")return U[x];if(Array.isArray(x))return x.map(N=>U[N])})})}).then(void 0,O=>{if(!(0,P.isCancellationError)(O))return _.$setError(w,O),Promise.reject(O)})}$onItemSelected(a){this._onDidSelectItem&&this._onDidSelectItem(a)}showInput(a,u=t.CancellationToken.None){return this._validateInput=a?a.validateInput:void 0,_.$input(a,typeof this._validateInput=="function",u).then(void 0,f=>{if(!(0,P.isCancellationError)(f))return Promise.reject(f)})}$validateInput(a){return this._validateInput?(0,h.asPromise)(()=>this._validateInput(a)):Promise.resolve(void 0)}async showWorkspaceFolderPick(a,u=t.CancellationToken.None){const f=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[a]);if(!f)return;const v=await this._workspace.getWorkspaceFolders2();if(!!v)return v.find(w=>w.uri.toString()===f.uri.toString())}createQuickPick(a){const u=new i(a,()=>this._sessions.delete(u._id));return this._sessions.set(u._id,u),u}createInputBox(a){const u=new r(a,()=>this._sessions.delete(u._id));return this._sessions.set(u._id,u),u}$onDidChangeValue(a,u){const f=this._sessions.get(a);f&&f._fireDidChangeValue(u)}$onDidAccept(a){const u=this._sessions.get(a);u&&u._fireDidAccept()}$onDidChangeActive(a,u){const f=this._sessions.get(a);f instanceof i&&f._fireDidChangeActive(u)}$onDidChangeSelection(a,u){const f=this._sessions.get(a);f instanceof i&&f._fireDidChangeSelection(u)}$onDidTriggerButton(a,u){const f=this._sessions.get(a);f&&f._fireDidTriggerButton(u)}$onDidTriggerItemButton(a,u,f){const v=this._sessions.get(a);v instanceof i&&v._fireDidTriggerItemButton(u,f)}$onDidHide(a){const u=this._sessions.get(a);u&&u._fireDidHide()}}class s{constructor(a,u){this._extensionId=a,this._onDidDispose=u,this._id=i._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new I.Emitter,this._onDidChangeValueEmitter=new I.Emitter,this._onDidTriggerButtonEmitter=new I.Emitter,this._onDidHideEmitter=new I.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(a){this._title=a,this.update({title:a})}get step(){return this._steps}set step(a){this._steps=a,this.update({step:a})}get totalSteps(){return this._totalSteps}set totalSteps(a){this._totalSteps=a,this.update({totalSteps:a})}get enabled(){return this._enabled}set enabled(a){this._enabled=a,this.update({enabled:a})}get busy(){return this._busy}set busy(a){this._busy=a,this.update({busy:a})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(a){this._ignoreFocusOut=a,this.update({ignoreFocusOut:a})}get value(){return this._value}set value(a){this._value=a,this.update({value:a})}get placeholder(){return this._placeholder}set placeholder(a){this._placeholder=a,this.update({placeholder:a})}get buttons(){return this._buttons}set buttons(a){this._buttons=a.slice(),this._handlesToButtons.clear(),a.forEach((u,f)=>{const v=u===D.QuickInputButtons.Back?-1:f;this._handlesToButtons.set(v,u)}),this.update({buttons:a.map((u,f)=>({...o(u),tooltip:u.tooltip,handle:u===D.QuickInputButtons.Back?-1:f}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(a){this._value=a,this._onDidChangeValueEmitter.fire(a)}_fireDidTriggerButton(a){const u=this._handlesToButtons.get(a);u&&this._onDidTriggerButtonEmitter.fire(u)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,y.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),_.$dispose(this._id))}update(a){if(!this._disposed){for(const u of Object.keys(a)){const f=a[u];this._pendingUpdate[u]=f===void 0?null:f}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){_.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}s._nextId=1;function d(c){if(c instanceof D.ThemeIcon)return{id:c.id};const a=S(c),u=n(c);return{dark:typeof a=="string"?k.URI.file(a):a,light:typeof u=="string"?k.URI.file(u):u}}function n(c){return typeof c=="object"&&"light"in c?c.light:c}function S(c){return typeof c=="object"&&"dark"in c?c.dark:c}function o(c){const a=d(c.iconPath);let u,f;return"id"in a?f=l.ThemeIcon.asClassName(a):u=a,{iconPath:u,iconClass:f}}class i extends s{constructor(a,u){super(a.identifier,u);this.extension=a,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new I.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new I.Emitter,this._onDidTriggerItemButtonEmitter=new I.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(a){a.some(f=>f.kind!==void 0)&&(0,E.checkProposedApiEnabled)(this.extension,"quickPickSeparators"),this._items=a.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),a.forEach((f,v)=>{this._handlesToItems.set(v,f),this._itemsToHandles.set(f,v)});const u=[];for(let f=0;f<a.length;f++){const v=a[f];v.kind===D.QuickPickItemKind.Separator?u.push({type:"separator",label:v.label}):u.push({handle:f,label:v.label,description:v.description,detail:v.detail,picked:v.picked,alwaysShow:v.alwaysShow,buttons:v.buttons?.map((w,A)=>({...o(w),tooltip:w.tooltip,handle:A}))})}this.update({items:u})}get canSelectMany(){return this._canSelectMany}set canSelectMany(a){this._canSelectMany=a,this.update({canSelectMany:a})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(a){this._matchOnDescription=a,this.update({matchOnDescription:a})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(a){this._matchOnDetail=a,this.update({matchOnDetail:a})}get sortByLabel(){return this._sortByLabel}set sortByLabel(a){this._sortByLabel=a,this.update({sortByLabel:a})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(a){this._keepScrollPosition=a,this.update({keepScrollPosition:a})}get activeItems(){return this._activeItems}set activeItems(a){this._activeItems=a.filter(u=>this._itemsToHandles.has(u)),this.update({activeItems:this._activeItems.map(u=>this._itemsToHandles.get(u))})}get selectedItems(){return this._selectedItems}set selectedItems(a){this._selectedItems=a.filter(u=>this._itemsToHandles.has(u)),this.update({selectedItems:this._selectedItems.map(u=>this._itemsToHandles.get(u))})}_fireDidChangeActive(a){const u=(0,L.coalesce)(a.map(f=>this._handlesToItems.get(f)));this._activeItems=u,this._onDidChangeActiveEmitter.fire(u)}_fireDidChangeSelection(a){const u=(0,L.coalesce)(a.map(f=>this._handlesToItems.get(f)));this._selectedItems=u,this._onDidChangeSelectionEmitter.fire(u)}_fireDidTriggerItemButton(a,u){const f=this._handlesToItems.get(a);if(!f||!f.buttons||!f.buttons.length)return;const v=f.buttons[u];v&&this._onDidTriggerItemButtonEmitter.fire({button:v,item:f})}}class r extends s{constructor(a,u){super(a,u);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(a){this._password=a,this.update({password:a})}get prompt(){return this._prompt}set prompt(a){this._prompt=a,this.update({prompt:a})}get validationMessage(){return this._validationMessage}set validationMessage(a){this._validationMessage=a,this.update({validationMessage:a,severity:a?C.default.Error:C.default.Ignore})}}return new g(b,F)}e.createExtHostQuickOpen=p});var nt=this&&this.__classPrivateFieldSet||function(Z,e,h,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!I:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(Z,h):I?I.value=h:e.set(Z,h),h},Fe=this&&this.__classPrivateFieldGet||function(Z,e,h,t){if(h==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?t:h==="a"?t.call(Z):t?t.value:e.get(Z)};define(ve[248],we([0,1,2,3,56,6,13,5,17,101,12,27,85,15,28]),function(Z,e,h,t,I,y,R,k,D,P,L,C,l,E,p){"use strict";var m,b;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function F(u){if(u)return typeof u.iconPath=="string"?h.URI.file(u.iconPath):h.URI.isUri(u.iconPath)||l.ThemeIcon.isThemeIcon(u.iconPath)?u.iconPath:void 0}function _(u,f){if(!u.iconPath&&!f.iconPath)return 0;if(u.iconPath){if(!f.iconPath)return 1}else return-1;const v=typeof u.iconPath=="string"?u.iconPath:h.URI.isUri(u.iconPath)?u.iconPath.fsPath:u.iconPath.id,w=typeof f.iconPath=="string"?f.iconPath:h.URI.isUri(f.iconPath)?f.iconPath.fsPath:f.iconPath.id;return(0,P.comparePaths)(v,w)}function g(u,f){let v=0;if(u.strikeThrough!==f.strikeThrough)return u.strikeThrough?1:-1;if(u.faded!==f.faded)return u.faded?1:-1;if(u.tooltip!==f.tooltip)return(u.tooltip||"").localeCompare(f.tooltip||"");if(v=_(u,f),v!==0)return v;if(u.light&&f.light)v=_(u.light,f.light);else{if(u.light)return 1;if(f.light)return-1}if(v!==0)return v;if(u.dark&&f.dark)v=_(u.dark,f.dark);else{if(u.dark)return 1;if(f.dark)return-1}return v}function s(u,f){if(u.command!==f.command)return u.command<f.command?-1:1;if(u.title!==f.title)return u.title<f.title?-1:1;if(u.tooltip!==f.tooltip){if(u.tooltip!==void 0&&f.tooltip!==void 0)return u.tooltip<f.tooltip?-1:1;if(u.tooltip!==void 0)return 1;if(f.tooltip!==void 0)return-1}if(u.arguments===f.arguments)return 0;if(u.arguments)if(f.arguments){if(u.arguments.length!==f.arguments.length)return u.arguments.length-f.arguments.length}else return 1;else return-1;for(let v=0;v<u.arguments.length;v++){const w=u.arguments[v],A=f.arguments[v];if(w!==A)return w<A?-1:1}return 0}function d(u,f){let v=(0,P.comparePaths)(u.resourceUri.fsPath,f.resourceUri.fsPath,!0);if(v!==0)return v;if(u.command&&f.command)v=s(u.command,f.command);else{if(u.command)return 1;if(f.command)return-1}if(v!==0)return v;if(u.decorations&&f.decorations)v=g(u.decorations,f.decorations);else{if(u.decorations)return 1;if(f.decorations)return-1}return v}function n(u,f){for(let v=0;v<u.length;v++)if(u[v]!==f[v])return!1;return!0}function S(u,f){return u.command===f.command&&u.title===f.title&&u.tooltip===f.tooltip&&(u.arguments&&f.arguments?n(u.arguments,f.arguments):u.arguments===f.arguments)}function o(u,f){return(0,D.equals)(u,f,S)}class i{constructor(f,v,w){this._extension=f,this._sourceControlHandle=w,m.set(this,void 0),this._value="",this._onDidChange=new t.Emitter,this._placeholder="",this._visible=!0,nt(this,m,v,"f")}get value(){return this._value}set value(f){f=f??"",Fe(this,m,"f").$setInputBoxValue(this._sourceControlHandle,f),this.updateValue(f)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(f){Fe(this,m,"f").$setInputBoxPlaceholder(this._sourceControlHandle,f),this._placeholder=f}get validateInput(){return(0,p.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(f){if((0,p.checkProposedApiEnabled)(this._extension,"scmValidation"),f&&typeof f!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=f,Fe(this,m,"f").$setValidationProviderIsEnabled(this._sourceControlHandle,!!f)}get visible(){return this._visible}set visible(f){f=!!f,this._visible!==f&&(this._visible=f,Fe(this,m,"f").$setInputBoxVisibility(this._sourceControlHandle,f))}showValidationMessage(f,v){(0,p.checkProposedApiEnabled)(this._extension,"scmValidation"),Fe(this,m,"f").$showValidationMessage(this._sourceControlHandle,f,v)}$onInputBoxValueChange(f){this.updateValue(f)}updateValue(f){this._value=f,this._onDidChange.fire(f)}}e.ExtHostSCMInputBox=i,m=new WeakMap;class r{constructor(f,v,w,A,M){this._proxy=f,this._commands=v,this._sourceControlHandle=w,this._id=A,this._label=M,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new t.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=r._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(f){this._label=f,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,f)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(f){this._hideWhenEmpty=f,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(f){this._resourceStates=[...f],this._onDidUpdateResourceStates.fire()}getResourceState(f){return this._resourceStatesMap.get(f)}$executeResourceCommand(f,v){const w=this._resourceStatesCommandsMap.get(f);return w?(0,R.asPromise)(()=>this._commands.executeCommand(w.command,...w.arguments||[],v)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const f=[...this._resourceStates].sort(d),w=(0,D.sortedDiff)(this._resourceSnapshot,f,d).map(T=>{const O=T.toInsert.map(U=>{const V=this._resourceHandlePool++;this._resourceStatesMap.set(V,U);const x=U.resourceUri;let N;if(U.command)if(U.command.command==="vscode.open"||U.command.command==="vscode.diff"){const oe=new y.DisposableStore;N=this._commands.converter.toInternal(U.command,oe),this._resourceStatesDisposablesMap.set(V,oe)}else this._resourceStatesCommandsMap.set(V,U.command);const $=F(U.decorations),B=U.decorations&&F(U.decorations.light)||$,z=U.decorations&&F(U.decorations.dark)||$,W=[B,z],Y=U.decorations&&U.decorations.tooltip||"",ie=U.decorations&&!!U.decorations.strikeThrough,ne=U.decorations&&!!U.decorations.faded,J=U.contextValue||"";return{rawResource:[V,x,W,Y,ie,ne,J,N],handle:V}});return{start:T.start,deleteCount:T.deleteCount,toInsert:O}}),A=w.map(({start:T,deleteCount:O,toInsert:U})=>[T,O,U.map(V=>V.rawResource)]),M=w.reverse();for(const{start:T,deleteCount:O,toInsert:U}of M){const V=U.map(N=>N.handle),x=this._handlesSnapshot.splice(T,O,...V);for(const N of x)this._resourceStatesMap.delete(N),this._resourceStatesCommandsMap.delete(N),this._resourceStatesDisposablesMap.get(N)?.dispose(),this._resourceStatesDisposablesMap.delete(N)}return this._resourceSnapshot=f,A}dispose(){this._disposed=!0,this._onDidDispose.fire()}}r._handlePool=0;class c{constructor(f,v,w,A,M,T){this._extension=f,this._commands=w,this._id=A,this._label=M,this._rootUri=T,b.set(this,void 0),this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new y.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new y.MutableDisposable,this._statusBarDisposables=new y.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new t.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=c._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,nt(this,b,v,"f"),this._inputBox=new i(f,Fe(this,b,"f"),this.handle),Fe(this,b,"f").$registerSourceControl(this.handle,A,M,T)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(f){this._count!==f&&(this._count=f,Fe(this,b,"f").$updateSourceControl(this.handle,{count:f}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(f){this._quickDiffProvider=f,Fe(this,b,"f").$updateSourceControl(this.handle,{hasQuickDiffProvider:!!f})}get commitTemplate(){return this._commitTemplate}set commitTemplate(f){f!==this._commitTemplate&&(this._commitTemplate=f,Fe(this,b,"f").$updateSourceControl(this.handle,{commitTemplate:f}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(f){this._acceptInputDisposables.value=new y.DisposableStore,this._acceptInputCommand=f;const v=this._commands.converter.toInternal(f,this._acceptInputDisposables.value);Fe(this,b,"f").$updateSourceControl(this.handle,{acceptInputCommand:v})}get actionButton(){return(0,p.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(f){(0,p.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new y.DisposableStore,this._actionButton=f;const v=f!==void 0?this._commands.converter.toInternal(this._actionButton,this._actionButtonDisposables.value):void 0;Fe(this,b,"f").$updateSourceControl(this.handle,{actionButton:v??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(f){if(this._statusBarCommands&&f&&o(this._statusBarCommands,f))return;this._statusBarDisposables.value=new y.DisposableStore,this._statusBarCommands=f;const v=(f||[]).map(w=>this._commands.converter.toInternal(w,this._statusBarDisposables.value));Fe(this,b,"f").$updateSourceControl(this.handle,{statusBarCommands:v})}get selected(){return this._selected}createResourceGroup(f,v){const w=new r(Fe(this,b,"f"),this._commands,this.handle,f,v),A=t.Event.once(w.onDidDispose)(()=>this.createdResourceGroups.delete(w));return this.createdResourceGroups.set(w,A),this.eventuallyAddResourceGroups(),w}eventuallyAddResourceGroups(){const f=[],v=[];for(const[w,A]of this.createdResourceGroups){A.dispose();const M=w.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(w),this.eventuallyUpdateResourceStates()});t.Event.once(w.onDidDispose)(()=>{this.updatedResourceGroups.delete(w),M.dispose(),this._groups.delete(w.handle),Fe(this,b,"f").$unregisterGroup(this.handle,w.handle)}),f.push([w.handle,w.id,w.label,w.features]);const T=w._takeResourceStateSnapshot();T.length>0&&v.push([w.handle,T]),this._groups.set(w.handle,w)}Fe(this,b,"f").$registerGroups(this.handle,f,v),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const f=[];this.updatedResourceGroups.forEach(v=>{const w=v._takeResourceStateSnapshot();w.length!==0&&f.push([v.handle,w])}),f.length>0&&Fe(this,b,"f").$spliceResourceStates(this.handle,f),this.updatedResourceGroups.clear()}getResourceGroup(f){return this._groups.get(f)}setSelectionState(f){this._selected=f,this._onDidChangeSelection.fire(f)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(f=>f.dispose()),Fe(this,b,"f").$unregisterSourceControl(this.handle)}}b=new WeakMap,c._handlePool=0,je([(0,I.debounce)(100)],c.prototype,"eventuallyAddResourceGroups",null),je([(0,I.debounce)(100)],c.prototype,"eventuallyUpdateResourceStates",null);let a=class Vi{constructor(f,v,w){this._commands=v,this.logService=w,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new t.Emitter,this._proxy=f.getProxy(k.MainContext.MainThreadSCM),this._telemetry=f.getProxy(k.MainContext.MainThreadTelemetry),v.registerArgumentProcessor({processArgument:A=>{if(A&&A.$mid===3){const M=this._sourceControls.get(A.sourceControlHandle);if(!M)return A;const T=M.getResourceGroup(A.groupHandle);return T?T.getResourceState(A.handle):A}else if(A&&A.$mid===4){const M=this._sourceControls.get(A.sourceControlHandle);return M?M.getResourceGroup(A.groupHandle):A}else if(A&&A.$mid===5){const M=this._sourceControls.get(A.handle);return M||A}return A}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(f,v,w,A){this.logService.trace("ExtHostSCM#createSourceControl",f.identifier.value,v,w,A),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:f.identifier.value});const M=Vi._handlePool++,T=new c(f,this._proxy,this._commands,v,w,A);this._sourceControls.set(M,T);const O=this._sourceControlsByExtension.get(C.ExtensionIdentifier.toKey(f.identifier))||[];return O.push(T),this._sourceControlsByExtension.set(C.ExtensionIdentifier.toKey(f.identifier),O),T}getLastInputBox(f){this.logService.trace("ExtHostSCM#getLastInputBox",f.identifier.value);const v=this._sourceControlsByExtension.get(C.ExtensionIdentifier.toKey(f.identifier)),w=v&&v[v.length-1];return w&&w.inputBox}$provideOriginalResource(f,v,w){const A=h.URI.revive(v);this.logService.trace("ExtHostSCM#$provideOriginalResource",f,A.toString());const M=this._sourceControls.get(f);return!M||!M.quickDiffProvider||!M.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,R.asPromise)(()=>M.quickDiffProvider.provideOriginalResource(A,w)).then(T=>T||null)}$onInputBoxValueChange(f,v){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",f);const w=this._sourceControls.get(f);return w&&w.inputBox.$onInputBoxValueChange(v),Promise.resolve(void 0)}$executeResourceCommand(f,v,w,A){this.logService.trace("ExtHostSCM#$executeResourceCommand",f,v,w);const M=this._sourceControls.get(f);if(!M)return Promise.resolve(void 0);const T=M.getResourceGroup(v);return T?T.$executeResourceCommand(w,A):Promise.resolve(void 0)}$validateInput(f,v,w){this.logService.trace("ExtHostSCM#$validateInput",f);const A=this._sourceControls.get(f);return!A||!A.inputBox.validateInput?Promise.resolve(void 0):(0,R.asPromise)(()=>A.inputBox.validateInput(v,w)).then(M=>{if(!M)return Promise.resolve(void 0);const T=E.MarkdownString.fromStrict(M.message);return T?Promise.resolve([T,M.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(f){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",f),f!==void 0&&this._sourceControls.get(f)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=f,Promise.resolve(void 0)}};a._handlePool=0,a=je([ze(2,L.ILogService)],a),e.ExtHostSCM=a});var nt=this&&this.__classPrivateFieldSet||function(Z,e,h,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!I:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(Z,h):I?I.value=h:e.set(Z,h),h},Fe=this&&this.__classPrivateFieldGet||function(Z,e,h,t){if(h==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?t:h==="a"?t.call(Z):t?t.value:e.get(Z)};define(ve[249],we([0,1,7,5,167,6,15,18]),function(Z,e,h,t,I,y,R,k){"use strict";var D,P;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class L{constructor(p,m,b,F,_=h.StatusBarAlignment.Left,g){D.set(this,void 0),P.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new y.DisposableStore,nt(this,D,p,"f"),nt(this,P,m,"f"),this._entryId=L.ID_GEN++,this._extension=b,this._id=F,this._alignment=_,this._priority=this.validatePriority(g)}validatePriority(p){if(!!(0,k.isNumber)(p))return p===Number.POSITIVE_INFINITY?Number.MAX_VALUE:p===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:p}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(p){this._text=p,this.update()}set name(p){this._name=p,this.update()}set tooltip(p){this._tooltip=p,this.update()}set color(p){this._color=p,this.update()}set backgroundColor(p){p&&!L.ALLOWED_BACKGROUND_COLORS.has(p.id)&&(p=void 0),this._backgroundColor=p,this.update()}set command(p){this._command?.fromApi!==p&&(this._internalCommandRegistration.clear(),typeof p=="string"?this._command={fromApi:p,internal:Fe(this,P,"f").toInternal({title:"",command:p},this._internalCommandRegistration)}:p?this._command={fromApi:p,internal:Fe(this,P,"f").toInternal(p,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(p){this._accessibilityInformation=p,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Fe(this,D,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let p;this._extension?this._id?p=`${this._extension.identifier.value}.${this._id}`:p=this._extension.identifier.value:p=this._id;let m;this._name?m=this._name:m=(0,I.localize)(0,null,this._extension.displayName||this._extension.name);let b=this._color;this._backgroundColor&&(b=L.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const F=this._tooltip?R.MarkdownString.fromStrict(this._tooltip):void 0;Fe(this,D,"f").$setEntry(this._entryId,p,m,this._text,F,this._command?.internal,b,this._backgroundColor,this._alignment===h.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=L,D=new WeakMap,P=new WeakMap,L.ID_GEN=0,L.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new h.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new h.ThemeColor("statusBarItem.warningForeground")]]);class C{constructor(p){this._messages=[],this._item=p.createStatusBarEntry(void 0,"status.extensionMessage",h.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,I.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(p){const m={message:p};return this._messages.unshift(m),this._update(),new h.Disposable(()=>{const b=this._messages.indexOf(m);b>=0&&(this._messages.splice(b,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class l{constructor(p,m){this._proxy=p.getProxy(t.MainContext.MainThreadStatusBar),this._commands=m,this._statusMessage=new C(this)}createStatusBarEntry(p,m,b,F){return new L(this._proxy,this._commands,p,m,b,F)}setStatusBarMessage(p,m){const b=this._statusMessage.setMessage(p);let F;return typeof m=="number"?F=setTimeout(()=>b.dispose(),m):typeof m!="undefined"&&m.then(()=>b.dispose(),()=>b.dispose()),new h.Disposable(()=>{b.dispose(),clearTimeout(F)})}}e.ExtHostStatusBar=l}),define(ve[90],we([0,1,5,3,4]),function(Z,e,h,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class y{constructor(k){this._onDidChangeStorage=new t.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=k.getProxy(h.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(k,D){this._proxy.$registerExtensionStorageKeysToSync(k,D)}initializeExtensionStorage(k,D,P){return this._proxy.$initializeExtensionStorage(k,D).then(L=>L||P)}setValue(k,D,P){return this._proxy.$setValue(k,D,P)}$acceptValue(k,D,P){this._onDidChangeStorage.fire({shared:k,key:D,value:P})}}e.ExtHostStorage=y,e.IExtHostStorage=(0,I.createDecorator)("IExtHostStorage")}),define(ve[68],we([0,1,4,26,12,67,2]),function(Z,e,h,t,I,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,h.createDecorator)("IExtensionStoragePaths");let k=class{constructor(P,L,C){this._logService=L,this._extHostFileSystem=C,this._workspace=P.workspace??void 0,this._environment=P.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(l=>this._value=l)}async _getWorkspaceStorageURI(P){return R.URI.joinPath(this._environment.workspaceStorageHome,P)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const P=this._workspace.id,L=await this._getWorkspaceStorageURI(P);try{return await this._extHostFileSystem.value.stat(L),this._logService.trace("[ExtHostStorage] storage dir already exists",L),L}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",L),await this._extHostFileSystem.value.createDirectory(L),await this._extHostFileSystem.value.writeFile(R.URI.joinPath(L,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:R.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),L}catch(C){this._logService.error("[ExtHostStorage]",C);return}}workspaceValue(P){if(this._value)return R.URI.joinPath(this._value,P.identifier.value)}globalValue(P){return R.URI.joinPath(this._environment.globalStorageHome,P.identifier.value.toLowerCase())}onWillDeactivateAll(){}};k=je([ze(0,t.IExtHostInitDataService),ze(1,I.ILogService),ze(2,y.IExtHostConsumerFileSystem)],k),e.ExtensionStoragePaths=k}),define(ve[34],we([0,1,3,5,4,2,14,6,7,168,16,214,21,33,196,85,18,13]),function(Z,e,h,t,I,y,R,k,D,P,L,C,l,E,p,m,b,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,I.createDecorator)("IExtHostTerminalService");class _{constructor(c,a,u,f){this._proxy=c,this._id=a,this._creationOptions=u,this._name=f,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(w=>this._pidPromiseComplete=w);const v=this;this.value={get name(){return v._name||""},get processId(){return v._pidPromise},get creationOptions(){return v._creationOptions},get exitStatus(){return v._exitStatus},get state(){return v._state},sendText(w,A=!0){v._checkDisposed(),v._proxy.$sendText(v._id,w,A)},show(w){v._checkDisposed(),v._proxy.$show(v._id,w)},hide(){v._checkDisposed(),v._proxy.$hide(v._id)},dispose(){v._disposed||(v._disposed=!0,v._proxy.$dispose(v._id))},get dimensions(){if(!(v._cols===void 0||v._rows===void 0))return{columns:v._cols,rows:v._rows}}}}async create(c,a){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:c.name,shellPath:(0,b.withNullAsUndefined)(c.shellPath),shellArgs:(0,b.withNullAsUndefined)(c.shellArgs),cwd:(0,b.withNullAsUndefined)(c.cwd),env:(0,b.withNullAsUndefined)(c.env),icon:(0,b.withNullAsUndefined)(o(c.iconPath)),color:m.ThemeColor.isThemeColor(c.color)?c.color.id:void 0,initialText:(0,b.withNullAsUndefined)(c.message),strictEnv:(0,b.withNullAsUndefined)(c.strictEnv),hideFromUser:(0,b.withNullAsUndefined)(c.hideFromUser),isFeatureTerminal:(0,b.withNullAsUndefined)(a?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,b.withNullAsUndefined)(a?.useShellEnvironment),location:a?.location||this._serializeParentTerminal(c.location,a?.resolvedExtHostIdentifier),disablePersistence:(0,b.withNullAsUndefined)(c.disablePersistence)})}async createExtensionTerminal(c,a,u,f){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:u,color:m.ThemeColor.isThemeColor(f)?f.id:void 0,location:this._serializeParentTerminal(c,a),disablePersistence:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(c,a){return typeof c=="object"?"parentTerminal"in c&&c.parentTerminal&&a?{parentTerminal:a}:"viewColumn"in c?{viewColumn:c.viewColumn,preserveFocus:c.preserveFocus}:void 0:c}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(c){this._name=c}setExitCode(c){this._exitStatus=Object.freeze({code:c})}setDimensions(c,a){return c===this._cols&&a===this._rows||c===0||a===0?!1:(this._cols=c,this._rows=a,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(c){this._pidPromiseComplete?(this._pidPromiseComplete(c),this._pidPromiseComplete=void 0):this._pidPromise.then(a=>{a!==c&&(this._pidPromise=Promise.resolve(c))})}}e.ExtHostTerminal=_;class g{constructor(c){this._pty=c,this.id=0,this.shouldPersist=!1,this._onProcessData=new h.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new h.Emitter,this._onDidChangeProperty=new h.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new h.Emitter,this.onProcessExit=this._onProcessExit.event}get onProcessReady(){return this._onProcessReady.event}refreshProperty(c){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${c}`)}updateProperty(c,a){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${c}, value: ${a}`)}async start(){}shutdown(){this._pty.close()}input(c){this._pty.handleInput?.(c)}resize(c,a){this._pty.setDimensions?.({columns:c,rows:a})}async processBinary(c){}acknowledgeDataEvent(c){}async setUnicodeVersion(c){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(c){this._pty.onDidWrite(a=>this._onProcessData.fire(a)),this._pty.onDidClose?.((a=void 0)=>{this._onProcessExit.fire(a===void 0?void 0:a)}),this._pty.onDidOverrideDimensions?.(a=>{a&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:a.columns,rows:a.rows}})}),this._pty.onDidChangeName?.(a=>{this._onDidChangeProperty.fire({type:"title",value:a})}),this._pty.open(c||void 0),c&&this._pty.setDimensions?.(c),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=g;let s=1,d=class extends k.Disposable{constructor(c,a){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new h.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new h.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new h.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new h.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new h.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=a.getProxy(t.MainContext.MainThreadTerminalService),this._bufferer=new p.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new h.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(c),this._register({dispose:()=>{for(const[u,f]of this._terminalProcesses)f.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(c=>c.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(c){return(c?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(c){return(c?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(c,a){const u=new _(this._proxy,(0,E.generateUuid)(),c,c.name),f=new g(c.pty);return u.createExtensionTerminal(c.location,this._serializeParentTerminal(c,a).resolvedExtHostIdentifier,o(c.iconPath),i(c.color)).then(v=>{const w=this._setupExtHostProcessListeners(v,f);this._terminalProcessDisposables[v]=w}),this._terminals.push(u),u.value}_serializeParentTerminal(c,a){if(a=a||{},c.location&&typeof c.location=="object"&&"parentTerminal"in c.location){const u=c.location.parentTerminal;if(u){const f=this._terminals.find(v=>v.value===u);f&&(a.resolvedExtHostIdentifier=f._id)}}else c.location&&typeof c.location!="object"?a.location=c.location:a.location&&typeof a.location=="object"&&"splitActiveTerminal"in a.location&&(a.location={splitActiveTerminal:!0});return a}attachPtyToTerminal(c,a){if(!this._getTerminalById(c))throw new Error(`Cannot resolve terminal with id ${c} for virtual process`);const f=new g(a),v=this._setupExtHostProcessListeners(c,f);this._terminalProcessDisposables[c]=v}async $acceptActiveTerminalChanged(c){const a=this._activeTerminal;if(c===null){this._activeTerminal=void 0,a!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const u=this._getTerminalById(c);u&&(this._activeTerminal=u,a!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(c,a){const u=this._getTerminalById(c);u&&this._onDidWriteTerminalData.fire({terminal:u.value,data:a})}async $acceptTerminalDimensions(c,a,u){const f=this._getTerminalById(c);f&&f.setDimensions(a,u)&&this._onDidChangeTerminalDimensions.fire({terminal:f.value,dimensions:f.value.dimensions})}async $acceptTerminalMaximumDimensions(c,a,u){this._terminalProcesses.get(c)?.resize(a,u)}async $acceptTerminalTitleChange(c,a){const u=this._getTerminalById(c);u&&(u.name=a)}async $acceptTerminalClosed(c,a){const u=this._getTerminalObjectIndexById(this._terminals,c);if(u!==null){const f=this._terminals.splice(u,1)[0];f.setExitCode(a),this._onDidCloseTerminal.fire(f.value)}}$acceptTerminalOpened(c,a,u,f){if(a){const A=this._getTerminalObjectIndexById(this._terminals,a);if(A!==null){this._terminals[A]._id=c,this._onDidOpenTerminal.fire(this.terminals[A]),this._terminals[A].isOpen=!0;return}}const v={name:f.name,shellPath:f.executable,shellArgs:f.args,cwd:typeof f.cwd=="string"?f.cwd:y.URI.revive(f.cwd),env:f.env,hideFromUser:f.hideFromUser},w=new _(this._proxy,c,v,u);this._terminals.push(w),this._onDidOpenTerminal.fire(w.value),w.isOpen=!0}async $acceptTerminalProcessId(c,a){const u=this._getTerminalById(c);u&&u._setProcessId(a)}async $startExtensionTerminal(c,a){const u=this._getTerminalById(c);if(!u)return{message:(0,P.localize)(0,null,c)};u.isOpen||await new Promise(v=>{const w=this.onDidOpenTerminal(async A=>{A===u.value&&(w.dispose(),v())})});const f=this._terminalProcesses.get(c);f?f.startSendingEvents(a):this._extensionTerminalAwaitingStart[c]={initialDimensions:a}}_setupExtHostProcessListeners(c,a){const u=new k.DisposableStore;u.add(a.onProcessReady(v=>this._proxy.$sendProcessReady(c,v.pid,v.cwd))),u.add(a.onDidChangeProperty(v=>this._proxy.$sendProcessProperty(c,v))),this._bufferer.startBuffering(c,a.onProcessData),u.add(a.onProcessExit(v=>this._onProcessExit(c,v))),this._terminalProcesses.set(c,a);const f=this._extensionTerminalAwaitingStart[c];return f&&a instanceof g&&(a.startSendingEvents(f.initialDimensions),delete this._extensionTerminalAwaitingStart[c]),u}$acceptProcessAckDataEvent(c,a){this._terminalProcesses.get(c)?.acknowledgeDataEvent(a)}$acceptProcessInput(c,a){this._terminalProcesses.get(c)?.input(a)}$acceptTerminalInteraction(c){const a=this._getTerminalById(c);a?.setInteractedWith()&&this._onDidChangeTerminalState.fire(a.value)}$acceptProcessResize(c,a,u){try{this._terminalProcesses.get(c)?.resize(a,u)}catch(f){if(f.code!=="EPIPE"&&f.code!=="ERR_IPC_CHANNEL_CLOSED")throw f}}$acceptProcessShutdown(c,a){this._terminalProcesses.get(c)?.shutdown(a)}$acceptProcessRequestInitialCwd(c){this._terminalProcesses.get(c)?.getInitialCwd().then(a=>this._proxy.$sendProcessProperty(c,{type:"initialCwd",value:a}))}$acceptProcessRequestCwd(c){this._terminalProcesses.get(c)?.getCwd().then(a=>this._proxy.$sendProcessProperty(c,{type:"cwd",value:a}))}$acceptProcessRequestLatency(c){return Promise.resolve(c)}registerLinkProvider(c){return this._linkProviders.add(c),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new D.Disposable(()=>{this._linkProviders.delete(c),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(c,a,u){if(this._profileProviders.has(a))throw new Error(`Terminal profile provider "${a}" already registered`);return this._profileProviders.set(a,u),this._proxy.$registerProfileProvider(a,c.identifier.value),new D.Disposable(()=>{this._profileProviders.delete(a),this._proxy.$unregisterProfileProvider(a)})}async $createContributedProfileTerminal(c,a){const u=new l.CancellationTokenSource().token;let f=await this._profileProviders.get(c)?.provideTerminalProfile(u);if(!u.isCancellationRequested){if(f&&!("options"in f)&&(f={options:f}),!f||!("options"in f))throw new Error(`No terminal profile options provided for id "${c}"`);if("pty"in f.options){this.createExtensionTerminal(f.options,a);return}this.createTerminalFromOptions(f.options,a)}}async $provideLinks(c,a){const u=this._getTerminalById(c);if(!u)return[];this._terminalLinkCache.delete(c);const f=this._terminalLinkCancellationSource.get(c);f&&f.dispose(!0);const v=new l.CancellationTokenSource;this._terminalLinkCancellationSource.set(c,v);const w=[],A={terminal:u.value,line:a},M=[];for(const U of this._linkProviders)M.push(F.Promises.withAsyncBody(async V=>{v.token.onCancellationRequested(()=>V({provider:U,links:[]}));const x=await U.provideTerminalLinks(A,v.token)||[];v.token.isCancellationRequested||V({provider:U,links:x})}));const T=await Promise.all(M);if(v.token.isCancellationRequested)return[];const O=new Map;for(const U of T)U&&U.links.length>0&&w.push(...U.links.map(V=>{const x={id:s++,startIndex:V.startIndex,length:V.length,label:V.tooltip};return O.set(x.id,{provider:U.provider,link:V}),x}));return this._terminalLinkCache.set(c,O),w}$activateLink(c,a){const u=this._terminalLinkCache.get(c)?.get(a);!u||u.provider.handleTerminalLink(u.link)}_onProcessExit(c,a){this._bufferer.stopBuffering(c),this._terminalProcesses.delete(c),delete this._extensionTerminalAwaitingStart[c];const u=this._terminalProcessDisposables[c];u&&(u.dispose(),delete this._terminalProcessDisposables[c]),this._proxy.$sendProcessExit(c,a)}_getTerminalById(c){return this._getTerminalObjectById(this._terminals,c)}_getTerminalObjectById(c,a){const u=this._getTerminalObjectIndexById(c,a);return u!==null?c[u]:null}_getTerminalObjectIndexById(c,a){let u=null;return c.some((f,v)=>f._id===a?(u=v,!0):!1),u}getEnvironmentVariableCollection(c){let a=this._environmentVariableCollections.get(c.identifier.value);return a||(a=new n,this._setEnvironmentVariableCollection(c.identifier.value,a)),a}_syncEnvironmentVariableCollection(c,a){const u=(0,C.serializeEnvironmentVariableCollection)(a.map);this._proxy.$setEnvironmentVariableCollection(c,a.persistent,u.length===0?void 0:u)}$initEnvironmentVariableCollections(c){c.forEach(a=>{const u=a[0],f=new n(a[1]);this._setEnvironmentVariableCollection(u,f)})}$acceptDefaultProfile(c,a){this._defaultProfile=c,this._defaultAutomationProfile=a}_setEnvironmentVariableCollection(c,a){this._environmentVariableCollections.set(c,a),a.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(c,a)})}};d=je([ze(1,R.IExtHostRpcService)],d),e.BaseExtHostTerminalService=d;class n{constructor(c){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new h.Emitter,this.map=new Map(c)}get persistent(){return this._persistent}set persistent(c){this._persistent=c,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(c,a){this._setIfDiffers(c,{value:a,type:D.EnvironmentVariableMutatorType.Replace})}append(c,a){this._setIfDiffers(c,{value:a,type:D.EnvironmentVariableMutatorType.Append})}prepend(c,a){this._setIfDiffers(c,{value:a,type:D.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(c,a){const u=this.map.get(c);(!u||u.value!==a.value||u.type!==a.type)&&(this.map.set(c,a),this._onDidChangeCollection.fire())}get(c){return this.map.get(c)}forEach(c,a){this.map.forEach((u,f)=>c.call(a,f,u,this))}delete(c){this.map.delete(c),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=n;let S=class extends d{constructor(c){super(!1,c)}createTerminal(c,a,u){throw new L.NotSupportedError}createTerminalFromOptions(c,a){throw new L.NotSupportedError}};S=je([ze(0,R.IExtHostRpcService)],S),e.WorkerExtHostTerminalService=S;function o(r){if(!(!r||typeof r=="string"))return"id"in r?{id:r.id,color:r.color}:r}function i(r){return m.ThemeColor.isThemeColor(r)?r:void 0}});var nt=this&&this.__classPrivateFieldSet||function(Z,e,h,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!I:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(Z,h):I?I.value=h:e.set(Z,h),h},Fe=this&&this.__classPrivateFieldGet||function(Z,e,h,t){if(h==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?t:h==="a"?t.call(Z):t?t.value:e.get(Z)};define(ve[250],we([0,1,17,22,21,3,76,58,6,25,18,33,5,14,64,15,7,220,128,88]),function(Z,e,h,t,I,y,R,k,D,P,L,C,l,E,p,m,b,F,_,g){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let d=class{constructor(A,M){this.resultsChangedEmitter=new y.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=A.getProxy(l.MainContext.MainThreadTesting),this.observer=new u(this.proxy),this.runTracker=new S(this.proxy),M.registerArgumentProcessor({processArgument:T=>T?.$mid===13?m.TestItem.toItemFromContext(T):T})}createTestController(A,M,T){if(this.controllers.has(A))throw new Error(`Attempt to insert a duplicate controller with ID "${A}"`);const O=new D.DisposableStore,U=O.add(new F.SingleUseTestCollection(A));U.root.label=M;const V=new Map,x=this.proxy,N={items:U.root.children,get label(){return M},set label(B){M=B,U.root.label=B,x.$updateController(A,{label:M})},get refreshHandler(){return T},set refreshHandler(B){T=B,x.$updateController(A,{canRefresh:!!B})},get id(){return A},createRunProfile:(B,z,W,Y,ie)=>{let ne=(0,k.hash)(B);for(;V.has(ne);)ne++;const J=new f(this.proxy,A,ne,B,z,W,Y,ie);return V.set(ne,J),J},createTestItem(B,z,W){return new p.TestItemImpl(A,B,z,W)},createTestRun:(B,z,W=!0)=>this.runTracker.createTestRun(A,U,B,z,W),set resolveHandler(B){U.resolveHandler=B},get resolveHandler(){return U.resolveHandler},dispose:()=>{O.dispose()}};x.$registerTestController(A,M,!!T),O.add((0,D.toDisposable)(()=>x.$unregisterTestController(A)));const $={controller:N,collection:U,profiles:V};return this.controllers.set(A,$),O.add((0,D.toDisposable)(()=>this.controllers.delete(A))),O.add(U.onDidGenerateDiff(B=>x.$publishDiff(A,B))),N}createTestObserver(){return this.observer.checkout()}async runTests(A,M=I.CancellationToken.None){const T=o(A);if(!T)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const O=this.controllers.get(T.controllerId);if(!O)throw new Error("Controller not found");await this.proxy.$runTests({targets:[{testIds:A.include?.map(U=>U.id)??[O.collection.root.id],profileGroup:v[T.kind],profileId:T.profileId,controllerId:T.controllerId}],exclude:A.exclude?.map(U=>U.id)},M)}$provideFileCoverage(A,M,T){return(0,h.mapFind)(this.runTracker.trackers,U=>U.id===A?U.getCoverage(M):void 0)?.provideFileCoverage(T)??Promise.resolve([])}$resolveFileCoverage(A,M,T,O){return(0,h.mapFind)(this.runTracker.trackers,V=>V.id===A?V.getCoverage(M):void 0)?.resolveFileCoverage(T,O)??Promise.resolve([])}$configureRunProfile(A,M){this.controllers.get(A)?.profiles.get(M)?.configureHandler?.()}async $refreshTests(A,M){await this.controllers.get(A)?.controller.refreshHandler?.(M)}$publishTestResults(A){this.results=Object.freeze(A.map(M=>(0,P.deepFreeze)(m.TestResults.to(M))).concat(this.results).sort((M,T)=>T.completedAt-M.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(A,M){const T=this.controllers.get(g.TestId.fromString(A).controllerId)?.collection;T&&(await T.expand(A,M<0?1/0:M),T.flushDiff())}$acceptDiff(A){this.observer.applyDiff(A)}async $runControllerTests(A,M){const T=this.controllers.get(A.controllerId);if(!T)return;const{collection:O,profiles:U}=T,V=U.get(A.profileId);if(!V)return;const x=A.testIds.map(z=>O.tree.get(z)).filter(L.isDefined),N=A.excludeExtIds.map(z=>T.collection.tree.get(z)).filter(L.isDefined).filter(z=>x.some(W=>W.fullId.compare(z.fullId)===2));if(!x.length)return;const $=new b.TestRunRequest(x.some(z=>z.actual instanceof p.TestItemRootImpl)?void 0:x.map(z=>z.actual),N.map(z=>z.actual),V),B=this.runTracker.prepareForMainThreadTestRun($,i.fromInternal(A,T.collection),M);try{await V.runHandler($,M)}finally{B.isRunning&&!M.isCancellationRequested&&await y.Event.toPromise(B.onEnd),B.dispose()}}$cancelExtensionTestRun(A){A===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(A)}};d=je([ze(0,E.IExtHostRpcService)],d),e.ExtHostTesting=d;class n extends D.Disposable{constructor(A,M,T){super();this.dto=A,this.proxy=M,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new y.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new I.CancellationTokenSource(T)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:O}of this.tasks.values())O.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(A){return this.tasks.get(A)?.coverage}createRun(A){const M=this.dto.id,T=this.dto.controllerId,O=(0,C.generateUuid)(),U=new r(this.proxy,M,O),V=B=>(z,...W)=>{if(N){console.warn(`Setting the state of test "${z.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(z)||(this.ensureTestIsKnown(z),B(z,...W))},x=(B,z)=>{const W=z instanceof Array?z.map(m.TestMessage.from):[m.TestMessage.from(z)];if(B.uri&&B.range){const Y={range:m.Range.from(B.range),uri:B.uri};for(const ie of W)ie.location=ie.location||Y}this.proxy.$appendTestMessagesInRun(M,O,g.TestId.fromExtHostTestItem(B,T).toString(),W)};let N=!1;const $={isPersisted:this.dto.isPersisted,token:this.cts.token,name:A,get coverageProvider(){return U.coverageProvider},set coverageProvider(B){U.coverageProvider=B},enqueued:V(B=>{this.proxy.$updateTestStateInRun(M,O,g.TestId.fromExtHostTestItem(B,T).toString(),1)}),skipped:V(B=>{this.proxy.$updateTestStateInRun(M,O,g.TestId.fromExtHostTestItem(B,T).toString(),5)}),started:V(B=>{this.proxy.$updateTestStateInRun(M,O,g.TestId.fromExtHostTestItem(B,T).toString(),2)}),errored:V((B,z,W)=>{x(B,z),this.proxy.$updateTestStateInRun(M,O,g.TestId.fromExtHostTestItem(B,T).toString(),6,W)}),failed:V((B,z,W)=>{x(B,z),this.proxy.$updateTestStateInRun(M,O,g.TestId.fromExtHostTestItem(B,T).toString(),4,W)}),passed:V((B,z)=>{this.proxy.$updateTestStateInRun(M,O,g.TestId.fromExtHostTestItem(B,this.dto.controllerId).toString(),3,z)}),appendOutput:(B,z,W)=>{N||(W&&(this.dto.isIncluded(W)?this.ensureTestIsKnown(W):W=void 0),this.proxy.$appendOutputToRun(M,O,t.VSBuffer.fromString(B),z&&m.location.from(z),W&&g.TestId.fromExtHostTestItem(W,T).toString()))},end:()=>{N||(N=!0,this.proxy.$finishedTestRunTask(M,O),this.tasks.delete(O),this.isRunning||this.dispose())}};return this.tasks.set(O,{run:$,coverage:U}),this.proxy.$startedTestRunTask(M,{id:O,name:A,running:!0}),$}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(A){if(!(A instanceof p.TestItemImpl))throw new p.InvalidTestItemError(A.id);if(this.sharedTestIds.has(g.TestId.fromExtHostTestItem(A,this.dto.controllerId).toString()))return;const M=[],T=this.dto.colllection.root;for(;;){const O=m.TestItem.from(A);if(M.unshift(O),this.sharedTestIds.has(O.extId)||(this.sharedTestIds.add(O.extId),A===T))break;A=A.parent||T}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,M)}}class S{constructor(A){this.proxy=A,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(A,M,T){return this.getTracker(A,M,T)}cancelRunById(A){for(const M of this.tracked.values())if(M.id===A){M.dispose();return}}cancelAllRuns(){for(const A of this.tracked.values())A.dispose()}createTestRun(A,M,T,O,U){const V=this.tracked.get(T);if(V)return V.createRun(O);const x=i.fromPublic(A,M,T,U),N=o(T);this.proxy.$startedExtensionTestRun({controllerId:A,profile:N&&{group:v[N.kind],id:N.profileId},exclude:T.exclude?.map(B=>B.id)??[],id:x.id,include:T.include?.map(B=>B.id)??[M.root.id],persist:U});const $=this.getTracker(T,x);return $.onEnd(()=>this.proxy.$finishedExtensionTestRun(x.id)),$.createRun(O)}getTracker(A,M,T){const O=new n(M,this.proxy,T);return this.tracked.set(A,O),O.onEnd(()=>this.tracked.delete(A)),O}}e.TestRunCoordinator=S;const o=w=>{if(!!w.profile){if(!(w.profile instanceof f))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return w.profile}};class i{constructor(A,M,T,O,U,V){this.controllerId=A,this.id=M,this.isPersisted=U,this.colllection=V,this.includePrefix=T.map(x=>x+"\0"),this.excludePrefix=O.map(x=>x+"\0")}static fromPublic(A,M,T,O){return new i(A,(0,C.generateUuid)(),T.include?.map(U=>g.TestId.fromExtHostTestItem(U,A).toString())??[A],T.exclude?.map(U=>g.TestId.fromExtHostTestItem(U,A).toString())??[],O,M)}static fromInternal(A,M){return new i(A.controllerId,A.runId,A.testIds,A.excludeExtIds,!0,M)}isIncluded(A){const M=g.TestId.fromExtHostTestItem(A,this.controllerId).toString()+"\0";for(const T of this.excludePrefix)if(M===T||M.startsWith(T))return!1;for(const T of this.includePrefix)if(M===T||M.startsWith(T))return!0;return!1}}e.TestRunDto=i;class r{constructor(A,M,T){this.proxy=A,this.runId=M,this.taskId=T}set coverageProvider(A){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!A||(this._coverageProvider=A,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(A){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(A))());try{return(await this.fileCoverage)?.map(m.TestCoverage.fromFile)??[]}catch(M){throw this.fileCoverage=void 0,M}}async resolveFileCoverage(A,M){const T=await this.fileCoverage;let O=T?.[A];return!this._coverageProvider||!T||!O?[]:(O.detailedCoverage||(O=T[A]=await this._coverageProvider.resolveFileCoverage?.(O,M)??O),O.detailedCoverage?.map(m.TestCoverage.fromDetailed)??[])}}class c extends _.IncrementalChangeCollector{constructor(A){super();this.emitter=A,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(A){this.added.add(A)}update(A){Object.assign(A.revived,m.TestItem.toPlain(A.item)),this.added.has(A)||this.updated.add(A)}remove(A){if(this.added.has(A)){this.added.delete(A);return}if(this.updated.delete(A),A.parent&&this.alreadyRemoved.has(A.parent)){this.alreadyRemoved.add(A.item.extId);return}this.removed.add(A)}getChangeEvent(){const{added:A,updated:M,removed:T}=this;return{get added(){return[...A].map(O=>O.revived)},get updated(){return[...M].map(O=>O.revived)},get removed(){return[...T].map(O=>O.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class a extends _.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new y.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(A){return this.items.get(A)}getMirroredTestDataByReference(A){return this.items.get(A.id)}createItem(A,M){return{...A,revived:m.TestItem.toPlain(A.item),depth:M?M.depth+1:0,children:new Set}}createChangeCollector(){return new c(this.changeEmitter)}}e.MirroredTestCollection=a;class u{constructor(A){this.proxy=A}checkout(){this.current||(this.current=this.createObserverData());const A=this.current;return A.observers++,{onDidChangeTest:A.tests.onDidChangeTests,get tests(){return[...A.tests.rootTests].map(M=>M.revived)},dispose:(0,R.once)(()=>{--A.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(A){return this.current?.tests.getMirroredTestDataByReference(A)}applyDiff(A){this.current?.tests.apply(A)}createObserverData(){const A=new a;return this.proxy.$subscribeToDiffs(),{observers:0,tests:A}}}class f{constructor(A,M,T,O,U,V,x=!1,N=void 0){this.controllerId=M,this.profileId=T,this._label=O,this.kind=U,this.runHandler=V,this._isDefault=x,this._tag=N,s.set(this,void 0),nt(this,s,A,"f");const $=v[U];if(typeof $!="number")throw new Error(`Unknown TestRunProfile.group ${U}`);Fe(this,s,"f").$publishTestRunProfile({profileId:T,controllerId:M,tag:N?m.TestTag.namespace(this.controllerId,N.id):null,label:O,group:$,isDefault:x,hasConfigurationHandler:!1})}get label(){return this._label}set label(A){A!==this._label&&(this._label=A,Fe(this,s,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:A}))}get isDefault(){return this._isDefault}set isDefault(A){A!==this._isDefault&&(this._isDefault=A,Fe(this,s,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:A}))}get tag(){return this._tag}set tag(A){A?.id!==this._tag?.id&&(this._tag=A,Fe(this,s,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:A?m.TestTag.namespace(this.controllerId,A.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(A){A!==this._configureHandler&&(this._configureHandler=A,Fe(this,s,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!A}))}dispose(){Fe(this,s,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=f,s=new WeakMap;const v={[b.TestRunProfileKind.Coverage]:8,[b.TestRunProfileKind.Debug]:4,[b.TestRunProfileKind.Run]:2}}),define(ve[251],we([0,1,3,17,5,131,15,7]),function(Z,e,h,t,I,y,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class D{constructor(L,C){this._extHostDocumentsAndEditors=C,this._onDidChangeTextEditorSelection=new h.Emitter,this._onDidChangeTextEditorOptions=new h.Emitter,this._onDidChangeTextEditorVisibleRanges=new h.Emitter,this._onDidChangeTextEditorViewColumn=new h.Emitter,this._onDidChangeActiveTextEditor=new h.Emitter,this._onDidChangeVisibleTextEditors=new h.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=L.getProxy(I.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(l=>this._onDidChangeVisibleTextEditors.fire(l)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(l=>this._onDidChangeActiveTextEditor.fire(l))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(L){const C=this._extHostDocumentsAndEditors.allEditors();return L?C:C.map(l=>l.value)}async showTextDocument(L,C,l){let E;typeof C=="number"?E={position:R.ViewColumn.from(C),preserveFocus:l}:typeof C=="object"?E={position:R.ViewColumn.from(C.viewColumn),preserveFocus:C.preserveFocus,selection:typeof C.selection=="object"?R.Range.from(C.selection):void 0,pinned:typeof C.preview=="boolean"?!C.preview:void 0}:E={preserveFocus:!1};const p=await this._proxy.$tryShowTextDocument(L.uri,E),m=p&&this._extHostDocumentsAndEditors.getEditor(p);if(m)return m.value;throw p?new Error(`Could NOT open editor for "${L.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${L.uri.toString()}".`)}createTextEditorDecorationType(L,C){return new y.TextEditorDecorationType(this._proxy,L,C).value}$acceptEditorPropertiesChanged(L,C){const l=this._extHostDocumentsAndEditors.getEditor(L);if(!l)throw new Error("unknown text editor");if(C.options&&l._acceptOptions(C.options),C.selections){const E=C.selections.selections.map(R.Selection.to);l._acceptSelections(E)}if(C.visibleRanges){const E=t.coalesce(C.visibleRanges.map(R.Range.to));l._acceptVisibleRanges(E)}if(C.options&&this._onDidChangeTextEditorOptions.fire({textEditor:l.value,options:{...C.options,lineNumbers:R.TextEditorLineNumbersStyle.to(C.options.lineNumbers)}}),C.selections){const E=k.TextEditorSelectionChangeKind.fromValue(C.selections.source),p=C.selections.selections.map(R.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:l.value,selections:p,kind:E})}if(C.visibleRanges){const E=t.coalesce(C.visibleRanges.map(R.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:l.value,visibleRanges:E})}}$acceptEditorPositionData(L){for(const C in L){const l=this._extHostDocumentsAndEditors.getEditor(C);if(!l)throw new Error("Unknown text editor");const E=R.ViewColumn.to(L[C]);l.value.viewColumn!==E&&(l._acceptViewColumn(E),this._onDidChangeTextEditorViewColumn.fire({textEditor:l.value,viewColumn:E}))}}getDiffInformation(L){return Promise.resolve(this._proxy.$getDiffInformation(L))}}e.ExtHostEditors=D}),define(ve[252],we([0,1,2,4,5,6,7]),function(Z,e,h,t,I,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,t.createDecorator)("IExtHostTimeline");class k{constructor(L,C){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=L.getProxy(I.MainContext.MainThreadTimeline),C.registerArgumentProcessor({processArgument:l=>{if(l&&l.$mid===11){const E=l.uri===void 0?void 0:h.URI.revive(l.uri);return this._itemsBySourceAndUriMap.get(l.source)?.get(D(E))?.get(l.handle)}return l}})}async $getTimeline(L,C,l,E,p){return this._providers.get(L)?.provideTimeline(h.URI.revive(C),l,E,p)}registerTimelineProvider(L,C,l,E){const p=new y.DisposableStore,m=this.convertTimelineItem(C.id,E,p).bind(this);let b;C.onDidChange&&(b=C.onDidChange(_=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,..._,id:C.id}),this));const F=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...C,scheme:L,onDidChange:void 0,async provideTimeline(_,g,s,d){d?.resetCache&&(p.clear(),F.get(C.id)?.clear());const n=await C.provideTimeline(_,g,s);if(n==null)return;const S=m(_,d);return{...n,source:C.id,items:n.items.map(S)}},dispose(){for(const _ of F.values())_.get(C.id)?.clear();b?.dispose(),p.dispose()}})}convertTimelineItem(L,C,l){return(E,p)=>{let m;if(p?.cacheResults){let b=this._itemsBySourceAndUriMap.get(L);b===void 0&&(b=new Map,this._itemsBySourceAndUriMap.set(L,b));const F=D(E);m=b.get(F),m===void 0&&(m=new Map,b.set(F,m))}return b=>{const{iconPath:F,..._}=b,g=`${L}|${b.id??b.timestamp}`;m?.set(g,b);let s,d,n;return b.iconPath&&(F instanceof R.ThemeIcon?n={id:F.id,color:F.color}:h.URI.isUri(F)?(s=F,d=F):{light:s,dark:d}=F),{..._,id:_.id??void 0,handle:g,source:L,command:b.command?C.toInternal(b.command,l):void 0,icon:s,iconDark:d,themeIcon:n,accessibilityInformation:b.accessibilityInformation}}}}registerTimelineProviderCore(L){if(this._providers.get(L.id))throw new Error(`Timeline Provider ${L.id} already exists.`);return this._proxy.$registerTimelineProvider({id:L.id,label:L.label,scheme:L.scheme}),this._providers.set(L.id,L),(0,y.toDisposable)(()=>{for(const l of this._itemsBySourceAndUriMap.values())l.get(L.id)?.clear();this._providers.delete(L.id),this._proxy.$unregisterTimelineProvider(L.id),L.dispose()})}}e.ExtHostTimeline=k;function D(P){return P?.toString()}}),define(ve[253],we([0,1,6,10,2,5]),function(Z,e,h,t,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class R{constructor(D){this._openers=new Map,this._proxy=D.getProxy(y.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(D,P,L,C){if(this._openers.has(P))throw new Error(`Opener with id '${P}' already registered`);const l=C.schemes.find(E=>!R.supportedSchemes.has(E));if(l)throw new Error(`Scheme '${l}' is not supported. Only http and https are currently supported.`);return this._openers.set(P,L),this._proxy.$registerUriOpener(P,C.schemes,D,C.label),(0,h.toDisposable)(()=>{this._openers.delete(P),this._proxy.$unregisterUriOpener(P)})}async $canOpenUri(D,P,L){const C=this._openers.get(D);if(!C)throw new Error(`Unknown opener with id: ${D}`);const l=I.URI.revive(P);return C.canOpenExternalUri(l,L)}async $openUri(D,P,L){const C=this._openers.get(D);if(!C)throw new Error(`Unknown opener id: '${D}'`);return C.openExternalUri(I.URI.revive(P.resolvedUri),{sourceUri:I.URI.revive(P.sourceUri)},L)}}e.ExtHostUriOpeners=R,R.supportedSchemes=new Set([t.Schemas.http,t.Schemas.https])}),define(ve[254],we([0,1,5,2,6,16,27]),function(Z,e,h,t,I,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class k{constructor(P){this.handles=new Set,this.handlers=new Map,this._proxy=P.getProxy(h.MainContext.MainThreadUrls)}registerUriHandler(P,L){if(this.handles.has(R.ExtensionIdentifier.toKey(P)))throw new Error(`Protocol handler already registered for extension ${P}`);const C=k.HandlePool++;return this.handles.add(R.ExtensionIdentifier.toKey(P)),this.handlers.set(C,L),this._proxy.$registerUriHandler(C,P),(0,I.toDisposable)(()=>{this.handles.delete(R.ExtensionIdentifier.toKey(P)),this.handlers.delete(C),this._proxy.$unregisterUriHandler(C)})}$handleExternalUri(P,L){const C=this.handlers.get(P);if(!C)return Promise.resolve(void 0);try{C.handleUri(t.URI.revive(L))}catch(l){(0,y.onUnexpectedError)(l)}return Promise.resolve(void 0)}async createAppUri(P){return t.URI.revive(await this._proxy.$createAppUri(P))}}e.ExtHostUrls=k,k.HandlePool=0});var nt=this&&this.__classPrivateFieldSet||function(Z,e,h,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!I:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(Z,h):I?I.value=h:e.set(Z,h),h},Fe=this&&this.__classPrivateFieldGet||function(Z,e,h,t){if(h==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?t:h==="a"?t.call(Z):t?t.value:e.get(Z)};define(ve[69],we([0,1,3,10,2,180,204,87,5]),function(Z,e,h,t,I,y,R,k,D){"use strict";var P,L,C,l,E,p,m,b,F,_,g,s;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class d{constructor(u,f,v,w,A,M,T){P.set(this,void 0),L.set(this,void 0),C.set(this,void 0),l.set(this,void 0),E.set(this,void 0),p.set(this,void 0),m.set(this,""),b.set(this,void 0),F.set(this,!1),_.set(this,!1),g.set(this,!1),this._onMessageEmitter=new h.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,s.set(this,new h.Emitter),this._onDidDispose=Fe(this,s,"f").event,nt(this,P,u,"f"),nt(this,L,f,"f"),nt(this,b,v,"f"),nt(this,l,w,"f"),nt(this,E,A,"f"),nt(this,p,M,"f"),nt(this,g,n(M),"f"),nt(this,C,T,"f")}dispose(){nt(this,F,!0,"f"),Fe(this,s,"f").fire(),Fe(this,s,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(u){return nt(this,_,!0,"f"),(0,k.asWebviewUri)(u,Fe(this,l,"f").remote)}get cspSource(){const u=Fe(this,p,"f").extensionLocation;if(u.scheme===t.Schemas.https||u.scheme===t.Schemas.http){let f=u.toString();return f.endsWith("/")||(f+="/"),f+" "+k.webviewGenericCspSource}return k.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Fe(this,m,"f")}set html(u){this.assertNotDisposed(),Fe(this,m,"f")!==u&&(nt(this,m,u,"f"),!Fe(this,_,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(u)&&(nt(this,_,!0,"f"),Fe(this,C,"f").report("Webview vscode-resource: uris",Fe(this,p,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Fe(this,L,"f").$setHtml(Fe(this,P,"f"),u))}get options(){return this.assertNotDisposed(),Fe(this,b,"f")}set options(u){this.assertNotDisposed(),Fe(this,L,"f").$setOptions(Fe(this,P,"f"),i(Fe(this,p,"f"),Fe(this,E,"f"),u)),nt(this,b,u,"f")}async postMessage(u){if(Fe(this,F,"f"))return!1;const f=(0,R.serializeWebviewMessage)(u,{serializeBuffersForPostMessage:Fe(this,g,"f")});return Fe(this,L,"f").$postMessage(Fe(this,P,"f"),f.message,...f.buffers)}assertNotDisposed(){if(Fe(this,F,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=d,P=new WeakMap,L=new WeakMap,C=new WeakMap,l=new WeakMap,E=new WeakMap,p=new WeakMap,m=new WeakMap,b=new WeakMap,F=new WeakMap,_=new WeakMap,g=new WeakMap,s=new WeakMap;function n(a){try{const u=(0,y.normalizeVersion)((0,y.parseVersion)(a.engines.vscode));return!!u&&u.majorBase>=1&&u.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=n;class S{constructor(u,f,v,w,A){this.initData=f,this.workspace=v,this._logService=w,this._deprecationService=A,this._webviews=new Map,this._webviewProxy=u.getProxy(D.MainContext.MainThreadWebviews)}$onMessage(u,f,v){const w=this.getWebview(u);if(w){const{message:A}=(0,R.deserializeWebviewMessage)(f,v.value);w._onMessageEmitter.fire(A)}}$onMissingCsp(u,f){this._logService.warn(`${f} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(u,f,v){const w=new d(u,this._webviewProxy,r(f),this.initData,this.workspace,v,this._deprecationService);return this._webviews.set(u,w),w._onDidDispose(()=>{this._webviews.delete(u)}),w}deleteWebview(u){this._webviews.delete(u)}getWebview(u){return this._webviews.get(u)}}e.ExtHostWebviews=S;function o(a){return{id:a.identifier,location:a.extensionLocation}}e.toExtensionData=o;function i(a,u,f){return{enableCommandUris:f.enableCommandUris,enableScripts:f.enableScripts,enableForms:f.enableForms,portMapping:f.portMapping,localResourceRoots:f.localResourceRoots||c(a,u)}}e.serializeWebviewOptions=i;function r(a){return{enableCommandUris:a.enableCommandUris,enableScripts:a.enableScripts,enableForms:a.enableForms,portMapping:a.portMapping,localResourceRoots:a.localResourceRoots?.map(u=>I.URI.from(u))}}e.reviveOptions=r;function c(a,u){return[...(u?.getWorkspaceFolders()||[]).map(f=>f.uri),a.extensionLocation]}}),define(ve[255],we([0,1,21,58,6,10,23,2,15,69,86,5,7]),function(Z,e,h,t,I,y,R,k,D,P,L,C,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class E{constructor(n,S){this.document=n,this._storagePath=S,this._backupCounter=1,this._edits=new L.Cache("custom documents")}addEdit(n){return this._edits.add([n])}async undo(n,S){await this.getEdit(n).undo(),S||this.disposeBackup()}async redo(n,S){await this.getEdit(n).redo(),S||this.disposeBackup()}disposeEdits(n){for(const S of n)this._edits.delete(S)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const n=s(this.document.uri)+this._backupCounter++;return(0,R.joinPath)(this._storagePath,n)}updateBackup(n){this._backup?.delete(),this._backup=n}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(n){const S=this._edits.get(n,0);if(!S)throw new Error("No edit found");return S}}class p{constructor(){this._documents=new Map}get(n,S){return this._documents.get(this.key(n,S))}add(n,S,o){const i=this.key(n,S.uri);if(this._documents.has(i))throw new Error(`Document already exists for viewType:${n} resource:${S.uri}`);const r=new E(S,o);return this._documents.set(i,r),r}delete(n,S){const o=this.key(n,S.uri);this._documents.delete(o)}key(n,S){return`${n}@@@${S}`}}var m;(function(d){d[d.Text=0]="Text",d[d.Custom=1]="Custom"})(m||(m={}));class b{constructor(){this._providers=new Map}addTextProvider(n,S,o){return this.add(0,n,S,o)}addCustomProvider(n,S,o){return this.add(1,n,S,o)}get(n){return this._providers.get(n)}add(n,S,o,i){if(this._providers.has(S))throw new Error(`Provider for viewType:${S} already registered`);return this._providers.set(S,{type:n,extension:o,provider:i}),new l.Disposable(()=>this._providers.delete(S))}}class F{constructor(n,S,o,i,r){this._extHostDocuments=S,this._extensionStoragePaths=o,this._extHostWebview=i,this._extHostWebviewPanels=r,this._editorProviders=new b,this._documents=new p,this._proxy=n.getProxy(C.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(n,S,o,i){const r=new I.DisposableStore;return _(o)?(r.add(this._editorProviders.addTextProvider(S,n,o)),this._proxy.$registerTextEditorProvider((0,P.toExtensionData)(n),S,i.webviewOptions||{},{supportsMove:!!o.moveCustomTextEditor},(0,P.shouldSerializeBuffersForPostMessage)(n))):(r.add(this._editorProviders.addCustomProvider(S,n,o)),this.supportEditing(o)&&r.add(o.onDidChangeCustomDocument(c=>{const a=this.getCustomDocumentEntry(S,c.document.uri);if(g(c)){const u=a.addEdit(c);this._proxy.$onDidEdit(c.document.uri,S,u,c.label)}else this._proxy.$onContentChange(c.document.uri,S)})),this._proxy.$registerCustomEditorProvider((0,P.toExtensionData)(n),S,i.webviewOptions||{},!!i.supportsMultipleEditorsPerDocument,(0,P.shouldSerializeBuffersForPostMessage)(n))),l.Disposable.from(r,new l.Disposable(()=>{this._proxy.$unregisterEditorProvider(S)}))}async $createCustomDocument(n,S,o,i,r){const c=this._editorProviders.get(S);if(!c)throw new Error(`No provider found for '${S}'`);if(c.type!==1)throw new Error(`Invalid provide type for '${S}'`);const a=k.URI.revive(n),u=await c.provider.openCustomDocument(a,{backupId:o,untitledDocumentData:i?.buffer},r);let f;return this.supportEditing(c.provider)&&this._extensionStoragePaths&&(f=this._extensionStoragePaths.workspaceValue(c.extension)??this._extensionStoragePaths.globalValue(c.extension)),this._documents.add(S,u,f),{editable:this.supportEditing(c.provider)}}async $disposeCustomDocument(n,S){const o=this._editorProviders.get(S);if(!o)throw new Error(`No provider found for '${S}'`);if(o.type!==1)throw new Error(`Invalid provider type for '${S}'`);const i=k.URI.revive(n),{document:r}=this.getCustomDocumentEntry(S,i);this._documents.delete(S,r),r.dispose()}async $resolveWebviewEditor(n,S,o,i,r,c){const a=this._editorProviders.get(o);if(!a)throw new Error(`No provider found for '${o}'`);const u=D.ViewColumn.to(r),f=this._extHostWebview.createNewWebview(S,i.webviewOptions,a.extension),v=this._extHostWebviewPanels.createNewWebviewPanel(S,o,i.title,u,i.panelOptions,f),w=k.URI.revive(n);switch(a.type){case 1:{const{document:A}=this.getCustomDocumentEntry(o,w);return a.provider.resolveCustomEditor(A,v,c)}case 0:{const A=this._extHostDocuments.getDocument(w);return a.provider.resolveCustomTextEditor(A,v,c)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(n,S,o){this.getCustomDocumentEntry(S,n).disposeEdits(o)}async $onMoveCustomEditor(n,S,o){const i=this._editorProviders.get(o);if(!i)throw new Error(`No provider found for '${o}'`);if(!i.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${o}'`);const r=this._extHostWebviewPanels.getWebviewPanel(n);if(!r)throw new Error("No webview found");const c=k.URI.revive(S),a=this._extHostDocuments.getDocument(c);await i.provider.moveCustomTextEditor(a,r,h.CancellationToken.None)}async $undo(n,S,o,i){return this.getCustomDocumentEntry(S,n).undo(o,i)}async $redo(n,S,o,i){return this.getCustomDocumentEntry(S,n).redo(o,i)}async $revert(n,S,o){const i=this.getCustomDocumentEntry(S,n);await this.getCustomEditorProvider(S).revertCustomDocument(i.document,o),i.disposeBackup()}async $onSave(n,S,o){const i=this.getCustomDocumentEntry(S,n);await this.getCustomEditorProvider(S).saveCustomDocument(i.document,o),i.disposeBackup()}async $onSaveAs(n,S,o,i){const r=this.getCustomDocumentEntry(S,n);return this.getCustomEditorProvider(S).saveCustomDocumentAs(r.document,k.URI.revive(o),i)}async $backup(n,S,o){const i=this.getCustomDocumentEntry(S,n),c=await this.getCustomEditorProvider(S).backupCustomDocument(i.document,{destination:i.getNewBackupUri()},o);return i.updateBackup(c),c.id}getCustomDocumentEntry(n,S){const o=this._documents.get(n,k.URI.revive(S));if(!o)throw new Error("No custom document found");return o}getCustomEditorProvider(n){const o=this._editorProviders.get(n)?.provider;if(!o||!this.supportEditing(o))throw new Error("Custom document is not editable");return o}supportEditing(n){return!!n.onDidChangeCustomDocument}}e.ExtHostCustomEditors=F;function _(d){return typeof d.resolveCustomTextEditor=="function"}function g(d){return typeof d.undo=="function"&&typeof d.redo=="function"}function s(d){const n=d.scheme===y.Schemas.file||d.scheme===y.Schemas.untitled?d.fsPath:d.toString();return(0,t.hash)(n)+""}});var nt=this&&this.__classPrivateFieldSet||function(Z,e,h,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!I:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(Z,h):I?I.value=h:e.set(Z,h),h},Fe=this&&this.__classPrivateFieldGet||function(Z,e,h,t){if(h==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?t:h==="a"?t.call(Z):t?t.value:e.get(Z)};define(ve[256],we([0,1,3,6,2,33,15,69,5,7]),function(Z,e,h,t,I,y,R,k,D,P){"use strict";var L,C,l,E,p,m,b,F,_,g,s,d,n;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class S extends t.Disposable{constructor(c,a,u,f,v,w,A){super();L.set(this,void 0),C.set(this,void 0),l.set(this,void 0),E.set(this,void 0),p.set(this,void 0),m.set(this,void 0),b.set(this,void 0),F.set(this,void 0),_.set(this,!0),g.set(this,!0),s.set(this,!1),d.set(this,this._register(new h.Emitter)),this.onDidDispose=Fe(this,d,"f").event,n.set(this,this._register(new h.Emitter)),this.onDidChangeViewState=Fe(this,n,"f").event,nt(this,L,c,"f"),nt(this,C,a,"f"),nt(this,l,u,"f"),nt(this,p,w,"f"),nt(this,F,v,"f"),nt(this,m,f,"f"),nt(this,E,A,"f")}dispose(){Fe(this,s,"f")||(nt(this,s,!0,"f"),Fe(this,d,"f").fire(),Fe(this,C,"f").$disposeWebview(Fe(this,L,"f")),Fe(this,E,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Fe(this,E,"f")}get viewType(){return this.assertNotDisposed(),Fe(this,l,"f")}get title(){return this.assertNotDisposed(),Fe(this,m,"f")}set title(c){this.assertNotDisposed(),Fe(this,m,"f")!==c&&(nt(this,m,c,"f"),Fe(this,C,"f").$setTitle(Fe(this,L,"f"),c))}get iconPath(){return this.assertNotDisposed(),Fe(this,b,"f")}set iconPath(c){this.assertNotDisposed(),Fe(this,b,"f")!==c&&(nt(this,b,c,"f"),Fe(this,C,"f").$setIconPath(Fe(this,L,"f"),I.URI.isUri(c)?{light:c,dark:c}:c))}get options(){return Fe(this,p,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Fe(this,F,"f")=="number"&&Fe(this,F,"f")<0))return Fe(this,F,"f")}get active(){return this.assertNotDisposed(),Fe(this,g,"f")}get visible(){return this.assertNotDisposed(),Fe(this,_,"f")}_updateViewState(c){Fe(this,s,"f")||(this.active!==c.active||this.visible!==c.visible||this.viewColumn!==c.viewColumn)&&(nt(this,g,c.active,"f"),nt(this,_,c.visible,"f"),nt(this,F,c.viewColumn,"f"),Fe(this,n,"f").fire({webviewPanel:this}))}reveal(c,a){this.assertNotDisposed(),Fe(this,C,"f").$reveal(Fe(this,L,"f"),{viewColumn:c?R.ViewColumn.from(c):void 0,preserveFocus:!!a})}assertNotDisposed(){if(Fe(this,s,"f"))throw new Error("Webview is disposed")}}L=new WeakMap,C=new WeakMap,l=new WeakMap,E=new WeakMap,p=new WeakMap,m=new WeakMap,b=new WeakMap,F=new WeakMap,_=new WeakMap,g=new WeakMap,s=new WeakMap,d=new WeakMap,n=new WeakMap;class o{constructor(c,a,u){this.webviews=a,this.workspace=u,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=c.getProxy(D.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,y.generateUuid)()}createWebviewPanel(c,a,u,f,v={}){const w=typeof f=="object"?f.viewColumn:f,A={viewColumn:R.ViewColumn.from(w),preserveFocus:typeof f=="object"&&!!f.preserveFocus},M=(0,k.shouldSerializeBuffersForPostMessage)(c),T=o.newHandle();this._proxy.$createWebviewPanel((0,k.toExtensionData)(c),T,a,{title:u,panelOptions:i(v),webviewOptions:(0,k.serializeWebviewOptions)(c,this.workspace,v),serializeBuffersForPostMessage:M},A);const O=this.webviews.createNewWebview(T,v,c);return this.createNewWebviewPanel(T,a,u,w,v,O)}$onDidChangeWebviewPanelViewStates(c){const a=Object.keys(c);a.sort((u,f)=>{const v=c[u],w=c[f];return v.active?1:w.active?-1:+v.visible-+w.visible});for(const u of a){const f=this.getWebviewPanel(u);if(!f)continue;const v=c[u];f._updateViewState({active:v.active,visible:v.visible,viewColumn:R.ViewColumn.to(v.position)})}}async $onDidDisposeWebviewPanel(c){this.getWebviewPanel(c)?.dispose(),this._webviewPanels.delete(c),this.webviews.deleteWebview(c)}registerWebviewPanelSerializer(c,a,u){if(this._serializers.has(a))throw new Error(`Serializer for '${a}' already registered`);return this._serializers.set(a,{serializer:u,extension:c}),this._proxy.$registerSerializer(a,{serializeBuffersForPostMessage:(0,k.shouldSerializeBuffersForPostMessage)(c)}),new P.Disposable(()=>{this._serializers.delete(a),this._proxy.$unregisterSerializer(a)})}async $deserializeWebviewPanel(c,a,u,f){const v=this._serializers.get(a);if(!v)throw new Error(`No serializer found for '${a}'`);const{serializer:w,extension:A}=v,M=this.webviews.createNewWebview(c,u.webviewOptions,A),T=this.createNewWebviewPanel(c,a,u.title,f,u.panelOptions,M);await w.deserializeWebviewPanel(T,u.state)}createNewWebviewPanel(c,a,u,f,v,w){const A=new S(c,this._proxy,a,u,f,v,w);return this._webviewPanels.set(c,A),A}getWebviewPanel(c){return this._webviewPanels.get(c)}}e.ExtHostWebviewPanels=o;function i(r){return{enableFindWidget:r.enableFindWidget,retainContextWhenHidden:r.retainContextWhenHidden}}});var nt=this&&this.__classPrivateFieldSet||function(Z,e,h,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!I:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(Z,h):I?I.value=h:e.set(Z,h),h},Fe=this&&this.__classPrivateFieldGet||function(Z,e,h,t){if(h==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?t:h==="a"?t.call(Z):t?t.value:e.get(Z)};define(ve[257],we([0,1,3,6,69,5,7]),function(Z,e,h,t,I,y,R){"use strict";var k,D,P,L,C,l,E,p,m,b;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class F extends t.Disposable{constructor(s,d,n,S,o,i){super();k.set(this,void 0),D.set(this,void 0),P.set(this,void 0),L.set(this,void 0),C.set(this,!1),l.set(this,void 0),E.set(this,void 0),p.set(this,void 0),m.set(this,this._register(new h.Emitter)),this.onDidChangeVisibility=Fe(this,m,"f").event,b.set(this,this._register(new h.Emitter)),this.onDidDispose=Fe(this,b,"f").event,nt(this,P,n,"f"),nt(this,E,S,"f"),nt(this,k,s,"f"),nt(this,D,d,"f"),nt(this,L,o,"f"),nt(this,l,i,"f")}dispose(){Fe(this,C,"f")||(nt(this,C,!0,"f"),Fe(this,b,"f").fire(),Fe(this,L,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Fe(this,E,"f")}set title(s){this.assertNotDisposed(),Fe(this,E,"f")!==s&&(nt(this,E,s,"f"),Fe(this,D,"f").$setWebviewViewTitle(Fe(this,k,"f"),s))}get description(){return this.assertNotDisposed(),Fe(this,p,"f")}set description(s){this.assertNotDisposed(),Fe(this,p,"f")!==s&&(nt(this,p,s,"f"),Fe(this,D,"f").$setWebviewViewDescription(Fe(this,k,"f"),s))}get visible(){return Fe(this,l,"f")}get webview(){return Fe(this,L,"f")}get viewType(){return Fe(this,P,"f")}_setVisible(s){s===Fe(this,l,"f")||Fe(this,C,"f")||(nt(this,l,s,"f"),Fe(this,m,"f").fire())}show(s){this.assertNotDisposed(),Fe(this,D,"f").$show(Fe(this,k,"f"),!!s)}assertNotDisposed(){if(Fe(this,C,"f"))throw new Error("Webview is disposed")}}k=new WeakMap,D=new WeakMap,P=new WeakMap,L=new WeakMap,C=new WeakMap,l=new WeakMap,E=new WeakMap,p=new WeakMap,m=new WeakMap,b=new WeakMap;class _{constructor(s,d){this._extHostWebview=d,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=s.getProxy(y.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(s,d,n,S){if(this._viewProviders.has(d))throw new Error(`View provider for '${d}' already registered`);return this._viewProviders.set(d,{provider:n,extension:s}),this._proxy.$registerWebviewViewProvider((0,I.toExtensionData)(s),d,{retainContextWhenHidden:S?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new R.Disposable(()=>{this._viewProviders.delete(d),this._proxy.$unregisterWebviewViewProvider(d)})}async $resolveWebviewView(s,d,n,S,o){const i=this._viewProviders.get(d);if(!i)throw new Error(`No view provider found for '${d}'`);const{provider:r,extension:c}=i,a=this._extHostWebview.createNewWebview(s,{},c),u=new F(s,this._proxy,d,n,a,!0);this._webviewViews.set(s,u),await r.resolveWebviewView(u,{state:S},o)}async $onDidChangeWebviewViewVisibility(s,d){this.getWebviewView(s)._setVisible(d)}async $disposeWebviewView(s){const d=this.getWebviewView(s);this._webviewViews.delete(s),d.dispose(),this._extHostWebview.deleteWebview(s)}getWebviewView(s){const d=this._webviewViews.get(s);if(!d)throw new Error("No webview found");return d}}e.ExtHostWebviewViews=_}),define(ve[135],we([0,1,3,5,2,10,8,4,14]),function(Z,e,h,t,I,y,R,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let P=class ji{constructor(C){this._onDidChangeWindowState=new h.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=ji.InitialState,this._proxy=C.getProxy(t.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(l=>this.$onDidChangeWindowFocus(l))}get state(){return this._state}$onDidChangeWindowFocus(C){C!==this._state.focused&&(this._state={...this._state,focused:C},this._onDidChangeWindowState.fire(this._state))}openUri(C,l){let E;if(typeof C=="string"){E=C;try{C=I.URI.parse(C)}catch{return Promise.reject(`Invalid uri - '${C}'`)}}return(0,R.isFalsyOrWhitespace)(C.scheme)?Promise.reject("Invalid scheme - cannot be empty"):C.scheme===y.Schemas.command?Promise.reject(`Invalid scheme '${C.scheme}'`):this._proxy.$openUri(C,E,l)}async asExternalUri(C,l){if((0,R.isFalsyOrWhitespace)(C.scheme))return Promise.reject("Invalid scheme - cannot be empty");const E=await this._proxy.$asExternalUri(C,l);return I.URI.from(E)}};P.InitialState={focused:!0},P=je([ze(0,D.IExtHostRpcService)],P),e.ExtHostWindow=P,e.IExtHostWindow=(0,k.createDecorator)("IExtHostWindow")}),define(ve[258],we([0,1,9,81,33,38,6,5,2,14]),function(Z,e,h,t,I,y,R,k,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let L=class extends R.Disposable{constructor(l,E){super();const p=l.getProxy(k.MainContext.MainThreadDownloadService);E.registerCommand(!1,"_workbench.downloadResource",async m=>{const b=D.URI.file((0,h.join)((0,t.tmpdir)(),(0,I.generateUuid)()));return await p.$download(m,b),b})}};L=je([ze(0,P.IExtHostRpcService),ze(1,y.IExtHostCommands)],L),e.ExtHostDownloadService=L}),define(ve[259],we([0,1,133,10,188,33]),function(Z,e,h,t,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;class R extends h.ExtHostLoggerService{doCreateLogger(D,P,L){return D.scheme===t.Schemas.file?new I.SpdLogLogger(L?.name||(0,y.generateUuid)(),D.fsPath,!L?.donotRotate,!!L?.donotUseFormatters,P):super.doCreateLogger(D,P,L)}}e.ExtHostLoggerService=R}),define(ve[260],we([0,1,60,9,2,68,6,10,13,30]),function(Z,e,h,t,I,y,R,k,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class L extends y.ExtensionStoragePaths{constructor(){super(...arguments);this._workspaceStorageLock=null}async _getWorkspaceStorageURI(n){const S=await super._getWorkspaceStorageURI(n);if(S.scheme!==k.Schemas.file)return S;if(this._environment.skipWorkspaceStorageLock)return this._logService.info(`Skipping acquiring lock for ${S.fsPath}.`),S;const o=S.fsPath;let i=0;do{let r;i===0?r=o:r=/[/\\]$/.test(o)?`${o.substr(0,o.length-1)}-${i}`:`${o}-${i}`,await C(r);const c=t.join(r,"vscode.lock"),a=await m(this._logService,c,!1);if(a)return this._workspaceStorageLock=a,process.on("exit",()=>{a.dispose()}),I.URI.file(r);i++}while(i<10);return S}onWillDeactivateAll(){this._workspaceStorageLock&&this._workspaceStorageLock.setWillRelease(6e3)}}e.ExtensionStoragePaths=L;async function C(d){try{await P.Promises.stat(d);return}catch{}try{await P.Promises.mkdir(d,{recursive:!0})}catch{}}const l=1e3,E=10*60*1e3;class p extends R.Disposable{constructor(n,S){super();this.logService=n,this.filename=S,this._timer=this._register(new D.IntervalTimer),this._timer.cancelAndSet(async()=>{const o=await b(n,S);(!o||o.pid!==process.pid)&&(n.info(`Lock '${S}': The lock was lost unexpectedly.`),this._timer.cancel());try{await P.Promises.utimes(S,new Date,new Date)}catch(i){n.error(i),n.info(`Lock '${S}': Could not update mtime.`)}},l)}dispose(){super.dispose();try{h.unlinkSync(this.filename)}catch{}}async setWillRelease(n){this.logService.info(`Lock '${this.filename}': Marking the lockfile as scheduled to be released in ${n} ms.`);try{const S={pid:process.pid,willReleaseAt:Date.now()+n};await P.Promises.writeFile(this.filename,JSON.stringify(S),{flag:"w"})}catch(S){this.logService.error(S)}}}async function m(d,n,S){try{const i={pid:process.pid,willReleaseAt:0};await P.Promises.writeFile(n,JSON.stringify(i),{flag:"wx"})}catch(i){d.error(i)}const o=await b(d,n);return!o||o.pid!==process.pid?S?(d.info(`Lock '${n}': Could not acquire lock, giving up.`),null):(d.info(`Lock '${n}': Could not acquire lock, checking if the file is stale.`),g(d,n)):(d.info(`Lock '${n}': Lock acquired.`),new p(d,n))}async function b(d,n){let S;try{S=await P.Promises.readFile(n)}catch(o){return d.error(o),null}try{return JSON.parse(String(S))}catch(o){return d.error(o),null}}async function F(d,n){let S;try{S=await P.Promises.stat(n)}catch(o){return d.error(o),0}return S.mtime.getTime()}function _(d){try{return process.kill(d,0),!0}catch{return!1}}async function g(d,n){const S=await b(d,n);if(!S)return d.info(`Lock '${n}': Could not read pid of lock holder.`),s(d,n);if(S.willReleaseAt){let a=S.willReleaseAt-Date.now();if(a<5e3){for(a>0?d.info(`Lock '${n}': The lockfile is scheduled to be released in ${a} ms.`):d.info(`Lock '${n}': The lockfile is scheduled to have been released.`);a>0;){if(await(0,D.timeout)(Math.min(100,a)),await F(d,n)===0)return s(d,n);a=S.willReleaseAt-Date.now()}return s(d,n)}}if(!_(S.pid))return d.info(`Lock '${n}': The pid ${S.pid} appears to be gone.`),s(d,n);const o=await F(d,n),i=Date.now()-o;if(i<=E)return d.info(`Lock '${n}': The lock does not look stale, elapsed: ${i} ms, giving up.`),null;d.info(`Lock '${n}': The lock looks stale, waiting for 2s.`),await(0,D.timeout)(2e3);const r=await F(d,n),c=Date.now()-r;return c<=E?(d.info(`Lock '${n}': The lock does not look stale, elapsed: ${c} ms, giving up.`),null):(d.info(`Lock '${n}': The lock looks stale even after waiting for 2s.`),s(d,n))}async function s(d,n){d.info(`Lock '${n}': Deleting a stale lock.`);try{await P.Promises.unlink(n)}catch{}return m(d,n,!0)}}),define(ve[261],we([0,1,33,14,34]),function(Z,e,h,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let y=class extends I.BaseExtHostTerminalService{constructor(k){super(!0,k)}createTerminal(k,D,P){return this.createTerminalFromOptions({name:k,shellPath:D,shellArgs:P})}createTerminalFromOptions(k,D){const P=new I.ExtHostTerminal(this._proxy,(0,h.generateUuid)(),k,k.name);return this._terminals.push(P),P.create(k,this._serializeParentTerminal(k,D)),P.value}};y=je([ze(0,t.IExtHostRpcService)],y),e.ExtHostTerminalService=y}),define(ve[262],we([0,1,5,14,172,6,26,2,37,23,30,7,11,51,3,122,94,12]),function(Z,e,h,t,I,y,R,k,D,P,L,C,l,E,p,m,b,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class _{constructor(u,f,v){this.remoteAddress=u,this.localAddress=f,this._dispose=v,this._onDispose=new p.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}function g(a){const u=a.trim().split(`
`),f=[];return u.forEach(w=>{const A=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(w);A&&A.length>=3&&f.push({pid:parseInt(A[1],10),socket:parseInt(A[2],10)})}),f.reduce((w,A)=>(w[A.socket]=A,w),{})}e.getSockets=g;function s(...a){const u=[].concat(...a.map(n));return[...new Map(u.filter(f=>f.st==="0A").map(f=>{const v=f.local_address.split(":");return{socket:parseInt(f.inode,10),ip:d(v[0]),port:parseInt(v[1],16)}}).map(f=>[f.ip+":"+f.port,f])).values()]}e.loadListeningPorts=s;function d(a){let u="";if(a.length===8)for(let f=a.length-2;f>=0;f-=2)u+=parseInt(a.substr(f,2),16),f!==0&&(u+=".");else for(let f=a.length-4;f>=0;f-=4)u+=parseInt(a.substr(f,4),16).toString(16),f!==0&&(u+=":");return u}e.parseIpAddress=d;function n(a){const u=a.trim().split(`
`),f=u.shift().trim().split(/\s+/).filter(w=>w!=="rx_queue"&&w!=="tm->when");return u.map(w=>w.trim().split(/\s+/).reduce((A,M,T)=>(A[f[T]||T]=M,A),{}))}e.loadConnectionTable=n;function S(a){return!!a.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||a.indexOf("out/vs/server/main.js")!==-1||a.indexOf("_productName=VSCode")!==-1}function o(a){const u=a.trim().split(`
`),f=[];return u.forEach(v=>{const w=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(v);w&&w.length>=4&&f.push({pid:parseInt(w[1],10),ppid:parseInt(w[2]),cmd:w[3]})}),f}e.getRootProcesses=o;async function i(a,u,f){const v=f.reduce((A,M)=>(A[M.pid]=M,A),{}),w=[];return a.forEach(({socket:A,ip:M,port:T})=>{const O=u[A]?u[A].pid:void 0,U=O?v[O]?.cmd:void 0;O&&U&&!S(U)&&w.push({host:M,port:T,detail:U,pid:O})}),w}e.findPorts=i;function r(a,u,f){const v=new Map,w=o(u);for(const A of a){const M=f.get(A.port);if(M){v.set(A.port,M);continue}const T=w.find(O=>O.cmd.includes(`${A.port}`));if(T){let O=T,U;do U=w.find(V=>V.ppid===O.pid),U&&(O=U);while(U);v.set(A.port,{host:A.ip,port:A.port,pid:O.pid,detail:O.cmd,ppid:O.ppid})}else v.set(A.port,{host:A.ip,port:A.port,ppid:Number.MAX_VALUE})}return v}e.tryFindRootPorts=r;let c=class extends y.Disposable{constructor(u,f,v){super();this.logService=v,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new p.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=u.getProxy(h.MainContext.MainThreadTunnelService),l.isLinux&&f.remote.isRemote&&f.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(u,f){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${u.identifier.value} called openTunnel API for ${f.remoteAddress.host}:${f.remoteAddress.port}.`);const v=await this._proxy.$openTunnel(f,u.displayName);if(v){const w=new _(v.remoteAddress,v.localAddress,()=>this._proxy.$closeTunnel(v.remoteAddress));return this._register(w),w}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(u){return Math.max(u*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(u,f){const v=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(v,{selector:u,provider:f}),this._proxy.$registerPortsAttributesProvider(u,v),new C.Disposable(()=>{this._portAttributesProviders.delete(v),this._proxy.$unregisterPortsAttributesProvider(v)})}async $providePortAttributes(u,f,v,w,A){const M=[];for(const O of u){const U=this._portAttributesProviders.get(O);if(!U)return[];M.push(...await Promise.all(f.map(async V=>U.provider.providePortAttributes(V,v,w,A))))}const T=M.filter(O=>!!O);return T.length>0?T.map(O=>({autoForwardAction:O.autoForwardAction,port:O.port})):[]}async $registerCandidateFinder(u){if(u&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=u;let f=new b.MovingAverage,v;for(;this._candidateFindingEnabled;){const w=new Date().getTime(),A=(await this.findCandidatePorts()).filter(T=>(0,m.isLocalhost)(T.host)||(0,m.isAllInterfaces)(T.host));this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${A.map(T=>T.port).join(", ")}`);const M=new Date().getTime()-w;f.update(M),(!v||JSON.stringify(v)!==JSON.stringify(A))&&(v=A,await this._proxy.$onFoundNewCandidates(v)),await new Promise(T=>setTimeout(()=>T(),this.calculateDelay(f.value)))}}async setTunnelFactory(u){if(u){if(u.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(u.candidatePortSource),u.showCandidatePort&&(this._showCandidatePort=u.showCandidatePort,this._proxy.$setCandidateFilter()),u.tunnelFactory){this._forwardPortProvider=u.tunnelFactory;let f=u.tunnelFeatures?.privacyOptions??[];u.tunnelFeatures?.public&&f.length===0&&(f=[{id:"private",label:I.localize(0,null),themeIcon:"lock"},{id:"public",label:I.localize(1,null),themeIcon:"eye"}]);const v=u.tunnelFeatures?{elevation:!!u.tunnelFeatures?.elevation,public:!!u.tunnelFeatures?.public,privacyOptions:f}:void 0;this._proxy.$setTunnelProvider(v)}}else this._forwardPortProvider=void 0;return(0,y.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(u,f){if(this._extensionTunnels.has(u.host)){const v=this._extensionTunnels.get(u.host);v.has(u.port)&&(f&&v.get(u.port).disposeListener.dispose(),await v.get(u.port).tunnel.dispose(),v.delete(u.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(u,f){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const v=this._forwardPortProvider(u,f);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),v!==void 0){const w=await v;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(u.remoteAddress.host)||this._extensionTunnels.set(u.remoteAddress.host,new Map);const A=this._register(w.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(w.remoteAddress))));return this._extensionTunnels.get(u.remoteAddress.host).set(u.remoteAddress.port,{tunnel:w,disposeListener:A}),E.TunnelDto.fromApiTunnel(w)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(u){const f=await Promise.all(u.map(w=>this._showCandidatePort(w.host,w.port,w.detail??""))),v=u.filter((w,A)=>f[A]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${u.map(w=>w.port).join(", ")} to ${v.map(w=>w.port).join(", ")}`),v}async findCandidatePorts(){let u="",f="";try{u=await L.Promises.readFile("/proc/net/tcp","utf8"),f=await L.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const v=s(u,f),w=await new Promise(N=>{(0,D.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",($,B,z)=>{N(B)})}),A=g(w),M=await L.Promises.readdir("/proc"),T=[];for(let N of M)try{const $=Number(N),B=P.joinPath(k.URI.file("/proc"),N);if((await L.Promises.stat(B.fsPath)).isDirectory()&&!isNaN($)){const W=await L.Promises.readlink(P.joinPath(B,"cwd").fsPath),Y=await L.Promises.readFile(P.joinPath(B,"cmdline").fsPath,"utf8");T.push({pid:$,cwd:W,cmd:Y})}}catch{}const O=[],U=v.filter(N=>{const $=A[N.socket];return $||O.push(N),$}),V=i(U,A,T);let x;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${O.length}`),O.length>0){const N=await new Promise($=>{(0,D.exec)("ps -F -A -l | grep root",(B,z,W)=>{$(z)})});this._foundRootPorts=r(O,N,this._foundRootPorts),x=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${x.join(", ")}`)}return V.then(N=>x?N.concat(x):N)}};c=je([ze(0,t.IExtHostRpcService),ze(1,R.IExtHostInitDataService),ze(2,F.ILogService)],c),e.ExtHostTunnelService=c}),define(ve[263],we([0,1,13,22,21,16,3,6,103,226,52]),function(Z,e,h,t,I,y,R,k,D,P,L){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function l(v,w){try{return JSON.stringify(v,w)}catch{return"null"}}const E="$$ref$$",p={[E]:-1};class m{constructor(w,A){this.jsonString=w,this.referencedBuffers=A}}function b(v,w=null,A=!1){const M=[];return{jsonString:(A?l:JSON.stringify)(v,(O,U)=>{if(typeof U=="undefined")return p;if(typeof U=="object"){if(U instanceof t.VSBuffer){const V=M.push(U)-1;return{[E]:V}}if(w)return w(O,U)}return U}),referencedBuffers:M}}e.stringifyJsonWithBufferRefs=b;function F(v,w,A){return JSON.parse(v,(M,T)=>{if(T){const O=T[E];if(typeof O=="number")return w[O];if(A&&T.$mid===1)return A.transformIncoming(T)}return T})}e.parseJsonAndRestoreBufferRefs=F;function _(v,w){return JSON.stringify(v,w)}function g(v){return v?(w,A)=>A&&A.$mid===1?v.transformOutgoing(A):A:null}var s;(function(v){v[v.LocalSide=0]="LocalSide",v[v.OtherSide=1]="OtherSide"})(s=e.RequestInitiator||(e.RequestInitiator={}));var d;(function(v){v[v.Responsive=0]="Responsive",v[v.Unresponsive=1]="Unresponsive"})(d=e.ResponsiveState||(e.ResponsiveState={}));const n=()=>{},S=Symbol.for("rpcProtocol"),o=Symbol.for("rpcProxy");class i extends k.Disposable{constructor(w,A=null,M=null){super();this[C]=!0,this._onDidChangeResponsiveState=this._register(new R.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=w,this._logger=A,this._uriTransformer=M,this._uriReplacer=g(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let T=0,O=L.ProxyIdentifier.count;T<O;T++)this._locals[T]=null,this._proxies[T]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new h.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(T=>this._receiveOneMessage(T))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(w=>{this._pendingRPCReplies[w].resolveErr(y.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(w){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(w){this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(w){this._responsiveState!==w&&(this._responsiveState=w,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(w){return this._uriTransformer?(0,D.transformIncomingURIs)(w,this._uriTransformer):w}getProxy(w){const{nid:A,sid:M}=w;return this._proxies[A]||(this._proxies[A]=this._createProxy(A,M)),this._proxies[A]}_createProxy(w,A){let M={get:(T,O)=>(typeof O=="string"&&!T[O]&&O.charCodeAt(0)===36&&(T[O]=(...U)=>this._remoteCall(w,O,U)),O===o?A:T[O])};return new Proxy(Object.create(null),M)}set(w,A){return this._locals[w.nid]=A,A}assertRegistered(w){for(let A=0,M=w.length;A<M;A++){const T=w[A];if(!this._locals[T.nid])throw new Error(`Missing proxy instance ${T.sid}`)}}_receiveOneMessage(w){if(this._isDisposed)return;const A=w.byteLength,M=r.read(w,0),T=M.readUInt8(),O=M.readUInt32();switch(T){case 1:case 2:{let{rpcId:U,method:V,args:x}=a.deserializeRequestJSONArgs(M);this._uriTransformer&&(x=(0,D.transformIncomingURIs)(x,this._uriTransformer)),this._receiveRequest(A,O,U,V,x,T===2);break}case 3:case 4:{let{rpcId:U,method:V,args:x}=a.deserializeRequestMixedArgs(M);this._uriTransformer&&(x=(0,D.transformIncomingURIs)(x,this._uriTransformer)),this._receiveRequest(A,O,U,V,x,T===4);break}case 5:{this._logger&&this._logger.logIncoming(A,O,0,"ack"),this._onDidReceiveAcknowledge(O);break}case 6:{this._receiveCancel(A,O);break}case 7:{this._receiveReply(A,O,void 0);break}case 9:{let U=a.deserializeReplyOKJSON(M);this._uriTransformer&&(U=(0,D.transformIncomingURIs)(U,this._uriTransformer)),this._receiveReply(A,O,U);break}case 10:{const U=a.deserializeReplyOKJSONWithBuffers(M,this._uriTransformer);this._receiveReply(A,O,U);break}case 8:{let U=a.deserializeReplyOKVSBuffer(M);this._receiveReply(A,O,U);break}case 11:{let U=a.deserializeReplyErrError(M);this._uriTransformer&&(U=(0,D.transformIncomingURIs)(U,this._uriTransformer)),this._receiveReplyErr(A,O,U);break}case 12:{this._receiveReplyErr(A,O,void 0);break}default:console.error("received unexpected message"),console.error(w)}}_receiveRequest(w,A,M,T,O,U){this._logger&&this._logger.logIncoming(w,A,1,`receiveRequest ${(0,L.getStringIdentifierForProxy)(M)}.${T}(`,O);const V=String(A);let x,N;if(U){const B=new I.CancellationTokenSource;O.push(B.token),x=this._invokeHandler(M,T,O),N=()=>B.cancel()}else x=this._invokeHandler(M,T,O),N=n;this._cancelInvokedHandlers[V]=N;const $=a.serializeAcknowledged(A);this._logger&&this._logger.logOutgoing($.byteLength,A,1,"ack"),this._protocol.send($),x.then(B=>{delete this._cancelInvokedHandlers[V];const z=a.serializeReplyOK(A,B,this._uriReplacer);this._logger&&this._logger.logOutgoing(z.byteLength,A,1,"reply:",B),this._protocol.send(z)},B=>{delete this._cancelInvokedHandlers[V];const z=a.serializeReplyErr(A,B);this._logger&&this._logger.logOutgoing(z.byteLength,A,1,"replyErr:",B),this._protocol.send(z)})}_receiveCancel(w,A){this._logger&&this._logger.logIncoming(w,A,1,"receiveCancel");const M=String(A);this._cancelInvokedHandlers[M]&&this._cancelInvokedHandlers[M]()}_receiveReply(w,A,M){this._logger&&this._logger.logIncoming(w,A,0,"receiveReply:",M);const T=String(A);if(!this._pendingRPCReplies.hasOwnProperty(T))return;const O=this._pendingRPCReplies[T];delete this._pendingRPCReplies[T],O.resolveOk(M)}_receiveReplyErr(w,A,M){this._logger&&this._logger.logIncoming(w,A,0,"receiveReplyErr:",M);const T=String(A);if(!this._pendingRPCReplies.hasOwnProperty(T))return;const O=this._pendingRPCReplies[T];delete this._pendingRPCReplies[T];let U;M&&(M.$isError?(U=new Error,U.name=M.name,U.message=M.message,U.stack=M.stack):U=M),O.resolveErr(U)}_invokeHandler(w,A,M){try{return Promise.resolve(this._doInvokeHandler(w,A,M))}catch(T){return Promise.reject(T)}}_doInvokeHandler(w,A,M){const T=this._locals[w];if(!T)throw new Error("Unknown actor "+(0,L.getStringIdentifierForProxy)(w));let O=T[A];if(typeof O!="function")throw new Error("Unknown method "+A+" on actor "+(0,L.getStringIdentifierForProxy)(w));return O.apply(T,M)}_remoteCall(w,A,M){if(this._isDisposed)return Promise.reject(y.canceled());let T=null;if(M.length>0&&I.CancellationToken.isCancellationToken(M[M.length-1])&&(T=M.pop()),T&&T.isCancellationRequested)return Promise.reject(y.canceled());const O=a.serializeRequestArguments(M,this._uriReplacer),U=++this._lastMessageId,V=String(U),x=new P.LazyPromise;T&&T.onCancellationRequested(()=>{const $=a.serializeCancel(U);this._logger&&this._logger.logOutgoing($.byteLength,U,0,"cancel"),this._protocol.send(a.serializeCancel(U))}),this._pendingRPCReplies[V]=x,this._onWillSendRequest(U);const N=a.serializeRequest(U,w,A,O,!!T);return this._logger&&this._logger.logOutgoing(N.byteLength,U,0,`request: ${(0,L.getStringIdentifierForProxy)(w)}.${A}(`,M),this._protocol.send(N),x}}e.RPCProtocol=i,C=S,i.UNRESPONSIVE_TIME=3*1e3;class r{constructor(w,A){this._buff=w,this._offset=A}static alloc(w,A,M){let T=new r(t.VSBuffer.alloc(M+1+4),0);return T.writeUInt8(w),T.writeUInt32(A),T}static read(w,A){return new r(w,A)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(w){this._buff.writeUInt8(w,this._offset),this._offset+=1}readUInt8(){const w=this._buff.readUInt8(this._offset);return this._offset+=1,w}writeUInt32(w){this._buff.writeUInt32BE(w,this._offset),this._offset+=4}readUInt32(){const w=this._buff.readUInt32BE(this._offset);return this._offset+=4,w}static sizeShortString(w){return 1+w.byteLength}writeShortString(w){this._buff.writeUInt8(w.byteLength,this._offset),this._offset+=1,this._buff.set(w,this._offset),this._offset+=w.byteLength}readShortString(){const w=this._buff.readUInt8(this._offset);this._offset+=1;const M=this._buff.slice(this._offset,this._offset+w).toString();return this._offset+=w,M}static sizeLongString(w){return 4+w.byteLength}writeLongString(w){this._buff.writeUInt32BE(w.byteLength,this._offset),this._offset+=4,this._buff.set(w,this._offset),this._offset+=w.byteLength}readLongString(){const w=this._buff.readUInt32BE(this._offset);this._offset+=4;const M=this._buff.slice(this._offset,this._offset+w).toString();return this._offset+=w,M}writeBuffer(w){this._buff.writeUInt32BE(w.byteLength,this._offset),this._offset+=4,this._buff.set(w,this._offset),this._offset+=w.byteLength}static sizeVSBuffer(w){return 4+w.byteLength}writeVSBuffer(w){this._buff.writeUInt32BE(w.byteLength,this._offset),this._offset+=4,this._buff.set(w,this._offset),this._offset+=w.byteLength}readVSBuffer(){const w=this._buff.readUInt32BE(this._offset);this._offset+=4;const A=this._buff.slice(this._offset,this._offset+w);return this._offset+=w,A}static sizeMixedArray(w){let A=0;A+=1;for(let M=0,T=w.length;M<T;M++){const O=w[M];switch(A+=1,O.type){case 1:A+=this.sizeLongString(O.value);break;case 2:A+=this.sizeVSBuffer(O.value);break;case 3:A+=this.sizeUInt32,A+=this.sizeLongString(O.value);for(let U=0;U<O.buffers.length;++U)A+=this.sizeVSBuffer(O.buffers[U]);break;case 4:break}}return A}writeMixedArray(w){this._buff.writeUInt8(w.length,this._offset),this._offset+=1;for(let A=0,M=w.length;A<M;A++){const T=w[A];switch(T.type){case 1:this.writeUInt8(1),this.writeLongString(T.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(T.value);break;case 3:this.writeUInt8(3),this.writeUInt32(T.buffers.length),this.writeLongString(T.value);for(let O=0;O<T.buffers.length;++O)this.writeBuffer(T.buffers[O]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const w=this._buff.readUInt8(this._offset);this._offset+=1;let A=new Array(w);for(let M=0;M<w;M++)switch(this.readUInt8()){case 1:A[M]=this.readLongString();break;case 2:A[M]=this.readVSBuffer();break;case 3:{const O=this.readUInt32(),U=this.readLongString(),V=[];for(let x=0;x<O;++x)V.push(this.readVSBuffer());A[M]=new L.SerializableObjectWithBuffers(F(U,V,null));break}case 4:A[M]=void 0;break}return A}}r.sizeUInt32=4;var c;(function(v){v[v.Simple=0]="Simple",v[v.Mixed=1]="Mixed"})(c||(c={}));class a{static _useMixedArgSerialization(w){for(let A=0,M=w.length;A<M;A++)if(w[A]instanceof t.VSBuffer||w[A]instanceof L.SerializableObjectWithBuffers||typeof w[A]=="undefined")return!0;return!1}static serializeRequestArguments(w,A){if(this._useMixedArgSerialization(w)){const M=[];for(let T=0,O=w.length;T<O;T++){const U=w[T];if(U instanceof t.VSBuffer)M[T]={type:2,value:U};else if(typeof U=="undefined")M[T]={type:4};else if(U instanceof L.SerializableObjectWithBuffers){const{jsonString:V,referencedBuffers:x}=b(U.value,A);M[T]={type:3,value:t.VSBuffer.fromString(V),buffers:x}}else M[T]={type:1,value:t.VSBuffer.fromString(_(U,A))}}return{type:1,args:M}}return{type:0,args:_(w,A)}}static serializeRequest(w,A,M,T,O){switch(T.type){case 0:return this._requestJSONArgs(w,A,M,T.args,O);case 1:return this._requestMixedArgs(w,A,M,T.args,O)}}static _requestJSONArgs(w,A,M,T,O){const U=t.VSBuffer.fromString(M),V=t.VSBuffer.fromString(T);let x=0;x+=r.sizeUInt8(),x+=r.sizeShortString(U),x+=r.sizeLongString(V);let N=r.alloc(O?2:1,w,x);return N.writeUInt8(A),N.writeShortString(U),N.writeLongString(V),N.buffer}static deserializeRequestJSONArgs(w){const A=w.readUInt8(),M=w.readShortString(),T=w.readLongString();return{rpcId:A,method:M,args:JSON.parse(T)}}static _requestMixedArgs(w,A,M,T,O){const U=t.VSBuffer.fromString(M);let V=0;V+=r.sizeUInt8(),V+=r.sizeShortString(U),V+=r.sizeMixedArray(T);let x=r.alloc(O?4:3,w,V);return x.writeUInt8(A),x.writeShortString(U),x.writeMixedArray(T),x.buffer}static deserializeRequestMixedArgs(w){const A=w.readUInt8(),M=w.readShortString(),T=w.readMixedArray(),O=new Array(T.length);for(let U=0,V=T.length;U<V;U++){const x=T[U];typeof x=="string"?O[U]=JSON.parse(x):O[U]=x}return{rpcId:A,method:M,args:O}}static serializeAcknowledged(w){return r.alloc(5,w,0).buffer}static serializeCancel(w){return r.alloc(6,w,0).buffer}static serializeReplyOK(w,A,M){if(typeof A=="undefined")return this._serializeReplyOKEmpty(w);if(A instanceof t.VSBuffer)return this._serializeReplyOKVSBuffer(w,A);if(A instanceof L.SerializableObjectWithBuffers){const{jsonString:T,referencedBuffers:O}=b(A.value,M,!0);return this._serializeReplyOKJSONWithBuffers(w,T,O)}else return this._serializeReplyOKJSON(w,l(A,M))}static _serializeReplyOKEmpty(w){return r.alloc(7,w,0).buffer}static _serializeReplyOKVSBuffer(w,A){let M=0;M+=r.sizeVSBuffer(A);let T=r.alloc(8,w,M);return T.writeVSBuffer(A),T.buffer}static deserializeReplyOKVSBuffer(w){return w.readVSBuffer()}static _serializeReplyOKJSON(w,A){const M=t.VSBuffer.fromString(A);let T=0;T+=r.sizeLongString(M);let O=r.alloc(9,w,T);return O.writeLongString(M),O.buffer}static _serializeReplyOKJSONWithBuffers(w,A,M){const T=t.VSBuffer.fromString(A);let O=0;O+=r.sizeUInt32,O+=r.sizeLongString(T);for(const V of M)O+=r.sizeVSBuffer(V);let U=r.alloc(10,w,O);U.writeUInt32(M.length),U.writeLongString(T);for(const V of M)U.writeBuffer(V);return U.buffer}static deserializeReplyOKJSON(w){const A=w.readLongString();return JSON.parse(A)}static deserializeReplyOKJSONWithBuffers(w,A){const M=w.readUInt32(),T=w.readLongString(),O=[];for(let U=0;U<M;++U)O.push(w.readVSBuffer());return new L.SerializableObjectWithBuffers(F(T,O,A))}static serializeReplyErr(w,A){return A?this._serializeReplyErrEror(w,A):this._serializeReplyErrEmpty(w)}static _serializeReplyErrEror(w,A){const M=t.VSBuffer.fromString(l(y.transformErrorForSerialization(A),null));let T=0;T+=r.sizeLongString(M);let O=r.alloc(11,w,T);return O.writeLongString(M),O.buffer}static deserializeReplyErrError(w){const A=w.readLongString();return JSON.parse(A)}static _serializeReplyErrEmpty(w){return r.alloc(12,w,0).buffer}}var u;(function(v){v[v.RequestJSONArgs=1]="RequestJSONArgs",v[v.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",v[v.RequestMixedArgs=3]="RequestMixedArgs",v[v.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",v[v.Acknowledged=5]="Acknowledged",v[v.Cancel=6]="Cancel",v[v.ReplyOKEmpty=7]="ReplyOKEmpty",v[v.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",v[v.ReplyOKJSON=9]="ReplyOKJSON",v[v.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",v[v.ReplyErrError=11]="ReplyErrError",v[v.ReplyErrEmpty=12]="ReplyErrEmpty"})(u||(u={}));var f;(function(v){v[v.String=1]="String",v[v.VSBuffer=2]="VSBuffer",v[v.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",v[v.Undefined=4]="Undefined"})(f||(f={}))}),define(ve[264],we([0,1,4]),function(Z,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,h.createDecorator)("remoteAgentService")}),define(ve[265],we([0,1,29,10,9,11,23,2,4,63,43,221,264]),function(Z,e,h,t,I,y,R,k,D,P,L,C,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,D.createDecorator)("pathService");let E=class qi{constructor(m,b,F,_){this.localUserHome=m,this.remoteAgentService=b,this.environmentService=F,this.contextService=_,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||y.OS)(),this.resolveUserHome=(async()=>{const g=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=g?.userHome||m})()}hasValidBasename(m,b,F){return typeof b=="string"||typeof b=="undefined"?this.resolveOS.then(_=>this.doHasValidBasename(m,_,b)):this.doHasValidBasename(m,b,F)}doHasValidBasename(m,b,F){return m.scheme===t.Schemas.file||m.scheme===t.Schemas.vscodeRemote?(0,h.isValidBasename)(F??(0,R.basename)(m),b===1):!0}get defaultUriScheme(){return qi.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(m,b){if(m.remoteAuthority)return t.Schemas.vscodeRemote;const F=(0,P.getVirtualWorkspaceScheme)(b.getWorkspace());if(F)return F;const _=b.getWorkspace().folders[0];if(_)return _.uri.scheme;const g=b.getWorkspace().configuration;return g?g.scheme:t.Schemas.file}async userHome(m){return m?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(m=>m===1?I.win32:I.posix)}async fileURI(m){let b="";if(await this.resolveOS===1&&(m=m.replace(/\\/g,"/")),m[0]==="/"&&m[1]==="/"){const _=m.indexOf("/",2);_===-1?(b=m.substring(2),m="/"):(b=m.substring(2,_),m=m.substring(_)||"/")}return k.URI.from({scheme:t.Schemas.file,authority:b,path:m,query:"",fragment:""})}};E=je([ze(1,l.IRemoteAgentService),ze(2,C.IWorkbenchEnvironmentService),ze(3,L.IWorkspaceContextService)],E),e.AbstractPathService=E}),define(ve[70],we([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class h{constructor(R,k){this.line=R,this.character=k}isBefore(R){return!1}isBeforeOrEqual(R){return!1}isAfter(R){return!1}isAfterOrEqual(R){return!1}isEqual(R){return!1}compareTo(R){return 0}translate(R,k){return new h(0,0)}with(R){return new h(0,0)}}e.Position=h;class t{constructor(R,k,D,P){this.isEmpty=!1,this.isSingleLine=!1,this.start=new h(R,k),this.end=new h(D,P)}contains(R){return!1}isEqual(R){return!1}intersection(R){}union(R){return new t(0,0,0,0)}with(R){return new t(0,0,0,0)}}e.Range=t;var I;(function(y){y[y.Information=1]="Information",y[y.Warning=2]="Warning"})(I=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(ve[31],we([0,1,17,32,25,29,8,4,9,16,70,13]),function(Z,e,h,t,I,y,R,k,D,P,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return L.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const l="\u27EA ",E=" characters skipped \u27EB",p=(l.length+E.length+5)*2;e.ISearchService=(0,k.createDecorator)("searchService");var m;(function($){$[$.file=0]="file",$[$.text=1]="text"})(m=e.SearchProviderType||(e.SearchProviderType={}));var b;(function($){$[$.File=1]="File",$[$.Text=2]="Text"})(b=e.QueryType||(e.QueryType={}));function F($){return!!$.preview}e.resultIsMatch=F;function _($){return!!$.resource}e.isFileMatch=_;function g($){return!!$.message}e.isProgressMessage=g;var s;(function($){$[$.Normal=0]="Normal",$[$.NewSearchStarted=1]="NewSearchStarted"})(s=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class d{constructor(B){this.resource=B,this.results=[]}}e.FileMatch=d;class n{constructor(B,z,W){this.ranges=z;const Y=Array.isArray(z)?z:[z];if(W&&W.matchLines===1&&S(Y)){B=(0,R.getNLines)(B,W.matchLines);let ie="",ne=0,J=0;const K=Math.floor(W.charsPerLine/5),oe=[];for(const fe of Y){const pe=Math.max(fe.startColumn-K,0),Te=fe.startColumn+W.charsPerLine;if(pe>J+K+p){const xe=l+(pe-J)+E;ie+=xe+B.slice(pe,Te),ne+=pe-(J+xe.length)}else ie+=B.slice(J,Te);oe.push(new i(0,fe.startColumn-ne,fe.endColumn-ne)),J=Te}this.preview={text:ie,matches:Array.isArray(this.ranges)?oe:oe[0]}}else{const ie=Array.isArray(z)?z[0].startLineNumber:z.startLineNumber;this.preview={text:B,matches:(0,h.mapArrayOrNot)(z,ne=>new o(ne.startLineNumber-ie,ne.startColumn,ne.endLineNumber-ie,ne.endColumn))}}}}e.TextSearchMatch=n;function S($){const B=$[0].startLineNumber;for(const z of $)if(z.startLineNumber!==B||z.endLineNumber!==B)return!1;return!0}class o{constructor(B,z,W,Y){this.startLineNumber=B,this.startColumn=z,this.endLineNumber=W,this.endColumn=Y}}e.SearchRange=o;class i extends o{constructor(B,z,W){super(B,z,B,W)}}e.OneLineRange=i;var r;(function($){$.Default="default",$.FileNames="fileNames",$.Type="type",$.Modified="modified",$.CountDescending="countDescending",$.CountAscending="countAscending"})(r=e.SearchSortOrder||(e.SearchSortOrder={}));function c($,B=!0){const z=$&&$.files&&$.files.exclude,W=B&&$&&$.search&&$.search.exclude;if(!z&&!W)return;if(!z||!W)return z||W;let Y=Object.create(null);return Y=I.mixin(Y,I.deepClone(z)),Y=I.mixin(Y,I.deepClone(W),!0),Y}e.getExcludes=c;function a($,B){return $.excludePattern&&t.match($.excludePattern,B)?!1:$.includePattern||$.usingSearchPaths?$.includePattern&&t.match($.includePattern,B)?!0:$.usingSearchPaths?!!$.folderQueries&&$.folderQueries.some(z=>{const W=z.folder.fsPath;if(y.isEqualOrParent(B,W)){const Y=D.relative(W,B);return!z.includePattern||!!t.match(z.includePattern,Y)}else return!1}):!1:!0}e.pathIncludedInQuery=a;var u;(function($){$[$.unknownEncoding=1]="unknownEncoding",$[$.regexParseError=2]="regexParseError",$[$.globParseError=3]="globParseError",$[$.invalidLiteral=4]="invalidLiteral",$[$.rgProcessError=5]="rgProcessError",$[$.other=6]="other",$[$.canceled=7]="canceled"})(u=e.SearchErrorCode||(e.SearchErrorCode={}));class f extends Error{constructor(B,z){super(B);this.code=z}}e.SearchError=f;function v($){const B=$.message;if((0,P.isCancellationError)($))return new f(B,u.canceled);try{const z=JSON.parse(B);return new f(z.message,z.code)}catch{return new f(B,u.other)}}e.deserializeSearchError=v;function w($){const B={message:$.message,code:$.code};return new Error(JSON.stringify(B))}e.serializeSearchError=w;function A($){return $.type==="error"?!0:$.type==="success"}e.isSerializedSearchComplete=A;function M($){return $.type==="success"}e.isSerializedSearchSuccess=M;function T($){return!!$.path}e.isSerializedFileMatch=T;function O($,B){const z=$.searchPath?$.searchPath:$.relativePath;return(0,R.fuzzyContains)(z,B)}e.isFilePatternMatch=O;class U{constructor(B){this.path=B,this.results=[]}addMatch(B){this.results.push(B)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=U;function V($,B){const z={...$||{},...B||{}};return Object.keys(z).filter(W=>{const Y=z[W];return typeof Y=="boolean"&&Y})}e.resolvePatternsForProvider=V;class x{constructor(B,z){this._parsedIncludeExpression=null,this._excludeExpression={...B.excludePattern||{},...z.excludePattern||{}},this._parsedExcludeExpression=t.parse(this._excludeExpression);let W=B.includePattern;z.includePattern&&(W?W={...W,...z.includePattern}:W=z.includePattern),W&&(this._parsedIncludeExpression=t.parse(W))}matchesExcludesSync(B,z,W){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(B,z,W))}includedInQuerySync(B,z,W){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(B,z,W)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(B,z,W))}includedInQuery(B,z,W){const Y=this._parsedExcludeExpression(B,z,W),ie=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(B,z,W):!0;return(0,C.isThenable)(Y)?Y.then(ne=>ne?!1:ie()):ie()}hasSiblingExcludeClauses(){return N(this._excludeExpression)}}e.QueryGlobTester=x;function N($){for(const B in $)if(typeof $[B]!="boolean")return!0;return!1}}),define(ve[35],we([0,1,17,13,21,3,24,10,94,23,8,18,2,170,4,12,189,43,44,26,14,15,7,31,5]),function(Z,e,h,t,I,y,R,k,D,P,L,C,l,E,p,m,b,F,_,g,s,d,n,S,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function i(A,M,T){return new P.ExtUri(O=>u(O,T)).isEqual(A,M)}function r(A,M,T){return i(A.uri,M.uri,T)?0:(0,L.compare)(A.uri.toString(),M.uri.toString())}function c(A,M,T){return A.index!==M.index?A.index<M.index?-1:1:i(A.uri,M.uri,T)?(0,L.compare)(A.name,M.name):(0,L.compare)(A.uri.toString(),M.uri.toString())}function a(A,M,T,O){const U=A.slice(0).sort((x,N)=>T(x,N,O)),V=M.slice(0).sort((x,N)=>T(x,N,O));return(0,h.delta)(U,V,(x,N)=>T(x,N,O))}function u(A,M){const T=M.getCapabilities(A.scheme);return!(T&&T&1024)}class f extends F.Workspace{constructor(M,T,O,U,V,x,N){super(M,O.map($=>new F.WorkspaceFolder($)),U,V,N);this._name=T,this._isUntitled=x,this._workspaceFolders=[],this._structure=R.TernarySearchTree.forUris(N),O.forEach($=>{this._workspaceFolders.push($),this._structure.set($.uri,$)})}static toExtHostWorkspace(M,T,O,U){if(!M)return{workspace:null,added:[],removed:[]};const{id:V,name:x,folders:N,configuration:$,transient:B,isUntitled:z}=M,W=[],Y=T;T?N.forEach((K,oe)=>{const fe=l.URI.revive(K.uri),pe=f._findFolder(O||T,fe,U);pe?(pe.name=K.name,pe.index=K.index,W.push(pe)):W.push({uri:fe,name:K.name,index:oe})}):W.push(...N.map(({uri:K,name:oe,index:fe})=>({uri:l.URI.revive(K),name:oe,index:fe}))),W.sort((K,oe)=>K.index<oe.index?-1:1);const ie=new f(V,x,W,!!B,$?l.URI.revive($):null,!!z,K=>u(K,U)),{added:ne,removed:J}=a(Y?Y.workspaceFolders:[],ie.workspaceFolders,r,U);return{workspace:ie,added:ne,removed:J}}static _findFolder(M,T,O){for(let U=0;U<M.folders.length;U++){const V=M.workspaceFolders[U];if(i(V.uri,T,O))return V}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(M,T){return T&&this._structure.get(M)&&(M=(0,P.dirname)(M)),this._structure.findSubstr(M)}resolveWorkspaceFolder(M){return this._structure.get(M)}}let v=class{constructor(M,T,O,U){this._onDidChangeWorkspace=new y.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new y.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=U,this._extHostFileSystemInfo=O,this._requestIdProvider=new D.Counter,this._barrier=new t.Barrier,this._proxy=M.getProxy(o.MainContext.MainThreadWorkspace),this._messageService=M.getProxy(o.MainContext.MainThreadMessageService);const V=T.workspace;this._confirmedWorkspace=V?new f(V.id,V.name,[],!!V.transient,V.configuration?l.URI.revive(V.configuration):null,!!V.isUntitled,x=>u(x,O)):void 0}$initializeWorkspace(M,T){this._trusted=T,this.$acceptWorkspaceData(M),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?l.URI.from({scheme:k.Schemas.untitled,path:(0,P.basename)((0,P.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(M,T,O,...U){const V=[];if(Array.isArray(U)&&U.forEach(z=>{l.URI.isUri(z.uri)&&!V.some(W=>i(W.uri,z.uri,this._extHostFileSystemInfo))&&V.push({uri:z.uri,name:z.name||(0,P.basenameOrAuthority)(z.uri)})}),this._unconfirmedWorkspace||[T,O].some(z=>typeof z!="number"||z<0)||O===0&&V.length===0)return!1;const x=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(T+O>x.length)return!1;const N=x.slice(0);N.splice(T,O,...V.map(z=>({uri:z.uri,name:z.name||(0,P.basenameOrAuthority)(z.uri),index:void 0})));for(let z=0;z<N.length;z++){const W=N[z];if(N.some((Y,ie)=>ie!==z&&i(W.uri,Y.uri,this._extHostFileSystemInfo)))return!1}N.forEach((z,W)=>z.index=W);const{added:$,removed:B}=a(x,N,c,this._extHostFileSystemInfo);if($.length===0&&B.length===0)return!1;if(this._proxy){const z=M.displayName||M.name;this._proxy.$updateWorkspaceFolders(z,T,O,V).then(void 0,W=>{this._unconfirmedWorkspace=void 0;const Y={source:{identifier:M.identifier,label:M.displayName||M.name}};this._messageService.$showMessage(b.Severity.Error,(0,E.localize)(0,null,z,W.toString()),Y,[])})}return this.trySetWorkspaceFolders(N),!0}getWorkspaceFolder(M,T){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(M,T)}async getWorkspaceFolder2(M,T){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(M,T)}async resolveWorkspaceFolder(M){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(M)}getPath(){if(!this._actualWorkspace)return;const{folders:M}=this._actualWorkspace;if(M.length!==0)return M[0].uri.fsPath}getRelativePath(M,T){let O,U="";if(typeof M=="string"?(O=l.URI.file(M),U=M):typeof M!="undefined"&&(O=M,U=M.fsPath),!O)return U;const V=this.getWorkspaceFolder(O,!0);if(!V)return U;typeof T=="undefined"&&this._actualWorkspace&&(T=this._actualWorkspace.folders.length>1);let x=(0,P.relativePath)(V.uri,O);return T&&V.name&&(x=`${V.name}/${x}`),x}trySetWorkspaceFolders(M){this._actualWorkspace&&(this._unconfirmedWorkspace=f.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:M,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(M){const{workspace:T,added:O,removed:U}=f.toExtHostWorkspace(M,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=T||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:O,removed:U}))}findFiles(M,T,O,U,V=I.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${U.value}, entryPoint: findFiles`);let x;if(T===null?x=!1:T&&(typeof T=="string"?x=T:x=T.pattern),V&&V.isCancellationRequested)return Promise.resolve([]);const{includePattern:N,folder:$}=w(d.GlobPattern.from(M));return this._proxy.$startFileSearch((0,C.withUndefinedAsNull)(N),(0,C.withUndefinedAsNull)($),(0,C.withUndefinedAsNull)(x),(0,C.withUndefinedAsNull)(O),V).then(B=>Array.isArray(B)?B.map(z=>l.URI.revive(z)):[])}async findTextInFiles(M,T,O,U,V=I.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${U.value}, entryPoint: findTextInFiles`);const x=this._requestIdProvider.getNext(),N=typeof T.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:T.previewOptions,{includePattern:$,folder:B}=w(d.GlobPattern.from(T.include)),z=typeof T.exclude=="string"?T.exclude:T.exclude?T.exclude.pattern:void 0,W={ignoreSymlinks:typeof T.followSymlinks=="boolean"?!T.followSymlinks:void 0,disregardIgnoreFiles:typeof T.useIgnoreFiles=="boolean"?!T.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof T.useGlobalIgnoreFiles=="boolean"?!T.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof T.useParentIgnoreFiles=="boolean"?!T.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof T.useDefaultExcludes=="boolean"?!T.useDefaultExcludes:!0,fileEncoding:T.encoding,maxResults:T.maxResults,previewOptions:N,afterContext:T.afterContext,beforeContext:T.beforeContext,includePattern:$,excludePattern:z},Y=!1;if(this._activeSearchCallbacks[x]=ie=>{if(Y)return;const ne=l.URI.revive(ie.resource);ie.results.forEach(J=>{(0,S.resultIsMatch)(J)?O({uri:ne,preview:{text:J.preview.text,matches:(0,h.mapArrayOrNot)(J.preview.matches,K=>new n.Range(K.startLineNumber,K.startColumn,K.endLineNumber,K.endColumn))},ranges:(0,h.mapArrayOrNot)(J.ranges,K=>new n.Range(K.startLineNumber,K.startColumn,K.endLineNumber,K.endColumn))}):O({uri:ne,text:J.text,lineNumber:J.lineNumber})})},V.isCancellationRequested)return{};try{const ie=await this._proxy.$startTextSearch(M,(0,C.withUndefinedAsNull)(B),W,x,V);return delete this._activeSearchCallbacks[x],ie||{}}catch(ie){throw delete this._activeSearchCallbacks[x],ie}}$handleTextSearchResult(M,T){this._activeSearchCallbacks[T]&&this._activeSearchCallbacks[T](M)}saveAll(M){return this._proxy.$saveAll(M)}resolveProxy(M){return this._proxy.$resolveProxy(M)}get trusted(){return this._trusted}requestWorkspaceTrust(M){return this._proxy.$requestWorkspaceTrust(M)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};v=je([ze(0,s.IExtHostRpcService),ze(1,g.IExtHostInitDataService),ze(2,_.IExtHostFileSystemInfo),ze(3,m.ILogService)],v),e.ExtHostWorkspace=v,e.IExtHostWorkspace=(0,p.createDecorator)("IExtHostWorkspace");function w(A){let M,T;return A&&(typeof A=="string"?M=A:(M=A.pattern,T=l.URI.revive(A.baseUri))),{includePattern:M,folder:T}}}),define(ve[36],we([0,1,25,3,35,5,7,193,119,18,13,4,14,12,2]),function(Z,e,h,t,I,y,R,k,D,P,L,C,l,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function m(S,o){if(o){const i=o.split(".");let r=S;for(let c=0;r&&c<i.length;c++)r=r[i[c]];return r}}function b(S){return S instanceof p.URI}function F(S){return S&&S.uri instanceof p.URI&&S.languageId&&typeof S.languageId=="string"}function _(S){return S&&!S.uri&&S.languageId&&typeof S.languageId=="string"}function g(S){return S&&S.uri instanceof p.URI&&(!S.name||typeof S.name=="string")&&(!S.index||typeof S.index=="number")}function s(S){if(b(S))return{resource:S};if(F(S))return{resource:S.uri,overrideIdentifier:S.languageId};if(_(S))return{overrideIdentifier:S.languageId};if(g(S))return{resource:S.uri};if(S===null)return{resource:null}}let d=class{constructor(o,i,r){this._proxy=o.getProxy(y.MainContext.MainThreadConfiguration),this._extHostWorkspace=i,this._logService=r,this._barrier=new L.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(o=>this._actual)}$initializeConfiguration(o){this._actual=new n(this._proxy,this._extHostWorkspace,o,this._logService),this._barrier.open()}$acceptConfigurationChanged(o,i){this.getConfigProvider().then(r=>r.$acceptConfigurationChanged(o,i))}};d=je([ze(0,l.IExtHostRpcService),ze(1,I.IExtHostWorkspace),ze(2,E.ILogService)],d),e.ExtHostConfiguration=d;class n{constructor(o,i,r,c){this._onDidChangeConfiguration=new t.Emitter,this._proxy=o,this._logService=c,this._extHostWorkspace=i,this._configuration=k.Configuration.parse(r),this._configurationScopes=this._toMap(r.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(o,i){const r={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=k.Configuration.parse(o),this._configurationScopes=this._toMap(o.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(i,r))}getConfiguration(o,i,r){const c=s(i)||{},a=this._toReadonlyValue(o?m(this._configuration.getValue(void 0,c,this._extHostWorkspace.workspace),o):this._configuration.getValue(void 0,c,this._extHostWorkspace.workspace));o&&this._validateConfigurationAccess(o,c,r?.identifier);function u(v){if(v==null)return null;if(typeof v=="boolean")return v?1:4;switch(v){case R.ConfigurationTarget.Global:return 1;case R.ConfigurationTarget.Workspace:return 4;case R.ConfigurationTarget.WorkspaceFolder:return 5}}const f={has(v){return typeof m(a,v)!="undefined"},get:(v,w)=>{this._validateConfigurationAccess(o?`${o}.${v}`:v,c,r?.identifier);let A=m(a,v);if(typeof A=="undefined")A=w;else{let M;const T=(O,U)=>{let V;const x=()=>{M=M||(0,h.deepClone)(a),V=V||m(M,U)};return(0,P.isObject)(O)?new Proxy(O,{get:(N,$)=>{if(typeof $=="string"&&$.toLowerCase()==="tojson")return x(),()=>V;if(M)return V=V||m(M,U),V[$];const B=N[$];return typeof $=="string"?T(B,`${U}.${$}`):B},set:(N,$,B)=>(x(),V&&(V[$]=B),!0),deleteProperty:(N,$)=>(x(),V&&delete V[$],!0),defineProperty:(N,$,B)=>(x(),V&&Object.defineProperty(V,$,B),!0)}):O};A=T(A,v)}return A},update:(v,w,A,M)=>{v=o?`${o}.${v}`:v;const T=u(A);return w!==void 0?this._proxy.$updateConfigurationOption(T,v,w,c,M):this._proxy.$removeConfigurationOption(T,v,c,M)},inspect:v=>{v=o?`${o}.${v}`:v;const w=(0,h.deepClone)(this._configuration.inspect(v,c,this._extHostWorkspace.workspace));if(w)return{key:v,defaultValue:w.default?.value,globalValue:w.user?.value,workspaceValue:w.workspace?.value,workspaceFolderValue:w.workspaceFolder?.value,defaultLanguageValue:w.default?.override,globalLanguageValue:w.user?.override,workspaceLanguageValue:w.workspace?.override,workspaceFolderLanguageValue:w.workspaceFolder?.override,languageIds:w.overrideIdentifiers}}};return typeof a=="object"&&(0,h.mixin)(f,a,!1),Object.freeze(f)}_toReadonlyValue(o){const i=r=>(0,P.isObject)(r)?new Proxy(r,{get:(c,a)=>i(c[a]),set:(c,a,u)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(a)}' of object`)},deleteProperty:(c,a)=>{throw new Error(`TypeError: Cannot delete read only property '${String(a)}' of object`)},defineProperty:(c,a)=>{throw new Error(`TypeError: Cannot define property '${String(a)}' for a readonly object`)},setPrototypeOf:c=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):r;return i(o)}_validateConfigurationAccess(o,i,r){const c=D.OVERRIDE_PROPERTY_REGEX.test(o)?4:this._configurationScopes.get(o),a=r?`[${r.value}] `:"";if(c===4){typeof i?.resource=="undefined"&&this._logService.warn(`${a}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${o}', provide the URI of a resource or 'null' for any resource.`);return}if(c===3){i?.resource&&this._logService.warn(`${a}Accessing a window scoped configuration for a resource is not expected. To associate '${o}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(o,i){const r=new k.ConfigurationChangeEvent(o,i,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(c,a)=>r.affectsConfiguration(c,s(a))})}_toMap(o){return o.reduce((i,r)=>(i.set(r[0],r[1]),i),new Map)}}e.ExtHostConfigProvider=n,e.IExtHostConfiguration=(0,C.createDecorator)("IExtHostConfiguration")});var nt=this&&this.__classPrivateFieldSet||function(Z,e,h,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!I:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(Z,h):I?I.value=h:e.set(Z,h),h},Fe=this&&this.__classPrivateFieldGet||function(Z,e,h,t){if(h==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?t:h==="a"?t.call(Z):t?t.value:e.get(Z)};define(ve[71],we([0,1,2,13,3,5,7,35,45,36,21,34,14,26,4,10,11,12,66,213,16]),function(Z,e,h,t,I,y,R,k,D,P,L,C,l,E,p,m,b,F,_,g,s){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var n;(function(U){function V(N){if(N!=null)return N}U.from=V;function x(N){if(N!=null)return N}U.to=x})(n=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var S;(function(U){function V(N){if(N!=null)return N}U.from=V;function x(N){if(N!=null)return N}U.to=x})(S=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var o;(function(U){function V(N){if(N!=null)return N}U.from=V;function x(N){if(N!=null)return N}U.to=x})(o=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var i;(function(U){function V($){if($){const B=$;return B&&!!B.process}else return!1}U.is=V;function x($){if($==null)return;const B={process:$.process,args:$.args};return $.options&&(B.options=o.from($.options)),B}U.from=x;function N($){if($!=null)return new R.ProcessExecution($.process,$.args,$.options)}U.to=N})(i=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var r;(function(U){function V(N){if(N!=null)return N}U.from=V;function x(N){if(N!=null)return N}U.to=x})(r=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var c;(function(U){function V($){if($){const B=$;return B&&(!!B.commandLine||!!B.command)}else return!1}U.is=V;function x($){if($==null)return;const B={};return $.commandLine!==void 0?B.commandLine=$.commandLine:(B.command=$.command,B.args=$.args),$.options&&(B.options=r.from($.options)),B}U.from=x;function N($){if(!($==null||$.command===void 0&&$.commandLine===void 0))return $.commandLine?new R.ShellExecution($.commandLine,$.options):new R.ShellExecution($.command,$.args?$.args:[],$.options)}U.to=N})(c=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var a;(function(U){function V($){if($){let B=$;return B&&B.customExecution==="customExecution"}else return!1}U.is=V;function x($){return{customExecution:"customExecution"}}U.from=x;function N($,B){return B.get($)}U.to=N})(a=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var u;(function(U){function V(x,N){let $;return x.scope!==void 0&&typeof x.scope!="number"?$=x.scope.uri:x.scope!==void 0&&typeof x.scope=="number"&&(x.scope===R.TaskScope.Workspace&&N&&N.workspaceFile?$=N.workspaceFile:$=g.USER_TASKS_GROUP_KEY),{id:x._id,workspaceFolder:$}}U.from=V})(u=e.TaskHandleDTO||(e.TaskHandleDTO={}));var f;(function(U){function V(x){if(x!=null)return{_id:x.id,isDefault:x.isDefault}}U.from=V})(f=e.TaskGroupDTO||(e.TaskGroupDTO={}));var v;(function(U){function V($,B){if($==null)return[];const z=[];for(let W of $){const Y=x(W,B);Y&&z.push(Y)}return z}U.fromMany=V;function x($,B){if($==null)return;let z;$.execution instanceof R.ProcessExecution?z=i.from($.execution):$.execution instanceof R.ShellExecution?z=c.from($.execution):$.execution&&$.execution instanceof R.CustomExecution&&(z=a.from($.execution));const W=n.from($.definition);let Y;return $.scope?typeof $.scope=="number"?Y=$.scope:Y=$.scope.uri:Y=R.TaskScope.Workspace,!W||!Y?void 0:{_id:$._id,definition:W,name:$.name,source:{extensionId:B.identifier.value,label:$.source,scope:Y},execution:z,isBackground:$.isBackground,group:f.from($.group),presentationOptions:S.from($.presentationOptions),problemMatchers:$.problemMatchers,hasDefinedMatchers:$.hasDefinedMatchers,runOptions:$.runOptions?$.runOptions:{reevaluateOnRerun:!0},detail:$.detail}}U.from=x;async function N($,B,z){if($==null)return;let W;i.is($.execution)?W=i.to($.execution):c.is($.execution)?W=c.to($.execution):a.is($.execution)&&(W=a.to($._id,z));const Y=n.to($.definition);let ie;if($.source&&($.source.scope!==void 0?typeof $.source.scope=="number"?ie=$.source.scope:ie=await B.resolveWorkspaceFolder(h.URI.revive($.source.scope)):ie=R.TaskScope.Workspace),!Y||!ie)return;const ne=new R.Task(Y,ie,$.name,$.source.label,W,$.problemMatchers);return $.isBackground!==void 0&&(ne.isBackground=$.isBackground),$.group!==void 0&&(ne.group=R.TaskGroup.from($.group._id),ne.group&&$.group.isDefault&&(ne.group=new R.TaskGroup(ne.group.id,ne.group.label),$.group.isDefault&&(ne.group.isDefault=$.group.isDefault))),$.presentationOptions&&(ne.presentationOptions=S.to($.presentationOptions)),$._id&&(ne._id=$._id),$.detail&&(ne.detail=$.detail),ne}U.to=N})(v=e.TaskDTO||(e.TaskDTO={}));var w;(function(U){function V(N){return N}U.from=V;function x(N){if(!!N)return Object.assign(Object.create(null),N)}U.to=x})(w=e.TaskFilterDTO||(e.TaskFilterDTO={}));class A{constructor(V,x,N){this._id=x,this._task=N,d.set(this,void 0),nt(this,d,V,"f")}get task(){return this._task}terminate(){Fe(this,d,"f").terminateTask(this)}fireDidStartProcess(V){}fireDidEndProcess(V){}}d=new WeakMap;var M;(function(U){function V(x){return{id:x._id,task:void 0}}U.from=V})(M=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let T=class{constructor(V,x,N,$,B,z,W,Y){this._onDidExecuteTask=new I.Emitter,this._onDidTerminateTask=new I.Emitter,this._onDidTaskProcessStarted=new I.Emitter,this._onDidTaskProcessEnded=new I.Emitter,this._proxy=V.getProxy(y.MainContext.MainThreadTask),this._workspaceProvider=N,this._editorService=$,this._configurationService=B,this._terminalService=z,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=W,this._deprecationService=Y,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(V,x,N){if(!N)return new R.Disposable(()=>{});const $=this.nextHandle();return this._handlers.set($,{type:x,provider:N,extension:V}),this._proxy.$registerTaskProvider($,x),new R.Disposable(()=>{this._handlers.delete($),this._proxy.$unregisterTaskProvider($)})}registerTaskSystem(V,x){this._proxy.$registerTaskSystem(V,x)}fetchTasks(V){return this._proxy.$fetchTasks(w.from(V)).then(async x=>{const N=[];for(let $ of x){const B=await v.to($,this._workspaceProvider,this._providedCustomExecutions2);B&&N.push(B)}return N})}get taskExecutions(){const V=[];return this._taskExecutions.forEach(x=>V.push(x)),V}terminateTask(V){if(!(V instanceof A))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(V._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(V,x,N){const $=this._providedCustomExecutions2.get(V.id);$&&(this._activeCustomExecutions2.set(V.id,$),this._terminalService.attachPtyToTerminal(x,await $.callback(N))),this._lastStartedTask=V.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(V)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(V){const x=await this.getTaskExecution(V);this._taskExecutionPromises.delete(V.id),this._taskExecutions.delete(V.id),this.customExecutionComplete(V),this._onDidTerminateTask.fire({execution:x})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(V){const x=await this.getTaskExecution(V.id);this._onDidTaskProcessStarted.fire({execution:x,processId:V.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(V){const x=await this.getTaskExecution(V.id);this._onDidTaskProcessEnded.fire({execution:x,exitCode:V.exitCode})}$provideTasks(V,x){const N=this._handlers.get(V);if(!N)return Promise.reject(new Error("no handler found"));const $=[],B=(0,t.asPromise)(()=>N.provider.provideTasks(L.CancellationToken.None)).then(z=>this.provideTasksInternal(x,$,N,z));return new Promise(z=>{B.then(W=>{Promise.all($).then(()=>{z(W)})})})}async $resolveTask(V,x){const N=this._handlers.get(V);if(!N)return Promise.reject(new Error("no handler found"));if(x.definition.type!==N.type)throw new Error(`Unexpected: Task of type [${x.definition.type}] cannot be resolved by provider of type [${N.type}].`);const $=await v.to(x,this._workspaceProvider,this._providedCustomExecutions2);if(!$)throw new Error("Unexpected: Task cannot be resolved.");const B=await N.provider.resolveTask($,L.CancellationToken.None);if(!B)return;this.checkDeprecation(B,N);const z=v.from(B,N.extension);if(!z)throw new Error("Unexpected: Task cannot be resolved.");if(B.definition!==$.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return a.is(z.execution)&&await this.addCustomExecution(z,B,!0),await this.resolveTaskInternal(z)}nextHandle(){return this._handleCounter++}async addCustomExecution(V,x,N){const $=await this._proxy.$createTaskId(V);!N&&!this._providedCustomExecutions2.has($)&&(this._notProvidedCustomExecutions.add($),this._activeCustomExecutions2.set($,x.execution)),this._providedCustomExecutions2.set($,x.execution)}async getTaskExecution(V,x){if(typeof V=="string"){const B=this._taskExecutionPromises.get(V);if(!B)throw new Error("Unexpected: The specified task is missing an execution");return B}let N=this._taskExecutionPromises.get(V.id);if(N)return N;const $=new Promise((B,z)=>{function W(Y,ie,ne){ne?B(new A(Y,ie.id,ne)):z("Unexpected: Task does not exist.")}x?W(this,V,x):v.to(V.task,this._workspaceProvider,this._providedCustomExecutions2).then(Y=>W(this,V,Y))});return this._taskExecutionPromises.set(V.id,$),$.then(B=>(this._taskExecutions.set(V.id,B),B),B=>Promise.reject(B))}checkDeprecation(V,x){V._deprecated&&this._deprecationService.report("Task.constructor",x.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(V){this._activeCustomExecutions2.get(V.id)&&this._activeCustomExecutions2.delete(V.id),this._notProvidedCustomExecutions.has(V.id)&&this._lastStartedTask!==V.id&&(this._providedCustomExecutions2.delete(V.id),this._notProvidedCustomExecutions.delete(V.id));let N=this._notProvidedCustomExecutions.values(),$=N.next();for(;!$.done;)!this._activeCustomExecutions2.has($.value)&&this._lastStartedTask!==$.value&&(this._providedCustomExecutions2.delete($.value),this._notProvidedCustomExecutions.delete($.value)),$=N.next()}};T=je([ze(0,l.IExtHostRpcService),ze(1,E.IExtHostInitDataService),ze(2,k.IExtHostWorkspace),ze(3,D.IExtHostDocumentsAndEditors),ze(4,P.IExtHostConfiguration),ze(5,C.IExtHostTerminalService),ze(6,F.ILogService),ze(7,_.IExtHostApiDeprecationService)],T),e.ExtHostTaskBase=T;let O=class extends T{constructor(V,x,N,$,B,z,W,Y){super(V,x,N,$,B,z,W,Y);this.registerTaskSystem(m.Schemas.vscodeRemote,{scheme:m.Schemas.vscodeRemote,authority:"",platform:b.PlatformToString(0)})}async executeTask(V,x){if(!x.execution)throw new Error("Tasks to execute must include an execution");const N=v.from(x,V);if(N===void 0)throw new Error("Task is not valid");if(a.is(N.execution))await this.addCustomExecution(N,x,!1);else throw new s.NotSupportedError;const $=await this.getTaskExecution(await this._proxy.$getTaskExecution(N),x);return this._proxy.$executeTask(N).catch(B=>{throw new Error(B)}),$}provideTasksInternal(V,x,N,$){const B=[];if($)for(let z of $){this.checkDeprecation(z,N),(!z.definition||!V[z.definition.type])&&this._logService.warn(`The task [${z.source}, ${z.name}] uses an undefined task type. The task will be ignored in the future.`);const W=v.from(z,N.extension);W&&a.is(W.execution)?(B.push(W),x.push(this.addCustomExecution(W,z,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:B,extension:N.extension}}async resolveTaskInternal(V){if(a.is(V.execution))return V;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(V,x){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(V,x,N){}};O=je([ze(0,l.IExtHostRpcService),ze(1,E.IExtHostInitDataService),ze(2,k.IExtHostWorkspace),ze(3,D.IExtHostDocumentsAndEditors),ze(4,P.IExtHostConfiguration),ze(5,C.IExtHostTerminalService),ze(6,F.ILogService),ze(7,_.IExtHostApiDeprecationService)],O),e.WorkerExtHostTask=O,e.IExtHostTask=(0,p.createDecorator)("IExtHostTask")}),define(ve[266],we([0,1,17,75,32,80,24,10,9,23,8,18,2,150,176,116,43,129,265,31]),function(Z,e,h,t,I,y,R,k,D,P,L,C,l,E,p,m,b,F,_,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let s=class{constructor(u,f,v,w){this.configurationService=u,this.workspaceContextService=f,this.editorGroupsService=v,this.pathService=w}text(u,f,v={}){u=this.getContentPattern(u,v);const w=this.configurationService.getValue(),A=f&&f.some(T=>!this.configurationService.getValue({resource:T}).search.useRipgrep);return{...this.commonQuery(f?.map(b.toWorkspaceFolder),v),type:2,contentPattern:u,previewOptions:v.previewOptions,maxFileSize:v.maxFileSize,usePCRE2:w.search.usePCRE2||A||!1,beforeContext:v.beforeContext,afterContext:v.afterContext,userDisabledExcludesAndIgnoreFiles:v.disregardExcludeSettings&&v.disregardIgnoreFiles}}getContentPattern(u,f){const v=this.configurationService.getValue();u.isRegExp&&(u.pattern=u.pattern.replace(/\r?\n/g,"\\n"));const w={...u,wordSeparators:v.editor.wordSeparators};return this.isCaseSensitive(u,f)&&(w.isCaseSensitive=!0),this.isMultiline(u)&&(w.isMultiline=!0),w}file(u,f={}){return{...this.commonQuery(u,f),type:1,filePattern:f.filePattern?f.filePattern.trim():f.filePattern,exists:f.exists,sortByScore:f.sortByScore,cacheKey:f.cacheKey}}handleIncludeExclude(u,f){return u?(u=Array.isArray(u)?u.map(i):i(u),f?this.parseSearchPaths(u):{pattern:n(...Array.isArray(u)?u:[u])}):{}}commonQuery(u=[],f={}){const v=this.handleIncludeExclude(f.includePattern,f.expandPatterns),w=this.handleIncludeExclude(f.excludePattern,f.expandPatterns),A=u.length>1,M=(v.searchPaths&&v.searchPaths.length?v.searchPaths.map(U=>this.getFolderQueryForSearchPath(U,f,w)):u.map(U=>this.getFolderQueryForRoot(U,f,w,A))).filter(U=>!!U),T={_reason:f._reason,folderQueries:M,usingSearchPaths:!!(v.searchPaths&&v.searchPaths.length),extraFileResources:f.extraFileResources,excludePattern:w.pattern,includePattern:v.pattern,onlyOpenEditors:f.onlyOpenEditors,maxResults:f.maxResults};if(f.onlyOpenEditors){const V=h.coalesce(h.flatten(this.editorGroupsService.groups.map(N=>N.editors.map($=>$.resource)))).filter(N=>(0,g.pathIncludedInQuery)(T,N.fsPath)),x=this.commonQueryFromFileList(V);return{...T,...x}}const O=f.extraFileResources&&f.extraFileResources.filter(U=>(0,g.pathIncludedInQuery)(T,U.fsPath));return T.extraFileResources=O&&O.length?O:void 0,T}commonQueryFromFileList(u){const f=[],v=new R.ResourceMap,w={};let A=!1;return u.forEach(M=>{if(M.scheme===k.Schemas.walkThrough)return;if((0,P.isAbsolutePath)(M)){const O=this.workspaceContextService.getWorkspaceFolder(M)?.uri??M.with({path:D.dirname(M.fsPath)});let U=v.get(O);U||(A=!0,U={folder:O,includePattern:{}},f.push(U),v.set(O,U));const V=D.relative(O.fsPath,M.fsPath);(0,C.assertIsDefined)(U.includePattern)[V.replace(/\\/g,"/")]=!0}else M.fsPath&&(A=!0,w[M.fsPath]=!0)}),{folderQueries:f,includePattern:w,usingSearchPaths:!0,excludePattern:A?void 0:{"**/*":!0}}}isCaseSensitive(u,f){if(f.isSmartCase){if(u.isRegExp){if(L.containsUppercaseCharacter(u.pattern,!0))return!0}else if(L.containsUppercaseCharacter(u.pattern))return!0}return!!u.isCaseSensitive}isMultiline(u){return u.isMultiline||u.isRegExp&&(0,E.isMultilineRegexSource)(u.pattern)||u.pattern.indexOf(`
`)>=0?!0:!!u.isMultiline}parseSearchPaths(u){const f=x=>D.isAbsolute(x)||/^\.\.?([\/\\]|$)/.test(x),w=(Array.isArray(u)?u:S(u)).map(x=>{const N=this.pathService.resolvedUserHome;return N?(0,y.untildify)(x,N.scheme===k.Schemas.file?N.fsPath:N.path):x}),A=t.groupBy(w,x=>f(x)?"searchPaths":"exprSegments"),M=(A.exprSegments||[]).map(x=>L.rtrim(x,"/")).map(x=>L.rtrim(x,"\\")).map(x=>(x[0]==="."&&(x="*"+x),o(x))),T={},O=this.expandSearchPathPatterns(A.searchPaths||[]);O&&O.length&&(T.searchPaths=O);const U=h.flatten(M),V=n(...U);return V&&(T.pattern=V),T}getExcludesForFolder(u,f){return f.disregardExcludeSettings?void 0:(0,g.getExcludes)(u,!f.disregardSearchExcludeSettings)}expandSearchPathPatterns(u){if(!u||!u.length)return[];const f=h.flatten(u.map(w=>{let{pathPortion:A,globPortion:M}=d(w);M&&(M=r(M));const T=this.expandOneSearchPath(A);return h.flatten(T.map(O=>this.resolveOneSearchPathPattern(O,M)))})),v=new Map;return f.forEach(w=>{const A=w.searchPath.toString(),M=v.get(A);M?w.pattern&&(M.pattern=M.pattern||{},M.pattern[w.pattern]=!0):v.set(A,{searchPath:w.searchPath,pattern:w.pattern?n(w.pattern):void 0})}),Array.from(v.values())}expandOneSearchPath(u){if(D.isAbsolute(u)){const f=this.workspaceContextService.getWorkspace().folders;return f[0]&&f[0].uri.scheme!==k.Schemas.file?[{searchPath:f[0].uri.with({path:u})}]:[{searchPath:l.URI.file(D.normalize(u))}]}if(this.workspaceContextService.getWorkbenchState()===2){const f=this.workspaceContextService.getWorkspace().folders[0].uri;if(u=i(u),u.startsWith("../")||u===".."){const w=D.posix.resolve(f.path,u);return[{searchPath:f.with({path:w})}]}const v=r(u);return[{searchPath:f,pattern:v}]}else{if(u==="./"||u===".\\")return[];{const f=u.replace(/^\.[\/\\]/,""),w=this.workspaceContextService.getWorkspace().folders.map(A=>{const M=f.match(new RegExp(`^${L.escapeRegExpCharacters(A.name)}(?:/(.*)|$)`));return M?{match:M,folder:A}:null}).filter(C.isDefined);if(w.length)return w.map(A=>{const M=A.match[1];return{searchPath:A.folder.uri,pattern:M&&r(M)}});{const A=u.match(/\.[\/\\](.+)[\/\\]?/),M=A?A[1]:u,T=p.localize(0,null,M);throw new Error(T)}}}}resolveOneSearchPathPattern(u,f){const v=u.pattern&&f?`${u.pattern}/${f}`:u.pattern||f,w=[{searchPath:u.searchPath,pattern:v}];return v&&!v.endsWith("**")&&w.push({searchPath:u.searchPath,pattern:v+"/**"}),w}getFolderQueryForSearchPath(u,f,v){const w=this.getFolderQueryForRoot((0,b.toWorkspaceFolder)(u.searchPath),f,v,!1);return w?{...w,includePattern:u.pattern}:null}getFolderQueryForRoot(u,f,v,w){let A;const M=l.URI.isUri(u)?u:u.uri;if(v.searchPaths){const x=v.searchPaths.filter(N=>(0,P.isEqual)(N.searchPath,M))[0];if(x&&!x.pattern)return null;x&&(A=x.pattern)}const T=this.configurationService.getValue({resource:M}),U={...this.getExcludesForFolder(T,f)||{},...A||{}},V=l.URI.isUri(u)?(0,P.basename)(u):u.name;return{folder:M,folderName:w?V:void 0,excludePattern:Object.keys(U).length>0?U:void 0,fileEncoding:T.files&&T.files.encoding,disregardIgnoreFiles:typeof f.disregardIgnoreFiles=="boolean"?f.disregardIgnoreFiles:!T.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof f.disregardGlobalIgnoreFiles=="boolean"?f.disregardGlobalIgnoreFiles:!T.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof f.disregardParentIgnoreFiles=="boolean"?f.disregardParentIgnoreFiles:!T.search.useParentIgnoreFiles,ignoreSymlinks:typeof f.ignoreSymlinks=="boolean"?f.ignoreSymlinks:!T.search.followSymlinks}}};s=je([ze(0,m.IConfigurationService),ze(1,b.IWorkspaceContextService),ze(2,F.IEditorGroupsService),ze(3,_.IPathService)],s),e.QueryBuilder=s;function d(a){const u=a.match(/[\*\{\}\(\)\[\]\?]/);if(u){const f=u.index,v=a.substr(0,f).match(/[/|\\][^/\\]*$/);if(v){let w=a.substr(0,v.index);return w.match(/[/\\]/)||(w+="/"),{pathPortion:w,globPortion:a.substr((v.index||0)+1)}}}return{pathPortion:a}}function n(...a){return a.length?a.reduce((u,f)=>(u[f]=!0,u),Object.create(null)):void 0}function S(a){return I.splitGlobAware(a,",").map(u=>u.trim()).filter(u=>!!u.length)}function o(a){return[`**/${a}/**`,`**/${a}`].map(f=>f.replace(/\*\*\/\*\*/g,"**"))}function i(a){return a.replace(/\\/g,"/")}function r(a){return i(a).replace(/^\.\//,"").replace(/\/+$/g,"")}function c(a,u){a=h.distinct(a,w=>w.toString());const f=[],v=u.getWorkspace();return a&&a.forEach(w=>{let A;if(u.getWorkbenchState()===2)A=(0,P.relativePath)(v.folders[0].uri,w),A&&A!=="."&&(A="./"+A);else{const M=u.getWorkspaceFolder(w);if(M){const T=M.name;if(v.folders.filter(U=>U.name===T).length===1){const U=(0,P.relativePath)(M.uri,w);U===""?A=`./${M.name}`:A=`./${M.name}/${U}`}else A=w.fsPath}}A&&f.push(A)}),f}e.resolveResourcesForSearchIncludes=c}),define(ve[267],we([0,1,23,2,21,16,4,266,31,43]),function(Z,e,h,t,I,y,R,k,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const L=7e3;function C(m,b){const F=b.activationEvents;if(!F)return Promise.resolve(void 0);const _=[],g=[];for(const i of F)if(/^workspaceContains:/.test(i)){const r=i.substr("workspaceContains:".length);r.indexOf("*")>=0||r.indexOf("?")>=0||m.forceUsingSearch?g.push(r):_.push(r)}if(_.length===0&&g.length===0)return Promise.resolve(void 0);let s;const d=new Promise((i,r)=>{s=i}),n=i=>s({activationEvent:i}),S=Promise.all(_.map(i=>l(m,i,n))).then(()=>{}),o=E(m,b.identifier,g,n);return Promise.all([S,o]).then(()=>{s(void 0)}),d}e.checkActivateWorkspaceContainsExtension=C;async function l(m,b,F){for(const _ of m.folders)if(await m.exists(h.joinPath(t.URI.revive(_),b))){F(`workspaceContains:${b}`);return}}async function E(m,b,F,_){if(F.length===0)return Promise.resolve(void 0);const g=new I.CancellationTokenSource,s=m.checkExists(m.folders,F,g.token),d=setTimeout(async()=>{g.cancel(),m.logService.info(`Not activating extension '${b.value}': Timed out while searching for 'workspaceContains' pattern ${F.join(",")}`)},L);let n=!1;try{n=await s}catch(S){y.isCancellationError(S)||y.onUnexpectedError(S)}g.dispose(),clearTimeout(d),n&&_(`workspaceContains:${F.join(",")}`)}function p(m,b,F,_){const g=m.get(R.IInstantiationService),s=m.get(D.ISearchService),n=g.createInstance(k.QueryBuilder).file(b.map(S=>(0,P.toWorkspaceFolder)(t.URI.revive(S))),{_reason:"checkExists",includePattern:F,exists:!0});return s.fileSearch(n,_).then(S=>!!S.limitHit,S=>y.isCancellationError(S)?!1:Promise.reject(S))}e.checkGlobFileExists=p});var nt=this&&this.__classPrivateFieldSet||function(Z,e,h,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!I:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(Z,h):I?I.value=h:e.set(Z,h),h},Fe=this&&this.__classPrivateFieldGet||function(Z,e,h,t){if(h==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?t:h==="a"?t.call(Z):t?t.value:e.get(Z)};define(ve[39],we([0,1,165,9,72,23,13,6,24,2,12,5,36,224,90,35,28,222,16,27,22,199,7,120,4,26,68,14,84,51,34,3,267,89,201,10]),function(Z,e,h,t,I,y,R,k,D,P,L,C,l,E,p,m,b,F,_,g,s,d,n,S,o,i,r,c,a,u,f,v,w,A,M,T){"use strict";var O,U,V;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,o.createDecorator)("IHostUtils");let x=class Gi extends k.Disposable{constructor(W,Y,ie,ne,J,K,oe,fe,pe,Te){super();this._onDidChangeRemoteConnectionData=this._register(new v.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=Y,this._extHostContext=ie,this._initData=oe,this._extHostWorkspace=ne,this._extHostConfiguration=J,this._logService=K,this._extHostTunnelService=pe,this._extHostTerminalService=Te,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(C.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(C.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(C.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new R.Barrier,this._readyToStartExtensionHost=new R.Barrier,this._readyToRunExtensions=new R.Barrier,this._eagerExtensionsActivated=new R.Barrier,this._registry=new F.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new p.ExtHostStorage(this._extHostContext),this._secretState=new A.ExtHostSecretState(this._extHostContext),this._storagePath=fe,this._instaService=W.createChild(new a.ServiceCollection([p.IExtHostStorage,this._storage],[A.IExtHostSecretState,this._secretState]));const xe=new Set;this._initData.hostExtensions.forEach(Ge=>xe.add(g.ExtensionIdentifier.toKey(Ge))),this._activator=this._register(new E.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(Ge,Qe,q)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(Ge,_.transformErrorForSerialization(Qe),q)},actualActivateExtension:async(Ge,Qe)=>{if(xe.has(g.ExtensionIdentifier.toKey(Ge)))return await this._mainThreadExtensionsProxy.$activateExtension(Ge,Qe),new E.HostExtension;const q=this._registry.getExtensionDescription(Ge);return this._activateExtension(q,Qe)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),I.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(W){_.onUnexpectedError(W)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let W=[];try{W=this._registry.getAllExtensionDescriptions().map(J=>J.identifier).filter(J=>this.isActivated(J)).map(J=>this._deactivate(J))}catch{}await Promise.all(W)}isActivated(W){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(W):!1}_activateByEvent(W,Y){return this._activator.activateByEvent(W,Y)}_activateById(W,Y){return this._activator.activateById(W,Y)}activateByIdWithErrors(W,Y){return this._activateById(W,Y).then(()=>{const ie=this._activator.getActivatedExtension(W);if(ie.activationFailed)return Promise.reject(ie.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(W=>this._registry)}getExtensionExports(W){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(W).exports:null}async _realPathExtensionUri(W){if(W.scheme!==T.Schemas.file)return W;const Y=await this._hostUtils.realpath(W.fsPath);return P.URI.file(Y)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=(async()=>{const W=D.TernarySearchTree.forUris(Y=>y.extUriBiasedIgnorePathCase.ignorePathCasing(Y));for(const Y of this._registry.getAllExtensionDescriptions())if(this._getEntryPoint(Y)){const ie=await this._realPathExtensionUri(Y.extensionLocation);W.set(ie,Y)}return W})()),this._extensionPathIndex}_deactivate(W){let Y=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(W))return Y;const ie=this._activator.getActivatedExtension(W);if(!ie)return Y;try{typeof ie.module.deactivate=="function"&&(Y=Promise.resolve(ie.module.deactivate()).then(void 0,ne=>(this._logService.error(ne),Promise.resolve(void 0))))}catch(ne){this._logService.error(`An error occurred when deactivating the extension '${W.value}':`),this._logService.error(ne)}try{(0,k.dispose)(ie.subscriptions)}catch(ne){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${W.value}':`),this._logService.error(ne)}return Y}async _activateExtension(W,Y){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(W.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(W.identifier),this._doActivateExtension(W,Y).then(ie=>{const ne=ie.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(W.identifier,ne.codeLoadingTime,ne.activateCallTime,ne.activateResolvedTime,Y),this._logExtensionActivationTimes(W,Y,"success",ne),ie},ie=>{throw this._logExtensionActivationTimes(W,Y,"failure"),ie})}_logExtensionActivationTimes(W,Y,ie,ne){const J=N(W,Y);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...J,...ne||{},outcome:ie})}_doActivateExtension(W,Y){const ie=N(W,Y);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",ie);const ne=this._getEntryPoint(W);if(!ne)return Promise.resolve(new E.EmptyExtension(E.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${W.identifier.value}, startup: ${Y.startup}, activationEvent: '${Y.activationEvent}'${W.identifier.value!==Y.extensionId.value?`, root cause: ${Y.extensionId.value}`:""}`),this._logService.flush();const J=new E.ExtensionActivationTimesBuilder(Y.startup);return Promise.all([this._loadCommonJSModule(W.identifier,(0,y.joinPath)(W.extensionLocation,ne),J),this._loadExtensionContext(W)]).then(K=>(I.mark(`code/extHost/willActivateExtension/${W.identifier.value}`),Gi._callActivate(this._logService,W.identifier,K[0],K[1],J))).then(K=>(I.mark(`code/extHost/didActivateExtension/${W.identifier.value}`),K))}_loadExtensionContext(W){const Y=new d.ExtensionGlobalMemento(W,this._storage),ie=new d.ExtensionMemento(W.identifier.value,!1,this._storage),ne=new M.ExtensionSecrets(W,this._secretState),J=W.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?n.ExtensionMode.Test:n.ExtensionMode.Development:n.ExtensionMode.Production,K=this._initData.remote.isRemote?n.ExtensionKind.Workspace:n.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${W.identifier.value}`),Promise.all([Y.whenReady,ie.whenReady,this._storagePath.whenReady]).then(()=>{const oe=this;let fe,pe;const Te=(0,b.isProposedApiEnabled)(W,"ipc")?this._initData.messagePorts?.get(g.ExtensionIdentifier.toKey(W.identifier)):void 0;return Object.freeze({globalState:Y,workspaceState:ie,secrets:ne,subscriptions:[],get extensionUri(){return W.extensionLocation},get extensionPath(){return W.extensionLocation.fsPath},asAbsolutePath(xe){return t.join(W.extensionLocation.fsPath,xe)},get storagePath(){return oe._storagePath.workspaceValue(W)?.fsPath},get globalStoragePath(){return oe._storagePath.globalValue(W).fsPath},get logPath(){return t.join(oe._initData.logsLocation.fsPath,W.identifier.value)},get logUri(){return P.URI.joinPath(oe._initData.logsLocation,W.identifier.value)},get storageUri(){return oe._storagePath.workspaceValue(W)},get globalStorageUri(){return oe._storagePath.globalValue(W)},get extensionMode(){return J},get extension(){return fe===void 0&&(fe=new $(oe,W.identifier,W,K)),fe},get extensionRuntime(){return(0,b.checkProposedApiEnabled)(W,"extensionRuntime"),oe.extensionRuntime},get environmentVariableCollection(){return oe._extHostTerminalService.getEnvironmentVariableCollection(W)},get messagePassingProtocol(){if(!pe){if(!Te)return;const xe=v.Event.buffer(v.Event.fromDOMEventEmitter(Te,"message",Ge=>Ge.data));Te.start(),pe={onDidReceiveMessage:xe,postMessage:Te.postMessage.bind(Te)}}return pe}})})}static _callActivate(W,Y,ie,ne,J){return ie=ie||{activate:void 0,deactivate:void 0},this._callActivateOptional(W,Y,ie,ne,J).then(K=>new E.ActivatedExtension(!1,null,J.build(),ie,K,ne.subscriptions))}static _callActivateOptional(W,Y,ie,ne,J){if(typeof ie.activate=="function")try{J.activateCallStart(),W.trace(`ExtensionService#_callActivateOptional ${Y.value}`);const K=typeof global=="object"?global:self,oe=ie.activate.apply(K,[ne]);return J.activateCallStop(),J.activateResolveStart(),Promise.resolve(oe).then(fe=>(J.activateResolveStop(),fe))}catch(K){return Promise.reject(K)}else return Promise.resolve(ie)}_activateOneStartupFinished(W,Y){this._activateById(W.identifier,{startup:!1,extensionId:W.identifier,activationEvent:Y}).then(void 0,ie=>{this._logService.error(ie)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(I.getMarks());for(const W of this._registry.getAllExtensionDescriptions())if(W.activationEvents)for(const Y of W.activationEvents)Y==="onStartupFinished"&&this._activateOneStartupFinished(W,Y)}_handleEagerExtensions(){const W=this._activateByEvent("*",!0).then(void 0,J=>{this._logService.error(J)});this._register(this._extHostWorkspace.onDidChangeWorkspace(J=>this._handleWorkspaceContainsEagerExtensions(J.added)));const Y=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],ie=this._handleWorkspaceContainsEagerExtensions(Y),ne=Promise.all([W,ie]).then(()=>{});return Promise.race([ne,(0,R.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),ne}_handleWorkspaceContainsEagerExtensions(W){return W.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(Y=>this._handleWorkspaceContainsEagerExtension(W,Y))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(W,Y){if(this.isActivated(Y.identifier))return;const ie=!this._initData.remote.isRemote&&!!this._initData.remote.authority,ne={logService:this._logService,folders:W.map(K=>K.uri),forceUsingSearch:ie,exists:K=>this._hostUtils.exists(K.fsPath),checkExists:(K,oe,fe)=>this._mainThreadWorkspaceProxy.$checkExists(K,oe,fe)},J=await(0,w.checkActivateWorkspaceContainsExtension)(ne,Y);if(!!J)return this._activateById(Y.identifier,{startup:!0,extensionId:Y.identifier,activationEvent:J.activationEvent}).then(void 0,K=>this._logService.error(K))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(W){throw console.error(W),W}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:W,extensionTestsLocationURI:Y}=this._initData.environment;if(!W||!Y)throw new Error(h.localize(0,null));const ie=await this._loadCommonJSModule(null,Y,new E.ExtensionActivationTimesBuilder(!1));if(!ie||typeof ie.run!="function")throw new Error(h.localize(1,null,Y.toString()));return new Promise((ne,J)=>{const K=(pe,Te)=>{pe?J(pe):ne(typeof Te=="number"&&Te>0?1:0)},oe=(0,y.originalFSPath)(Y),fe=ie.run(oe,K);fe&&fe.then&&fe.then(()=>{ne(0)}).catch(pe=>{J(pe instanceof Error&&pe.stack?pe.stack:String(pe))})})}async $extensionTestsExit(W){this._logService.info(`Extension host terminating: test runner requested exit with code ${W}`),this._hostUtils.pid&&this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${W}`),this._logService.flush(),this._hostUtils.exit(W)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(W,Y){return this._resolvers[W]=Y,(0,k.toDisposable)(()=>{delete this._resolvers[W]})}async _activateAndGetResolver(W){const Y=W.indexOf("+");if(Y===-1)throw new Error("Not an authority that can be resolved!");const ie=W.substr(0,Y);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${ie}`,!1),{authorityPrefix:ie,resolver:this._resolvers[ie]}}async $resolveAuthority(W,Y){this._logService.info(`$resolveAuthority invoked for authority (${B(W)})`);const{authorityPrefix:ie,resolver:ne}=await this._activateAndGetResolver(W);if(!ne)return{type:"error",error:{code:S.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${ie}.`,detail:void 0}};try{this._register(await this._extHostTunnelService.setTunnelFactory(ne)),I.mark(`code/extHost/willResolveAuthority/${ie}`);const J=await ne.resolve(W,{resolveAttempt:Y});I.mark(`code/extHost/didResolveAuthorityOK/${ie}`);const K={authority:W,host:J.host,port:J.port,connectionToken:J.connectionToken},oe={extensionHostEnv:J.extensionHostEnv,isTrusted:J.isTrusted,authenticationSession:J.authenticationSessionForInitializingExtensions?{id:J.authenticationSessionForInitializingExtensions.id,providerId:J.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:K,options:oe,tunnelInformation:{environmentTunnels:J.environmentTunnels,features:J.tunnelFeatures}}}}catch(J){if(I.mark(`code/extHost/didResolveAuthorityError/${ie}`),J instanceof n.RemoteAuthorityResolverError)return{type:"error",error:{code:J._code,message:J._message,detail:J._detail}};throw J}}async $getCanonicalURI(W,Y){this._logService.info(`$getCanonicalURI invoked for authority (${B(W)})`);const{authorityPrefix:ie,resolver:ne}=await this._activateAndGetResolver(W);if(!ne)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${ie}`);const J=P.URI.revive(Y);if(typeof ne.getCanonicalURI=="undefined")return J;const K=await(0,R.asPromise)(()=>ne.getCanonicalURI(J));return K||J}$startExtensionHost(W){return this._registry.keepOnly(W),this._startExtensionHost()}$activateByEvent(W,Y){return Y===1?this._activateByEvent(W,!1):this._readyToRunExtensions.wait().then(ie=>this._activateByEvent(W,!1))}async $activate(W,Y){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(W)?(await this._activateById(W,Y),!0):!1}async $deltaExtensions(W,Y){W.forEach(ne=>ne.extensionLocation=P.URI.revive(ne.extensionLocation));const ie=await this.getExtensionPathIndex();return await Promise.all(Y.map(async ne=>{const J=this._registry.getExtensionDescription(ne);J&&ie.delete(await this._realPathExtensionUri(J.extensionLocation))})),await Promise.all(W.map(async ne=>{const J=await this._realPathExtensionUri(ne.extensionLocation);ie.set(J,ne)})),this._registry.deltaExtensions(W,Y),Promise.resolve(void 0)}async $test_latency(W){return W}async $test_up(W){return W.byteLength}async $test_down(W){let Y=s.VSBuffer.alloc(W),ie=Math.random()%256;for(let ne=0;ne<W;ne++)Y.writeUInt8(ie,ne);return Y}async $updateRemoteConnectionData(W){this._remoteConnectionData=W,this._onDidChangeRemoteConnectionData.fire()}};x=je([ze(0,o.IInstantiationService),ze(1,e.IHostUtils),ze(2,c.IExtHostRpcService),ze(3,m.IExtHostWorkspace),ze(4,l.IExtHostConfiguration),ze(5,L.ILogService),ze(6,i.IExtHostInitDataService),ze(7,r.IExtensionStoragePaths),ze(8,u.IExtHostTunnelService),ze(9,f.IExtHostTerminalService)],x),e.AbstractExtHostExtensionService=x;function N(z,W){return{id:z.identifier.value,name:z.name,extensionVersion:z.version,publisherDisplayName:z.publisher,activationEvents:z.activationEvents?z.activationEvents.join(","):null,isBuiltin:z.isBuiltin,reason:W.activationEvent,reasonId:W.extensionId.value}}e.IExtHostExtensionService=(0,o.createDecorator)("IExtHostExtensionService");class ${constructor(W,Y,ie,ne){O.set(this,void 0),U.set(this,void 0),V.set(this,void 0),nt(this,O,W,"f"),nt(this,U,Y,"f"),nt(this,V,ie.identifier,"f"),this.id=ie.identifier.value,this.extensionUri=ie.extensionLocation,this.extensionPath=t.normalize((0,y.originalFSPath)(ie.extensionLocation)),this.packageJSON=ie,this.extensionKind=ne}get isActive(){return Fe(this,O,"f").isActivated(Fe(this,V,"f"))}get exports(){if(this.packageJSON.api!=="none")return Fe(this,O,"f").getExtensionExports(Fe(this,V,"f"))}activate(){return Fe(this,O,"f").activateByIdWithErrors(Fe(this,V,"f"),{startup:!1,extensionId:Fe(this,U,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=$,O=new WeakMap,U=new WeakMap,V=new WeakMap;function B(z){const W=z.indexOf("+");return W===-1?z:z.substring(0,W)}}),define(ve[54],we([0,1,9,2,3,13,5,7,125,35,39,45,215,36,208,14,4,18,40,53]),function(Z,e,h,t,I,y,R,k,D,P,L,C,l,E,p,m,b,F,_,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,b.createDecorator)("IExtHostDebugService");let s=class{constructor(a,u,f,v,w,A){this._workspaceService=u,this._extensionService=f,this._editorsService=v,this._configurationService=w,this._editorTabs=A,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new I.Emitter,this._onDidTerminateDebugSession=new I.Emitter,this._onDidChangeActiveDebugSession=new I.Emitter,this._onDidReceiveDebugSessionCustomEvent=new I.Emitter,this._debugServiceProxy=a.getProxy(R.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new I.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new n(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(M=>{M.onDidChange(T=>{this.registerAllDebugTypes(M)}),this.registerAllDebugTypes(M)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(a,u){const f=a;if(typeof f.sourceReference=="number"&&f.sourceReference>0){let v=`debug:${encodeURIComponent(f.path||"")}`,w="?";return u&&(v+=`${w}session=${encodeURIComponent(u.id)}`,w="&"),v+=`${w}ref=${f.sourceReference}`,t.URI.parse(v)}else{if(f.path)return t.URI.file(f.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(a){const u=[];for(const f of a.getAllExtensionDescriptions())if(f.contributes){const v=f.contributes.debuggers;if(v&&v.length>0)for(const w of v)(0,p.isDebuggerMainContribution)(w)&&u.push(w.type)}this._debugServiceProxy.$registerDebugTypes(u)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const a=[];return this._breakpoints.forEach(u=>a.push(u)),a}addBreakpoints(a){this.startBreakpoints();const u=a.filter(w=>{const A=w.id;return this._breakpoints.has(A)?!1:(this._breakpoints.set(A,w),!0)});this.fireBreakpointChanges(u,[],[]);const f=[],v=new Map;for(const w of u)if(w instanceof k.SourceBreakpoint){let A=v.get(w.location.uri.toString());A||(A={type:"sourceMulti",uri:w.location.uri,lines:[]},v.set(w.location.uri.toString(),A),f.push(A)),A.lines.push({id:w.id,enabled:w.enabled,condition:w.condition,hitCondition:w.hitCondition,logMessage:w.logMessage,line:w.location.range.start.line,character:w.location.range.start.character})}else w instanceof k.FunctionBreakpoint&&f.push({type:"function",id:w.id,enabled:w.enabled,hitCondition:w.hitCondition,logMessage:w.logMessage,condition:w.condition,functionName:w.functionName});return this._debugServiceProxy.$registerBreakpoints(f)}removeBreakpoints(a){this.startBreakpoints();const u=a.filter(A=>this._breakpoints.delete(A.id));this.fireBreakpointChanges([],u,[]);const f=u.filter(A=>A instanceof k.SourceBreakpoint).map(A=>A.id),v=u.filter(A=>A instanceof k.FunctionBreakpoint).map(A=>A.id),w=u.filter(A=>A instanceof k.DataBreakpoint).map(A=>A.id);return this._debugServiceProxy.$unregisterBreakpoints(f,v,w)}startDebugging(a,u,f){return this._debugServiceProxy.$startDebugging(a?a.uri:void 0,u,{parentSessionID:f.parentSession?f.parentSession.id:void 0,lifecycleManagedByParent:f.lifecycleManagedByParent,repl:f.consoleMode===k.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:f.noDebug,compact:f.compact,debugUI:f.debugUI,suppressSaveBeforeStart:f.suppressSaveBeforeStart})}stopDebugging(a){return this._debugServiceProxy.$stopDebugging(a?a.id:void 0)}registerDebugConfigurationProvider(a,u,f){if(!u)return new k.Disposable(()=>{});const v=this._configProviderHandleCounter++;return this._configProviders.push({type:a,handle:v,provider:u}),this._debugServiceProxy.$registerDebugConfigurationProvider(a,f,!!u.provideDebugConfigurations,!!u.resolveDebugConfiguration,!!u.resolveDebugConfigurationWithSubstitutedVariables,v),new k.Disposable(()=>{this._configProviders=this._configProviders.filter(w=>w.provider!==u),this._debugServiceProxy.$unregisterDebugConfigurationProvider(v)})}registerDebugAdapterDescriptorFactory(a,u,f){if(!f)return new k.Disposable(()=>{});if(!this.definesDebugType(a,u))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${u}' debugger.`);if(this.getAdapterDescriptorFactoryByType(u))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const v=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:u,handle:v,factory:f}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(u,v),new k.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(w=>w.factory!==f),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(v)})}registerDebugAdapterTrackerFactory(a,u){if(!u)return new k.Disposable(()=>{});const f=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:a,handle:f,factory:u}),new k.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(v=>v.factory!==u)})}async $runInTerminal(a,u){return Promise.resolve(void 0)}async $substituteVariables(a,u){if(!this._variableResolver){const[w,A]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(w||[],this._editorsService,A)}let f;const v=await this.getFolder(a);return v&&(f={uri:v.uri,name:v.name,index:v.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(f,u)}createDebugAdapter(a,u){if(a.type==="implementation")return new i(a.implementation)}createSignService(){}async $startDASession(a,u){const f=this,v=await this.getSession(u);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(v.type),v).then(w=>{if(!w)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${v.type}' (extension might have failed to activate)`);const A=this.convertToDto(w),M=this.createDebugAdapter(A,v);if(!M)throw new Error(`Couldn't create a debug adapter for type '${v.type}'.`);const T=M;return this._debugAdapters.set(a,T),this.getDebugAdapterTrackers(v).then(O=>(O&&this._debugAdaptersTrackers.set(a,O),T.onMessage(async U=>{if(U.type==="request"&&U.command==="handshake"){const V=U,x={type:"response",seq:0,command:V.command,request_seq:V.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const N=await this._signService.sign(V.arguments.value);x.body={signature:N},T.sendResponse(x)}else throw new Error("no signer")}catch(N){x.success=!1,x.message=N.message,T.sendResponse(x)}}else O&&O.onDidSendMessage&&O.onDidSendMessage(U),U=(0,p.convertToVSCPaths)(U,!0),f._debugServiceProxy.$acceptDAMessage(a,U)}),T.onError(U=>{O&&O.onError&&O.onError(U),this._debugServiceProxy.$acceptDAError(a,U.name,U.message,U.stack)}),T.onExit(U=>{O&&O.onExit&&O.onExit((0,F.withNullAsUndefined)(U),void 0),this._debugServiceProxy.$acceptDAExit(a,(0,F.withNullAsUndefined)(U),void 0)}),O&&O.onWillStartSession&&O.onWillStartSession(),T.startSession()))})}$sendDAMessage(a,u){u=(0,p.convertToDAPaths)(u,!1);const f=this._debugAdaptersTrackers.get(a);f&&f.onWillReceiveMessage&&f.onWillReceiveMessage(u);const v=this._debugAdapters.get(a);v&&v.sendMessage(u)}$stopDASession(a){const u=this._debugAdaptersTrackers.get(a);this._debugAdaptersTrackers.delete(a),u&&u.onWillStopSession&&u.onWillStopSession();const f=this._debugAdapters.get(a);return this._debugAdapters.delete(a),f?f.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(a){const u=[],f=[],v=[];if(a.added)for(const w of a.added){const A=w.id;if(A&&!this._breakpoints.has(A)){let M;if(w.type==="function")M=new k.FunctionBreakpoint(w.functionName,w.enabled,w.condition,w.hitCondition,w.logMessage);else if(w.type==="data")M=new k.DataBreakpoint(w.label,w.dataId,w.canPersist,w.enabled,w.hitCondition,w.condition,w.logMessage);else{const T=t.URI.revive(w.uri);M=new k.SourceBreakpoint(new k.Location(T,new k.Position(w.line,w.character)),w.enabled,w.condition,w.hitCondition,w.logMessage)}M._id=A,this._breakpoints.set(A,M),u.push(M)}}if(a.removed)for(const w of a.removed){const A=this._breakpoints.get(w);A&&(this._breakpoints.delete(w),f.push(A))}if(a.changed){for(const w of a.changed)if(w.id){const A=this._breakpoints.get(w.id);if(A){if(A instanceof k.FunctionBreakpoint&&w.type==="function"){const M=A;M.enabled=w.enabled,M.condition=w.condition,M.hitCondition=w.hitCondition,M.logMessage=w.logMessage,M.functionName=w.functionName}else if(A instanceof k.SourceBreakpoint&&w.type==="source"){const M=A;M.enabled=w.enabled,M.condition=w.condition,M.hitCondition=w.hitCondition,M.logMessage=w.logMessage,M.location=new k.Location(t.URI.revive(w.uri),new k.Position(w.line,w.character))}v.push(A)}}}this.fireBreakpointChanges(u,f,v)}$provideDebugConfigurations(a,u,f){return(0,y.asPromise)(async()=>{const v=this.getConfigProviderByHandle(a);if(!v)throw new Error("no DebugConfigurationProvider found");if(!v.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const w=await this.getFolder(u);return v.provideDebugConfigurations(w,f)}).then(v=>{if(!v)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return v})}$resolveDebugConfiguration(a,u,f,v){return(0,y.asPromise)(async()=>{const w=this.getConfigProviderByHandle(a);if(!w)throw new Error("no DebugConfigurationProvider found");if(!w.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const A=await this.getFolder(u);return w.resolveDebugConfiguration(A,f,v)})}$resolveDebugConfigurationWithSubstitutedVariables(a,u,f,v){return(0,y.asPromise)(async()=>{const w=this.getConfigProviderByHandle(a);if(!w)throw new Error("no DebugConfigurationProvider found");if(!w.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const A=await this.getFolder(u);return w.resolveDebugConfigurationWithSubstitutedVariables(A,f,v)})}async $provideDebugAdapter(a,u){const f=this.getAdapterDescriptorFactoryByHandle(a);if(!f)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const v=await this.getSession(u);return this.getAdapterDescriptor(f,v).then(w=>{if(!w)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${v.type}'`);return this.convertToDto(w)})}async $acceptDebugSessionStarted(a){const u=await this.getSession(a);this._onDidStartDebugSession.fire(u)}async $acceptDebugSessionTerminated(a){const u=await this.getSession(a);u&&(this._onDidTerminateDebugSession.fire(u),this._debugSessions.delete(u.id))}async $acceptDebugSessionActiveChanged(a){this._activeDebugSession=a?await this.getSession(a):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(a,u){const f=await this.getSession(a);f&&f._acceptNameChanged(u)}async $acceptDebugSessionCustomEvent(a,u){const v={session:await this.getSession(a),event:u.event,body:u.body};this._onDidReceiveDebugSessionCustomEvent.fire(v)}convertToDto(a){if(a instanceof k.DebugAdapterExecutable)return{type:"executable",command:a.command,args:a.args,options:a.options};if(a instanceof k.DebugAdapterServer)return{type:"server",port:a.port,host:a.host};if(a instanceof k.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:a.path};if(a instanceof k.DebugAdapterInlineImplementation)return{type:"implementation",implementation:a.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(a){const u=this._adapterFactories.filter(f=>f.type===a);if(u.length>0)return u[0].factory}getAdapterDescriptorFactoryByHandle(a){const u=this._adapterFactories.filter(f=>f.handle===a);if(u.length>0)return u[0].factory}getConfigProviderByHandle(a){const u=this._configProviders.filter(f=>f.handle===a);if(u.length>0)return u[0].provider}definesDebugType(a,u){if(a.contributes){const f=a.contributes.debuggers;if(f&&f.length>0){for(const v of f)if(v.label&&v.type&&v.type===u)return!0}}return!1}getDebugAdapterTrackers(a){const f=a.configuration.type,v=this._trackerFactories.filter(w=>w.type===f||w.type==="*").map(w=>(0,y.asPromise)(()=>w.factory.createDebugAdapterTracker(a)).then(A=>A,A=>null));return Promise.race([Promise.all(v).then(w=>{const A=w.filter(M=>!!M);if(A.length>0)return new o(A)}),new Promise((w,A)=>{const M=setTimeout(()=>{clearTimeout(M),A(new Error("timeout"))},1e3)})]).catch(w=>{})}async getAdapterDescriptor(a,u){const f=u.configuration.debugServer;if(typeof f=="number")return Promise.resolve(new k.DebugAdapterServer(f));if(a){const w=await this._extensionService.getExtensionRegistry();return(0,y.asPromise)(()=>a.createDebugAdapterDescriptor(u,this.daExecutableFromPackage(u,w))).then(A=>{if(A)return A})}const v=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(u,v))}daExecutableFromPackage(a,u){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(a,u,f){(a.length>0||u.length>0||f.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:a,removed:u,changed:f}))}async getSession(a){if(a)if(typeof a=="string"){const u=this._debugSessions.get(a);if(u)return u}else{let u=this._debugSessions.get(a.id);if(!u){const f=await this.getFolder(a.folderUri),v=a.parent?this._debugSessions.get(a.parent):void 0;u=new d(this._debugServiceProxy,a.id,a.type,a.name,f,a.configuration,v),this._debugSessions.set(u.id,u),this._debugServiceProxy.$sessionCached(u.id)}return u}throw new Error("cannot find session")}getFolder(a){if(a){const u=t.URI.revive(a);return this._workspaceService.resolveWorkspaceFolder(u)}return Promise.resolve(void 0)}};s=je([ze(0,m.IExtHostRpcService),ze(1,P.IExtHostWorkspace),ze(2,L.IExtHostExtensionService),ze(3,C.IExtHostDocumentsAndEditors),ze(4,E.IExtHostConfiguration),ze(5,g.IExtHostEditorTabs)],s),e.ExtHostDebugServiceBase=s;class d{constructor(a,u,f,v,w,A,M){this._debugServiceProxy=a,this._id=u,this._type=f,this._name=v,this._workspaceFolder=w,this._configuration=A,this._parentSession=M}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(a){this._name=a,this._debugServiceProxy.$setDebugSessionName(this._id,a)}get parentSession(){return this._parentSession}_acceptNameChanged(a){this._name=a}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(a,u){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,a,u)}getDebugProtocolBreakpoint(a){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,a.id)}}e.ExtHostDebugSession=d;class n{constructor(a){this.value=Object.freeze({append(u){a.$appendDebugConsole(u)},appendLine(u){this.append(u+`
`)}})}}e.ExtHostDebugConsole=n;class S extends l.AbstractVariableResolverService{constructor(a,u,f,v,w){function A(){if(u){const M=u.activeEditor();if(M)return M.document.uri;const T=v.tabs.filter(O=>O.isActive);if(T.length>0){const O=T[0].resource;return O&&(O.primary||O.secondary)?O.primary??O.secondary:T[0].resource}}}super({getFolderUri:M=>{const T=a.filter(O=>O.name===M);if(T&&T.length>0)return T[0].uri},getWorkspaceFolderCount:()=>a.length,getConfigurationValue:(M,T)=>f.getConfiguration(void 0,M).get(T),getAppRoot:()=>_.cwd(),getExecPath:()=>_.env.VSCODE_EXEC_PATH,getFilePath:()=>{const M=A();if(M)return h.normalize(M.fsPath)},getWorkspaceFolderPathForFile:()=>{if(w){const M=A();if(M){const T=w.getWorkspaceFolder(M);if(T)return h.normalize(T.uri.fsPath)}}},getSelectedText:()=>{if(u){const M=u.activeEditor();if(M&&!M.selection.isEmpty)return M.document.getText(M.selection)}},getLineNumber:()=>{if(u){const M=u.activeEditor();if(M)return String(M.selection.end.line+1)}}},void 0,Promise.resolve(_.env))}}e.ExtHostVariableResolverService=S;class o{constructor(a){this.trackers=a}onWillStartSession(){this.trackers.forEach(a=>a.onWillStartSession?a.onWillStartSession():void 0)}onWillReceiveMessage(a){this.trackers.forEach(u=>u.onWillReceiveMessage?u.onWillReceiveMessage(a):void 0)}onDidSendMessage(a){this.trackers.forEach(u=>u.onDidSendMessage?u.onDidSendMessage(a):void 0)}onWillStopSession(){this.trackers.forEach(a=>a.onWillStopSession?a.onWillStopSession():void 0)}onError(a){this.trackers.forEach(u=>u.onError?u.onError(a):void 0)}onExit(a,u){this.trackers.forEach(f=>f.onExit?f.onExit(a,u):void 0)}}class i extends D.AbstractDebugAdapter{constructor(a){super();this.implementation=a,a.onDidSendMessage(u=>{this.acceptMessage(u)})}startSession(){return Promise.resolve(void 0)}sendMessage(a){this.implementation.handleMessage(a)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let r=class extends s{constructor(a,u,f,v,w,A){super(a,u,f,v,w,A)}createVariableResolver(a,u,f){return new S(a,u,f,this._editorTabs)}};r=je([ze(0,m.IExtHostRpcService),ze(1,P.IExtHostWorkspace),ze(2,L.IExtHostExtensionService),ze(3,C.IExtHostDocumentsAndEditors),ze(4,E.IExtHostConfiguration),ze(5,g.IExtHostEditorTabs)],r),e.WorkerExtHostDebugService=r}),define(ve[268],we([0,1,72,2,5,36,28,27,14,26,4,39,40,12,8]),function(Z,e,h,t,I,y,R,k,D,P,L,C,l,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let m=class{constructor(d,n,S,o,i,r,c){this._apiFactory=d,this._extensionRegistry=n,this._instaService=S,this._extHostConfiguration=o,this._extHostExtensionService=i,this._initData=r,this._logService=c,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),h.mark("code/extHost/willWaitForConfig");const d=await this._extHostConfiguration.getConfigProvider();h.mark("code/extHost/didWaitForConfig");const n=await this._extHostExtensionService.getExtensionPathIndex();this.register(new F(this._apiFactory,n,this._extensionRegistry,d,this._logService)),this.register(this._instaService.createInstance(_,n)),this.register(this._instaService.createInstance(b)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(g,n,this._initData.environment.appUriScheme))}register(d){if("nodeModuleName"in d)if(Array.isArray(d.nodeModuleName))for(let n of d.nodeModuleName)this._factories.set(n,d);else this._factories.set(d.nodeModuleName,d);typeof d.alternativeModuleName=="function"&&this._alternatives.push(n=>d.alternativeModuleName(n))}};m=je([ze(2,L.IInstantiationService),ze(3,y.IExtHostConfiguration),ze(4,C.IExtHostExtensionService),ze(5,P.IExtHostInitDataService),ze(6,E.ILogService)],m),e.RequireInterceptor=m;let b=class zi{constructor(d){if(d.environment.appRoot&&zi.aliased.size){const n=(0,p.escapeRegExpCharacters)(this.forceForwardSlashes(d.environment.appRoot.fsPath)),S="[a-z0-9_.-]",o=`@${S}+\\/${S}+|${S}+`,i="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${n}/${i}\\/)(${o})(.*)$`,"i")}}alternativeModuleName(d){if(!this.re)return;const n=this.re.exec(this.forceForwardSlashes(d));if(!n)return;const[,S,o,i]=n,r=zi.aliased.get(o);if(r!==void 0)return console.warn(`${o} as been renamed to ${r}, please update your imports`),S+r+i}forceForwardSlashes(d){return d.replace(/\\/g,"/")}};b.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"]]),b=je([ze(0,P.IExtHostInitDataService)],b);class F{constructor(d,n,S,o,i){this._apiFactory=d,this._extensionPaths=n,this._extensionRegistry=S,this._configProvider=o,this._logService=i,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(d,n){const S=this._extensionPaths.findSubstr(n);if(S){let o=this._extApiImpl.get(k.ExtensionIdentifier.toKey(S.identifier));return o||(o=this._apiFactory(S,this._extensionRegistry,this._configProvider),this._extApiImpl.set(k.ExtensionIdentifier.toKey(S.identifier),o)),o}if(!this._defaultApiImpl){let o="";this._extensionPaths.forEach((i,r)=>o+=`	${r} -> ${i.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${n}. These are the extension path mappings: 
${o}`),this._defaultApiImpl=this._apiFactory(R.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let _=class{constructor(d,n,S){this._extensionPaths=d,this.nodeModuleName="keytar",this._mainThreadTelemetry=n.getProxy(I.MainContext.MainThreadTelemetry);const{environment:o}=S,i=n.getProxy(I.MainContext.MainThreadKeytar);if(o.appRoot){let r=o.appRoot.fsPath;l.platform==="win32"&&(r=r.replace(/\\/g,"/")),r[r.length-1]==="/"&&(r=r.substr(0,r.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${r}/node_modules.asar/keytar`),this.alternativeNames.add(`${r}/node_modules/keytar`)}this._impl={getPassword:(r,c)=>i.$getPassword(r,c),setPassword:(r,c,a)=>i.$setPassword(r,c,a),deletePassword:(r,c)=>i.$deletePassword(r,c),findPassword:r=>i.$findPassword(r),findCredentials(r){return i.$findCredentials(r)}}}load(d,n){const S=this._extensionPaths.findSubstr(n);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:S?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(d){const n=d.length;if(n<=7||!this.alternativeNames)return;const S=n-7;if((d.charAt(S)==="/"||d.charAt(S)==="\\")&&d.endsWith("keytar")&&(d=d.replace(/\\/g,"/"),this.alternativeNames.has(d)))return"keytar"}};_=je([ze(1,D.IExtHostRpcService),ze(2,P.IExtHostInitDataService)],_);let g=class{constructor(d,n,S){this._extensionPaths=d,this._appUriScheme=n,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=S.getProxy(I.MainContext.MainThreadTelemetry);const o=S.getProxy(I.MainContext.MainThreadWindow);this._impl=(i,r)=>{const c=t.URI.parse(i);return r?this.callOriginal(i,r):c.scheme==="http"||c.scheme==="https"?o.$openUri(c,i,{allowTunneling:!0}):c.scheme==="mailto"||c.scheme===this._appUriScheme?o.$openUri(c,i,{}):this.callOriginal(i,r)}}load(d,n,S){const o=this._extensionPaths.findSubstr(n);return o&&(this._extensionId=o.identifier.value,this.sendShimmingTelemetry()),this._original=S(d),this._impl}callOriginal(d,n){return this.sendNoForwardTelemetry(),this._original(d,n)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};g=je([ze(2,D.IExtHostRpcService)],g)}),define(ve[269],we([0,1,171,11,7,209,35,39,45,36,34,14,54,195,13,210,53]),function(Z,e,h,t,I,y,R,k,D,P,L,C,l,E,p,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let F=class extends l.ExtHostDebugServiceBase{constructor(s,d,n,S,o,i,r){super(s,d,n,S,o,r);this._terminalService=i,this._integratedTerminalInstances=new _}createDebugAdapter(s,d){switch(s.type){case"server":return new y.SocketDebugAdapter(s);case"pipeServer":return new y.NamedPipeDebugAdapter(s);case"executable":return new y.ExecutableDebugAdapter(s,d.type)}return super.createDebugAdapter(s,d)}daExecutableFromPackage(s,d){const n=y.ExecutableDebugAdapter.platformAdapterExecutable(d.getAllExtensionDescriptions(),s.type);if(n)return new I.DebugAdapterExecutable(n.command,n.args,n.options)}createSignService(){return new E.SignService}async $runInTerminal(s,d){if(s.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(A=>{this._integratedTerminalInstances.onTerminalClosed(A)}));const n=await this._configurationService.getConfigProvider(),S=this._terminalService.getDefaultShell(!0),o=this._terminalService.getDefaultShellArgs(!0),i=s.title||h.localize(0,null),r=JSON.stringify({shell:S,shellArgs:o});let c=await this._integratedTerminalInstances.checkout(r,i),a,u=!1;if(c)a=s.cwd;else{const A={shellPath:S,shellArgs:o,cwd:s.cwd,name:i,iconPath:new I.ThemeIcon("debug")};u=!0,c=this._terminalService.createTerminalFromOptions(A,{isFeatureTerminal:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(c,r)}c.show(!0);const f=await c.processId;u?await new Promise(A=>setTimeout(A,1e3)):n.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(S.indexOf("powershell")>=0||S.indexOf("pwsh")>=0||S.indexOf("cmd.exe")>=0?c.sendText("cls"):S.indexOf("bash")>=0?c.sendText("clear"):t.isWindows?c.sendText("cls"):c.sendText("clear"));const v=(0,m.prepareCommand)(S,s.args,a,s.env);c.sendText(v);const w=this.onDidTerminateDebugSession(A=>{A.id===d&&(this._integratedTerminalInstances.free(c),w.dispose())});return f}else if(s.kind==="external")return(0,m.runInExternalTerminal)(s,await this._configurationService.getConfigProvider());return super.$runInTerminal(s,d)}createVariableResolver(s,d,n){return new l.ExtHostVariableResolverService(s,d,n,this._editorTabs,this._workspaceService)}};F=je([ze(0,C.IExtHostRpcService),ze(1,R.IExtHostWorkspace),ze(2,k.IExtHostExtensionService),ze(3,D.IExtHostDocumentsAndEditors),ze(4,P.IExtHostConfiguration),ze(5,L.IExtHostTerminalService),ze(6,b.IExtHostEditorTabs)],F),e.ExtHostDebugService=F;class _{constructor(){this._terminalInstances=new Map}async checkout(s,d){const S=[...this._terminalInstances.entries()].map(([o,i])=>(0,p.createCancelablePromise)(async r=>{if(o.name!==d||i.lastUsedAt!==-1&&await(0,m.hasChildProcesses)(await o.processId))return null;const c=Date.now();return i.lastUsedAt+_.minUseDelay>c||r.isCancellationRequested||i.config!==s?null:(i.lastUsedAt=c,o)}));return await(0,p.firstParallel)(S,o=>!!o)}insert(s,d){this._terminalInstances.set(s,{lastUsedAt:Date.now(),config:d})}free(s){const d=this._terminalInstances.get(s);d&&(d.lastUsedAt=-1)}onTerminalClosed(s){this._terminalInstances.delete(s)}}_.minUseDelay=1e3}),define(ve[270],we([0,1,9,2,113,35,54,45,36,43,34,14,26,71,10,12,66,53,23,81]),function(Z,e,h,t,I,y,R,k,D,P,L,C,l,E,p,m,b,F,_,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let s=class extends E.ExtHostTaskBase{constructor(n,S,o,i,r,c,a,u,f){super(n,S,o,i,r,c,a,u);this.workspaceService=o,this.editorTabs=f,S.remote.isRemote&&S.remote.authority?this.registerTaskSystem(p.Schemas.vscodeRemote,{scheme:p.Schemas.vscodeRemote,authority:S.remote.authority,platform:process.platform}):this.registerTaskSystem(p.Schemas.file,{scheme:p.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(n,S){const o=S;if(!S.execution&&o._id===void 0)throw new Error("Tasks to execute must include an execution");if(o._id!==void 0){const i=E.TaskHandleDTO.from(o,this.workspaceService),r=await this._proxy.$getTaskExecution(i);if(r.task===void 0)throw new Error("Task from execution DTO is undefined");const c=await this.getTaskExecution(r,S);return this._proxy.$executeTask(i).catch(()=>{}),c}else{const i=E.TaskDTO.from(S,n);if(i===void 0)return Promise.reject(new Error("Task is not valid"));E.CustomExecutionDTO.is(i.execution)&&await this.addCustomExecution(i,S,!1);const r=await this.getTaskExecution(await this._proxy.$getTaskExecution(i),S);return this._proxy.$executeTask(i).catch(()=>{}),r}}provideTasksInternal(n,S,o,i){const r=[];if(i)for(let c of i){this.checkDeprecation(c,o),(!c.definition||!n[c.definition.type])&&this._logService.warn(`The task [${c.source}, ${c.name}] uses an undefined task type. The task will be ignored in the future.`);const a=E.TaskDTO.from(c,o.extension);a&&(r.push(a),E.CustomExecutionDTO.is(a.execution)&&S.push(this.addCustomExecution(a,c,!0)))}return{tasks:r,extension:o.extension}}async resolveTaskInternal(n){return n}async getVariableResolver(n){if(this._variableResolver===void 0){const S=await this._configurationService.getConfigProvider();this._variableResolver=new R.ExtHostVariableResolverService(n,this._editorService,S,this.editorTabs,this.workspaceService)}return this._variableResolver}async getAFolder(n){let S=n&&n.length>0?n[0]:void 0;if(!S){const o=t.URI.file((0,g.homedir)());S=new P.WorkspaceFolder({uri:o,name:_.basename(o),index:0})}return{uri:S.uri,name:S.name,index:S.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(n,S){const o=t.URI.revive(n),i={process:void 0,variables:Object.create(null)},r=await this._workspaceProvider.resolveWorkspaceFolder(o),c=await this._workspaceProvider.getWorkspaceFolders2()??[],a=await this.getVariableResolver(c),u=r?{uri:r.uri,name:r.name,index:r.index,toResource:()=>{throw new Error("Not implemented")}}:await this.getAFolder(c);for(let f of S.variables)i.variables[f]=await a.resolveAsync(u,f);if(S.process!==void 0){let f;if(S.process.path!==void 0){f=S.process.path.split(h.delimiter);for(let v=0;v<f.length;v++)f[v]=await a.resolveAsync(u,f[v])}i.process=await I.win32.findExecutable(await a.resolveAsync(u,S.process.name),S.process.cwd!==void 0?await a.resolveAsync(u,S.process.cwd):void 0,f)}return i}async $jsonTasksSupported(){return!0}async $findExecutable(n,S,o){return I.win32.findExecutable(n,S,o)}};s=je([ze(0,C.IExtHostRpcService),ze(1,l.IExtHostInitDataService),ze(2,y.IExtHostWorkspace),ze(3,k.IExtHostDocumentsAndEditors),ze(4,D.IExtHostConfiguration),ze(5,L.IExtHostTerminalService),ze(6,m.ILogService),ze(7,b.IExtHostApiDeprecationService),ze(8,F.IExtHostEditorTabs)],s),e.ExtHostTask=s}),define(ve[271],we([0,1,13,16,72,6,2,5,263,12,61,84,26,187,14,65,39,34]),function(Z,e,h,t,I,y,R,k,D,P,L,C,l,E,p,m,b,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class _{constructor(s,d,n,S,o){this._disposables=new y.DisposableStore,this._isTerminating=!1,this._hostUtils=n,this._rpcProtocol=new D.RPCProtocol(s,null,S),d=_._transform(d,this._rpcProtocol);const i=new C.ServiceCollection(...(0,L.getSingletonServiceDescriptors)());i.set(l.IExtHostInitDataService,{_serviceBrand:void 0,...d,messagePorts:o}),i.set(p.IExtHostRpcService,new p.ExtHostRpcService(this._rpcProtocol)),i.set(m.IURITransformerService,new m.URITransformerService(S)),i.set(b.IHostUtils,n);const r=new E.InstantiationService(i,!0);this._disposables.add(r.invokeFunction(f=>f.get(F.IExtHostTerminalService))),this._disposables.add(r.invokeFunction(f=>f.get(b.IExtHostExtensionService))),this._logService=r.invokeFunction(f=>f.get(P.ILogService)),I.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",d),this._extensionService=r.invokeFunction(f=>f.get(b.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const c=new WeakMap;this._extensionService.getExtensionPathIndex().then(f=>{Error.prepareStackTrace=(v,w)=>{let A="",M,T;for(const O of w)A+=`
	at ${O.toString()}`,T=O.getFileName(),!M&&T&&(M=f.findSubstr(R.URI.file(T)));return c.set(v,M),`${v.name||"Error"}: ${v.message||""}${A}`}});const a=this._rpcProtocol.getProxy(k.MainContext.MainThreadExtensionService),u=this._rpcProtocol.getProxy(k.MainContext.MainThreadErrors);t.setUnexpectedErrorHandler(f=>{const v=t.transformErrorForSerialization(f),w=c.get(f);w?a.$onExtensionRuntimeError(w.identifier,v):u.$onUnexpectedError(v)})}terminate(s){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${s}`),this._logService.flush(),this._disposables.dispose(),t.setUnexpectedErrorHandler(n=>{this._logService.error(n)}),this._rpcProtocol.dispose();const d=this._extensionService.deactivateAll();Promise.race([(0,h.timeout)(5e3),d]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code 0`):this._logService.info("Extension host exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})}static _transform(s,d){s.extensions.forEach(S=>S.extensionLocation=R.URI.revive(d.transformIncomingURIs(S.extensionLocation))),s.environment.appRoot=R.URI.revive(d.transformIncomingURIs(s.environment.appRoot));const n=s.environment.extensionDevelopmentLocationURI;return n&&(s.environment.extensionDevelopmentLocationURI=n.map(S=>R.URI.revive(d.transformIncomingURIs(S)))),s.environment.extensionTestsLocationURI=R.URI.revive(d.transformIncomingURIs(s.environment.extensionTestsLocationURI)),s.environment.globalStorageHome=R.URI.revive(d.transformIncomingURIs(s.environment.globalStorageHome)),s.environment.workspaceStorageHome=R.URI.revive(d.transformIncomingURIs(s.environment.workspaceStorageHome)),s.logsLocation=R.URI.revive(d.transformIncomingURIs(s.logsLocation)),s.logFile=R.URI.revive(d.transformIncomingURIs(s.logFile)),s.workspace=d.transformIncomingURIs(s.workspace),s}}e.ExtensionHostMain=_}),define(ve[272],we([0,1,9,21,49,32,23,46,31]),function(Z,e,h,t,I,y,R,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class P{constructor(l,E,p){this.config=l,this.provider=E,this.sessionToken=p,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=l.filePattern,this.includePattern=l.includePattern&&y.parse(l.includePattern),this.maxResults=l.maxResults||void 0,this.exists=l.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=l.excludePattern&&y.parse(l.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(l=>l.cancel()),this.activeCancellationTokens=new Set}search(l){const E=this.config.folderQueries||[];return new Promise((p,m)=>{const b=F=>{this.resultCount++,l(F)};if(this.isCanceled)return p({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(F=>{const _=F.toString(),g=h.basename(_);this.globalExcludePattern&&this.globalExcludePattern(_,g)||this.matchFile(b,{base:F,basename:g})}),Promise.all(E.map(F=>this.searchInFolder(F,b))).then(F=>{p({limitHit:this.isLimitHit,stats:F[0]||void 0})},F=>{m(new Error((0,I.toErrorMessage)(F)))})})}async searchInFolder(l,E){const p=new t.CancellationTokenSource,m=this.getSearchOptionsForFolder(l),b=this.initDirectoryTree(),F=new D.QueryGlobTester(this.config,l),_=!F.hasSiblingExcludeClauses();let g;try{this.activeCancellationTokens.add(p),g=k.StopWatch.create();const s=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},m,p.token),d=g.elapsed(),n=k.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(s&&s.forEach(S=>{const o=h.posix.relative(l.folder.path,S.path);if(_){const i=h.basename(S.path);this.matchFile(E,{base:l.folder,relativePath:o,basename:i});return}this.addDirectoryEntries(b,l.folder,o,E)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(b,F,E),{providerTime:d,postProcessTime:n.elapsed()})}finally{p.dispose(),this.activeCancellationTokens.delete(p)}}getSearchOptionsForFolder(l){const E=(0,D.resolvePatternsForProvider)(this.config.includePattern,l.includePattern),p=(0,D.resolvePatternsForProvider)(this.config.excludePattern,l.excludePattern);return{folder:l.folder,excludes:p,includes:E,useIgnoreFiles:!l.disregardIgnoreFiles,useGlobalIgnoreFiles:!l.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!l.disregardParentIgnoreFiles,followSymlinks:!l.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const l={rootEntries:[],pathToEntries:Object.create(null)};return l.pathToEntries["."]=l.rootEntries,l}addDirectoryEntries({pathToEntries:l},E,p,m){if(p===this.filePattern){const F=h.basename(this.filePattern);this.matchFile(m,{base:E,relativePath:this.filePattern,basename:F})}function b(F){const _=h.basename(F),g=h.dirname(F);let s=l[g];s||(s=l[g]=[],b(g)),s.push({base:E,relativePath:F,basename:_})}b(p)}matchDirectoryTree({rootEntries:l,pathToEntries:E},p,m){const b=this,F=this.filePattern;function _(g){const s=y.hasSiblingFn(()=>g.map(d=>d.basename));for(let d=0,n=g.length;d<n;d++){const S=g[d],{relativePath:o,basename:i}=S;if(p.matchesExcludesSync(o,i,F!==i?s:void 0))continue;const r=E[o];if(r)_(r);else{if(o===F)continue;b.matchFile(m,S)}if(b.isLimitHit)break}}_(l)}matchFile(l,E){(!this.includePattern||E.relativePath&&this.includePattern(E.relativePath,E.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||l(E))}}class L{constructor(){this.sessions=new Map}fileSearch(l,E,p,m){const b=this.getSessionTokenSource(l.cacheKey),F=new P(l,E,b&&b.token);let _=0;const g=s=>{_+=s.length,p(s.map(d=>this.rawMatchToSearchItem(d)))};return this.doSearch(F,L.BATCH_SIZE,g,m).then(s=>({limitHit:s.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:_,detailStats:s.stats}}))}clearCache(l){const E=this.getSessionTokenSource(l);E&&E.cancel()}getSessionTokenSource(l){if(!!l)return this.sessions.has(l)||this.sessions.set(l,new t.CancellationTokenSource),this.sessions.get(l)}rawMatchToSearchItem(l){return l.relativePath?{resource:R.joinPath(l.base,l.relativePath)}:{resource:l.base}}doSearch(l,E,p,m){m.onCancellationRequested(()=>{l.cancel()});const b=_=>{_&&(F.push(_),E>0&&F.length>=E&&(p(F),F=[]))};let F=[];return l.search(b).then(_=>(F.length&&p(F),_),_=>(F.length&&p(F),Promise.reject(_)))}}e.FileSearchManager=L,L.BATCH_SIZE=512}),define(ve[136],we([0,1,17,13,21,49,32,10,9,23,18,2,31]),function(Z,e,h,t,I,y,R,k,D,P,L,C,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class E{constructor(s,d,n,S){this.query=s,this.provider=d,this.fileUtils=n,this.processType=S,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(s,d){const n=this.query.folderQueries||[],S=new I.CancellationTokenSource;return d.onCancellationRequested(()=>S.cancel()),new Promise((o,i)=>{this.collector=new m(s);let r=!1;const c=(a,u)=>{if(!r&&!this.isLimitHit){const f=this.resultSize(a);F(a)&&typeof this.query.maxResults=="number"&&this.resultCount+f>this.query.maxResults&&(this.isLimitHit=!0,r=!0,S.cancel(),a=this.trimResultToSize(a,this.query.maxResults-this.resultCount));const v=this.resultSize(a);this.resultCount+=v,(v>0||!F(a))&&this.collector.add(a,u)}};Promise.all(n.map((a,u)=>this.searchInFolder(a,f=>c(f,u),S.token))).then(a=>{S.dispose(),this.collector.flush();const u=a.some(f=>!!f&&!!f.limitHit);o({limitHit:this.isLimitHit||u,messages:(0,h.flatten)(a.map(f=>f?.message?(0,L.isArray)(f.message)?f.message:[f.message]:[])),stats:{type:this.processType}})},a=>{S.dispose();const u=(0,y.toErrorMessage)(a);i(new Error(u))})})}resultSize(s){return F(s)?Array.isArray(s.ranges)?s.ranges.length:1:0}trimResultToSize(s,d){const n=Array.isArray(s.ranges)?s.ranges:[s.ranges],S=Array.isArray(s.preview.matches)?s.preview.matches:[s.preview.matches];return{ranges:n.slice(0,d),preview:{matches:S.slice(0,d),text:s.preview.text},uri:s.uri}}async searchInFolder(s,d,n){const S=new l.QueryGlobTester(this.query,s),o=[],i={report:a=>{if(!this.validateProviderResult(a))return;const u=s.folder.scheme===k.Schemas.file?R.hasSiblingPromiseFn(()=>this.fileUtils.readdir(P.dirname(a.uri))):void 0,f=P.relativePath(s.folder,a.uri);if(f){const v=S.includedInQuery(f,D.basename(f),u);(0,t.isThenable)(v)?o.push(v.then(w=>{w&&d(a)})):v&&d(a)}}},r=this.getSearchOptionsForFolder(s),c=await this.provider.provideTextSearchResults(p(this.query.contentPattern),r,i,n);return o.length&&await Promise.all(o),c}validateProviderResult(s){if(F(s)){if(Array.isArray(s.ranges)){if(!Array.isArray(s.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(s.preview.matches.length!==s.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(s.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(s){const d=(0,l.resolvePatternsForProvider)(this.query.includePattern,s.includePattern),n=(0,l.resolvePatternsForProvider)(this.query.excludePattern,s.excludePattern),S={folder:C.URI.from(s.folder),excludes:n,includes:d,useIgnoreFiles:!s.disregardIgnoreFiles,useGlobalIgnoreFiles:!s.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!s.disregardParentIgnoreFiles,followSymlinks:!s.ignoreSymlinks,encoding:s.fileEncoding&&this.fileUtils.toCanonicalName(s.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return S.usePCRE2=this.query.usePCRE2,S}}e.TextSearchManager=E;function p(g){return{isCaseSensitive:g.isCaseSensitive||!1,isRegExp:g.isRegExp||!1,isWordMatch:g.isWordMatch||!1,isMultiline:g.isMultiline||!1,pattern:g.pattern}}class m{constructor(s){this._onResult=s,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new _(512,d=>this.sendItems(d))}add(s,d){this._currentFileMatch&&(this._currentFolderIdx!==d||!P.isEqual(this._currentUri,s.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=d,this._currentFileMatch={resource:s.uri,results:[]}),this._currentFileMatch.results.push(b(s))}pushToCollector(){const s=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,s)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(s){this._onResult(s)}}e.TextSearchResultsCollector=m;function b(g){return F(g)?{preview:{matches:(0,h.mapArrayOrNot)(g.preview.matches,s=>({startLineNumber:s.start.line,startColumn:s.start.character,endLineNumber:s.end.line,endColumn:s.end.character})),text:g.preview.text},ranges:(0,h.mapArrayOrNot)(g.ranges,s=>({startLineNumber:s.start.line,startColumn:s.start.character,endLineNumber:s.end.line,endColumn:s.end.character}))}:{text:g.text,lineNumber:g.lineNumber}}function F(g){return!!g.preview}e.extensionResultIsMatch=F;class _{constructor(s,d){this.maxBatchSize=s,this.cb=d,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(s,d){!s||this.addItemToBatch(s,d)}addItems(s,d){!s||this.addItemsToBatch(s,d)}addItemToBatch(s,d){this.batch.push(s),this.batchSize+=d,this.onUpdate()}addItemsToBatch(s,d){this.batch=this.batch.concat(s),this.batchSize+=d,this.onUpdate()}onUpdate(){this.totalNumberCompleted<_.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},_.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=_,_.TIMEOUT=4e3,_.START_BATCH_AFTER_COUNT=50}),define(ve[73],we([0,1,6,5,4,272,14,65,12,2,136]),function(Z,e,h,t,I,y,R,k,D,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,I.createDecorator)("IExtHostSearch");let C=class{constructor(m,b,F){this.extHostRpc=m,this._uriTransformer=b,this._logService=F,this._proxy=this.extHostRpc.getProxy(t.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new y.FileSearchManager}_transformScheme(m){return this._uriTransformer.transformOutgoingScheme(m)}registerTextSearchProvider(m,b){if(this._textSearchUsedSchemes.has(m))throw new Error(`a text search provider for the scheme '${m}' is already registered`);this._textSearchUsedSchemes.add(m);const F=this._handlePool++;return this._textSearchProvider.set(F,b),this._proxy.$registerTextSearchProvider(F,this._transformScheme(m)),(0,h.toDisposable)(()=>{this._textSearchUsedSchemes.delete(m),this._textSearchProvider.delete(F),this._proxy.$unregisterProvider(F)})}registerFileSearchProvider(m,b){if(this._fileSearchUsedSchemes.has(m))throw new Error(`a file search provider for the scheme '${m}' is already registered`);this._fileSearchUsedSchemes.add(m);const F=this._handlePool++;return this._fileSearchProvider.set(F,b),this._proxy.$registerFileSearchProvider(F,this._transformScheme(m)),(0,h.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(m),this._fileSearchProvider.delete(F),this._proxy.$unregisterProvider(F)})}$provideFileSearchResults(m,b,F,_){const g=l(F),s=this._fileSearchProvider.get(m);if(s)return this._fileSearchManager.fileSearch(g,s,d=>{this._proxy.$handleFileMatch(m,b,d.map(n=>n.resource))},_);throw new Error("unknown provider: "+m)}$clearCache(m){return this._fileSearchManager.clearCache(m),Promise.resolve(void 0)}$provideTextSearchResults(m,b,F,_){const g=this._textSearchProvider.get(m);if(!g||!g.provideTextSearchResults)throw new Error(`Unknown provider ${m}`);const s=l(F);return this.createTextSearchManager(s,g).search(n=>this._proxy.$handleTextMatch(m,b,n),_)}$enableExtensionHostSearch(){}createTextSearchManager(m,b){return new L.TextSearchManager(m,b,{readdir:F=>Promise.resolve([]),toCanonicalName:F=>F},"textSearchProvider")}};C=je([ze(0,R.IExtHostRpcService),ze(1,k.IURITransformerService),ze(2,D.ILogService)],C),e.ExtHostSearch=C;function l(p){return{...p,folderQueries:p.folderQueries&&p.folderQueries.map(E),extraFileResources:p.extraFileResources&&p.extraFileResources.map(m=>P.URI.revive(m))}}e.reviveQuery=l;function E(p){return{...p,folder:P.URI.revive(p.folder)}}}),define(ve[273],we([0,1,61,134,35,132,36,38,45,34,71,54,73,90,51,66,135,67,44,89,123,53,133,12,225]),function(Z,e,h,t,I,y,R,k,D,P,L,C,l,E,p,m,b,F,_,g,s,d,n,S,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,h.registerSingleton)(S.ILoggerService,n.ExtHostLoggerService),(0,h.registerSingleton)(S.ILogService,o.ExtHostLogService),(0,h.registerSingleton)(m.IExtHostApiDeprecationService,m.ExtHostApiDeprecationService),(0,h.registerSingleton)(k.IExtHostCommands,k.ExtHostCommands),(0,h.registerSingleton)(R.IExtHostConfiguration,R.ExtHostConfiguration),(0,h.registerSingleton)(F.IExtHostConsumerFileSystem,F.ExtHostConsumerFileSystem),(0,h.registerSingleton)(C.IExtHostDebugService,C.WorkerExtHostDebugService),(0,h.registerSingleton)(y.IExtHostDecorations,y.ExtHostDecorations),(0,h.registerSingleton)(D.IExtHostDocumentsAndEditors,D.ExtHostDocumentsAndEditors),(0,h.registerSingleton)(_.IExtHostFileSystemInfo,_.ExtHostFileSystemInfo),(0,h.registerSingleton)(t.IExtHostOutputService,t.ExtHostOutputService),(0,h.registerSingleton)(l.IExtHostSearch,l.ExtHostSearch),(0,h.registerSingleton)(E.IExtHostStorage,E.ExtHostStorage),(0,h.registerSingleton)(L.IExtHostTask,L.WorkerExtHostTask),(0,h.registerSingleton)(P.IExtHostTerminalService,P.WorkerExtHostTerminalService),(0,h.registerSingleton)(p.IExtHostTunnelService,p.ExtHostTunnelService),(0,h.registerSingleton)(b.IExtHostWindow,b.ExtHostWindow),(0,h.registerSingleton)(I.IExtHostWorkspace,I.ExtHostWorkspace),(0,h.registerSingleton)(g.IExtHostSecretState,g.ExtHostSecretState),(0,h.registerSingleton)(s.IExtHostTelemetry,s.ExtHostTelemetry),(0,h.registerSingleton)(d.IExtHostEditorTabs,d.ExtHostEditorTabs)}),define(ve[91],we([0,1,17,12,31,70]),function(Z,e,h,t,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function R(C){return C.startsWith("**")||C.startsWith("/")?C:`/${C}`}e.anchorGlob=R;function k(C,l,E,p){const m=(0,h.mapArrayOrNot)(E,D),b=new I.TextSearchMatch(l,m,p),F=b.preview.matches;return{ranges:(0,h.mapArrayOrNot)(m,P),uri:C,preview:{text:b.preview.text,matches:(0,h.mapArrayOrNot)(F,P)}}}e.createTextSearchResult=k;function D(C){return new I.SearchRange(C.start.line,C.start.character,C.end.line,C.end.character)}function P(C){return new y.Range(C.startLineNumber,C.startColumn,C.endLineNumber,C.endColumn)}let L=class{constructor(l,E){this.prefix=l,this.logService=E}appendLine(l){this.logService.debug(`${this.prefix}#search`,l)}};L=je([ze(1,t.ILogService)],L),e.OutputChannel=L}),define(ve[274],we([0,1,37,9,79,29,11,8,91,275]),function(Z,e,h,t,I,y,R,k,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const L=P.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function C(g,s,d,n){const S=l(g,s,d,n),o=s.folder.fsPath;return{cmd:h.spawn(L,S.args,{cwd:o}),rgDiskPath:L,siblingClauses:S.siblingClauses,rgArgs:S,cwd:o}}e.spawnRipgrepCmd=C;function l(g,s,d,n){const S=["--files","--hidden","--case-sensitive"];p([s],d,!1).forEach(i=>{const r=(0,D.anchorGlob)(i);if(S.push("-g",r),R.isMacintosh){const c=(0,I.normalizeNFD)(r);c!==r&&S.push("-g",c)}});const o=E([s],n,void 0,!1);return o.globArgs.forEach(i=>{const r=`!${(0,D.anchorGlob)(i)}`;if(S.push("-g",r),R.isMacintosh){const c=(0,I.normalizeNFD)(r);c!==r&&S.push("-g",c)}}),s.disregardIgnoreFiles!==!1?S.push("--no-ignore"):s.disregardParentIgnoreFiles!==!1&&S.push("--no-ignore-parent"),s.ignoreSymlinks||S.push("--follow"),g.exists&&S.push("--quiet"),S.push("--no-config"),s.disregardGlobalIgnoreFiles&&S.push("--no-ignore-global"),{args:S,siblingClauses:o.siblingClauses}}function E(g,s,d,n=!0){const S=[];let o={};return g.forEach(i=>{const r=Object.assign({},i.excludePattern||{},s||{}),c=m(r,n?i.folder.fsPath:void 0,d);S.push(...c.globArgs),c.siblingClauses&&(o=Object.assign(o,c.siblingClauses))}),{globArgs:S,siblingClauses:o}}e.foldersToRgExcludeGlobs=E;function p(g,s,d=!0){const n=[];return g.forEach(S=>{const o=Object.assign({},s||{},S.includePattern||{}),i=m(o,d?S.folder.fsPath:void 0);n.push(...i.globArgs)}),n}e.foldersToIncludeGlobs=p;function m(g,s,d){const n=[],S={};return Object.keys(g).forEach(o=>{if(d&&d.has(o)||!o)return;const i=g[o];o=F(s?b(s,o):o),o.startsWith("\\\\")?o="\\\\"+o.substr(2).replace(/\\/g,"/"):o=o.replace(/\\/g,"/"),typeof i=="boolean"&&i?(o.startsWith("\\\\")&&(o+="**"),n.push(_(o))):i&&i.when&&(S[o]=i)}),{globArgs:n,siblingClauses:S}}function b(g,s){return t.isAbsolute(s)?s:t.join(g,s)}e.getAbsoluteGlob=b;function F(g){return g=k.rtrim(g,"\\"),k.rtrim(g,"/")}function _(g){return y.getRoot(g).toLowerCase()==="c:/"?g.replace(/^c:[/\\]/i,"/"):g}e.fixDriveC=_}),define(ve[276],we([0,1,37,60,9,104,17,49,32,79,29,11,46,8,18,30,31,274,102]),function(Z,e,h,t,I,y,R,k,D,P,L,C,l,E,p,m,b,F,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const g=new Set;process.on("exit",()=>{g.forEach(o=>o())});class s{constructor(i){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=i,this.filePattern=i.filePattern||"",this.includePattern=i.includePattern&&D.parse(i.includePattern),this.maxResults=i.maxResults||null,this.exists=!!i.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,_.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=i.excludePattern&&D.parse(i.excludePattern),this.folderExcludePatterns=new Map,i.folderQueries.forEach(r=>{const c=Object.assign({},r.excludePattern||{},this.config.excludePattern||{}),a=r.folder.fsPath;i.folderQueries.map(u=>u.folder.fsPath).filter(u=>u!==a).forEach(u=>{(0,L.isEqualOrParent)(u,a)&&(c[I.relative(a,u)]=!0)}),this.folderExcludePatterns.set(a,new n(c,a))})}cancel(){this.isCanceled=!0,g.forEach(i=>i())}walk(i,r,c,a,u){if(this.fileWalkSW=l.StopWatch.create(!1),this.isCanceled)return u(null,this.isLimitHit);r.forEach(f=>{const v=I.basename(f.fsPath);this.globalExcludePattern&&this.globalExcludePattern(f.fsPath,v)||this.matchFile(c,{relativePath:f.fsPath,searchPath:void 0})}),this.cmdSW=l.StopWatch.create(!1),this.parallel(i,(f,v)=>{this.call(this.cmdTraversal,this,f,c,a,w=>{if(w){const A=(0,k.toErrorMessage)(w);console.error(A),this.errors.push(A),v(w,void 0)}else v(null,void 0)})},(f,v)=>{this.fileWalkSW.stop();const w=f?R.coalesce(f)[0]:null;u(w,this.isLimitHit)})}parallel(i,r,c){const a=new Array(i.length),u=new Array(i.length);let f=!1,v=0;if(i.length===0)return c(null,[]);i.forEach((w,A)=>{r(w,(M,T)=>{if(M?(f=!0,a[A]=null,u[A]=M):(a[A]=T,u[A]=null),++v===i.length)return c(f?u:null,a)})})}call(i,r,...c){try{i.apply(r,c)}catch(a){c[c.length-1](a)}}cmdTraversal(i,r,c,a){const u=i.folder.fsPath,f=C.isMacintosh;let v;const w=()=>v&&v.kill();g.add(w);let A=N=>{g.delete(w),A=()=>{},a(N)},M="";const T=this.initDirectoryTree();let O;const U=(0,F.spawnRipgrepCmd)(this.config,i,this.config.includePattern,this.folderExcludePatterns.get(i.folder.fsPath).expression);v=U.cmd,O=!Object.keys(U.siblingClauses).length;const V=U.rgArgs.args.map(N=>N.match(/^-/)?N:`'${N}'`).join(" ");let x=`${U.rgDiskPath} ${V}
 - cwd: ${U.cwd}`;U.rgArgs.siblingClauses&&(x+=`
 - Sibling clauses: ${JSON.stringify(U.rgArgs.siblingClauses)}`),c({message:x}),this.cmdResultCount=0,this.collectStdout(v,"utf8",c,(N,$,B)=>{if(N){A(N);return}if(this.isLimitHit){A();return}const W=(M+(f?P.normalizeNFC($||""):$)).split(`
`);if(B){const Y=W.length;W[Y-1]=W[Y-1].trim(),W[Y-1]||W.pop()}else M=W.pop()||"";if(W.length&&W[0].indexOf(`
`)!==-1){A(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=W.length,O){for(const Y of W)if(this.matchFile(r,{base:u,relativePath:Y,searchPath:this.getSearchPath(i,Y)}),this.isLimitHit){w();break}(B||this.isLimitHit)&&A();return}this.addDirectoryEntries(i,T,u,W,r),B&&(this.matchDirectoryTree(T,u,r),A())})}spawnFindCmd(i){const r=this.folderExcludePatterns.get(i.folder.fsPath),c=r.getBasenameTerms(),a=r.getPathTerms(),u=["-L","."];if(c.length||a.length){u.push("-not","(","(");for(const f of c)u.push("-name",f),u.push("-o");for(const f of a)u.push("-path",f),u.push("-o");u.pop(),u.push(")","-prune",")")}return u.push("-type","f"),h.spawn("find",u,{cwd:i.folder.fsPath})}readStdout(i,r,c){let a="";this.collectStdout(i,r,()=>{},(u,f,v)=>{if(u){c(u);return}a+=f,v&&c(null,a)})}collectStdout(i,r,c,a){let u=(w,A,M)=>{(w||M)&&(u=()=>{},this.cmdSW&&this.cmdSW.stop()),a(w,A,M)},f=!1;i.stdout?(this.forwardData(i.stdout,r,u),i.stdout.once("data",()=>f=!0)):c({message:"stdout is null"});let v;i.stderr?v=this.collectData(i.stderr):c({message:"stderr is null"}),i.on("error",w=>{u(w)}),i.on("close",w=>{let A;!f&&(A=this.decodeData(v,r))&&S(A)?u(new Error(`command failed with error code ${w}: ${this.decodeData(v,r)}`)):(this.exists&&w===0&&(this.isLimitHit=!0),u(null,"",!0))})}forwardData(i,r,c){const a=new y.StringDecoder(r);return i.on("data",u=>{c(null,a.write(u))}),a}collectData(i){const r=[];return i.on("data",c=>{r.push(c)}),r}decodeData(i,r){const c=new y.StringDecoder(r);return i.map(a=>c.write(a)).join("")}initDirectoryTree(){const i={rootEntries:[],pathToEntries:Object.create(null)};return i.pathToEntries["."]=i.rootEntries,i}addDirectoryEntries(i,{pathToEntries:r},c,a,u){a.indexOf(this.filePattern)!==-1&&this.matchFile(u,{base:c,relativePath:this.filePattern,searchPath:this.getSearchPath(i,this.filePattern)});const f=v=>{const w=I.basename(v),A=I.dirname(v);let M=r[A];M||(M=r[A]=[],f(A)),M.push({base:c,relativePath:v,basename:w,searchPath:this.getSearchPath(i,v)})};a.forEach(f)}matchDirectoryTree({rootEntries:i,pathToEntries:r},c,a){const u=this,f=this.folderExcludePatterns.get(c),v=this.filePattern;function w(A){u.directoriesWalked++;const M=D.hasSiblingFn(()=>A.map(T=>T.basename));for(let T=0,O=A.length;T<O;T++){const U=A[T],{relativePath:V,basename:x}=U;if(f.test(V,x,v!==x?M:void 0))continue;const N=r[V];if(N)w(N);else{if(u.filesWalked++,V===v)continue;u.matchFile(a,U)}if(u.isLimitHit)break}}w(i)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(i,r,c,a,u){const f=i.folder,v=D.hasSiblingFn(()=>c);this.parallel(c,(w,A)=>{if(this.isCanceled||this.isLimitHit)return A(null);const M=r?[r,w].join(I.sep):w;if(this.folderExcludePatterns.get(i.folder.fsPath).test(M,w,this.config.filePattern!==w?v:void 0))return A(null);const T=[f.fsPath,M].join(I.sep);t.lstat(T,(O,U)=>{if(O||this.isCanceled||this.isLimitHit)return A(null);this.statLinkIfNeeded(T,U,(V,x)=>V||this.isCanceled||this.isLimitHit?A(null):x.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(T,U,(N,$)=>N||this.isCanceled||this.isLimitHit||($=$||"",this.walkedPaths[$])?A(null):(this.walkedPaths[$]=!0,m.Promises.readdir(T).then(B=>{if(this.isCanceled||this.isLimitHit)return A(null);this.doWalk(i,M,B,a,z=>A(z||null))},B=>{A(null)})))):(this.filesWalked++,M===this.filePattern||this.maxFilesize&&p.isNumber(x.size)&&x.size>this.maxFilesize||this.matchFile(a,{base:f.fsPath,relativePath:M,searchPath:this.getSearchPath(i,M)}),A(null,void 0)))})},w=>{const A=w&&R.coalesce(w);return u(A&&A.length>0?A[0]:void 0)})}matchFile(i,r){this.isFileMatch(r)&&(!this.includePattern||this.includePattern(r.relativePath,I.basename(r.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||i(r))}isFileMatch(i){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,b.isFilePatternMatch)(i,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(i,r,c){return r.isSymbolicLink()?t.stat(i,c):c(null,r)}realPathIfNeeded(i,r,c){return r.isSymbolicLink()?t.realpath(i,(a,u)=>a?c(a):c(null,u)):c(null,i)}getSearchPath(i,r){return i.folderName?I.join(i.folderName,r):r}}e.FileWalker=s;class d{constructor(i){this.folderQueries=i.folderQueries,this.extraFiles=i.extraFileResources||[],this.walker=new s(i)}search(i,r,c){this.walker.walk(this.folderQueries,this.extraFiles,i,r,(a,u)=>{c(a,{limitHit:u,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=d;class n{constructor(i,r){this.expression=i,this.root=r,this.init(i)}init(i){let r,c;Object.keys(i).filter(a=>i[a]).forEach(a=>{I.isAbsolute(a)?(r=r||D.getEmptyExpression(),r[a]=i[a]):(c=c||D.getEmptyExpression(),c[a]=i[a])}),this.absoluteParsedExpr=r&&D.parse(r,{trimForExclusions:!0}),this.relativeParsedExpr=c&&D.parse(c,{trimForExclusions:!0})}test(i,r,c){return this.relativeParsedExpr&&this.relativeParsedExpr(i,r,c)||this.absoluteParsedExpr&&this.absoluteParsedExpr(I.join(this.root,i),r,c)}getBasenameTerms(){const i=[];return this.absoluteParsedExpr&&i.push(...D.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&i.push(...D.getBasenameTerms(this.relativeParsedExpr)),i}getPathTerms(){const i=[];return this.absoluteParsedExpr&&i.push(...D.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&i.push(...D.getPathTerms(this.relativeParsedExpr)),i}}function S(o){const i=o.trim().split(`
`),r=i[0].trim();if(r.startsWith("Error parsing regex"))return r;if(r.startsWith("regex parse error"))return E.uppercaseFirstLetter(i[i.length-1].trim());if(r.startsWith("error parsing glob")||r.startsWith("unsupported encoding"))return r.charAt(0).toUpperCase()+r.substr(1);if(r==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(r.startsWith("Literal "))return r}e.rgErrorMsgForDisplay=S}),define(ve[277],we([0,1,97,22]),function(Z,e,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.DecodeStreamError=e.DecodeStreamErrorKind=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function I(o){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(i=>i===o)}e.isUTFEncoding=I,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const y=512,R=512,k=512*8,D=512*128;var P;(function(o){o[o.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(P=e.DecodeStreamErrorKind||(e.DecodeStreamErrorKind={}));class L extends Error{constructor(i,r){super(i);this.decodeStreamErrorKind=r}}e.DecodeStreamError=L;class C{constructor(i){this.iconvLiteDecoder=i}static async create(i){let r;if(i!==e.UTF8)r=(await new Promise((a,u)=>{Z(["@vscode/iconv-lite-umd"],a,u)})).getDecoder(m(i));else{const c=new TextDecoder;r={write(a){return c.decode(a,{stream:!0})},end(){return c.decode()}}}return new C(r)}write(i){return this.iconvLiteDecoder.write(i)}end(){return this.iconvLiteDecoder.end()}}function l(o,i){const r=i.minBytesRequiredForDetection??i.guessEncoding?k:R;return new Promise((c,a)=>{const u=(0,h.newWriteableStream)(T=>T.join("")),f=[];let v=0,w,A;const M=async()=>{try{const T=await S({buffer:t.VSBuffer.concat(f),bytesRead:v},i.guessEncoding);if(T.seemsBinary&&i.acceptTextOnly)throw new L("Stream is binary but only text is accepted for decoding",1);T.encoding=await i.overwriteEncoding(T.encoding),w=await C.create(T.encoding);const O=w.write(t.VSBuffer.concat(f).buffer);u.write(O),f.length=0,v=0,c({stream:u,detected:T})}catch(T){A?.dispose(),u.destroy(),a(T)}};A=(0,h.listenStream)(o,{onData:async T=>{w?u.write(w.write(T.buffer)):(f.push(T),v+=T.byteLength,v>=r&&(o.pause(),await M(),setTimeout(()=>o.resume())))},onError:T=>u.error(T),onEnd:async()=>{w||await M(),u.end(w?.end())}})})}e.toDecodeStream=l;async function E(o,i,r){const a=(await new Promise((v,w)=>{Z(["@vscode/iconv-lite-umd"],v,w)})).getEncoder(m(i),r);let u=!1,f=!1;return{read(){if(f)return null;const v=o.read();if(typeof v!="string"){if(f=!0,!u&&r?.addBOM)switch(i){case e.UTF8:case e.UTF8_with_bom:return t.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return t.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return t.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const w=a.end();return w&&w.length>0?(u=!0,t.VSBuffer.wrap(w)):null}return u=!0,t.VSBuffer.wrap(a.write(v))}}}e.toEncodeReadable=E;async function p(o){return(await new Promise((r,c)=>{Z(["@vscode/iconv-lite-umd"],r,c)})).encodingExists(m(o))}e.encodingExists=p;function m(o){return o===e.UTF8_with_bom||o===null?e.UTF8:o}e.toNodeEncoding=m;function b(o,i){if(!o||i<e.UTF16be_BOM.length)return null;const r=o.readUInt8(0),c=o.readUInt8(1);if(r===e.UTF16be_BOM[0]&&c===e.UTF16be_BOM[1])return e.UTF16be;if(r===e.UTF16le_BOM[0]&&c===e.UTF16le_BOM[1])return e.UTF16le;if(i<e.UTF8_BOM.length)return null;const a=o.readUInt8(2);return r===e.UTF8_BOM[0]&&c===e.UTF8_BOM[1]&&a===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=b;const F=["ascii","utf-16","utf-32"];async function _(o){const i=await new Promise((f,v)=>{Z(["jschardet"],f,v)}),r=o.slice(0,D),c=d(r.buffer),a=i.detect(c);if(!a||!a.encoding)return null;const u=a.encoding.toLowerCase();return 0<=F.indexOf(u)?null:s(a.encoding)}const g={ibm866:"cp866",big5:"cp950"};function s(o){const i=o.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return g[i]||i}function d(o){let i="";for(let r=0;r<o.length;r++)i+=String.fromCharCode(o[r]);return i}function n(o){switch(o){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const i=o.match(/windows(\d+)/);return i?"windows-"+i[1]:o}}}e.toCanonicalName=n;function S({buffer:o,bytesRead:i},r){let c=b(o,i),a=!1;if(c!==e.UTF16be&&c!==e.UTF16le&&o){let u=!0,f=!0,v=!1;for(let w=0;w<i&&w<y;w++){const A=w%2==1,M=o.readUInt8(w)===0;if(M&&(v=!0),u&&(A&&!M||!A&&M)&&(u=!1),f&&(A&&M||!A&&!M)&&(f=!1),M&&!u&&!f)break}v&&(u?c=e.UTF16le:f?c=e.UTF16be:a=!0)}return r&&!a&&!c&&o?_(o.slice(0,i)).then(u=>({seemsBinary:!1,encoding:u})):{seemsBinary:a,encoding:c}}e.detectEncodingFromBuffer=S,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(ve[137],we([0,1,277,30,136]),function(Z,e,h,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class y extends I.TextSearchManager{constructor(k,D,P=t,L="searchProcess"){super(k,D,{readdir:C=>P.Promises.readdir(C.fsPath),toCanonicalName:C=>(0,h.toCanonicalName)(C)},L)}}e.NativeTextSearchManager=y}),define(ve[278],we([0,1,61,4]),function(Z,e,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeViewsDragAndDropService=e.ITreeViewsDragAndDropService=void 0,e.ITreeViewsDragAndDropService=(0,t.createDecorator)("treeViewsDragAndDropService");class I{constructor(){this._dragOperations=new Map}removeDragOperationTransfer(R){if(R&&this._dragOperations.has(R)){const k=this._dragOperations.get(R);return this._dragOperations.delete(R),k}}addDragOperationTransfer(R,k){this._dragOperations.set(R,k)}}e.TreeViewsDragAndDropService=I,(0,h.registerSingleton)(e.ITreeViewsDragAndDropService,I)}),define(ve[279],we([0,1,169,23,2,3,6,13,7,18,17,15,21,205,278]),function(Z,e,h,t,I,y,R,k,D,P,L,C,l,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function m(_,g){if((0,P.isString)(_))return{label:_};if(_&&typeof _=="object"&&typeof _.label=="string"){let s;return Array.isArray(_.highlights)&&(s=_.highlights.filter(d=>d.length===2&&typeof d[0]=="number"&&typeof d[1]=="number"),s=s.length?s:void 0),{label:_.label,highlights:s}}}class b{constructor(g,s,d){this._proxy=g,this.commands=s,this.logService=d,this.treeViews=new Map,this.treeDragAndDropService=new p.TreeViewsDragAndDropService;function n(S){return S&&S.$treeViewId&&S.$treeItemHandle}s.registerArgumentProcessor({processArgument:S=>n(S)?this.convertArgument(S):Array.isArray(S)&&S.length>0?S.map(o=>n(o)?this.convertArgument(o):o):S})}registerTreeDataProvider(g,s,d){const n=this.createTreeView(g,{treeDataProvider:s},d);return{dispose:()=>n.dispose()}}createTreeView(g,s,d){if(!s||!s.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const n=s.dragAndDropController?.supportedMimeTypes,S=!!s.dragAndDropController?.handleDrag,o=this._proxy.$registerTreeViewDataProvider(g,{showCollapseAll:!!s.showCollapseAll,canSelectMany:!!s.canSelectMany,dragAndDropMimeTypes:n,hasHandleDrag:S}),i=this.createExtHostTreeView(g,s,d);return{get onDidCollapseElement(){return i.onDidCollapseElement},get onDidExpandElement(){return i.onDidExpandElement},get selection(){return i.selectedElements},get onDidChangeSelection(){return i.onDidChangeSelection},get visible(){return i.visible},get onDidChangeVisibility(){return i.onDidChangeVisibility},get message(){return i.message},set message(r){i.message=r},get title(){return i.title},set title(r){i.title=r},get description(){return i.description},set description(r){i.description=r},reveal:(r,c)=>i.reveal(r,c),dispose:async()=>{await o,this.treeViews.delete(g),i.dispose()}}}$getChildren(g,s){const d=this.treeViews.get(g);return d?d.getChildren(s):Promise.reject(new Error((0,h.localize)(0,null,g)))}async $handleDrop(g,s,d,n,S,o){const i=this.treeViews.get(g);if(!i)return Promise.reject(new Error((0,h.localize)(1,null,g)));const r=E.TreeDataTransferConverter.toITreeDataTransfer(s);return S===g&&o&&await this.addAdditionalTransferItems(r,i,o,n),i.onDrop(r,d)}async addAdditionalTransferItems(g,s,d,n){const S=this.treeDragAndDropService.removeDragOperationTransfer(n);if(S)(await S)?.forEach((o,i)=>{o&&g.set(i,o)});else if(n&&s.handleDrag){const o=s.handleDrag(d,g);this.treeDragAndDropService.addDragOperationTransfer(n,o),await o}return g}async $handleDrag(g,s,d){const n=this.treeViews.get(g);if(!n)return Promise.reject(new Error((0,h.localize)(2,null,g)));const S=await this.addAdditionalTransferItems(new Map,n,s,d);if(!!S)return E.TreeDataTransferConverter.toTreeDataTransferDTO(S)}async $hasResolve(g){const s=this.treeViews.get(g);if(!s)throw new Error((0,h.localize)(3,null,g));return s.hasResolve}$resolve(g,s,d){const n=this.treeViews.get(g);if(!n)throw new Error((0,h.localize)(4,null,g));return n.resolveTreeItem(s,d)}$setExpanded(g,s,d){const n=this.treeViews.get(g);if(!n)throw new Error((0,h.localize)(5,null,g));n.setExpanded(s,d)}$setSelection(g,s){const d=this.treeViews.get(g);if(!d)throw new Error((0,h.localize)(6,null,g));d.setSelection(s)}$setVisible(g,s){const d=this.treeViews.get(g);if(!d)throw new Error((0,h.localize)(7,null,g));d.setVisible(s)}createExtHostTreeView(g,s,d){const n=new F(g,s,this._proxy,this.commands.converter,this.logService,d);return this.treeViews.set(g,n),n}convertArgument(g){const s=this.treeViews.get(g.$treeViewId);return s?s.getExtensionElement(g.$treeItemHandle):null}}e.ExtHostTreeViews=b;class F extends R.Disposable{constructor(g,s,d,n,S,o){super();if(this.viewId=g,this.proxy=d,this.commands=n,this.logService=S,this.extension=o,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new y.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new y.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new y.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new y.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new y.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new l.CancellationTokenSource,o.contributes&&o.contributes.views)for(const c in o.contributes.views)for(const a of o.contributes.views[c])a.id===g&&(this._title=a.name);this.dataProvider=s.treeDataProvider,this.dndController=s.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(c=>this._onDidChangeData.fire({message:!1,element:c}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(c=>this._onDidChangeData.fire({message:!1,element:c})));let i,r;this._register(y.Event.debounce(this._onDidChangeData.event,(c,a)=>(c||(c={message:!1,elements:[]}),a.element!==!1&&(i||(i=new Promise(u=>r=u),this.refreshPromise=this.refreshPromise.then(()=>i)),Array.isArray(a.element)?c.elements.push(...a.element):c.elements.push(a.element)),a.message&&(c.message=!0),c),200,!0)(({message:c,elements:a})=>{a.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const u=r;return i=null,this.refresh(a).then(()=>u())})),c&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(g=>this.getExtensionElement(g)).filter(g=>!(0,P.isUndefinedOrNull)(g))}async getChildren(g){const s=g?this.getExtensionElement(g):void 0;if(g&&!s)return this.logService.error(`No tree item with id '${g}' found.`),Promise.resolve([]);let d=this.getChildrenNodes(g);return d||(d=await this.fetchChildrenNodes(s)),d?d.map(n=>n.item):void 0}getExtensionElement(g){return this.elements.get(g)}reveal(g,s){s=s||{select:!0,focus:!1};const d=(0,P.isUndefinedOrNull)(s.select)?!0:s.select,n=(0,P.isUndefinedOrNull)(s.focus)?!1:s.focus,S=(0,P.isUndefinedOrNull)(s.expand)?!1:s.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):g?this.refreshPromise.then(()=>this.resolveUnknownParentChain(g)).then(o=>this.resolveTreeNode(g,o[o.length-1]).then(i=>this.proxy.$reveal(this.viewId,{item:i.item,parentChain:o.map(r=>r.item)},{select:d,focus:n,expand:S})),o=>this.logService.error(o)):this.proxy.$reveal(this.viewId,void 0,{select:d,focus:n,expand:S})}get message(){return this._message}set message(g){this._message=g,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(g){this._title=g,this.proxy.$setTitle(this.viewId,g,this._description)}get description(){return this._description}set description(g){this._description=g,this.proxy.$setTitle(this.viewId,this._title,g)}setExpanded(g,s){const d=this.getExtensionElement(g);d&&(s?this._onDidExpandElement.fire(Object.freeze({element:d})):this._onDidCollapseElement.fire(Object.freeze({element:d})))}setSelection(g){(0,L.equals)(this._selectedHandles,g)||(this._selectedHandles=g,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(g){g!==this._visible&&(this._visible=g,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async handleDrag(g,s){const d=[];for(const n of g){const S=this.getExtensionElement(n);S&&d.push(S)}if(!(!this.dndController?.handleDrag||d.length===0))return await this.dndController.handleDrag(d,s),s}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(g,s){const d=this.getExtensionElement(s);if(!!d)return(0,k.asPromise)(()=>this.dndController?.handleDrop(g,d))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(g,s){if(!this.dataProvider.resolveTreeItem)return;const d=this.elements.get(g);if(d){const n=this.nodes.get(d);if(n){const S=await this.dataProvider.resolveTreeItem(n.extensionItem,d,s)??n.extensionItem;return n.item.tooltip=this.getTooltip(S.tooltip),n.item.command=this.getCommand(n.disposableStore,S.command),n.item}}}resolveUnknownParentChain(g){return this.resolveParent(g).then(s=>s?this.resolveUnknownParentChain(s).then(d=>this.resolveTreeNode(s,d[d.length-1]).then(n=>(d.push(n),d))):Promise.resolve([]))}resolveParent(g){const s=this.nodes.get(g);return s?Promise.resolve(s.parent?this.elements.get(s.parent.item.handle):void 0):(0,k.asPromise)(()=>this.dataProvider.getParent(g))}resolveTreeNode(g,s){const d=this.nodes.get(g);return d?Promise.resolve(d):(0,k.asPromise)(()=>this.dataProvider.getTreeItem(g)).then(n=>this.createHandle(g,n,s,!0)).then(n=>this.getChildren(s?s.item.handle:void 0).then(()=>{const S=this.getExtensionElement(n);if(S){const o=this.nodes.get(S);if(o)return Promise.resolve(o)}throw new Error(`Cannot resolve tree item for element ${n}`)}))}getChildrenNodes(g){if(g){let s;if(typeof g=="string"){const d=this.getExtensionElement(g);s=d?this.nodes.get(d):void 0}else s=g;return s&&s.children||void 0}return this.roots}async fetchChildrenNodes(g){this.clearChildren(g);const s=new l.CancellationTokenSource(this._refreshCancellationSource.token);try{const d=g?this.nodes.get(g):void 0,n=await this.dataProvider.getChildren(g);if(s.token.isCancellationRequested)return;const S=await Promise.all((0,L.coalesce)(n||[]).map(async o=>{const i=await this.dataProvider.getTreeItem(o);return i&&!s.token.isCancellationRequested?this.createAndRegisterTreeNode(o,i,d):null}));return s.token.isCancellationRequested?void 0:(0,L.coalesce)(S)}finally{s.dispose()}}refresh(g){if(g.some(d=>!d))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new l.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const d=this.getHandlesToRefresh(g);if(d.length)return this.refreshHandles(d)}return Promise.resolve(void 0)}getHandlesToRefresh(g){const s=new Set,d=g.map(S=>this.nodes.get(S));for(const S of d)if(S&&!s.has(S.item.handle)){let o=S;for(;o&&o.parent&&d.findIndex(i=>o&&o.parent&&i&&i.item.handle===o.parent.item.handle)===-1;){const i=this.elements.get(o.parent.item.handle);o=i?this.nodes.get(i):void 0}o&&!o.parent&&s.add(S.item.handle)}const n=[];return s.forEach(S=>{const o=this.elements.get(S);if(o){const i=this.nodes.get(o);i&&(!i.parent||!s.has(i.parent.item.handle))&&n.push(S)}}),n}refreshHandles(g){const s={};return Promise.all(g.map(d=>this.refreshNode(d).then(n=>{n&&(s[d]=n.item)}))).then(()=>Object.keys(s).length?this.proxy.$refresh(this.viewId,s):void 0)}refreshNode(g){const s=this.getExtensionElement(g);if(s){const d=this.nodes.get(s);if(d)return this.clearChildren(s),(0,k.asPromise)(()=>this.dataProvider.getTreeItem(s)).then(n=>{if(n){const S=this.createTreeNode(s,n,d.parent);return this.updateNodeCache(s,S,d,d.parent),d.dispose(),S}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(g,s,d){const n=this.createTreeNode(g,s,d);if(s.id&&this.elements.has(n.item.handle))throw new Error((0,h.localize)(8,null,s.id));return this.addNodeToCache(g,n),this.addNodeToParentCache(n,d),n}getTooltip(g){return D.MarkdownString.isMarkdownString(g)?C.MarkdownString.from(g):g}getCommand(g,s){return s?this.commands.toInternal(s,g):void 0}createTreeNode(g,s,d){const n=new R.DisposableStore,S=this.createHandle(g,s,d),o=this.getLightIconPath(s);return{item:{handle:S,parentHandle:d?d.item.handle:void 0,label:m(s.label,this.extension),description:s.description,resourceUri:s.resourceUri,tooltip:this.getTooltip(s.tooltip),command:this.getCommand(n,s.command),contextValue:s.contextValue,icon:o,iconDark:this.getDarkIconPath(s)||o,themeIcon:this.getThemeIcon(s),collapsibleState:(0,P.isUndefinedOrNull)(s.collapsibleState)?D.TreeItemCollapsibleState.None:s.collapsibleState,accessibilityInformation:s.accessibilityInformation},extensionItem:s,parent:d,children:void 0,disposableStore:n,dispose(){n.dispose()}}}getThemeIcon(g){return g.iconPath instanceof D.ThemeIcon?g.iconPath:void 0}createHandle(g,{id:s,label:d,resourceUri:n},S,o){if(s)return`${F.ID_HANDLE_PREFIX}/${s}`;const i=m(d,this.extension),r=S?S.item.handle:F.LABEL_HANDLE_PREFIX;let c=i?i.label:n?(0,t.basename)(n):"";c=c.indexOf("/")!==-1?c.replace("/","//"):c;const a=this.nodes.has(g)?this.nodes.get(g).item.handle:void 0,u=this.getChildrenNodes(S)||[];let f,v=0;do{if(f=`${r}/${v}:${c}`,o||!this.elements.has(f)||a===f)break;v++}while(v<=u.length);return f}getLightIconPath(g){if(g.iconPath&&!(g.iconPath instanceof D.ThemeIcon))return typeof g.iconPath=="string"||I.URI.isUri(g.iconPath)?this.getIconPath(g.iconPath):this.getIconPath(g.iconPath.light)}getDarkIconPath(g){if(g.iconPath&&!(g.iconPath instanceof D.ThemeIcon)&&g.iconPath.dark)return this.getIconPath(g.iconPath.dark)}getIconPath(g){return I.URI.isUri(g)?g:I.URI.file(g)}addNodeToCache(g,s){this.elements.set(s.item.handle,g),this.nodes.set(g,s)}updateNodeCache(g,s,d,n){this.elements.delete(s.item.handle),this.nodes.delete(g),s.item.handle!==d.item.handle&&this.elements.delete(d.item.handle),this.addNodeToCache(g,s);const S=this.getChildrenNodes(n)||[],o=S.filter(i=>i.item.handle===d.item.handle)[0];o&&S.splice(S.indexOf(o),1,s)}addNodeToParentCache(g,s){s?(s.children||(s.children=[]),s.children.push(g)):(this.roots||(this.roots=[]),this.roots.push(g))}clearChildren(g){if(g){const s=this.nodes.get(g);if(s){if(s.children)for(const d of s.children){const n=this.elements.get(d.item.handle);n&&this.clear(n)}s.children=void 0}}else this.clearAll()}clear(g){const s=this.nodes.get(g);if(s){if(s.children)for(const d of s.children){const n=this.elements.get(d.item.handle);n&&this.clear(n)}this.nodes.delete(g),this.elements.delete(s.item.handle),s.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(g=>g.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}F.LABEL_HANDLE_PREFIX="0",F.ID_HANDLE_PREFIX="1"}),define(ve[280],we([0,1,21,16,3,47,2,114,109,147,82,42,5,230,229,38,231,36,232,233,234,217,235,45,39,236,237,240,241,242,134,219,247,248,249,90,34,251,279,15,7,254,69,135,35,75,206,239,63,132,71,54,73,12,65,14,26,243,203,51,66,227,252,202,68,67,257,255,256,228,44,250,253,89,53,123,245,70,246,10,190,244,200,238,6,28]),function(Z,e,h,t,I,y,R,k,D,P,L,C,l,E,p,m,b,F,_,g,s,d,n,S,o,i,r,c,a,u,f,v,w,A,M,T,O,U,V,x,N,$,B,z,W,Y,ie,ne,J,K,oe,fe,pe,Te,xe,Ge,Qe,q,te,G,Q,ae,me,ke,We,Je,it,st,ot,tt,rt,gt,Ue,It,ee,re,Se,se,ye,Me,qe,Ve,ut,Le,Ae,De){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function ce(de){const be=de.get(Qe.IExtHostInitDataService),Ce=de.get(rt.IExtHostFileSystemInfo),Oe=de.get(Je.IExtHostConsumerFileSystem),Ke=de.get(o.IExtHostExtensionService),$e=de.get(W.IExtHostWorkspace),Ze=de.get(re.IExtHostTelemetry),lt=de.get(F.IExtHostConfiguration),ct=de.get(xe.IURITransformerService),He=de.get(Ge.IExtHostRpcService),Ee=de.get(T.IExtHostStorage),_e=de.get(We.IExtensionStoragePaths),he=de.get(Te.ILoggerService),X=de.get(Te.ILogService),Ie=de.get(G.IExtHostTunnelService),Ne=de.get(Q.IExtHostApiDeprecationService),Ye=de.get(z.IExtHostWindow),Xe=de.get(It.IExtHostSecretState),pt=de.get(ee.IExtHostEditorTabs);He.set(l.ExtHostContext.ExtHostFileSystemInfo,Ce),He.set(l.ExtHostContext.ExtHostLogLevelServiceShape,he),He.set(l.ExtHostContext.ExtHostWorkspace,$e),He.set(l.ExtHostContext.ExtHostConfiguration,lt),He.set(l.ExtHostContext.ExtHostExtensionService,Ke),He.set(l.ExtHostContext.ExtHostStorage,Ee),He.set(l.ExtHostContext.ExtHostTunnelService,Ie),He.set(l.ExtHostContext.ExtHostWindow,Ye),He.set(l.ExtHostContext.ExtHostSecretState,Xe),He.set(l.ExtHostContext.ExtHostTelemetry,Ze),He.set(l.ExtHostContext.ExtHostEditorTabs,pt);const St=He.set(l.ExtHostContext.ExtHostDecorations,de.get(K.IExtHostDecorations)),yt=He.set(l.ExtHostContext.ExtHostDocumentsAndEditors,de.get(S.IExtHostDocumentsAndEditors)),ft=He.set(l.ExtHostContext.ExtHostCommands,de.get(m.IExtHostCommands)),wt=He.set(l.ExtHostContext.ExtHostTerminalService,de.get(O.IExtHostTerminalService)),bt=He.set(l.ExtHostContext.ExtHostDebugService,de.get(fe.IExtHostDebugService)),Ut=He.set(l.ExtHostContext.ExtHostSearch,de.get(pe.IExtHostSearch)),Pt=He.set(l.ExtHostContext.ExtHostTask,de.get(oe.IExtHostTask)),Ft=He.set(l.ExtHostContext.ExtHostOutputService,de.get(f.IExtHostOutputService)),kt=He.set(l.ExtHostContext.ExtHostUrls,new $.ExtHostUrls(He)),Ct=He.set(l.ExtHostContext.ExtHostDocuments,new n.ExtHostDocuments(He,yt)),Qt=He.set(l.ExtHostContext.ExtHostDocumentContentProviders,new s.ExtHostDocumentContentProvider(He,yt,X)),Vt=He.set(l.ExtHostContext.ExtHostDocumentSaveParticipant,new d.ExtHostDocumentSaveParticipant(X,Ct,He.getProxy(l.MainContext.MainThreadBulkEdits))),Et=He.set(l.ExtHostContext.ExtHostNotebook,new q.ExtHostNotebookController(He,ft,yt,Ct,_e)),Xt=He.set(l.ExtHostContext.ExtHostNotebookDocuments,new ut.ExtHostNotebookDocuments(X,Et)),qt=He.set(l.ExtHostContext.ExtHostNotebookEditors,new Ve.ExtHostNotebookEditors(X,He,Et)),Yt=He.set(l.ExtHostContext.ExtHostNotebookKernels,new Se.ExtHostNotebookKernels(He,be,Et,ft,X)),ai=He.set(l.ExtHostContext.ExtHostNotebookRenderers,new ye.ExtHostNotebookRenderers(He,Et)),Rt=He.set(l.ExtHostContext.ExtHostEditors,new U.ExtHostEditors(He,yt)),Jt=He.set(l.ExtHostContext.ExtHostTreeViews,new V.ExtHostTreeViews(He.getProxy(l.MainContext.MainThreadTreeViews),ft,X)),li=He.set(l.ExtHostContext.ExtHostEditorInsets,new ie.ExtHostEditorInsets(He.getProxy(l.MainContext.MainThreadEditorInsets),Rt,be)),jt=He.set(l.ExtHostContext.ExtHostDiagnostics,new _.ExtHostDiagnostics(He,X,Ce)),Zt=He.set(l.ExtHostContext.ExtHostLanguages,new a.ExtHostLanguages(He,Ct,ft.converter,ct)),vt=He.set(l.ExtHostContext.ExtHostLanguageFeatures,new c.ExtHostLanguageFeatures(He,ct,Ct,ft,jt,X,Ne)),ci=He.set(l.ExtHostContext.ExtHostFileSystem,new i.ExtHostFileSystem(He,vt)),Ot=He.set(l.ExtHostContext.ExtHostFileSystemEventService,new r.ExtHostFileSystemEventService(He,X,yt)),$t=He.set(l.ExtHostContext.ExtHostQuickOpen,(0,w.createExtHostQuickOpen)(He,$e,ft)),vi=He.set(l.ExtHostContext.ExtHostSCM,new A.ExtHostSCM(He,ft,X)),ui=He.set(l.ExtHostContext.ExtHostComments,(0,b.createExtHostComments)(He,ft,Ct)),ei=He.set(l.ExtHostContext.ExtHostProgress,new v.ExtHostProgress(He.getProxy(l.MainContext.MainThreadProgress))),Ci=He.set(l.ExtHostContext.ExtHosLabelService,new ne.ExtHostLabelService(He)),wi=He.set(l.ExtHostContext.ExtHostTheming,new te.ExtHostTheming(He)),ti=He.set(l.ExtHostContext.ExtHostAuthentication,new ae.ExtHostAuthentication(He)),Di=He.set(l.ExtHostContext.ExtHostTimeline,new me.ExtHostTimeline(He,ft)),di=He.set(l.ExtHostContext.ExtHostWebviews,new B.ExtHostWebviews(He,{remote:be.remote},$e,X,Ne)),Gt=He.set(l.ExtHostContext.ExtHostWebviewPanels,new ot.ExtHostWebviewPanels(He,di,$e)),hi=He.set(l.ExtHostContext.ExtHostCustomEditors,new st.ExtHostCustomEditors(He,Ct,_e,di,Gt)),ki=He.set(l.ExtHostContext.ExtHostWebviewViews,new it.ExtHostWebviewViews(He,di)),Kt=He.set(l.ExtHostContext.ExtHostTesting,new gt.ExtHostTesting(He,ft)),Ii=He.set(l.ExtHostContext.ExtHostUriOpeners,new Ue.ExtHostUriOpeners(He));He.set(l.ExtHostContext.ExtHostInteractive,new Le.ExtHostInteractive(He,Et,yt,ft));const Pi=(0,Y.values)(l.ExtHostContext);He.assertRegistered(Pi);const ii=new tt.ExtHostBulkEdits(He,yt),Ai=new p.ExtHostClipboard(He),fi=new u.ExtHostMessageService(He,X),bi=new g.ExtHostDialogs(He),ni=new M.ExtHostStatusBar(He,ft.converter);return E.ExtHostApiCommands.register(ft),function(Be,Ht,Bt){const _t=function(){let le=!Be.isUnderDevelopment;function ge(){le||(X.info(`Extension '${Be.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),le=!0)}return function Re(ht){if(Array.isArray(ht))ht.forEach(Re);else if(typeof ht=="string")ge();else{const Dt=ht;typeof Dt.scheme=="undefined"&&ge(),typeof Dt.exclusive=="boolean"&&(0,De.checkProposedApiEnabled)(Be,"documentFiltersExclusive")}return ht}}(),Mt={getSession(le,ge,Re){return ti.getSession(Be,le,ge,Re)},async hasSession(le,ge){return(0,De.checkProposedApiEnabled)(Be,"authSession"),!!await ti.getSession(Be,le,ge,{silent:!0})},get onDidChangeSessions(){return ti.onDidChangeSessions},registerAuthenticationProvider(le,ge,Re,ht){return ti.registerAuthenticationProvider(le,ge,Re,ht)}},ri={registerCommand(le,ge,Re){return ft.registerCommand(!0,le,ge,Re,void 0,Be)},registerTextEditorCommand(le,ge,Re){return ft.registerCommand(!0,le,(...ht)=>{const Dt=Rt.getActiveTextEditor();if(!Dt){X.warn("Cannot execute "+le+" because there is no active text editor.");return}return Dt.edit(Tt=>{ge.apply(Re,[Dt,Tt,...ht])}).then(Tt=>{Tt||X.warn("Edits from command "+le+" were not applied.")},Tt=>{X.warn("An error occurred while running command "+le,Tt)})},void 0,void 0,Be)},registerDiffInformationCommand:(le,ge,Re)=>((0,De.checkProposedApiEnabled)(Be,"diffCommand"),ft.registerCommand(!0,le,async(...ht)=>{const Dt=yt.activeEditor(!0);if(!Dt){X.warn("Cannot execute "+le+" because there is no active text editor.");return}const Tt=await Rt.getDiffInformation(Dt.id);ge.apply(Re,[Tt,...ht])},void 0,void 0,Be)),executeCommand(le,...ge){return ft.executeCommand(le,...ge)},getCommands(le=!1){return ft.getCommands(le)}},Ei={get machineId(){return be.telemetryInfo.machineId},get sessionId(){return be.telemetryInfo.sessionId},get language(){return be.environment.appLanguage},get appName(){return be.environment.appName},get appRoot(){return be.environment.appRoot?.fsPath??""},get appHost(){return be.environment.appHost},get uriScheme(){return be.environment.appUriScheme},get clipboard(){return Ai.value},get shell(){return wt.getDefaultShell(!1)},get isTelemetryEnabled(){return Ze.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return Ze.onDidChangeTelemetryEnabled},get isNewAppInstall(){const le=Date.now()-new Date(be.telemetryInfo.firstSessionDate).getTime();return isNaN(le)?!1:le<1e3*60*60*24},openExternal(le,ge){return Ye.openUri(le,{allowTunneling:!!be.remote.authority,allowContributedOpeners:ge?.allowContributedOpeners})},async asExternalUri(le){if(le.scheme===be.environment.appUriScheme)return kt.createAppUri(le);try{return await Ye.asExternalUri(le,{allowTunneling:!!be.remote.authority})}catch(ge){if((0,qe.matchesScheme)(le,Me.Schemas.http)||(0,qe.matchesScheme)(le,Me.Schemas.https))return le;throw ge}},get remoteName(){return(0,J.getRemoteName)(be.remote.authority)},get remoteAuthority(){return(0,De.checkProposedApiEnabled)(Be,"resolvers"),be.remote.authority},get uiKind(){return be.uiKind}};be.environment.extensionTestsLocationURI||Object.freeze(Ei);const Si=be.remote.isRemote?N.ExtensionKind.Workspace:N.ExtensionKind.UI,Ti={createTestController(le,ge,Re){return Re&&(0,De.checkProposedApiEnabled)(Be,"testRefresh"),Kt.createTestController(le,ge,Re)},createTestObserver(){return(0,De.checkProposedApiEnabled)(Be,"testObserver"),Kt.createTestObserver()},runTests(le){return(0,De.checkProposedApiEnabled)(Be,"testObserver"),Kt.runTests(le)},get onDidChangeTestResults(){return(0,De.checkProposedApiEnabled)(Be,"testObserver"),Kt.onResultsChanged},get testResults(){return(0,De.checkProposedApiEnabled)(Be,"testObserver"),Kt.results}},Ri={getExtension(le){const ge=Ht.getExtensionDescription(le);if(ge)return new o.Extension(Ke,Be.identifier,ge,Si)},get all(){return Ht.getAllExtensionDescriptions().map(le=>new o.Extension(Ke,Be.identifier,le,Si))},get onDidChange(){return Ht.onDidChange}},Li={createDiagnosticCollection(le){return jt.createDiagnosticCollection(Be.identifier,le)},get onDidChangeDiagnostics(){return jt.onDidChangeDiagnostics},getDiagnostics:le=>jt.getDiagnostics(le),getLanguages(){return Zt.getLanguages()},setTextDocumentLanguage(le,ge){return Zt.changeLanguage(le.uri,ge)},match(le,ge){return(0,L.score)(x.LanguageSelector.from(le),ge.uri,ge.languageId,!0)},registerCodeActionsProvider(le,ge,Re){return vt.registerCodeActionProvider(Be,_t(le),ge,Re)},registerCodeLensProvider(le,ge){return vt.registerCodeLensProvider(Be,_t(le),ge)},registerDefinitionProvider(le,ge){return vt.registerDefinitionProvider(Be,_t(le),ge)},registerDeclarationProvider(le,ge){return vt.registerDeclarationProvider(Be,_t(le),ge)},registerImplementationProvider(le,ge){return vt.registerImplementationProvider(Be,_t(le),ge)},registerTypeDefinitionProvider(le,ge){return vt.registerTypeDefinitionProvider(Be,_t(le),ge)},registerHoverProvider(le,ge){return vt.registerHoverProvider(Be,_t(le),ge,Be.identifier)},registerEvaluatableExpressionProvider(le,ge){return vt.registerEvaluatableExpressionProvider(Be,_t(le),ge,Be.identifier)},registerInlineValuesProvider(le,ge){return vt.registerInlineValuesProvider(Be,_t(le),ge,Be.identifier)},registerDocumentHighlightProvider(le,ge){return vt.registerDocumentHighlightProvider(Be,_t(le),ge)},registerLinkedEditingRangeProvider(le,ge){return vt.registerLinkedEditingRangeProvider(Be,_t(le),ge)},registerReferenceProvider(le,ge){return vt.registerReferenceProvider(Be,_t(le),ge)},registerRenameProvider(le,ge){return vt.registerRenameProvider(Be,_t(le),ge)},registerDocumentSymbolProvider(le,ge,Re){return vt.registerDocumentSymbolProvider(Be,_t(le),ge,Re)},registerWorkspaceSymbolProvider(le){return vt.registerWorkspaceSymbolProvider(Be,le)},registerDocumentFormattingEditProvider(le,ge){return vt.registerDocumentFormattingEditProvider(Be,_t(le),ge)},registerDocumentRangeFormattingEditProvider(le,ge){return vt.registerDocumentRangeFormattingEditProvider(Be,_t(le),ge)},registerOnTypeFormattingEditProvider(le,ge,Re,...ht){return vt.registerOnTypeFormattingEditProvider(Be,_t(le),ge,[Re].concat(ht))},registerDocumentSemanticTokensProvider(le,ge,Re){return vt.registerDocumentSemanticTokensProvider(Be,_t(le),ge,Re)},registerDocumentRangeSemanticTokensProvider(le,ge,Re){return vt.registerDocumentRangeSemanticTokensProvider(Be,_t(le),ge,Re)},registerSignatureHelpProvider(le,ge,Re,...ht){return typeof Re=="object"?vt.registerSignatureHelpProvider(Be,_t(le),ge,Re):vt.registerSignatureHelpProvider(Be,_t(le),ge,typeof Re=="undefined"?[]:[Re,...ht])},registerCompletionItemProvider(le,ge,...Re){return vt.registerCompletionItemProvider(Be,_t(le),ge,Re)},registerInlineCompletionItemProvider(le,ge){return(0,De.checkProposedApiEnabled)(Be,"inlineCompletions"),vt.registerInlineCompletionsProvider(Be,_t(le),ge)},registerDocumentLinkProvider(le,ge){return vt.registerDocumentLinkProvider(Be,_t(le),ge)},registerColorProvider(le,ge){return vt.registerColorProvider(Be,_t(le),ge)},registerFoldingRangeProvider(le,ge){return vt.registerFoldingRangeProvider(Be,_t(le),ge)},registerSelectionRangeProvider(le,ge){return vt.registerSelectionRangeProvider(Be,le,ge)},registerCallHierarchyProvider(le,ge){return vt.registerCallHierarchyProvider(Be,le,ge)},registerTypeHierarchyProvider(le,ge){return vt.registerTypeHierarchyProvider(Be,le,ge)},setLanguageConfiguration:(le,ge)=>vt.setLanguageConfiguration(Be,le,ge),getTokenInformationAtPosition(le,ge){return(0,De.checkProposedApiEnabled)(Be,"tokenInformation"),Zt.tokenAtPosition(le,ge)},registerInlayHintsProvider(le,ge){return(0,De.checkProposedApiEnabled)(Be,"inlayHints"),vt.registerInlayHintsProvider(Be,le,ge)},createLanguageStatusItem(le,ge){return(0,De.checkProposedApiEnabled)(Be,"languageStatus"),Zt.createLanguageStatusItem(Be,le,ge)}},Fi={get activeTextEditor(){return Rt.getActiveTextEditor()},get visibleTextEditors(){return Rt.getVisibleTextEditors()},get activeTerminal(){return wt.activeTerminal},get terminals(){return wt.terminals},async showTextDocument(le,ge,Re){const ht=await(R.URI.isUri(le)?Promise.resolve(_i.openTextDocument(le)):Promise.resolve(le));return Rt.showTextDocument(ht,ge,Re)},createTextEditorDecorationType(le){return Rt.createTextEditorDecorationType(Be,le)},onDidChangeActiveTextEditor(le,ge,Re){return Rt.onDidChangeActiveTextEditor(le,ge,Re)},onDidChangeVisibleTextEditors(le,ge,Re){return Rt.onDidChangeVisibleTextEditors(le,ge,Re)},onDidChangeTextEditorSelection(le,ge,Re){return Rt.onDidChangeTextEditorSelection(le,ge,Re)},onDidChangeTextEditorOptions(le,ge,Re){return Rt.onDidChangeTextEditorOptions(le,ge,Re)},onDidChangeTextEditorVisibleRanges(le,ge,Re){return Rt.onDidChangeTextEditorVisibleRanges(le,ge,Re)},onDidChangeTextEditorViewColumn(le,ge,Re){return Rt.onDidChangeTextEditorViewColumn(le,ge,Re)},onDidCloseTerminal(le,ge,Re){return wt.onDidCloseTerminal(le,ge,Re)},onDidOpenTerminal(le,ge,Re){return wt.onDidOpenTerminal(le,ge,Re)},onDidChangeActiveTerminal(le,ge,Re){return wt.onDidChangeActiveTerminal(le,ge,Re)},onDidChangeTerminalDimensions(le,ge,Re){return(0,De.checkProposedApiEnabled)(Be,"terminalDimensions"),wt.onDidChangeTerminalDimensions(le,ge,Re)},onDidChangeTerminalState(le,ge,Re){return wt.onDidChangeTerminalState(le,ge,Re)},onDidWriteTerminalData(le,ge,Re){return(0,De.checkProposedApiEnabled)(Be,"terminalDataWriteEvent"),wt.onDidWriteTerminalData(le,ge,Re)},get state(){return Ye.state},onDidChangeWindowState(le,ge,Re){return Ye.onDidChangeWindowState(le,ge,Re)},showInformationMessage(le,...ge){return fi.showMessage(Be,y.default.Info,le,ge[0],ge.slice(1))},showWarningMessage(le,...ge){return fi.showMessage(Be,y.default.Warning,le,ge[0],ge.slice(1))},showErrorMessage(le,...ge){return fi.showMessage(Be,y.default.Error,le,ge[0],ge.slice(1))},showQuickPick(le,ge,Re){return Array.isArray(le)&&le.some(ht=>ht.kind===N.QuickPickItemKind.Separator)&&(0,De.checkProposedApiEnabled)(Be,"quickPickSeparators"),$t.showQuickPick(le,ge,Re)},showWorkspaceFolderPick(le){return $t.showWorkspaceFolderPick(le)},showInputBox(le,ge){return $t.showInput(le,ge)},showOpenDialog(le){return bi.showOpenDialog(le)},showSaveDialog(le){return bi.showSaveDialog(le)},createStatusBarItem(le,ge,Re){let ht,Dt,Tt;return typeof le=="string"?(ht=le,Dt=ge,Tt=Re):(Dt=le,Tt=ge),ni.createStatusBarEntry(Be,ht,Dt,Tt)},setStatusBarMessage(le,ge){return ni.setStatusBarMessage(le,ge)},withScmProgress(le){return Ne.report("window.withScmProgress",Be,"Use 'withProgress' instead."),ei.withProgress(Be,{location:N.ProgressLocation.SourceControl},(ge,Re)=>le({report(ht){}}))},withProgress(le,ge){return ei.withProgress(Be,le,ge)},createOutputChannel(le){return Ft.createOutputChannel(le,Be)},createWebviewPanel(le,ge,Re,ht){return Gt.createWebviewPanel(Be,le,ge,Re,ht)},createWebviewTextEditorInset(le,ge,Re,ht){return(0,De.checkProposedApiEnabled)(Be,"editorInsets"),li.createWebviewEditorInset(le,ge,Re,ht,Be)},createTerminal(le,ge,Re){return typeof le=="object"?"pty"in le?wt.createExtensionTerminal(le):wt.createTerminalFromOptions(le):wt.createTerminal(le,ge,Re)},registerTerminalLinkProvider(le){return wt.registerLinkProvider(le)},registerTerminalProfileProvider(le,ge){return wt.registerProfileProvider(Be,le,ge)},registerTreeDataProvider(le,ge){return Jt.registerTreeDataProvider(le,ge,Be)},createTreeView(le,ge){return Jt.createTreeView(le,ge,Be)},registerWebviewPanelSerializer:(le,ge)=>Gt.registerWebviewPanelSerializer(Be,le,ge),registerCustomEditorProvider:(le,ge,Re={})=>hi.registerCustomEditorProvider(Be,le,ge,Re),registerFileDecorationProvider(le){return St.registerFileDecorationProvider(le,Be.identifier)},registerUriHandler(le){return kt.registerUriHandler(Be.identifier,le)},createQuickPick(){return $t.createQuickPick(Be)},createInputBox(){return $t.createInputBox(Be.identifier)},get activeColorTheme(){return wi.activeColorTheme},onDidChangeActiveColorTheme(le,ge,Re){return wi.onDidChangeActiveColorTheme(le,ge,Re)},registerWebviewViewProvider(le,ge,Re){return ki.registerWebviewViewProvider(Be,le,ge,Re?.webviewOptions)},get activeNotebookEditor(){return(0,De.checkProposedApiEnabled)(Be,"notebookEditor"),Et.activeNotebookEditor},onDidChangeActiveNotebookEditor(le,ge,Re){return(0,De.checkProposedApiEnabled)(Be,"notebookEditor"),Et.onDidChangeActiveNotebookEditor(le,ge,Re)},get visibleNotebookEditors(){return(0,De.checkProposedApiEnabled)(Be,"notebookEditor"),Et.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,De.checkProposedApiEnabled)(Be,"notebookEditor"),Et.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(le,ge,Re){return(0,De.checkProposedApiEnabled)(Be,"notebookEditor"),qt.onDidChangeNotebookEditorSelection(le,ge,Re)},onDidChangeNotebookEditorVisibleRanges(le,ge,Re){return(0,De.checkProposedApiEnabled)(Be,"notebookEditor"),qt.onDidChangeNotebookEditorVisibleRanges(le,ge,Re)},showNotebookDocument(le,ge){return(0,De.checkProposedApiEnabled)(Be,"notebookEditor"),Et.showNotebookDocument(le,ge)},registerExternalUriOpener(le,ge,Re){return(0,De.checkProposedApiEnabled)(Be,"externalUriOpener"),Ii.registerExternalUriOpener(Be.identifier,le,ge,Re)},get tabs(){return(0,De.checkProposedApiEnabled)(Be,"tabs"),pt.tabs},get activeTab(){return(0,De.checkProposedApiEnabled)(Be,"tabs"),pt.activeTab},get onDidChangeTabs(){return(0,De.checkProposedApiEnabled)(Be,"tabs"),pt.onDidChangeTabs},get onDidChangeActiveTab(){return(0,De.checkProposedApiEnabled)(Be,"tabs"),pt.onDidChangeActiveTab},getInlineCompletionItemController(le){return(0,De.checkProposedApiEnabled)(Be,"inlineCompletions"),c.InlineCompletionController.get(le)}},_i={get rootPath(){return Ne.report("workspace.rootPath",Be,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),$e.getPath()},set rootPath(le){throw t.readonly()},getWorkspaceFolder(le){return $e.getWorkspaceFolder(le)},get workspaceFolders(){return $e.getWorkspaceFolders()},get name(){return $e.name},set name(le){throw t.readonly()},get workspaceFile(){return $e.workspaceFile},set workspaceFile(le){throw t.readonly()},updateWorkspaceFolders:(le,ge,...Re)=>$e.updateWorkspaceFolders(Be,le,ge||0,...Re),onDidChangeWorkspaceFolders:function(le,ge,Re){return $e.onDidChangeWorkspace(le,ge,Re)},asRelativePath:(le,ge)=>$e.getRelativePath(le,ge),findFiles:(le,ge,Re,ht)=>$e.findFiles(le,ge,Re,Be.identifier,ht),findTextInFiles:(le,ge,Re,ht)=>{(0,De.checkProposedApiEnabled)(Be,"findTextInFiles");let Dt,Tt;return typeof ge=="object"?(Dt=ge,Tt=Re):(Dt={},Tt=ge,ht=Re),$e.findTextInFiles(le,Dt||{},Tt,Be.identifier,ht)},saveAll:le=>$e.saveAll(le),applyEdit(le){return ii.applyWorkspaceEdit(le)},createFileSystemWatcher:(le,ge,Re,ht)=>Ot.createFileSystemWatcher($e,Be,le,ge,Re,ht),get textDocuments(){return Ct.getAllDocumentData().map(le=>le.document)},set textDocuments(le){throw t.readonly()},openTextDocument(le){let ge;const Re=le;if(typeof le=="string")ge=Promise.resolve(R.URI.file(le));else if(R.URI.isUri(le))ge=Promise.resolve(le);else if(!Re||typeof Re=="object")ge=Ct.createDocumentData(Re);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ge.then(ht=>Ct.ensureDocumentData(ht).then(Dt=>Dt.document))},onDidOpenTextDocument:(le,ge,Re)=>Ct.onDidAddDocument(le,ge,Re),onDidCloseTextDocument:(le,ge,Re)=>Ct.onDidRemoveDocument(le,ge,Re),onDidChangeTextDocument:(le,ge,Re)=>Ct.onDidChangeDocument(le,ge,Re),onDidSaveTextDocument:(le,ge,Re)=>Ct.onDidSaveDocument(le,ge,Re),onWillSaveTextDocument:(le,ge,Re)=>Vt.getOnWillSaveTextDocumentEvent(Be)(le,ge,Re),get notebookDocuments(){return Et.notebookDocuments.map(le=>le.apiNotebook)},async openNotebookDocument(le,ge){let Re;if(R.URI.isUri(le))Re=le,await Et.openNotebookDocument(le);else if(typeof le=="string")Re=R.URI.revive(await Et.createNotebookDocument({viewType:le,content:ge}));else throw new Error("Invalid arguments");return Et.getNotebookDocument(Re).apiNotebook},get onDidOpenNotebookDocument(){return Et.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return Et.onDidCloseNotebookDocument},registerNotebookSerializer(le,ge,Re,ht){return Et.registerNotebookSerializer(Be,le,ge,Re,(0,De.isProposedApiEnabled)(Be,"notebookLiveShare")?ht:void 0)},registerNotebookContentProvider:(le,ge,Re,ht)=>((0,De.checkProposedApiEnabled)(Be,"notebookContentProvider"),Et.registerNotebookContentProvider(Be,le,ge,Re,(0,De.isProposedApiEnabled)(Be,"notebookLiveShare")?ht:void 0)),onDidChangeConfiguration:(le,ge,Re)=>Bt.onDidChangeConfiguration(le,ge,Re),getConfiguration(le,ge){return ge=arguments.length===1?void 0:ge,Bt.getConfiguration(le,ge,Be)},registerTextDocumentContentProvider(le,ge){return Qt.registerTextDocumentContentProvider(le,ge)},registerTaskProvider:(le,ge)=>(Ne.report("window.registerTaskProvider",Be,"Use the corresponding function on the 'tasks' namespace instead"),Pt.registerTaskProvider(Be,le,ge)),registerFileSystemProvider(le,ge,Re){return(0,Ae.combinedDisposable)(ci.registerFileSystemProvider(Be,le,ge,Re),Oe.addFileSystemProvider(le,ge))},get fs(){return Oe.value},registerFileSearchProvider:(le,ge)=>((0,De.checkProposedApiEnabled)(Be,"fileSearchProvider"),Ut.registerFileSearchProvider(le,ge)),registerTextSearchProvider:(le,ge)=>((0,De.checkProposedApiEnabled)(Be,"textSearchProvider"),Ut.registerTextSearchProvider(le,ge)),registerRemoteAuthorityResolver:(le,ge)=>((0,De.checkProposedApiEnabled)(Be,"resolvers"),Ke.registerRemoteAuthorityResolver(le,ge)),registerResourceLabelFormatter:le=>((0,De.checkProposedApiEnabled)(Be,"resolvers"),Ci.$registerResourceLabelFormatter(le)),onDidCreateFiles:(le,ge,Re)=>Ot.onDidCreateFile(le,ge,Re),onDidDeleteFiles:(le,ge,Re)=>Ot.onDidDeleteFile(le,ge,Re),onDidRenameFiles:(le,ge,Re)=>Ot.onDidRenameFile(le,ge,Re),onWillCreateFiles:(le,ge,Re)=>Ot.getOnWillCreateFileEvent(Be)(le,ge,Re),onWillDeleteFiles:(le,ge,Re)=>Ot.getOnWillDeleteFileEvent(Be)(le,ge,Re),onWillRenameFiles:(le,ge,Re)=>Ot.getOnWillRenameFileEvent(Be)(le,ge,Re),openTunnel:le=>((0,De.checkProposedApiEnabled)(Be,"resolvers"),Ie.openTunnel(Be,le).then(ge=>{if(!ge)throw new Error("cannot open tunnel");return ge})),get tunnels(){return(0,De.checkProposedApiEnabled)(Be,"resolvers"),Ie.getTunnels()},onDidChangeTunnels:(le,ge,Re)=>((0,De.checkProposedApiEnabled)(Be,"resolvers"),Ie.onDidChangeTunnels(le,ge,Re)),registerPortAttributesProvider:(le,ge)=>((0,De.checkProposedApiEnabled)(Be,"portsAttributes"),Ie.registerPortsAttributesProvider(le,ge)),registerTimelineProvider:(le,ge)=>((0,De.checkProposedApiEnabled)(Be,"timeline"),Di.registerTimelineProvider(le,ge,Be.identifier,ft.converter)),get isTrusted(){return $e.trusted},requestWorkspaceTrust:le=>((0,De.checkProposedApiEnabled)(Be,"workspaceTrust"),$e.requestWorkspaceTrust(le)),onDidGrantWorkspaceTrust:(le,ge,Re)=>$e.onDidGrantWorkspaceTrust(le,ge,Re)},mi={get inputBox(){return Ne.report("scm.inputBox",Be,"Use 'SourceControl.inputBox' instead"),vi.getLastInputBox(Be)},createSourceControl(le,ge,Re){return vi.createSourceControl(Be,le,ge,Re)}},Mi={createCommentController(le,ge){return ui.createCommentController(Be,le,ge)}},Oi={get activeDebugSession(){return bt.activeDebugSession},get activeDebugConsole(){return bt.activeDebugConsole},get breakpoints(){return bt.breakpoints},onDidStartDebugSession(le,ge,Re){return bt.onDidStartDebugSession(le,ge,Re)},onDidTerminateDebugSession(le,ge,Re){return bt.onDidTerminateDebugSession(le,ge,Re)},onDidChangeActiveDebugSession(le,ge,Re){return bt.onDidChangeActiveDebugSession(le,ge,Re)},onDidReceiveDebugSessionCustomEvent(le,ge,Re){return bt.onDidReceiveDebugSessionCustomEvent(le,ge,Re)},onDidChangeBreakpoints(le,ge,Re){return bt.onDidChangeBreakpoints(le,ge,Re)},registerDebugConfigurationProvider(le,ge,Re){return bt.registerDebugConfigurationProvider(le,ge,Re||N.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(le,ge){return bt.registerDebugAdapterDescriptorFactory(Be,le,ge)},registerDebugAdapterTrackerFactory(le,ge){return bt.registerDebugAdapterTrackerFactory(le,ge)},startDebugging(le,ge,Re){return!Re||typeof Re=="object"&&"configuration"in Re?bt.startDebugging(le,ge,{parentSession:Re}):bt.startDebugging(le,ge,Re||{})},stopDebugging(le){return bt.stopDebugging(le)},addBreakpoints(le){return bt.addBreakpoints(le)},removeBreakpoints(le){return bt.removeBreakpoints(le)},asDebugSourceUri(le,ge){return bt.asDebugSourceUri(le,ge)}},Ni={registerTaskProvider:(le,ge)=>Pt.registerTaskProvider(Be,le,ge),fetchTasks:le=>Pt.fetchTasks(le),executeTask:le=>Pt.executeTask(Be,le),get taskExecutions(){return Pt.taskExecutions},onDidStartTask:(le,ge,Re)=>Pt.onDidStartTask(le,ge,Re),onDidEndTask:(le,ge,Re)=>Pt.onDidEndTask(le,ge,Re),onDidStartTaskProcess:(le,ge,Re)=>Pt.onDidStartTaskProcess(le,ge,Re),onDidEndTaskProcess:(le,ge,Re)=>Pt.onDidEndTaskProcess(le,ge,Re)},Ui={createNotebookController(le,ge,Re,ht,Dt){return Yt.createNotebookController(Be,le,ge,Re,ht,(0,De.isProposedApiEnabled)(Be,"notebookMessaging")?Dt:void 0)},registerNotebookCellStatusBarItemProvider:(le,ge)=>Et.registerNotebookCellStatusBarItemProvider(Be,le,ge),get onDidSaveNotebookDocument(){return(0,De.checkProposedApiEnabled)(Be,"notebookEditor"),Xt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(le){return(0,De.checkProposedApiEnabled)(Be,"notebookEditorDecorationType"),qt.createNotebookEditorDecorationType(le)},createRendererMessaging(le){return ai.createRendererMessaging(Be,le)},onDidChangeNotebookDocumentMetadata(le,ge,Re){return(0,De.checkProposedApiEnabled)(Be,"notebookEditor"),Xt.onDidChangeNotebookDocumentMetadata(le,ge,Re)},onDidChangeNotebookCells(le,ge,Re){return(0,De.checkProposedApiEnabled)(Be,"notebookEditor"),Et.onDidChangeNotebookCells(le,ge,Re)},onDidChangeNotebookCellExecutionState(le,ge,Re){return(0,De.checkProposedApiEnabled)(Be,"notebookCellExecutionState"),Yt.onDidChangeNotebookCellExecutionState(le,ge,Re)},onDidChangeCellOutputs(le,ge,Re){return(0,De.checkProposedApiEnabled)(Be,"notebookEditor"),Et.onDidChangeCellOutputs(le,ge,Re)},onDidChangeCellMetadata(le,ge,Re){return(0,De.checkProposedApiEnabled)(Be,"notebookEditor"),Et.onDidChangeCellMetadata(le,ge,Re)},createConcatTextDocument(le,ge){return(0,De.checkProposedApiEnabled)(Be,"notebookConcatTextDocument"),new ke.ExtHostNotebookConcatDocument(Et,Ct,le,ge)}};return{version:be.version,authentication:Mt,commands:ri,comments:Mi,debug:Oi,env:Ei,extensions:Ri,languages:Li,notebooks:Ui,scm:mi,tasks:Ni,tests:Ti,window:Fi,workspace:_i,Breakpoint:N.Breakpoint,CallHierarchyIncomingCall:N.CallHierarchyIncomingCall,CallHierarchyItem:N.CallHierarchyItem,CallHierarchyOutgoingCall:N.CallHierarchyOutgoingCall,CancellationError:t.CancellationError,CancellationTokenSource:h.CancellationTokenSource,CandidatePortSource:l.CandidatePortSource,CodeAction:N.CodeAction,CodeActionKind:N.CodeActionKind,CodeActionTriggerKind:N.CodeActionTriggerKind,CodeLens:N.CodeLens,Color:N.Color,ColorInformation:N.ColorInformation,ColorPresentation:N.ColorPresentation,ColorThemeKind:N.ColorThemeKind,CommentMode:N.CommentMode,CommentThreadCollapsibleState:N.CommentThreadCollapsibleState,CompletionItem:N.CompletionItem,CompletionItemKind:N.CompletionItemKind,CompletionItemTag:N.CompletionItemTag,CompletionList:N.CompletionList,CompletionTriggerKind:N.CompletionTriggerKind,ConfigurationTarget:N.ConfigurationTarget,CustomExecution:N.CustomExecution,DebugAdapterExecutable:N.DebugAdapterExecutable,DebugAdapterInlineImplementation:N.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:N.DebugAdapterNamedPipeServer,DebugAdapterServer:N.DebugAdapterServer,DebugConfigurationProviderTriggerKind:N.DebugConfigurationProviderTriggerKind,DebugConsoleMode:N.DebugConsoleMode,DecorationRangeBehavior:N.DecorationRangeBehavior,Diagnostic:N.Diagnostic,DiagnosticRelatedInformation:N.DiagnosticRelatedInformation,DiagnosticSeverity:N.DiagnosticSeverity,DiagnosticTag:N.DiagnosticTag,Disposable:N.Disposable,DocumentHighlight:N.DocumentHighlight,DocumentHighlightKind:N.DocumentHighlightKind,DocumentLink:N.DocumentLink,DocumentSymbol:N.DocumentSymbol,EndOfLine:N.EndOfLine,EnvironmentVariableMutatorType:N.EnvironmentVariableMutatorType,EvaluatableExpression:N.EvaluatableExpression,InlineValueText:N.InlineValueText,InlineValueVariableLookup:N.InlineValueVariableLookup,InlineValueEvaluatableExpression:N.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:N.InlineCompletionTriggerKind,EventEmitter:I.Emitter,ExtensionKind:N.ExtensionKind,ExtensionMode:N.ExtensionMode,ExternalUriOpenerPriority:N.ExternalUriOpenerPriority,FileChangeType:N.FileChangeType,FileDecoration:N.FileDecoration,FileSystemError:N.FileSystemError,FileType:C.FileType,FilePermission:C.FilePermission,FoldingRange:N.FoldingRange,FoldingRangeKind:N.FoldingRangeKind,FunctionBreakpoint:N.FunctionBreakpoint,InlineCompletionItem:N.InlineSuggestion,InlineCompletionList:N.InlineSuggestions,Hover:N.Hover,IndentAction:P.IndentAction,Location:N.Location,MarkdownString:N.MarkdownString,OverviewRulerLane:D.OverviewRulerLane,ParameterInformation:N.ParameterInformation,PortAutoForwardAction:N.PortAutoForwardAction,Position:N.Position,ProcessExecution:N.ProcessExecution,ProgressLocation:N.ProgressLocation,QuickInputButtons:N.QuickInputButtons,Range:N.Range,RelativePattern:N.RelativePattern,Selection:N.Selection,SelectionRange:N.SelectionRange,SemanticTokens:N.SemanticTokens,SemanticTokensBuilder:N.SemanticTokensBuilder,SemanticTokensEdit:N.SemanticTokensEdit,SemanticTokensEdits:N.SemanticTokensEdits,SemanticTokensLegend:N.SemanticTokensLegend,ShellExecution:N.ShellExecution,ShellQuoting:N.ShellQuoting,SignatureHelp:N.SignatureHelp,SignatureHelpTriggerKind:N.SignatureHelpTriggerKind,SignatureInformation:N.SignatureInformation,SnippetString:N.SnippetString,SourceBreakpoint:N.SourceBreakpoint,StandardTokenType:N.StandardTokenType,StatusBarAlignment:N.StatusBarAlignment,SymbolInformation:N.SymbolInformation,SymbolKind:N.SymbolKind,SymbolTag:N.SymbolTag,Task:N.Task,TaskGroup:N.TaskGroup,TaskPanelKind:N.TaskPanelKind,TaskRevealKind:N.TaskRevealKind,TaskScope:N.TaskScope,TerminalLink:N.TerminalLink,TerminalLocation:N.TerminalLocation,TerminalProfile:N.TerminalProfile,TextDocumentSaveReason:N.TextDocumentSaveReason,TextEdit:N.TextEdit,TextEditorCursorStyle:k.TextEditorCursorStyle,TextEditorLineNumbersStyle:N.TextEditorLineNumbersStyle,TextEditorRevealType:N.TextEditorRevealType,TextEditorSelectionChangeKind:N.TextEditorSelectionChangeKind,TextDocumentChangeReason:N.TextDocumentChangeReason,ThemeColor:N.ThemeColor,ThemeIcon:N.ThemeIcon,TreeItem:N.TreeItem,TreeItemCollapsibleState:N.TreeItemCollapsibleState,TypeHierarchyItem:N.TypeHierarchyItem,UIKind:l.UIKind,Uri:R.URI,ViewColumn:N.ViewColumn,WorkspaceEdit:N.WorkspaceEdit,InlayHint:N.InlayHint,InlayHintLabelPart:N.InlayHintLabelPart,InlayHintKind:N.InlayHintKind,RemoteAuthorityResolverError:N.RemoteAuthorityResolverError,ResolvedAuthority:N.ResolvedAuthority,SourceControlInputBoxValidationType:N.SourceControlInputBoxValidationType,ExtensionRuntime:N.ExtensionRuntime,TimelineItem:N.TimelineItem,NotebookRange:N.NotebookRange,NotebookCellKind:N.NotebookCellKind,NotebookCellExecutionState:N.NotebookCellExecutionState,NotebookCellData:N.NotebookCellData,NotebookData:N.NotebookData,NotebookRendererScript:N.NotebookRendererScript,NotebookCellStatusBarAlignment:N.NotebookCellStatusBarAlignment,NotebookEditorRevealType:N.NotebookEditorRevealType,NotebookCellOutput:N.NotebookCellOutput,NotebookCellOutputItem:N.NotebookCellOutputItem,NotebookCellStatusBarItem:N.NotebookCellStatusBarItem,NotebookControllerAffinity:N.NotebookControllerAffinity,PortAttributes:N.PortAttributes,LinkedEditingRanges:N.LinkedEditingRanges,TestResultState:N.TestResultState,TestRunRequest:N.TestRunRequest,TestMessage:N.TestMessage,TestTag:N.TestTag,TestRunProfileKind:N.TestRunProfileKind,TextSearchCompleteMessageType:se.TextSearchCompleteMessageType,TreeDataTransfer:N.TreeDataTransfer,TreeDataTransferItem:N.TreeDataTransferItem,CoveredCount:N.CoveredCount,FileCoverage:N.FileCoverage,StatementCoverage:N.StatementCoverage,BranchCoverage:N.BranchCoverage,FunctionCoverage:N.FunctionCoverage,WorkspaceTrustState:N.WorkspaceTrustState,LanguageStatusSeverity:N.LanguageStatusSeverity,QuickPickItemKind:N.QuickPickItemKind}}}e.createApiFactoryAndRegisterActors=ce}),define(ve[281],we([0,1,282,293,294,2,295]),function(Z,e,h,t,I,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function k(C,l,E,p,m,b){const F=b.environment.useHostProxy,_=typeof F=="boolean"?F:!b.remote.isRemote,g=(0,R.createProxyResolver)({resolveProxy:d=>C.resolveProxy(d),getHttpProxySetting:()=>l.getConfiguration("http").get("proxy"),log:(d,n,...S)=>{switch(d){case R.LogLevel.Trace:p.trace(n,...S);break;case R.LogLevel.Debug:p.debug(n,...S);break;case R.LogLevel.Info:p.info(n,...S);break;case R.LogLevel.Warning:p.warn(n,...S);break;case R.LogLevel.Error:p.error(n,...S);break;case R.LogLevel.Critical:p.critical(n,...S);break;case R.LogLevel.Off:break;default:o(d,n,S);break}function o(i,r,...c){p.error("Unknown log level",i),p.error(r,...c)}},getLogLevel:()=>p.getLevel(),proxyResolveTelemetry:d=>{m.$publicLog2("resolveProxy",d)},useHostProxy:_,env:process.env}),s=D(l,g);return L(E,s)}e.connectProxyResolver=k;function D(C,l){const E={config:C.getConfiguration("http").get("proxySupport")||"off"};C.onDidChangeConfiguration(m=>{E.config=C.getConfiguration("http").get("proxySupport")||"off"});const p={config:!!C.getConfiguration("http").get("systemCertificates")};return C.onDidChangeConfiguration(m=>{p.config=!!C.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},h,(0,R.createHttpPatch)(h,l,{config:"off"},p,!0)),on:Object.assign({},h,(0,R.createHttpPatch)(h,l,{config:"on"},p,!0)),override:Object.assign({},h,(0,R.createHttpPatch)(h,l,{config:"override"},p,!0)),onRequest:Object.assign({},h,(0,R.createHttpPatch)(h,l,E,p,!0)),default:Object.assign(h,(0,R.createHttpPatch)(h,l,E,p,!1))},https:{off:Object.assign({},t,(0,R.createHttpPatch)(t,l,{config:"off"},p,!0)),on:Object.assign({},t,(0,R.createHttpPatch)(t,l,{config:"on"},p,!0)),override:Object.assign({},t,(0,R.createHttpPatch)(t,l,{config:"override"},p,!0)),onRequest:Object.assign({},t,(0,R.createHttpPatch)(t,l,E,p,!0)),default:Object.assign(t,(0,R.createHttpPatch)(t,l,E,p,!1))},tls:Object.assign(I,(0,R.createTlsPatch)(I))}}const P=new Map;function L(C,l){return C.getExtensionPathIndex().then(E=>{const p=Z.__$__nodeRequire("module"),m=p._load;p._load=function(F,_,g){if(F==="tls")return l.tls;if(F!=="http"&&F!=="https")return m.apply(this,arguments);const s=l[F],d=E.findSubstr(y.URI.file(_.filename));let n=P.get(d);if(n||P.set(d,n={}),!n[F]){let S=s.default;n[F]={...S}}return n[F]}})}}),define(ve[138],we([0,1,37,296,104,17,75,32,9,8,2,31,70,297,275,91]),function(Z,e,h,t,I,y,R,k,D,P,L,C,l,E,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const b=p.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class F{constructor(f){this.outputChannel=f}provideTextSearchResults(f,v,w,A){return this.outputChannel.appendLine(`provideTextSearchResults ${f.pattern}, ${JSON.stringify({...v,folder:v.folder.toString()})}`),new Promise((M,T)=>{A.onCancellationRequested(()=>z());const O=S(f,v),U=v.folder.fsPath,V=O.map(J=>J.match(/^-/)?J:`'${J}'`).join(" ");this.outputChannel.appendLine(`${b} ${V}
 - cwd: ${U}`);let x=h.spawn(b,O,{cwd:U});x.on("error",J=>{console.error(J),this.outputChannel.appendLine("Error: "+(J&&J.message)),T((0,C.serializeSearchError)(new C.SearchError(J&&J.message,C.SearchErrorCode.rgProcessError)))});let N=!1;const $=new s(v.maxResults,U,v.previewOptions);$.on("result",J=>{N=!0,Y="",w.report(J)});let B=!1;const z=()=>{B=!0,x&&x.kill(),$&&$.cancel()};let W=!1;$.on("hitLimit",()=>{W=!0,z()});let Y="";x.stdout.on("data",J=>{$.handleData(J),N||(Y+=J)});let ie=!1;x.stdout.once("data",()=>ie=!0);let ne="";x.stderr.on("data",J=>{const K=J.toString();this.outputChannel.appendLine(K),ne+=K}),x.on("close",()=>{if(this.outputChannel.appendLine(ie?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(N?"Got result from parser":"No result from parser"),Y&&this.outputChannel.appendLine(`Got data without result: ${Y}`),this.outputChannel.appendLine(""),B)M({limitHit:W});else{$.flush(),x=null;let J;ne&&!ie&&(J=_(ne))?T((0,C.serializeSearchError)(new C.SearchError(J.message,J.code))):M({limitHit:W})}})})}}e.RipgrepTextSearchEngine=F;function _(u){const f=u.split(`
`),v=f[0].trim();if(f.some(A=>A.startsWith("regex parse error")))return new C.SearchError(g(f),C.SearchErrorCode.regexParseError);const w=v.match(/grep config error: unknown encoding: (.*)/);if(w)return new C.SearchError(`Unknown encoding: ${w[1]}`,C.SearchErrorCode.unknownEncoding);if(v.startsWith("error parsing glob"))return new C.SearchError(v.charAt(0).toUpperCase()+v.substr(1),C.SearchErrorCode.globParseError);if(v.startsWith("the literal"))return new C.SearchError(v.charAt(0).toUpperCase()+v.substr(1),C.SearchErrorCode.invalidLiteral);if(v.startsWith("PCRE2: error compiling pattern"))return new C.SearchError(v,C.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=_;function g(u){const f=["Regex parse error"],v=u.filter(w=>w.startsWith("PCRE2:"));if(v.length>=1){const w=v[0].replace("PCRE2:","");if(w.indexOf(":")!==-1&&w.split(":").length>=2){const A=w.split(":")[1];f.push(":"+A)}}return f.join("")}e.buildRegexParseError=g;class s extends t.EventEmitter{constructor(f,v,w){super();this.maxResults=f,this.rootFolder=v,this.previewOptions=w,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new I.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(f,v){return super.on(f,v),this}handleData(f){if(this.isDone)return;const v=typeof f=="string"?f:this.stringDecoder.write(f);this.handleDecodedData(v)}handleDecodedData(f){let v=f.indexOf(`
`);const w=this.remainder+f;if(v>=0)v+=this.remainder.length;else{this.remainder=w;return}let A=0;for(;v>=0;)this.handleLine(w.substring(A,v).trim()),A=v+1,v=w.indexOf(`
`,A);this.remainder=w.substring(A)}handleLine(f){if(this.isDone||!f)return;let v;try{v=JSON.parse(f)}catch{throw new Error(`malformed line from rg: ${f}`)}if(v.type==="match"){const w=d(v.data.path),A=L.URI.file(D.join(this.rootFolder,w)),M=this.createTextSearchMatch(v.data,A);this.onResult(M),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(v.type==="context"){const w=d(v.data.path),A=L.URI.file(D.join(this.rootFolder,w));this.createTextSearchContext(v.data,A).forEach(T=>this.onResult(T))}}createTextSearchMatch(f,v){const w=f.line_number-1,A=d(f.lines),M=Buffer.from(A);let T=0,O=0,U=w;f.submatches.length===0&&f.submatches.push(A.length?{start:0,end:1,match:{text:A[0]}}:{start:0,end:0,match:{text:""}});const V=(0,y.coalesce)(f.submatches.map((x,N)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);const $=d(x.match),B=M.slice(T,x.start).toString().length,z=O+B,W=n($),Y=U,ie=W.numLines+Y,ne=W.numLines>0?W.lastLineLength:W.lastLineLength+z;return T=x.end,O=ne,U=ie,new l.Range(Y,z,ie,ne)}));return(0,m.createTextSearchResult)(v,A,V,this.previewOptions)}createTextSearchContext(f,v){const w=d(f.lines),A=f.line_number;return w.replace(/\r?\n$/,"").split(`
`).map((M,T)=>({text:M,uri:v,lineNumber:A+T}))}onResult(f){this.emit("result",f)}}e.RipgrepParser=s;function d(u){return u.bytes?Buffer.from(u.bytes,"base64").toString():u.text}function n(u){const f=/\n/g;let v=0,w=-1,A;for(;A=f.exec(u);)v++,w=A.index;const M=w>=0?u.length-w-1:u.length;return{numLines:v,lastLineLength:M}}function S(u,f){const v=["--hidden"];v.push(u.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:w,otherIncludes:A}=(0,R.groupBy)(f.includes,T=>T.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(A&&A.length){const T=new Set;A.forEach(O=>{T.add(O)}),v.push("-g","!*"),T.forEach(O=>{o(O).map(m.anchorGlob).forEach(U=>{v.push("-g",U)})})}w&&w.length&&w.forEach(T=>{v.push("-g",T)}),f.excludes.map(m.anchorGlob).forEach(T=>v.push("-g",`!${T}`)),f.maxFileSize&&v.push("--max-filesize",f.maxFileSize+""),f.useIgnoreFiles?f.useParentIgnoreFiles||v.push("--no-ignore-parent"):v.push("--no-ignore"),f.followSymlinks&&v.push("--follow"),f.encoding&&f.encoding!=="utf8"&&v.push("--encoding",f.encoding),u.pattern==="--"&&(u.isRegExp=!0,u.pattern="\\-\\-"),u.isMultiline&&!u.isRegExp&&(u.pattern=(0,P.escapeRegExpCharacters)(u.pattern),u.isRegExp=!0),f.usePCRE2&&v.push("--pcre2"),v.push("--crlf"),u.isRegExp&&(u.pattern=i(u.pattern),v.push("--engine","auto"));let M;if(u.isWordMatch){const O=(0,P.createRegExp)(u.pattern,!!u.isRegExp,{wholeWord:u.isWordMatch}).source.replace(/\\\//g,"/");v.push("--regexp",O)}else if(u.isRegExp){let T=c(u.pattern);T=a(T),v.push("--regexp",T)}else M=u.pattern,v.push("--fixed-strings");return v.push("--no-config"),f.useGlobalIgnoreFiles||v.push("--no-ignore-global"),v.push("--json"),u.isMultiline&&v.push("--multiline"),f.beforeContext&&v.push("--before-context",f.beforeContext+""),f.afterContext&&v.push("--after-context",f.afterContext+""),v.push("--"),M&&v.push(M),v.push("."),v}function o(u){const f=(0,k.splitGlobAware)(u,"/");return f.map((v,w)=>f.slice(0,w+1).join("/"))}e.spreadGlobComponents=o;function i(u){const f=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;u.match(f);)u=u.replace(f,"$1\\x{$2}");const v=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;u.match(v);)u=u.replace(v,"$1\\x{$2}");return u}e.unicodeEscapesToPCRE2=i;const r=u=>u.type==="Assertion"&&u.kind==="lookbehind";function c(u){let f;try{f=new E.RegExpParser().parsePattern(u)}catch{return u}let v="",w=0;const A=(O,U,V)=>{v+=u.slice(w,O)+V,w=U},M=[];return new E.RegExpVisitor({onCharacterEnter(O){if(O.raw!=="\\n")return;const U=M[0];if(!U)A(O.start,O.end,"\\r?\\n");else if(!M.some(r))if(U.type==="CharacterClass")if(U.negate){const V=u.slice(U.start+2,O.start)+u.slice(O.end,U.end-1);if(U.parent?.type==="Quantifier"){const x=U.parent;A(x.start,x.end,(V?`[^${V}]`:".")+(x.greedy?"+":"*"))}else A(U.start,U.end,"(?!\\r?\\n"+(V?`|[${V}]`:"")+")")}else{const V=u.slice(U.start+1,O.start)+u.slice(O.end,U.end-1);A(U.start,U.end,V===""?"\\r?\\n":`(?:[${V}]|\\r?\\n)`)}else U.type==="Quantifier"&&A(O.start,O.end,"(?:\\r?\\n)")},onQuantifierEnter(O){M.unshift(O)},onQuantifierLeave(){M.shift()},onCharacterClassRangeEnter(O){M.unshift(O)},onCharacterClassRangeLeave(){M.shift()},onCharacterClassEnter(O){M.unshift(O)},onCharacterClassLeave(){M.shift()},onAssertionEnter(O){r(O)&&M.push(O)},onAssertionLeave(O){M[0]===O&&M.shift()}}).visit(f),v+=u.slice(w),v}e.fixRegexNewline=c;function a(u){return u.replace(/\n/g,"\\r?\\n")}e.fixNewline=a}),define(ve[283],we([0,1,21,138,118,10]),function(Z,e,h,t,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class R{constructor(P){this.outputChannel=P,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(P,L,C,l){const E=new t.RipgrepTextSearchEngine(this.outputChannel);if(L.folder.scheme===y.Schemas.userData){const p={...L,folder:L.folder.with({scheme:y.Schemas.file})},m=new I.Progress(b=>C.report({...b,uri:b.uri.with({scheme:L.folder.scheme})}));return this.withToken(l,b=>E.provideTextSearchResults(P,p,m,b))}else return this.withToken(l,p=>E.provideTextSearchResults(P,L,C,p))}async withToken(P,L){const C=k(P);this.inProgress.add(C);const l=await L(C.token);return this.inProgress.delete(C),l}dispose(){this.inProgress.forEach(P=>P.cancel())}}e.RipgrepSearchProvider=R;function k(D){const P=new h.CancellationTokenSource;return D.onCancellationRequested(()=>P.cancel()),P}}),define(ve[284],we([0,1,30,138,137]),function(Z,e,h,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class y{constructor(D){this.query=D}search(D,P,L){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const C={appendLine(E){L({message:E})}},l=new I.NativeTextSearchManager(this.query,new t.RipgrepTextSearchEngine(C),h);return new Promise((E,p)=>l.search(m=>{P(m.map(R))},D).then(m=>E({limitHit:m.limitHit,type:"success",stats:m.stats}),p))}}e.TextSearchEngineAdapter=y;function R(k){return{path:k.resource&&k.resource.fsPath,results:k.results,numMatches:(k.results||[]).reduce((D,P)=>{if(P.ranges){const L=P;return D+(Array.isArray(L.ranges)?L.ranges.length:1)}else return D+1},0)}}}),define(ve[285],we([0,1,17,13,16,3,102,9,46,2,42,31,276,284]),function(Z,e,h,t,I,y,R,k,D,P,L,C,l,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0;class p{constructor(s="searchProcess"){this.processType=s,this.caches=Object.create(null)}fileSearch(s){let d;const n=F(s),S=new y.Emitter({onFirstListenerDidAdd:()=>{d=(0,t.createCancelablePromise)(o=>this.doFileSearchWithEngine(l.Engine,n,i=>S.fire(i),o)),d.then(o=>S.fire(o),o=>S.fire({type:"error",error:{message:o.message,stack:o.stack}}))},onLastListenerRemove:()=>{d.cancel()}});return S.event}textSearch(s){let d;const n=F(s),S=new y.Emitter({onFirstListenerDidAdd:()=>{d=(0,t.createCancelablePromise)(o=>this.ripgrepTextSearch(n,i=>S.fire(i),o)),d.then(o=>S.fire(o),o=>S.fire({type:"error",error:{message:o.message,stack:o.stack}}))},onLastListenerRemove:()=>{d.cancel()}});return S.event}ripgrepTextSearch(s,d,n){return s.maxFileSize=(0,L.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new E.TextSearchEngineAdapter(s).search(n,d,d)}doFileSearch(s,d,n){return this.doFileSearchWithEngine(l.Engine,s,d,n)}doFileSearchWithEngine(s,d,n,S,o=p.BATCH_SIZE){let i=0;const r=a=>{Array.isArray(a)?(i+=a.length,n(a.map(u=>this.rawMatchToSearchItem(u)))):a.relativePath?(i++,n(this.rawMatchToSearchItem(a))):n(a)};if(d.sortByScore){let a=this.trySortedSearchFromCache(d,r,S);if(!a){const u=d.maxResults?Object.assign({},d,{maxResults:null}):d,f=new s(u);a=this.doSortedSearch(f,d,n,r,S)}return new Promise((u,f)=>{a.then(([v,w])=>{const A=w.map(M=>this.rawMatchToSearchItem(M));this.sendProgress(A,n,o),u(v)},f)})}const c=new s(d);return this.doSearch(c,r,o,S).then(a=>({limitHit:a.limitHit,type:"success",stats:{detailStats:a.stats,type:this.processType,fromCache:!1,resultCount:i,sortingTime:void 0}}))}rawMatchToSearchItem(s){return{path:s.base?(0,k.join)(s.base,s.relativePath):s.relativePath}}doSortedSearch(s,d,n,S,o){const i=new y.Emitter;let r=(0,t.createCancelablePromise)(a=>{let u=[];const f=v=>{Array.isArray(v)?u=v:(S(v),i.fire(v))};return this.doSearch(s,f,-1,a).then(v=>[v,u])}),c;if(d.cacheKey){c=this.getOrCreateCache(d.cacheKey);const a={promise:r,event:i.event,resolved:!1};c.resultsToSearchCache[d.filePattern||""]=a,r.then(()=>{a.resolved=!0},u=>{delete c.resultsToSearchCache[d.filePattern||""]}),r=this.preventCancellation(r)}return r.then(([a,u])=>{const f=c?c.scorerCache:Object.create(null),v=(typeof d.maxResults!="number"||d.maxResults>0)&&D.StopWatch.create(!1);return this.sortResults(d,u,f,o).then(w=>{const A=v?v.elapsed():-1;return[{type:"success",stats:{detailStats:a.stats,sortingTime:A,fromCache:!1,type:this.processType,workspaceFolderCount:d.folderQueries.length,resultCount:w.length},messages:a.messages,limitHit:a.limitHit||typeof d.maxResults=="number"&&u.length>d.maxResults},w]})})}getOrCreateCache(s){const d=this.caches[s];return d||(this.caches[s]=new m)}trySortedSearchFromCache(s,d,n){const S=s.cacheKey&&this.caches[s.cacheKey];if(!S)return;const o=this.getResultsFromCache(S,s.filePattern||"",d,n);if(o)return o.then(([i,r,c])=>{const a=D.StopWatch.create(!1);return this.sortResults(s,r,S.scorerCache,n).then(u=>{const f=a.elapsed(),v={fromCache:!0,detailStats:c,type:this.processType,resultCount:r.length,sortingTime:f};return[{type:"success",limitHit:i.limitHit||typeof s.maxResults=="number"&&r.length>s.maxResults,stats:v},u]})})}sortResults(s,d,n,S){const o=(0,R.prepareQuery)(s.filePattern||""),i=(c,a)=>(0,R.compareItemsByFuzzyScore)(c,a,o,!0,b,n),r=typeof s.maxResults=="number"?s.maxResults:Number.MAX_VALUE;return h.topAsync(d,i,r,1e4,S)}sendProgress(s,d,n){if(n&&n>0)for(let S=0;S<s.length;S+=n)d(s.slice(S,S+n));else d(s)}getResultsFromCache(s,d,n,S){const o=D.StopWatch.create(!1),i=d.indexOf(k.sep)>=0;let r;for(const f in s.resultsToSearchCache)if(d.startsWith(f)){if(i&&f.indexOf(k.sep)<0&&f!=="")continue;const v=s.resultsToSearchCache[f];r={promise:this.preventCancellation(v.promise),event:v.event,resolved:v.resolved};break}if(!r)return null;const c=o.elapsed(),a=D.StopWatch.create(!1),u=r.event(n);return S&&S.onCancellationRequested(()=>{u.dispose()}),r.promise.then(([f,v])=>{if(S&&S.isCancellationRequested)throw(0,I.canceled)();const w=[],A=(0,R.prepareQuery)(d).normalizedLowercase;for(const M of v)!(0,C.isFilePatternMatch)(M,A)||w.push(M);return[f,w,{cacheWasResolved:r.resolved,cacheLookupTime:c,cacheFilterTime:a.elapsed(),cacheEntryCount:v.length}]})}doSearch(s,d,n,S){return new Promise((o,i)=>{let r=[];S&&S.onCancellationRequested(()=>s.cancel()),s.search(c=>{c&&(n?(r.push(c),n>0&&r.length>=n&&(d(r),r=[])):d(c))},c=>{d(c)},(c,a)=>{r.length&&d(r),c?i(c):o(a)})})}clearCache(s){return delete this.caches[s],Promise.resolve(void 0)}preventCancellation(s){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(d,n){return s.then(d,n)}catch(d){return this.then(void 0,d)}finally(d){return s.finally(d)}}}}e.SearchService=p,p.BATCH_SIZE=512;class m{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const b=new class{getItemLabel(g){return(0,k.basename)(g.relativePath)}getItemDescription(g){return(0,k.dirname)(g.relativePath)}getItemPath(g){return g.relativePath}};function F(g){return{...g,folderQueries:g.folderQueries&&g.folderQueries.map(_),extraFileResources:g.extraFileResources&&g.extraFileResources.map(s=>P.URI.revive(s))}}function _(g){return{...g,folder:P.URI.revive(g.folder)}}}),define(ve[286],we([0,1,6,10,2,30,12,26,14,73,65,31,285,283,91,137]),function(Z,e,h,t,I,y,R,k,D,P,L,C,l,E,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let b=class extends P.ExtHostSearch{constructor(_,g,s,d){super(_,s,d);this._pfs=y,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null,this._registeredEHSearchProvider=!1;const n=new p.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(t.Schemas.userData,new E.RipgrepSearchProvider(n)),g.remote.isRemote&&g.remote.authority&&this._registerEHSearchProviders()}$enableExtensionHostSearch(){this._registerEHSearchProviders()}_registerEHSearchProviders(){if(this._registeredEHSearchProvider)return;this._registeredEHSearchProvider=!0;const _=new p.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(t.Schemas.file,new E.RipgrepSearchProvider(_)),this.registerInternalFileSearchProvider(t.Schemas.file,new l.SearchService("fileSearchProvider"))}registerInternalFileSearchProvider(_,g){const s=this._handlePool++;return this._internalFileSearchProvider=g,this._internalFileSearchHandle=s,this._proxy.$registerFileSearchProvider(s,this._transformScheme(_)),(0,h.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(s)})}$provideFileSearchResults(_,g,s,d){const n=(0,P.reviveQuery)(s);return _===this._internalFileSearchHandle?this.doInternalFileSearch(_,g,n,d):super.$provideFileSearchResults(_,g,s,d)}doInternalFileSearch(_,g,s,d){const n=S=>{if((0,C.isSerializedFileMatch)(S)&&(S=[S]),Array.isArray(S)){this._proxy.$handleFileMatch(_,g,S.map(o=>I.URI.file(o.path)));return}S.message&&this._logService.debug("ExtHostSearch",S.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(s,n,d)}$clearCache(_){return this._internalFileSearchProvider&&this._internalFileSearchProvider.clearCache(_),super.$clearCache(_)}createTextSearchManager(_,g){return new m.NativeTextSearchManager(_,g,void 0,"textSearchProvider")}};b=je([ze(0,D.IExtHostRpcService),ze(1,k.IExtHostInitDataService),ze(2,L.IURITransformerService),ze(3,R.ILogService)],b),e.NativeExtHostSearch=b}),define(ve[139],we([0,1,298,126,81,22,16,3,6,9,11,33,106,107,299]),function(Z,e,h,t,I,y,R,k,D,P,L,C,l,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class m{constructor(v,w=""){this.debugLabel=w,this.socket=v,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=A=>{if(this.traceSocketEvent("error",{code:A?.code,message:A?.message}),A){if(A.code==="EPIPE")return;(0,R.onUnexpectedError)(A)}},this.socket.on("error",this._errorListener)}traceSocketEvent(v,w){E.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,v,w)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(v){const w=A=>{this.traceSocketEvent("read",A),v(y.VSBuffer.wrap(A))};return this.socket.on("data",w),{dispose:()=>this.socket.off("data",w)}}onClose(v){const w=A=>{this.traceSocketEvent("close",{hadError:A}),v({type:0,hadError:A,error:void 0})};return this.socket.on("close",w),{dispose:()=>this.socket.off("close",w)}}onEnd(v){const w=()=>{this.traceSocketEvent("nodeEndReceived"),v()};return this.socket.on("end",w),{dispose:()=>this.socket.off("end",w)}}write(v){if(!this.socket.destroyed)try{this.traceSocketEvent("write",v),this.socket.write(v.buffer,w=>{if(w){if(w.code==="EPIPE")return;(0,R.onUnexpectedError)(w)}})}catch(w){if(w.code==="EPIPE")return;(0,R.onUnexpectedError)(w)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((v,w)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),v();return}const A=()=>{this.socket.off("close",A),this.socket.off("end",A),this.socket.off("error",A),this.socket.off("timeout",A),this.socket.off("drain",A),this.traceSocketEvent("nodeDrainEnd"),v()};this.socket.on("close",A),this.socket.on("end",A),this.socket.on("error",A),this.socket.on("timeout",A),this.socket.on("drain",A)})}}e.NodeSocket=m;var b;(function(f){f[f.MinHeaderByteSize=2]="MinHeaderByteSize"})(b||(b={}));var F;(function(f){f[f.PeekHeader=1]="PeekHeader",f[f.ReadHeader=2]="ReadHeader",f[f.ReadBody=3]="ReadBody",f[f.Fin=4]="Fin"})(F||(F={}));class _ extends D.Disposable{constructor(v,w,A,M){super();this._onData=this._register(new k.Emitter),this._onClose=this._register(new k.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=v,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:w,inflateBytesLength:A?.byteLength||0,recordInflateBytes:M}),this._flowManager=this._register(new g(this,w,A,M,this._onData,(T,O)=>this._write(T,O))),this._register(this._flowManager.onError(T=>{console.error(T),(0,R.onUnexpectedError)(T),this._onClose.fire({type:0,hadError:!0,error:T})})),this._incomingData=new E.ChunkStream,this._register(this.socket.onData(T=>this._acceptChunk(T))),this._register(this.socket.onClose(T=>this._onClose.fire(T)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(v,w){this.socket.traceSocketEvent(v,w)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(v){return this._onData.event(v)}onClose(v){return this._onClose.event(v)}onEnd(v){return this.socket.onEnd(v)}write(v){this._flowManager.writeMessage(v)}_write(v,w){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",v);let A=2;v.byteLength<126?A+=0:v.byteLength<2**16?A+=2:A+=8;const M=y.VSBuffer.alloc(A);if(w?M.writeUInt8(194,0):M.writeUInt8(130,0),v.byteLength<126)M.writeUInt8(v.byteLength,1);else if(v.byteLength<2**16){M.writeUInt8(126,1);let T=1;M.writeUInt8(v.byteLength>>>8&255,++T),M.writeUInt8(v.byteLength>>>0&255,++T)}else{M.writeUInt8(127,1);let T=1;M.writeUInt8(0,++T),M.writeUInt8(0,++T),M.writeUInt8(0,++T),M.writeUInt8(0,++T),M.writeUInt8(v.byteLength>>>24&255,++T),M.writeUInt8(v.byteLength>>>16&255,++T),M.writeUInt8(v.byteLength>>>8&255,++T),M.writeUInt8(v.byteLength>>>0&255,++T)}this.socket.write(y.VSBuffer.concat([M,v]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(v){if(v.byteLength!==0){for(this._incomingData.acceptChunk(v);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const w=this._incomingData.peek(this._state.readLen),A=w.readUInt8(0),M=(A&128)>>>7,T=(A&64)>>>6,O=w.readUInt8(1),U=(O&128)>>>7,V=O&127;this._state.state=2,this._state.readLen=2+(U?4:0)+(V===126?2:0)+(V===127?8:0),this._state.fin=M,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(T)),this._state.firstFrameOfMessage=Boolean(M),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const w=this._incomingData.read(this._state.readLen),A=w.readUInt8(1),M=(A&128)>>>7;let T=A&127,O=1;T===126?T=w.readUInt8(++O)*2**8+w.readUInt8(++O):T===127&&(T=w.readUInt8(++O)*0+w.readUInt8(++O)*0+w.readUInt8(++O)*0+w.readUInt8(++O)*0+w.readUInt8(++O)*2**24+w.readUInt8(++O)*2**16+w.readUInt8(++O)*2**8+w.readUInt8(++O));let U=0;M&&(U=w.readUInt8(++O)*2**24+w.readUInt8(++O)*2**16+w.readUInt8(++O)*2**8+w.readUInt8(++O)),this._state.state=3,this._state.readLen=T,this._state.mask=U,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const w=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",w),n(w,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",w),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(w,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await k.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=_;class g extends D.Disposable{constructor(v,w,A,M,T,O){super();this._tracer=v,this._onData=T,this._writeFn=O,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new k.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,w?(this._zlibInflateStream=this._register(new s(this._tracer,M,A,{windowBits:15})),this._zlibDeflateStream=this._register(new d(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(U=>this._onError.fire(U))),this._register(this._zlibDeflateStream.onError(U=>this._onError.fire(U)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:y.VSBuffer.alloc(0)}writeMessage(v){this._writeQueue.push(v),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const v=this._writeQueue.shift();if(this._zlibDeflateStream){const w=await this._deflateMessage(this._zlibDeflateStream,v);this._writeFn(w,!0)}else this._writeFn(v,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(v,w){return new Promise((A,M)=>{v.write(w),v.flush(T=>A(T))})}acceptFrame(v,w,A){this._readQueue.push({data:v,isCompressed:w,isLastFrameOfMessage:A}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const v=this._readQueue.shift();if(this._zlibInflateStream&&v.isCompressed){const w=await this._inflateFrame(this._zlibInflateStream,v.data,v.isLastFrameOfMessage);this._onData.fire(w)}else this._onData.fire(v.data)}this._isProcessingReadQueue=!1}}_inflateFrame(v,w,A){return new Promise((M,T)=>{v.write(w),A&&v.write(y.VSBuffer.fromByteArray([0,0,255,255])),v.flush(O=>M(O))})}}class s extends D.Disposable{constructor(v,w,A,M){super();this._tracer=v,this._recordInflateBytes=w,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=p.createInflateRaw(M),this._zlibInflate.on("error",T=>{this._tracer.traceSocketEvent("zlibInflateError",{message:T?.message,code:T?.code}),this._onError.fire(T)}),this._zlibInflate.on("data",T=>{this._tracer.traceSocketEvent("zlibInflateData",T),this._pendingInflateData.push(y.VSBuffer.wrap(T))}),A&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",A.buffer),this._zlibInflate.write(A.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?y.VSBuffer.concat(this._recordedInflateBytes):y.VSBuffer.alloc(0)}write(v){this._recordInflateBytes&&this._recordedInflateBytes.push(v.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",v),this._zlibInflate.write(v.buffer)}flush(v){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const w=y.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,v(w)})}}class d extends D.Disposable{constructor(v,w){super();this._tracer=v,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=p.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",A=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:A?.message,code:A?.code}),this._onError.fire(A)}),this._zlibDeflate.on("data",A=>{this._tracer.traceSocketEvent("zlibDeflateData",A),this._pendingDeflateData.push(y.VSBuffer.wrap(A))})}write(v){this._tracer.traceSocketEvent("zlibDeflateWrite",v.buffer),this._zlibDeflate.write(v.buffer)}flush(v){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let w=y.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,w=w.slice(0,w.byteLength-4),v(w)})}}function n(f,v){if(v===0)return;let w=f.byteLength>>>2;for(let V=0;V<w;V++){const x=f.readUInt32BE(V*4);f.writeUInt32BE(x^v,V*4)}let A=w*4,M=f.byteLength-A;const T=v>>>24&255,O=v>>>16&255,U=v>>>8&255;M>=1&&f.writeUInt8(f.readUInt8(A)^T,A),M>=2&&f.writeUInt8(f.readUInt8(A+1)^O,A+1),M>=3&&f.writeUInt8(f.readUInt8(A+2)^U,A+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const S={[2]:107,[1]:103};function o(){const f=(0,C.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${f}-sock`;let v;return e.XDG_RUNTIME_DIR?v=(0,P.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${f}.sock`):v=(0,P.join)((0,I.tmpdir)(),`vscode-ipc-${f}.sock`),r(v),v}e.createRandomIPCHandle=o;function i(f,v,w){const A=(0,h.createHash)("md5").update(f).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${A}-${w}-${v}-sock`;let M;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?M=(0,P.join)(e.XDG_RUNTIME_DIR,`vscode-${A.substr(0,8)}-${w}-${v}.sock`):M=(0,P.join)(f,`${w}-${v}.sock`),r(M),M}e.createStaticIPCHandle=i;function r(f){const v=S[L.platform];typeof v=="number"&&f.length>=v&&console.warn(`WARNING: IPC handle "${f}" is longer than ${v} chars, try a shorter --user-data-dir`)}class c extends l.IPCServer{constructor(v){super(c.toClientConnectionEvent(v));this.server=v}static toClientConnectionEvent(v){const w=k.Event.fromNodeEventEmitter(v,"connection");return k.Event.map(w,A=>({protocol:new E.Protocol(new m(A,"ipc-server-connection")),onDidClientDisconnect:k.Event.once(k.Event.fromNodeEventEmitter(A,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=c;function a(f){return new Promise((v,w)=>{const A=(0,t.createServer)();A.on("error",w),A.listen(f,()=>{A.removeListener("error",w),v(new c(A))})})}e.serve=a;function u(f,v){return new Promise((w,A)=>{const M=(0,t.createConnection)(f,()=>{M.removeListener("error",A),w(E.Client.fromSocket(new m(M,`ipc-client${v}`),v))});M.once("error",A)})}e.connect=u}),define(ve[287],we([0,1,139,282,60,38,2,198,12]),function(Z,e,h,t,I,y,R,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class P{constructor(l,E,p){this._commands=l,this.logService=E,this._ipcHandlePath=p,this._server=t.createServer((m,b)=>this.onRequest(m,b)),this.setup().catch(m=>(E.error(m),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",l=>this.logService.error(l))}catch{this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(l,E){const p=[];l.setEncoding("utf8"),l.on("data",m=>p.push(m)),l.on("end",()=>{const m=JSON.parse(p.join(""));switch(m.type){case"open":this.open(m,E);break;case"openExternal":this.openExternal(m,E);break;case"status":this.getStatus(m,E);break;case"extensionManagement":this.manageExtensions(m,E).catch(this.logService.error);break;default:E.writeHead(404),E.write(`Unknown message type: ${m.type}`,b=>{b&&this.logService.error(b)}),E.end();break}})}open(l,E){const{fileURIs:p,folderURIs:m,forceNewWindow:b,diffMode:F,addMode:_,forceReuseWindow:g,gotoLineMode:s,waitMarkerFilePath:d,remoteAuthority:n}=l,S=[];if(Array.isArray(m))for(const c of m)try{S.push({folderUri:R.URI.parse(c)})}catch{}if(Array.isArray(p))for(const c of p)try{(0,k.hasWorkspaceFileExtension)(c)?S.push({workspaceUri:R.URI.parse(c)}):S.push({fileUri:R.URI.parse(c)})}catch{}const o=d?R.URI.file(d):void 0,r={forceNewWindow:b,diffMode:F,addMode:_,gotoLineMode:s,forceReuseWindow:g,preferNewWindow:!g&&!o&&!_,waitMarkerFileURI:o,remoteAuthority:n};this._commands.executeCommand("_remoteCLI.windowOpen",S,r),E.writeHead(200),E.end()}async openExternal(l,E){for(const p of l.uris){const m=R.URI.parse(p),b=m.scheme==="file"?m:p;await this._commands.executeCommand("_remoteCLI.openExternal",b)}E.writeHead(200),E.end()}async manageExtensions(l,E){try{const p=F=>F?.map(_=>/\.vsix$/i.test(_)?R.URI.parse(_):_),m={list:l.list,install:p(l.install),uninstall:p(l.uninstall),force:l.force},b=await this._commands.executeCommand("_remoteCLI.manageExtensions",m);E.writeHead(200),E.write(b)}catch(p){E.writeHead(500),E.write(String(p),m=>{m&&this.logService.error(m)})}E.end()}async getStatus(l,E){try{const p=await this._commands.executeCommand("_remoteCLI.getSystemStatus");E.writeHead(200),E.write(p),E.end()}catch(p){E.writeHead(500),E.write(String(p),m=>{m&&this.logService.error(m)}),E.end()}}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&I.existsSync(this._ipcHandlePath)&&I.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=P;let L=class extends P{constructor(l,E){super(l,E,(0,h.createRandomIPCHandle)())}};L=je([ze(0,y.IExtHostCommands),ze(1,D.ILogService)],L),e.CLIServer=L}),define(ve[288],we([0,1,72,280,268,5,281,39,258,2,10,7,287,105]),function(Z,e,h,t,I,y,R,k,D,P,L,C,l,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class p extends I.RequireInterceptor{_installInterceptor(){const F=this,_=Z.__$__nodeRequire("module"),g=_._load;_._load=function(S,o,i){return S=d(S),F._factories.has(S)?F._factories.get(S).load(S,P.URI.file((0,E.realpathSync)(o.filename)),r=>g.apply(this,[r,o,i])):g.apply(this,arguments)};const s=_._resolveLookupPaths;_._resolveLookupPaths=(n,S)=>s.call(this,d(n),S);const d=n=>{for(let S of F._alternatives){let o=S(n);if(o){n=o;break}}return n}}}class m extends k.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=C.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){const F=this._instaService.invokeFunction(t.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(D.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const n=this._instaService.createInstance(l.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=n.ipcHandlePath}await this._instaService.createInstance(p,F,this._registry).install(),h.mark("code/extHost/didInitAPI");const g=await this._extHostConfiguration.getConfigProvider();await(0,R.connectProxyResolver)(this._extHostWorkspace,g,this,this._logService,this._mainThreadTelemetryProxy,this._initData),h.mark("code/extHost/didInitProxyResolver");const s=process.send,d=this._extHostContext.getProxy(y.MainContext.MainThreadConsole);process.send=(...n)=>n.length===0||!n[0]||n[0].type!=="__$console"?s.apply(process,n):(d.$logExtensionHostMessage(n[0]),!1)}_getEntryPoint(F){return F.main}_loadCommonJSModule(F,_,g){if(_.scheme!==L.Schemas.file)throw new Error(`Cannot load URI: '${_}', must be of file-scheme`);let s=null;g.codeLoadingStart(),this._logService.trace(`ExtensionService#loadCommonJSModule ${_.toString(!0)}`),this._logService.flush();try{F&&h.mark(`code/extHost/willLoadExtensionCode/${F.value}`),s=Z.__$__nodeRequire(_.fsPath)}catch(d){return Promise.reject(d)}finally{F&&h.mark(`code/extHost/didLoadExtensionCode/${F.value}`),g.codeLoadingStop()}return Promise.resolve(s)}async $setRemoteEnvironment(F){if(!!this._initData.remote.isRemote)for(const _ in F){const g=F[_];g===null?delete process.env[_]:process.env[_]=g}}}e.ExtHostExtensionService=m}),define(ve[289],we([0,1,61,261,270,269,286,288,262,54,39,73,71,34,51,68,260,259,12]),function(Z,e,h,t,I,y,R,k,D,P,L,C,l,E,p,m,b,F,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,h.registerSingleton)(L.IExtHostExtensionService,k.ExtHostExtensionService),(0,h.registerSingleton)(_.ILoggerService,F.ExtHostLoggerService),(0,h.registerSingleton)(m.IExtensionStoragePaths,b.ExtensionStoragePaths),(0,h.registerSingleton)(P.IExtHostDebugService,y.ExtHostDebugService),(0,h.registerSingleton)(C.IExtHostSearch,R.NativeExtHostSearch),(0,h.registerSingleton)(l.IExtHostTask,I.ExtHostTask),(0,h.registerSingleton)(E.IExtHostTerminalService,t.ExtHostTerminalService),(0,h.registerSingleton)(p.IExtHostTunnelService,D.ExtHostTunnelService)}),define(ve[290],we([0,1,126,300,72,16,107,139,191,223,271,22,103,30,105,13,114,273,289]),function(Z,e,h,t,I,y,R,k,D,P,L,C,l,E,p,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let r=0;r<process.execArgv.length;r++)process.execArgv[r]==="--inspect-port=0"&&(process.execArgv.splice(r,1),r--)}();const F=t(process.argv.slice(2),{string:["uriTransformerPath"],boolean:["skipWorkspaceStorageLock","useHostProxy"]});(function(){const i=Z.__$__nodeRequire("module"),r=i._load;i._load=function(c){if(c==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return r.apply(this,arguments)}})();const _=process.exit.bind(process);function g(i){process.exit=function(r){if(i)_(r);else{const c=new Error("An extension called process.exit() and this was prevented.");console.warn(c.stack)}},process.crash=function(){const r=new Error("An extension called process.crash() and this was prevented.");console.warn(r.stack)}}let s=function(i){_()};function d(){if(process.env.VSCODE_EXTHOST_WILL_SEND_SOCKET)return new Promise((i,r)=>{let c=null,a=setTimeout(()=>{s("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4);const u=108e5,f=3e5,v=new m.ProcessTimeRunOnceScheduler(()=>s("renderer disconnected for too long (1)"),u),w=new m.ProcessTimeRunOnceScheduler(()=>s("renderer disconnected for too long (2)"),f);process.on("message",(M,T)=>{if(M&&M.type==="VSCODE_EXTHOST_IPC_SOCKET"){T.setNoDelay(!0);const O=C.VSBuffer.wrap(Buffer.from(M.initialDataChunk,"base64"));let U;if(M.skipWebSocketFrames)U=new k.NodeSocket(T,"extHost-socket");else{const V=C.VSBuffer.wrap(Buffer.from(M.inflateBytes,"base64"));U=new k.WebSocketNodeSocket(new k.NodeSocket(T,"extHost-socket"),M.permessageDeflate,V,!1)}c?(v.cancel(),w.cancel(),c.beginAcceptReconnection(U,O),c.endAcceptReconnection(),c.sendResume()):(clearTimeout(a),c=new R.PersistentProtocol(U,O),c.sendResume(),c.onDidDispose(()=>s("renderer disconnected")),i(c),c.onSocketClose(()=>{v.schedule()}))}if(M&&M.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(w.isScheduled())return;v.isScheduled()&&w.schedule()}});const A={type:"VSCODE_EXTHOST_IPC_READY"};process.send&&process.send(A)});{const i=process.env.VSCODE_IPC_HOOK_EXTHOST;return new Promise((r,c)=>{const a=h.createConnection(i,()=>{a.removeListener("error",c),r(new R.PersistentProtocol(new k.NodeSocket(a,"extHost-renderer")))});a.once("error",c),a.on("close",()=>{s("renderer closed the socket")})})}}async function n(){const i=await d();return new class{constructor(){this._onMessage=new R.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,i.onMessage(r=>{(0,P.isMessageOfType)(r,2)?(this._terminating=!0,s("received terminate message from renderer")):this._onMessage.fire(r)})}send(r){this._terminating||i.send(r)}drain(){return i.drain()}}}function S(i){return new Promise(r=>{const c=i.onMessage(a=>{c.dispose();const u=JSON.parse(a.toString()),f=u.commit,v=D.default.commit;f&&v&&f!==v&&_(55);let w=0;setInterval(function(){try{process.kill(u.parentPid,0),w=0}catch(M){M&&M.code==="EPERM"?(w++,w>=3&&s(`parent process ${u.parentPid} does not exist anymore (3 x EPERM): ${M.message} (code: ${M.code}) (errno: ${M.errno})`)):s(`parent process ${u.parentPid} does not exist anymore: ${M.message} (code: ${M.code}) (errno: ${M.errno})`)}},1e3);let A;try{A=Z.__$__nodeRequire("native-watchdog"),A.start(u.parentPid)}catch(M){(0,y.onUnexpectedError)(M)}i.send((0,P.createMessageOfType)(0)),r({protocol:i,initData:u})});i.send((0,P.createMessageOfType)(1))})}async function o(){const i=[];process.on("unhandledRejection",(w,A)=>{i.push(A),setTimeout(()=>{const M=i.indexOf(A);M>=0&&A.catch(T=>{i.splice(M,1),(0,y.isCancellationError)(T)||(console.warn(`rejected promise not handled within 1 second: ${T}`),T&&T.stack&&console.warn(`stack trace: ${T.stack}`),w&&(0,y.onUnexpectedError)(w))})},1e3)}),process.on("rejectionHandled",w=>{const A=i.indexOf(w);A>=0&&i.splice(A,1)}),process.on("uncaughtException",function(w){(0,y.onUnexpectedError)(w)}),I.mark("code/extHost/willConnectToRenderer");const r=await n();I.mark("code/extHost/didConnectToRenderer");const c=await S(r);I.mark("code/extHost/didWaitForInitData");const{initData:a}=c;g(!!a.environment.extensionTestsLocationURI),a.environment.useHostProxy=!!F.useHostProxy,a.environment.skipWorkspaceStorageLock=(0,b.boolean)(F.skipWorkspaceStorageLock,!1);const u=new class{constructor(){this.pid=process.pid}exit(A){_(A)}exists(A){return E.Promises.exists(A)}realpath(A){return(0,p.realpath)(A)}};let f=null;if(a.remote.authority&&F.uriTransformerPath)try{const A=Z.__$__nodeRequire(F.uriTransformerPath)(a.remote.authority);f=new l.URITransformer(A)}catch(w){console.error(w)}const v=new L.ExtensionHostMain(c.protocol,a,u,f);s=w=>v.terminate(w)}e.startExtensionHostProcess=o}),define(ve[301],we([0,1,290]),function(Z,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,h.startExtensionHostProcess)().catch(t=>console.log(t))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/0c6d1e9f7ef648cfa50733abb62388bc0791856a/core/vs/workbench/services/extensions/node/extensionHostProcess.js.map
