/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Se=["require","exports","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/base/common/strings","vs/base/common/async","vs/base/common/network","vs/platform/log/common/log","vs/base/common/types","vs/workbench/api/common/extHostRpcService","vs/base/common/errors","vs/base/common/arrays","vs/base/common/path","vs/nls","vs/nls!vs/workbench/services/extensions/worker/extensionHostWorker","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/map","vs/base/common/platform","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/glob","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/severity","vs/base/common/extpath","vs/base/common/uuid","vs/platform/registry/common/platform","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostTerminalService","vs/workbench/services/search/common/search","vs/base/common/assert","vs/base/common/errorMessage","vs/platform/instantiation/common/extensions","vs/platform/contextkey/common/contextkey","vs/platform/files/common/files","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostWebview","vs/base/common/codicons","vs/base/common/decorators","vs/base/common/idGenerator","vs/base/common/marshalling","vs/editor/common/languages/languageSelector","vs/editor/common/languages","vs/editor/common/core/range","vs/platform/instantiation/common/serviceCollection","vs/platform/remote/common/remoteHosts","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/shared/webview","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/collections","vs/base/common/mime","vs/base/common/htmlContent","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/instantiation/common/descriptors","vs/platform/configuration/common/configuration","vs/platform/markers/common/markers","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testCollection","vs/base/common/process","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/base/common/hash","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/numbers","vs/base/common/stream","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/tokenizationRegistry","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/model/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/model","vs/editor/common/languages/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/remote/common/tunnel","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/base/common/iterator","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/output/common/output","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/base/common/stopwatch","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.common.services","vs/workbench/services/views/common/treeViewsDragAndDropService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/editor/common/model/mirrorTextModel","vs/editor/common/viewModel/prefixSumComputer","vs/base/common/marked/marked","vs/base/common/linkedList","vs/editor/common/core/position","vs/base/common/lazy","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/base/common/functional","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/services/extensions/worker/extensionHostWorker"],_e=function(ee){for(var e=[],r=0,t=ee.length;r<t;r++)e[r]=Se[ee[r]];return e};define(Se[42],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function r(t,S){if(!t)throw new Error(S?`Assertion failed (${S})`:"Assertion Failed")}e.ok=r}),define(Se[52],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function r(A){return A?A.replace(/\$\((.*?)\)/g,(I,D)=>` ${D} `).trim():""}e.getCodiconAriaLabel=r;class t{constructor(I,D,T){this.id=I,this.definition=D,this.description=T,t._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t._allCodicons}}e.Codicon=t,t._allCodicons=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",{fontCharacter:"\\ea71"}),t.closeDirty=new t("close-dirty",{fontCharacter:"\\ea71"}),t.debugBreakpoint=new t("debug-breakpoint",{fontCharacter:"\\ea71"}),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),t.debugHint=new t("debug-hint",{fontCharacter:"\\ea71"}),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circleOutline=new t("circle-outline",{fontCharacter:"\\eabc"}),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.debugStackframeDot=new t("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLargeOutline=new t("circle-large-outline",{fontCharacter:"\\ebb5"}),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);function S(A,I){const D=["codicon","codicon-"+A];return I&&D.push("codicon-modifier-"+I),D}e.getClassNamesArray=S;var P;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const I=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function D(b){if(b instanceof t)return["codicon","codicon-"+b.id];const i=I.exec(b.id);if(!i)return D(t.error);let[,f,a]=i;const o=["codicon","codicon-"+f];return a&&o.push("codicon-modifier-"+a.substr(1)),o}A.asClassNameArray=D;function T(b){return D(b).join(" ")}A.asClassName=T;function R(b){return"."+D(b).join(".")}A.asCSSSelector=R})(P=e.CSSIcon||(e.CSSIcon={}))}),define(Se[73],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const r=Object.prototype.hasOwnProperty;function t(R){const b=[];for(let i in R)r.call(R,i)&&b.push(R[i]);return b}e.values=t;function S(R,b){for(let i in R)if(r.call(R,i)&&b({key:i,value:R[i]},function(){delete R[i]})===!1)return}e.forEach=S;function P(R,b){const i=Object.create(null);for(const f of R){const a=b(f);let o=i[a];o||(o=i[a]=[]),o.push(f)}return i}e.groupBy=P;function A(R){const b=Object.create(null);return R&&R.forEach((i,f)=>{b[f]=i}),b}e.fromMap=A;function I(R,b){const i=[],f=[];for(let a of R)b.has(a)||i.push(a);for(let a of b)R.has(a)||f.push(a);return{removed:i,added:f}}e.diffSets=I;function D(R,b){const i=[],f=[];for(let[a,o]of R)b.has(a)||i.push(o);for(let[a,o]of b)R.has(a)||f.push(o);return{removed:i,added:f}}e.diffMaps=D;class T{constructor(){this.map=new Map}add(b,i){let f=this.map.get(b);f||(f=new Set,this.map.set(b,f)),f.add(i)}delete(b,i){const f=this.map.get(b);!f||(f.delete(i),f.size===0&&this.map.delete(b))}forEach(b,i){const f=this.map.get(b);!f||f.forEach(i)}}e.SetMap=T}),define(Se[53],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function r(A){return(I,D,T)=>{let R=null,b=null;if(typeof T.value=="function"?(R="value",b=T.value):typeof T.get=="function"&&(R="get",b=T.get),!b)throw new Error("not supported");T[R]=A(b,D)}}e.createDecorator=r;function t(A,I,D){let T=null,R=null;if(typeof D.value=="function"?(T="value",R=D.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof D.get=="function"&&(T="get",R=D.get),!R)throw new Error("not supported");const b=`$memoize$${I}`;D[T]=function(...i){return this.hasOwnProperty(b)||Object.defineProperty(this,b,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,i)}),this[b]}}e.memoize=t;function S(A,I,D){return r((T,R)=>{const b=`$debounce$${R}`,i=`$debounce$result$${R}`;return function(...f){this[i]||(this[i]=D?D():void 0),clearTimeout(this[b]),I&&(this[i]=I(this[i],...f),f=[this[i]]),this[b]=setTimeout(()=>{T.apply(this,f),this[i]=D?D():void 0},A)}})}e.debounce=S;function P(A,I,D){return r((T,R)=>{const b=`$throttle$timer$${R}`,i=`$throttle$result$${R}`,f=`$throttle$lastRun$${R}`,a=`$throttle$pending$${R}`;return function(...o){if(this[i]||(this[i]=D?D():void 0),(this[f]===null||this[f]===void 0)&&(this[f]=-Number.MAX_VALUE),I&&(this[i]=I(this[i],...o)),this[a])return;const m=this[f]+A;m<=Date.now()?(this[f]=Date.now(),T.apply(this,[this[i]]),this[i]=D?D():void 0):(this[a]=!0,this[b]=setTimeout(()=>{this[a]=!1,this[f]=Date.now(),T.apply(this,[this[i]]),this[i]=D?D():void 0},m-Date.now()))}})}e.throttle=P}),define(Se[54],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class r{constructor(S){this._prefix=S,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=r,e.defaultGenerator=new r("id#")}),define(Se[99],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var r;(function(l){l[l.None=0]="None",l[l.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",l[l.UnexpectedEndOfString=2]="UnexpectedEndOfString",l[l.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",l[l.InvalidUnicode=4]="InvalidUnicode",l[l.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",l[l.InvalidCharacter=6]="InvalidCharacter"})(r=e.ScanError||(e.ScanError={}));var t;(function(l){l[l.OpenBraceToken=1]="OpenBraceToken",l[l.CloseBraceToken=2]="CloseBraceToken",l[l.OpenBracketToken=3]="OpenBracketToken",l[l.CloseBracketToken=4]="CloseBracketToken",l[l.CommaToken=5]="CommaToken",l[l.ColonToken=6]="ColonToken",l[l.NullKeyword=7]="NullKeyword",l[l.TrueKeyword=8]="TrueKeyword",l[l.FalseKeyword=9]="FalseKeyword",l[l.StringLiteral=10]="StringLiteral",l[l.NumericLiteral=11]="NumericLiteral",l[l.LineCommentTrivia=12]="LineCommentTrivia",l[l.BlockCommentTrivia=13]="BlockCommentTrivia",l[l.LineBreakTrivia=14]="LineBreakTrivia",l[l.Trivia=15]="Trivia",l[l.Unknown=16]="Unknown",l[l.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var S;(function(l){l[l.InvalidSymbol=1]="InvalidSymbol",l[l.InvalidNumberFormat=2]="InvalidNumberFormat",l[l.PropertyNameExpected=3]="PropertyNameExpected",l[l.ValueExpected=4]="ValueExpected",l[l.ColonExpected=5]="ColonExpected",l[l.CommaExpected=6]="CommaExpected",l[l.CloseBraceExpected=7]="CloseBraceExpected",l[l.CloseBracketExpected=8]="CloseBracketExpected",l[l.EndOfFileExpected=9]="EndOfFileExpected",l[l.InvalidCommentToken=10]="InvalidCommentToken",l[l.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",l[l.UnexpectedEndOfString=12]="UnexpectedEndOfString",l[l.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",l[l.InvalidUnicode=14]="InvalidUnicode",l[l.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",l[l.InvalidCharacter=16]="InvalidCharacter"})(S=e.ParseErrorCode||(e.ParseErrorCode={}));var P;(function(l){l.DEFAULT={allowTrailingComma:!0}})(P=e.ParseOptions||(e.ParseOptions={}));function A(l,F=!1){let c=0,n=l.length,h="",g=0,s=16,d=0;function p(U){let j=0,H=0;for(;j<U;){const $=l.charCodeAt(c);if($>=48&&$<=57)H=H*16+$-48;else if($>=65&&$<=70)H=H*16+$-65+10;else if($>=97&&$<=102)H=H*16+$-97+10;else break;c++,j++}return j<U&&(H=-1),H}function w(U){c=U,h="",g=0,s=16,d=0}function v(){const U=c;if(l.charCodeAt(c)===48)c++;else for(c++;c<l.length&&T(l.charCodeAt(c));)c++;if(c<l.length&&l.charCodeAt(c)===46)if(c++,c<l.length&&T(l.charCodeAt(c)))for(c++;c<l.length&&T(l.charCodeAt(c));)c++;else return d=3,l.substring(U,c);let j=c;if(c<l.length&&(l.charCodeAt(c)===69||l.charCodeAt(c)===101))if(c++,(c<l.length&&l.charCodeAt(c)===43||l.charCodeAt(c)===45)&&c++,c<l.length&&T(l.charCodeAt(c))){for(c++;c<l.length&&T(l.charCodeAt(c));)c++;j=c}else d=3;return l.substring(U,j)}function k(){let U="",j=c;for(;;){if(c>=n){U+=l.substring(j,c),d=2;break}const H=l.charCodeAt(c);if(H===34){U+=l.substring(j,c),c++;break}if(H===92){if(U+=l.substring(j,c),c++,c>=n){d=2;break}switch(l.charCodeAt(c++)){case 34:U+='"';break;case 92:U+="\\";break;case 47:U+="/";break;case 98:U+="\b";break;case 102:U+="\f";break;case 110:U+=`
`;break;case 114:U+="\r";break;case 116:U+="	";break;case 117:{const G=p(4);G>=0?U+=String.fromCharCode(G):d=4;break}default:d=5}j=c;continue}if(H>=0&&H<=31)if(D(H)){U+=l.substring(j,c),d=2;break}else d=6;c++}return U}function L(){if(h="",d=0,g=c,c>=n)return g=n,s=17;let U=l.charCodeAt(c);if(I(U)){do c++,h+=String.fromCharCode(U),U=l.charCodeAt(c);while(I(U));return s=15}if(D(U))return c++,h+=String.fromCharCode(U),U===13&&l.charCodeAt(c)===10&&(c++,h+=`
`),s=14;switch(U){case 123:return c++,s=1;case 125:return c++,s=2;case 91:return c++,s=3;case 93:return c++,s=4;case 58:return c++,s=6;case 44:return c++,s=5;case 34:return c++,h=k(),s=10;case 47:{const j=c-1;if(l.charCodeAt(c+1)===47){for(c+=2;c<n&&!D(l.charCodeAt(c));)c++;return h=l.substring(j,c),s=12}if(l.charCodeAt(c+1)===42){c+=2;const H=n-1;let $=!1;for(;c<H;){if(l.charCodeAt(c)===42&&l.charCodeAt(c+1)===47){c+=2,$=!0;break}c++}return $||(c++,d=1),h=l.substring(j,c),s=13}return h+=String.fromCharCode(U),c++,s=16}case 45:if(h+=String.fromCharCode(U),c++,c===n||!T(l.charCodeAt(c)))return s=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return h+=v(),s=11;default:for(;c<n&&E(U);)c++,U=l.charCodeAt(c);if(g!==c){switch(h=l.substring(g,c),h){case"true":return s=8;case"false":return s=9;case"null":return s=7}return s=16}return h+=String.fromCharCode(U),c++,s=16}}function E(U){if(I(U)||D(U))return!1;switch(U){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function O(){let U;do U=L();while(U>=12&&U<=15);return U}return{setPosition:w,getPosition:()=>c,scan:F?O:L,getToken:()=>s,getTokenValue:()=>h,getTokenOffset:()=>g,getTokenLength:()=>c-g,getTokenError:()=>d}}e.createScanner=A;function I(l){return l===32||l===9||l===11||l===12||l===160||l===5760||l>=8192&&l<=8203||l===8239||l===8287||l===12288||l===65279}function D(l){return l===10||l===13||l===8232||l===8233}function T(l){return l>=48&&l<=57}var R;(function(l){l[l.nullCharacter=0]="nullCharacter",l[l.maxAsciiCharacter=127]="maxAsciiCharacter",l[l.lineFeed=10]="lineFeed",l[l.carriageReturn=13]="carriageReturn",l[l.lineSeparator=8232]="lineSeparator",l[l.paragraphSeparator=8233]="paragraphSeparator",l[l.nextLine=133]="nextLine",l[l.space=32]="space",l[l.nonBreakingSpace=160]="nonBreakingSpace",l[l.enQuad=8192]="enQuad",l[l.emQuad=8193]="emQuad",l[l.enSpace=8194]="enSpace",l[l.emSpace=8195]="emSpace",l[l.threePerEmSpace=8196]="threePerEmSpace",l[l.fourPerEmSpace=8197]="fourPerEmSpace",l[l.sixPerEmSpace=8198]="sixPerEmSpace",l[l.figureSpace=8199]="figureSpace",l[l.punctuationSpace=8200]="punctuationSpace",l[l.thinSpace=8201]="thinSpace",l[l.hairSpace=8202]="hairSpace",l[l.zeroWidthSpace=8203]="zeroWidthSpace",l[l.narrowNoBreakSpace=8239]="narrowNoBreakSpace",l[l.ideographicSpace=12288]="ideographicSpace",l[l.mathematicalSpace=8287]="mathematicalSpace",l[l.ogham=5760]="ogham",l[l._=95]="_",l[l.$=36]="$",l[l._0=48]="_0",l[l._1=49]="_1",l[l._2=50]="_2",l[l._3=51]="_3",l[l._4=52]="_4",l[l._5=53]="_5",l[l._6=54]="_6",l[l._7=55]="_7",l[l._8=56]="_8",l[l._9=57]="_9",l[l.a=97]="a",l[l.b=98]="b",l[l.c=99]="c",l[l.d=100]="d",l[l.e=101]="e",l[l.f=102]="f",l[l.g=103]="g",l[l.h=104]="h",l[l.i=105]="i",l[l.j=106]="j",l[l.k=107]="k",l[l.l=108]="l",l[l.m=109]="m",l[l.n=110]="n",l[l.o=111]="o",l[l.p=112]="p",l[l.q=113]="q",l[l.r=114]="r",l[l.s=115]="s",l[l.t=116]="t",l[l.u=117]="u",l[l.v=118]="v",l[l.w=119]="w",l[l.x=120]="x",l[l.y=121]="y",l[l.z=122]="z",l[l.A=65]="A",l[l.B=66]="B",l[l.C=67]="C",l[l.D=68]="D",l[l.E=69]="E",l[l.F=70]="F",l[l.G=71]="G",l[l.H=72]="H",l[l.I=73]="I",l[l.J=74]="J",l[l.K=75]="K",l[l.L=76]="L",l[l.M=77]="M",l[l.N=78]="N",l[l.O=79]="O",l[l.P=80]="P",l[l.Q=81]="Q",l[l.R=82]="R",l[l.S=83]="S",l[l.T=84]="T",l[l.U=85]="U",l[l.V=86]="V",l[l.W=87]="W",l[l.X=88]="X",l[l.Y=89]="Y",l[l.Z=90]="Z",l[l.ampersand=38]="ampersand",l[l.asterisk=42]="asterisk",l[l.at=64]="at",l[l.backslash=92]="backslash",l[l.bar=124]="bar",l[l.caret=94]="caret",l[l.closeBrace=125]="closeBrace",l[l.closeBracket=93]="closeBracket",l[l.closeParen=41]="closeParen",l[l.colon=58]="colon",l[l.comma=44]="comma",l[l.dot=46]="dot",l[l.doubleQuote=34]="doubleQuote",l[l.equals=61]="equals",l[l.exclamation=33]="exclamation",l[l.greaterThan=62]="greaterThan",l[l.lessThan=60]="lessThan",l[l.minus=45]="minus",l[l.openBrace=123]="openBrace",l[l.openBracket=91]="openBracket",l[l.openParen=40]="openParen",l[l.percent=37]="percent",l[l.plus=43]="plus",l[l.question=63]="question",l[l.semicolon=59]="semicolon",l[l.singleQuote=39]="singleQuote",l[l.slash=47]="slash",l[l.tilde=126]="tilde",l[l.backspace=8]="backspace",l[l.formFeed=12]="formFeed",l[l.byteOrderMark=65279]="byteOrderMark",l[l.tab=9]="tab",l[l.verticalTab=11]="verticalTab"})(R||(R={}));function b(l,F){const c=[],n=new Object;let h;const g={value:{},offset:0,length:0,type:"object",parent:void 0};let s=!1;function d(p,w,v,k){g.value=p,g.offset=w,g.length=v,g.type=k,g.colonOffset=void 0,h=g}try{_(l,{onObjectBegin:(p,w)=>{if(F<=p)throw n;h=void 0,s=F>p,c.push("")},onObjectProperty:(p,w,v)=>{if(F<w||(d(p,w,v,"property"),c[c.length-1]=p,F<=w+v))throw n},onObjectEnd:(p,w)=>{if(F<=p)throw n;h=void 0,c.pop()},onArrayBegin:(p,w)=>{if(F<=p)throw n;h=void 0,c.push(0)},onArrayEnd:(p,w)=>{if(F<=p)throw n;h=void 0,c.pop()},onLiteralValue:(p,w,v)=>{if(F<w||(d(p,w,v,C(p)),F<=w+v))throw n},onSeparator:(p,w,v)=>{if(F<=w)throw n;if(p===":"&&h&&h.type==="property")h.colonOffset=w,s=!1,h=void 0;else if(p===","){const k=c[c.length-1];typeof k=="number"?c[c.length-1]=k+1:(s=!0,c[c.length-1]=""),h=void 0}}})}catch(p){if(p!==n)throw p}return{path:c,previousNode:h,isAtPropertyKey:s,matches:p=>{let w=0;for(let v=0;w<p.length&&v<c.length;v++)if(p[w]===c[v]||p[w]==="*")w++;else if(p[w]!=="**")return!1;return w===p.length}}}e.getLocation=b;function i(l,F=[],c=P.DEFAULT){let n=null,h=[];const g=[];function s(p){Array.isArray(h)?h.push(p):n!==null&&(h[n]=p)}return _(l,{onObjectBegin:()=>{const p={};s(p),g.push(h),h=p,n=null},onObjectProperty:p=>{n=p},onObjectEnd:()=>{h=g.pop()},onArrayBegin:()=>{const p=[];s(p),g.push(h),h=p,n=null},onArrayEnd:()=>{h=g.pop()},onLiteralValue:s,onError:(p,w,v)=>{F.push({error:p,offset:w,length:v})}},c),h[0]}e.parse=i;function f(l,F=[],c=P.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function h(p){n.type==="property"&&(n.length=p-n.offset,n=n.parent)}function g(p){return n.children.push(p),p}_(l,{onObjectBegin:p=>{n=g({type:"object",offset:p,length:-1,parent:n,children:[]})},onObjectProperty:(p,w,v)=>{n=g({type:"property",offset:w,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:p,offset:w,length:v,parent:n})},onObjectEnd:(p,w)=>{n.length=p+w-n.offset,n=n.parent,h(p+w)},onArrayBegin:(p,w)=>{n=g({type:"array",offset:p,length:-1,parent:n,children:[]})},onArrayEnd:(p,w)=>{n.length=p+w-n.offset,n=n.parent,h(p+w)},onLiteralValue:(p,w,v)=>{g({type:C(p),offset:w,length:v,parent:n,value:p}),h(w+v)},onSeparator:(p,w,v)=>{n.type==="property"&&(p===":"?n.colonOffset=w:p===","&&h(w))},onError:(p,w,v)=>{F.push({error:p,offset:w,length:v})}},c);const d=n.children[0];return d&&delete d.parent,d}e.parseTree=f;function a(l,F){if(!l)return;let c=l;for(let n of F)if(typeof n=="string"){if(c.type!=="object"||!Array.isArray(c.children))return;let h=!1;for(const g of c.children)if(Array.isArray(g.children)&&g.children[0].value===n){c=g.children[1],h=!0;break}if(!h)return}else{const h=n;if(c.type!=="array"||h<0||!Array.isArray(c.children)||h>=c.children.length)return;c=c.children[h]}return c}e.findNodeAtLocation=a;function o(l){if(!l.parent||!l.parent.children)return[];const F=o(l.parent);if(l.parent.type==="property"){const c=l.parent.children[0].value;F.push(c)}else if(l.parent.type==="array"){const c=l.parent.children.indexOf(l);c!==-1&&F.push(c)}return F}e.getNodePath=o;function m(l){switch(l.type){case"array":return l.children.map(m);case"object":{const F=Object.create(null);for(let c of l.children){const n=c.children[1];n&&(F[c.children[0].value]=m(n))}return F}case"null":case"string":case"number":case"boolean":return l.value;default:return}}e.getNodeValue=m;function M(l,F,c=!1){return F>=l.offset&&F<l.offset+l.length||c&&F===l.offset+l.length}e.contains=M;function y(l,F,c=!1){if(M(l,F,c)){const n=l.children;if(Array.isArray(n))for(let h=0;h<n.length&&n[h].offset<=F;h++){const g=y(n[h],F,c);if(g)return g}return l}}e.findNodeAtOffset=y;function _(l,F,c=P.DEFAULT){const n=A(l,!1);function h(ge){return ge?()=>ge(n.getTokenOffset(),n.getTokenLength()):()=>!0}function g(ge){return ge?we=>ge(we,n.getTokenOffset(),n.getTokenLength()):()=>!0}const s=h(F.onObjectBegin),d=g(F.onObjectProperty),p=h(F.onObjectEnd),w=h(F.onArrayBegin),v=h(F.onArrayEnd),k=g(F.onLiteralValue),L=g(F.onSeparator),E=h(F.onComment),O=g(F.onError),U=c&&c.disallowComments,j=c&&c.allowTrailingComma;function H(){for(;;){const ge=n.scan();switch(n.getTokenError()){case 4:$(14);break;case 5:$(15);break;case 3:$(13);break;case 1:U||$(11);break;case 2:$(12);break;case 6:$(16);break}switch(ge){case 12:case 13:U?$(10):E();break;case 16:$(1);break;case 15:case 14:break;default:return ge}}}function $(ge,we=[],re=[]){if(O(ge),we.length+re.length>0){let be=n.getToken();for(;be!==17;){if(we.indexOf(be)!==-1){H();break}else if(re.indexOf(be)!==-1)break;be=H()}}}function G(ge){const we=n.getTokenValue();return ge?k(we):d(we),H(),!0}function ie(){switch(n.getToken()){case 11:{let ge=0;try{ge=JSON.parse(n.getTokenValue()),typeof ge!="number"&&($(2),ge=0)}catch{$(2)}k(ge);break}case 7:k(null);break;case 8:k(!0);break;case 9:k(!1);break;default:return!1}return H(),!0}function le(){return n.getToken()!==10?($(3,[],[2,5]),!1):(G(!1),n.getToken()===6?(L(":"),H(),ve()||$(4,[],[2,5])):$(5,[],[2,5]),!0)}function X(){s(),H();let ge=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(ge||$(4,[],[]),L(","),H(),n.getToken()===2&&j)break}else ge&&$(6,[],[]);le()||$(4,[],[2,5]),ge=!0}return p(),n.getToken()!==2?$(7,[2],[]):H(),!0}function ue(){w(),H();let ge=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(ge||$(4,[],[]),L(","),H(),n.getToken()===4&&j)break}else ge&&$(6,[],[]);ve()||$(4,[],[4,5]),ge=!0}return v(),n.getToken()!==4?$(8,[4],[]):H(),!0}function ve(){switch(n.getToken()){case 3:return ue();case 1:return X();case 10:return G(!0);default:return ie()}}return H(),n.getToken()===17?c.allowEmptyContent?!0:($(4,[],[]),!1):ve()?(n.getToken()!==17&&$(9,[],[]),!0):($(4,[],[]),!1)}e.visit=_;function u(l,F){let c=A(l),n=[],h,g=0,s;do switch(s=c.getPosition(),h=c.scan(),h){case 12:case 13:case 17:g!==s&&n.push(l.substring(g,s)),F!==void 0&&n.push(c.getTokenValue().replace(/[^\r\n]/g,F)),g=c.getPosition();break}while(h!==17);return n.join("")}e.stripComments=u;function C(l){switch(typeof l){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(l){if(Array.isArray(l))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=C}),function(ee,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(ee=typeof globalThis!="undefined"?globalThis:ee||self,ee.marked=e())}(this,function(){"use strict";function ee(Ae,De){for(var pe=0;pe<De.length;pe++){var te=De[pe];te.enumerable=te.enumerable||!1,te.configurable=!0,"value"in te&&(te.writable=!0),Object.defineProperty(Ae,te.key,te)}}function e(Ae,De,pe){return De&&ee(Ae.prototype,De),pe&&ee(Ae,pe),Ae}function r(Ae,De){if(!!Ae){if(typeof Ae=="string")return t(Ae,De);var pe=Object.prototype.toString.call(Ae).slice(8,-1);if(pe==="Object"&&Ae.constructor&&(pe=Ae.constructor.name),pe==="Map"||pe==="Set")return Array.from(Ae);if(pe==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(pe))return t(Ae,De)}}function t(Ae,De){(De==null||De>Ae.length)&&(De=Ae.length);for(var pe=0,te=new Array(De);pe<De;pe++)te[pe]=Ae[pe];return te}function S(Ae,De){var pe=typeof Symbol!="undefined"&&Ae[Symbol.iterator]||Ae["@@iterator"];if(pe)return(pe=pe.call(Ae)).next.bind(pe);if(Array.isArray(Ae)||(pe=r(Ae))||De&&Ae&&typeof Ae.length=="number"){pe&&(Ae=pe);var te=0;return function(){return te>=Ae.length?{done:!0}:{done:!1,value:Ae[te++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}var P={exports:{}};function A(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function I(Ae){P.exports.defaults=Ae}P.exports={defaults:A(),getDefaults:A,changeDefaults:I};var D=/[&<>"']/,T=/[&<>"']/g,R=/[<>"']|&(?!#?\w+;)/,b=/[<>"']|&(?!#?\w+;)/g,i={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},f=function(De){return i[De]};function a(Ae,De){if(De){if(D.test(Ae))return Ae.replace(T,f)}else if(R.test(Ae))return Ae.replace(b,f);return Ae}var o=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function m(Ae){return Ae.replace(o,function(De,pe){return pe=pe.toLowerCase(),pe==="colon"?":":pe.charAt(0)==="#"?pe.charAt(1)==="x"?String.fromCharCode(parseInt(pe.substring(2),16)):String.fromCharCode(+pe.substring(1)):""})}var M=/(^|[^\[])\^/g;function y(Ae,De){Ae=Ae.source||Ae,De=De||"";var pe={replace:function(ne,de){return de=de.source||de,de=de.replace(M,"$1"),Ae=Ae.replace(ne,de),pe},getRegex:function(){return new RegExp(Ae,De)}};return pe}var _=/[^\w:]/g,u=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function C(Ae,De,pe){if(Ae){var te;try{te=decodeURIComponent(m(pe)).replace(_,"").toLowerCase()}catch{return null}if(te.indexOf("javascript:")===0||te.indexOf("vbscript:")===0||te.indexOf("data:")===0)return null}De&&!u.test(pe)&&(pe=h(De,pe));try{pe=encodeURI(pe).replace(/%25/g,"%")}catch{return null}return pe}var l={},F=/^[^:]+:\/*[^/]*$/,c=/^([^:]+:)[\s\S]*$/,n=/^([^:]+:\/*[^/]*)[\s\S]*$/;function h(Ae,De){l[" "+Ae]||(F.test(Ae)?l[" "+Ae]=Ae+"/":l[" "+Ae]=p(Ae,"/",!0)),Ae=l[" "+Ae];var pe=Ae.indexOf(":")===-1;return De.substring(0,2)==="//"?pe?De:Ae.replace(c,"$1")+De:De.charAt(0)==="/"?pe?De:Ae.replace(n,"$1")+De:Ae+De}var g={exec:function(){}};function s(Ae){for(var De=1,pe,te;De<arguments.length;De++){pe=arguments[De];for(te in pe)Object.prototype.hasOwnProperty.call(pe,te)&&(Ae[te]=pe[te])}return Ae}function d(Ae,De){var pe=Ae.replace(/\|/g,function(de,me,Te){for(var He=!1,Le=me;--Le>=0&&Te[Le]==="\\";)He=!He;return He?"|":" |"}),te=pe.split(/ \|/),ne=0;if(te[0].trim()||te.shift(),te[te.length-1].trim()||te.pop(),te.length>De)te.splice(De);else for(;te.length<De;)te.push("");for(;ne<te.length;ne++)te[ne]=te[ne].trim().replace(/\\\|/g,"|");return te}function p(Ae,De,pe){var te=Ae.length;if(te===0)return"";for(var ne=0;ne<te;){var de=Ae.charAt(te-ne-1);if(de===De&&!pe)ne++;else if(de!==De&&pe)ne++;else break}return Ae.substr(0,te-ne)}function w(Ae,De){if(Ae.indexOf(De[1])===-1)return-1;for(var pe=Ae.length,te=0,ne=0;ne<pe;ne++)if(Ae[ne]==="\\")ne++;else if(Ae[ne]===De[0])te++;else if(Ae[ne]===De[1]&&(te--,te<0))return ne;return-1}function v(Ae){Ae&&Ae.sanitize&&!Ae.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function k(Ae,De){if(De<1)return"";for(var pe="";De>1;)De&1&&(pe+=Ae),De>>=1,Ae+=Ae;return pe+Ae}var L={escape:a,unescape:m,edit:y,cleanUrl:C,resolveUrl:h,noopTest:g,merge:s,splitCells:d,rtrim:p,findClosingBracket:w,checkSanitizeDeprecation:v,repeatString:k},E=P.exports.defaults,O=L.rtrim,U=L.splitCells,j=L.escape,H=L.findClosingBracket;function $(Ae,De,pe,te){var ne=De.href,de=De.title?j(De.title):null,me=Ae[1].replace(/\\([\[\]])/g,"$1");if(Ae[0].charAt(0)!=="!"){te.state.inLink=!0;var Te={type:"link",raw:pe,href:ne,title:de,text:me,tokens:te.inlineTokens(me,[])};return te.state.inLink=!1,Te}else return{type:"image",raw:pe,href:ne,title:de,text:j(me)}}function G(Ae,De){var pe=Ae.match(/^(\s+)(?:```)/);if(pe===null)return De;var te=pe[1];return De.split(`
`).map(function(ne){var de=ne.match(/^\s+/);if(de===null)return ne;var me=de[0];return me.length>=te.length?ne.slice(te.length):ne}).join(`
`)}var ie=function(){function Ae(pe){this.options=pe||E}var De=Ae.prototype;return De.space=function(te){var ne=this.rules.block.newline.exec(te);if(ne)return ne[0].length>1?{type:"space",raw:ne[0]}:{raw:`
`}},De.code=function(te){var ne=this.rules.block.code.exec(te);if(ne){var de=ne[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ne[0],codeBlockStyle:"indented",text:this.options.pedantic?de:O(de,`
`)}}},De.fences=function(te){var ne=this.rules.block.fences.exec(te);if(ne){var de=ne[0],me=G(de,ne[3]||"");return{type:"code",raw:de,lang:ne[2]?ne[2].trim():ne[2],text:me}}},De.heading=function(te){var ne=this.rules.block.heading.exec(te);if(ne){var de=ne[2].trim();if(/#$/.test(de)){var me=O(de,"#");(this.options.pedantic||!me||/ $/.test(me))&&(de=me.trim())}var Te={type:"heading",raw:ne[0],depth:ne[1].length,text:de,tokens:[]};return this.lexer.inline(Te.text,Te.tokens),Te}},De.hr=function(te){var ne=this.rules.block.hr.exec(te);if(ne)return{type:"hr",raw:ne[0]}},De.blockquote=function(te){var ne=this.rules.block.blockquote.exec(te);if(ne){var de=ne[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:ne[0],tokens:this.lexer.blockTokens(de,[]),text:de}}},De.list=function(te){var ne=this.rules.block.list.exec(te);if(ne){var de,me,Te,He,Le,Ge,st,at,Ne,ce,fe=ne[1].trim(),oe=fe.length>1,W={type:"list",raw:"",ordered:oe,start:oe?+fe.slice(0,-1):"",loose:!1,items:[]};fe=oe?"\\d{1,9}\\"+fe.slice(-1):"\\"+fe,this.options.pedantic&&(fe=oe?fe:"[*+-]");for(var Ee=new RegExp("^( {0,3}"+fe+")((?: [^\\n]*| *)(?:\\n[^\\n]*)*(?:\\n|$))");te&&!(this.rules.block.hr.test(te)||!(ne=Ee.exec(te)));){Ne=ne[2].split(`
`),this.options.pedantic?(He=2,ce=Ne[0].trimLeft()):(He=ne[2].search(/[^ ]/),He=ne[1].length+(He>4?1:He),ce=Ne[0].slice(He-ne[1].length)),Ge=!1,de=ne[0],!Ne[0]&&/^ *$/.test(Ne[1])&&(de=ne[1]+Ne.slice(0,2).join(`
`)+`
`,W.loose=!0,Ne=[]);var Re=new RegExp("^ {0,"+Math.min(3,He-1)+"}(?:[*+-]|\\d{1,9}[.)])");for(Le=1;Le<Ne.length;Le++){if(at=Ne[Le],this.options.pedantic&&(at=at.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),Re.test(at)){de=ne[1]+Ne.slice(0,Le).join(`
`)+`
`;break}if(!Ge){at.trim()||(Ge=!0),at.search(/[^ ]/)>=He?ce+=`
`+at.slice(He):ce+=`
`+at;continue}if(at.search(/[^ ]/)>=He||!at.trim()){ce+=`
`+at.slice(He);continue}else{de=ne[1]+Ne.slice(0,Le).join(`
`)+`
`;break}}W.loose||(st?W.loose=!0:/\n *\n *$/.test(de)&&(st=!0)),this.options.gfm&&(me=/^\[[ xX]\] /.exec(ce),me&&(Te=me[0]!=="[ ] ",ce=ce.replace(/^\[[ xX]\] +/,""))),W.items.push({type:"list_item",raw:de,task:!!me,checked:Te,loose:!1,text:ce}),W.raw+=de,te=te.slice(de.length)}W.items[W.items.length-1].raw=de.trimRight(),W.items[W.items.length-1].text=ce.trimRight(),W.raw=W.raw.trimRight();var Ve=W.items.length;for(Le=0;Le<Ve;Le++)this.lexer.state.top=!1,W.items[Le].tokens=this.lexer.blockTokens(W.items[Le].text,[]),W.items[Le].tokens.some(function(We){return We.type==="space"})&&(W.loose=!0,W.items[Le].loose=!0);return W}},De.html=function(te){var ne=this.rules.block.html.exec(te);if(ne){var de={type:"html",raw:ne[0],pre:!this.options.sanitizer&&(ne[1]==="pre"||ne[1]==="script"||ne[1]==="style"),text:ne[0]};return this.options.sanitize&&(de.type="paragraph",de.text=this.options.sanitizer?this.options.sanitizer(ne[0]):j(ne[0]),de.tokens=[],this.lexer.inline(de.text,de.tokens)),de}},De.def=function(te){var ne=this.rules.block.def.exec(te);if(ne){ne[3]&&(ne[3]=ne[3].substring(1,ne[3].length-1));var de=ne[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:de,raw:ne[0],href:ne[2],title:ne[3]}}},De.table=function(te){var ne=this.rules.block.table.exec(te);if(ne){var de={type:"table",header:U(ne[1]).map(function(st){return{text:st}}),align:ne[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ne[3]?ne[3].replace(/\n$/,"").split(`
`):[]};if(de.header.length===de.align.length){de.raw=ne[0];var me=de.align.length,Te,He,Le,Ge;for(Te=0;Te<me;Te++)/^ *-+: *$/.test(de.align[Te])?de.align[Te]="right":/^ *:-+: *$/.test(de.align[Te])?de.align[Te]="center":/^ *:-+ *$/.test(de.align[Te])?de.align[Te]="left":de.align[Te]=null;for(me=de.rows.length,Te=0;Te<me;Te++)de.rows[Te]=U(de.rows[Te],de.header.length).map(function(st){return{text:st}});for(me=de.header.length,He=0;He<me;He++)de.header[He].tokens=[],this.lexer.inlineTokens(de.header[He].text,de.header[He].tokens);for(me=de.rows.length,He=0;He<me;He++)for(Ge=de.rows[He],Le=0;Le<Ge.length;Le++)Ge[Le].tokens=[],this.lexer.inlineTokens(Ge[Le].text,Ge[Le].tokens);return de}}},De.lheading=function(te){var ne=this.rules.block.lheading.exec(te);if(ne){var de={type:"heading",raw:ne[0],depth:ne[2].charAt(0)==="="?1:2,text:ne[1],tokens:[]};return this.lexer.inline(de.text,de.tokens),de}},De.paragraph=function(te){var ne=this.rules.block.paragraph.exec(te);if(ne){var de={type:"paragraph",raw:ne[0],text:ne[1].charAt(ne[1].length-1)===`
`?ne[1].slice(0,-1):ne[1],tokens:[]};return this.lexer.inline(de.text,de.tokens),de}},De.text=function(te){var ne=this.rules.block.text.exec(te);if(ne){var de={type:"text",raw:ne[0],text:ne[0],tokens:[]};return this.lexer.inline(de.text,de.tokens),de}},De.escape=function(te){var ne=this.rules.inline.escape.exec(te);if(ne)return{type:"escape",raw:ne[0],text:j(ne[1])}},De.tag=function(te){var ne=this.rules.inline.tag.exec(te);if(ne)return!this.lexer.state.inLink&&/^<a /i.test(ne[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ne[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ne[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ne[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ne[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ne[0]):j(ne[0]):ne[0]}},De.link=function(te){var ne=this.rules.inline.link.exec(te);if(ne){var de=ne[2].trim();if(!this.options.pedantic&&/^</.test(de)){if(!/>$/.test(de))return;var me=O(de.slice(0,-1),"\\");if((de.length-me.length)%2==0)return}else{var Te=H(ne[2],"()");if(Te>-1){var He=ne[0].indexOf("!")===0?5:4,Le=He+ne[1].length+Te;ne[2]=ne[2].substring(0,Te),ne[0]=ne[0].substring(0,Le).trim(),ne[3]=""}}var Ge=ne[2],st="";if(this.options.pedantic){var at=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ge);at&&(Ge=at[1],st=at[3])}else st=ne[3]?ne[3].slice(1,-1):"";return Ge=Ge.trim(),/^</.test(Ge)&&(this.options.pedantic&&!/>$/.test(de)?Ge=Ge.slice(1):Ge=Ge.slice(1,-1)),$(ne,{href:Ge&&Ge.replace(this.rules.inline._escapes,"$1"),title:st&&st.replace(this.rules.inline._escapes,"$1")},ne[0],this.lexer)}},De.reflink=function(te,ne){var de;if((de=this.rules.inline.reflink.exec(te))||(de=this.rules.inline.nolink.exec(te))){var me=(de[2]||de[1]).replace(/\s+/g," ");if(me=ne[me.toLowerCase()],!me||!me.href){var Te=de[0].charAt(0);return{type:"text",raw:Te,text:Te}}return $(de,me,de[0],this.lexer)}},De.emStrong=function(te,ne,de){de===void 0&&(de="");var me=this.rules.inline.emStrong.lDelim.exec(te);if(!!me&&!(me[3]&&de.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Te=me[1]||me[2]||"";if(!Te||Te&&(de===""||this.rules.inline.punctuation.exec(de))){var He=me[0].length-1,Le,Ge,st=He,at=0,Ne=me[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(Ne.lastIndex=0,ne=ne.slice(-1*te.length+He);(me=Ne.exec(ne))!=null;)if(Le=me[1]||me[2]||me[3]||me[4]||me[5]||me[6],!!Le){if(Ge=Le.length,me[3]||me[4]){st+=Ge;continue}else if((me[5]||me[6])&&He%3&&!((He+Ge)%3)){at+=Ge;continue}if(st-=Ge,!(st>0)){if(Ge=Math.min(Ge,Ge+st+at),Math.min(He,Ge)%2){var ce=te.slice(1,He+me.index+Ge);return{type:"em",raw:te.slice(0,He+me.index+Ge+1),text:ce,tokens:this.lexer.inlineTokens(ce,[])}}var fe=te.slice(2,He+me.index+Ge-1);return{type:"strong",raw:te.slice(0,He+me.index+Ge+1),text:fe,tokens:this.lexer.inlineTokens(fe,[])}}}}}},De.codespan=function(te){var ne=this.rules.inline.code.exec(te);if(ne){var de=ne[2].replace(/\n/g," "),me=/[^ ]/.test(de),Te=/^ /.test(de)&&/ $/.test(de);return me&&Te&&(de=de.substring(1,de.length-1)),de=j(de,!0),{type:"codespan",raw:ne[0],text:de}}},De.br=function(te){var ne=this.rules.inline.br.exec(te);if(ne)return{type:"br",raw:ne[0]}},De.del=function(te){var ne=this.rules.inline.del.exec(te);if(ne)return{type:"del",raw:ne[0],text:ne[2],tokens:this.lexer.inlineTokens(ne[2],[])}},De.autolink=function(te,ne){var de=this.rules.inline.autolink.exec(te);if(de){var me,Te;return de[2]==="@"?(me=j(this.options.mangle?ne(de[1]):de[1]),Te="mailto:"+me):(me=j(de[1]),Te=me),{type:"link",raw:de[0],text:me,href:Te,tokens:[{type:"text",raw:me,text:me}]}}},De.url=function(te,ne){var de;if(de=this.rules.inline.url.exec(te)){var me,Te;if(de[2]==="@")me=j(this.options.mangle?ne(de[0]):de[0]),Te="mailto:"+me;else{var He;do He=de[0],de[0]=this.rules.inline._backpedal.exec(de[0])[0];while(He!==de[0]);me=j(de[0]),de[1]==="www."?Te="http://"+me:Te=me}return{type:"link",raw:de[0],text:me,href:Te,tokens:[{type:"text",raw:me,text:me}]}}},De.inlineText=function(te,ne){var de=this.rules.inline.text.exec(te);if(de){var me;return this.lexer.state.inRawBlock?me=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(de[0]):j(de[0]):de[0]:me=j(this.options.smartypants?ne(de[0]):de[0]),{type:"text",raw:de[0],text:me}}},Ae}(),le=L.noopTest,X=L.edit,ue=L.merge,ve={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,table:le,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};ve._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,ve._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,ve.def=X(ve.def).replace("label",ve._label).replace("title",ve._title).getRegex(),ve.bullet=/(?:[*+-]|\d{1,9}[.)])/,ve.listItemStart=X(/^( *)(bull) */).replace("bull",ve.bullet).getRegex(),ve.list=X(ve.list).replace(/bull/g,ve.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+ve.def.source+")").getRegex(),ve._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",ve._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,ve.html=X(ve.html,"i").replace("comment",ve._comment).replace("tag",ve._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),ve.paragraph=X(ve._paragraph).replace("hr",ve.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ve._tag).getRegex(),ve.blockquote=X(ve.blockquote).replace("paragraph",ve.paragraph).getRegex(),ve.normal=ue({},ve),ve.gfm=ue({},ve.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)\\|?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),ve.gfm.table=X(ve.gfm.table).replace("hr",ve.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ve._tag).getRegex(),ve.pedantic=ue({},ve.normal,{html:X(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",ve._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:le,paragraph:X(ve.normal._paragraph).replace("hr",ve.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",ve.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var ge={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:le,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_*]*?\*[^_*]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^_*]*?\_[^_*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:le,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};ge._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",ge.punctuation=X(ge.punctuation).replace(/punctuation/g,ge._punctuation).getRegex(),ge.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,ge.escapedEmSt=/\\\*|\\_/g,ge._comment=X(ve._comment).replace("(?:-->|$)","-->").getRegex(),ge.emStrong.lDelim=X(ge.emStrong.lDelim).replace(/punct/g,ge._punctuation).getRegex(),ge.emStrong.rDelimAst=X(ge.emStrong.rDelimAst,"g").replace(/punct/g,ge._punctuation).getRegex(),ge.emStrong.rDelimUnd=X(ge.emStrong.rDelimUnd,"g").replace(/punct/g,ge._punctuation).getRegex(),ge._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,ge._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,ge._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,ge.autolink=X(ge.autolink).replace("scheme",ge._scheme).replace("email",ge._email).getRegex(),ge._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,ge.tag=X(ge.tag).replace("comment",ge._comment).replace("attribute",ge._attribute).getRegex(),ge._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,ge._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,ge._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,ge.link=X(ge.link).replace("label",ge._label).replace("href",ge._href).replace("title",ge._title).getRegex(),ge.reflink=X(ge.reflink).replace("label",ge._label).getRegex(),ge.reflinkSearch=X(ge.reflinkSearch,"g").replace("reflink",ge.reflink).replace("nolink",ge.nolink).getRegex(),ge.normal=ue({},ge),ge.pedantic=ue({},ge.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:X(/^!?\[(label)\]\((.*?)\)/).replace("label",ge._label).getRegex(),reflink:X(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",ge._label).getRegex()}),ge.gfm=ue({},ge.normal,{escape:X(ge.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),ge.gfm.url=X(ge.gfm.url,"i").replace("email",ge.gfm._extended_email).getRegex(),ge.breaks=ue({},ge.gfm,{br:X(ge.br).replace("{2,}","*").getRegex(),text:X(ge.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var we={block:ve,inline:ge},re=ie,be=P.exports.defaults,Pe=we.block,Fe=we.inline,ze=L.repeatString;function nt(Ae){return Ae.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function et(Ae){var De="",pe,te,ne=Ae.length;for(pe=0;pe<ne;pe++)te=Ae.charCodeAt(pe),Math.random()>.5&&(te="x"+te.toString(16)),De+="&#"+te+";";return De}var Ze=function(){function Ae(pe){this.tokens=[],this.tokens.links=Object.create(null),this.options=pe||be,this.options.tokenizer=this.options.tokenizer||new re,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var te={block:Pe.normal,inline:Fe.normal};this.options.pedantic?(te.block=Pe.pedantic,te.inline=Fe.pedantic):this.options.gfm&&(te.block=Pe.gfm,this.options.breaks?te.inline=Fe.breaks:te.inline=Fe.gfm),this.tokenizer.rules=te}Ae.lex=function(te,ne){var de=new Ae(ne);return de.lex(te)},Ae.lexInline=function(te,ne){var de=new Ae(ne);return de.inlineTokens(te)};var De=Ae.prototype;return De.lex=function(te){te=te.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(te,this.tokens);for(var ne;ne=this.inlineQueue.shift();)this.inlineTokens(ne.src,ne.tokens);return this.tokens},De.blockTokens=function(te,ne){var de=this;ne===void 0&&(ne=[]),this.options.pedantic&&(te=te.replace(/^ +$/gm,""));for(var me,Te,He,Le;te;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(st){return(me=st.call({lexer:de},te,ne))?(te=te.substring(me.raw.length),ne.push(me),!0):!1}))){if(me=this.tokenizer.space(te)){te=te.substring(me.raw.length),me.type&&ne.push(me);continue}if(me=this.tokenizer.code(te)){te=te.substring(me.raw.length),Te=ne[ne.length-1],Te&&(Te.type==="paragraph"||Te.type==="text")?(Te.raw+=`
`+me.raw,Te.text+=`
`+me.text,this.inlineQueue[this.inlineQueue.length-1].src=Te.text):ne.push(me);continue}if(me=this.tokenizer.fences(te)){te=te.substring(me.raw.length),ne.push(me);continue}if(me=this.tokenizer.heading(te)){te=te.substring(me.raw.length),ne.push(me);continue}if(me=this.tokenizer.hr(te)){te=te.substring(me.raw.length),ne.push(me);continue}if(me=this.tokenizer.blockquote(te)){te=te.substring(me.raw.length),ne.push(me);continue}if(me=this.tokenizer.list(te)){te=te.substring(me.raw.length),ne.push(me);continue}if(me=this.tokenizer.html(te)){te=te.substring(me.raw.length),ne.push(me);continue}if(me=this.tokenizer.def(te)){te=te.substring(me.raw.length),Te=ne[ne.length-1],Te&&(Te.type==="paragraph"||Te.type==="text")?(Te.raw+=`
`+me.raw,Te.text+=`
`+me.raw,this.inlineQueue[this.inlineQueue.length-1].src=Te.text):this.tokens.links[me.tag]||(this.tokens.links[me.tag]={href:me.href,title:me.title});continue}if(me=this.tokenizer.table(te)){te=te.substring(me.raw.length),ne.push(me);continue}if(me=this.tokenizer.lheading(te)){te=te.substring(me.raw.length),ne.push(me);continue}if(He=te,this.options.extensions&&this.options.extensions.startBlock&&function(){var st=1/0,at=te.slice(1),Ne=void 0;de.options.extensions.startBlock.forEach(function(ce){Ne=ce.call({lexer:this},at),typeof Ne=="number"&&Ne>=0&&(st=Math.min(st,Ne))}),st<1/0&&st>=0&&(He=te.substring(0,st+1))}(),this.state.top&&(me=this.tokenizer.paragraph(He))){Te=ne[ne.length-1],Le&&Te.type==="paragraph"?(Te.raw+=`
`+me.raw,Te.text+=`
`+me.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Te.text):ne.push(me),Le=He.length!==te.length,te=te.substring(me.raw.length);continue}if(me=this.tokenizer.text(te)){te=te.substring(me.raw.length),Te=ne[ne.length-1],Te&&Te.type==="text"?(Te.raw+=`
`+me.raw,Te.text+=`
`+me.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Te.text):ne.push(me);continue}if(te){var Ge="Infinite loop on byte: "+te.charCodeAt(0);if(this.options.silent){console.error(Ge);break}else throw new Error(Ge)}}return this.state.top=!0,ne},De.inline=function(te,ne){this.inlineQueue.push({src:te,tokens:ne})},De.inlineTokens=function(te,ne){var de=this;ne===void 0&&(ne=[]);var me,Te,He,Le=te,Ge,st,at;if(this.tokens.links){var Ne=Object.keys(this.tokens.links);if(Ne.length>0)for(;(Ge=this.tokenizer.rules.inline.reflinkSearch.exec(Le))!=null;)Ne.includes(Ge[0].slice(Ge[0].lastIndexOf("[")+1,-1))&&(Le=Le.slice(0,Ge.index)+"["+ze("a",Ge[0].length-2)+"]"+Le.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ge=this.tokenizer.rules.inline.blockSkip.exec(Le))!=null;)Le=Le.slice(0,Ge.index)+"["+ze("a",Ge[0].length-2)+"]"+Le.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ge=this.tokenizer.rules.inline.escapedEmSt.exec(Le))!=null;)Le=Le.slice(0,Ge.index)+"++"+Le.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;te;)if(st||(at=""),st=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(fe){return(me=fe.call({lexer:de},te,ne))?(te=te.substring(me.raw.length),ne.push(me),!0):!1}))){if(me=this.tokenizer.escape(te)){te=te.substring(me.raw.length),ne.push(me);continue}if(me=this.tokenizer.tag(te)){te=te.substring(me.raw.length),Te=ne[ne.length-1],Te&&me.type==="text"&&Te.type==="text"?(Te.raw+=me.raw,Te.text+=me.text):ne.push(me);continue}if(me=this.tokenizer.link(te)){te=te.substring(me.raw.length),ne.push(me);continue}if(me=this.tokenizer.reflink(te,this.tokens.links)){te=te.substring(me.raw.length),Te=ne[ne.length-1],Te&&me.type==="text"&&Te.type==="text"?(Te.raw+=me.raw,Te.text+=me.text):ne.push(me);continue}if(me=this.tokenizer.emStrong(te,Le,at)){te=te.substring(me.raw.length),ne.push(me);continue}if(me=this.tokenizer.codespan(te)){te=te.substring(me.raw.length),ne.push(me);continue}if(me=this.tokenizer.br(te)){te=te.substring(me.raw.length),ne.push(me);continue}if(me=this.tokenizer.del(te)){te=te.substring(me.raw.length),ne.push(me);continue}if(me=this.tokenizer.autolink(te,et)){te=te.substring(me.raw.length),ne.push(me);continue}if(!this.state.inLink&&(me=this.tokenizer.url(te,et))){te=te.substring(me.raw.length),ne.push(me);continue}if(He=te,this.options.extensions&&this.options.extensions.startInline&&function(){var fe=1/0,oe=te.slice(1),W=void 0;de.options.extensions.startInline.forEach(function(Ee){W=Ee.call({lexer:this},oe),typeof W=="number"&&W>=0&&(fe=Math.min(fe,W))}),fe<1/0&&fe>=0&&(He=te.substring(0,fe+1))}(),me=this.tokenizer.inlineText(He,nt)){te=te.substring(me.raw.length),me.raw.slice(-1)!=="_"&&(at=me.raw.slice(-1)),st=!0,Te=ne[ne.length-1],Te&&Te.type==="text"?(Te.raw+=me.raw,Te.text+=me.text):ne.push(me);continue}if(te){var ce="Infinite loop on byte: "+te.charCodeAt(0);if(this.options.silent){console.error(ce);break}else throw new Error(ce)}}return ne},e(Ae,null,[{key:"rules",get:function(){return{block:Pe,inline:Fe}}}]),Ae}(),x=P.exports.defaults,K=L.cleanUrl,z=L.escape,V=function(){function Ae(pe){this.options=pe||x}var De=Ae.prototype;return De.code=function(te,ne,de){var me=(ne||"").match(/\S*/)[0];if(this.options.highlight){var Te=this.options.highlight(te,me);Te!=null&&Te!==te&&(de=!0,te=Te)}return te=te.replace(/\n$/,"")+`
`,me?'<pre><code class="'+this.options.langPrefix+z(me,!0)+'">'+(de?te:z(te,!0))+`</code></pre>
`:"<pre><code>"+(de?te:z(te,!0))+`</code></pre>
`},De.blockquote=function(te){return`<blockquote>
`+te+`</blockquote>
`},De.html=function(te){return te},De.heading=function(te,ne,de,me){return this.options.headerIds?"<h"+ne+' id="'+this.options.headerPrefix+me.slug(de)+'">'+te+"</h"+ne+`>
`:"<h"+ne+">"+te+"</h"+ne+`>
`},De.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},De.list=function(te,ne,de){var me=ne?"ol":"ul",Te=ne&&de!==1?' start="'+de+'"':"";return"<"+me+Te+`>
`+te+"</"+me+`>
`},De.listitem=function(te){return"<li>"+te+`</li>
`},De.checkbox=function(te){return"<input "+(te?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},De.paragraph=function(te){return"<p>"+te+`</p>
`},De.table=function(te,ne){return ne&&(ne="<tbody>"+ne+"</tbody>"),`<table>
<thead>
`+te+`</thead>
`+ne+`</table>
`},De.tablerow=function(te){return`<tr>
`+te+`</tr>
`},De.tablecell=function(te,ne){var de=ne.header?"th":"td",me=ne.align?"<"+de+' align="'+ne.align+'">':"<"+de+">";return me+te+"</"+de+`>
`},De.strong=function(te){return"<strong>"+te+"</strong>"},De.em=function(te){return"<em>"+te+"</em>"},De.codespan=function(te){return"<code>"+te+"</code>"},De.br=function(){return this.options.xhtml?"<br/>":"<br>"},De.del=function(te){return"<del>"+te+"</del>"},De.link=function(te,ne,de){if(te=K(this.options.sanitize,this.options.baseUrl,te),te===null)return de;var me='<a href="'+z(te)+'"';return ne&&(me+=' title="'+ne+'"'),me+=">"+de+"</a>",me},De.image=function(te,ne,de){if(te=K(this.options.sanitize,this.options.baseUrl,te),te===null)return de;var me='<img src="'+te+'" alt="'+de+'"';return ne&&(me+=' title="'+ne+'"'),me+=this.options.xhtml?"/>":">",me},De.text=function(te){return te},Ae}(),Y=function(){function Ae(){}var De=Ae.prototype;return De.strong=function(te){return te},De.em=function(te){return te},De.codespan=function(te){return te},De.del=function(te){return te},De.html=function(te){return te},De.text=function(te){return te},De.link=function(te,ne,de){return""+de},De.image=function(te,ne,de){return""+de},De.br=function(){return""},Ae}(),se=function(){function Ae(){this.seen={}}var De=Ae.prototype;return De.serialize=function(te){return te.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},De.getNextSafeSlug=function(te,ne){var de=te,me=0;if(this.seen.hasOwnProperty(de)){me=this.seen[te];do me++,de=te+"-"+me;while(this.seen.hasOwnProperty(de))}return ne||(this.seen[te]=me,this.seen[de]=0),de},De.slug=function(te,ne){ne===void 0&&(ne={});var de=this.serialize(te);return this.getNextSafeSlug(de,ne.dryrun)},Ae}(),ye=V,Ue=Y,je=se,Qe=P.exports.defaults,rt=L.unescape,ot=function(){function Ae(pe){this.options=pe||Qe,this.options.renderer=this.options.renderer||new ye,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Ue,this.slugger=new je}Ae.parse=function(te,ne){var de=new Ae(ne);return de.parse(te)},Ae.parseInline=function(te,ne){var de=new Ae(ne);return de.parseInline(te)};var De=Ae.prototype;return De.parse=function(te,ne){ne===void 0&&(ne=!0);var de="",me,Te,He,Le,Ge,st,at,Ne,ce,fe,oe,W,Ee,Re,Ve,We,mt,Et,St,dt=te.length;for(me=0;me<dt;me++){if(fe=te[me],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[fe.type]&&(St=this.options.extensions.renderers[fe.type].call({parser:this},fe),St!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(fe.type))){de+=St||"";continue}switch(fe.type){case"space":continue;case"hr":{de+=this.renderer.hr();continue}case"heading":{de+=this.renderer.heading(this.parseInline(fe.tokens),fe.depth,rt(this.parseInline(fe.tokens,this.textRenderer)),this.slugger);continue}case"code":{de+=this.renderer.code(fe.text,fe.lang,fe.escaped);continue}case"table":{for(Ne="",at="",Le=fe.header.length,Te=0;Te<Le;Te++)at+=this.renderer.tablecell(this.parseInline(fe.header[Te].tokens),{header:!0,align:fe.align[Te]});for(Ne+=this.renderer.tablerow(at),ce="",Le=fe.rows.length,Te=0;Te<Le;Te++){for(st=fe.rows[Te],at="",Ge=st.length,He=0;He<Ge;He++)at+=this.renderer.tablecell(this.parseInline(st[He].tokens),{header:!1,align:fe.align[He]});ce+=this.renderer.tablerow(at)}de+=this.renderer.table(Ne,ce);continue}case"blockquote":{ce=this.parse(fe.tokens),de+=this.renderer.blockquote(ce);continue}case"list":{for(oe=fe.ordered,W=fe.start,Ee=fe.loose,Le=fe.items.length,ce="",Te=0;Te<Le;Te++)Ve=fe.items[Te],We=Ve.checked,mt=Ve.task,Re="",Ve.task&&(Et=this.renderer.checkbox(We),Ee?Ve.tokens.length>0&&Ve.tokens[0].type==="paragraph"?(Ve.tokens[0].text=Et+" "+Ve.tokens[0].text,Ve.tokens[0].tokens&&Ve.tokens[0].tokens.length>0&&Ve.tokens[0].tokens[0].type==="text"&&(Ve.tokens[0].tokens[0].text=Et+" "+Ve.tokens[0].tokens[0].text)):Ve.tokens.unshift({type:"text",text:Et}):Re+=Et),Re+=this.parse(Ve.tokens,Ee),ce+=this.renderer.listitem(Re,mt,We);de+=this.renderer.list(ce,oe,W);continue}case"html":{de+=this.renderer.html(fe.text);continue}case"paragraph":{de+=this.renderer.paragraph(this.parseInline(fe.tokens));continue}case"text":{for(ce=fe.tokens?this.parseInline(fe.tokens):fe.text;me+1<dt&&te[me+1].type==="text";)fe=te[++me],ce+=`
`+(fe.tokens?this.parseInline(fe.tokens):fe.text);de+=ne?this.renderer.paragraph(ce):ce;continue}default:{var vt='Token with "'+fe.type+'" type was not found.';if(this.options.silent){console.error(vt);return}else throw new Error(vt)}}}return de},De.parseInline=function(te,ne){ne=ne||this.renderer;var de="",me,Te,He,Le=te.length;for(me=0;me<Le;me++){if(Te=te[me],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Te.type]&&(He=this.options.extensions.renderers[Te.type].call({parser:this},Te),He!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Te.type))){de+=He||"";continue}switch(Te.type){case"escape":{de+=ne.text(Te.text);break}case"html":{de+=ne.html(Te.text);break}case"link":{de+=ne.link(Te.href,Te.title,this.parseInline(Te.tokens,ne));break}case"image":{de+=ne.image(Te.href,Te.title,Te.text);break}case"strong":{de+=ne.strong(this.parseInline(Te.tokens,ne));break}case"em":{de+=ne.em(this.parseInline(Te.tokens,ne));break}case"codespan":{de+=ne.codespan(Te.text);break}case"br":{de+=ne.br();break}case"del":{de+=ne.del(this.parseInline(Te.tokens,ne));break}case"text":{de+=ne.text(Te.text);break}default:{var Ge='Token with "'+Te.type+'" type was not found.';if(this.options.silent){console.error(Ge);return}else throw new Error(Ge)}}}return de},Ae}(),Je=Ze,tt=ot,pt=ie,Me=V,At=Y,q=se,Q=L.merge,he=L.checkSanitizeDeprecation,Be=L.escape,qe=P.exports.getDefaults,lt=P.exports.changeDefaults,ht=P.exports.defaults;function Ye(Ae,De,pe){if(typeof Ae=="undefined"||Ae===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Ae!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Ae)+", string expected");if(typeof De=="function"&&(pe=De,De=null),De=Q({},Ye.defaults,De||{}),he(De),pe){var te=De.highlight,ne;try{ne=Je.lex(Ae,De)}catch(He){return pe(He)}var de=function(Le){var Ge;if(!Le)try{De.walkTokens&&Ye.walkTokens(ne,De.walkTokens),Ge=tt.parse(ne,De)}catch(st){Le=st}return De.highlight=te,Le?pe(Le):pe(null,Ge)};if(!te||te.length<3||(delete De.highlight,!ne.length))return de();var me=0;Ye.walkTokens(ne,function(He){He.type==="code"&&(me++,setTimeout(function(){te(He.text,He.lang,function(Le,Ge){if(Le)return de(Le);Ge!=null&&Ge!==He.text&&(He.text=Ge,He.escaped=!0),me--,me===0&&de()})},0))}),me===0&&de();return}try{var Te=Je.lex(Ae,De);return De.walkTokens&&Ye.walkTokens(Te,De.walkTokens),tt.parse(Te,De)}catch(He){if(He.message+=`
Please report this to https://github.com/markedjs/marked.`,De.silent)return"<p>An error occurred:</p><pre>"+Be(He.message+"",!0)+"</pre>";throw He}}Ye.options=Ye.setOptions=function(Ae){return Q(Ye.defaults,Ae),lt(Ye.defaults),Ye},Ye.getDefaults=qe,Ye.defaults=ht,Ye.use=function(){for(var Ae=this,De=arguments.length,pe=new Array(De),te=0;te<De;te++)pe[te]=arguments[te];var ne=Q.apply(void 0,[{}].concat(pe)),de=Ye.defaults.extensions||{renderers:{},childTokens:{}},me;pe.forEach(function(Te){if(Te.extensions&&(me=!0,Te.extensions.forEach(function(Le){if(!Le.name)throw new Error("extension name required");if(Le.renderer){var Ge=de.renderers?de.renderers[Le.name]:null;Ge?de.renderers[Le.name]=function(){for(var st=arguments.length,at=new Array(st),Ne=0;Ne<st;Ne++)at[Ne]=arguments[Ne];var ce=Le.renderer.apply(this,at);return ce===!1&&(ce=Ge.apply(this,at)),ce}:de.renderers[Le.name]=Le.renderer}if(Le.tokenizer){if(!Le.level||Le.level!=="block"&&Le.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");de[Le.level]?de[Le.level].unshift(Le.tokenizer):de[Le.level]=[Le.tokenizer],Le.start&&(Le.level==="block"?de.startBlock?de.startBlock.push(Le.start):de.startBlock=[Le.start]:Le.level==="inline"&&(de.startInline?de.startInline.push(Le.start):de.startInline=[Le.start]))}Le.childTokens&&(de.childTokens[Le.name]=Le.childTokens)})),Te.renderer&&function(){var Le=Ye.defaults.renderer||new Me,Ge=function(Ne){var ce=Le[Ne];Le[Ne]=function(){for(var fe=arguments.length,oe=new Array(fe),W=0;W<fe;W++)oe[W]=arguments[W];var Ee=Te.renderer[Ne].apply(Le,oe);return Ee===!1&&(Ee=ce.apply(Le,oe)),Ee}};for(var st in Te.renderer)Ge(st);ne.renderer=Le}(),Te.tokenizer&&function(){var Le=Ye.defaults.tokenizer||new pt,Ge=function(Ne){var ce=Le[Ne];Le[Ne]=function(){for(var fe=arguments.length,oe=new Array(fe),W=0;W<fe;W++)oe[W]=arguments[W];var Ee=Te.tokenizer[Ne].apply(Le,oe);return Ee===!1&&(Ee=ce.apply(Le,oe)),Ee}};for(var st in Te.tokenizer)Ge(st);ne.tokenizer=Le}(),Te.walkTokens){var He=Ye.defaults.walkTokens;ne.walkTokens=function(Le){Te.walkTokens.call(Ae,Le),He&&He(Le)}}me&&(ne.extensions=de),Ye.setOptions(ne)})},Ye.walkTokens=function(Ae,De){for(var pe=function(){var me=ne.value;switch(De(me),me.type){case"table":{for(var Te=S(me.header),He;!(He=Te()).done;){var Le=He.value;Ye.walkTokens(Le.tokens,De)}for(var Ge=S(me.rows),st;!(st=Ge()).done;)for(var at=st.value,Ne=S(at),ce;!(ce=Ne()).done;){var fe=ce.value;Ye.walkTokens(fe.tokens,De)}break}case"list":{Ye.walkTokens(me.items,De);break}default:Ye.defaults.extensions&&Ye.defaults.extensions.childTokens&&Ye.defaults.extensions.childTokens[me.type]?Ye.defaults.extensions.childTokens[me.type].forEach(function(oe){Ye.walkTokens(me[oe],De)}):me.tokens&&Ye.walkTokens(me.tokens,De)}},te=S(Ae),ne;!(ne=te()).done;)pe()},Ye.parseInline=function(Ae,De){if(typeof Ae=="undefined"||Ae===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Ae!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Ae)+", string expected");De=Q({},Ye.defaults,De||{}),he(De);try{var pe=Je.lexInline(Ae,De);return De.walkTokens&&Ye.walkTokens(pe,De.walkTokens),tt.parseInline(pe,De)}catch(te){if(te.message+=`
Please report this to https://github.com/markedjs/marked.`,De.silent)return"<p>An error occurred:</p><pre>"+Be(te.message+"",!0)+"</pre>";throw te}},Ye.Parser=tt,Ye.parser=tt.parse,Ye.Renderer=Me,Ye.TextRenderer=At,Ye.Lexer=Je,Ye.lexer=Je.lex,Ye.Tokenizer=pt,Ye.Slugger=q,Ye.parse=Ye;var kt=Ye;return kt}),define(Se[100],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function r(I,D,T){return Math.min(Math.max(I,D),T)}e.clamp=r;function t(I,D){return(D+I%D)%D}e.rot=t;class S{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=S;class P{constructor(){this._n=1,this._val=0}update(D){return this._val=this._val+(D-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=P;class A{constructor(D){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(D),this._values.fill(0,0,D)}update(D){const T=this._values[this._index];return this._values[this._index]=D,this._index=(this._index+1)%this._values.length,this._sum-=T,this._sum+=D,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=A}),function(){function ee(S){const P=[];typeof S=="number"&&P.push("code/timeOrigin",S);function A(D){P.push(D,Date.now())}function I(){const D=[];for(let T=0;T<P.length;T+=2)D.push({name:P[T],startTime:P[T+1]});return D}return{mark:A,getMarks:I}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ee():{mark(S){performance.mark(S)},getMarks(){let S=performance.timeOrigin;typeof S!="number"&&(S=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const P=[{name:"code/timeOrigin",startTime:Math.round(S)}];for(const A of performance.getEntriesByType("mark"))P.push({name:A.name,startTime:Math.round(S+A.startTime)});return P}};if(typeof process=="object"){const S=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return ee(S)}else return console.trace("perf-util loaded in UNKNOWN environment"),ee()}function r(S){return S.MonacoPerformanceMarks||(S.MonacoPerformanceMarks=e()),S.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return r(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=r(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=r(t))}(),define(Se[74],_e([0,1,17]),function(ee,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0;var t;(function(b){b.text="text/plain",b.binary="application/octet-stream",b.unknown="application/unknown",b.markdown="text/markdown",b.latex="text/latex"})(t=e.Mimes||(e.Mimes={}));const S={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},P={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function A(b){const i=(0,r.extname)(b),f=S[i.toLowerCase()];return f!==void 0?f:I(b)}e.getMediaOrTextMime=A;function I(b){const i=(0,r.extname)(b);return P[i.toLowerCase()]}e.getMediaMime=I;function D(b){for(const i in P)if(P[i]===b)return i}e.getExtensionForMimeType=D;const T=/^(.+)\/(.+?)(;.+)?$/;function R(b,i){const f=T.exec(b);return f?`${f[1].toLowerCase()}/${f[2].toLowerCase()}${f[3]??""}`:i?void 0:b}e.normalizeMimeType=R}),define(Se[101],_e([0,1,15,6]),function(ee,e,r,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function S(_){const u=_;return u?[u.on,u.pause,u.resume,u.destroy].every(C=>typeof C=="function"):!1}e.isReadableStream=S;function P(_){const u=_;return u?S(u.stream)&&Array.isArray(u.buffer)&&typeof u.ended=="boolean":!1}e.isReadableBufferedStream=P;function A(_,u){return new I(_,u)}e.newWriteableStream=A;class I{constructor(u,C){this.reducer=u,this.options=C,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(u){if(!this.state.destroyed){if(this.state.flowing)this.emitData(u);else if(this.buffer.data.push(u),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(C=>this.pendingWritePromises.push(C))}}error(u){this.state.destroyed||(this.state.flowing?this.emitError(u):this.buffer.error.push(u))}end(u){this.state.destroyed||(typeof u!="undefined"&&this.write(u),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(u){this.listeners.data.slice(0).forEach(C=>C(u))}emitError(u){this.listeners.error.length===0?(0,r.onUnexpectedError)(u):this.listeners.error.slice(0).forEach(C=>C(u))}emitEnd(){this.listeners.end.slice(0).forEach(u=>u())}on(u,C){if(!this.state.destroyed)switch(u){case"data":this.listeners.data.push(C),this.resume();break;case"end":this.listeners.end.push(C),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(C),this.state.flowing&&this.flowErrors();break}}removeListener(u,C){if(this.state.destroyed)return;let l;switch(u){case"data":l=this.listeners.data;break;case"end":l=this.listeners.end;break;case"error":l=this.listeners.error;break}if(l){const F=l.indexOf(C);F>=0&&l.splice(F,1)}}flowData(){if(this.buffer.data.length>0){const u=this.reducer(this.buffer.data);this.emitData(u),this.buffer.data.length=0;const C=[...this.pendingWritePromises];this.pendingWritePromises.length=0,C.forEach(l=>l())}}flowErrors(){if(this.listeners.error.length>0){for(const u of this.buffer.error)this.emitError(u);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function D(_,u){const C=[];let l;for(;(l=_.read())!==null;)C.push(l);return u(C)}e.consumeReadable=D;function T(_,u,C){const l=[];let F;for(;(F=_.read())!==null&&l.length<C;)l.push(F);return F===null&&l.length>0?u(l):{read:()=>{if(l.length>0)return l.shift();if(typeof F!="undefined"){const c=F;return F=void 0,c}return _.read()}}}e.peekReadable=T;function R(_,u){return new Promise((C,l)=>{const F=[];b(_,{onData:c=>{u&&F.push(c)},onError:c=>{u?l(c):C(void 0)},onEnd:()=>{C(u?u(F):void 0)}})})}e.consumeStream=R;function b(_,u){let C=!1;return _.on("error",l=>{C||u.onError(l)}),_.on("end",()=>{C||u.onEnd()}),_.on("data",l=>{C||u.onData(l)}),(0,t.toDisposable)(()=>C=!0)}e.listenStream=b;function i(_,u){return new Promise((C,l)=>{const F=new t.DisposableStore,c=[],n=s=>{if(c.push(s),c.length>u)return F.dispose(),_.pause(),C({stream:_,buffer:c,ended:!1})},h=s=>l(s),g=()=>C({stream:_,buffer:c,ended:!0});F.add((0,t.toDisposable)(()=>_.removeListener("error",h))),_.on("error",h),F.add((0,t.toDisposable)(()=>_.removeListener("end",g))),_.on("end",g),F.add((0,t.toDisposable)(()=>_.removeListener("data",n))),_.on("data",n)})}e.peekStream=i;function f(_,u){const C=A(u);return C.end(_),C}e.toStream=f;function a(){const _=A(()=>{throw new Error("not supported")});return _.end(),_}e.emptyStream=a;function o(_){let u=!1;return{read:()=>u?null:(u=!0,_)}}e.toReadable=o;function m(_,u,C){const l=A(C);return b(_,{onData:F=>l.write(u.data(F)),onError:F=>l.error(u.error?u.error(F):F),onEnd:()=>l.end()}),l}e.transform=m;function M(_,u,C){let l=!1;return{read:()=>{const F=u.read();return l?F:(l=!0,F!==null?C([_,F]):_)}}}e.prefixedReadable=M;function y(_,u,C){let l=!1;const F=A(C);return b(u,{onData:c=>l?F.write(c):(l=!0,F.write(C([_,c]))),onError:c=>F.error(c),onEnd:()=>{l||(l=!0,F.write(_)),F.end()}}),F}e.prefixedStream=y}),define(Se[21],_e([0,1,101]),function(ee,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer!="undefined";let S,P;class A{constructor(d){this.buffer=d,this.byteLength=this.buffer.byteLength}static alloc(d){return t?new A(Buffer.allocUnsafe(d)):new A(new Uint8Array(d))}static wrap(d){return t&&!Buffer.isBuffer(d)&&(d=Buffer.from(d.buffer,d.byteOffset,d.byteLength)),new A(d)}static fromString(d,p){return!(p?.dontUseNodeBuffer||!1)&&t?new A(Buffer.from(d)):(S||(S=new TextEncoder),new A(S.encode(d)))}static fromByteArray(d){const p=A.alloc(d.length);for(let w=0,v=d.length;w<v;w++)p.buffer[w]=d[w];return p}static concat(d,p){if(typeof p=="undefined"){p=0;for(let k=0,L=d.length;k<L;k++)p+=d[k].byteLength}const w=A.alloc(p);let v=0;for(let k=0,L=d.length;k<L;k++){const E=d[k];w.set(E,v),v+=E.byteLength}return w}clone(){const d=A.alloc(this.byteLength);return d.set(this),d}toString(){return t?this.buffer.toString():(P||(P=new TextDecoder),P.decode(this.buffer))}slice(d,p){return new A(this.buffer.subarray(d,p))}set(d,p){if(d instanceof A)this.buffer.set(d.buffer,p);else if(d instanceof Uint8Array)this.buffer.set(d,p);else if(d instanceof ArrayBuffer)this.buffer.set(new Uint8Array(d),p);else if(ArrayBuffer.isView(d))this.buffer.set(new Uint8Array(d.buffer,d.byteOffset,d.byteLength),p);else throw new Error("Unkown argument 'array'")}readUInt32BE(d){return T(this.buffer,d)}writeUInt32BE(d,p){R(this.buffer,d,p)}readUInt32LE(d){return b(this.buffer,d)}writeUInt32LE(d,p){i(this.buffer,d,p)}readUInt8(d){return f(this.buffer,d)}writeUInt8(d,p){a(this.buffer,d,p)}}e.VSBuffer=A;function I(s,d){return s[d+0]<<0>>>0|s[d+1]<<8>>>0}e.readUInt16LE=I;function D(s,d,p){s[p+0]=d&255,d=d>>>8,s[p+1]=d&255}e.writeUInt16LE=D;function T(s,d){return s[d]*2**24+s[d+1]*2**16+s[d+2]*2**8+s[d+3]}e.readUInt32BE=T;function R(s,d,p){s[p+3]=d,d=d>>>8,s[p+2]=d,d=d>>>8,s[p+1]=d,d=d>>>8,s[p]=d}e.writeUInt32BE=R;function b(s,d){return s[d+0]<<0>>>0|s[d+1]<<8>>>0|s[d+2]<<16>>>0|s[d+3]<<24>>>0}e.readUInt32LE=b;function i(s,d,p){s[p+0]=d&255,d=d>>>8,s[p+1]=d&255,d=d>>>8,s[p+2]=d&255,d=d>>>8,s[p+3]=d&255}e.writeUInt32LE=i;function f(s,d){return s[d]}e.readUInt8=f;function a(s,d,p){s[p]=d}e.writeUInt8=a;function o(s){return r.consumeReadable(s,d=>A.concat(d))}e.readableToBuffer=o;function m(s){return r.toReadable(s)}e.bufferToReadable=m;function M(s){return r.consumeStream(s,d=>A.concat(d))}e.streamToBuffer=M;async function y(s){return s.ended?A.concat(s.buffer):A.concat([...s.buffer,await M(s.stream)])}e.bufferedStreamToBuffer=y;function _(s){return r.toStream(s,d=>A.concat(d))}e.bufferToStream=_;function u(s){return r.transform(s,{data:d=>typeof d=="string"?A.fromString(d):A.wrap(d)},d=>A.concat(d))}e.streamToBufferReadableStream=u;function C(s){return r.newWriteableStream(d=>A.concat(d),s)}e.newWriteableBufferStream=C;function l(s,d){return r.prefixedReadable(s,d,p=>A.concat(p))}e.prefixedBufferReadable=l;function F(s,d){return r.prefixedStream(s,d,p=>A.concat(p))}e.prefixedBufferStream=F;function c(s){let d=0,p=0,w=0;const v=new Uint8Array(Math.floor(s.length/4*3)),k=E=>{switch(p){case 3:v[w++]=d|E,p=0;break;case 2:v[w++]=d|E>>>2,d=E<<6,p=3;break;case 1:v[w++]=d|E>>>4,d=E<<4,p=2;break;default:d=E<<2,p=1}};for(let E=0;E<s.length;E++){const O=s.charCodeAt(E);if(O>=65&&O<=90)k(O-65);else if(O>=97&&O<=122)k(O-97+26);else if(O>=48&&O<=57)k(O-48+52);else if(O===43||O===45)k(62);else if(O===47||O===95)k(63);else{if(O===61)break;throw new SyntaxError(`Unexpected base64 character ${s[E]}`)}}const L=w;for(;p>0;)k(0);return A.wrap(v).slice(0,L)}e.decodeBase64=c;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",h="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function g({buffer:s},d=!0,p=!1){const w=p?h:n;let v="";const k=s.byteLength%3;let L=0;for(;L<s.byteLength-k;L+=3){const E=s[L+0],O=s[L+1],U=s[L+2];v+=w[E>>>2],v+=w[(E<<4|O>>>4)&63],v+=w[(O<<2|U>>>6)&63],v+=w[U&63]}if(k===1){const E=s[L+0];v+=w[E>>>2],v+=w[E<<4&63],d&&(v+="==")}else if(k===2){const E=s[L+0],O=s[L+1];v+=w[E>>>2],v+=w[(E<<4|O>>>4)&63],v+=w[O<<2&63],d&&(v+="=")}return v}e.encodeBase64=g});var Xe=this&&this.__classPrivateFieldSet||function(ee,e,r,t,S){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!S:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?S.call(ee,r):S?S.value=r:e.set(ee,r),r},Ie=this&&this.__classPrivateFieldGet||function(ee,e,r,t){if(r==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!t:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?t:r==="a"?t.call(ee):t?t.value:e.get(ee)};define(Se[22],_e([0,1,16,9]),function(ee,e,r,t){"use strict";var S,P,A;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function I(c,n,h){let g=c.get(n);return g===void 0&&(g=h,c.set(n,g)),g}e.getOrSet=I;function D(c){const n=[];return c.forEach((h,g)=>{n.push(`${g} => ${h}`)}),`Map(${c.size}) {${n.join(", ")}}`}e.mapToString=D;function T(c){const n=[];return c.forEach(h=>{n.push(h)}),`Set(${c.size}) {${n.join(", ")}}`}e.setToString=T;class R{constructor(){this._value="",this._pos=0}reset(n){return this._value=n,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(n){const h=n.charCodeAt(0),g=this._value.charCodeAt(this._pos);return h-g}value(){return this._value[this._pos]}}e.StringIterator=R;class b{constructor(n=!0){this._caseSensitive=n}reset(n){return this._value=n,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(n)this._from++;else break;else n=!1;return this}cmp(n){return this._caseSensitive?(0,t.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=b;class i{constructor(n=!0,h=!0){this._splitOnBackslash=n,this._caseSensitive=h}reset(n){this._from=0,this._to=0,this._value=n,this._valueLen=n.length;for(let h=n.length-1;h>=0;h--,this._valueLen--){const g=this._value.charCodeAt(h);if(!(g===47||this._splitOnBackslash&&g===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let n=!0;for(;this._to<this._valueLen;this._to++){const h=this._value.charCodeAt(this._to);if(h===47||this._splitOnBackslash&&h===92)if(n)this._from++;else break;else n=!1}return this}cmp(n){return this._caseSensitive?(0,t.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=i;var f;(function(c){c[c.Scheme=1]="Scheme",c[c.Authority=2]="Authority",c[c.Path=3]="Path",c[c.Query=4]="Query",c[c.Fragment=5]="Fragment"})(f||(f={}));class a{constructor(n){this._ignorePathCasing=n,this._states=[],this._stateIdx=0}reset(n){return this._value=n,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new i(!1,!this._ignorePathCasing(n)),this._pathIterator.reset(n.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(n){if(this._states[this._stateIdx]===1)return(0,t.compareIgnoreCase)(n,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,t.compareIgnoreCase)(n,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(n);if(this._states[this._stateIdx]===4)return(0,t.compare)(n,this._value.query);if(this._states[this._stateIdx]===5)return(0,t.compare)(n,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=a;class o{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const n=this.right;return this.right=n.left,n.left=this,this.updateHeight(),n.updateHeight(),n}rotateRight(){const n=this.left;return this.left=n.right,n.right=this,this.updateHeight(),n.updateHeight(),n}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var m;(function(c){c[c.Left=-1]="Left",c[c.Mid=0]="Mid",c[c.Right=1]="Right"})(m||(m={}));class M{constructor(n){this._iter=n}static forUris(n=()=>!1){return new M(new a(n))}static forPaths(n=!1){return new M(new i(void 0,!n))}static forStrings(){return new M(new R)}static forConfigKeys(){return new M(new b)}clear(){this._root=void 0}fill(n,h){if(h){const g=h.slice(0);(0,r.shuffle)(g);for(let s of g)this.set(s,n)}else{const g=n.slice(0);(0,r.shuffle)(g);for(let s of g)this.set(s[0],s[1])}}set(n,h){const g=this._iter.reset(n);let s;this._root||(this._root=new o,this._root.segment=g.value());const d=[];for(s=this._root;;){const w=g.cmp(s.segment);if(w>0)s.left||(s.left=new o,s.left.segment=g.value()),d.push([-1,s]),s=s.left;else if(w<0)s.right||(s.right=new o,s.right.segment=g.value()),d.push([1,s]),s=s.right;else if(g.hasNext())g.next(),s.mid||(s.mid=new o,s.mid.segment=g.value()),d.push([0,s]),s=s.mid;else break}const p=s.value;s.value=h,s.key=n;for(let w=d.length-1;w>=0;w--){const v=d[w][1];v.updateHeight();const k=v.balanceFactor();if(k<-1||k>1){const L=d[w][0],E=d[w+1][0];if(L===1&&E===1)d[w][1]=v.rotateLeft();else if(L===-1&&E===-1)d[w][1]=v.rotateRight();else if(L===1&&E===-1)v.right=d[w+1][1]=d[w+1][1].rotateRight(),d[w][1]=v.rotateLeft();else if(L===-1&&E===1)v.left=d[w+1][1]=d[w+1][1].rotateLeft(),d[w][1]=v.rotateRight();else throw new Error;if(w>0)switch(d[w-1][0]){case-1:d[w-1][1].left=d[w][1];break;case 1:d[w-1][1].right=d[w][1];break;case 0:d[w-1][1].mid=d[w][1];break}else this._root=d[0][1]}}return p}get(n){return this._getNode(n)?.value}_getNode(n){const h=this._iter.reset(n);let g=this._root;for(;g;){const s=h.cmp(g.segment);if(s>0)g=g.left;else if(s<0)g=g.right;else if(h.hasNext())h.next(),g=g.mid;else break}return g}has(n){const h=this._getNode(n);return!(h?.value===void 0&&h?.mid===void 0)}delete(n){return this._delete(n,!1)}deleteSuperstr(n){return this._delete(n,!0)}_delete(n,h){const g=this._iter.reset(n),s=[];let d=this._root;for(;d;){const p=g.cmp(d.segment);if(p>0)s.push([-1,d]),d=d.left;else if(p<0)s.push([1,d]),d=d.right;else if(g.hasNext())g.next(),s.push([0,d]),d=d.mid;else break}if(!!d){if(h?(d.left=void 0,d.mid=void 0,d.right=void 0,d.height=1):(d.key=void 0,d.value=void 0),!d.mid&&!d.value)if(d.left&&d.right){const p=this._min(d.right),{key:w,value:v,segment:k}=p;this._delete(p.key,!1),d.key=w,d.value=v,d.segment=k}else{const p=d.left??d.right;if(s.length>0){const[w,v]=s[s.length-1];switch(w){case-1:v.left=p;break;case 0:v.mid=p;break;case 1:v.right=p;break}}else this._root=p}for(let p=s.length-1;p>=0;p--){const w=s[p][1];w.updateHeight();const v=w.balanceFactor();if(v>1?(w.right.balanceFactor()>=0||(w.right=w.right.rotateRight()),s[p][1]=w.rotateLeft()):v<-1&&(w.left.balanceFactor()<=0||(w.left=w.left.rotateLeft()),s[p][1]=w.rotateRight()),p>0)switch(s[p-1][0]){case-1:s[p-1][1].left=s[p][1];break;case 1:s[p-1][1].right=s[p][1];break;case 0:s[p-1][1].mid=s[p][1];break}else this._root=s[0][1]}}}_min(n){for(;n.left;)n=n.left;return n}findSubstr(n){const h=this._iter.reset(n);let g=this._root,s;for(;g;){const d=h.cmp(g.segment);if(d>0)g=g.left;else if(d<0)g=g.right;else if(h.hasNext())h.next(),s=g.value||s,g=g.mid;else break}return g&&g.value||s}findSuperstr(n){const h=this._iter.reset(n);let g=this._root;for(;g;){const s=h.cmp(g.segment);if(s>0)g=g.left;else if(s<0)g=g.right;else if(h.hasNext())h.next(),g=g.mid;else return g.mid?this._entries(g.mid):void 0}}forEach(n){for(const[h,g]of this)n(g,h)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(n){!n||(n.left&&(yield*this._entries(n.left)),n.value&&(yield[n.key,n.value]),n.mid&&(yield*this._entries(n.mid)),n.right&&(yield*this._entries(n.right)))}_isBalanced(){const n=h=>{if(!h)return!0;const g=h.balanceFactor();return g<-1||g>1?!1:n(h.left)&&n(h.right)};return n(this._root)}}e.TernarySearchTree=M;class y{constructor(n,h){this.uri=n,this.value=h}}class _{constructor(n,h){this[S]="ResourceMap",n instanceof _?(this.map=new Map(n.map),this.toKey=h??_.defaultToKey):(this.map=new Map,this.toKey=n??_.defaultToKey)}set(n,h){return this.map.set(this.toKey(n),new y(n,h)),this}get(n){return this.map.get(this.toKey(n))?.value}has(n){return this.map.has(this.toKey(n))}get size(){return this.map.size}clear(){this.map.clear()}delete(n){return this.map.delete(this.toKey(n))}forEach(n,h){typeof h!="undefined"&&(n=n.bind(h));for(let[g,s]of this.map)n(s.value,s.uri,this)}*values(){for(let n of this.map.values())yield n.value}*keys(){for(let n of this.map.values())yield n.uri}*entries(){for(let n of this.map.values())yield[n.uri,n.value]}*[(S=Symbol.toStringTag,Symbol.iterator)](){for(let[,n]of this.map)yield[n.uri,n.value]}}e.ResourceMap=_,_.defaultToKey=c=>c.toString();var u;(function(c){c[c.None=0]="None",c[c.AsOld=1]="AsOld",c[c.AsNew=2]="AsNew"})(u=e.Touch||(e.Touch={}));class C{constructor(){this[P]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(n){return this._map.has(n)}get(n,h=0){const g=this._map.get(n);if(!!g)return h!==0&&this.touch(g,h),g.value}set(n,h,g=0){let s=this._map.get(n);if(s)s.value=h,g!==0&&this.touch(s,g);else{switch(s={key:n,value:h,next:void 0,previous:void 0},g){case 0:this.addItemLast(s);break;case 1:this.addItemFirst(s);break;case 2:this.addItemLast(s);break;default:this.addItemLast(s);break}this._map.set(n,s),this._size++}return this}delete(n){return!!this.remove(n)}remove(n){const h=this._map.get(n);if(!!h)return this._map.delete(n),this.removeItem(h),this._size--,h.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const n=this._head;return this._map.delete(n.key),this.removeItem(n),this._size--,n.value}forEach(n,h){const g=this._state;let s=this._head;for(;s;){if(h?n.bind(h)(s.value,s.key,this):n(s.value,s.key,this),this._state!==g)throw new Error("LinkedMap got modified during iteration.");s=s.next}}keys(){const n=this,h=this._state;let g=this._head;const s={[Symbol.iterator](){return s},next(){if(n._state!==h)throw new Error("LinkedMap got modified during iteration.");if(g){const d={value:g.key,done:!1};return g=g.next,d}else return{value:void 0,done:!0}}};return s}values(){const n=this,h=this._state;let g=this._head;const s={[Symbol.iterator](){return s},next(){if(n._state!==h)throw new Error("LinkedMap got modified during iteration.");if(g){const d={value:g.value,done:!1};return g=g.next,d}else return{value:void 0,done:!0}}};return s}entries(){const n=this,h=this._state;let g=this._head;const s={[Symbol.iterator](){return s},next(){if(n._state!==h)throw new Error("LinkedMap got modified during iteration.");if(g){const d={value:[g.key,g.value],done:!1};return g=g.next,d}else return{value:void 0,done:!0}}};return s}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(n){if(n>=this.size)return;if(n===0){this.clear();return}let h=this._head,g=this.size;for(;h&&g>n;)this._map.delete(h.key),h=h.next,g--;this._head=h,this._size=g,h&&(h.previous=void 0),this._state++}addItemFirst(n){if(!this._head&&!this._tail)this._tail=n;else if(this._head)n.next=this._head,this._head.previous=n;else throw new Error("Invalid list");this._head=n,this._state++}addItemLast(n){if(!this._head&&!this._tail)this._head=n;else if(this._tail)n.previous=this._tail,this._tail.next=n;else throw new Error("Invalid list");this._tail=n,this._state++}removeItem(n){if(n===this._head&&n===this._tail)this._head=void 0,this._tail=void 0;else if(n===this._head){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this._head=n.next}else if(n===this._tail){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this._tail=n.previous}else{const h=n.next,g=n.previous;if(!h||!g)throw new Error("Invalid list");h.previous=g,g.next=h}n.next=void 0,n.previous=void 0,this._state++}touch(n,h){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(h!==1&&h!==2)){if(h===1){if(n===this._head)return;const g=n.next,s=n.previous;n===this._tail?(s.next=void 0,this._tail=s):(g.previous=s,s.next=g),n.previous=void 0,n.next=this._head,this._head.previous=n,this._head=n,this._state++}else if(h===2){if(n===this._tail)return;const g=n.next,s=n.previous;n===this._head?(g.previous=void 0,this._head=g):(g.previous=s,s.next=g),n.next=void 0,n.previous=this._tail,this._tail.next=n,this._tail=n,this._state++}}}toJSON(){const n=[];return this.forEach((h,g)=>{n.push([g,h])}),n}fromJSON(n){this.clear();for(const[h,g]of n)this.set(h,g)}}e.LinkedMap=C;class l extends C{constructor(n,h=1){super();this._limit=n,this._ratio=Math.min(Math.max(0,h),1)}get limit(){return this._limit}set limit(n){this._limit=n,this.checkTrim()}get ratio(){return this._ratio}set ratio(n){this._ratio=Math.min(Math.max(0,n),1),this.checkTrim()}get(n,h=2){return super.get(n,h)}peek(n){return super.get(n,0)}set(n,h){return super.set(n,h,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=l;class F{constructor(n){A.set(this,void 0),Xe(this,A,n,"f")}get size(){return Ie(this,A,"f").size}forEach(n,h){Ie(this,A,"f").forEach(n,h)}get(n){return Ie(this,A,"f").get(n)}has(n){return Ie(this,A,"f").has(n)}entries(){return Ie(this,A,"f").entries()}keys(){return Ie(this,A,"f").keys()}values(){return Ie(this,A,"f").values()}[(A=new WeakMap,Symbol.iterator)](){return Ie(this,A,"f").entries()}}e.ReadonlyMapView=F}),define(Se[102],_e([0,1,22,9]),function(ee,e,r,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function S(...z){return function(V,Y){for(let se=0,ye=z.length;se<ye;se++){const Ue=z[se](V,Y);if(Ue)return Ue}return null}}e.or=S,e.matchesStrictPrefix=P.bind(void 0,!1),e.matchesPrefix=P.bind(void 0,!0);function P(z,V,Y){if(!Y||Y.length<V.length)return null;let se;return z?se=t.startsWithIgnoreCase(Y,V):se=Y.indexOf(V)===0,se?V.length>0?[{start:0,end:V.length}]:[]:null}function A(z,V){const Y=V.toLowerCase().indexOf(z.toLowerCase());return Y===-1?null:[{start:Y,end:Y+z.length}]}e.matchesContiguousSubString=A;function I(z,V){return D(z.toLowerCase(),V.toLowerCase(),0,0)}e.matchesSubString=I;function D(z,V,Y,se){if(Y===z.length)return[];if(se===V.length)return null;if(z[Y]===V[se]){let ye=null;return(ye=D(z,V,Y+1,se+1))?M({start:se,end:se+1},ye):null}return D(z,V,Y,se+1)}function T(z){return 97<=z&&z<=122}function R(z){return 65<=z&&z<=90}e.isUpper=R;function b(z){return 48<=z&&z<=57}function i(z){return z===32||z===9||z===10||z===13}const f=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(z=>f.add(z.charCodeAt(0)));function a(z){return i(z)||f.has(z)}function o(z,V){return z===V||a(z)&&a(V)}function m(z){return T(z)||R(z)||b(z)}function M(z,V){return V.length===0?V=[z]:z.end===V[0].start?V[0].start=z.start:V.unshift(z),V}function y(z,V){for(let Y=V;Y<z.length;Y++){const se=z.charCodeAt(Y);if(R(se)||b(se)||Y>0&&!m(z.charCodeAt(Y-1)))return Y}return z.length}function _(z,V,Y,se){if(Y===z.length)return[];if(se===V.length)return null;if(z[Y]!==V[se].toLowerCase())return null;{let ye=null,Ue=se+1;for(ye=_(z,V,Y+1,se+1);!ye&&(Ue=y(V,Ue))<V.length;)ye=_(z,V,Y+1,Ue),Ue++;return ye===null?null:M({start:se,end:se+1},ye)}}function u(z){let V=0,Y=0,se=0,ye=0,Ue=0;for(let Je=0;Je<z.length;Je++)Ue=z.charCodeAt(Je),R(Ue)&&V++,T(Ue)&&Y++,m(Ue)&&se++,b(Ue)&&ye++;const je=V/z.length,Qe=Y/z.length,rt=se/z.length,ot=ye/z.length;return{upperPercent:je,lowerPercent:Qe,alphaPercent:rt,numericPercent:ot}}function C(z){const{upperPercent:V,lowerPercent:Y}=z;return Y===0&&V>.6}function l(z){const{upperPercent:V,lowerPercent:Y,alphaPercent:se,numericPercent:ye}=z;return Y>.2&&V<.8&&se>.6&&ye<.2}function F(z){let V=0,Y=0,se=0,ye=0;for(let Ue=0;Ue<z.length;Ue++)se=z.charCodeAt(Ue),R(se)&&V++,T(se)&&Y++,i(se)&&ye++;return(V===0||Y===0)&&ye===0?z.length<=30:V<=5}function c(z,V){if(!V||(V=V.trim(),V.length===0)||!F(z)||V.length>60)return null;const Y=u(V);if(!l(Y)){if(!C(Y))return null;V=V.toLowerCase()}let se=null,ye=0;for(z=z.toLowerCase();ye<V.length&&(se=_(z,V,0,ye))===null;)ye=y(V,ye+1);return se}e.matchesCamelCase=c;function n(z,V,Y=!1){if(!V||V.length===0)return null;let se=null,ye=0;for(z=z.toLowerCase(),V=V.toLowerCase();ye<V.length&&(se=h(z,V,0,ye,Y))===null;)ye=g(V,ye+1);return se}e.matchesWords=n;function h(z,V,Y,se,ye){if(Y===z.length)return[];if(se===V.length)return null;if(o(z.charCodeAt(Y),V.charCodeAt(se))){let Ue=null,je=se+1;if(Ue=h(z,V,Y+1,se+1,ye),!ye)for(;!Ue&&(je=g(V,je))<V.length;)Ue=h(z,V,Y+1,je,ye),je++;return Ue===null?null:M({start:se,end:se+1},Ue)}else return null}function g(z,V){for(let Y=V;Y<z.length;Y++)if(a(z.charCodeAt(Y))||Y>0&&a(z.charCodeAt(Y-1)))return Y;return z.length}const s=S(e.matchesPrefix,c,A),d=S(e.matchesPrefix,c,I),p=new r.LRUCache(1e4);function w(z,V,Y=!1){if(typeof z!="string"||typeof V!="string")return null;let se=p.get(z);se||(se=new RegExp(t.convertSimple2RegExpPattern(z),"i"),p.set(z,se));const ye=se.exec(V);return ye?[{start:ye.index,end:ye.index+ye[0].length}]:Y?d(z,V):s(z,V)}e.matchesFuzzy=w;function v(z,V){const Y=Fe(z,z.toLowerCase(),0,V,V.toLowerCase(),0,!0);return Y?L(Y):null}e.matchesFuzzy2=v;function k(z,V,Y,se,ye,Ue){const je=Math.min(13,z.length);for(;Y<je;Y++){const Qe=Fe(z,V,Y,se,ye,Ue,!1);if(Qe)return Qe}return[0,Ue]}e.anyScore=k;function L(z){if(typeof z=="undefined")return[];const V=[],Y=z[1];for(let se=z.length-1;se>1;se--){const ye=z[se]+Y,Ue=V[V.length-1];Ue&&Ue.end===ye?Ue.end=ye+1:V.push({start:ye,end:ye+1})}return V}e.createMatches=L;const E=128;function O(){const z=[],V=[];for(let Y=0;Y<=E;Y++)V[Y]=0;for(let Y=0;Y<=E;Y++)z.push(V.slice(0));return z}function U(z){const V=[];for(let Y=0;Y<=z;Y++)V[Y]=0;return V}const j=U(2*E),H=U(2*E),$=O(),G=O(),ie=O(),le=!1;function X(z,V,Y,se,ye){function Ue(Qe,rt,ot=" "){for(;Qe.length<rt;)Qe=ot+Qe;return Qe}let je=` |   |${se.split("").map(Qe=>Ue(Qe,3)).join("|")}
`;for(let Qe=0;Qe<=Y;Qe++)Qe===0?je+=" |":je+=`${V[Qe-1]}|`,je+=z[Qe].slice(0,ye+1).map(rt=>Ue(rt.toString(),3)).join("|")+`
`;return je}function ue(z,V,Y,se){z=z.substr(V),Y=Y.substr(se),console.log(X(G,z,z.length,Y,Y.length)),console.log(X(ie,z,z.length,Y,Y.length)),console.log(X($,z,z.length,Y,Y.length))}function ve(z,V){if(V<0||V>=z.length)return!1;const Y=z.codePointAt(V);switch(Y){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!t.isEmojiImprecise(Y)}}function ge(z,V){if(V<0||V>=z.length)return!1;switch(z.charCodeAt(V)){case 32:case 9:return!0;default:return!1}}function we(z,V,Y){return V[z]!==Y[z]}function re(z,V,Y,se,ye,Ue,je=!1){for(;V<Y&&ye<Ue;)z[V]===se[ye]&&(je&&(j[V]=ye),V+=1),ye+=1;return V===Y}e.isPatternInWord=re;var be;(function(z){z[z.Diag=1]="Diag",z[z.Left=2]="Left",z[z.LeftLeft=3]="LeftLeft"})(be||(be={}));var Pe;(function(z){z.Default=[-100,0];function V(Y){return!Y||Y.length===2&&Y[0]===-100&&Y[1]===0}z.isDefault=V})(Pe=e.FuzzyScore||(e.FuzzyScore={}));function Fe(z,V,Y,se,ye,Ue,je){const Qe=z.length>E?E:z.length,rt=se.length>E?E:se.length;if(Y>=Qe||Ue>=rt||Qe-Y>rt-Ue||!re(V,Y,Qe,ye,Ue,rt,!0))return;ze(Qe,rt,Y,Ue,V,ye);let ot=1,Je=1,tt=Y,pt=Ue;const Me=[!1];for(ot=1,tt=Y;tt<Qe;ot++,tt++){const Be=j[tt],qe=H[tt],lt=tt+1<Qe?H[tt+1]:rt;for(Je=Be-Ue+1,pt=Be;pt<lt;Je++,pt++){let ht=Number.MIN_SAFE_INTEGER,Ye=!1;pt<=qe&&(ht=nt(z,V,tt,Y,se,ye,pt,rt,Ue,$[ot-1][Je-1]===0,Me));let kt=0;ht!==Number.MAX_SAFE_INTEGER&&(Ye=!0,kt=ht+G[ot-1][Je-1]);const Ae=pt>Be,De=Ae?G[ot][Je-1]+($[ot][Je-1]>0?-5:0):0,pe=pt>Be+1&&$[ot][Je-1]>0,te=pe?G[ot][Je-2]+($[ot][Je-2]>0?-5:0):0;if(pe&&(!Ae||te>=De)&&(!Ye||te>=kt))G[ot][Je]=te,ie[ot][Je]=3,$[ot][Je]=0;else if(Ae&&(!Ye||De>=kt))G[ot][Je]=De,ie[ot][Je]=2,$[ot][Je]=0;else if(Ye)G[ot][Je]=kt,ie[ot][Je]=1,$[ot][Je]=$[ot-1][Je-1]+1;else throw new Error("not possible")}}if(le&&ue(z,Y,se,Ue),!Me[0]&&!je)return;ot--,Je--;const At=[G[ot][Je],Ue];let q=0,Q=0;for(;ot>=1;){let Be=Je;do{const qe=ie[ot][Be];if(qe===3)Be=Be-2;else if(qe===2)Be=Be-1;else break}while(Be>=1);q>1&&V[Y+ot-1]===ye[Ue+Je-1]&&!we(Be+Ue-1,se,ye)&&q+1>$[ot][Be]&&(Be=Je),Be===Je?q++:q=1,Q||(Q=Be),ot--,Je=Be-1,At.push(Je)}rt===Qe&&(At[0]+=2);const he=Q-Qe;return At[0]-=he,At}e.fuzzyScore=Fe;function ze(z,V,Y,se,ye,Ue){let je=z-1,Qe=V-1;for(;je>=Y&&Qe>=se;)ye[je]===Ue[Qe]&&(H[je]=Qe,je--),Qe--}function nt(z,V,Y,se,ye,Ue,je,Qe,rt,ot,Je){if(V[Y]!==Ue[je])return Number.MIN_SAFE_INTEGER;let tt=1,pt=!1;return je===Y-se?tt=z[Y]===ye[je]?7:5:we(je,ye,Ue)&&(je===0||!we(je-1,ye,Ue))?(tt=z[Y]===ye[je]?7:5,pt=!0):ve(Ue,je)&&(je===0||!ve(Ue,je-1))?tt=5:(ve(Ue,je-1)||ge(Ue,je-1))&&(tt=5,pt=!0),tt>1&&Y===se&&(Je[0]=!0),pt||(pt=we(je,ye,Ue)||ve(Ue,je-1)||ge(Ue,je-1)),Y===se?je>rt&&(tt-=pt?3:5):ot?tt+=pt?2:0:tt+=pt?0:1,je+1===Qe&&(tt-=pt?3:5),tt}function et(z,V,Y,se,ye,Ue,je){return x(z,V,Y,se,ye,Ue,!0,je)}e.fuzzyScoreGracefulAggressive=et;function Ze(z,V,Y,se,ye,Ue,je){return x(z,V,Y,se,ye,Ue,!1,je)}e.fuzzyScoreGraceful=Ze;function x(z,V,Y,se,ye,Ue,je,Qe){let rt=Fe(z,V,Y,se,ye,Ue,Qe);if(rt&&!je)return rt;if(z.length>=3){const ot=Math.min(7,z.length-1);for(let Je=Y+1;Je<ot;Je++){const tt=K(z,Je);if(tt){const pt=Fe(tt,tt.toLowerCase(),Y,se,ye,Ue,Qe);pt&&(pt[0]-=3,(!rt||pt[0]>rt[0])&&(rt=pt))}}}return rt}function K(z,V){if(V+1>=z.length)return;const Y=z[V],se=z[V+1];if(Y!==se)return z.slice(0,V)+se+Y+z.slice(V+2)}}),define(Se[103],_e([0,1,52,102,9]),function(ee,e,r,t,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const P=new RegExp(`\\$\\(${r.CSSIcon.iconNameExpression}(?:${r.CSSIcon.iconModifierExpression})?\\)`,"g"),A=new RegExp(r.CSSIcon.iconNameCharacter),I=new RegExp(`(\\\\)?${P.source}`,"g");function D(m){return m.replace(I,(M,y)=>y?M:`\\${M}`)}e.escapeIcons=D;const T=new RegExp(`\\\\${P.source}`,"g");function R(m){return m.replace(T,M=>`\\${M}`)}e.markdownEscapeEscapedIcons=R;const b=new RegExp(`(\\s)?(\\\\)?${P.source}(\\s)?`,"g");function i(m){return m.indexOf(e.iconStartMarker)===-1?m:m.replace(b,(M,y,_,u)=>_?M:y||u||"")}e.stripIcons=i;function f(m){const M=m.indexOf(e.iconStartMarker);return M===-1?{text:m}:a(m,M)}e.parseLabelWithIcons=f;function a(m,M){const y=[];let _="";function u(s){if(s){_+=s;for(const d of s)y.push(F)}}let C=-1,l="",F=0,c,n,h=M;const g=m.length;for(u(m.substr(0,M));h<g;)c=m[h],n=m[h+1],c===e.iconStartMarker[0]&&n===e.iconStartMarker[1]?(C=h,u(l),l=e.iconStartMarker,h++):c===")"&&C!==-1?(F+=h-C+1,C=-1,l=""):C!==-1?A.test(c)?l+=c:(u(l),C=-1,l=""):u(c),h++;return u(l),{text:_,iconOffsets:y}}function o(m,M,y=!1){const{text:_,iconOffsets:u}=M;if(!u||u.length===0)return(0,t.matchesFuzzy)(m,_,y);const C=(0,S.ltrim)(_," "),l=_.length-C.length,F=(0,t.matchesFuzzy)(m,C,y);if(F)for(const c of F){const n=u[c.start+l]+l;c.start+=n,c.end+=n}return F}e.matchesFuzzyIconAware=o}),define(Se[75],_e([0,1,15,103]),function(ee,e,r,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var S;(function(i){i[i.Paragraph=0]="Paragraph",i[i.Break=1]="Break"})(S=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class P{constructor(f="",a=!1){if(this.value=f,typeof this.value!="string")throw(0,r.illegalArgument)("value");typeof a=="boolean"?(this.isTrusted=a,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=a.isTrusted??void 0,this.supportThemeIcons=a.supportThemeIcons??!1,this.supportHtml=a.supportHtml??!1)}appendText(f,a=0){return this.value+=T(this.supportThemeIcons?(0,t.escapeIcons)(f):f).replace(/([ \t]+)/g,(o,m)=>"&nbsp;".repeat(m.length)).replace(/\>/gm,"\\>").replace(/\n/g,a===1?`\\
`:`

`),this}appendMarkdown(f){return this.value+=f,this}appendCodeblock(f,a){return this.value+="\n```",this.value+=f,this.value+=`
`,this.value+=a,this.value+="\n```\n",this}}e.MarkdownString=P;function A(i){return I(i)?!i.value:Array.isArray(i)?i.every(A):!0}e.isEmptyMarkdownString=A;function I(i){return i instanceof P?!0:i&&typeof i=="object"?typeof i.value=="string"&&(typeof i.isTrusted=="boolean"||i.isTrusted===void 0)&&(typeof i.supportThemeIcons=="boolean"||i.supportThemeIcons===void 0):!1}e.isMarkdownString=I;function D(i,f){return i===f?!0:!i||!f?!1:i.value===f.value&&i.isTrusted===f.isTrusted&&i.supportThemeIcons===f.supportThemeIcons}e.markdownStringEqual=D;function T(i){return i.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=T;function R(i){return i&&i.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=R;function b(i){const f=[],a=i.split("|").map(m=>m.trim());i=a[0];const o=a[1];if(o){const m=/height=(\d+)/.exec(o),M=/width=(\d+)/.exec(o),y=m?m[1]:"",_=M?M[1]:"",u=isFinite(parseInt(_)),C=isFinite(parseInt(y));u&&f.push(`width="${_}"`),C&&f.push(`height="${y}"`)}return{href:i,dimensions:f}}e.parseHrefAndDimensions=b}),define(Se[34],_e([0,1,9]),function(ee,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t;(function(S){S[S.Ignore=0]="Ignore",S[S.Info=1]="Info",S[S.Warning=2]="Warning",S[S.Error=3]="Error"})(t||(t={})),function(S){const P="error",A="warning",I="warn",D="info",T="ignore";function R(i){return i?r.equalsIgnoreCase(P,i)?S.Error:r.equalsIgnoreCase(A,i)||r.equalsIgnoreCase(I,i)?S.Warning:r.equalsIgnoreCase(D,i)?S.Info:S.Ignore:S.Ignore}S.fromValue=R;function b(i){switch(i){case S.Error:return P;case S.Warning:return A;case S.Info:return D;default:return T}}S.toString=b}(t||(t={})),e.default=t}),define(Se[35],_e([0,1,17,23,9,13]),function(ee,e,r,t,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function A(h){return h===47||h===92}e.isPathSeparator=A;function I(h){return h.replace(/[\\/]/g,r.posix.sep)}e.toSlashes=I;function D(h){return h.indexOf("/")===-1&&(h=I(h)),/^[a-zA-Z]:(\/|$)/.test(h)&&(h="/"+h),h}e.toPosixPath=D;function T(h,g=r.posix.sep){if(!h)return"";const s=h.length,d=h.charCodeAt(0);if(A(d)){if(A(h.charCodeAt(1))&&!A(h.charCodeAt(2))){let w=3;const v=w;for(;w<s&&!A(h.charCodeAt(w));w++);if(v!==w&&!A(h.charCodeAt(w+1))){for(w+=1;w<s;w++)if(A(h.charCodeAt(w)))return h.slice(0,w+1).replace(/[\\/]/g,g)}}return g}else if(M(d)&&h.charCodeAt(1)===58)return A(h.charCodeAt(2))?h.slice(0,2)+g:h.slice(0,2);let p=h.indexOf("://");if(p!==-1){for(p+=3;p<s;p++)if(A(h.charCodeAt(p)))return h.slice(0,p+1)}return""}e.getRoot=T;function R(h){if(!t.isWindows||!h||h.length<5)return!1;let g=h.charCodeAt(0);if(g!==92||(g=h.charCodeAt(1),g!==92))return!1;let s=2;const d=s;for(;s<h.length&&(g=h.charCodeAt(s),g!==92);s++);return!(d===s||(g=h.charCodeAt(s+1),isNaN(g)||g===92))}e.isUNC=R;const b=/[\\/:\*\?"<>\|]/g,i=/[\\/]/g,f=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function a(h,g=t.isWindows){const s=g?b:i;return!(!h||h.length===0||/^\s+$/.test(h)||(s.lastIndex=0,s.test(h))||g&&f.test(h)||h==="."||h===".."||g&&h[h.length-1]==="."||g&&h.length!==h.trim().length||h.length>255)}e.isValidBasename=a;function o(h,g,s){const d=h===g;return!s||d?d:!h||!g?!1:(0,S.equalsIgnoreCase)(h,g)}e.isEqual=o;function m(h,g,s,d=r.sep){if(h===g)return!0;if(!h||!g||g.length>h.length)return!1;if(s){if(!(0,S.startsWithIgnoreCase)(h,g))return!1;if(g.length===h.length)return!0;let w=g.length;return g.charAt(g.length-1)===d&&w--,h.charAt(w)===d}return g.charAt(g.length-1)!==d&&(g+=d),h.indexOf(g)===0}e.isEqualOrParent=m;function M(h){return h>=65&&h<=90||h>=97&&h<=122}e.isWindowsDriveLetter=M;function y(h,g){return t.isWindows&&h.endsWith(":")&&(h+=r.sep),(0,r.isAbsolute)(h)||(h=(0,r.join)(g,h)),h=(0,r.normalize)(h),t.isWindows?(h=(0,S.rtrim)(h,r.sep),h.endsWith(":")&&(h+=r.sep)):(h=(0,S.rtrim)(h,r.sep),h||(h=r.sep)),h}e.sanitizeFilePath=y;function _(h){const g=(0,r.normalize)(h);return t.isWindows?h.length>3?!1:u(g)&&(h.length===2||g.charCodeAt(2)===92):g===r.posix.sep}e.isRootOrDriveLetter=_;function u(h,g){return(g!==void 0?g:t.isWindows)?M(h.charCodeAt(0))&&h.charCodeAt(1)===58:!1}e.hasDriveLetter=u;function C(h){return u(h)?h[0]:void 0}e.getDriveLetter=C;function l(h,g,s){return g.length>h.length?-1:h===g?0:(s&&(h=h.toLowerCase(),g=g.toLowerCase()),h.indexOf(g))}e.indexOfPath=l;function F(h){const g=h.split(":");let s,d,p;for(const w of g){const v=Number(w);(0,P.isNumber)(v)?d===void 0?d=v:p===void 0&&(p=v):s=s?[s,w].join(":"):w}if(!s)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:s,line:d!==void 0?d:void 0,column:p!==void 0?p:d!==void 0?1:void 0}}e.parseLineAndColumnAware=F;const c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function n(h,g,s=8){let d="";for(let w=0;w<s;w++)d+=c.charAt(Math.floor(Math.random()*c.length));let p;return g?p=`${g}-${d}`:p=d,h?(0,r.join)(h,p):p}e.randomPath=n}),define(Se[55],_e([0,1,21,9,2]),function(ee,e,r,t,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function P(R){return JSON.stringify(R,D)}e.stringify=P;function A(R){let b=JSON.parse(R);return b=T(b),b}e.parse=A;var I;(function(R){R[R.Uri=1]="Uri",R[R.Regexp=2]="Regexp",R[R.ScmResource=3]="ScmResource",R[R.ScmResourceGroup=4]="ScmResourceGroup",R[R.ScmProvider=5]="ScmProvider",R[R.CommentController=6]="CommentController",R[R.CommentThread=7]="CommentThread",R[R.CommentThreadReply=8]="CommentThreadReply",R[R.CommentNode=9]="CommentNode",R[R.CommentThreadNode=10]="CommentThreadNode",R[R.TimelineActionContext=11]="TimelineActionContext",R[R.NotebookCellActionContext=12]="NotebookCellActionContext",R[R.TestItemContext=13]="TestItemContext",R[R.Date=14]="Date"})(I=e.MarshalledId||(e.MarshalledId={}));function D(R,b){return b instanceof RegExp?{$mid:2,source:b.source,flags:(0,t.regExpFlags)(b)}:b}function T(R,b=0){if(!R||b>200)return R;if(typeof R=="object"){switch(R.$mid){case 1:return S.URI.revive(R);case 2:return new RegExp(R.source,R.flags);case 14:return new Date(R.source)}if(R instanceof r.VSBuffer||R instanceof Uint8Array)return R;if(Array.isArray(R))for(let i=0;i<R.length;++i)R[i]=T(R[i],b+1);else for(const i in R)Object.hasOwnProperty.call(R,i)&&(R[i]=T(R[i],b+1))}return R}e.revive=T}),define(Se[11],_e([0,1,23,2]),function(ee,e,r,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var S;(function(I){I.inMemory="inmemory",I.vscode="vscode",I.internal="private",I.walkThrough="walkThrough",I.walkThroughSnippet="walkThroughSnippet",I.http="http",I.https="https",I.file="file",I.mailto="mailto",I.untitled="untitled",I.data="data",I.command="command",I.vscodeRemote="vscode-remote",I.vscodeRemoteResource="vscode-remote-resource",I.userData="vscode-userdata",I.vscodeCustomEditor="vscode-custom-editor",I.vscodeNotebook="vscode-notebook",I.vscodeNotebookCell="vscode-notebook-cell",I.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",I.vscodeNotebookCellOutput="vscode-notebook-cell-output",I.vscodeInteractive="vscode-interactive",I.vscodeInteractiveInput="vscode-interactive-input",I.vscodeSettings="vscode-settings",I.vscodeWorkspaceTrust="vscode-workspace-trust",I.vscodeTerminal="vscode-terminal",I.webviewPanel="webview-panel",I.vscodeWebview="vscode-webview",I.extension="extension",I.vscodeFileResource="vscode-file",I.tmp="tmp",I.vsls="vsls"})(S=e.Schemas||(e.Schemas={}));class P{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(D){this._preferredWebSchema=D}setDelegate(D){this._delegate=D}set(D,T,R){this._hosts[D]=T,this._ports[D]=R}setConnectionToken(D,T){this._connectionTokens[D]=T}rewrite(D){if(this._delegate)return this._delegate(D);const T=D.authority;let R=this._hosts[T];R&&R.indexOf(":")!==-1&&(R=`[${R}]`);const b=this._ports[T],i=this._connectionTokens[T];let f=`path=${encodeURIComponent(D.path)}`;return typeof i=="string"&&(f+=`&tkn=${encodeURIComponent(i)}`),t.URI.from({scheme:r.isWeb?this._preferredWebSchema:S.vscodeRemoteResource,authority:`${R}:${b}`,path:"/vscode-remote-resource",query:f})}}e.RemoteAuthorities=new P;class A{asBrowserUri(D,T){const R=this.toUri(D,T);return R.scheme===S.vscodeRemote?e.RemoteAuthorities.rewrite(R):R.scheme===S.file&&(r.isNative||typeof r.globals.importScripts=="function"&&r.globals.origin===`${S.vscodeFileResource}://${A.FALLBACK_AUTHORITY}`)?R.with({scheme:S.vscodeFileResource,authority:R.authority||A.FALLBACK_AUTHORITY,query:null,fragment:null}):R}asFileUri(D,T){const R=this.toUri(D,T);return R.scheme===S.vscodeFileResource?R.with({scheme:S.file,authority:R.authority!==A.FALLBACK_AUTHORITY?R.authority:null,query:null,fragment:null}):R}toUri(D,T){return t.URI.isUri(D)?D:t.URI.parse(T.toUrl(D))}}A.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new A}),define(Se[24],_e([0,1,35,11,17,23,9,2]),function(ee,e,r,t,S,P,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function D(f){return(0,I.uriToFsPath)(f,!0)}e.originalFSPath=D;class T{constructor(a){this._ignorePathCasing=a}compare(a,o,m=!1){return a===o?0:(0,A.compare)(this.getComparisonKey(a,m),this.getComparisonKey(o,m))}isEqual(a,o,m=!1){return a===o?!0:!a||!o?!1:this.getComparisonKey(a,m)===this.getComparisonKey(o,m)}getComparisonKey(a,o=!1){return a.with({path:this._ignorePathCasing(a)?a.path.toLowerCase():void 0,fragment:o?null:void 0}).toString()}ignorePathCasing(a){return this._ignorePathCasing(a)}isEqualOrParent(a,o,m=!1){if(a.scheme===o.scheme){if(a.scheme===t.Schemas.file)return r.isEqualOrParent(D(a),D(o),this._ignorePathCasing(a))&&a.query===o.query&&(m||a.fragment===o.fragment);if((0,e.isEqualAuthority)(a.authority,o.authority))return r.isEqualOrParent(a.path,o.path,this._ignorePathCasing(a),"/")&&a.query===o.query&&(m||a.fragment===o.fragment)}return!1}joinPath(a,...o){return I.URI.joinPath(a,...o)}basenameOrAuthority(a){return(0,e.basename)(a)||a.authority}basename(a){return S.posix.basename(a.path)}extname(a){return S.posix.extname(a.path)}dirname(a){if(a.path.length===0)return a;let o;return a.scheme===t.Schemas.file?o=I.URI.file(S.dirname(D(a))).path:(o=S.posix.dirname(a.path),a.authority&&o.length&&o.charCodeAt(0)!==47&&(console.error(`dirname("${a.toString})) resulted in a relative path`),o="/")),a.with({path:o})}normalizePath(a){if(!a.path.length)return a;let o;return a.scheme===t.Schemas.file?o=I.URI.file(S.normalize(D(a))).path:o=S.posix.normalize(a.path),a.with({path:o})}relativePath(a,o){if(a.scheme!==o.scheme||!(0,e.isEqualAuthority)(a.authority,o.authority))return;if(a.scheme===t.Schemas.file){const y=S.relative(D(a),D(o));return P.isWindows?r.toSlashes(y):y}let m=a.path||"/",M=o.path||"/";if(this._ignorePathCasing(a)){let y=0;for(const _=Math.min(m.length,M.length);y<_&&!(m.charCodeAt(y)!==M.charCodeAt(y)&&m.charAt(y).toLowerCase()!==M.charAt(y).toLowerCase());y++);m=M.substr(0,y)+m.substr(y)}return S.posix.relative(m,M)}resolvePath(a,o){if(a.scheme===t.Schemas.file){const m=I.URI.file(S.resolve(D(a),o));return a.with({authority:m.authority,path:m.path})}return o=r.toPosixPath(o),a.with({path:S.posix.resolve(a.path,o)})}isAbsolutePath(a){return!!a.path&&a.path[0]==="/"}isEqualAuthority(a,o){return a===o||a!==void 0&&o!==void 0&&(0,A.equalsIgnoreCase)(a,o)}hasTrailingPathSeparator(a,o=S.sep){if(a.scheme===t.Schemas.file){const m=D(a);return m.length>r.getRoot(m).length&&m[m.length-1]===o}else{const m=a.path;return m.length>1&&m.charCodeAt(m.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(a.fsPath)}}removeTrailingPathSeparator(a,o=S.sep){return(0,e.hasTrailingPathSeparator)(a,o)?a.with({path:a.path.substr(0,a.path.length-1)}):a}addTrailingPathSeparator(a,o=S.sep){let m=!1;if(a.scheme===t.Schemas.file){const M=D(a);m=M!==void 0&&M.length===r.getRoot(M).length&&M[M.length-1]===o}else{o="/";const M=a.path;m=M.length===1&&M.charCodeAt(M.length-1)===47}return!m&&!(0,e.hasTrailingPathSeparator)(a,o)?a.with({path:a.path+"/"}):a}}e.ExtUri=T,e.extUri=new T(()=>!1),e.extUriBiasedIgnorePathCase=new T(f=>f.scheme===t.Schemas.file?!P.isLinux:!0),e.extUriIgnorePathCase=new T(f=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function R(f,a){const o=[];for(let m=0;m<f.length;m++){const M=a(f[m]);f.some((y,_)=>_===m?!1:(0,e.isEqualOrParent)(M,a(y)))||o.push(f[m])}return o}e.distinctParents=R;var b;(function(f){f.META_DATA_LABEL="label",f.META_DATA_DESCRIPTION="description",f.META_DATA_SIZE="size",f.META_DATA_MIME="mime";function a(o){const m=new Map;o.path.substring(o.path.indexOf(";")+1,o.path.lastIndexOf(";")).split(";").forEach(_=>{const[u,C]=_.split(":");u&&C&&m.set(u,C)});const y=o.path.substring(0,o.path.indexOf(";"));return y&&m.set(f.META_DATA_MIME,y),m}f.parseMetaData=a})(b=e.DataUri||(e.DataUri={}));function i(f,a,o){if(a){let m=f.path;return m&&m[0]!==S.posix.sep&&(m=S.posix.sep+m),f.with({scheme:o,authority:a,path:m})}return f.with({scheme:o})}e.toLocalResource=i}),define(Se[10],_e([0,1,20,15,4,6,24,23]),function(ee,e,r,t,S,P,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function D(we){return!!we&&typeof we.then=="function"}e.isThenable=D;function T(we){const re=new r.CancellationTokenSource,be=we(re.token),Pe=new Promise((Fe,ze)=>{const nt=re.token.onCancellationRequested(()=>{nt.dispose(),re.dispose(),ze(new t.CancellationError)});Promise.resolve(be).then(et=>{nt.dispose(),re.dispose(),Fe(et)},et=>{nt.dispose(),re.dispose(),ze(et)})});return new class{cancel(){re.cancel()}then(Fe,ze){return Pe.then(Fe,ze)}catch(Fe){return this.then(void 0,Fe)}finally(Fe){return Pe.finally(Fe)}}}e.createCancelablePromise=T;function R(we,re,be){return new Promise((Pe,Fe)=>{const ze=re.onCancellationRequested(()=>{ze.dispose(),Pe(be)});we.then(Pe,Fe).finally(()=>ze.dispose())})}e.raceCancellation=R;function b(we,re){return new Promise((be,Pe)=>{const Fe=re.onCancellationRequested(()=>{Fe.dispose(),Pe(new t.CancellationError)});we.then(be,Pe).finally(()=>Fe.dispose())})}e.raceCancellationError=b;async function i(we){let re=-1;const be=we.map((Fe,ze)=>Fe.then(nt=>(re=ze,nt))),Pe=await Promise.race(be);return we.forEach((Fe,ze)=>{ze!==re&&Fe.cancel()}),Pe}e.raceCancellablePromises=i;function f(we,re,be){let Pe;const Fe=setTimeout(()=>{Pe?.(void 0),be?.()},re);return Promise.race([we.finally(()=>clearTimeout(Fe)),new Promise(ze=>Pe=ze)])}e.raceTimeout=f;function a(we){return new Promise((re,be)=>{const Pe=we();D(Pe)?Pe.then(re,be):re(Pe)})}e.asPromise=a;class o{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(re){if(this.activePromise){if(this.queuedPromiseFactory=re,!this.queuedPromise){const be=()=>{this.queuedPromise=null;const Pe=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,Pe};this.queuedPromise=new Promise(Pe=>{this.activePromise.then(be,be).then(Pe)})}return new Promise((be,Pe)=>{this.queuedPromise.then(be,Pe)})}return this.activePromise=re(),new Promise((be,Pe)=>{this.activePromise.then(Fe=>{this.activePromise=null,be(Fe)},Fe=>{this.activePromise=null,Pe(Fe)})})}}e.Throttler=o;class m{constructor(){this.current=Promise.resolve(null)}queue(re){return this.current=this.current.then(()=>re(),()=>re())}}e.Sequencer=m;class M{constructor(){this.promiseMap=new Map}queue(re,be){const Fe=(this.promiseMap.get(re)??Promise.resolve()).catch(()=>{}).then(be).finally(()=>{this.promiseMap.get(re)===Fe&&this.promiseMap.delete(re)});return this.promiseMap.set(re,Fe),Fe}}e.SequencerByKey=M;const y=(we,re)=>{let be=!0;const Pe=setTimeout(()=>{be=!1,re()},we);return{isTriggered:()=>be,dispose:()=>{clearTimeout(Pe),be=!1}}},_=we=>{let re=!0;return queueMicrotask(()=>{re&&(re=!1,we())}),{isTriggered:()=>re,dispose:()=>{re=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class u{constructor(re){this.defaultDelay=re,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(re,be=this.defaultDelay){this.task=re,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((Fe,ze)=>{this.doResolve=Fe,this.doReject=ze}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const Fe=this.task;return this.task=null,Fe()}}));const Pe=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=be===e.MicrotaskDelay?_(Pe):y(be,Pe),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(new t.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=u;class C{constructor(re){this.delayer=new u(re),this.throttler=new o}trigger(re,be){return this.delayer.trigger(()=>this.throttler.queue(re),be)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=C;class l{constructor(){this._isOpen=!1,this._promise=new Promise((re,be)=>{this._completePromise=re})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=l;class F extends l{constructor(re){super();this._timeout=setTimeout(()=>this.open(),re)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=F;function c(we,re){return re?new Promise((be,Pe)=>{const Fe=setTimeout(()=>{ze.dispose(),be()},we),ze=re.onCancellationRequested(()=>{clearTimeout(Fe),ze.dispose(),Pe(new t.CancellationError)})}):T(be=>c(we,be))}e.timeout=c;function n(we,re=0){const be=setTimeout(we,re);return(0,P.toDisposable)(()=>clearTimeout(be))}e.disposableTimeout=n;function h(we){const re=[];let be=0;const Pe=we.length;function Fe(){return be<Pe?we[be++]():null}function ze(nt){nt!=null&&re.push(nt);const et=Fe();return et?et.then(ze):Promise.resolve(re)}return Promise.resolve(null).then(ze)}e.sequence=h;function g(we,re=Pe=>!!Pe,be=null){let Pe=0;const Fe=we.length,ze=()=>{if(Pe>=Fe)return Promise.resolve(be);const nt=we[Pe++];return Promise.resolve(nt()).then(Ze=>re(Ze)?Promise.resolve(Ze):ze())};return ze()}e.first=g;function s(we,re=Pe=>!!Pe,be=null){if(we.length===0)return Promise.resolve(be);let Pe=we.length;const Fe=()=>{Pe=-1;for(const ze of we)ze.cancel?.()};return new Promise((ze,nt)=>{for(const et of we)et.then(Ze=>{--Pe>=0&&re(Ze)?(Fe(),ze(Ze)):Pe===0&&ze(be)}).catch(Ze=>{--Pe>=0&&(Fe(),nt(Ze))})})}e.firstParallel=s;class d{constructor(re){this._size=0,this.maxDegreeOfParalellism=re,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new S.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(re){return this._size++,new Promise((be,Pe)=>{this.outstandingPromises.push({factory:re,c:be,e:Pe}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const re=this.outstandingPromises.shift();this.runningPromises++;const be=re.factory();be.then(re.c,re.e),be.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=d;class p extends d{constructor(){super(1)}}e.Queue=p;class w{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const re=new ie;return this.drainers.add(re),re.p}isDrained(){for(const[,re]of this.queues)if(re.size>0)return!1;return!0}queueFor(re,be=A.extUri){const Pe=be.getComparisonKey(re);let Fe=this.queues.get(Pe);return Fe||(Fe=new p,S.Event.once(Fe.onFinished)(()=>{Fe?.dispose(),this.queues.delete(Pe),this.onDidQueueFinish()}),this.queues.set(Pe,Fe)),Fe}onDidQueueFinish(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const re of this.drainers)re.complete();this.drainers.clear()}dispose(){for(const[,re]of this.queues)re.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=w;class v{constructor(re,be){this._token=-1,typeof re=="function"&&typeof be=="number"&&this.setIfNotSet(re,be)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(re,be){this.cancel(),this._token=setTimeout(()=>{this._token=-1,re()},be)}setIfNotSet(re,be){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,re()},be))}}e.TimeoutTimer=v;class k{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(re,be){this.cancel(),this._token=setInterval(()=>{re()},be)}}e.IntervalTimer=k;class L{constructor(re,be){this.timeoutToken=-1,this.runner=re,this.timeout=be,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(re=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,re)}get delay(){return this.timeout}set delay(re){this.timeout=re}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=L;class E{constructor(re,be){be%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${be}ms is not a multiple of 1000ms.`),this.runner=re,this.timeout=be,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(re=this.timeout){re%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${re}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(re/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=E;class O extends L{constructor(re,be){super(re,be);this.units=[]}work(re){this.units.push(re),this.isScheduled()||this.schedule()}doRun(){const re=this.units;this.units=[],this.runner&&this.runner(re)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=O;class U extends P.Disposable{constructor(re,be){super();this.options=re,this.handler=be,this.pendingWork=[],this.throttler=this._register(new P.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(re){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+re.length>this.options.maxBufferedWork)return!1}else if(this.pending+re.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...re),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new L(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=U,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=we=>{(0,I.setTimeout0)(()=>{if(re)return;const be=Date.now()+15;we(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,be-Date.now())}}))});let re=!1;return{dispose(){re||(re=!0)}}}:e.runWhenIdle=(we,re)=>{const be=requestIdleCallback(we,typeof re=="number"?{timeout:re}:void 0);let Pe=!1;return{dispose(){Pe||(Pe=!0,cancelIdleCallback(be))}}}}();class j{constructor(re){this._didRun=!1,this._executor=()=>{try{this._value=re()}catch(be){this._error=be}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=j;async function H(we,re,be){let Pe;for(let Fe=0;Fe<be;Fe++)try{return await we()}catch(ze){Pe=ze,await c(re)}throw Pe}e.retry=H;class ${hasPending(re){return this._pending?typeof re=="number"?this._pending.taskId===re:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(re,be,Pe){return this._pending={taskId:re,cancel:()=>Pe?.(),promise:be},be.then(()=>this.donePending(re),()=>this.donePending(re)),be}donePending(re){this._pending&&re===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const re=this._next;this._next=void 0,re.run().then(re.promiseResolve,re.promiseReject)}}setNext(re){if(this._next)this._next.run=re;else{let be,Pe;const Fe=new Promise((ze,nt)=>{be=ze,Pe=nt});this._next={run:re,promise:Fe,promiseResolve:be,promiseReject:Pe}}return this._next.promise}}e.TaskSequentializer=$;class G{constructor(re,be=()=>Date.now()){this.interval=re,this.nowFn=be,this.lastIncrementTime=0,this.value=0}increment(){const re=this.nowFn();return re-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=re,this.value=0),this.value++,this.value}}e.IntervalCounter=G;class ie{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((re,be)=>{this.completeCallback=re,this.errorCallback=be})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(re){return new Promise(be=>{this.completeCallback(re),this.resolved=!0,be()})}error(re){return new Promise(be=>{this.errorCallback(re),this.rejected=!0,be()})}cancel(){new Promise(re=>{this.errorCallback(new t.CancellationError),this.rejected=!0,re()})}}e.DeferredPromise=ie;var le;(function(we){async function re(Pe){let Fe;const ze=await Promise.all(Pe.map(nt=>nt.then(et=>et,et=>{Fe||(Fe=et)})));if(typeof Fe!="undefined")throw Fe;return ze}we.settled=re;function be(Pe){return new Promise(async(Fe,ze)=>{try{await Pe(Fe,ze)}catch(nt){ze(nt)}})}we.withAsyncBody=be})(le=e.Promises||(e.Promises={}));var X;(function(we){we[we.Initial=0]="Initial",we[we.DoneOK=1]="DoneOK",we[we.DoneError=2]="DoneError"})(X||(X={}));class ue{constructor(re){this._state=0,this._results=[],this._error=null,this._onStateChanged=new S.Emitter,queueMicrotask(async()=>{const be={emitOne:Pe=>this.emitOne(Pe),emitMany:Pe=>this.emitMany(Pe),reject:Pe=>this.reject(Pe)};try{await Promise.resolve(re(be)),this.resolve()}catch(Pe){this.reject(Pe)}finally{be.emitOne=void 0,be.emitMany=void 0,be.reject=void 0}})}static fromArray(re){return new ue(be=>{be.emitMany(re)})}static fromPromise(re){return new ue(async be=>{be.emitMany(await re)})}static fromPromises(re){return new ue(async be=>{await Promise.all(re.map(async Pe=>be.emitOne(await Pe)))})}static merge(re){return new ue(async be=>{await Promise.all(re.map(async Pe=>{for await(const Fe of Pe)be.emitOne(Fe)}))})}[Symbol.asyncIterator](){let re=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(re<this._results.length)return{done:!1,value:this._results[re++]};if(this._state===1)return{done:!0,value:void 0};await S.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(re,be){return new ue(async Pe=>{for await(const Fe of re)Pe.emitOne(be(Fe))})}map(re){return ue.map(this,re)}static filter(re,be){return new ue(async Pe=>{for await(const Fe of re)be(Fe)&&Pe.emitOne(Fe)})}filter(re){return ue.filter(this,re)}static coalesce(re){return ue.filter(re,be=>!!be)}coalesce(){return ue.coalesce(this)}static async toPromise(re){const be=[];for await(const Pe of re)be.push(Pe);return be}toPromise(){return ue.toPromise(this)}emitOne(re){this._state===0&&(this._results.push(re),this._onStateChanged.fire())}emitMany(re){this._state===0&&(this._results=this._results.concat(re),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(re){this._state===0&&(this._state=2,this._error=re,this._onStateChanged.fire())}}e.AsyncIterableObject=ue,ue.EMPTY=ue.fromArray([]);class ve extends ue{constructor(re,be){super(be);this._source=re}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=ve;function ge(we){const re=new r.CancellationTokenSource,be=we(re.token);return new ve(re,async Pe=>{const Fe=re.token.onCancellationRequested(()=>{Fe.dispose(),re.dispose(),Pe.reject(new t.CancellationError)});try{for await(const ze of be){if(re.token.isCancellationRequested)return;Pe.emitOne(ze)}Fe.dispose(),re.dispose()}catch(ze){Fe.dispose(),re.dispose(),Pe.reject(ze)}})}e.createCancelableAsyncIterable=ge}),define(Se[104],_e([0,1,10,17]),function(ee,e,r,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const S=new r.IdleValue(()=>{const p=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:p,collatorIsNumeric:p.resolvedOptions().numeric}}),P=new r.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),A=new r.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function I(p,w,v=!1){const k=p||"",L=w||"",E=S.value.collator.compare(k,L);return S.value.collatorIsNumeric&&E===0&&k!==L?k<L?-1:1:E}e.compareFileNames=I;function D(p,w){const v=P.value.collator;return p=p||"",w=w||"",C(v,p,w)}e.compareFileNamesDefault=D;function T(p,w){const v=P.value.collator;return p=p||"",w=w||"",n(p,w)||C(v,p,w)}e.compareFileNamesUpper=T;function R(p,w){const v=P.value.collator;return p=p||"",w=w||"",c(p,w)||C(v,p,w)}e.compareFileNamesLower=R;function b(p,w){return p=p||"",w=w||"",p===w?0:p<w?-1:1}e.compareFileNamesUnicode=b;function i(p,w,v=!1){v||(p=p&&p.toLowerCase(),w=w&&w.toLowerCase());const[k,L]=_(p),[E,O]=_(w);return k!==E?k<E?-1:1:L===O?0:L<O?-1:1}e.noIntlCompareFileNames=i;function f(p,w){const[v,k]=_(p),[L,E]=_(w);let O=S.value.collator.compare(k,E);if(O===0){if(S.value.collatorIsNumeric&&k!==E)return k<E?-1:1;if(O=S.value.collator.compare(v,L),S.value.collatorIsNumeric&&O===0&&v!==L)return v<L?-1:1}return O}e.compareFileExtensions=f;function a(p,w){p=p||"",w=w||"";const v=u(p),k=u(w),L=P.value.collator,E=A.value.collator;return C(E,v,k)||C(L,p,w)}e.compareFileExtensionsDefault=a;function o(p,w){p=p||"",w=w||"";const v=u(p),k=u(w),L=P.value.collator,E=A.value.collator;return C(E,v,k)||n(p,w)||C(L,p,w)}e.compareFileExtensionsUpper=o;function m(p,w){p=p||"",w=w||"";const v=u(p),k=u(w),L=P.value.collator,E=A.value.collator;return C(E,v,k)||c(p,w)||C(L,p,w)}e.compareFileExtensionsLower=m;function M(p,w){p=p||"",w=w||"";const v=u(p).toLowerCase(),k=u(w).toLowerCase();return v!==k?v<k?-1:1:p!==w?p<w?-1:1:0}e.compareFileExtensionsUnicode=M;const y=/^(.*?)(\.([^.]*))?$/;function _(p,w=!1){const v=p?y.exec(p):[];let k=[v&&v[1]||"",v&&v[3]||""];return w&&(!k[0]&&k[1]||k[0]&&k[0].charAt(0)===".")&&(k=[k[0]+"."+k[1],""]),k}function u(p){const w=p?y.exec(p):[];return w&&w[1]&&w[1].charAt(0)!=="."&&w[3]||""}function C(p,w,v){let k=p.compare(w,v);return k!==0?k:w.length!==v.length?w.length<v.length?-1:1:0}function l(p){const w=p.charAt(0);return w.toLocaleUpperCase()!==w}function F(p){const w=p.charAt(0);return w.toLocaleLowerCase()!==w}function c(p,w){return l(p)&&F(w)?-1:F(p)&&l(w)?1:0}function n(p,w){return F(p)&&l(w)?-1:l(p)&&F(w)?1:0}function h(p,w,v=!1){return v||(p=p&&p.toLowerCase(),w=w&&w.toLowerCase()),p===w?0:p<w?-1:1}function g(p,w,v=!1){const k=p.split(t.sep),L=w.split(t.sep),E=k.length-1,O=L.length-1;let U,j;for(let H=0;;H++){if(U=E===H,j=O===H,U&&j)return I(k[H],L[H],v);if(U)return-1;if(j)return 1;const $=h(k[H],L[H],v);if($!==0)return $}}e.comparePaths=g;function s(p,w,v){const k=p.toLowerCase(),L=w.toLowerCase(),E=d(p,w,v);if(E)return E;const O=k.endsWith(v),U=L.endsWith(v);if(O!==U)return O?-1:1;const j=I(k,L);return j!==0?j:k.localeCompare(L)}e.compareAnything=s;function d(p,w,v){const k=p.toLowerCase(),L=w.toLowerCase(),E=k.startsWith(v),O=L.startsWith(v);if(E!==O)return E?-1:1;if(E&&O){if(k.length<L.length)return-1;if(k.length>L.length)return 1}return 0}e.compareByPrefix=d}),define(Se[29],_e([0,1,10,35,22,17,23,9]),function(ee,e,r,t,S,P,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function D(){return Object.create(null)}e.getEmptyExpression=D,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const T="[/\\\\]",R="[^/\\\\]",b=/\//g;function i(ie){switch(ie){case 0:return"";case 1:return`${R}*?`;default:return`(?:${T}|${R}+${T}|${T}${R}+)*?`}}function f(ie,le){if(!ie)return[];const X=[];let ue=!1,ve=!1,ge="";for(const we of ie){switch(we){case le:if(!ue&&!ve){X.push(ge),ge="";continue}break;case"{":ue=!0;break;case"}":ue=!1;break;case"[":ve=!0;break;case"]":ve=!1;break}ge+=we}return ge&&X.push(ge),X}e.splitGlobAware=f;function a(ie){if(!ie)return"";let le="";const X=f(ie,e.GLOB_SPLIT);if(X.every(ue=>ue===e.GLOBSTAR))le=".*";else{let ue=!1;X.forEach((ve,ge)=>{if(ve===e.GLOBSTAR){ue||(le+=i(2),ue=!0);return}let we=!1,re="",be=!1,Pe="";for(const Fe of ve){if(Fe!=="}"&&we){re+=Fe;continue}if(be&&(Fe!=="]"||!Pe)){let ze;Fe==="-"?ze=Fe:(Fe==="^"||Fe==="!")&&!Pe?ze="^":Fe===e.GLOB_SPLIT?ze="":ze=(0,I.escapeRegExpCharacters)(Fe),Pe+=ze;continue}switch(Fe){case"{":we=!0;continue;case"[":be=!0;continue;case"}":{le+=`(?:${f(re,",").map(et=>a(et)).join("|")})`,we=!1,re="";break}case"]":le+="["+Pe+"]",be=!1,Pe="";break;case"?":le+=R;continue;case"*":le+=i(1);continue;default:le+=(0,I.escapeRegExpCharacters)(Fe)}}ge<X.length-1&&(X[ge+1]!==e.GLOBSTAR||ge+2<X.length)&&(le+=T),ue=!1})}return le}const o=/^\*\*\/\*\.[\w\.-]+$/,m=/^\*\*\/([\w\.-]+)\/?$/,M=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,y=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,_=/^\*\*((\/[\w\.-]+)+)\/?$/,u=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,C=new S.LRUCache(1e4),l=function(){return!1},F=function(){return null};function c(ie,le){if(!ie)return F;let X;typeof ie!="string"?X=ie.pattern:X=ie,X=X.trim();const ue=`${X}_${!!le.trimForExclusions}`;let ve=C.get(ue);if(ve)return n(ve,ie);let ge;if(o.test(X)){const we=X.substr(4);ve=function(re,be){return typeof re=="string"&&re.endsWith(we)?X:null}}else(ge=m.exec(h(X,le)))?ve=g(ge[1],X):(le.trimForExclusions?y:M).test(X)?ve=s(X,le):(ge=_.exec(h(X,le)))?ve=d(ge[1].substr(1),X,!0):(ge=u.exec(h(X,le)))?ve=d(ge[1],X,!1):ve=p(X);return C.set(ue,ve),n(ve,ie)}function n(ie,le){return typeof le=="string"?ie:function(X,ue){return(0,t.isEqualOrParent)(X,le.base,!A.isLinux)?ie(X.substr(le.base.length+1),ue):null}}function h(ie,le){return le.trimForExclusions&&ie.endsWith("/**")?ie.substr(0,ie.length-2):ie}function g(ie,le){const X=`/${ie}`,ue=`\\${ie}`,ve=function(we,re){return typeof we!="string"?null:re?re===ie?le:null:we===ie||we.endsWith(X)||we.endsWith(ue)?le:null},ge=[ie];return ve.basenames=ge,ve.patterns=[le],ve.allBasenames=ge,ve}function s(ie,le){const X=G(ie.slice(1,-1).split(",").map(re=>c(re,le)).filter(re=>re!==F),ie),ue=X.length;if(!ue)return F;if(ue===1)return X[0];const ve=function(re,be){for(let Pe=0,Fe=X.length;Pe<Fe;Pe++)if(X[Pe](re,be))return ie;return null},ge=X.find(re=>!!re.allBasenames);ge&&(ve.allBasenames=ge.allBasenames);const we=X.reduce((re,be)=>be.allPaths?re.concat(be.allPaths):re,[]);return we.length&&(ve.allPaths=we),ve}function d(ie,le,X){const ue=P.sep===P.posix.sep,ve=ue?ie:ie.replace(b,P.sep),ge=P.sep+ve,we=P.posix.sep+ie,re=X?function(be,Pe){return typeof be=="string"&&(be===ve||be.endsWith(ge)||!ue&&(be===ie||be.endsWith(we)))?le:null}:function(be,Pe){return typeof be=="string"&&(be===ve||!ue&&be===ie)?le:null};return re.allPaths=[(X?"*/":"./")+ie],re}function p(ie){try{const le=new RegExp(`^${a(ie)}$`);return function(X){return le.lastIndex=0,typeof X=="string"&&le.test(X)?ie:null}}catch{return F}}function w(ie,le,X){return!ie||typeof le!="string"?!1:v(ie)(le,void 0,X)}e.match=w;function v(ie,le={}){if(!ie)return l;if(typeof ie=="string"||O(ie)){const X=c(ie,le);if(X===F)return l;const ue=function(ve,ge){return!!X(ve,ge)};return X.allBasenames&&(ue.allBasenames=X.allBasenames),X.allPaths&&(ue.allPaths=X.allPaths),ue}return H(ie,le)}e.parse=v;function k(ie){if(!ie)return;let le;return X=>(le||(le=(ie()||Promise.resolve([])).then(ue=>ue?E(ue):{})),le.then(ue=>!!ue[X]))}e.hasSiblingPromiseFn=k;function L(ie){if(!ie)return;let le;return X=>{if(!le){const ue=ie();le=ue?E(ue):{}}return!!le[X]}}e.hasSiblingFn=L;function E(ie){const le={};for(const X of ie)le[X]=!0;return le}function O(ie){const le=ie;return le?typeof le.base=="string"&&typeof le.pattern=="string":!1}e.isRelativePattern=O;function U(ie){return ie.allBasenames||[]}e.getBasenameTerms=U;function j(ie){return ie.allPaths||[]}e.getPathTerms=j;function H(ie,le){const X=G(Object.getOwnPropertyNames(ie).map(re=>$(re,ie[re],le)).filter(re=>re!==F)),ue=X.length;if(!ue)return F;if(!X.some(re=>!!re.requiresSiblings)){if(ue===1)return X[0];const re=function(Fe,ze){for(let nt=0,et=X.length;nt<et;nt++){const Ze=X[nt](Fe,ze);if(Ze)return Ze}return null},be=X.find(Fe=>!!Fe.allBasenames);be&&(re.allBasenames=be.allBasenames);const Pe=X.reduce((Fe,ze)=>ze.allPaths?Fe.concat(ze.allPaths):Fe,[]);return Pe.length&&(re.allPaths=Pe),re}const ve=function(re,be,Pe){let Fe;for(let ze=0,nt=X.length;ze<nt;ze++){const et=X[ze];et.requiresSiblings&&Pe&&(be||(be=(0,P.basename)(re)),Fe||(Fe=be.substr(0,be.length-(0,P.extname)(re).length)));const Ze=et(re,be,Fe,Pe);if(Ze)return Ze}return null},ge=X.find(re=>!!re.allBasenames);ge&&(ve.allBasenames=ge.allBasenames);const we=X.reduce((re,be)=>be.allPaths?re.concat(be.allPaths):re,[]);return we.length&&(ve.allPaths=we),ve}function $(ie,le,X){if(le===!1)return F;const ue=c(ie,X);if(ue===F)return F;if(typeof le=="boolean")return ue;if(le){const ve=le.when;if(typeof ve=="string"){const ge=(we,re,be,Pe)=>{if(!Pe||!ue(we,re))return null;const Fe=ve.replace("$(basename)",be),ze=Pe(Fe);return(0,r.isThenable)(ze)?ze.then(nt=>nt?ie:null):ze?ie:null};return ge.requiresSiblings=!0,ge}}return ue}function G(ie,le){const X=ie.filter(re=>!!re.basenames);if(X.length<2)return ie;const ue=X.reduce((re,be)=>{const Pe=be.basenames;return Pe?re.concat(Pe):re},[]);let ve;if(le){ve=[];for(let re=0,be=ue.length;re<be;re++)ve.push(le)}else ve=X.reduce((re,be)=>{const Pe=be.patterns;return Pe?re.concat(Pe):re},[]);const ge=function(re,be){if(typeof re!="string")return null;if(!be){let Fe;for(Fe=re.length;Fe>0;Fe--){const ze=re.charCodeAt(Fe-1);if(ze===47||ze===92)break}be=re.substr(Fe)}const Pe=ue.indexOf(be);return Pe!==-1?ve[Pe]:null};ge.basenames=ue,ge.patterns=ve,ge.allBasenames=ue;const we=ie.filter(re=>!re.basenames);return we.push(ge),we}}),define(Se[76],_e([0,1,35,11,17,23,24,9,2]),function(ee,e,r,t,S,P,A,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function T(n,h,g){if(typeof n=="string"&&(n=D.URI.file(n)),g){const d=g.getWorkspaceFolder(n);if(d){const p=g.getWorkspace().folders.length>1;let w;if((0,A.isEqual)(d.uri,n)?w="":w=(0,A.relativePath)(d.uri,n),p){const v=d.name?d.name:(0,A.basename)(d.uri);w=w?v+" \u2022 "+w:v}return w}}if(n.scheme!==t.Schemas.file&&n.scheme!==t.Schemas.untitled)return n.with({query:null,fragment:null}).toString(!0);if((0,r.hasDriveLetter)(n.fsPath))return(0,S.normalize)(b(n.fsPath));let s=(0,S.normalize)(n.fsPath);return!P.isWindows&&h?.userHome&&(s=f(s,h.userHome.fsPath)),s}e.getPathLabel=T;function R(n){if(!n)return;typeof n=="string"&&(n=D.URI.file(n));const h=(0,A.basename)(n)||(n.scheme===t.Schemas.file?n.fsPath:n.path);return P.isWindows&&(0,r.isRootOrDriveLetter)(h)?b(h):h}e.getBaseLabel=R;function b(n,h){return(0,r.hasDriveLetter)(n,h)?n.charAt(0).toUpperCase()+n.slice(1):n}e.normalizeDriveLetter=b;let i=Object.create(null);function f(n,h){if(P.isWindows||!n||!h)return n;let g=i.original===h?i.normalized:void 0;return g||(g=`${(0,I.rtrim)(h,S.posix.sep)}${S.posix.sep}`,i={original:h,normalized:g}),(P.isLinux?n.startsWith(g):(0,I.startsWithIgnoreCase)(n,g))&&(n=`~/${n.substr(g.length)}`),n}e.tildify=f;function a(n,h){return n.replace(/^~($|\/|\\)/,`${h}$1`)}e.untildify=a;const o="\u2026",m="\\\\",M="~";function y(n,h=S.sep){const g=new Array(n.length);let s=!1;for(let d=0;d<n.length;d++){let p=n[d];if(p===""){g[d]=`.${h}`;continue}if(!p){g[d]=p;continue}s=!0;let w="";p.indexOf(m)===0?(w=p.substr(0,p.indexOf(m)+m.length),p=p.substr(p.indexOf(m)+m.length)):p.indexOf(h)===0?(w=p.substr(0,p.indexOf(h)+h.length),p=p.substr(p.indexOf(h)+h.length)):p.indexOf(M)===0&&(w=p.substr(0,p.indexOf(M)+M.length),p=p.substr(p.indexOf(M)+M.length));const v=p.split(h);for(let k=1;s&&k<=v.length;k++)for(let L=v.length-k;s&&L>=0;L--){s=!1;let E=v.slice(L,L+k).join(h);for(let O=0;!s&&O<n.length;O++)if(O!==d&&n[O]&&n[O].indexOf(E)>-1){const U=L+k===v.length,j=L>0&&n[O].indexOf(h)>-1?h+E:E,H=n[O].endsWith(j);s=!U||H}if(!s){let O="";(v[0].endsWith(":")||w!=="")&&(L===1&&(L=0,k++,E=v[0]+h+E),L>0&&(O=v[0]+h),O=w+O),L>0&&(O=O+o+h),O=O+E,L+k<v.length&&(O=O+h+o),g[d]=O}}s&&(g[d]=p)}return g}e.shorten=y;var _;(function(n){n[n.TEXT=0]="TEXT",n[n.VARIABLE=1]="VARIABLE",n[n.SEPARATOR=2]="SEPARATOR"})(_||(_={}));function u(n,h=Object.create(null)){const g=[];let s=!1,d="";for(const p of n)if(p==="$"||s&&p==="{")d&&g.push({value:d,type:_.TEXT}),d="",s=!0;else if(p==="}"&&s){const w=h[d];if(typeof w=="string")w.length&&g.push({value:w,type:_.VARIABLE});else if(w){const v=g[g.length-1];(!v||v.type!==_.SEPARATOR)&&g.push({value:w.label,type:_.SEPARATOR})}d="",s=!1}else d+=p;return d&&!s&&g.push({value:d,type:_.TEXT}),g.filter((p,w)=>{if(p.type===_.SEPARATOR){const v=g[w-1],k=g[w+1];return[v,k].every(L=>L&&(L.type===_.VARIABLE||L.type===_.TEXT)&&L.value.length>0)}return!0}).map(p=>p.value).join("")}e.template=u;function C(n,h){return P.isMacintosh||h?n.replace(/\(&&\w\)|&&/g,"").replace(/&/g,P.isMacintosh?"&":"&&"):n.replace(/&&|&/g,g=>g==="&"?"&&":"&")}e.mnemonicMenuLabel=C;function l(n,h){return P.isMacintosh||h?n.replace(/\(&&\w\)|&&/g,""):P.isWindows?n.replace(/&&|&/g,g=>g==="&"?"&&":"&"):n.replace(/&&/g,"_")}e.mnemonicButtonLabel=l;function F(n){return n.replace(/&/g,"&&")}e.unmnemonicLabel=F;function c(n){const h=n.indexOf("/")!==-1?S.posix:S.win32,g=h.basename(n),s=h.dirname(n);return g.length?{name:g,parentPath:s}:{name:s,parentPath:""}}e.splitName=c}),define(Se[105],_e([0,1,2]),function(ee,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(R){return R.toJSON()}class S{constructor(b){this._uriTransformer=b}transformIncoming(b){const i=this._uriTransformer.transformIncoming(b);return i===b?b:t(r.URI.from(i))}transformOutgoing(b){const i=this._uriTransformer.transformOutgoing(b);return i===b?b:t(r.URI.from(i))}transformOutgoingURI(b){const i=this._uriTransformer.transformOutgoing(b);return i===b?b:r.URI.from(i)}transformOutgoingScheme(b){return this._uriTransformer.transformOutgoingScheme(b)}}e.URITransformer=S,e.DefaultURITransformer=new class{transformIncoming(R){return R}transformOutgoing(R){return R}transformOutgoingURI(R){return R}transformOutgoingScheme(R){return R}};function P(R,b,i){if(!R||i>200)return null;if(typeof R=="object"){if(R instanceof r.URI)return b.transformOutgoing(R);for(let f in R)if(Object.hasOwnProperty.call(R,f)){const a=P(R[f],b,i+1);a!==null&&(R[f]=a)}}return null}function A(R,b){const i=P(R,b,0);return i===null?R:i}e.transformOutgoingURIs=A;function I(R,b,i,f){if(!R||f>200)return null;if(typeof R=="object"){if(R.$mid===1)return i?r.URI.revive(b.transformIncoming(R)):b.transformIncoming(R);for(let a in R)if(Object.hasOwnProperty.call(R,a)){const o=I(R[a],b,i,f+1);o!==null&&(R[a]=o)}}return null}function D(R,b){const i=I(R,b,!1,0);return i===null?R:i}e.transformIncomingURIs=D;function T(R,b){const i=I(R,b,!0,0);return i===null?R:i}e.transformAndReviveIncomingURIs=T}),define(Se[36],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const r=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(D){return r.test(D)}e.isUUID=t;const S=new Uint8Array(16),P=[];for(let D=0;D<256;D++)P.push(D.toString(16).padStart(2,"0"));let A;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?A=crypto.getRandomValues.bind(crypto):A=function(D){for(let T=0;T<D.length;T++)D[T]=Math.floor(Math.random()*256);return D};function I(){A(S),S[6]=S[6]&15|64,S[8]=S[8]&63|128;let D=0,T="";return T+=P[S[D++]],T+=P[S[D++]],T+=P[S[D++]],T+=P[S[D++]],T+="-",T+=P[S[D++]],T+=P[S[D++]],T+="-",T+=P[S[D++]],T+=P[S[D++]],T+="-",T+=P[S[D++]],T+=P[S[D++]],T+="-",T+=P[S[D++]],T+=P[S[D++]],T+=P[S[D++]],T+=P[S[D++]],T+=P[S[D++]],T+=P[S[D++]],T}e.generateUuid=I}),define(Se[106],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var r;(function(A){A[A.None=0]="None",A[A.Indent=1]="Indent",A[A.IndentOutdent=2]="IndentOutdent",A[A.Outdent=3]="Outdent"})(r=e.IndentAction||(e.IndentAction={}));class t{constructor(I){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=I.open,this.close=I.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(I.notIn))for(let D=0,T=I.notIn.length;D<T;D++)switch(I.notIn[D]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(I){switch(I){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(I,D){if(I.getTokenCount()===0)return!0;const T=I.findTokenIndexAtOffset(D-2),R=I.getStandardTokenType(T);return this.isOK(R)}_findNeutralCharacterInRange(I,D){for(let T=I;T<=D;T++){const R=String.fromCharCode(T);if(!this.open.includes(R)&&!this.close.includes(R))return R}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=t;class S{constructor(I){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const D of I)P(this.autoClosingPairsOpenByStart,D.open.charAt(0),D),P(this.autoClosingPairsOpenByEnd,D.open.charAt(D.open.length-1),D),P(this.autoClosingPairsCloseByStart,D.close.charAt(0),D),P(this.autoClosingPairsCloseByEnd,D.close.charAt(D.close.length-1),D),D.close.length===1&&D.open.length===1&&P(this.autoClosingPairsCloseSingleChar,D.close,D)}}e.AutoClosingPairs=S;function P(A,I,D){A.has(I)?A.get(I).push(D):A.set(I,[D])}}),define(Se[56],_e([0,1,29,17]),function(ee,e,r,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function S(P,A,I,D){if(Array.isArray(P)){let T=0;for(const R of P){const b=S(R,A,I,D);if(b===10)return b;b>T&&(T=b)}return T}else{if(typeof P=="string")return D?P==="*"?5:P===I?10:0:0;if(P){const{language:T,pattern:R,scheme:b,hasAccessToAllModels:i}=P;if(!D&&!i)return 0;let f=0;if(b)if(b===A.scheme)f=10;else if(b==="*")f=5;else return 0;if(T)if(T===I)f=10;else if(T==="*")f=Math.max(f,5);else return 0;if(R){let a;if(typeof R=="string"?a=R:a={...R,base:(0,t.normalize)(R.base)},a===A.fsPath||(0,r.match)(a,A.fsPath))f=10;else return 0}return f}else return 0}}e.score=S}),define(Se[107],_e([0,1,4,6]),function(ee,e,r,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class S{constructor(){this._map=new Map,this._factories=new Map,this._onDidChange=new r.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(I){this._onDidChange.fire({changedLanguages:I,changedColorMap:!1})}register(I,D){return this._map.set(I,D),this.fire([I]),(0,t.toDisposable)(()=>{this._map.get(I)===D&&(this._map.delete(I),this.fire([I]))})}registerFactory(I,D){this._factories.get(I)?.dispose();const T=new P(this,I,D);return this._factories.set(I,T),(0,t.toDisposable)(()=>{const R=this._factories.get(I);!R||R!==T||(this._factories.delete(I),R.dispose())})}async getOrCreate(I){const D=this.get(I);if(D)return D;const T=this._factories.get(I);return!T||T.isResolved?null:(await T.resolve(),this.get(I))}get(I){return this._map.get(I)||null}isResolved(I){if(this.get(I))return!0;const T=this._factories.get(I);return!!(!T||T.isResolved)}setColorMap(I){this._colorMap=I,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistry=S;class P extends t.Disposable{constructor(I,D,T){super();this._registry=I,this._languageId=D,this._factory=T,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}get isResolved(){return this._isResolved}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const I=await Promise.resolve(this._factory.createTokenizationSupport());this._isResolved=!0,I&&!this._isDisposed&&this._register(this._registry.register(this._languageId,I))}}}),define(Se[77],_e([0,1,21,23]),function(ee,e,r,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var S;(function(b){b[b.Full=1]="Full",b[b.Delta=2]="Delta"})(S||(S={}));function P(b){for(let i=0,f=b.length;i<f;i+=4){const a=b[i+0],o=b[i+1],m=b[i+2],M=b[i+3];b[i+0]=M,b[i+1]=m,b[i+2]=o,b[i+3]=a}}function A(b){const i=new Uint8Array(b.buffer,b.byteOffset,b.length*4);return t.isLittleEndian()||P(i),r.VSBuffer.wrap(i)}function I(b){const i=b.buffer;if(t.isLittleEndian()||P(i),i.byteOffset%4==0)return new Uint32Array(i.buffer,i.byteOffset,i.length/4);{const f=new Uint8Array(i.byteLength);return f.set(i),new Uint32Array(f.buffer,f.byteOffset,f.length/4)}}function D(b){const i=new Uint32Array(T(b));let f=0;if(i[f++]=b.id,b.type==="full")i[f++]=1,i[f++]=b.data.length,i.set(b.data,f),f+=b.data.length;else{i[f++]=2,i[f++]=b.deltas.length;for(const a of b.deltas)i[f++]=a.start,i[f++]=a.deleteCount,a.data?(i[f++]=a.data.length,i.set(a.data,f),f+=a.data.length):i[f++]=0}return A(i)}e.encodeSemanticTokensDto=D;function T(b){let i=0;if(i+=1+1,b.type==="full")i+=1+b.data.length;else{i+=1,i+=(1+1+1)*b.deltas.length;for(const f of b.deltas)f.data&&(i+=f.data.length)}return i}function R(b){const i=I(b);let f=0;const a=i[f++];if(i[f++]===1){const y=i[f++],_=i.subarray(f,f+y);return f+=y,{id:a,type:"full",data:_}}const m=i[f++],M=[];for(let y=0;y<m;y++){const _=i[f++],u=i[f++],C=i[f++];let l;C>0&&(l=i.subarray(f,f+C),f+=C),M[y]={start:_,deleteCount:u,data:l}}return{id:a,type:"delta",deltas:M}}e.decodeSemanticTokensDto=R}),define(Se[108],_e([18,19]),function(ee,e){return ee.create("vs/base/common/date",e)}),define(Se[109],_e([0,1,108]),function(ee,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,S=t*60,P=S*24,A=P*7,I=P*30,D=P*365;function T(b,i,f){typeof b!="number"&&(b=b.getTime());const a=Math.round((new Date().getTime()-b)/1e3);if(a<-30)return(0,r.localize)(0,null,T(new Date().getTime()+a*1e3,!1));if(a<30)return(0,r.localize)(1,null);let o;return a<t?(o=a,i?o===1?f?(0,r.localize)(2,null,o):(0,r.localize)(3,null,o):f?(0,r.localize)(4,null,o):(0,r.localize)(5,null,o):o===1?f?(0,r.localize)(6,null,o):(0,r.localize)(7,null,o):f?(0,r.localize)(8,null,o):(0,r.localize)(9,null,o)):a<S?(o=Math.floor(a/t),i?o===1?f?(0,r.localize)(10,null,o):(0,r.localize)(11,null,o):f?(0,r.localize)(12,null,o):(0,r.localize)(13,null,o):o===1?f?(0,r.localize)(14,null,o):(0,r.localize)(15,null,o):f?(0,r.localize)(16,null,o):(0,r.localize)(17,null,o)):a<P?(o=Math.floor(a/S),i?o===1?f?(0,r.localize)(18,null,o):(0,r.localize)(19,null,o):f?(0,r.localize)(20,null,o):(0,r.localize)(21,null,o):o===1?f?(0,r.localize)(22,null,o):(0,r.localize)(23,null,o):f?(0,r.localize)(24,null,o):(0,r.localize)(25,null,o)):a<A?(o=Math.floor(a/P),i?o===1?(0,r.localize)(26,null,o):(0,r.localize)(27,null,o):o===1?(0,r.localize)(28,null,o):(0,r.localize)(29,null,o)):a<I?(o=Math.floor(a/A),i?o===1?f?(0,r.localize)(30,null,o):(0,r.localize)(31,null,o):f?(0,r.localize)(32,null,o):(0,r.localize)(33,null,o):o===1?f?(0,r.localize)(34,null,o):(0,r.localize)(35,null,o):f?(0,r.localize)(36,null,o):(0,r.localize)(37,null,o)):a<D?(o=Math.floor(a/I),i?o===1?f?(0,r.localize)(38,null,o):(0,r.localize)(39,null,o):f?(0,r.localize)(40,null,o):(0,r.localize)(41,null,o):o===1?f?(0,r.localize)(42,null,o):(0,r.localize)(43,null,o):f?(0,r.localize)(44,null,o):(0,r.localize)(45,null,o)):(o=Math.floor(a/D),i?o===1?f?(0,r.localize)(46,null,o):(0,r.localize)(47,null,o):f?(0,r.localize)(48,null,o):(0,r.localize)(49,null,o):o===1?f?(0,r.localize)(50,null,o):(0,r.localize)(51,null,o):f?(0,r.localize)(52,null,o):(0,r.localize)(53,null,o))}e.fromNow=T;function R(b){return b.getFullYear()+"-"+String(b.getMonth()+1).padStart(2,"0")+"-"+String(b.getDate()).padStart(2,"0")+"T"+String(b.getHours()).padStart(2,"0")+":"+String(b.getMinutes()).padStart(2,"0")+":"+String(b.getSeconds()).padStart(2,"0")+"."+(b.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=R}),define(Se[110],_e([18,19]),function(ee,e){return ee.create("vs/base/common/errorMessage",e)}),define(Se[43],_e([0,1,16,13,110]),function(ee,e,r,t,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function P(T,R){return R&&(T.stack||T.stacktrace)?S.localize(0,null,I(T),A(T.stack)||A(T.stacktrace)):I(T)}function A(T){return Array.isArray(T)?T.join(`
`):T}function I(T){return typeof T.code=="string"&&typeof T.errno=="number"&&typeof T.syscall=="string"?S.localize(1,null,T.message):T.message||S.localize(2,null)}function D(T=null,R=!1){if(!T)return S.localize(3,null);if(Array.isArray(T)){const b=r.coalesce(T),i=D(b[0],R);return b.length>1?S.localize(4,null,i,b.length):i}if(t.isString(T))return T;if(T.detail){const b=T.detail;if(b.error)return P(b.error,R);if(b.exception)return P(b.exception,R)}return T.stack?P(T,R):T.message?T.message:S.localize(5,null)}e.toErrorMessage=D}),define(Se[111],_e([18,19]),function(ee,e){return ee.create("vs/editor/common/config/editorOptions",e)}),define(Se[112],_e([0,1,111,23,113,16,27]),function(ee,e,r,t,S,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var I;(function(q){q[q.None=0]="None",q[q.Keep=1]="Keep",q[q.Brackets=2]="Brackets",q[q.Advanced=3]="Advanced",q[q.Full=4]="Full"})(I=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class D{constructor(Q){this._values=Q}hasChanged(Q){return this._values[Q]}}e.ConfigurationChangedEvent=D;class T{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=T;class R{constructor(Q,he,Be,qe){this.id=Q,this.name=he,this.defaultValue=Be,this.schema=qe}applyUpdate(Q,he){return i(Q,he)}compute(Q,he,Be){return Be}}class b{constructor(Q,he){this.newValue=Q,this.didChange=he}}e.ApplyUpdateResult=b;function i(q,Q){if(typeof q!="object"||typeof Q!="object"||!q||!Q)return new b(Q,q!==Q);if(Array.isArray(q)||Array.isArray(Q)){const Be=Array.isArray(q)&&Array.isArray(Q)&&P.equals(q,Q);return new b(Q,Be)}let he=!1;for(const Be in Q)if(Q.hasOwnProperty(Be)){const qe=i(q[Be],Q[Be]);qe.didChange&&(q[Be]=qe.newValue,he=!0)}return new b(q,he)}class f{constructor(Q){this.schema=void 0,this.id=Q,this.name="_never_",this.defaultValue=void 0}applyUpdate(Q,he){return i(Q,he)}validate(Q){return this.defaultValue}}class a{constructor(Q,he,Be,qe){this.id=Q,this.name=he,this.defaultValue=Be,this.schema=qe}applyUpdate(Q,he){return i(Q,he)}validate(Q){return typeof Q=="undefined"?this.defaultValue:Q}compute(Q,he,Be){return Be}}function o(q,Q){return typeof q=="undefined"?Q:q==="false"?!1:Boolean(q)}e.boolean=o;class m extends a{constructor(Q,he,Be,qe=void 0){typeof qe!="undefined"&&(qe.type="boolean",qe.default=Be);super(Q,he,Be,qe)}validate(Q){return o(Q,this.defaultValue)}}function M(q,Q,he,Be){if(typeof q=="undefined")return Q;let qe=parseInt(q,10);return isNaN(qe)?Q:(qe=Math.max(he,qe),qe=Math.min(Be,qe),qe|0)}e.clampedInt=M;class y extends a{constructor(Q,he,Be,qe,lt,ht=void 0){typeof ht!="undefined"&&(ht.type="integer",ht.default=Be,ht.minimum=qe,ht.maximum=lt);super(Q,he,Be,ht);this.minimum=qe,this.maximum=lt}static clampedInt(Q,he,Be,qe){return M(Q,he,Be,qe)}validate(Q){return y.clampedInt(Q,this.defaultValue,this.minimum,this.maximum)}}class _ extends a{constructor(Q,he,Be,qe,lt){typeof lt!="undefined"&&(lt.type="number",lt.default=Be);super(Q,he,Be,lt);this.validationFn=qe}static clamp(Q,he,Be){return Q<he?he:Q>Be?Be:Q}static float(Q,he){if(typeof Q=="number")return Q;if(typeof Q=="undefined")return he;const Be=parseFloat(Q);return isNaN(Be)?he:Be}validate(Q){return this.validationFn(_.float(Q,this.defaultValue))}}class u extends a{static string(Q,he){return typeof Q!="string"?he:Q}constructor(Q,he,Be,qe=void 0){typeof qe!="undefined"&&(qe.type="string",qe.default=Be);super(Q,he,Be,qe)}validate(Q){return u.string(Q,this.defaultValue)}}function C(q,Q,he){return typeof q!="string"||he.indexOf(q)===-1?Q:q}e.stringSet=C;class l extends a{constructor(Q,he,Be,qe,lt=void 0){typeof lt!="undefined"&&(lt.type="string",lt.enum=qe,lt.default=Be);super(Q,he,Be,lt);this._allowedValues=qe}validate(Q){return C(Q,this.defaultValue,this._allowedValues)}}class F extends R{constructor(Q,he,Be,qe,lt,ht,Ye=void 0){typeof Ye!="undefined"&&(Ye.type="string",Ye.enum=lt,Ye.default=qe);super(Q,he,Be,Ye);this._allowedValues=lt,this._convert=ht}validate(Q){return typeof Q!="string"?this.defaultValue:this._allowedValues.indexOf(Q)===-1?this.defaultValue:this._convert(Q)}}function c(q){switch(q){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class n extends R{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[r.localize(0,null),r.localize(1,null),r.localize(2,null)],default:"auto",description:r.localize(3,null)})}validate(Q){switch(Q){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Q,he,Be){return Be===0?Q.accessibilitySupport:Be}}class h extends R{constructor(){const Q={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",Q,{"editor.comments.insertSpace":{type:"boolean",default:Q.insertSpace,description:r.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Q.ignoreEmptyLines,description:r.localize(5,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{insertSpace:o(he.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:o(he.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var g;(function(q){q[q.Hidden=0]="Hidden",q[q.Blink=1]="Blink",q[q.Smooth=2]="Smooth",q[q.Phase=3]="Phase",q[q.Expand=4]="Expand",q[q.Solid=5]="Solid"})(g=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function s(q){switch(q){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var d;(function(q){q[q.Line=1]="Line",q[q.Block=2]="Block",q[q.Underline=3]="Underline",q[q.LineThin=4]="LineThin",q[q.BlockOutline=5]="BlockOutline",q[q.UnderlineThin=6]="UnderlineThin"})(d=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function p(q){switch(q){case d.Line:return"line";case d.Block:return"block";case d.Underline:return"underline";case d.LineThin:return"line-thin";case d.BlockOutline:return"block-outline";case d.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=p;function w(q){switch(q){case"line":return d.Line;case"block":return d.Block;case"underline":return d.Underline;case"line-thin":return d.LineThin;case"block-outline":return d.BlockOutline;case"underline-thin":return d.UnderlineThin}}class v extends f{constructor(){super(128)}compute(Q,he,Be){const qe=["monaco-editor"];return he.get(33)&&qe.push(he.get(33)),Q.extraEditorClassName&&qe.push(Q.extraEditorClassName),he.get(66)==="default"?qe.push("mouse-default"):he.get(66)==="copy"&&qe.push("mouse-copy"),he.get(100)&&qe.push("showUnused"),he.get(126)&&qe.push("showDeprecated"),qe.join(" ")}}class k extends m{constructor(){super(32,"emptySelectionClipboard",!0,{description:r.localize(6,null)})}compute(Q,he,Be){return Be&&Q.emptySelectionClipboard}}class L extends R{constructor(){const Q={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(35,"find",Q,{"editor.find.cursorMoveOnType":{type:"boolean",default:Q.cursorMoveOnType,description:r.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Q.seedSearchStringFromSelection,enumDescriptions:[r.localize(8,null),r.localize(9,null),r.localize(10,null)],description:r.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Q.autoFindInSelection,enumDescriptions:[r.localize(12,null),r.localize(13,null),r.localize(14,null)],description:r.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Q.globalFindClipboard,description:r.localize(16,null),included:t.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Q.addExtraSpaceOnTop,description:r.localize(17,null)},"editor.find.loop":{type:"boolean",default:Q.loop,description:r.localize(18,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{cursorMoveOnType:o(he.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Q.seedSearchStringFromSelection=="boolean"?Q.seedSearchStringFromSelection?"always":"never":C(he.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Q.autoFindInSelection=="boolean"?Q.autoFindInSelection?"always":"never":C(he.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:o(he.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:o(he.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:o(he.loop,this.defaultValue.loop)}}}class E extends R{constructor(){super(45,"fontLigatures",E.OFF,{anyOf:[{type:"boolean",description:r.localize(19,null)},{type:"string",description:r.localize(20,null)}],description:r.localize(21,null),default:!1})}validate(Q){return typeof Q=="undefined"?this.defaultValue:typeof Q=="string"?Q==="false"?E.OFF:Q==="true"?E.ON:Q:Boolean(Q)?E.ON:E.OFF}}e.EditorFontLigatures=E,E.OFF='"liga" off, "calt" off',E.ON='"liga" on, "calt" on';class O extends f{constructor(){super(44)}compute(Q,he,Be){return Q.fontInfo}}class U extends a{constructor(){super(46,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:r.localize(22,null)})}validate(Q){const he=_.float(Q,this.defaultValue);return he===0?e.EDITOR_FONT_DEFAULTS.fontSize:_.clamp(he,6,100)}compute(Q,he,Be){return Q.fontInfo.fontSize}}class j extends R{constructor(){super(47,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:j.MINIMUM_VALUE,maximum:j.MAXIMUM_VALUE,errorMessage:r.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:j.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:r.localize(24,null)})}validate(Q){return Q==="normal"||Q==="bold"?Q:String(y.clampedInt(Q,e.EDITOR_FONT_DEFAULTS.fontWeight,j.MINIMUM_VALUE,j.MAXIMUM_VALUE))}}j.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],j.MINIMUM_VALUE=1,j.MAXIMUM_VALUE=1e3;class H extends R{constructor(){const Q={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},he={type:"string",enum:["peek","gotoAndPeek","goto"],default:Q.multiple,enumDescriptions:[r.localize(25,null),r.localize(26,null),r.localize(27,null)]},Be=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(51,"gotoLocation",Q,{"editor.gotoLocation.multiple":{deprecationMessage:r.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:r.localize(29,null),...he},"editor.gotoLocation.multipleTypeDefinitions":{description:r.localize(30,null),...he},"editor.gotoLocation.multipleDeclarations":{description:r.localize(31,null),...he},"editor.gotoLocation.multipleImplementations":{description:r.localize(32,null),...he},"editor.gotoLocation.multipleReferences":{description:r.localize(33,null),...he},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Q.alternativeDefinitionCommand,enum:Be,description:r.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Q.alternativeTypeDefinitionCommand,enum:Be,description:r.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Q.alternativeDeclarationCommand,enum:Be,description:r.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Q.alternativeImplementationCommand,enum:Be,description:r.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Q.alternativeReferenceCommand,enum:Be,description:r.localize(38,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{multiple:C(he.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:he.multipleDefinitions??C(he.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:he.multipleTypeDefinitions??C(he.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:he.multipleDeclarations??C(he.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:he.multipleImplementations??C(he.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:he.multipleReferences??C(he.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:u.string(he.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:u.string(he.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:u.string(he.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:u.string(he.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:u.string(he.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class $ extends R{constructor(){const Q={enabled:!0,delay:300,sticky:!0,above:!0};super(53,"hover",Q,{"editor.hover.enabled":{type:"boolean",default:Q.enabled,description:r.localize(39,null)},"editor.hover.delay":{type:"number",default:Q.delay,minimum:0,maximum:1e4,description:r.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:Q.sticky,description:r.localize(41,null)},"editor.hover.above":{type:"boolean",default:Q.above,description:r.localize(42,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{enabled:o(he.enabled,this.defaultValue.enabled),delay:y.clampedInt(he.delay,this.defaultValue.delay,0,1e4),sticky:o(he.sticky,this.defaultValue.sticky),above:o(he.above,this.defaultValue.above)}}}var G;(function(q){q[q.None=0]="None",q[q.Text=1]="Text",q[q.Blocks=2]="Blocks"})(G=e.RenderMinimap||(e.RenderMinimap={}));class ie extends f{constructor(){super(131)}compute(Q,he,Be){return ie.computeLayout(he,{memory:Q.memory,outerWidth:Q.outerWidth,outerHeight:Q.outerHeight,isDominatedByLongLines:Q.isDominatedByLongLines,lineHeight:Q.fontInfo.lineHeight,viewLineCount:Q.viewLineCount,lineNumbersDigitCount:Q.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Q.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Q.fontInfo.maxDigitWidth,pixelRatio:Q.pixelRatio})}static computeContainedMinimapLineCount(Q){const he=Q.height/Q.lineHeight,Be=Q.scrollBeyondLastLine?he-1:0,qe=(Q.viewLineCount+Be)/(Q.pixelRatio*Q.height),lt=Math.floor(Q.viewLineCount/qe);return{typicalViewportLineCount:he,extraLinesBeyondLastLine:Be,desiredRatio:qe,minimapLineCount:lt}}static _computeMinimapLayout(Q,he){const Be=Q.outerWidth,qe=Q.outerHeight,lt=Q.pixelRatio;if(!Q.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(lt*qe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:qe};const ht=he.stableMinimapLayoutInput,Ye=ht&&Q.outerHeight===ht.outerHeight&&Q.lineHeight===ht.lineHeight&&Q.typicalHalfwidthCharacterWidth===ht.typicalHalfwidthCharacterWidth&&Q.pixelRatio===ht.pixelRatio&&Q.scrollBeyondLastLine===ht.scrollBeyondLastLine&&Q.minimap.enabled===ht.minimap.enabled&&Q.minimap.side===ht.minimap.side&&Q.minimap.size===ht.minimap.size&&Q.minimap.showSlider===ht.minimap.showSlider&&Q.minimap.renderCharacters===ht.minimap.renderCharacters&&Q.minimap.maxColumn===ht.minimap.maxColumn&&Q.minimap.scale===ht.minimap.scale&&Q.verticalScrollbarWidth===ht.verticalScrollbarWidth&&Q.isViewportWrapping===ht.isViewportWrapping,kt=Q.lineHeight,Ae=Q.typicalHalfwidthCharacterWidth,De=Q.scrollBeyondLastLine,pe=Q.minimap.renderCharacters;let te=lt>=2?Math.round(Q.minimap.scale*2):Q.minimap.scale;const ne=Q.minimap.maxColumn,de=Q.minimap.size,me=Q.minimap.side,Te=Q.verticalScrollbarWidth,He=Q.viewLineCount,Le=Q.remainingWidth,Ge=Q.isViewportWrapping,st=pe?2:3;let at=Math.floor(lt*qe);const Ne=at/lt;let ce=!1,fe=!1,oe=st*te,W=te/lt,Ee=1;if(de==="fill"||de==="fit"){const{typicalViewportLineCount:dt,extraLinesBeyondLastLine:vt,desiredRatio:bt,minimapLineCount:Ut}=ie.computeContainedMinimapLineCount({viewLineCount:He,scrollBeyondLastLine:De,height:qe,lineHeight:kt,pixelRatio:lt});if(He/Ut>1)ce=!0,fe=!0,te=1,oe=1,W=te/lt;else{let Mt=!1,Dt=te+1;if(de==="fit"){const _t=Math.ceil((He+vt)*oe);Ge&&Ye&&Le<=he.stableFitRemainingWidth?(Mt=!0,Dt=he.stableFitMaxMinimapScale):Mt=_t>at}if(de==="fill"||Mt){ce=!0;const _t=te;oe=Math.min(kt*lt,Math.max(1,Math.floor(1/bt))),Ge&&Ye&&Le<=he.stableFitRemainingWidth&&(Dt=he.stableFitMaxMinimapScale),te=Math.min(Dt,Math.max(1,Math.floor(oe/st))),te>_t&&(Ee=Math.min(2,te/_t)),W=te/lt/Ee,at=Math.ceil(Math.max(dt,He+vt)*oe),Ge?(he.stableMinimapLayoutInput=Q,he.stableFitRemainingWidth=Le,he.stableFitMaxMinimapScale=te):(he.stableMinimapLayoutInput=null,he.stableFitRemainingWidth=0)}}}const Re=Math.floor(ne*W),Ve=Math.min(Re,Math.max(0,Math.floor((Le-Te-2)*W/(Ae+W)))+e.MINIMAP_GUTTER_WIDTH);let We=Math.floor(lt*Ve);const mt=We/lt;We=Math.floor(We*Ee);const Et=pe?1:2,St=me==="left"?0:Be-Ve-Te;return{renderMinimap:Et,minimapLeft:St,minimapWidth:Ve,minimapHeightIsEditorHeight:ce,minimapIsSampling:fe,minimapScale:te,minimapLineHeight:oe,minimapCanvasInnerWidth:We,minimapCanvasInnerHeight:at,minimapCanvasOuterWidth:mt,minimapCanvasOuterHeight:Ne}}static computeLayout(Q,he){const Be=he.outerWidth|0,qe=he.outerHeight|0,lt=he.lineHeight|0,ht=he.lineNumbersDigitCount|0,Ye=he.typicalHalfwidthCharacterWidth,kt=he.maxDigitWidth,Ae=he.pixelRatio,De=he.viewLineCount,pe=Q.get(123),te=pe==="inherit"?Q.get(122):pe,ne=te==="inherit"?Q.get(118):te,de=Q.get(121),me=Q.get(2),Te=he.isDominatedByLongLines,He=Q.get(50),Le=Q.get(60).renderType!==0,Ge=Q.get(61),st=Q.get(94),at=Q.get(65),Ne=Q.get(92),ce=Ne.verticalScrollbarSize,fe=Ne.verticalHasArrows,oe=Ne.arrowSize,W=Ne.horizontalScrollbarSize,Ee=Q.get(58),Re=Q.get(37);let Ve;if(typeof Ee=="string"&&/^\d+(\.\d+)?ch$/.test(Ee)){const wt=parseFloat(Ee.substr(0,Ee.length-2));Ve=y.clampedInt(wt*Ye,0,0,1e3)}else Ve=y.clampedInt(Ee,0,0,1e3);Re&&(Ve+=16);let We=0;if(Le){const wt=Math.max(ht,Ge);We=Math.round(wt*kt)}let mt=0;He&&(mt=lt);let Et=0,St=Et+mt,dt=St+We,vt=dt+Ve;const bt=Be-mt-We-Ve;let Ut=!1,It=!1,Mt=-1;me!==2&&(te==="inherit"&&Te?(Ut=!0,It=!0):ne==="on"||ne==="bounded"?It=!0:ne==="wordWrapColumn"&&(Mt=de));const Dt=ie._computeMinimapLayout({outerWidth:Be,outerHeight:qe,lineHeight:lt,typicalHalfwidthCharacterWidth:Ye,pixelRatio:Ae,scrollBeyondLastLine:st,minimap:at,verticalScrollbarWidth:ce,viewLineCount:De,remainingWidth:bt,isViewportWrapping:It},he.memory||new T);Dt.renderMinimap!==0&&Dt.minimapLeft===0&&(Et+=Dt.minimapWidth,St+=Dt.minimapWidth,dt+=Dt.minimapWidth,vt+=Dt.minimapWidth);const _t=bt-Dt.minimapWidth,Qt=Math.max(1,Math.floor((_t-ce-2)/Ye)),Vt=fe?oe:0;return It&&(Mt=Math.max(1,Qt),ne==="bounded"&&(Mt=Math.min(Mt,de))),{width:Be,height:qe,glyphMarginLeft:Et,glyphMarginWidth:mt,lineNumbersLeft:St,lineNumbersWidth:We,decorationsLeft:dt,decorationsWidth:Ve,contentLeft:vt,contentWidth:_t,minimap:Dt,viewportColumn:Qt,isWordWrapMinified:Ut,isViewportWrapping:It,wrappingColumn:Mt,verticalScrollbarWidth:ce,horizontalScrollbarHeight:W,overviewRuler:{top:Vt,width:ce,height:qe-2*Vt,right:0}}}}e.EditorLayoutInfoComputer=ie;class le extends R{constructor(){const Q={enabled:!0};super(57,"lightbulb",Q,{"editor.lightbulb.enabled":{type:"boolean",default:Q.enabled,description:r.localize(43,null)}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{enabled:o(Q.enabled,this.defaultValue.enabled)}}}class X extends R{constructor(){const Q={enabled:!0,fontSize:0,fontFamily:""};super(127,"inlayHints",Q,{"editor.inlayHints.enabled":{type:"boolean",default:Q.enabled,description:r.localize(44,null)},"editor.inlayHints.fontSize":{type:"number",default:Q.fontSize,markdownDescription:r.localize(45,null)},"editor.inlayHints.fontFamily":{type:"string",default:Q.fontFamily,markdownDescription:r.localize(46,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{enabled:o(he.enabled,this.defaultValue.enabled),fontSize:y.clampedInt(he.fontSize,this.defaultValue.fontSize,0,100),fontFamily:u.string(he.fontFamily,this.defaultValue.fontFamily)}}}class ue extends _{constructor(){super(59,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Q=>_.clamp(Q,0,150),{markdownDescription:r.localize(47,null)})}compute(Q,he,Be){return Q.fontInfo.lineHeight}}class ve extends R{constructor(){const Q={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(65,"minimap",Q,{"editor.minimap.enabled":{type:"boolean",default:Q.enabled,description:r.localize(48,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[r.localize(49,null),r.localize(50,null),r.localize(51,null)],default:Q.size,description:r.localize(52,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Q.side,description:r.localize(53,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Q.showSlider,description:r.localize(54,null)},"editor.minimap.scale":{type:"number",default:Q.scale,minimum:1,maximum:3,enum:[1,2,3],description:r.localize(55,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Q.renderCharacters,description:r.localize(56,null)},"editor.minimap.maxColumn":{type:"number",default:Q.maxColumn,description:r.localize(57,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{enabled:o(he.enabled,this.defaultValue.enabled),size:C(he.size,this.defaultValue.size,["proportional","fill","fit"]),side:C(he.side,this.defaultValue.side,["right","left"]),showSlider:C(he.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:o(he.renderCharacters,this.defaultValue.renderCharacters),scale:y.clampedInt(he.scale,1,1,3),maxColumn:y.clampedInt(he.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function ge(q){return q==="ctrlCmd"?t.isMacintosh?"metaKey":"ctrlKey":"altKey"}class we extends R{constructor(){super(75,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:r.localize(58,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:r.localize(59,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{top:y.clampedInt(he.top,0,0,1e3),bottom:y.clampedInt(he.bottom,0,0,1e3)}}}class re extends R{constructor(){const Q={enabled:!0,cycle:!1};super(76,"parameterHints",Q,{"editor.parameterHints.enabled":{type:"boolean",default:Q.enabled,description:r.localize(60,null)},"editor.parameterHints.cycle":{type:"boolean",default:Q.cycle,description:r.localize(61,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{enabled:o(he.enabled,this.defaultValue.enabled),cycle:o(he.cycle,this.defaultValue.cycle)}}}class be extends f{constructor(){super(129)}compute(Q,he,Be){return Q.pixelRatio}}class Pe extends R{constructor(){const Q={other:!0,comments:!1,strings:!1};super(79,"quickSuggestions",Q,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:Q.strings,description:r.localize(62,null)},comments:{type:"boolean",default:Q.comments,description:r.localize(63,null)},other:{type:"boolean",default:Q.other,description:r.localize(64,null)}}}],default:Q,description:r.localize(65,null)});this.defaultValue=Q}validate(Q){if(typeof Q=="boolean")return Q;if(Q&&typeof Q=="object"){const he=Q,Be={other:o(he.other,this.defaultValue.other),comments:o(he.comments,this.defaultValue.comments),strings:o(he.strings,this.defaultValue.strings)};return Be.other&&Be.comments&&Be.strings?!0:!Be.other&&!Be.comments&&!Be.strings?!1:Be}return this.defaultValue}}var Fe;(function(q){q[q.Off=0]="Off",q[q.On=1]="On",q[q.Relative=2]="Relative",q[q.Interval=3]="Interval",q[q.Custom=4]="Custom"})(Fe=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class ze extends R{constructor(){super(60,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[r.localize(66,null),r.localize(67,null),r.localize(68,null),r.localize(69,null)],default:"on",description:r.localize(70,null)})}validate(Q){let he=this.defaultValue.renderType,Be=this.defaultValue.renderFn;return typeof Q!="undefined"&&(typeof Q=="function"?(he=4,Be=Q):Q==="interval"?he=3:Q==="relative"?he=2:Q==="on"?he=1:he=0),{renderType:he,renderFn:Be}}}function nt(q){const Q=q.get(87);return Q==="editable"?q.get(81):Q!=="on"}e.filterValidationDecorations=nt;class et extends R{constructor(){const Q=[],he={type:"number",description:r.localize(71,null)};super(91,"rulers",Q,{type:"array",items:{anyOf:[he,{type:["object"],properties:{column:he,color:{type:"string",description:r.localize(72,null),format:"color-hex"}}}]},default:Q,description:r.localize(73,null)})}validate(Q){if(Array.isArray(Q)){const he=[];for(let Be of Q)if(typeof Be=="number")he.push({column:y.clampedInt(Be,0,0,1e4),color:null});else if(Be&&typeof Be=="object"){const qe=Be;he.push({column:y.clampedInt(qe.column,0,0,1e4),color:qe.color})}return he.sort((Be,qe)=>Be.column-qe.column),he}return this.defaultValue}}function Ze(q,Q){if(typeof q!="string")return Q;switch(q){case"hidden":return 2;case"visible":return 3;default:return 1}}class x extends R{constructor(){const Q={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(92,"scrollbar",Q,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[r.localize(74,null),r.localize(75,null),r.localize(76,null)],default:"auto",description:r.localize(77,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[r.localize(78,null),r.localize(79,null),r.localize(80,null)],default:"auto",description:r.localize(81,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Q.verticalScrollbarSize,description:r.localize(82,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Q.horizontalScrollbarSize,description:r.localize(83,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Q.scrollByPage,description:r.localize(84,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q,Be=y.clampedInt(he.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),qe=y.clampedInt(he.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:y.clampedInt(he.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ze(he.vertical,this.defaultValue.vertical),horizontal:Ze(he.horizontal,this.defaultValue.horizontal),useShadows:o(he.useShadows,this.defaultValue.useShadows),verticalHasArrows:o(he.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:o(he.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:o(he.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:o(he.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Be,horizontalSliderSize:y.clampedInt(he.horizontalSliderSize,Be,0,1e3),verticalScrollbarSize:qe,verticalSliderSize:y.clampedInt(he.verticalSliderSize,qe,0,1e3),scrollByPage:o(he.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class K extends R{constructor(){const Q={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(113,"unicodeHighlight",Q,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.nonBasicASCII,description:r.localize(85,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Q.invisibleCharacters,description:r.localize(86,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Q.ambiguousCharacters,description:r.localize(87,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeComments,description:r.localize(88,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeStrings,description:r.localize(89,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Q.allowedCharacters,description:r.localize(90,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Q.allowedLocales,description:r.localize(91,null)}})}applyUpdate(Q,he){let Be=!1;he.allowedCharacters&&(A.equals(Q.allowedCharacters,he.allowedCharacters)||(Q={...Q,allowedCharacters:he.allowedCharacters},Be=!0)),he.allowedLocales&&(A.equals(Q.allowedLocales,he.allowedLocales)||(Q={...Q,allowedLocales:he.allowedLocales},Be=!0));const qe=super.applyUpdate(Q,he);return Be?new b(qe.newValue,!0):qe}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{nonBasicASCII:se(he.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:o(he.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:o(he.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:se(he.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:se(he.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(Q.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(Q.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(Q,he){if(typeof Q!="object"||!Q)return he;const Be={};for(const[qe,lt]of Object.entries(Q))lt===!0&&(Be[qe]=!0);return Be}}class z extends R{constructor(){const Q={enabled:!0,mode:"subwordSmart"};super(55,"inlineSuggest",Q,{"editor.inlineSuggest.enabled":{type:"boolean",default:Q.enabled,description:r.localize(92,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{enabled:o(he.enabled,this.defaultValue.enabled),mode:C(he.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class V extends R{constructor(){const Q={enabled:e.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled};super(12,"bracketPairColorization",Q,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Q.enabled,description:r.localize(93,null)}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{enabled:o(Q.enabled,this.defaultValue.enabled)}}}class Y extends R{constructor(){const Q={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",Q,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[r.localize(94,null),r.localize(95,null),r.localize(96,null)],default:Q.bracketPairs,description:r.localize(97,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[r.localize(98,null),r.localize(99,null),r.localize(100,null)],default:Q.bracketPairsHorizontal,description:r.localize(101,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Q.highlightActiveBracketPair,description:r.localize(102,null)},"editor.guides.indentation":{type:"boolean",default:Q.indentation,description:r.localize(103,null)},"editor.guides.highlightActiveIndentation":{type:"boolean",default:Q.highlightActiveIndentation,description:r.localize(104,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{bracketPairs:se(he.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:se(he.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:o(he.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:o(he.indentation,this.defaultValue.indentation),highlightActiveIndentation:o(he.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation)}}}function se(q,Q,he){const Be=he.indexOf(q);return Be===-1?Q:he[Be]}class ye extends R{constructor(){const Q={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(106,"suggest",Q,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[r.localize(105,null),r.localize(106,null)],default:Q.insertMode,description:r.localize(107,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Q.filterGraceful,description:r.localize(108,null)},"editor.suggest.localityBonus":{type:"boolean",default:Q.localityBonus,description:r.localize(109,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Q.shareSuggestSelections,markdownDescription:r.localize(110,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Q.snippetsPreventQuickSuggestions,description:r.localize(111,null)},"editor.suggest.showIcons":{type:"boolean",default:Q.showIcons,description:r.localize(112,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Q.showStatusBar,description:r.localize(113,null)},"editor.suggest.preview":{type:"boolean",default:Q.preview,description:r.localize(114,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Q.showInlineDetails,description:r.localize(115,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:r.localize(116,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:r.localize(117,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:r.localize(118,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:r.localize(119,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:r.localize(120,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:r.localize(121,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:r.localize(122,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:r.localize(123,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:r.localize(124,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:r.localize(125,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:r.localize(126,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:r.localize(127,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:r.localize(128,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:r.localize(129,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:r.localize(130,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:r.localize(131,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:r.localize(132,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:r.localize(133,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:r.localize(134,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:r.localize(135,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:r.localize(136,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:r.localize(137,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:r.localize(138,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:r.localize(139,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:r.localize(140,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:r.localize(141,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:r.localize(142,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:r.localize(143,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:r.localize(144,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:r.localize(145,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:r.localize(146,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{insertMode:C(he.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:o(he.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:o(he.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:o(he.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:o(he.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:o(he.showIcons,this.defaultValue.showIcons),showStatusBar:o(he.showStatusBar,this.defaultValue.showStatusBar),preview:o(he.preview,this.defaultValue.preview),previewMode:C(he.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:o(he.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:o(he.showMethods,this.defaultValue.showMethods),showFunctions:o(he.showFunctions,this.defaultValue.showFunctions),showConstructors:o(he.showConstructors,this.defaultValue.showConstructors),showDeprecated:o(he.showDeprecated,this.defaultValue.showDeprecated),showFields:o(he.showFields,this.defaultValue.showFields),showVariables:o(he.showVariables,this.defaultValue.showVariables),showClasses:o(he.showClasses,this.defaultValue.showClasses),showStructs:o(he.showStructs,this.defaultValue.showStructs),showInterfaces:o(he.showInterfaces,this.defaultValue.showInterfaces),showModules:o(he.showModules,this.defaultValue.showModules),showProperties:o(he.showProperties,this.defaultValue.showProperties),showEvents:o(he.showEvents,this.defaultValue.showEvents),showOperators:o(he.showOperators,this.defaultValue.showOperators),showUnits:o(he.showUnits,this.defaultValue.showUnits),showValues:o(he.showValues,this.defaultValue.showValues),showConstants:o(he.showConstants,this.defaultValue.showConstants),showEnums:o(he.showEnums,this.defaultValue.showEnums),showEnumMembers:o(he.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:o(he.showKeywords,this.defaultValue.showKeywords),showWords:o(he.showWords,this.defaultValue.showWords),showColors:o(he.showColors,this.defaultValue.showColors),showFiles:o(he.showFiles,this.defaultValue.showFiles),showReferences:o(he.showReferences,this.defaultValue.showReferences),showFolders:o(he.showFolders,this.defaultValue.showFolders),showTypeParameters:o(he.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:o(he.showSnippets,this.defaultValue.showSnippets),showUsers:o(he.showUsers,this.defaultValue.showUsers),showIssues:o(he.showIssues,this.defaultValue.showIssues)}}}class Ue extends R{constructor(){super(102,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:r.localize(147,null),default:!0,type:"boolean"}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:o(Q.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class je extends f{constructor(){super(130)}compute(Q,he,Be){return he.get(81)?!0:Q.tabFocusMode}}var Qe;(function(q){q[q.None=0]="None",q[q.Same=1]="Same",q[q.Indent=2]="Indent",q[q.DeepIndent=3]="DeepIndent"})(Qe=e.WrappingIndent||(e.WrappingIndent={}));function rt(q){switch(q){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class ot extends f{constructor(){super(132)}compute(Q,he,Be){const qe=he.get(131);return{isDominatedByLongLines:Q.isDominatedByLongLines,isWordWrapMinified:qe.isWordWrapMinified,isViewportWrapping:qe.isViewportWrapping,wrappingColumn:qe.wrappingColumn}}}const Je="Consolas, 'Courier New', monospace",tt="Menlo, Monaco, 'Courier New', monospace",pt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:t.isMacintosh?tt:t.isLinux?pt:Je,fontWeight:"normal",fontSize:t.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!1}},e.editorOptionsRegistry=[];function Me(q){return e.editorOptionsRegistry[q.id]=q,q}var At;(function(q){q[q.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",q[q.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",q[q.accessibilitySupport=2]="accessibilitySupport",q[q.accessibilityPageSize=3]="accessibilityPageSize",q[q.ariaLabel=4]="ariaLabel",q[q.autoClosingBrackets=5]="autoClosingBrackets",q[q.autoClosingDelete=6]="autoClosingDelete",q[q.autoClosingOvertype=7]="autoClosingOvertype",q[q.autoClosingQuotes=8]="autoClosingQuotes",q[q.autoIndent=9]="autoIndent",q[q.automaticLayout=10]="automaticLayout",q[q.autoSurround=11]="autoSurround",q[q.bracketPairColorization=12]="bracketPairColorization",q[q.guides=13]="guides",q[q.codeLens=14]="codeLens",q[q.codeLensFontFamily=15]="codeLensFontFamily",q[q.codeLensFontSize=16]="codeLensFontSize",q[q.colorDecorators=17]="colorDecorators",q[q.columnSelection=18]="columnSelection",q[q.comments=19]="comments",q[q.contextmenu=20]="contextmenu",q[q.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",q[q.cursorBlinking=22]="cursorBlinking",q[q.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",q[q.cursorStyle=24]="cursorStyle",q[q.cursorSurroundingLines=25]="cursorSurroundingLines",q[q.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",q[q.cursorWidth=27]="cursorWidth",q[q.disableLayerHinting=28]="disableLayerHinting",q[q.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",q[q.domReadOnly=30]="domReadOnly",q[q.dragAndDrop=31]="dragAndDrop",q[q.emptySelectionClipboard=32]="emptySelectionClipboard",q[q.extraEditorClassName=33]="extraEditorClassName",q[q.fastScrollSensitivity=34]="fastScrollSensitivity",q[q.find=35]="find",q[q.fixedOverflowWidgets=36]="fixedOverflowWidgets",q[q.folding=37]="folding",q[q.foldingStrategy=38]="foldingStrategy",q[q.foldingHighlight=39]="foldingHighlight",q[q.foldingImportsByDefault=40]="foldingImportsByDefault",q[q.foldingMaximumRegions=41]="foldingMaximumRegions",q[q.unfoldOnClickAfterEndOfLine=42]="unfoldOnClickAfterEndOfLine",q[q.fontFamily=43]="fontFamily",q[q.fontInfo=44]="fontInfo",q[q.fontLigatures=45]="fontLigatures",q[q.fontSize=46]="fontSize",q[q.fontWeight=47]="fontWeight",q[q.formatOnPaste=48]="formatOnPaste",q[q.formatOnType=49]="formatOnType",q[q.glyphMargin=50]="glyphMargin",q[q.gotoLocation=51]="gotoLocation",q[q.hideCursorInOverviewRuler=52]="hideCursorInOverviewRuler",q[q.hover=53]="hover",q[q.inDiffEditor=54]="inDiffEditor",q[q.inlineSuggest=55]="inlineSuggest",q[q.letterSpacing=56]="letterSpacing",q[q.lightbulb=57]="lightbulb",q[q.lineDecorationsWidth=58]="lineDecorationsWidth",q[q.lineHeight=59]="lineHeight",q[q.lineNumbers=60]="lineNumbers",q[q.lineNumbersMinChars=61]="lineNumbersMinChars",q[q.linkedEditing=62]="linkedEditing",q[q.links=63]="links",q[q.matchBrackets=64]="matchBrackets",q[q.minimap=65]="minimap",q[q.mouseStyle=66]="mouseStyle",q[q.mouseWheelScrollSensitivity=67]="mouseWheelScrollSensitivity",q[q.mouseWheelZoom=68]="mouseWheelZoom",q[q.multiCursorMergeOverlapping=69]="multiCursorMergeOverlapping",q[q.multiCursorModifier=70]="multiCursorModifier",q[q.multiCursorPaste=71]="multiCursorPaste",q[q.occurrencesHighlight=72]="occurrencesHighlight",q[q.overviewRulerBorder=73]="overviewRulerBorder",q[q.overviewRulerLanes=74]="overviewRulerLanes",q[q.padding=75]="padding",q[q.parameterHints=76]="parameterHints",q[q.peekWidgetDefaultFocus=77]="peekWidgetDefaultFocus",q[q.definitionLinkOpensInPeek=78]="definitionLinkOpensInPeek",q[q.quickSuggestions=79]="quickSuggestions",q[q.quickSuggestionsDelay=80]="quickSuggestionsDelay",q[q.readOnly=81]="readOnly",q[q.renameOnType=82]="renameOnType",q[q.renderControlCharacters=83]="renderControlCharacters",q[q.renderFinalNewline=84]="renderFinalNewline",q[q.renderLineHighlight=85]="renderLineHighlight",q[q.renderLineHighlightOnlyWhenFocus=86]="renderLineHighlightOnlyWhenFocus",q[q.renderValidationDecorations=87]="renderValidationDecorations",q[q.renderWhitespace=88]="renderWhitespace",q[q.revealHorizontalRightPadding=89]="revealHorizontalRightPadding",q[q.roundedSelection=90]="roundedSelection",q[q.rulers=91]="rulers",q[q.scrollbar=92]="scrollbar",q[q.scrollBeyondLastColumn=93]="scrollBeyondLastColumn",q[q.scrollBeyondLastLine=94]="scrollBeyondLastLine",q[q.scrollPredominantAxis=95]="scrollPredominantAxis",q[q.selectionClipboard=96]="selectionClipboard",q[q.selectionHighlight=97]="selectionHighlight",q[q.selectOnLineNumbers=98]="selectOnLineNumbers",q[q.showFoldingControls=99]="showFoldingControls",q[q.showUnused=100]="showUnused",q[q.snippetSuggestions=101]="snippetSuggestions",q[q.smartSelect=102]="smartSelect",q[q.smoothScrolling=103]="smoothScrolling",q[q.stickyTabStops=104]="stickyTabStops",q[q.stopRenderingLineAfter=105]="stopRenderingLineAfter",q[q.suggest=106]="suggest",q[q.suggestFontSize=107]="suggestFontSize",q[q.suggestLineHeight=108]="suggestLineHeight",q[q.suggestOnTriggerCharacters=109]="suggestOnTriggerCharacters",q[q.suggestSelection=110]="suggestSelection",q[q.tabCompletion=111]="tabCompletion",q[q.tabIndex=112]="tabIndex",q[q.unicodeHighlighting=113]="unicodeHighlighting",q[q.unusualLineTerminators=114]="unusualLineTerminators",q[q.useShadowDOM=115]="useShadowDOM",q[q.useTabStops=116]="useTabStops",q[q.wordSeparators=117]="wordSeparators",q[q.wordWrap=118]="wordWrap",q[q.wordWrapBreakAfterCharacters=119]="wordWrapBreakAfterCharacters",q[q.wordWrapBreakBeforeCharacters=120]="wordWrapBreakBeforeCharacters",q[q.wordWrapColumn=121]="wordWrapColumn",q[q.wordWrapOverride1=122]="wordWrapOverride1",q[q.wordWrapOverride2=123]="wordWrapOverride2",q[q.wrappingIndent=124]="wrappingIndent",q[q.wrappingStrategy=125]="wrappingStrategy",q[q.showDeprecated=126]="showDeprecated",q[q.inlayHints=127]="inlayHints",q[q.editorClassName=128]="editorClassName",q[q.pixelRatio=129]="pixelRatio",q[q.tabFocusMode=130]="tabFocusMode",q[q.layoutInfo=131]="layoutInfo",q[q.wrappingInfo=132]="wrappingInfo"})(At=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Me(new m(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:r.localize(148,null)})),acceptSuggestionOnEnter:Me(new l(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",r.localize(149,null),""],markdownDescription:r.localize(150,null)})),accessibilitySupport:Me(new n),accessibilityPageSize:Me(new y(3,"accessibilityPageSize",10,1,1073741824,{description:r.localize(151,null)})),ariaLabel:Me(new u(4,"ariaLabel",r.localize(152,null))),autoClosingBrackets:Me(new l(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",r.localize(153,null),r.localize(154,null),""],description:r.localize(155,null)})),autoClosingDelete:Me(new l(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",r.localize(156,null),""],description:r.localize(157,null)})),autoClosingOvertype:Me(new l(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",r.localize(158,null),""],description:r.localize(159,null)})),autoClosingQuotes:Me(new l(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",r.localize(160,null),r.localize(161,null),""],description:r.localize(162,null)})),autoIndent:Me(new F(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],c,{enumDescriptions:[r.localize(163,null),r.localize(164,null),r.localize(165,null),r.localize(166,null),r.localize(167,null)],description:r.localize(168,null)})),automaticLayout:Me(new m(10,"automaticLayout",!1)),autoSurround:Me(new l(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[r.localize(169,null),r.localize(170,null),r.localize(171,null),""],description:r.localize(172,null)})),bracketPairColorization:Me(new V),bracketPairGuides:Me(new Y),stickyTabStops:Me(new m(104,"stickyTabStops",!1,{description:r.localize(173,null)})),codeLens:Me(new m(14,"codeLens",!0,{description:r.localize(174,null)})),codeLensFontFamily:Me(new u(15,"codeLensFontFamily","",{description:r.localize(175,null)})),codeLensFontSize:Me(new y(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:r.localize(176,null)})),colorDecorators:Me(new m(17,"colorDecorators",!0,{description:r.localize(177,null)})),columnSelection:Me(new m(18,"columnSelection",!1,{description:r.localize(178,null)})),comments:Me(new h),contextmenu:Me(new m(20,"contextmenu",!0)),copyWithSyntaxHighlighting:Me(new m(21,"copyWithSyntaxHighlighting",!0,{description:r.localize(179,null)})),cursorBlinking:Me(new F(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],s,{description:r.localize(180,null)})),cursorSmoothCaretAnimation:Me(new m(23,"cursorSmoothCaretAnimation",!1,{description:r.localize(181,null)})),cursorStyle:Me(new F(24,"cursorStyle",d.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],w,{description:r.localize(182,null)})),cursorSurroundingLines:Me(new y(25,"cursorSurroundingLines",0,0,1073741824,{description:r.localize(183,null)})),cursorSurroundingLinesStyle:Me(new l(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[r.localize(184,null),r.localize(185,null)],description:r.localize(186,null)})),cursorWidth:Me(new y(27,"cursorWidth",0,0,1073741824,{markdownDescription:r.localize(187,null)})),disableLayerHinting:Me(new m(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:Me(new m(29,"disableMonospaceOptimizations",!1)),domReadOnly:Me(new m(30,"domReadOnly",!1)),dragAndDrop:Me(new m(31,"dragAndDrop",!0,{description:r.localize(188,null)})),emptySelectionClipboard:Me(new k),extraEditorClassName:Me(new u(33,"extraEditorClassName","")),fastScrollSensitivity:Me(new _(34,"fastScrollSensitivity",5,q=>q<=0?5:q,{markdownDescription:r.localize(189,null)})),find:Me(new L),fixedOverflowWidgets:Me(new m(36,"fixedOverflowWidgets",!1)),folding:Me(new m(37,"folding",!0,{description:r.localize(190,null)})),foldingStrategy:Me(new l(38,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[r.localize(191,null),r.localize(192,null)],description:r.localize(193,null)})),foldingHighlight:Me(new m(39,"foldingHighlight",!0,{description:r.localize(194,null)})),foldingImportsByDefault:Me(new m(40,"foldingImportsByDefault",!1,{description:r.localize(195,null)})),foldingMaximumRegions:Me(new y(41,"foldingMaximumRegions",5e3,10,65e3,{description:r.localize(196,null)})),unfoldOnClickAfterEndOfLine:Me(new m(42,"unfoldOnClickAfterEndOfLine",!1,{description:r.localize(197,null)})),fontFamily:Me(new u(43,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:r.localize(198,null)})),fontInfo:Me(new O),fontLigatures2:Me(new E),fontSize:Me(new U),fontWeight:Me(new j),formatOnPaste:Me(new m(48,"formatOnPaste",!1,{description:r.localize(199,null)})),formatOnType:Me(new m(49,"formatOnType",!1,{description:r.localize(200,null)})),glyphMargin:Me(new m(50,"glyphMargin",!0,{description:r.localize(201,null)})),gotoLocation:Me(new H),hideCursorInOverviewRuler:Me(new m(52,"hideCursorInOverviewRuler",!1,{description:r.localize(202,null)})),hover:Me(new $),inDiffEditor:Me(new m(54,"inDiffEditor",!1)),letterSpacing:Me(new _(56,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,q=>_.clamp(q,-5,20),{description:r.localize(203,null)})),lightbulb:Me(new le),lineDecorationsWidth:Me(new a(58,"lineDecorationsWidth",10)),lineHeight:Me(new ue),lineNumbers:Me(new ze),lineNumbersMinChars:Me(new y(61,"lineNumbersMinChars",5,1,300)),linkedEditing:Me(new m(62,"linkedEditing",!1,{description:r.localize(204,null)})),links:Me(new m(63,"links",!0,{description:r.localize(205,null)})),matchBrackets:Me(new l(64,"matchBrackets","always",["always","near","never"],{description:r.localize(206,null)})),minimap:Me(new ve),mouseStyle:Me(new l(66,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Me(new _(67,"mouseWheelScrollSensitivity",1,q=>q===0?1:q,{markdownDescription:r.localize(207,null)})),mouseWheelZoom:Me(new m(68,"mouseWheelZoom",!1,{markdownDescription:r.localize(208,null)})),multiCursorMergeOverlapping:Me(new m(69,"multiCursorMergeOverlapping",!0,{description:r.localize(209,null)})),multiCursorModifier:Me(new F(70,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],ge,{markdownEnumDescriptions:[r.localize(210,null),r.localize(211,null)],markdownDescription:r.localize(212,null)})),multiCursorPaste:Me(new l(71,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[r.localize(213,null),r.localize(214,null)],markdownDescription:r.localize(215,null)})),occurrencesHighlight:Me(new m(72,"occurrencesHighlight",!0,{description:r.localize(216,null)})),overviewRulerBorder:Me(new m(73,"overviewRulerBorder",!0,{description:r.localize(217,null)})),overviewRulerLanes:Me(new y(74,"overviewRulerLanes",3,0,3)),padding:Me(new we),parameterHints:Me(new re),peekWidgetDefaultFocus:Me(new l(77,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[r.localize(218,null),r.localize(219,null)],description:r.localize(220,null)})),definitionLinkOpensInPeek:Me(new m(78,"definitionLinkOpensInPeek",!1,{description:r.localize(221,null)})),quickSuggestions:Me(new Pe),quickSuggestionsDelay:Me(new y(80,"quickSuggestionsDelay",10,0,1073741824,{description:r.localize(222,null)})),readOnly:Me(new m(81,"readOnly",!1)),renameOnType:Me(new m(82,"renameOnType",!1,{description:r.localize(223,null),markdownDeprecationMessage:r.localize(224,null)})),renderControlCharacters:Me(new m(83,"renderControlCharacters",!0,{description:r.localize(225,null),restricted:!0})),renderFinalNewline:Me(new m(84,"renderFinalNewline",!0,{description:r.localize(226,null)})),renderLineHighlight:Me(new l(85,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",r.localize(227,null)],description:r.localize(228,null)})),renderLineHighlightOnlyWhenFocus:Me(new m(86,"renderLineHighlightOnlyWhenFocus",!1,{description:r.localize(229,null)})),renderValidationDecorations:Me(new l(87,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Me(new l(88,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",r.localize(230,null),r.localize(231,null),r.localize(232,null),""],description:r.localize(233,null)})),revealHorizontalRightPadding:Me(new y(89,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:Me(new m(90,"roundedSelection",!0,{description:r.localize(234,null)})),rulers:Me(new et),scrollbar:Me(new x),scrollBeyondLastColumn:Me(new y(93,"scrollBeyondLastColumn",5,0,1073741824,{description:r.localize(235,null)})),scrollBeyondLastLine:Me(new m(94,"scrollBeyondLastLine",!0,{description:r.localize(236,null)})),scrollPredominantAxis:Me(new m(95,"scrollPredominantAxis",!0,{description:r.localize(237,null)})),selectionClipboard:Me(new m(96,"selectionClipboard",!0,{description:r.localize(238,null),included:t.isLinux})),selectionHighlight:Me(new m(97,"selectionHighlight",!0,{description:r.localize(239,null)})),selectOnLineNumbers:Me(new m(98,"selectOnLineNumbers",!0)),showFoldingControls:Me(new l(99,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[r.localize(240,null),r.localize(241,null)],description:r.localize(242,null)})),showUnused:Me(new m(100,"showUnused",!0,{description:r.localize(243,null)})),showDeprecated:Me(new m(126,"showDeprecated",!0,{description:r.localize(244,null)})),inlayHints:Me(new X),snippetSuggestions:Me(new l(101,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[r.localize(245,null),r.localize(246,null),r.localize(247,null),r.localize(248,null)],description:r.localize(249,null)})),smartSelect:Me(new Ue),smoothScrolling:Me(new m(103,"smoothScrolling",!1,{description:r.localize(250,null)})),stopRenderingLineAfter:Me(new y(105,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Me(new ye),inlineSuggest:Me(new z),suggestFontSize:Me(new y(107,"suggestFontSize",0,0,1e3,{markdownDescription:r.localize(251,null)})),suggestLineHeight:Me(new y(108,"suggestLineHeight",0,0,1e3,{markdownDescription:r.localize(252,null)})),suggestOnTriggerCharacters:Me(new m(109,"suggestOnTriggerCharacters",!0,{description:r.localize(253,null)})),suggestSelection:Me(new l(110,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[r.localize(254,null),r.localize(255,null),r.localize(256,null)],description:r.localize(257,null)})),tabCompletion:Me(new l(111,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[r.localize(258,null),r.localize(259,null),r.localize(260,null)],description:r.localize(261,null)})),tabIndex:Me(new y(112,"tabIndex",0,-1,1073741824)),unicodeHighlight:Me(new K),unusualLineTerminators:Me(new l(114,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[r.localize(262,null),r.localize(263,null),r.localize(264,null)],description:r.localize(265,null)})),useShadowDOM:Me(new m(115,"useShadowDOM",!0)),useTabStops:Me(new m(116,"useTabStops",!0,{description:r.localize(266,null)})),wordSeparators:Me(new u(117,"wordSeparators",S.USUAL_WORD_SEPARATORS,{description:r.localize(267,null)})),wordWrap:Me(new l(118,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[r.localize(268,null),r.localize(269,null),r.localize(270,null),r.localize(271,null)],description:r.localize(272,null)})),wordWrapBreakAfterCharacters:Me(new u(119,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Me(new u(120,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Me(new y(121,"wordWrapColumn",80,1,1073741824,{markdownDescription:r.localize(273,null)})),wordWrapOverride1:Me(new l(122,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Me(new l(123,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:Me(new F(124,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],rt,{enumDescriptions:[r.localize(274,null),r.localize(275,null),r.localize(276,null),r.localize(277,null)],description:r.localize(278,null)})),wrappingStrategy:Me(new l(125,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[r.localize(279,null),r.localize(280,null)],description:r.localize(281,null)})),editorClassName:Me(new v),pixelRatio:Me(new be),tabFocusMode:Me(new je),layoutInfo:Me(new ie),wrappingInfo:Me(new ot)}}),define(Se[114],_e([18,19]),function(ee,e){return ee.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Se[115],_e([18,19]),function(ee,e){return ee.create("vs/platform/extensions/common/extensionValidator",e)}),define(Se[116],_e([18,19]),function(ee,e){return ee.create("vs/platform/files/common/files",e)}),define(Se[117],_e([18,19]),function(ee,e){return ee.create("vs/platform/markers/common/markers",e)}),define(Se[118],_e([18,19]),function(ee,e){return ee.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Se[119],_e([18,19]),function(ee,e){return ee.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Se[120],_e([18,19]),function(ee,e){return ee.create("vs/workbench/api/common/extHostProgress",e)}),define(Se[121],_e([18,19]),function(ee,e){return ee.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Se[122],_e([18,19]),function(ee,e){return ee.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Se[123],_e([18,19]),function(ee,e){return ee.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Se[124],_e([18,19]),function(ee,e){return ee.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Se[125],_e([18,19]),function(ee,e){return ee.create("vs/workbench/common/editor",e)}),define(Se[126],_e([18,19]),function(ee,e){return ee.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Se[127],_e([18,19]),function(ee,e){return ee.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(Se[128],_e([18,19]),function(ee,e){return ee.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(Se[129],_e([18,19]),function(ee,e){return ee.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Se[130],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var r;(function(A){A[A.ACTIVATE=1]="ACTIVATE",A[A.RESTORE=2]="RESTORE",A[A.PRESERVE=3]="PRESERVE"})(r=e.EditorActivation||(e.EditorActivation={}));var t;(function(A){A[A.PICK=0]="PICK",A[A.DISABLED=1]="DISABLED",A[A.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(t=e.EditorResolution||(e.EditorResolution={}));var S;(function(A){A[A.API=0]="API",A[A.USER=1]="USER"})(S=e.EditorOpenContext||(e.EditorOpenContext={}));var P;(function(A){A[A.Center=0]="Center",A[A.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",A[A.NearTop=2]="NearTop",A[A.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(P=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(Se[131],_e([0,1,115]),function(ee,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const t=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,S=/^-(\d{4})(\d{2})(\d{2})$/;function P(i){return i=i.trim(),i==="*"||t.test(i)}e.isValidVersionStr=P;function A(i){if(!P(i))return null;if(i=i.trim(),i==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let f=i.match(t);return f?{hasCaret:f[1]==="^",hasGreaterEquals:f[1]===">=",majorBase:f[2]==="x"?0:parseInt(f[2],10),majorMustEqual:f[2]!=="x",minorBase:f[4]==="x"?0:parseInt(f[4],10),minorMustEqual:f[4]!=="x",patchBase:f[6]==="x"?0:parseInt(f[6],10),patchMustEqual:f[6]!=="x",preRelease:f[8]||null}:null}e.parseVersion=A;function I(i){if(!i)return null;let f=i.majorBase,a=i.majorMustEqual,o=i.minorBase,m=i.minorMustEqual,M=i.patchBase,y=i.patchMustEqual;i.hasCaret&&(f===0||(m=!1),y=!1);let _=0;if(i.preRelease){const u=S.exec(i.preRelease);if(u){const[,C,l,F]=u;_=Date.UTC(Number(C),Number(l)-1,Number(F))}}return{majorBase:f,majorMustEqual:a,minorBase:o,minorMustEqual:m,patchBase:M,patchMustEqual:y,isMinimum:i.hasGreaterEquals,notBefore:_}}e.normalizeVersion=I;function D(i,f,a){let o;typeof i=="string"?o=I(A(i)):o=i;let m;f instanceof Date?m=f.getTime():typeof f=="string"&&(m=new Date(f).getTime());let M;if(typeof a=="string"?M=I(A(a)):M=a,!o||!M)return!1;let y=o.majorBase,_=o.minorBase,u=o.patchBase,C=M.majorBase,l=M.minorBase,F=M.patchBase,c=M.notBefore,n=M.majorMustEqual,h=M.minorMustEqual,g=M.patchMustEqual;return M.isMinimum?y>C?!0:y<C?!1:_>l?!0:_<l||m&&m<c?!1:u>=F:(y===1&&C===0&&(!n||!h||!g)&&(C=1,l=0,F=0,n=!0,h=!1,g=!1),y<C?!1:y>C?!n:_<l?!1:_>l?!h:u<F?!1:u>F?!g:!(m&&m<c))}e.isValidVersion=D;function T(i,f,a,o){return a.isBuiltin||typeof a.main=="undefined"?!0:b(i,f,a.engines.vscode,o)}e.isValidExtensionVersion=T;function R(i,f,a){return i==="*"||b(f,a,i)}e.isEngineValid=R;function b(i,f,a,o=[]){let m=I(A(a));if(!m)return o.push(r.localize(0,null,a)),!1;if(m.majorBase===0){if(!m.majorMustEqual||!m.minorMustEqual)return o.push(r.localize(1,null,a)),!1}else if(!m.majorMustEqual)return o.push(r.localize(2,null,a)),!1;return D(i,f,m)?!0:(o.push(r.localize(3,null,i,a)),!1)}}),define(Se[78],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class r{constructor(S,P=[],A=!1){this.ctor=S,this.staticArguments=P,this.supportsDelayedInstantiation=A}}e.SyncDescriptor=r}),define(Se[44],_e([0,1,78]),function(ee,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const t=[];function S(A,I,D){I instanceof r.SyncDescriptor||(I=new r.SyncDescriptor(I,[],D)),t.push([A,I])}e.registerSingleton=S;function P(){return t}e.getSingletonServiceDescriptors=P}),define(Se[132],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class r{constructor(P){this.incoming=new Map,this.outgoing=new Map,this.data=P}}e.Node=r;class t{constructor(P){this._hashFn=P,this._nodes=new Map}roots(){const P=[];for(let A of this._nodes.values())A.outgoing.size===0&&P.push(A);return P}insertEdge(P,A){const I=this.lookupOrInsertNode(P),D=this.lookupOrInsertNode(A);I.outgoing.set(this._hashFn(A),D),D.incoming.set(this._hashFn(P),I)}removeNode(P){const A=this._hashFn(P);this._nodes.delete(A);for(let I of this._nodes.values())I.outgoing.delete(A),I.incoming.delete(A)}lookupOrInsertNode(P){const A=this._hashFn(P);let I=this._nodes.get(A);return I||(I=new r(P),this._nodes.set(A,I)),I}lookup(P){return this._nodes.get(this._hashFn(P))}isEmpty(){return this._nodes.size===0}toString(){let P=[];for(let[A,I]of this._nodes)P.push(`${A}, (incoming)[${[...I.incoming.keys()].join(", ")}], (outgoing)[${[...I.outgoing.keys()].join(",")}]`);return P.join(`
`)}findCycleSlow(){for(let[P,A]of this._nodes){const I=new Set([P]),D=this._findCycle(A,I);if(D)return D}}_findCycle(P,A){for(let[I,D]of P.outgoing){if(A.has(I))return[...A,I].join(" -> ");A.add(I);const T=this._findCycle(D,A);if(T)return T;A.delete(I)}}}e.Graph=t}),define(Se[3],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var r;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function I(D){return D[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=I})(r=e._util||(e._util={})),e.IInstantiationService=S("instantiationService");function t(A,I,D,T){I[r.DI_TARGET]===I?I[r.DI_DEPENDENCIES].push({id:A,index:D,optional:T}):(I[r.DI_DEPENDENCIES]=[{id:A,index:D,optional:T}],I[r.DI_TARGET]=I)}function S(A){if(r.serviceIds.has(A))return r.serviceIds.get(A);const I=function(D,T,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(I,D,R,!1)};return I.toString=()=>A,r.serviceIds.set(A,I),I}e.createDecorator=S;function P(A){return A}e.refineServiceDecorator=P}),define(Se[133],_e([0,1,3]),function(ee,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,r.createDecorator)("modelService");function t(S){return!S.isTooLargeForSyncing()&&!S.isForSimpleWidget}e.shouldSynchronizeModel=t}),define(Se[134],_e([0,1,4,6,56,133]),function(ee,e,r,t,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRegistry=void 0;function A(D){return typeof D=="string"?!1:Array.isArray(D)?D.every(A):!!D.exclusive}class I{constructor(){this._clock=0,this._entries=[],this._onDidChange=new r.Emitter}get onDidChange(){return this._onDidChange.event}register(T,R){let b={selector:T,provider:R,_score:-1,_time:this._clock++};return this._entries.push(b),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,t.toDisposable)(()=>{if(b){const i=this._entries.indexOf(b);i>=0&&(this._entries.splice(i,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),b=void 0)}})}has(T){return this.all(T).length>0}all(T){if(!T)return[];this._updateScores(T);const R=[];for(let b of this._entries)b._score>0&&R.push(b.provider);return R}ordered(T){const R=[];return this._orderedForEach(T,b=>R.push(b.provider)),R}orderedGroups(T){const R=[];let b,i;return this._orderedForEach(T,f=>{b&&i===f._score?b.push(f.provider):(i=f._score,b=[f.provider],R.push(b))}),R}_orderedForEach(T,R){if(!!T){this._updateScores(T);for(const b of this._entries)b._score>0&&R(b)}}_updateScores(T){const R={uri:T.uri.toString(),language:T.getLanguageId()};if(!(this._lastCandidate&&this._lastCandidate.language===R.language&&this._lastCandidate.uri===R.uri)){this._lastCandidate=R;for(let b of this._entries)if(b._score=(0,S.score)(b.selector,T.uri,T.getLanguageId(),(0,P.shouldSynchronizeModel)(T)),A(b.selector)&&b._score>0){for(let i of this._entries)i._score=0;b._score=1e3;break}this._entries.sort(I._compareByScoreAndTime)}}static _compareByScoreAndTime(T,R){return T._score<R._score?1:T._score>R._score?-1:T._time<R._time?1:T._time>R._time?-1:0}}e.LanguageFeatureRegistry=I}),define(Se[57],_e([0,1,2,58,134,107,52]),function(ee,e,r,t,S,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.Command=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var I;(function(v){v[v.Null=0]="Null",v[v.PlainText=1]="PlainText"})(I=e.LanguageId||(e.LanguageId={}));var D;(function(v){v[v.NotSet=-1]="NotSet",v[v.None=0]="None",v[v.Italic=1]="Italic",v[v.Bold=2]="Bold",v[v.Underline=4]="Underline",v[v.Strikethrough=8]="Strikethrough"})(D=e.FontStyle||(e.FontStyle={}));var T;(function(v){v[v.None=0]="None",v[v.DefaultForeground=1]="DefaultForeground",v[v.DefaultBackground=2]="DefaultBackground"})(T=e.ColorId||(e.ColorId={}));var R;(function(v){v[v.Other=0]="Other",v[v.Comment=1]="Comment",v[v.String=2]="String",v[v.RegEx=3]="RegEx"})(R=e.StandardTokenType||(e.StandardTokenType={}));var b;(function(v){v[v.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",v[v.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",v[v.FONT_STYLE_MASK=15360]="FONT_STYLE_MASK",v[v.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",v[v.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",v[v.ITALIC_MASK=1024]="ITALIC_MASK",v[v.BOLD_MASK=2048]="BOLD_MASK",v[v.UNDERLINE_MASK=4096]="UNDERLINE_MASK",v[v.STRIKETHROUGH_MASK=8192]="STRIKETHROUGH_MASK",v[v.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",v[v.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",v[v.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",v[v.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",v[v.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",v[v.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",v[v.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",v[v.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",v[v.FONT_STYLE_OFFSET=10]="FONT_STYLE_OFFSET",v[v.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",v[v.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(b=e.MetadataConsts||(e.MetadataConsts={}));class i{static getLanguageId(k){return(k&255)>>>0}static getTokenType(k){return(k&768)>>>8}static getFontStyle(k){return(k&15360)>>>10}static getForeground(k){return(k&8372224)>>>14}static getBackground(k){return(k&4286578688)>>>23}static getClassNameFromMetadata(k){const L=this.getForeground(k);let E="mtk"+L;const O=this.getFontStyle(k);return O&1&&(E+=" mtki"),O&2&&(E+=" mtkb"),O&4&&(E+=" mtku"),O&8&&(E+=" mtks"),E}static getInlineStyleFromMetadata(k,L){const E=this.getForeground(k),O=this.getFontStyle(k);let U=`color: ${L[E]};`;O&1&&(U+="font-style: italic;"),O&2&&(U+="font-weight: bold;");let j="";return O&4&&(j+=" underline"),O&8&&(j+=" line-through"),j&&(U+=`text-decoration:${j};`),U}static getPresentationFromMetadata(k){const L=this.getForeground(k),E=this.getFontStyle(k);return{foreground:L,italic:Boolean(E&1),bold:Boolean(E&2),underline:Boolean(E&4),strikethrough:Boolean(E&8)}}}e.TokenMetadata=i;var f;(function(v){v[v.Method=0]="Method",v[v.Function=1]="Function",v[v.Constructor=2]="Constructor",v[v.Field=3]="Field",v[v.Variable=4]="Variable",v[v.Class=5]="Class",v[v.Struct=6]="Struct",v[v.Interface=7]="Interface",v[v.Module=8]="Module",v[v.Property=9]="Property",v[v.Event=10]="Event",v[v.Operator=11]="Operator",v[v.Unit=12]="Unit",v[v.Value=13]="Value",v[v.Constant=14]="Constant",v[v.Enum=15]="Enum",v[v.EnumMember=16]="EnumMember",v[v.Keyword=17]="Keyword",v[v.Text=18]="Text",v[v.Color=19]="Color",v[v.File=20]="File",v[v.Reference=21]="Reference",v[v.Customcolor=22]="Customcolor",v[v.Folder=23]="Folder",v[v.TypeParameter=24]="TypeParameter",v[v.User=25]="User",v[v.Issue=26]="Issue",v[v.Snippet=27]="Snippet"})(f=e.CompletionItemKind||(e.CompletionItemKind={}));var a;(function(v){const k=new Map;k.set(0,A.Codicon.symbolMethod),k.set(1,A.Codicon.symbolFunction),k.set(2,A.Codicon.symbolConstructor),k.set(3,A.Codicon.symbolField),k.set(4,A.Codicon.symbolVariable),k.set(5,A.Codicon.symbolClass),k.set(6,A.Codicon.symbolStruct),k.set(7,A.Codicon.symbolInterface),k.set(8,A.Codicon.symbolModule),k.set(9,A.Codicon.symbolProperty),k.set(10,A.Codicon.symbolEvent),k.set(11,A.Codicon.symbolOperator),k.set(12,A.Codicon.symbolUnit),k.set(13,A.Codicon.symbolValue),k.set(15,A.Codicon.symbolEnum),k.set(14,A.Codicon.symbolConstant),k.set(15,A.Codicon.symbolEnum),k.set(16,A.Codicon.symbolEnumMember),k.set(17,A.Codicon.symbolKeyword),k.set(27,A.Codicon.symbolSnippet),k.set(18,A.Codicon.symbolText),k.set(19,A.Codicon.symbolColor),k.set(20,A.Codicon.symbolFile),k.set(21,A.Codicon.symbolReference),k.set(22,A.Codicon.symbolCustomColor),k.set(23,A.Codicon.symbolFolder),k.set(24,A.Codicon.symbolTypeParameter),k.set(25,A.Codicon.account),k.set(26,A.Codicon.issues);function L(U){let j=k.get(U);return j||(console.info("No codicon found for CompletionItemKind "+U),j=A.Codicon.symbolProperty),j}v.toIcon=L;const E=new Map;E.set("method",0),E.set("function",1),E.set("constructor",2),E.set("field",3),E.set("variable",4),E.set("class",5),E.set("struct",6),E.set("interface",7),E.set("module",8),E.set("property",9),E.set("event",10),E.set("operator",11),E.set("unit",12),E.set("value",13),E.set("constant",14),E.set("enum",15),E.set("enum-member",16),E.set("enumMember",16),E.set("keyword",17),E.set("snippet",27),E.set("text",18),E.set("color",19),E.set("file",20),E.set("reference",21),E.set("customcolor",22),E.set("folder",23),E.set("type-parameter",24),E.set("typeParameter",24),E.set("account",25),E.set("issue",26);function O(U,j){let H=E.get(U);return typeof H=="undefined"&&!j&&(H=9),H}v.fromString=O})(a=e.CompletionItemKinds||(e.CompletionItemKinds={}));var o;(function(v){v[v.Deprecated=1]="Deprecated"})(o=e.CompletionItemTag||(e.CompletionItemTag={}));var m;(function(v){v[v.KeepWhitespace=1]="KeepWhitespace",v[v.InsertAsSnippet=4]="InsertAsSnippet"})(m=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var M;(function(v){v[v.Invoke=0]="Invoke",v[v.TriggerCharacter=1]="TriggerCharacter",v[v.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(M=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var y;(function(v){v[v.Automatic=0]="Automatic",v[v.Explicit=1]="Explicit"})(y=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var _;(function(v){v[v.Invoke=1]="Invoke",v[v.Auto=2]="Auto"})(_=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var u;(function(v){v[v.Invoke=1]="Invoke",v[v.TriggerCharacter=2]="TriggerCharacter",v[v.ContentChange=3]="ContentChange"})(u=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var C;(function(v){v[v.Text=0]="Text",v[v.Read=1]="Read",v[v.Write=2]="Write"})(C=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function l(v){return v&&r.URI.isUri(v.uri)&&t.Range.isIRange(v.range)&&(t.Range.isIRange(v.originSelectionRange)||t.Range.isIRange(v.targetSelectionRange))}e.isLocationLink=l;var F;(function(v){v[v.File=0]="File",v[v.Module=1]="Module",v[v.Namespace=2]="Namespace",v[v.Package=3]="Package",v[v.Class=4]="Class",v[v.Method=5]="Method",v[v.Property=6]="Property",v[v.Field=7]="Field",v[v.Constructor=8]="Constructor",v[v.Enum=9]="Enum",v[v.Interface=10]="Interface",v[v.Function=11]="Function",v[v.Variable=12]="Variable",v[v.Constant=13]="Constant",v[v.String=14]="String",v[v.Number=15]="Number",v[v.Boolean=16]="Boolean",v[v.Array=17]="Array",v[v.Object=18]="Object",v[v.Key=19]="Key",v[v.Null=20]="Null",v[v.EnumMember=21]="EnumMember",v[v.Struct=22]="Struct",v[v.Event=23]="Event",v[v.Operator=24]="Operator",v[v.TypeParameter=25]="TypeParameter"})(F=e.SymbolKind||(e.SymbolKind={}));var c;(function(v){v[v.Deprecated=1]="Deprecated"})(c=e.SymbolTag||(e.SymbolTag={}));var n;(function(v){const k=new Map;k.set(0,A.Codicon.symbolFile),k.set(1,A.Codicon.symbolModule),k.set(2,A.Codicon.symbolNamespace),k.set(3,A.Codicon.symbolPackage),k.set(4,A.Codicon.symbolClass),k.set(5,A.Codicon.symbolMethod),k.set(6,A.Codicon.symbolProperty),k.set(7,A.Codicon.symbolField),k.set(8,A.Codicon.symbolConstructor),k.set(9,A.Codicon.symbolEnum),k.set(10,A.Codicon.symbolInterface),k.set(11,A.Codicon.symbolFunction),k.set(12,A.Codicon.symbolVariable),k.set(13,A.Codicon.symbolConstant),k.set(14,A.Codicon.symbolString),k.set(15,A.Codicon.symbolNumber),k.set(16,A.Codicon.symbolBoolean),k.set(17,A.Codicon.symbolArray),k.set(18,A.Codicon.symbolObject),k.set(19,A.Codicon.symbolKey),k.set(20,A.Codicon.symbolNull),k.set(21,A.Codicon.symbolEnumMember),k.set(22,A.Codicon.symbolStruct),k.set(23,A.Codicon.symbolEvent),k.set(24,A.Codicon.symbolOperator),k.set(25,A.Codicon.symbolTypeParameter);function L(E){let O=k.get(E);return O||(console.info("No codicon found for SymbolKind "+E),O=A.Codicon.symbolProperty),O}v.toIcon=L})(n=e.SymbolKinds||(e.SymbolKinds={}));class h{constructor(k){this.value=k}}e.FoldingRangeKind=h,h.Comment=new h("comment"),h.Imports=new h("imports"),h.Region=new h("region");var g;(function(v){function k(L){return!L||typeof L!="object"?!1:typeof L.id=="string"&&typeof L.title=="string"}v.is=k})(g=e.Command||(e.Command={}));var s;(function(v){v[v.Collapsed=0]="Collapsed",v[v.Expanded=1]="Expanded"})(s=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var d;(function(v){v[v.Editing=0]="Editing",v[v.Preview=1]="Preview"})(d=e.CommentMode||(e.CommentMode={}));var p;(function(v){v[v.Other=0]="Other",v[v.Type=1]="Type",v[v.Parameter=2]="Parameter"})(p=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new S.LanguageFeatureRegistry,e.RenameProviderRegistry=new S.LanguageFeatureRegistry,e.CompletionProviderRegistry=new S.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new S.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new S.LanguageFeatureRegistry,e.HoverProviderRegistry=new S.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new S.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new S.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new S.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new S.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new S.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new S.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new S.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new S.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new S.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new S.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new S.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new S.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new S.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new S.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new S.LanguageFeatureRegistry,e.LinkProviderRegistry=new S.LanguageFeatureRegistry,e.ColorProviderRegistry=new S.LanguageFeatureRegistry,e.SelectionRangeRegistry=new S.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new S.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new S.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new S.LanguageFeatureRegistry,e.TokenizationRegistry=new P.TokenizationRegistry;var w;(function(v){v[v.None=0]="None",v[v.Option=1]="Option",v[v.Default=2]="Default",v[v.Preferred=3]="Preferred"})(w=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(Se[79],_e([0,1,13,2,3]),function(ee,e,r,t,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,S.createDecorator)("configurationService");function P(m){return m&&typeof m=="object"&&(!m.overrideIdentifier||typeof m.overrideIdentifier=="string")&&(!m.resource||m.resource instanceof t.URI)}e.isConfigurationOverrides=P;function A(m){return m&&typeof m=="object"&&(!m.overrideIdentifiers||r.isArray(m.overrideIdentifiers))&&!m.overrideIdentifier&&(!m.resource||m.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=A;var I;(function(m){m[m.USER=1]="USER",m[m.USER_LOCAL=2]="USER_LOCAL",m[m.USER_REMOTE=3]="USER_REMOTE",m[m.WORKSPACE=4]="WORKSPACE",m[m.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",m[m.DEFAULT=6]="DEFAULT",m[m.MEMORY=7]="MEMORY"})(I=e.ConfigurationTarget||(e.ConfigurationTarget={}));function D(m){switch(m){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=D;function T(m,M){const y=Object.create(null);for(let _ in m)R(y,_,m[_],M);return y}e.toValuesTree=T;function R(m,M,y,_){const u=M.split("."),C=u.pop();let l=m;for(let F=0;F<u.length;F++){let c=u[F],n=l[c];switch(typeof n){case"undefined":n=l[c]=Object.create(null);break;case"object":break;default:_(`Ignoring ${M} as ${u.slice(0,F+1).join(".")} is ${JSON.stringify(n)}`);return}l=n}if(typeof l=="object"&&l!==null)try{l[C]=y}catch{_(`Ignoring ${M} as ${u.join(".")} is ${JSON.stringify(l)}`)}else _(`Ignoring ${M} as ${u.join(".")} is ${JSON.stringify(l)}`)}e.addToValueTree=R;function b(m,M){const y=M.split(".");i(m,y)}e.removeFromValueTree=b;function i(m,M){const y=M.shift();if(M.length===0){delete m[y];return}if(Object.keys(m).indexOf(y)!==-1){const _=m[y];typeof _=="object"&&!Array.isArray(_)&&(i(_,M),Object.keys(_).length===0&&delete m[y])}}function f(m,M,y){function _(l,F){let c=l;for(const n of F){if(typeof c!="object"||c===null)return;c=c[n]}return c}const u=M.split("."),C=_(m,u);return typeof C=="undefined"?y:C}e.getConfigurationValue=f;function a(m,M,y){Object.keys(M).forEach(_=>{_!=="__proto__"&&(_ in m?r.isObject(m[_])&&r.isObject(M[_])?a(m[_],M[_],y):y&&(m[_]=M[_]):m[_]=M[_])})}e.merge=a;function o(m,M,y){const _=m.inspect(M),u=m.inspect(y);return typeof _.userValue!="undefined"||typeof _.workspaceValue!="undefined"||typeof _.workspaceFolderValue!="undefined"?_.value:typeof u.userValue!="undefined"||typeof u.workspaceValue!="undefined"||typeof u.workspaceFolderValue!="undefined"?u.value:_.defaultValue}e.getMigratedSettingValue=o}),define(Se[45],_e([0,1,23,9,3]),function(ee,e,r,t,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const P=new Map;P.set("false",!1),P.set("true",!0),P.set("isMac",r.isMacintosh),P.set("isLinux",r.isLinux),P.set("isWindows",r.isWindows),P.set("isWeb",r.isWeb),P.set("isMacNative",r.isMacintosh&&!r.isWeb),P.set("isEdge",r.isEdge),P.set("isFirefox",r.isFirefox),P.set("isChrome",r.isChrome),P.set("isSafari",r.isSafari);const A=Object.prototype.hasOwnProperty;var I;(function(L){L[L.False=0]="False",L[L.True=1]="True",L[L.Defined=2]="Defined",L[L.Not=3]="Not",L[L.Equals=4]="Equals",L[L.NotEquals=5]="NotEquals",L[L.And=6]="And",L[L.Regex=7]="Regex",L[L.NotRegex=8]="NotRegex",L[L.Or=9]="Or",L[L.In=10]="In",L[L.NotIn=11]="NotIn",L[L.Greater=12]="Greater",L[L.GreaterEquals=13]="GreaterEquals",L[L.Smaller=14]="Smaller",L[L.SmallerEquals=15]="SmallerEquals"})(I=e.ContextKeyExprType||(e.ContextKeyExprType={}));class D{static false(){return b.INSTANCE}static true(){return i.INSTANCE}static has(E){return f.create(E)}static equals(E,O){return a.create(E,O)}static notEquals(E,O){return M.create(E,O)}static regex(E,O){return c.create(E,O)}static in(E,O){return o.create(E,O)}static not(E){return y.create(E)}static and(...E){return g.create(E,null)}static or(...E){return s.create(E,null,!0)}static greater(E,O){return u.create(E,O)}static greaterEquals(E,O){return C.create(E,O)}static smaller(E,O){return l.create(E,O)}static smallerEquals(E,O){return F.create(E,O)}static deserialize(E,O=!1){if(!!E)return this._deserializeOrExpression(E,O)}static _deserializeOrExpression(E,O){let U=E.split("||");return s.create(U.map(j=>this._deserializeAndExpression(j,O)),null,!0)}static _deserializeAndExpression(E,O){let U=E.split("&&");return g.create(U.map(j=>this._deserializeOne(j,O)),null)}static _deserializeOne(E,O){if(E=E.trim(),E.indexOf("!=")>=0){let U=E.split("!=");return M.create(U[0].trim(),this._deserializeValue(U[1],O))}if(E.indexOf("==")>=0){let U=E.split("==");return a.create(U[0].trim(),this._deserializeValue(U[1],O))}if(E.indexOf("=~")>=0){let U=E.split("=~");return c.create(U[0].trim(),this._deserializeRegexValue(U[1],O))}if(E.indexOf(" in ")>=0){let U=E.split(" in ");return o.create(U[0].trim(),U[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(E)){const U=E.split(">=");return C.create(U[0].trim(),U[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(E)){const U=E.split(">");return u.create(U[0].trim(),U[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(E)){const U=E.split("<=");return F.create(U[0].trim(),U[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(E)){const U=E.split("<");return l.create(U[0].trim(),U[1].trim())}return/^\!\s*/.test(E)?y.create(E.substr(1).trim()):f.create(E)}static _deserializeValue(E,O){if(E=E.trim(),E==="true")return!0;if(E==="false")return!1;let U=/^'([^']*)'$/.exec(E);return U?U[1].trim():E}static _deserializeRegexValue(E,O){if((0,t.isFalsyOrWhitespace)(E)){if(O)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let U=E.indexOf("/"),j=E.lastIndexOf("/");if(U===j||U<0){if(O)throw new Error(`bad regexp-value '${E}', missing /-enclosure`);return console.warn(`bad regexp-value '${E}', missing /-enclosure`),null}let H=E.slice(U+1,j),$=E[j+1]==="i"?"i":"";try{return new RegExp(H,$)}catch(G){if(O)throw new Error(`bad regexp-value '${E}', parse error: ${G}`);return console.warn(`bad regexp-value '${E}', parse error: ${G}`),null}}}e.ContextKeyExpr=D;function T(L,E){const O=L?L.substituteConstants():void 0,U=E?E.substituteConstants():void 0;return!O&&!U?!0:!O||!U?!1:O.equals(U)}e.expressionsAreEqualWithConstantSubstitution=T;function R(L,E){return L.cmp(E)}class b{constructor(){this.type=0}cmp(E){return this.type-E.type}equals(E){return E.type===this.type}substituteConstants(){return this}evaluate(E){return!1}serialize(){return"false"}keys(){return[]}map(E){return this}negate(){return i.INSTANCE}}e.ContextKeyFalseExpr=b,b.INSTANCE=new b;class i{constructor(){this.type=1}cmp(E){return this.type-E.type}equals(E){return E.type===this.type}substituteConstants(){return this}evaluate(E){return!0}serialize(){return"true"}keys(){return[]}map(E){return this}negate(){return b.INSTANCE}}e.ContextKeyTrueExpr=i,i.INSTANCE=new i;class f{constructor(E,O){this.key=E,this.negated=O,this.type=2}static create(E,O=null){const U=P.get(E);return typeof U=="boolean"?U?i.INSTANCE:b.INSTANCE:new f(E,O)}cmp(E){return E.type!==this.type?this.type-E.type:p(this.key,E.key)}equals(E){return E.type===this.type?this.key===E.key:!1}substituteConstants(){const E=P.get(this.key);return typeof E=="boolean"?E?i.INSTANCE:b.INSTANCE:this}evaluate(E){return!!E.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(E){return E.mapDefined(this.key)}negate(){return this.negated||(this.negated=y.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=f;class a{constructor(E,O,U){this.key=E,this.value=O,this.negated=U,this.type=4}static create(E,O,U=null){if(typeof O=="boolean")return O?f.create(E,U):y.create(E,U);const j=P.get(E);return typeof j=="boolean"?O===(j?"true":"false")?i.INSTANCE:b.INSTANCE:new a(E,O,U)}cmp(E){return E.type!==this.type?this.type-E.type:w(this.key,this.value,E.key,E.value)}equals(E){return E.type===this.type?this.key===E.key&&this.value===E.value:!1}substituteConstants(){const E=P.get(this.key);if(typeof E=="boolean"){const O=E?"true":"false";return this.value===O?i.INSTANCE:b.INSTANCE}return this}evaluate(E){return E.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(E){return E.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=M.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=a;class o{constructor(E,O){this.key=E,this.valueKey=O,this.type=10,this.negated=null}static create(E,O){return new o(E,O)}cmp(E){return E.type!==this.type?this.type-E.type:w(this.key,this.valueKey,E.key,E.valueKey)}equals(E){return E.type===this.type?this.key===E.key&&this.valueKey===E.valueKey:!1}substituteConstants(){return this}evaluate(E){const O=E.getValue(this.valueKey),U=E.getValue(this.key);return Array.isArray(O)?O.indexOf(U)>=0:typeof U=="string"&&typeof O=="object"&&O!==null?A.call(O,U):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(E){return E.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=m.create(this)),this.negated}}e.ContextKeyInExpr=o;class m{constructor(E){this._actual=E,this.type=11}static create(E){return new m(E)}cmp(E){return E.type!==this.type?this.type-E.type:this._actual.cmp(E._actual)}equals(E){return E.type===this.type?this._actual.equals(E._actual):!1}substituteConstants(){return this}evaluate(E){return!this._actual.evaluate(E)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(E){return new m(this._actual.map(E))}negate(){return this._actual}}e.ContextKeyNotInExpr=m;class M{constructor(E,O,U){this.key=E,this.value=O,this.negated=U,this.type=5}static create(E,O,U=null){if(typeof O=="boolean")return O?y.create(E,U):f.create(E,U);const j=P.get(E);return typeof j=="boolean"?O===(j?"true":"false")?b.INSTANCE:i.INSTANCE:new M(E,O,U)}cmp(E){return E.type!==this.type?this.type-E.type:w(this.key,this.value,E.key,E.value)}equals(E){return E.type===this.type?this.key===E.key&&this.value===E.value:!1}substituteConstants(){const E=P.get(this.key);if(typeof E=="boolean"){const O=E?"true":"false";return this.value===O?b.INSTANCE:i.INSTANCE}return this}evaluate(E){return E.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(E){return E.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=a.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=M;class y{constructor(E,O){this.key=E,this.negated=O,this.type=3}static create(E,O=null){const U=P.get(E);return typeof U=="boolean"?U?b.INSTANCE:i.INSTANCE:new y(E,O)}cmp(E){return E.type!==this.type?this.type-E.type:p(this.key,E.key)}equals(E){return E.type===this.type?this.key===E.key:!1}substituteConstants(){const E=P.get(this.key);return typeof E=="boolean"?E?b.INSTANCE:i.INSTANCE:this}evaluate(E){return!E.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(E){return E.mapNot(this.key)}negate(){return this.negated||(this.negated=f.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=y;function _(L,E){if(typeof L=="string"){const O=parseFloat(L);isNaN(O)||(L=O)}return typeof L=="string"||typeof L=="number"?E(L):b.INSTANCE}class u{constructor(E,O,U){this.key=E,this.value=O,this.negated=U,this.type=12}static create(E,O,U=null){return _(O,j=>new u(E,j,U))}cmp(E){return E.type!==this.type?this.type-E.type:w(this.key,this.value,E.key,E.value)}equals(E){return E.type===this.type?this.key===E.key&&this.value===E.value:!1}substituteConstants(){return this}evaluate(E){return typeof this.value=="string"?!1:parseFloat(E.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(E){return E.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=F.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=u;class C{constructor(E,O,U){this.key=E,this.value=O,this.negated=U,this.type=13}static create(E,O,U=null){return _(O,j=>new C(E,j,U))}cmp(E){return E.type!==this.type?this.type-E.type:w(this.key,this.value,E.key,E.value)}equals(E){return E.type===this.type?this.key===E.key&&this.value===E.value:!1}substituteConstants(){return this}evaluate(E){return typeof this.value=="string"?!1:parseFloat(E.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(E){return E.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=l.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=C;class l{constructor(E,O,U){this.key=E,this.value=O,this.negated=U,this.type=14}static create(E,O,U=null){return _(O,j=>new l(E,j,U))}cmp(E){return E.type!==this.type?this.type-E.type:w(this.key,this.value,E.key,E.value)}equals(E){return E.type===this.type?this.key===E.key&&this.value===E.value:!1}substituteConstants(){return this}evaluate(E){return typeof this.value=="string"?!1:parseFloat(E.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(E){return E.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=C.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=l;class F{constructor(E,O,U){this.key=E,this.value=O,this.negated=U,this.type=15}static create(E,O,U=null){return _(O,j=>new F(E,j,U))}cmp(E){return E.type!==this.type?this.type-E.type:w(this.key,this.value,E.key,E.value)}equals(E){return E.type===this.type?this.key===E.key&&this.value===E.value:!1}substituteConstants(){return this}evaluate(E){return typeof this.value=="string"?!1:parseFloat(E.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(E){return E.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=u.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=F;class c{constructor(E,O){this.key=E,this.regexp=O,this.type=7,this.negated=null}static create(E,O){return new c(E,O)}cmp(E){if(E.type!==this.type)return this.type-E.type;if(this.key<E.key)return-1;if(this.key>E.key)return 1;const O=this.regexp?this.regexp.source:"",U=E.regexp?E.regexp.source:"";return O<U?-1:O>U?1:0}equals(E){if(E.type===this.type){const O=this.regexp?this.regexp.source:"",U=E.regexp?E.regexp.source:"";return this.key===E.key&&O===U}return!1}substituteConstants(){return this}evaluate(E){let O=E.getValue(this.key);return this.regexp?this.regexp.test(O):!1}serialize(){const E=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${E}`}keys(){return[this.key]}map(E){return E.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=n.create(this)),this.negated}}e.ContextKeyRegexExpr=c;class n{constructor(E){this._actual=E,this.type=8}static create(E){return new n(E)}cmp(E){return E.type!==this.type?this.type-E.type:this._actual.cmp(E._actual)}equals(E){return E.type===this.type?this._actual.equals(E._actual):!1}substituteConstants(){return this}evaluate(E){return!this._actual.evaluate(E)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(E){return new n(this._actual.map(E))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=n;function h(L){let E=null;for(let O=0,U=L.length;O<U;O++){const j=L[O].substituteConstants();if(L[O]!==j&&E===null){E=[];for(let H=0;H<O;H++)E[H]=L[H]}E!==null&&(E[O]=j)}return E===null?L:E}class g{constructor(E,O){this.expr=E,this.negated=O,this.type=6}static create(E,O){return g._normalizeArr(E,O)}cmp(E){if(E.type!==this.type)return this.type-E.type;if(this.expr.length<E.expr.length)return-1;if(this.expr.length>E.expr.length)return 1;for(let O=0,U=this.expr.length;O<U;O++){const j=R(this.expr[O],E.expr[O]);if(j!==0)return j}return 0}equals(E){if(E.type===this.type){if(this.expr.length!==E.expr.length)return!1;for(let O=0,U=this.expr.length;O<U;O++)if(!this.expr[O].equals(E.expr[O]))return!1;return!0}return!1}substituteConstants(){const E=h(this.expr);return E===this.expr?this:g.create(E,this.negated)}evaluate(E){for(let O=0,U=this.expr.length;O<U;O++)if(!this.expr[O].evaluate(E))return!1;return!0}static _normalizeArr(E,O){const U=[];let j=!1;for(const H of E)if(!!H){if(H.type===1){j=!0;continue}if(H.type===0)return b.INSTANCE;if(H.type===6){U.push(...H.expr);continue}U.push(H)}if(U.length===0&&j)return i.INSTANCE;if(U.length!==0){if(U.length===1)return U[0];U.sort(R);for(let H=1;H<U.length;H++)U[H-1].equals(U[H])&&(U.splice(H,1),H--);if(U.length===1)return U[0];for(;U.length>1;){const H=U[U.length-1];if(H.type!==9)break;U.pop();const $=U.pop(),G=U.length===0,ie=s.create(H.expr.map(le=>g.create([le,$],null)),null,G);ie&&(U.push(ie),U.sort(R))}return U.length===1?U[0]:new g(U,O)}}serialize(){return this.expr.map(E=>E.serialize()).join(" && ")}keys(){const E=[];for(let O of this.expr)E.push(...O.keys());return E}map(E){return new g(this.expr.map(O=>O.map(E)),null)}negate(){if(!this.negated){const E=[];for(let O of this.expr)E.push(O.negate());this.negated=s.create(E,this,!0)}return this.negated}}class s{constructor(E,O){this.expr=E,this.negated=O,this.type=9}static create(E,O,U){return s._normalizeArr(E,O,U)}cmp(E){if(E.type!==this.type)return this.type-E.type;if(this.expr.length<E.expr.length)return-1;if(this.expr.length>E.expr.length)return 1;for(let O=0,U=this.expr.length;O<U;O++){const j=R(this.expr[O],E.expr[O]);if(j!==0)return j}return 0}equals(E){if(E.type===this.type){if(this.expr.length!==E.expr.length)return!1;for(let O=0,U=this.expr.length;O<U;O++)if(!this.expr[O].equals(E.expr[O]))return!1;return!0}return!1}substituteConstants(){const E=h(this.expr);return E===this.expr?this:s.create(E,this.negated,!1)}evaluate(E){for(let O=0,U=this.expr.length;O<U;O++)if(this.expr[O].evaluate(E))return!0;return!1}static _normalizeArr(E,O,U){let j=[],H=!1;if(E){for(let $=0,G=E.length;$<G;$++){const ie=E[$];if(!!ie){if(ie.type===0){H=!0;continue}if(ie.type===1)return i.INSTANCE;if(ie.type===9){j=j.concat(ie.expr);continue}j.push(ie)}}if(j.length===0&&H)return b.INSTANCE;j.sort(R)}if(j.length!==0){if(j.length===1)return j[0];for(let $=1;$<j.length;$++)j[$-1].equals(j[$])&&(j.splice($,1),$--);if(j.length===1)return j[0];if(U){for(let $=0;$<j.length;$++)for(let G=$+1;G<j.length;G++)v(j[$],j[G])&&(j.splice(G,1),G--);if(j.length===1)return j[0]}return new s(j,O)}}serialize(){return this.expr.map(E=>E.serialize()).join(" || ")}keys(){const E=[];for(let O of this.expr)E.push(...O.keys());return E}map(E){return new s(this.expr.map(O=>O.map(E)),null)}negate(){if(!this.negated){let E=[];for(let O of this.expr)E.push(O.negate());for(;E.length>1;){const O=E.shift(),U=E.shift(),j=[];for(const $ of k(O))for(const G of k(U))j.push(g.create([$,G],null));const H=E.length===0;E.unshift(s.create(j,null,H))}this.negated=E[0]}return this.negated}}class d extends f{constructor(E,O,U){super(E,null);this._defaultValue=O,typeof U=="object"?d._info.push({...U,key:E}):U!==!0&&d._info.push({key:E,description:U,type:O!=null?typeof O:void 0})}static all(){return d._info.values()}bindTo(E){return E.createKey(this.key,this._defaultValue)}getValue(E){return E.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(E){return a.create(this.key,E)}notEqualsTo(E){return M.create(this.key,E)}}e.RawContextKey=d,d._info=[],e.IContextKeyService=(0,S.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function p(L,E){return L<E?-1:L>E?1:0}function w(L,E,O,U){return L<O?-1:L>O?1:E<U?-1:E>U?1:0}function v(L,E){if(E.type===6&&L.type!==9&&L.type!==6){for(const j of E.expr)if(L.equals(j))return!0}const O=L.negate(),U=k(O).concat(k(E));U.sort(R);for(let j=0;j<U.length;j++){const $=U[j].negate();for(let G=j+1;G<U.length;G++){const ie=U[G];if($.equals(ie))return!0}}return!1}e.implies=v;function k(L){return L.type===9?L.expr:[L]}}),define(Se[135],_e([0,1,3]),function(ee,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,r.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,r.refineServiceDecorator)(e.IEnvironmentService)}),define(Se[46],_e([0,1,22,17,9,13,2,116,3]),function(ee,e,r,t,S,P,A,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,D.createDecorator)("fileService");function T(H){return H.create===!0}e.isFileOpenForWriteOptions=T;var R;(function(H){H[H.Unknown=0]="Unknown",H[H.File=1]="File",H[H.Directory=2]="Directory",H[H.SymbolicLink=64]="SymbolicLink"})(R=e.FileType||(e.FileType={}));var b;(function(H){H[H.Readonly=1]="Readonly"})(b=e.FilePermission||(e.FilePermission={}));var i;(function(H){H[H.FileReadWrite=2]="FileReadWrite",H[H.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",H[H.FileReadStream=16]="FileReadStream",H[H.FileFolderCopy=8]="FileFolderCopy",H[H.PathCaseSensitive=1024]="PathCaseSensitive",H[H.Readonly=2048]="Readonly",H[H.Trash=4096]="Trash",H[H.FileWriteUnlock=8192]="FileWriteUnlock",H[H.FileAtomicRead=16384]="FileAtomicRead"})(i=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function f(H){return!!(H.capabilities&2)}e.hasReadWriteCapability=f;function a(H){return!!(H.capabilities&8)}e.hasFileFolderCopyCapability=a;function o(H){return!!(H.capabilities&4)}e.hasOpenReadWriteCloseCapability=o;function m(H){return!!(H.capabilities&16)}e.hasFileReadStreamCapability=m;function M(H){return f(H)?!!(H.capabilities&16384):!1}e.hasFileAtomicReadCapability=M;var y;(function(H){H.FileExists="EntryExists",H.FileNotFound="EntryNotFound",H.FileNotADirectory="EntryNotADirectory",H.FileIsADirectory="EntryIsADirectory",H.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",H.FileTooLarge="EntryTooLarge",H.FileWriteLocked="EntryWriteLocked",H.NoPermissions="NoPermissions",H.Unavailable="Unavailable",H.Unknown="Unknown"})(y=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class _ extends Error{constructor($,G){super($);this.code=G}}e.FileSystemProviderError=_;function u(H,$){const G=new _(H.toString(),$);return l(G,$),G}e.createFileSystemProviderError=u;function C(H){return H||u((0,I.localize)(0,null),y.Unknown)}e.ensureFileSystemProviderError=C;function l(H,$){return H.name=$?`${$} (FileSystemError)`:"FileSystemError",H}e.markAsFileSystemProviderError=l;function F(H){if(!H)return y.Unknown;if(H instanceof _)return H.code;const $=/^(.+) \(FileSystemError\)$/.exec(H.name);if(!$)return y.Unknown;switch($[1]){case y.FileExists:return y.FileExists;case y.FileIsADirectory:return y.FileIsADirectory;case y.FileNotADirectory:return y.FileNotADirectory;case y.FileNotFound:return y.FileNotFound;case y.FileExceedsMemoryLimit:return y.FileExceedsMemoryLimit;case y.FileTooLarge:return y.FileTooLarge;case y.FileWriteLocked:return y.FileWriteLocked;case y.NoPermissions:return y.NoPermissions;case y.Unavailable:return y.Unavailable}return y.Unknown}e.toFileSystemProviderErrorCode=F;function c(H){if(H instanceof p)return H.fileOperationResult;switch(F(H)){case y.FileNotFound:return 1;case y.FileIsADirectory:return 0;case y.FileNotADirectory:return 10;case y.FileWriteLocked:return 5;case y.NoPermissions:return 6;case y.FileExists:return 4;case y.FileExceedsMemoryLimit:return 9;case y.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=c;var n;(function(H){H[H.CREATE=0]="CREATE",H[H.DELETE=1]="DELETE",H[H.MOVE=2]="MOVE",H[H.COPY=3]="COPY"})(n=e.FileOperation||(e.FileOperation={}));class h{constructor($,G,ie){this.resource=$,this.operation=G,this.target=ie}isOperation($){return this.operation===$}}e.FileOperationEvent=h;var g;(function(H){H[H.UPDATED=0]="UPDATED",H[H.ADDED=1]="ADDED",H[H.DELETED=2]="DELETED"})(g=e.FileChangeType||(e.FileChangeType={}));class s{constructor($,G){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=$;const ie=new Map;for(const le of $){const X=ie.get(le.type);switch(X?X.push([le.resource,le]):ie.set(le.type,[[le.resource,le]]),le.type){case 1:this.rawAdded.push(le.resource);break;case 0:this.rawUpdated.push(le.resource);break;case 2:this.rawDeleted.push(le.resource);break}}for(const[le,X]of ie)switch(le){case 1:this.added=r.TernarySearchTree.forUris(()=>G),this.added.fill(X);break;case 0:this.updated=r.TernarySearchTree.forUris(()=>G),this.updated.fill(X);break;case 2:this.deleted=r.TernarySearchTree.forUris(()=>G),this.deleted.fill(X);break}}contains($,...G){return this.doContains($,{includeChildren:!1},...G)}affects($,...G){return this.doContains($,{includeChildren:!0},...G)}doContains($,G,...ie){if(!$)return!1;const le=ie.length>0;return!!((!le||ie.includes(1))&&(this.added?.get($)||G.includeChildren&&this.added?.findSuperstr($))||(!le||ie.includes(0))&&(this.updated?.get($)||G.includeChildren&&this.updated?.findSuperstr($))||(!le||ie.includes(2))&&(this.deleted?.findSubstr($)||G.includeChildren&&this.deleted?.findSuperstr($)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=s;function d(H,$,G){return!H||!$||H===$||$.length>H.length?!1:($.charAt($.length-1)!==t.sep&&($+=t.sep),G?(0,S.startsWithIgnoreCase)(H,$):H.indexOf($)===0)}e.isParent=d;class p extends Error{constructor($,G,ie){super($);this.fileOperationResult=G,this.options=ie}}e.FileOperationError=p;class w extends p{constructor($,G,ie){super($,2,ie);this.stat=G}}e.NotModifiedSinceFileOperationError=w;var v;(function(H){H[H.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",H[H.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",H[H.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",H[H.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",H[H.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",H[H.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",H[H.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",H[H.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",H[H.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",H[H.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",H[H.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",H[H.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(v=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var k;(function(H){H[H.FILE=0]="FILE",H[H.FOLDER=1]="FOLDER",H[H.ROOT_FOLDER=2]="ROOT_FOLDER"})(k=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function L(H){if(!(typeof H.size!="number"||typeof H.mtime!="number"))return H.mtime.toString(29)+H.size.toString(31)}e.etag=L;async function E(H,$){if(!$.hasProvider(A.URI.from({scheme:H.scheme})))return new Promise(G=>{const ie=$.onDidChangeFileSystemProviderRegistrations(le=>{le.scheme===H.scheme&&le.added&&(ie.dispose(),G())})})}e.whenProviderRegistered=E,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class O{static formatSize($){return(0,P.isNumber)($)||($=0),$<O.KB?(0,I.localize)(1,null,$.toFixed(0)):$<O.MB?(0,I.localize)(2,null,($/O.KB).toFixed(2)):$<O.GB?(0,I.localize)(3,null,($/O.MB).toFixed(2)):$<O.TB?(0,I.localize)(4,null,($/O.GB).toFixed(2)):(0,I.localize)(5,null,($/O.TB).toFixed(2))}}e.ByteSize=O,O.KB=1024,O.MB=O.KB*O.KB,O.GB=O.MB*O.KB,O.TB=O.GB*O.KB;var U;(function(H){H[H.IA32=0]="IA32",H[H.OTHER=1]="OTHER"})(U=e.Arch||(e.Arch={}));function j(H){return{maxFileSize:H===0?300*O.MB:16*O.GB,maxHeapSize:H===0?700*O.MB:2*700*O.MB}}e.getPlatformLimits=j}),define(Se[59],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class r{constructor(...S){this._entries=new Map;for(let[P,A]of S)this.set(P,A)}set(S,P){const A=this._entries.get(S);return this._entries.set(S,P),A}has(S){return this._entries.has(S)}get(S){return this._entries.get(S)}}e.ServiceCollection=r}),define(Se[136],_e([0,1,10,15,78,132,3,59]),function(ee,e,r,t,S,P,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const D=!1;class T extends Error{constructor(a){super("cyclic dependency between services");this.message=a.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${a.toString()}`}}class R{constructor(a=new I.ServiceCollection,o=!1,m){this._activeInstantiations=new Set,this._services=a,this._strict=o,this._parent=m,this._services.set(A.IInstantiationService,this)}createChild(a){return new R(a,this._strict,this)}invokeFunction(a,...o){let m=i.traceInvocation(a),M=!1;try{return a({get:_=>{if(M)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const u=this._getOrCreateServiceInstance(_,m);if(!u)throw new Error(`[invokeFunction] unknown service '${_}'`);return u}},...o)}finally{M=!0,m.stop()}}createInstance(a,...o){let m,M;return a instanceof S.SyncDescriptor?(m=i.traceCreation(a.ctor),M=this._createInstance(a.ctor,a.staticArguments.concat(o),m)):(m=i.traceCreation(a),M=this._createInstance(a,o,m)),m.stop(),M}_createInstance(a,o=[],m){let M=A._util.getServiceDependencies(a).sort((u,C)=>u.index-C.index),y=[];for(const u of M){let C=this._getOrCreateServiceInstance(u.id,m);if(!C&&this._strict&&!u.optional)throw new Error(`[createInstance] ${a.name} depends on UNKNOWN service ${u.id}.`);y.push(C)}let _=M.length>0?M[0].index:o.length;if(o.length!==_){console.warn(`[createInstance] First service dependency of ${a.name} at position ${_+1} conflicts with ${o.length} static arguments`);let u=_-o.length;u>0?o=o.concat(new Array(u)):o=o.slice(0,_)}return new a(...[...o,...y])}_setServiceInstance(a,o){if(this._services.get(a)instanceof S.SyncDescriptor)this._services.set(a,o);else if(this._parent)this._parent._setServiceInstance(a,o);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(a){let o=this._services.get(a);return!o&&this._parent?this._parent._getServiceInstanceOrDescriptor(a):o}_getOrCreateServiceInstance(a,o){let m=this._getServiceInstanceOrDescriptor(a);return m instanceof S.SyncDescriptor?this._safeCreateAndCacheServiceInstance(a,m,o.branch(a,!0)):(o.branch(a,!1),m)}_safeCreateAndCacheServiceInstance(a,o,m){if(this._activeInstantiations.has(a))throw new Error(`illegal state - RECURSIVELY instantiating service '${a}'`);this._activeInstantiations.add(a);try{return this._createAndCacheServiceInstance(a,o,m)}finally{this._activeInstantiations.delete(a)}}_createAndCacheServiceInstance(a,o,m){const M=new P.Graph(u=>u.id.toString());let y=0;const _=[{id:a,desc:o,_trace:m}];for(;_.length;){const u=_.pop();if(M.lookupOrInsertNode(u),y++>1e3)throw new T(M);for(let C of A._util.getServiceDependencies(u.desc.ctor)){let l=this._getServiceInstanceOrDescriptor(C.id);if(!l&&!C.optional&&console.warn(`[createInstance] ${a} depends on ${C.id} which is NOT registered.`),l instanceof S.SyncDescriptor){const F={id:C.id,desc:l,_trace:u._trace.branch(C.id,!0)};M.insertEdge(u,F),_.push(F)}}}for(;;){const u=M.roots();if(u.length===0){if(!M.isEmpty())throw new T(M);break}for(const{data:C}of u){if(this._getServiceInstanceOrDescriptor(C.id)instanceof S.SyncDescriptor){const F=this._createServiceInstanceWithOwner(C.id,C.desc.ctor,C.desc.staticArguments,C.desc.supportsDelayedInstantiation,C._trace);this._setServiceInstance(C.id,F)}M.removeNode(C)}}return this._getServiceInstanceOrDescriptor(a)}_createServiceInstanceWithOwner(a,o,m=[],M,y){if(this._services.get(a)instanceof S.SyncDescriptor)return this._createServiceInstance(o,m,M,y);if(this._parent)return this._parent._createServiceInstanceWithOwner(a,o,m,M,y);throw new Error(`illegalState - creating UNKNOWN service instance ${o.name}`)}_createServiceInstance(a,o=[],m,M){if(m){const y=new r.IdleValue(()=>this._createInstance(a,o,M));return new Proxy(Object.create(null),{get(_,u){if(u in _)return _[u];let C=y.value,l=C[u];return typeof l!="function"||(l=l.bind(C),_[u]=l),l},set(_,u,C){return y.value[u]=C,!0}})}else return this._createInstance(a,o,M)}}e.InstantiationService=R;var b;(function(f){f[f.Creation=0]="Creation",f[f.Invocation=1]="Invocation",f[f.Branch=2]="Branch"})(b||(b={}));class i{constructor(a,o){this.type=a,this.name=o,this._start=Date.now(),this._dep=[]}static traceInvocation(a){return D?new i(1,a.name||a.toString().substring(0,42).replace(/\n/g,"")):i._None}static traceCreation(a){return D?new i(0,a.name):i._None}branch(a,o){let m=new i(2,a.toString());return this._dep.push([a,o,m]),m}stop(){let a=Date.now()-this._start;i._totals+=a;let o=!1;function m(y,_){let u=[],C=new Array(y+1).join("	");for(const[l,F,c]of _._dep)if(F&&c){o=!0,u.push(`${C}CREATES -> ${l}`);let n=m(y+1,c);n&&u.push(n)}else u.push(`${C}uses -> ${l}`);return u.join(`
`)}let M=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${m(1,this)}`,`DONE, took ${a.toFixed(2)}ms (grand total ${i._totals.toFixed(2)}ms)`];(a>2||o)&&console.log(M.join(`
`))}}e.Trace=i,i._None=new class extends i{constructor(){super(-1,null)}stop(){}branch(){return this}},i._totals=0}),define(Se[12],_e([0,1,43,4,6,23,3]),function(ee,e,r,t,S,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,A.createDecorator)("logService"),e.ILoggerService=(0,A.createDecorator)("loggerService");function I(){return new Date().toISOString()}var D;(function(F){F[F.Trace=0]="Trace",F[F.Debug=1]="Debug",F[F.Info=2]="Info",F[F.Warning=3]="Warning",F[F.Error=4]="Error",F[F.Critical=5]="Critical",F[F.Off=6]="Off"})(D=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=D.Info;function T(F,c,n){switch(c){case D.Trace:F.trace(n);break;case D.Debug:F.debug(n);break;case D.Info:F.info(n);break;case D.Warning:F.warn(n);break;case D.Error:F.error(n);break;case D.Critical:F.critical(n);break;default:throw new Error("Invalid log level")}}e.log=T;function R(F){let c="";for(let n=0;n<F.length;n++){let h=F[n];if(typeof h=="object")try{h=JSON.stringify(h)}catch{}c+=(n>0?" ":"")+h}return c}e.format=R;class b extends S.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new t.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(c){this.level!==c&&(this.level=c,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=b;class i extends b{constructor(c){super();this.logAlways=c}checkLogLevel(c){return this.logAlways||this.getLevel()<=c}trace(c,...n){this.checkLogLevel(D.Trace)&&this.log(D.Trace,R([c,...n]))}debug(c,...n){this.checkLogLevel(D.Debug)&&this.log(D.Debug,R([c,...n]))}info(c,...n){this.checkLogLevel(D.Info)&&this.log(D.Info,R([c,...n]))}warn(c,...n){this.checkLogLevel(D.Warning)&&this.log(D.Warning,R([c,...n]))}error(c,...n){if(this.checkLogLevel(D.Error))if(c instanceof Error){const h=Array.prototype.slice.call(arguments);h[0]=c.stack,this.log(D.Error,R(h))}else this.log(D.Error,R([c,...n]))}critical(c,...n){this.checkLogLevel(D.Critical)&&this.log(D.Critical,R([c,...n]))}flush(){}}e.AbstractMessageLogger=i;class f extends b{constructor(c=e.DEFAULT_LOG_LEVEL){super();this.setLevel(c),this.useColors=!P.isWindows}trace(c,...n){this.getLevel()<=D.Trace&&(this.useColors?console.log(`[90m[main ${I()}][0m`,c,...n):console.log(`[main ${I()}]`,c,...n))}debug(c,...n){this.getLevel()<=D.Debug&&(this.useColors?console.log(`[90m[main ${I()}][0m`,c,...n):console.log(`[main ${I()}]`,c,...n))}info(c,...n){this.getLevel()<=D.Info&&(this.useColors?console.log(`[90m[main ${I()}][0m`,c,...n):console.log(`[main ${I()}]`,c,...n))}warn(c,...n){this.getLevel()<=D.Warning&&(this.useColors?console.warn(`[93m[main ${I()}][0m`,c,...n):console.warn(`[main ${I()}]`,c,...n))}error(c,...n){this.getLevel()<=D.Error&&(this.useColors?console.error(`[91m[main ${I()}][0m`,c,...n):console.error(`[main ${I()}]`,c,...n))}critical(c,...n){this.getLevel()<=D.Critical&&(this.useColors?console.error(`[90m[main ${I()}][0m`,c,...n):console.error(`[main ${I()}]`,c,...n))}dispose(){}flush(){}}e.ConsoleMainLogger=f;class a extends b{constructor(c=e.DEFAULT_LOG_LEVEL){super();this.setLevel(c)}trace(c,...n){this.getLevel()<=D.Trace&&console.log("%cTRACE","color: #888",c,...n)}debug(c,...n){this.getLevel()<=D.Debug&&console.log("%cDEBUG","background: #eee; color: #888",c,...n)}info(c,...n){this.getLevel()<=D.Info&&console.log("%c INFO","color: #33f",c,...n)}warn(c,...n){this.getLevel()<=D.Warning&&console.log("%c WARN","color: #993",c,...n)}error(c,...n){this.getLevel()<=D.Error&&console.log("%c  ERR","color: #f33",c,...n)}critical(c,...n){this.getLevel()<=D.Critical&&console.log("%cCRITI","background: #f33; color: white",c,...n)}dispose(){}flush(){}}e.ConsoleLogger=a;class o extends b{constructor(c,n=e.DEFAULT_LOG_LEVEL){super();this.adapter=c,this.setLevel(n)}trace(c,...n){this.getLevel()<=D.Trace&&this.adapter.log(D.Trace,[this.extractMessage(c),...n])}debug(c,...n){this.getLevel()<=D.Debug&&this.adapter.log(D.Debug,[this.extractMessage(c),...n])}info(c,...n){this.getLevel()<=D.Info&&this.adapter.log(D.Info,[this.extractMessage(c),...n])}warn(c,...n){this.getLevel()<=D.Warning&&this.adapter.log(D.Warning,[this.extractMessage(c),...n])}error(c,...n){this.getLevel()<=D.Error&&this.adapter.log(D.Error,[this.extractMessage(c),...n])}critical(c,...n){this.getLevel()<=D.Critical&&this.adapter.log(D.Critical,[this.extractMessage(c),...n])}extractMessage(c){return typeof c=="string"?c:(0,r.toErrorMessage)(c,this.getLevel()<=D.Trace)}dispose(){}flush(){}}e.AdapterLogger=o;class m extends b{constructor(c){super();this.logServices=c,c.length&&this.setLevel(c[0].getLevel())}setLevel(c){for(const n of this.logServices)n.setLevel(c);super.setLevel(c)}trace(c,...n){for(const h of this.logServices)h.trace(c,...n)}debug(c,...n){for(const h of this.logServices)h.debug(c,...n)}info(c,...n){for(const h of this.logServices)h.info(c,...n)}warn(c,...n){for(const h of this.logServices)h.warn(c,...n)}error(c,...n){for(const h of this.logServices)h.error(c,...n)}critical(c,...n){for(const h of this.logServices)h.critical(c,...n)}flush(){for(const c of this.logServices)c.flush()}dispose(){for(const c of this.logServices)c.dispose()}}e.MultiplexLogService=m;class M extends S.Disposable{constructor(c){super();this.logger=c,this._register(c)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(c){this.logger.setLevel(c)}getLevel(){return this.logger.getLevel()}trace(c,...n){this.logger.trace(c,...n)}debug(c,...n){this.logger.debug(c,...n)}info(c,...n){this.logger.info(c,...n)}warn(c,...n){this.logger.warn(c,...n)}error(c,...n){this.logger.error(c,...n)}critical(c,...n){this.logger.critical(c,...n)}flush(){this.logger.flush()}}e.LogService=M;class y extends S.Disposable{constructor(c,n){super();this.logLevel=c,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(n(h=>{this.logLevel=h,this.logLevelChangeableLoggers.forEach(g=>g.setLevel(h))}))}getLogger(c){return this.loggers.get(c.toString())}createLogger(c,n){let h=this.loggers.get(c.toString());return h||(h=this.doCreateLogger(c,n?.always?D.Trace:this.logLevel,n),this.loggers.set(c.toString(),h),n?.always||this.logLevelChangeableLoggers.push(h)),h}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(c=>c.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=y;class _{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(c){}getLevel(){return D.Info}trace(c,...n){}debug(c,...n){}info(c,...n){}warn(c,...n){}error(c,...n){}critical(c,...n){}dispose(){}flush(){}}e.NullLogService=_;function u(F){if(F.verbose)return D.Trace;if(typeof F.logLevel=="string"){const c=C(F.logLevel.toLowerCase());if(c!==void 0)return c}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=u;function C(F){switch(F){case"trace":return D.Trace;case"debug":return D.Debug;case"info":return D.Info;case"warn":return D.Warning;case"error":return D.Error;case"critical":return D.Critical;case"off":return D.Off}}e.parseLogLevel=C;function l(F){switch(F){case D.Trace:return"trace";case D.Debug:return"debug";case D.Info:return"info";case D.Warning:return"warn";case D.Error:return"error";case D.Critical:return"critical";case D.Off:return"off"}}e.LogLevelToString=l}),define(Se[80],_e([0,1,34,117,3]),function(ee,e,r,t,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var P;(function(D){D[D.Unnecessary=1]="Unnecessary",D[D.Deprecated=2]="Deprecated"})(P=e.MarkerTag||(e.MarkerTag={}));var A;(function(D){D[D.Hint=1]="Hint",D[D.Info=2]="Info",D[D.Warning=4]="Warning",D[D.Error=8]="Error"})(A=e.MarkerSeverity||(e.MarkerSeverity={})),function(D){function T(a,o){return o-a}D.compare=T;const R=Object.create(null);R[D.Error]=(0,t.localize)(0,null),R[D.Warning]=(0,t.localize)(1,null),R[D.Info]=(0,t.localize)(2,null);function b(a){return R[a]||""}D.toString=b;function i(a){switch(a){case r.default.Error:return D.Error;case r.default.Warning:return D.Warning;case r.default.Info:return D.Info;case r.default.Ignore:return D.Hint}}D.fromSeverity=i;function f(a){switch(a){case D.Error:return r.default.Error;case D.Warning:return r.default.Warning;case D.Info:return r.default.Info;case D.Hint:return r.default.Ignore}}D.toSeverity=f}(A=e.MarkerSeverity||(e.MarkerSeverity={}));var I;(function(D){const T="";function R(i){return b(i,!0)}D.makeKey=R;function b(i,f){let a=[T];return i.source?a.push(i.source.replace("\xA6","\\\xA6")):a.push(T),i.code?typeof i.code=="string"?a.push(i.code.replace("\xA6","\\\xA6")):a.push(i.code.value.replace("\xA6","\\\xA6")):a.push(T),i.severity!==void 0&&i.severity!==null?a.push(A.toString(i.severity)):a.push(T),i.message&&f?a.push(i.message.replace("\xA6","\\\xA6")):a.push(T),i.startLineNumber!==void 0&&i.startLineNumber!==null?a.push(i.startLineNumber.toString()):a.push(T),i.startColumn!==void 0&&i.startColumn!==null?a.push(i.startColumn.toString()):a.push(T),i.endLineNumber!==void 0&&i.endLineNumber!==null?a.push(i.endLineNumber.toString()):a.push(T),i.endColumn!==void 0&&i.endColumn!==null?a.push(i.endColumn.toString()):a.push(T),a.push(T),a.join("\xA6")}D.makeKeyOptionalMessage=b})(I=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,S.createDecorator)("markerService")}),define(Se[137],_e([0,1,4,34,3]),function(ee,e,r,t,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=t.default,e.INotificationService=(0,S.createDecorator)("notificationService");var P;(function(T){T[T.WORKSPACE=0]="WORKSPACE",T[T.GLOBAL=1]="GLOBAL"})(P=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var A;(function(T){T[T.OFF=0]="OFF",T[T.SILENT=1]="SILENT",T[T.ERROR=2]="ERROR"})(A=e.NotificationsFilter||(e.NotificationsFilter={}));class I{constructor(){this.progress=new D,this.onDidClose=r.Event.None,this.onDidChangeVisibility=r.Event.None}updateSeverity(R){}updateMessage(R){}updateActions(R){}close(){}}e.NoOpNotification=I;class D{infinite(){}done(){}total(R){}worked(R){}}e.NoOpProgress=D}),define(Se[138],_e([0,1,6,9,2,3]),function(ee,e,r,t,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesSomeScheme=e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,P.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return r.Disposable.None},registerValidator(){return r.Disposable.None},registerExternalUriResolver(){return r.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return r.Disposable.None},async open(){return!1},async resolveExternalUri(D){return{resolved:D,dispose(){}}}});function A(D,T){return S.URI.isUri(D)?(0,t.equalsIgnoreCase)(D.scheme,T):(0,t.startsWithIgnoreCase)(D,T+":")}e.matchesScheme=A;function I(D,...T){return T.some(R=>A(D,R))}e.matchesSomeScheme=I});var xe=this&&this.__decorate||function(ee,e,r,t){var S=arguments.length,P=S<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,r):t,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")P=Reflect.decorate(ee,e,r,t);else for(var I=ee.length-1;I>=0;I--)(A=ee[I])&&(P=(S<3?A(P):S>3?A(e,r,P):A(e,r))||P);return S>3&&P&&Object.defineProperty(e,r,P),P},$e=this&&this.__param||function(ee,e){return function(r,t){e(r,t,ee)}};define(Se[139],_e([0,1,10,20,6,3]),function(ee,e,r,t,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,P.createDecorator)("progressService");var A;(function(R){R[R.Explorer=1]="Explorer",R[R.Scm=3]="Scm",R[R.Extensions=5]="Extensions",R[R.Window=10]="Window",R[R.Notification=15]="Notification",R[R.Dialog=20]="Dialog"})(A=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class I{constructor(b){this.callback=b}get value(){return this._value}report(b){this._value=b,this.callback(this._value)}}e.Progress=I,I.None=Object.freeze({report(){}});let D=class extends S.Disposable{constructor(b,i){super();this.deferred=new r.DeferredPromise,i.withProgress(b,f=>(this.reporter=f,this.lastStep&&f.report(this.lastStep),this.deferred.p)),this._register((0,S.toDisposable)(()=>this.deferred.complete()))}report(b){this.reporter?this.reporter.report(b):this.lastStep=b}};D=xe([$e(1,e.IProgressService)],D),e.UnmanagedProgress=D;class T extends S.Disposable{constructor(b){super();this.progressIndicator=b,this.currentOperationId=0,this.currentOperationDisposables=this._register(new S.DisposableStore)}start(b){this.stop();const i=++this.currentOperationId,f=new t.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{i===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},b),this.currentOperationDisposables.add((0,S.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,S.toDisposable)(()=>f.cancel())),this.currentOperationDisposables.add((0,S.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:i,token:f.token,stop:()=>this.doStop(i),isCurrent:()=>this.currentOperationId===i}}stop(){this.doStop(this.currentOperationId)}doStop(b){this.currentOperationId===b&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=T,e.IEditorProgressService=(0,P.createDecorator)("editorProgressService")}),define(Se[37],_e([0,1,42,13]),function(ee,e,r,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class S{constructor(){this.data=new Map}add(A,I){r.ok(t.isString(A)),r.ok(t.isObject(I)),r.ok(!this.data.has(A),"There is already an extension with this id"),this.data.set(A,I)}knows(A){return this.data.has(A)}as(A){return this.data.get(A)||null}}e.Registry=new S}),define(Se[140],_e([0,1,4,37]),function(ee,e,r,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function S(I){return I.length>0&&I.charAt(I.length-1)==="#"?I.substring(0,I.length-1):I}class P{constructor(){this._onDidChangeSchema=new r.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(D,T){this.schemasById[S(D)]=T,this._onDidChangeSchema.fire(D)}notifySchemaChanged(D){this._onDidChangeSchema.fire(D)}getSchemaContributions(){return{schemas:this.schemasById}}}const A=new P;t.Registry.add(e.Extensions.JSONContribution,A)}),define(Se[81],_e([0,1,16,4,13,114,140,37]),function(ee,e,r,t,S,P,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var D;(function(u){u.Multiline="multilineText",u.Singleline="singlelineText"})(D=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var T;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.MACHINE=2]="MACHINE",u[u.WINDOW=3]="WINDOW",u[u.RESOURCE=4]="RESOURCE",u[u.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",u[u.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(T=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const R=I.Registry.as(A.Extensions.JSONContribution);class b{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new t.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new t.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:P.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(C,l=!0){this.registerConfigurations([C],l)}registerConfigurations(C,l=!0){const F=this.doRegisterConfigurations(C,l);R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:F})}deregisterConfigurations(C){const l=this.doDeregisterConfigurations(C);R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:l})}updateConfigurations({add:C,remove:l}){const F=[];F.push(...this.doDeregisterConfigurations(l)),F.push(...this.doRegisterConfigurations(C,!1)),R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,r.distinct)(F)})}registerDefaultConfigurations(C){const l=[],F=[];for(const{overrides:c,source:n}of C)for(const h in c)if(l.push(h),e.OVERRIDE_PROPERTY_REGEX.test(h)){const g={...this.configurationDefaultsOverrides.get(h)?.value||{},...c[h]};this.configurationDefaultsOverrides.set(h,{source:n,value:g});const s={type:"object",default:g,description:P.localize(1,null,h),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:g,source:S.isString(n)?void 0:n};F.push(...a(h)),this.configurationProperties[h]=s,this.defaultLanguageConfigurationOverridesNode.properties[h]=s}else{this.configurationDefaultsOverrides.set(h,{value:c[h],source:n});const g=this.configurationProperties[h];g&&(this.updatePropertyDefaultValue(h,g),this.updateSchema(h,g))}this.registerOverrideIdentifiers(F),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:l,defaultsOverrides:!0})}deregisterDefaultConfigurations(C){const l=[];for(const{overrides:F,source:c}of C)for(const n in F){const h=this.configurationDefaultsOverrides.get(n),g=S.isString(c)?c:c?.id,s=S.isString(h?.source)?h?.source:h?.source?.id;if(g===s)if(l.push(n),this.configurationDefaultsOverrides.delete(n),e.OVERRIDE_PROPERTY_REGEX.test(n))delete this.configurationProperties[n],delete this.defaultLanguageConfigurationOverridesNode.properties[n];else{const d=this.configurationProperties[n];d&&(this.updatePropertyDefaultValue(n,d),this.updateSchema(n,d))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:l,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...C){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(C){for(const l of C)this.overrideIdentifiers.add(l);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(C,l){const F=[];return C.forEach(c=>{F.push(...this.validateAndRegisterProperties(c,l,c.extensionInfo,c.restrictedProperties)),this.configurationContributors.push(c),this.registerJSONConfiguration(c)}),F}doDeregisterConfigurations(C){const l=[],F=c=>{if(c.properties)for(const n in c.properties)l.push(n),delete this.configurationProperties[n],this.removeFromSchema(n,c.properties[n]);c.allOf&&c.allOf.forEach(n=>F(n))};for(const c of C){F(c);const n=this.configurationContributors.indexOf(c);n!==-1&&this.configurationContributors.splice(n,1)}return l}validateAndRegisterProperties(C,l=!0,F,c,n=3){n=S.isUndefinedOrNull(C.scope)?n:C.scope;let h=[],g=C.properties;if(g)for(let d in g){if(l&&y(d)){delete g[d];continue}const p=g[d];if(p.source=F,p.defaultDefaultValue=g[d].default,this.updatePropertyDefaultValue(d,p),e.OVERRIDE_PROPERTY_REGEX.test(d)?p.scope=void 0:(p.scope=S.isUndefinedOrNull(p.scope)?n:p.scope,p.restricted=S.isUndefinedOrNull(p.restricted)?!!c?.includes(d):p.restricted),g[d].hasOwnProperty("included")&&!g[d].included){this.excludedConfigurationProperties[d]=g[d],delete g[d];continue}else this.configurationProperties[d]=g[d];!g[d].deprecationMessage&&g[d].markdownDeprecationMessage&&(g[d].deprecationMessage=g[d].markdownDeprecationMessage),h.push(d)}let s=C.allOf;if(s)for(let d of s)h.push(...this.validateAndRegisterProperties(d,l,F,c,n));return h}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(C){const l=F=>{let c=F.properties;if(c)for(const h in c)this.updateSchema(h,c[h]);let n=F.allOf;n&&n.forEach(l)};l(C)}updateSchema(C,l){switch(e.allSettings.properties[C]=l,l.scope){case 1:e.applicationSettings.properties[C]=l;break;case 2:e.machineSettings.properties[C]=l;break;case 6:e.machineOverridableSettings.properties[C]=l;break;case 3:e.windowSettings.properties[C]=l;break;case 4:e.resourceSettings.properties[C]=l;break;case 5:e.resourceSettings.properties[C]=l,this.resourceLanguageSettingsSchema.properties[C]=l;break}}removeFromSchema(C,l){switch(delete e.allSettings.properties[C],l.scope){case 1:delete e.applicationSettings.properties[C];break;case 2:delete e.machineSettings.properties[C];break;case 6:delete e.machineOverridableSettings.properties[C];break;case 3:delete e.windowSettings.properties[C];break;case 4:case 5:delete e.resourceSettings.properties[C],delete this.resourceLanguageSettingsSchema.properties[C];break}}updateOverridePropertyPatternKey(){for(const C of this.overrideIdentifiers.values()){const l=`[${C}]`,F={type:"object",description:P.localize(2,null),errorMessage:P.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(l,F),e.allSettings.properties[l]=F,e.applicationSettings.properties[l]=F,e.machineSettings.properties[l]=F,e.machineOverridableSettings.properties[l]=F,e.windowSettings.properties[l]=F,e.resourceSettings.properties[l]=F}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const C={type:"object",description:P.localize(4,null),errorMessage:P.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=C,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=C,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=C,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=C,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=C,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=C,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(C,l){const F=this.configurationDefaultsOverrides.get(C);let c=F?.value,n=F?.source;S.isUndefined(c)&&(c=l.defaultDefaultValue,n=void 0),S.isUndefined(c)&&(c=m(l.type)),l.default=c,l.defaultValueSource=n}}const i="\\[([^\\]]+)\\]",f=new RegExp(i,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${i})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function a(u){const C=[];if(e.OVERRIDE_PROPERTY_REGEX.test(u)){let l=f.exec(u);for(;l?.length;){const F=l[1].trim();F&&C.push(F),l=f.exec(u)}}return(0,r.distinct)(C)}e.overrideIdentifiersFromKey=a;function o(u){return u.reduce((C,l)=>`${C}[${l}]`,"")}e.keyFromOverrideIdentifiers=o;function m(u){switch(Array.isArray(u)?u[0]:u){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=m;const M=new b;I.Registry.add(e.Extensions.Configuration,M);function y(u){return u.trim()?e.OVERRIDE_PROPERTY_REGEX.test(u)?P.localize(7,null,u):M.getConfigurationProperties()[u]!==void 0?P.localize(8,null,u):null:P.localize(6,null)}e.validateProperty=y;function _(){const u=[],C=M.getConfigurationProperties();for(const l of Object.keys(C))u.push([l,C[l].scope]);return u.push(["launch",4]),u.push(["task",4]),u}e.getScopes=_}),define(Se[141],_e([0,1,16,4,99,6,22,27,13,2,79,81,37]),function(ee,e,r,t,S,P,A,I,D,T,R,b,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class f{constructor(c={},n=[],h=[]){this._contents=c,this._keys=n,this._overrides=h,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(c){return c?(0,R.getConfigurationValue)(this.contents,c):this.contents}getOverrideValue(c,n){const h=this.getContentsForOverrideIdentifer(n);return h?c?(0,R.getConfigurationValue)(h,c):h:void 0}getKeysForOverrideIdentifier(c){const n=[];for(const h of this.overrides)h.identifiers.includes(c)&&n.push(...h.keys);return r.distinct(n)}getAllOverrideIdentifiers(){const c=[];for(const n of this.overrides)c.push(...n.identifiers);return r.distinct(c)}override(c){let n=this.overrideConfigurations.get(c);return n||(n=this.createOverrideConfigurationModel(c),this.overrideConfigurations.set(c,n)),n}merge(...c){const n=I.deepClone(this.contents),h=I.deepClone(this.overrides),g=[...this.keys];for(const s of c){this.mergeContents(n,s.contents);for(const d of s.overrides){const[p]=h.filter(w=>r.equals(w.identifiers,d.identifiers));p?(this.mergeContents(p.contents,d.contents),p.keys.push(...d.keys),p.keys=r.distinct(p.keys)):h.push(I.deepClone(d))}for(const d of s.keys)g.indexOf(d)===-1&&g.push(d)}return new f(n,g,h)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(c){const n=this.getContentsForOverrideIdentifer(c);if(!n||typeof n!="object"||!Object.keys(n).length)return this;let h={};for(const g of r.distinct([...Object.keys(this.contents),...Object.keys(n)])){let s=this.contents[g],d=n[g];d&&(typeof s=="object"&&typeof d=="object"?(s=I.deepClone(s),this.mergeContents(s,d)):s=d),h[g]=s}return new f(h,this.keys,this.overrides)}mergeContents(c,n){for(const h of Object.keys(n)){if(h in c&&D.isObject(c[h])&&D.isObject(n[h])){this.mergeContents(c[h],n[h]);continue}c[h]=I.deepClone(n[h])}}checkAndFreeze(c){return this.isFrozen&&!Object.isFrozen(c)?I.deepFreeze(c):c}getContentsForOverrideIdentifer(c){let n=null,h=null;const g=s=>{s&&(h?this.mergeContents(h,s):h=I.deepClone(s))};for(const s of this.overrides)r.equals(s.identifiers,[c])?n=s.contents:s.identifiers.includes(c)&&g(s.contents);return g(n),h}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(c,n){this.addKey(c),(0,R.addToValueTree)(this.contents,c,n,h=>{throw new Error(h)})}removeValue(c){this.removeKey(c)&&(0,R.removeFromValueTree)(this.contents,c)}addKey(c){let n=this.keys.length;for(let h=0;h<n;h++)c.indexOf(this.keys[h])===0&&(n=h);this.keys.splice(n,1,c)}removeKey(c){let n=this.keys.indexOf(c);return n!==-1?(this.keys.splice(n,1),!0):!1}}e.ConfigurationModel=f;class a extends f{constructor(c={}){const n=i.Registry.as(b.Extensions.Configuration).getConfigurationProperties(),h=Object.keys(n),g=Object.create(null),s=[];for(const d in n){const p=c[d],w=p!==void 0?p:n[d].default;(0,R.addToValueTree)(g,d,w,v=>console.error(`Conflict in default settings: ${v}`))}for(const d of Object.keys(g))b.OVERRIDE_PROPERTY_REGEX.test(d)&&s.push({identifiers:(0,b.overrideIdentifiersFromKey)(d),keys:Object.keys(g[d]),contents:(0,R.toValuesTree)(g[d],p=>console.error(`Conflict in default settings file: ${p}`))});super(g,h,s)}}e.DefaultConfigurationModel=a;class o{constructor(c){this._name=c,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new f}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(c,n){if(!D.isUndefinedOrNull(c)){const h=this.doParseContent(c);this.parseRaw(h,n)}}reparse(c){this._raw&&this.parseRaw(this._raw,c)}parseRaw(c,n){this._raw=c;const{contents:h,keys:g,overrides:s,restricted:d}=this.doParseRaw(c,n);this._configurationModel=new f(h,g,s),this._restrictedConfigurations=d||[]}doParseContent(c){let n={},h=null,g=[],s=[],d=[];function p(v){Array.isArray(g)?g.push(v):h!==null&&(g[h]=v)}let w={onObjectBegin:()=>{let v={};p(v),s.push(g),g=v,h=null},onObjectProperty:v=>{h=v},onObjectEnd:()=>{g=s.pop()},onArrayBegin:()=>{let v=[];p(v),s.push(g),g=v,h=null},onArrayEnd:()=>{g=s.pop()},onLiteralValue:p,onError:(v,k,L)=>{d.push({error:v,offset:k,length:L})}};if(c)try{S.visit(c,w),n=g[0]||{}}catch(v){console.error(`Error while parsing settings file ${this._name}: ${v}`),this._parseErrors=[v]}return n}doParseRaw(c,n){const h=i.Registry.as(b.Extensions.Configuration).getConfigurationProperties(),g=this.filter(c,h,!0,n);c=g.raw;const s=(0,R.toValuesTree)(c,w=>console.error(`Conflict in settings file ${this._name}: ${w}`)),d=Object.keys(c),p=this.toOverrides(c,w=>console.error(`Conflict in settings file ${this._name}: ${w}`));return{contents:s,keys:d,overrides:p,restricted:g.restricted}}filter(c,n,h,g){if(!g?.scopes&&!g?.skipRestricted)return{raw:c,restricted:[]};const s={},d=[];for(let p in c)if(b.OVERRIDE_PROPERTY_REGEX.test(p)&&h){const w=this.filter(c[p],n,!1,g);s[p]=w.raw,d.push(...w.restricted)}else{const w=n[p],v=w?typeof w.scope!="undefined"?w.scope:3:void 0;w?.restricted&&d.push(p),(v===void 0||g.scopes===void 0||g.scopes.includes(v))&&(g.skipRestricted&&w?.restricted||(s[p]=c[p]))}return{raw:s,restricted:d}}toOverrides(c,n){const h=[];for(const g of Object.keys(c))if(b.OVERRIDE_PROPERTY_REGEX.test(g)){const s={};for(const d in c[g])s[d]=c[g][d];h.push({identifiers:(0,b.overrideIdentifiersFromKey)(g),keys:Object.keys(s),contents:(0,R.toValuesTree)(s,n)})}return h}}e.ConfigurationModelParser=o;class m extends P.Disposable{constructor(c,n,h,g){super();this.userSettingsResource=c,this.scopes=n,this.fileService=g,this._onDidChange=this._register(new t.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new o(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(h.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(t.Event.filter(this.fileService.onDidFilesChange,s=>s.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const c=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(c.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new f}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=m;class M{constructor(c,n,h=new f,g=new f,s=new A.ResourceMap,d=new f,p=new A.ResourceMap,w=!0){this._defaultConfiguration=c,this._localUserConfiguration=n,this._remoteUserConfiguration=h,this._workspaceConfiguration=g,this._folderConfigurations=s,this._memoryConfiguration=d,this._memoryConfigurationByResource=p,this._freeze=w,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new A.ResourceMap,this._userConfiguration=null}getValue(c,n,h){return this.getConsolidateConfigurationModel(n,h).getValue(c)}updateValue(c,n,h={}){let g;h.resource?(g=this._memoryConfigurationByResource.get(h.resource),g||(g=new f,this._memoryConfigurationByResource.set(h.resource,g))):g=this._memoryConfiguration,n===void 0?g.removeValue(c):g.setValue(c,n),h.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(c,n,h){const g=this.getConsolidateConfigurationModel(n,h),s=this.getFolderConfigurationModelForResource(n.resource,h),d=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,p=n.overrideIdentifier?this._defaultConfiguration.freeze().override(n.overrideIdentifier).getValue(c):this._defaultConfiguration.freeze().getValue(c),w=n.overrideIdentifier?this.userConfiguration.freeze().override(n.overrideIdentifier).getValue(c):this.userConfiguration.freeze().getValue(c),v=n.overrideIdentifier?this.localUserConfiguration.freeze().override(n.overrideIdentifier).getValue(c):this.localUserConfiguration.freeze().getValue(c),k=n.overrideIdentifier?this.remoteUserConfiguration.freeze().override(n.overrideIdentifier).getValue(c):this.remoteUserConfiguration.freeze().getValue(c),L=h?n.overrideIdentifier?this._workspaceConfiguration.freeze().override(n.overrideIdentifier).getValue(c):this._workspaceConfiguration.freeze().getValue(c):void 0,E=s?n.overrideIdentifier?s.freeze().override(n.overrideIdentifier).getValue(c):s.freeze().getValue(c):void 0,O=n.overrideIdentifier?d.override(n.overrideIdentifier).getValue(c):d.getValue(c),U=g.getValue(c),j=r.distinct(r.flatten(g.overrides.map(H=>H.identifiers))).filter(H=>g.getOverrideValue(c,H)!==void 0);return{defaultValue:p,userValue:w,userLocalValue:v,userRemoteValue:k,workspaceValue:L,workspaceFolderValue:E,memoryValue:O,value:U,default:p!==void 0?{value:this._defaultConfiguration.freeze().getValue(c),override:n.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(c,n.overrideIdentifier):void 0}:void 0,user:w!==void 0?{value:this.userConfiguration.freeze().getValue(c),override:n.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(c,n.overrideIdentifier):void 0}:void 0,userLocal:v!==void 0?{value:this.localUserConfiguration.freeze().getValue(c),override:n.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(c,n.overrideIdentifier):void 0}:void 0,userRemote:k!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(c),override:n.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(c,n.overrideIdentifier):void 0}:void 0,workspace:L!==void 0?{value:this._workspaceConfiguration.freeze().getValue(c),override:n.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(c,n.overrideIdentifier):void 0}:void 0,workspaceFolder:E!==void 0?{value:s?.freeze().getValue(c),override:n.overrideIdentifier?s?.freeze().getOverrideValue(c,n.overrideIdentifier):void 0}:void 0,memory:O!==void 0?{value:d.getValue(c),override:n.overrideIdentifier?d.getOverrideValue(c,n.overrideIdentifier):void 0}:void 0,overrideIdentifiers:j.length?j:void 0}}keys(c){const n=this.getFolderConfigurationModelForResource(void 0,c);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:n?n.freeze().keys:[]}}updateDefaultConfiguration(c){this._defaultConfiguration=c,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(c){this._localUserConfiguration=c,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(c){this._remoteUserConfiguration=c,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(c){this._workspaceConfiguration=c,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(c,n){this._folderConfigurations.set(c,n),this._foldersConsolidatedConfigurations.delete(c)}deleteFolderConfiguration(c){this.folderConfigurations.delete(c),this._foldersConsolidatedConfigurations.delete(c)}compareAndUpdateDefaultConfiguration(c,n){const h=[];if(!n){const{added:g,updated:s,removed:d}=C(this._defaultConfiguration,c);n=[...g,...s,...d]}for(const g of n)for(const s of(0,b.overrideIdentifiersFromKey)(g)){const d=this._defaultConfiguration.getKeysForOverrideIdentifier(s),p=c.getKeysForOverrideIdentifier(s),w=[...p.filter(v=>d.indexOf(v)===-1),...d.filter(v=>p.indexOf(v)===-1),...d.filter(v=>!I.equals(this._defaultConfiguration.override(s).getValue(v),c.override(s).getValue(v)))];h.push([s,w])}return this.updateDefaultConfiguration(c),{keys:n,overrides:h}}compareAndUpdateLocalUserConfiguration(c){const{added:n,updated:h,removed:g,overrides:s}=C(this.localUserConfiguration,c),d=[...n,...h,...g];return d.length&&this.updateLocalUserConfiguration(c),{keys:d,overrides:s}}compareAndUpdateRemoteUserConfiguration(c){const{added:n,updated:h,removed:g,overrides:s}=C(this.remoteUserConfiguration,c);let d=[...n,...h,...g];return d.length&&this.updateRemoteUserConfiguration(c),{keys:d,overrides:s}}compareAndUpdateWorkspaceConfiguration(c){const{added:n,updated:h,removed:g,overrides:s}=C(this.workspaceConfiguration,c);let d=[...n,...h,...g];return d.length&&this.updateWorkspaceConfiguration(c),{keys:d,overrides:s}}compareAndUpdateFolderConfiguration(c,n){const h=this.folderConfigurations.get(c),{added:g,updated:s,removed:d,overrides:p}=C(h,n);let w=[...g,...s,...d];return(w.length||!h)&&this.updateFolderConfiguration(c,n),{keys:w,overrides:p}}compareAndDeleteFolderConfiguration(c){const n=this.folderConfigurations.get(c);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(c);const{added:h,updated:g,removed:s,overrides:d}=C(n,void 0);return{keys:[...h,...g,...s],overrides:d}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(c,n){let h=this.getConsolidatedConfigurationModelForResource(c,n);return c.overrideIdentifier?h.override(c.overrideIdentifier):h}getConsolidatedConfigurationModelForResource({resource:c},n){let h=this.getWorkspaceConsolidatedConfiguration();if(n&&c){const g=n.getFolder(c);g&&(h=this.getFolderConsolidatedConfiguration(g.uri)||h);const s=this._memoryConfigurationByResource.get(c);s&&(h=h.merge(s))}return h}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(c){let n=this._foldersConsolidatedConfigurations.get(c);if(!n){const h=this.getWorkspaceConsolidatedConfiguration(),g=this._folderConfigurations.get(c);g?(n=h.merge(g),this._freeze&&(n=n.freeze()),this._foldersConsolidatedConfigurations.set(c,n)):n=h}return n}getFolderConfigurationModelForResource(c,n){if(n&&c){const h=n.getFolder(c);if(h)return this._folderConfigurations.get(h.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((c,n)=>{const{contents:h,overrides:g,keys:s}=this._folderConfigurations.get(n);return c.push([n,{contents:h,overrides:g,keys:s}]),c},[])}}allKeys(){const c=new Set;return this._defaultConfiguration.freeze().keys.forEach(n=>c.add(n)),this.userConfiguration.freeze().keys.forEach(n=>c.add(n)),this._workspaceConfiguration.freeze().keys.forEach(n=>c.add(n)),this._folderConfigurations.forEach(n=>n.freeze().keys.forEach(h=>c.add(h))),[...c.values()]}allOverrideIdentifiers(){const c=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>c.add(n)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>c.add(n)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>c.add(n)),this._folderConfigurations.forEach(n=>n.freeze().getAllOverrideIdentifiers().forEach(h=>c.add(h))),[...c.values()]}getAllKeysForOverrideIdentifier(c){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(c).forEach(h=>n.add(h)),this.userConfiguration.getKeysForOverrideIdentifier(c).forEach(h=>n.add(h)),this._workspaceConfiguration.getKeysForOverrideIdentifier(c).forEach(h=>n.add(h)),this._folderConfigurations.forEach(h=>h.getKeysForOverrideIdentifier(c).forEach(g=>n.add(g))),[...n.values()]}static parse(c){const n=this.parseConfigurationModel(c.defaults),h=this.parseConfigurationModel(c.user),g=this.parseConfigurationModel(c.workspace),s=c.folders.reduce((d,p)=>(d.set(T.URI.revive(p[0]),this.parseConfigurationModel(p[1])),d),new A.ResourceMap);return new M(n,h,new f,g,s,new f,new A.ResourceMap,!1)}static parseConfigurationModel(c){return new f(c.contents,c.keys,c.overrides).freeze()}}e.Configuration=M;function y(...F){if(F.length===0)return{keys:[],overrides:[]};if(F.length===1)return F[0];const c=new Set,n=new Map;for(const g of F)g.keys.forEach(s=>c.add(s)),g.overrides.forEach(([s,d])=>{const p=(0,A.getOrSet)(n,s,new Set);d.forEach(w=>p.add(w))});const h=[];return n.forEach((g,s)=>h.push([s,[...g.values()]])),{keys:[...c.values()],overrides:h}}e.mergeChanges=y;class _{constructor(c,n,h,g){this.change=c,this.previous=n,this.currentConfiguraiton=h,this.currentWorkspace=g,this._previousConfiguration=void 0;const s=new Set;c.keys.forEach(p=>s.add(p)),c.overrides.forEach(([,p])=>p.forEach(w=>s.add(w))),this.affectedKeys=[...s.values()];const d=new f;this.affectedKeys.forEach(p=>d.setValue(p,{})),this.affectedKeysTree=d.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=M.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(c,n){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,c)){if(n){const h=this.previousConfiguration?this.previousConfiguration.getValue(c,n,this.previous?.workspace):void 0,g=this.currentConfiguraiton.getValue(c,n,this.currentWorkspace);return!I.equals(h,g)}return!0}return!1}doesAffectedKeysTreeContains(c,n){let h=(0,R.toValuesTree)({[n]:!0},()=>{}),g;for(;typeof h=="object"&&(g=Object.keys(h)[0]);){if(c=c[g],!c)return!1;h=h[g]}return!0}}e.ConfigurationChangeEvent=_;class u extends _{constructor(c,n,h,g){super({keys:c.allKeys(),overrides:[]},void 0,c,n);this.source=h,this.sourceConfig=g}}e.AllKeysConfigurationChangeEvent=u;function C(F,c){const{added:n,removed:h,updated:g}=l(c,F),s=[],d=F?.getAllOverrideIdentifiers()||[],p=c?.getAllOverrideIdentifiers()||[];if(c){const w=p.filter(v=>!d.includes(v));for(const v of w)s.push([v,c.getKeysForOverrideIdentifier(v)])}if(F){const w=d.filter(v=>!p.includes(v));for(const v of w)s.push([v,F.getKeysForOverrideIdentifier(v)])}if(c&&F){for(const w of d)if(p.includes(w)){const v=l({contents:F.getOverrideValue(void 0,w)||{},keys:F.getKeysForOverrideIdentifier(w)},{contents:c.getOverrideValue(void 0,w)||{},keys:c.getKeysForOverrideIdentifier(w)});s.push([w,[...v.added,...v.removed,...v.updated]])}}return{added:n,removed:h,updated:g,overrides:s}}function l(F,c){const n=F?c?F.keys.filter(s=>c.keys.indexOf(s)===-1):[...F.keys]:[],h=c?F?c.keys.filter(s=>F.keys.indexOf(s)===-1):[...c.keys]:[],g=[];if(F&&c){for(const s of c.keys)if(F.keys.indexOf(s)!==-1){const d=(0,R.getConfigurationValue)(c.contents,s),p=(0,R.getConfigurationValue)(F.contents,s);I.equals(d,p)||g.push(s)}}return{added:n,removed:h,updated:g}}}),define(Se[82],_e([0,1,3]),function(ee,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,r.createDecorator)("remoteAuthorityResolverService");var t;(function(P){P.Unknown="Unknown",P.NotAvailable="NotAvailable",P.TemporarilyNotAvailable="TemporarilyNotAvailable",P.NoResolverFound="NoResolverFound"})(t=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class S extends Error{constructor(A,I=t.Unknown,D){super(A);this._message=A,this._code=I,this._detail=D,this.isHandled=I===t.NotAvailable&&D===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,S.prototype)}static isTemporarilyNotAvailable(A){return A instanceof S&&A._code===t.TemporarilyNotAvailable}static isNoResolverFound(A){return A instanceof S&&A._code===t.NoResolverFound}static isHandled(A){return A instanceof S&&A.isHandled}}e.RemoteAuthorityResolverError=S}),define(Se[60],_e([0,1,11]),function(ee,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function t(T){return T.scheme===r.Schemas.vscodeRemote?T.authority:void 0}e.getRemoteAuthority=t;function S(T){if(!T)return;const R=T.indexOf("+");return R<0?T:T.substr(0,R)}e.getRemoteName=S;function P(T){return T.scheme!==r.Schemas.file&&T.scheme!==r.Schemas.vscodeRemote}e.isVirtualResource=P;function A(T){if(T.folders.length)return T.folders.every(R=>P(R.uri))?T.folders[0].uri:void 0;if(T.configuration&&P(T.configuration))return T.configuration}e.getVirtualWorkspaceLocation=A;function I(T){return A(T)?.scheme}e.getVirtualWorkspaceScheme=I;function D(T){return A(T)!==void 0}e.isVirtualWorkspace=D}),define(Se[25],_e([0,1,9,3,60]),function(ee,e,r,t,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function P(i){if(typeof i=="object"&&i!==null&&i.supported!==!0)return i.description}e.getWorkspaceSupportTypeMessage=P;function A(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}e.isIExtensionIdentifier=A,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var I;(function(i){i[i.System=0]="System",i[i.User=1]="User"})(I=e.ExtensionType||(e.ExtensionType={}));class D{constructor(f){this.value=f,this._lower=f.toLowerCase()}static equals(f,a){if(typeof f=="undefined"||f===null)return typeof a=="undefined"||a===null;if(typeof a=="undefined"||a===null)return!1;if(typeof f=="string"||typeof a=="string"){let o=typeof f=="string"?f:f.value,m=typeof a=="string"?a:a.value;return r.equalsIgnoreCase(o,m)}return f._lower===a._lower}static toKey(f){return typeof f=="string"?f.toLowerCase():f._lower}}e.ExtensionIdentifier=D;function T(i){return i.contributes&&i.contributes.localizations?i.contributes.localizations.length>0:!1}e.isLanguagePackExtension=T;function R(i){return i.contributes&&i.contributes.authentication?i.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=R;function b(i,f){if(f){const a=`onResolveRemoteAuthority:${(0,S.getRemoteName)(f)}`;return i.activationEvents?.indexOf(a)!==-1}return!1}e.isResolverExtension=b,e.IBuiltinExtensionsScannerService=(0,t.createDecorator)("IBuiltinExtensionsScannerService")}),define(Se[142],_e([0,1,9,25]),function(ee,e,r,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function S(a,o){return a.uuid&&o.uuid?a.uuid===o.uuid:a.id===o.id?!0:(0,r.compareIgnoreCase)(a.id,o.id)===0}e.areSameExtensions=S;class P{constructor(o,m){this.version=m,this.id=o.id,this.uuid=o.uuid}key(){return`${this.id}-${this.version}`}equals(o){return o instanceof P?S(this,o)&&this.version===o.version:!1}}e.ExtensionIdentifierWithVersion=P;function A(a,o){return`${a}.${o}`}e.getExtensionId=A;function I(a){return a.toLocaleLowerCase()}e.adoptToGalleryExtensionId=I;function D(a,o){return I(A(a,o))}e.getGalleryExtensionId=D;function T(a,o){const m=[],M=y=>{for(const _ of m)if(_.some(u=>S(o(u),o(y))))return _;return null};for(const y of a){const _=M(y);_?_.push(y):m.push([y])}return m}e.groupByExtension=T;function R(a){return{id:a.identifier.id,name:a.manifest.name,galleryId:null,publisherId:a.publisherId,publisherName:a.manifest.publisher,publisherDisplayName:a.publisherDisplayName,dependencies:a.manifest.extensionDependencies&&a.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=R;function b(a){return{id:a.identifier.id,name:a.name,galleryId:a.identifier.uuid,publisherId:a.publisherId,publisherName:a.publisher,publisherDisplayName:a.publisherDisplayName,isPreReleaseVersion:a.properties.isPreReleaseVersion,dependencies:!!(a.properties.dependencies&&a.properties.dependencies.length>0),...a.telemetryData}}e.getGalleryExtensionTelemetryData=b,e.BetterMergeId=new t.ExtensionIdentifier("pprice.better-merge");function i(a){const o=new Set;if(a.malicious)for(const m of a.malicious)o.add(m.id);return o}e.getMaliciousExtensionsSet=i;function f(a,o){const m=[],M=o.manifest.extensionDependencies?.slice(0)??[];for(;M.length;){const y=M.shift();if(y&&m.every(_=>!S(_.identifier,{id:y}))){const _=a.filter(u=>S(u.identifier,{id:y}));_.length===1&&(m.push(_[0]),M.push(..._[0].manifest.extensionDependencies?.slice(0)??[]))}}return m}e.getExtensionDependencies=f}),define(Se[143],_e([0,1,4,23,3,12]),function(ee,e,r,t,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,S.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,S.createDecorator)("sharedTunnelsService");var A;(function(a){a.Http="http",a.Https="https"})(A=e.TunnelProtocol||(e.TunnelProtocol={}));var I;(function(a){a.ConstantPrivate="constantPrivate",a.Private="private",a.Public="public"})(I=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var D;(function(a){a[a.Notify=1]="Notify",a[a.OpenBrowser=2]="OpenBrowser",a[a.OpenPreview=3]="OpenPreview",a[a.Silent=4]="Silent",a[a.Ignore=5]="Ignore",a[a.OpenBrowserOnce=6]="OpenBrowserOnce"})(D=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function T(a){if(a.scheme!=="http"&&a.scheme!=="https")return;const o=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(a.authority);if(!!o)return{address:o[1],port:+o[2]}}e.extractLocalHostUriMetaDataForPortMapping=T,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function R(a){return e.LOCALHOST_ADDRESSES.indexOf(a)>=0}e.isLocalhost=R,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function b(a){return e.ALL_INTERFACES_ADDRESSES.indexOf(a)>=0}e.isAllInterfaces=b;function i(a,o){return o?o!==1&&a<1024:!t.isWindows&&a<1024}e.isPortPrivileged=i;let f=class{constructor(o){this.logService=o,this._onTunnelOpened=new r.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new r.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new r.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(o){return this._tunnelProvider=o,o?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(o){this._canElevate=o.elevation,this._privacyOptions=o.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const o=[],m=Array.from(this._tunnels.values());for(let M of m){const y=Array.from(M.values());for(let _ of y){const u=await _.value;u&&o.push(u)}}return o}async dispose(){for(const o of this._tunnels.values()){for(const{value:m}of o.values())await m.then(M=>M?.dispose());o.clear()}this._tunnels.clear()}openTunnel(o,m,M,y,_=!1,u=I.Private,C){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${m}:${M} on local port ${y}.`),!o)return;m||(m="localhost");const l=this.retainOrCreateTunnel(o,m,M,y,_,u,C);return l?l.then(F=>{if(!F){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(m,M);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const c=this.makeTunnel(F);return(F.tunnelRemoteHost!==m||F.tunnelRemotePort!==M)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(c),c}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),l)}makeTunnel(o){return{tunnelRemotePort:o.tunnelRemotePort,tunnelRemoteHost:o.tunnelRemoteHost,tunnelLocalPort:o.tunnelLocalPort,localAddress:o.localAddress,privacy:o.privacy,protocol:o.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${o.tunnelRemoteHost}:${o.tunnelRemotePort} `);const m=this._tunnels.get(o.tunnelRemoteHost);if(m){const M=m.get(o.tunnelRemotePort);M&&(M.refcount--,await this.tryDisposeTunnel(o.tunnelRemoteHost,o.tunnelRemotePort,M))}}}}async tryDisposeTunnel(o,m,M){if(M.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${o}:${m}.`);const y=M.value.then(async _=>{_&&(await _.dispose(!0),this._onTunnelClosed.fire({host:_.tunnelRemoteHost,port:_.tunnelRemotePort}))});return this._tunnels.has(o)&&this._tunnels.get(o).delete(m),y}}async closeTunnel(o,m){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${o}:${m} `);const M=this._tunnels.get(o);if(M&&M.has(m)){const y=M.get(m);y.refcount=0,await this.tryDisposeTunnel(o,m,y)}}addTunnelToMap(o,m,M){this._tunnels.has(o)||this._tunnels.set(o,new Map),this._tunnels.get(o).set(m,{refcount:1,value:M})}async removeEmptyTunnelFromMap(o,m){const M=this._tunnels.get(o);M&&(await M.get(m)||M.delete(m),M.size===0&&this._tunnels.delete(o))}getTunnelFromMap(o,m){let M=[o];R(o)?(M.push(...e.LOCALHOST_ADDRESSES),M.push(...e.ALL_INTERFACES_ADDRESSES)):b(o)&&M.push(...e.ALL_INTERFACES_ADDRESSES);const y=M.map(_=>this._tunnels.get(_));for(const _ of y){const u=_?.get(m);if(u)return u}}canTunnel(o){return!!T(o)}createWithProvider(o,m,M,y,_,u,C){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${m}:${M} on local port ${y}.`);const F={elevationRequired:_?i(y===void 0?M:y):!1},c={remoteAddress:{host:m,port:M},localAddressPort:y,privacy:u,public:u!==I.Private,protocol:C},n=o.forwardPort(c,F);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),n&&this.addTunnelToMap(m,M,n),n}};f=xe([$e(0,P.ILogService)],f),e.AbstractTunnelService=f}),define(Se[144],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class r{constructor(S){this._callback=S,this._terminalBufferMap=new Map}dispose(){for(const S of this._terminalBufferMap.values())S.dispose()}startBuffering(S,P,A=5){let I;return I=P(D=>{const T=typeof D=="string"?D:D.data;let R=this._terminalBufferMap.get(S);if(R){R.data.push(T);return}const b=setTimeout(()=>this.flushBuffer(S),A);R={data:[T],timeoutId:b,dispose:()=>{clearTimeout(b),this.flushBuffer(S),I.dispose()}},this._terminalBufferMap.set(S,R)}),I}stopBuffering(S){const P=this._terminalBufferMap.get(S);P&&P.dispose()}flushBuffer(S){const P=this._terminalBufferMap.get(S);P&&(this._terminalBufferMap.delete(S),this._callback(S,P.data.join("")))}}e.TerminalDataBufferer=r}),define(Se[145],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var r;(function(t){t.DARK="dark",t.LIGHT="light",t.HIGH_CONTRAST="hc"})(r=e.ColorScheme||(e.ColorScheme={}))}),define(Se[61],_e([0,1,52,4,6,3,37,145]),function(ee,e,r,t,S,P,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,P.createDecorator)("themeService");var D;(function(m){function M(y){return y&&typeof y=="object"&&typeof y.id=="string"}m.isThemeColor=M})(D=e.ThemeColor||(e.ThemeColor={}));function T(m){return{id:m}}e.themeColorFromId=T;var R;(function(m){function M(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color=="undefined"||D.isThemeColor(n.color))}m.isThemeIcon=M;const y=new RegExp(`^\\$\\((${r.CSSIcon.iconNameExpression}(?:${r.CSSIcon.iconModifierExpression})?)\\)$`);function _(n){const h=y.exec(n);if(!h)return;let[,g]=h;return{id:g}}m.fromString=_;function u(n){return{id:n}}m.fromId=u;function C(n,h){let g=n.id;const s=g.lastIndexOf("~");return s!==-1&&(g=g.substring(0,s)),h&&(g=`${g}~${h}`),{id:g}}m.modify=C;function l(n){const h=n.id.lastIndexOf("~");if(h!==-1)return n.id.substring(h+1)}m.getModifier=l;function F(n,h){return n.id===h.id&&n.color?.id===h.color?.id}m.isEqual=F;function c(n,h){return{id:n.id,color:h?T(h):void 0}}m.asThemeIcon=c,m.asClassNameArray=r.CSSIcon.asClassNameArray,m.asClassName=r.CSSIcon.asClassName,m.asCSSSelector=r.CSSIcon.asCSSSelector})(R=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=r.Codicon.file,e.FolderThemeIcon=r.Codicon.folder;function b(m){switch(m){case I.ColorScheme.DARK:return"vs-dark";case I.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=b,e.Extensions={ThemingContribution:"base.contributions.theming"};class i{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new t.Emitter}onColorThemeChange(M){return this.themingParticipants.push(M),this.onThemingParticipantAddedEmitter.fire(M),(0,S.toDisposable)(()=>{const y=this.themingParticipants.indexOf(M);this.themingParticipants.splice(y,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let f=new i;A.Registry.add(e.Extensions.ThemingContribution,f);function a(m){return f.onColorThemeChange(m)}e.registerThemingParticipant=a;class o extends S.Disposable{constructor(M){super();this.themeService=M,this.theme=M.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(y=>this.onThemeChange(y)))}onThemeChange(M){this.theme=M,this.updateStyles()}updateStyles(){}getColor(M,y){let _=this.theme.getColor(M);return _&&y&&(_=y(_,this.theme)),_?_.toString():null}}e.Themable=o}),define(Se[47],_e([0,1,22,24,2,3]),function(ee,e,r,t,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,P.createDecorator)("contextService");var A;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(A=e.WorkbenchState||(e.WorkbenchState={}));function I(i){const f=i;return!!(f&&typeof f=="object"&&typeof f.id=="string"&&Array.isArray(f.folders))}e.isWorkspace=I;function D(i){const f=i;return!!(f&&typeof f=="object"&&S.URI.isUri(f.uri)&&typeof f.name=="string"&&typeof f.toResource=="function")}e.isWorkspaceFolder=D;class T{constructor(f,a,o,m,M){this._id=f,this._transient=o,this._configuration=m,this._ignorePathCasing=M,this._foldersMap=r.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=a}update(f){this._id=f.id,this._configuration=f.configuration,this._transient=f.transient,this._ignorePathCasing=f._ignorePathCasing,this.folders=f.folders}get folders(){return this._folders}set folders(f){this._folders=f,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(f){this._configuration=f}getFolder(f){return f&&this._foldersMap.findSubstr(f.with({scheme:f.scheme,authority:f.authority,path:f.path}))||null}updateFoldersMap(){this._foldersMap=r.TernarySearchTree.forUris(this._ignorePathCasing);for(const f of this.folders)this._foldersMap.set(f.uri,f)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=T;class R{constructor(f,a){this.raw=a,this.uri=f.uri,this.index=f.index,this.name=f.name}toResource(f){return(0,t.joinPath)(this.uri,f)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=R;function b(i){return new R({uri:i,index:0,name:(0,t.basenameOrAuthority)(i)},{uri:i.toString()})}e.toWorkspaceFolder=b}),define(Se[62],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class r{constructor(S){this.id=S,this._data=new Map,this._idPool=1}add(S){const P=this._idPool++;return this._data.set(P,S),this.logDebugInfo(),P}get(S,P){return this._data.has(S)?this._data.get(S)[P]:void 0}delete(S){this._data.delete(S),this.logDebugInfo()}logDebugInfo(){!r.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=r,r.enableDebugLogging=!1}),define(Se[30],_e([0,1,11,24,3]),function(ee,e,r,t,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class P{constructor(){this._systemSchemes=new Set(Object.keys(r.Schemas)),this._providerInfo=new Map,this.extUri=new t.ExtUri(I=>{const D=this._providerInfo.get(I.scheme);return!(D===void 0||D&1024)})}$acceptProviderInfos(I,D){D===null?this._providerInfo.delete(I.scheme):this._providerInfo.set(I.scheme,D)}isFreeScheme(I){return!this._providerInfo.has(I)&&!this._systemSchemes.has(I)}getCapabilities(I){return this._providerInfo.get(I)}}e.ExtHostFileSystemInfo=P,e.IExtHostFileSystemInfo=(0,S.createDecorator)("IExtHostFileSystemInfo")}),define(Se[28],_e([0,1,3]),function(ee,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,r.createDecorator)("IExtHostInitDataService")}),define(Se[146],_e([0,1,10]),function(ee,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class t{constructor(A,I,D){this._deferredPromises=new Map,this._id=A,this._shared=I,this._storage=D,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(T=>(this._value=T,this)),this._storageListener=this._storage.onDidChangeStorage(T=>{T.shared===this._shared&&T.key===this._id&&(this._value=T.value)}),this._scheduler=new r.RunOnceScheduler(()=>{const T=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const R of T.values())R.complete()}catch(R){for(const b of T.values())b.error(R)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,A])=>A!==void 0).map(([A])=>A)}get whenReady(){return this._init}get(A,I){let D=this._value[A];return typeof D=="undefined"&&(D=I),D}update(A,I){this._value[A]=I;let D=this._deferredPromises.get(A);if(D!==void 0)return D.p;const T=new r.DeferredPromise;return this._deferredPromises.set(A,T),this._scheduler.isScheduled()||this._scheduler.schedule(),T.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=t;class S extends t{constructor(A,I){super(A.identifier.value,!0,I);this._extension=A}setKeysForSync(A){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},A)}}e.ExtensionGlobalMemento=S}),define(Se[147],_e([0,1,4,2,12]),function(ee,e,r,t,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let P=class{constructor(I,D){this._logService=I,this._notebooksAndEditors=D,this._onDidChangeNotebookDocumentMetadata=new r.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new r.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(I,D,T){this._notebooksAndEditors.getNotebookDocument(t.URI.revive(I)).acceptModelChanged(D.value,T)}$acceptDirtyStateChanged(I,D){this._notebooksAndEditors.getNotebookDocument(t.URI.revive(I)).acceptDirty(D)}$acceptModelSaved(I){const D=this._notebooksAndEditors.getNotebookDocument(t.URI.revive(I));this._onDidSaveNotebookDocument.fire(D.apiNotebook)}$acceptDocumentPropertiesChanged(I,D){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",I.path,D);const T=this._notebooksAndEditors.getNotebookDocument(t.URI.revive(I));T.acceptDocumentPropertiesChanged(D),D.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:T.apiNotebook})}};P=xe([$e(0,S.ILogService)],P),e.ExtHostNotebookDocuments=P}),define(Se[14],_e([0,1,3]),function(ee,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,r.createDecorator)("IExtHostRpcService");class t{constructor(P){this.getProxy=P.getProxy.bind(P),this.set=P.set.bind(P),this.assertRegistered=P.assertRegistered.bind(P),this.drain=P.drain.bind(P)}}e.ExtHostRpcService=t});var Xe=this&&this.__classPrivateFieldSet||function(ee,e,r,t,S){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!S:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?S.call(ee,r):S?S.value=r:e.set(ee,r),r},Ie=this&&this.__classPrivateFieldGet||function(ee,e,r,t){if(r==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!t:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?t:r==="a"?t.call(ee):t?t.value:e.get(ee)};define(Se[148],_e([0,1,25,4]),function(ee,e,r,t){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class P{constructor(I,D){S.set(this,void 0),this._onDidChange=new t.Emitter,this.onDidChange=this._onDidChange.event,this._id=r.ExtensionIdentifier.toKey(I.identifier),Xe(this,S,D,"f"),Ie(this,S,"f").onDidChangePassword(T=>{T.extensionId===this._id&&this._onDidChange.fire({key:T.key})})}get(I){return Ie(this,S,"f").get(this._id,I)}store(I,D){return Ie(this,S,"f").store(this._id,I,D)}delete(I){return Ie(this,S,"f").delete(this._id,I)}}e.ExtensionSecrets=P,S=new WeakMap}),define(Se[83],_e([0,1,3,4]),function(ee,e,r,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class S{constructor(){this._onDidChangeTelemetryEnabled=new t.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(A){this._enabled=A}$onDidChangeTelemetryEnabled(A){this._enabled=A,this._onDidChangeTelemetryEnabled.fire(A)}}e.ExtHostTelemetry=S,e.IExtHostTelemetry=(0,r.createDecorator)("IExtHostTelemetry")}),define(Se[48],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var r;(function(y){y[y.Upsert=0]="Upsert",y[y.RemoveChild=1]="RemoveChild",y[y.Invalidated=2]="Invalidated",y[y.SetProp=3]="SetProp",y[y.Bulk=4]="Bulk"})(r=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const t=new WeakMap,S=(y,_)=>{const u={controllerId:_};return t.set(y,u),u};e.createPrivateApiFor=S;const P=y=>t.get(y);e.getPrivateApiFor=P;const A=(y,_,u,C)=>{let l=u;return{enumerable:!0,configurable:!1,get(){return l},set(F){if(!C(l,F)){const c=l;l=F,y.listener?.({op:3,key:_,value:F,previous:c})}}}},I=(y,_)=>y===_,D={range:(y,_)=>y===_?!0:!y||!_?!1:y.isEqual(_),label:I,description:I,busy:I,error:I,canResolveChildren:I,tags:(y,_)=>!(y.length!==_.length||y.some(u=>!_.find(C=>u.id===C.id)))},T=Object.keys(D),R=(y,_)=>({range:A(y,"range",void 0,D.range),label:A(y,"label",_,D.label),description:A(y,"description",void 0,D.description),canResolveChildren:A(y,"canResolveChildren",!1,D.canResolveChildren),busy:A(y,"busy",!1,D.busy),error:A(y,"error",void 0,D.error),tags:A(y,"tags",[],D.tags)}),b=(y,_)=>{const u=new Map;for(const C of T)D[C](y[C],_[C])||u.set(C,_[C]);return u};e.diffTestItems=b;class i extends Error{constructor(_){super(`Attempted to insert a duplicate test item ID ${_}`)}}e.DuplicateTestItemError=i;class f extends Error{constructor(_){super(`TestItem with ID "${_}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=f;class a extends Error{constructor(_,u,C){super(`TestItem with ID "${_}" is from controller "${u}" and cannot be added as a child of an item from controller "${C}".`)}}e.MixedTestItemController=a;const o=y=>{const _=(0,e.getPrivateApiFor)(y);let u=new Map;return{get size(){return u.size},forEach(C,l){for(const F of u.values())C.call(l,F,this)},replace(C){const l=new Map,F=new Set(u.keys()),c={op:4,ops:[]};for(const n of C){if(!(n instanceof m))throw new f(n.id);const h=(0,e.getPrivateApiFor)(n).controllerId;if(h!==_.controllerId)throw new a(n.id,h,_.controllerId);if(l.has(n.id))throw new i(n.id);l.set(n.id,n),F.delete(n.id),c.ops.push({op:0,item:n})}for(const n of F.keys())c.ops.push({op:1,id:n});_.listener?.(c),u=l},add(C){if(!(C instanceof m))throw new f(C.id);u.set(C.id,C),_.listener?.({op:0,item:C})},delete(C){u.delete(C)&&_.listener?.({op:1,id:C})},get(C){return u.get(C)},toJSON(){return Array.from(u.values())},[Symbol.iterator](){return u.values()}}};class m{constructor(_,u,C,l){if(u.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(u)} symbol`);const F=(0,e.createPrivateApiFor)(this,_);Object.defineProperties(this,{id:{value:u,enumerable:!0,writable:!1},uri:{value:l,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return F.parent instanceof M?void 0:F.parent}},children:{value:o(this),enumerable:!0,writable:!1},...R(F,C)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=m;class M extends m{constructor(_,u){super(_,_,u,void 0)}}e.TestItemRootImpl=M}),define(Se[63],_e([0,1,3,143,4,14]),function(ee,e,r,t,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var A;(function(D){function T(b){return{remoteAddress:b.remoteAddress,localAddress:b.localAddress,public:!!b.public,privacy:b.privacy??(b.public?t.TunnelPrivacyId.Public:t.TunnelPrivacyId.Private),protocol:b.protocol}}D.fromApiTunnel=T;function R(b){return{remoteAddress:{host:b.tunnelRemoteHost,port:b.tunnelRemotePort},localAddress:b.localAddress,public:b.privacy!==t.TunnelPrivacyId.ConstantPrivate&&b.privacy!==t.TunnelPrivacyId.ConstantPrivate,privacy:b.privacy,protocol:b.protocol}}D.fromServiceTunnel=R})(A=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,r.createDecorator)("IExtHostTunnelService");let I=class{constructor(T){this.onDidChangeTunnels=new S.Emitter().event}async $applyCandidateFilter(T){return T}async openTunnel(T,R){}async getTunnels(){return[]}async setTunnelFactory(T){return{dispose:()=>{}}}registerPortsAttributesProvider(T,R){return{dispose:()=>{}}}async $providePortAttributes(T,R,b,i,f){return[]}async $forwardPort(T,R){}async $closeTunnel(T){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};I=xe([$e(0,P.IExtHostRpcService)],I),e.ExtHostTunnelService=I});var Xe=this&&this.__classPrivateFieldSet||function(ee,e,r,t,S){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!S:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?S.call(ee,r):S?S.value=r:e.set(ee,r),r},Ie=this&&this.__classPrivateFieldGet||function(ee,e,r,t){if(r==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!t:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?t:r==="a"?t.call(ee):t?t.value:e.get(ee)};define(Se[7],_e([0,1,16,15,75,22,74,9,13,2,36,46,82]),function(ee,e,r,t,S,P,A,I,D,T,R,b,i){"use strict";var f,a,o,m,M,y,_,u,C,l,F,c,n,h,g,s,d,p,w,v;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeDataTransfer=e.TreeDataTransferItem=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function k(B){function N(){return Reflect.construct(B,arguments,this.constructor)}return Object.defineProperty(N,"name",Object.getOwnPropertyDescriptor(B,"name")),Object.setPrototypeOf(N,B),Object.setPrototypeOf(N.prototype,B.prototype),N}let L=M=class{constructor(N){f.set(this,void 0),Xe(this,f,N,"f")}static from(...N){let Z=N;return new M(function(){if(Z){for(const Ce of Z)Ce&&typeof Ce.dispose=="function"&&Ce.dispose();Z=void 0}})}dispose(){typeof Ie(this,f,"f")=="function"&&(Ie(this,f,"f").call(this),Xe(this,f,void 0,"f"))}};f=new WeakMap,L=M=xe([k],L),e.Disposable=L;let E=y=class{constructor(N,Z){if(N<0)throw(0,t.illegalArgument)("line must be non-negative");if(Z<0)throw(0,t.illegalArgument)("character must be non-negative");this._line=N,this._character=Z}static Min(...N){if(N.length===0)throw new TypeError;let Z=N[0];for(let Ce=1;Ce<N.length;Ce++){const Ke=N[Ce];Ke.isBefore(Z)&&(Z=Ke)}return Z}static Max(...N){if(N.length===0)throw new TypeError;let Z=N[0];for(let Ce=1;Ce<N.length;Ce++){const Ke=N[Ce];Ke.isAfter(Z)&&(Z=Ke)}return Z}static isPosition(N){if(!N)return!1;if(N instanceof y)return!0;let{line:Z,character:Ce}=N;return typeof Z=="number"&&typeof Ce=="number"}get line(){return this._line}get character(){return this._character}isBefore(N){return this._line<N._line?!0:N._line<this._line?!1:this._character<N._character}isBeforeOrEqual(N){return this._line<N._line?!0:N._line<this._line?!1:this._character<=N._character}isAfter(N){return!this.isBeforeOrEqual(N)}isAfterOrEqual(N){return!this.isBefore(N)}isEqual(N){return this._line===N._line&&this._character===N._character}compareTo(N){return this._line<N._line?-1:this._line>N.line?1:this._character<N._character?-1:this._character>N._character?1:0}translate(N,Z=0){if(N===null||Z===null)throw(0,t.illegalArgument)();let Ce;return typeof N=="undefined"?Ce=0:typeof N=="number"?Ce=N:(Ce=typeof N.lineDelta=="number"?N.lineDelta:0,Z=typeof N.characterDelta=="number"?N.characterDelta:0),Ce===0&&Z===0?this:new y(this.line+Ce,this.character+Z)}with(N,Z=this.character){if(N===null||Z===null)throw(0,t.illegalArgument)();let Ce;return typeof N=="undefined"?Ce=this.line:typeof N=="number"?Ce=N:(Ce=typeof N.line=="number"?N.line:this.line,Z=typeof N.character=="number"?N.character:this.character),Ce===this.line&&Z===this.character?this:new y(Ce,Z)}toJSON(){return{line:this.line,character:this.character}}};E=y=xe([k],E),e.Position=E;let O=_=class{constructor(N,Z,Ce,Ke){let it,ct;if(typeof N=="number"&&typeof Z=="number"&&typeof Ce=="number"&&typeof Ke=="number"?(it=new E(N,Z),ct=new E(Ce,Ke)):N instanceof E&&Z instanceof E&&(it=N,ct=Z),!it||!ct)throw new Error("Invalid arguments");it.isBefore(ct)?(this._start=it,this._end=ct):(this._start=ct,this._end=it)}static isRange(N){return N instanceof _?!0:N?E.isPosition(N.start)&&E.isPosition(N.end):!1}get start(){return this._start}get end(){return this._end}contains(N){return N instanceof _?this.contains(N._start)&&this.contains(N._end):N instanceof E?!(N.isBefore(this._start)||this._end.isBefore(N)):!1}isEqual(N){return this._start.isEqual(N._start)&&this._end.isEqual(N._end)}intersection(N){const Z=E.Max(N.start,this._start),Ce=E.Min(N.end,this._end);if(!Z.isAfter(Ce))return new _(Z,Ce)}union(N){if(this.contains(N))return this;if(N.contains(this))return N;const Z=E.Min(N.start,this._start),Ce=E.Max(N.end,this.end);return new _(Z,Ce)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(N,Z=this.end){if(N===null||Z===null)throw(0,t.illegalArgument)();let Ce;return N?E.isPosition(N)?Ce=N:(Ce=N.start||this.start,Z=N.end||this.end):Ce=this.start,Ce.isEqual(this._start)&&Z.isEqual(this.end)?this:new _(Ce,Z)}toJSON(){return[this.start,this.end]}};O=_=xe([k],O),e.Range=O;let U=u=class extends O{constructor(N,Z,Ce,Ke){let it,ct;if(typeof N=="number"&&typeof Z=="number"&&typeof Ce=="number"&&typeof Ke=="number"?(it=new E(N,Z),ct=new E(Ce,Ke)):N instanceof E&&Z instanceof E&&(it=N,ct=Z),!it||!ct)throw new Error("Invalid arguments");super(it,ct);this._anchor=it,this._active=ct}static isSelection(N){return N instanceof u?!0:N?O.isRange(N)&&E.isPosition(N.anchor)&&E.isPosition(N.active)&&typeof N.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};U=u=xe([k],U),e.Selection=U;class j{constructor(N,Z,Ce){if(typeof N!="string"||N.length===0)throw(0,t.illegalArgument)("host");if(typeof Z!="number"||Z===0||Math.round(Z)!==Z)throw(0,t.illegalArgument)("port");if(typeof Ce!="undefined"&&(typeof Ce!="string"||Ce.length===0||!/^[0-9A-Za-z\-]+$/.test(Ce)))throw(0,t.illegalArgument)("connectionToken");this.host=N,this.port=Math.round(Z),this.connectionToken=Ce}}e.ResolvedAuthority=j;class H extends Error{constructor(N,Z=i.RemoteAuthorityResolverErrorCode.Unknown,Ce){super(N);this._message=N,this._code=Z,this._detail=Ce,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,H.prototype)}static NotAvailable(N,Z){return new H(N,i.RemoteAuthorityResolverErrorCode.NotAvailable,Z)}static TemporarilyNotAvailable(N){return new H(N,i.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=H;var $;(function(B){B[B.LF=1]="LF",B[B.CRLF=2]="CRLF"})($=e.EndOfLine||(e.EndOfLine={}));var G;(function(B){B[B.Replace=1]="Replace",B[B.Append=2]="Append",B[B.Prepend=3]="Prepend"})(G=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let ie=C=class{constructor(N,Z){this._range=N,this._newText=Z}static isTextEdit(N){return N instanceof C?!0:N?O.isRange(N)&&typeof N.newText=="string":!1}static replace(N,Z){return new C(N,Z)}static insert(N,Z){return C.replace(new O(N,N),Z)}static delete(N){return C.replace(N,"")}static setEndOfLine(N){const Z=new C(new O(new E(0,0),new E(0,0)),"");return Z.newEol=N,Z}get range(){return this._range}set range(N){if(N&&!O.isRange(N))throw(0,t.illegalArgument)("range");this._range=N}get newText(){return this._newText||""}set newText(N){if(N&&typeof N!="string")throw(0,t.illegalArgument)("newText");this._newText=N}get newEol(){return this._newEol}set newEol(N){if(N&&typeof N!="number")throw(0,t.illegalArgument)("newEol");this._newEol=N}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};ie=C=xe([k],ie),e.TextEdit=ie;var le;(function(B){B[B.File=1]="File",B[B.Text=2]="Text",B[B.Cell=3]="Cell",B[B.CellReplace=5]="CellReplace"})(le=e.FileEditType||(e.FileEditType={}));let X=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(N,Z,Ce,Ke){this._edits.push({_type:1,from:N,to:Z,options:Ce,metadata:Ke})}createFile(N,Z,Ce){this._edits.push({_type:1,from:void 0,to:N,options:Z,metadata:Ce})}deleteFile(N,Z,Ce){this._edits.push({_type:1,from:N,to:void 0,options:Z,metadata:Ce})}replaceNotebookMetadata(N,Z,Ce){this._edits.push({_type:3,metadata:Ce,uri:N,edit:{editType:5,metadata:Z},notebookMetadata:Z})}replaceNotebookCells(N,Z,Ce,Ke,it){let ct,ft,Pt=[],Ft;if(zt.isNotebookRange(Z)&&Bt.isNotebookCellDataArray(Ce)&&!Bt.isNotebookCellDataArray(Ke)?(ct=Z.start,ft=Z.end,Pt=Ce,Ft=Ke):typeof Z=="number"&&typeof Ce=="number"&&Bt.isNotebookCellDataArray(Ke)&&(ct=Z,ft=Ce,Pt=Ke,Ft=it),ct===void 0||ft===void 0)throw new Error("Invalid arguments");(ct!==ft||Pt.length>0)&&this._edits.push({_type:5,uri:N,index:ct,count:ft-ct,cells:Pt,metadata:Ft})}replaceNotebookCellMetadata(N,Z,Ce,Ke){this._edits.push({_type:3,metadata:Ke,uri:N,edit:{editType:8,index:Z,metadata:Ce}})}replace(N,Z,Ce,Ke){this._edits.push({_type:2,uri:N,edit:new ie(Z,Ce),metadata:Ke})}insert(N,Z,Ce,Ke){this.replace(N,new O(Z,Z),Ce,Ke)}delete(N,Z,Ce){this.replace(N,Z,"",Ce)}has(N){return this._edits.some(Z=>Z._type===2&&Z.uri.toString()===N.toString())}set(N,Z){if(Z)for(const Ce of Z)Ce&&this._edits.push({_type:2,uri:N,edit:Ce});else{for(let Ce=0;Ce<this._edits.length;Ce++){const Ke=this._edits[Ce];Ke._type===2&&Ke.uri.toString()===N.toString()&&(this._edits[Ce]=void 0)}(0,r.coalesceInPlace)(this._edits)}}get(N){const Z=[];for(let Ce of this._edits)Ce._type===2&&Ce.uri.toString()===N.toString()&&Z.push(Ce.edit);return Z}entries(){const N=new P.ResourceMap;for(let Z of this._edits)if(Z._type===2){let Ce=N.get(Z.uri);Ce||(Ce=[Z.uri,[]],N.set(Z.uri,Ce)),Ce[1].push(Z.edit)}return[...N.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};X=xe([k],X),e.WorkspaceEdit=X;let ue=l=class{constructor(N){this._tabstop=1,this.value=N||""}static isSnippetString(N){return N instanceof l?!0:N?typeof N.value=="string":!1}static _escape(N){return N.replace(/\$|}|\\/g,"\\$&")}appendText(N){return this.value+=l._escape(N),this}appendTabstop(N=this._tabstop++){return this.value+="$",this.value+=N,this}appendPlaceholder(N,Z=this._tabstop++){if(typeof N=="function"){const Ce=new l;Ce._tabstop=this._tabstop,N(Ce),this._tabstop=Ce._tabstop,N=Ce.value}else N=l._escape(N);return this.value+="${",this.value+=Z,this.value+=":",this.value+=N,this.value+="}",this}appendChoice(N,Z=this._tabstop++){const Ce=N.map(Ke=>Ke.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=Z,this.value+="|",this.value+=Ce,this.value+="|}",this}appendVariable(N,Z){if(typeof Z=="function"){const Ce=new l;Ce._tabstop=this._tabstop,Z(Ce),this._tabstop=Ce._tabstop,Z=Ce.value}else typeof Z=="string"&&(Z=Z.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=N,Z&&(this.value+=":",this.value+=Z),this.value+="}",this}};ue=l=xe([k],ue),e.SnippetString=ue;var ve;(function(B){B[B.Unnecessary=1]="Unnecessary",B[B.Deprecated=2]="Deprecated"})(ve=e.DiagnosticTag||(e.DiagnosticTag={}));var ge;(function(B){B[B.Hint=3]="Hint",B[B.Information=2]="Information",B[B.Warning=1]="Warning",B[B.Error=0]="Error"})(ge=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let we=F=class{constructor(N,Z){if(this.uri=N,Z)if(Z instanceof O)this.range=Z;else if(Z instanceof E)this.range=new O(Z,Z);else throw new Error("Illegal argument")}static isLocation(N){return N instanceof F?!0:N?O.isRange(N.range)&&T.URI.isUri(N.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};we=F=xe([k],we),e.Location=we;let re=class{constructor(N,Z){this.location=N,this.message=Z}static is(N){return N?typeof N.message=="string"&&N.location&&O.isRange(N.location.range)&&T.URI.isUri(N.location.uri):!1}static isEqual(N,Z){return N===Z?!0:!N||!Z?!1:N.message===Z.message&&N.location.range.isEqual(Z.location.range)&&N.location.uri.toString()===Z.location.uri.toString()}};re=xe([k],re),e.DiagnosticRelatedInformation=re;let be=class{constructor(N,Z,Ce=ge.Error){if(!O.isRange(N))throw new TypeError("range must be set");if(!Z)throw new TypeError("message must be set");this.range=N,this.message=Z,this.severity=Ce}toJSON(){return{severity:ge[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(N,Z){return N===Z?!0:!N||!Z?!1:N.message===Z.message&&N.severity===Z.severity&&N.code===Z.code&&N.severity===Z.severity&&N.source===Z.source&&N.range.isEqual(Z.range)&&(0,r.equals)(N.tags,Z.tags)&&(0,r.equals)(N.relatedInformation,Z.relatedInformation,re.isEqual)}};be=xe([k],be),e.Diagnostic=be;let Pe=class{constructor(N,Z){if(!N)throw new Error("Illegal argument, contents must be defined");Array.isArray(N)?this.contents=N:this.contents=[N],this.range=Z}};Pe=xe([k],Pe),e.Hover=Pe;var Fe;(function(B){B[B.Text=0]="Text",B[B.Read=1]="Read",B[B.Write=2]="Write"})(Fe=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let ze=class{constructor(N,Z=Fe.Text){this.range=N,this.kind=Z}toJSON(){return{range:this.range,kind:Fe[this.kind]}}};ze=xe([k],ze),e.DocumentHighlight=ze;var nt;(function(B){B[B.File=0]="File",B[B.Module=1]="Module",B[B.Namespace=2]="Namespace",B[B.Package=3]="Package",B[B.Class=4]="Class",B[B.Method=5]="Method",B[B.Property=6]="Property",B[B.Field=7]="Field",B[B.Constructor=8]="Constructor",B[B.Enum=9]="Enum",B[B.Interface=10]="Interface",B[B.Function=11]="Function",B[B.Variable=12]="Variable",B[B.Constant=13]="Constant",B[B.String=14]="String",B[B.Number=15]="Number",B[B.Boolean=16]="Boolean",B[B.Array=17]="Array",B[B.Object=18]="Object",B[B.Key=19]="Key",B[B.Null=20]="Null",B[B.EnumMember=21]="EnumMember",B[B.Struct=22]="Struct",B[B.Event=23]="Event",B[B.Operator=24]="Operator",B[B.TypeParameter=25]="TypeParameter"})(nt=e.SymbolKind||(e.SymbolKind={}));var et;(function(B){B[B.Deprecated=1]="Deprecated"})(et=e.SymbolTag||(e.SymbolTag={}));let Ze=c=class{constructor(N,Z,Ce,Ke,it){this.name=N,this.kind=Z,this.containerName=it,typeof Ce=="string"&&(this.containerName=Ce),Ke instanceof we?this.location=Ke:Ce instanceof O&&(this.location=new we(Ke,Ce)),c.validate(this)}static validate(N){if(!N.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:nt[this.kind],location:this.location,containerName:this.containerName}}};Ze=c=xe([k],Ze),e.SymbolInformation=Ze;let x=n=class{constructor(N,Z,Ce,Ke,it){this.name=N,this.detail=Z,this.kind=Ce,this.range=Ke,this.selectionRange=it,this.children=[],n.validate(this)}static validate(N){if(!N.name)throw new Error("name must not be falsy");if(!N.range.contains(N.selectionRange))throw new Error("selectionRange must be contained in fullRange");N.children&&N.children.forEach(n.validate)}};x=n=xe([k],x),e.DocumentSymbol=x;var K;(function(B){B[B.Invoke=1]="Invoke",B[B.Automatic=2]="Automatic"})(K=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let z=class{constructor(N,Z){this.title=N,this.kind=Z}};z=xe([k],z),e.CodeAction=z;let V=h=class{constructor(N){this.value=N}append(N){return new h(this.value?this.value+h.sep+N:N)}intersects(N){return this.contains(N)||N.contains(this)}contains(N){return this.value===N.value||N.value.startsWith(this.value+h.sep)}};V.sep=".",V=h=xe([k],V),e.CodeActionKind=V,V.Empty=new V(""),V.QuickFix=V.Empty.append("quickfix"),V.Refactor=V.Empty.append("refactor"),V.RefactorExtract=V.Refactor.append("extract"),V.RefactorInline=V.Refactor.append("inline"),V.RefactorRewrite=V.Refactor.append("rewrite"),V.Source=V.Empty.append("source"),V.SourceOrganizeImports=V.Source.append("organizeImports"),V.SourceFixAll=V.Source.append("fixAll");let Y=class{constructor(N,Z){if(this.range=N,this.parent=Z,Z&&!Z.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};Y=xe([k],Y),e.SelectionRange=Y;class se{constructor(N,Z,Ce,Ke,it,ct){this.kind=N,this.name=Z,this.detail=Ce,this.uri=Ke,this.range=it,this.selectionRange=ct}}e.CallHierarchyItem=se;class ye{constructor(N,Z){this.fromRanges=Z,this.from=N}}e.CallHierarchyIncomingCall=ye;class Ue{constructor(N,Z){this.fromRanges=Z,this.to=N}}e.CallHierarchyOutgoingCall=Ue;var je;(function(B){B[B.Information=0]="Information",B[B.Warning=1]="Warning",B[B.Error=2]="Error"})(je=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let Qe=class{constructor(N,Z){this.range=N,this.command=Z}get isResolved(){return!!this.command}};Qe=xe([k],Qe),e.CodeLens=Qe;let rt=g=class{constructor(N,Z=!1){a.set(this,void 0),Xe(this,a,new S.MarkdownString(N,{supportThemeIcons:Z}),"f")}static isMarkdownString(N){return N instanceof g?!0:N&&N.appendCodeblock&&N.appendMarkdown&&N.appendText&&N.value!==void 0}get value(){return Ie(this,a,"f").value}set value(N){Ie(this,a,"f").value=N}get isTrusted(){return Ie(this,a,"f").isTrusted}set isTrusted(N){Ie(this,a,"f").isTrusted=N}get supportThemeIcons(){return Ie(this,a,"f").supportThemeIcons}set supportThemeIcons(N){Ie(this,a,"f").supportThemeIcons=N}get supportHtml(){return Ie(this,a,"f").supportHtml}set supportHtml(N){Ie(this,a,"f").supportHtml=N}appendText(N){return Ie(this,a,"f").appendText(N),this}appendMarkdown(N){return Ie(this,a,"f").appendMarkdown(N),this}appendCodeblock(N,Z){return Ie(this,a,"f").appendCodeblock(Z??"",N),this}};a=new WeakMap,rt=g=xe([k],rt),e.MarkdownString=rt;let ot=class{constructor(N,Z){this.label=N,this.documentation=Z}};ot=xe([k],ot),e.ParameterInformation=ot;let Je=class{constructor(N,Z){this.label=N,this.documentation=Z,this.parameters=[]}};Je=xe([k],Je),e.SignatureInformation=Je;let tt=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};tt=xe([k],tt),e.SignatureHelp=tt;var pt;(function(B){B[B.Invoke=1]="Invoke",B[B.TriggerCharacter=2]="TriggerCharacter",B[B.ContentChange=3]="ContentChange"})(pt=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Me;(function(B){B[B.Other=0]="Other",B[B.Type=1]="Type",B[B.Parameter=2]="Parameter"})(Me=e.InlayHintKind||(e.InlayHintKind={}));let At=class{constructor(N){this.label=N}};At=xe([k],At),e.InlayHintLabelPart=At;let q=class{constructor(N,Z,Ce){this.label=N,this.position=Z,this.kind=Ce}};q=xe([k],q),e.InlayHint=q;var Q;(function(B){B[B.Invoke=0]="Invoke",B[B.TriggerCharacter=1]="TriggerCharacter",B[B.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Q=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var he;(function(B){B[B.Text=0]="Text",B[B.Method=1]="Method",B[B.Function=2]="Function",B[B.Constructor=3]="Constructor",B[B.Field=4]="Field",B[B.Variable=5]="Variable",B[B.Class=6]="Class",B[B.Interface=7]="Interface",B[B.Module=8]="Module",B[B.Property=9]="Property",B[B.Unit=10]="Unit",B[B.Value=11]="Value",B[B.Enum=12]="Enum",B[B.Keyword=13]="Keyword",B[B.Snippet=14]="Snippet",B[B.Color=15]="Color",B[B.File=16]="File",B[B.Reference=17]="Reference",B[B.Folder=18]="Folder",B[B.EnumMember=19]="EnumMember",B[B.Constant=20]="Constant",B[B.Struct=21]="Struct",B[B.Event=22]="Event",B[B.Operator=23]="Operator",B[B.TypeParameter=24]="TypeParameter",B[B.User=25]="User",B[B.Issue=26]="Issue"})(he=e.CompletionItemKind||(e.CompletionItemKind={}));var Be;(function(B){B[B.Deprecated=1]="Deprecated"})(Be=e.CompletionItemTag||(e.CompletionItemTag={}));let qe=class{constructor(N,Z){this.label=N,this.kind=Z}toJSON(){return{label:this.label,kind:this.kind&&he[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};qe=xe([k],qe),e.CompletionItem=qe;let lt=class{constructor(N=[],Z=!1){this.items=N,this.isIncomplete=Z}};lt=xe([k],lt),e.CompletionList=lt;let ht=class{constructor(N,Z,Ce){this.text=N,this.range=Z,this.command=Ce}};ht=xe([k],ht),e.InlineSuggestion=ht;let Ye=class{constructor(N){this.items=N}};Ye=xe([k],Ye),e.InlineSuggestions=Ye;var kt;(function(B){B[B.Active=-1]="Active",B[B.Beside=-2]="Beside",B[B.One=1]="One",B[B.Two=2]="Two",B[B.Three=3]="Three",B[B.Four=4]="Four",B[B.Five=5]="Five",B[B.Six=6]="Six",B[B.Seven=7]="Seven",B[B.Eight=8]="Eight",B[B.Nine=9]="Nine"})(kt=e.ViewColumn||(e.ViewColumn={}));var Ae;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(Ae=e.StatusBarAlignment||(e.StatusBarAlignment={}));var De;(function(B){B[B.Off=0]="Off",B[B.On=1]="On",B[B.Relative=2]="Relative"})(De=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var pe;(function(B){B[B.Manual=1]="Manual",B[B.AfterDelay=2]="AfterDelay",B[B.FocusOut=3]="FocusOut"})(pe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var te;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(te=e.TextEditorRevealType||(e.TextEditorRevealType={}));var ne;(function(B){B[B.Keyboard=1]="Keyboard",B[B.Mouse=2]="Mouse",B[B.Command=3]="Command"})(ne=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var de;(function(B){B[B.Undo=1]="Undo",B[B.Redo=2]="Redo"})(de=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var me;(function(B){B[B.OpenOpen=0]="OpenOpen",B[B.ClosedClosed=1]="ClosedClosed",B[B.OpenClosed=2]="OpenClosed",B[B.ClosedOpen=3]="ClosedOpen"})(me=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(B){function N(Z){switch(Z){case"keyboard":return B.Keyboard;case"mouse":return B.Mouse;case"api":return B.Command}}B.fromValue=N}(ne=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Te=class{constructor(N,Z){if(Z&&!T.URI.isUri(Z))throw(0,t.illegalArgument)("target");if(!O.isRange(N)||N.isEmpty)throw(0,t.illegalArgument)("range");this.range=N,this.target=Z}};Te=xe([k],Te),e.DocumentLink=Te;let He=class{constructor(N,Z,Ce,Ke){this.red=N,this.green=Z,this.blue=Ce,this.alpha=Ke}};He=xe([k],He),e.Color=He;let Le=class{constructor(N,Z){if(Z&&!(Z instanceof He))throw(0,t.illegalArgument)("color");if(!O.isRange(N)||N.isEmpty)throw(0,t.illegalArgument)("range");this.range=N,this.color=Z}};Le=xe([k],Le),e.ColorInformation=Le;let Ge=class{constructor(N){if(!N||typeof N!="string")throw(0,t.illegalArgument)("label");this.label=N}};Ge=xe([k],Ge),e.ColorPresentation=Ge;var st;(function(B){B[B.RGB=0]="RGB",B[B.HEX=1]="HEX",B[B.HSL=2]="HSL"})(st=e.ColorFormat||(e.ColorFormat={}));var at;(function(B){B[B.Error=0]="Error",B[B.Warning=1]="Warning",B[B.Information=2]="Information"})(at=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class Ne{constructor(N,Z,Ce){if(this.startIndex=N,this.length=Z,this.tooltip=Ce,typeof N!="number"||N<0)throw(0,t.illegalArgument)("startIndex");if(typeof Z!="number"||Z<1)throw(0,t.illegalArgument)("length");if(Ce!==void 0&&typeof Ce!="string")throw(0,t.illegalArgument)("tooltip")}}e.TerminalLink=Ne;var ce;(function(B){B[B.Panel=1]="Panel",B[B.Editor=2]="Editor"})(ce=e.TerminalLocation||(e.TerminalLocation={}));class fe{constructor(N){this.options=N,typeof N!="object"&&(0,t.illegalArgument)("options")}}e.TerminalProfile=fe;var oe;(function(B){B[B.Always=1]="Always",B[B.Silent=2]="Silent",B[B.Never=3]="Never"})(oe=e.TaskRevealKind||(e.TaskRevealKind={}));var W;(function(B){B[B.Shared=1]="Shared",B[B.Dedicated=2]="Dedicated",B[B.New=3]="New"})(W=e.TaskPanelKind||(e.TaskPanelKind={}));let Ee=s=class{constructor(N,Z){if(this.label=Z,typeof N!="string"||typeof Z!="string")throw(0,t.illegalArgument)("name");this._id=N}static from(N){switch(N){case"clean":return s.Clean;case"build":return s.Build;case"rebuild":return s.Rebuild;case"test":return s.Test;default:return}}get id(){return this._id}};Ee.Clean=new s("clean","Clean"),Ee.Build=new s("build","Build"),Ee.Rebuild=new s("rebuild","Rebuild"),Ee.Test=new s("test","Test"),Ee=s=xe([k],Ee),e.TaskGroup=Ee;function Re(B){let N="";for(let Z=0;Z<B.length;Z++)N+=B[Z].replace(/,/g,",,")+",";return N}let Ve=class{constructor(N,Z,Ce){if(typeof N!="string")throw(0,t.illegalArgument)("process");this._args=[],this._process=N,Z!==void 0&&(Array.isArray(Z)?(this._args=Z,this._options=Ce):this._options=Z)}get process(){return this._process}set process(N){if(typeof N!="string")throw(0,t.illegalArgument)("process");this._process=N}get args(){return this._args}set args(N){Array.isArray(N)||(N=[]),this._args=N}get options(){return this._options}set options(N){this._options=N}computeId(){const N=[];if(N.push("process"),this._process!==void 0&&N.push(this._process),this._args&&this._args.length>0)for(let Z of this._args)N.push(Z);return Re(N)}};Ve=xe([k],Ve),e.ProcessExecution=Ve;let We=class{constructor(N,Z,Ce){if(this._args=[],Array.isArray(Z)){if(!N)throw(0,t.illegalArgument)("command can't be undefined or null");if(typeof N!="string"&&typeof N.value!="string")throw(0,t.illegalArgument)("command");this._command=N,this._args=Z,this._options=Ce}else{if(typeof N!="string")throw(0,t.illegalArgument)("commandLine");this._commandLine=N,this._options=Z}}get commandLine(){return this._commandLine}set commandLine(N){if(typeof N!="string")throw(0,t.illegalArgument)("commandLine");this._commandLine=N}get command(){return this._command?this._command:""}set command(N){if(typeof N!="string"&&typeof N.value!="string")throw(0,t.illegalArgument)("command");this._command=N}get args(){return this._args}set args(N){this._args=N||[]}get options(){return this._options}set options(N){this._options=N}computeId(){const N=[];if(N.push("shell"),this._commandLine!==void 0&&N.push(this._commandLine),this._command!==void 0&&N.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let Z of this._args)N.push(typeof Z=="string"?Z:Z.value);return Re(N)}};We=xe([k],We),e.ShellExecution=We;var mt;(function(B){B[B.Escape=1]="Escape",B[B.Strong=2]="Strong",B[B.Weak=3]="Weak"})(mt=e.ShellQuoting||(e.ShellQuoting={}));var Et;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace"})(Et=e.TaskScope||(e.TaskScope={}));class St{constructor(N){this._callback=N}computeId(){return"customExecution"+(0,R.generateUuid)()}set callback(N){this._callback=N}get callback(){return this._callback}}e.CustomExecution=St;let dt=d=class{constructor(N,Z,Ce,Ke,it,ct){this.__deprecated=!1,this._definition=this.definition=N;let ft;typeof Z=="string"?(this._name=this.name=Z,this._source=this.source=Ce,this.execution=Ke,ft=it,this.__deprecated=!0):Z===Et.Global||Z===Et.Workspace?(this.target=Z,this._name=this.name=Ce,this._source=this.source=Ke,this.execution=it,ft=ct):(this.target=Z,this._name=this.name=Ce,this._source=this.source=Ke,this.execution=it,ft=ct),typeof ft=="string"?(this._problemMatchers=[ft],this._hasDefinedMatchers=!0):Array.isArray(ft)?(this._problemMatchers=ft,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(N){this.__id=N}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Ve?this._definition={type:d.ProcessType,id:this._execution.computeId()}:this._execution instanceof We?this._definition={type:d.ShellType,id:this._execution.computeId()}:this._execution instanceof St?this._definition={type:d.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:d.EmptyType,id:(0,R.generateUuid)()}}get definition(){return this._definition}set definition(N){if(N==null)throw(0,t.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=N}get scope(){return this._scope}set target(N){this.clear(),this._scope=N}get name(){return this._name}set name(N){if(typeof N!="string")throw(0,t.illegalArgument)("name");this.clear(),this._name=N}get execution(){return this._execution}set execution(N){N===null&&(N=void 0),this.clear(),this._execution=N;const Z=this._definition.type;(d.EmptyType===Z||d.ProcessType===Z||d.ShellType===Z||d.ExtensionCallbackType===Z)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(N){if(Array.isArray(N))this.clear(),this._problemMatchers=N,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(N){N!==!0&&N!==!1&&(N=!1),this.clear(),this._isBackground=N}get source(){return this._source}set source(N){if(typeof N!="string"||N.length===0)throw(0,t.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=N}get group(){return this._group}set group(N){N===null&&(N=void 0),this.clear(),this._group=N}get detail(){return this._detail}set detail(N){N===null&&(N=void 0),this._detail=N}get presentationOptions(){return this._presentationOptions}set presentationOptions(N){N==null&&(N=Object.create(null)),this.clear(),this._presentationOptions=N}get runOptions(){return this._runOptions}set runOptions(N){N==null&&(N=Object.create(null)),this.clear(),this._runOptions=N}};dt.ExtensionCallbackType="customExecution",dt.ProcessType="process",dt.ShellType="shell",dt.EmptyType="$empty",dt=d=xe([k],dt),e.Task=dt;var vt;(function(B){B[B.SourceControl=1]="SourceControl",B[B.Window=10]="Window",B[B.Notification=15]="Notification"})(vt=e.ProgressLocation||(e.ProgressLocation={}));let bt=class{constructor(N,Z=Ut.None){this.collapsibleState=Z,T.URI.isUri(N)?this.resourceUri=N:this.label=N}};bt=xe([k],bt),e.TreeItem=bt;var Ut;(function(B){B[B.None=0]="None",B[B.Collapsed=1]="Collapsed",B[B.Expanded=2]="Expanded"})(Ut=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let It=class{constructor(N){this._value=N}async asString(){return JSON.stringify(this._value)}};It=xe([k],It),e.TreeDataTransferItem=It;let Mt=class{constructor(){this._items=new Map}get(N){return this._items.get(N)}set(N,Z){this._items.set(N,Z)}forEach(N){this._items.forEach(N)}};Mt=xe([k],Mt),e.TreeDataTransfer=Mt;let Dt=class{constructor(N,Z){this.id=N,this.color=Z}};Dt=xe([k],Dt),e.ThemeIcon=Dt,Dt.File=new Dt("file"),Dt.Folder=new Dt("folder");let _t=class{constructor(N){this.id=N}};_t=xe([k],_t),e.ThemeColor=_t;var Qt;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace",B[B.WorkspaceFolder=3]="WorkspaceFolder"})(Qt=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Vt=class{constructor(N,Z){if(typeof N!="string"&&(!N||!T.URI.isUri(N)&&!T.URI.isUri(N.uri)))throw(0,t.illegalArgument)("base");if(typeof Z!="string")throw(0,t.illegalArgument)("pattern");typeof N=="string"?this.baseUri=T.URI.file(N):T.URI.isUri(N)?this.baseUri=N:this.baseUri=N.uri,this.pattern=Z}get base(){return this._base}set base(N){this._base=N,this._baseUri=T.URI.file(N)}get baseUri(){return this._baseUri}set baseUri(N){this._baseUri=N,this._base=N.fsPath}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};Vt=xe([k],Vt),e.RelativePattern=Vt;let wt=class{constructor(N,Z,Ce,Ke){this.enabled=typeof N=="boolean"?N:!0,typeof Z=="string"&&(this.condition=Z),typeof Ce=="string"&&(this.hitCondition=Ce),typeof Ke=="string"&&(this.logMessage=Ke)}get id(){return this._id||(this._id=(0,R.generateUuid)()),this._id}};wt=xe([k],wt),e.Breakpoint=wt;let Yt=class extends wt{constructor(N,Z,Ce,Ke,it){super(Z,Ce,Ke,it);if(N===null)throw(0,t.illegalArgument)("location");this.location=N}};Yt=xe([k],Yt),e.SourceBreakpoint=Yt;let qt=class extends wt{constructor(N,Z,Ce,Ke,it){super(Z,Ce,Ke,it);this.functionName=N}};qt=xe([k],qt),e.FunctionBreakpoint=qt;let Xt=class extends wt{constructor(N,Z,Ce,Ke,it,ct,ft){super(Ke,it,ct,ft);if(!Z)throw(0,t.illegalArgument)("dataId");this.label=N,this.dataId=Z,this.canPersist=Ce}};Xt=xe([k],Xt),e.DataBreakpoint=Xt;let ai=class{constructor(N,Z,Ce){this.command=N,this.args=Z||[],this.options=Ce}};ai=xe([k],ai),e.DebugAdapterExecutable=ai;let Rt=class{constructor(N,Z){this.port=N,this.host=Z}};Rt=xe([k],Rt),e.DebugAdapterServer=Rt;let Jt=class{constructor(N){this.path=N}};Jt=xe([k],Jt),e.DebugAdapterNamedPipeServer=Jt;let li=class{constructor(N){this.implementation=N}};li=xe([k],li),e.DebugAdapterInlineImplementation=li;let jt=class{constructor(N,Z){this.range=N,this.expression=Z}};jt=xe([k],jt),e.EvaluatableExpression=jt;var Zt;(function(B){B[B.Automatic=0]="Automatic",B[B.Explicit=1]="Explicit"})(Zt=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let gt=class{constructor(N,Z){this.range=N,this.text=Z}};gt=xe([k],gt),e.InlineValueText=gt;let ci=class{constructor(N,Z,Ce=!0){this.range=N,this.variableName=Z,this.caseSensitiveLookup=Ce}};ci=xe([k],ci),e.InlineValueVariableLookup=ci;let Lt=class{constructor(N,Z){this.range=N,this.expression=Z}};Lt=xe([k],Lt),e.InlineValueEvaluatableExpression=Lt;let $t=class{constructor(N,Z){this.frameId=N,this.stoppedLocation=Z}};$t=xe([k],$t),e.InlineValueContext=$t;var vi;(function(B){B[B.Changed=1]="Changed",B[B.Created=2]="Created",B[B.Deleted=3]="Deleted"})(vi=e.FileChangeType||(e.FileChangeType={}));let ui=p=class extends Error{constructor(N,Z=b.FileSystemProviderErrorCode.Unknown,Ce){super(T.URI.isUri(N)?N.toString(!0):N);this.code=Ce?.name??"Unknown",(0,b.markAsFileSystemProviderError)(this,Z),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,p.prototype),typeof Error.captureStackTrace=="function"&&typeof Ce=="function"&&Error.captureStackTrace(this,Ce)}static FileExists(N){return new p(N,b.FileSystemProviderErrorCode.FileExists,p.FileExists)}static FileNotFound(N){return new p(N,b.FileSystemProviderErrorCode.FileNotFound,p.FileNotFound)}static FileNotADirectory(N){return new p(N,b.FileSystemProviderErrorCode.FileNotADirectory,p.FileNotADirectory)}static FileIsADirectory(N){return new p(N,b.FileSystemProviderErrorCode.FileIsADirectory,p.FileIsADirectory)}static NoPermissions(N){return new p(N,b.FileSystemProviderErrorCode.NoPermissions,p.NoPermissions)}static Unavailable(N){return new p(N,b.FileSystemProviderErrorCode.Unavailable,p.Unavailable)}};ui=p=xe([k],ui),e.FileSystemError=ui;let ei=class{constructor(N,Z,Ce){this.start=N,this.end=Z,this.kind=Ce}};ei=xe([k],ei),e.FoldingRange=ei;var Ci;(function(B){B[B.Comment=1]="Comment",B[B.Imports=2]="Imports",B[B.Region=3]="Region"})(Ci=e.FoldingRangeKind||(e.FoldingRangeKind={}));var bi;(function(B){B[B.Collapsed=0]="Collapsed",B[B.Expanded=1]="Expanded"})(bi=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var ti;(function(B){B[B.Editing=0]="Editing",B[B.Preview=1]="Preview"})(ti=e.CommentMode||(e.CommentMode={}));class Di{constructor(N,Z=[]){this.tokenTypes=N,this.tokenModifiers=Z}}e.SemanticTokensLegend=Di;function di(B){return typeof B=="undefined"||(0,D.isStringArray)(B)}class Gt{constructor(N){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,N){this._hasLegend=!0;for(let Z=0,Ce=N.tokenTypes.length;Z<Ce;Z++)this._tokenTypeStrToInt.set(N.tokenTypes[Z],Z);for(let Z=0,Ce=N.tokenModifiers.length;Z<Ce;Z++)this._tokenModifierStrToInt.set(N.tokenModifiers[Z],Z)}}push(N,Z,Ce,Ke,it){if(typeof N=="number"&&typeof Z=="number"&&typeof Ce=="number"&&typeof Ke=="number"&&(typeof it=="number"||typeof it=="undefined"))return typeof it=="undefined"&&(it=0),this._pushEncoded(N,Z,Ce,Ke,it);if(O.isRange(N)&&typeof Z=="string"&&di(Ce))return this._push(N,Z,Ce);throw(0,t.illegalArgument)()}_push(N,Z,Ce){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(N.start.line!==N.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(Z))throw new Error("`tokenType` is not in the provided legend");const Ke=N.start.line,it=N.start.character,ct=N.end.character-N.start.character,ft=this._tokenTypeStrToInt.get(Z);let Pt=0;if(Ce)for(const Ft of Ce){if(!this._tokenModifierStrToInt.has(Ft))throw new Error("`tokenModifier` is not in the provided legend");const Nt=this._tokenModifierStrToInt.get(Ft);Pt|=1<<Nt>>>0}this._pushEncoded(Ke,it,ct,ft,Pt)}_pushEncoded(N,Z,Ce,Ke,it){if(this._dataIsSortedAndDeltaEncoded&&(N<this._prevLine||N===this._prevLine&&Z<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Pt=this._data.length/5|0;let Ft=0,Nt=0;for(let xt=0;xt<Pt;xt++){let Ht=this._data[5*xt],gi=this._data[5*xt+1];Ht===0?(Ht=Ft,gi+=Nt):Ht+=Ft,this._data[5*xt]=Ht,this._data[5*xt+1]=gi,Ft=Ht,Nt=gi}}let ct=N,ft=Z;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(ct-=this._prevLine,ct===0&&(ft-=this._prevChar)),this._data[this._dataLen++]=ct,this._data[this._dataLen++]=ft,this._data[this._dataLen++]=Ce,this._data[this._dataLen++]=Ke,this._data[this._dataLen++]=it,this._prevLine=N,this._prevChar=Z}static _sortAndDeltaEncode(N){let Z=[];const Ce=N.length/5|0;for(let ft=0;ft<Ce;ft++)Z[ft]=ft;Z.sort((ft,Pt)=>{const Ft=N[5*ft],Nt=N[5*Pt];if(Ft===Nt){const xt=N[5*ft+1],Ht=N[5*Pt+1];return xt-Ht}return Ft-Nt});const Ke=new Uint32Array(N.length);let it=0,ct=0;for(let ft=0;ft<Ce;ft++){const Pt=5*Z[ft],Ft=N[Pt+0],Nt=N[Pt+1],xt=N[Pt+2],Ht=N[Pt+3],gi=N[Pt+4],Wi=Ft-it,Ji=Wi===0?Nt-ct:Nt,pi=5*ft;Ke[pi+0]=Wi,Ke[pi+1]=Ji,Ke[pi+2]=xt,Ke[pi+3]=Ht,Ke[pi+4]=gi,it=Ft,ct=Nt}return Ke}build(N){return this._dataIsSortedAndDeltaEncoded?new hi(new Uint32Array(this._data),N):new hi(Gt._sortAndDeltaEncode(this._data),N)}}e.SemanticTokensBuilder=Gt;class hi{constructor(N,Z){this.resultId=Z,this.data=N}}e.SemanticTokens=hi;class ki{constructor(N,Z,Ce){this.start=N,this.deleteCount=Z,this.data=Ce}}e.SemanticTokensEdit=ki;class Kt{constructor(N,Z){this.resultId=Z,this.edits=N}}e.SemanticTokensEdits=Kt;var Ii;(function(B){B[B.Separate=0]="Separate",B[B.MergeWithParent=1]="MergeWithParent"})(Ii=e.DebugConsoleMode||(e.DebugConsoleMode={}));var Pi;(function(B){B[B.Initial=1]="Initial",B[B.Dynamic=2]="Dynamic"})(Pi=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let ii=class{constructor(){}};ii.Back={iconPath:new Dt("arrow-left")},ii=xe([k],ii),e.QuickInputButtons=ii;var Ti;(function(B){B[B.Separator=-1]="Separator",B[B.Default=1]="Default"})(Ti=e.QuickPickItemKind||(e.QuickPickItemKind={}));var fi;(function(B){B[B.UI=1]="UI",B[B.Workspace=2]="Workspace"})(fi=e.ExtensionKind||(e.ExtensionKind={}));class wi{constructor(N,Z,Ce){this.badge=N,this.tooltip=Z,this.color=Ce}static validate(N){if(N.badge){let Z=(0,I.nextCharLength)(N.badge,0);if(Z<N.badge.length&&(Z+=(0,I.nextCharLength)(N.badge,Z)),N.badge.length>Z)throw new Error("The 'badge'-property must be undefined or a short character")}if(!N.color&&!N.badge&&!N.tooltip)throw new Error("The decoration is empty");return!0}}e.FileDecoration=wi;let ni=class{constructor(N){this.kind=N}};ni=xe([k],ni),e.ColorTheme=ni;var Oe;(function(B){B[B.Light=1]="Light",B[B.Dark=2]="Dark",B[B.HighContrast=3]="HighContrast"})(Oe=e.ColorThemeKind||(e.ColorThemeKind={}));class zt{constructor(N,Z){if(N<0)throw(0,t.illegalArgument)("start must be positive");if(Z<0)throw(0,t.illegalArgument)("end must be positive");N<=Z?(this._start=N,this._end=Z):(this._start=Z,this._end=N)}static isNotebookRange(N){return N instanceof zt?!0:N?typeof N.start=="number"&&typeof N.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(N){let Z=this._start,Ce=this._end;return N.start!==void 0&&(Z=N.start),N.end!==void 0&&(Ce=N.end),Z===this._start&&Ce===this._end?this:new zt(Z,Ce)}}e.NotebookRange=zt;class Bt{constructor(N,Z,Ce,Ke,it,ct,ft){this.kind=N,this.value=Z,this.languageId=Ce,this.mime=Ke,this.outputs=it??[],this.metadata=ct,this.executionSummary=ft,Bt.validate(this)}static validate(N){if(typeof N.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof N.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof N.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(N){return Array.isArray(N)&&N.every(Z=>Bt.isNotebookCellData(Z))}static isNotebookCellData(N){return!0}}e.NotebookCellData=Bt;class yt{constructor(N){this.cells=N}}e.NotebookData=yt;class Ot{constructor(N,Z){this.data=N,this.mime=Z;const Ce=(0,A.normalizeMimeType)(Z,!0);if(!Ce)throw new Error(`INVALID mime type: ${Z}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Ce}static isNotebookCellOutputItem(N){return N instanceof Ot?!0:N?typeof N.mime=="string"&&N.data instanceof Uint8Array:!1}static error(N){const Z={name:N.name,message:N.message,stack:N.stack};return Ot.json(Z,"application/vnd.code.notebook.error")}static stdout(N){return Ot.text(N,"application/vnd.code.notebook.stdout")}static stderr(N){return Ot.text(N,"application/vnd.code.notebook.stderr")}static bytes(N,Z="application/octet-stream"){return new Ot(N,Z)}static text(N,Z=A.Mimes.text){const Ce=Ie(Ot,o,"f",m).encode(String(N));return new Ot(Ce,Z)}static json(N,Z="application/json"){const Ce=JSON.stringify(N,void 0,"	");return Ot.text(Ce,Z)}}e.NotebookCellOutputItem=Ot,o=Ot,m={value:new TextEncoder};class ri{constructor(N,Z,Ce){this.items=ri.ensureUniqueMimeTypes(N,!0),typeof Z=="string"?(this.id=Z,this.metadata=Ce):(this.id=(0,R.generateUuid)(),this.metadata=Z??Ce)}static isNotebookCellOutput(N){return N instanceof ri?!0:!N||typeof N!="object"?!1:typeof N.id=="string"&&(0,D.isArray)(N.items)}static ensureUniqueMimeTypes(N,Z=!1){const Ce=new Set,Ke=new Set;for(let it=0;it<N.length;it++){const ct=N[it],ft=(0,A.normalizeMimeType)(ct.mime);if(!Ce.has(ft)){Ce.add(ft);continue}Ke.add(it),Z&&console.warn(`DUPLICATED mime type '${ct.mime}' will be dropped`)}return Ke.size===0?N:N.filter((it,ct)=>!Ke.has(ct))}}e.NotebookCellOutput=ri;var Ei;(function(B){B[B.Markup=1]="Markup",B[B.Code=2]="Code"})(Ei=e.NotebookCellKind||(e.NotebookCellKind={}));var yi;(function(B){B[B.Idle=1]="Idle",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(yi=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Ai;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(Ai=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Ri;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(Ri=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Fi{constructor(N,Z){this.text=N,this.alignment=Z}}e.NotebookCellStatusBarItem=Fi;var Mi;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred"})(Mi=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Si{constructor(N,Z=[]){this.uri=N,this.provides=(0,r.asArray)(Z)}}e.NotebookRendererScript=Si;let mi=class{constructor(N,Z){this.label=N,this.timestamp=Z}};mi=xe([k],mi),e.TimelineItem=mi;var Oi;(function(B){B[B.Production=1]="Production",B[B.Development=2]="Development",B[B.Test=3]="Test"})(Oi=e.ExtensionMode||(e.ExtensionMode={}));var Li;(function(B){B[B.Node=1]="Node",B[B.Webworker=2]="Webworker"})(Li=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Ni;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=3]="RegEx"})(Ni=e.StandardTokenType||(e.StandardTokenType={}));class Ui{constructor(N,Z){this.ranges=N,this.wordPattern=Z}}e.LinkedEditingRanges=Ui;class J{constructor(N,Z){this._port=N,this._autoForwardAction=Z}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=J;var ae;(function(B){B[B.Queued=1]="Queued",B[B.Running=2]="Running",B[B.Passed=3]="Passed",B[B.Failed=4]="Failed",B[B.Skipped=5]="Skipped",B[B.Errored=6]="Errored"})(ae=e.TestResultState||(e.TestResultState={}));var ke;(function(B){B[B.Run=1]="Run",B[B.Debug=2]="Debug",B[B.Coverage=3]="Coverage"})(ke=e.TestRunProfileKind||(e.TestRunProfileKind={}));let ut=class{constructor(N=void 0,Z=void 0,Ce=void 0){this.include=N,this.exclude=Z,this.profile=Ce}};ut=xe([k],ut),e.TestRunRequest=ut;let Ct=w=class{constructor(N){this.message=N}static diff(N,Z,Ce){const Ke=new w(N);return Ke.expectedOutput=Z,Ke.actualOutput=Ce,Ke}};Ct=w=xe([k],Ct),e.TestMessage=Ct;let Tt=class{constructor(N){this.id=N}};Tt=xe([k],Tt),e.TestTag=Tt;let oi=class{constructor(N,Z){this.covered=N,this.total=Z}};oi=xe([k],oi),e.CoveredCount=oi;let Bi=v=class{constructor(N,Z,Ce,Ke){this.uri=N,this.statementCoverage=Z,this.branchCoverage=Ce,this.functionCoverage=Ke}static fromDetails(N,Z){const Ce=new oi(0,0),Ke=new oi(0,0),it=new oi(0,0);for(const ft of Z)if("branches"in ft){Ce.total+=1,Ce.covered+=ft.executionCount>0?1:0;for(const Pt of ft.branches)Ke.total+=1,Ke.covered+=Pt.executionCount>0?1:0}else it.total+=1,it.covered+=ft.executionCount>0?1:0;const ct=new v(N,Ce,Ke.total>0?Ke:void 0,it.total>0?it:void 0);return ct.detailedCoverage=Z,ct}};Bi=v=xe([k],Bi),e.FileCoverage=Bi;let xi=class{constructor(N,Z,Ce=[]){this.executionCount=N,this.location=Z,this.branches=Ce}};xi=xe([k],xi),e.StatementCoverage=xi;let $i=class{constructor(N,Z){this.executionCount=N,this.location=Z}};$i=xe([k],$i),e.BranchCoverage=$i;let zi=class{constructor(N,Z){this.executionCount=N,this.location=Z}};zi=xe([k],zi),e.FunctionCoverage=zi;var Ki;(function(B){B[B.None=0]="None",B[B.Option=1]="Option",B[B.Default=2]="Default",B[B.Preferred=3]="Preferred"})(Ki=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Qi;(function(B){B[B.Untrusted=0]="Untrusted",B[B.Trusted=1]="Trusted",B[B.Unspecified=2]="Unspecified"})(Qi=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Yi;(function(B){B[B.Notify=1]="Notify",B[B.OpenBrowser=2]="OpenBrowser",B[B.OpenPreview=3]="OpenPreview",B[B.Silent=4]="Silent",B[B.Ignore=5]="Ignore",B[B.OpenBrowserOnce=6]="OpenBrowserOnce"})(Yi=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class Xi{constructor(N,Z,Ce,Ke,it,ct){this.kind=N,this.name=Z,this.detail=Ce,this.uri=Ke,this.range=it,this.selectionRange=ct}}e.TypeHierarchyItem=Xi}),define(Se[84],_e([0,1,42,11,9,223,113,7,16]),function(ee,e,r,t,S,P,A,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const T=new Map;function R(a,o){o?T.set(a,o):T.delete(a)}e.setWordDefinitionFor=R;function b(a){return T.get(a)}e.getWordDefinitionFor=b;class i extends P.MirrorTextModel{constructor(o,m,M,y,_,u,C,l){super(m,M,y,_);this._proxy=o,this._languageId=u,this._isDirty=C,this._notebook=l,this._isDisposed=!1}dispose(){(0,r.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(o){return(0,D.equals)(this._lines,o)}get document(){if(!this._document){const o=this;this._document={get uri(){return o._uri},get fileName(){return o._uri.fsPath},get isUntitled(){return o._uri.scheme===t.Schemas.untitled},get languageId(){return o._languageId},get version(){return o._versionId},get isClosed(){return o._isDisposed},get isDirty(){return o._isDirty},get notebook(){return o._notebook},save(){return o._save()},getText(m){return m?o._getTextInRange(m):o.getText()},get eol(){return o._eol===`
`?I.EndOfLine.LF:I.EndOfLine.CRLF},get lineCount(){return o._lines.length},lineAt(m){return o._lineAt(m)},offsetAt(m){return o._offsetAt(m)},positionAt(m){return o._positionAt(m)},validateRange(m){return o._validateRange(m)},validatePosition(m){return o._validatePosition(m)},getWordRangeAtPosition(m,M){return o._getWordRangeAtPosition(m,M)}}}return Object.freeze(this._document)}_acceptLanguageId(o){(0,r.ok)(!this._isDisposed),this._languageId=o}_acceptIsDirty(o){(0,r.ok)(!this._isDisposed),this._isDirty=o}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(o){const m=this._validateRange(o);if(m.isEmpty)return"";if(m.isSingleLine)return this._lines[m.start.line].substring(m.start.character,m.end.character);const M=this._eol,y=m.start.line,_=m.end.line,u=[];u.push(this._lines[y].substring(m.start.character));for(let C=y+1;C<_;C++)u.push(this._lines[C]);return u.push(this._lines[_].substring(0,m.end.character)),u.join(M)}_lineAt(o){let m;if(o instanceof I.Position?m=o.line:typeof o=="number"&&(m=o),typeof m!="number"||m<0||m>=this._lines.length||Math.floor(m)!==m)throw new Error("Illegal value for `line`");return new f(m,this._lines[m],m===this._lines.length-1)}_offsetAt(o){return o=this._validatePosition(o),this._ensureLineStarts(),this._lineStarts.getPrefixSum(o.line-1)+o.character}_positionAt(o){o=Math.floor(o),o=Math.max(0,o),this._ensureLineStarts();const m=this._lineStarts.getIndexOf(o),M=this._lines[m.index].length;return new I.Position(m.index,Math.min(m.remainder,M))}_validateRange(o){if(!(o instanceof I.Range))throw new Error("Invalid argument");const m=this._validatePosition(o.start),M=this._validatePosition(o.end);return m===o.start&&M===o.end?o:new I.Range(m.line,m.character,M.line,M.character)}_validatePosition(o){if(!(o instanceof I.Position))throw new Error("Invalid argument");if(this._lines.length===0)return o.with(0,0);let{line:m,character:M}=o,y=!1;if(m<0)m=0,M=0,y=!0;else if(m>=this._lines.length)m=this._lines.length-1,M=this._lines[m].length,y=!0;else{const _=this._lines[m].length;M<0?(M=0,y=!0):M>_&&(M=_,y=!0)}return y?new I.Position(m,M):o}_getWordRangeAtPosition(o,m){const M=this._validatePosition(o);if(!m)m=b(this._languageId);else if((0,S.regExpLeadsToEndlessLoop)(m))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${m.source}' because it matches the empty string.`);const y=(0,A.getWordAtText)(M.character+1,(0,A.ensureValidWordDefinition)(m),this._lines[M.line],0);if(y)return new I.Range(M.line,y.startColumn-1,M.line,y.endColumn-1)}}e.ExtHostDocumentData=i;class f{constructor(o,m,M){this._line=o,this._text=m,this._isLastLine=M}get lineNumber(){return this._line}get text(){return this._text}get range(){return new I.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new I.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=f}),define(Se[149],_e([0,1,7,4,224,6,56,22,2,36]),function(ee,e,r,t,S,P,A,I,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class R{constructor(i,f,a,o){this._notebook=a,this._selector=o,this._disposables=new P.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new t.Emitter,this.onDidChange=this._onDidChange.event,this.uri=D.URI.from({scheme:"vscode-concat-doc",path:(0,T.generateUuid)()}),this._init(),this._disposables.add(f.onDidChangeDocument(M=>{const y=this._cellUris.get(M.document.uri);y!==void 0&&(this._cellLengths.setValue(y,this._cells[y].document.getText().length+1),this._cellLines.setValue(y,this._cells[y].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const m=M=>{M===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(i.onDidChangeNotebookCells(M=>m(M.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new I.ResourceMap;const i=[],f=[];for(const a of this._notebook.getCells())a.kind===r.NotebookCellKind.Code&&(!this._selector||(0,A.score)(this._selector,a.document.uri,a.document.languageId,!0))&&(this._cellUris.set(a.document.uri,this._cells.length),this._cells.push(a),i.push(a.document.getText().length+1),f.push(a.document.lineCount));this._cellLengths=new S.PrefixSumComputer(new Uint32Array(i)),this._cellLines=new S.PrefixSumComputer(new Uint32Array(f))}get version(){return this._versionId}getText(i){if(!i){let y="";for(const _ of this._cells)y+=_.document.getText()+`
`;return y=y.slice(0,-1),y}if(i.isEmpty)return"";const f=this.locationAt(i.start),a=this.locationAt(i.end),o=this._cellUris.get(f.uri),m=this._cellUris.get(a.uri);if(o===void 0||m===void 0)return"";if(o===m)return this._cells[o].document.getText(new r.Range(f.range.start,a.range.end));const M=[this._cells[o].document.getText(new r.Range(f.range.start,new r.Position(this._cells[o].document.lineCount,0)))];for(let y=o+1;y<m;y++)M.push(this._cells[y].document.getText());return M.push(this._cells[m].document.getText(new r.Range(new r.Position(0,0),a.range.end))),M.join(`
`)}offsetAt(i){const f=this._cellLines.getIndexOf(i.line),a=this._cellLengths.getPrefixSum(f.index-1),o=this._cells[f.index].document.offsetAt(i.with(f.remainder));return a+o}positionAt(i){if(typeof i=="number"){const a=this._cellLengths.getIndexOf(i),o=this._cellLines.getPrefixSum(a.index-1);return this._cells[a.index].document.positionAt(a.remainder).translate(o)}const f=this._cellUris.get(i.uri);if(f!==void 0){const a=this._cellLines.getPrefixSum(f-1);return new r.Position(a+i.range.start.line,i.range.start.character)}return new r.Position(0,0)}locationAt(i){r.Range.isRange(i)||(i=new r.Range(i,i));const f=this._cellLines.getIndexOf(i.start.line);let a=f;i.isEmpty||(a=this._cellLines.getIndexOf(i.end.line));const o=new r.Position(f.remainder,i.start.character),m=new r.Position(a.remainder,i.end.character),M=new r.Range(o,m),y=this._cells[f.index];return new r.Location(y.document.uri,y.document.validateRange(M))}contains(i){return this._cellUris.has(i)}validateRange(i){const f=this.validatePosition(i.start),a=this.validatePosition(i.end);return i.with(f,a)}validatePosition(i){const f=this._cellLines.getIndexOf(i.line),a=new r.Position(f.remainder,i.character),o=this._cells[f.index].document.validatePosition(a),m=this._cellLines.getPrefixSum(f.index-1);return new r.Position(m+o.line,o.character)}}e.ExtHostNotebookConcatDocument=R}),define(Se[150],_e([0,1,7,14,4]),function(ee,e,r,t,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let P=class{constructor(I){this._actual=new r.ColorTheme(r.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new S.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(I){let D=I==="light"?r.ColorThemeKind.Light:I==="dark"?r.ColorThemeKind.Dark:r.ColorThemeKind.HighContrast;this._actual=new r.ColorTheme(D),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};P=xe([$e(0,t.IExtHostRpcService)],P),e.ExtHostTheming=P}),define(Se[64],_e([0,1,3]),function(ee,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,r.createDecorator)("IURITransformerService");class t{constructor(P){P?(this.transformIncoming=P.transformIncoming.bind(P),this.transformOutgoing=P.transformOutgoing.bind(P),this.transformOutgoingURI=P.transformOutgoingURI.bind(P),this.transformOutgoingScheme=P.transformOutgoingScheme.bind(P)):(this.transformIncoming=A=>A,this.transformOutgoing=A=>A,this.transformOutgoingURI=A=>A,this.transformOutgoingScheme=A=>A)}}e.URITransformerService=t}),define(Se[151],_e([0,1,21]),function(ee,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class t{constructor(){this.buffers=[]}add(D){let T=this.buffers.indexOf(D);return T<0&&(T=this.buffers.length,this.buffers.push(D)),T}}function S(I,D){if(D.serializeBuffersForPostMessage){const T=new t,R=(f,a)=>{if(a instanceof ArrayBuffer){const o=T.add(a);return{$$vscode_array_buffer_reference$$:!0,index:o}}else if(ArrayBuffer.isView(a)){const o=P(a);if(o){const m=T.add(a.buffer);return{$$vscode_array_buffer_reference$$:!0,index:m,view:{type:o,byteLength:a.byteLength,byteOffset:a.byteOffset}}}}return a},b=JSON.stringify(I,R),i=T.buffers.map(f=>{const a=new Uint8Array(f);return r.VSBuffer.wrap(a)});return{message:b,buffers:i}}else return{message:JSON.stringify(I),buffers:[]}}e.serializeWebviewMessage=S;function P(I){switch(I.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function A(I,D){const T=D.map(i=>{const f=new ArrayBuffer(i.byteLength);return new Uint8Array(f).set(i.buffer),f}),R=D.length?(i,f)=>{if(typeof f=="object"&&f.$$vscode_array_buffer_reference$$){const a=f,{index:o}=a,m=T[o];if(a.view)switch(a.view.type){case 1:return new Int8Array(m,a.view.byteOffset,a.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(m,a.view.byteOffset,a.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(m,a.view.byteOffset,a.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(m,a.view.byteOffset,a.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(m,a.view.byteOffset,a.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(m,a.view.byteOffset,a.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(m,a.view.byteOffset,a.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(m,a.view.byteOffset,a.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(m,a.view.byteOffset,a.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(m,a.view.byteOffset,a.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(m,a.view.byteOffset,a.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return m}return f}:void 0;return{message:JSON.parse(I,R),arrayBuffers:T}}e.deserializeWebviewMessage=A}),define(Se[152],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var r;(function(t){function S(A){const I=new Map;return A.types.forEach((D,T)=>{I.set(D,{asString:async()=>A.items[T].asString})}),I}t.toITreeDataTransfer=S;async function P(A){const I={types:[],items:[]},D=Array.from(A.entries());for(const T of D)I.types.push(T[0]),I.items.push({asString:await T[1].asString()});return I}t.toTreeDataTransferDTO=P})(r=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(Se[65],_e([0,1,11,2]),function(ee,e,r,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function S(I,D){return I.scheme===r.Schemas.http||I.scheme===r.Schemas.https?I:(D&&D.authority&&D.isRemote&&I.scheme===r.Schemas.file&&(I=t.URI.from({scheme:r.Schemas.vscodeRemote,authority:D.authority,path:I.path})),t.URI.from({scheme:r.Schemas.https,authority:`${I.scheme}+${P(I.authority)}.${e.webviewRootResourceAuthority}`,path:I.path,fragment:I.fragment,query:I.query}))}e.asWebviewUri=S;function P(I){return I.replace(/./g,D=>{const T=D.charCodeAt(0);return T>=97&&T<=122||T>=65&&T<=90||T>=48&&T<=57?D:"-"+T.toString(16).padStart(4,"0")})}function A(I){return I.replace(/-([0-9a-f]{4})/g,(D,T)=>String.fromCharCode(parseInt(T,16)))}e.decodeAuthority=A}),define(Se[153],_e([0,1,4,6,65]),function(ee,e,r,t,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class P{constructor(I,D,T){this._proxy=I,this._editors=D,this._initData=T,this._handlePool=0,this._disposables=new t.DisposableStore,this._insets=new Map,this._disposables.add(D.onDidChangeVisibleTextEditors(()=>{const R=D.getVisibleTextEditors();for(const b of this._insets.values())R.indexOf(b.editor)<0&&b.inset.dispose()}))}dispose(){this._insets.forEach(I=>I.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(I,D,T,R,b){let i;for(const _ of this._editors.getVisibleTextEditors(!0))if(_.value===I){i=_;break}if(!i)throw new Error("not a visible editor");const f=this,a=this._handlePool++,o=new r.Emitter,m=new r.Emitter,M=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(_){return(0,S.asWebviewUri)(_,f._initData.remote)}get cspSource(){return S.webviewGenericCspSource}set options(_){this._options=_,f._proxy.$setOptions(a,_)}get options(){return this._options}set html(_){this._html=_,f._proxy.$setHtml(a,_)}get html(){return this._html}get onDidReceiveMessage(){return o.event}postMessage(_){return f._proxy.$postMessage(a,_)}},y=new class{constructor(){this.editor=I,this.line=D,this.height=T,this.webview=M,this.onDidDispose=m.event}dispose(){f._insets.has(a)&&(f._insets.delete(a),f._proxy.$disposeEditorInset(a),m.fire(),m.dispose(),o.dispose())}};return this._proxy.$createEditorInset(a,i.id,i.value.document.uri,D+1,T,R||{},b.identifier,b.extensionLocation),this._insets.set(a,{editor:I,inset:y,onDidReceiveMessage:o}),y}$onDidDispose(I){const D=this._insets.get(I);D&&D.inset.dispose()}$onDidReceiveMessage(I,D){const T=this._insets.get(I);T&&T.onDidReceiveMessage.fire(D)}}e.ExtHostEditorInsets=P}),define(Se[154],_e([0,1,125,13,2,6,3,45,37,46,16,11]),function(ee,e,r,t,S,P,A,I,D,T,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.EditorTabsVisibleContext=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLockedContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.SideBySideEditorActiveContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorCanSplitInGroupContext=e.ActiveEditorCanRevertContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,r.localize)(0,null),providerDisplayName:(0,r.localize)(1,null)},e.ActiveEditorDirtyContext=new I.RawContextKey("activeEditorIsDirty",!1,(0,r.localize)(2,null)),e.ActiveEditorPinnedContext=new I.RawContextKey("activeEditorIsNotPreview",!1,(0,r.localize)(3,null)),e.ActiveEditorStickyContext=new I.RawContextKey("activeEditorIsPinned",!1,(0,r.localize)(4,null)),e.ActiveEditorReadonlyContext=new I.RawContextKey("activeEditorIsReadonly",!1,(0,r.localize)(5,null)),e.ActiveEditorCanRevertContext=new I.RawContextKey("activeEditorCanRevert",!1,(0,r.localize)(6,null)),e.ActiveEditorCanSplitInGroupContext=new I.RawContextKey("activeEditorCanSplitInGroup",!0),e.ActiveEditorContext=new I.RawContextKey("activeEditor",null,{type:"string",description:(0,r.localize)(7,null)}),e.ActiveEditorAvailableEditorIdsContext=new I.RawContextKey("activeEditorAvailableEditorIds","",(0,r.localize)(8,null)),e.TextCompareEditorVisibleContext=new I.RawContextKey("textCompareEditorVisible",!1,(0,r.localize)(9,null)),e.TextCompareEditorActiveContext=new I.RawContextKey("textCompareEditorActive",!1,(0,r.localize)(10,null)),e.SideBySideEditorActiveContext=new I.RawContextKey("sideBySideEditorActive",!1,(0,r.localize)(11,null)),e.EditorGroupEditorsCountContext=new I.RawContextKey("groupEditorsCount",0,(0,r.localize)(12,null)),e.ActiveEditorGroupEmptyContext=new I.RawContextKey("activeEditorGroupEmpty",!1,(0,r.localize)(13,null)),e.ActiveEditorGroupIndexContext=new I.RawContextKey("activeEditorGroupIndex",0,(0,r.localize)(14,null)),e.ActiveEditorGroupLastContext=new I.RawContextKey("activeEditorGroupLast",!1,(0,r.localize)(15,null)),e.ActiveEditorGroupLockedContext=new I.RawContextKey("activeEditorGroupLocked",!1,(0,r.localize)(16,null)),e.MultipleEditorGroupsContext=new I.RawContextKey("multipleEditorGroups",!1,(0,r.localize)(17,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new I.RawContextKey("editorIsOpen",!1,(0,r.localize)(18,null)),e.InEditorZenModeContext=new I.RawContextKey("inZenMode",!1,(0,r.localize)(19,null)),e.IsCenteredLayoutContext=new I.RawContextKey("isCenteredLayout",!1,(0,r.localize)(20,null)),e.SplitEditorsVertically=new I.RawContextKey("splitEditorsVertically",!1,(0,r.localize)(21,null)),e.EditorAreaVisibleContext=new I.RawContextKey("editorAreaVisible",!0,(0,r.localize)(22,null)),e.EditorTabsVisibleContext=new I.RawContextKey("editorTabsVisible",!0,(0,r.localize)(23,null)),e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function i(O,U,j){for(const H of j.visibleEditorPanes)if(H.group.id===U&&O.matches(H.input))return H.getViewState()}e.findViewStateForEditor=i;function f(O){if(C(O))return!1;const U=O;return S.URI.isUri(U?.resource)}e.isResourceEditorInput=f;function a(O){if(C(O))return!1;const U=O;return U?.original!==void 0&&U.modified!==void 0}e.isResourceDiffEditorInput=a;function o(O){if(C(O)||a(O))return!1;const U=O;return U?.primary!==void 0&&U.secondary!==void 0}e.isResourceSideBySideEditorInput=o;function m(O){if(C(O))return!1;const U=O;return U?U.resource===void 0||U.resource.scheme===b.Schemas.untitled||U.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=m;var M;(function(O){O[O.SHORT=0]="SHORT",O[O.MEDIUM=1]="MEDIUM",O[O.LONG=2]="LONG"})(M=e.Verbosity||(e.Verbosity={}));var y;(function(O){O[O.EXPLICIT=1]="EXPLICIT",O[O.AUTO=2]="AUTO",O[O.FOCUS_CHANGE=3]="FOCUS_CHANGE",O[O.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(y=e.SaveReason||(e.SaveReason={}));var _;(function(O){O[O.None=0]="None",O[O.Readonly=2]="Readonly",O[O.Untitled=4]="Untitled",O[O.Singleton=8]="Singleton",O[O.RequiresTrust=16]="RequiresTrust",O[O.CanSplitInGroup=32]="CanSplitInGroup",O[O.ForceDescription=64]="ForceDescription"})(_=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class u extends P.Disposable{}e.AbstractEditorInput=u;function C(O){return O instanceof u}e.isEditorInput=C;function l(O){const U=O;return S.URI.isUri(U?.preferredResource)}function F(O){const U=O;return C(U?.primary)&&C(U?.secondary)}e.isSideBySideEditorInput=F;function c(O){const U=O;return C(U?.modified)&&C(U?.original)}e.isDiffEditorInput=c;function n(O){return C(O?.editor)}e.isEditorInputWithOptions=n;function h(O){const U=O;return n(O)&&U?.group!==void 0}e.isEditorInputWithOptionsAndGroup=h;function g(O){const U=O;return typeof U?.groupId=="number"&&C(U.editor)}e.isEditorIdentifier=g;var s;(function(O){O[O.UNKNOWN=0]="UNKNOWN",O[O.REPLACE=1]="REPLACE",O[O.MOVE=2]="MOVE",O[O.UNPIN=3]="UNPIN"})(s=e.EditorCloseContext||(e.EditorCloseContext={}));var d;(function(O){O[O.GROUP_ACTIVE=0]="GROUP_ACTIVE",O[O.GROUP_INDEX=1]="GROUP_INDEX",O[O.GROUP_LOCKED=2]="GROUP_LOCKED",O[O.EDITOR_OPEN=3]="EDITOR_OPEN",O[O.EDITOR_CLOSE=4]="EDITOR_CLOSE",O[O.EDITOR_MOVE=5]="EDITOR_MOVE",O[O.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",O[O.EDITOR_LABEL=7]="EDITOR_LABEL",O[O.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",O[O.EDITOR_PIN=9]="EDITOR_PIN",O[O.EDITOR_STICKY=10]="EDITOR_STICKY",O[O.EDITOR_DIRTY=11]="EDITOR_DIRTY",O[O.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(d=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var p;(function(O){O[O.PRIMARY=1]="PRIMARY",O[O.SECONDARY=2]="SECONDARY",O[O.BOTH=3]="BOTH",O[O.ANY=4]="ANY"})(p=e.SideBySideEditor||(e.SideBySideEditor={}));class w{getOriginalUri(U,j){if(!U)return;if(j?.supportSideBySide){const{primary:$,secondary:G}=this.getSideEditors(U);if($&&G){if(j?.supportSideBySide===p.BOTH)return{primary:this.getOriginalUri($,{filterByScheme:j.filterByScheme}),secondary:this.getOriginalUri(G,{filterByScheme:j.filterByScheme})};if(j?.supportSideBySide===p.ANY)return this.getOriginalUri($,{filterByScheme:j.filterByScheme})??this.getOriginalUri(G,{filterByScheme:j.filterByScheme});U=j.supportSideBySide===p.PRIMARY?$:G}}if(a(U)||o(U))return;const H=l(U)?U.preferredResource:U.resource;return!H||!j||!j.filterByScheme?H:this.filterUri(H,j.filterByScheme)}getSideEditors(U){return F(U)||o(U)?{primary:U.primary,secondary:U.secondary}:c(U)||a(U)?{primary:U.modified,secondary:U.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(U,j){if(!U)return;if(j?.supportSideBySide){const{primary:$,secondary:G}=this.getSideEditors(U);if($&&G){if(j?.supportSideBySide===p.BOTH)return{primary:this.getCanonicalUri($,{filterByScheme:j.filterByScheme}),secondary:this.getCanonicalUri(G,{filterByScheme:j.filterByScheme})};if(j?.supportSideBySide===p.ANY)return this.getCanonicalUri($,{filterByScheme:j.filterByScheme})??this.getCanonicalUri(G,{filterByScheme:j.filterByScheme});U=j.supportSideBySide===p.PRIMARY?$:G}}if(a(U)||o(U))return;const H=U.resource;return!H||!j||!j.filterByScheme?H:this.filterUri(H,j.filterByScheme)}filterUri(U,j){if(Array.isArray(j)){if(j.some(H=>U.scheme===H))return U}else if(j===U.scheme)return U}}e.EditorResourceAccessor=new w;var v;(function(O){O[O.LEFT=0]="LEFT",O[O.RIGHT=1]="RIGHT"})(v=e.CloseDirection||(e.CloseDirection={}));class k{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(U){const j=this.instantiationService=U.get(A.IInstantiationService);for(const[H,$]of this.editorSerializerConstructors)this.createEditorSerializer(H,$,j);this.editorSerializerConstructors.clear()}createEditorSerializer(U,j,H){const $=H.createInstance(j);this.editorSerializerInstances.set(U,$)}registerFileEditorFactory(U){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=U}getFileEditorFactory(){return(0,t.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(U,j){if(this.editorSerializerConstructors.has(U)||this.editorSerializerInstances.has(U))throw new Error(`A editor serializer with type ID '${U}' was already registered.`);return this.instantiationService?this.createEditorSerializer(U,j,this.instantiationService):this.editorSerializerConstructors.set(U,j),(0,P.toDisposable)(()=>{this.editorSerializerConstructors.delete(U),this.editorSerializerInstances.delete(U)})}getEditorSerializer(U){return this.editorSerializerInstances.get(typeof U=="string"?U:U.typeId)}}D.Registry.add(e.EditorExtensions.EditorFactory,new k);async function L(O,U){if(!O||!O.length)return[];const j=await Promise.all(O.map(async H=>{const $=S.URI.revive(H.fileUri);if(!$||!await U.canHandleResource($))return;let ie=H.exists,le=H.type;if(typeof ie!="boolean"||typeof le!="number")try{le=(await U.resolve($)).isDirectory?T.FileType.Directory:T.FileType.Unknown,ie=!0}catch{ie=!1}if(!ie&&H.openOnlyIfExists||le===T.FileType.Directory)return;const X={selection:ie?H.selection:void 0,pinned:!0,override:H.editorOverrideId};let ue;return ie?ue={resource:$,options:X}:ue={resource:$,options:X,forceUntitled:!0},ue}));return(0,R.coalesce)(j)}e.pathsToEditors=L;var E;(function(O){O[O.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",O[O.SEQUENTIAL=1]="SEQUENTIAL"})(E=e.EditorsOrder||(e.EditorsOrder={}))}),define(Se[155],_e([0,1,4,10,126]),function(ee,e,r,t,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class P{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new r.Emitter,this._onExit=new r.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(I){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=I}onEvent(I){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=I}onRequest(I){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=I}sendResponse(I){I.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${I.command}`)):this.internalSend("response",I)}sendRequest(I,D,T,R){const b={command:I};if(D&&Object.keys(D).length>0&&(b.arguments=D),this.internalSend("request",b),typeof R=="number"){const i=setTimeout(()=>{clearTimeout(i);const f=this.pendingRequests.get(b.seq);if(f){this.pendingRequests.delete(b.seq);const a={type:"response",seq:0,request_seq:b.seq,success:!1,command:I,message:(0,S.localize)(0,null,R,I)};f(a)}},R)}return T&&this.pendingRequests.set(b.seq,T),b.seq}acceptMessage(I){this.messageCallback?this.messageCallback(I):(this.queue.push(I),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(I,D){return I.type!=="event"||D.type!=="event"}async processQueue(){let I;for(;this.queue.length;){if((!I||this.needsTaskBoundaryBetween(this.queue[0],I))&&await(0,t.timeout)(0),I=this.queue.shift(),!I)return;switch(I.type){case"event":this.eventCallback&&this.eventCallback(I);break;case"request":this.requestCallback&&this.requestCallback(I);break;case"response":{const D=I,T=this.pendingRequests.get(D.request_seq);T&&(this.pendingRequests.delete(D.request_seq),T(D));break}}}}internalSend(I,D){D.type=I,D.seq=this.sequence++,this.sendMessage(D)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const I=new Map;this.pendingRequests.forEach((D,T)=>I.set(T,D)),await(0,t.timeout)(500),I.forEach((D,T)=>{D({type:"response",seq:0,request_seq:T,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(T)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=P}),define(Se[156],_e([0,1,9,2,17,27,11]),function(ee,e,r,t,S,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const I=/{([^}]+)}/g;function D(c,n,h){return c.replace(I,function(g,s){return n&&s.length>0&&s[0]!=="_"?g:h&&h.hasOwnProperty(s)?h[s]:g})}e.formatPII=D;function T(c){const n={};for(const h of Object.keys(c))h.startsWith("!")||(n[h]=c[h]);return n}e.filterExceptionsFromTelemetry=T;function R(c){return c.configuration.request==="attach"&&!b(c)&&(!c.parentSession||R(c.parentSession))}e.isSessionAttach=R;function b(c){let n=c.configuration.type;if(!!n)return n==="vslsShare"&&(n=c.configuration.adapterProxy.configuration.type),(0,r.equalsIgnoreCase)(n,"extensionhost")||(0,r.equalsIgnoreCase)(n,"pwa-extensionhost")?c:c.parentSession?b(c.parentSession):void 0}e.getExtensionHostDebugSession=b;function i(c){return c.type&&(c.label||c.program||c.runtime)}e.isDebuggerMainContribution=i;function f(c,n,h){let g,s=0;const d=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let p=null;for(;p=d.exec(c);){const w=p.index+1,v=w+p[0].length;if(w<=n&&v>=h){g=p[0],s=w;break}}if(g){const w=/\w+/g;let v=null;for(;(v=w.exec(g))&&!(v.index+1+s+v[0].length>=h););v&&(g=g.substring(0,w.lastIndex))}return g?{start:s,end:s+g.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=f;const a=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function o(c){return!!(c&&c.match(a))}e.isUri=o;function m(c){if(typeof c.path=="string"&&!(typeof c.sourceReference=="number"&&c.sourceReference>0)){if(o(c.path))return t.URI.parse(c.path);if((0,S.isAbsolute)(c.path))return t.URI.file(c.path)}return c.path}function M(c){if(typeof c.path=="object"){const n=t.URI.revive(c.path);if(n)return n.scheme===A.Schemas.file?n.fsPath:n.toString()}return c.path}function y(c,n){const h=n?m:M,g=(0,P.deepClone)(c);return u(g,(s,d)=>{s&&d&&(d.path=h(d))}),g}e.convertToDAPaths=y;function _(c,n){const h=n?m:M,g=(0,P.deepClone)(c);return u(g,(s,d)=>{!s&&d&&(d.path=h(d))}),g}e.convertToVSCPaths=_;function u(c,n){switch(c.type){case"event":{const h=c;switch(h.event){case"output":n(!1,h.body.source);break;case"loadedSource":n(!1,h.body.source);break;case"breakpoint":n(!1,h.body.breakpoint.source);break;default:break}break}case"request":{const h=c;switch(h.command){case"setBreakpoints":n(!0,h.arguments.source);break;case"breakpointLocations":n(!0,h.arguments.source);break;case"source":n(!0,h.arguments.source);break;case"gotoTargets":n(!0,h.arguments.source);break;case"launchVSCode":h.arguments.args.forEach(g=>n(!1,g));break;default:break}break}case"response":{const h=c;if(h.success&&h.body)switch(h.command){case"stackTrace":h.body.stackFrames.forEach(g=>n(!1,g.source));break;case"loadedSources":h.body.sources.forEach(g=>n(!1,g));break;case"scopes":h.body.scopes.forEach(g=>n(!1,g.source));break;case"setFunctionBreakpoints":h.body.breakpoints.forEach(g=>n(!1,g.source));break;case"setBreakpoints":h.body.breakpoints.forEach(g=>n(!1,g.source));break;default:break}break}}}function C(c){return c.filter(n=>!n.presentation?.hidden).sort((n,h)=>n.presentation?h.presentation?n.presentation.group?h.presentation.group?n.presentation.group!==h.presentation.group?n.presentation.group.localeCompare(h.presentation.group):l(n.presentation.order,h.presentation.order):-1:h.presentation.group?1:l(n.presentation.order,h.presentation.order):-1:h.presentation?1:0)}e.getVisibleAndSorted=C;function l(c,n){return typeof c!="number"?typeof n!="number"?0:1:typeof n!="number"?-1:c-n}async function F(c,n){const h=c.getValue("debug.saveBeforeStart",{overrideIdentifier:n.activeTextEditorLanguageId});if(h!=="none"&&(await n.saveAll(),h==="allEditorsInActiveGroup")){const g=n.activeEditorPane;g&&g.input.resource?.scheme===A.Schemas.untitled&&await n.save({editor:g.input,groupId:g.group.id})}await c.reloadConfiguration()}e.saveAllBeforeDebugStart=F}),define(Se[85],_e([0,1,29,157,74,11,17,23,45]),function(ee,e,r,t,S,P,A,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var T;(function(w){w[w.Markup=1]="Markup",w[w.Code=2]="Code"})(T=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",S.Mimes.latex,S.Mimes.markdown,"image/png","image/jpeg",S.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[S.Mimes.latex,S.Mimes.markdown,"application/json",S.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var R;(function(w){w[w.Running=1]="Running",w[w.Idle=2]="Idle"})(R=e.NotebookRunState||(e.NotebookRunState={}));var b;(function(w){w[w.Pending=2]="Pending",w[w.Executing=3]="Executing"})(b=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var i;(function(w){w[w.WithHardKernelDependency=0]="WithHardKernelDependency",w[w.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",w[w.Pure=2]="Pure",w[w.Never=3]="Never"})(i=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var f;(function(w){w.Always="always",w.Never="never",w.Optional="optional"})(f=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var a;(function(w){w[w.ModelChange=1]="ModelChange",w[w.Move=2]="Move",w[w.ChangeLanguage=5]="ChangeLanguage",w[w.Initialize=6]="Initialize",w[w.ChangeCellMetadata=7]="ChangeCellMetadata",w[w.Output=8]="Output",w[w.OutputItem=9]="OutputItem",w[w.ChangeCellContent=10]="ChangeCellContent",w[w.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",w[w.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",w[w.ChangeCellMime=13]="ChangeCellMime",w[w.Unknown=100]="Unknown"})(a=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var o;(function(w){w[w.Handle=0]="Handle",w[w.Index=1]="Index"})(o=e.SelectionStateType||(e.SelectionStateType={}));var m;(function(w){w[w.Replace=1]="Replace",w[w.Output=2]="Output",w[w.Metadata=3]="Metadata",w[w.CellLanguage=4]="CellLanguage",w[w.DocumentMetadata=5]="DocumentMetadata",w[w.Move=6]="Move",w[w.OutputItems=7]="OutputItems",w[w.PartialMetadata=8]="PartialMetadata",w[w.PartialInternalMetadata=9]="PartialInternalMetadata"})(m=e.CellEditType||(e.CellEditType={}));var M;(function(w){w.scheme=P.Schemas.vscodeNotebookCell;const v=/^ch(\d{7,})/;function k(H,$){return H.with({scheme:w.scheme,fragment:`ch${$.toString().padStart(7,"0")}${H.scheme!==P.Schemas.file?H.scheme:""}`})}w.generate=k;function L(H){if(H.scheme!==w.scheme)return;const $=v.exec(H.fragment);return $?{handle:Number($[1]),notebook:H.with({scheme:H.fragment.substring($[0].length)||P.Schemas.file,fragment:null})}:void 0}w.parse=L;function E(H,$,G){return H.with({scheme:P.Schemas.vscodeNotebookCellOutput,fragment:`ch${$.toString().padStart(7,"0")},${G??""},${H.scheme!==P.Schemas.file?H.scheme:""}`})}w.generateCellOutputUri=E;function O(H){if(H.scheme!==P.Schemas.vscodeNotebookCellOutput)return;const $=/^ch(\d{7,})\,([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(H.fragment);if(!$)return;const G=Number($[1]),ie=$[2]&&$[2]!==""?$[2]:void 0,le=$[3];return{handle:G,outputId:ie,notebook:H.with({scheme:le||P.Schemas.file,fragment:null})}}w.parseCellOutputUri=O;function U(H,$,G){return H.with({scheme:G,fragment:`ch${$.toString().padStart(7,"0")}${H.scheme!==P.Schemas.file?H.scheme:""}`})}w.generateCellUri=U;function j(H,$){if(H.scheme!==$)return;const G=v.exec(H.fragment);return G?{handle:Number(G[1]),notebook:H.with({scheme:H.fragment.substring(G[0].length)||P.Schemas.file,fragment:null})}:void 0}w.parseCellUri=j})(M=e.CellUri||(e.CellUri={}));const y=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[S.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function _(w){return y.get(w)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=_;function u(w){return y.get(w)?.supportedByCore??!1}e.mimeTypeSupportedByCore=u;function C(w){return y.get(w)?.mergeable??!1}e.mimeTypeIsMergeable=C;const l=w=>I.isWindows?w.replace(/\//g,"\\"):w;class F{constructor(v=[],k=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=k,this.order=[...new Set(v)].map(L=>({pattern:L,matches:r.parse(l(L))}))}sort(v){const k=new Map(t.Iterable.map(v,E=>[E,l(E)]));let L=[];for(const{matches:E}of this.order)for(const[O,U]of k)if(E(U)){L.push(O),k.delete(O);break}return k.size&&(L=L.concat([...k.keys()].sort((E,O)=>this.defaultOrder.indexOf(E)-this.defaultOrder.indexOf(O)))),L}prioritize(v,k){const L=this.findIndex(v);if(L===-1){this.order.unshift({pattern:v,matches:r.parse(l(v))});return}const E=new Set(k.map(U=>this.findIndex(U,L)));E.delete(-1);const O=Array.from(E).sort();this.order.splice(L+1,0,...O.map(U=>this.order[U]));for(let U=O.length-1;U>=0;U--)this.order.splice(O[U],1)}toArray(){return this.order.map(v=>v.pattern)}findIndex(v,k=this.order.length){const L=l(v);for(let E=0;E<k;E++)if(this.order[E].matches(L))return E;return-1}}e.MimeTypeDisplayOrder=F;function c(w,v,k,L=(E,O)=>E===O){const E=[];function O(H,$,G){if($===0&&G.length===0)return;const ie=E[E.length-1];ie&&ie.start+ie.deleteCount===H?(ie.deleteCount+=$,ie.toInsert.push(...G)):E.push({start:H,deleteCount:$,toInsert:G})}let U=0,j=0;for(;;){if(U===w.length){O(U,0,v.slice(j));break}if(j===v.length){O(U,w.length-U,[]);break}const H=w[U],$=v[j];if(L(H,$)){U+=1,j+=1;continue}k($)?(O(U,1,[]),U+=1):(O(U,0,[$]),j+=1)}return E}e.diff=c,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new D.RawContextKey("notebookEditorCursorAtBoundary","none");var n;(function(w){w.default="default",w.option="option"})(n=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function h(w){const v=w;return!!((typeof v.include=="string"||r.isRelativePattern(v.include))&&(typeof v.exclude=="string"||r.isRelativePattern(v.exclude)))}e.isDocumentExcludePattern=h;function g(w,v,k){if(Array.isArray(w.viewType)&&w.viewType.indexOf(v)>=0||w.viewType===v)return!0;if(w.filenamePattern){const L=h(w.filenamePattern)?w.filenamePattern.include:w.filenamePattern,E=h(w.filenamePattern)?w.filenamePattern.exclude:void 0;if(r.match(L,(0,A.basename)(k.fsPath).toLowerCase()))return!(E&&r.match(E,(0,A.basename)(k.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=g;class s{constructor(v){this.textModel=v}getElements(){const v=new Int32Array(this.textModel.cells.length);for(let k=0;k<this.textModel.cells.length;k++)v[k]=this.textModel.cells[k].getHashValue();return v}}e.CellSequence=s,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode"};var d;(function(w){w[w.Left=1]="Left",w[w.Right=2]="Right"})(d=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class p{static create(v){return`${p._prefix}${v}`}static parse(v){if(v.startsWith(p._prefix))return v.substring(p._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=p,p._prefix="notebook/"}),define(Se[158],_e([0,1,3]),function(ee,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var t;(function(S){S[S.Output=1]="Output",S[S.OutputItems=2]="OutputItems",S[S.ExecutionState=3]="ExecutionState"})(t=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,r.createDecorator)("INotebookExecutionService")}),define(Se[159],_e([0,1,3,45]),function(ee,e,r,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new t.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new t.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new t.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,r.createDecorator)(e.OUTPUT_SERVICE_ID);var S;(function(P){P[P.Append=1]="Append",P[P.Replace=2]="Replace",P[P.Clear=3]="Clear"})(S=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={}))}),define(Se[160],_e([0,1,128,3,45]),function(ee,e,r,t,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new S.RawContextKey("customExecutionSupported",!0,r.localize(0,null)),e.ShellExecutionSupportedContext=new S.RawContextKey("shellExecutionSupported",!1,r.localize(1,null)),e.ProcessExecutionSupportedContext=new S.RawContextKey("processExecutionSupported",!1,r.localize(2,null)),e.ITaskService=(0,t.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(Se[161],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function r(S){return[...S.entries()]}e.serializeEnvironmentVariableCollection=r;function t(S){return new Map(S)}e.deserializeEnvironmentVariableCollection=t}),define(Se[86],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.TestMessageType=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var r;(function(b){b[b.Unset=0]="Unset",b[b.Queued=1]="Queued",b[b.Running=2]="Running",b[b.Passed=3]="Passed",b[b.Failed=4]="Failed",b[b.Skipped=5]="Skipped",b[b.Errored=6]="Errored"})(r=e.TestResultState||(e.TestResultState={}));var t;(function(b){b[b.Run=2]="Run",b[b.Debug=4]="Debug",b[b.Coverage=8]="Coverage",b[b.HasNonDefaultProfile=16]="HasNonDefaultProfile",b[b.HasConfigurable=32]="HasConfigurable"})(t=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var S;(function(b){b[b.Error=0]="Error",b[b.Info=1]="Info"})(S=e.TestMessageType||(e.TestMessageType={}));var P;(function(b){b[b.NotExpandable=0]="NotExpandable",b[b.Expandable=1]="Expandable",b[b.BusyExpanding=2]="BusyExpanding",b[b.Expanded=3]="Expanded"})(P=e.TestItemExpandState||(e.TestItemExpandState={}));const A=(b,i)=>{i.expand!==void 0&&(b.expand=i.expand),i.item!==void 0&&(b.item=b.item?Object.assign(b.item,i.item):i.item)};e.applyTestItemUpdate=A;var I;(function(b){b[b.Function=0]="Function",b[b.Statement=1]="Statement"})(I=e.DetailType||(e.DetailType={}));var D;(function(b){b[b.Add=0]="Add",b[b.Update=1]="Update",b[b.Remove=2]="Remove",b[b.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",b[b.Retire=4]="Retire",b[b.AddTag=5]="AddTag",b[b.RemoveTag=6]="RemoveTag"})(D=e.TestDiffOpType||(e.TestDiffOpType={}));class T{add(i){}update(i){}remove(i,f){}complete(){}}e.IncrementalChangeCollector=T;class R{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(i){const f=this.createChangeCollector();for(const a of i)switch(a[0]){case 0:{const o=a[1];if(o.parent){if(this.items.has(o.parent)){const m=this.items.get(o.parent);m.children.add(o.item.extId);const M=this.createItem(o,m);this.items.set(o.item.extId,M),f.add(M)}}else{const m=this.createItem(o);this.roots.add(m),this.items.set(o.item.extId,m),f.add(m)}o.expand===2&&this.busyControllerCount++;break}case 1:{const o=a[1],m=this.items.get(o.extId);if(!m)break;o.expand!==void 0&&(m.expand===2&&this.busyControllerCount--,o.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(m,o),f.update(m);break}case 2:{const o=this.items.get(a[1]);if(!o)break;o.parent?this.items.get(o.parent).children.delete(o.item.extId):this.roots.delete(o);const m=[[a[1]]];for(;m.length;)for(const M of m.pop()){const y=this.items.get(M);y&&(m.push(y.children),this.items.delete(M),f.remove(y,y!==o),y.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(a[1]);break;case 3:this.updatePendingRoots(a[1]);break;case 5:this._tags.set(a[1].id,a[1]);break;case 6:this._tags.delete(a[1]);break}f.complete()}retireTest(i){}updatePendingRoots(i){this.pendingRootCount+=i}createChangeCollector(){return new T}}e.AbstractIncrementalTestCollection=R}),define(Se[66],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var r;(function(P){P.Delimiter="\0"})(r=e.TestIdPathParts||(e.TestIdPathParts={}));var t;(function(P){P[P.IsSame=0]="IsSame",P[P.Disconnected=1]="Disconnected",P[P.IsChild=2]="IsChild",P[P.IsParent=3]="IsParent"})(t=e.TestPosition||(e.TestPosition={}));class S{constructor(A,I=A.length){if(this.path=A,this.viewEnd=I,A.length===0||I<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(A,I,D=A.parent){if(A.id===I)return new S([I]);let T=[A.id];for(let R=D;R&&R.id!==I;R=R.parent)T.push(R.id);return T.push(I),new S(T.reverse())}static isRoot(A){return!A.includes("\0")}static root(A){const I=A.indexOf("\0");return I===-1?A:A.slice(0,I)}static fromString(A){return new S(A.split("\0"))}static join(A,I){return new S([...A.path,I])}static joinToString(A,I){return A.toString()+"\0"+I}static compare(A,I){return A===I?0:I.startsWith(A+"\0")?2:A.startsWith(I+"\0")?3:1}get parentId(){return this.viewEnd>1?new S(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let A=1;A<=this.viewEnd;A++)yield new S(this.path,A)}compare(A){if(typeof A=="string")return S.compare(this.toString(),A);for(let I=0;I<A.viewEnd&&I<this.viewEnd;I++)if(A.path[I]!==this.path[I])return 1;return A.viewEnd>this.viewEnd?2:A.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let A=1;A<this.viewEnd;A++)this.stringifed+="\0",this.stringifed+=this.path[A]}return this.stringifed}}e.TestId=S}),define(Se[162],_e([0,1,17,87,13,27,23,76,129]),function(ee,e,r,t,S,P,A,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class T{constructor(b,i,f){this._contributedVariables=new Map,this._context=b,this._labelService=i,f&&(this._envVariablesPromise=f.then(a=>this.prepareEnv(a)))}prepareEnv(b){if(A.isWindows){const i=Object.create(null);return Object.keys(b).forEach(f=>{i[f.toLowerCase()]=b[f]}),i}return b}resolveWithEnvironment(b,i,f){return this.recursiveResolve(this.prepareEnv(b),i?i.uri:void 0,f)}async resolveAsync(b,i){return this.recursiveResolve(await this._envVariablesPromise,b?b.uri:void 0,i)}async resolveAnyBase(b,i,f,a){const o=P.deepClone(i);return A.isWindows&&o.windows?Object.keys(o.windows).forEach(m=>o[m]=o.windows[m]):A.isMacintosh&&o.osx?Object.keys(o.osx).forEach(m=>o[m]=o.osx[m]):A.isLinux&&o.linux&&Object.keys(o.linux).forEach(m=>o[m]=o.linux[m]),delete o.windows,delete o.osx,delete o.linux,this.recursiveResolve(await this._envVariablesPromise,b?b.uri:void 0,o,f,a)}async resolveAnyAsync(b,i,f){return this.resolveAnyBase(b,i,f)}async resolveAnyMap(b,i,f){const a=new Map;return{newConfig:await this.resolveAnyBase(b,i,f,a),resolvedVariables:a}}resolveWithInteractionReplace(b,i,f,a){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(b,i,f,a){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(b,i){if(this._contributedVariables.has(b))throw new Error("Variable "+b+" is contributed twice.");this._contributedVariables.set(b,i)}recursiveResolve(b,i,f,a,o){if(S.isString(f))return this.resolveString(b,i,f,a,o);if(S.isArray(f))return f.map(m=>this.recursiveResolve(b,i,m,a,o));if(S.isObject(f)){let m=Object.create(null);return Object.keys(f).forEach(M=>{const y=this.resolveString(b,i,M,a,o);m[y]=this.recursiveResolve(b,i,f[M],a,o)}),m}return f}resolveString(b,i,f,a,o){return f.replace(T.VARIABLE_REGEXP,(M,y)=>{if(y.includes(T.VARIABLE_LHS))return M;let _=this.evaluateSingleVariable(b,M,y,i,a);return o&&o.set(y,_),_!==M&&S.isString(_)&&_.match(T.VARIABLE_REGEXP)&&(_=this.resolveString(b,i,_,a,o)),_})}fsPath(b){return this._labelService?this._labelService.getUriLabel(b,{noPrefix:!0}):b.fsPath}evaluateSingleVariable(b,i,f,a,o){let m;const M=f.split(":");M.length>1&&(f=M[0],m=M[1]);const y=()=>{const C=this._context.getFilePath();if(C)return C;throw new Error((0,D.localize)(0,null,i))},_=()=>{const C=y();if(this._context.getWorkspaceFolderPathForFile){const l=this._context.getWorkspaceFolderPathForFile();if(l)return l}throw new Error((0,D.localize)(1,null,i,r.basename(C)))},u=()=>{if(m){const C=this._context.getFolderUri(m);if(C)return C;throw new Error((0,D.localize)(2,null,i,m))}if(a)return a;throw this._context.getWorkspaceFolderCount()>1?new Error((0,D.localize)(3,null,i)):new Error((0,D.localize)(4,null,i))};switch(f){case"env":if(m){if(b){const C=b[A.isWindows?m.toLowerCase():m];if(S.isString(C))return C}return""}throw new Error((0,D.localize)(5,null,i));case"config":if(m){const C=this._context.getConfigurationValue(a,m);if(S.isUndefinedOrNull(C))throw new Error((0,D.localize)(6,null,i,m));if(S.isObject(C))throw new Error((0,D.localize)(7,null,i,m));return C}throw new Error((0,D.localize)(8,null,i));case"command":return this.resolveFromMap(i,m,o,"command");case"input":return this.resolveFromMap(i,m,o,"input");default:switch(f){case"workspaceRoot":case"workspaceFolder":return(0,I.normalizeDriveLetter)(this.fsPath(u()));case"cwd":return a||m?(0,I.normalizeDriveLetter)(this.fsPath(u())):t.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return r.basename(this.fsPath(u()));case"lineNumber":{const C=this._context.getLineNumber();if(C)return C;throw new Error((0,D.localize)(9,null,i))}case"selectedText":{const C=this._context.getSelectedText();if(C)return C;throw new Error((0,D.localize)(10,null,i))}case"file":return y();case"fileWorkspaceFolder":return _();case"relativeFile":return a||m?r.relative(this.fsPath(u()),y()):y();case"relativeFileDirname":{const C=r.dirname(y());if(a||m){const l=r.relative(this.fsPath(u()),C);return l.length===0?".":l}return C}case"fileDirname":return r.dirname(y());case"fileExtname":return r.extname(y());case"fileBasename":return r.basename(y());case"fileBasenameNoExtension":{const C=r.basename(y());return C.slice(0,C.length-r.extname(C).length)}case"fileDirnameBasename":return r.basename(r.dirname(y()));case"execPath":{const C=this._context.getExecPath();return C||i}case"execInstallFolder":{const C=this._context.getAppRoot();return C||i}case"pathSeparator":return r.sep;default:try{const C=m?`${f}:${m}`:f;return this.resolveFromMap(i,C,o,void 0)}catch{return i}}}}resolveFromMap(b,i,f,a){if(i&&f){const o=a===void 0?f[i]:f[a+":"+i];if(typeof o=="string")return o;throw new Error((0,D.localize)(11,null,b))}return b}}e.AbstractVariableResolverService=T,T.VARIABLE_LHS="${",T.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(Se[88],_e([0,1,3,154]),function(ee,e,r,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,r.createDecorator)("editorGroupsService");var S;(function(a){a[a.UP=0]="UP",a[a.DOWN=1]="DOWN",a[a.LEFT=2]="LEFT",a[a.RIGHT=3]="RIGHT"})(S=e.GroupDirection||(e.GroupDirection={}));var P;(function(a){a[a.HORIZONTAL=0]="HORIZONTAL",a[a.VERTICAL=1]="VERTICAL"})(P=e.GroupOrientation||(e.GroupOrientation={}));var A;(function(a){a[a.FIRST=0]="FIRST",a[a.LAST=1]="LAST",a[a.NEXT=2]="NEXT",a[a.PREVIOUS=3]="PREVIOUS"})(A=e.GroupLocation||(e.GroupLocation={}));var I;(function(a){a[a.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",a[a.EVEN=1]="EVEN",a[a.TOGGLE=2]="TOGGLE"})(I=e.GroupsArrangement||(e.GroupsArrangement={}));var D;(function(a){a[a.COPY_EDITORS=0]="COPY_EDITORS",a[a.MOVE_EDITORS=1]="MOVE_EDITORS"})(D=e.MergeGroupMode||(e.MergeGroupMode={}));function T(a){const o=a;return(0,t.isEditorInput)(o?.editor)&&(0,t.isEditorInput)(o?.replacement)}e.isEditorReplacement=T;var R;(function(a){a[a.CREATION_TIME=0]="CREATION_TIME",a[a.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",a[a.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(R=e.GroupsOrder||(e.GroupsOrder={}));var b;(function(a){a[a.NEW_EDITOR=1]="NEW_EDITOR",a[a.MOVE_EDITOR=2]="MOVE_EDITOR",a[a.COPY_EDITOR=3]="COPY_EDITOR"})(b=e.OpenEditorContext||(e.OpenEditorContext={}));function i(a){const o=a;return!!o&&typeof o.id=="number"&&Array.isArray(o.editors)}e.isEditorGroup=i;function f(a){return a.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=f}),define(Se[163],_e([0,1,3,88]),function(ee,e,r,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,r.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function S(P){const A=P;return typeof P=="number"||(0,t.isEditorGroup)(A)}e.isPreferredGroup=S}),define(Se[8],_e([0,1,16,21,75,225,55,27,13,2,58,57,130,80,48,85,66,163,7]),function(ee,e,r,t,S,P,A,I,D,T,R,b,i,f,a,o,m,M,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var _;(function(ce){function fe(W){const{selectionStartLineNumber:Ee,selectionStartColumn:Re,positionLineNumber:Ve,positionColumn:We}=W,mt=new y.Position(Ee-1,Re-1),Et=new y.Position(Ve-1,We-1);return new y.Selection(mt,Et)}ce.to=fe;function oe(W){const{anchor:Ee,active:Re}=W;return{selectionStartLineNumber:Ee.line+1,selectionStartColumn:Ee.character+1,positionLineNumber:Re.line+1,positionColumn:Re.character+1}}ce.from=oe})(_=e.Selection||(e.Selection={}));var u;(function(ce){function fe(W){if(!W)return;const{start:Ee,end:Re}=W;return{startLineNumber:Ee.line+1,startColumn:Ee.character+1,endLineNumber:Re.line+1,endColumn:Re.character+1}}ce.from=fe;function oe(W){if(!W)return;const{startLineNumber:Ee,startColumn:Re,endLineNumber:Ve,endColumn:We}=W;return new y.Range(Ee-1,Re-1,Ve-1,We-1)}ce.to=oe})(u=e.Range||(e.Range={}));var C;(function(ce){function fe(oe){switch(oe){case 1:return y.StandardTokenType.Comment;case 0:return y.StandardTokenType.Other;case 3:return y.StandardTokenType.RegEx;case 2:return y.StandardTokenType.String}}ce.to=fe})(C=e.TokenType||(e.TokenType={}));var l;(function(ce){function fe(W){return new y.Position(W.lineNumber-1,W.column-1)}ce.to=fe;function oe(W){return{lineNumber:W.line+1,column:W.character+1}}ce.from=oe})(l=e.Position||(e.Position={}));var F;(function(ce){function fe(Ee,Re){return(0,r.coalesce)((0,r.asArray)(Ee).map(Ve=>oe(Ve,Re)))}ce.from=fe;function oe(Ee,Re){if(typeof Ee=="string")return{$serialized:!0,language:Ee};if(Ee)return{$serialized:!0,language:Ee.language,scheme:W(Ee.scheme,Re),pattern:he.from(Ee.pattern)??void 0,exclusive:Ee.exclusive}}function W(Ee,Re){return Re&&typeof Ee=="string"?Re.transformOutgoingScheme(Ee):Ee}})(F=e.DocumentSelector||(e.DocumentSelector={}));var c;(function(ce){function fe(W){switch(W){case y.DiagnosticTag.Unnecessary:return 1;case y.DiagnosticTag.Deprecated:return 2}}ce.from=fe;function oe(W){switch(W){case 1:return y.DiagnosticTag.Unnecessary;case 2:return y.DiagnosticTag.Deprecated;default:return}}ce.to=oe})(c=e.DiagnosticTag||(e.DiagnosticTag={}));var n;(function(ce){function fe(W){let Ee;return W.code&&((0,D.isString)(W.code)||(0,D.isNumber)(W.code)?Ee=String(W.code):Ee={value:String(W.code.value),target:W.code.target}),{...u.from(W.range),message:W.message,source:W.source,code:Ee,severity:g.from(W.severity),relatedInformation:W.relatedInformation&&W.relatedInformation.map(h.from),tags:Array.isArray(W.tags)?(0,r.coalesce)(W.tags.map(c.from)):void 0}}ce.from=fe;function oe(W){const Ee=new y.Diagnostic(u.to(W),W.message,g.to(W.severity));return Ee.source=W.source,Ee.code=(0,D.isString)(W.code)?W.code:W.code?.value,Ee.relatedInformation=W.relatedInformation&&W.relatedInformation.map(h.to),Ee.tags=W.tags&&(0,r.coalesce)(W.tags.map(c.to)),Ee}ce.to=oe})(n=e.Diagnostic||(e.Diagnostic={}));var h;(function(ce){function fe(W){return{...u.from(W.location.range),message:W.message,resource:W.location.uri}}ce.from=fe;function oe(W){return new y.DiagnosticRelatedInformation(new y.Location(W.resource,u.to(W)),W.message)}ce.to=oe})(h=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var g;(function(ce){function fe(W){switch(W){case y.DiagnosticSeverity.Error:return f.MarkerSeverity.Error;case y.DiagnosticSeverity.Warning:return f.MarkerSeverity.Warning;case y.DiagnosticSeverity.Information:return f.MarkerSeverity.Info;case y.DiagnosticSeverity.Hint:return f.MarkerSeverity.Hint}return f.MarkerSeverity.Error}ce.from=fe;function oe(W){switch(W){case f.MarkerSeverity.Info:return y.DiagnosticSeverity.Information;case f.MarkerSeverity.Warning:return y.DiagnosticSeverity.Warning;case f.MarkerSeverity.Error:return y.DiagnosticSeverity.Error;case f.MarkerSeverity.Hint:return y.DiagnosticSeverity.Hint;default:return y.DiagnosticSeverity.Error}}ce.to=oe})(g=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var s;(function(ce){function fe(W){return typeof W=="number"&&W>=y.ViewColumn.One?W-1:W===y.ViewColumn.Beside?M.SIDE_GROUP:M.ACTIVE_GROUP}ce.from=fe;function oe(W){if(typeof W=="number"&&W>=0)return W+1;throw new Error("invalid 'EditorGroupColumn'")}ce.to=oe})(s=e.ViewColumn||(e.ViewColumn={}));function d(ce){return typeof ce.range!="undefined"}function p(ce){return ce.length===0?!0:!!d(ce[0])}e.isDecorationOptionsArr=p;var w;(function(ce){function fe(We){return We.map(ce.from)}ce.fromMany=fe;function oe(We){return We&&typeof We=="object"&&typeof We.language=="string"&&typeof We.value=="string"}function W(We){let mt;if(oe(We)){const{language:vt,value:bt}=We;mt={value:"```"+vt+`
`+bt+"\n```\n"}}else y.MarkdownString.isMarkdownString(We)?mt={value:We.value,isTrusted:We.isTrusted,supportThemeIcons:We.supportThemeIcons,supportHtml:We.supportHtml}:typeof We=="string"?mt={value:We}:mt={value:""};const Et=Object.create(null);mt.uris=Et;const St=vt=>{try{let bt=T.URI.parse(vt,!0);bt=bt.with({query:Ee(bt.query,Et)}),Et[vt]=bt}catch{}return""},dt=new P.Renderer;return dt.link=St,dt.image=vt=>St(S.parseHrefAndDimensions(vt).href),P(mt.value,{renderer:dt}),mt}ce.from=W;function Ee(We,mt){if(!We)return We;let Et;try{Et=(0,A.parse)(We)}catch{}if(!Et)return We;let St=!1;return Et=(0,I.cloneAndChange)(Et,dt=>{if(T.URI.isUri(dt)){const vt=`__uri_${Math.random().toString(16).slice(2,8)}`;return mt[vt]=dt,St=!0,vt}else return}),St?JSON.stringify(Et):We}function Re(We){const mt=new y.MarkdownString(We.value,We.supportThemeIcons);return mt.isTrusted=We.isTrusted,mt.supportHtml=We.supportHtml,mt}ce.to=Re;function Ve(We){if(!!We)return typeof We=="string"?We:ce.from(We)}ce.fromStrict=Ve})(w=e.MarkdownString||(e.MarkdownString={}));function v(ce){return p(ce)?ce.map(fe=>({range:u.from(fe.range),hoverMessage:Array.isArray(fe.hoverMessage)?w.fromMany(fe.hoverMessage):fe.hoverMessage?w.from(fe.hoverMessage):void 0,renderOptions:fe.renderOptions})):ce.map(fe=>({range:u.from(fe)}))}e.fromRangeOrRangeWithMessage=v;function k(ce){return typeof ce=="undefined"?ce:typeof ce=="string"?T.URI.file(ce):ce}e.pathOrURIToURI=k;var L;(function(ce){function fe(oe){return typeof oe=="undefined"?oe:{contentText:oe.contentText,contentIconPath:oe.contentIconPath?k(oe.contentIconPath):void 0,border:oe.border,borderColor:oe.borderColor,fontStyle:oe.fontStyle,fontWeight:oe.fontWeight,textDecoration:oe.textDecoration,color:oe.color,backgroundColor:oe.backgroundColor,margin:oe.margin,width:oe.width,height:oe.height}}ce.from=fe})(L=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var E;(function(ce){function fe(oe){return typeof oe=="undefined"?oe:{backgroundColor:oe.backgroundColor,outline:oe.outline,outlineColor:oe.outlineColor,outlineStyle:oe.outlineStyle,outlineWidth:oe.outlineWidth,border:oe.border,borderColor:oe.borderColor,borderRadius:oe.borderRadius,borderSpacing:oe.borderSpacing,borderStyle:oe.borderStyle,borderWidth:oe.borderWidth,fontStyle:oe.fontStyle,fontWeight:oe.fontWeight,textDecoration:oe.textDecoration,cursor:oe.cursor,color:oe.color,opacity:oe.opacity,letterSpacing:oe.letterSpacing,gutterIconPath:oe.gutterIconPath?k(oe.gutterIconPath):void 0,gutterIconSize:oe.gutterIconSize,overviewRulerColor:oe.overviewRulerColor,before:oe.before?L.from(oe.before):void 0,after:oe.after?L.from(oe.after):void 0}}ce.from=fe})(E=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var O;(function(ce){function fe(oe){if(typeof oe=="undefined")return oe;switch(oe){case y.DecorationRangeBehavior.OpenOpen:return 0;case y.DecorationRangeBehavior.ClosedClosed:return 1;case y.DecorationRangeBehavior.OpenClosed:return 2;case y.DecorationRangeBehavior.ClosedOpen:return 3}}ce.from=fe})(O=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var U;(function(ce){function fe(oe){return{isWholeLine:oe.isWholeLine,rangeBehavior:oe.rangeBehavior?O.from(oe.rangeBehavior):void 0,overviewRulerLane:oe.overviewRulerLane,light:oe.light?E.from(oe.light):void 0,dark:oe.dark?E.from(oe.dark):void 0,backgroundColor:oe.backgroundColor,outline:oe.outline,outlineColor:oe.outlineColor,outlineStyle:oe.outlineStyle,outlineWidth:oe.outlineWidth,border:oe.border,borderColor:oe.borderColor,borderRadius:oe.borderRadius,borderSpacing:oe.borderSpacing,borderStyle:oe.borderStyle,borderWidth:oe.borderWidth,fontStyle:oe.fontStyle,fontWeight:oe.fontWeight,textDecoration:oe.textDecoration,cursor:oe.cursor,color:oe.color,opacity:oe.opacity,letterSpacing:oe.letterSpacing,gutterIconPath:oe.gutterIconPath?k(oe.gutterIconPath):void 0,gutterIconSize:oe.gutterIconSize,overviewRulerColor:oe.overviewRulerColor,before:oe.before?L.from(oe.before):void 0,after:oe.after?L.from(oe.after):void 0}}ce.from=fe})(U=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var j;(function(ce){function fe(W){return{text:W.newText,eol:W.newEol&&pt.from(W.newEol),range:u.from(W.range)}}ce.from=fe;function oe(W){const Ee=new y.TextEdit(u.to(W.range),W.text);return Ee.newEol=typeof W.eol=="undefined"?void 0:pt.to(W.eol),Ee}ce.to=oe})(j=e.TextEdit||(e.TextEdit={}));var H;(function(ce){function fe(W,Ee,Re){const Ve={edits:[]};if(W instanceof y.WorkspaceEdit)for(let We of W._allEntries())if(We._type===1)Ve.edits.push({_type:1,oldUri:We.from,newUri:We.to,options:We.options,metadata:We.metadata});else if(We._type===2){const mt=Ee?.getDocument(We.uri);Ve.edits.push({_type:2,resource:We.uri,edit:j.from(We.edit),modelVersionId:mt?.version,metadata:We.metadata})}else We._type===3?Ve.edits.push({_type:3,metadata:We.metadata,resource:We.uri,edit:We.edit,notebookMetadata:We.notebookMetadata,notebookVersionId:Re?.getNotebookDocument(We.uri,!0)?.apiNotebook.version}):We._type===5&&Ve.edits.push({_type:3,metadata:We.metadata,resource:We.uri,notebookVersionId:Re?.getNotebookDocument(We.uri,!0)?.apiNotebook.version,edit:{editType:1,index:We.index,count:We.count,cells:We.cells.map(kt.from)}});return Ve}ce.from=fe;function oe(W){const Ee=new y.WorkspaceEdit;for(const Re of W.edits)Re.edit?Ee.replace(T.URI.revive(Re.resource),u.to(Re.edit.range),Re.edit.text):Ee.renameFile(T.URI.revive(Re.oldUri),T.URI.revive(Re.newUri),Re.options);return Ee}ce.to=oe})(H=e.WorkspaceEdit||(e.WorkspaceEdit={}));var $;(function(ce){const fe=Object.create(null);fe[y.SymbolKind.File]=0,fe[y.SymbolKind.Module]=1,fe[y.SymbolKind.Namespace]=2,fe[y.SymbolKind.Package]=3,fe[y.SymbolKind.Class]=4,fe[y.SymbolKind.Method]=5,fe[y.SymbolKind.Property]=6,fe[y.SymbolKind.Field]=7,fe[y.SymbolKind.Constructor]=8,fe[y.SymbolKind.Enum]=9,fe[y.SymbolKind.Interface]=10,fe[y.SymbolKind.Function]=11,fe[y.SymbolKind.Variable]=12,fe[y.SymbolKind.Constant]=13,fe[y.SymbolKind.String]=14,fe[y.SymbolKind.Number]=15,fe[y.SymbolKind.Boolean]=16,fe[y.SymbolKind.Array]=17,fe[y.SymbolKind.Object]=18,fe[y.SymbolKind.Key]=19,fe[y.SymbolKind.Null]=20,fe[y.SymbolKind.EnumMember]=21,fe[y.SymbolKind.Struct]=22,fe[y.SymbolKind.Event]=23,fe[y.SymbolKind.Operator]=24,fe[y.SymbolKind.TypeParameter]=25;function oe(Ee){return typeof fe[Ee]=="number"?fe[Ee]:6}ce.from=oe;function W(Ee){for(const Re in fe)if(fe[Re]===Ee)return Number(Re);return y.SymbolKind.Property}ce.to=W})($=e.SymbolKind||(e.SymbolKind={}));var G;(function(ce){function fe(W){switch(W){case y.SymbolTag.Deprecated:return 1}}ce.from=fe;function oe(W){switch(W){case 1:return y.SymbolTag.Deprecated}}ce.to=oe})(G=e.SymbolTag||(e.SymbolTag={}));var ie;(function(ce){function fe(W){return{name:W.name,kind:$.from(W.kind),tags:W.tags&&W.tags.map(G.from),containerName:W.containerName,location:ge.from(W.location)}}ce.from=fe;function oe(W){const Ee=new y.SymbolInformation(W.name,$.to(W.kind),W.containerName,ge.to(W.location));return Ee.tags=W.tags&&W.tags.map(G.to),Ee}ce.to=oe})(ie=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var le;(function(ce){function fe(W){const Ee={name:W.name||"!!MISSING: name!!",detail:W.detail,range:u.from(W.range),selectionRange:u.from(W.selectionRange),kind:$.from(W.kind),tags:W.tags?.map(G.from)??[]};return W.children&&(Ee.children=W.children.map(fe)),Ee}ce.from=fe;function oe(W){const Ee=new y.DocumentSymbol(W.name,W.detail,$.to(W.kind),u.to(W.range),u.to(W.selectionRange));return(0,r.isNonEmptyArray)(W.tags)&&(Ee.tags=W.tags.map(G.to)),W.children&&(Ee.children=W.children.map(oe)),Ee}ce.to=oe})(le=e.DocumentSymbol||(e.DocumentSymbol={}));var X;(function(ce){function fe(W){const Ee=new y.CallHierarchyItem($.to(W.kind),W.name,W.detail||"",T.URI.revive(W.uri),u.to(W.range),u.to(W.selectionRange));return Ee._sessionId=W._sessionId,Ee._itemId=W._itemId,Ee}ce.to=fe;function oe(W,Ee,Re){if(Ee=Ee??W._sessionId,Re=Re??W._itemId,Ee===void 0||Re===void 0)throw new Error("invalid item");return{_sessionId:Ee,_itemId:Re,name:W.name,detail:W.detail,kind:$.from(W.kind),uri:W.uri,range:u.from(W.range),selectionRange:u.from(W.selectionRange),tags:W.tags?.map(G.from)}}ce.from=oe})(X=e.CallHierarchyItem||(e.CallHierarchyItem={}));var ue;(function(ce){function fe(oe){return new y.CallHierarchyIncomingCall(X.to(oe.from),oe.fromRanges.map(W=>u.to(W)))}ce.to=fe})(ue=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var ve;(function(ce){function fe(oe){return new y.CallHierarchyOutgoingCall(X.to(oe.to),oe.fromRanges.map(W=>u.to(W)))}ce.to=fe})(ve=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var ge;(function(ce){function fe(W){return{range:W.range&&u.from(W.range),uri:W.uri}}ce.from=fe;function oe(W){return new y.Location(T.URI.revive(W.uri),u.to(W.range))}ce.to=oe})(ge=e.location||(e.location={}));var we;(function(ce){function fe(W){const Ee=W,Re=W;return{originSelectionRange:Ee.originSelectionRange?u.from(Ee.originSelectionRange):void 0,uri:Ee.targetUri?Ee.targetUri:Re.uri,range:u.from(Ee.targetRange?Ee.targetRange:Re.range),targetSelectionRange:Ee.targetSelectionRange?u.from(Ee.targetSelectionRange):void 0}}ce.from=fe;function oe(W){return{targetUri:T.URI.revive(W.uri),targetRange:u.to(W.range),targetSelectionRange:W.targetSelectionRange?u.to(W.targetSelectionRange):void 0,originSelectionRange:W.originSelectionRange?u.to(W.originSelectionRange):void 0}}ce.to=oe})(we=e.DefinitionLink||(e.DefinitionLink={}));var re;(function(ce){function fe(W){return{range:u.from(W.range),contents:w.fromMany(W.contents)}}ce.from=fe;function oe(W){return new y.Hover(W.contents.map(w.to),u.to(W.range))}ce.to=oe})(re=e.Hover||(e.Hover={}));var be;(function(ce){function fe(W){return{range:u.from(W.range),expression:W.expression}}ce.from=fe;function oe(W){return new y.EvaluatableExpression(u.to(W.range),W.expression)}ce.to=oe})(be=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Pe;(function(ce){function fe(W){if(W instanceof y.InlineValueText)return{type:"text",range:u.from(W.range),text:W.text};if(W instanceof y.InlineValueVariableLookup)return{type:"variable",range:u.from(W.range),variableName:W.variableName,caseSensitiveLookup:W.caseSensitiveLookup};if(W instanceof y.InlineValueEvaluatableExpression)return{type:"expression",range:u.from(W.range),expression:W.expression};throw new Error("Unknown 'InlineValue' type")}ce.from=fe;function oe(W){switch(W.type){case"text":return{range:u.to(W.range),text:W.text};case"variable":return{range:u.to(W.range),variableName:W.variableName,caseSensitiveLookup:W.caseSensitiveLookup};case"expression":return{range:u.to(W.range),expression:W.expression}}}ce.to=oe})(Pe=e.InlineValue||(e.InlineValue={}));var Fe;(function(ce){function fe(W){return{frameId:W.frameId,stoppedLocation:u.from(W.stoppedLocation)}}ce.from=fe;function oe(W){return new y.InlineValueContext(W.frameId,u.to(W.stoppedLocation))}ce.to=oe})(Fe=e.InlineValueContext||(e.InlineValueContext={}));var ze;(function(ce){function fe(W){return{range:u.from(W.range),kind:W.kind}}ce.from=fe;function oe(W){return new y.DocumentHighlight(u.to(W.range),W.kind)}ce.to=oe})(ze=e.DocumentHighlight||(e.DocumentHighlight={}));var nt;(function(ce){function fe(oe){switch(oe){case 1:return y.CompletionTriggerKind.TriggerCharacter;case 2:return y.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return y.CompletionTriggerKind.Invoke}}ce.to=fe})(nt=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var et;(function(ce){function fe(oe){return{triggerKind:nt.to(oe.triggerKind),triggerCharacter:oe.triggerCharacter}}ce.to=fe})(et=e.CompletionContext||(e.CompletionContext={}));var Ze;(function(ce){function fe(W){switch(W){case y.CompletionItemTag.Deprecated:return 1}}ce.from=fe;function oe(W){switch(W){case 1:return y.CompletionItemTag.Deprecated}}ce.to=oe})(Ze=e.CompletionItemTag||(e.CompletionItemTag={}));var x;(function(ce){const fe=new Map([[y.CompletionItemKind.Method,0],[y.CompletionItemKind.Function,1],[y.CompletionItemKind.Constructor,2],[y.CompletionItemKind.Field,3],[y.CompletionItemKind.Variable,4],[y.CompletionItemKind.Class,5],[y.CompletionItemKind.Interface,7],[y.CompletionItemKind.Struct,6],[y.CompletionItemKind.Module,8],[y.CompletionItemKind.Property,9],[y.CompletionItemKind.Unit,12],[y.CompletionItemKind.Value,13],[y.CompletionItemKind.Constant,14],[y.CompletionItemKind.Enum,15],[y.CompletionItemKind.EnumMember,16],[y.CompletionItemKind.Keyword,17],[y.CompletionItemKind.Snippet,27],[y.CompletionItemKind.Text,18],[y.CompletionItemKind.Color,19],[y.CompletionItemKind.File,20],[y.CompletionItemKind.Reference,21],[y.CompletionItemKind.Folder,23],[y.CompletionItemKind.Event,10],[y.CompletionItemKind.Operator,11],[y.CompletionItemKind.TypeParameter,24],[y.CompletionItemKind.Issue,26],[y.CompletionItemKind.User,25]]);function oe(Re){return fe.get(Re)??9}ce.from=oe;const W=new Map([[0,y.CompletionItemKind.Method],[1,y.CompletionItemKind.Function],[2,y.CompletionItemKind.Constructor],[3,y.CompletionItemKind.Field],[4,y.CompletionItemKind.Variable],[5,y.CompletionItemKind.Class],[7,y.CompletionItemKind.Interface],[6,y.CompletionItemKind.Struct],[8,y.CompletionItemKind.Module],[9,y.CompletionItemKind.Property],[12,y.CompletionItemKind.Unit],[13,y.CompletionItemKind.Value],[14,y.CompletionItemKind.Constant],[15,y.CompletionItemKind.Enum],[16,y.CompletionItemKind.EnumMember],[17,y.CompletionItemKind.Keyword],[27,y.CompletionItemKind.Snippet],[18,y.CompletionItemKind.Text],[19,y.CompletionItemKind.Color],[20,y.CompletionItemKind.File],[21,y.CompletionItemKind.Reference],[23,y.CompletionItemKind.Folder],[10,y.CompletionItemKind.Event],[11,y.CompletionItemKind.Operator],[24,y.CompletionItemKind.TypeParameter],[25,y.CompletionItemKind.User],[26,y.CompletionItemKind.Issue]]);function Ee(Re){return W.get(Re)??y.CompletionItemKind.Property}ce.to=Ee})(x=e.CompletionItemKind||(e.CompletionItemKind={}));var K;(function(ce){function fe(oe,W){const Ee=new y.CompletionItem(oe.label);return Ee.insertText=oe.insertText,Ee.kind=x.to(oe.kind),Ee.tags=oe.tags?.map(Ze.to),Ee.detail=oe.detail,Ee.documentation=S.isMarkdownString(oe.documentation)?w.to(oe.documentation):oe.documentation,Ee.sortText=oe.sortText,Ee.filterText=oe.filterText,Ee.preselect=oe.preselect,Ee.commitCharacters=oe.commitCharacters,R.Range.isIRange(oe.range)?Ee.range=u.to(oe.range):typeof oe.range=="object"&&(Ee.range={inserting:u.to(oe.range.insert),replacing:u.to(oe.range.replace)}),Ee.keepWhitespace=typeof oe.insertTextRules=="undefined"?!1:Boolean(oe.insertTextRules&1),typeof oe.insertTextRules!="undefined"&&oe.insertTextRules&4?Ee.insertText=new y.SnippetString(oe.insertText):(Ee.insertText=oe.insertText,Ee.textEdit=Ee.range instanceof y.Range?new y.TextEdit(Ee.range,Ee.insertText):void 0),oe.additionalTextEdits&&oe.additionalTextEdits.length>0&&(Ee.additionalTextEdits=oe.additionalTextEdits.map(Re=>j.to(Re))),Ee.command=W&&oe.command?W.fromInternal(oe.command):void 0,Ee}ce.to=fe})(K=e.CompletionItem||(e.CompletionItem={}));var z;(function(ce){function fe(W){return{label:W.label,documentation:W.documentation?w.fromStrict(W.documentation):void 0}}ce.from=fe;function oe(W){return{label:W.label,documentation:S.isMarkdownString(W.documentation)?w.to(W.documentation):W.documentation}}ce.to=oe})(z=e.ParameterInformation||(e.ParameterInformation={}));var V;(function(ce){function fe(W){return{label:W.label,documentation:W.documentation?w.fromStrict(W.documentation):void 0,parameters:Array.isArray(W.parameters)?W.parameters.map(z.from):[],activeParameter:W.activeParameter}}ce.from=fe;function oe(W){return{label:W.label,documentation:S.isMarkdownString(W.documentation)?w.to(W.documentation):W.documentation,parameters:Array.isArray(W.parameters)?W.parameters.map(z.to):[],activeParameter:W.activeParameter}}ce.to=oe})(V=e.SignatureInformation||(e.SignatureInformation={}));var Y;(function(ce){function fe(W){return{activeSignature:W.activeSignature,activeParameter:W.activeParameter,signatures:Array.isArray(W.signatures)?W.signatures.map(V.from):[]}}ce.from=fe;function oe(W){return{activeSignature:W.activeSignature,activeParameter:W.activeParameter,signatures:Array.isArray(W.signatures)?W.signatures.map(V.to):[]}}ce.to=oe})(Y=e.SignatureHelp||(e.SignatureHelp={}));var se;(function(ce){function fe(oe,W){const Ee=new y.InlayHint(typeof W.label=="string"?W.label:W.label.map(ye.to.bind(void 0,oe)),l.to(W.position),Ue.to(W.kind));return Ee.tooltip=S.isMarkdownString(W.tooltip)?w.to(W.tooltip):W.tooltip,Ee.paddingLeft=W.paddingLeft,Ee.paddingRight=W.paddingRight,Ee}ce.to=fe})(se=e.InlayHint||(e.InlayHint={}));var ye;(function(ce){function fe(oe,W){const Ee=new y.InlayHintLabelPart(W.label);return Ee.tooltip=S.isMarkdownString(W.tooltip)?w.to(W.tooltip):W.tooltip,b.Command.is(W.command)?Ee.command=oe.fromInternal(W.command):W.location&&(Ee.location=ge.to(W.location)),Ee}ce.to=fe})(ye=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var Ue;(function(ce){function fe(W){return W}ce.from=fe;function oe(W){return W}ce.to=oe})(Ue=e.InlayHintKind||(e.InlayHintKind={}));var je;(function(ce){function fe(W){return{range:u.from(W.range),url:W.target,tooltip:W.tooltip}}ce.from=fe;function oe(W){let Ee;if(W.url)try{Ee=typeof W.url=="string"?T.URI.parse(W.url,!0):T.URI.revive(W.url)}catch{}return new y.DocumentLink(u.to(W.range),Ee)}ce.to=oe})(je=e.DocumentLink||(e.DocumentLink={}));var Qe;(function(ce){function fe(W){const Ee=new y.ColorPresentation(W.label);return W.textEdit&&(Ee.textEdit=j.to(W.textEdit)),W.additionalTextEdits&&(Ee.additionalTextEdits=W.additionalTextEdits.map(Re=>j.to(Re))),Ee}ce.to=fe;function oe(W){return{label:W.label,textEdit:W.textEdit?j.from(W.textEdit):void 0,additionalTextEdits:W.additionalTextEdits?W.additionalTextEdits.map(Ee=>j.from(Ee)):void 0}}ce.from=oe})(Qe=e.ColorPresentation||(e.ColorPresentation={}));var rt;(function(ce){function fe(W){return new y.Color(W[0],W[1],W[2],W[3])}ce.to=fe;function oe(W){return[W.red,W.green,W.blue,W.alpha]}ce.from=oe})(rt=e.Color||(e.Color={}));var ot;(function(ce){function fe(W){return{range:u.from(W.range)}}ce.from=fe;function oe(W){return new y.SelectionRange(u.to(W.range))}ce.to=oe})(ot=e.SelectionRange||(e.SelectionRange={}));var Je;(function(ce){function fe(oe){switch(oe){case 2:return y.TextDocumentSaveReason.AfterDelay;case 1:return y.TextDocumentSaveReason.Manual;case 3:case 4:return y.TextDocumentSaveReason.FocusOut}}ce.to=fe})(Je=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var tt;(function(ce){function fe(W){switch(W){case y.TextEditorLineNumbersStyle.Off:return 0;case y.TextEditorLineNumbersStyle.Relative:return 2;case y.TextEditorLineNumbersStyle.On:default:return 1}}ce.from=fe;function oe(W){switch(W){case 0:return y.TextEditorLineNumbersStyle.Off;case 2:return y.TextEditorLineNumbersStyle.Relative;case 1:default:return y.TextEditorLineNumbersStyle.On}}ce.to=oe})(tt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var pt;(function(ce){function fe(W){if(W===y.EndOfLine.CRLF)return 1;if(W===y.EndOfLine.LF)return 0}ce.from=fe;function oe(W){if(W===1)return y.EndOfLine.CRLF;if(W===0)return y.EndOfLine.LF}ce.to=oe})(pt=e.EndOfLine||(e.EndOfLine={}));var Me;(function(ce){function fe(oe){if(typeof oe=="object")return oe.viewId;switch(oe){case y.ProgressLocation.SourceControl:return 3;case y.ProgressLocation.Window:return 10;case y.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}ce.from=fe})(Me=e.ProgressLocation||(e.ProgressLocation={}));var At;(function(ce){function fe(oe){const W={start:oe.start+1,end:oe.end+1};return oe.kind&&(W.kind=q.from(oe.kind)),W}ce.from=fe})(At=e.FoldingRange||(e.FoldingRange={}));var q;(function(ce){function fe(oe){if(oe)switch(oe){case y.FoldingRangeKind.Comment:return b.FoldingRangeKind.Comment;case y.FoldingRangeKind.Imports:return b.FoldingRangeKind.Imports;case y.FoldingRangeKind.Region:return b.FoldingRangeKind.Region}}ce.from=fe})(q=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Q;(function(ce){function fe(oe){if(oe)return{pinned:typeof oe.preview=="boolean"?!oe.preview:void 0,inactive:oe.background,preserveFocus:oe.preserveFocus,selection:typeof oe.selection=="object"?u.from(oe.selection):void 0,override:typeof oe.override=="boolean"?i.EditorResolution.DISABLED:void 0}}ce.from=fe})(Q=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var he;(function(ce){function fe(Re){return Re instanceof y.RelativePattern?Re.toJSON():typeof Re=="string"?Re:oe(Re)||W(Re)?new y.RelativePattern(Re.baseUri??Re.base,Re.pattern).toJSON():Re}ce.from=fe;function oe(Re){const Ve=Re;return Ve?T.URI.isUri(Ve.baseUri)&&typeof Ve.pattern=="string":!1}function W(Re){const Ve=Re;return Ve?typeof Ve.base=="string"&&typeof Ve.pattern=="string":!1}function Ee(Re){return typeof Re=="string"?Re:new y.RelativePattern(T.URI.revive(Re.baseUri),Re.pattern)}ce.to=Ee})(he=e.GlobPattern||(e.GlobPattern={}));var Be;(function(ce){function fe(oe){if(oe){if(Array.isArray(oe))return oe.map(fe);if(typeof oe=="string")return oe;{const W=oe;return{language:W.language,scheme:W.scheme,pattern:he.from(W.pattern),exclusive:W.exclusive}}}else return}ce.from=fe})(Be=e.LanguageSelector||(e.LanguageSelector={}));var qe;(function(ce){function fe(W){return{start:W.start,end:W.end}}ce.from=fe;function oe(W){return new y.NotebookRange(W.start,W.end)}ce.to=oe})(qe=e.NotebookRange||(e.NotebookRange={}));var lt;(function(ce){function fe(W){return{timing:typeof W.runStartTime=="number"&&typeof W.runEndTime=="number"?{startTime:W.runStartTime,endTime:W.runEndTime}:void 0,executionOrder:W.executionOrder,success:W.lastRunSuccess}}ce.to=fe;function oe(W){return{lastRunSuccess:W.success,runStartTime:W.timing?.startTime,runEndTime:W.timing?.endTime,executionOrder:W.executionOrder}}ce.from=oe})(lt=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var ht;(function(ce){function fe(W){switch(W){case y.NotebookCellKind.Markup:return o.CellKind.Markup;case y.NotebookCellKind.Code:default:return o.CellKind.Code}}ce.from=fe;function oe(W){switch(W){case o.CellKind.Markup:return y.NotebookCellKind.Markup;case o.CellKind.Code:default:return y.NotebookCellKind.Code}}ce.to=oe})(ht=e.NotebookCellKind||(e.NotebookCellKind={}));var Ye;(function(ce){function fe(W){const Ee={metadata:W.metadata??Object.create(null),cells:[]};for(let Re of W.cells)y.NotebookCellData.validate(Re),Ee.cells.push(kt.from(Re));return Ee}ce.from=fe;function oe(W){const Ee=new y.NotebookData(W.cells.map(kt.to));return(0,D.isEmptyObject)(W.metadata)||(Ee.metadata=W.metadata),Ee}ce.to=oe})(Ye=e.NotebookData||(e.NotebookData={}));var kt;(function(ce){function fe(W){return{cellKind:ht.from(W.kind),language:W.languageId,mime:W.mime,source:W.value,metadata:W.metadata,internalMetadata:lt.from(W.executionSummary??{}),outputs:W.outputs?W.outputs.map(De.from):[]}}ce.from=fe;function oe(W){return new y.NotebookCellData(ht.to(W.cellKind),W.source,W.language,W.mime,W.outputs?W.outputs.map(De.to):void 0,W.metadata,W.internalMetadata?lt.to(W.internalMetadata):void 0)}ce.to=oe})(kt=e.NotebookCellData||(e.NotebookCellData={}));var Ae;(function(ce){function fe(W){return{mime:W.mime,valueBytes:t.VSBuffer.wrap(W.data)}}ce.from=fe;function oe(W){return new y.NotebookCellOutputItem(W.valueBytes.buffer,W.mime)}ce.to=oe})(Ae=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var De;(function(ce){function fe(W){return{outputId:W.id,items:W.items.map(Ae.from),metadata:W.metadata}}ce.from=fe;function oe(W){const Ee=W.items.map(Ae.to);return new y.NotebookCellOutput(Ee,W.outputId,W.metadata)}ce.to=oe})(De=e.NotebookCellOutput||(e.NotebookCellOutput={}));var pe;(function(ce){function fe(Ee){return W(Ee)?{include:(0,D.withNullAsUndefined)(he.from(Ee.include)),exclude:(0,D.withNullAsUndefined)(he.from(Ee.exclude))}:(0,D.withNullAsUndefined)(he.from(Ee))}ce.from=fe;function oe(Ee){return W(Ee)?{include:he.to(Ee.include),exclude:he.to(Ee.exclude)}:he.to(Ee)}ce.to=oe;function W(Ee){const Re=Ee;return Re?!!Re.include&&!!Re.exclude:!1}})(pe=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var te;(function(ce){function fe(oe){return{backgroundColor:oe.backgroundColor,borderColor:oe.borderColor,top:oe.top?L.from(oe.top):void 0}}ce.from=fe})(te=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var ne;(function(ce){function fe(oe,W,Ee){const Re=typeof oe.command=="string"?{title:"",command:oe.command}:oe.command;return{alignment:oe.alignment===y.NotebookCellStatusBarAlignment.Left?1:2,command:W.toInternal(Re,Ee),text:oe.text,tooltip:oe.tooltip,accessibilityInformation:oe.accessibilityInformation,priority:oe.priority}}ce.from=fe})(ne=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var de;(function(ce){function fe(oe){return{transientOutputs:oe?.transientOutputs??!1,transientCellMetadata:oe?.transientCellMetadata??{},transientDocumentMetadata:oe?.transientDocumentMetadata??{}}}ce.from=fe})(de=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var me;(function(ce){function fe(W){return{uri:W.uri,provides:W.provides}}ce.from=fe;function oe(W){return new y.NotebookRendererScript(T.URI.revive(W.uri),W.provides)}ce.to=oe})(me=e.NotebookRendererScript||(e.NotebookRendererScript={}));var Te;(function(ce){function fe(W){return{message:w.fromStrict(W.message)||"",type:0,expected:W.expectedOutput,actual:W.actualOutput,location:W.location?ge.from(W.location):void 0}}ce.from=fe;function oe(W){const Ee=new y.TestMessage(typeof W.message=="string"?W.message:w.to(W.message));return Ee.actualOutput=W.actual,Ee.expectedOutput=W.expected,Ee.location=W.location?ge.to(W.location):void 0,Ee}ce.to=oe})(Te=e.TestMessage||(e.TestMessage={}));var He;(function(ce){let fe;(function(oe){oe.Delimiter="\0"})(fe||(fe={})),ce.namespace=(oe,W)=>oe+"\0"+W,ce.denamespace=oe=>{const W=oe.indexOf("\0");return{ctrlId:oe.slice(0,W),tagId:oe.slice(W+1)}}})(He=e.TestTag||(e.TestTag={}));var Le;(function(ce){function fe(Re){const Ve=(0,a.getPrivateApiFor)(Re).controllerId;return{extId:m.TestId.fromExtHostTestItem(Re,Ve).toString(),label:Re.label,uri:Re.uri,tags:Re.tags.map(We=>He.namespace(Ve,We.id)),range:u.from(Re.range)||null,description:Re.description||null,error:Re.error&&w.fromStrict(Re.error)||null}}ce.from=fe;function oe(Re){return{parent:void 0,error:void 0,id:m.TestId.fromString(Re.extId).localId,label:Re.label,uri:T.URI.revive(Re.uri),tags:(Re.tags||[]).map(Ve=>{const{tagId:We}=He.denamespace(Ve);return new y.TestTag(We)}),range:u.to(Re.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:Re.description||void 0}}ce.toPlain=oe;function W(Re){const Ve=m.TestId.fromString(Re.extId),We=new a.TestItemImpl(Ve.controllerId,Ve.localId,Re.label,T.URI.revive(Re.uri));return We.range=u.to(Re.range||void 0),We.description=Re.description||void 0,We}function Ee(Re){let Ve;for(const We of Re.tests){const mt=W(We.item);(0,a.getPrivateApiFor)(mt).parent=Ve,Ve=mt}return Ve}ce.toItemFromContext=Ee})(Le=e.TestItem||(e.TestItem={})),function(ce){function fe(W){return{id:W.id}}ce.from=fe;function oe(W){return new y.TestTag(W.id)}ce.to=oe}(He=e.TestTag||(e.TestTag={}));var Ge;(function(ce){const fe=(W,Ee)=>{const Re={...Le.toPlain(W.item),parent:void 0,taskStates:W.tasks.map(Ve=>({state:Ve.state,duration:Ve.duration,messages:Ve.messages.filter(We=>We.type===0).map(Te.to)})),children:W.children.map(Ve=>Ee.get(Ve)).filter(D.isDefined).map(Ve=>fe(Ve,Ee))};for(const Ve of Re.children)Ve.parent=Re;return Re};function oe(W){const Ee=[],Re=new Map;for(const Ve of W.items)Re.set(Ve.item.extId,Ve),W.request.targets.some(We=>We.controllerId===Ve.controllerId&&We.testIds.includes(Ve.item.extId))&&Ee.push(Ve);return{completedAt:W.completedAt,results:Ee.map(Ve=>fe(Ve,Re))}}ce.to=oe})(Ge=e.TestResults||(e.TestResults={}));var st;(function(ce){function fe(Re){return{covered:Re.covered,total:Re.covered}}function oe(Re){return"line"in Re?l.from(Re):u.from(Re)}function W(Re){return"branches"in Re?{count:Re.executionCount,location:oe(Re.location),type:1,branches:Re.branches.length?Re.branches.map(Ve=>({count:Ve.executionCount,location:Ve.location&&oe(Ve.location)})):void 0}:{type:0,count:Re.executionCount,location:oe(Re.location)}}ce.fromDetailed=W;function Ee(Re){return{uri:Re.uri,statement:fe(Re.statementCoverage),branch:Re.branchCoverage&&fe(Re.branchCoverage),function:Re.functionCoverage&&fe(Re.functionCoverage),details:Re.detailedCoverage?.map(W)}}ce.fromFile=Ee})(st=e.TestCoverage||(e.TestCoverage={}));var at;(function(ce){function fe(oe){switch(oe){case 1:return y.CodeActionTriggerKind.Invoke;case 2:return y.CodeActionTriggerKind.Automatic}}ce.to=fe})(at=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Ne;(function(ce){function fe(W){const Ee=new y.TypeHierarchyItem($.to(W.kind),W.name,W.detail||"",T.URI.revive(W.uri),u.to(W.range),u.to(W.selectionRange));return Ee._sessionId=W._sessionId,Ee._itemId=W._itemId,Ee}ce.to=fe;function oe(W,Ee,Re){if(Ee=Ee??W._sessionId,Re=Re??W._itemId,Ee===void 0||Re===void 0)throw new Error("invalid item");return{_sessionId:Ee,_itemId:Re,kind:$.from(W.kind),name:W.name,detail:W.detail??"",uri:W.uri,range:u.from(W.range),selectionRange:u.from(W.selectionRange),tags:W.tags?.map(G.from)}}ce.from=oe})(Ne=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(Se[164],_e([0,1,2,15,7,8,226]),function(ee,e,r,t,S,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class I{constructor(T,R,b,i={timeout:1500,errors:3}){this._logService=T,this._documents=R,this._mainThreadBulkEdits=b,this._thresholds=i,this._callbacks=new A.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(T){return(R,b,i)=>{const a={dispose:this._callbacks.push([R,b,T])};return Array.isArray(i)&&i.push(a),a}}async $participateInSave(T,R){const b=r.URI.revive(T);let i=!1;const f=setTimeout(()=>i=!0,this._thresholds.timeout),a=[];try{for(let o of[...this._callbacks]){if(i)break;const m=this._documents.getDocument(b),M=await this._deliverEventAsyncAndBlameBadListeners(o,{document:m,reason:P.TextDocumentSaveReason.to(R)});a.push(M)}}finally{clearTimeout(f)}return a}_deliverEventAsyncAndBlameBadListeners([T,R,b],i){const f=this._badListeners.get(T);return typeof f=="number"&&f>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(b,T,R,i).then(()=>!0,a=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${b.identifier.value}' threw ERROR`),this._logService.error(a),!(a instanceof Error)||a.message!=="concurrent_edits"){const o=this._badListeners.get(T);this._badListeners.set(T,o?o+1:1),typeof o=="number"&&o>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${b.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(T,R,b,i){const f=[],a=Date.now(),{document:o,reason:m}=i,{version:M}=o,y=Object.freeze({document:o,reason:m,waitUntil(_){if(Object.isFrozen(f))throw(0,t.illegalState)("waitUntil can not be called async");f.push(Promise.resolve(_))}});try{R.apply(b,[y])}catch(_){return Promise.reject(_)}return Object.freeze(f),new Promise((_,u)=>{const C=setTimeout(()=>u(new Error("timeout")),this._thresholds.timeout);return Promise.all(f).then(l=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${T.identifier.value}' finished after ${Date.now()-a}ms`),clearTimeout(C),_(l)}).catch(l=>{clearTimeout(C),u(l)})}).then(_=>{const u={edits:[]};for(const C of _)if(Array.isArray(C)&&C.every(l=>l instanceof S.TextEdit))for(const{newText:l,newEol:F,range:c}of C)u.edits.push({_type:2,resource:o.uri,edit:{range:c&&P.Range.from(c),text:l,eol:F&&P.EndOfLine.from(F)}});if(u.edits.length!==0)return M===o.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(u):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=I}),define(Se[165],_e([0,1,11,27,2,8,85]),function(ee,e,r,t,S,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class I{constructor(b,i,f,a){this.start=b,this.deletedCount=i,this.deletedItems=f,this.items=a}static asApiEvents(b){return b.map(i=>({start:i.start,deletedCount:i.deletedCount,deletedItems:i.deletedItems,items:i.items.map(f=>f.apiCell)}))}}class D{constructor(b,i,f){this.notebook=b,this._extHostDocument=i,this._cellData=f,this.handle=f.handle,this.uri=S.URI.revive(f.uri),this.cellKind=f.cellKind,this._outputs=f.outputs.map(P.NotebookCellOutput.to),this._internalMetadata=f.internalMetadata??{},this._metadata=Object.freeze(f.metadata??{}),this._previousResult=Object.freeze(P.NotebookCellExecutionSummary.to(f.internalMetadata??{}))}static asModelAddData(b,i){return{EOL:i.eol,lines:i.source,languageId:i.language,uri:i.uri,isDirty:!1,versionId:1,notebook:b}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const b=this,i=this._extHostDocument.getDocument(this.uri);if(!i)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return b.notebook.getCellIndex(b)},notebook:b.notebook.apiNotebook,kind:P.NotebookCellKind.to(this._cellData.cellKind),document:i.document,get mime(){return b._mime},set mime(f){b._mime=f},get outputs(){return b._outputs.slice(0)},get metadata(){return b._metadata},get executionSummary(){return b._previousResult}})}return this._apiCell}setOutputs(b){this._outputs=b.map(P.NotebookCellOutput.to)}setOutputItems(b,i,f){const a=f.map(P.NotebookCellOutputItem.to),o=this._outputs.find(m=>m.id===b);o&&(i||(o.items.length=0),o.items.push(...a))}setMetadata(b){this._metadata=Object.freeze(b)}setInternalMetadata(b){this._internalMetadata=b,this._previousResult=Object.freeze(P.NotebookCellExecutionSummary.to(b))}setMime(b){}}e.ExtHostCell=D;class T{constructor(b,i,f,a,o,m){this._proxy=b,this._textDocumentsAndEditors=i,this._textDocuments=f,this._emitter=a,this.uri=o,this.handle=T._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=m.viewType,this._metadata=Object.freeze(m.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,m.cells]],!0),this._versionId=m.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const b=this;this._notebook={get uri(){return b.uri},get version(){return b._versionId},get notebookType(){return b._notebookType},get isDirty(){return b._isDirty},get isUntitled(){return b.uri.scheme===r.Schemas.untitled},get isClosed(){return b._disposed},get metadata(){return b._metadata},get cellCount(){return b._cells.length},cellAt(i){return i=b._validateIndex(i),b._cells[i].apiCell},getCells(i){return(i?b._getCells(i):b._cells).map(a=>a.apiCell)},save(){return b._save()}}}return this._notebook}updateBackup(b){this._backup?.delete(),this._backup=b}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(b){b.metadata&&(this._metadata=Object.freeze({...this._metadata,...b.metadata}))}acceptDirty(b){this._isDirty=b}acceptModelChanged(b,i){this._versionId=b.versionId,this._isDirty=i;for(const f of b.rawEvents)f.kind===A.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(f.changes,!1):f.kind===A.NotebookCellsChangeType.Move?this._moveCell(f.index,f.newIdx):f.kind===A.NotebookCellsChangeType.Output?this._setCellOutputs(f.index,f.outputs):f.kind===A.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(f.index,f.outputId,f.append,f.outputItems):f.kind===A.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(f.index,f.language):f.kind===A.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(f.index,f.mime):f.kind===A.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(f.index,f.metadata):f.kind===A.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(f.index,f.internalMetadata)}_validateIndex(b){return b=b|0,b<0?0:b>=this._cells.length?this._cells.length-1:b}_validateRange(b){let i=b.start|0,f=b.end|0;return i<0&&(i=0),f>this._cells.length&&(f=this._cells.length),b.with({start:i,end:f})}_getCells(b){b=this._validateRange(b);const i=[];for(let f=b.start;f<b.end;f++)i.push(this._cells[f]);return i}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(b,i){if(this._disposed)return;const f=[],a=[],o=[];b.reverse().forEach(m=>{const y=m[2].map(C=>{const l=new D(this,this._textDocumentsAndEditors,C);return i||a.push(D.asModelAddData(this.apiNotebook,C)),l}),_=new I(m[0],m[1],[],y),u=this._cells.splice(m[0],m[1],...y);for(const C of u)o.push(C.uri),_.deletedItems.push(C.apiCell);f.push(_)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:a,removedDocuments:o}),i||this._emitter.emitModelChange((0,t.deepFreeze)({document:this.apiNotebook,changes:I.asApiEvents(f)}))}_moveCell(b,i){const f=this._cells.splice(b,1);this._cells.splice(i,0,...f);const a=[new I(b,1,f.map(o=>o.apiCell),[]),new I(i,0,[],f)];this._emitter.emitModelChange((0,t.deepFreeze)({document:this.apiNotebook,changes:I.asApiEvents(a)}))}_setCellOutputs(b,i){const f=this._cells[b];f.setOutputs(i),this._emitter.emitCellOutputsChange((0,t.deepFreeze)({document:this.apiNotebook,cells:[f.apiCell]}))}_setCellOutputItems(b,i,f,a){const o=this._cells[b];o.setOutputItems(i,f,a),this._emitter.emitCellOutputsChange((0,t.deepFreeze)({document:this.apiNotebook,cells:[o.apiCell]}))}_changeCellLanguage(b,i){const f=this._cells[b];f.apiCell.document.languageId!==i&&this._textDocuments.$acceptModelLanguageChanged(f.uri,i)}_changeCellMime(b,i){const f=this._cells[b];f.apiCell.mime=i}_changeCellMetadata(b,i){const f=this._cells[b],a=f.apiCell.metadata;f.setMetadata(i);const o=f.apiCell.metadata;(0,t.equals)(a,o)||this._emitter.emitCellMetadataChange((0,t.deepFreeze)({document:this.apiNotebook,cell:f.apiCell}))}_changeCellInternalMetadata(b,i){this._cells[b].setInternalMetadata(i)}getCellFromApiCell(b){return this._cells.find(i=>i.apiCell===b)}getCellFromIndex(b){return this._cells[b]}getCell(b){return this._cells.find(i=>i.handle===b)}getCellIndex(b){return this._cells.indexOf(b)}}e.ExtHostNotebookDocument=T,T._handlePool=0}),define(Se[89],_e([0,1,7,8,15]),function(ee,e,r,t,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class P{constructor(D){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=D}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(D){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:D})}replaceCellMetadata(D,T){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:D,metadata:T})}replaceCells(D,T,R){this._throwIfFinalized(),!(D===T&&R.length===0)&&this._collectedEdits.push({editType:1,index:D,count:T-D,cells:R.map(t.NotebookCellData.from)})}}class A{constructor(D,T,R,b,i,f){this.id=D,this._proxy=T,this.notebookData=R,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=i,this._visibleRanges=b,this._viewColumn=f}get apiEditor(){if(!this._editor){const D=this;this._editor={get document(){return D.notebookData.apiNotebook},get selections(){return D._selections},set selections(T){if(!Array.isArray(T)||!T.every(r.NotebookRange.isNotebookRange))throw(0,S.illegalArgument)("selections");D._selections=T,D._trySetSelections(T)},get visibleRanges(){return D._visibleRanges},revealRange(T,R){D._proxy.$tryRevealRange(D.id,t.NotebookRange.from(T),R??r.NotebookEditorRevealType.Default)},get viewColumn(){return D._viewColumn},edit(T){const R=new P(this.document.version);return T(R),D._applyEdit(R.finalize())},setDecorations(T,R){return D.setDecorations(T,R)}},A.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(D){this._visible=D}_acceptVisibleRanges(D){this._visibleRanges=D}_acceptSelections(D){this._selections=D}_trySetSelections(D){this._proxy.$trySetSelections(this.id,D.map(t.NotebookRange.from))}_acceptViewColumn(D){this._viewColumn=D}_applyEdit(D){if(D.cellEdits.length===0)return Promise.resolve(!0);const T=[];let R=-1;for(let b=0;b<D.cellEdits.length;b++){if(R<0){T.push(D.cellEdits[b]),R++;continue}const f=T[R],a=D.cellEdits[b];if(f.editType===1&&a.editType===1&&f.index===a.index){f.cells.push(...D.cellEdits[b].cells),f.count+=D.cellEdits[b].count;continue}T.push(D.cellEdits[b]),R++}return this._proxy.$tryApplyEdits(this.id,D.documentVersionId,T)}setDecorations(D,T){if(!(T.isEmpty&&!this._hasDecorationsForKey.has(D.key)))return T.isEmpty?this._hasDecorationsForKey.delete(D.key):this._hasDecorationsForKey.add(D.key),this._proxy.$trySetDecorations(this.id,t.NotebookRange.from(T),D.key)}}e.ExtHostNotebookEditor=A,A.apiEditorsToExtHost=new WeakMap}),define(Se[166],_e([0,1,8,139,120,20,53,15]),function(ee,e,r,t,S,P,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class D{constructor(i){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=i}async withProgress(i,f,a){const o=this._handles++,{title:m,location:M,cancellable:y}=f,_={label:(0,S.localize)(0,null,i.displayName||i.name),id:i.identifier.value};return this._proxy.$startProgress(o,{location:r.ProgressLocation.from(M),title:m,source:_,cancellable:y},i.isUnderDevelopment?void 0:i.identifier.value).catch(I.onUnexpectedExternalError),this._withProgress(o,a,!!y)}_withProgress(i,f,a){let o;a&&(o=new P.CancellationTokenSource,this._mapHandleToCancellationSource.set(i,o));const m=y=>{this._proxy.$progressEnd(y),this._mapHandleToCancellationSource.delete(y),o&&o.dispose()};let M;try{M=f(new R(this._proxy,i),a&&o?o.token:P.CancellationToken.None)}catch(y){throw m(i),y}return M.then(y=>m(i),y=>m(i)),M}$acceptProgressCanceled(i){const f=this._mapHandleToCancellationSource.get(i);f&&(f.cancel(),this._mapHandleToCancellationSource.delete(i))}}e.ExtHostProgress=D;function T(b,i){return b.message=i.message,typeof i.increment=="number"&&(typeof b.increment=="number"?b.increment+=i.increment:b.increment=i.increment),b}class R extends t.Progress{constructor(i,f){super(a=>this.throttledReport(a));this._proxy=i,this._handle=f}throttledReport(i){this._proxy.$progressReport(this._handle,i)}}xe([(0,A.throttle)(100,(b,i)=>T(b,i),()=>Object.create(null))],R.prototype,"throttledReport",null)}),define(Se[90],_e([0,1,42,15,54,8,7]),function(ee,e,r,t,S,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class I{constructor(i,f,a){const o=I._Keys.nextId();i.$registerTextEditorDecorationType(f.identifier,o,P.DecorationRenderOptions.from(a)),this.value=Object.freeze({key:o,dispose(){i.$removeTextEditorDecorationType(o)}})}}e.TextEditorDecorationType=I,I._Keys=new S.IdGenerator("TextEditorDecorationType");class D{constructor(i,f){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=i,this._documentVersionId=i.version,this._undoStopBefore=f.undoStopBefore,this._undoStopAfter=f.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(i,f){this._throwIfFinalized();let a=null;if(i instanceof A.Position)a=new A.Range(i,i);else if(i instanceof A.Range)a=i;else throw new Error("Unrecognized location");this._pushEdit(a,f,!1)}insert(i,f){this._throwIfFinalized(),this._pushEdit(new A.Range(i,i),f,!0)}delete(i){this._throwIfFinalized();let f=null;if(i instanceof A.Range)f=i;else throw new Error("Unrecognized location");this._pushEdit(f,null,!0)}_pushEdit(i,f,a){const o=this._document.validateRange(i);this._collectedEdits.push({range:o,text:f,forceMoveMarkers:a})}setEndOfLine(i){if(this._throwIfFinalized(),i!==A.EndOfLine.LF&&i!==A.EndOfLine.CRLF)throw(0,t.illegalArgument)("endOfLine");this._setEndOfLine=i}}e.TextEditorEdit=D;class T{constructor(i,f,a,o){this._proxy=i,this._id=f,this._accept(a),this._logService=o;const m=this;this.value={get tabSize(){return m._tabSize},set tabSize(M){m._setTabSize(M)},get insertSpaces(){return m._insertSpaces},set insertSpaces(M){m._setInsertSpaces(M)},get cursorStyle(){return m._cursorStyle},set cursorStyle(M){m._setCursorStyle(M)},get lineNumbers(){return m._lineNumbers},set lineNumbers(M){m._setLineNumbers(M)}}}_accept(i){this._tabSize=i.tabSize,this._insertSpaces=i.insertSpaces,this._cursorStyle=i.cursorStyle,this._lineNumbers=P.TextEditorLineNumbersStyle.to(i.lineNumbers)}_validateTabSize(i){if(i==="auto")return"auto";if(typeof i=="number"){const f=Math.floor(i);return f>0?f:null}if(typeof i=="string"){const f=parseInt(i,10);return isNaN(f)?null:f>0?f:null}return null}_setTabSize(i){const f=this._validateTabSize(i);if(f!==null){if(typeof f=="number"){if(this._tabSize===f)return;this._tabSize=f}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:f}))}}_validateInsertSpaces(i){return i==="auto"?"auto":i==="false"?!1:Boolean(i)}_setInsertSpaces(i){const f=this._validateInsertSpaces(i);if(typeof f=="boolean"){if(this._insertSpaces===f)return;this._insertSpaces=f}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:f}))}_setCursorStyle(i){this._cursorStyle!==i&&(this._cursorStyle=i,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:i})))}_setLineNumbers(i){this._lineNumbers!==i&&(this._lineNumbers=i,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:P.TextEditorLineNumbersStyle.from(i)})))}assign(i){const f={};let a=!1;if(typeof i.tabSize!="undefined"){const o=this._validateTabSize(i.tabSize);o==="auto"?(a=!0,f.tabSize=o):typeof o=="number"&&this._tabSize!==o&&(this._tabSize=o,a=!0,f.tabSize=o)}if(typeof i.insertSpaces!="undefined"){const o=this._validateInsertSpaces(i.insertSpaces);o==="auto"?(a=!0,f.insertSpaces=o):this._insertSpaces!==o&&(this._insertSpaces=o,a=!0,f.insertSpaces=o)}typeof i.cursorStyle!="undefined"&&this._cursorStyle!==i.cursorStyle&&(this._cursorStyle=i.cursorStyle,a=!0,f.cursorStyle=i.cursorStyle),typeof i.lineNumbers!="undefined"&&this._lineNumbers!==i.lineNumbers&&(this._lineNumbers=i.lineNumbers,a=!0,f.lineNumbers=P.TextEditorLineNumbersStyle.from(i.lineNumbers)),a&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,f))}_warnOnError(i,f){f.catch(a=>{this._logService.warn(`ExtHostTextEditorOptions '${i}' failed:'`),this._logService.warn(a)})}}e.ExtHostTextEditorOptions=T;class R{constructor(i,f,a,o,m,M,y,_){this.id=i,this._proxy=f,this._logService=a,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=m,this._options=new T(this._proxy,this.id,M,a),this._visibleRanges=y,this._viewColumn=_;const u=this;this.value=Object.freeze({get document(){return o.getValue()},set document(C){throw(0,t.readonly)("document")},get selection(){return u._selections&&u._selections[0]},set selection(C){if(!(C instanceof A.Selection))throw(0,t.illegalArgument)("selection");u._selections=[C],u._trySetSelection()},get selections(){return u._selections},set selections(C){if(!Array.isArray(C)||C.some(l=>!(l instanceof A.Selection)))throw(0,t.illegalArgument)("selections");u._selections=C,u._trySetSelection()},get visibleRanges(){return u._visibleRanges},set visibleRanges(C){throw(0,t.readonly)("visibleRanges")},get options(){return u._options.value},set options(C){u._disposed||u._options.assign(C)},get viewColumn(){return u._viewColumn},set viewColumn(C){throw(0,t.readonly)("viewColumn")},edit(C,l={undoStopBefore:!0,undoStopAfter:!0}){if(u._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const F=new D(o.getValue(),l);return C(F),u._applyEdit(F)},insertSnippet(C,l,F={undoStopBefore:!0,undoStopAfter:!0}){if(u._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let c;if(!l||Array.isArray(l)&&l.length===0)c=u._selections.map(n=>P.Range.from(n));else if(l instanceof A.Position){const{lineNumber:n,column:h}=P.Position.from(l);c=[{startLineNumber:n,startColumn:h,endLineNumber:n,endColumn:h}]}else if(l instanceof A.Range)c=[P.Range.from(l)];else{c=[];for(const n of l)if(n instanceof A.Range)c.push(P.Range.from(n));else{const{lineNumber:h,column:g}=P.Position.from(n);c.push({startLineNumber:h,startColumn:g,endLineNumber:h,endColumn:g})}}return f.$tryInsertSnippet(i,C.value,c,F)},setDecorations(C,l){const F=l.length===0;F&&!u._hasDecorationsForKey.has(C.key)||(F?u._hasDecorationsForKey.delete(C.key):u._hasDecorationsForKey.add(C.key),u._runOnProxy(()=>{if(P.isDecorationOptionsArr(l))return f.$trySetDecorations(i,C.key,P.fromRangeOrRangeWithMessage(l));{const c=new Array(4*l.length);for(let n=0,h=l.length;n<h;n++){const g=l[n];c[4*n]=g.start.line+1,c[4*n+1]=g.start.character+1,c[4*n+2]=g.end.line+1,c[4*n+3]=g.end.character+1}return f.$trySetDecorationsFast(i,C.key,c)}}))},revealRange(C,l){u._runOnProxy(()=>f.$tryRevealRange(i,P.Range.from(C),l||A.TextEditorRevealType.Default))},show(C){f.$tryShowEditor(i,P.ViewColumn.from(C))},hide(){f.$tryHideEditor(i)}})}dispose(){(0,r.ok)(!this._disposed),this._disposed=!0}_acceptOptions(i){(0,r.ok)(!this._disposed),this._options._accept(i)}_acceptVisibleRanges(i){(0,r.ok)(!this._disposed),this._visibleRanges=i}_acceptViewColumn(i){(0,r.ok)(!this._disposed),this._viewColumn=i}_acceptSelections(i){(0,r.ok)(!this._disposed),this._selections=i}async _trySetSelection(){const i=this._selections.map(P.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,i)),this.value}_applyEdit(i){const f=i.finalize();if(f.edits.length===0&&!f.setEndOfLine)return Promise.resolve(!0);const a=f.edits.map(m=>m.range);a.sort((m,M)=>m.end.line===M.end.line?m.end.character===M.end.character?m.start.line===M.start.line?m.start.character-M.start.character:m.start.line-M.start.line:m.end.character-M.end.character:m.end.line-M.end.line);for(let m=0,M=a.length-1;m<M;m++){const y=a[m].end;if(a[m+1].start.isBefore(y))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const o=f.edits.map(m=>({range:P.Range.from(m.range),text:m.text,forceMoveMarkers:m.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,f.documentVersionId,o,{setEndOfLine:typeof f.setEndOfLine=="number"?P.EndOfLine.from(f.setEndOfLine):void 0,undoStopBefore:f.undoStopBefore,undoStopAfter:f.undoStopAfter})}_runOnProxy(i){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):i().then(()=>this,f=>(f instanceof Error&&f.name==="DISPOSED"||this._logService.warn(f),null))}}e.ExtHostTextEditor=R}),define(Se[167],_e([0,1,10,4,6,13,48,8,86,66]),function(ee,e,r,t,S,P,A,I,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class R extends S.Disposable{constructor(i){super();this.controllerId=i,this.debounceSendDiff=this._register(new r.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new t.Emitter),this.root=new A.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(i){this._resolveHandler=i;for(const f of this.tree.values())this.updateExpandability(f)}collectDiff(){const i=this.diff;return this.diff=[],i}pushDiff(i){const f=this.diff[this.diff.length-1];if(f&&i[0]===1){if(f[0]===1&&f[1].extId===i[1].extId){(0,D.applyTestItemUpdate)(f[1],i[1]);return}if(f[0]===0&&f[1].item.extId===i[1].extId){(0,D.applyTestItemUpdate)(f[1],i[1]);return}}this.diff.push(i),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(i,f){const a=this.tree.get(i);if(!!a){if((a.expandLevels===void 0||f>a.expandLevels)&&(a.expandLevels=f),a.expand===1){const o=this.resolveChildren(a);return o.isOpen()?this.expandChildren(a,f-1):o.wait().then(()=>this.expandChildren(a,f-1))}else if(a.expand===3)return a.resolveBarrier?.isOpen()===!1?a.resolveBarrier.wait().then(()=>this.expandChildren(a,f-1)):this.expandChildren(a,f-1)}}dispose(){for(const i of this.tree.values())(0,A.getPrivateApiFor)(i.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(i,f){switch(f.op){case 2:this.pushDiff([4,i.fullId.toString()]);break;case 1:this.removeItem(T.TestId.joinToString(i.fullId,f.id));break;case 0:this.upsertItem(f.item,i);break;case 4:for(const a of f.ops)this.onTestItemEvent(i,a);break;case 3:{const{key:a,value:o,previous:m}=f,M=i.fullId.toString();switch(a){case"canResolveChildren":this.updateExpandability(i);break;case"tags":this.diffTagRefs(o,m,M);break;case"range":this.pushDiff([1,{extId:M,item:{range:I.Range.from(o)}}]);break;case"error":this.pushDiff([1,{extId:M,item:{error:I.MarkdownString.fromStrict(o)||null}}]);break;default:this.pushDiff([1,{extId:M,item:{[a]:o??null}}]);break}break}default:(0,P.assertNever)(f)}}upsertItem(i,f){if(!(i instanceof A.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${i.id} did not`);const a=T.TestId.fromExtHostTestItem(i,this.root.id,f?.actual),o=(0,A.getPrivateApiFor)(i);o.parent&&o.parent!==f?.actual&&o.parent.children.delete(i.id);let m=this.tree.get(a.toString());if(!m){m={fullId:a,actual:i,parent:f?a.parentId:null,expandLevels:f?.expandLevels?f.expandLevels-1:void 0,expand:0},i.tags.forEach(this.incrementTagRefs,this),this.tree.set(m.fullId.toString(),m),this.setItemParent(i,f),this.pushDiff([0,{parent:m.parent&&m.parent.toString(),controllerId:this.controllerId,expand:m.expand,item:I.TestItem.from(i)}]),this.connectItemAndChildren(i,m,f);return}if(m.actual===i){this.connectItem(i,m,f);return}const M=m.actual.children,y=m.actual,_=(0,A.diffTestItems)(y,i);(0,A.getPrivateApiFor)(y).listener=void 0,m.actual=i,m.expand=0;for(const[u,C]of _)this.onTestItemEvent(m,{op:3,key:u,value:C,previous:y[u]});this.connectItemAndChildren(i,m,f);for(const u of M)i.children.get(u.id)||this.removeItem(T.TestId.joinToString(a,u.id))}diffTagRefs(i,f,a){const o=new Set(f.map(m=>m.id));for(const m of i)o.delete(m.id)||this.incrementTagRefs(m);this.pushDiff([1,{extId:a,item:{tags:i.map(m=>I.TestTag.namespace(this.controllerId,m.id))}}]),o.forEach(this.decrementTagRefs,this)}incrementTagRefs(i){const f=this.tags.get(i.id);f?f.refCount++:(this.tags.set(i.id,{refCount:1}),this.pushDiff([5,{id:I.TestTag.namespace(this.controllerId,i.id),ctrlLabel:this.root.label}]))}decrementTagRefs(i){const f=this.tags.get(i);f&&!--f.refCount&&(this.tags.delete(i),this.pushDiff([6,I.TestTag.namespace(this.controllerId,i)]))}setItemParent(i,f){(0,A.getPrivateApiFor)(i).parent=f&&f.actual!==this.root?f.actual:void 0}connectItem(i,f,a){this.setItemParent(i,a);const o=(0,A.getPrivateApiFor)(i);o.parent=a?.actual,o.listener=m=>this.onTestItemEvent(f,m),this.updateExpandability(f)}connectItemAndChildren(i,f,a){this.connectItem(i,f,a);for(const o of i.children)this.upsertItem(o,f)}updateExpandability(i){let f;this._resolveHandler?i.resolveBarrier?f=i.resolveBarrier.isOpen()?3:2:f=i.actual.canResolveChildren?1:0:f=0,f!==i.expand&&(i.expand=f,this.pushDiff([1,{extId:i.fullId.toString(),expand:f}]),f===1&&i.expandLevels!==void 0&&this.resolveChildren(i))}expandChildren(i,f){if(f<0)return;const a=[];for(const o of i.actual.children){const m=this.expand(T.TestId.joinToString(i.fullId,o.id),f);(0,r.isThenable)(m)&&a.push(m)}if(a.length)return Promise.all(a).then(()=>{})}resolveChildren(i){if(i.resolveBarrier)return i.resolveBarrier;if(!this._resolveHandler){const m=new r.Barrier;return m.open(),m}i.expand=2,this.pushExpandStateUpdate(i);const f=i.resolveBarrier=new r.Barrier,a=m=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),i.actual!==this.root&&(i.actual.error=m.stack||m.message||String(m))};let o;try{o=this._resolveHandler(i.actual===this.root?void 0:i.actual)}catch(m){a(m)}return(0,r.isThenable)(o)?o.catch(a).then(()=>{f.open(),this.updateExpandability(i)}):(f.open(),this.updateExpandability(i)),i.resolveBarrier}pushExpandStateUpdate(i){this.pushDiff([1,{extId:i.fullId.toString(),expand:i.expand}])}removeItem(i){const f=this.tree.get(i);if(!f)throw new Error("attempting to remove non-existent child");this.pushDiff([2,i]);const a=[f];for(;a.length;){const o=a.pop();if(!!o){(0,A.getPrivateApiFor)(o.actual).listener=void 0;for(const m of o.actual.tags)this.decrementTagRefs(m.id);this.tree.delete(o.fullId.toString());for(const m of o.actual.children)a.push(this.tree.get(T.TestId.joinToString(o.fullId,m.id)))}}}flushDiff(){const i=this.collectDiff();i.length&&this.diffOpEmitter.fire(i)}}e.SingleUseTestCollection=R}),define(Se[168],_e([0,1,3,135]),function(ee,e,r,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,r.refineServiceDecorator)(t.IEnvironmentService)}),define(Se[169],_e([0,1,25,4,17]),function(ee,e,r,t,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class P{constructor(R){this.removedDueToLooping=R}}e.DeltaExtensionsResult=P;class A{constructor(R){this._onDidChange=new t.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=R,this._initialize()}_initialize(){this._extensionDescriptions.sort(D),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const R of this._extensionDescriptions){if(this._extensionsMap.has(r.ExtensionIdentifier.toKey(R.identifier))){console.error("Extension `"+R.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(r.ExtensionIdentifier.toKey(R.identifier),R),this._extensionsArr.push(R),Array.isArray(R.activationEvents))for(let b of R.activationEvents)b==="onUri"&&(b=`onUri:${r.ExtensionIdentifier.toKey(R.identifier)}`),this._activationMap.has(b)||this._activationMap.set(b,[]),this._activationMap.get(b).push(R)}}keepOnly(R){const b=new Set;R.forEach(i=>b.add(r.ExtensionIdentifier.toKey(i))),this._extensionDescriptions=this._extensionDescriptions.filter(i=>b.has(r.ExtensionIdentifier.toKey(i.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(R,b){R.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(R));const i=A._findLoopingExtensions(this._extensionDescriptions);if(b=b.concat(i.map(f=>f.identifier)),b.length>0){const f=new Set;b.forEach(a=>f.add(r.ExtensionIdentifier.toKey(a))),this._extensionDescriptions=this._extensionDescriptions.filter(a=>!f.has(r.ExtensionIdentifier.toKey(a.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new P(i)}static _findLoopingExtensions(R){const b=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(m){this._nodesSet.has(m)||(this._nodesSet.add(m),this._nodesArr.push(m))}addArc(m,M){this.addNode(m),this.addNode(M),this._arcs.has(m)?this._arcs.get(m).push(M):this._arcs.set(m,[M])}getArcs(m){return this._arcs.has(m)?this._arcs.get(m):[]}hasOnlyGoodArcs(m,M){const y=b.getArcs(m);for(let _=0;_<y.length;_++)if(!M.has(y[_]))return!1;return!0}getNodes(){return this._nodesArr}};let i=new Map;for(let m of R){const M=r.ExtensionIdentifier.toKey(m.identifier);if(i.set(M,m),m.extensionDependencies)for(let y of m.extensionDependencies){const _=r.ExtensionIdentifier.toKey(y);b.addArc(M,_)}}let f=new Set;b.getNodes().filter(m=>b.getArcs(m).length===0).forEach(m=>f.add(m));let a=b.getNodes().filter(m=>!f.has(m)),o;do{o=!1;for(let m=0;m<a.length;m++){const M=a[m];b.hasOnlyGoodArcs(M,f)&&(a.splice(m,1),m--,f.add(M),o=!0)}}while(o);return a.map(m=>i.get(m))}containsActivationEvent(R){return this._activationMap.has(R)}containsExtension(R){return this._extensionsMap.has(r.ExtensionIdentifier.toKey(R))}getExtensionDescriptionsForActivationEvent(R){const b=this._activationMap.get(R);return b?b.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(R){const b=this._extensionsMap.get(r.ExtensionIdentifier.toKey(R));return b||void 0}}e.ExtensionDescriptionRegistry=A;var I;(function(T){T[T.Builtin=0]="Builtin",T[T.User=1]="User",T[T.Dev=2]="Dev"})(I||(I={}));function D(T,R){const b=T.isBuiltin?0:T.isUnderDevelopment?2:1,i=R.isBuiltin?0:R.isUnderDevelopment?2:1;if(b!==i)return b-i;const f=S.posix.basename(T.extensionLocation.path),a=S.posix.basename(R.extensionLocation.path);return f<a?-1:f>a?1:0}}),define(Se[170],_e([0,1,21]),function(ee,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var t;(function(I){I[I.VersionMismatch=55]="VersionMismatch",I[I.UnexpectedError=81]="UnexpectedError"})(t=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var S;(function(I){I[I.Initialized=0]="Initialized",I[I.Ready=1]="Ready",I[I.Terminate=2]="Terminate"})(S=e.MessageType||(e.MessageType={}));function P(I){const D=r.VSBuffer.alloc(1);switch(I){case 0:D.writeUInt8(1,0);break;case 1:D.writeUInt8(2,0);break;case 2:D.writeUInt8(3,0);break}return D}e.createMessageOfType=P;function A(I,D){if(I.byteLength!==1)return!1;switch(I.readUInt8(0)){case 1:return D===0;case 2:return D===1;case 3:return D===2;default:return!1}}e.isMessageOfType=A}),define(Se[26],_e([0,1,4,2,3,25,142]),function(ee,e,r,t,S,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.extensionRunningLocationToString=e.ExtensionRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new P.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:t.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,S.createDecorator)("extensionService");var I;(function(u){u[u.None=0]="None",u[u.LocalProcess=1]="LocalProcess",u[u.LocalWebWorker=2]="LocalWebWorker",u[u.Remote=3]="Remote"})(I=e.ExtensionRunningLocation||(e.ExtensionRunningLocation={}));function D(u){switch(u){case 0:return"None";case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionRunningLocationToString=D;class T{constructor(C){this.dependency=C}}e.MissingExtensionDependency=T;var R;(function(u){u[u.LocalProcess=0]="LocalProcess",u[u.LocalWebWorker=1]="LocalWebWorker",u[u.Remote=2]="Remote"})(R=e.ExtensionHostKind||(e.ExtensionHostKind={}));function b(u){switch(u){case 0:return"LocalProcess";case 1:return"LocalWebWorker";case 2:return"Remote"}}e.extensionHostKindToString=b;function i(u,C){return u.enabledApiProposals?u.enabledApiProposals.includes(C):!1}e.isProposedApiEnabled=i;function f(u,C){if(!i(u,C))throw new Error(`Extension '${u.identifier.value}' CANNOT use API proposal: ${C}.
Its package.json#enabledApiProposals-property declares: ${u.enabledApiProposals?.join(", ")??"[]"} but NOT ${C}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${u.identifier.value}`)}e.checkProposedApiEnabled=f;class a{constructor(C,l,F,c){this.codeLoadingTime=C,this.activateCallTime=l,this.activateResolvedTime=F,this.activationReason=c}}e.ActivationTimes=a;class o{constructor(C,l){this.description=C,this.value=l}}e.ExtensionPointContribution=o,e.ExtensionHostLogFileName="exthost";var m;(function(u){u[u.Normal=0]="Normal",u[u.Immediate=1]="Immediate"})(m=e.ActivationKind||(e.ActivationKind={}));function M(u){return{type:u.isBuiltin?0:1,isBuiltin:u.isBuiltin||u.isUserBuiltin,identifier:{id:(0,A.getGalleryExtensionId)(u.publisher,u.name),uuid:u.uuid},manifest:u,location:u.extensionLocation}}e.toExtension=M;function y(u,C){return{identifier:new P.ExtensionIdentifier((0,A.getExtensionId)(u.manifest.publisher,u.manifest.name)),isBuiltin:u.type===0,isUserBuiltin:u.type===1&&u.isBuiltin,isUnderDevelopment:!!C,extensionLocation:u.location,...u.manifest,uuid:u.identifier.uuid}}e.toExtensionDescription=y;class _{constructor(){this.onDidRegisterExtensions=r.Event.None,this.onDidChangeExtensionsStatus=r.Event.None,this.onDidChangeExtensions=r.Event.None,this.onWillActivateByEvent=r.Event.None,this.onDidChangeResponsiveChange=r.Event.None}activateByEvent(C){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(C){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(C){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(C){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(C,l){return Promise.resolve()}_onWillActivateExtension(C){}_onDidActivateExtension(C,l,F,c,n){}_onDidActivateExtensionError(C,l){}_onExtensionRuntimeError(C,l){}_onExtensionHostExit(C){}}e.NullExtensionService=_}),define(Se[171],_e([0,1,15,25,26,12]),function(ee,e,r,t,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const A=Promise.resolve(void 0);class I{constructor(o,m,M,y){this.startup=o,this.codeLoadingTime=m,this.activateCallTime=M,this.activateResolvedTime=y}}e.ExtensionActivationTimes=I,I.NONE=new I(!1,-1,-1,-1);class D{constructor(o){this._startup=o,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(o,m){return o===-1||m===-1?-1:m-o}build(){return new I(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=D;class T{constructor(o,m,M,y,_,u){this.activationFailed=o,this.activationFailedError=m,this.activationTimes=M,this.module=y,this.exports=_,this.subscriptions=u}}e.ActivatedExtension=T;class R extends T{constructor(o){super(!1,null,o,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=R;class b extends T{constructor(){super(!1,null,I.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=b;class i extends T{constructor(o){super(!0,o,I.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=i;let f=class{constructor(o,m,M,y,_){this._logService=_,this._isDisposed=!1,this._registry=o,this._resolvedExtensionsSet=new Set,m.forEach(u=>this._resolvedExtensionsSet.add(t.ExtensionIdentifier.toKey(u))),this._hostExtensionsMap=new Map,M.forEach(u=>this._hostExtensionsMap.set(t.ExtensionIdentifier.toKey(u),u)),this._host=y,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}dispose(){this._isDisposed=!0}isActivated(o){const m=t.ExtensionIdentifier.toKey(o);return this._activatedExtensions.has(m)}getActivatedExtension(o){const m=t.ExtensionIdentifier.toKey(o),M=this._activatedExtensions.get(m);if(!M)throw new Error("Extension `"+o.value+"` is not known or not activated");return M}activateByEvent(o,m){if(this._alreadyActivatedEvents[o])return A;const M=this._registry.getExtensionDescriptionsForActivationEvent(o);return this._activateExtensions(M.map(y=>({id:y.identifier,reason:{startup:m,extensionId:y.identifier,activationEvent:o}}))).then(()=>{this._alreadyActivatedEvents[o]=!0})}activateById(o,m){const M=this._registry.getExtensionDescription(o);if(!M)throw new Error("Extension `"+o+"` is not known");return this._activateExtensions([{id:M.identifier,reason:m}])}_handleActivateRequest(o,m,M){if(this._hostExtensionsMap.has(t.ExtensionIdentifier.toKey(o.id))){m[t.ExtensionIdentifier.toKey(o.id)]=o;return}const y=this._registry.getExtensionDescription(o.id);if(!y){const C=new Error(`Cannot activate unknown extension '${o.id.value}'`);this._host.onExtensionActivationError(o.id,C,new S.MissingExtensionDependency(o.id.value)),this._activatedExtensions.set(t.ExtensionIdentifier.toKey(o.id),new i(C));return}const _=typeof y.extensionDependencies=="undefined"?[]:y.extensionDependencies;let u=!0;for(let C=0,l=_.length;C<l;C++){const F=_[C];if(this._resolvedExtensionsSet.has(t.ExtensionIdentifier.toKey(F)))continue;const c=this._activatedExtensions.get(t.ExtensionIdentifier.toKey(F));if(c&&!c.activationFailed)continue;if(c&&c.activationFailed){const s=y.displayName||y.identifier.value,d=this._registry.getExtensionDescription(F),p=d&&d.displayName||F,w=new Error(`Cannot activate the '${s}' extension because its dependency '${p}' failed to activate`);w.detail=c.activationFailedError,this._host.onExtensionActivationError(y.identifier,w,null),this._activatedExtensions.set(t.ExtensionIdentifier.toKey(y.identifier),new i(w));return}if(this._hostExtensionsMap.has(t.ExtensionIdentifier.toKey(F))){u=!1,m[t.ExtensionIdentifier.toKey(F)]={id:this._hostExtensionsMap.get(t.ExtensionIdentifier.toKey(F)),reason:o.reason};continue}const n=this._registry.getExtensionDescription(F);if(n){if(!n.main&&!n.browser)continue;u=!1,m[t.ExtensionIdentifier.toKey(F)]={id:n.identifier,reason:o.reason};continue}const h=y.displayName||y.identifier.value,g=new Error(`Cannot activate the '${h}' extension because it depends on unknown extension '${F}'`);this._host.onExtensionActivationError(y.identifier,g,new S.MissingExtensionDependency(F)),this._activatedExtensions.set(t.ExtensionIdentifier.toKey(y.identifier),new i(g));return}u?m[t.ExtensionIdentifier.toKey(y.identifier)]=o:M.push(o)}_activateExtensions(o){if(o.length===0||(o=o.filter(_=>!this._activatedExtensions.has(t.ExtensionIdentifier.toKey(_.id))),o.length===0))return Promise.resolve(void 0);const m=Object.create(null),M=[];for(let _=0,u=o.length;_<u;_++)this._handleActivateRequest(o[_],m,M);for(let _=0,u=M.length;_<u;_++){const C=t.ExtensionIdentifier.toKey(M[_].id);m[C]&&delete m[C]}const y=Object.keys(m).map(_=>m[_]);return M.length===0?Promise.all(y.map(_=>this._activateExtension(_.id,_.reason))).then(_=>{}):this._activateExtensions(y).then(_=>this._activateExtensions(M))}_activateExtension(o,m){const M=t.ExtensionIdentifier.toKey(o);if(this._activatedExtensions.has(M))return Promise.resolve(void 0);const y=this._activatingExtensions.get(M);if(y)return y;const _=this._host.actualActivateExtension(o,m).then(void 0,u=>{const C=new Error;return u&&u.name&&(C.name=u.name),u&&u.message?C.message=`Activating extension '${o.value}' failed: ${u.message}.`:C.message=`Activating extension '${o.value}' failed: ${u}.`,u&&u.stack&&(C.stack=u.stack),this._isDisposed&&r.isCancellationError(u)?new i(u):(this._host.onExtensionActivationError(o,C,null),this._logService.error(`Activating extension ${o.value} failed due to an error:`),this._logService.error(u),new i(u))}).then(u=>{this._activatedExtensions.set(M,u),this._activatingExtensions.delete(M)});return this._activatingExtensions.set(M,_),_}};f=xe([$e(4,P.ILogService)],f),e.ExtensionsActivator=f}),define(Se[172],_e([0,1,12,28,26]),function(ee,e,r,t,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let P=class extends r.LogService{constructor(I,D){super(I.createLogger(D.logFile,{name:S.ExtensionHostLogFileName}))}};P=xe([$e(0,r.ILoggerService),$e(1,t.IExtHostInitDataService)],P),e.ExtHostLogService=P}),define(Se[173],_e([0,1,15]),function(ee,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class t{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((P,A)=>{this._actualOk=P,this._actualErr=A,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(P){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=P,this._actual&&this._actualOk(P))}resolveErr(P){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=P,this._actual?this._actualErr(P):(0,r.onUnexpectedError)(P))}then(P,A){return this._ensureActual().then(P,A)}catch(P){return this._ensureActual().then(void 0,P)}finally(P){return this._ensureActual().finally(P)}}e.LazyPromise=t}),define(Se[38],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class r{constructor(D){this._proxyIdentifierBrand=void 0,this.sid=D,this.nid=++r.count}}e.ProxyIdentifier=r,r.count=0;const t=[];function S(I){const D=new r(I);return t[D.nid]=D,D}e.createProxyIdentifier=S;function P(I){return t[I].sid}e.getStringIdentifierForProxy=P;class A{constructor(D){this.value=D}}e.SerializableObjectWithBuffers=A}),define(Se[5],_e([0,1,55,2,38]),function(ee,e,r,t,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var P;(function(y){y[y.Desktop=1]="Desktop",y[y.Web=2]="Web"})(P=e.UIKind||(e.UIKind={}));var A;(function(y){y[y.Default=0]="Default",y[y.InCenter=1]="InCenter",y[y.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",y[y.AtTop=3]="AtTop"})(A=e.TextEditorRevealType||(e.TextEditorRevealType={}));var I;(function(y){y[y.Editable=0]="Editable",y[y.SupportsHotExit=1]="SupportsHotExit"})(I=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var D;(function(y){y[y.Int8Array=1]="Int8Array",y[y.Uint8Array=2]="Uint8Array",y[y.Uint8ClampedArray=3]="Uint8ClampedArray",y[y.Int16Array=4]="Int16Array",y[y.Uint16Array=5]="Uint16Array",y[y.Int32Array=6]="Int32Array",y[y.Uint32Array=7]="Uint32Array",y[y.Float32Array=8]="Float32Array",y[y.Float64Array=9]="Float64Array",y[y.BigInt64Array=10]="BigInt64Array",y[y.BigUint64Array=11]="BigUint64Array"})(D=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var T;(function(y){y[y.Text=1]="Text",y[y.Error=2]="Error",y[y.Rich=3]="Rich"})(T=e.CellOutputKind||(e.CellOutputKind={}));var R;(function(y){y[y.Default=0]="Default",y[y.InCenter=1]="InCenter",y[y.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",y[y.AtTop=3]="AtTop"})(R=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var b;(function(y){y[y.None=0]="None",y[y.Process=1]="Process",y[y.Output=2]="Output"})(b=e.CandidatePortSource||(e.CandidatePortSource={}));class i{static mixin(_){return _._id=i._n++,_}}e.IdObject=i,i._n=0;var f;(function(y){y.label="a",y.kind="b",y.detail="c",y.documentation="d",y.sortText="e",y.filterText="f",y.preselect="g",y.insertText="h",y.insertTextRules="i",y.range="j",y.commitCharacters="k",y.additionalTextEdits="l",y.command="m",y.kindModifier="n"})(f=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var a;(function(y){y.defaultRanges="a",y.completions="b",y.isIncomplete="c",y.duration="d"})(a=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var o;(function(y){y[y.File=1]="File",y[y.Text=2]="Text",y[y.Cell=3]="Cell"})(o=e.WorkspaceEditType||(e.WorkspaceEditType={}));function m(y){if(y&&y.edits)for(const _ of y.edits)typeof _.resource=="object"?_.resource=t.URI.revive(_.resource):(_.newUri=t.URI.revive(_.newUri),_.oldUri=t.URI.revive(_.oldUri)),_.metadata&&_.metadata.iconPath&&(_.metadata=(0,r.revive)(_.metadata));return y}e.reviveWorkspaceEditDto=m;var M;(function(y){y[y.Workspace=0]="Workspace",y[y.TextDocument=1]="TextDocument"})(M=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,S.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,S.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,S.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,S.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,S.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,S.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,S.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,S.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,S.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,S.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,S.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,S.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,S.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,S.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,S.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,S.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,S.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,S.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,S.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,S.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,S.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,S.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,S.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,S.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,S.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,S.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,S.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,S.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,S.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,S.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,S.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,S.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,S.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,S.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,S.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,S.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,S.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,S.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,S.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,S.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,S.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,S.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,S.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,S.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,S.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,S.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,S.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,S.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,S.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,S.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,S.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,S.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,S.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,S.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,S.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,S.createProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,S.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,S.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,S.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,S.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,S.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,S.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,S.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,S.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,S.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,S.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,S.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,S.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,S.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,S.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,S.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,S.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,S.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,S.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,S.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,S.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,S.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,S.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,S.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,S.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,S.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,S.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,S.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,S.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,S.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,S.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,S.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,S.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,S.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,S.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,S.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,S.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,S.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,S.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,S.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,S.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,S.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,S.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,S.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,S.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,S.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,S.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,S.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,S.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,S.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,S.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,S.createProxyIdentifier)("ExtHostTelemetry")}}),define(Se[67],_e([0,1,5,4,3]),function(ee,e,r,t,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class P{constructor(I){this._onDidChangePassword=new t.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=I.getProxy(r.MainContext.MainThreadSecretState)}async $onDidChangePassword(I){this._onDidChangePassword.fire(I)}get(I,D){return this._proxy.$getPassword(I,D)}store(I,D,T){return this._proxy.$setPassword(I,D,T)}delete(I,D){return this._proxy.$deletePassword(I,D)}}e.ExtHostSecretState=P,e.IExtHostSecretState=(0,S.createDecorator)("IExtHostSecretState")}),define(Se[68],_e([0,1,3,12,5,14]),function(ee,e,r,t,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,r.createDecorator)("IExtHostApiDeprecationService");let A=class{constructor(D,T){this._extHostLogService=T,this._reportedUsages=new Set,this._telemetryShape=D.getProxy(S.MainContext.MainThreadTelemetry)}report(D,T,R){const b=this.getUsageKey(D,T);this._reportedUsages.has(b)||(this._reportedUsages.add(b),T.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${D}' is deprecated. ${R}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:T.identifier.value,apiId:D}))}getUsageKey(D,T){return`${D}-${T.identifier.value}`}};A=xe([$e(0,P.IExtHostRpcService),$e(1,t.ILogService)],A),e.ExtHostApiDeprecationService=A,e.NullApiDeprecationService=Object.freeze(new class{report(I,D,T){}})}),define(Se[174],_e([0,1,4,5,7,25]),function(ee,e,r,t,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class A{constructor(D){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new r.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=D.getProxy(t.MainContext.MainThreadAuthentication)}$setProviders(D){return this._providers=D,Promise.resolve()}async getSession(D,T,R,b={}){const i=P.ExtensionIdentifier.toKey(D.identifier),f=this._inFlightRequests.get(i)||[],a=[...R].sort().join(" ");let o=f.find(m=>m.scopes===a);if(o)return o.result;{const m=this._getSession(D,i,T,R,b);o={scopes:a,result:m},f.push(o),this._inFlightRequests.set(i,f);try{await m}finally{const M=f.findIndex(y=>y.scopes===a);M>-1&&(f.splice(M),this._inFlightRequests.set(i,f))}return m}}async _getSession(D,T,R,b,i={}){await this._proxy.$ensureProvider(R);const f=D.displayName||D.name;return this._proxy.$getSession(R,b,T,f,i)}async removeSession(D,T){const R=this._authenticationProviders.get(D);return R?R.provider.removeSession(T):this._proxy.$removeSession(D,T)}registerAuthenticationProvider(D,T,R,b){if(this._authenticationProviders.get(D))throw new Error(`An authentication provider with id '${D}' is already registered.`);this._authenticationProviders.set(D,{label:T,provider:R,options:b??{supportsMultipleAccounts:!1}}),this._providers.find(f=>f.id===D)||this._providers.push({id:D,label:T});const i=R.onDidChangeSessions(f=>{this._proxy.$sendDidChangeSessions(D,{added:f.added??[],changed:f.changed??[],removed:f.removed??[]})});return this._proxy.$registerAuthenticationProvider(D,T,b?.supportsMultipleAccounts??!1),new S.Disposable(()=>{i.dispose(),this._authenticationProviders.delete(D);const f=this._providers.findIndex(a=>a.id===D);f>-1&&this._providers.splice(f),this._proxy.$unregisterAuthenticationProvider(D)})}$createSession(D,T){const R=this._authenticationProviders.get(D);if(R)return Promise.resolve(R.provider.createSession(T));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$removeSession(D,T){const R=this._authenticationProviders.get(D);if(R)return Promise.resolve(R.provider.removeSession(T));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$getSessions(D,T){const R=this._authenticationProviders.get(D);if(R)return Promise.resolve(R.provider.getSessions(T));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$onDidChangeAuthenticationSessions(D,T){return this._onDidChangeSessions.fire({provider:{id:D,label:T}}),Promise.resolve()}}e.ExtHostAuthentication=A}),define(Se[175],_e([0,1,5,14,8]),function(ee,e,r,t,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let P=class{constructor(I,D){this._extHostDocumentsAndEditors=D,this._proxy=I.getProxy(r.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(I){const D=S.WorkspaceEdit.from(I,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(D)}};P=xe([$e(0,t.IExtHostRpcService)],P),e.ExtHostBulkEdits=P}),define(Se[176],_e([0,1,5]),function(ee,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class t{constructor(P){const A=P.getProxy(r.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return A.$readText()},writeText(I){return A.$writeText(I)}})}}e.ExtHostClipboard=t});var Xe=this&&this.__classPrivateFieldSet||function(ee,e,r,t,S){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!S:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?S.call(ee,r):S?S.value=r:e.set(ee,r),r},Ie=this&&this.__classPrivateFieldGet||function(ee,e,r,t){if(r==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!t:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?t:r==="a"?t.call(ee):t?t.value:e.get(ee)};define(Se[39],_e([0,1,13,7,8,27,5,16,12,55,58,227,2,6,3,14,48,21,38,43]),function(ee,e,r,t,S,P,A,I,D,T,R,b,i,f,a,o,m,M,y,_){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let C=class{constructor(g,s){u.set(this,void 0),this._commands=new Map,this._apiCommands=new Map,Xe(this,u,g.getProxy(A.MainContext.MainThreadCommands),"f"),this._logService=s,this.converter=new l(this,d=>{const p=this._apiCommands.get(d);return p?.result===c.Void?p:void 0},s),this._argumentProcessors=[{processArgument(d){return(0,T.revive)(d)}},{processArgument(d){return(0,P.cloneAndChange)(d,function(p){if(R.Range.isIRange(p))return S.Range.to(p);if(b.Position.isIPosition(p))return S.Position.to(p);if(R.Range.isIRange(p.range)&&i.URI.isUri(p.uri))return S.location.to(p);if(p instanceof M.VSBuffer)return p.buffer.buffer;if(!Array.isArray(p))return p})}}]}registerArgumentProcessor(g){this._argumentProcessors.push(g)}registerApiCommand(g){const s=this.registerCommand(!1,g.id,async(...d)=>{const p=g.args.map((v,k)=>{if(!v.validate(d[k]))throw new Error(`Invalid argument '${v.name}' when running '${g.id}', received: ${d[k]}`);return v.convert(d[k])}),w=await this.executeCommand(g.internalId,...p);return g.result.convert(w,d,this.converter)},void 0,{description:g.description,args:g.args,returns:g.result.description});return this._apiCommands.set(g.id,g),new t.Disposable(()=>{s.dispose(),this._apiCommands.delete(g.id)})}registerCommand(g,s,d,p,w,v){if(this._logService.trace("ExtHostCommands#registerCommand",s),!s.trim().length)throw new Error("invalid id");if(this._commands.has(s))throw new Error(`command '${s}' already exists`);return this._commands.set(s,{callback:d,thisArg:p,description:w,extension:v}),g&&Ie(this,u,"f").$registerCommand(s),new t.Disposable(()=>{this._commands.delete(s)&&g&&Ie(this,u,"f").$unregisterCommand(s)})}executeCommand(g,...s){return this._logService.trace("ExtHostCommands#executeCommand",g),this._doExecuteCommand(g,s,!0)}async _doExecuteCommand(g,s,d){if(this._commands.has(g))return this._executeContributedCommand(g,s,!1);{let p=!1;const w=(0,P.cloneAndChange)(s,function(v){if(v instanceof t.Position)return S.Position.from(v);if(v instanceof t.Range)return S.Range.from(v);if(v instanceof t.Location)return S.location.from(v);if(t.NotebookRange.isNotebookRange(v))return S.NotebookRange.from(v);if(v instanceof ArrayBuffer)return p=!0,M.VSBuffer.wrap(new Uint8Array(v));if(v instanceof Uint8Array)return p=!0,M.VSBuffer.wrap(v);if(!Array.isArray(v))return v});try{const v=await Ie(this,u,"f").$executeCommand(g,p?new y.SerializableObjectWithBuffers(w):w,d);return(0,T.revive)(v)}catch(v){if(v instanceof Error&&v.message==="$executeCommand:retry")return this._doExecuteCommand(g,s,!1);throw v}}}async _executeContributedCommand(g,s,d){const p=this._commands.get(g);if(!p)throw new Error("Unknown command");let{callback:w,thisArg:v,description:k}=p;if(k)for(let L=0;L<k.args.length;L++)try{(0,r.validateConstraint)(s[L],k.args[L].constraint)}catch{throw new Error(`Running the contributed command: '${g}' failed. Illegal argument '${k.args[L].name}' - ${k.args[L].description}`)}try{return await w.apply(v,s)}catch(L){if(g===this.converter.delegatingCommandId){const E=this.converter.getActualCommand(...s);E&&(g=E.command)}throw this._logService.error(L,g,p.extension?.identifier),d?new class extends Error{constructor(){super((0,_.toErrorMessage)(L));this.id=g,this.source=p.extension?.displayName??p.extension?.name}}:L}}$executeContributedCommand(g,...s){return this._logService.trace("ExtHostCommands#$executeContributedCommand",g),this._commands.has(g)?(s=s.map(d=>this._argumentProcessors.reduce((p,w)=>w.processArgument(p),d)),this._executeContributedCommand(g,s,!0)):Promise.reject(new Error(`Contributed command '${g}' does not exist.`))}getCommands(g=!1){return this._logService.trace("ExtHostCommands#getCommands",g),Ie(this,u,"f").$getCommands().then(s=>(g&&(s=s.filter(d=>d[0]!=="_")),s))}$getContributedCommandHandlerDescriptions(){const g=Object.create(null);for(let[s,d]of this._commands){let{description:p}=d;p&&(g[s]=p)}return Promise.resolve(g)}};u=new WeakMap,C=xe([$e(0,o.IExtHostRpcService),$e(1,D.ILogService)],C),e.ExtHostCommands=C,e.IExtHostCommands=(0,a.createDecorator)("IExtHostCommands");class l{constructor(g,s,d){this._commands=g,this._lookupApiCommand=s,this._logService=d,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(g,s){if(!g)return;const d={$ident:void 0,id:g.command,title:g.title,tooltip:g.tooltip};if(!g.command)return d;const p=this._lookupApiCommand(g.command);if(p)d.id=p.internalId,d.arguments=p.args.map((w,v)=>w.convert(g.arguments&&g.arguments[v]));else if((0,I.isNonEmptyArray)(g.arguments)){const w=++this._cachIdPool;this._cache.set(w,g),s.add((0,f.toDisposable)(()=>{this._cache.delete(w),this._logService.trace("CommandsConverter#DISPOSE",w)})),d.$ident=w,d.id=this.delegatingCommandId,d.arguments=[w],this._logService.trace("CommandsConverter#CREATE",g.command,w)}return d}fromInternal(g){return typeof g.$ident=="number"?this._cache.get(g.$ident):{command:g.id,title:g.title,arguments:g.arguments}}getActualCommand(...g){return this._cache.get(g[0])}_executeConvertedCommand(...g){const s=this.getActualCommand(...g);return this._logService.trace("CommandsConverter#EXECUTE",g[0],s?s.command:"MISSING"),s?this._commands.executeCommand(s.command,...s.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=l;class F{constructor(g,s,d,p){this.name=g,this.description=s,this.validate=d,this.convert=p}optional(){return new F(this.name,`(optional) ${this.description}`,g=>g==null||this.validate(g),g=>g===void 0?void 0:g===null?null:this.convert(g))}with(g,s){return new F(g??this.name,s??this.description,this.validate,this.convert)}}e.ApiCommandArgument=F,F.Uri=new F("uri","Uri of a text document",h=>i.URI.isUri(h),h=>h),F.Position=new F("position","A position in a text document",h=>t.Position.isPosition(h),S.Position.from),F.Range=new F("range","A range in a text document",h=>t.Range.isRange(h),S.Range.from),F.Selection=new F("selection","A selection in a text document",h=>t.Selection.isSelection(h),S.Selection.from),F.Number=new F("number","",h=>typeof h=="number",h=>h),F.String=new F("string","",h=>typeof h=="string",h=>h),F.CallHierarchyItem=new F("item","A call hierarchy item",h=>h instanceof t.CallHierarchyItem,S.CallHierarchyItem.from),F.TypeHierarchyItem=new F("item","A type hierarchy item",h=>h instanceof t.TypeHierarchyItem,S.TypeHierarchyItem.from),F.TestItem=new F("testItem","A VS Code TestItem",h=>h instanceof m.TestItemImpl,S.TestItem.from);class c{constructor(g,s){this.description=g,this.convert=s}}e.ApiCommandResult=c,c.Void=new c("no result",h=>h);class n{constructor(g,s,d,p,w){this.id=g,this.internalId=s,this.description=d,this.args=p,this.result=w}}e.ApiCommand=n}),define(Se[177],_e([0,1,8,7,57,39,16,77]),function(ee,e,r,t,S,P,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const D=[new P.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Position],new P.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",R(r.DocumentHighlight.to))),new P.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[P.ApiCommandArgument.Uri],new P.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(i,f)=>{if((0,A.isFalsyOrEmpty)(i))return;class a extends t.SymbolInformation{static to(m){const M=new a(m.name,r.SymbolKind.to(m.kind),m.containerName||"",new t.Location(f[0],r.Range.to(m.range)));return M.detail=m.detail,M.range=M.location.range,M.selectionRange=r.Range.to(m.selectionRange),M.children=m.children?m.children.map(a.to):[],M}}return i.map(a.to)})),new P.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[P.ApiCommandArgument.Uri,new P.ApiCommandArgument("options","Formatting options",i=>!0,i=>i)],new P.ApiCommandResult("A promise that resolves to an array of TextEdits.",R(r.TextEdit.to))),new P.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Range,new P.ApiCommandArgument("options","Formatting options",i=>!0,i=>i)],new P.ApiCommandResult("A promise that resolves to an array of TextEdits.",R(r.TextEdit.to))),new P.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Position,new P.ApiCommandArgument("ch","Trigger character",i=>typeof i=="string",i=>i),new P.ApiCommandArgument("options","Formatting options",i=>!0,i=>i)],new P.ApiCommandResult("A promise that resolves to an array of TextEdits.",R(r.TextEdit.to))),new P.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Position],new P.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",b)),new P.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Position],new P.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",b)),new P.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Position],new P.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",b)),new P.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Position],new P.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",b)),new P.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Position],new P.ApiCommandResult("A promise that resolves to an array of Location-instances.",R(r.location.to))),new P.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Position],new P.ApiCommandResult("A promise that resolves to an array of Hover-instances.",R(r.Hover.to))),new P.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[P.ApiCommandArgument.Uri,new P.ApiCommandArgument("position","A position in a text document",i=>Array.isArray(i)&&i.every(f=>t.Position.isPosition(f)),i=>i.map(r.Position.from))],new P.ApiCommandResult("A promise that resolves to an array of ranges.",i=>i.map(f=>{let a;for(const o of f.reverse())a=new t.SelectionRange(r.Range.to(o),a);return a}))),new P.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[P.ApiCommandArgument.String.with("query","Search string")],new P.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",i=>i.map(r.WorkspaceSymbol.to))),new P.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Position],new P.ApiCommandResult("A CallHierarchyItem or undefined",i=>i.map(r.CallHierarchyItem.to))),new P.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[P.ApiCommandArgument.CallHierarchyItem],new P.ApiCommandResult("A CallHierarchyItem or undefined",i=>i.map(r.CallHierarchyIncomingCall.to))),new P.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[P.ApiCommandArgument.CallHierarchyItem],new P.ApiCommandResult("A CallHierarchyItem or undefined",i=>i.map(r.CallHierarchyOutgoingCall.to))),new P.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Position],new P.ApiCommandResult("A promise that resolves to a range and placeholder text.",i=>{if(!!i)return{range:r.Range.to(i.range),placeholder:i.text}})),new P.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Position,P.ApiCommandArgument.String.with("newName","The new symbol name")],new P.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",i=>{if(!!i){if(i.rejectReason)throw new Error(i.rejectReason);return r.WorkspaceEdit.to(i)}})),new P.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new P.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",i=>i.map(r.DocumentLink.to))),new P.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[P.ApiCommandArgument.Uri],new P.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",i=>{if(!!i)return new t.SemanticTokensLegend(i.tokenTypes,i.tokenModifiers)})),new P.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[P.ApiCommandArgument.Uri],new P.ApiCommandResult("A promise that resolves to SemanticTokens.",i=>{if(!i)return;const f=(0,I.decodeSemanticTokensDto)(i);if(f.type==="full")return new t.SemanticTokens(f.data,void 0)})),new P.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Range.optional()],new P.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",i=>{if(!!i)return new t.SemanticTokensLegend(i.tokenTypes,i.tokenModifiers)})),new P.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Range],new P.ApiCommandResult("A promise that resolves to SemanticTokens.",i=>{if(!i)return;const f=(0,I.decodeSemanticTokensDto)(i);if(f.type==="full")return new t.SemanticTokens(f.data,void 0)})),new P.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Position,P.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),P.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new P.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(i,f,a)=>{if(!i)return new t.CompletionList([]);const o=i.suggestions.map(m=>r.CompletionItem.to(m,a));return new t.CompletionList(o,i.incomplete)})),new P.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Position,P.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new P.ApiCommandResult("A promise that resolves to SignatureHelp.",i=>{if(i)return r.SignatureHelp.to(i)})),new P.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new P.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(i,f,a)=>R(o=>new t.CodeLens(r.Range.to(o.range),o.command&&a.fromInternal(o.command)))(i))),new P.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[P.ApiCommandArgument.Uri,new P.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",i=>t.Range.isRange(i),i=>t.Selection.isSelection(i)?r.Selection.from(i):r.Range.from(i)),P.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),P.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new P.ApiCommandResult("A promise that resolves to an array of Command-instances.",(i,f,a)=>R(o=>{if(o._isSynthetic){if(!o.command)throw new Error("Synthetic code actions must have a command");return a.fromInternal(o.command)}else{const m=new t.CodeAction(o.title,o.kind?new t.CodeActionKind(o.kind):void 0);return o.edit&&(m.edit=r.WorkspaceEdit.to(o.edit)),o.command&&(m.command=a.fromInternal(o.command)),m.isPreferred=o.isPreferred,m}})(i))),new P.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[P.ApiCommandArgument.Uri],new P.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",i=>i?i.map(f=>new t.ColorInformation(r.Range.to(f.range),r.Color.to(f.color))):[])),new P.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new P.ApiCommandArgument("color","The color to show and insert",i=>i instanceof t.Color,r.Color.from),new P.ApiCommandArgument("context","Context object with uri and range",i=>!0,i=>({uri:i.uri,range:r.Range.from(i.range)}))],new P.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",i=>i?i.map(r.ColorPresentation.to):[])),new P.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Range],new P.ApiCommandResult("A promise that resolves to an array of Inlay objects",(i,f,a)=>i.map(r.InlayHint.to.bind(void 0,a)))),new P.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new P.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",R(i=>({viewType:i.viewType,displayName:i.displayName,options:{transientOutputs:i.options.transientOutputs,transientCellMetadata:i.options.transientCellMetadata,transientDocumentMetadata:i.options.transientDocumentMetadata},filenamePattern:i.filenamePattern.map(f=>r.NotebookExclusiveDocumentPattern.to(f))})))),new P.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Range],new P.ApiCommandResult("A promise that resolves to an array of InlineValue objects",i=>i.map(r.InlineValue.to))),new P.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[P.ApiCommandArgument.Uri,new P.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",i=>i===void 0||typeof i=="number"||typeof i=="object",i=>i&&(typeof i=="number"?[r.ViewColumn.from(i),void 0]:[r.ViewColumn.from(i.viewColumn),r.TextEditorOpenOptions.from(i)])).optional(),P.ApiCommandArgument.String.with("label","").optional()],P.ApiCommandResult.Void),new P.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[P.ApiCommandArgument.Uri.with("resource","Resource to open"),P.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new P.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",i=>i===void 0||typeof i=="number"||typeof i=="object",i=>i&&(typeof i=="number"?[r.ViewColumn.from(i),void 0]:[r.ViewColumn.from(i.viewColumn),r.TextEditorOpenOptions.from(i)])).optional()],P.ApiCommandResult.Void),new P.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[P.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),P.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),P.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new P.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",i=>i===void 0||typeof i=="object",i=>i&&[r.ViewColumn.from(i.viewColumn),r.TextEditorOpenOptions.from(i)]).optional()],P.ApiCommandResult.Void),new P.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Position],new P.ApiCommandResult("A TypeHierarchyItem or undefined",i=>i.map(r.TypeHierarchyItem.to))),new P.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[P.ApiCommandArgument.TypeHierarchyItem],new P.ApiCommandResult("A TypeHierarchyItem or undefined",i=>i.map(r.TypeHierarchyItem.to))),new P.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[P.ApiCommandArgument.TypeHierarchyItem],new P.ApiCommandResult("A TypeHierarchyItem or undefined",i=>i.map(r.TypeHierarchyItem.to))),new P.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[P.ApiCommandArgument.TestItem],P.ApiCommandResult.Void)];class T{static register(f){D.forEach(f.registerApiCommand,f)}}e.ExtHostApiCommands=T;function R(i){return f=>{if(Array.isArray(f))return f.map(i)}}function b(i){if(!Array.isArray(i))return;const f=[];for(const a of i)S.isLocationLink(a)?f.push(r.DefinitionLink.to(a)):f.push(r.location.to(a));return f}}),define(Se[178],_e([0,1,10,53,4,6,2,57,25,8,7,26,5]),function(ee,e,r,t,S,P,A,I,D,T,R,b,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function f(a,o,m){const M=a.getProxy(i.MainContext.MainThreadComments);class y{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,o.registerArgumentProcessor({processArgument:h=>{if(h&&h.$mid===6){const g=this._commentControllers.get(h.handle);return g||h}else if(h&&h.$mid===7){const g=this._commentControllers.get(h.commentControlHandle);if(!g)return h;const s=g.getCommentThread(h.commentThreadHandle);return s||h}else if(h&&h.$mid===8){const g=this._commentControllers.get(h.thread.commentControlHandle);if(!g)return h;const s=g.getCommentThread(h.thread.commentThreadHandle);return s?{thread:s,text:h.text}:h}else if(h&&h.$mid===9){const g=this._commentControllers.get(h.thread.commentControlHandle);if(!g)return h;const s=g.getCommentThread(h.thread.commentThreadHandle);if(!s)return h;let d=h.commentUniqueId,p=s.getCommentByUniqueId(d);return p||h}else if(h&&h.$mid===10){const g=this._commentControllers.get(h.thread.commentControlHandle);if(!g)return h;const s=g.getCommentThread(h.thread.commentThreadHandle);if(!s)return h;let d=h.text,p=h.commentUniqueId,w=s.getCommentByUniqueId(p);return w?(w.body=d,w):h}return h}})}createCommentController(h,g,s){const d=y.handlePool++,p=new u(h,d,g,s);this._commentControllers.set(p.handle,p);const w=this._commentControllersByExtension.get(D.ExtensionIdentifier.toKey(h.identifier))||[];return w.push(p),this._commentControllersByExtension.set(D.ExtensionIdentifier.toKey(h.identifier),w),p.value}$createCommentThreadTemplate(h,g,s){const d=this._commentControllers.get(h);!d||d.$createCommentThreadTemplate(g,s)}async $updateCommentThreadTemplate(h,g,s){const d=this._commentControllers.get(h);!d||d.$updateCommentThreadTemplate(g,s)}$deleteCommentThread(h,g){const s=this._commentControllers.get(h);s&&s.$deleteCommentThread(g)}$provideCommentingRanges(h,g,s){const d=this._commentControllers.get(h);if(!d||!d.commentingRangeProvider)return Promise.resolve(void 0);const p=m.getDocument(A.URI.revive(g));return(0,r.asPromise)(()=>d.commentingRangeProvider.provideCommentingRanges(p,s)).then(w=>w?w.map(v=>T.Range.from(v)):void 0)}$toggleReaction(h,g,s,d,p){const w=this._commentControllers.get(h);return!w||!w.reactionHandler?Promise.resolve(void 0):(0,r.asPromise)(()=>{const v=w.getCommentThread(g);if(v){const k=v.getCommentByUniqueId(d.uniqueIdInThread);if(w!==void 0&&k&&w.reactionHandler)return w.reactionHandler(k,F(p))}return Promise.resolve(void 0)})}dispose(){}}y.handlePool=0;class _{constructor(h,g,s,d,p,w,v){this._commentControllerHandle=g,this._id=s,this._uri=d,this._range=p,this._comments=w,this.extensionDescription=v,this.handle=_._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new S.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new P.MutableDisposable,this._acceptInputDisposables.value=new P.DisposableStore,this._id===void 0&&(this._id=`${h}.${this.handle}`),M.$createCommentThread(g,this.handle,this._id,this._uri,T.Range.from(this._range),v.identifier),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=w,this._localDisposables.push({dispose:()=>{M.$deleteCommentThread(g,this.handle)}});const k=this;this.value={get uri(){return k.uri},get range(){return k.range},set range(L){k.range=L},get comments(){return k.comments},set comments(L){k.comments=L},get collapsibleState(){return k.collapsibleState},set collapsibleState(L){k.collapsibleState=L},get canReply(){return k.canReply},set canReply(L){k.canReply=L},get contextValue(){return k.contextValue},set contextValue(L){k.contextValue=L},get label(){return k.label},set label(L){k.label=L},dispose:()=>{k.dispose()}}}set threadId(h){this._id=h}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(h){h.isEqual(this._range)||(this._range=h,this.modifications.range=h,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(h){this._canReply!==h&&(this._canReply=h,this.modifications.canReply=h,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(h){this._label=h,this.modifications.label=h,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(h){this._contextValue=h,this.modifications.contextValue=h,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(h){this._comments=h,this.modifications.comments=h,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(h){this._collapseState=h,this.modifications.collapsibleState=h,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new P.DisposableStore);const h=s=>Object.prototype.hasOwnProperty.call(this.modifications,s),g={};h("range")&&(g.range=T.Range.from(this._range)),h("label")&&(g.label=this.label),h("contextValue")&&(g.contextValue=this.contextValue??null),h("comments")&&(g.comments=this._comments.map(s=>C(this,s,this._commentsMap))),h("collapsibleState")&&(g.collapseState=c(this._collapseState)),h("canReply")&&(g.canReply=this.canReply),this.modifications={},M.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,g)}getCommentByUniqueId(h){for(let g of this._commentsMap){let s=g[0],d=g[1];if(h===d)return s}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(h=>h.dispose())}}_._handlePool=0,xe([(0,t.debounce)(100)],_.prototype,"eventuallyUpdateCommentThread",null);class u{constructor(h,g,s,d){this._extension=h,this._handle=g,this._id=s,this._label=d,this._threads=new Map,M.$registerCommentController(this.handle,s,d);const p=this;this.value=Object.freeze({id:p.id,label:p.label,get options(){return p.options},set options(w){p.options=w},get commentingRangeProvider(){return p.commentingRangeProvider},set commentingRangeProvider(w){p.commentingRangeProvider=w},get reactionHandler(){return p.reactionHandler},set reactionHandler(w){p.reactionHandler=w},createCommentThread(w,v,k){return p.createCommentThread(w,v,k).value},dispose:()=>{p.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{M.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(h){this._commentingRangeProvider=h,M.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(h){this._reactionHandler=h,M.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!h})}get options(){return this._options}set options(h){this._options=h,M.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(h,g,s,d){if(typeof h=="string"){const p=new _(this.id,this.handle,h,g,s,d,this._extension);return this._threads.set(p.handle,p),p}else{const p=new _(this.id,this.handle,void 0,h,g,s,this._extension);return this._threads.set(p.handle,p),p}}$createCommentThreadTemplate(h,g){const s=new _(this.id,this.handle,void 0,A.URI.revive(h),T.Range.to(g),[],this._extension);return s.collapsibleState=I.CommentThreadCollapsibleState.Expanded,this._threads.set(s.handle,s),s}$updateCommentThreadTemplate(h,g){let s=this._threads.get(h);s&&(s.range=T.Range.to(g))}$deleteCommentThread(h){let g=this._threads.get(h);g&&g.dispose(),this._threads.delete(h)}getCommentThread(h){return this._threads.get(h)}dispose(){this._threads.forEach(h=>{h.dispose()}),this._localDisposables.forEach(h=>h.dispose())}}function C(n,h,g){let s=g.get(h);s||(s=++n.commentHandle,g.set(h,s));const d=h.author&&h.author.iconPath?h.author.iconPath.toString():void 0;h.detail&&(0,b.checkProposedApiEnabled)(n.extensionDescription,"commentTimestamp");let p;return h.detail&&typeof h.detail!="string"?p={source:h.detail,$mid:14}:p=h.detail,{mode:h.mode,contextValue:h.contextValue,uniqueIdInThread:s,body:T.MarkdownString.from(h.body),userName:h.author.name,userIconPath:d,label:h.label,commentReactions:h.reactions?h.reactions.map(w=>l(w)):void 0,detail:p}}function l(n){return{label:n.label,iconPath:n.iconPath?T.pathOrURIToURI(n.iconPath):void 0,count:n.count,hasReacted:n.authorHasReacted}}function F(n){return{label:n.label||"",count:n.count||0,iconPath:n.iconPath?A.URI.revive(n.iconPath):"",authorHasReacted:n.hasReacted||!1}}function c(n){if(n!==void 0)switch(n){case R.CommentThreadCollapsibleState.Expanded:return I.CommentThreadCollapsibleState.Expanded;case R.CommentThreadCollapsibleState.Collapsed:return I.CommentThreadCollapsibleState.Collapsed}return I.CommentThreadCollapsibleState.Collapsed}return new y}e.createExtHostComments=f}),define(Se[91],_e([0,1,2,5,7,3,14,12,16,9,17]),function(ee,e,r,t,S,P,A,I,D,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let b=class _i{constructor(f,a){this._logService=a,this._provider=new Map,this._proxy=f.getProxy(t.MainContext.MainThreadDecorations)}registerFileDecorationProvider(f,a){const o=_i._handlePool++;this._provider.set(o,{provider:f,extensionId:a}),this._proxy.$registerDecorationProvider(o,a.value);const m=f.onDidChangeFileDecorations&&f.onDidChangeFileDecorations(M=>{if(!M){this._proxy.$onDidChange(o,null);return}let y=(0,D.asArray)(M);if(y.length<=_i._maxEventSize){this._proxy.$onDidChange(o,y);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",a.value,y.length);const _=y.map(l=>({uri:l,rank:(0,T.count)(l.path,"/")})),u=(0,D.groupBy)(_,(l,F)=>l.rank-F.rank||(0,T.compare)(l.uri.path,F.uri.path));let C=[];e:for(let l of u){let F;for(let c of l){let n=(0,R.dirname)(c.uri.path);if(F!==n&&(F=n,C.push(c.uri)>=_i._maxEventSize))break e}}this._proxy.$onDidChange(o,C)});return new S.Disposable(()=>{m?.dispose(),this._proxy.$unregisterDecorationProvider(o),this._provider.delete(o)})}async $provideDecorations(f,a,o){if(!this._provider.has(f))return Object.create(null);const m=Object.create(null),{provider:M,extensionId:y}=this._provider.get(f);return await Promise.all(a.map(async _=>{try{const{uri:u,id:C}=_,l=await Promise.resolve(M.provideFileDecoration(r.URI.revive(u),o));if(!l)return;try{S.FileDecoration.validate(l),m[C]=[l.propagate,l.tooltip,l.badge,l.color]}catch(F){this._logService.warn(`INVALID decoration from extension '${y.value}': ${F}`)}}catch(u){this._logService.error(u)}})),m}};b._handlePool=0,b._maxEventSize=250,b=xe([$e(0,A.IExtHostRpcService),$e(1,I.ILogService)],b),e.ExtHostDecorations=b,e.IExtHostDecorations=(0,P.createDecorator)("IExtHostDecorations")});var Xe=this&&this.__classPrivateFieldSet||function(ee,e,r,t,S){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!S:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?S.call(ee,r):S?S.value=r:e.set(ee,r),r},Ie=this&&this.__classPrivateFieldGet||function(ee,e,r,t){if(r==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!t:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?t:r==="a"?t.call(ee):t?t.value:e.get(ee)};define(Se[179],_e([0,1,118,80,2,5,7,8,4,12,22,30]),function(ee,e,r,t,S,P,A,I,D,T,R,b){"use strict";var i,f,a;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class o{constructor(y,_,u,C,l,F){this._name=y,this._owner=_,this._maxDiagnosticsPerFile=u,i.set(this,void 0),f.set(this,void 0),a.set(this,void 0),this._isDisposed=!1,Xe(this,a,new R.ResourceMap(c=>C.getComparisonKey(c)),"f"),Xe(this,i,l,"f"),Xe(this,f,F,"f")}dispose(){this._isDisposed||(Ie(this,f,"f").fire([...Ie(this,a,"f").keys()]),Ie(this,i,"f")&&Ie(this,i,"f").$clear(this._owner),Ie(this,a,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(y,_){if(!y){this.clear();return}this._checkDisposed();let u=[];if(S.URI.isUri(y)){if(!_){this.delete(y);return}Ie(this,a,"f").set(y,_.slice()),u=[y]}else if(Array.isArray(y)){u=[];let l;y=[...y].sort(o._compareIndexedTuplesByUri);for(const F of y){const[c,n]=F;if((!l||c.toString()!==l.toString())&&(l&&Ie(this,a,"f").get(l).length===0&&Ie(this,a,"f").delete(l),l=c,u.push(c),Ie(this,a,"f").set(c,[])),n){const h=Ie(this,a,"f").get(c);h&&h.push(...n)}else{const h=Ie(this,a,"f").get(c);h&&(h.length=0)}}}if(Ie(this,f,"f").fire(u),!Ie(this,i,"f"))return;const C=[];for(let l of u){let F=[];const c=Ie(this,a,"f").get(l);if(c)if(c.length>this._maxDiagnosticsPerFile){F=[];const n=[A.DiagnosticSeverity.Error,A.DiagnosticSeverity.Warning,A.DiagnosticSeverity.Information,A.DiagnosticSeverity.Hint];e:for(let h=0;h<4;h++)for(let g of c)if(g.severity===n[h]&&F.push(I.Diagnostic.from(g))===this._maxDiagnosticsPerFile)break e;F.push({severity:t.MarkerSeverity.Info,message:(0,r.localize)(0,null,c.length-this._maxDiagnosticsPerFile),startLineNumber:F[F.length-1].startLineNumber,startColumn:F[F.length-1].startColumn,endLineNumber:F[F.length-1].endLineNumber,endColumn:F[F.length-1].endColumn})}else F=c.map(n=>I.Diagnostic.from(n));C.push([l,F])}Ie(this,i,"f").$changeMany(this._owner,C)}delete(y){this._checkDisposed(),Ie(this,f,"f").fire([y]),Ie(this,a,"f").delete(y),Ie(this,i,"f")&&Ie(this,i,"f").$changeMany(this._owner,[[y,void 0]])}clear(){this._checkDisposed(),Ie(this,f,"f").fire([...Ie(this,a,"f").keys()]),Ie(this,a,"f").clear(),Ie(this,i,"f")&&Ie(this,i,"f").$clear(this._owner)}forEach(y,_){this._checkDisposed();for(let u of Ie(this,a,"f").keys())y.apply(_,[u,this.get(u),this])}get(y){this._checkDisposed();const _=Ie(this,a,"f").get(y);return Array.isArray(_)?Object.freeze(_.slice(0)):[]}has(y){return this._checkDisposed(),Array.isArray(Ie(this,a,"f").get(y))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(y,_){return y[0].toString()<_[0].toString()?-1:y[0].toString()>_[0].toString()?1:0}}e.DiagnosticCollection=o,i=new WeakMap,f=new WeakMap,a=new WeakMap;let m=class si{constructor(y,_,u){this._logService=_,this._fileSystemInfoService=u,this._collections=new Map,this._onDidChangeDiagnostics=new D.DebounceEmitter({merge:C=>C.flat(),delay:50}),this.onDidChangeDiagnostics=D.Event.map(this._onDidChangeDiagnostics.event,si._mapper),this._proxy=y.getProxy(P.MainContext.MainThreadDiagnostics)}static _mapper(y){const _=new R.ResourceMap;for(const u of y)_.set(u,u);return{uris:Object.freeze(Array.from(_.values()))}}createDiagnosticCollection(y,_){const{_collections:u,_proxy:C,_onDidChangeDiagnostics:l,_logService:F,_fileSystemInfoService:c}=this,n=new class{$changeMany(s,d){C.$changeMany(s,d),F.trace("[DiagnosticCollection] change many (extension, owner, uris)",y.value,s,d.length===0?"CLEARING":d)}$clear(s){C.$clear(s),F.trace("[DiagnosticCollection] remove all (extension, owner)",y.value,s)}dispose(){C.dispose()}};let h;if(!_)_="_generated_diagnostic_collection_name_#"+si._idPool++,h=_;else if(!u.has(_))h=_;else{this._logService.warn(`DiagnosticCollection with name '${_}' does already exist.`);do h=_+si._idPool++;while(u.has(h))}return new class extends o{constructor(){super(_,h,si._maxDiagnosticsPerFile,c.extUri,n,l);u.set(h,this)}dispose(){super.dispose(),u.delete(h)}}}getDiagnostics(y){if(y)return this._getDiagnostics(y);{const _=new Map,u=[];for(const C of this._collections.values())C.forEach((l,F)=>{let c=_.get(l.toString());typeof c=="undefined"&&(c=u.length,_.set(l.toString(),c),u.push([l,[]])),u[c][1]=u[c][1].concat(...F)});return u}}_getDiagnostics(y){let _=[];for(let u of this._collections.values())u.has(y)&&(_=_.concat(u.get(y)));return _}$acceptMarkersChange(y){if(!this._mirrorCollection){const _="_generated_mirror",u=new o(_,_,si._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(_,u),this._mirrorCollection=u}for(const[_,u]of y)this._mirrorCollection.set(S.URI.revive(_),u.map(I.Diagnostic.to))}};m._idPool=0,m._maxDiagnosticsPerFile=1e3,m=xe([$e(1,T.ILogService),$e(2,b.IExtHostFileSystemInfo)],m),e.ExtHostDiagnostics=m}),define(Se[180],_e([0,1,2,5]),function(ee,e,r,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class S{constructor(A){this._proxy=A.getProxy(t.MainContext.MainThreadDialogs)}showOpenDialog(A){return this._proxy.$showOpenDialog(A).then(I=>I?I.map(D=>r.URI.revive(D)):void 0)}showSaveDialog(A){return this._proxy.$showSaveDialog(A).then(I=>I?r.URI.revive(I):void 0)}}e.ExtHostDialogs=S}),define(Se[181],_e([0,1,15,2,7,5,11,20,9]),function(ee,e,r,t,S,P,A,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class T{constructor(b,i,f){this._documentsAndEditors=i,this._logService=f,this._documentContentProviders=new Map,this._proxy=b.getProxy(P.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(b,i){if(Object.keys(A.Schemas).indexOf(b)>=0)throw new Error(`scheme '${b}' already registered`);const f=T._handlePool++;this._documentContentProviders.set(f,i),this._proxy.$registerTextContentProvider(f,b);let a;return typeof i.onDidChange=="function"&&(a=i.onDidChange(o=>{if(o.scheme!==b){this._logService.warn(`Provider for scheme '${b}' is firing event for schema '${o.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(o)&&this.$provideTextDocumentContent(f,o).then(m=>{if(!m&&typeof m!="string")return;const M=this._documentsAndEditors.getDocument(o);if(!M)return;const y=(0,D.splitLines)(m);if(!M.equalLines(y))return this._proxy.$onVirtualDocumentChange(o,m)},r.onUnexpectedError)})),new S.Disposable(()=>{this._documentContentProviders.delete(f)&&this._proxy.$unregisterTextContentProvider(f),a&&(a.dispose(),a=void 0)})}$provideTextDocumentContent(b,i){const f=this._documentContentProviders.get(b);return f?Promise.resolve(f.provideTextDocumentContent(t.URI.revive(i),I.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${i.scheme}`))}}e.ExtHostDocumentContentProvider=T,T._handlePool=0}),define(Se[182],_e([0,1,4,6,2,5,84,8,13,27,7]),function(ee,e,r,t,S,P,A,I,D,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class b{constructor(f,a){this._onDidAddDocument=new r.Emitter,this._onDidRemoveDocument=new r.Emitter,this._onDidChangeDocument=new r.Emitter,this._onDidSaveDocument=new r.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new t.DisposableStore,this._documentLoader=new Map,this._proxy=f.getProxy(P.MainContext.MainThreadDocuments),this._documentsAndEditors=a,this._documentsAndEditors.onDidRemoveDocuments(o=>{for(const m of o)this._onDidRemoveDocument.fire(m.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(o=>{for(const m of o)this._onDidAddDocument.fire(m.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(f){if(!f)return;const a=this._documentsAndEditors.getDocument(f);if(a)return a}getDocument(f){const a=this.getDocumentData(f);if(!a?.document)throw new Error(`Unable to retrieve document from URI '${f}'`);return a.document}ensureDocumentData(f){const a=this._documentsAndEditors.getDocument(f);if(a)return Promise.resolve(a);let o=this._documentLoader.get(f.toString());return o||(o=this._proxy.$tryOpenDocument(f).then(m=>{this._documentLoader.delete(f.toString());const M=S.URI.revive(m);return(0,D.assertIsDefined)(this._documentsAndEditors.getDocument(M))},m=>(this._documentLoader.delete(f.toString()),Promise.reject(m))),this._documentLoader.set(f.toString(),o)),o}createDocumentData(f){return this._proxy.$tryCreateDocument(f).then(a=>S.URI.revive(a))}$acceptModelLanguageChanged(f,a){const o=S.URI.revive(f),m=this._documentsAndEditors.getDocument(o);if(!m)throw new Error("unknown document");this._onDidRemoveDocument.fire(m.document),m._acceptLanguageId(a),this._onDidAddDocument.fire(m.document)}$acceptModelSaved(f){const a=S.URI.revive(f),o=this._documentsAndEditors.getDocument(a);if(!o)throw new Error("unknown document");this.$acceptDirtyStateChanged(f,!1),this._onDidSaveDocument.fire(o.document)}$acceptDirtyStateChanged(f,a){const o=S.URI.revive(f),m=this._documentsAndEditors.getDocument(o);if(!m)throw new Error("unknown document");m._acceptIsDirty(a),this._onDidChangeDocument.fire({document:m.document,contentChanges:[],reason:void 0})}$acceptModelChanged(f,a,o){const m=S.URI.revive(f),M=this._documentsAndEditors.getDocument(m);if(!M)throw new Error("unknown document");M._acceptIsDirty(o),M.onEvents(a);let y;a.isUndoing?y=R.TextDocumentChangeReason.Undo:a.isRedoing&&(y=R.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,T.deepFreeze)({document:M.document,contentChanges:a.changes.map(_=>({range:I.Range.to(_.range),rangeOffset:_.rangeOffset,rangeLength:_.rangeLength,text:_.text})),reason:y}))}setWordDefinitionFor(f,a){(0,A.setWordDefinitionFor)(f,a)}}e.ExtHostDocuments=b}),define(Se[49],_e([0,1,42,4,6,2,3,5,84,14,90,8,12,22,11,157,228]),function(ee,e,r,t,S,P,A,I,D,T,R,b,i,f,a,o,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class M{constructor(u){this.value=u,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let y=class{constructor(u,C){this._extHostRpc=u,this._logService=C,this._activeEditorId=null,this._editors=new Map,this._documents=new f.ResourceMap,this._onDidAddDocuments=new t.Emitter,this._onDidRemoveDocuments=new t.Emitter,this._onDidChangeVisibleTextEditors=new t.Emitter,this._onDidChangeActiveTextEditor=new t.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(u){this.acceptDocumentsAndEditorsDelta(u)}acceptDocumentsAndEditorsDelta(u){const C=[],l=[],F=[];if(u.removedDocuments)for(const c of u.removedDocuments){const n=P.URI.revive(c),h=this._documents.get(n);h?.unref()&&(this._documents.delete(n),C.push(h.value))}if(u.addedDocuments)for(const c of u.addedDocuments){const n=P.URI.revive(c.uri);let h=this._documents.get(n);if(h&&n.scheme!==a.Schemas.vscodeNotebookCell&&n.scheme!==a.Schemas.vscodeInteractiveInput)throw new Error(`document '${n} already exists!'`);h||(h=new M(new D.ExtHostDocumentData(this._extHostRpc.getProxy(I.MainContext.MainThreadDocuments),n,c.lines,c.EOL,c.versionId,c.languageId,c.isDirty,c.notebook)),this._documents.set(n,h),l.push(h.value)),h.ref()}if(u.removedEditors)for(const c of u.removedEditors){const n=this._editors.get(c);this._editors.delete(c),n&&F.push(n)}if(u.addedEditors)for(const c of u.addedEditors){const n=P.URI.revive(c.documentUri);r.ok(this._documents.has(n),`document '${n}' does not exist`),r.ok(!this._editors.has(c.id),`editor '${c.id}' already exists!`);const h=this._documents.get(n).value,g=new R.ExtHostTextEditor(c.id,this._extHostRpc.getProxy(I.MainContext.MainThreadTextEditors),this._logService,new m.Lazy(()=>h.document),c.selections.map(b.Selection.to),c.options,c.visibleRanges.map(s=>b.Range.to(s)),typeof c.editorPosition=="number"?b.ViewColumn.to(c.editorPosition):void 0);this._editors.set(c.id,g)}u.newActiveEditor!==void 0&&(r.ok(u.newActiveEditor===null||this._editors.has(u.newActiveEditor),`active editor '${u.newActiveEditor}' does not exist`),this._activeEditorId=u.newActiveEditor),(0,S.dispose)(C),(0,S.dispose)(F),u.removedDocuments&&this._onDidRemoveDocuments.fire(C),u.addedDocuments&&this._onDidAddDocuments.fire(l),(u.removedEditors||u.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(c=>c.value)),u.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(u){return this._documents.get(u)?.value}allDocuments(){return o.Iterable.map(this._documents.values(),u=>u.value)}getEditor(u){return this._editors.get(u)}activeEditor(u){if(!this._activeEditorId)return;const C=this._editors.get(this._activeEditorId);return u?C:C?.value}allEditors(){return[...this._editors.values()]}};y=xe([$e(0,T.IExtHostRpcService),$e(1,i.ILogService)],y),e.ExtHostDocumentsAndEditors=y,e.IExtHostDocumentsAndEditors=(0,A.createDecorator)("IExtHostDocumentsAndEditors")}),define(Se[69],_e([0,1,8,5,2,4,3,14,10]),function(ee,e,r,t,S,P,A,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,A.createDecorator)("IExtHostEditorTabs");let T=class{constructor(b){this._onDidChangeTabs=new P.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._onDidChangeActiveTab=new P.Emitter,this.onDidChangeActiveTab=this._onDidChangeActiveTab.event,this._tabs=[],this._proxy=b.getProxy(t.MainContext.MainThreadEditorTabs)}get tabs(){return this._tabs}get activeTab(){return this._activeTab}$acceptEditorTabs(b){let i=-1;this._tabs=b.map((a,o)=>(a.isActive&&(i=o),Object.freeze({label:a.label,viewColumn:r.ViewColumn.to(a.viewColumn),index:o,resource:S.URI.revive(a.resource),additionalResourcesAndViewIds:a.additionalResourcesAndViewIds.map(({resource:m,viewId:M})=>({resource:S.URI.revive(m),viewId:M})),viewId:a.editorId,isActive:a.isActive,move:async(m,M)=>{this._proxy.$moveTab(a,m,r.ViewColumn.from(M)),await(0,D.raceTimeout)(P.Event.toPromise(this._onDidChangeTabs.event),1e3)},close:async()=>{await this._proxy.$closeTab(a),await(0,D.raceTimeout)(P.Event.toPromise(this._onDidChangeTabs.event),1e3)}}))),this._tabs=this._tabs.sort((a,o)=>a.viewColumn===o.viewColumn?a.index-o.index:a.viewColumn-o.viewColumn);const f=this._activeTab;this._activeTab=i===-1?void 0:this._tabs[i],this._activeTab!==f&&this._onDidChangeActiveTab.fire(this._activeTab),this._onDidChangeTabs.fire(this._tabs)}};T=xe([$e(0,I.IExtHostRpcService)],T),e.ExtHostEditorTabs=T}),define(Se[183],_e([0,1,2,5,6,7,8,229,9,21,26]),function(ee,e,r,t,S,P,A,I,D,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class b{constructor(){this._schemes=[]}add(a){this._stateMachine=void 0,this._schemes.push(a)}delete(a){const o=this._schemes.indexOf(a);o>=0&&(this._schemes.splice(o,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const a=this._schemes.sort(),o=[];let m,M,y=14,_=14;for(const u of a){let C=m?(0,D.commonPrefixLength)(m,u):0;for(C===0?M=1:M=_;C<u.length;C++)C+1===u.length?(y=_,_=9):_+=1,o.push([M,u.toUpperCase().charCodeAt(C),_]),o.push([M,u.toLowerCase().charCodeAt(C),_]),M=_;m=u,_=y}o.push([9,58,10]),o.push([10,47,12]),this._stateMachine=new I.StateMachine(o)}}provideDocumentLinks(a){this._initStateMachine();const o=[],m=I.LinkComputer.computeLinks({getLineContent(M){return a.lineAt(M-1).text},getLineCount(){return a.lineCount}},this._stateMachine);for(const M of m){const y=A.DocumentLink.to(M);y.target&&o.push(y)}return o}}class i{constructor(a,o){this._extHostLanguageFeatures=o,this._linkProvider=new b,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=a.getProxy(t.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(a,o,m,M={}){if(this._registeredSchemes.has(o))throw new Error(`a provider for the scheme '${o}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(a,"*",this._linkProvider));const y=this._handlePool++;this._linkProvider.add(o),this._registeredSchemes.add(o),this._fsProvider.set(y,m);let _=2;M.isCaseSensitive&&(_+=1024),M.isReadonly&&(_+=2048),typeof m.copy=="function"&&(_+=8),typeof m.open=="function"&&typeof m.close=="function"&&typeof m.read=="function"&&typeof m.write=="function"&&((0,R.checkProposedApiEnabled)(a,"fsChunks"),_+=4),this._proxy.$registerFileSystemProvider(y,o,_).catch(C=>{console.error(`FAILED to register filesystem provider of ${a.identifier.value}-extension for the scheme ${o}`),console.error(C)});const u=m.onDidChangeFile(C=>{const l=[];for(const F of C){let{uri:c,type:n}=F;if(c.scheme!==o)continue;let h;switch(n){case P.FileChangeType.Changed:h=0;break;case P.FileChangeType.Created:h=1;break;case P.FileChangeType.Deleted:h=2;break;default:throw new Error("Unknown FileChangeType")}l.push({resource:c,type:h})}this._proxy.$onFileSystemChange(y,l)});return(0,S.toDisposable)(()=>{u.dispose(),this._linkProvider.delete(o),this._registeredSchemes.delete(o),this._fsProvider.delete(y),this._proxy.$unregisterProvider(y)})}static _asIStat(a){const{type:o,ctime:m,mtime:M,size:y,permissions:_}=a;return{type:o,ctime:m,mtime:M,size:y,permissions:_}}$stat(a,o){return Promise.resolve(this._getFsProvider(a).stat(r.URI.revive(o))).then(m=>i._asIStat(m))}$readdir(a,o){return Promise.resolve(this._getFsProvider(a).readDirectory(r.URI.revive(o)))}$readFile(a,o){return Promise.resolve(this._getFsProvider(a).readFile(r.URI.revive(o))).then(m=>T.VSBuffer.wrap(m))}$writeFile(a,o,m,M){return Promise.resolve(this._getFsProvider(a).writeFile(r.URI.revive(o),m.buffer,M))}$delete(a,o,m){return Promise.resolve(this._getFsProvider(a).delete(r.URI.revive(o),m))}$rename(a,o,m,M){return Promise.resolve(this._getFsProvider(a).rename(r.URI.revive(o),r.URI.revive(m),M))}$copy(a,o,m,M){const y=this._getFsProvider(a);if(!y.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(y.copy(r.URI.revive(o),r.URI.revive(m),M))}$mkdir(a,o){return Promise.resolve(this._getFsProvider(a).createDirectory(r.URI.revive(o)))}$watch(a,o,m,M){const y=this._getFsProvider(a).watch(r.URI.revive(m),M);this._watches.set(o,y)}$unwatch(a,o){const m=this._watches.get(o);m&&(m.dispose(),this._watches.delete(o))}$open(a,o,m){const M=this._getFsProvider(a);if(!M.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(M.open(r.URI.revive(o),m))}$close(a,o){const m=this._getFsProvider(a);if(!m.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(m.close(o))}$read(a,o,m,M){const y=this._getFsProvider(a);if(!y.read)throw new Error('FileSystemProvider does not implement "read"');const _=T.VSBuffer.alloc(M);return Promise.resolve(y.read(o,m,_.buffer,0,M)).then(u=>_.slice(0,u))}$write(a,o,m,M){const y=this._getFsProvider(a);if(!y.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(y.write(o,m,M.buffer,0,M.byteLength))}_getFsProvider(a){const o=this._fsProvider.get(a);if(!o){const m=new Error;throw m.name="ENOPRO",m.message="no provider",m}return o}}e.ExtHostFileSystem=i}),define(Se[50],_e([0,1,5,46,7,21,3,14,30,6]),function(ee,e,r,t,S,P,A,I,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let R=class Wt{constructor(i,f){this._fileSystemProvider=new Map,this._proxy=i.getProxy(r.MainContext.MainThreadFileSystem);const a=this;this.value=Object.freeze({async stat(o){try{const m=a._fileSystemProvider.get(o.scheme);if(!m)return await a._proxy.$stat(o);await a._proxy.$ensureActivation(o.scheme);const M=await m.stat(o);return{type:M.type,ctime:M.ctime,mtime:M.mtime,size:M.size,permissions:M.permissions}}catch(m){Wt._handleError(m)}},async readDirectory(o){try{const m=a._fileSystemProvider.get(o.scheme);return m?(await a._proxy.$ensureActivation(o.scheme),(await m.readDirectory(o)).slice()):await a._proxy.$readdir(o)}catch(m){return Wt._handleError(m)}},async createDirectory(o){try{return await a._proxy.$mkdir(o)}catch(m){return Wt._handleError(m)}},async readFile(o){try{const m=a._fileSystemProvider.get(o.scheme);return m?(await a._proxy.$ensureActivation(o.scheme),(await m.readFile(o)).slice()):(await a._proxy.$readFile(o)).buffer}catch(m){return Wt._handleError(m)}},async writeFile(o,m){try{return await a._proxy.$writeFile(o,P.VSBuffer.wrap(m))}catch(M){return Wt._handleError(M)}},async delete(o,m){try{const M=a._fileSystemProvider.get(o.scheme);return M?(await a._proxy.$ensureActivation(o.scheme),await M.delete(o,{recursive:!1,...m})):await a._proxy.$delete(o,{recursive:!1,useTrash:!1,...m})}catch(M){return Wt._handleError(M)}},async rename(o,m,M){try{return await a._proxy.$rename(o,m,{overwrite:!1,...M})}catch(y){return Wt._handleError(y)}},async copy(o,m,M){try{return await a._proxy.$copy(o,m,{overwrite:!1,...M})}catch(y){return Wt._handleError(y)}},isWritableFileSystem(o){const m=f.getCapabilities(o);if(typeof m=="number")return!(m&2048)}})}static _handleError(i){if(i instanceof S.FileSystemError)throw i;if(!(i instanceof Error))throw new S.FileSystemError(String(i));if(i.name==="ENOPRO")throw S.FileSystemError.Unavailable(i.message);switch(i.name){case t.FileSystemProviderErrorCode.FileExists:throw S.FileSystemError.FileExists(i.message);case t.FileSystemProviderErrorCode.FileNotFound:throw S.FileSystemError.FileNotFound(i.message);case t.FileSystemProviderErrorCode.FileNotADirectory:throw S.FileSystemError.FileNotADirectory(i.message);case t.FileSystemProviderErrorCode.FileIsADirectory:throw S.FileSystemError.FileIsADirectory(i.message);case t.FileSystemProviderErrorCode.NoPermissions:throw S.FileSystemError.NoPermissions(i.message);case t.FileSystemProviderErrorCode.Unavailable:throw S.FileSystemError.Unavailable(i.message);default:throw new S.FileSystemError(i.message,i.name)}}addFileSystemProvider(i,f){return this._fileSystemProvider.set(i,f),(0,T.toDisposable)(()=>this._fileSystemProvider.delete(i))}};R=xe([$e(0,I.IExtHostRpcService),$e(1,D.IExtHostFileSystemInfo)],R),e.ExtHostConsumerFileSystem=R,e.IExtHostConsumerFileSystem=(0,A.createDecorator)("IExtHostConsumerFileSystem")}),define(Se[184],_e([0,1,4,29,2,5,8,7]),function(ee,e,r,t,S,P,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class D{constructor(b,i,f,a,o,m,M,y){this._onDidCreate=new r.Emitter,this._onDidChange=new r.Emitter,this._onDidDelete=new r.Emitter;const _=this.ensureWatching(b,f,o);this._config=0,m&&(this._config+=1),M&&(this._config+=2),y&&(this._config+=4);const u=(0,t.parse)(o),C=typeof o=="string",l=a(F=>{if(!m)for(let c of F.created){const n=S.URI.revive(c);u(n.fsPath)&&(!C||i.getWorkspaceFolder(n))&&this._onDidCreate.fire(n)}if(!M)for(let c of F.changed){const n=S.URI.revive(c);u(n.fsPath)&&(!C||i.getWorkspaceFolder(n))&&this._onDidChange.fire(n)}if(!y)for(let c of F.deleted){const n=S.URI.revive(c);u(n.fsPath)&&(!C||i.getWorkspaceFolder(n))&&this._onDidDelete.fire(n)}});this._disposable=I.Disposable.from(_,this._onDidCreate,this._onDidChange,this._onDidDelete,l)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}ensureWatching(b,i,f){let a=I.Disposable.from();if(typeof f=="string")return a;const o=b.getProxy(P.MainContext.MainThreadFileSystem);let m=!1;(f.pattern.includes(t.GLOBSTAR)||f.pattern.includes(t.GLOB_SPLIT))&&(m=!0);const M=Math.random();return o.$watch(i.identifier.value,M,f.baseUri,{recursive:m,excludes:[]}),I.Disposable.from({dispose:()=>o.$unwatch(M)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class T{constructor(b,i,f){this._mainContext=b,this._logService=i,this._extHostDocumentsAndEditors=f,this._onFileSystemEvent=new r.Emitter,this._onDidRenameFile=new r.Emitter,this._onDidCreateFile=new r.Emitter,this._onDidDeleteFile=new r.Emitter,this._onWillRenameFile=new r.AsyncEmitter,this._onWillCreateFile=new r.AsyncEmitter,this._onWillDeleteFile=new r.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(b,i,f,a,o,m){return new D(this._mainContext,b,i,this._onFileSystemEvent.event,A.GlobPattern.from(f),a,o,m)}$onFileEvent(b){this._onFileSystemEvent.fire(b)}$onDidRunFileOperation(b,i){switch(b){case 2:this._onDidRenameFile.fire(Object.freeze({files:i.map(f=>({oldUri:S.URI.revive(f.source),newUri:S.URI.revive(f.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:i.map(f=>S.URI.revive(f.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:i.map(f=>S.URI.revive(f.target))}));break;default:}}getOnWillRenameFileEvent(b){return this._createWillExecuteEvent(b,this._onWillRenameFile)}getOnWillCreateFileEvent(b){return this._createWillExecuteEvent(b,this._onWillCreateFile)}getOnWillDeleteFileEvent(b){return this._createWillExecuteEvent(b,this._onWillDeleteFile)}_createWillExecuteEvent(b,i){return(f,a,o)=>{const m=function(y){f.call(a,y)};return m.extension=b,i.event(m,void 0,o)}}async $onWillRunFileOperation(b,i,f,a){switch(b){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:i.map(o=>({oldUri:S.URI.revive(o.source),newUri:S.URI.revive(o.target)}))},f,a);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:i.map(o=>S.URI.revive(o.target))},f,a);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:i.map(o=>S.URI.revive(o.target))},f,a)}}async _fireWillEvent(b,i,f,a){const o=new Set,m=[];if(await b.fireAsync(i,a,async(y,_)=>{const u=Date.now(),C=await Promise.resolve(y);C instanceof I.WorkspaceEdit&&(m.push(C),o.add(_.extension.displayName??_.extension.identifier.value)),Date.now()-u>f&&this._logService.warn("SLOW file-participant",_.extension.identifier)}),a.isCancellationRequested||m.length===0)return;const M={edits:[]};for(let y of m){let{edits:_}=A.WorkspaceEdit.from(y,this._extHostDocumentsAndEditors);M.edits=M.edits.concat(_)}return{edit:M,extensionNames:Array.from(o)}}}e.ExtHostFileSystemEventService=T}),define(Se[185],_e([0,1,2,39]),function(ee,e,r,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class S{constructor(A,I,D,T){this._extHostNotebooks=I,this._textDocumentsAndEditors=D,this._commands=T;const R=new t.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new t.ApiCommandArgument("showOptions","Show Options",b=>!0,b=>b),new t.ApiCommandArgument("resource","Interactive resource Uri",b=>!0,b=>b),new t.ApiCommandArgument("controllerId","Notebook controller Id",b=>!0,b=>b),new t.ApiCommandArgument("title","Interactive editor title",b=>!0,b=>b)],new t.ApiCommandResult("Notebook and input URI",b=>{if(b.notebookEditorId!==void 0){const i=this._extHostNotebooks.getEditorById(b.notebookEditorId);return{notebookUri:r.URI.revive(b.notebookUri),inputUri:r.URI.revive(b.inputUri),notebookEditor:i.apiEditor}}return{notebookUri:r.URI.revive(b.notebookUri),inputUri:r.URI.revive(b.inputUri)}}));this._commands.registerApiCommand(R)}$willAddInteractiveDocument(A,I,D,T){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:I,lines:[""],languageId:D,uri:A,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(r.URI.revive(T))?.apiNotebook}]})}$willRemoveInteractiveDocument(A,I){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[A]})}}e.ExtHostInteractive=S}),define(Se[186],_e([0,1,6,5]),function(ee,e,r,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class S{constructor(A){this._handlePool=0,this._proxy=A.getProxy(t.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(A){const I=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(I,A),(0,r.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(I)})}}e.ExtHostLabelService=S}),define(Se[187],_e([0,1,2,27,8,7,5,9,58,16,13,230,20,6,77,54,62,188,15,4,10]),function(ee,e,r,t,S,P,A,I,D,T,R,b,i,f,a,o,m,M,y,_,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class C{constructor(x,K){this._documents=x,this._provider=K}async provideDocumentSymbols(x,K){const z=this._documents.getDocument(x),V=await this._provider.provideDocumentSymbols(z,K);if(!(0,T.isFalsyOrEmpty)(V))return V[0]instanceof P.DocumentSymbol?V.map(S.DocumentSymbol.from):C._asDocumentSymbolTree(V)}static _asDocumentSymbolTree(x){x=x.slice(0).sort((V,Y)=>{let se=V.location.range.start.compareTo(Y.location.range.start);return se===0&&(se=Y.location.range.end.compareTo(V.location.range.end)),se});const K=[],z=[];for(const V of x){const Y={name:V.name||"!!MISSING: name!!",kind:S.SymbolKind.from(V.kind),tags:V.tags?.map(S.SymbolTag.from)||[],detail:"",containerName:V.containerName,range:S.Range.from(V.location.range),selectionRange:S.Range.from(V.location.range),children:[]};for(;;){if(z.length===0){z.push(Y),K.push(Y);break}const se=z[z.length-1];if(D.Range.containsRange(se.range,Y.range)&&!D.Range.equalsRange(se.range,Y.range)){se.children&&se.children.push(Y),z.push(Y);break}z.pop()}}return K}}class l{constructor(x,K,z){this._documents=x,this._commands=K,this._provider=z,this._cache=new m.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(x,K){const z=this._documents.getDocument(x),V=await this._provider.provideCodeLenses(z,K);if(!V||K.isCancellationRequested)return;const Y=this._cache.add(V),se=new f.DisposableStore;this._disposables.set(Y,se);const ye={cacheId:Y,lenses:[]};for(let Ue=0;Ue<V.length;Ue++)ye.lenses.push({cacheId:[Y,Ue],range:S.Range.from(V[Ue].range),command:this._commands.toInternal(V[Ue].command,se)});return ye}async resolveCodeLens(x,K){const z=x.cacheId&&this._cache.get(...x.cacheId);if(!z)return;let V;if(typeof this._provider.resolveCodeLens!="function"||z.isResolved?V=z:V=await this._provider.resolveCodeLens(z,K),V||(V=z),K.isCancellationRequested)return;const Y=x.cacheId&&this._disposables.get(x.cacheId[0]);if(!!Y)return x.command=this._commands.toInternal(V.command??l._badCmd,Y),x}releaseCodeLenses(x){this._disposables.get(x)?.dispose(),this._disposables.delete(x),this._cache.delete(x)}}l._badCmd={command:"missing",title:"!!MISSING: command!!"};function F(Ze){return Array.isArray(Ze)?Ze.map(S.DefinitionLink.from):Ze?[S.DefinitionLink.from(Ze)]:[]}class c{constructor(x,K){this._documents=x,this._provider=K}async provideDefinition(x,K,z){const V=this._documents.getDocument(x),Y=S.Position.to(K),se=await this._provider.provideDefinition(V,Y,z);return F(se)}}class n{constructor(x,K){this._documents=x,this._provider=K}async provideDeclaration(x,K,z){const V=this._documents.getDocument(x),Y=S.Position.to(K),se=await this._provider.provideDeclaration(V,Y,z);return F(se)}}class h{constructor(x,K){this._documents=x,this._provider=K}async provideImplementation(x,K,z){const V=this._documents.getDocument(x),Y=S.Position.to(K),se=await this._provider.provideImplementation(V,Y,z);return F(se)}}class g{constructor(x,K){this._documents=x,this._provider=K}async provideTypeDefinition(x,K,z){const V=this._documents.getDocument(x),Y=S.Position.to(K),se=await this._provider.provideTypeDefinition(V,Y,z);return F(se)}}class s{constructor(x,K){this._documents=x,this._provider=K}async provideHover(x,K,z){const V=this._documents.getDocument(x),Y=S.Position.to(K),se=await this._provider.provideHover(V,Y,z);if(!(!se||(0,T.isFalsyOrEmpty)(se.contents)))return se.range||(se.range=V.getWordRangeAtPosition(Y)),se.range||(se.range=new P.Range(Y,Y)),S.Hover.from(se)}}class d{constructor(x,K){this._documents=x,this._provider=K}async provideEvaluatableExpression(x,K,z){const V=this._documents.getDocument(x),Y=S.Position.to(K),se=await this._provider.provideEvaluatableExpression(V,Y,z);if(se)return S.EvaluatableExpression.from(se)}}class p{constructor(x,K){this._documents=x,this._provider=K}async provideInlineValues(x,K,z,V){const Y=this._documents.getDocument(x),se=await this._provider.provideInlineValues(Y,S.Range.to(K),S.InlineValueContext.to(z),V);if(Array.isArray(se))return se.map(ye=>S.InlineValue.from(ye))}}class w{constructor(x,K){this._documents=x,this._provider=K}async provideDocumentHighlights(x,K,z){const V=this._documents.getDocument(x),Y=S.Position.to(K),se=await this._provider.provideDocumentHighlights(V,Y,z);if(Array.isArray(se))return se.map(S.DocumentHighlight.from)}}class v{constructor(x,K){this._documents=x,this._provider=K}async provideLinkedEditingRanges(x,K,z){const V=this._documents.getDocument(x),Y=S.Position.to(K),se=await this._provider.provideLinkedEditingRanges(V,Y,z);if(se&&Array.isArray(se.ranges))return{ranges:(0,T.coalesce)(se.ranges.map(S.Range.from)),wordPattern:se.wordPattern}}}class k{constructor(x,K){this._documents=x,this._provider=K}async provideReferences(x,K,z,V){const Y=this._documents.getDocument(x),se=S.Position.to(K),ye=await this._provider.provideReferences(Y,se,z,V);if(Array.isArray(ye))return ye.map(S.location.from)}}class L{constructor(x,K,z,V,Y,se,ye){this._documents=x,this._commands=K,this._diagnostics=z,this._provider=V,this._logService=Y,this._extension=se,this._apiDeprecation=ye,this._cache=new m.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(x,K,z,V){const Y=this._documents.getDocument(x),se=b.Selection.isISelection(K)?S.Selection.to(K):S.Range.to(K),ye=[];for(const Je of this._diagnostics.getDiagnostics(x))if(se.intersection(Je.range)&&ye.push(Je)>L._maxCodeActionsPerFile)break;const Ue={diagnostics:ye,only:z.only?new P.CodeActionKind(z.only):void 0,triggerKind:S.CodeActionTriggerKind.to(z.trigger)},je=await this._provider.provideCodeActions(Y,se,Ue,V);if(!(0,T.isNonEmptyArray)(je)||V.isCancellationRequested)return;const Qe=this._cache.add(je),rt=new f.DisposableStore;this._disposables.set(Qe,rt);const ot=[];for(let Je=0;Je<je.length;Je++){const tt=je[Je];!tt||(L._isCommand(tt)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),ot.push({_isSynthetic:!0,title:tt.title,command:this._commands.toInternal(tt,rt)})):(Ue.only&&(tt.kind?Ue.only.contains(tt.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ue.only.value} 'requested but returned code action is of kind '${tt.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ue.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),ot.push({cacheId:[Qe,Je],title:tt.title,command:tt.command&&this._commands.toInternal(tt.command,rt),diagnostics:tt.diagnostics&&tt.diagnostics.map(S.Diagnostic.from),edit:tt.edit&&S.WorkspaceEdit.from(tt.edit),kind:tt.kind&&tt.kind.value,isPreferred:tt.isPreferred,disabled:tt.disabled?.reason})))}return{cacheId:Qe,actions:ot}}async resolveCodeAction(x,K){const[z,V]=x,Y=this._cache.get(z,V);if(!Y||L._isCommand(Y)||!this._provider.resolveCodeAction)return;const se=await this._provider.resolveCodeAction(Y,K)??Y;return se?.edit?S.WorkspaceEdit.from(se.edit):void 0}releaseCodeActions(x){this._disposables.get(x)?.dispose(),this._disposables.delete(x),this._cache.delete(x)}static _isCommand(x){return typeof x.command=="string"&&typeof x.title=="string"}}L._maxCodeActionsPerFile=1e3;class E{constructor(x,K){this._documents=x,this._provider=K}async provideDocumentFormattingEdits(x,K,z){const V=this._documents.getDocument(x),Y=await this._provider.provideDocumentFormattingEdits(V,K,z);if(Array.isArray(Y))return Y.map(S.TextEdit.from)}}class O{constructor(x,K){this._documents=x,this._provider=K}async provideDocumentRangeFormattingEdits(x,K,z,V){const Y=this._documents.getDocument(x),se=S.Range.to(K),ye=await this._provider.provideDocumentRangeFormattingEdits(Y,se,z,V);if(Array.isArray(ye))return ye.map(S.TextEdit.from)}}class U{constructor(x,K){this._documents=x,this._provider=K,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(x,K,z,V,Y){const se=this._documents.getDocument(x),ye=S.Position.to(K),Ue=await this._provider.provideOnTypeFormattingEdits(se,ye,z,V,Y);if(Array.isArray(Ue))return Ue.map(S.TextEdit.from)}}class j{constructor(x,K){this._provider=x,this._logService=K,this._cache=new m.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(x,K){const z=await this._provider.provideWorkspaceSymbols(x,K);if(!(0,T.isNonEmptyArray)(z))return{symbols:[]};const V=this._cache.add(z),Y={cacheId:V,symbols:[]};for(let se=0;se<z.length;se++){const ye=z[se];if(!ye||!ye.name){this._logService.warn("INVALID SymbolInformation",ye);continue}Y.symbols.push({...S.WorkspaceSymbol.from(ye),cacheId:[V,se]})}return Y}async resolveWorkspaceSymbol(x,K){if(typeof this._provider.resolveWorkspaceSymbol!="function"||!x.cacheId)return x;const z=this._cache.get(...x.cacheId);if(z){const V=await this._provider.resolveWorkspaceSymbol(z,K);return V&&(0,t.mixin)(x,S.WorkspaceSymbol.from(V),!0)}}releaseWorkspaceSymbols(x){this._cache.delete(x)}}class H{constructor(x,K,z){this._documents=x,this._provider=K,this._logService=z}static supportsResolving(x){return typeof x.prepareRename=="function"}async provideRenameEdits(x,K,z,V){const Y=this._documents.getDocument(x),se=S.Position.to(K);try{const ye=await this._provider.provideRenameEdits(Y,se,z,V);return ye?S.WorkspaceEdit.from(ye):void 0}catch(ye){const Ue=H._asMessage(ye);return Ue?{rejectReason:Ue,edits:void 0}:Promise.reject(ye)}}async resolveRenameLocation(x,K,z){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const V=this._documents.getDocument(x),Y=S.Position.to(K);try{const se=await this._provider.prepareRename(V,Y,z);let ye,Ue;if(P.Range.isRange(se)?(ye=se,Ue=V.getText(se)):(0,R.isObject)(se)&&(ye=se.range,Ue=se.placeholder),!ye||!Ue)return;if(ye.start.line>Y.line||ye.end.line<Y.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:S.Range.from(ye),text:Ue}}catch(se){const ye=H._asMessage(se);return ye?{rejectReason:ye,range:void 0,text:void 0}:Promise.reject(se)}}static _asMessage(x){return typeof x=="string"?x:x instanceof Error&&typeof x.message=="string"?x.message:void 0}}class ${constructor(x,K){this.resultId=x,this.tokens=K}}class G{constructor(x,K){this._documents=x,this._provider=K,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(x,K,z){const V=this._documents.getDocument(x),Y=K!==0?this._previousResults.get(K):null;let se=typeof Y?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(V,Y.resultId,z):await this._provider.provideDocumentSemanticTokens(V,z);return Y&&this._previousResults.delete(K),se?(se=G._fixProvidedSemanticTokens(se),this._send(G._convertToEdits(Y,se),se)):null}async releaseDocumentSemanticColoring(x){this._previousResults.delete(x)}static _fixProvidedSemanticTokens(x){return G._isSemanticTokens(x)?G._isCorrectSemanticTokens(x)?x:new P.SemanticTokens(new Uint32Array(x.data),x.resultId):G._isSemanticTokensEdits(x)?G._isCorrectSemanticTokensEdits(x)?x:new P.SemanticTokensEdits(x.edits.map(K=>new P.SemanticTokensEdit(K.start,K.deleteCount,K.data?new Uint32Array(K.data):K.data)),x.resultId):x}static _isSemanticTokens(x){return x&&!!x.data}static _isCorrectSemanticTokens(x){return x.data instanceof Uint32Array}static _isSemanticTokensEdits(x){return x&&Array.isArray(x.edits)}static _isCorrectSemanticTokensEdits(x){for(const K of x.edits)if(!(K.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(x,K){if(!G._isSemanticTokens(K)||!x||!x.tokens)return K;const z=x.tokens,V=z.length,Y=K.data,se=Y.length;let ye=0;const Ue=Math.min(V,se);for(;ye<Ue&&z[ye]===Y[ye];)ye++;if(ye===V&&ye===se)return new P.SemanticTokensEdits([],K.resultId);let je=0;const Qe=Ue-ye;for(;je<Qe&&z[V-je-1]===Y[se-je-1];)je++;return new P.SemanticTokensEdits([{start:ye,deleteCount:V-ye-je,data:Y.subarray(ye,se-je)}],K.resultId)}_send(x,K){if(G._isSemanticTokens(x)){const z=this._nextResultId++;return this._previousResults.set(z,new $(x.resultId,x.data)),(0,a.encodeSemanticTokensDto)({id:z,type:"full",data:x.data})}if(G._isSemanticTokensEdits(x)){const z=this._nextResultId++;return G._isSemanticTokens(K)?this._previousResults.set(z,new $(K.resultId,K.data)):this._previousResults.set(z,new $(x.resultId)),(0,a.encodeSemanticTokensDto)({id:z,type:"delta",deltas:(x.edits||[]).map(V=>({start:V.start,deleteCount:V.deleteCount,data:V.data}))})}return null}}e.DocumentSemanticTokensAdapter=G;class ie{constructor(x,K){this._documents=x,this._provider=K}async provideDocumentRangeSemanticTokens(x,K,z){const V=this._documents.getDocument(x),Y=await this._provider.provideDocumentRangeSemanticTokens(V,S.Range.to(K),z);return Y?this._send(Y):null}_send(x){return(0,a.encodeSemanticTokensDto)({id:0,type:"full",data:x.data})}}e.DocumentRangeSemanticTokensAdapter=ie;class le{constructor(x,K,z,V,Y){this._documents=x,this._commands=K,this._provider=z,this._apiDeprecation=V,this._extension=Y,this._cache=new m.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(x){return typeof x.resolveCompletionItem=="function"}async provideCompletionItems(x,K,z,V){const Y=this._documents.getDocument(x),se=S.Position.to(K),ye=Y.getWordRangeAtPosition(se)||new P.Range(se,se),Ue=ye.with({end:se}),je=new M.StopWatch(!0),Qe=await this._provider.provideCompletionItems(Y,se,V,S.CompletionContext.to(z));if(!Qe||V.isCancellationRequested)return;const rt=Array.isArray(Qe)?new P.CompletionList(Qe):Qe,ot=le.supportsResolving(this._provider)?this._cache.add(rt.items):this._cache.add([]),Je=new f.DisposableStore;this._disposables.set(ot,Je);const tt=[],pt={x:ot,b:tt,a:{replace:S.Range.from(ye),insert:S.Range.from(Ue)},c:rt.isIncomplete||void 0,d:je.elapsed()};for(let Me=0;Me<rt.items.length;Me++){const At=rt.items[Me],q=this._convertCompletionItem(At,[ot,Me],Ue,ye);tt.push(q)}return pt}async resolveCompletionItem(x,K){if(typeof this._provider.resolveCompletionItem!="function")return;const z=this._cache.get(...x);if(!z)return;const V=await this._provider.resolveCompletionItem(z,K);if(!!V)return this._convertCompletionItem(V,x)}releaseCompletionItems(x){this._disposables.get(x)?.dispose(),this._disposables.delete(x),this._cache.delete(x)}_convertCompletionItem(x,K,z,V){const Y=this._disposables.get(K[0]);if(!Y)throw Error("DisposableStore is missing...");const se={x:K,a:x.label,b:x.kind!==void 0?S.CompletionItemKind.from(x.kind):void 0,n:x.tags&&x.tags.map(S.CompletionItemTag.from),c:x.detail,d:typeof x.documentation=="undefined"?void 0:S.MarkdownString.fromStrict(x.documentation),e:x.sortText!==x.label?x.sortText:void 0,f:x.filterText!==x.label?x.filterText:void 0,g:x.preselect||void 0,i:x.keepWhitespace?1:0,k:x.commitCharacters,l:x.additionalTextEdits&&x.additionalTextEdits.map(S.TextEdit.from),m:this._commands.toInternal(x.command,Y)};x.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),se.h=x.textEdit.newText):typeof x.insertText=="string"?se.h=x.insertText:x.insertText instanceof P.SnippetString&&(se.h=x.insertText.value,se.i|=4);let ye;return x.textEdit?ye=x.textEdit.range:x.range&&(ye=x.range),P.Range.isRange(ye)?se.j=S.Range.from(ye):ye&&(!z?.isEqual(ye.inserting)||!V?.isEqual(ye.replacing))&&(se.j={insert:S.Range.from(ye.inserting),replace:S.Range.from(ye.replacing)}),se}}class X{constructor(x,K,z){this._documents=x,this._provider=K,this._commands=z,this._cache=new m.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(x,K,z,V){const Y=this._documents.getDocument(x),se=S.Position.to(K),ye=await this._provider.provideInlineCompletionItems(Y,se,{selectedCompletionInfo:z.selectedSuggestionInfo?{range:S.Range.to(z.selectedSuggestionInfo.range),text:z.selectedSuggestionInfo.text,isSnippetText:z.selectedSuggestionInfo.isSnippetText,completionKind:S.CompletionItemKind.to(z.selectedSuggestionInfo.completionKind)}:void 0,triggerKind:z.triggerKind},V);if(!ye||V.isCancellationRequested)return;const Ue=(0,R.isArray)(ye)?{items:ye}:ye,je=this._cache.add(Ue.items);let Qe;return{pid:je,items:Ue.items.map((rt,ot)=>{let Je;return rt.command&&(Qe||(Qe=new f.DisposableStore,this._disposables.set(je,Qe)),Je=this._commands.toInternal(rt.command,Qe)),{text:rt.text,range:rt.range?S.Range.from(rt.range):void 0,command:Je,idx:ot}})}}disposeCompletions(x){this._cache.delete(x);const K=this._disposables.get(x);K&&K.clear(),this._disposables.delete(x)}handleDidShowCompletionItem(x,K){const z=this._cache.get(x,K);z&&ue.get(this._provider).fireOnDidShowCompletionItem({completionItem:z})}}class ue{constructor(){this._onDidShowCompletionItemEmitter=new _.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(x){let K=ue.map.get(x);return K||(K=new ue,ue.map.set(x,K)),K}fireOnDidShowCompletionItem(x){this._onDidShowCompletionItemEmitter.fire(x)}}e.InlineCompletionController=ue,ue.map=new WeakMap;class ve{constructor(x,K){this._documents=x,this._provider=K,this._cache=new m.Cache("SignatureHelp")}async provideSignatureHelp(x,K,z,V){const Y=this._documents.getDocument(x),se=S.Position.to(K),ye=this.reviveContext(z),Ue=await this._provider.provideSignatureHelp(Y,se,V,ye);if(Ue){const je=this._cache.add([Ue]);return{...S.SignatureHelp.from(Ue),id:je}}}reviveContext(x){let K;if(x.activeSignatureHelp){const z=S.SignatureHelp.to(x.activeSignatureHelp),V=this._cache.get(x.activeSignatureHelp.id,0);V?(K=V,K.activeSignature=z.activeSignature,K.activeParameter=z.activeParameter):K=z}return{...x,activeSignatureHelp:K}}releaseSignatureHelp(x){this._cache.delete(x)}}class ge{constructor(x,K,z,V,Y){this._documents=x,this._commands=K,this._provider=z,this._logService=V,this._extension=Y,this._cache=new m.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(x,K,z){const V=this._documents.getDocument(x),Y=S.Range.to(K),se=await this._provider.provideInlayHints(V,Y,z);if(!Array.isArray(se)||se.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for ${K}`);return}if(z.isCancellationRequested)return;const ye=this._cache.add(se);this._disposables.set(ye,new f.DisposableStore);const Ue={hints:[],cacheId:ye};for(let je=0;je<se.length;je++)this._isValidInlayHint(se[je],Y)&&Ue.hints.push(this._convertInlayHint(se[je],[ye,je]));return this._logService.trace(`[InlayHints] ${Ue.hints.length} inlay hints from '${this._extension.identifier.value}' for ${K}`),Ue}async resolveInlayHint(x,K){if(typeof this._provider.resolveInlayHint!="function")return;const z=this._cache.get(...x);if(!z)return;const V=await this._provider.resolveInlayHint(z,K);if(!!V&&!!this._isValidInlayHint(V))return this._convertInlayHint(V,x)}releaseHints(x){this._disposables.get(x)?.dispose(),this._disposables.delete(x),this._cache.delete(x)}_isValidInlayHint(x,K){return x.label.length===0||Array.isArray(x.label)&&x.label.every(z=>z.label.length===0)?(console.log("INVALID inlay hint, empty label",x),!1):!(K&&!K.contains(x.position))}_convertInlayHint(x,K){const z=this._disposables.get(K[0]);if(!z)throw Error("DisposableStore is missing...");const V={label:"",cacheId:K,tooltip:x.tooltip&&S.MarkdownString.from(x.tooltip),position:S.Position.from(x.position),kind:S.InlayHintKind.from(x.kind??P.InlayHintKind.Other),paddingLeft:x.paddingLeft,paddingRight:x.paddingRight};return typeof x.label=="string"?V.label=x.label:V.label=x.label.map(Y=>{let se={label:Y.label};return se.tooltip=Y.tooltip&&S.MarkdownString.from(Y.tooltip),P.Location.isLocation(Y.location)?se.location=S.location.from(Y.location):Y.command&&(se.command=this._commands.toInternal(Y.command,z)),se}),V}}class we{constructor(x,K){this._documents=x,this._provider=K,this._cache=new m.Cache("DocumentLink")}async provideLinks(x,K){const z=this._documents.getDocument(x),V=await this._provider.provideDocumentLinks(z,K);if(!(!Array.isArray(V)||V.length===0)&&!K.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:V.filter(we._validateLink).map(S.DocumentLink.from)};{const Y=this._cache.add(V),se={links:[],cacheId:Y};for(let ye=0;ye<V.length;ye++){if(!we._validateLink(V[ye]))continue;const Ue=S.DocumentLink.from(V[ye]);Ue.cacheId=[Y,ye],se.links.push(Ue)}return se}}}static _validateLink(x){return x.target&&x.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(x,K){if(typeof this._provider.resolveDocumentLink!="function")return;const z=this._cache.get(...x);if(!z)return;const V=await this._provider.resolveDocumentLink(z,K);if(!(!V||!we._validateLink(V)))return S.DocumentLink.from(V)}releaseLinks(x){this._cache.delete(x)}}class re{constructor(x,K){this._documents=x,this._provider=K}async provideColors(x,K){const z=this._documents.getDocument(x),V=await this._provider.provideDocumentColors(z,K);return Array.isArray(V)?V.map(se=>({color:S.Color.from(se.color),range:S.Range.from(se.range)})):[]}async provideColorPresentations(x,K,z){const V=this._documents.getDocument(x),Y=S.Range.to(K.range),se=S.Color.to(K.color),ye=await this._provider.provideColorPresentations(se,{document:V,range:Y},z);if(!!Array.isArray(ye))return ye.map(S.ColorPresentation.from)}}class be{constructor(x,K){this._documents=x,this._provider=K}async provideFoldingRanges(x,K,z){const V=this._documents.getDocument(x),Y=await this._provider.provideFoldingRanges(V,K,z);if(!!Array.isArray(Y))return Y.map(S.FoldingRange.from)}}class Pe{constructor(x,K,z){this._documents=x,this._provider=K,this._logService=z}async provideSelectionRanges(x,K,z){const V=this._documents.getDocument(x),Y=K.map(S.Position.to),se=await this._provider.provideSelectionRanges(V,Y,z);if(!(0,T.isNonEmptyArray)(se))return[];if(se.length!==Y.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const ye=[];for(let Ue=0;Ue<Y.length;Ue++){const je=[];ye.push(je);let Qe=Y[Ue],rt=se[Ue];for(;;){if(!rt.range.contains(Qe))throw new Error("INVALID selection range, must contain the previous range");if(je.push(S.SelectionRange.from(rt)),!rt.parent)break;Qe=rt.range,rt=rt.parent}}return ye}}class Fe{constructor(x,K){this._documents=x,this._provider=K,this._idPool=new o.IdGenerator(""),this._cache=new Map}async prepareSession(x,K,z){const V=this._documents.getDocument(x),Y=S.Position.to(K),se=await this._provider.prepareCallHierarchy(V,Y,z);if(!se)return;const ye=this._idPool.nextId();return this._cache.set(ye,new Map),Array.isArray(se)?se.map(Ue=>this._cacheAndConvertItem(ye,Ue)):[this._cacheAndConvertItem(ye,se)]}async provideCallsTo(x,K,z){const V=this._itemFromCache(x,K);if(!V)throw new Error("missing call hierarchy item");const Y=await this._provider.provideCallHierarchyIncomingCalls(V,z);if(!!Y)return Y.map(se=>({from:this._cacheAndConvertItem(x,se.from),fromRanges:se.fromRanges.map(ye=>S.Range.from(ye))}))}async provideCallsFrom(x,K,z){const V=this._itemFromCache(x,K);if(!V)throw new Error("missing call hierarchy item");const Y=await this._provider.provideCallHierarchyOutgoingCalls(V,z);if(!!Y)return Y.map(se=>({to:this._cacheAndConvertItem(x,se.to),fromRanges:se.fromRanges.map(ye=>S.Range.from(ye))}))}releaseSession(x){this._cache.delete(x)}_cacheAndConvertItem(x,K){const z=this._cache.get(x),V=S.CallHierarchyItem.from(K,x,z.size.toString(36));return z.set(V._itemId,K),V}_itemFromCache(x,K){return this._cache.get(x)?.get(K)}}class ze{constructor(x,K){this._documents=x,this._provider=K,this._idPool=new o.IdGenerator(""),this._cache=new Map}async prepareSession(x,K,z){const V=this._documents.getDocument(x),Y=S.Position.to(K),se=await this._provider.prepareTypeHierarchy(V,Y,z);if(!se)return;const ye=this._idPool.nextId();return this._cache.set(ye,new Map),Array.isArray(se)?se.map(Ue=>this._cacheAndConvertItem(ye,Ue)):[this._cacheAndConvertItem(ye,se)]}async provideSupertypes(x,K,z){const V=this._itemFromCache(x,K);if(!V)throw new Error("missing type hierarchy item");const Y=await this._provider.provideTypeHierarchySupertypes(V,z);if(!!Y)return Y.map(se=>this._cacheAndConvertItem(x,se))}async provideSubtypes(x,K,z){const V=this._itemFromCache(x,K);if(!V)throw new Error("missing type hierarchy item");const Y=await this._provider.provideTypeHierarchySubtypes(V,z);if(!!Y)return Y.map(se=>this._cacheAndConvertItem(x,se))}releaseSession(x){this._cache.delete(x)}_cacheAndConvertItem(x,K){const z=this._cache.get(x),V=S.TypeHierarchyItem.from(K,x,z.size.toString(36));return z.set(V._itemId,K),V}_itemFromCache(x,K){return this._cache.get(x)?.get(K)}}class nt{constructor(x,K){this.adapter=x,this.extension=K}}class et{constructor(x,K,z,V,Y,se,ye){this._adapter=new Map,this._uriTransformer=K,this._proxy=x.getProxy(A.MainContext.MainThreadLanguageFeatures),this._documents=z,this._commands=V,this._diagnostics=Y,this._logService=se,this._apiDeprecation=ye}_transformDocumentSelector(x){return S.DocumentSelector.from(x,this._uriTransformer)}_createDisposable(x){return new P.Disposable(()=>{this._adapter.delete(x),this._proxy.$unregister(x)})}_nextHandle(){return et._handlePool++}async _withAdapter(x,K,z,V,Y){const se=this._adapter.get(x);if(!se||!(se.adapter instanceof K))return V;const ye=Date.now();this._logService.trace(`[${se.extension.identifier.value}] INVOKE provider '${z.toString().replace(/[\r\n]/g,"")}'`);const Ue=z(se.adapter,se.extension);return Promise.resolve(Ue).catch(je=>{(0,y.isCancellationError)(je)||(this._logService.error(`[${se.extension.identifier.value}] provider FAILED`),this._logService.error(je))}).finally(()=>{this._logService.trace(`[${se.extension.identifier.value}] provider DONE after ${Date.now()-ye}ms`)}),i.CancellationToken.isCancellationToken(Y)?(0,u.raceCancellationError)(Ue,Y):Ue}_addNewAdapter(x,K){const z=this._nextHandle();return this._adapter.set(z,new nt(x,K)),z}static _extLabel(x){return x.displayName||x.name}registerDocumentSymbolProvider(x,K,z,V){const Y=this._addNewAdapter(new C(this._documents,z),x),se=V&&V.label||et._extLabel(x);return this._proxy.$registerDocumentSymbolProvider(Y,this._transformDocumentSelector(K),se),this._createDisposable(Y)}$provideDocumentSymbols(x,K,z){return this._withAdapter(x,C,V=>V.provideDocumentSymbols(r.URI.revive(K),z),void 0,z)}registerCodeLensProvider(x,K,z){const V=this._nextHandle(),Y=typeof z.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(V,new nt(new l(this._documents,this._commands.converter,z),x)),this._proxy.$registerCodeLensSupport(V,this._transformDocumentSelector(K),Y);let se=this._createDisposable(V);if(Y!==void 0){const ye=z.onDidChangeCodeLenses(Ue=>this._proxy.$emitCodeLensEvent(Y));se=P.Disposable.from(se,ye)}return se}$provideCodeLenses(x,K,z){return this._withAdapter(x,l,V=>V.provideCodeLenses(r.URI.revive(K),z),void 0,void 0)}$resolveCodeLens(x,K,z){return this._withAdapter(x,l,V=>V.resolveCodeLens(K,z),void 0,void 0)}$releaseCodeLenses(x,K){this._withAdapter(x,l,z=>Promise.resolve(z.releaseCodeLenses(K)),void 0,void 0)}registerDefinitionProvider(x,K,z){const V=this._addNewAdapter(new c(this._documents,z),x);return this._proxy.$registerDefinitionSupport(V,this._transformDocumentSelector(K)),this._createDisposable(V)}$provideDefinition(x,K,z,V){return this._withAdapter(x,c,Y=>Y.provideDefinition(r.URI.revive(K),z,V),[],V)}registerDeclarationProvider(x,K,z){const V=this._addNewAdapter(new n(this._documents,z),x);return this._proxy.$registerDeclarationSupport(V,this._transformDocumentSelector(K)),this._createDisposable(V)}$provideDeclaration(x,K,z,V){return this._withAdapter(x,n,Y=>Y.provideDeclaration(r.URI.revive(K),z,V),[],V)}registerImplementationProvider(x,K,z){const V=this._addNewAdapter(new h(this._documents,z),x);return this._proxy.$registerImplementationSupport(V,this._transformDocumentSelector(K)),this._createDisposable(V)}$provideImplementation(x,K,z,V){return this._withAdapter(x,h,Y=>Y.provideImplementation(r.URI.revive(K),z,V),[],V)}registerTypeDefinitionProvider(x,K,z){const V=this._addNewAdapter(new g(this._documents,z),x);return this._proxy.$registerTypeDefinitionSupport(V,this._transformDocumentSelector(K)),this._createDisposable(V)}$provideTypeDefinition(x,K,z,V){return this._withAdapter(x,g,Y=>Y.provideTypeDefinition(r.URI.revive(K),z,V),[],V)}registerHoverProvider(x,K,z,V){const Y=this._addNewAdapter(new s(this._documents,z),x);return this._proxy.$registerHoverProvider(Y,this._transformDocumentSelector(K)),this._createDisposable(Y)}$provideHover(x,K,z,V){return this._withAdapter(x,s,Y=>Y.provideHover(r.URI.revive(K),z,V),void 0,void 0)}registerEvaluatableExpressionProvider(x,K,z,V){const Y=this._addNewAdapter(new d(this._documents,z),x);return this._proxy.$registerEvaluatableExpressionProvider(Y,this._transformDocumentSelector(K)),this._createDisposable(Y)}$provideEvaluatableExpression(x,K,z,V){return this._withAdapter(x,d,Y=>Y.provideEvaluatableExpression(r.URI.revive(K),z,V),void 0,void 0)}registerInlineValuesProvider(x,K,z,V){const Y=typeof z.onDidChangeInlineValues=="function"?this._nextHandle():void 0,se=this._addNewAdapter(new p(this._documents,z),x);this._proxy.$registerInlineValuesProvider(se,this._transformDocumentSelector(K),Y);let ye=this._createDisposable(se);if(Y!==void 0){const Ue=z.onDidChangeInlineValues(je=>this._proxy.$emitInlineValuesEvent(Y));ye=P.Disposable.from(ye,Ue)}return ye}$provideInlineValues(x,K,z,V,Y){return this._withAdapter(x,p,se=>se.provideInlineValues(r.URI.revive(K),z,V,Y),void 0,void 0)}registerDocumentHighlightProvider(x,K,z){const V=this._addNewAdapter(new w(this._documents,z),x);return this._proxy.$registerDocumentHighlightProvider(V,this._transformDocumentSelector(K)),this._createDisposable(V)}$provideDocumentHighlights(x,K,z,V){return this._withAdapter(x,w,Y=>Y.provideDocumentHighlights(r.URI.revive(K),z,V),void 0,void 0)}registerLinkedEditingRangeProvider(x,K,z){const V=this._addNewAdapter(new v(this._documents,z),x);return this._proxy.$registerLinkedEditingRangeProvider(V,this._transformDocumentSelector(K)),this._createDisposable(V)}$provideLinkedEditingRanges(x,K,z,V){return this._withAdapter(x,v,async Y=>{const se=await Y.provideLinkedEditingRanges(r.URI.revive(K),z,V);if(se)return{ranges:se.ranges,wordPattern:se.wordPattern?et._serializeRegExp(se.wordPattern):void 0}},void 0,void 0)}registerReferenceProvider(x,K,z){const V=this._addNewAdapter(new k(this._documents,z),x);return this._proxy.$registerReferenceSupport(V,this._transformDocumentSelector(K)),this._createDisposable(V)}$provideReferences(x,K,z,V,Y){return this._withAdapter(x,k,se=>se.provideReferences(r.URI.revive(K),z,V,Y),void 0,Y)}registerCodeActionProvider(x,K,z,V){const Y=new f.DisposableStore,se=this._addNewAdapter(new L(this._documents,this._commands.converter,this._diagnostics,z,this._logService,x,this._apiDeprecation),x);return this._proxy.$registerQuickFixSupport(se,this._transformDocumentSelector(K),{providedKinds:V?.providedCodeActionKinds?.map(ye=>ye.value),documentation:V?.documentation?.map(ye=>({kind:ye.kind.value,command:this._commands.converter.toInternal(ye.command,Y)}))},et._extLabel(x),Boolean(z.resolveCodeAction)),Y.add(this._createDisposable(se)),Y}$provideCodeActions(x,K,z,V,Y){return this._withAdapter(x,L,se=>se.provideCodeActions(r.URI.revive(K),z,V,Y),void 0,void 0)}$resolveCodeAction(x,K,z){return this._withAdapter(x,L,V=>V.resolveCodeAction(K,z),void 0,void 0)}$releaseCodeActions(x,K){this._withAdapter(x,L,z=>Promise.resolve(z.releaseCodeActions(K)),void 0,void 0)}registerDocumentFormattingEditProvider(x,K,z){const V=this._addNewAdapter(new E(this._documents,z),x);return this._proxy.$registerDocumentFormattingSupport(V,this._transformDocumentSelector(K),x.identifier,x.displayName||x.name),this._createDisposable(V)}$provideDocumentFormattingEdits(x,K,z,V){return this._withAdapter(x,E,Y=>Y.provideDocumentFormattingEdits(r.URI.revive(K),z,V),void 0,void 0)}registerDocumentRangeFormattingEditProvider(x,K,z){const V=this._addNewAdapter(new O(this._documents,z),x);return this._proxy.$registerRangeFormattingSupport(V,this._transformDocumentSelector(K),x.identifier,x.displayName||x.name),this._createDisposable(V)}$provideDocumentRangeFormattingEdits(x,K,z,V,Y){return this._withAdapter(x,O,se=>se.provideDocumentRangeFormattingEdits(r.URI.revive(K),z,V,Y),void 0,void 0)}registerOnTypeFormattingEditProvider(x,K,z,V){const Y=this._addNewAdapter(new U(this._documents,z),x);return this._proxy.$registerOnTypeFormattingSupport(Y,this._transformDocumentSelector(K),V,x.identifier),this._createDisposable(Y)}$provideOnTypeFormattingEdits(x,K,z,V,Y,se){return this._withAdapter(x,U,ye=>ye.provideOnTypeFormattingEdits(r.URI.revive(K),z,V,Y,se),void 0,void 0)}registerWorkspaceSymbolProvider(x,K){const z=this._addNewAdapter(new j(K,this._logService),x);return this._proxy.$registerNavigateTypeSupport(z,typeof K.resolveWorkspaceSymbol=="function"),this._createDisposable(z)}$provideWorkspaceSymbols(x,K,z){return this._withAdapter(x,j,V=>V.provideWorkspaceSymbols(K,z),{symbols:[]},z)}$resolveWorkspaceSymbol(x,K,z){return this._withAdapter(x,j,V=>V.resolveWorkspaceSymbol(K,z),void 0,void 0)}$releaseWorkspaceSymbols(x,K){this._withAdapter(x,j,z=>z.releaseWorkspaceSymbols(K),void 0,void 0)}registerRenameProvider(x,K,z){const V=this._addNewAdapter(new H(this._documents,z,this._logService),x);return this._proxy.$registerRenameSupport(V,this._transformDocumentSelector(K),H.supportsResolving(z)),this._createDisposable(V)}$provideRenameEdits(x,K,z,V,Y){return this._withAdapter(x,H,se=>se.provideRenameEdits(r.URI.revive(K),z,V,Y),void 0,void 0)}$resolveRenameLocation(x,K,z,V){return this._withAdapter(x,H,Y=>Y.resolveRenameLocation(r.URI.revive(K),z,V),void 0,void 0)}registerDocumentSemanticTokensProvider(x,K,z,V){const Y=this._addNewAdapter(new G(this._documents,z),x),se=typeof z.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(Y,this._transformDocumentSelector(K),V,se);let ye=this._createDisposable(Y);if(se){const Ue=z.onDidChangeSemanticTokens(je=>this._proxy.$emitDocumentSemanticTokensEvent(se));ye=P.Disposable.from(ye,Ue)}return ye}$provideDocumentSemanticTokens(x,K,z,V){return this._withAdapter(x,G,Y=>Y.provideDocumentSemanticTokens(r.URI.revive(K),z,V),null,void 0)}$releaseDocumentSemanticTokens(x,K){this._withAdapter(x,G,z=>z.releaseDocumentSemanticColoring(K),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(x,K,z,V){const Y=this._addNewAdapter(new ie(this._documents,z),x);return this._proxy.$registerDocumentRangeSemanticTokensProvider(Y,this._transformDocumentSelector(K),V),this._createDisposable(Y)}$provideDocumentRangeSemanticTokens(x,K,z,V){return this._withAdapter(x,ie,Y=>Y.provideDocumentRangeSemanticTokens(r.URI.revive(K),z,V),null,void 0)}registerCompletionItemProvider(x,K,z,V){const Y=this._addNewAdapter(new le(this._documents,this._commands.converter,z,this._apiDeprecation,x),x);return this._proxy.$registerSuggestSupport(Y,this._transformDocumentSelector(K),V,le.supportsResolving(z),`${x.identifier.value}(${V.join("")})`),this._createDisposable(Y)}$provideCompletionItems(x,K,z,V,Y){return this._withAdapter(x,le,se=>se.provideCompletionItems(r.URI.revive(K),z,V,Y),void 0,Y)}$resolveCompletionItem(x,K,z){return this._withAdapter(x,le,V=>V.resolveCompletionItem(K,z),void 0,z)}$releaseCompletionItems(x,K){this._withAdapter(x,le,z=>z.releaseCompletionItems(K),void 0,void 0)}registerInlineCompletionsProvider(x,K,z){const V=this._addNewAdapter(new X(this._documents,z,this._commands.converter),x);return this._proxy.$registerInlineCompletionsSupport(V,this._transformDocumentSelector(K)),this._createDisposable(V)}$provideInlineCompletions(x,K,z,V,Y){return this._withAdapter(x,X,se=>se.provideInlineCompletions(r.URI.revive(K),z,V,Y),void 0,void 0)}$handleInlineCompletionDidShow(x,K,z){this._withAdapter(x,X,async V=>{V.handleDidShowCompletionItem(K,z)},void 0,void 0)}$freeInlineCompletionsList(x,K){this._withAdapter(x,X,async z=>{z.disposeCompletions(K)},void 0,void 0)}registerSignatureHelpProvider(x,K,z,V){const Y=Array.isArray(V)?{triggerCharacters:V,retriggerCharacters:[]}:V,se=this._addNewAdapter(new ve(this._documents,z),x);return this._proxy.$registerSignatureHelpProvider(se,this._transformDocumentSelector(K),Y),this._createDisposable(se)}$provideSignatureHelp(x,K,z,V,Y){return this._withAdapter(x,ve,se=>se.provideSignatureHelp(r.URI.revive(K),z,V,Y),void 0,void 0)}$releaseSignatureHelp(x,K){this._withAdapter(x,ve,z=>z.releaseSignatureHelp(K),void 0,void 0)}registerInlayHintsProvider(x,K,z){const V=typeof z.onDidChangeInlayHints=="function"?this._nextHandle():void 0,Y=this._addNewAdapter(new ge(this._documents,this._commands.converter,z,this._logService,x),x);this._proxy.$registerInlayHintsProvider(Y,this._transformDocumentSelector(K),typeof z.resolveInlayHint=="function",V);let se=this._createDisposable(Y);if(V!==void 0){const ye=z.onDidChangeInlayHints(Ue=>this._proxy.$emitInlayHintsEvent(V));se=P.Disposable.from(se,ye)}return se}$provideInlayHints(x,K,z,V){return this._withAdapter(x,ge,Y=>Y.provideInlayHints(r.URI.revive(K),z,V),void 0,V)}$resolveInlayHint(x,K,z){return this._withAdapter(x,ge,V=>V.resolveInlayHint(K,z),void 0,z)}$releaseInlayHints(x,K){this._withAdapter(x,ge,z=>z.releaseHints(K),void 0,void 0)}registerDocumentLinkProvider(x,K,z){const V=this._addNewAdapter(new we(this._documents,z),x);return this._proxy.$registerDocumentLinkProvider(V,this._transformDocumentSelector(K),typeof z.resolveDocumentLink=="function"),this._createDisposable(V)}$provideDocumentLinks(x,K,z){return this._withAdapter(x,we,V=>V.provideLinks(r.URI.revive(K),z),void 0,void 0)}$resolveDocumentLink(x,K,z){return this._withAdapter(x,we,V=>V.resolveLink(K,z),void 0,void 0)}$releaseDocumentLinks(x,K){this._withAdapter(x,we,z=>z.releaseLinks(K),void 0,void 0)}registerColorProvider(x,K,z){const V=this._addNewAdapter(new re(this._documents,z),x);return this._proxy.$registerDocumentColorProvider(V,this._transformDocumentSelector(K)),this._createDisposable(V)}$provideDocumentColors(x,K,z){return this._withAdapter(x,re,V=>V.provideColors(r.URI.revive(K),z),[],void 0)}$provideColorPresentations(x,K,z,V){return this._withAdapter(x,re,Y=>Y.provideColorPresentations(r.URI.revive(K),z,V),void 0,void 0)}registerFoldingRangeProvider(x,K,z){const V=this._nextHandle(),Y=typeof z.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(V,new nt(new be(this._documents,z),x)),this._proxy.$registerFoldingRangeProvider(V,this._transformDocumentSelector(K),Y);let se=this._createDisposable(V);if(Y!==void 0){const ye=z.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(Y));se=P.Disposable.from(se,ye)}return se}$provideFoldingRanges(x,K,z,V){return this._withAdapter(x,be,Y=>Y.provideFoldingRanges(r.URI.revive(K),z,V),void 0,void 0)}registerSelectionRangeProvider(x,K,z){const V=this._addNewAdapter(new Pe(this._documents,z,this._logService),x);return this._proxy.$registerSelectionRangeProvider(V,this._transformDocumentSelector(K)),this._createDisposable(V)}$provideSelectionRanges(x,K,z,V){return this._withAdapter(x,Pe,Y=>Y.provideSelectionRanges(r.URI.revive(K),z,V),[],V)}registerCallHierarchyProvider(x,K,z){const V=this._addNewAdapter(new Fe(this._documents,z),x);return this._proxy.$registerCallHierarchyProvider(V,this._transformDocumentSelector(K)),this._createDisposable(V)}$prepareCallHierarchy(x,K,z,V){return this._withAdapter(x,Fe,Y=>Promise.resolve(Y.prepareSession(r.URI.revive(K),z,V)),void 0,V)}$provideCallHierarchyIncomingCalls(x,K,z,V){return this._withAdapter(x,Fe,Y=>Y.provideCallsTo(K,z,V),void 0,V)}$provideCallHierarchyOutgoingCalls(x,K,z,V){return this._withAdapter(x,Fe,Y=>Y.provideCallsFrom(K,z,V),void 0,V)}$releaseCallHierarchy(x,K){this._withAdapter(x,Fe,z=>Promise.resolve(z.releaseSession(K)),void 0,void 0)}registerTypeHierarchyProvider(x,K,z){const V=this._addNewAdapter(new ze(this._documents,z),x);return this._proxy.$registerTypeHierarchyProvider(V,this._transformDocumentSelector(K)),this._createDisposable(V)}$prepareTypeHierarchy(x,K,z,V){return this._withAdapter(x,ze,Y=>Promise.resolve(Y.prepareSession(r.URI.revive(K),z,V)),void 0,V)}$provideTypeHierarchySupertypes(x,K,z,V){return this._withAdapter(x,ze,Y=>Y.provideSupertypes(K,z,V),void 0,V)}$provideTypeHierarchySubtypes(x,K,z,V){return this._withAdapter(x,ze,Y=>Y.provideSubtypes(K,z,V),void 0,V)}$releaseTypeHierarchy(x,K){this._withAdapter(x,ze,z=>Promise.resolve(z.releaseSession(K)),void 0,void 0)}static _serializeRegExp(x){return{pattern:x.source,flags:(0,I.regExpFlags)(x)}}static _serializeIndentationRule(x){return{decreaseIndentPattern:et._serializeRegExp(x.decreaseIndentPattern),increaseIndentPattern:et._serializeRegExp(x.increaseIndentPattern),indentNextLinePattern:x.indentNextLinePattern?et._serializeRegExp(x.indentNextLinePattern):void 0,unIndentedLinePattern:x.unIndentedLinePattern?et._serializeRegExp(x.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(x){return{beforeText:et._serializeRegExp(x.beforeText),afterText:x.afterText?et._serializeRegExp(x.afterText):void 0,previousLineText:x.previousLineText?et._serializeRegExp(x.previousLineText):void 0,action:x.action}}static _serializeOnEnterRules(x){return x.map(et._serializeOnEnterRule)}setLanguageConfiguration(x,K,z){let{wordPattern:V}=z;if(V&&(0,I.regExpLeadsToEndlessLoop)(V))throw new Error(`Invalid language configuration: wordPattern '${V}' is not allowed to match the empty string.`);V?this._documents.setWordDefinitionFor(K,V):this._documents.setWordDefinitionFor(K,void 0),z.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",x,"Do not use."),z.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",x,"Do not use.");const Y=this._nextHandle(),se={comments:z.comments,brackets:z.brackets,wordPattern:z.wordPattern?et._serializeRegExp(z.wordPattern):void 0,indentationRules:z.indentationRules?et._serializeIndentationRule(z.indentationRules):void 0,onEnterRules:z.onEnterRules?et._serializeOnEnterRules(z.onEnterRules):void 0,__electricCharacterSupport:z.__electricCharacterSupport,__characterPairSupport:z.__characterPairSupport};return this._proxy.$setLanguageConfiguration(Y,K,se),this._createDisposable(Y)}$setWordDefinitions(x){for(const K of x)this._documents.setWordDefinitionFor(K.languageId,new RegExp(K.regexSource,K.regexFlags))}}e.ExtHostLanguageFeatures=et,et._handlePool=0}),define(Se[189],_e([0,1,5,8,7,34,10,6]),function(ee,e,r,t,S,P,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class D{constructor(R,b,i,f){this._documents=b,this._commands=i,this._uriTransformer=f,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=R.getProxy(r.MainContext.MainThreadLanguages)}$acceptLanguageIds(R){this._languageIds=R}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(R,b){await this._proxy.$changeLanguage(R,b);const i=this._documents.getDocumentData(R);if(!i)throw new Error(`document '${R.toString}' NOT found`);return i.document}async tokenAtPosition(R,b){const i=R.version,f=t.Position.from(b),a=await this._proxy.$tokensAtPosition(R.uri,f),o={type:S.StandardTokenType.Other,range:R.getWordRangeAtPosition(b)??new S.Range(b.line,b.character,b.line,b.character)};if(!a)return o;const m={range:t.Range.to(a.range),type:t.TokenType.to(a.type)};return!m.range.contains(b)||i!==R.version?o:m}createLanguageStatusItem(R,b,i){const f=this._handlePool++,a=this._proxy,o=this._ids,m=`${R.identifier.value}/${b}`;if(o.has(m))throw new Error(`LanguageStatusItem with id '${b}' ALREADY exists`);o.add(m);const M={selector:i,id:b,name:R.displayName??R.name,severity:S.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let y,_=new I.DisposableStore;const u=()=>{y?.dispose(),y=(0,A.disposableTimeout)(()=>{_.clear(),this._proxy.$setLanguageStatus(f,{id:m,name:M.name??R.displayName??R.name,source:R.displayName??R.name,selector:t.DocumentSelector.from(M.selector,this._uriTransformer),label:M.text,detail:M.detail??"",severity:M.severity===S.LanguageStatusSeverity.Error?P.default.Error:M.severity===S.LanguageStatusSeverity.Warning?P.default.Warning:P.default.Info,command:M.command&&this._commands.toInternal(M.command,_),accessibilityInfo:M.accessibilityInformation,busy:M.busy})},0)},C={dispose(){_.dispose(),y?.dispose(),a.$removeLanguageStatus(f),o.delete(m)},get id(){return M.id},get name(){return M.name},set name(l){M.name=l,u()},get selector(){return M.selector},set selector(l){M.selector=l,u()},get text(){return M.text},set text(l){M.text=l,u()},get detail(){return M.detail},set detail(l){M.detail=l,u()},get severity(){return M.severity},set severity(l){M.severity=l,u()},get accessibilityInformation(){return M.accessibilityInformation},set accessibilityInformation(l){M.accessibilityInformation=l,u()},get command(){return M.command},set command(l){M.command=l,u()},get busy(){return M.busy},set busy(l){M.busy=l,u()}};return u(),C}}e.ExtHostLanguages=D}),define(Se[190],_e([0,1,12,5,28,14,4]),function(ee,e,r,t,S,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let I=class extends r.AbstractLoggerService{constructor(R,b){const i=new A.Emitter;super(b.logLevel,i.event);this._proxy=R.getProxy(t.MainContext.MainThreadLogger),this._onDidChangeLogLevel=this._register(i)}$setLevel(R){this._onDidChangeLogLevel.fire(R)}doCreateLogger(R,b,i){return new D(this._proxy,R,b,i)}};I=xe([$e(0,P.IExtHostRpcService),$e(1,S.IExtHostInitDataService)],I),e.ExtHostLoggerService=I;class D extends r.AbstractMessageLogger{constructor(R,b,i,f){super(f?.always);this.proxy=R,this.file=b,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(i),this.proxy.$createLogger(b,f).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(R,b){const i=[[R,b]];this.isLoggerCreated?this.doLog(i):this.buffer.push(...i)}doLog(R){this.proxy.$log(this.file,R)}}}),define(Se[191],_e([0,1,5,12,26]),function(ee,e,r,t,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function P(I){return I&&I.title}let A=class{constructor(D,T){this._logService=T,this._proxy=D.getProxy(r.MainContext.MainThreadMessageService)}showMessage(D,T,R,b,i){const f={source:{identifier:D.identifier,label:D.displayName||D.name}};let a;typeof b=="string"||P(b)?a=[b,...i]:(f.modal=b?.modal,f.useCustom=b?.useCustom,f.detail=b?.detail,a=i),f.useCustom&&(0,S.checkProposedApiEnabled)(D,"resolvers");const o=[];for(let m=0;m<a.length;m++){const M=a[m];if(typeof M=="string")o.push({title:M,handle:m,isCloseAffordance:!1});else if(typeof M=="object"){let{title:y,isCloseAffordance:_}=M;o.push({title:y,isCloseAffordance:!!_,handle:m})}else this._logService.warn("Invalid message item:",M)}return this._proxy.$showMessage(T,R,f,o).then(m=>{if(typeof m=="number")return a[m]})}};A=xe([$e(1,t.ILogService)],A),e.ExtHostMessageService=A}),define(Se[192],_e([0,1,21,4,92,6,22,9,13,2,62,5,8,7,38,165,89]),function(ee,e,r,t,S,P,A,I,D,T,R,b,i,f,a,o,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class M{constructor(_,u,C,l,F){this._textDocumentsAndEditors=C,this._textDocuments=l,this._extensionStoragePaths=F,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new A.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new t.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new t.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new t.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new t.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new t.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new t.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new t.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new R.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=_.getProxy(b.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=_.getProxy(b.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=_.getProxy(b.MainContext.MainThreadNotebookEditors),this._commandsConverter=u.converter,u.registerArgumentProcessor({processArgument:c=>{if(c&&c.$mid===12){const n=c.notebookEditor?.notebookUri,h=c.cell.handle,s=this._documents.get(n)?.getCell(h);if(s)return s.apiCell}return c}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(_=>_.apiEditor)}getEditorById(_){const u=this._editors.get(_);if(!u)throw new Error(`unknown text editor: ${_}. known editors: ${[...this._editors.keys()]} `);return u}getIdByEditor(_){for(const[u,C]of this._editors)if(C.apiEditor===_)return u}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(_,u){const C=this._documents.get(_);if(!C&&!u)throw new Error(`NO notebook document for '${_}'`);return C}_getProviderData(_){const u=this._notebookContentProviders.get(_);if(!u)throw new Error(`NO provider for '${_}'`);return u}registerNotebookContentProvider(_,u,C,l,F){if((0,I.isFalsyOrWhitespace)(u))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(u))throw new Error(`Notebook provider for '${u}' already registered`);this._notebookContentProviders.set(u,{extension:_,provider:C});let c;return C.onDidChangeNotebookContentOptions&&(c=C.onDidChangeNotebookContentOptions(()=>{const n=i.NotebookDocumentContentOptions.from(C.options);this._notebookProxy.$updateNotebookProviderOptions(u,n)})),this._notebookProxy.$registerNotebookProvider({id:_.identifier,location:_.extensionLocation},u,i.NotebookDocumentContentOptions.from(l),M._convertNotebookRegistrationData(_,F)),new f.Disposable(()=>{c?.dispose(),this._notebookContentProviders.delete(u),this._notebookProxy.$unregisterNotebookProvider(u)})}static _convertNotebookRegistrationData(_,u){if(!u)return;const C=u.filenamePattern.map(l=>i.NotebookExclusiveDocumentPattern.from(l)).filter(l=>l!==void 0);if(u.filenamePattern&&!C){console.warn(`Notebook content provider view options file name pattern is invalid ${u.filenamePattern}`);return}return{extension:_.identifier,providerDisplayName:_.displayName||_.name,displayName:u.displayName,filenamePattern:C,exclusive:u.exclusive||!1}}registerNotebookCellStatusBarItemProvider(_,u,C){const l=M._notebookStatusBarItemProviderHandlePool++,F=typeof C.onDidChangeCellStatusBarItems=="function"?M._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(l,C),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(l,F,u);let c;return F!==void 0&&(c=C.onDidChangeCellStatusBarItems(n=>this._notebookProxy.$emitCellStatusBarEvent(F))),new f.Disposable(()=>{this._notebookStatusBarItemProviders.delete(l),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(l,F),c&&c.dispose()})}async createNotebookDocument(_){const u=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:_.viewType,content:_.content&&i.NotebookData.from(_.content)});return T.URI.revive(u)}async openNotebookDocument(_){const u=this._documents.get(_);if(u)return u.apiNotebook;const C=await this._notebookDocumentsProxy.$tryOpenNotebook(_),l=this._documents.get(T.URI.revive(C));return(0,D.assertIsDefined)(l?.apiNotebook)}async showNotebookDocument(_,u){T.URI.isUri(_)&&(_=await this.openNotebookDocument(_));let C;typeof u=="object"?C={position:i.ViewColumn.from(u.viewColumn),preserveFocus:u.preserveFocus,selections:u.selections&&u.selections.map(i.NotebookRange.from),pinned:typeof u.preview=="boolean"?!u.preview:void 0}:C={preserveFocus:!1};const l=await this._notebookEditorsProxy.$tryShowNotebookDocument(_.uri,_.notebookType,C),F=l&&this._editors.get(l)?.apiEditor;if(F)return F;throw l?new Error(`Could NOT open editor for "${_.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${_.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(_,u,C,l){const F=this._notebookStatusBarItemProviders.get(_),c=T.URI.revive(u),n=this._documents.get(c);if(!n||!F)return;const h=n.getCellFromIndex(C);if(!h)return;const g=await F.provideCellStatusBarItems(h.apiCell,l);if(!g)return;const s=new P.DisposableStore,d=this._statusBarCache.add([s]),w=(Array.isArray(g)?g:[g]).map(v=>i.NotebookStatusBarItem.from(v,this._commandsConverter,s));return{cacheId:d,items:w}}$releaseNotebookCellStatusBarItems(_){this._statusBarCache.delete(_)}registerNotebookSerializer(_,u,C,l,F){if((0,I.isFalsyOrWhitespace)(u))throw new Error("viewType cannot be empty or just whitespace");const c=this._handlePool++;return this._notebookSerializer.set(c,C),this._notebookProxy.$registerNotebookSerializer(c,{id:_.identifier,location:_.extensionLocation},u,i.NotebookDocumentContentOptions.from(l),M._convertNotebookRegistrationData(_,F)),(0,P.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(c)})}async $dataToNotebook(_,u,C){const l=this._notebookSerializer.get(_);if(!l)throw new Error("NO serializer found");const F=await l.deserializeNotebook(u.buffer,C);return new a.SerializableObjectWithBuffers(i.NotebookData.from(F))}async $notebookToData(_,u,C){const l=this._notebookSerializer.get(_);if(!l)throw new Error("NO serializer found");const F=await l.serializeNotebook(i.NotebookData.to(u.value),C);return r.VSBuffer.wrap(F)}async $openNotebook(_,u,C,l,F){const{provider:c}=this._getProviderData(_),n=await c.openNotebook(T.URI.revive(u),{backupId:C,untitledDocumentData:l?.buffer},F);return new a.SerializableObjectWithBuffers({metadata:n.metadata??Object.create(null),cells:n.cells.map(i.NotebookCellData.from)})}async $saveNotebook(_,u,C){const l=this.getNotebookDocument(T.URI.revive(u)),{provider:F}=this._getProviderData(_);return await F.saveNotebook(l.apiNotebook,C),!0}async $saveNotebookAs(_,u,C,l){const F=this.getNotebookDocument(T.URI.revive(u)),{provider:c}=this._getProviderData(_);return await c.saveNotebookAs(T.URI.revive(C),F.apiNotebook,l),!0}async $backupNotebook(_,u,C){const l=this.getNotebookDocument(T.URI.revive(u)),F=this._getProviderData(_),c=this._extensionStoragePaths.workspaceValue(F.extension)??this._extensionStoragePaths.globalValue(F.extension),n=String((0,S.hash)([l.uri.toString(),this._backupIdPool++])),h=T.URI.joinPath(c,n),g=await F.provider.backupNotebook(l.apiNotebook,{destination:h},C);return l.updateBackup(g),g.id}_createExtHostEditor(_,u,C){if(this._editors.has(u))throw new Error(`editor with id ALREADY EXSIST: ${u}`);const l=new m.ExtHostNotebookEditor(u,this._notebookEditorsProxy,_,C.visibleRanges.map(i.NotebookRange.to),C.selections.map(i.NotebookRange.to),typeof C.viewColumn=="number"?i.ViewColumn.to(C.viewColumn):void 0);this._editors.set(u,l)}$acceptDocumentAndEditorsDelta(_){if(_.value.removedDocuments)for(const C of _.value.removedDocuments){const l=T.URI.revive(C),F=this._documents.get(l);F&&(F.dispose(),this._documents.delete(l),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:F.apiNotebook.getCells().map(c=>c.document.uri)}),this._onDidCloseNotebookDocument.fire(F.apiNotebook));for(const c of this._editors.values())c.notebookData.uri.toString()===l.toString()&&this._editors.delete(c.id)}if(_.value.addedDocuments){const C=[];for(const l of _.value.addedDocuments){const F=T.URI.revive(l.uri);if(this._documents.has(F))throw new Error(`adding EXISTING notebook ${F} `);const c=this,n=new o.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(h){c._onDidChangeNotebookCells.fire(h)},emitCellOutputsChange(h){c._onDidChangeCellOutputs.fire(h)},emitCellMetadataChange(h){c._onDidChangeCellMetadata.fire(h)}},F,l);C.push(...l.cells.map(h=>o.ExtHostCell.asModelAddData(n.apiNotebook,h))),this._documents.get(F)?.dispose(),this._documents.set(F,n),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:C}),this._onDidOpenNotebookDocument.fire(n.apiNotebook)}}if(_.value.addedEditors)for(const C of _.value.addedEditors){if(this._editors.has(C.id))return;const l=T.URI.revive(C.documentUri),F=this._documents.get(l);F&&this._createExtHostEditor(F,C.id,C)}const u=[];if(_.value.removedEditors)for(const C of _.value.removedEditors){const l=this._editors.get(C);l&&(this._editors.delete(C),this._activeNotebookEditor?.id===l.id&&(this._activeNotebookEditor=void 0),u.push(l))}if(_.value.visibleEditors){this._visibleNotebookEditors=_.value.visibleEditors.map(l=>this._editors.get(l)).filter(l=>!!l);const C=new Set;this._visibleNotebookEditors.forEach(l=>C.add(l.id));for(const l of this._editors.values()){const F=C.has(l.id);l._acceptVisibility(F)}this._visibleNotebookEditors=[...this._editors.values()].map(l=>l).filter(l=>l.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}_.value.newActiveEditor===null?this._activeNotebookEditor=void 0:_.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(_.value.newActiveEditor)),_.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=M,M._notebookStatusBarItemProviderHandlePool=0}),define(Se[193],_e([0,1,4,54,12,5,14,8]),function(ee,e,r,t,S,P,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class D{constructor(b,i){const f=D._Keys.nextId();b.$registerNotebookEditorDecorationType(f,I.NotebookDecorationRenderOptions.from(i)),this.value={key:f,dispose(){b.$removeNotebookEditorDecorationType(f)}}}}D._Keys=new t.IdGenerator("NotebookEditorDecorationType");let T=class{constructor(b,i,f){this._logService=b,this._extHostRpc=i,this._notebooksAndEditors=f,this._onDidChangeNotebookEditorSelection=new r.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new r.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(b){return new D(this._extHostRpc.getProxy(P.MainContext.MainThreadNotebookEditors),b).value}$acceptEditorPropertiesChanged(b,i){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",b,i);const f=this._notebooksAndEditors.getEditorById(b);i.visibleRanges&&f._acceptVisibleRanges(i.visibleRanges.ranges.map(I.NotebookRange.to)),i.selections&&f._acceptSelections(i.selections.selections.map(I.NotebookRange.to)),i.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:f.apiEditor,visibleRanges:f.apiEditor.visibleRanges}),i.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:f.apiEditor,selections:f.apiEditor.selections}))}$acceptEditorViewColumns(b){for(const i in b)this._notebooksAndEditors.getEditorById(i)._acceptViewColumn(I.ViewColumn.to(b[i]))}};T=xe([$e(0,S.ILogService),$e(1,A.IExtHostRpcService)],T),e.ExtHostNotebookEditors=T}),define(Se[194],_e([0,1,16,10,20,4,6,22,2,25,12,5,39,8,7,65,158,26,38]),function(ee,e,r,t,S,P,A,I,D,T,R,b,i,f,a,o,m,M,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let _=class{constructor(n,h,g,s,d){this._initData=h,this._extHostNotebook=g,this._commands=s,this._logService=d,this._activeExecutions=new I.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new P.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._proxy=n.getProxy(b.MainContext.MainThreadNotebookKernels);const p=new i.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new i.ApiCommandArgument("options","Select kernel options",w=>!0,w=>{if(w&&"notebookEditor"in w&&"id"in w){const v=this._extHostNotebook.getIdByEditor(w.notebookEditor);return{id:w.id,extension:w.extension,notebookEditorId:v}}else if(w&&"notebookEditor"in w){const v=this._extHostNotebook.getIdByEditor(w.notebookEditor);if(v===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${w.notebookEditor.document.uri.toString()}`);return{notebookEditorId:v}}return w})],i.ApiCommandResult.Void);this._commands.registerApiCommand(p)}createNotebookController(n,h,g,s,d,p){for(const ue of this._kernelData.values())if(ue.controller.id===h&&T.ExtensionIdentifier.equals(n.identifier,ue.extensionId))throw new Error(`notebook controller with id '${h}' ALREADY exist`);const w=this._handlePool++,v=this;this._logService.trace(`NotebookController[${w}], CREATED by ${n.identifier.value}, ${h}`);const k=()=>console.warn(`NO execute handler from notebook controller '${j.id}' of extension: '${n.identifier}'`);let L=!1;const E=new A.DisposableStore,O=new P.Emitter,U=new P.Emitter,j={id:F(n,h),notebookType:g,extensionId:n.identifier,extensionLocation:n.extensionLocation,label:s||n.identifier.value,preloads:p?p.map(f.NotebookRendererScript.from):[]};let H=d??k,$;this._proxy.$addKernel(w,j).catch(ue=>{console.log(ue),L=!0});let G=0;const ie=()=>{if(L)return;const ue=++G;Promise.resolve().then(()=>{ue===G&&this._proxy.$updateKernel(w,j)})},le=new I.ResourceMap,X={get id(){return h},get notebookType(){return j.notebookType},onDidChangeSelectedNotebooks:O.event,get label(){return j.label},set label(ue){j.label=ue??n.displayName??n.name,ie()},get detail(){return j.detail??""},set detail(ue){j.detail=ue,ie()},get description(){return j.description??""},set description(ue){j.description=ue,ie()},get kind(){return(0,M.checkProposedApiEnabled)(n,"notebookControllerKind"),j.kind??""},set kind(ue){(0,M.checkProposedApiEnabled)(n,"notebookControllerKind"),j.kind=ue,ie()},get supportedLanguages(){return j.supportedLanguages},set supportedLanguages(ue){j.supportedLanguages=ue,ie()},get supportsExecutionOrder(){return j.supportsExecutionOrder??!1},set supportsExecutionOrder(ue){j.supportsExecutionOrder=ue,ie()},get rendererScripts(){return j.preloads?j.preloads.map(f.NotebookRendererScript.to):[]},get executeHandler(){return H},set executeHandler(ue){H=ue??k},get interruptHandler(){return $},set interruptHandler(ue){$=ue,j.supportsInterrupt=Boolean(ue),ie()},createNotebookCellExecution(ue){if(L)throw new Error("notebook controller is DISPOSED");if(!le.has(ue.notebook.uri))throw v._logService.trace(`NotebookController[${w}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(le.keys()).map(ve=>ve.toString())),new Error(`notebook controller is NOT associated to notebook: ${ue.notebook.uri.toString()}`);return v._createNotebookCellExecution(ue,F(n,this.id))},dispose:()=>{L||(this._logService.trace(`NotebookController[${w}], DISPOSED`),L=!0,this._kernelData.delete(w),E.dispose(),O.dispose(),U.dispose(),this._proxy.$removeKernel(w))},updateNotebookAffinity(ue,ve){v._proxy.$updateNotebookPriority(w,ue.uri,ve)},onDidReceiveMessage:U.event,postMessage(ue,ve){return(0,M.checkProposedApiEnabled)(n,"notebookMessaging"),v._proxy.$postMessage(w,ve&&v._extHostNotebook.getIdByEditor(ve),ue)},asWebviewUri(ue){return(0,M.checkProposedApiEnabled)(n,"notebookMessaging"),(0,o.asWebviewUri)(ue,v._initData.remote)}};return this._kernelData.set(w,{extensionId:n.identifier,controller:X,onDidReceiveMessage:U,onDidChangeSelection:O,associatedNotebooks:le}),X}$acceptNotebookAssociation(n,h,g){const s=this._kernelData.get(n);if(s){const d=this._extHostNotebook.getNotebookDocument(D.URI.revive(h));g?s.associatedNotebooks.set(d.uri,!0):s.associatedNotebooks.delete(d.uri),this._logService.trace(`NotebookController[${n}] ASSOCIATE notebook`,d.uri.toString(),g),s.onDidChangeSelection.fire({selected:g,notebook:d.apiNotebook})}}async $executeCells(n,h,g){const s=this._kernelData.get(n);if(!s)return;const d=this._extHostNotebook.getNotebookDocument(D.URI.revive(h)),p=[];for(const w of g){const v=d.getCell(w);v&&p.push(v.apiCell)}try{this._logService.trace(`NotebookController[${n}] EXECUTE cells`,d.uri.toString(),p.length),await s.controller.executeHandler.call(s.controller,p,d.apiNotebook,s.controller)}catch(w){this._logService.error(`NotebookController[${n}] execute cells FAILED`,w),console.error(w)}}async $cancelCells(n,h,g){const s=this._kernelData.get(n);if(!s)return;const d=this._extHostNotebook.getNotebookDocument(D.URI.revive(h));if(s.controller.interruptHandler)await s.controller.interruptHandler.call(s.controller,d.apiNotebook);else for(const p of g){const w=d.getCell(p);w&&this._activeExecutions.get(w.uri)?.cancel()}}$acceptKernelMessageFromRenderer(n,h,g){const s=this._kernelData.get(n);if(!s)return;const d=this._extHostNotebook.getEditorById(h);s.onDidReceiveMessage.fire(Object.freeze({editor:d.apiEditor,message:g}))}$cellExecutionChanged(n,h,g){const d=this._extHostNotebook.getNotebookDocument(D.URI.revive(n)).getCell(h);d&&this._onDidChangeCellExecutionState.fire({cell:d.apiCell,state:g??a.NotebookCellExecutionState.Idle})}_createNotebookCellExecution(n,h){if(n.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const s=this._extHostNotebook.getNotebookDocument(n.notebook.uri).getCellFromApiCell(n);if(!s)throw new Error("invalid cell");if(this._activeExecutions.has(s.uri))throw new Error(`duplicate execution for ${s.uri}`);const d=new C(h,s,this._proxy);this._activeExecutions.set(s.uri,d);const p=d.onDidChangeState(()=>{d.state===u.Resolved&&(d.dispose(),p.dispose(),this._activeExecutions.delete(s.uri))});return d.asApiObject()}};_=xe([$e(4,R.ILogService)],_),e.ExtHostNotebookKernels=_;var u;(function(c){c[c.Init=0]="Init",c[c.Started=1]="Started",c[c.Resolved=2]="Resolved"})(u||(u={}));class C extends A.Disposable{constructor(n,h,g){super();this._cell=h,this._proxy=g,this._handle=C.HANDLE++,this._onDidChangeState=new P.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=u.Init,this._tokenSource=this._register(new S.CancellationTokenSource),this._collector=new l(10,s=>this.update(s)),this._executionOrder=h.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,n,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(n){await this._collector.addItem(n)}async update(n){const h=Array.isArray(n)?n:[n];return this._proxy.$updateExecution(this._handle,new y.SerializableObjectWithBuffers(h))}verifyStateForOutput(){if(this._state===u.Init)throw new Error("Must call start before modifying cell output");if(this._state===u.Resolved)throw new Error("Cannot modify cell output after calling resolve")}validateAndConvertOutputs(n){return n.map(h=>{const g=a.NotebookCellOutput.ensureUniqueMimeTypes(h.items,!0);return g===h.items?f.NotebookCellOutput.from(h):f.NotebookCellOutput.from({items:g,id:h.id,metadata:h.metadata})})}async updateOutputs(n,h,g){const s=this.validateAndConvertOutputs((0,r.asArray)(n));return this.updateSoon({editType:m.CellExecutionUpdateType.Output,append:g,outputs:s})}async updateOutputItems(n,h,g){return n=a.NotebookCellOutput.ensureUniqueMimeTypes((0,r.asArray)(n),!0),this.updateSoon({editType:m.CellExecutionUpdateType.OutputItems,items:n.map(f.NotebookCellOutputItem.from),outputId:h.id,append:g})}asApiObject(){const n=this;return Object.freeze({get token(){return n._tokenSource.token},get cell(){return n._cell.apiCell},get executionOrder(){return n._executionOrder},set executionOrder(g){n._executionOrder=g,n.update([{editType:m.CellExecutionUpdateType.ExecutionState,executionOrder:n._executionOrder}])},start(g){if(n._state===u.Resolved||n._state===u.Started)throw new Error("Cannot call start again");n._state=u.Started,n._onDidChangeState.fire(),n.update({editType:m.CellExecutionUpdateType.ExecutionState,runStartTime:g})},end(g,s){if(n._state===u.Resolved)throw new Error("Cannot call resolve twice");n._state=u.Resolved,n._onDidChangeState.fire(),n._collector.flush(),n._proxy.$completeExecution(n._handle,new y.SerializableObjectWithBuffers({runEndTime:s,lastRunSuccess:g}))},clearOutput(g){return n.verifyStateForOutput(),n.updateOutputs([],g,!1)},appendOutput(g,s){return n.verifyStateForOutput(),n.updateOutputs(g,s,!0)},replaceOutput(g,s){return n.verifyStateForOutput(),n.updateOutputs(g,s,!1)},appendOutputItems(g,s){return n.verifyStateForOutput(),n.updateOutputItems(g,s,!0)},replaceOutputItems(g,s){return n.verifyStateForOutput(),n.updateOutputItems(g,s,!1)}})}}C.HANDLE=0;class l{constructor(n,h){this.delay=n,this.callback=h,this.batch=[],this.startedTimer=Date.now()}addItem(n){return this.batch.push(n),this.currentDeferred||(this.currentDeferred=new t.DeferredPromise,this.startedTimer=Date.now(),(0,t.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const n=this.currentDeferred;this.currentDeferred=void 0;const h=this.batch;return this.batch=[],this.callback(h).finally(()=>n.complete())}}function F(c,n){return`${c.identifier.value}/${n}`}}),define(Se[195],_e([0,1,4,5,89,26]),function(ee,e,r,t,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class A{constructor(D,T){this._extHostNotebook=T,this._rendererMessageEmitters=new Map,this.proxy=D.getProxy(t.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(D,T,R){const b=this._extHostNotebook.getEditorById(D);this._rendererMessageEmitters.get(T)?.fire({editor:b.apiEditor,message:R})}createRendererMessaging(D,T){if(!D.contributes?.notebookRenderer?.some(f=>f.id===T))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${T})`);const R=(0,P.isProposedApiEnabled)(D,"notebookEditor"),b=new WeakMap;return{onDidReceiveMessage:(f,a,o)=>{const m=R?f:M=>{const y={};b.set(y,M.editor),f({editor:y,message:M.message})};return this.getOrCreateEmitterFor(T).event(m,a,o)},postMessage:(f,a)=>{S.ExtHostNotebookEditor.apiEditorsToExtHost.has(f)&&([f,a]=[a,f]);const o=R?a:b.get(a),m=o&&S.ExtHostNotebookEditor.apiEditorsToExtHost.get(o);return this.proxy.$postMessage(m?.id,T,f)}}}getOrCreateEmitterFor(D){let T=this._rendererMessageEmitters.get(D);return T||(T=new r.Emitter({onLastListenerRemove:()=>{T?.dispose(),this._rendererMessageEmitters.delete(D)}}),this._rendererMessageEmitters.set(D,T),T)}}e.ExtHostNotebookRenderers=A}),define(Se[93],_e([0,1,5,6,3,14,12,159,50,28,30,109,21]),function(ee,e,r,t,S,P,A,I,D,T,R,b,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.ExtHostOutputChannel=void 0;class f extends t.Disposable{constructor(m,M,y,_){super();this.id=m,this.name=M,this.logger=y,this.proxy=_,this.offset=0,this.visible=!1,this._disposed=!1}get disposed(){return this._disposed}appendLine(m){this.append(m+`
`)}append(m){this.write(m),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,I.OutputChannelUpdateMode.Append))}clear(){const m=this.offset;this.logger.flush(),this.proxy.$update(this.id,I.OutputChannelUpdateMode.Clear,m)}replace(m){const M=this.offset;this.write(m),this.proxy.$update(this.id,I.OutputChannelUpdateMode.Replace,M),this.visible&&this.logger.flush()}show(m,M){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof m=="boolean"?m:M))}hide(){this.proxy.$close(this.id)}write(m){this.offset+=i.VSBuffer.fromString(m).byteLength,this.logger.info(m)}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}e.ExtHostOutputChannel=f;let a=class{constructor(m,M,y,_,u){this.extHostFileSystem=y,this.extHostFileSystemInfo=_,this.loggerService=u,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=m.getProxy(r.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(M.logsLocation,`output_logging_${(0,b.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(m){this.visibleChannelId=m;for(const[M,y]of this.channels)y.visible=M===this.visibleChannelId}createOutputChannel(m,M){if(m=m.trim(),!m)throw new Error("illegal argument `name`. must not be falsy");const y=this.doCreateOutputChannel(m,M);return y.then(_=>{this.channels.set(_.id,_),_.visible=_.id===this.visibleChannelId}),this.createExtHostOutputChannel(m,y)}async doCreateOutputChannel(m,M){const y=await this.createOutputDirectory(),_=this.extHostFileSystemInfo.extUri.joinPath(y,`${this.namePool++}-${m.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),u=this.loggerService.createLogger(_,{always:!0,donotRotate:!0,donotUseFormatters:!0}),C=await this.proxy.$register(m,!1,_,M.identifier.value);return new f(C,m,u,this.proxy)}createOutputDirectory(){return this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation)),this.outputDirectoryPromise}createExtHostOutputChannel(m,M){let y=!1;const _=()=>{if(y)throw new Error("Channel has been closed")};return{get name(){return m},append(u){_(),M.then(C=>C.append(u))},appendLine(u){_(),M.then(C=>C.appendLine(u))},clear(){_(),M.then(u=>u.clear())},replace(u){_(),M.then(C=>C.replace(u))},show(u,C){_(),M.then(l=>l.show(u,C))},hide(){_(),M.then(u=>u.hide())},dispose(){y=!0,M.then(u=>u.dispose())}}}};a=xe([$e(0,P.IExtHostRpcService),$e(1,T.IExtHostInitDataService),$e(2,D.IExtHostConsumerFileSystem),$e(3,R.IExtHostFileSystemInfo),$e(4,A.ILoggerService)],a),e.ExtHostOutputService=a,e.IExtHostOutputService=(0,S.createDecorator)("IExtHostOutputService")}),define(Se[196],_e([0,1,10,20,4,6,5,2,7,15,16,34,61,26]),function(ee,e,r,t,S,P,A,I,D,T,R,b,i,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function a(o,m,M){const y=o.getProxy(A.MainContext.MainThreadQuickOpen);class _{constructor(s,d){this._sessions=new Map,this._instances=0,this._workspace=s,this._commands=d}showQuickPick(s,d,p=t.CancellationToken.None){this._onDidSelectItem=void 0;const w=Promise.resolve(s),v=++this._instances,k=y.$show(v,{title:d?.title,placeHolder:d?.placeHolder,matchOnDescription:d?.matchOnDescription,matchOnDetail:d?.matchOnDetail,ignoreFocusLost:d?.ignoreFocusOut,canPickMany:d?.canPickMany},p),L={},E=k.then(()=>L);return Promise.race([E,w]).then(O=>{if(O!==L)return w.then(U=>{const j=[];for(let H=0;H<U.length;H++){const $=U[H];typeof $=="string"?j.push({label:$,handle:H}):$.kind===D.QuickPickItemKind.Separator?j.push({type:"separator",label:$.label}):j.push({label:$.label,description:$.description,detail:$.detail,picked:$.picked,alwaysShow:$.alwaysShow,handle:H})}return d&&typeof d.onDidSelectItem=="function"&&(this._onDidSelectItem=H=>{d.onDidSelectItem(U[H])}),y.$setItems(v,j),k.then(H=>{if(typeof H=="number")return U[H];if(Array.isArray(H))return H.map($=>U[$])})})}).then(void 0,O=>{if(!(0,T.isCancellationError)(O))return y.$setError(v,O),Promise.reject(O)})}$onItemSelected(s){this._onDidSelectItem&&this._onDidSelectItem(s)}showInput(s,d=t.CancellationToken.None){return this._validateInput=s?s.validateInput:void 0,y.$input(s,typeof this._validateInput=="function",d).then(void 0,p=>{if(!(0,T.isCancellationError)(p))return Promise.reject(p)})}$validateInput(s){return this._validateInput?(0,r.asPromise)(()=>this._validateInput(s)):Promise.resolve(void 0)}async showWorkspaceFolderPick(s,d=t.CancellationToken.None){const p=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[s]);if(!p)return;const w=await this._workspace.getWorkspaceFolders2();if(!!w)return w.find(v=>v.uri.toString()===p.uri.toString())}createQuickPick(s){const d=new n(s,()=>this._sessions.delete(d._id));return this._sessions.set(d._id,d),d}createInputBox(s){const d=new h(s,()=>this._sessions.delete(d._id));return this._sessions.set(d._id,d),d}$onDidChangeValue(s,d){const p=this._sessions.get(s);p&&p._fireDidChangeValue(d)}$onDidAccept(s){const d=this._sessions.get(s);d&&d._fireDidAccept()}$onDidChangeActive(s,d){const p=this._sessions.get(s);p instanceof n&&p._fireDidChangeActive(d)}$onDidChangeSelection(s,d){const p=this._sessions.get(s);p instanceof n&&p._fireDidChangeSelection(d)}$onDidTriggerButton(s,d){const p=this._sessions.get(s);p&&p._fireDidTriggerButton(d)}$onDidTriggerItemButton(s,d,p){const w=this._sessions.get(s);w instanceof n&&w._fireDidTriggerItemButton(d,p)}$onDidHide(s){const d=this._sessions.get(s);d&&d._fireDidHide()}}class u{constructor(s,d){this._extensionId=s,this._onDidDispose=d,this._id=n._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new S.Emitter,this._onDidChangeValueEmitter=new S.Emitter,this._onDidTriggerButtonEmitter=new S.Emitter,this._onDidHideEmitter=new S.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(s){this._title=s,this.update({title:s})}get step(){return this._steps}set step(s){this._steps=s,this.update({step:s})}get totalSteps(){return this._totalSteps}set totalSteps(s){this._totalSteps=s,this.update({totalSteps:s})}get enabled(){return this._enabled}set enabled(s){this._enabled=s,this.update({enabled:s})}get busy(){return this._busy}set busy(s){this._busy=s,this.update({busy:s})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(s){this._ignoreFocusOut=s,this.update({ignoreFocusOut:s})}get value(){return this._value}set value(s){this._value=s,this.update({value:s})}get placeholder(){return this._placeholder}set placeholder(s){this._placeholder=s,this.update({placeholder:s})}get buttons(){return this._buttons}set buttons(s){this._buttons=s.slice(),this._handlesToButtons.clear(),s.forEach((d,p)=>{const w=d===D.QuickInputButtons.Back?-1:p;this._handlesToButtons.set(w,d)}),this.update({buttons:s.map((d,p)=>({...c(d),tooltip:d.tooltip,handle:d===D.QuickInputButtons.Back?-1:p}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(s){this._value=s,this._onDidChangeValueEmitter.fire(s)}_fireDidTriggerButton(s){const d=this._handlesToButtons.get(s);d&&this._onDidTriggerButtonEmitter.fire(d)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,P.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),y.$dispose(this._id))}update(s){if(!this._disposed){for(const d of Object.keys(s)){const p=s[d];this._pendingUpdate[d]=p===void 0?null:p}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){y.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}u._nextId=1;function C(g){if(g instanceof D.ThemeIcon)return{id:g.id};const s=F(g),d=l(g);return{dark:typeof s=="string"?I.URI.file(s):s,light:typeof d=="string"?I.URI.file(d):d}}function l(g){return typeof g=="object"&&"light"in g?g.light:g}function F(g){return typeof g=="object"&&"dark"in g?g.dark:g}function c(g){const s=C(g.iconPath);let d,p;return"id"in s?p=i.ThemeIcon.asClassName(s):d=s,{iconPath:d,iconClass:p}}class n extends u{constructor(s,d){super(s.identifier,d);this.extension=s,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new S.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new S.Emitter,this._onDidTriggerItemButtonEmitter=new S.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(s){s.some(p=>p.kind!==void 0)&&(0,f.checkProposedApiEnabled)(this.extension,"quickPickSeparators"),this._items=s.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),s.forEach((p,w)=>{this._handlesToItems.set(w,p),this._itemsToHandles.set(p,w)});const d=[];for(let p=0;p<s.length;p++){const w=s[p];w.kind===D.QuickPickItemKind.Separator?d.push({type:"separator",label:w.label}):d.push({handle:p,label:w.label,description:w.description,detail:w.detail,picked:w.picked,alwaysShow:w.alwaysShow,buttons:w.buttons?.map((v,k)=>({...c(v),tooltip:v.tooltip,handle:k}))})}this.update({items:d})}get canSelectMany(){return this._canSelectMany}set canSelectMany(s){this._canSelectMany=s,this.update({canSelectMany:s})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(s){this._matchOnDescription=s,this.update({matchOnDescription:s})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(s){this._matchOnDetail=s,this.update({matchOnDetail:s})}get sortByLabel(){return this._sortByLabel}set sortByLabel(s){this._sortByLabel=s,this.update({sortByLabel:s})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(s){this._keepScrollPosition=s,this.update({keepScrollPosition:s})}get activeItems(){return this._activeItems}set activeItems(s){this._activeItems=s.filter(d=>this._itemsToHandles.has(d)),this.update({activeItems:this._activeItems.map(d=>this._itemsToHandles.get(d))})}get selectedItems(){return this._selectedItems}set selectedItems(s){this._selectedItems=s.filter(d=>this._itemsToHandles.has(d)),this.update({selectedItems:this._selectedItems.map(d=>this._itemsToHandles.get(d))})}_fireDidChangeActive(s){const d=(0,R.coalesce)(s.map(p=>this._handlesToItems.get(p)));this._activeItems=d,this._onDidChangeActiveEmitter.fire(d)}_fireDidChangeSelection(s){const d=(0,R.coalesce)(s.map(p=>this._handlesToItems.get(p)));this._selectedItems=d,this._onDidChangeSelectionEmitter.fire(d)}_fireDidTriggerItemButton(s,d){const p=this._handlesToItems.get(s);if(!p||!p.buttons||!p.buttons.length)return;const w=p.buttons[d];w&&this._onDidTriggerItemButtonEmitter.fire({button:w,item:p})}}class h extends u{constructor(s,d){super(s,d);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(s){this._password=s,this.update({password:s})}get prompt(){return this._prompt}set prompt(s){this._prompt=s,this.update({prompt:s})}get validationMessage(){return this._validationMessage}set validationMessage(s){this._validationMessage=s,this.update({validationMessage:s,severity:s?b.default.Error:b.default.Ignore})}}return new _(m,M)}e.createExtHostQuickOpen=a});var Xe=this&&this.__classPrivateFieldSet||function(ee,e,r,t,S){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!S:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?S.call(ee,r):S?S.value=r:e.set(ee,r),r},Ie=this&&this.__classPrivateFieldGet||function(ee,e,r,t){if(r==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!t:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?t:r==="a"?t.call(ee):t?t.value:e.get(ee)};define(Se[197],_e([0,1,2,4,53,6,10,5,16,104,12,25,61,8,26]),function(ee,e,r,t,S,P,A,I,D,T,R,b,i,f,a){"use strict";var o,m;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function M(d){if(d)return typeof d.iconPath=="string"?r.URI.file(d.iconPath):r.URI.isUri(d.iconPath)||i.ThemeIcon.isThemeIcon(d.iconPath)?d.iconPath:void 0}function y(d,p){if(!d.iconPath&&!p.iconPath)return 0;if(d.iconPath){if(!p.iconPath)return 1}else return-1;const w=typeof d.iconPath=="string"?d.iconPath:r.URI.isUri(d.iconPath)?d.iconPath.fsPath:d.iconPath.id,v=typeof p.iconPath=="string"?p.iconPath:r.URI.isUri(p.iconPath)?p.iconPath.fsPath:p.iconPath.id;return(0,T.comparePaths)(w,v)}function _(d,p){let w=0;if(d.strikeThrough!==p.strikeThrough)return d.strikeThrough?1:-1;if(d.faded!==p.faded)return d.faded?1:-1;if(d.tooltip!==p.tooltip)return(d.tooltip||"").localeCompare(p.tooltip||"");if(w=y(d,p),w!==0)return w;if(d.light&&p.light)w=y(d.light,p.light);else{if(d.light)return 1;if(p.light)return-1}if(w!==0)return w;if(d.dark&&p.dark)w=y(d.dark,p.dark);else{if(d.dark)return 1;if(p.dark)return-1}return w}function u(d,p){if(d.command!==p.command)return d.command<p.command?-1:1;if(d.title!==p.title)return d.title<p.title?-1:1;if(d.tooltip!==p.tooltip){if(d.tooltip!==void 0&&p.tooltip!==void 0)return d.tooltip<p.tooltip?-1:1;if(d.tooltip!==void 0)return 1;if(p.tooltip!==void 0)return-1}if(d.arguments===p.arguments)return 0;if(d.arguments)if(p.arguments){if(d.arguments.length!==p.arguments.length)return d.arguments.length-p.arguments.length}else return 1;else return-1;for(let w=0;w<d.arguments.length;w++){const v=d.arguments[w],k=p.arguments[w];if(v!==k)return v<k?-1:1}return 0}function C(d,p){let w=(0,T.comparePaths)(d.resourceUri.fsPath,p.resourceUri.fsPath,!0);if(w!==0)return w;if(d.command&&p.command)w=u(d.command,p.command);else{if(d.command)return 1;if(p.command)return-1}if(w!==0)return w;if(d.decorations&&p.decorations)w=_(d.decorations,p.decorations);else{if(d.decorations)return 1;if(p.decorations)return-1}return w}function l(d,p){for(let w=0;w<d.length;w++)if(d[w]!==p[w])return!1;return!0}function F(d,p){return d.command===p.command&&d.title===p.title&&d.tooltip===p.tooltip&&(d.arguments&&p.arguments?l(d.arguments,p.arguments):d.arguments===p.arguments)}function c(d,p){return(0,D.equals)(d,p,F)}class n{constructor(p,w,v){this._extension=p,this._sourceControlHandle=v,o.set(this,void 0),this._value="",this._onDidChange=new t.Emitter,this._placeholder="",this._visible=!0,Xe(this,o,w,"f")}get value(){return this._value}set value(p){p=p??"",Ie(this,o,"f").$setInputBoxValue(this._sourceControlHandle,p),this.updateValue(p)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(p){Ie(this,o,"f").$setInputBoxPlaceholder(this._sourceControlHandle,p),this._placeholder=p}get validateInput(){return(0,a.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(p){if((0,a.checkProposedApiEnabled)(this._extension,"scmValidation"),p&&typeof p!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=p,Ie(this,o,"f").$setValidationProviderIsEnabled(this._sourceControlHandle,!!p)}get visible(){return this._visible}set visible(p){p=!!p,this._visible!==p&&(this._visible=p,Ie(this,o,"f").$setInputBoxVisibility(this._sourceControlHandle,p))}showValidationMessage(p,w){(0,a.checkProposedApiEnabled)(this._extension,"scmValidation"),Ie(this,o,"f").$showValidationMessage(this._sourceControlHandle,p,w)}$onInputBoxValueChange(p){this.updateValue(p)}updateValue(p){this._value=p,this._onDidChange.fire(p)}}e.ExtHostSCMInputBox=n,o=new WeakMap;class h{constructor(p,w,v,k,L){this._proxy=p,this._commands=w,this._sourceControlHandle=v,this._id=k,this._label=L,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new t.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=h._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(p){this._label=p,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,p)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(p){this._hideWhenEmpty=p,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(p){this._resourceStates=[...p],this._onDidUpdateResourceStates.fire()}getResourceState(p){return this._resourceStatesMap.get(p)}$executeResourceCommand(p,w){const v=this._resourceStatesCommandsMap.get(p);return v?(0,A.asPromise)(()=>this._commands.executeCommand(v.command,...v.arguments||[],w)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const p=[...this._resourceStates].sort(C),v=(0,D.sortedDiff)(this._resourceSnapshot,p,C).map(E=>{const O=E.toInsert.map(U=>{const j=this._resourceHandlePool++;this._resourceStatesMap.set(j,U);const H=U.resourceUri;let $;if(U.command)if(U.command.command==="vscode.open"||U.command.command==="vscode.diff"){const be=new P.DisposableStore;$=this._commands.converter.toInternal(U.command,be),this._resourceStatesDisposablesMap.set(j,be)}else this._resourceStatesCommandsMap.set(j,U.command);const G=M(U.decorations),ie=U.decorations&&M(U.decorations.light)||G,le=U.decorations&&M(U.decorations.dark)||G,X=[ie,le],ue=U.decorations&&U.decorations.tooltip||"",ve=U.decorations&&!!U.decorations.strikeThrough,ge=U.decorations&&!!U.decorations.faded,we=U.contextValue||"";return{rawResource:[j,H,X,ue,ve,ge,we,$],handle:j}});return{start:E.start,deleteCount:E.deleteCount,toInsert:O}}),k=v.map(({start:E,deleteCount:O,toInsert:U})=>[E,O,U.map(j=>j.rawResource)]),L=v.reverse();for(const{start:E,deleteCount:O,toInsert:U}of L){const j=U.map($=>$.handle),H=this._handlesSnapshot.splice(E,O,...j);for(const $ of H)this._resourceStatesMap.delete($),this._resourceStatesCommandsMap.delete($),this._resourceStatesDisposablesMap.get($)?.dispose(),this._resourceStatesDisposablesMap.delete($)}return this._resourceSnapshot=p,k}dispose(){this._disposed=!0,this._onDidDispose.fire()}}h._handlePool=0;class g{constructor(p,w,v,k,L,E){this._extension=p,this._commands=v,this._id=k,this._label=L,this._rootUri=E,m.set(this,void 0),this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new P.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new P.MutableDisposable,this._statusBarDisposables=new P.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new t.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=g._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,Xe(this,m,w,"f"),this._inputBox=new n(p,Ie(this,m,"f"),this.handle),Ie(this,m,"f").$registerSourceControl(this.handle,k,L,E)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(p){this._count!==p&&(this._count=p,Ie(this,m,"f").$updateSourceControl(this.handle,{count:p}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(p){this._quickDiffProvider=p,Ie(this,m,"f").$updateSourceControl(this.handle,{hasQuickDiffProvider:!!p})}get commitTemplate(){return this._commitTemplate}set commitTemplate(p){p!==this._commitTemplate&&(this._commitTemplate=p,Ie(this,m,"f").$updateSourceControl(this.handle,{commitTemplate:p}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(p){this._acceptInputDisposables.value=new P.DisposableStore,this._acceptInputCommand=p;const w=this._commands.converter.toInternal(p,this._acceptInputDisposables.value);Ie(this,m,"f").$updateSourceControl(this.handle,{acceptInputCommand:w})}get actionButton(){return(0,a.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(p){(0,a.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new P.DisposableStore,this._actionButton=p;const w=p!==void 0?this._commands.converter.toInternal(this._actionButton,this._actionButtonDisposables.value):void 0;Ie(this,m,"f").$updateSourceControl(this.handle,{actionButton:w??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(p){if(this._statusBarCommands&&p&&c(this._statusBarCommands,p))return;this._statusBarDisposables.value=new P.DisposableStore,this._statusBarCommands=p;const w=(p||[]).map(v=>this._commands.converter.toInternal(v,this._statusBarDisposables.value));Ie(this,m,"f").$updateSourceControl(this.handle,{statusBarCommands:w})}get selected(){return this._selected}createResourceGroup(p,w){const v=new h(Ie(this,m,"f"),this._commands,this.handle,p,w),k=t.Event.once(v.onDidDispose)(()=>this.createdResourceGroups.delete(v));return this.createdResourceGroups.set(v,k),this.eventuallyAddResourceGroups(),v}eventuallyAddResourceGroups(){const p=[],w=[];for(const[v,k]of this.createdResourceGroups){k.dispose();const L=v.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(v),this.eventuallyUpdateResourceStates()});t.Event.once(v.onDidDispose)(()=>{this.updatedResourceGroups.delete(v),L.dispose(),this._groups.delete(v.handle),Ie(this,m,"f").$unregisterGroup(this.handle,v.handle)}),p.push([v.handle,v.id,v.label,v.features]);const E=v._takeResourceStateSnapshot();E.length>0&&w.push([v.handle,E]),this._groups.set(v.handle,v)}Ie(this,m,"f").$registerGroups(this.handle,p,w),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const p=[];this.updatedResourceGroups.forEach(w=>{const v=w._takeResourceStateSnapshot();v.length!==0&&p.push([w.handle,v])}),p.length>0&&Ie(this,m,"f").$spliceResourceStates(this.handle,p),this.updatedResourceGroups.clear()}getResourceGroup(p){return this._groups.get(p)}setSelectionState(p){this._selected=p,this._onDidChangeSelection.fire(p)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(p=>p.dispose()),Ie(this,m,"f").$unregisterSourceControl(this.handle)}}m=new WeakMap,g._handlePool=0,xe([(0,S.debounce)(100)],g.prototype,"eventuallyAddResourceGroups",null),xe([(0,S.debounce)(100)],g.prototype,"eventuallyUpdateResourceStates",null);let s=class Vi{constructor(p,w,v){this._commands=w,this.logService=v,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new t.Emitter,this._proxy=p.getProxy(I.MainContext.MainThreadSCM),this._telemetry=p.getProxy(I.MainContext.MainThreadTelemetry),w.registerArgumentProcessor({processArgument:k=>{if(k&&k.$mid===3){const L=this._sourceControls.get(k.sourceControlHandle);if(!L)return k;const E=L.getResourceGroup(k.groupHandle);return E?E.getResourceState(k.handle):k}else if(k&&k.$mid===4){const L=this._sourceControls.get(k.sourceControlHandle);return L?L.getResourceGroup(k.groupHandle):k}else if(k&&k.$mid===5){const L=this._sourceControls.get(k.handle);return L||k}return k}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(p,w,v,k){this.logService.trace("ExtHostSCM#createSourceControl",p.identifier.value,w,v,k),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:p.identifier.value});const L=Vi._handlePool++,E=new g(p,this._proxy,this._commands,w,v,k);this._sourceControls.set(L,E);const O=this._sourceControlsByExtension.get(b.ExtensionIdentifier.toKey(p.identifier))||[];return O.push(E),this._sourceControlsByExtension.set(b.ExtensionIdentifier.toKey(p.identifier),O),E}getLastInputBox(p){this.logService.trace("ExtHostSCM#getLastInputBox",p.identifier.value);const w=this._sourceControlsByExtension.get(b.ExtensionIdentifier.toKey(p.identifier)),v=w&&w[w.length-1];return v&&v.inputBox}$provideOriginalResource(p,w,v){const k=r.URI.revive(w);this.logService.trace("ExtHostSCM#$provideOriginalResource",p,k.toString());const L=this._sourceControls.get(p);return!L||!L.quickDiffProvider||!L.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,A.asPromise)(()=>L.quickDiffProvider.provideOriginalResource(k,v)).then(E=>E||null)}$onInputBoxValueChange(p,w){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",p);const v=this._sourceControls.get(p);return v&&v.inputBox.$onInputBoxValueChange(w),Promise.resolve(void 0)}$executeResourceCommand(p,w,v,k){this.logService.trace("ExtHostSCM#$executeResourceCommand",p,w,v);const L=this._sourceControls.get(p);if(!L)return Promise.resolve(void 0);const E=L.getResourceGroup(w);return E?E.$executeResourceCommand(v,k):Promise.resolve(void 0)}$validateInput(p,w,v){this.logService.trace("ExtHostSCM#$validateInput",p);const k=this._sourceControls.get(p);return!k||!k.inputBox.validateInput?Promise.resolve(void 0):(0,A.asPromise)(()=>k.inputBox.validateInput(w,v)).then(L=>{if(!L)return Promise.resolve(void 0);const E=f.MarkdownString.fromStrict(L.message);return E?Promise.resolve([E,L.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(p){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",p),p!==void 0&&this._sourceControls.get(p)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=p,Promise.resolve(void 0)}};s._handlePool=0,s=xe([$e(2,R.ILogService)],s),e.ExtHostSCM=s});var Xe=this&&this.__classPrivateFieldSet||function(ee,e,r,t,S){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!S:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?S.call(ee,r):S?S.value=r:e.set(ee,r),r},Ie=this&&this.__classPrivateFieldGet||function(ee,e,r,t){if(r==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!t:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?t:r==="a"?t.call(ee):t?t.value:e.get(ee)};define(Se[198],_e([0,1,7,5,121,6,8,13]),function(ee,e,r,t,S,P,A,I){"use strict";var D,T;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class R{constructor(a,o,m,M,y=r.StatusBarAlignment.Left,_){D.set(this,void 0),T.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new P.DisposableStore,Xe(this,D,a,"f"),Xe(this,T,o,"f"),this._entryId=R.ID_GEN++,this._extension=m,this._id=M,this._alignment=y,this._priority=this.validatePriority(_)}validatePriority(a){if(!!(0,I.isNumber)(a))return a===Number.POSITIVE_INFINITY?Number.MAX_VALUE:a===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:a}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(a){this._text=a,this.update()}set name(a){this._name=a,this.update()}set tooltip(a){this._tooltip=a,this.update()}set color(a){this._color=a,this.update()}set backgroundColor(a){a&&!R.ALLOWED_BACKGROUND_COLORS.has(a.id)&&(a=void 0),this._backgroundColor=a,this.update()}set command(a){this._command?.fromApi!==a&&(this._internalCommandRegistration.clear(),typeof a=="string"?this._command={fromApi:a,internal:Ie(this,T,"f").toInternal({title:"",command:a},this._internalCommandRegistration)}:a?this._command={fromApi:a,internal:Ie(this,T,"f").toInternal(a,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(a){this._accessibilityInformation=a,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Ie(this,D,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let a;this._extension?this._id?a=`${this._extension.identifier.value}.${this._id}`:a=this._extension.identifier.value:a=this._id;let o;this._name?o=this._name:o=(0,S.localize)(0,null,this._extension.displayName||this._extension.name);let m=this._color;this._backgroundColor&&(m=R.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const M=this._tooltip?A.MarkdownString.fromStrict(this._tooltip):void 0;Ie(this,D,"f").$setEntry(this._entryId,a,o,this._text,M,this._command?.internal,m,this._backgroundColor,this._alignment===r.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=R,D=new WeakMap,T=new WeakMap,R.ID_GEN=0,R.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new r.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new r.ThemeColor("statusBarItem.warningForeground")]]);class b{constructor(a){this._messages=[],this._item=a.createStatusBarEntry(void 0,"status.extensionMessage",r.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,S.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(a){const o={message:a};return this._messages.unshift(o),this._update(),new r.Disposable(()=>{const m=this._messages.indexOf(o);m>=0&&(this._messages.splice(m,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class i{constructor(a,o){this._proxy=a.getProxy(t.MainContext.MainThreadStatusBar),this._commands=o,this._statusMessage=new b(this)}createStatusBarEntry(a,o,m,M){return new R(this._proxy,this._commands,a,o,m,M)}setStatusBarMessage(a,o){const m=this._statusMessage.setMessage(a);let M;return typeof o=="number"?M=setTimeout(()=>m.dispose(),o):typeof o!="undefined"&&o.then(()=>m.dispose(),()=>m.dispose()),new r.Disposable(()=>{m.dispose(),clearTimeout(M)})}}e.ExtHostStatusBar=i}),define(Se[70],_e([0,1,5,4,3]),function(ee,e,r,t,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class P{constructor(I){this._onDidChangeStorage=new t.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=I.getProxy(r.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(I,D){this._proxy.$registerExtensionStorageKeysToSync(I,D)}initializeExtensionStorage(I,D,T){return this._proxy.$initializeExtensionStorage(I,D).then(R=>R||T)}setValue(I,D,T){return this._proxy.$setValue(I,D,T)}$acceptValue(I,D,T){this._onDidChangeStorage.fire({shared:I,key:D,value:T})}}e.ExtHostStorage=P,e.IExtHostStorage=(0,S.createDecorator)("IExtHostStorage")}),define(Se[71],_e([0,1,3,28,12,50,2]),function(ee,e,r,t,S,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,r.createDecorator)("IExtensionStoragePaths");let I=class{constructor(T,R,b){this._logService=R,this._extHostFileSystem=b,this._workspace=T.workspace??void 0,this._environment=T.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(i=>this._value=i)}async _getWorkspaceStorageURI(T){return A.URI.joinPath(this._environment.workspaceStorageHome,T)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const T=this._workspace.id,R=await this._getWorkspaceStorageURI(T);try{return await this._extHostFileSystem.value.stat(R),this._logService.trace("[ExtHostStorage] storage dir already exists",R),R}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",R),await this._extHostFileSystem.value.createDirectory(R),await this._extHostFileSystem.value.writeFile(A.URI.joinPath(R,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:A.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),R}catch(b){this._logService.error("[ExtHostStorage]",b);return}}workspaceValue(T){if(this._value)return A.URI.joinPath(this._value,T.identifier.value)}globalValue(T){return A.URI.joinPath(this._environment.globalStorageHome,T.identifier.value.toLowerCase())}onWillDeactivateAll(){}};I=xe([$e(0,t.IExtHostInitDataService),$e(1,S.ILogService),$e(2,P.IExtHostConsumerFileSystem)],I),e.ExtensionStoragePaths=I}),define(Se[40],_e([0,1,4,5,3,2,14,6,7,122,15,161,20,36,144,61,13,10]),function(ee,e,r,t,S,P,A,I,D,T,R,b,i,f,a,o,m,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,S.createDecorator)("IExtHostTerminalService");class y{constructor(g,s,d,p){this._proxy=g,this._id=s,this._creationOptions=d,this._name=p,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(v=>this._pidPromiseComplete=v);const w=this;this.value={get name(){return w._name||""},get processId(){return w._pidPromise},get creationOptions(){return w._creationOptions},get exitStatus(){return w._exitStatus},get state(){return w._state},sendText(v,k=!0){w._checkDisposed(),w._proxy.$sendText(w._id,v,k)},show(v){w._checkDisposed(),w._proxy.$show(w._id,v)},hide(){w._checkDisposed(),w._proxy.$hide(w._id)},dispose(){w._disposed||(w._disposed=!0,w._proxy.$dispose(w._id))},get dimensions(){if(!(w._cols===void 0||w._rows===void 0))return{columns:w._cols,rows:w._rows}}}}async create(g,s){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:g.name,shellPath:(0,m.withNullAsUndefined)(g.shellPath),shellArgs:(0,m.withNullAsUndefined)(g.shellArgs),cwd:(0,m.withNullAsUndefined)(g.cwd),env:(0,m.withNullAsUndefined)(g.env),icon:(0,m.withNullAsUndefined)(c(g.iconPath)),color:o.ThemeColor.isThemeColor(g.color)?g.color.id:void 0,initialText:(0,m.withNullAsUndefined)(g.message),strictEnv:(0,m.withNullAsUndefined)(g.strictEnv),hideFromUser:(0,m.withNullAsUndefined)(g.hideFromUser),isFeatureTerminal:(0,m.withNullAsUndefined)(s?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,m.withNullAsUndefined)(s?.useShellEnvironment),location:s?.location||this._serializeParentTerminal(g.location,s?.resolvedExtHostIdentifier),disablePersistence:(0,m.withNullAsUndefined)(g.disablePersistence)})}async createExtensionTerminal(g,s,d,p){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:d,color:o.ThemeColor.isThemeColor(p)?p.id:void 0,location:this._serializeParentTerminal(g,s),disablePersistence:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(g,s){return typeof g=="object"?"parentTerminal"in g&&g.parentTerminal&&s?{parentTerminal:s}:"viewColumn"in g?{viewColumn:g.viewColumn,preserveFocus:g.preserveFocus}:void 0:g}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(g){this._name=g}setExitCode(g){this._exitStatus=Object.freeze({code:g})}setDimensions(g,s){return g===this._cols&&s===this._rows||g===0||s===0?!1:(this._cols=g,this._rows=s,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(g){this._pidPromiseComplete?(this._pidPromiseComplete(g),this._pidPromiseComplete=void 0):this._pidPromise.then(s=>{s!==g&&(this._pidPromise=Promise.resolve(g))})}}e.ExtHostTerminal=y;class _{constructor(g){this._pty=g,this.id=0,this.shouldPersist=!1,this._onProcessData=new r.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new r.Emitter,this._onDidChangeProperty=new r.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new r.Emitter,this.onProcessExit=this._onProcessExit.event}get onProcessReady(){return this._onProcessReady.event}refreshProperty(g){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${g}`)}updateProperty(g,s){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${g}, value: ${s}`)}async start(){}shutdown(){this._pty.close()}input(g){this._pty.handleInput?.(g)}resize(g,s){this._pty.setDimensions?.({columns:g,rows:s})}async processBinary(g){}acknowledgeDataEvent(g){}async setUnicodeVersion(g){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(g){this._pty.onDidWrite(s=>this._onProcessData.fire(s)),this._pty.onDidClose?.((s=void 0)=>{this._onProcessExit.fire(s===void 0?void 0:s)}),this._pty.onDidOverrideDimensions?.(s=>{s&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:s.columns,rows:s.rows}})}),this._pty.onDidChangeName?.(s=>{this._onDidChangeProperty.fire({type:"title",value:s})}),this._pty.open(g||void 0),g&&this._pty.setDimensions?.(g),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=_;let u=1,C=class extends I.Disposable{constructor(g,s){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new r.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new r.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new r.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new r.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new r.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=s.getProxy(t.MainContext.MainThreadTerminalService),this._bufferer=new a.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new r.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(g),this._register({dispose:()=>{for(const[d,p]of this._terminalProcesses)p.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(g=>g.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(g){return(g?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(g){return(g?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(g,s){const d=new y(this._proxy,(0,f.generateUuid)(),g,g.name),p=new _(g.pty);return d.createExtensionTerminal(g.location,this._serializeParentTerminal(g,s).resolvedExtHostIdentifier,c(g.iconPath),n(g.color)).then(w=>{const v=this._setupExtHostProcessListeners(w,p);this._terminalProcessDisposables[w]=v}),this._terminals.push(d),d.value}_serializeParentTerminal(g,s){if(s=s||{},g.location&&typeof g.location=="object"&&"parentTerminal"in g.location){const d=g.location.parentTerminal;if(d){const p=this._terminals.find(w=>w.value===d);p&&(s.resolvedExtHostIdentifier=p._id)}}else g.location&&typeof g.location!="object"?s.location=g.location:s.location&&typeof s.location=="object"&&"splitActiveTerminal"in s.location&&(s.location={splitActiveTerminal:!0});return s}attachPtyToTerminal(g,s){if(!this._getTerminalById(g))throw new Error(`Cannot resolve terminal with id ${g} for virtual process`);const p=new _(s),w=this._setupExtHostProcessListeners(g,p);this._terminalProcessDisposables[g]=w}async $acceptActiveTerminalChanged(g){const s=this._activeTerminal;if(g===null){this._activeTerminal=void 0,s!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const d=this._getTerminalById(g);d&&(this._activeTerminal=d,s!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(g,s){const d=this._getTerminalById(g);d&&this._onDidWriteTerminalData.fire({terminal:d.value,data:s})}async $acceptTerminalDimensions(g,s,d){const p=this._getTerminalById(g);p&&p.setDimensions(s,d)&&this._onDidChangeTerminalDimensions.fire({terminal:p.value,dimensions:p.value.dimensions})}async $acceptTerminalMaximumDimensions(g,s,d){this._terminalProcesses.get(g)?.resize(s,d)}async $acceptTerminalTitleChange(g,s){const d=this._getTerminalById(g);d&&(d.name=s)}async $acceptTerminalClosed(g,s){const d=this._getTerminalObjectIndexById(this._terminals,g);if(d!==null){const p=this._terminals.splice(d,1)[0];p.setExitCode(s),this._onDidCloseTerminal.fire(p.value)}}$acceptTerminalOpened(g,s,d,p){if(s){const k=this._getTerminalObjectIndexById(this._terminals,s);if(k!==null){this._terminals[k]._id=g,this._onDidOpenTerminal.fire(this.terminals[k]),this._terminals[k].isOpen=!0;return}}const w={name:p.name,shellPath:p.executable,shellArgs:p.args,cwd:typeof p.cwd=="string"?p.cwd:P.URI.revive(p.cwd),env:p.env,hideFromUser:p.hideFromUser},v=new y(this._proxy,g,w,d);this._terminals.push(v),this._onDidOpenTerminal.fire(v.value),v.isOpen=!0}async $acceptTerminalProcessId(g,s){const d=this._getTerminalById(g);d&&d._setProcessId(s)}async $startExtensionTerminal(g,s){const d=this._getTerminalById(g);if(!d)return{message:(0,T.localize)(0,null,g)};d.isOpen||await new Promise(w=>{const v=this.onDidOpenTerminal(async k=>{k===d.value&&(v.dispose(),w())})});const p=this._terminalProcesses.get(g);p?p.startSendingEvents(s):this._extensionTerminalAwaitingStart[g]={initialDimensions:s}}_setupExtHostProcessListeners(g,s){const d=new I.DisposableStore;d.add(s.onProcessReady(w=>this._proxy.$sendProcessReady(g,w.pid,w.cwd))),d.add(s.onDidChangeProperty(w=>this._proxy.$sendProcessProperty(g,w))),this._bufferer.startBuffering(g,s.onProcessData),d.add(s.onProcessExit(w=>this._onProcessExit(g,w))),this._terminalProcesses.set(g,s);const p=this._extensionTerminalAwaitingStart[g];return p&&s instanceof _&&(s.startSendingEvents(p.initialDimensions),delete this._extensionTerminalAwaitingStart[g]),d}$acceptProcessAckDataEvent(g,s){this._terminalProcesses.get(g)?.acknowledgeDataEvent(s)}$acceptProcessInput(g,s){this._terminalProcesses.get(g)?.input(s)}$acceptTerminalInteraction(g){const s=this._getTerminalById(g);s?.setInteractedWith()&&this._onDidChangeTerminalState.fire(s.value)}$acceptProcessResize(g,s,d){try{this._terminalProcesses.get(g)?.resize(s,d)}catch(p){if(p.code!=="EPIPE"&&p.code!=="ERR_IPC_CHANNEL_CLOSED")throw p}}$acceptProcessShutdown(g,s){this._terminalProcesses.get(g)?.shutdown(s)}$acceptProcessRequestInitialCwd(g){this._terminalProcesses.get(g)?.getInitialCwd().then(s=>this._proxy.$sendProcessProperty(g,{type:"initialCwd",value:s}))}$acceptProcessRequestCwd(g){this._terminalProcesses.get(g)?.getCwd().then(s=>this._proxy.$sendProcessProperty(g,{type:"cwd",value:s}))}$acceptProcessRequestLatency(g){return Promise.resolve(g)}registerLinkProvider(g){return this._linkProviders.add(g),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new D.Disposable(()=>{this._linkProviders.delete(g),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(g,s,d){if(this._profileProviders.has(s))throw new Error(`Terminal profile provider "${s}" already registered`);return this._profileProviders.set(s,d),this._proxy.$registerProfileProvider(s,g.identifier.value),new D.Disposable(()=>{this._profileProviders.delete(s),this._proxy.$unregisterProfileProvider(s)})}async $createContributedProfileTerminal(g,s){const d=new i.CancellationTokenSource().token;let p=await this._profileProviders.get(g)?.provideTerminalProfile(d);if(!d.isCancellationRequested){if(p&&!("options"in p)&&(p={options:p}),!p||!("options"in p))throw new Error(`No terminal profile options provided for id "${g}"`);if("pty"in p.options){this.createExtensionTerminal(p.options,s);return}this.createTerminalFromOptions(p.options,s)}}async $provideLinks(g,s){const d=this._getTerminalById(g);if(!d)return[];this._terminalLinkCache.delete(g);const p=this._terminalLinkCancellationSource.get(g);p&&p.dispose(!0);const w=new i.CancellationTokenSource;this._terminalLinkCancellationSource.set(g,w);const v=[],k={terminal:d.value,line:s},L=[];for(const U of this._linkProviders)L.push(M.Promises.withAsyncBody(async j=>{w.token.onCancellationRequested(()=>j({provider:U,links:[]}));const H=await U.provideTerminalLinks(k,w.token)||[];w.token.isCancellationRequested||j({provider:U,links:H})}));const E=await Promise.all(L);if(w.token.isCancellationRequested)return[];const O=new Map;for(const U of E)U&&U.links.length>0&&v.push(...U.links.map(j=>{const H={id:u++,startIndex:j.startIndex,length:j.length,label:j.tooltip};return O.set(H.id,{provider:U.provider,link:j}),H}));return this._terminalLinkCache.set(g,O),v}$activateLink(g,s){const d=this._terminalLinkCache.get(g)?.get(s);!d||d.provider.handleTerminalLink(d.link)}_onProcessExit(g,s){this._bufferer.stopBuffering(g),this._terminalProcesses.delete(g),delete this._extensionTerminalAwaitingStart[g];const d=this._terminalProcessDisposables[g];d&&(d.dispose(),delete this._terminalProcessDisposables[g]),this._proxy.$sendProcessExit(g,s)}_getTerminalById(g){return this._getTerminalObjectById(this._terminals,g)}_getTerminalObjectById(g,s){const d=this._getTerminalObjectIndexById(g,s);return d!==null?g[d]:null}_getTerminalObjectIndexById(g,s){let d=null;return g.some((p,w)=>p._id===s?(d=w,!0):!1),d}getEnvironmentVariableCollection(g){let s=this._environmentVariableCollections.get(g.identifier.value);return s||(s=new l,this._setEnvironmentVariableCollection(g.identifier.value,s)),s}_syncEnvironmentVariableCollection(g,s){const d=(0,b.serializeEnvironmentVariableCollection)(s.map);this._proxy.$setEnvironmentVariableCollection(g,s.persistent,d.length===0?void 0:d)}$initEnvironmentVariableCollections(g){g.forEach(s=>{const d=s[0],p=new l(s[1]);this._setEnvironmentVariableCollection(d,p)})}$acceptDefaultProfile(g,s){this._defaultProfile=g,this._defaultAutomationProfile=s}_setEnvironmentVariableCollection(g,s){this._environmentVariableCollections.set(g,s),s.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(g,s)})}};C=xe([$e(1,A.IExtHostRpcService)],C),e.BaseExtHostTerminalService=C;class l{constructor(g){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new r.Emitter,this.map=new Map(g)}get persistent(){return this._persistent}set persistent(g){this._persistent=g,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(g,s){this._setIfDiffers(g,{value:s,type:D.EnvironmentVariableMutatorType.Replace})}append(g,s){this._setIfDiffers(g,{value:s,type:D.EnvironmentVariableMutatorType.Append})}prepend(g,s){this._setIfDiffers(g,{value:s,type:D.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(g,s){const d=this.map.get(g);(!d||d.value!==s.value||d.type!==s.type)&&(this.map.set(g,s),this._onDidChangeCollection.fire())}get(g){return this.map.get(g)}forEach(g,s){this.map.forEach((d,p)=>g.call(s,p,d,this))}delete(g){this.map.delete(g),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=l;let F=class extends C{constructor(g){super(!1,g)}createTerminal(g,s,d){throw new R.NotSupportedError}createTerminalFromOptions(g,s){throw new R.NotSupportedError}};F=xe([$e(0,A.IExtHostRpcService)],F),e.WorkerExtHostTerminalService=F;function c(h){if(!(!h||typeof h=="string"))return"id"in h?{id:h.id,color:h.color}:h}function n(h){return o.ThemeColor.isThemeColor(h)?h:void 0}});var Xe=this&&this.__classPrivateFieldSet||function(ee,e,r,t,S){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!S:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?S.call(ee,r):S?S.value=r:e.set(ee,r),r},Ie=this&&this.__classPrivateFieldGet||function(ee,e,r,t){if(r==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!t:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?t:r==="a"?t.call(ee):t?t.value:e.get(ee)};define(Se[199],_e([0,1,16,21,20,4,231,92,6,27,13,36,5,14,48,8,7,167,86,66]),function(ee,e,r,t,S,P,A,I,D,T,R,b,i,f,a,o,m,M,y,_){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let C=class{constructor(k,L){this.resultsChangedEmitter=new P.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=k.getProxy(i.MainContext.MainThreadTesting),this.observer=new d(this.proxy),this.runTracker=new F(this.proxy),L.registerArgumentProcessor({processArgument:E=>E?.$mid===13?o.TestItem.toItemFromContext(E):E})}createTestController(k,L,E){if(this.controllers.has(k))throw new Error(`Attempt to insert a duplicate controller with ID "${k}"`);const O=new D.DisposableStore,U=O.add(new M.SingleUseTestCollection(k));U.root.label=L;const j=new Map,H=this.proxy,$={items:U.root.children,get label(){return L},set label(ie){L=ie,U.root.label=ie,H.$updateController(k,{label:L})},get refreshHandler(){return E},set refreshHandler(ie){E=ie,H.$updateController(k,{canRefresh:!!ie})},get id(){return k},createRunProfile:(ie,le,X,ue,ve)=>{let ge=(0,I.hash)(ie);for(;j.has(ge);)ge++;const we=new p(this.proxy,k,ge,ie,le,X,ue,ve);return j.set(ge,we),we},createTestItem(ie,le,X){return new a.TestItemImpl(k,ie,le,X)},createTestRun:(ie,le,X=!0)=>this.runTracker.createTestRun(k,U,ie,le,X),set resolveHandler(ie){U.resolveHandler=ie},get resolveHandler(){return U.resolveHandler},dispose:()=>{O.dispose()}};H.$registerTestController(k,L,!!E),O.add((0,D.toDisposable)(()=>H.$unregisterTestController(k)));const G={controller:$,collection:U,profiles:j};return this.controllers.set(k,G),O.add((0,D.toDisposable)(()=>this.controllers.delete(k))),O.add(U.onDidGenerateDiff(ie=>H.$publishDiff(k,ie))),$}createTestObserver(){return this.observer.checkout()}async runTests(k,L=S.CancellationToken.None){const E=c(k);if(!E)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const O=this.controllers.get(E.controllerId);if(!O)throw new Error("Controller not found");await this.proxy.$runTests({targets:[{testIds:k.include?.map(U=>U.id)??[O.collection.root.id],profileGroup:w[E.kind],profileId:E.profileId,controllerId:E.controllerId}],exclude:k.exclude?.map(U=>U.id)},L)}$provideFileCoverage(k,L,E){return(0,r.mapFind)(this.runTracker.trackers,U=>U.id===k?U.getCoverage(L):void 0)?.provideFileCoverage(E)??Promise.resolve([])}$resolveFileCoverage(k,L,E,O){return(0,r.mapFind)(this.runTracker.trackers,j=>j.id===k?j.getCoverage(L):void 0)?.resolveFileCoverage(E,O)??Promise.resolve([])}$configureRunProfile(k,L){this.controllers.get(k)?.profiles.get(L)?.configureHandler?.()}async $refreshTests(k,L){await this.controllers.get(k)?.controller.refreshHandler?.(L)}$publishTestResults(k){this.results=Object.freeze(k.map(L=>(0,T.deepFreeze)(o.TestResults.to(L))).concat(this.results).sort((L,E)=>E.completedAt-L.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(k,L){const E=this.controllers.get(_.TestId.fromString(k).controllerId)?.collection;E&&(await E.expand(k,L<0?1/0:L),E.flushDiff())}$acceptDiff(k){this.observer.applyDiff(k)}async $runControllerTests(k,L){const E=this.controllers.get(k.controllerId);if(!E)return;const{collection:O,profiles:U}=E,j=U.get(k.profileId);if(!j)return;const H=k.testIds.map(le=>O.tree.get(le)).filter(R.isDefined),$=k.excludeExtIds.map(le=>E.collection.tree.get(le)).filter(R.isDefined).filter(le=>H.some(X=>X.fullId.compare(le.fullId)===2));if(!H.length)return;const G=new m.TestRunRequest(H.some(le=>le.actual instanceof a.TestItemRootImpl)?void 0:H.map(le=>le.actual),$.map(le=>le.actual),j),ie=this.runTracker.prepareForMainThreadTestRun(G,n.fromInternal(k,E.collection),L);try{await j.runHandler(G,L)}finally{ie.isRunning&&!L.isCancellationRequested&&await P.Event.toPromise(ie.onEnd),ie.dispose()}}$cancelExtensionTestRun(k){k===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(k)}};C=xe([$e(0,f.IExtHostRpcService)],C),e.ExtHostTesting=C;class l extends D.Disposable{constructor(k,L,E){super();this.dto=k,this.proxy=L,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new P.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new S.CancellationTokenSource(E)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:O}of this.tasks.values())O.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(k){return this.tasks.get(k)?.coverage}createRun(k){const L=this.dto.id,E=this.dto.controllerId,O=(0,b.generateUuid)(),U=new h(this.proxy,L,O),j=ie=>(le,...X)=>{if($){console.warn(`Setting the state of test "${le.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(le)||(this.ensureTestIsKnown(le),ie(le,...X))},H=(ie,le)=>{const X=le instanceof Array?le.map(o.TestMessage.from):[o.TestMessage.from(le)];if(ie.uri&&ie.range){const ue={range:o.Range.from(ie.range),uri:ie.uri};for(const ve of X)ve.location=ve.location||ue}this.proxy.$appendTestMessagesInRun(L,O,_.TestId.fromExtHostTestItem(ie,E).toString(),X)};let $=!1;const G={isPersisted:this.dto.isPersisted,token:this.cts.token,name:k,get coverageProvider(){return U.coverageProvider},set coverageProvider(ie){U.coverageProvider=ie},enqueued:j(ie=>{this.proxy.$updateTestStateInRun(L,O,_.TestId.fromExtHostTestItem(ie,E).toString(),1)}),skipped:j(ie=>{this.proxy.$updateTestStateInRun(L,O,_.TestId.fromExtHostTestItem(ie,E).toString(),5)}),started:j(ie=>{this.proxy.$updateTestStateInRun(L,O,_.TestId.fromExtHostTestItem(ie,E).toString(),2)}),errored:j((ie,le,X)=>{H(ie,le),this.proxy.$updateTestStateInRun(L,O,_.TestId.fromExtHostTestItem(ie,E).toString(),6,X)}),failed:j((ie,le,X)=>{H(ie,le),this.proxy.$updateTestStateInRun(L,O,_.TestId.fromExtHostTestItem(ie,E).toString(),4,X)}),passed:j((ie,le)=>{this.proxy.$updateTestStateInRun(L,O,_.TestId.fromExtHostTestItem(ie,this.dto.controllerId).toString(),3,le)}),appendOutput:(ie,le,X)=>{$||(X&&(this.dto.isIncluded(X)?this.ensureTestIsKnown(X):X=void 0),this.proxy.$appendOutputToRun(L,O,t.VSBuffer.fromString(ie),le&&o.location.from(le),X&&_.TestId.fromExtHostTestItem(X,E).toString()))},end:()=>{$||($=!0,this.proxy.$finishedTestRunTask(L,O),this.tasks.delete(O),this.isRunning||this.dispose())}};return this.tasks.set(O,{run:G,coverage:U}),this.proxy.$startedTestRunTask(L,{id:O,name:k,running:!0}),G}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(k){if(!(k instanceof a.TestItemImpl))throw new a.InvalidTestItemError(k.id);if(this.sharedTestIds.has(_.TestId.fromExtHostTestItem(k,this.dto.controllerId).toString()))return;const L=[],E=this.dto.colllection.root;for(;;){const O=o.TestItem.from(k);if(L.unshift(O),this.sharedTestIds.has(O.extId)||(this.sharedTestIds.add(O.extId),k===E))break;k=k.parent||E}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,L)}}class F{constructor(k){this.proxy=k,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(k,L,E){return this.getTracker(k,L,E)}cancelRunById(k){for(const L of this.tracked.values())if(L.id===k){L.dispose();return}}cancelAllRuns(){for(const k of this.tracked.values())k.dispose()}createTestRun(k,L,E,O,U){const j=this.tracked.get(E);if(j)return j.createRun(O);const H=n.fromPublic(k,L,E,U),$=c(E);this.proxy.$startedExtensionTestRun({controllerId:k,profile:$&&{group:w[$.kind],id:$.profileId},exclude:E.exclude?.map(ie=>ie.id)??[],id:H.id,include:E.include?.map(ie=>ie.id)??[L.root.id],persist:U});const G=this.getTracker(E,H);return G.onEnd(()=>this.proxy.$finishedExtensionTestRun(H.id)),G.createRun(O)}getTracker(k,L,E){const O=new l(L,this.proxy,E);return this.tracked.set(k,O),O.onEnd(()=>this.tracked.delete(k)),O}}e.TestRunCoordinator=F;const c=v=>{if(!!v.profile){if(!(v.profile instanceof p))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return v.profile}};class n{constructor(k,L,E,O,U,j){this.controllerId=k,this.id=L,this.isPersisted=U,this.colllection=j,this.includePrefix=E.map(H=>H+"\0"),this.excludePrefix=O.map(H=>H+"\0")}static fromPublic(k,L,E,O){return new n(k,(0,b.generateUuid)(),E.include?.map(U=>_.TestId.fromExtHostTestItem(U,k).toString())??[k],E.exclude?.map(U=>_.TestId.fromExtHostTestItem(U,k).toString())??[],O,L)}static fromInternal(k,L){return new n(k.controllerId,k.runId,k.testIds,k.excludeExtIds,!0,L)}isIncluded(k){const L=_.TestId.fromExtHostTestItem(k,this.controllerId).toString()+"\0";for(const E of this.excludePrefix)if(L===E||L.startsWith(E))return!1;for(const E of this.includePrefix)if(L===E||L.startsWith(E))return!0;return!1}}e.TestRunDto=n;class h{constructor(k,L,E){this.proxy=k,this.runId=L,this.taskId=E}set coverageProvider(k){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!k||(this._coverageProvider=k,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(k){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(k))());try{return(await this.fileCoverage)?.map(o.TestCoverage.fromFile)??[]}catch(L){throw this.fileCoverage=void 0,L}}async resolveFileCoverage(k,L){const E=await this.fileCoverage;let O=E?.[k];return!this._coverageProvider||!E||!O?[]:(O.detailedCoverage||(O=E[k]=await this._coverageProvider.resolveFileCoverage?.(O,L)??O),O.detailedCoverage?.map(o.TestCoverage.fromDetailed)??[])}}class g extends y.IncrementalChangeCollector{constructor(k){super();this.emitter=k,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(k){this.added.add(k)}update(k){Object.assign(k.revived,o.TestItem.toPlain(k.item)),this.added.has(k)||this.updated.add(k)}remove(k){if(this.added.has(k)){this.added.delete(k);return}if(this.updated.delete(k),k.parent&&this.alreadyRemoved.has(k.parent)){this.alreadyRemoved.add(k.item.extId);return}this.removed.add(k)}getChangeEvent(){const{added:k,updated:L,removed:E}=this;return{get added(){return[...k].map(O=>O.revived)},get updated(){return[...L].map(O=>O.revived)},get removed(){return[...E].map(O=>O.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class s extends y.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new P.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(k){return this.items.get(k)}getMirroredTestDataByReference(k){return this.items.get(k.id)}createItem(k,L){return{...k,revived:o.TestItem.toPlain(k.item),depth:L?L.depth+1:0,children:new Set}}createChangeCollector(){return new g(this.changeEmitter)}}e.MirroredTestCollection=s;class d{constructor(k){this.proxy=k}checkout(){this.current||(this.current=this.createObserverData());const k=this.current;return k.observers++,{onDidChangeTest:k.tests.onDidChangeTests,get tests(){return[...k.tests.rootTests].map(L=>L.revived)},dispose:(0,A.once)(()=>{--k.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(k){return this.current?.tests.getMirroredTestDataByReference(k)}applyDiff(k){this.current?.tests.apply(k)}createObserverData(){const k=new s;return this.proxy.$subscribeToDiffs(),{observers:0,tests:k}}}class p{constructor(k,L,E,O,U,j,H=!1,$=void 0){this.controllerId=L,this.profileId=E,this._label=O,this.kind=U,this.runHandler=j,this._isDefault=H,this._tag=$,u.set(this,void 0),Xe(this,u,k,"f");const G=w[U];if(typeof G!="number")throw new Error(`Unknown TestRunProfile.group ${U}`);Ie(this,u,"f").$publishTestRunProfile({profileId:E,controllerId:L,tag:$?o.TestTag.namespace(this.controllerId,$.id):null,label:O,group:G,isDefault:H,hasConfigurationHandler:!1})}get label(){return this._label}set label(k){k!==this._label&&(this._label=k,Ie(this,u,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:k}))}get isDefault(){return this._isDefault}set isDefault(k){k!==this._isDefault&&(this._isDefault=k,Ie(this,u,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:k}))}get tag(){return this._tag}set tag(k){k?.id!==this._tag?.id&&(this._tag=k,Ie(this,u,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:k?o.TestTag.namespace(this.controllerId,k.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(k){k!==this._configureHandler&&(this._configureHandler=k,Ie(this,u,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!k}))}dispose(){Ie(this,u,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=p,u=new WeakMap;const w={[m.TestRunProfileKind.Coverage]:8,[m.TestRunProfileKind.Debug]:4,[m.TestRunProfileKind.Run]:2}}),define(Se[200],_e([0,1,4,16,5,90,8,7]),function(ee,e,r,t,S,P,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class D{constructor(R,b){this._extHostDocumentsAndEditors=b,this._onDidChangeTextEditorSelection=new r.Emitter,this._onDidChangeTextEditorOptions=new r.Emitter,this._onDidChangeTextEditorVisibleRanges=new r.Emitter,this._onDidChangeTextEditorViewColumn=new r.Emitter,this._onDidChangeActiveTextEditor=new r.Emitter,this._onDidChangeVisibleTextEditors=new r.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=R.getProxy(S.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(i=>this._onDidChangeVisibleTextEditors.fire(i)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(i=>this._onDidChangeActiveTextEditor.fire(i))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(R){const b=this._extHostDocumentsAndEditors.allEditors();return R?b:b.map(i=>i.value)}async showTextDocument(R,b,i){let f;typeof b=="number"?f={position:A.ViewColumn.from(b),preserveFocus:i}:typeof b=="object"?f={position:A.ViewColumn.from(b.viewColumn),preserveFocus:b.preserveFocus,selection:typeof b.selection=="object"?A.Range.from(b.selection):void 0,pinned:typeof b.preview=="boolean"?!b.preview:void 0}:f={preserveFocus:!1};const a=await this._proxy.$tryShowTextDocument(R.uri,f),o=a&&this._extHostDocumentsAndEditors.getEditor(a);if(o)return o.value;throw a?new Error(`Could NOT open editor for "${R.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${R.uri.toString()}".`)}createTextEditorDecorationType(R,b){return new P.TextEditorDecorationType(this._proxy,R,b).value}$acceptEditorPropertiesChanged(R,b){const i=this._extHostDocumentsAndEditors.getEditor(R);if(!i)throw new Error("unknown text editor");if(b.options&&i._acceptOptions(b.options),b.selections){const f=b.selections.selections.map(A.Selection.to);i._acceptSelections(f)}if(b.visibleRanges){const f=t.coalesce(b.visibleRanges.map(A.Range.to));i._acceptVisibleRanges(f)}if(b.options&&this._onDidChangeTextEditorOptions.fire({textEditor:i.value,options:{...b.options,lineNumbers:A.TextEditorLineNumbersStyle.to(b.options.lineNumbers)}}),b.selections){const f=I.TextEditorSelectionChangeKind.fromValue(b.selections.source),a=b.selections.selections.map(A.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:i.value,selections:a,kind:f})}if(b.visibleRanges){const f=t.coalesce(b.visibleRanges.map(A.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:i.value,visibleRanges:f})}}$acceptEditorPositionData(R){for(const b in R){const i=this._extHostDocumentsAndEditors.getEditor(b);if(!i)throw new Error("Unknown text editor");const f=A.ViewColumn.to(R[b]);i.value.viewColumn!==f&&(i._acceptViewColumn(f),this._onDidChangeTextEditorViewColumn.fire({textEditor:i.value,viewColumn:f}))}}getDiffInformation(R){return Promise.resolve(this._proxy.$getDiffInformation(R))}}e.ExtHostEditors=D}),define(Se[201],_e([0,1,2,3,5,6,7]),function(ee,e,r,t,S,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,t.createDecorator)("IExtHostTimeline");class I{constructor(R,b){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=R.getProxy(S.MainContext.MainThreadTimeline),b.registerArgumentProcessor({processArgument:i=>{if(i&&i.$mid===11){const f=i.uri===void 0?void 0:r.URI.revive(i.uri);return this._itemsBySourceAndUriMap.get(i.source)?.get(D(f))?.get(i.handle)}return i}})}async $getTimeline(R,b,i,f,a){return this._providers.get(R)?.provideTimeline(r.URI.revive(b),i,f,a)}registerTimelineProvider(R,b,i,f){const a=new P.DisposableStore,o=this.convertTimelineItem(b.id,f,a).bind(this);let m;b.onDidChange&&(m=b.onDidChange(y=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...y,id:b.id}),this));const M=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...b,scheme:R,onDidChange:void 0,async provideTimeline(y,_,u,C){C?.resetCache&&(a.clear(),M.get(b.id)?.clear());const l=await b.provideTimeline(y,_,u);if(l==null)return;const F=o(y,C);return{...l,source:b.id,items:l.items.map(F)}},dispose(){for(const y of M.values())y.get(b.id)?.clear();m?.dispose(),a.dispose()}})}convertTimelineItem(R,b,i){return(f,a)=>{let o;if(a?.cacheResults){let m=this._itemsBySourceAndUriMap.get(R);m===void 0&&(m=new Map,this._itemsBySourceAndUriMap.set(R,m));const M=D(f);o=m.get(M),o===void 0&&(o=new Map,m.set(M,o))}return m=>{const{iconPath:M,...y}=m,_=`${R}|${m.id??m.timestamp}`;o?.set(_,m);let u,C,l;return m.iconPath&&(M instanceof A.ThemeIcon?l={id:M.id,color:M.color}:r.URI.isUri(M)?(u=M,C=M):{light:u,dark:C}=M),{...y,id:y.id??void 0,handle:_,source:R,command:m.command?b.toInternal(m.command,i):void 0,icon:u,iconDark:C,themeIcon:l,accessibilityInformation:m.accessibilityInformation}}}}registerTimelineProviderCore(R){if(this._providers.get(R.id))throw new Error(`Timeline Provider ${R.id} already exists.`);return this._proxy.$registerTimelineProvider({id:R.id,label:R.label,scheme:R.scheme}),this._providers.set(R.id,R),(0,P.toDisposable)(()=>{for(const i of this._itemsBySourceAndUriMap.values())i.get(R.id)?.clear();this._providers.delete(R.id),this._proxy.$unregisterTimelineProvider(R.id),R.dispose()})}}e.ExtHostTimeline=I;function D(T){return T?.toString()}}),define(Se[202],_e([0,1,6,11,2,5]),function(ee,e,r,t,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class A{constructor(D){this._openers=new Map,this._proxy=D.getProxy(P.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(D,T,R,b){if(this._openers.has(T))throw new Error(`Opener with id '${T}' already registered`);const i=b.schemes.find(f=>!A.supportedSchemes.has(f));if(i)throw new Error(`Scheme '${i}' is not supported. Only http and https are currently supported.`);return this._openers.set(T,R),this._proxy.$registerUriOpener(T,b.schemes,D,b.label),(0,r.toDisposable)(()=>{this._openers.delete(T),this._proxy.$unregisterUriOpener(T)})}async $canOpenUri(D,T,R){const b=this._openers.get(D);if(!b)throw new Error(`Unknown opener with id: ${D}`);const i=S.URI.revive(T);return b.canOpenExternalUri(i,R)}async $openUri(D,T,R){const b=this._openers.get(D);if(!b)throw new Error(`Unknown opener id: '${D}'`);return b.openExternalUri(S.URI.revive(T.resolvedUri),{sourceUri:S.URI.revive(T.sourceUri)},R)}}e.ExtHostUriOpeners=A,A.supportedSchemes=new Set([t.Schemas.http,t.Schemas.https])}),define(Se[203],_e([0,1,5,2,6,15,25]),function(ee,e,r,t,S,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class I{constructor(T){this.handles=new Set,this.handlers=new Map,this._proxy=T.getProxy(r.MainContext.MainThreadUrls)}registerUriHandler(T,R){if(this.handles.has(A.ExtensionIdentifier.toKey(T)))throw new Error(`Protocol handler already registered for extension ${T}`);const b=I.HandlePool++;return this.handles.add(A.ExtensionIdentifier.toKey(T)),this.handlers.set(b,R),this._proxy.$registerUriHandler(b,T),(0,S.toDisposable)(()=>{this.handles.delete(A.ExtensionIdentifier.toKey(T)),this.handlers.delete(b),this._proxy.$unregisterUriHandler(b)})}$handleExternalUri(T,R){const b=this.handlers.get(T);if(!b)return Promise.resolve(void 0);try{b.handleUri(t.URI.revive(R))}catch(i){(0,P.onUnexpectedError)(i)}return Promise.resolve(void 0)}async createAppUri(T){return t.URI.revive(await this._proxy.$createAppUri(T))}}e.ExtHostUrls=I,I.HandlePool=0});var Xe=this&&this.__classPrivateFieldSet||function(ee,e,r,t,S){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!S:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?S.call(ee,r):S?S.value=r:e.set(ee,r),r},Ie=this&&this.__classPrivateFieldGet||function(ee,e,r,t){if(r==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!t:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?t:r==="a"?t.call(ee):t?t.value:e.get(ee)};define(Se[51],_e([0,1,4,11,2,131,151,65,5]),function(ee,e,r,t,S,P,A,I,D){"use strict";var T,R,b,i,f,a,o,m,M,y,_,u;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class C{constructor(d,p,w,v,k,L,E){T.set(this,void 0),R.set(this,void 0),b.set(this,void 0),i.set(this,void 0),f.set(this,void 0),a.set(this,void 0),o.set(this,""),m.set(this,void 0),M.set(this,!1),y.set(this,!1),_.set(this,!1),this._onMessageEmitter=new r.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,u.set(this,new r.Emitter),this._onDidDispose=Ie(this,u,"f").event,Xe(this,T,d,"f"),Xe(this,R,p,"f"),Xe(this,m,w,"f"),Xe(this,i,v,"f"),Xe(this,f,k,"f"),Xe(this,a,L,"f"),Xe(this,_,l(L),"f"),Xe(this,b,E,"f")}dispose(){Xe(this,M,!0,"f"),Ie(this,u,"f").fire(),Ie(this,u,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(d){return Xe(this,y,!0,"f"),(0,I.asWebviewUri)(d,Ie(this,i,"f").remote)}get cspSource(){const d=Ie(this,a,"f").extensionLocation;if(d.scheme===t.Schemas.https||d.scheme===t.Schemas.http){let p=d.toString();return p.endsWith("/")||(p+="/"),p+" "+I.webviewGenericCspSource}return I.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Ie(this,o,"f")}set html(d){this.assertNotDisposed(),Ie(this,o,"f")!==d&&(Xe(this,o,d,"f"),!Ie(this,y,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(d)&&(Xe(this,y,!0,"f"),Ie(this,b,"f").report("Webview vscode-resource: uris",Ie(this,a,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Ie(this,R,"f").$setHtml(Ie(this,T,"f"),d))}get options(){return this.assertNotDisposed(),Ie(this,m,"f")}set options(d){this.assertNotDisposed(),Ie(this,R,"f").$setOptions(Ie(this,T,"f"),n(Ie(this,a,"f"),Ie(this,f,"f"),d)),Xe(this,m,d,"f")}async postMessage(d){if(Ie(this,M,"f"))return!1;const p=(0,A.serializeWebviewMessage)(d,{serializeBuffersForPostMessage:Ie(this,_,"f")});return Ie(this,R,"f").$postMessage(Ie(this,T,"f"),p.message,...p.buffers)}assertNotDisposed(){if(Ie(this,M,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=C,T=new WeakMap,R=new WeakMap,b=new WeakMap,i=new WeakMap,f=new WeakMap,a=new WeakMap,o=new WeakMap,m=new WeakMap,M=new WeakMap,y=new WeakMap,_=new WeakMap,u=new WeakMap;function l(s){try{const d=(0,P.normalizeVersion)((0,P.parseVersion)(s.engines.vscode));return!!d&&d.majorBase>=1&&d.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=l;class F{constructor(d,p,w,v,k){this.initData=p,this.workspace=w,this._logService=v,this._deprecationService=k,this._webviews=new Map,this._webviewProxy=d.getProxy(D.MainContext.MainThreadWebviews)}$onMessage(d,p,w){const v=this.getWebview(d);if(v){const{message:k}=(0,A.deserializeWebviewMessage)(p,w.value);v._onMessageEmitter.fire(k)}}$onMissingCsp(d,p){this._logService.warn(`${p} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(d,p,w){const v=new C(d,this._webviewProxy,h(p),this.initData,this.workspace,w,this._deprecationService);return this._webviews.set(d,v),v._onDidDispose(()=>{this._webviews.delete(d)}),v}deleteWebview(d){this._webviews.delete(d)}getWebview(d){return this._webviews.get(d)}}e.ExtHostWebviews=F;function c(s){return{id:s.identifier,location:s.extensionLocation}}e.toExtensionData=c;function n(s,d,p){return{enableCommandUris:p.enableCommandUris,enableScripts:p.enableScripts,enableForms:p.enableForms,portMapping:p.portMapping,localResourceRoots:p.localResourceRoots||g(s,d)}}e.serializeWebviewOptions=n;function h(s){return{enableCommandUris:s.enableCommandUris,enableScripts:s.enableScripts,enableForms:s.enableForms,portMapping:s.portMapping,localResourceRoots:s.localResourceRoots?.map(d=>S.URI.from(d))}}e.reviveOptions=h;function g(s,d){return[...(d?.getWorkspaceFolders()||[]).map(p=>p.uri),s.extensionLocation]}}),define(Se[204],_e([0,1,20,92,6,11,24,2,8,51,62,5,7]),function(ee,e,r,t,S,P,A,I,D,T,R,b,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class f{constructor(l,F){this.document=l,this._storagePath=F,this._backupCounter=1,this._edits=new R.Cache("custom documents")}addEdit(l){return this._edits.add([l])}async undo(l,F){await this.getEdit(l).undo(),F||this.disposeBackup()}async redo(l,F){await this.getEdit(l).redo(),F||this.disposeBackup()}disposeEdits(l){for(const F of l)this._edits.delete(F)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const l=u(this.document.uri)+this._backupCounter++;return(0,A.joinPath)(this._storagePath,l)}updateBackup(l){this._backup?.delete(),this._backup=l}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(l){const F=this._edits.get(l,0);if(!F)throw new Error("No edit found");return F}}class a{constructor(){this._documents=new Map}get(l,F){return this._documents.get(this.key(l,F))}add(l,F,c){const n=this.key(l,F.uri);if(this._documents.has(n))throw new Error(`Document already exists for viewType:${l} resource:${F.uri}`);const h=new f(F,c);return this._documents.set(n,h),h}delete(l,F){const c=this.key(l,F.uri);this._documents.delete(c)}key(l,F){return`${l}@@@${F}`}}var o;(function(C){C[C.Text=0]="Text",C[C.Custom=1]="Custom"})(o||(o={}));class m{constructor(){this._providers=new Map}addTextProvider(l,F,c){return this.add(0,l,F,c)}addCustomProvider(l,F,c){return this.add(1,l,F,c)}get(l){return this._providers.get(l)}add(l,F,c,n){if(this._providers.has(F))throw new Error(`Provider for viewType:${F} already registered`);return this._providers.set(F,{type:l,extension:c,provider:n}),new i.Disposable(()=>this._providers.delete(F))}}class M{constructor(l,F,c,n,h){this._extHostDocuments=F,this._extensionStoragePaths=c,this._extHostWebview=n,this._extHostWebviewPanels=h,this._editorProviders=new m,this._documents=new a,this._proxy=l.getProxy(b.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(l,F,c,n){const h=new S.DisposableStore;return y(c)?(h.add(this._editorProviders.addTextProvider(F,l,c)),this._proxy.$registerTextEditorProvider((0,T.toExtensionData)(l),F,n.webviewOptions||{},{supportsMove:!!c.moveCustomTextEditor},(0,T.shouldSerializeBuffersForPostMessage)(l))):(h.add(this._editorProviders.addCustomProvider(F,l,c)),this.supportEditing(c)&&h.add(c.onDidChangeCustomDocument(g=>{const s=this.getCustomDocumentEntry(F,g.document.uri);if(_(g)){const d=s.addEdit(g);this._proxy.$onDidEdit(g.document.uri,F,d,g.label)}else this._proxy.$onContentChange(g.document.uri,F)})),this._proxy.$registerCustomEditorProvider((0,T.toExtensionData)(l),F,n.webviewOptions||{},!!n.supportsMultipleEditorsPerDocument,(0,T.shouldSerializeBuffersForPostMessage)(l))),i.Disposable.from(h,new i.Disposable(()=>{this._proxy.$unregisterEditorProvider(F)}))}async $createCustomDocument(l,F,c,n,h){const g=this._editorProviders.get(F);if(!g)throw new Error(`No provider found for '${F}'`);if(g.type!==1)throw new Error(`Invalid provide type for '${F}'`);const s=I.URI.revive(l),d=await g.provider.openCustomDocument(s,{backupId:c,untitledDocumentData:n?.buffer},h);let p;return this.supportEditing(g.provider)&&this._extensionStoragePaths&&(p=this._extensionStoragePaths.workspaceValue(g.extension)??this._extensionStoragePaths.globalValue(g.extension)),this._documents.add(F,d,p),{editable:this.supportEditing(g.provider)}}async $disposeCustomDocument(l,F){const c=this._editorProviders.get(F);if(!c)throw new Error(`No provider found for '${F}'`);if(c.type!==1)throw new Error(`Invalid provider type for '${F}'`);const n=I.URI.revive(l),{document:h}=this.getCustomDocumentEntry(F,n);this._documents.delete(F,h),h.dispose()}async $resolveWebviewEditor(l,F,c,n,h,g){const s=this._editorProviders.get(c);if(!s)throw new Error(`No provider found for '${c}'`);const d=D.ViewColumn.to(h),p=this._extHostWebview.createNewWebview(F,n.webviewOptions,s.extension),w=this._extHostWebviewPanels.createNewWebviewPanel(F,c,n.title,d,n.panelOptions,p),v=I.URI.revive(l);switch(s.type){case 1:{const{document:k}=this.getCustomDocumentEntry(c,v);return s.provider.resolveCustomEditor(k,w,g)}case 0:{const k=this._extHostDocuments.getDocument(v);return s.provider.resolveCustomTextEditor(k,w,g)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(l,F,c){this.getCustomDocumentEntry(F,l).disposeEdits(c)}async $onMoveCustomEditor(l,F,c){const n=this._editorProviders.get(c);if(!n)throw new Error(`No provider found for '${c}'`);if(!n.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${c}'`);const h=this._extHostWebviewPanels.getWebviewPanel(l);if(!h)throw new Error("No webview found");const g=I.URI.revive(F),s=this._extHostDocuments.getDocument(g);await n.provider.moveCustomTextEditor(s,h,r.CancellationToken.None)}async $undo(l,F,c,n){return this.getCustomDocumentEntry(F,l).undo(c,n)}async $redo(l,F,c,n){return this.getCustomDocumentEntry(F,l).redo(c,n)}async $revert(l,F,c){const n=this.getCustomDocumentEntry(F,l);await this.getCustomEditorProvider(F).revertCustomDocument(n.document,c),n.disposeBackup()}async $onSave(l,F,c){const n=this.getCustomDocumentEntry(F,l);await this.getCustomEditorProvider(F).saveCustomDocument(n.document,c),n.disposeBackup()}async $onSaveAs(l,F,c,n){const h=this.getCustomDocumentEntry(F,l);return this.getCustomEditorProvider(F).saveCustomDocumentAs(h.document,I.URI.revive(c),n)}async $backup(l,F,c){const n=this.getCustomDocumentEntry(F,l),g=await this.getCustomEditorProvider(F).backupCustomDocument(n.document,{destination:n.getNewBackupUri()},c);return n.updateBackup(g),g.id}getCustomDocumentEntry(l,F){const c=this._documents.get(l,I.URI.revive(F));if(!c)throw new Error("No custom document found");return c}getCustomEditorProvider(l){const c=this._editorProviders.get(l)?.provider;if(!c||!this.supportEditing(c))throw new Error("Custom document is not editable");return c}supportEditing(l){return!!l.onDidChangeCustomDocument}}e.ExtHostCustomEditors=M;function y(C){return typeof C.resolveCustomTextEditor=="function"}function _(C){return typeof C.undo=="function"&&typeof C.redo=="function"}function u(C){const l=C.scheme===P.Schemas.file||C.scheme===P.Schemas.untitled?C.fsPath:C.toString();return(0,t.hash)(l)+""}});var Xe=this&&this.__classPrivateFieldSet||function(ee,e,r,t,S){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!S:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?S.call(ee,r):S?S.value=r:e.set(ee,r),r},Ie=this&&this.__classPrivateFieldGet||function(ee,e,r,t){if(r==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!t:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?t:r==="a"?t.call(ee):t?t.value:e.get(ee)};define(Se[205],_e([0,1,4,6,2,36,8,51,5,7]),function(ee,e,r,t,S,P,A,I,D,T){"use strict";var R,b,i,f,a,o,m,M,y,_,u,C,l;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class F extends t.Disposable{constructor(g,s,d,p,w,v,k){super();R.set(this,void 0),b.set(this,void 0),i.set(this,void 0),f.set(this,void 0),a.set(this,void 0),o.set(this,void 0),m.set(this,void 0),M.set(this,void 0),y.set(this,!0),_.set(this,!0),u.set(this,!1),C.set(this,this._register(new r.Emitter)),this.onDidDispose=Ie(this,C,"f").event,l.set(this,this._register(new r.Emitter)),this.onDidChangeViewState=Ie(this,l,"f").event,Xe(this,R,g,"f"),Xe(this,b,s,"f"),Xe(this,i,d,"f"),Xe(this,a,v,"f"),Xe(this,M,w,"f"),Xe(this,o,p,"f"),Xe(this,f,k,"f")}dispose(){Ie(this,u,"f")||(Xe(this,u,!0,"f"),Ie(this,C,"f").fire(),Ie(this,b,"f").$disposeWebview(Ie(this,R,"f")),Ie(this,f,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Ie(this,f,"f")}get viewType(){return this.assertNotDisposed(),Ie(this,i,"f")}get title(){return this.assertNotDisposed(),Ie(this,o,"f")}set title(g){this.assertNotDisposed(),Ie(this,o,"f")!==g&&(Xe(this,o,g,"f"),Ie(this,b,"f").$setTitle(Ie(this,R,"f"),g))}get iconPath(){return this.assertNotDisposed(),Ie(this,m,"f")}set iconPath(g){this.assertNotDisposed(),Ie(this,m,"f")!==g&&(Xe(this,m,g,"f"),Ie(this,b,"f").$setIconPath(Ie(this,R,"f"),S.URI.isUri(g)?{light:g,dark:g}:g))}get options(){return Ie(this,a,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Ie(this,M,"f")=="number"&&Ie(this,M,"f")<0))return Ie(this,M,"f")}get active(){return this.assertNotDisposed(),Ie(this,_,"f")}get visible(){return this.assertNotDisposed(),Ie(this,y,"f")}_updateViewState(g){Ie(this,u,"f")||(this.active!==g.active||this.visible!==g.visible||this.viewColumn!==g.viewColumn)&&(Xe(this,_,g.active,"f"),Xe(this,y,g.visible,"f"),Xe(this,M,g.viewColumn,"f"),Ie(this,l,"f").fire({webviewPanel:this}))}reveal(g,s){this.assertNotDisposed(),Ie(this,b,"f").$reveal(Ie(this,R,"f"),{viewColumn:g?A.ViewColumn.from(g):void 0,preserveFocus:!!s})}assertNotDisposed(){if(Ie(this,u,"f"))throw new Error("Webview is disposed")}}R=new WeakMap,b=new WeakMap,i=new WeakMap,f=new WeakMap,a=new WeakMap,o=new WeakMap,m=new WeakMap,M=new WeakMap,y=new WeakMap,_=new WeakMap,u=new WeakMap,C=new WeakMap,l=new WeakMap;class c{constructor(g,s,d){this.webviews=s,this.workspace=d,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=g.getProxy(D.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,P.generateUuid)()}createWebviewPanel(g,s,d,p,w={}){const v=typeof p=="object"?p.viewColumn:p,k={viewColumn:A.ViewColumn.from(v),preserveFocus:typeof p=="object"&&!!p.preserveFocus},L=(0,I.shouldSerializeBuffersForPostMessage)(g),E=c.newHandle();this._proxy.$createWebviewPanel((0,I.toExtensionData)(g),E,s,{title:d,panelOptions:n(w),webviewOptions:(0,I.serializeWebviewOptions)(g,this.workspace,w),serializeBuffersForPostMessage:L},k);const O=this.webviews.createNewWebview(E,w,g);return this.createNewWebviewPanel(E,s,d,v,w,O)}$onDidChangeWebviewPanelViewStates(g){const s=Object.keys(g);s.sort((d,p)=>{const w=g[d],v=g[p];return w.active?1:v.active?-1:+w.visible-+v.visible});for(const d of s){const p=this.getWebviewPanel(d);if(!p)continue;const w=g[d];p._updateViewState({active:w.active,visible:w.visible,viewColumn:A.ViewColumn.to(w.position)})}}async $onDidDisposeWebviewPanel(g){this.getWebviewPanel(g)?.dispose(),this._webviewPanels.delete(g),this.webviews.deleteWebview(g)}registerWebviewPanelSerializer(g,s,d){if(this._serializers.has(s))throw new Error(`Serializer for '${s}' already registered`);return this._serializers.set(s,{serializer:d,extension:g}),this._proxy.$registerSerializer(s,{serializeBuffersForPostMessage:(0,I.shouldSerializeBuffersForPostMessage)(g)}),new T.Disposable(()=>{this._serializers.delete(s),this._proxy.$unregisterSerializer(s)})}async $deserializeWebviewPanel(g,s,d,p){const w=this._serializers.get(s);if(!w)throw new Error(`No serializer found for '${s}'`);const{serializer:v,extension:k}=w,L=this.webviews.createNewWebview(g,d.webviewOptions,k),E=this.createNewWebviewPanel(g,s,d.title,p,d.panelOptions,L);await v.deserializeWebviewPanel(E,d.state)}createNewWebviewPanel(g,s,d,p,w,v){const k=new F(g,this._proxy,s,d,p,w,v);return this._webviewPanels.set(g,k),k}getWebviewPanel(g){return this._webviewPanels.get(g)}}e.ExtHostWebviewPanels=c;function n(h){return{enableFindWidget:h.enableFindWidget,retainContextWhenHidden:h.retainContextWhenHidden}}});var Xe=this&&this.__classPrivateFieldSet||function(ee,e,r,t,S){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!S:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?S.call(ee,r):S?S.value=r:e.set(ee,r),r},Ie=this&&this.__classPrivateFieldGet||function(ee,e,r,t){if(r==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!t:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?t:r==="a"?t.call(ee):t?t.value:e.get(ee)};define(Se[206],_e([0,1,4,6,51,5,7]),function(ee,e,r,t,S,P,A){"use strict";var I,D,T,R,b,i,f,a,o,m;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class M extends t.Disposable{constructor(u,C,l,F,c,n){super();I.set(this,void 0),D.set(this,void 0),T.set(this,void 0),R.set(this,void 0),b.set(this,!1),i.set(this,void 0),f.set(this,void 0),a.set(this,void 0),o.set(this,this._register(new r.Emitter)),this.onDidChangeVisibility=Ie(this,o,"f").event,m.set(this,this._register(new r.Emitter)),this.onDidDispose=Ie(this,m,"f").event,Xe(this,T,l,"f"),Xe(this,f,F,"f"),Xe(this,I,u,"f"),Xe(this,D,C,"f"),Xe(this,R,c,"f"),Xe(this,i,n,"f")}dispose(){Ie(this,b,"f")||(Xe(this,b,!0,"f"),Ie(this,m,"f").fire(),Ie(this,R,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Ie(this,f,"f")}set title(u){this.assertNotDisposed(),Ie(this,f,"f")!==u&&(Xe(this,f,u,"f"),Ie(this,D,"f").$setWebviewViewTitle(Ie(this,I,"f"),u))}get description(){return this.assertNotDisposed(),Ie(this,a,"f")}set description(u){this.assertNotDisposed(),Ie(this,a,"f")!==u&&(Xe(this,a,u,"f"),Ie(this,D,"f").$setWebviewViewDescription(Ie(this,I,"f"),u))}get visible(){return Ie(this,i,"f")}get webview(){return Ie(this,R,"f")}get viewType(){return Ie(this,T,"f")}_setVisible(u){u===Ie(this,i,"f")||Ie(this,b,"f")||(Xe(this,i,u,"f"),Ie(this,o,"f").fire())}show(u){this.assertNotDisposed(),Ie(this,D,"f").$show(Ie(this,I,"f"),!!u)}assertNotDisposed(){if(Ie(this,b,"f"))throw new Error("Webview is disposed")}}I=new WeakMap,D=new WeakMap,T=new WeakMap,R=new WeakMap,b=new WeakMap,i=new WeakMap,f=new WeakMap,a=new WeakMap,o=new WeakMap,m=new WeakMap;class y{constructor(u,C){this._extHostWebview=C,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=u.getProxy(P.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(u,C,l,F){if(this._viewProviders.has(C))throw new Error(`View provider for '${C}' already registered`);return this._viewProviders.set(C,{provider:l,extension:u}),this._proxy.$registerWebviewViewProvider((0,S.toExtensionData)(u),C,{retainContextWhenHidden:F?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new A.Disposable(()=>{this._viewProviders.delete(C),this._proxy.$unregisterWebviewViewProvider(C)})}async $resolveWebviewView(u,C,l,F,c){const n=this._viewProviders.get(C);if(!n)throw new Error(`No view provider found for '${C}'`);const{provider:h,extension:g}=n,s=this._extHostWebview.createNewWebview(u,{},g),d=new M(u,this._proxy,C,l,s,!0);this._webviewViews.set(u,d),await h.resolveWebviewView(d,{state:F},c)}async $onDidChangeWebviewViewVisibility(u,C){this.getWebviewView(u)._setVisible(C)}async $disposeWebviewView(u){const C=this.getWebviewView(u);this._webviewViews.delete(u),C.dispose(),this._extHostWebview.deleteWebview(u)}getWebviewView(u){const C=this._webviewViews.get(u);if(!C)throw new Error("No webview found");return C}}e.ExtHostWebviewViews=y}),define(Se[94],_e([0,1,4,5,2,11,9,3,14]),function(ee,e,r,t,S,P,A,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let T=class ji{constructor(b){this._onDidChangeWindowState=new r.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=ji.InitialState,this._proxy=b.getProxy(t.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(i=>this.$onDidChangeWindowFocus(i))}get state(){return this._state}$onDidChangeWindowFocus(b){b!==this._state.focused&&(this._state={...this._state,focused:b},this._onDidChangeWindowState.fire(this._state))}openUri(b,i){let f;if(typeof b=="string"){f=b;try{b=S.URI.parse(b)}catch{return Promise.reject(`Invalid uri - '${b}'`)}}return(0,A.isFalsyOrWhitespace)(b.scheme)?Promise.reject("Invalid scheme - cannot be empty"):b.scheme===P.Schemas.command?Promise.reject(`Invalid scheme '${b.scheme}'`):this._proxy.$openUri(b,f,i)}async asExternalUri(b,i){if((0,A.isFalsyOrWhitespace)(b.scheme))return Promise.reject("Invalid scheme - cannot be empty");const f=await this._proxy.$asExternalUri(b,i);return S.URI.from(f)}};T.InitialState={focused:!0},T=xe([$e(0,D.IExtHostRpcService)],T),e.ExtHostWindow=T,e.IExtHostWindow=(0,I.createDecorator)("IExtHostWindow")}),define(Se[207],_e([0,1,10,21,20,15,4,6,105,173,38]),function(ee,e,r,t,S,P,A,I,D,T,R){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function i(w,v){try{return JSON.stringify(w,v)}catch{return"null"}}const f="$$ref$$",a={[f]:-1};class o{constructor(v,k){this.jsonString=v,this.referencedBuffers=k}}function m(w,v=null,k=!1){const L=[];return{jsonString:(k?i:JSON.stringify)(w,(O,U)=>{if(typeof U=="undefined")return a;if(typeof U=="object"){if(U instanceof t.VSBuffer){const j=L.push(U)-1;return{[f]:j}}if(v)return v(O,U)}return U}),referencedBuffers:L}}e.stringifyJsonWithBufferRefs=m;function M(w,v,k){return JSON.parse(w,(L,E)=>{if(E){const O=E[f];if(typeof O=="number")return v[O];if(k&&E.$mid===1)return k.transformIncoming(E)}return E})}e.parseJsonAndRestoreBufferRefs=M;function y(w,v){return JSON.stringify(w,v)}function _(w){return w?(v,k)=>k&&k.$mid===1?w.transformOutgoing(k):k:null}var u;(function(w){w[w.LocalSide=0]="LocalSide",w[w.OtherSide=1]="OtherSide"})(u=e.RequestInitiator||(e.RequestInitiator={}));var C;(function(w){w[w.Responsive=0]="Responsive",w[w.Unresponsive=1]="Unresponsive"})(C=e.ResponsiveState||(e.ResponsiveState={}));const l=()=>{},F=Symbol.for("rpcProtocol"),c=Symbol.for("rpcProxy");class n extends I.Disposable{constructor(v,k=null,L=null){super();this[b]=!0,this._onDidChangeResponsiveState=this._register(new A.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=v,this._logger=k,this._uriTransformer=L,this._uriReplacer=_(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let E=0,O=R.ProxyIdentifier.count;E<O;E++)this._locals[E]=null,this._proxies[E]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new r.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(E=>this._receiveOneMessage(E))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(v=>{this._pendingRPCReplies[v].resolveErr(P.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(v){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+n.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(v){this._unresponsiveTime=Date.now()+n.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(v){this._responsiveState!==v&&(this._responsiveState=v,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(v){return this._uriTransformer?(0,D.transformIncomingURIs)(v,this._uriTransformer):v}getProxy(v){const{nid:k,sid:L}=v;return this._proxies[k]||(this._proxies[k]=this._createProxy(k,L)),this._proxies[k]}_createProxy(v,k){let L={get:(E,O)=>(typeof O=="string"&&!E[O]&&O.charCodeAt(0)===36&&(E[O]=(...U)=>this._remoteCall(v,O,U)),O===c?k:E[O])};return new Proxy(Object.create(null),L)}set(v,k){return this._locals[v.nid]=k,k}assertRegistered(v){for(let k=0,L=v.length;k<L;k++){const E=v[k];if(!this._locals[E.nid])throw new Error(`Missing proxy instance ${E.sid}`)}}_receiveOneMessage(v){if(this._isDisposed)return;const k=v.byteLength,L=h.read(v,0),E=L.readUInt8(),O=L.readUInt32();switch(E){case 1:case 2:{let{rpcId:U,method:j,args:H}=s.deserializeRequestJSONArgs(L);this._uriTransformer&&(H=(0,D.transformIncomingURIs)(H,this._uriTransformer)),this._receiveRequest(k,O,U,j,H,E===2);break}case 3:case 4:{let{rpcId:U,method:j,args:H}=s.deserializeRequestMixedArgs(L);this._uriTransformer&&(H=(0,D.transformIncomingURIs)(H,this._uriTransformer)),this._receiveRequest(k,O,U,j,H,E===4);break}case 5:{this._logger&&this._logger.logIncoming(k,O,0,"ack"),this._onDidReceiveAcknowledge(O);break}case 6:{this._receiveCancel(k,O);break}case 7:{this._receiveReply(k,O,void 0);break}case 9:{let U=s.deserializeReplyOKJSON(L);this._uriTransformer&&(U=(0,D.transformIncomingURIs)(U,this._uriTransformer)),this._receiveReply(k,O,U);break}case 10:{const U=s.deserializeReplyOKJSONWithBuffers(L,this._uriTransformer);this._receiveReply(k,O,U);break}case 8:{let U=s.deserializeReplyOKVSBuffer(L);this._receiveReply(k,O,U);break}case 11:{let U=s.deserializeReplyErrError(L);this._uriTransformer&&(U=(0,D.transformIncomingURIs)(U,this._uriTransformer)),this._receiveReplyErr(k,O,U);break}case 12:{this._receiveReplyErr(k,O,void 0);break}default:console.error("received unexpected message"),console.error(v)}}_receiveRequest(v,k,L,E,O,U){this._logger&&this._logger.logIncoming(v,k,1,`receiveRequest ${(0,R.getStringIdentifierForProxy)(L)}.${E}(`,O);const j=String(k);let H,$;if(U){const ie=new S.CancellationTokenSource;O.push(ie.token),H=this._invokeHandler(L,E,O),$=()=>ie.cancel()}else H=this._invokeHandler(L,E,O),$=l;this._cancelInvokedHandlers[j]=$;const G=s.serializeAcknowledged(k);this._logger&&this._logger.logOutgoing(G.byteLength,k,1,"ack"),this._protocol.send(G),H.then(ie=>{delete this._cancelInvokedHandlers[j];const le=s.serializeReplyOK(k,ie,this._uriReplacer);this._logger&&this._logger.logOutgoing(le.byteLength,k,1,"reply:",ie),this._protocol.send(le)},ie=>{delete this._cancelInvokedHandlers[j];const le=s.serializeReplyErr(k,ie);this._logger&&this._logger.logOutgoing(le.byteLength,k,1,"replyErr:",ie),this._protocol.send(le)})}_receiveCancel(v,k){this._logger&&this._logger.logIncoming(v,k,1,"receiveCancel");const L=String(k);this._cancelInvokedHandlers[L]&&this._cancelInvokedHandlers[L]()}_receiveReply(v,k,L){this._logger&&this._logger.logIncoming(v,k,0,"receiveReply:",L);const E=String(k);if(!this._pendingRPCReplies.hasOwnProperty(E))return;const O=this._pendingRPCReplies[E];delete this._pendingRPCReplies[E],O.resolveOk(L)}_receiveReplyErr(v,k,L){this._logger&&this._logger.logIncoming(v,k,0,"receiveReplyErr:",L);const E=String(k);if(!this._pendingRPCReplies.hasOwnProperty(E))return;const O=this._pendingRPCReplies[E];delete this._pendingRPCReplies[E];let U;L&&(L.$isError?(U=new Error,U.name=L.name,U.message=L.message,U.stack=L.stack):U=L),O.resolveErr(U)}_invokeHandler(v,k,L){try{return Promise.resolve(this._doInvokeHandler(v,k,L))}catch(E){return Promise.reject(E)}}_doInvokeHandler(v,k,L){const E=this._locals[v];if(!E)throw new Error("Unknown actor "+(0,R.getStringIdentifierForProxy)(v));let O=E[k];if(typeof O!="function")throw new Error("Unknown method "+k+" on actor "+(0,R.getStringIdentifierForProxy)(v));return O.apply(E,L)}_remoteCall(v,k,L){if(this._isDisposed)return Promise.reject(P.canceled());let E=null;if(L.length>0&&S.CancellationToken.isCancellationToken(L[L.length-1])&&(E=L.pop()),E&&E.isCancellationRequested)return Promise.reject(P.canceled());const O=s.serializeRequestArguments(L,this._uriReplacer),U=++this._lastMessageId,j=String(U),H=new T.LazyPromise;E&&E.onCancellationRequested(()=>{const G=s.serializeCancel(U);this._logger&&this._logger.logOutgoing(G.byteLength,U,0,"cancel"),this._protocol.send(s.serializeCancel(U))}),this._pendingRPCReplies[j]=H,this._onWillSendRequest(U);const $=s.serializeRequest(U,v,k,O,!!E);return this._logger&&this._logger.logOutgoing($.byteLength,U,0,`request: ${(0,R.getStringIdentifierForProxy)(v)}.${k}(`,L),this._protocol.send($),H}}e.RPCProtocol=n,b=F,n.UNRESPONSIVE_TIME=3*1e3;class h{constructor(v,k){this._buff=v,this._offset=k}static alloc(v,k,L){let E=new h(t.VSBuffer.alloc(L+1+4),0);return E.writeUInt8(v),E.writeUInt32(k),E}static read(v,k){return new h(v,k)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(v){this._buff.writeUInt8(v,this._offset),this._offset+=1}readUInt8(){const v=this._buff.readUInt8(this._offset);return this._offset+=1,v}writeUInt32(v){this._buff.writeUInt32BE(v,this._offset),this._offset+=4}readUInt32(){const v=this._buff.readUInt32BE(this._offset);return this._offset+=4,v}static sizeShortString(v){return 1+v.byteLength}writeShortString(v){this._buff.writeUInt8(v.byteLength,this._offset),this._offset+=1,this._buff.set(v,this._offset),this._offset+=v.byteLength}readShortString(){const v=this._buff.readUInt8(this._offset);this._offset+=1;const L=this._buff.slice(this._offset,this._offset+v).toString();return this._offset+=v,L}static sizeLongString(v){return 4+v.byteLength}writeLongString(v){this._buff.writeUInt32BE(v.byteLength,this._offset),this._offset+=4,this._buff.set(v,this._offset),this._offset+=v.byteLength}readLongString(){const v=this._buff.readUInt32BE(this._offset);this._offset+=4;const L=this._buff.slice(this._offset,this._offset+v).toString();return this._offset+=v,L}writeBuffer(v){this._buff.writeUInt32BE(v.byteLength,this._offset),this._offset+=4,this._buff.set(v,this._offset),this._offset+=v.byteLength}static sizeVSBuffer(v){return 4+v.byteLength}writeVSBuffer(v){this._buff.writeUInt32BE(v.byteLength,this._offset),this._offset+=4,this._buff.set(v,this._offset),this._offset+=v.byteLength}readVSBuffer(){const v=this._buff.readUInt32BE(this._offset);this._offset+=4;const k=this._buff.slice(this._offset,this._offset+v);return this._offset+=v,k}static sizeMixedArray(v){let k=0;k+=1;for(let L=0,E=v.length;L<E;L++){const O=v[L];switch(k+=1,O.type){case 1:k+=this.sizeLongString(O.value);break;case 2:k+=this.sizeVSBuffer(O.value);break;case 3:k+=this.sizeUInt32,k+=this.sizeLongString(O.value);for(let U=0;U<O.buffers.length;++U)k+=this.sizeVSBuffer(O.buffers[U]);break;case 4:break}}return k}writeMixedArray(v){this._buff.writeUInt8(v.length,this._offset),this._offset+=1;for(let k=0,L=v.length;k<L;k++){const E=v[k];switch(E.type){case 1:this.writeUInt8(1),this.writeLongString(E.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(E.value);break;case 3:this.writeUInt8(3),this.writeUInt32(E.buffers.length),this.writeLongString(E.value);for(let O=0;O<E.buffers.length;++O)this.writeBuffer(E.buffers[O]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const v=this._buff.readUInt8(this._offset);this._offset+=1;let k=new Array(v);for(let L=0;L<v;L++)switch(this.readUInt8()){case 1:k[L]=this.readLongString();break;case 2:k[L]=this.readVSBuffer();break;case 3:{const O=this.readUInt32(),U=this.readLongString(),j=[];for(let H=0;H<O;++H)j.push(this.readVSBuffer());k[L]=new R.SerializableObjectWithBuffers(M(U,j,null));break}case 4:k[L]=void 0;break}return k}}h.sizeUInt32=4;var g;(function(w){w[w.Simple=0]="Simple",w[w.Mixed=1]="Mixed"})(g||(g={}));class s{static _useMixedArgSerialization(v){for(let k=0,L=v.length;k<L;k++)if(v[k]instanceof t.VSBuffer||v[k]instanceof R.SerializableObjectWithBuffers||typeof v[k]=="undefined")return!0;return!1}static serializeRequestArguments(v,k){if(this._useMixedArgSerialization(v)){const L=[];for(let E=0,O=v.length;E<O;E++){const U=v[E];if(U instanceof t.VSBuffer)L[E]={type:2,value:U};else if(typeof U=="undefined")L[E]={type:4};else if(U instanceof R.SerializableObjectWithBuffers){const{jsonString:j,referencedBuffers:H}=m(U.value,k);L[E]={type:3,value:t.VSBuffer.fromString(j),buffers:H}}else L[E]={type:1,value:t.VSBuffer.fromString(y(U,k))}}return{type:1,args:L}}return{type:0,args:y(v,k)}}static serializeRequest(v,k,L,E,O){switch(E.type){case 0:return this._requestJSONArgs(v,k,L,E.args,O);case 1:return this._requestMixedArgs(v,k,L,E.args,O)}}static _requestJSONArgs(v,k,L,E,O){const U=t.VSBuffer.fromString(L),j=t.VSBuffer.fromString(E);let H=0;H+=h.sizeUInt8(),H+=h.sizeShortString(U),H+=h.sizeLongString(j);let $=h.alloc(O?2:1,v,H);return $.writeUInt8(k),$.writeShortString(U),$.writeLongString(j),$.buffer}static deserializeRequestJSONArgs(v){const k=v.readUInt8(),L=v.readShortString(),E=v.readLongString();return{rpcId:k,method:L,args:JSON.parse(E)}}static _requestMixedArgs(v,k,L,E,O){const U=t.VSBuffer.fromString(L);let j=0;j+=h.sizeUInt8(),j+=h.sizeShortString(U),j+=h.sizeMixedArray(E);let H=h.alloc(O?4:3,v,j);return H.writeUInt8(k),H.writeShortString(U),H.writeMixedArray(E),H.buffer}static deserializeRequestMixedArgs(v){const k=v.readUInt8(),L=v.readShortString(),E=v.readMixedArray(),O=new Array(E.length);for(let U=0,j=E.length;U<j;U++){const H=E[U];typeof H=="string"?O[U]=JSON.parse(H):O[U]=H}return{rpcId:k,method:L,args:O}}static serializeAcknowledged(v){return h.alloc(5,v,0).buffer}static serializeCancel(v){return h.alloc(6,v,0).buffer}static serializeReplyOK(v,k,L){if(typeof k=="undefined")return this._serializeReplyOKEmpty(v);if(k instanceof t.VSBuffer)return this._serializeReplyOKVSBuffer(v,k);if(k instanceof R.SerializableObjectWithBuffers){const{jsonString:E,referencedBuffers:O}=m(k.value,L,!0);return this._serializeReplyOKJSONWithBuffers(v,E,O)}else return this._serializeReplyOKJSON(v,i(k,L))}static _serializeReplyOKEmpty(v){return h.alloc(7,v,0).buffer}static _serializeReplyOKVSBuffer(v,k){let L=0;L+=h.sizeVSBuffer(k);let E=h.alloc(8,v,L);return E.writeVSBuffer(k),E.buffer}static deserializeReplyOKVSBuffer(v){return v.readVSBuffer()}static _serializeReplyOKJSON(v,k){const L=t.VSBuffer.fromString(k);let E=0;E+=h.sizeLongString(L);let O=h.alloc(9,v,E);return O.writeLongString(L),O.buffer}static _serializeReplyOKJSONWithBuffers(v,k,L){const E=t.VSBuffer.fromString(k);let O=0;O+=h.sizeUInt32,O+=h.sizeLongString(E);for(const j of L)O+=h.sizeVSBuffer(j);let U=h.alloc(10,v,O);U.writeUInt32(L.length),U.writeLongString(E);for(const j of L)U.writeBuffer(j);return U.buffer}static deserializeReplyOKJSON(v){const k=v.readLongString();return JSON.parse(k)}static deserializeReplyOKJSONWithBuffers(v,k){const L=v.readUInt32(),E=v.readLongString(),O=[];for(let U=0;U<L;++U)O.push(v.readVSBuffer());return new R.SerializableObjectWithBuffers(M(E,O,k))}static serializeReplyErr(v,k){return k?this._serializeReplyErrEror(v,k):this._serializeReplyErrEmpty(v)}static _serializeReplyErrEror(v,k){const L=t.VSBuffer.fromString(i(P.transformErrorForSerialization(k),null));let E=0;E+=h.sizeLongString(L);let O=h.alloc(11,v,E);return O.writeLongString(L),O.buffer}static deserializeReplyErrError(v){const k=v.readLongString();return JSON.parse(k)}static _serializeReplyErrEmpty(v){return h.alloc(12,v,0).buffer}}var d;(function(w){w[w.RequestJSONArgs=1]="RequestJSONArgs",w[w.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",w[w.RequestMixedArgs=3]="RequestMixedArgs",w[w.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",w[w.Acknowledged=5]="Acknowledged",w[w.Cancel=6]="Cancel",w[w.ReplyOKEmpty=7]="ReplyOKEmpty",w[w.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",w[w.ReplyOKJSON=9]="ReplyOKJSON",w[w.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",w[w.ReplyErrError=11]="ReplyErrError",w[w.ReplyErrEmpty=12]="ReplyErrEmpty"})(d||(d={}));var p;(function(w){w[w.String=1]="String",w[w.VSBuffer=2]="VSBuffer",w[w.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",w[w.Undefined=4]="Undefined"})(p||(p={}))}),define(Se[208],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const r=function(P){const A=I=>{self.removeEventListener("message",A);const D=I.data;Object.defineProperties(self,{postMessage:{value(T,R){D.postMessage(T,R)}},onmessage:{get(){return D.onmessage},set(T){D.onmessage=T}}}),D.addEventListener("message",T=>{self.dispatchEvent(new MessageEvent("message",{data:T.data}))}),D.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(P)};self.addEventListener("message",A)}.toString();class t extends EventTarget{constructor(P,A,I){super();this.onmessage=null,this.onmessageerror=null,this.onerror=null;const D=`((${r})('${A}'))`,T=new Blob([D],{type:"application/javascript"}),R=URL.createObjectURL(T),b=new MessageChannel,i=R,f={type:"_newWorker",id:i,port:b.port2,url:R,options:I};P(f,[b.port2]),this.postMessage=b.port1.postMessage.bind(b.port1),this.terminate=()=>{const a={type:"_terminateWorker",id:i};b.port1.postMessage(a),URL.revokeObjectURL(R),b.port1.close(),b.port2.close()},Object.defineProperties(this,{onmessage:{get(){return b.port1.onmessage},set(a){b.port1.onmessage=a}},onmessageerror:{get(){return b.port1.onmessageerror},set(a){b.port1.onmessageerror=a}}}),b.port1.addEventListener("messageerror",a=>{const o=new MessageEvent("messageerror",{data:a.data});this.dispatchEvent(o)}),b.port1.addEventListener("message",a=>{const o=new MessageEvent("message",{data:a.data});this.dispatchEvent(o)}),b.port1.start()}}e.NestedWorker=t}),define(Se[209],_e([0,1,3]),function(ee,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,r.createDecorator)("remoteAgentService")}),define(Se[210],_e([0,1,35,11,17,23,24,2,3,60,47,168,209]),function(ee,e,r,t,S,P,A,I,D,T,R,b,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,D.createDecorator)("pathService");let f=class qi{constructor(o,m,M,y){this.localUserHome=o,this.remoteAgentService=m,this.environmentService=M,this.contextService=y,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||P.OS)(),this.resolveUserHome=(async()=>{const _=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=_?.userHome||o})()}hasValidBasename(o,m,M){return typeof m=="string"||typeof m=="undefined"?this.resolveOS.then(y=>this.doHasValidBasename(o,y,m)):this.doHasValidBasename(o,m,M)}doHasValidBasename(o,m,M){return o.scheme===t.Schemas.file||o.scheme===t.Schemas.vscodeRemote?(0,r.isValidBasename)(M??(0,A.basename)(o),m===1):!0}get defaultUriScheme(){return qi.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(o,m){if(o.remoteAuthority)return t.Schemas.vscodeRemote;const M=(0,T.getVirtualWorkspaceScheme)(m.getWorkspace());if(M)return M;const y=m.getWorkspace().folders[0];if(y)return y.uri.scheme;const _=m.getWorkspace().configuration;return _?_.scheme:t.Schemas.file}async userHome(o){return o?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(o=>o===1?S.win32:S.posix)}async fileURI(o){let m="";if(await this.resolveOS===1&&(o=o.replace(/\\/g,"/")),o[0]==="/"&&o[1]==="/"){const y=o.indexOf("/",2);y===-1?(m=o.substring(2),o="/"):(m=o.substring(2,y),o=o.substring(y)||"/")}return I.URI.from({scheme:t.Schemas.file,authority:m,path:o,query:"",fragment:""})}};f=xe([$e(1,i.IRemoteAgentService),$e(2,b.IWorkbenchEnvironmentService),$e(3,R.IWorkspaceContextService)],f),e.AbstractPathService=f}),define(Se[95],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class r{constructor(A,I){this.line=A,this.character=I}isBefore(A){return!1}isBeforeOrEqual(A){return!1}isAfter(A){return!1}isAfterOrEqual(A){return!1}isEqual(A){return!1}compareTo(A){return 0}translate(A,I){return new r(0,0)}with(A){return new r(0,0)}}e.Position=r;class t{constructor(A,I,D,T){this.isEmpty=!1,this.isSingleLine=!1,this.start=new r(A,I),this.end=new r(D,T)}contains(A){return!1}isEqual(A){return!1}intersection(A){}union(A){return new t(0,0,0,0)}with(A){return new t(0,0,0,0)}}e.Range=t;var S;(function(P){P[P.Information=1]="Information",P[P.Warning=2]="Warning"})(S=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(Se[41],_e([0,1,16,29,27,35,9,3,17,15,95,10]),function(ee,e,r,t,S,P,A,I,D,T,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return R.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const i="\u27EA ",f=" characters skipped \u27EB",a=(i.length+f.length+5)*2;e.ISearchService=(0,I.createDecorator)("searchService");var o;(function(G){G[G.file=0]="file",G[G.text=1]="text"})(o=e.SearchProviderType||(e.SearchProviderType={}));var m;(function(G){G[G.File=1]="File",G[G.Text=2]="Text"})(m=e.QueryType||(e.QueryType={}));function M(G){return!!G.preview}e.resultIsMatch=M;function y(G){return!!G.resource}e.isFileMatch=y;function _(G){return!!G.message}e.isProgressMessage=_;var u;(function(G){G[G.Normal=0]="Normal",G[G.NewSearchStarted=1]="NewSearchStarted"})(u=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class C{constructor(ie){this.resource=ie,this.results=[]}}e.FileMatch=C;class l{constructor(ie,le,X){this.ranges=le;const ue=Array.isArray(le)?le:[le];if(X&&X.matchLines===1&&F(ue)){ie=(0,A.getNLines)(ie,X.matchLines);let ve="",ge=0,we=0;const re=Math.floor(X.charsPerLine/5),be=[];for(const Pe of ue){const Fe=Math.max(Pe.startColumn-re,0),ze=Pe.startColumn+X.charsPerLine;if(Fe>we+re+a){const nt=i+(Fe-we)+f;ve+=nt+ie.slice(Fe,ze),ge+=Fe-(we+nt.length)}else ve+=ie.slice(we,ze);be.push(new n(0,Pe.startColumn-ge,Pe.endColumn-ge)),we=ze}this.preview={text:ve,matches:Array.isArray(this.ranges)?be:be[0]}}else{const ve=Array.isArray(le)?le[0].startLineNumber:le.startLineNumber;this.preview={text:ie,matches:(0,r.mapArrayOrNot)(le,ge=>new c(ge.startLineNumber-ve,ge.startColumn,ge.endLineNumber-ve,ge.endColumn))}}}}e.TextSearchMatch=l;function F(G){const ie=G[0].startLineNumber;for(const le of G)if(le.startLineNumber!==ie||le.endLineNumber!==ie)return!1;return!0}class c{constructor(ie,le,X,ue){this.startLineNumber=ie,this.startColumn=le,this.endLineNumber=X,this.endColumn=ue}}e.SearchRange=c;class n extends c{constructor(ie,le,X){super(ie,le,ie,X)}}e.OneLineRange=n;var h;(function(G){G.Default="default",G.FileNames="fileNames",G.Type="type",G.Modified="modified",G.CountDescending="countDescending",G.CountAscending="countAscending"})(h=e.SearchSortOrder||(e.SearchSortOrder={}));function g(G,ie=!0){const le=G&&G.files&&G.files.exclude,X=ie&&G&&G.search&&G.search.exclude;if(!le&&!X)return;if(!le||!X)return le||X;let ue=Object.create(null);return ue=S.mixin(ue,S.deepClone(le)),ue=S.mixin(ue,S.deepClone(X),!0),ue}e.getExcludes=g;function s(G,ie){return G.excludePattern&&t.match(G.excludePattern,ie)?!1:G.includePattern||G.usingSearchPaths?G.includePattern&&t.match(G.includePattern,ie)?!0:G.usingSearchPaths?!!G.folderQueries&&G.folderQueries.some(le=>{const X=le.folder.fsPath;if(P.isEqualOrParent(ie,X)){const ue=D.relative(X,ie);return!le.includePattern||!!t.match(le.includePattern,ue)}else return!1}):!1:!0}e.pathIncludedInQuery=s;var d;(function(G){G[G.unknownEncoding=1]="unknownEncoding",G[G.regexParseError=2]="regexParseError",G[G.globParseError=3]="globParseError",G[G.invalidLiteral=4]="invalidLiteral",G[G.rgProcessError=5]="rgProcessError",G[G.other=6]="other",G[G.canceled=7]="canceled"})(d=e.SearchErrorCode||(e.SearchErrorCode={}));class p extends Error{constructor(ie,le){super(ie);this.code=le}}e.SearchError=p;function w(G){const ie=G.message;if((0,T.isCancellationError)(G))return new p(ie,d.canceled);try{const le=JSON.parse(ie);return new p(le.message,le.code)}catch{return new p(ie,d.other)}}e.deserializeSearchError=w;function v(G){const ie={message:G.message,code:G.code};return new Error(JSON.stringify(ie))}e.serializeSearchError=v;function k(G){return G.type==="error"?!0:G.type==="success"}e.isSerializedSearchComplete=k;function L(G){return G.type==="success"}e.isSerializedSearchSuccess=L;function E(G){return!!G.path}e.isSerializedFileMatch=E;function O(G,ie){const le=G.searchPath?G.searchPath:G.relativePath;return(0,A.fuzzyContains)(le,ie)}e.isFilePatternMatch=O;class U{constructor(ie){this.path=ie,this.results=[]}addMatch(ie){this.results.push(ie)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=U;function j(G,ie){const le={...G||{},...ie||{}};return Object.keys(le).filter(X=>{const ue=le[X];return typeof ue=="boolean"&&ue})}e.resolvePatternsForProvider=j;class H{constructor(ie,le){this._parsedIncludeExpression=null,this._excludeExpression={...ie.excludePattern||{},...le.excludePattern||{}},this._parsedExcludeExpression=t.parse(this._excludeExpression);let X=ie.includePattern;le.includePattern&&(X?X={...X,...le.includePattern}:X=le.includePattern),X&&(this._parsedIncludeExpression=t.parse(X))}matchesExcludesSync(ie,le,X){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ie,le,X))}includedInQuerySync(ie,le,X){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ie,le,X)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(ie,le,X))}includedInQuery(ie,le,X){const ue=this._parsedExcludeExpression(ie,le,X),ve=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(ie,le,X):!0;return(0,b.isThenable)(ue)?ue.then(ge=>ge?!1:ve()):ve()}hasSiblingExcludeClauses(){return $(this._excludeExpression)}}e.QueryGlobTester=H;function $(G){for(const ie in G)if(typeof G[ie]!="boolean")return!0;return!1}}),define(Se[31],_e([0,1,16,10,20,4,22,11,100,24,9,13,2,124,3,12,137,47,30,28,14,8,7,41,5]),function(ee,e,r,t,S,P,A,I,D,T,R,b,i,f,a,o,m,M,y,_,u,C,l,F,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function n(k,L,E){return new T.ExtUri(O=>d(O,E)).isEqual(k,L)}function h(k,L,E){return n(k.uri,L.uri,E)?0:(0,R.compare)(k.uri.toString(),L.uri.toString())}function g(k,L,E){return k.index!==L.index?k.index<L.index?-1:1:n(k.uri,L.uri,E)?(0,R.compare)(k.name,L.name):(0,R.compare)(k.uri.toString(),L.uri.toString())}function s(k,L,E,O){const U=k.slice(0).sort((H,$)=>E(H,$,O)),j=L.slice(0).sort((H,$)=>E(H,$,O));return(0,r.delta)(U,j,(H,$)=>E(H,$,O))}function d(k,L){const E=L.getCapabilities(k.scheme);return!(E&&E&1024)}class p extends M.Workspace{constructor(L,E,O,U,j,H,$){super(L,O.map(G=>new M.WorkspaceFolder(G)),U,j,$);this._name=E,this._isUntitled=H,this._workspaceFolders=[],this._structure=A.TernarySearchTree.forUris($),O.forEach(G=>{this._workspaceFolders.push(G),this._structure.set(G.uri,G)})}static toExtHostWorkspace(L,E,O,U){if(!L)return{workspace:null,added:[],removed:[]};const{id:j,name:H,folders:$,configuration:G,transient:ie,isUntitled:le}=L,X=[],ue=E;E?$.forEach((re,be)=>{const Pe=i.URI.revive(re.uri),Fe=p._findFolder(O||E,Pe,U);Fe?(Fe.name=re.name,Fe.index=re.index,X.push(Fe)):X.push({uri:Pe,name:re.name,index:be})}):X.push(...$.map(({uri:re,name:be,index:Pe})=>({uri:i.URI.revive(re),name:be,index:Pe}))),X.sort((re,be)=>re.index<be.index?-1:1);const ve=new p(j,H,X,!!ie,G?i.URI.revive(G):null,!!le,re=>d(re,U)),{added:ge,removed:we}=s(ue?ue.workspaceFolders:[],ve.workspaceFolders,h,U);return{workspace:ve,added:ge,removed:we}}static _findFolder(L,E,O){for(let U=0;U<L.folders.length;U++){const j=L.workspaceFolders[U];if(n(j.uri,E,O))return j}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(L,E){return E&&this._structure.get(L)&&(L=(0,T.dirname)(L)),this._structure.findSubstr(L)}resolveWorkspaceFolder(L){return this._structure.get(L)}}let w=class{constructor(L,E,O,U){this._onDidChangeWorkspace=new P.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new P.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=U,this._extHostFileSystemInfo=O,this._requestIdProvider=new D.Counter,this._barrier=new t.Barrier,this._proxy=L.getProxy(c.MainContext.MainThreadWorkspace),this._messageService=L.getProxy(c.MainContext.MainThreadMessageService);const j=E.workspace;this._confirmedWorkspace=j?new p(j.id,j.name,[],!!j.transient,j.configuration?i.URI.revive(j.configuration):null,!!j.isUntitled,H=>d(H,O)):void 0}$initializeWorkspace(L,E){this._trusted=E,this.$acceptWorkspaceData(L),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?i.URI.from({scheme:I.Schemas.untitled,path:(0,T.basename)((0,T.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(L,E,O,...U){const j=[];if(Array.isArray(U)&&U.forEach(le=>{i.URI.isUri(le.uri)&&!j.some(X=>n(X.uri,le.uri,this._extHostFileSystemInfo))&&j.push({uri:le.uri,name:le.name||(0,T.basenameOrAuthority)(le.uri)})}),this._unconfirmedWorkspace||[E,O].some(le=>typeof le!="number"||le<0)||O===0&&j.length===0)return!1;const H=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(E+O>H.length)return!1;const $=H.slice(0);$.splice(E,O,...j.map(le=>({uri:le.uri,name:le.name||(0,T.basenameOrAuthority)(le.uri),index:void 0})));for(let le=0;le<$.length;le++){const X=$[le];if($.some((ue,ve)=>ve!==le&&n(X.uri,ue.uri,this._extHostFileSystemInfo)))return!1}$.forEach((le,X)=>le.index=X);const{added:G,removed:ie}=s(H,$,g,this._extHostFileSystemInfo);if(G.length===0&&ie.length===0)return!1;if(this._proxy){const le=L.displayName||L.name;this._proxy.$updateWorkspaceFolders(le,E,O,j).then(void 0,X=>{this._unconfirmedWorkspace=void 0;const ue={source:{identifier:L.identifier,label:L.displayName||L.name}};this._messageService.$showMessage(m.Severity.Error,(0,f.localize)(0,null,le,X.toString()),ue,[])})}return this.trySetWorkspaceFolders($),!0}getWorkspaceFolder(L,E){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(L,E)}async getWorkspaceFolder2(L,E){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(L,E)}async resolveWorkspaceFolder(L){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(L)}getPath(){if(!this._actualWorkspace)return;const{folders:L}=this._actualWorkspace;if(L.length!==0)return L[0].uri.fsPath}getRelativePath(L,E){let O,U="";if(typeof L=="string"?(O=i.URI.file(L),U=L):typeof L!="undefined"&&(O=L,U=L.fsPath),!O)return U;const j=this.getWorkspaceFolder(O,!0);if(!j)return U;typeof E=="undefined"&&this._actualWorkspace&&(E=this._actualWorkspace.folders.length>1);let H=(0,T.relativePath)(j.uri,O);return E&&j.name&&(H=`${j.name}/${H}`),H}trySetWorkspaceFolders(L){this._actualWorkspace&&(this._unconfirmedWorkspace=p.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:L,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(L){const{workspace:E,added:O,removed:U}=p.toExtHostWorkspace(L,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=E||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:O,removed:U}))}findFiles(L,E,O,U,j=S.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${U.value}, entryPoint: findFiles`);let H;if(E===null?H=!1:E&&(typeof E=="string"?H=E:H=E.pattern),j&&j.isCancellationRequested)return Promise.resolve([]);const{includePattern:$,folder:G}=v(C.GlobPattern.from(L));return this._proxy.$startFileSearch((0,b.withUndefinedAsNull)($),(0,b.withUndefinedAsNull)(G),(0,b.withUndefinedAsNull)(H),(0,b.withUndefinedAsNull)(O),j).then(ie=>Array.isArray(ie)?ie.map(le=>i.URI.revive(le)):[])}async findTextInFiles(L,E,O,U,j=S.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${U.value}, entryPoint: findTextInFiles`);const H=this._requestIdProvider.getNext(),$=typeof E.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:E.previewOptions,{includePattern:G,folder:ie}=v(C.GlobPattern.from(E.include)),le=typeof E.exclude=="string"?E.exclude:E.exclude?E.exclude.pattern:void 0,X={ignoreSymlinks:typeof E.followSymlinks=="boolean"?!E.followSymlinks:void 0,disregardIgnoreFiles:typeof E.useIgnoreFiles=="boolean"?!E.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof E.useGlobalIgnoreFiles=="boolean"?!E.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof E.useParentIgnoreFiles=="boolean"?!E.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof E.useDefaultExcludes=="boolean"?!E.useDefaultExcludes:!0,fileEncoding:E.encoding,maxResults:E.maxResults,previewOptions:$,afterContext:E.afterContext,beforeContext:E.beforeContext,includePattern:G,excludePattern:le},ue=!1;if(this._activeSearchCallbacks[H]=ve=>{if(ue)return;const ge=i.URI.revive(ve.resource);ve.results.forEach(we=>{(0,F.resultIsMatch)(we)?O({uri:ge,preview:{text:we.preview.text,matches:(0,r.mapArrayOrNot)(we.preview.matches,re=>new l.Range(re.startLineNumber,re.startColumn,re.endLineNumber,re.endColumn))},ranges:(0,r.mapArrayOrNot)(we.ranges,re=>new l.Range(re.startLineNumber,re.startColumn,re.endLineNumber,re.endColumn))}):O({uri:ge,text:we.text,lineNumber:we.lineNumber})})},j.isCancellationRequested)return{};try{const ve=await this._proxy.$startTextSearch(L,(0,b.withUndefinedAsNull)(ie),X,H,j);return delete this._activeSearchCallbacks[H],ve||{}}catch(ve){throw delete this._activeSearchCallbacks[H],ve}}$handleTextSearchResult(L,E){this._activeSearchCallbacks[E]&&this._activeSearchCallbacks[E](L)}saveAll(L){return this._proxy.$saveAll(L)}resolveProxy(L){return this._proxy.$resolveProxy(L)}get trusted(){return this._trusted}requestWorkspaceTrust(L){return this._proxy.$requestWorkspaceTrust(L)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};w=xe([$e(0,u.IExtHostRpcService),$e(1,_.IExtHostInitDataService),$e(2,y.IExtHostFileSystemInfo),$e(3,o.ILogService)],w),e.ExtHostWorkspace=w,e.IExtHostWorkspace=(0,a.createDecorator)("IExtHostWorkspace");function v(k){let L,E;return k&&(typeof k=="string"?L=k:(L=k.pattern,E=i.URI.revive(k.baseUri))),{includePattern:L,folder:E}}}),define(Se[32],_e([0,1,27,4,31,5,7,141,81,13,10,3,14,12,2]),function(ee,e,r,t,S,P,A,I,D,T,R,b,i,f,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function o(F,c){if(c){const n=c.split(".");let h=F;for(let g=0;h&&g<n.length;g++)h=h[n[g]];return h}}function m(F){return F instanceof a.URI}function M(F){return F&&F.uri instanceof a.URI&&F.languageId&&typeof F.languageId=="string"}function y(F){return F&&!F.uri&&F.languageId&&typeof F.languageId=="string"}function _(F){return F&&F.uri instanceof a.URI&&(!F.name||typeof F.name=="string")&&(!F.index||typeof F.index=="number")}function u(F){if(m(F))return{resource:F};if(M(F))return{resource:F.uri,overrideIdentifier:F.languageId};if(y(F))return{overrideIdentifier:F.languageId};if(_(F))return{resource:F.uri};if(F===null)return{resource:null}}let C=class{constructor(c,n,h){this._proxy=c.getProxy(P.MainContext.MainThreadConfiguration),this._extHostWorkspace=n,this._logService=h,this._barrier=new R.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(c=>this._actual)}$initializeConfiguration(c){this._actual=new l(this._proxy,this._extHostWorkspace,c,this._logService),this._barrier.open()}$acceptConfigurationChanged(c,n){this.getConfigProvider().then(h=>h.$acceptConfigurationChanged(c,n))}};C=xe([$e(0,i.IExtHostRpcService),$e(1,S.IExtHostWorkspace),$e(2,f.ILogService)],C),e.ExtHostConfiguration=C;class l{constructor(c,n,h,g){this._onDidChangeConfiguration=new t.Emitter,this._proxy=c,this._logService=g,this._extHostWorkspace=n,this._configuration=I.Configuration.parse(h),this._configurationScopes=this._toMap(h.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(c,n){const h={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=I.Configuration.parse(c),this._configurationScopes=this._toMap(c.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(n,h))}getConfiguration(c,n,h){const g=u(n)||{},s=this._toReadonlyValue(c?o(this._configuration.getValue(void 0,g,this._extHostWorkspace.workspace),c):this._configuration.getValue(void 0,g,this._extHostWorkspace.workspace));c&&this._validateConfigurationAccess(c,g,h?.identifier);function d(w){if(w==null)return null;if(typeof w=="boolean")return w?1:4;switch(w){case A.ConfigurationTarget.Global:return 1;case A.ConfigurationTarget.Workspace:return 4;case A.ConfigurationTarget.WorkspaceFolder:return 5}}const p={has(w){return typeof o(s,w)!="undefined"},get:(w,v)=>{this._validateConfigurationAccess(c?`${c}.${w}`:w,g,h?.identifier);let k=o(s,w);if(typeof k=="undefined")k=v;else{let L;const E=(O,U)=>{let j;const H=()=>{L=L||(0,r.deepClone)(s),j=j||o(L,U)};return(0,T.isObject)(O)?new Proxy(O,{get:($,G)=>{if(typeof G=="string"&&G.toLowerCase()==="tojson")return H(),()=>j;if(L)return j=j||o(L,U),j[G];const ie=$[G];return typeof G=="string"?E(ie,`${U}.${G}`):ie},set:($,G,ie)=>(H(),j&&(j[G]=ie),!0),deleteProperty:($,G)=>(H(),j&&delete j[G],!0),defineProperty:($,G,ie)=>(H(),j&&Object.defineProperty(j,G,ie),!0)}):O};k=E(k,w)}return k},update:(w,v,k,L)=>{w=c?`${c}.${w}`:w;const E=d(k);return v!==void 0?this._proxy.$updateConfigurationOption(E,w,v,g,L):this._proxy.$removeConfigurationOption(E,w,g,L)},inspect:w=>{w=c?`${c}.${w}`:w;const v=(0,r.deepClone)(this._configuration.inspect(w,g,this._extHostWorkspace.workspace));if(v)return{key:w,defaultValue:v.default?.value,globalValue:v.user?.value,workspaceValue:v.workspace?.value,workspaceFolderValue:v.workspaceFolder?.value,defaultLanguageValue:v.default?.override,globalLanguageValue:v.user?.override,workspaceLanguageValue:v.workspace?.override,workspaceFolderLanguageValue:v.workspaceFolder?.override,languageIds:v.overrideIdentifiers}}};return typeof s=="object"&&(0,r.mixin)(p,s,!1),Object.freeze(p)}_toReadonlyValue(c){const n=h=>(0,T.isObject)(h)?new Proxy(h,{get:(g,s)=>n(g[s]),set:(g,s,d)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(s)}' of object`)},deleteProperty:(g,s)=>{throw new Error(`TypeError: Cannot delete read only property '${String(s)}' of object`)},defineProperty:(g,s)=>{throw new Error(`TypeError: Cannot define property '${String(s)}' for a readonly object`)},setPrototypeOf:g=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):h;return n(c)}_validateConfigurationAccess(c,n,h){const g=D.OVERRIDE_PROPERTY_REGEX.test(c)?4:this._configurationScopes.get(c),s=h?`[${h.value}] `:"";if(g===4){typeof n?.resource=="undefined"&&this._logService.warn(`${s}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${c}', provide the URI of a resource or 'null' for any resource.`);return}if(g===3){n?.resource&&this._logService.warn(`${s}Accessing a window scoped configuration for a resource is not expected. To associate '${c}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(c,n){const h=new I.ConfigurationChangeEvent(c,n,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(g,s)=>h.affectsConfiguration(g,u(s))})}_toMap(c){return c.reduce((n,h)=>(n.set(h[0],h[1]),n),new Map)}}e.ExtHostConfigProvider=l,e.IExtHostConfiguration=(0,b.createDecorator)("IExtHostConfiguration")});var Xe=this&&this.__classPrivateFieldSet||function(ee,e,r,t,S){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!S:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?S.call(ee,r):S?S.value=r:e.set(ee,r),r},Ie=this&&this.__classPrivateFieldGet||function(ee,e,r,t){if(r==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!t:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?t:r==="a"?t.call(ee):t?t.value:e.get(ee)};define(Se[96],_e([0,1,2,10,4,5,7,31,49,32,20,40,14,28,3,11,23,12,68,160,15]),function(ee,e,r,t,S,P,A,I,D,T,R,b,i,f,a,o,m,M,y,_,u){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var l;(function(U){function j($){if($!=null)return $}U.from=j;function H($){if($!=null)return $}U.to=H})(l=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var F;(function(U){function j($){if($!=null)return $}U.from=j;function H($){if($!=null)return $}U.to=H})(F=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var c;(function(U){function j($){if($!=null)return $}U.from=j;function H($){if($!=null)return $}U.to=H})(c=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var n;(function(U){function j(G){if(G){const ie=G;return ie&&!!ie.process}else return!1}U.is=j;function H(G){if(G==null)return;const ie={process:G.process,args:G.args};return G.options&&(ie.options=c.from(G.options)),ie}U.from=H;function $(G){if(G!=null)return new A.ProcessExecution(G.process,G.args,G.options)}U.to=$})(n=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var h;(function(U){function j($){if($!=null)return $}U.from=j;function H($){if($!=null)return $}U.to=H})(h=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var g;(function(U){function j(G){if(G){const ie=G;return ie&&(!!ie.commandLine||!!ie.command)}else return!1}U.is=j;function H(G){if(G==null)return;const ie={};return G.commandLine!==void 0?ie.commandLine=G.commandLine:(ie.command=G.command,ie.args=G.args),G.options&&(ie.options=h.from(G.options)),ie}U.from=H;function $(G){if(!(G==null||G.command===void 0&&G.commandLine===void 0))return G.commandLine?new A.ShellExecution(G.commandLine,G.options):new A.ShellExecution(G.command,G.args?G.args:[],G.options)}U.to=$})(g=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var s;(function(U){function j(G){if(G){let ie=G;return ie&&ie.customExecution==="customExecution"}else return!1}U.is=j;function H(G){return{customExecution:"customExecution"}}U.from=H;function $(G,ie){return ie.get(G)}U.to=$})(s=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var d;(function(U){function j(H,$){let G;return H.scope!==void 0&&typeof H.scope!="number"?G=H.scope.uri:H.scope!==void 0&&typeof H.scope=="number"&&(H.scope===A.TaskScope.Workspace&&$&&$.workspaceFile?G=$.workspaceFile:G=_.USER_TASKS_GROUP_KEY),{id:H._id,workspaceFolder:G}}U.from=j})(d=e.TaskHandleDTO||(e.TaskHandleDTO={}));var p;(function(U){function j(H){if(H!=null)return{_id:H.id,isDefault:H.isDefault}}U.from=j})(p=e.TaskGroupDTO||(e.TaskGroupDTO={}));var w;(function(U){function j(G,ie){if(G==null)return[];const le=[];for(let X of G){const ue=H(X,ie);ue&&le.push(ue)}return le}U.fromMany=j;function H(G,ie){if(G==null)return;let le;G.execution instanceof A.ProcessExecution?le=n.from(G.execution):G.execution instanceof A.ShellExecution?le=g.from(G.execution):G.execution&&G.execution instanceof A.CustomExecution&&(le=s.from(G.execution));const X=l.from(G.definition);let ue;return G.scope?typeof G.scope=="number"?ue=G.scope:ue=G.scope.uri:ue=A.TaskScope.Workspace,!X||!ue?void 0:{_id:G._id,definition:X,name:G.name,source:{extensionId:ie.identifier.value,label:G.source,scope:ue},execution:le,isBackground:G.isBackground,group:p.from(G.group),presentationOptions:F.from(G.presentationOptions),problemMatchers:G.problemMatchers,hasDefinedMatchers:G.hasDefinedMatchers,runOptions:G.runOptions?G.runOptions:{reevaluateOnRerun:!0},detail:G.detail}}U.from=H;async function $(G,ie,le){if(G==null)return;let X;n.is(G.execution)?X=n.to(G.execution):g.is(G.execution)?X=g.to(G.execution):s.is(G.execution)&&(X=s.to(G._id,le));const ue=l.to(G.definition);let ve;if(G.source&&(G.source.scope!==void 0?typeof G.source.scope=="number"?ve=G.source.scope:ve=await ie.resolveWorkspaceFolder(r.URI.revive(G.source.scope)):ve=A.TaskScope.Workspace),!ue||!ve)return;const ge=new A.Task(ue,ve,G.name,G.source.label,X,G.problemMatchers);return G.isBackground!==void 0&&(ge.isBackground=G.isBackground),G.group!==void 0&&(ge.group=A.TaskGroup.from(G.group._id),ge.group&&G.group.isDefault&&(ge.group=new A.TaskGroup(ge.group.id,ge.group.label),G.group.isDefault&&(ge.group.isDefault=G.group.isDefault))),G.presentationOptions&&(ge.presentationOptions=F.to(G.presentationOptions)),G._id&&(ge._id=G._id),G.detail&&(ge.detail=G.detail),ge}U.to=$})(w=e.TaskDTO||(e.TaskDTO={}));var v;(function(U){function j($){return $}U.from=j;function H($){if(!!$)return Object.assign(Object.create(null),$)}U.to=H})(v=e.TaskFilterDTO||(e.TaskFilterDTO={}));class k{constructor(j,H,$){this._id=H,this._task=$,C.set(this,void 0),Xe(this,C,j,"f")}get task(){return this._task}terminate(){Ie(this,C,"f").terminateTask(this)}fireDidStartProcess(j){}fireDidEndProcess(j){}}C=new WeakMap;var L;(function(U){function j(H){return{id:H._id,task:void 0}}U.from=j})(L=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let E=class{constructor(j,H,$,G,ie,le,X,ue){this._onDidExecuteTask=new S.Emitter,this._onDidTerminateTask=new S.Emitter,this._onDidTaskProcessStarted=new S.Emitter,this._onDidTaskProcessEnded=new S.Emitter,this._proxy=j.getProxy(P.MainContext.MainThreadTask),this._workspaceProvider=$,this._editorService=G,this._configurationService=ie,this._terminalService=le,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=X,this._deprecationService=ue,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(j,H,$){if(!$)return new A.Disposable(()=>{});const G=this.nextHandle();return this._handlers.set(G,{type:H,provider:$,extension:j}),this._proxy.$registerTaskProvider(G,H),new A.Disposable(()=>{this._handlers.delete(G),this._proxy.$unregisterTaskProvider(G)})}registerTaskSystem(j,H){this._proxy.$registerTaskSystem(j,H)}fetchTasks(j){return this._proxy.$fetchTasks(v.from(j)).then(async H=>{const $=[];for(let G of H){const ie=await w.to(G,this._workspaceProvider,this._providedCustomExecutions2);ie&&$.push(ie)}return $})}get taskExecutions(){const j=[];return this._taskExecutions.forEach(H=>j.push(H)),j}terminateTask(j){if(!(j instanceof k))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(j._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(j,H,$){const G=this._providedCustomExecutions2.get(j.id);G&&(this._activeCustomExecutions2.set(j.id,G),this._terminalService.attachPtyToTerminal(H,await G.callback($))),this._lastStartedTask=j.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(j)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(j){const H=await this.getTaskExecution(j);this._taskExecutionPromises.delete(j.id),this._taskExecutions.delete(j.id),this.customExecutionComplete(j),this._onDidTerminateTask.fire({execution:H})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(j){const H=await this.getTaskExecution(j.id);this._onDidTaskProcessStarted.fire({execution:H,processId:j.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(j){const H=await this.getTaskExecution(j.id);this._onDidTaskProcessEnded.fire({execution:H,exitCode:j.exitCode})}$provideTasks(j,H){const $=this._handlers.get(j);if(!$)return Promise.reject(new Error("no handler found"));const G=[],ie=(0,t.asPromise)(()=>$.provider.provideTasks(R.CancellationToken.None)).then(le=>this.provideTasksInternal(H,G,$,le));return new Promise(le=>{ie.then(X=>{Promise.all(G).then(()=>{le(X)})})})}async $resolveTask(j,H){const $=this._handlers.get(j);if(!$)return Promise.reject(new Error("no handler found"));if(H.definition.type!==$.type)throw new Error(`Unexpected: Task of type [${H.definition.type}] cannot be resolved by provider of type [${$.type}].`);const G=await w.to(H,this._workspaceProvider,this._providedCustomExecutions2);if(!G)throw new Error("Unexpected: Task cannot be resolved.");const ie=await $.provider.resolveTask(G,R.CancellationToken.None);if(!ie)return;this.checkDeprecation(ie,$);const le=w.from(ie,$.extension);if(!le)throw new Error("Unexpected: Task cannot be resolved.");if(ie.definition!==G.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return s.is(le.execution)&&await this.addCustomExecution(le,ie,!0),await this.resolveTaskInternal(le)}nextHandle(){return this._handleCounter++}async addCustomExecution(j,H,$){const G=await this._proxy.$createTaskId(j);!$&&!this._providedCustomExecutions2.has(G)&&(this._notProvidedCustomExecutions.add(G),this._activeCustomExecutions2.set(G,H.execution)),this._providedCustomExecutions2.set(G,H.execution)}async getTaskExecution(j,H){if(typeof j=="string"){const ie=this._taskExecutionPromises.get(j);if(!ie)throw new Error("Unexpected: The specified task is missing an execution");return ie}let $=this._taskExecutionPromises.get(j.id);if($)return $;const G=new Promise((ie,le)=>{function X(ue,ve,ge){ge?ie(new k(ue,ve.id,ge)):le("Unexpected: Task does not exist.")}H?X(this,j,H):w.to(j.task,this._workspaceProvider,this._providedCustomExecutions2).then(ue=>X(this,j,ue))});return this._taskExecutionPromises.set(j.id,G),G.then(ie=>(this._taskExecutions.set(j.id,ie),ie),ie=>Promise.reject(ie))}checkDeprecation(j,H){j._deprecated&&this._deprecationService.report("Task.constructor",H.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(j){this._activeCustomExecutions2.get(j.id)&&this._activeCustomExecutions2.delete(j.id),this._notProvidedCustomExecutions.has(j.id)&&this._lastStartedTask!==j.id&&(this._providedCustomExecutions2.delete(j.id),this._notProvidedCustomExecutions.delete(j.id));let $=this._notProvidedCustomExecutions.values(),G=$.next();for(;!G.done;)!this._activeCustomExecutions2.has(G.value)&&this._lastStartedTask!==G.value&&(this._providedCustomExecutions2.delete(G.value),this._notProvidedCustomExecutions.delete(G.value)),G=$.next()}};E=xe([$e(0,i.IExtHostRpcService),$e(1,f.IExtHostInitDataService),$e(2,I.IExtHostWorkspace),$e(3,D.IExtHostDocumentsAndEditors),$e(4,T.IExtHostConfiguration),$e(5,b.IExtHostTerminalService),$e(6,M.ILogService),$e(7,y.IExtHostApiDeprecationService)],E),e.ExtHostTaskBase=E;let O=class extends E{constructor(j,H,$,G,ie,le,X,ue){super(j,H,$,G,ie,le,X,ue);this.registerTaskSystem(o.Schemas.vscodeRemote,{scheme:o.Schemas.vscodeRemote,authority:"",platform:m.PlatformToString(0)})}async executeTask(j,H){if(!H.execution)throw new Error("Tasks to execute must include an execution");const $=w.from(H,j);if($===void 0)throw new Error("Task is not valid");if(s.is($.execution))await this.addCustomExecution($,H,!1);else throw new u.NotSupportedError;const G=await this.getTaskExecution(await this._proxy.$getTaskExecution($),H);return this._proxy.$executeTask($).catch(ie=>{throw new Error(ie)}),G}provideTasksInternal(j,H,$,G){const ie=[];if(G)for(let le of G){this.checkDeprecation(le,$),(!le.definition||!j[le.definition.type])&&this._logService.warn(`The task [${le.source}, ${le.name}] uses an undefined task type. The task will be ignored in the future.`);const X=w.from(le,$.extension);X&&s.is(X.execution)?(ie.push(X),H.push(this.addCustomExecution(X,le,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:ie,extension:$.extension}}async resolveTaskInternal(j){if(s.is(j.execution))return j;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(j,H){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(j,H,$){}};O=xe([$e(0,i.IExtHostRpcService),$e(1,f.IExtHostInitDataService),$e(2,I.IExtHostWorkspace),$e(3,D.IExtHostDocumentsAndEditors),$e(4,T.IExtHostConfiguration),$e(5,b.IExtHostTerminalService),$e(6,M.ILogService),$e(7,y.IExtHostApiDeprecationService)],O),e.WorkerExtHostTask=O,e.IExtHostTask=(0,a.createDecorator)("IExtHostTask")}),define(Se[211],_e([0,1,16,73,29,76,22,11,17,24,9,13,2,232,127,79,47,88,210,41]),function(ee,e,r,t,S,P,A,I,D,T,R,b,i,f,a,o,m,M,y,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let u=class{constructor(d,p,w,v){this.configurationService=d,this.workspaceContextService=p,this.editorGroupsService=w,this.pathService=v}text(d,p,w={}){d=this.getContentPattern(d,w);const v=this.configurationService.getValue(),k=p&&p.some(E=>!this.configurationService.getValue({resource:E}).search.useRipgrep);return{...this.commonQuery(p?.map(m.toWorkspaceFolder),w),type:2,contentPattern:d,previewOptions:w.previewOptions,maxFileSize:w.maxFileSize,usePCRE2:v.search.usePCRE2||k||!1,beforeContext:w.beforeContext,afterContext:w.afterContext,userDisabledExcludesAndIgnoreFiles:w.disregardExcludeSettings&&w.disregardIgnoreFiles}}getContentPattern(d,p){const w=this.configurationService.getValue();d.isRegExp&&(d.pattern=d.pattern.replace(/\r?\n/g,"\\n"));const v={...d,wordSeparators:w.editor.wordSeparators};return this.isCaseSensitive(d,p)&&(v.isCaseSensitive=!0),this.isMultiline(d)&&(v.isMultiline=!0),v}file(d,p={}){return{...this.commonQuery(d,p),type:1,filePattern:p.filePattern?p.filePattern.trim():p.filePattern,exists:p.exists,sortByScore:p.sortByScore,cacheKey:p.cacheKey}}handleIncludeExclude(d,p){return d?(d=Array.isArray(d)?d.map(n):n(d),p?this.parseSearchPaths(d):{pattern:l(...Array.isArray(d)?d:[d])}):{}}commonQuery(d=[],p={}){const w=this.handleIncludeExclude(p.includePattern,p.expandPatterns),v=this.handleIncludeExclude(p.excludePattern,p.expandPatterns),k=d.length>1,L=(w.searchPaths&&w.searchPaths.length?w.searchPaths.map(U=>this.getFolderQueryForSearchPath(U,p,v)):d.map(U=>this.getFolderQueryForRoot(U,p,v,k))).filter(U=>!!U),E={_reason:p._reason,folderQueries:L,usingSearchPaths:!!(w.searchPaths&&w.searchPaths.length),extraFileResources:p.extraFileResources,excludePattern:v.pattern,includePattern:w.pattern,onlyOpenEditors:p.onlyOpenEditors,maxResults:p.maxResults};if(p.onlyOpenEditors){const j=r.coalesce(r.flatten(this.editorGroupsService.groups.map($=>$.editors.map(G=>G.resource)))).filter($=>(0,_.pathIncludedInQuery)(E,$.fsPath)),H=this.commonQueryFromFileList(j);return{...E,...H}}const O=p.extraFileResources&&p.extraFileResources.filter(U=>(0,_.pathIncludedInQuery)(E,U.fsPath));return E.extraFileResources=O&&O.length?O:void 0,E}commonQueryFromFileList(d){const p=[],w=new A.ResourceMap,v={};let k=!1;return d.forEach(L=>{if(L.scheme===I.Schemas.walkThrough)return;if((0,T.isAbsolutePath)(L)){const O=this.workspaceContextService.getWorkspaceFolder(L)?.uri??L.with({path:D.dirname(L.fsPath)});let U=w.get(O);U||(k=!0,U={folder:O,includePattern:{}},p.push(U),w.set(O,U));const j=D.relative(O.fsPath,L.fsPath);(0,b.assertIsDefined)(U.includePattern)[j.replace(/\\/g,"/")]=!0}else L.fsPath&&(k=!0,v[L.fsPath]=!0)}),{folderQueries:p,includePattern:v,usingSearchPaths:!0,excludePattern:k?void 0:{"**/*":!0}}}isCaseSensitive(d,p){if(p.isSmartCase){if(d.isRegExp){if(R.containsUppercaseCharacter(d.pattern,!0))return!0}else if(R.containsUppercaseCharacter(d.pattern))return!0}return!!d.isCaseSensitive}isMultiline(d){return d.isMultiline||d.isRegExp&&(0,f.isMultilineRegexSource)(d.pattern)||d.pattern.indexOf(`
`)>=0?!0:!!d.isMultiline}parseSearchPaths(d){const p=H=>D.isAbsolute(H)||/^\.\.?([\/\\]|$)/.test(H),v=(Array.isArray(d)?d:F(d)).map(H=>{const $=this.pathService.resolvedUserHome;return $?(0,P.untildify)(H,$.scheme===I.Schemas.file?$.fsPath:$.path):H}),k=t.groupBy(v,H=>p(H)?"searchPaths":"exprSegments"),L=(k.exprSegments||[]).map(H=>R.rtrim(H,"/")).map(H=>R.rtrim(H,"\\")).map(H=>(H[0]==="."&&(H="*"+H),c(H))),E={},O=this.expandSearchPathPatterns(k.searchPaths||[]);O&&O.length&&(E.searchPaths=O);const U=r.flatten(L),j=l(...U);return j&&(E.pattern=j),E}getExcludesForFolder(d,p){return p.disregardExcludeSettings?void 0:(0,_.getExcludes)(d,!p.disregardSearchExcludeSettings)}expandSearchPathPatterns(d){if(!d||!d.length)return[];const p=r.flatten(d.map(v=>{let{pathPortion:k,globPortion:L}=C(v);L&&(L=h(L));const E=this.expandOneSearchPath(k);return r.flatten(E.map(O=>this.resolveOneSearchPathPattern(O,L)))})),w=new Map;return p.forEach(v=>{const k=v.searchPath.toString(),L=w.get(k);L?v.pattern&&(L.pattern=L.pattern||{},L.pattern[v.pattern]=!0):w.set(k,{searchPath:v.searchPath,pattern:v.pattern?l(v.pattern):void 0})}),Array.from(w.values())}expandOneSearchPath(d){if(D.isAbsolute(d)){const p=this.workspaceContextService.getWorkspace().folders;return p[0]&&p[0].uri.scheme!==I.Schemas.file?[{searchPath:p[0].uri.with({path:d})}]:[{searchPath:i.URI.file(D.normalize(d))}]}if(this.workspaceContextService.getWorkbenchState()===2){const p=this.workspaceContextService.getWorkspace().folders[0].uri;if(d=n(d),d.startsWith("../")||d===".."){const v=D.posix.resolve(p.path,d);return[{searchPath:p.with({path:v})}]}const w=h(d);return[{searchPath:p,pattern:w}]}else{if(d==="./"||d===".\\")return[];{const p=d.replace(/^\.[\/\\]/,""),v=this.workspaceContextService.getWorkspace().folders.map(k=>{const L=p.match(new RegExp(`^${R.escapeRegExpCharacters(k.name)}(?:/(.*)|$)`));return L?{match:L,folder:k}:null}).filter(b.isDefined);if(v.length)return v.map(k=>{const L=k.match[1];return{searchPath:k.folder.uri,pattern:L&&h(L)}});{const k=d.match(/\.[\/\\](.+)[\/\\]?/),L=k?k[1]:d,E=a.localize(0,null,L);throw new Error(E)}}}}resolveOneSearchPathPattern(d,p){const w=d.pattern&&p?`${d.pattern}/${p}`:d.pattern||p,v=[{searchPath:d.searchPath,pattern:w}];return w&&!w.endsWith("**")&&v.push({searchPath:d.searchPath,pattern:w+"/**"}),v}getFolderQueryForSearchPath(d,p,w){const v=this.getFolderQueryForRoot((0,m.toWorkspaceFolder)(d.searchPath),p,w,!1);return v?{...v,includePattern:d.pattern}:null}getFolderQueryForRoot(d,p,w,v){let k;const L=i.URI.isUri(d)?d:d.uri;if(w.searchPaths){const H=w.searchPaths.filter($=>(0,T.isEqual)($.searchPath,L))[0];if(H&&!H.pattern)return null;H&&(k=H.pattern)}const E=this.configurationService.getValue({resource:L}),U={...this.getExcludesForFolder(E,p)||{},...k||{}},j=i.URI.isUri(d)?(0,T.basename)(d):d.name;return{folder:L,folderName:v?j:void 0,excludePattern:Object.keys(U).length>0?U:void 0,fileEncoding:E.files&&E.files.encoding,disregardIgnoreFiles:typeof p.disregardIgnoreFiles=="boolean"?p.disregardIgnoreFiles:!E.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof p.disregardGlobalIgnoreFiles=="boolean"?p.disregardGlobalIgnoreFiles:!E.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof p.disregardParentIgnoreFiles=="boolean"?p.disregardParentIgnoreFiles:!E.search.useParentIgnoreFiles,ignoreSymlinks:typeof p.ignoreSymlinks=="boolean"?p.ignoreSymlinks:!E.search.followSymlinks}}};u=xe([$e(0,o.IConfigurationService),$e(1,m.IWorkspaceContextService),$e(2,M.IEditorGroupsService),$e(3,y.IPathService)],u),e.QueryBuilder=u;function C(s){const d=s.match(/[\*\{\}\(\)\[\]\?]/);if(d){const p=d.index,w=s.substr(0,p).match(/[/|\\][^/\\]*$/);if(w){let v=s.substr(0,w.index);return v.match(/[/\\]/)||(v+="/"),{pathPortion:v,globPortion:s.substr((w.index||0)+1)}}}return{pathPortion:s}}function l(...s){return s.length?s.reduce((d,p)=>(d[p]=!0,d),Object.create(null)):void 0}function F(s){return S.splitGlobAware(s,",").map(d=>d.trim()).filter(d=>!!d.length)}function c(s){return[`**/${s}/**`,`**/${s}`].map(p=>p.replace(/\*\*\/\*\*/g,"**"))}function n(s){return s.replace(/\\/g,"/")}function h(s){return n(s).replace(/^\.\//,"").replace(/\/+$/g,"")}function g(s,d){s=r.distinct(s,v=>v.toString());const p=[],w=d.getWorkspace();return s&&s.forEach(v=>{let k;if(d.getWorkbenchState()===2)k=(0,T.relativePath)(w.folders[0].uri,v),k&&k!=="."&&(k="./"+k);else{const L=d.getWorkspaceFolder(v);if(L){const E=L.name;if(w.folders.filter(U=>U.name===E).length===1){const U=(0,T.relativePath)(L.uri,v);U===""?k=`./${L.name}`:k=`./${L.name}/${U}`}else k=v.fsPath}}k&&p.push(k)}),p}e.resolveResourcesForSearchIncludes=g}),define(Se[212],_e([0,1,24,2,20,15,3,211,41,47]),function(ee,e,r,t,S,P,A,I,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const R=7e3;function b(o,m){const M=m.activationEvents;if(!M)return Promise.resolve(void 0);const y=[],_=[];for(const n of M)if(/^workspaceContains:/.test(n)){const h=n.substr("workspaceContains:".length);h.indexOf("*")>=0||h.indexOf("?")>=0||o.forceUsingSearch?_.push(h):y.push(h)}if(y.length===0&&_.length===0)return Promise.resolve(void 0);let u;const C=new Promise((n,h)=>{u=n}),l=n=>u({activationEvent:n}),F=Promise.all(y.map(n=>i(o,n,l))).then(()=>{}),c=f(o,m.identifier,_,l);return Promise.all([F,c]).then(()=>{u(void 0)}),C}e.checkActivateWorkspaceContainsExtension=b;async function i(o,m,M){for(const y of o.folders)if(await o.exists(r.joinPath(t.URI.revive(y),m))){M(`workspaceContains:${m}`);return}}async function f(o,m,M,y){if(M.length===0)return Promise.resolve(void 0);const _=new S.CancellationTokenSource,u=o.checkExists(o.folders,M,_.token),C=setTimeout(async()=>{_.cancel(),o.logService.info(`Not activating extension '${m.value}': Timed out while searching for 'workspaceContains' pattern ${M.join(",")}`)},R);let l=!1;try{l=await u}catch(F){P.isCancellationError(F)||P.onUnexpectedError(F)}_.dispose(),clearTimeout(C),l&&y(`workspaceContains:${M.join(",")}`)}function a(o,m,M,y){const _=o.get(A.IInstantiationService),u=o.get(D.ISearchService),l=_.createInstance(I.QueryBuilder).file(m.map(F=>(0,T.toWorkspaceFolder)(t.URI.revive(F))),{_reason:"checkExists",includePattern:M,exists:!0});return u.fileSearch(l,y).then(F=>!!F.limitHit,F=>P.isCancellationError(F)?!1:Promise.reject(F))}e.checkGlobFileExists=a});var Xe=this&&this.__classPrivateFieldSet||function(ee,e,r,t,S){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!S:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?S.call(ee,r):S?S.value=r:e.set(ee,r),r},Ie=this&&this.__classPrivateFieldGet||function(ee,e,r,t){if(r==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!t:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?t:r==="a"?t.call(ee):t?t.value:e.get(ee)};define(Se[33],_e([0,1,119,17,72,24,10,6,22,2,12,5,32,171,70,31,26,169,15,25,21,146,7,82,3,28,71,14,59,63,40,4,212,67,148,11]),function(ee,e,r,t,S,P,A,I,D,T,R,b,i,f,a,o,m,M,y,_,u,C,l,F,c,n,h,g,s,d,p,w,v,k,L,E){"use strict";var O,U,j;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,c.createDecorator)("IHostUtils");let H=class Gi extends I.Disposable{constructor(X,ue,ve,ge,we,re,be,Pe,Fe,ze){super();this._onDidChangeRemoteConnectionData=this._register(new w.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=ue,this._extHostContext=ve,this._initData=be,this._extHostWorkspace=ge,this._extHostConfiguration=we,this._logService=re,this._extHostTunnelService=Fe,this._extHostTerminalService=ze,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(b.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(b.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(b.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new A.Barrier,this._readyToStartExtensionHost=new A.Barrier,this._readyToRunExtensions=new A.Barrier,this._eagerExtensionsActivated=new A.Barrier,this._registry=new M.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new a.ExtHostStorage(this._extHostContext),this._secretState=new k.ExtHostSecretState(this._extHostContext),this._storagePath=Pe,this._instaService=X.createChild(new s.ServiceCollection([a.IExtHostStorage,this._storage],[k.IExtHostSecretState,this._secretState]));const nt=new Set;this._initData.hostExtensions.forEach(et=>nt.add(_.ExtensionIdentifier.toKey(et))),this._activator=this._register(new f.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(et,Ze,x)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(et,y.transformErrorForSerialization(Ze),x)},actualActivateExtension:async(et,Ze)=>{if(nt.has(_.ExtensionIdentifier.toKey(et)))return await this._mainThreadExtensionsProxy.$activateExtension(et,Ze),new f.HostExtension;const x=this._registry.getExtensionDescription(et);return this._activateExtension(x,Ze)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),S.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(X){y.onUnexpectedError(X)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let X=[];try{X=this._registry.getAllExtensionDescriptions().map(we=>we.identifier).filter(we=>this.isActivated(we)).map(we=>this._deactivate(we))}catch{}await Promise.all(X)}isActivated(X){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(X):!1}_activateByEvent(X,ue){return this._activator.activateByEvent(X,ue)}_activateById(X,ue){return this._activator.activateById(X,ue)}activateByIdWithErrors(X,ue){return this._activateById(X,ue).then(()=>{const ve=this._activator.getActivatedExtension(X);if(ve.activationFailed)return Promise.reject(ve.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(X=>this._registry)}getExtensionExports(X){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(X).exports:null}async _realPathExtensionUri(X){if(X.scheme!==E.Schemas.file)return X;const ue=await this._hostUtils.realpath(X.fsPath);return T.URI.file(ue)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=(async()=>{const X=D.TernarySearchTree.forUris(ue=>P.extUriBiasedIgnorePathCase.ignorePathCasing(ue));for(const ue of this._registry.getAllExtensionDescriptions())if(this._getEntryPoint(ue)){const ve=await this._realPathExtensionUri(ue.extensionLocation);X.set(ve,ue)}return X})()),this._extensionPathIndex}_deactivate(X){let ue=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(X))return ue;const ve=this._activator.getActivatedExtension(X);if(!ve)return ue;try{typeof ve.module.deactivate=="function"&&(ue=Promise.resolve(ve.module.deactivate()).then(void 0,ge=>(this._logService.error(ge),Promise.resolve(void 0))))}catch(ge){this._logService.error(`An error occurred when deactivating the extension '${X.value}':`),this._logService.error(ge)}try{(0,I.dispose)(ve.subscriptions)}catch(ge){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${X.value}':`),this._logService.error(ge)}return ue}async _activateExtension(X,ue){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(X.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(X.identifier),this._doActivateExtension(X,ue).then(ve=>{const ge=ve.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(X.identifier,ge.codeLoadingTime,ge.activateCallTime,ge.activateResolvedTime,ue),this._logExtensionActivationTimes(X,ue,"success",ge),ve},ve=>{throw this._logExtensionActivationTimes(X,ue,"failure"),ve})}_logExtensionActivationTimes(X,ue,ve,ge){const we=$(X,ue);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...we,...ge||{},outcome:ve})}_doActivateExtension(X,ue){const ve=$(X,ue);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",ve);const ge=this._getEntryPoint(X);if(!ge)return Promise.resolve(new f.EmptyExtension(f.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${X.identifier.value}, startup: ${ue.startup}, activationEvent: '${ue.activationEvent}'${X.identifier.value!==ue.extensionId.value?`, root cause: ${ue.extensionId.value}`:""}`),this._logService.flush();const we=new f.ExtensionActivationTimesBuilder(ue.startup);return Promise.all([this._loadCommonJSModule(X.identifier,(0,P.joinPath)(X.extensionLocation,ge),we),this._loadExtensionContext(X)]).then(re=>(S.mark(`code/extHost/willActivateExtension/${X.identifier.value}`),Gi._callActivate(this._logService,X.identifier,re[0],re[1],we))).then(re=>(S.mark(`code/extHost/didActivateExtension/${X.identifier.value}`),re))}_loadExtensionContext(X){const ue=new C.ExtensionGlobalMemento(X,this._storage),ve=new C.ExtensionMemento(X.identifier.value,!1,this._storage),ge=new L.ExtensionSecrets(X,this._secretState),we=X.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?l.ExtensionMode.Test:l.ExtensionMode.Development:l.ExtensionMode.Production,re=this._initData.remote.isRemote?l.ExtensionKind.Workspace:l.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${X.identifier.value}`),Promise.all([ue.whenReady,ve.whenReady,this._storagePath.whenReady]).then(()=>{const be=this;let Pe,Fe;const ze=(0,m.isProposedApiEnabled)(X,"ipc")?this._initData.messagePorts?.get(_.ExtensionIdentifier.toKey(X.identifier)):void 0;return Object.freeze({globalState:ue,workspaceState:ve,secrets:ge,subscriptions:[],get extensionUri(){return X.extensionLocation},get extensionPath(){return X.extensionLocation.fsPath},asAbsolutePath(nt){return t.join(X.extensionLocation.fsPath,nt)},get storagePath(){return be._storagePath.workspaceValue(X)?.fsPath},get globalStoragePath(){return be._storagePath.globalValue(X).fsPath},get logPath(){return t.join(be._initData.logsLocation.fsPath,X.identifier.value)},get logUri(){return T.URI.joinPath(be._initData.logsLocation,X.identifier.value)},get storageUri(){return be._storagePath.workspaceValue(X)},get globalStorageUri(){return be._storagePath.globalValue(X)},get extensionMode(){return we},get extension(){return Pe===void 0&&(Pe=new G(be,X.identifier,X,re)),Pe},get extensionRuntime(){return(0,m.checkProposedApiEnabled)(X,"extensionRuntime"),be.extensionRuntime},get environmentVariableCollection(){return be._extHostTerminalService.getEnvironmentVariableCollection(X)},get messagePassingProtocol(){if(!Fe){if(!ze)return;const nt=w.Event.buffer(w.Event.fromDOMEventEmitter(ze,"message",et=>et.data));ze.start(),Fe={onDidReceiveMessage:nt,postMessage:ze.postMessage.bind(ze)}}return Fe}})})}static _callActivate(X,ue,ve,ge,we){return ve=ve||{activate:void 0,deactivate:void 0},this._callActivateOptional(X,ue,ve,ge,we).then(re=>new f.ActivatedExtension(!1,null,we.build(),ve,re,ge.subscriptions))}static _callActivateOptional(X,ue,ve,ge,we){if(typeof ve.activate=="function")try{we.activateCallStart(),X.trace(`ExtensionService#_callActivateOptional ${ue.value}`);const re=typeof global=="object"?global:self,be=ve.activate.apply(re,[ge]);return we.activateCallStop(),we.activateResolveStart(),Promise.resolve(be).then(Pe=>(we.activateResolveStop(),Pe))}catch(re){return Promise.reject(re)}else return Promise.resolve(ve)}_activateOneStartupFinished(X,ue){this._activateById(X.identifier,{startup:!1,extensionId:X.identifier,activationEvent:ue}).then(void 0,ve=>{this._logService.error(ve)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(S.getMarks());for(const X of this._registry.getAllExtensionDescriptions())if(X.activationEvents)for(const ue of X.activationEvents)ue==="onStartupFinished"&&this._activateOneStartupFinished(X,ue)}_handleEagerExtensions(){const X=this._activateByEvent("*",!0).then(void 0,we=>{this._logService.error(we)});this._register(this._extHostWorkspace.onDidChangeWorkspace(we=>this._handleWorkspaceContainsEagerExtensions(we.added)));const ue=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],ve=this._handleWorkspaceContainsEagerExtensions(ue),ge=Promise.all([X,ve]).then(()=>{});return Promise.race([ge,(0,A.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),ge}_handleWorkspaceContainsEagerExtensions(X){return X.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(ue=>this._handleWorkspaceContainsEagerExtension(X,ue))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(X,ue){if(this.isActivated(ue.identifier))return;const ve=!this._initData.remote.isRemote&&!!this._initData.remote.authority,ge={logService:this._logService,folders:X.map(re=>re.uri),forceUsingSearch:ve,exists:re=>this._hostUtils.exists(re.fsPath),checkExists:(re,be,Pe)=>this._mainThreadWorkspaceProxy.$checkExists(re,be,Pe)},we=await(0,v.checkActivateWorkspaceContainsExtension)(ge,ue);if(!!we)return this._activateById(ue.identifier,{startup:!0,extensionId:ue.identifier,activationEvent:we.activationEvent}).then(void 0,re=>this._logService.error(re))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(X){throw console.error(X),X}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:X,extensionTestsLocationURI:ue}=this._initData.environment;if(!X||!ue)throw new Error(r.localize(0,null));const ve=await this._loadCommonJSModule(null,ue,new f.ExtensionActivationTimesBuilder(!1));if(!ve||typeof ve.run!="function")throw new Error(r.localize(1,null,ue.toString()));return new Promise((ge,we)=>{const re=(Fe,ze)=>{Fe?we(Fe):ge(typeof ze=="number"&&ze>0?1:0)},be=(0,P.originalFSPath)(ue),Pe=ve.run(be,re);Pe&&Pe.then&&Pe.then(()=>{ge(0)}).catch(Fe=>{we(Fe instanceof Error&&Fe.stack?Fe.stack:String(Fe))})})}async $extensionTestsExit(X){this._logService.info(`Extension host terminating: test runner requested exit with code ${X}`),this._hostUtils.pid&&this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${X}`),this._logService.flush(),this._hostUtils.exit(X)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(X,ue){return this._resolvers[X]=ue,(0,I.toDisposable)(()=>{delete this._resolvers[X]})}async _activateAndGetResolver(X){const ue=X.indexOf("+");if(ue===-1)throw new Error("Not an authority that can be resolved!");const ve=X.substr(0,ue);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${ve}`,!1),{authorityPrefix:ve,resolver:this._resolvers[ve]}}async $resolveAuthority(X,ue){this._logService.info(`$resolveAuthority invoked for authority (${ie(X)})`);const{authorityPrefix:ve,resolver:ge}=await this._activateAndGetResolver(X);if(!ge)return{type:"error",error:{code:F.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${ve}.`,detail:void 0}};try{this._register(await this._extHostTunnelService.setTunnelFactory(ge)),S.mark(`code/extHost/willResolveAuthority/${ve}`);const we=await ge.resolve(X,{resolveAttempt:ue});S.mark(`code/extHost/didResolveAuthorityOK/${ve}`);const re={authority:X,host:we.host,port:we.port,connectionToken:we.connectionToken},be={extensionHostEnv:we.extensionHostEnv,isTrusted:we.isTrusted,authenticationSession:we.authenticationSessionForInitializingExtensions?{id:we.authenticationSessionForInitializingExtensions.id,providerId:we.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:re,options:be,tunnelInformation:{environmentTunnels:we.environmentTunnels,features:we.tunnelFeatures}}}}catch(we){if(S.mark(`code/extHost/didResolveAuthorityError/${ve}`),we instanceof l.RemoteAuthorityResolverError)return{type:"error",error:{code:we._code,message:we._message,detail:we._detail}};throw we}}async $getCanonicalURI(X,ue){this._logService.info(`$getCanonicalURI invoked for authority (${ie(X)})`);const{authorityPrefix:ve,resolver:ge}=await this._activateAndGetResolver(X);if(!ge)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${ve}`);const we=T.URI.revive(ue);if(typeof ge.getCanonicalURI=="undefined")return we;const re=await(0,A.asPromise)(()=>ge.getCanonicalURI(we));return re||we}$startExtensionHost(X){return this._registry.keepOnly(X),this._startExtensionHost()}$activateByEvent(X,ue){return ue===1?this._activateByEvent(X,!1):this._readyToRunExtensions.wait().then(ve=>this._activateByEvent(X,!1))}async $activate(X,ue){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(X)?(await this._activateById(X,ue),!0):!1}async $deltaExtensions(X,ue){X.forEach(ge=>ge.extensionLocation=T.URI.revive(ge.extensionLocation));const ve=await this.getExtensionPathIndex();return await Promise.all(ue.map(async ge=>{const we=this._registry.getExtensionDescription(ge);we&&ve.delete(await this._realPathExtensionUri(we.extensionLocation))})),await Promise.all(X.map(async ge=>{const we=await this._realPathExtensionUri(ge.extensionLocation);ve.set(we,ge)})),this._registry.deltaExtensions(X,ue),Promise.resolve(void 0)}async $test_latency(X){return X}async $test_up(X){return X.byteLength}async $test_down(X){let ue=u.VSBuffer.alloc(X),ve=Math.random()%256;for(let ge=0;ge<X;ge++)ue.writeUInt8(ve,ge);return ue}async $updateRemoteConnectionData(X){this._remoteConnectionData=X,this._onDidChangeRemoteConnectionData.fire()}};H=xe([$e(0,c.IInstantiationService),$e(1,e.IHostUtils),$e(2,g.IExtHostRpcService),$e(3,o.IExtHostWorkspace),$e(4,i.IExtHostConfiguration),$e(5,R.ILogService),$e(6,n.IExtHostInitDataService),$e(7,h.IExtensionStoragePaths),$e(8,d.IExtHostTunnelService),$e(9,p.IExtHostTerminalService)],H),e.AbstractExtHostExtensionService=H;function $(le,X){return{id:le.identifier.value,name:le.name,extensionVersion:le.version,publisherDisplayName:le.publisher,activationEvents:le.activationEvents?le.activationEvents.join(","):null,isBuiltin:le.isBuiltin,reason:X.activationEvent,reasonId:X.extensionId.value}}e.IExtHostExtensionService=(0,c.createDecorator)("IExtHostExtensionService");class G{constructor(X,ue,ve,ge){O.set(this,void 0),U.set(this,void 0),j.set(this,void 0),Xe(this,O,X,"f"),Xe(this,U,ue,"f"),Xe(this,j,ve.identifier,"f"),this.id=ve.identifier.value,this.extensionUri=ve.extensionLocation,this.extensionPath=t.normalize((0,P.originalFSPath)(ve.extensionLocation)),this.packageJSON=ve,this.extensionKind=ge}get isActive(){return Ie(this,O,"f").isActivated(Ie(this,j,"f"))}get exports(){if(this.packageJSON.api!=="none")return Ie(this,O,"f").getExtensionExports(Ie(this,j,"f"))}activate(){return Ie(this,O,"f").activateByIdWithErrors(Ie(this,j,"f"),{startup:!1,extensionId:Ie(this,U,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=G,O=new WeakMap,U=new WeakMap,j=new WeakMap;function ie(le){const X=le.indexOf("+");return X===-1?le:le.substring(0,X)}}),define(Se[97],_e([0,1,17,2,4,10,5,7,155,31,33,49,162,32,156,14,3,13,87,69]),function(ee,e,r,t,S,P,A,I,D,T,R,b,i,f,a,o,m,M,y,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,m.createDecorator)("IExtHostDebugService");let u=class{constructor(s,d,p,w,v,k){this._workspaceService=d,this._extensionService=p,this._editorsService=w,this._configurationService=v,this._editorTabs=k,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new S.Emitter,this._onDidTerminateDebugSession=new S.Emitter,this._onDidChangeActiveDebugSession=new S.Emitter,this._onDidReceiveDebugSessionCustomEvent=new S.Emitter,this._debugServiceProxy=s.getProxy(A.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new S.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new l(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(L=>{L.onDidChange(E=>{this.registerAllDebugTypes(L)}),this.registerAllDebugTypes(L)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(s,d){const p=s;if(typeof p.sourceReference=="number"&&p.sourceReference>0){let w=`debug:${encodeURIComponent(p.path||"")}`,v="?";return d&&(w+=`${v}session=${encodeURIComponent(d.id)}`,v="&"),w+=`${v}ref=${p.sourceReference}`,t.URI.parse(w)}else{if(p.path)return t.URI.file(p.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(s){const d=[];for(const p of s.getAllExtensionDescriptions())if(p.contributes){const w=p.contributes.debuggers;if(w&&w.length>0)for(const v of w)(0,a.isDebuggerMainContribution)(v)&&d.push(v.type)}this._debugServiceProxy.$registerDebugTypes(d)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const s=[];return this._breakpoints.forEach(d=>s.push(d)),s}addBreakpoints(s){this.startBreakpoints();const d=s.filter(v=>{const k=v.id;return this._breakpoints.has(k)?!1:(this._breakpoints.set(k,v),!0)});this.fireBreakpointChanges(d,[],[]);const p=[],w=new Map;for(const v of d)if(v instanceof I.SourceBreakpoint){let k=w.get(v.location.uri.toString());k||(k={type:"sourceMulti",uri:v.location.uri,lines:[]},w.set(v.location.uri.toString(),k),p.push(k)),k.lines.push({id:v.id,enabled:v.enabled,condition:v.condition,hitCondition:v.hitCondition,logMessage:v.logMessage,line:v.location.range.start.line,character:v.location.range.start.character})}else v instanceof I.FunctionBreakpoint&&p.push({type:"function",id:v.id,enabled:v.enabled,hitCondition:v.hitCondition,logMessage:v.logMessage,condition:v.condition,functionName:v.functionName});return this._debugServiceProxy.$registerBreakpoints(p)}removeBreakpoints(s){this.startBreakpoints();const d=s.filter(k=>this._breakpoints.delete(k.id));this.fireBreakpointChanges([],d,[]);const p=d.filter(k=>k instanceof I.SourceBreakpoint).map(k=>k.id),w=d.filter(k=>k instanceof I.FunctionBreakpoint).map(k=>k.id),v=d.filter(k=>k instanceof I.DataBreakpoint).map(k=>k.id);return this._debugServiceProxy.$unregisterBreakpoints(p,w,v)}startDebugging(s,d,p){return this._debugServiceProxy.$startDebugging(s?s.uri:void 0,d,{parentSessionID:p.parentSession?p.parentSession.id:void 0,lifecycleManagedByParent:p.lifecycleManagedByParent,repl:p.consoleMode===I.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:p.noDebug,compact:p.compact,debugUI:p.debugUI,suppressSaveBeforeStart:p.suppressSaveBeforeStart})}stopDebugging(s){return this._debugServiceProxy.$stopDebugging(s?s.id:void 0)}registerDebugConfigurationProvider(s,d,p){if(!d)return new I.Disposable(()=>{});const w=this._configProviderHandleCounter++;return this._configProviders.push({type:s,handle:w,provider:d}),this._debugServiceProxy.$registerDebugConfigurationProvider(s,p,!!d.provideDebugConfigurations,!!d.resolveDebugConfiguration,!!d.resolveDebugConfigurationWithSubstitutedVariables,w),new I.Disposable(()=>{this._configProviders=this._configProviders.filter(v=>v.provider!==d),this._debugServiceProxy.$unregisterDebugConfigurationProvider(w)})}registerDebugAdapterDescriptorFactory(s,d,p){if(!p)return new I.Disposable(()=>{});if(!this.definesDebugType(s,d))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${d}' debugger.`);if(this.getAdapterDescriptorFactoryByType(d))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const w=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:d,handle:w,factory:p}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(d,w),new I.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(v=>v.factory!==p),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(w)})}registerDebugAdapterTrackerFactory(s,d){if(!d)return new I.Disposable(()=>{});const p=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:s,handle:p,factory:d}),new I.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(w=>w.factory!==d)})}async $runInTerminal(s,d){return Promise.resolve(void 0)}async $substituteVariables(s,d){if(!this._variableResolver){const[v,k]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(v||[],this._editorsService,k)}let p;const w=await this.getFolder(s);return w&&(p={uri:w.uri,name:w.name,index:w.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(p,d)}createDebugAdapter(s,d){if(s.type==="implementation")return new n(s.implementation)}createSignService(){}async $startDASession(s,d){const p=this,w=await this.getSession(d);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(w.type),w).then(v=>{if(!v)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${w.type}' (extension might have failed to activate)`);const k=this.convertToDto(v),L=this.createDebugAdapter(k,w);if(!L)throw new Error(`Couldn't create a debug adapter for type '${w.type}'.`);const E=L;return this._debugAdapters.set(s,E),this.getDebugAdapterTrackers(w).then(O=>(O&&this._debugAdaptersTrackers.set(s,O),E.onMessage(async U=>{if(U.type==="request"&&U.command==="handshake"){const j=U,H={type:"response",seq:0,command:j.command,request_seq:j.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const $=await this._signService.sign(j.arguments.value);H.body={signature:$},E.sendResponse(H)}else throw new Error("no signer")}catch($){H.success=!1,H.message=$.message,E.sendResponse(H)}}else O&&O.onDidSendMessage&&O.onDidSendMessage(U),U=(0,a.convertToVSCPaths)(U,!0),p._debugServiceProxy.$acceptDAMessage(s,U)}),E.onError(U=>{O&&O.onError&&O.onError(U),this._debugServiceProxy.$acceptDAError(s,U.name,U.message,U.stack)}),E.onExit(U=>{O&&O.onExit&&O.onExit((0,M.withNullAsUndefined)(U),void 0),this._debugServiceProxy.$acceptDAExit(s,(0,M.withNullAsUndefined)(U),void 0)}),O&&O.onWillStartSession&&O.onWillStartSession(),E.startSession()))})}$sendDAMessage(s,d){d=(0,a.convertToDAPaths)(d,!1);const p=this._debugAdaptersTrackers.get(s);p&&p.onWillReceiveMessage&&p.onWillReceiveMessage(d);const w=this._debugAdapters.get(s);w&&w.sendMessage(d)}$stopDASession(s){const d=this._debugAdaptersTrackers.get(s);this._debugAdaptersTrackers.delete(s),d&&d.onWillStopSession&&d.onWillStopSession();const p=this._debugAdapters.get(s);return this._debugAdapters.delete(s),p?p.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(s){const d=[],p=[],w=[];if(s.added)for(const v of s.added){const k=v.id;if(k&&!this._breakpoints.has(k)){let L;if(v.type==="function")L=new I.FunctionBreakpoint(v.functionName,v.enabled,v.condition,v.hitCondition,v.logMessage);else if(v.type==="data")L=new I.DataBreakpoint(v.label,v.dataId,v.canPersist,v.enabled,v.hitCondition,v.condition,v.logMessage);else{const E=t.URI.revive(v.uri);L=new I.SourceBreakpoint(new I.Location(E,new I.Position(v.line,v.character)),v.enabled,v.condition,v.hitCondition,v.logMessage)}L._id=k,this._breakpoints.set(k,L),d.push(L)}}if(s.removed)for(const v of s.removed){const k=this._breakpoints.get(v);k&&(this._breakpoints.delete(v),p.push(k))}if(s.changed){for(const v of s.changed)if(v.id){const k=this._breakpoints.get(v.id);if(k){if(k instanceof I.FunctionBreakpoint&&v.type==="function"){const L=k;L.enabled=v.enabled,L.condition=v.condition,L.hitCondition=v.hitCondition,L.logMessage=v.logMessage,L.functionName=v.functionName}else if(k instanceof I.SourceBreakpoint&&v.type==="source"){const L=k;L.enabled=v.enabled,L.condition=v.condition,L.hitCondition=v.hitCondition,L.logMessage=v.logMessage,L.location=new I.Location(t.URI.revive(v.uri),new I.Position(v.line,v.character))}w.push(k)}}}this.fireBreakpointChanges(d,p,w)}$provideDebugConfigurations(s,d,p){return(0,P.asPromise)(async()=>{const w=this.getConfigProviderByHandle(s);if(!w)throw new Error("no DebugConfigurationProvider found");if(!w.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const v=await this.getFolder(d);return w.provideDebugConfigurations(v,p)}).then(w=>{if(!w)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return w})}$resolveDebugConfiguration(s,d,p,w){return(0,P.asPromise)(async()=>{const v=this.getConfigProviderByHandle(s);if(!v)throw new Error("no DebugConfigurationProvider found");if(!v.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const k=await this.getFolder(d);return v.resolveDebugConfiguration(k,p,w)})}$resolveDebugConfigurationWithSubstitutedVariables(s,d,p,w){return(0,P.asPromise)(async()=>{const v=this.getConfigProviderByHandle(s);if(!v)throw new Error("no DebugConfigurationProvider found");if(!v.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const k=await this.getFolder(d);return v.resolveDebugConfigurationWithSubstitutedVariables(k,p,w)})}async $provideDebugAdapter(s,d){const p=this.getAdapterDescriptorFactoryByHandle(s);if(!p)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const w=await this.getSession(d);return this.getAdapterDescriptor(p,w).then(v=>{if(!v)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${w.type}'`);return this.convertToDto(v)})}async $acceptDebugSessionStarted(s){const d=await this.getSession(s);this._onDidStartDebugSession.fire(d)}async $acceptDebugSessionTerminated(s){const d=await this.getSession(s);d&&(this._onDidTerminateDebugSession.fire(d),this._debugSessions.delete(d.id))}async $acceptDebugSessionActiveChanged(s){this._activeDebugSession=s?await this.getSession(s):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(s,d){const p=await this.getSession(s);p&&p._acceptNameChanged(d)}async $acceptDebugSessionCustomEvent(s,d){const w={session:await this.getSession(s),event:d.event,body:d.body};this._onDidReceiveDebugSessionCustomEvent.fire(w)}convertToDto(s){if(s instanceof I.DebugAdapterExecutable)return{type:"executable",command:s.command,args:s.args,options:s.options};if(s instanceof I.DebugAdapterServer)return{type:"server",port:s.port,host:s.host};if(s instanceof I.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:s.path};if(s instanceof I.DebugAdapterInlineImplementation)return{type:"implementation",implementation:s.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(s){const d=this._adapterFactories.filter(p=>p.type===s);if(d.length>0)return d[0].factory}getAdapterDescriptorFactoryByHandle(s){const d=this._adapterFactories.filter(p=>p.handle===s);if(d.length>0)return d[0].factory}getConfigProviderByHandle(s){const d=this._configProviders.filter(p=>p.handle===s);if(d.length>0)return d[0].provider}definesDebugType(s,d){if(s.contributes){const p=s.contributes.debuggers;if(p&&p.length>0){for(const w of p)if(w.label&&w.type&&w.type===d)return!0}}return!1}getDebugAdapterTrackers(s){const p=s.configuration.type,w=this._trackerFactories.filter(v=>v.type===p||v.type==="*").map(v=>(0,P.asPromise)(()=>v.factory.createDebugAdapterTracker(s)).then(k=>k,k=>null));return Promise.race([Promise.all(w).then(v=>{const k=v.filter(L=>!!L);if(k.length>0)return new c(k)}),new Promise((v,k)=>{const L=setTimeout(()=>{clearTimeout(L),k(new Error("timeout"))},1e3)})]).catch(v=>{})}async getAdapterDescriptor(s,d){const p=d.configuration.debugServer;if(typeof p=="number")return Promise.resolve(new I.DebugAdapterServer(p));if(s){const v=await this._extensionService.getExtensionRegistry();return(0,P.asPromise)(()=>s.createDebugAdapterDescriptor(d,this.daExecutableFromPackage(d,v))).then(k=>{if(k)return k})}const w=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(d,w))}daExecutableFromPackage(s,d){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(s,d,p){(s.length>0||d.length>0||p.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:s,removed:d,changed:p}))}async getSession(s){if(s)if(typeof s=="string"){const d=this._debugSessions.get(s);if(d)return d}else{let d=this._debugSessions.get(s.id);if(!d){const p=await this.getFolder(s.folderUri),w=s.parent?this._debugSessions.get(s.parent):void 0;d=new C(this._debugServiceProxy,s.id,s.type,s.name,p,s.configuration,w),this._debugSessions.set(d.id,d),this._debugServiceProxy.$sessionCached(d.id)}return d}throw new Error("cannot find session")}getFolder(s){if(s){const d=t.URI.revive(s);return this._workspaceService.resolveWorkspaceFolder(d)}return Promise.resolve(void 0)}};u=xe([$e(0,o.IExtHostRpcService),$e(1,T.IExtHostWorkspace),$e(2,R.IExtHostExtensionService),$e(3,b.IExtHostDocumentsAndEditors),$e(4,f.IExtHostConfiguration),$e(5,_.IExtHostEditorTabs)],u),e.ExtHostDebugServiceBase=u;class C{constructor(s,d,p,w,v,k,L){this._debugServiceProxy=s,this._id=d,this._type=p,this._name=w,this._workspaceFolder=v,this._configuration=k,this._parentSession=L}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(s){this._name=s,this._debugServiceProxy.$setDebugSessionName(this._id,s)}get parentSession(){return this._parentSession}_acceptNameChanged(s){this._name=s}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(s,d){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,s,d)}getDebugProtocolBreakpoint(s){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,s.id)}}e.ExtHostDebugSession=C;class l{constructor(s){this.value=Object.freeze({append(d){s.$appendDebugConsole(d)},appendLine(d){this.append(d+`
`)}})}}e.ExtHostDebugConsole=l;class F extends i.AbstractVariableResolverService{constructor(s,d,p,w,v){function k(){if(d){const L=d.activeEditor();if(L)return L.document.uri;const E=w.tabs.filter(O=>O.isActive);if(E.length>0){const O=E[0].resource;return O&&(O.primary||O.secondary)?O.primary??O.secondary:E[0].resource}}}super({getFolderUri:L=>{const E=s.filter(O=>O.name===L);if(E&&E.length>0)return E[0].uri},getWorkspaceFolderCount:()=>s.length,getConfigurationValue:(L,E)=>p.getConfiguration(void 0,L).get(E),getAppRoot:()=>y.cwd(),getExecPath:()=>y.env.VSCODE_EXEC_PATH,getFilePath:()=>{const L=k();if(L)return r.normalize(L.fsPath)},getWorkspaceFolderPathForFile:()=>{if(v){const L=k();if(L){const E=v.getWorkspaceFolder(L);if(E)return r.normalize(E.uri.fsPath)}}},getSelectedText:()=>{if(d){const L=d.activeEditor();if(L&&!L.selection.isEmpty)return L.document.getText(L.selection)}},getLineNumber:()=>{if(d){const L=d.activeEditor();if(L)return String(L.selection.end.line+1)}}},void 0,Promise.resolve(y.env))}}e.ExtHostVariableResolverService=F;class c{constructor(s){this.trackers=s}onWillStartSession(){this.trackers.forEach(s=>s.onWillStartSession?s.onWillStartSession():void 0)}onWillReceiveMessage(s){this.trackers.forEach(d=>d.onWillReceiveMessage?d.onWillReceiveMessage(s):void 0)}onDidSendMessage(s){this.trackers.forEach(d=>d.onDidSendMessage?d.onDidSendMessage(s):void 0)}onWillStopSession(){this.trackers.forEach(s=>s.onWillStopSession?s.onWillStopSession():void 0)}onError(s){this.trackers.forEach(d=>d.onError?d.onError(s):void 0)}onExit(s,d){this.trackers.forEach(p=>p.onExit?p.onExit(s,d):void 0)}}class n extends D.AbstractDebugAdapter{constructor(s){super();this.implementation=s,s.onDidSendMessage(d=>{this.acceptMessage(d)})}startSession(){return Promise.resolve(void 0)}sendMessage(s){this.implementation.handleMessage(s)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let h=class extends u{constructor(s,d,p,w,v,k){super(s,d,p,w,v,k)}createVariableResolver(s,d,p){return new F(s,d,p,this._editorTabs)}};h=xe([$e(0,o.IExtHostRpcService),$e(1,T.IExtHostWorkspace),$e(2,R.IExtHostExtensionService),$e(3,b.IExtHostDocumentsAndEditors),$e(4,f.IExtHostConfiguration),$e(5,_.IExtHostEditorTabs)],h),e.WorkerExtHostDebugService=h}),define(Se[213],_e([0,1,72,2,5,32,26,25,14,28,3,33,87,12,9]),function(ee,e,r,t,S,P,A,I,D,T,R,b,i,f,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let o=class{constructor(C,l,F,c,n,h,g){this._apiFactory=C,this._extensionRegistry=l,this._instaService=F,this._extHostConfiguration=c,this._extHostExtensionService=n,this._initData=h,this._logService=g,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),r.mark("code/extHost/willWaitForConfig");const C=await this._extHostConfiguration.getConfigProvider();r.mark("code/extHost/didWaitForConfig");const l=await this._extHostExtensionService.getExtensionPathIndex();this.register(new M(this._apiFactory,l,this._extensionRegistry,C,this._logService)),this.register(this._instaService.createInstance(y,l)),this.register(this._instaService.createInstance(m)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(_,l,this._initData.environment.appUriScheme))}register(C){if("nodeModuleName"in C)if(Array.isArray(C.nodeModuleName))for(let l of C.nodeModuleName)this._factories.set(l,C);else this._factories.set(C.nodeModuleName,C);typeof C.alternativeModuleName=="function"&&this._alternatives.push(l=>C.alternativeModuleName(l))}};o=xe([$e(2,R.IInstantiationService),$e(3,P.IExtHostConfiguration),$e(4,b.IExtHostExtensionService),$e(5,T.IExtHostInitDataService),$e(6,f.ILogService)],o),e.RequireInterceptor=o;let m=class Hi{constructor(C){if(C.environment.appRoot&&Hi.aliased.size){const l=(0,a.escapeRegExpCharacters)(this.forceForwardSlashes(C.environment.appRoot.fsPath)),F="[a-z0-9_.-]",c=`@${F}+\\/${F}+|${F}+`,n="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${l}/${n}\\/)(${c})(.*)$`,"i")}}alternativeModuleName(C){if(!this.re)return;const l=this.re.exec(this.forceForwardSlashes(C));if(!l)return;const[,F,c,n]=l,h=Hi.aliased.get(c);if(h!==void 0)return console.warn(`${c} as been renamed to ${h}, please update your imports`),F+h+n}forceForwardSlashes(C){return C.replace(/\\/g,"/")}};m.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"]]),m=xe([$e(0,T.IExtHostInitDataService)],m);class M{constructor(C,l,F,c,n){this._apiFactory=C,this._extensionPaths=l,this._extensionRegistry=F,this._configProvider=c,this._logService=n,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(C,l){const F=this._extensionPaths.findSubstr(l);if(F){let c=this._extApiImpl.get(I.ExtensionIdentifier.toKey(F.identifier));return c||(c=this._apiFactory(F,this._extensionRegistry,this._configProvider),this._extApiImpl.set(I.ExtensionIdentifier.toKey(F.identifier),c)),c}if(!this._defaultApiImpl){let c="";this._extensionPaths.forEach((n,h)=>c+=`	${h} -> ${n.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${l}. These are the extension path mappings: 
${c}`),this._defaultApiImpl=this._apiFactory(A.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let y=class{constructor(C,l,F){this._extensionPaths=C,this.nodeModuleName="keytar",this._mainThreadTelemetry=l.getProxy(S.MainContext.MainThreadTelemetry);const{environment:c}=F,n=l.getProxy(S.MainContext.MainThreadKeytar);if(c.appRoot){let h=c.appRoot.fsPath;i.platform==="win32"&&(h=h.replace(/\\/g,"/")),h[h.length-1]==="/"&&(h=h.substr(0,h.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${h}/node_modules.asar/keytar`),this.alternativeNames.add(`${h}/node_modules/keytar`)}this._impl={getPassword:(h,g)=>n.$getPassword(h,g),setPassword:(h,g,s)=>n.$setPassword(h,g,s),deletePassword:(h,g)=>n.$deletePassword(h,g),findPassword:h=>n.$findPassword(h),findCredentials(h){return n.$findCredentials(h)}}}load(C,l){const F=this._extensionPaths.findSubstr(l);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:F?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(C){const l=C.length;if(l<=7||!this.alternativeNames)return;const F=l-7;if((C.charAt(F)==="/"||C.charAt(F)==="\\")&&C.endsWith("keytar")&&(C=C.replace(/\\/g,"/"),this.alternativeNames.has(C)))return"keytar"}};y=xe([$e(1,D.IExtHostRpcService),$e(2,T.IExtHostInitDataService)],y);let _=class{constructor(C,l,F){this._extensionPaths=C,this._appUriScheme=l,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=F.getProxy(S.MainContext.MainThreadTelemetry);const c=F.getProxy(S.MainContext.MainThreadWindow);this._impl=(n,h)=>{const g=t.URI.parse(n);return h?this.callOriginal(n,h):g.scheme==="http"||g.scheme==="https"?c.$openUri(g,n,{allowTunneling:!0}):g.scheme==="mailto"||g.scheme===this._appUriScheme?c.$openUri(g,n,{}):this.callOriginal(n,h)}}load(C,l,F){const c=this._extensionPaths.findSubstr(l);return c&&(this._extensionId=c.identifier.value,this.sendShimmingTelemetry()),this._original=F(C),this._impl}callOriginal(C,l){return this.sendNoForwardTelemetry(),this._original(C,l)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};_=xe([$e(2,D.IExtHostRpcService)],_)}),define(Se[214],_e([0,1,10,15,72,6,2,5,207,12,44,59,28,136,14,64,33,40]),function(ee,e,r,t,S,P,A,I,D,T,R,b,i,f,a,o,m,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class y{constructor(u,C,l,F,c){this._disposables=new P.DisposableStore,this._isTerminating=!1,this._hostUtils=l,this._rpcProtocol=new D.RPCProtocol(u,null,F),C=y._transform(C,this._rpcProtocol);const n=new b.ServiceCollection(...(0,R.getSingletonServiceDescriptors)());n.set(i.IExtHostInitDataService,{_serviceBrand:void 0,...C,messagePorts:c}),n.set(a.IExtHostRpcService,new a.ExtHostRpcService(this._rpcProtocol)),n.set(o.IURITransformerService,new o.URITransformerService(F)),n.set(m.IHostUtils,l);const h=new f.InstantiationService(n,!0);this._disposables.add(h.invokeFunction(p=>p.get(M.IExtHostTerminalService))),this._disposables.add(h.invokeFunction(p=>p.get(m.IExtHostExtensionService))),this._logService=h.invokeFunction(p=>p.get(T.ILogService)),S.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",C),this._extensionService=h.invokeFunction(p=>p.get(m.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const g=new WeakMap;this._extensionService.getExtensionPathIndex().then(p=>{Error.prepareStackTrace=(w,v)=>{let k="",L,E;for(const O of v)k+=`
	at ${O.toString()}`,E=O.getFileName(),!L&&E&&(L=p.findSubstr(A.URI.file(E)));return g.set(w,L),`${w.name||"Error"}: ${w.message||""}${k}`}});const s=this._rpcProtocol.getProxy(I.MainContext.MainThreadExtensionService),d=this._rpcProtocol.getProxy(I.MainContext.MainThreadErrors);t.setUnexpectedErrorHandler(p=>{const w=t.transformErrorForSerialization(p),v=g.get(p);v?s.$onExtensionRuntimeError(v.identifier,w):d.$onUnexpectedError(w)})}terminate(u){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${u}`),this._logService.flush(),this._disposables.dispose(),t.setUnexpectedErrorHandler(l=>{this._logService.error(l)}),this._rpcProtocol.dispose();const C=this._extensionService.deactivateAll();Promise.race([(0,r.timeout)(5e3),C]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code 0`):this._logService.info("Extension host exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})}static _transform(u,C){u.extensions.forEach(F=>F.extensionLocation=A.URI.revive(C.transformIncomingURIs(F.extensionLocation))),u.environment.appRoot=A.URI.revive(C.transformIncomingURIs(u.environment.appRoot));const l=u.environment.extensionDevelopmentLocationURI;return l&&(u.environment.extensionDevelopmentLocationURI=l.map(F=>A.URI.revive(C.transformIncomingURIs(F)))),u.environment.extensionTestsLocationURI=A.URI.revive(C.transformIncomingURIs(u.environment.extensionTestsLocationURI)),u.environment.globalStorageHome=A.URI.revive(C.transformIncomingURIs(u.environment.globalStorageHome)),u.environment.workspaceStorageHome=A.URI.revive(C.transformIncomingURIs(u.environment.workspaceStorageHome)),u.logsLocation=A.URI.revive(C.transformIncomingURIs(u.logsLocation)),u.logFile=A.URI.revive(C.transformIncomingURIs(u.logFile)),u.workspace=C.transformIncomingURIs(u.workspace),u}}e.ExtensionHostMain=y}),define(Se[215],_e([0,1,17,20,43,29,24,188,41]),function(ee,e,r,t,S,P,A,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class T{constructor(i,f,a){this.config=i,this.provider=f,this.sessionToken=a,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=i.filePattern,this.includePattern=i.includePattern&&P.parse(i.includePattern),this.maxResults=i.maxResults||void 0,this.exists=i.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=i.excludePattern&&P.parse(i.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(i=>i.cancel()),this.activeCancellationTokens=new Set}search(i){const f=this.config.folderQueries||[];return new Promise((a,o)=>{const m=M=>{this.resultCount++,i(M)};if(this.isCanceled)return a({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(M=>{const y=M.toString(),_=r.basename(y);this.globalExcludePattern&&this.globalExcludePattern(y,_)||this.matchFile(m,{base:M,basename:_})}),Promise.all(f.map(M=>this.searchInFolder(M,m))).then(M=>{a({limitHit:this.isLimitHit,stats:M[0]||void 0})},M=>{o(new Error((0,S.toErrorMessage)(M)))})})}async searchInFolder(i,f){const a=new t.CancellationTokenSource,o=this.getSearchOptionsForFolder(i),m=this.initDirectoryTree(),M=new D.QueryGlobTester(this.config,i),y=!M.hasSiblingExcludeClauses();let _;try{this.activeCancellationTokens.add(a),_=I.StopWatch.create();const u=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},o,a.token),C=_.elapsed(),l=I.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(u&&u.forEach(F=>{const c=r.posix.relative(i.folder.path,F.path);if(y){const n=r.basename(F.path);this.matchFile(f,{base:i.folder,relativePath:c,basename:n});return}this.addDirectoryEntries(m,i.folder,c,f)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(m,M,f),{providerTime:C,postProcessTime:l.elapsed()})}finally{a.dispose(),this.activeCancellationTokens.delete(a)}}getSearchOptionsForFolder(i){const f=(0,D.resolvePatternsForProvider)(this.config.includePattern,i.includePattern),a=(0,D.resolvePatternsForProvider)(this.config.excludePattern,i.excludePattern);return{folder:i.folder,excludes:a,includes:f,useIgnoreFiles:!i.disregardIgnoreFiles,useGlobalIgnoreFiles:!i.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!i.disregardParentIgnoreFiles,followSymlinks:!i.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const i={rootEntries:[],pathToEntries:Object.create(null)};return i.pathToEntries["."]=i.rootEntries,i}addDirectoryEntries({pathToEntries:i},f,a,o){if(a===this.filePattern){const M=r.basename(this.filePattern);this.matchFile(o,{base:f,relativePath:this.filePattern,basename:M})}function m(M){const y=r.basename(M),_=r.dirname(M);let u=i[_];u||(u=i[_]=[],m(_)),u.push({base:f,relativePath:M,basename:y})}m(a)}matchDirectoryTree({rootEntries:i,pathToEntries:f},a,o){const m=this,M=this.filePattern;function y(_){const u=P.hasSiblingFn(()=>_.map(C=>C.basename));for(let C=0,l=_.length;C<l;C++){const F=_[C],{relativePath:c,basename:n}=F;if(a.matchesExcludesSync(c,n,M!==n?u:void 0))continue;const h=f[c];if(h)y(h);else{if(c===M)continue;m.matchFile(o,F)}if(m.isLimitHit)break}}y(i)}matchFile(i,f){(!this.includePattern||f.relativePath&&this.includePattern(f.relativePath,f.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||i(f))}}class R{constructor(){this.sessions=new Map}fileSearch(i,f,a,o){const m=this.getSessionTokenSource(i.cacheKey),M=new T(i,f,m&&m.token);let y=0;const _=u=>{y+=u.length,a(u.map(C=>this.rawMatchToSearchItem(C)))};return this.doSearch(M,R.BATCH_SIZE,_,o).then(u=>({limitHit:u.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:y,detailStats:u.stats}}))}clearCache(i){const f=this.getSessionTokenSource(i);f&&f.cancel()}getSessionTokenSource(i){if(!!i)return this.sessions.has(i)||this.sessions.set(i,new t.CancellationTokenSource),this.sessions.get(i)}rawMatchToSearchItem(i){return i.relativePath?{resource:A.joinPath(i.base,i.relativePath)}:{resource:i.base}}doSearch(i,f,a,o){o.onCancellationRequested(()=>{i.cancel()});const m=y=>{y&&(M.push(y),f>0&&M.length>=f&&(a(M),M=[]))};let M=[];return i.search(m).then(y=>(M.length&&a(M),y),y=>(M.length&&a(M),Promise.reject(y)))}}e.FileSearchManager=R,R.BATCH_SIZE=512}),define(Se[216],_e([0,1,16,10,20,43,29,11,17,24,13,2,41]),function(ee,e,r,t,S,P,A,I,D,T,R,b,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class f{constructor(u,C,l,F){this.query=u,this.provider=C,this.fileUtils=l,this.processType=F,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(u,C){const l=this.query.folderQueries||[],F=new S.CancellationTokenSource;return C.onCancellationRequested(()=>F.cancel()),new Promise((c,n)=>{this.collector=new o(u);let h=!1;const g=(s,d)=>{if(!h&&!this.isLimitHit){const p=this.resultSize(s);M(s)&&typeof this.query.maxResults=="number"&&this.resultCount+p>this.query.maxResults&&(this.isLimitHit=!0,h=!0,F.cancel(),s=this.trimResultToSize(s,this.query.maxResults-this.resultCount));const w=this.resultSize(s);this.resultCount+=w,(w>0||!M(s))&&this.collector.add(s,d)}};Promise.all(l.map((s,d)=>this.searchInFolder(s,p=>g(p,d),F.token))).then(s=>{F.dispose(),this.collector.flush();const d=s.some(p=>!!p&&!!p.limitHit);c({limitHit:this.isLimitHit||d,messages:(0,r.flatten)(s.map(p=>p?.message?(0,R.isArray)(p.message)?p.message:[p.message]:[])),stats:{type:this.processType}})},s=>{F.dispose();const d=(0,P.toErrorMessage)(s);n(new Error(d))})})}resultSize(u){return M(u)?Array.isArray(u.ranges)?u.ranges.length:1:0}trimResultToSize(u,C){const l=Array.isArray(u.ranges)?u.ranges:[u.ranges],F=Array.isArray(u.preview.matches)?u.preview.matches:[u.preview.matches];return{ranges:l.slice(0,C),preview:{matches:F.slice(0,C),text:u.preview.text},uri:u.uri}}async searchInFolder(u,C,l){const F=new i.QueryGlobTester(this.query,u),c=[],n={report:s=>{if(!this.validateProviderResult(s))return;const d=u.folder.scheme===I.Schemas.file?A.hasSiblingPromiseFn(()=>this.fileUtils.readdir(T.dirname(s.uri))):void 0,p=T.relativePath(u.folder,s.uri);if(p){const w=F.includedInQuery(p,D.basename(p),d);(0,t.isThenable)(w)?c.push(w.then(v=>{v&&C(s)})):w&&C(s)}}},h=this.getSearchOptionsForFolder(u),g=await this.provider.provideTextSearchResults(a(this.query.contentPattern),h,n,l);return c.length&&await Promise.all(c),g}validateProviderResult(u){if(M(u)){if(Array.isArray(u.ranges)){if(!Array.isArray(u.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(u.preview.matches.length!==u.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(u.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(u){const C=(0,i.resolvePatternsForProvider)(this.query.includePattern,u.includePattern),l=(0,i.resolvePatternsForProvider)(this.query.excludePattern,u.excludePattern),F={folder:b.URI.from(u.folder),excludes:l,includes:C,useIgnoreFiles:!u.disregardIgnoreFiles,useGlobalIgnoreFiles:!u.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!u.disregardParentIgnoreFiles,followSymlinks:!u.ignoreSymlinks,encoding:u.fileEncoding&&this.fileUtils.toCanonicalName(u.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return F.usePCRE2=this.query.usePCRE2,F}}e.TextSearchManager=f;function a(_){return{isCaseSensitive:_.isCaseSensitive||!1,isRegExp:_.isRegExp||!1,isWordMatch:_.isWordMatch||!1,isMultiline:_.isMultiline||!1,pattern:_.pattern}}class o{constructor(u){this._onResult=u,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new y(512,C=>this.sendItems(C))}add(u,C){this._currentFileMatch&&(this._currentFolderIdx!==C||!T.isEqual(this._currentUri,u.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=C,this._currentFileMatch={resource:u.uri,results:[]}),this._currentFileMatch.results.push(m(u))}pushToCollector(){const u=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,u)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(u){this._onResult(u)}}e.TextSearchResultsCollector=o;function m(_){return M(_)?{preview:{matches:(0,r.mapArrayOrNot)(_.preview.matches,u=>({startLineNumber:u.start.line,startColumn:u.start.character,endLineNumber:u.end.line,endColumn:u.end.character})),text:_.preview.text},ranges:(0,r.mapArrayOrNot)(_.ranges,u=>({startLineNumber:u.start.line,startColumn:u.start.character,endLineNumber:u.end.line,endColumn:u.end.character}))}:{text:_.text,lineNumber:_.lineNumber}}function M(_){return!!_.preview}e.extensionResultIsMatch=M;class y{constructor(u,C){this.maxBatchSize=u,this.cb=C,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(u,C){!u||this.addItemToBatch(u,C)}addItems(u,C){!u||this.addItemsToBatch(u,C)}addItemToBatch(u,C){this.batch.push(u),this.batchSize+=C,this.onUpdate()}addItemsToBatch(u,C){this.batch=this.batch.concat(u),this.batchSize+=C,this.onUpdate()}onUpdate(){this.totalNumberCompleted<y.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},y.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=y,y.TIMEOUT=4e3,y.START_BATCH_AFTER_COUNT=50}),define(Se[98],_e([0,1,6,5,3,215,14,64,12,2,216]),function(ee,e,r,t,S,P,A,I,D,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,S.createDecorator)("IExtHostSearch");let b=class{constructor(o,m,M){this.extHostRpc=o,this._uriTransformer=m,this._logService=M,this._proxy=this.extHostRpc.getProxy(t.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new P.FileSearchManager}_transformScheme(o){return this._uriTransformer.transformOutgoingScheme(o)}registerTextSearchProvider(o,m){if(this._textSearchUsedSchemes.has(o))throw new Error(`a text search provider for the scheme '${o}' is already registered`);this._textSearchUsedSchemes.add(o);const M=this._handlePool++;return this._textSearchProvider.set(M,m),this._proxy.$registerTextSearchProvider(M,this._transformScheme(o)),(0,r.toDisposable)(()=>{this._textSearchUsedSchemes.delete(o),this._textSearchProvider.delete(M),this._proxy.$unregisterProvider(M)})}registerFileSearchProvider(o,m){if(this._fileSearchUsedSchemes.has(o))throw new Error(`a file search provider for the scheme '${o}' is already registered`);this._fileSearchUsedSchemes.add(o);const M=this._handlePool++;return this._fileSearchProvider.set(M,m),this._proxy.$registerFileSearchProvider(M,this._transformScheme(o)),(0,r.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(o),this._fileSearchProvider.delete(M),this._proxy.$unregisterProvider(M)})}$provideFileSearchResults(o,m,M,y){const _=i(M),u=this._fileSearchProvider.get(o);if(u)return this._fileSearchManager.fileSearch(_,u,C=>{this._proxy.$handleFileMatch(o,m,C.map(l=>l.resource))},y);throw new Error("unknown provider: "+o)}$clearCache(o){return this._fileSearchManager.clearCache(o),Promise.resolve(void 0)}$provideTextSearchResults(o,m,M,y){const _=this._textSearchProvider.get(o);if(!_||!_.provideTextSearchResults)throw new Error(`Unknown provider ${o}`);const u=i(M);return this.createTextSearchManager(u,_).search(l=>this._proxy.$handleTextMatch(o,m,l),y)}$enableExtensionHostSearch(){}createTextSearchManager(o,m){return new R.TextSearchManager(o,m,{readdir:M=>Promise.resolve([]),toCanonicalName:M=>M},"textSearchProvider")}};b=xe([$e(0,A.IExtHostRpcService),$e(1,I.IURITransformerService),$e(2,D.ILogService)],b),e.ExtHostSearch=b;function i(a){return{...a,folderQueries:a.folderQueries&&a.folderQueries.map(f),extraFileResources:a.extraFileResources&&a.extraFileResources.map(o=>T.URI.revive(o))}}e.reviveQuery=i;function f(a){return{...a,folder:T.URI.revive(a.folder)}}}),define(Se[217],_e([0,1,44,93,31,91,32,39,49,40,96,97,98,70,63,68,94,50,30,67,83,69,190,12,172]),function(ee,e,r,t,S,P,A,I,D,T,R,b,i,f,a,o,m,M,y,_,u,C,l,F,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,r.registerSingleton)(F.ILoggerService,l.ExtHostLoggerService),(0,r.registerSingleton)(F.ILogService,c.ExtHostLogService),(0,r.registerSingleton)(o.IExtHostApiDeprecationService,o.ExtHostApiDeprecationService),(0,r.registerSingleton)(I.IExtHostCommands,I.ExtHostCommands),(0,r.registerSingleton)(A.IExtHostConfiguration,A.ExtHostConfiguration),(0,r.registerSingleton)(M.IExtHostConsumerFileSystem,M.ExtHostConsumerFileSystem),(0,r.registerSingleton)(b.IExtHostDebugService,b.WorkerExtHostDebugService),(0,r.registerSingleton)(P.IExtHostDecorations,P.ExtHostDecorations),(0,r.registerSingleton)(D.IExtHostDocumentsAndEditors,D.ExtHostDocumentsAndEditors),(0,r.registerSingleton)(y.IExtHostFileSystemInfo,y.ExtHostFileSystemInfo),(0,r.registerSingleton)(t.IExtHostOutputService,t.ExtHostOutputService),(0,r.registerSingleton)(i.IExtHostSearch,i.ExtHostSearch),(0,r.registerSingleton)(f.IExtHostStorage,f.ExtHostStorage),(0,r.registerSingleton)(R.IExtHostTask,R.WorkerExtHostTask),(0,r.registerSingleton)(T.IExtHostTerminalService,T.WorkerExtHostTerminalService),(0,r.registerSingleton)(a.IExtHostTunnelService,a.ExtHostTunnelService),(0,r.registerSingleton)(m.IExtHostWindow,m.ExtHostWindow),(0,r.registerSingleton)(S.IExtHostWorkspace,S.ExtHostWorkspace),(0,r.registerSingleton)(_.IExtHostSecretState,_.ExtHostSecretState),(0,r.registerSingleton)(u.IExtHostTelemetry,u.ExtHostTelemetry),(0,r.registerSingleton)(C.IExtHostEditorTabs,C.ExtHostEditorTabs)}),define(Se[218],_e([0,1,44,3]),function(ee,e,r,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeViewsDragAndDropService=e.ITreeViewsDragAndDropService=void 0,e.ITreeViewsDragAndDropService=(0,t.createDecorator)("treeViewsDragAndDropService");class S{constructor(){this._dragOperations=new Map}removeDragOperationTransfer(A){if(A&&this._dragOperations.has(A)){const I=this._dragOperations.get(A);return this._dragOperations.delete(A),I}}addDragOperationTransfer(A,I){this._dragOperations.set(A,I)}}e.TreeViewsDragAndDropService=S,(0,r.registerSingleton)(e.ITreeViewsDragAndDropService,S)}),define(Se[219],_e([0,1,123,24,2,4,6,10,7,13,16,8,20,152,218]),function(ee,e,r,t,S,P,A,I,D,T,R,b,i,f,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function o(y,_){if((0,T.isString)(y))return{label:y};if(y&&typeof y=="object"&&typeof y.label=="string"){let u;return Array.isArray(y.highlights)&&(u=y.highlights.filter(C=>C.length===2&&typeof C[0]=="number"&&typeof C[1]=="number"),u=u.length?u:void 0),{label:y.label,highlights:u}}}class m{constructor(_,u,C){this._proxy=_,this.commands=u,this.logService=C,this.treeViews=new Map,this.treeDragAndDropService=new a.TreeViewsDragAndDropService;function l(F){return F&&F.$treeViewId&&F.$treeItemHandle}u.registerArgumentProcessor({processArgument:F=>l(F)?this.convertArgument(F):Array.isArray(F)&&F.length>0?F.map(c=>l(c)?this.convertArgument(c):c):F})}registerTreeDataProvider(_,u,C){const l=this.createTreeView(_,{treeDataProvider:u},C);return{dispose:()=>l.dispose()}}createTreeView(_,u,C){if(!u||!u.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const l=u.dragAndDropController?.supportedMimeTypes,F=!!u.dragAndDropController?.handleDrag,c=this._proxy.$registerTreeViewDataProvider(_,{showCollapseAll:!!u.showCollapseAll,canSelectMany:!!u.canSelectMany,dragAndDropMimeTypes:l,hasHandleDrag:F}),n=this.createExtHostTreeView(_,u,C);return{get onDidCollapseElement(){return n.onDidCollapseElement},get onDidExpandElement(){return n.onDidExpandElement},get selection(){return n.selectedElements},get onDidChangeSelection(){return n.onDidChangeSelection},get visible(){return n.visible},get onDidChangeVisibility(){return n.onDidChangeVisibility},get message(){return n.message},set message(h){n.message=h},get title(){return n.title},set title(h){n.title=h},get description(){return n.description},set description(h){n.description=h},reveal:(h,g)=>n.reveal(h,g),dispose:async()=>{await c,this.treeViews.delete(_),n.dispose()}}}$getChildren(_,u){const C=this.treeViews.get(_);return C?C.getChildren(u):Promise.reject(new Error((0,r.localize)(0,null,_)))}async $handleDrop(_,u,C,l,F,c){const n=this.treeViews.get(_);if(!n)return Promise.reject(new Error((0,r.localize)(1,null,_)));const h=f.TreeDataTransferConverter.toITreeDataTransfer(u);return F===_&&c&&await this.addAdditionalTransferItems(h,n,c,l),n.onDrop(h,C)}async addAdditionalTransferItems(_,u,C,l){const F=this.treeDragAndDropService.removeDragOperationTransfer(l);if(F)(await F)?.forEach((c,n)=>{c&&_.set(n,c)});else if(l&&u.handleDrag){const c=u.handleDrag(C,_);this.treeDragAndDropService.addDragOperationTransfer(l,c),await c}return _}async $handleDrag(_,u,C){const l=this.treeViews.get(_);if(!l)return Promise.reject(new Error((0,r.localize)(2,null,_)));const F=await this.addAdditionalTransferItems(new Map,l,u,C);if(!!F)return f.TreeDataTransferConverter.toTreeDataTransferDTO(F)}async $hasResolve(_){const u=this.treeViews.get(_);if(!u)throw new Error((0,r.localize)(3,null,_));return u.hasResolve}$resolve(_,u,C){const l=this.treeViews.get(_);if(!l)throw new Error((0,r.localize)(4,null,_));return l.resolveTreeItem(u,C)}$setExpanded(_,u,C){const l=this.treeViews.get(_);if(!l)throw new Error((0,r.localize)(5,null,_));l.setExpanded(u,C)}$setSelection(_,u){const C=this.treeViews.get(_);if(!C)throw new Error((0,r.localize)(6,null,_));C.setSelection(u)}$setVisible(_,u){const C=this.treeViews.get(_);if(!C)throw new Error((0,r.localize)(7,null,_));C.setVisible(u)}createExtHostTreeView(_,u,C){const l=new M(_,u,this._proxy,this.commands.converter,this.logService,C);return this.treeViews.set(_,l),l}convertArgument(_){const u=this.treeViews.get(_.$treeViewId);return u?u.getExtensionElement(_.$treeItemHandle):null}}e.ExtHostTreeViews=m;class M extends A.Disposable{constructor(_,u,C,l,F,c){super();if(this.viewId=_,this.proxy=C,this.commands=l,this.logService=F,this.extension=c,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new P.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new P.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new P.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new P.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new P.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new i.CancellationTokenSource,c.contributes&&c.contributes.views)for(const g in c.contributes.views)for(const s of c.contributes.views[g])s.id===_&&(this._title=s.name);this.dataProvider=u.treeDataProvider,this.dndController=u.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(g=>this._onDidChangeData.fire({message:!1,element:g}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(g=>this._onDidChangeData.fire({message:!1,element:g})));let n,h;this._register(P.Event.debounce(this._onDidChangeData.event,(g,s)=>(g||(g={message:!1,elements:[]}),s.element!==!1&&(n||(n=new Promise(d=>h=d),this.refreshPromise=this.refreshPromise.then(()=>n)),Array.isArray(s.element)?g.elements.push(...s.element):g.elements.push(s.element)),s.message&&(g.message=!0),g),200,!0)(({message:g,elements:s})=>{s.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const d=h;return n=null,this.refresh(s).then(()=>d())})),g&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(_=>this.getExtensionElement(_)).filter(_=>!(0,T.isUndefinedOrNull)(_))}async getChildren(_){const u=_?this.getExtensionElement(_):void 0;if(_&&!u)return this.logService.error(`No tree item with id '${_}' found.`),Promise.resolve([]);let C=this.getChildrenNodes(_);return C||(C=await this.fetchChildrenNodes(u)),C?C.map(l=>l.item):void 0}getExtensionElement(_){return this.elements.get(_)}reveal(_,u){u=u||{select:!0,focus:!1};const C=(0,T.isUndefinedOrNull)(u.select)?!0:u.select,l=(0,T.isUndefinedOrNull)(u.focus)?!1:u.focus,F=(0,T.isUndefinedOrNull)(u.expand)?!1:u.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):_?this.refreshPromise.then(()=>this.resolveUnknownParentChain(_)).then(c=>this.resolveTreeNode(_,c[c.length-1]).then(n=>this.proxy.$reveal(this.viewId,{item:n.item,parentChain:c.map(h=>h.item)},{select:C,focus:l,expand:F})),c=>this.logService.error(c)):this.proxy.$reveal(this.viewId,void 0,{select:C,focus:l,expand:F})}get message(){return this._message}set message(_){this._message=_,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(_){this._title=_,this.proxy.$setTitle(this.viewId,_,this._description)}get description(){return this._description}set description(_){this._description=_,this.proxy.$setTitle(this.viewId,this._title,_)}setExpanded(_,u){const C=this.getExtensionElement(_);C&&(u?this._onDidExpandElement.fire(Object.freeze({element:C})):this._onDidCollapseElement.fire(Object.freeze({element:C})))}setSelection(_){(0,R.equals)(this._selectedHandles,_)||(this._selectedHandles=_,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(_){_!==this._visible&&(this._visible=_,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async handleDrag(_,u){const C=[];for(const l of _){const F=this.getExtensionElement(l);F&&C.push(F)}if(!(!this.dndController?.handleDrag||C.length===0))return await this.dndController.handleDrag(C,u),u}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(_,u){const C=this.getExtensionElement(u);if(!!C)return(0,I.asPromise)(()=>this.dndController?.handleDrop(_,C))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(_,u){if(!this.dataProvider.resolveTreeItem)return;const C=this.elements.get(_);if(C){const l=this.nodes.get(C);if(l){const F=await this.dataProvider.resolveTreeItem(l.extensionItem,C,u)??l.extensionItem;return l.item.tooltip=this.getTooltip(F.tooltip),l.item.command=this.getCommand(l.disposableStore,F.command),l.item}}}resolveUnknownParentChain(_){return this.resolveParent(_).then(u=>u?this.resolveUnknownParentChain(u).then(C=>this.resolveTreeNode(u,C[C.length-1]).then(l=>(C.push(l),C))):Promise.resolve([]))}resolveParent(_){const u=this.nodes.get(_);return u?Promise.resolve(u.parent?this.elements.get(u.parent.item.handle):void 0):(0,I.asPromise)(()=>this.dataProvider.getParent(_))}resolveTreeNode(_,u){const C=this.nodes.get(_);return C?Promise.resolve(C):(0,I.asPromise)(()=>this.dataProvider.getTreeItem(_)).then(l=>this.createHandle(_,l,u,!0)).then(l=>this.getChildren(u?u.item.handle:void 0).then(()=>{const F=this.getExtensionElement(l);if(F){const c=this.nodes.get(F);if(c)return Promise.resolve(c)}throw new Error(`Cannot resolve tree item for element ${l}`)}))}getChildrenNodes(_){if(_){let u;if(typeof _=="string"){const C=this.getExtensionElement(_);u=C?this.nodes.get(C):void 0}else u=_;return u&&u.children||void 0}return this.roots}async fetchChildrenNodes(_){this.clearChildren(_);const u=new i.CancellationTokenSource(this._refreshCancellationSource.token);try{const C=_?this.nodes.get(_):void 0,l=await this.dataProvider.getChildren(_);if(u.token.isCancellationRequested)return;const F=await Promise.all((0,R.coalesce)(l||[]).map(async c=>{const n=await this.dataProvider.getTreeItem(c);return n&&!u.token.isCancellationRequested?this.createAndRegisterTreeNode(c,n,C):null}));return u.token.isCancellationRequested?void 0:(0,R.coalesce)(F)}finally{u.dispose()}}refresh(_){if(_.some(C=>!C))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new i.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const C=this.getHandlesToRefresh(_);if(C.length)return this.refreshHandles(C)}return Promise.resolve(void 0)}getHandlesToRefresh(_){const u=new Set,C=_.map(F=>this.nodes.get(F));for(const F of C)if(F&&!u.has(F.item.handle)){let c=F;for(;c&&c.parent&&C.findIndex(n=>c&&c.parent&&n&&n.item.handle===c.parent.item.handle)===-1;){const n=this.elements.get(c.parent.item.handle);c=n?this.nodes.get(n):void 0}c&&!c.parent&&u.add(F.item.handle)}const l=[];return u.forEach(F=>{const c=this.elements.get(F);if(c){const n=this.nodes.get(c);n&&(!n.parent||!u.has(n.parent.item.handle))&&l.push(F)}}),l}refreshHandles(_){const u={};return Promise.all(_.map(C=>this.refreshNode(C).then(l=>{l&&(u[C]=l.item)}))).then(()=>Object.keys(u).length?this.proxy.$refresh(this.viewId,u):void 0)}refreshNode(_){const u=this.getExtensionElement(_);if(u){const C=this.nodes.get(u);if(C)return this.clearChildren(u),(0,I.asPromise)(()=>this.dataProvider.getTreeItem(u)).then(l=>{if(l){const F=this.createTreeNode(u,l,C.parent);return this.updateNodeCache(u,F,C,C.parent),C.dispose(),F}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(_,u,C){const l=this.createTreeNode(_,u,C);if(u.id&&this.elements.has(l.item.handle))throw new Error((0,r.localize)(8,null,u.id));return this.addNodeToCache(_,l),this.addNodeToParentCache(l,C),l}getTooltip(_){return D.MarkdownString.isMarkdownString(_)?b.MarkdownString.from(_):_}getCommand(_,u){return u?this.commands.toInternal(u,_):void 0}createTreeNode(_,u,C){const l=new A.DisposableStore,F=this.createHandle(_,u,C),c=this.getLightIconPath(u);return{item:{handle:F,parentHandle:C?C.item.handle:void 0,label:o(u.label,this.extension),description:u.description,resourceUri:u.resourceUri,tooltip:this.getTooltip(u.tooltip),command:this.getCommand(l,u.command),contextValue:u.contextValue,icon:c,iconDark:this.getDarkIconPath(u)||c,themeIcon:this.getThemeIcon(u),collapsibleState:(0,T.isUndefinedOrNull)(u.collapsibleState)?D.TreeItemCollapsibleState.None:u.collapsibleState,accessibilityInformation:u.accessibilityInformation},extensionItem:u,parent:C,children:void 0,disposableStore:l,dispose(){l.dispose()}}}getThemeIcon(_){return _.iconPath instanceof D.ThemeIcon?_.iconPath:void 0}createHandle(_,{id:u,label:C,resourceUri:l},F,c){if(u)return`${M.ID_HANDLE_PREFIX}/${u}`;const n=o(C,this.extension),h=F?F.item.handle:M.LABEL_HANDLE_PREFIX;let g=n?n.label:l?(0,t.basename)(l):"";g=g.indexOf("/")!==-1?g.replace("/","//"):g;const s=this.nodes.has(_)?this.nodes.get(_).item.handle:void 0,d=this.getChildrenNodes(F)||[];let p,w=0;do{if(p=`${h}/${w}:${g}`,c||!this.elements.has(p)||s===p)break;w++}while(w<=d.length);return p}getLightIconPath(_){if(_.iconPath&&!(_.iconPath instanceof D.ThemeIcon))return typeof _.iconPath=="string"||S.URI.isUri(_.iconPath)?this.getIconPath(_.iconPath):this.getIconPath(_.iconPath.light)}getDarkIconPath(_){if(_.iconPath&&!(_.iconPath instanceof D.ThemeIcon)&&_.iconPath.dark)return this.getIconPath(_.iconPath.dark)}getIconPath(_){return S.URI.isUri(_)?_:S.URI.file(_)}addNodeToCache(_,u){this.elements.set(u.item.handle,_),this.nodes.set(_,u)}updateNodeCache(_,u,C,l){this.elements.delete(u.item.handle),this.nodes.delete(_),u.item.handle!==C.item.handle&&this.elements.delete(C.item.handle),this.addNodeToCache(_,u);const F=this.getChildrenNodes(l)||[],c=F.filter(n=>n.item.handle===C.item.handle)[0];c&&F.splice(F.indexOf(c),1,u)}addNodeToParentCache(_,u){u?(u.children||(u.children=[]),u.children.push(_)):(this.roots||(this.roots=[]),this.roots.push(_))}clearChildren(_){if(_){const u=this.nodes.get(_);if(u){if(u.children)for(const C of u.children){const l=this.elements.get(C.item.handle);l&&this.clear(l)}u.children=void 0}}else this.clearAll()}clear(_){const u=this.nodes.get(_);if(u){if(u.children)for(const C of u.children){const l=this.elements.get(C.item.handle);l&&this.clear(l)}this.nodes.delete(_),this.elements.delete(u.item.handle),u.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(_=>_.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}M.LABEL_HANDLE_PREFIX="0",M.ID_HANDLE_PREFIX="1"}),define(Se[220],_e([0,1,20,15,4,34,2,112,233,106,56,46,5,177,176,39,178,32,179,180,181,164,182,49,33,183,184,187,189,191,93,166,196,197,198,70,40,200,219,8,7,203,51,94,31,73,153,186,60,91,96,97,98,12,64,14,28,192,150,63,68,174,201,149,71,50,206,204,205,175,30,199,202,67,69,83,194,95,195,11,138,193,147,185,6,26]),function(ee,e,r,t,S,P,A,I,D,T,R,b,i,f,a,o,m,M,y,_,u,C,l,F,c,n,h,g,s,d,p,w,v,k,L,E,O,U,j,H,$,G,ie,le,X,ue,ve,ge,we,re,be,Pe,Fe,ze,nt,et,Ze,x,K,z,V,Y,se,ye,Ue,je,Qe,rt,ot,Je,tt,pt,Me,At,q,Q,he,Be,qe,lt,ht,Ye,kt,Ae,De,pe){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function te(ne){const de=ne.get(Ze.IExtHostInitDataService),me=ne.get(tt.IExtHostFileSystemInfo),Te=ne.get(je.IExtHostConsumerFileSystem),He=ne.get(c.IExtHostExtensionService),Le=ne.get(X.IExtHostWorkspace),Ge=ne.get(Q.IExtHostTelemetry),st=ne.get(M.IExtHostConfiguration),at=ne.get(nt.IURITransformerService),Ne=ne.get(et.IExtHostRpcService),ce=ne.get(E.IExtHostStorage),fe=ne.get(Ue.IExtensionStoragePaths),oe=ne.get(ze.ILoggerService),W=ne.get(ze.ILogService),Ee=ne.get(z.IExtHostTunnelService),Re=ne.get(V.IExtHostApiDeprecationService),Ve=ne.get(le.IExtHostWindow),We=ne.get(At.IExtHostSecretState),mt=ne.get(q.IExtHostEditorTabs);Ne.set(i.ExtHostContext.ExtHostFileSystemInfo,me),Ne.set(i.ExtHostContext.ExtHostLogLevelServiceShape,oe),Ne.set(i.ExtHostContext.ExtHostWorkspace,Le),Ne.set(i.ExtHostContext.ExtHostConfiguration,st),Ne.set(i.ExtHostContext.ExtHostExtensionService,He),Ne.set(i.ExtHostContext.ExtHostStorage,ce),Ne.set(i.ExtHostContext.ExtHostTunnelService,Ee),Ne.set(i.ExtHostContext.ExtHostWindow,Ve),Ne.set(i.ExtHostContext.ExtHostSecretState,We),Ne.set(i.ExtHostContext.ExtHostTelemetry,Ge),Ne.set(i.ExtHostContext.ExtHostEditorTabs,mt);const Et=Ne.set(i.ExtHostContext.ExtHostDecorations,ne.get(re.IExtHostDecorations)),St=Ne.set(i.ExtHostContext.ExtHostDocumentsAndEditors,ne.get(F.IExtHostDocumentsAndEditors)),dt=Ne.set(i.ExtHostContext.ExtHostCommands,ne.get(o.IExtHostCommands)),vt=Ne.set(i.ExtHostContext.ExtHostTerminalService,ne.get(O.IExtHostTerminalService)),bt=Ne.set(i.ExtHostContext.ExtHostDebugService,ne.get(Pe.IExtHostDebugService)),Ut=Ne.set(i.ExtHostContext.ExtHostSearch,ne.get(Fe.IExtHostSearch)),It=Ne.set(i.ExtHostContext.ExtHostTask,ne.get(be.IExtHostTask)),Mt=Ne.set(i.ExtHostContext.ExtHostOutputService,ne.get(p.IExtHostOutputService)),Dt=Ne.set(i.ExtHostContext.ExtHostUrls,new G.ExtHostUrls(Ne)),_t=Ne.set(i.ExtHostContext.ExtHostDocuments,new l.ExtHostDocuments(Ne,St)),Qt=Ne.set(i.ExtHostContext.ExtHostDocumentContentProviders,new u.ExtHostDocumentContentProvider(Ne,St,W)),Vt=Ne.set(i.ExtHostContext.ExtHostDocumentSaveParticipant,new C.ExtHostDocumentSaveParticipant(W,_t,Ne.getProxy(i.MainContext.MainThreadBulkEdits))),wt=Ne.set(i.ExtHostContext.ExtHostNotebook,new x.ExtHostNotebookController(Ne,dt,St,_t,fe)),Yt=Ne.set(i.ExtHostContext.ExtHostNotebookDocuments,new kt.ExtHostNotebookDocuments(W,wt)),qt=Ne.set(i.ExtHostContext.ExtHostNotebookEditors,new Ye.ExtHostNotebookEditors(W,Ne,wt)),Xt=Ne.set(i.ExtHostContext.ExtHostNotebookKernels,new he.ExtHostNotebookKernels(Ne,de,wt,dt,W)),ai=Ne.set(i.ExtHostContext.ExtHostNotebookRenderers,new qe.ExtHostNotebookRenderers(Ne,wt)),Rt=Ne.set(i.ExtHostContext.ExtHostEditors,new U.ExtHostEditors(Ne,St)),Jt=Ne.set(i.ExtHostContext.ExtHostTreeViews,new j.ExtHostTreeViews(Ne.getProxy(i.MainContext.MainThreadTreeViews),dt,W)),li=Ne.set(i.ExtHostContext.ExtHostEditorInsets,new ve.ExtHostEditorInsets(Ne.getProxy(i.MainContext.MainThreadEditorInsets),Rt,de)),jt=Ne.set(i.ExtHostContext.ExtHostDiagnostics,new y.ExtHostDiagnostics(Ne,W,me)),Zt=Ne.set(i.ExtHostContext.ExtHostLanguages,new s.ExtHostLanguages(Ne,_t,dt.converter,at)),gt=Ne.set(i.ExtHostContext.ExtHostLanguageFeatures,new g.ExtHostLanguageFeatures(Ne,at,_t,dt,jt,W,Re)),ci=Ne.set(i.ExtHostContext.ExtHostFileSystem,new n.ExtHostFileSystem(Ne,gt)),Lt=Ne.set(i.ExtHostContext.ExtHostFileSystemEventService,new h.ExtHostFileSystemEventService(Ne,W,St)),$t=Ne.set(i.ExtHostContext.ExtHostQuickOpen,(0,v.createExtHostQuickOpen)(Ne,Le,dt)),vi=Ne.set(i.ExtHostContext.ExtHostSCM,new k.ExtHostSCM(Ne,dt,W)),ui=Ne.set(i.ExtHostContext.ExtHostComments,(0,m.createExtHostComments)(Ne,dt,_t)),ei=Ne.set(i.ExtHostContext.ExtHostProgress,new w.ExtHostProgress(Ne.getProxy(i.MainContext.MainThreadProgress))),Ci=Ne.set(i.ExtHostContext.ExtHosLabelService,new ge.ExtHostLabelService(Ne)),bi=Ne.set(i.ExtHostContext.ExtHostTheming,new K.ExtHostTheming(Ne)),ti=Ne.set(i.ExtHostContext.ExtHostAuthentication,new Y.ExtHostAuthentication(Ne)),Di=Ne.set(i.ExtHostContext.ExtHostTimeline,new se.ExtHostTimeline(Ne,dt)),di=Ne.set(i.ExtHostContext.ExtHostWebviews,new ie.ExtHostWebviews(Ne,{remote:de.remote},Le,W,Re)),Gt=Ne.set(i.ExtHostContext.ExtHostWebviewPanels,new ot.ExtHostWebviewPanels(Ne,di,Le)),hi=Ne.set(i.ExtHostContext.ExtHostCustomEditors,new rt.ExtHostCustomEditors(Ne,_t,fe,di,Gt)),ki=Ne.set(i.ExtHostContext.ExtHostWebviewViews,new Qe.ExtHostWebviewViews(Ne,di)),Kt=Ne.set(i.ExtHostContext.ExtHostTesting,new pt.ExtHostTesting(Ne,dt)),Ii=Ne.set(i.ExtHostContext.ExtHostUriOpeners,new Me.ExtHostUriOpeners(Ne));Ne.set(i.ExtHostContext.ExtHostInteractive,new Ae.ExtHostInteractive(Ne,wt,St,dt));const Pi=(0,ue.values)(i.ExtHostContext);Ne.assertRegistered(Pi);const ii=new Je.ExtHostBulkEdits(Ne,St),Ti=new a.ExtHostClipboard(Ne),fi=new d.ExtHostMessageService(Ne,W),wi=new _.ExtHostDialogs(Ne),ni=new L.ExtHostStatusBar(Ne,dt.converter);return f.ExtHostApiCommands.register(dt),function(Oe,zt,Bt){const yt=function(){let J=!Oe.isUnderDevelopment;function ae(){J||(W.info(`Extension '${Oe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),J=!0)}return function ke(ut){if(Array.isArray(ut))ut.forEach(ke);else if(typeof ut=="string")ae();else{const Ct=ut;typeof Ct.scheme=="undefined"&&ae(),typeof Ct.exclusive=="boolean"&&(0,pe.checkProposedApiEnabled)(Oe,"documentFiltersExclusive")}return ut}}(),Ot={getSession(J,ae,ke){return ti.getSession(Oe,J,ae,ke)},async hasSession(J,ae){return(0,pe.checkProposedApiEnabled)(Oe,"authSession"),!!await ti.getSession(Oe,J,ae,{silent:!0})},get onDidChangeSessions(){return ti.onDidChangeSessions},registerAuthenticationProvider(J,ae,ke,ut){return ti.registerAuthenticationProvider(J,ae,ke,ut)}},ri={registerCommand(J,ae,ke){return dt.registerCommand(!0,J,ae,ke,void 0,Oe)},registerTextEditorCommand(J,ae,ke){return dt.registerCommand(!0,J,(...ut)=>{const Ct=Rt.getActiveTextEditor();if(!Ct){W.warn("Cannot execute "+J+" because there is no active text editor.");return}return Ct.edit(Tt=>{ae.apply(ke,[Ct,Tt,...ut])}).then(Tt=>{Tt||W.warn("Edits from command "+J+" were not applied.")},Tt=>{W.warn("An error occurred while running command "+J,Tt)})},void 0,void 0,Oe)},registerDiffInformationCommand:(J,ae,ke)=>((0,pe.checkProposedApiEnabled)(Oe,"diffCommand"),dt.registerCommand(!0,J,async(...ut)=>{const Ct=St.activeEditor(!0);if(!Ct){W.warn("Cannot execute "+J+" because there is no active text editor.");return}const Tt=await Rt.getDiffInformation(Ct.id);ae.apply(ke,[Tt,...ut])},void 0,void 0,Oe)),executeCommand(J,...ae){return dt.executeCommand(J,...ae)},getCommands(J=!1){return dt.getCommands(J)}},Ei={get machineId(){return de.telemetryInfo.machineId},get sessionId(){return de.telemetryInfo.sessionId},get language(){return de.environment.appLanguage},get appName(){return de.environment.appName},get appRoot(){return de.environment.appRoot?.fsPath??""},get appHost(){return de.environment.appHost},get uriScheme(){return de.environment.appUriScheme},get clipboard(){return Ti.value},get shell(){return vt.getDefaultShell(!1)},get isTelemetryEnabled(){return Ge.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return Ge.onDidChangeTelemetryEnabled},get isNewAppInstall(){const J=Date.now()-new Date(de.telemetryInfo.firstSessionDate).getTime();return isNaN(J)?!1:J<1e3*60*60*24},openExternal(J,ae){return Ve.openUri(J,{allowTunneling:!!de.remote.authority,allowContributedOpeners:ae?.allowContributedOpeners})},async asExternalUri(J){if(J.scheme===de.environment.appUriScheme)return Dt.createAppUri(J);try{return await Ve.asExternalUri(J,{allowTunneling:!!de.remote.authority})}catch(ae){if((0,ht.matchesScheme)(J,lt.Schemas.http)||(0,ht.matchesScheme)(J,lt.Schemas.https))return J;throw ae}},get remoteName(){return(0,we.getRemoteName)(de.remote.authority)},get remoteAuthority(){return(0,pe.checkProposedApiEnabled)(Oe,"resolvers"),de.remote.authority},get uiKind(){return de.uiKind}};de.environment.extensionTestsLocationURI||Object.freeze(Ei);const yi=de.remote.isRemote?$.ExtensionKind.Workspace:$.ExtensionKind.UI,Ai={createTestController(J,ae,ke){return ke&&(0,pe.checkProposedApiEnabled)(Oe,"testRefresh"),Kt.createTestController(J,ae,ke)},createTestObserver(){return(0,pe.checkProposedApiEnabled)(Oe,"testObserver"),Kt.createTestObserver()},runTests(J){return(0,pe.checkProposedApiEnabled)(Oe,"testObserver"),Kt.runTests(J)},get onDidChangeTestResults(){return(0,pe.checkProposedApiEnabled)(Oe,"testObserver"),Kt.onResultsChanged},get testResults(){return(0,pe.checkProposedApiEnabled)(Oe,"testObserver"),Kt.results}},Ri={getExtension(J){const ae=zt.getExtensionDescription(J);if(ae)return new c.Extension(He,Oe.identifier,ae,yi)},get all(){return zt.getAllExtensionDescriptions().map(J=>new c.Extension(He,Oe.identifier,J,yi))},get onDidChange(){return zt.onDidChange}},Fi={createDiagnosticCollection(J){return jt.createDiagnosticCollection(Oe.identifier,J)},get onDidChangeDiagnostics(){return jt.onDidChangeDiagnostics},getDiagnostics:J=>jt.getDiagnostics(J),getLanguages(){return Zt.getLanguages()},setTextDocumentLanguage(J,ae){return Zt.changeLanguage(J.uri,ae)},match(J,ae){return(0,R.score)(H.LanguageSelector.from(J),ae.uri,ae.languageId,!0)},registerCodeActionsProvider(J,ae,ke){return gt.registerCodeActionProvider(Oe,yt(J),ae,ke)},registerCodeLensProvider(J,ae){return gt.registerCodeLensProvider(Oe,yt(J),ae)},registerDefinitionProvider(J,ae){return gt.registerDefinitionProvider(Oe,yt(J),ae)},registerDeclarationProvider(J,ae){return gt.registerDeclarationProvider(Oe,yt(J),ae)},registerImplementationProvider(J,ae){return gt.registerImplementationProvider(Oe,yt(J),ae)},registerTypeDefinitionProvider(J,ae){return gt.registerTypeDefinitionProvider(Oe,yt(J),ae)},registerHoverProvider(J,ae){return gt.registerHoverProvider(Oe,yt(J),ae,Oe.identifier)},registerEvaluatableExpressionProvider(J,ae){return gt.registerEvaluatableExpressionProvider(Oe,yt(J),ae,Oe.identifier)},registerInlineValuesProvider(J,ae){return gt.registerInlineValuesProvider(Oe,yt(J),ae,Oe.identifier)},registerDocumentHighlightProvider(J,ae){return gt.registerDocumentHighlightProvider(Oe,yt(J),ae)},registerLinkedEditingRangeProvider(J,ae){return gt.registerLinkedEditingRangeProvider(Oe,yt(J),ae)},registerReferenceProvider(J,ae){return gt.registerReferenceProvider(Oe,yt(J),ae)},registerRenameProvider(J,ae){return gt.registerRenameProvider(Oe,yt(J),ae)},registerDocumentSymbolProvider(J,ae,ke){return gt.registerDocumentSymbolProvider(Oe,yt(J),ae,ke)},registerWorkspaceSymbolProvider(J){return gt.registerWorkspaceSymbolProvider(Oe,J)},registerDocumentFormattingEditProvider(J,ae){return gt.registerDocumentFormattingEditProvider(Oe,yt(J),ae)},registerDocumentRangeFormattingEditProvider(J,ae){return gt.registerDocumentRangeFormattingEditProvider(Oe,yt(J),ae)},registerOnTypeFormattingEditProvider(J,ae,ke,...ut){return gt.registerOnTypeFormattingEditProvider(Oe,yt(J),ae,[ke].concat(ut))},registerDocumentSemanticTokensProvider(J,ae,ke){return gt.registerDocumentSemanticTokensProvider(Oe,yt(J),ae,ke)},registerDocumentRangeSemanticTokensProvider(J,ae,ke){return gt.registerDocumentRangeSemanticTokensProvider(Oe,yt(J),ae,ke)},registerSignatureHelpProvider(J,ae,ke,...ut){return typeof ke=="object"?gt.registerSignatureHelpProvider(Oe,yt(J),ae,ke):gt.registerSignatureHelpProvider(Oe,yt(J),ae,typeof ke=="undefined"?[]:[ke,...ut])},registerCompletionItemProvider(J,ae,...ke){return gt.registerCompletionItemProvider(Oe,yt(J),ae,ke)},registerInlineCompletionItemProvider(J,ae){return(0,pe.checkProposedApiEnabled)(Oe,"inlineCompletions"),gt.registerInlineCompletionsProvider(Oe,yt(J),ae)},registerDocumentLinkProvider(J,ae){return gt.registerDocumentLinkProvider(Oe,yt(J),ae)},registerColorProvider(J,ae){return gt.registerColorProvider(Oe,yt(J),ae)},registerFoldingRangeProvider(J,ae){return gt.registerFoldingRangeProvider(Oe,yt(J),ae)},registerSelectionRangeProvider(J,ae){return gt.registerSelectionRangeProvider(Oe,J,ae)},registerCallHierarchyProvider(J,ae){return gt.registerCallHierarchyProvider(Oe,J,ae)},registerTypeHierarchyProvider(J,ae){return gt.registerTypeHierarchyProvider(Oe,J,ae)},setLanguageConfiguration:(J,ae)=>gt.setLanguageConfiguration(Oe,J,ae),getTokenInformationAtPosition(J,ae){return(0,pe.checkProposedApiEnabled)(Oe,"tokenInformation"),Zt.tokenAtPosition(J,ae)},registerInlayHintsProvider(J,ae){return(0,pe.checkProposedApiEnabled)(Oe,"inlayHints"),gt.registerInlayHintsProvider(Oe,J,ae)},createLanguageStatusItem(J,ae){return(0,pe.checkProposedApiEnabled)(Oe,"languageStatus"),Zt.createLanguageStatusItem(Oe,J,ae)}},Mi={get activeTextEditor(){return Rt.getActiveTextEditor()},get visibleTextEditors(){return Rt.getVisibleTextEditors()},get activeTerminal(){return vt.activeTerminal},get terminals(){return vt.terminals},async showTextDocument(J,ae,ke){const ut=await(A.URI.isUri(J)?Promise.resolve(Si.openTextDocument(J)):Promise.resolve(J));return Rt.showTextDocument(ut,ae,ke)},createTextEditorDecorationType(J){return Rt.createTextEditorDecorationType(Oe,J)},onDidChangeActiveTextEditor(J,ae,ke){return Rt.onDidChangeActiveTextEditor(J,ae,ke)},onDidChangeVisibleTextEditors(J,ae,ke){return Rt.onDidChangeVisibleTextEditors(J,ae,ke)},onDidChangeTextEditorSelection(J,ae,ke){return Rt.onDidChangeTextEditorSelection(J,ae,ke)},onDidChangeTextEditorOptions(J,ae,ke){return Rt.onDidChangeTextEditorOptions(J,ae,ke)},onDidChangeTextEditorVisibleRanges(J,ae,ke){return Rt.onDidChangeTextEditorVisibleRanges(J,ae,ke)},onDidChangeTextEditorViewColumn(J,ae,ke){return Rt.onDidChangeTextEditorViewColumn(J,ae,ke)},onDidCloseTerminal(J,ae,ke){return vt.onDidCloseTerminal(J,ae,ke)},onDidOpenTerminal(J,ae,ke){return vt.onDidOpenTerminal(J,ae,ke)},onDidChangeActiveTerminal(J,ae,ke){return vt.onDidChangeActiveTerminal(J,ae,ke)},onDidChangeTerminalDimensions(J,ae,ke){return(0,pe.checkProposedApiEnabled)(Oe,"terminalDimensions"),vt.onDidChangeTerminalDimensions(J,ae,ke)},onDidChangeTerminalState(J,ae,ke){return vt.onDidChangeTerminalState(J,ae,ke)},onDidWriteTerminalData(J,ae,ke){return(0,pe.checkProposedApiEnabled)(Oe,"terminalDataWriteEvent"),vt.onDidWriteTerminalData(J,ae,ke)},get state(){return Ve.state},onDidChangeWindowState(J,ae,ke){return Ve.onDidChangeWindowState(J,ae,ke)},showInformationMessage(J,...ae){return fi.showMessage(Oe,P.default.Info,J,ae[0],ae.slice(1))},showWarningMessage(J,...ae){return fi.showMessage(Oe,P.default.Warning,J,ae[0],ae.slice(1))},showErrorMessage(J,...ae){return fi.showMessage(Oe,P.default.Error,J,ae[0],ae.slice(1))},showQuickPick(J,ae,ke){return Array.isArray(J)&&J.some(ut=>ut.kind===$.QuickPickItemKind.Separator)&&(0,pe.checkProposedApiEnabled)(Oe,"quickPickSeparators"),$t.showQuickPick(J,ae,ke)},showWorkspaceFolderPick(J){return $t.showWorkspaceFolderPick(J)},showInputBox(J,ae){return $t.showInput(J,ae)},showOpenDialog(J){return wi.showOpenDialog(J)},showSaveDialog(J){return wi.showSaveDialog(J)},createStatusBarItem(J,ae,ke){let ut,Ct,Tt;return typeof J=="string"?(ut=J,Ct=ae,Tt=ke):(Ct=J,Tt=ae),ni.createStatusBarEntry(Oe,ut,Ct,Tt)},setStatusBarMessage(J,ae){return ni.setStatusBarMessage(J,ae)},withScmProgress(J){return Re.report("window.withScmProgress",Oe,"Use 'withProgress' instead."),ei.withProgress(Oe,{location:$.ProgressLocation.SourceControl},(ae,ke)=>J({report(ut){}}))},withProgress(J,ae){return ei.withProgress(Oe,J,ae)},createOutputChannel(J){return Mt.createOutputChannel(J,Oe)},createWebviewPanel(J,ae,ke,ut){return Gt.createWebviewPanel(Oe,J,ae,ke,ut)},createWebviewTextEditorInset(J,ae,ke,ut){return(0,pe.checkProposedApiEnabled)(Oe,"editorInsets"),li.createWebviewEditorInset(J,ae,ke,ut,Oe)},createTerminal(J,ae,ke){return typeof J=="object"?"pty"in J?vt.createExtensionTerminal(J):vt.createTerminalFromOptions(J):vt.createTerminal(J,ae,ke)},registerTerminalLinkProvider(J){return vt.registerLinkProvider(J)},registerTerminalProfileProvider(J,ae){return vt.registerProfileProvider(Oe,J,ae)},registerTreeDataProvider(J,ae){return Jt.registerTreeDataProvider(J,ae,Oe)},createTreeView(J,ae){return Jt.createTreeView(J,ae,Oe)},registerWebviewPanelSerializer:(J,ae)=>Gt.registerWebviewPanelSerializer(Oe,J,ae),registerCustomEditorProvider:(J,ae,ke={})=>hi.registerCustomEditorProvider(Oe,J,ae,ke),registerFileDecorationProvider(J){return Et.registerFileDecorationProvider(J,Oe.identifier)},registerUriHandler(J){return Dt.registerUriHandler(Oe.identifier,J)},createQuickPick(){return $t.createQuickPick(Oe)},createInputBox(){return $t.createInputBox(Oe.identifier)},get activeColorTheme(){return bi.activeColorTheme},onDidChangeActiveColorTheme(J,ae,ke){return bi.onDidChangeActiveColorTheme(J,ae,ke)},registerWebviewViewProvider(J,ae,ke){return ki.registerWebviewViewProvider(Oe,J,ae,ke?.webviewOptions)},get activeNotebookEditor(){return(0,pe.checkProposedApiEnabled)(Oe,"notebookEditor"),wt.activeNotebookEditor},onDidChangeActiveNotebookEditor(J,ae,ke){return(0,pe.checkProposedApiEnabled)(Oe,"notebookEditor"),wt.onDidChangeActiveNotebookEditor(J,ae,ke)},get visibleNotebookEditors(){return(0,pe.checkProposedApiEnabled)(Oe,"notebookEditor"),wt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,pe.checkProposedApiEnabled)(Oe,"notebookEditor"),wt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(J,ae,ke){return(0,pe.checkProposedApiEnabled)(Oe,"notebookEditor"),qt.onDidChangeNotebookEditorSelection(J,ae,ke)},onDidChangeNotebookEditorVisibleRanges(J,ae,ke){return(0,pe.checkProposedApiEnabled)(Oe,"notebookEditor"),qt.onDidChangeNotebookEditorVisibleRanges(J,ae,ke)},showNotebookDocument(J,ae){return(0,pe.checkProposedApiEnabled)(Oe,"notebookEditor"),wt.showNotebookDocument(J,ae)},registerExternalUriOpener(J,ae,ke){return(0,pe.checkProposedApiEnabled)(Oe,"externalUriOpener"),Ii.registerExternalUriOpener(Oe.identifier,J,ae,ke)},get tabs(){return(0,pe.checkProposedApiEnabled)(Oe,"tabs"),mt.tabs},get activeTab(){return(0,pe.checkProposedApiEnabled)(Oe,"tabs"),mt.activeTab},get onDidChangeTabs(){return(0,pe.checkProposedApiEnabled)(Oe,"tabs"),mt.onDidChangeTabs},get onDidChangeActiveTab(){return(0,pe.checkProposedApiEnabled)(Oe,"tabs"),mt.onDidChangeActiveTab},getInlineCompletionItemController(J){return(0,pe.checkProposedApiEnabled)(Oe,"inlineCompletions"),g.InlineCompletionController.get(J)}},Si={get rootPath(){return Re.report("workspace.rootPath",Oe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),Le.getPath()},set rootPath(J){throw t.readonly()},getWorkspaceFolder(J){return Le.getWorkspaceFolder(J)},get workspaceFolders(){return Le.getWorkspaceFolders()},get name(){return Le.name},set name(J){throw t.readonly()},get workspaceFile(){return Le.workspaceFile},set workspaceFile(J){throw t.readonly()},updateWorkspaceFolders:(J,ae,...ke)=>Le.updateWorkspaceFolders(Oe,J,ae||0,...ke),onDidChangeWorkspaceFolders:function(J,ae,ke){return Le.onDidChangeWorkspace(J,ae,ke)},asRelativePath:(J,ae)=>Le.getRelativePath(J,ae),findFiles:(J,ae,ke,ut)=>Le.findFiles(J,ae,ke,Oe.identifier,ut),findTextInFiles:(J,ae,ke,ut)=>{(0,pe.checkProposedApiEnabled)(Oe,"findTextInFiles");let Ct,Tt;return typeof ae=="object"?(Ct=ae,Tt=ke):(Ct={},Tt=ae,ut=ke),Le.findTextInFiles(J,Ct||{},Tt,Oe.identifier,ut)},saveAll:J=>Le.saveAll(J),applyEdit(J){return ii.applyWorkspaceEdit(J)},createFileSystemWatcher:(J,ae,ke,ut)=>Lt.createFileSystemWatcher(Le,Oe,J,ae,ke,ut),get textDocuments(){return _t.getAllDocumentData().map(J=>J.document)},set textDocuments(J){throw t.readonly()},openTextDocument(J){let ae;const ke=J;if(typeof J=="string")ae=Promise.resolve(A.URI.file(J));else if(A.URI.isUri(J))ae=Promise.resolve(J);else if(!ke||typeof ke=="object")ae=_t.createDocumentData(ke);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ae.then(ut=>_t.ensureDocumentData(ut).then(Ct=>Ct.document))},onDidOpenTextDocument:(J,ae,ke)=>_t.onDidAddDocument(J,ae,ke),onDidCloseTextDocument:(J,ae,ke)=>_t.onDidRemoveDocument(J,ae,ke),onDidChangeTextDocument:(J,ae,ke)=>_t.onDidChangeDocument(J,ae,ke),onDidSaveTextDocument:(J,ae,ke)=>_t.onDidSaveDocument(J,ae,ke),onWillSaveTextDocument:(J,ae,ke)=>Vt.getOnWillSaveTextDocumentEvent(Oe)(J,ae,ke),get notebookDocuments(){return wt.notebookDocuments.map(J=>J.apiNotebook)},async openNotebookDocument(J,ae){let ke;if(A.URI.isUri(J))ke=J,await wt.openNotebookDocument(J);else if(typeof J=="string")ke=A.URI.revive(await wt.createNotebookDocument({viewType:J,content:ae}));else throw new Error("Invalid arguments");return wt.getNotebookDocument(ke).apiNotebook},get onDidOpenNotebookDocument(){return wt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return wt.onDidCloseNotebookDocument},registerNotebookSerializer(J,ae,ke,ut){return wt.registerNotebookSerializer(Oe,J,ae,ke,(0,pe.isProposedApiEnabled)(Oe,"notebookLiveShare")?ut:void 0)},registerNotebookContentProvider:(J,ae,ke,ut)=>((0,pe.checkProposedApiEnabled)(Oe,"notebookContentProvider"),wt.registerNotebookContentProvider(Oe,J,ae,ke,(0,pe.isProposedApiEnabled)(Oe,"notebookLiveShare")?ut:void 0)),onDidChangeConfiguration:(J,ae,ke)=>Bt.onDidChangeConfiguration(J,ae,ke),getConfiguration(J,ae){return ae=arguments.length===1?void 0:ae,Bt.getConfiguration(J,ae,Oe)},registerTextDocumentContentProvider(J,ae){return Qt.registerTextDocumentContentProvider(J,ae)},registerTaskProvider:(J,ae)=>(Re.report("window.registerTaskProvider",Oe,"Use the corresponding function on the 'tasks' namespace instead"),It.registerTaskProvider(Oe,J,ae)),registerFileSystemProvider(J,ae,ke){return(0,De.combinedDisposable)(ci.registerFileSystemProvider(Oe,J,ae,ke),Te.addFileSystemProvider(J,ae))},get fs(){return Te.value},registerFileSearchProvider:(J,ae)=>((0,pe.checkProposedApiEnabled)(Oe,"fileSearchProvider"),Ut.registerFileSearchProvider(J,ae)),registerTextSearchProvider:(J,ae)=>((0,pe.checkProposedApiEnabled)(Oe,"textSearchProvider"),Ut.registerTextSearchProvider(J,ae)),registerRemoteAuthorityResolver:(J,ae)=>((0,pe.checkProposedApiEnabled)(Oe,"resolvers"),He.registerRemoteAuthorityResolver(J,ae)),registerResourceLabelFormatter:J=>((0,pe.checkProposedApiEnabled)(Oe,"resolvers"),Ci.$registerResourceLabelFormatter(J)),onDidCreateFiles:(J,ae,ke)=>Lt.onDidCreateFile(J,ae,ke),onDidDeleteFiles:(J,ae,ke)=>Lt.onDidDeleteFile(J,ae,ke),onDidRenameFiles:(J,ae,ke)=>Lt.onDidRenameFile(J,ae,ke),onWillCreateFiles:(J,ae,ke)=>Lt.getOnWillCreateFileEvent(Oe)(J,ae,ke),onWillDeleteFiles:(J,ae,ke)=>Lt.getOnWillDeleteFileEvent(Oe)(J,ae,ke),onWillRenameFiles:(J,ae,ke)=>Lt.getOnWillRenameFileEvent(Oe)(J,ae,ke),openTunnel:J=>((0,pe.checkProposedApiEnabled)(Oe,"resolvers"),Ee.openTunnel(Oe,J).then(ae=>{if(!ae)throw new Error("cannot open tunnel");return ae})),get tunnels(){return(0,pe.checkProposedApiEnabled)(Oe,"resolvers"),Ee.getTunnels()},onDidChangeTunnels:(J,ae,ke)=>((0,pe.checkProposedApiEnabled)(Oe,"resolvers"),Ee.onDidChangeTunnels(J,ae,ke)),registerPortAttributesProvider:(J,ae)=>((0,pe.checkProposedApiEnabled)(Oe,"portsAttributes"),Ee.registerPortsAttributesProvider(J,ae)),registerTimelineProvider:(J,ae)=>((0,pe.checkProposedApiEnabled)(Oe,"timeline"),Di.registerTimelineProvider(J,ae,Oe.identifier,dt.converter)),get isTrusted(){return Le.trusted},requestWorkspaceTrust:J=>((0,pe.checkProposedApiEnabled)(Oe,"workspaceTrust"),Le.requestWorkspaceTrust(J)),onDidGrantWorkspaceTrust:(J,ae,ke)=>Le.onDidGrantWorkspaceTrust(J,ae,ke)},mi={get inputBox(){return Re.report("scm.inputBox",Oe,"Use 'SourceControl.inputBox' instead"),vi.getLastInputBox(Oe)},createSourceControl(J,ae,ke){return vi.createSourceControl(Oe,J,ae,ke)}},Oi={createCommentController(J,ae){return ui.createCommentController(Oe,J,ae)}},Li={get activeDebugSession(){return bt.activeDebugSession},get activeDebugConsole(){return bt.activeDebugConsole},get breakpoints(){return bt.breakpoints},onDidStartDebugSession(J,ae,ke){return bt.onDidStartDebugSession(J,ae,ke)},onDidTerminateDebugSession(J,ae,ke){return bt.onDidTerminateDebugSession(J,ae,ke)},onDidChangeActiveDebugSession(J,ae,ke){return bt.onDidChangeActiveDebugSession(J,ae,ke)},onDidReceiveDebugSessionCustomEvent(J,ae,ke){return bt.onDidReceiveDebugSessionCustomEvent(J,ae,ke)},onDidChangeBreakpoints(J,ae,ke){return bt.onDidChangeBreakpoints(J,ae,ke)},registerDebugConfigurationProvider(J,ae,ke){return bt.registerDebugConfigurationProvider(J,ae,ke||$.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(J,ae){return bt.registerDebugAdapterDescriptorFactory(Oe,J,ae)},registerDebugAdapterTrackerFactory(J,ae){return bt.registerDebugAdapterTrackerFactory(J,ae)},startDebugging(J,ae,ke){return!ke||typeof ke=="object"&&"configuration"in ke?bt.startDebugging(J,ae,{parentSession:ke}):bt.startDebugging(J,ae,ke||{})},stopDebugging(J){return bt.stopDebugging(J)},addBreakpoints(J){return bt.addBreakpoints(J)},removeBreakpoints(J){return bt.removeBreakpoints(J)},asDebugSourceUri(J,ae){return bt.asDebugSourceUri(J,ae)}},Ni={registerTaskProvider:(J,ae)=>It.registerTaskProvider(Oe,J,ae),fetchTasks:J=>It.fetchTasks(J),executeTask:J=>It.executeTask(Oe,J),get taskExecutions(){return It.taskExecutions},onDidStartTask:(J,ae,ke)=>It.onDidStartTask(J,ae,ke),onDidEndTask:(J,ae,ke)=>It.onDidEndTask(J,ae,ke),onDidStartTaskProcess:(J,ae,ke)=>It.onDidStartTaskProcess(J,ae,ke),onDidEndTaskProcess:(J,ae,ke)=>It.onDidEndTaskProcess(J,ae,ke)},Ui={createNotebookController(J,ae,ke,ut,Ct){return Xt.createNotebookController(Oe,J,ae,ke,ut,(0,pe.isProposedApiEnabled)(Oe,"notebookMessaging")?Ct:void 0)},registerNotebookCellStatusBarItemProvider:(J,ae)=>wt.registerNotebookCellStatusBarItemProvider(Oe,J,ae),get onDidSaveNotebookDocument(){return(0,pe.checkProposedApiEnabled)(Oe,"notebookEditor"),Yt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(J){return(0,pe.checkProposedApiEnabled)(Oe,"notebookEditorDecorationType"),qt.createNotebookEditorDecorationType(J)},createRendererMessaging(J){return ai.createRendererMessaging(Oe,J)},onDidChangeNotebookDocumentMetadata(J,ae,ke){return(0,pe.checkProposedApiEnabled)(Oe,"notebookEditor"),Yt.onDidChangeNotebookDocumentMetadata(J,ae,ke)},onDidChangeNotebookCells(J,ae,ke){return(0,pe.checkProposedApiEnabled)(Oe,"notebookEditor"),wt.onDidChangeNotebookCells(J,ae,ke)},onDidChangeNotebookCellExecutionState(J,ae,ke){return(0,pe.checkProposedApiEnabled)(Oe,"notebookCellExecutionState"),Xt.onDidChangeNotebookCellExecutionState(J,ae,ke)},onDidChangeCellOutputs(J,ae,ke){return(0,pe.checkProposedApiEnabled)(Oe,"notebookEditor"),wt.onDidChangeCellOutputs(J,ae,ke)},onDidChangeCellMetadata(J,ae,ke){return(0,pe.checkProposedApiEnabled)(Oe,"notebookEditor"),wt.onDidChangeCellMetadata(J,ae,ke)},createConcatTextDocument(J,ae){return(0,pe.checkProposedApiEnabled)(Oe,"notebookConcatTextDocument"),new ye.ExtHostNotebookConcatDocument(wt,_t,J,ae)}};return{version:de.version,authentication:Ot,commands:ri,comments:Oi,debug:Li,env:Ei,extensions:Ri,languages:Fi,notebooks:Ui,scm:mi,tasks:Ni,tests:Ai,window:Mi,workspace:Si,Breakpoint:$.Breakpoint,CallHierarchyIncomingCall:$.CallHierarchyIncomingCall,CallHierarchyItem:$.CallHierarchyItem,CallHierarchyOutgoingCall:$.CallHierarchyOutgoingCall,CancellationError:t.CancellationError,CancellationTokenSource:r.CancellationTokenSource,CandidatePortSource:i.CandidatePortSource,CodeAction:$.CodeAction,CodeActionKind:$.CodeActionKind,CodeActionTriggerKind:$.CodeActionTriggerKind,CodeLens:$.CodeLens,Color:$.Color,ColorInformation:$.ColorInformation,ColorPresentation:$.ColorPresentation,ColorThemeKind:$.ColorThemeKind,CommentMode:$.CommentMode,CommentThreadCollapsibleState:$.CommentThreadCollapsibleState,CompletionItem:$.CompletionItem,CompletionItemKind:$.CompletionItemKind,CompletionItemTag:$.CompletionItemTag,CompletionList:$.CompletionList,CompletionTriggerKind:$.CompletionTriggerKind,ConfigurationTarget:$.ConfigurationTarget,CustomExecution:$.CustomExecution,DebugAdapterExecutable:$.DebugAdapterExecutable,DebugAdapterInlineImplementation:$.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:$.DebugAdapterNamedPipeServer,DebugAdapterServer:$.DebugAdapterServer,DebugConfigurationProviderTriggerKind:$.DebugConfigurationProviderTriggerKind,DebugConsoleMode:$.DebugConsoleMode,DecorationRangeBehavior:$.DecorationRangeBehavior,Diagnostic:$.Diagnostic,DiagnosticRelatedInformation:$.DiagnosticRelatedInformation,DiagnosticSeverity:$.DiagnosticSeverity,DiagnosticTag:$.DiagnosticTag,Disposable:$.Disposable,DocumentHighlight:$.DocumentHighlight,DocumentHighlightKind:$.DocumentHighlightKind,DocumentLink:$.DocumentLink,DocumentSymbol:$.DocumentSymbol,EndOfLine:$.EndOfLine,EnvironmentVariableMutatorType:$.EnvironmentVariableMutatorType,EvaluatableExpression:$.EvaluatableExpression,InlineValueText:$.InlineValueText,InlineValueVariableLookup:$.InlineValueVariableLookup,InlineValueEvaluatableExpression:$.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:$.InlineCompletionTriggerKind,EventEmitter:S.Emitter,ExtensionKind:$.ExtensionKind,ExtensionMode:$.ExtensionMode,ExternalUriOpenerPriority:$.ExternalUriOpenerPriority,FileChangeType:$.FileChangeType,FileDecoration:$.FileDecoration,FileSystemError:$.FileSystemError,FileType:b.FileType,FilePermission:b.FilePermission,FoldingRange:$.FoldingRange,FoldingRangeKind:$.FoldingRangeKind,FunctionBreakpoint:$.FunctionBreakpoint,InlineCompletionItem:$.InlineSuggestion,InlineCompletionList:$.InlineSuggestions,Hover:$.Hover,IndentAction:T.IndentAction,Location:$.Location,MarkdownString:$.MarkdownString,OverviewRulerLane:D.OverviewRulerLane,ParameterInformation:$.ParameterInformation,PortAutoForwardAction:$.PortAutoForwardAction,Position:$.Position,ProcessExecution:$.ProcessExecution,ProgressLocation:$.ProgressLocation,QuickInputButtons:$.QuickInputButtons,Range:$.Range,RelativePattern:$.RelativePattern,Selection:$.Selection,SelectionRange:$.SelectionRange,SemanticTokens:$.SemanticTokens,SemanticTokensBuilder:$.SemanticTokensBuilder,SemanticTokensEdit:$.SemanticTokensEdit,SemanticTokensEdits:$.SemanticTokensEdits,SemanticTokensLegend:$.SemanticTokensLegend,ShellExecution:$.ShellExecution,ShellQuoting:$.ShellQuoting,SignatureHelp:$.SignatureHelp,SignatureHelpTriggerKind:$.SignatureHelpTriggerKind,SignatureInformation:$.SignatureInformation,SnippetString:$.SnippetString,SourceBreakpoint:$.SourceBreakpoint,StandardTokenType:$.StandardTokenType,StatusBarAlignment:$.StatusBarAlignment,SymbolInformation:$.SymbolInformation,SymbolKind:$.SymbolKind,SymbolTag:$.SymbolTag,Task:$.Task,TaskGroup:$.TaskGroup,TaskPanelKind:$.TaskPanelKind,TaskRevealKind:$.TaskRevealKind,TaskScope:$.TaskScope,TerminalLink:$.TerminalLink,TerminalLocation:$.TerminalLocation,TerminalProfile:$.TerminalProfile,TextDocumentSaveReason:$.TextDocumentSaveReason,TextEdit:$.TextEdit,TextEditorCursorStyle:I.TextEditorCursorStyle,TextEditorLineNumbersStyle:$.TextEditorLineNumbersStyle,TextEditorRevealType:$.TextEditorRevealType,TextEditorSelectionChangeKind:$.TextEditorSelectionChangeKind,TextDocumentChangeReason:$.TextDocumentChangeReason,ThemeColor:$.ThemeColor,ThemeIcon:$.ThemeIcon,TreeItem:$.TreeItem,TreeItemCollapsibleState:$.TreeItemCollapsibleState,TypeHierarchyItem:$.TypeHierarchyItem,UIKind:i.UIKind,Uri:A.URI,ViewColumn:$.ViewColumn,WorkspaceEdit:$.WorkspaceEdit,InlayHint:$.InlayHint,InlayHintLabelPart:$.InlayHintLabelPart,InlayHintKind:$.InlayHintKind,RemoteAuthorityResolverError:$.RemoteAuthorityResolverError,ResolvedAuthority:$.ResolvedAuthority,SourceControlInputBoxValidationType:$.SourceControlInputBoxValidationType,ExtensionRuntime:$.ExtensionRuntime,TimelineItem:$.TimelineItem,NotebookRange:$.NotebookRange,NotebookCellKind:$.NotebookCellKind,NotebookCellExecutionState:$.NotebookCellExecutionState,NotebookCellData:$.NotebookCellData,NotebookData:$.NotebookData,NotebookRendererScript:$.NotebookRendererScript,NotebookCellStatusBarAlignment:$.NotebookCellStatusBarAlignment,NotebookEditorRevealType:$.NotebookEditorRevealType,NotebookCellOutput:$.NotebookCellOutput,NotebookCellOutputItem:$.NotebookCellOutputItem,NotebookCellStatusBarItem:$.NotebookCellStatusBarItem,NotebookControllerAffinity:$.NotebookControllerAffinity,PortAttributes:$.PortAttributes,LinkedEditingRanges:$.LinkedEditingRanges,TestResultState:$.TestResultState,TestRunRequest:$.TestRunRequest,TestMessage:$.TestMessage,TestTag:$.TestTag,TestRunProfileKind:$.TestRunProfileKind,TextSearchCompleteMessageType:Be.TextSearchCompleteMessageType,TreeDataTransfer:$.TreeDataTransfer,TreeDataTransferItem:$.TreeDataTransferItem,CoveredCount:$.CoveredCount,FileCoverage:$.FileCoverage,StatementCoverage:$.StatementCoverage,BranchCoverage:$.BranchCoverage,FunctionCoverage:$.FunctionCoverage,WorkspaceTrustState:$.WorkspaceTrustState,LanguageStatusSeverity:$.LanguageStatusSeverity,QuickPickItemKind:$.QuickPickItemKind}}}e.createApiFactoryAndRegisterActors=te}),define(Se[221],_e([0,1,220,33,213,7,10,5,11]),function(ee,e,r,t,S,P,A,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class T extends S.RequireInterceptor{_installInterceptor(){}getModule(a,o){for(let m of this._alternatives){let M=m(a);if(M){a=M;break}}if(this._factories.has(a))return this._factories.get(a).load(a,o,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class R extends t.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=P.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){const a=this._extHostContext.getProxy(I.MainContext.MainThreadConsole);i(a,this._initData.environment.isExtensionDevelopmentDebug);const o=this._instaService.invokeFunction(r.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(T,o,this._registry),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(a){return a.browser}async _loadCommonJSModule(a,o,m){o=o.with({path:b(o.path,".js")}),a&&performance.mark(`code/extHost/willFetchExtensionCode/${a.value}`);const M=await fetch(D.FileAccess.asBrowserUri(o).toString(!0));if(a&&performance.mark(`code/extHost/didFetchExtensionCode/${a.value}`),M.status!==200)throw new Error(M.statusText);const y=await M.text(),_=`${o.toString(!0)}#vscode-extension`,u=`${y}
//# sourceURL=${_}`;let C;try{C=new Function("module","exports","require",u)}catch(n){throw console.error(a?`Loading code for extension ${a.value} failed: ${n.message}`:`Loading code failed: ${n.message}`),console.error(`${o.toString(!0)}${typeof n.line=="number"?` line ${n.line}`:""}${typeof n.column=="number"?` column ${n.column}`:""}`),console.error(n),n}const l={},F={exports:l},c=n=>{const h=this._fakeModules.getModule(n,o);if(h===void 0)throw new Error(`Cannot load module '${n}'`);return h};try{return m.codeLoadingStart(),a&&performance.mark(`code/extHost/willLoadExtensionCode/${a.value}`),C(F,l,c),F.exports!==l?F.exports:l}finally{a&&performance.mark(`code/extHost/didLoadExtensionCode/${a.value}`),m.codeLoadingStop()}}async $setRemoteEnvironment(a){}async _waitForDebuggerAttachment(a=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const o=Date.now()+a;for(;Date.now()<o&&!("__jsDebugIsReady"in globalThis);)await(0,A.timeout)(10)}}e.ExtHostExtensionService=R;function b(f,a){return f.endsWith(a)?f:f+a}function i(f,a){o("info","log"),o("log","log"),o("warn","warn"),o("error","error");function o(y,_){const u=console[y];console[y]=function(){f.$logExtensionHostMessage({type:"__$console",severity:_,arguments:M(arguments)}),a&&u.apply(console,arguments)}}const m=1e5;function M(y){const _=[],u=[];if(y.length)for(let C=0;C<y.length;C++){if(typeof y[C]=="undefined")y[C]="undefined";else if(y[C]instanceof Error){const l=y[C];l.stack?y[C]=l.stack:y[C]=l.toString()}u.push(y[C])}try{const C=JSON.stringify(u,function(l,F){if(F&&typeof F=="object"){if(_.indexOf(F)!==-1)return"[Circular]";_.push(F)}return F});return C.length>m?"Output omitted for a large object that exceeds the limits":C}catch(C){return`Output omitted for an object that cannot be inspected ('${C.toString()}')`}}}}),define(Se[222],_e([0,1,44,33,71,221]),function(ee,e,r,t,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,r.registerSingleton)(t.IExtHostExtensionService,P.ExtHostExtensionService),(0,r.registerSingleton)(S.IExtensionStoragePaths,S.ExtensionStoragePaths)}),define(Se[234],_e([0,1,21,4,170,214,208,17,72,11,2,217,222]),function(ee,e,r,t,S,P,A,I,D,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const b=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const i=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");const f=fetch.bind(self);if(self.fetch=function(_,u){return _ instanceof Request||/^file:/i.test(String(_))&&(_=T.FileAccess.asBrowserUri(R.URI.parse(String(_))).toString(!0)),f(_,u)},self.XMLHttpRequest=class extends XMLHttpRequest{open(_,u,C,l,F){return/^file:/i.test(u.toString())&&(u=T.FileAccess.asBrowserUri(R.URI.parse(u.toString())).toString(!0)),super.open(_,u,C??!0,l,F)}},self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const _=self.Worker;Worker=function(u,C){/^file:/i.test(u.toString())&&(u=T.FileAccess.asBrowserUri(R.URI.parse(u.toString())).toString(!0));const F=`(${function(g){function s(w){return typeof w=="string"||w instanceof URL?String(w).replace(/^file:\/\//i,"vscode-file://vscode-app"):w}const d=fetch.bind(self);self.fetch=function(w,v){return w instanceof Request?d(w,v):d(s(w),v)},self.XMLHttpRequest=class extends XMLHttpRequest{open(w,v,k,L,E){return super.open(w,s(v),k??!0,L,E)}};const p=importScripts.bind(self);self.importScripts=(...w)=>{p(...w.map(s))},p(g)}.toString()}('${u}'))`;C=C||{},C.name=C.name||I.basename(u.toString());const c=new Blob([F],{type:"application/javascript"}),n=URL.createObjectURL(c);return new _(n,C)}}else self.Worker=class extends A.NestedWorker{constructor(_,u){super(i,_,{name:I.basename(_.toString()),...u})}};const a=new class{constructor(){this.pid=void 0}exit(_){b()}async exists(_){return!0}async realpath(_){return _}};class o{constructor(){const u=new MessageChannel,C=new t.Emitter;let l=!1;i(u.port2,[u.port2]),u.port1.onmessage=F=>{const{data:c}=F;if(!(c instanceof ArrayBuffer)){console.warn("UNKNOWN data received",c);return}const n=r.VSBuffer.wrap(new Uint8Array(c,0,c.byteLength));if((0,S.isMessageOfType)(n,2)){l=!0,M("received terminate message from renderer");return}C.fire(n)},this.protocol={onMessage:C.event,send:F=>{if(!l){const c=F.buffer.buffer.slice(F.buffer.byteOffset,F.buffer.byteOffset+F.buffer.byteLength);u.port1.postMessage(c,[c])}}}}}function m(_){return new Promise(u=>{const C=_.onMessage(l=>{C.dispose();const F=JSON.parse(l.toString());_.send((0,S.createMessageOfType)(0)),u({protocol:_,initData:F})});_.send((0,S.createMessageOfType)(1))})}let M=_=>b();function y(){D.mark("code/extHost/willConnectToRenderer");const _=new o;return{onmessage(u){m(_.protocol).then(C=>{D.mark("code/extHost/didWaitForInitData");const l=new P.ExtensionHostMain(C.protocol,C.initData,a,null,u);M=F=>l.terminate(F)})}}}e.create=y})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/0c6d1e9f7ef648cfa50733abb62388bc0791856a/core/vs/workbench/services/extensions/worker/extensionHostWorker.js.map
